/*

    Scorpion 4 Hardware Platform (c)1996 Bell Fruit Manufacturing

    Skeleton Driver

    THIS DRIVER IS NONE FUNCTIONAL, THERE IS NO EMULATION CODE.

    -----------------

    what's the difference between this and Scorpion 5? Later revisons of many games appear
    to be on the latter.

    Scorpion 4:::

    Main CPU is a MC68307FG16, present on Motherboard

    Configuration is SC4 motherboard + game card

    The game card contains the program roms, sound rom and YMZ280B

    Adder 4 video board adds an additional card with a MC68340PV25E (25.175Mhz)

    -------------------------------

    This is currently a mess of Scorpion 4, Scorpion 5 and Scorpion 5 Adder 5 games.
    I think some games might use multiple boards of different techs linked up via
    serial ports, but I'm not sure

    THIS NEEDS SORTING OUT, TIDYING UP and PROPERLY DOCUMENTING

    Sorting Tips:
    Scorpion 5 sets seem to have SC5 as the first bytes (when interleaved)
    Larger roms seem to be Adder 5 (and also have SC5 at the start)

    Other roms are SC4? Some games are on both platforms - check..
    even within many 'SC5' sets there are roms without SC5 in the header
    these are either SC4 versions, or maybe some additional HW? - check...

    SC5 stuff seems to use opcodes which don't exist in the 68020, are these
    68340 based, or something else with additional opcodes (coldfire?)


    -------------------------------
*/

#include "emu.h"
#include "cpu/m68000/m68000.h"


class sc4_state : public driver_device
{
public:
	sc4_state(const machine_config &mconfig, device_type type, const char *tag)
		: driver_device(mconfig, type, tag) { }

};


static ADDRESS_MAP_START( sc4_map, AS_PROGRAM, 32 )
	AM_RANGE(0x000000, 0x2fffff) AM_ROM
	AM_RANGE(0x800000, 0x80ffff) AM_RAM
ADDRESS_MAP_END

static ADDRESS_MAP_START( sc4_addre4_map, AS_PROGRAM, 32 )
	AM_RANGE(0x000000, 0x2fffff) AM_ROM
ADDRESS_MAP_END



static INPUT_PORTS_START(  sc4 )
INPUT_PORTS_END

static MACHINE_CONFIG_START( sc4, sc4_state )
	MCFG_CPU_ADD("maincpu", M68020, 16000000)	 // 68307! (EC000 core)
	MCFG_CPU_PROGRAM_MAP(sc4_map)

	MCFG_SPEAKER_STANDARD_STEREO("lspeaker", "rspeaker")
	/* unknown sound */
MACHINE_CONFIG_END


static MACHINE_CONFIG_DERIVED( sc4_adder4, sc4 )
	MCFG_CPU_ADD("adder4", M68020, 25175000)	 // 68340 (CPU32 core)
	MCFG_CPU_PROGRAM_MAP(sc4_addre4_map)
MACHINE_CONFIG_END

ROM_START( sc4tst )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "ftu_sc4_testrig.hi", 0x00000, 0x080000, CRC(dacba04e) SHA1(fb96c790600f55769ddff4868d10b431d07777a4) )
	ROM_LOAD16_BYTE( "ftu_sc4_testrig.lo", 0x00001, 0x080000, CRC(fd313f2e) SHA1(8453842fc10a69758b991541542b8c55c1f3b02f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( ad4skill )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "skilldicegame_hi.bin", 0x00000, 0x080000, CRC(83d10f1b) SHA1(383a337e924313b1aa1e62451227218a82cd6cd3) )
	ROM_LOAD16_BYTE( "skilldicegame_lo.bin", 0x00001, 0x080000, CRC(e8d35560) SHA1(30efb6dabfc98cf89766bb33e249fed661219798) )

	ROM_REGION( 0x400000, "adder4", 0 )
	ROM_LOAD16_BYTE( "skilldiceadder_hi.bin", 0x00000, 0x080000, CRC(14da612d) SHA1(ad33ef3736538374b9f81868f0041d6b736e2375) )
	ROM_LOAD16_BYTE( "skilldiceadder_lo.bin", 0x00001, 0x080000, CRC(93a2aaf5) SHA1(c6b7c2ac56a9980e01e059f54048472f3e6d8b5b) )

	ROM_REGION( 0x100000, "ym", 0 )
	ROM_LOAD( "skilldicesound.bin", 0x0000, 0x080000, CRC(aeccd210) SHA1(ee88f67b436092854cc6719cc91db91d905ffc6f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc4bbust )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406101.evn", 0x00000, 0x080000, CRC(b6accc1e) SHA1(dec2c3710967605f12a5e07d0fd43f11fc6e1f03) )
	ROM_LOAD16_BYTE( "95406100.odd", 0x00001, 0x080000, CRC(b3b8ed69) SHA1(6c96e30add751b039b305983ef15cd2c68dfe430) )

	ROM_REGION( 0x100000, "ym", 0 )
	ROM_LOAD( "95008050.bin", 0x0000, 0x0fc8a1, CRC(8f1a49b5) SHA1(9d75e7118c628b3665a31376a3e35797b7058f6b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc4cvani )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404753.evn", 0x00000, 0x080000, CRC(e8e6d801) SHA1(33e9d1f829e8deba170e81379da0ccf5b2a677d7) )
	ROM_LOAD16_BYTE( "95404752.odd", 0x00001, 0x080000, CRC(8ad0ea8d) SHA1(90119c17fe828bbb52844e32b9be489ef98f6ad8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD( "95405878.odd", 0x00001, 0x080000, CRC(8788c032) SHA1(7f5f4f4f72339d719a6413e1e47082e3a9bee5ad) )
	ROM_LOAD( "95405879.evn", 0x00000, 0x080000, CRC(803cecd7) SHA1(1670525c4bef19d3b5253d0d14fe60f7736e6150) )
	ROM_LOAD( "95406118.odd", 0x00001, 0x080000, CRC(5eba8a9b) SHA1(9b498549e08ab6de1dacc3b602d34d0d2b2e97d0) )
	ROM_LOAD( "95406119.evn", 0x00000, 0x080000, CRC(a8be8679) SHA1(6170c737bd2440d0c6afd98027c3f5c409c90eb2) )
	ROM_LOAD( "95407118.odd", 0x00001, 0x080000, CRC(cad80a25) SHA1(b0f7fa45b6fdeee050337b67f3b59797f0d8f400) )
	ROM_LOAD( "95407119.evn", 0x00000, 0x080000, CRC(567bbb96) SHA1(afb3f308141c3d5d8e9d214b03fa4143a83b756a) )
	ROM_LOAD( "95408744.odd", 0x00001, 0x080000, CRC(327b8358) SHA1(79bafefdca55747e2b2bfd7e1875659fc8dfcc61) )
	ROM_LOAD( "95408745.evn", 0x00000, 0x080000, CRC(c0197b57) SHA1(a08333429e0cae556e2d9cfdb125dd1fed3652c9) )
	ROM_LOAD( "95409326.odd", 0x00001, 0x080000, CRC(a6357aa3) SHA1(ab9b0febe49afa7e851cbb3cb1ce77c7bfb28611) )
	ROM_LOAD( "95409327.evn", 0x00000, 0x080000, CRC(e0bba9ba) SHA1(c4946788db0844e40bab240f423aeb32713f0f57) )
	ROM_LOAD( "95414308.odd", 0x00001, 0x080000, CRC(aac38393) SHA1(3b4e8de63acb9b1134ed162baa6ab282d942e91e) )
	ROM_LOAD( "95414309.evn", 0x00000, 0x080000, CRC(bbedb6bb) SHA1(4c18ad6e54ac8e2ee5ed1c998ffe01c67ff834ef) )
	ROM_LOAD( "95414310.odd", 0x00001, 0x080000, CRC(a1941e8d) SHA1(0712e303179b590775dfee26ffb5124bdc60e5d1) )
	ROM_LOAD( "95414311.evn", 0x00000, 0x080000, CRC(b155ef1f) SHA1(c6fcee7cd723e1fd4e9f6bec5cdd0f1cfa1c42bd) )
	ROM_LOAD( "95415308.odd", 0x00001, 0x080000, CRC(8d243b05) SHA1(440ff23b01112d55793b15b91803b09c10e93b4a) )
	ROM_LOAD( "95415309.evn", 0x00000, 0x080000, CRC(99732cdc) SHA1(6bb23eae97124b411ad3e44b65118ca1cdf30d64) )
	ROM_LOAD( "95415310.odd", 0x00001, 0x080000, CRC(8673a61b) SHA1(5ae94eec0d34ba92418201d4c097328c46eabf6b) )
	ROM_LOAD( "95415311.evn", 0x00000, 0x080000, CRC(93cb7578) SHA1(ddac328917ac628e0ac2732ebc01f2936019b71e) )

	ROM_REGION( 0x100000, "ymz", 0 )
	ROM_LOAD( "95008237.bin", 0x0000, 0x0fdb37, CRC(ce0a3555) SHA1(7ba0c53709236d41f9e73b3a5151174ca2bf3fae) )
ROM_END


ROM_START( sc4cvclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408293.evn", 0x00000, 0x080000, CRC(52b2a132) SHA1(120c86d9822081afee9f4a16d871522ab0d52e7a) )
	ROM_LOAD16_BYTE( "95408292.odd", 0x00001, 0x080000, CRC(2b1e111b) SHA1(a9730617512ff76de4dfaa487e0156b2470ace88) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD( "95408394.odd", 0x00001, 0x080000, CRC(e1de3d0b) SHA1(9bd3382d6538ca455ae747902cd1a7fe704ca7f4) )
	ROM_LOAD( "95408395.evn", 0x00000, 0x080000, CRC(73727dab) SHA1(1b6b64b8430c0ab8cb6a6b2cb8d8282d4e32ba21) )
	ROM_LOAD( "95408430.odd", 0x00001, 0x080000, CRC(f6d20ce7) SHA1(0071bbb6175150b35a185e867800009403298fb8) )
	ROM_LOAD( "95408431.evn", 0x00000, 0x080000, CRC(4e92b4e3) SHA1(d008e4f2a0b6d48376a689b92cbda08a0b015234) )
	ROM_LOAD( "95409292.odd", 0x00001, 0x080000, CRC(e2d7476d) SHA1(ea54697110b35a286c1e60fc07ebf6fdf24469d0) )
	ROM_LOAD( "95409293.evn", 0x00000, 0x080000, CRC(26a61688) SHA1(c7128768d031fb03ab31a0b09ccba32913cc5d4e) )
	ROM_LOAD( "95409394.odd", 0x00001, 0x080000, CRC(115ec430) SHA1(a7e1a5866e6e50eb1dfc9f990ca9f0ff3be8e77b) )
	ROM_LOAD( "95409395.evn", 0x00000, 0x080000, CRC(8d28167c) SHA1(82e88e2544cb940eebcd237389debcbeaa8a0a38) )
	ROM_LOAD( "95409430.odd", 0x00001, 0x080000, CRC(2e43b6fe) SHA1(6916ced089911c53a6ead3025c823675ae47835e) )
	ROM_LOAD( "95409431.evn", 0x00000, 0x080000, CRC(d30e9665) SHA1(d1087018f5dd401a38700669ee08eb247758eecc) )
	ROM_LOAD( "95410920.odd", 0x00001, 0x080000, CRC(85edbcc3) SHA1(8789484deceef2d53df3bbed3e0e48b20a46aa2a) )
	ROM_LOAD( "95410921.evn", 0x00000, 0x080000, CRC(28090fef) SHA1(dca69f2ef3e09cadad840dfded89d4c228d4df74) )
	ROM_LOAD( "95411920.odd", 0x00001, 0x080000, CRC(815e76f9) SHA1(e3be90da856a86873916e1524dc81143cf546862) )
	ROM_LOAD( "95411921.evn", 0x00000, 0x080000, CRC(a247d382) SHA1(4bab91b42d4c1f0e31a1176656af20ed5b26c1d0) )

	ROM_REGION( 0x100000, "ymz", 0 )
	ROM_LOAD( "95008345.bin", 0x0000, 0x0fdb37, CRC(1e01057c) SHA1(f54cd2b59b1b4901b972b8b33c85defc975b0fac) )
ROM_END


ROM_START( sc4pstat )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406831.evn", 0x00000, 0x080000, CRC(c8470bf4) SHA1(a3cc8a6ba55c4b017452fbe55ff40b00e5cbf541) )
	ROM_LOAD16_BYTE( "95406830.odd", 0x00001, 0x080000, CRC(92800608) SHA1(8b584ae5378bf28797ef0bf8f100f0c2fc52d00e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD( "95406938.odd", 0x00001, 0x080000, CRC(d06d63dd) SHA1(8dd55290930dc4d4532a75c86848c56dfe507022) )
	ROM_LOAD( "95406939.evn", 0x00000, 0x080000, CRC(ee8dba94) SHA1(8125751a3dc29e8ea5d396c2b055d25b6e0d1ebc) )
	ROM_LOAD( "95407830.odd", 0x00001, 0x080000, CRC(c1bba3a6) SHA1(67e5f41e15c9c12048dd938ccd6671712e53b252) )
	ROM_LOAD( "95407831.evn", 0x00000, 0x080000, CRC(bcccea76) SHA1(d615e64d0d9051f944eac67273442dc677ab6bb4) )
	ROM_LOAD( "95407938.odd", 0x00001, 0x080000, CRC(4d86ab35) SHA1(2d85731871405ec6679438a267c10879e0d8018b) )
	ROM_LOAD( "95407939.evn", 0x00000, 0x080000, CRC(b49d0ab0) SHA1(0950d7124b8ec18cea397cbb68a7fde8ddf2733c) )
	ROM_LOAD( "95409330.odd", 0x00001, 0x080000, CRC(63ca83de) SHA1(efe8fcccb425ad01b202ec1dc6f9e6e81c90388b) )
	ROM_LOAD( "95409331.evn", 0x00000, 0x080000, CRC(ef9b9518) SHA1(356cc2ab7f8b06708eb4244ca7d7ad83ad5174a0) )
	ROM_LOAD( "95409536.odd", 0x00001, 0x080000, CRC(48891ea9) SHA1(b49b1adfe189aeb113bb59c1840429d37fca1b12) )
	ROM_LOAD( "95409537.evn", 0x00000, 0x080000, CRC(50ed3f7f) SHA1(8d071db1104602eebe9e48a118d4fa0a4532e7cc) )
	ROM_LOAD( "95410772.odd", 0x00001, 0x080000, CRC(fe898786) SHA1(f04cc8aec44b6b27d4fe3100b498389b85227f61) )
	ROM_LOAD( "95410773.evn", 0x00000, 0x080000, CRC(31ac2db0) SHA1(0e9c25b1a70c2941543b4b4fee94bb87d4f2d66b) )
	ROM_LOAD( "95410774.odd", 0x00001, 0x080000, CRC(f0ff037c) SHA1(efc7c5631a733d84352778f87958a507ddaf8014) )
	ROM_LOAD( "95410775.evn", 0x00000, 0x080000, CRC(acd9d42a) SHA1(801ed0499251e513f4f0c72c9de3da9493ba7761) )
	ROM_LOAD( "95410922.odd", 0x00001, 0x080000, CRC(cd7bbf74) SHA1(063893ebb67bec38372cb29c4c3f4e16cfc2720d) )
	ROM_LOAD( "95410923.evn", 0x00000, 0x080000, CRC(5b487dcc) SHA1(b4c4d84ed7dc5ab360e8d1bc9d0da5d4ecf4719f) )
	ROM_LOAD( "95411772.odd", 0x00001, 0x080000, CRC(4e2afc53) SHA1(76138abff8a8a481c0bd0281d79c90967e8158a2) )
	ROM_LOAD( "95411773.evn", 0x00000, 0x080000, CRC(e16d17c1) SHA1(5bbfc5c973a4a2dfdff3c57ab207641ec2d05e1c) )
	ROM_LOAD( "95411774.odd", 0x00001, 0x080000, CRC(19be804e) SHA1(9c407133b0766065ea883532cd213479d6e7aa99) )
	ROM_LOAD( "95411775.evn", 0x00000, 0x080000, CRC(7db91413) SHA1(6d78c8b24a01dd132be23f2866366af12d125e3f) )

	// these 4 were also in the 'pieces of 8' set, check where they belong
	ROM_LOAD( "95411780.odd", 0x00001, 0x080000, CRC(ceaecb27) SHA1(4bcc731b0f319d9b7e92743d57f43433bc7b183b) )
	ROM_LOAD( "95411781.evn", 0x00000, 0x080000, CRC(45be07c8) SHA1(e9a18125e577f0d42833140ed181c2308a66d370) )
	ROM_LOAD( "95411782.odd", 0x00001, 0x080000, CRC(b5fc0aa3) SHA1(3db5658e19b5fba27c7c1218726e1ee27efcb65f) )
	ROM_LOAD( "95411783.evn", 0x00000, 0x080000, CRC(3d26600f) SHA1(3f7aab34d39bf6383b7d2423e6e6d3edd7b7cc0e) )

	ROM_LOAD( "95411922.odd", 0x00001, 0x080000, CRC(a3e204ad) SHA1(ff755e30406328e1a1d28403814e289743777f5e) )
	ROM_LOAD( "95411923.evn", 0x00000, 0x080000, CRC(413eb2ae) SHA1(81ec1af213fed3d7d66e2da646ef79b091586eaf) )
	ROM_LOAD( "95414304.odd", 0x00001, 0x080000, CRC(cc00f2af) SHA1(a76122a25d7d07e81baa99e797ee8b927c00b8ef) )
	ROM_LOAD( "95414305.evn", 0x00000, 0x080000, CRC(341ce188) SHA1(fd0b350c6855187642416e492cab329fa138bb3a) )
	ROM_LOAD( "95414306.odd", 0x00001, 0x080000, CRC(87ed4d56) SHA1(14c2fcbed5765f210315b8234db05c92b7f5ba94) )
	ROM_LOAD( "95414307.evn", 0x00000, 0x080000, CRC(bf6bf908) SHA1(e614f8581a97ce0f44627635c07b4b1c5426d498) )
	ROM_LOAD( "95415304.odd", 0x00001, 0x080000, CRC(12a9dac0) SHA1(91b27b6ac23788b22da0f3682d21380f1841f27d) )
	ROM_LOAD( "95415305.evn", 0x00000, 0x080000, CRC(c6dc17a6) SHA1(715c4f501b87deab5f271c5ac36efb88ef0ae858) )
	ROM_LOAD( "95415306.odd", 0x00001, 0x080000, CRC(59446539) SHA1(0583272c1832de1265924a83781c83b711a4318c) )
	ROM_LOAD( "95415307.evn", 0x00000, 0x080000, CRC(4dab0f26) SHA1(2e29e2ff48c29628259271e4c63d199d9280a2fe) )

	ROM_REGION( 0x100000, "ymz", 0 )
	ROM_LOAD( "95008294.bin", 0x0000, 0x0e410e, CRC(89e20874) SHA1(d6539d3051938d01c980360046e33c04e35a7929) )
	ROM_LOAD( "paystation_sound", 0x0000, 0x100000, CRC(0d87f9af) SHA1(7b00cbe3ba69f646fd692bfd6f002bd37801325e) )
ROM_END


ROM_START( sc4spark )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402142.hi", 0x00000, 0x080000, CRC(1ffc404b) SHA1(44e0f02708e6b0b15d3e272e6fa398d573242fba) )
	ROM_LOAD16_BYTE( "95402141.lo", 0x00001, 0x080000, CRC(57db7e17) SHA1(bd9a12ac901b379459dbd13dcde9b6441dfafdc3) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD( "95402143.lo", 0x00001, 0x080000, CRC(d06307dc) SHA1(021fb928366aaefc0009ad9a0482294d15fe66a6) )
	ROM_LOAD( "95402144.hi", 0x00000, 0x080000, CRC(0be0d27f) SHA1(d97156c6b386712afb929321d537b46f81cda81e) )
	ROM_LOAD( "95403141.lo", 0x00001, 0x080000, CRC(6cb6b647) SHA1(83c862ded1424a120b19323a79fda748a7d49ba3) )
	ROM_LOAD( "95403142.hi", 0x00000, 0x080000, CRC(8e65a90c) SHA1(b801b9d06333a91a2d0b7b86cc6ffc2443833fe0) )
	ROM_LOAD( "95403143.lo", 0x00001, 0x080000, CRC(78752813) SHA1(3e8327af899def1e1ea9f7b1d6b44252bd8af9f5) )
	ROM_LOAD( "95403144.hi", 0x00000, 0x080000, CRC(c0f6dd24) SHA1(3231f66bf6a78d86b1e9653add17ff73e620db1c) )
	ROM_LOAD( "95404090.lo", 0x00001, 0x080000, CRC(0d2be53b) SHA1(67d1ce2f676e0531e775d5fc54e385c083a9a9a1) )
	ROM_LOAD( "95404091.hi", 0x00000, 0x080000, CRC(0e026041) SHA1(0eca329deeea24ebefcfb46393b8515a5bea4c50) )
	ROM_LOAD( "95404092.lo", 0x00001, 0x080000, CRC(c00bc000) SHA1(0fe12fccc219cedd4cee2ef974d2b56099862b15) )
	ROM_LOAD( "95404093.hi", 0x00000, 0x080000, CRC(1d60ce98) SHA1(3011b0f59145d80d8d34207d31abf98331285eff) )

	ROM_REGION( 0x200000, "ymz", 0 )
	ROM_LOAD( "95008031.bin", 0x000000, 0x100000, CRC(445d3cf7) SHA1(ded74e46b4fb4ef405eb74027a63d301efce1f45) )
	ROM_LOAD( "95008032.bin", 0x100000, 0x0fd082, CRC(88781139) SHA1(e8e972032664c314f5263d7acb5a3f0769c7fb2a) )
ROM_END



ROM_START( sc4brkfs )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402330.hi", 0x00000, 0x080000, CRC(5fe5753b) SHA1(df165a79dbfdaa85d6d5664c4b64e68581b6b46e) )
	ROM_LOAD16_BYTE( "95402329.lo", 0x00001, 0x080000, CRC(0717309e) SHA1(55a1f8554cfb84bd33f88ea24c781ff6e7323daa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD( "95402331.lo", 0x00001, 0x080000, CRC(a1e71c0a) SHA1(19d5d10924869e5c95a8d72d9aaa9ab09053d4e0) )
	ROM_LOAD( "95402332.hi", 0x00000, 0x080000, CRC(11915577) SHA1(c2202142bff28d274f5a10dd160ba0159547b6b9) )
	ROM_LOAD( "95403329.lo", 0x00001, 0x080000, CRC(f80bea0a) SHA1(38b6cdda2968923e1ad82766b89688e5a80a1fad) )
	ROM_LOAD( "95403330.hi", 0x00000, 0x080000, CRC(5e448f73) SHA1(ce9d3a38e681c3e5fde2928426b07d544bf2e544) )
	ROM_LOAD( "95403331.lo", 0x00001, 0x080000, CRC(77f05126) SHA1(bf3240a0a7e29d0bf11a241f1068fa1ec4143432) )
	ROM_LOAD( "95403332.hi", 0x00000, 0x080000, CRC(8008bc30) SHA1(501180f871f44fb54fa1c7343a71ff634334f97d) )

	ROM_REGION( 0x200000, "ymz", 0 )
	ROM_LOAD( "95008013.lo", 0x00001, 0x100000, CRC(286e59da) SHA1(e43901f4ad9fc7f083cbb7ef5cd7e4ad6289833b) )
	ROM_LOAD( "95008014.hi", 0x00000, 0x100000, CRC(1b9936ad) SHA1(0c98618d1ca30fa4f9913a5214a5f431e520917c) )
ROM_END



ROM_START( sc4gslam )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402975.hi", 0x00000, 0x080000, CRC(ac255d4b) SHA1(2bb6017c915a62faa5cb0bca7b67a7c16540861a) )
	ROM_LOAD16_BYTE( "95402974.lo", 0x00001, 0x080000, CRC(6a170906) SHA1(0fc5c87db38abe350c655e5b9595da792ddeaa34) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD( "95402976.lo", 0x00001, 0x080000, CRC(6859579d) SHA1(c9e13dd332d5b92cc1a94962d4d22954fa532b76) )
	ROM_LOAD( "95402977.hi", 0x00000, 0x080000, CRC(5b16cd86) SHA1(5283a97e2ae2c563c82d2b7593e522ab532a3d76) )
	ROM_LOAD( "95403974.lo", 0x00001, 0x080000, CRC(118bd82c) SHA1(68d936f3146beb80239603de8551d8adb8732302) )
	ROM_LOAD( "95403975.hi", 0x00000, 0x080000, CRC(9a027e9e) SHA1(64c650e7a9504785c10af7b7702198235976a690) )
	ROM_LOAD( "95403976.lo", 0x00001, 0x080000, CRC(e645e490) SHA1(7429feb090bc0e17918d804583073d27e7d1cf63) )
	ROM_LOAD( "95403977.hi", 0x00000, 0x080000, CRC(e37850b9) SHA1(79162fdc8db1b3f7c6b0124a6dcc1b97bad33172) )
	ROM_LOAD( "95404078.lo", 0x00001, 0x080000, CRC(e32b12b5) SHA1(6459ae08365c806d9cee083036a8b55f9017d6e2) )
	ROM_LOAD( "95404079.hi", 0x00000, 0x080000, CRC(7d97128c) SHA1(0b7273d460d8aeaf1b8c2507613c994e71b5acd2) )
	ROM_LOAD( "95405078.lo", 0x00001, 0x080000, CRC(24156751) SHA1(de18a563a5e74318af5e91d70ddfc037a99bf3e4) )
	ROM_LOAD( "95405079.hi", 0x00000, 0x080000, CRC(a21017ac) SHA1(b8fab6e558cb0f0390c8f0a60e30eb7da32fcf1e) )
	//Super six cabinet - club?
	ROM_LOAD( "slam1000.hi", 0x00000, 0x080000, CRC(3fd1a9bd) SHA1(ec5cbed2427bd58f93da1b380f2c44179e460c66) )
	ROM_LOAD( "slam1000.lo", 0x00001, 0x080000, CRC(6499044b) SHA1(50bf83d6a2cabec3c8358401432f9611eaf88dfa) )

	ROM_REGION( 0x200000, "ymz", 0 )
	ROM_LOAD( "95004169.bin", 0x000000, 0x080000, CRC(d2293b2f) SHA1(e3eed38a15885c5a6d63fc79d95f77c5225e9168) )
	ROM_LOAD( "95004170.bin", 0x080000, 0x080000, CRC(1da0db8f) SHA1(b3c37b5e02efe7267556d8603c362298ed55bb88) )
ROM_END




ROM_START( sc_ivply )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406374.lo", 0x00001, 0x080000, CRC(33511be6) SHA1(17d1f87620e1f592f2660815c96dbbbe7a5d1dfe) )
	ROM_LOAD16_BYTE( "95406375.hi", 0x00000, 0x080000, CRC(fb0e1f4f) SHA1(9cf091fb82ec7696ec7c1d3434b2e1a8cf753782) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004313.snd", 0x0000, 0x080000, CRC(28faed9e) SHA1(624d6cfcc97dd1950b5d908cde2e4d2eb6ea1dc6) )
ROM_END




ROM_START( sc_abra )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414374.lo", 0x00001, 0x080000, CRC(f8b83090) SHA1(82aa06f76ea0168b03e6b31132db2e14f279755f) )
	ROM_LOAD16_BYTE( "95414375.hi", 0x00000, 0x080000, CRC(25bd9371) SHA1(ad3900d5a6e032c5094fc651b9ec1767231fb245) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95415374.lo", 0x00001, 0x080000, CRC(28a54f37) SHA1(64c185f97e9147418bd35538f1607aaebe04ffbb) )
	ROM_LOAD16_BYTE( "95415375.hi", 0x00000, 0x080000, CRC(d59f6b87) SHA1(0dbef7ef213dd557cea91b0ac6c8e71ca45ac23c) )
	ROM_LOAD16_BYTE( "95420438.lo", 0x00001, 0x080000, CRC(9ac61925) SHA1(7f3f812a6a3b20fcf5624a631555b564307f17ce) )
	ROM_LOAD16_BYTE( "95420439.hi", 0x00000, 0x080000, CRC(33f4f2c0) SHA1(bc434d1db481f0210810aa2cec7062a502586ecf) )
	ROM_LOAD16_BYTE( "95421438.lo", 0x00001, 0x080000, CRC(af623d23) SHA1(ff467317338a5901bfd4a6b2d29da84603e24252) )
	ROM_LOAD16_BYTE( "95421439.hi", 0x00000, 0x080000, CRC(fed59f04) SHA1(3823dab966dad2aa3b1fcd486cb98c291045359a) )
	ROM_LOAD16_BYTE( "95424038.lo", 0x00001, 0x080000, CRC(030b0c4e) SHA1(aa90f47cd55468542ceb9b8713ab7eea4fba0f7e) )
	ROM_LOAD16_BYTE( "95424039.hi", 0x00000, 0x080000, CRC(765156ff) SHA1(856d51584d406f29b033faff8fea9e16adcbc460) )
	ROM_LOAD16_BYTE( "95425038.lo", 0x00001, 0x080000, CRC(eff52c5b) SHA1(606b3a111cf44b119537e347b6baca3fa50f5241) )
	ROM_LOAD16_BYTE( "95425039.hi", 0x00000, 0x080000, CRC(d135072e) SHA1(488f35beb8d1f579520851a2afff783a4dae8a43) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_acesh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406960.lo", 0x00001, 0x080000, CRC(e3c4712d) SHA1(50e17f4a1d1c5a140d6f591fca66b8d5191e1d3c) )
	ROM_LOAD16_BYTE( "95406961.hi", 0x00000, 0x080000, CRC(44b5e0d2) SHA1(16837ecb5dbb96b964cf0ec1d1890a0d914ec675) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407960.lo", 0x00001, 0x080000, CRC(d4334b67) SHA1(7ecdee5f7a19da5745d8c1bd3ec68ceb51cfe554) )
	ROM_LOAD16_BYTE( "95407961.hi", 0x00000, 0x080000, CRC(3ca49ca9) SHA1(ccf655d4057a405f04597ae450944e828dda626b) )
	ROM_LOAD16_BYTE( "95410470.lo", 0x00001, 0x080000, CRC(9c614444) SHA1(7e691b192503e583052c1e7e1c46c18a60aa05e9) )
	ROM_LOAD16_BYTE( "95410471.hi", 0x00000, 0x080000, CRC(9deb916e) SHA1(ce9cbccef8f26233de7bebf96415b67fe632ee74) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008292.bin", 0x0000, 0x100000, CRC(1c238098) SHA1(e2e2cb52ea84a7dc5e557b61b3ee21bd5a063833) )
	ROM_LOAD( "95401643.bin", 0x0000, 0x100000, CRC(3a85490e) SHA1(e1e4765785d631a7ec4e5daa33d1ce4fbdaee446) )
ROM_END




ROM_START( sc_adren )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412318.lo", 0x00001, 0x080000, CRC(f0b06b9c) SHA1(024cfe8cd6a4b00287f14682354a73fa685b39e7) )
	ROM_LOAD16_BYTE( "95412319.hi", 0x00000, 0x080000, CRC(f6e0b128) SHA1(75b5b001b6da1c19bf895582d2db7adaee69fc1e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412320.lo", 0x00001, 0x080000, CRC(5df555f0) SHA1(1130b73dd815754eb4ad5efca316fd78608f85ec) )
	ROM_LOAD16_BYTE( "95412321.hi", 0x00000, 0x080000, CRC(42f1069a) SHA1(e3ee74d1d9b8f2dc41c405b89495ced7da36f930) )
	ROM_LOAD16_BYTE( "95413318.lo", 0x00001, 0x080000, CRC(d7f16cd4) SHA1(cba61a0e63e160ba07f67465db7fcdb9d054ce25) )
	ROM_LOAD16_BYTE( "95413319.hi", 0x00000, 0x080000, CRC(338e2d52) SHA1(05f4416642a76246725a3d2ba21222922314aadd) )
	ROM_LOAD16_BYTE( "95413320.lo", 0x00001, 0x080000, CRC(2965ba19) SHA1(9fbcb639d81a0b2c8d651500a9a100630519f853) )
	ROM_LOAD16_BYTE( "95413321.hi", 0x00000, 0x080000, CRC(6212c41d) SHA1(fa961dedaa25519ac04364e189e800455567dc13) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_alad )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402133.lo", 0x00001, 0x080000, CRC(cff17504) SHA1(5db95fe3c40b47c357dca1587f8d2973568d1259) )
	ROM_LOAD16_BYTE( "95402134.hi", 0x00000, 0x080000, CRC(fc1680c8) SHA1(842d681cf9862c3bd352b6ada9fd5d40ab588230) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403133.lo", 0x00001, 0x080000, CRC(79b60ee9) SHA1(672d30742d4ea4845bb8def4dc9945e6554a2c12) )
	ROM_LOAD16_BYTE( "95403134.hi", 0x00000, 0x080000, CRC(a4e43e34) SHA1(366c152666ee81410638794f959cda3b165bb29d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008075.bin", 0x0000, 0x080000, CRC(c9306583) SHA1(8bccb9529e7d24be7b4f3ffda0d35780a170be43) )
ROM_END




ROM_START( sc_adjb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422202.lo", 0x00001, 0x080000, CRC(b46dacd1) SHA1(35765ee76a9f513cf7c2b93310d58a4b5ae2d11a) )
	ROM_LOAD16_BYTE( "95422203.hi", 0x00000, 0x080000, CRC(aa15a168) SHA1(2cb949a1e8a607291682c6c5896e3a21103db1be) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422204.lo", 0x00001, 0x080000, CRC(330a0bc8) SHA1(046079ee90d3e75c39615a786879c7e9d5ef40aa) )
	ROM_LOAD16_BYTE( "95422205.hi", 0x00000, 0x080000, CRC(73cb56fd) SHA1(0fcb444be12cc24720bb3a84ac5e4ffe1582c0e7) )
	ROM_LOAD16_BYTE( "95422344.lo", 0x00001, 0x080000, CRC(cd8f64f5) SHA1(ac8146c6e003bf0d2d709227a8c071b9261e8768) )
	ROM_LOAD16_BYTE( "95422345.hi", 0x00000, 0x080000, CRC(9931c998) SHA1(792aa5c7aed1ec51a0e32d81ebb0d697f8f2c213) )
	ROM_LOAD16_BYTE( "95422346.lo", 0x00001, 0x080000, CRC(614bc81e) SHA1(433da3c2ff9f41b92f4e52bb37ed39b28732afe4) )
	ROM_LOAD16_BYTE( "95422347.hi", 0x00000, 0x080000, CRC(98cecb00) SHA1(ed02da4896eeab76ea31d4ef79a75d4ea5b4d884) )
	ROM_LOAD16_BYTE( "95422612.lo", 0x00001, 0x080000, CRC(0230fef6) SHA1(a1c7fad70bf8ac54255761e61c41415a044dcacf) )
	ROM_LOAD16_BYTE( "95422613.hi", 0x00000, 0x080000, CRC(dba8b822) SHA1(07ebb8f9d69dcde96d1e5cf9b70ef6597d5d163a) )
	ROM_LOAD16_BYTE( "95422616.lo", 0x00001, 0x080000, CRC(1a517468) SHA1(d562120c96eb8b7511b19a594400f39b17911519) )
	ROM_LOAD16_BYTE( "95422617.hi", 0x00000, 0x080000, CRC(57f76ea6) SHA1(865487238f5eabb08895f6800eef767213d50e0b) )
	ROM_LOAD16_BYTE( "95422738.lo", 0x00001, 0x080000, CRC(6e756b04) SHA1(8895d25f914c8058fc1d27e8c27ce30c4eecab92) )
	ROM_LOAD16_BYTE( "95422739.hi", 0x00000, 0x080000, CRC(711891ea) SHA1(18035de1d74b9e4b8dece0d6cd7d42b2fd86869d) )
	ROM_LOAD16_BYTE( "95422844.lo", 0x00001, 0x080000, CRC(f41e2053) SHA1(bcb33f317a7f1afb00ea5e66d0f0909c0b7ad7b4) )
	ROM_LOAD16_BYTE( "95422845.hi", 0x00000, 0x080000, CRC(6fcbea84) SHA1(876a43c3aa07604c4dc29aaede18dc04f7bd7de2) )
	ROM_LOAD16_BYTE( "95423202.lo", 0x00001, 0x080000, CRC(ea5118ac) SHA1(e75f547f2dad9a24f4ca4418b0462e1e62c34707) )
	ROM_LOAD16_BYTE( "95423203.hi", 0x00000, 0x080000, CRC(7cae64e7) SHA1(7b9c108a3ca98fd530b5b512f42abf2308cd1929) )
	ROM_LOAD16_BYTE( "95423204.lo", 0x00001, 0x080000, CRC(9d830a8f) SHA1(381f93a8890f2b9e409760078dff4046e1ed2060) )
	ROM_LOAD16_BYTE( "95423205.hi", 0x00000, 0x080000, CRC(31b3451e) SHA1(659672722886959b7953ea505adc971b14ac14f4) )
	ROM_LOAD16_BYTE( "95423344.lo", 0x00001, 0x080000, CRC(f4f471d2) SHA1(ec9b22538a3b260fbf698d8bca7bb04f49bf7743) )
	ROM_LOAD16_BYTE( "95423345.hi", 0x00000, 0x080000, CRC(d862d1c7) SHA1(2e558422b96cd04bcb7c30be88a3cd1f10fcfc40) )
	ROM_LOAD16_BYTE( "95423346.lo", 0x00001, 0x080000, CRC(da4698f7) SHA1(2a257089e6fdf6d9b028c2d5b98670cb886b2753) )
	ROM_LOAD16_BYTE( "95423347.hi", 0x00000, 0x080000, CRC(2d8abca5) SHA1(ae52093d2869c8deff560b0995e6de57e63d383e) )
	ROM_LOAD16_BYTE( "95423612.lo", 0x00001, 0x080000, CRC(d5f79dc8) SHA1(bc7a37b44c60a5d3b116f96961687c0e5c4aef16) )
	ROM_LOAD16_BYTE( "95423613.hi", 0x00000, 0x080000, CRC(271befb0) SHA1(5d2a9d78a4995788aeb03c8053da60c47ba5ec55) )
	ROM_LOAD16_BYTE( "95423616.lo", 0x00001, 0x080000, CRC(bac8efd2) SHA1(3be18e085844c683e84e4ae16d39b985d3a42bf7) )
	ROM_LOAD16_BYTE( "95423617.hi", 0x00000, 0x080000, CRC(f00e7e40) SHA1(289cbd6909040e542b82e567148732e13fe9358c) )
	ROM_LOAD16_BYTE( "95423738.lo", 0x00001, 0x080000, CRC(7889520c) SHA1(a3c6a203144a9c95adf5ac9efa974b55b3b2b9a8) )
	ROM_LOAD16_BYTE( "95423739.hi", 0x00000, 0x080000, CRC(4945201a) SHA1(540f0987dbb3d3d3a44baf3127af0b780982d2a8) )
	ROM_LOAD16_BYTE( "95426108.lo", 0x00001, 0x080000, CRC(d5f4a4a8) SHA1(dca003286b6d4d933125aeb6664ad5b66124a914) )
	ROM_LOAD16_BYTE( "95426109.hi", 0x00000, 0x080000, CRC(6ff8b169) SHA1(62fa8ca4172d72cbdf7c59634faba49682ecf675) )
	ROM_LOAD16_BYTE( "95426156.lo", 0x00001, 0x080000, CRC(9f149b4c) SHA1(9c40e575ca1bcd8848f2f2132be299d881f7b744) )
	ROM_LOAD16_BYTE( "95426157.hi", 0x00000, 0x080000, CRC(63762f8a) SHA1(cb347a79b475f24d2ea251288e201c5333149e4f) )
	ROM_LOAD16_BYTE( "95426286.lo", 0x00001, 0x080000, CRC(c7ac0270) SHA1(18b6f8502e512758a2a4753a9f20ea73b1f6c1f8) )
	ROM_LOAD16_BYTE( "95426287.hi", 0x00000, 0x080000, CRC(535606de) SHA1(d174a4a209d35cdcdc13657f598c861b3d5e446a) )
	ROM_LOAD16_BYTE( "95426330.lo", 0x00001, 0x080000, CRC(1ee5674e) SHA1(07ea9fbf3d1563df3680cb47db12cdcd08d1ec4c) )
	ROM_LOAD16_BYTE( "95426331.hi", 0x00000, 0x080000, CRC(1aa9591c) SHA1(461c034b9b8709357f2aa396231141a94fbb3c6b) )
	ROM_LOAD16_BYTE( "95427108.lo", 0x00001, 0x080000, CRC(7596b006) SHA1(52374ce812f404e0d3b852a6497e312e3c34fd53) )
	ROM_LOAD16_BYTE( "95427109.hi", 0x00000, 0x080000, CRC(8de91bb0) SHA1(14ab21c5f0852266cb9989186f1580a8f5f70750) )
	ROM_LOAD16_BYTE( "95427156.lo", 0x00001, 0x080000, CRC(6bea4916) SHA1(697305893467ea2074bc89a332c95dd4f4044438) )
	ROM_LOAD16_BYTE( "95427157.hi", 0x00000, 0x080000, CRC(211c1bdb) SHA1(0fe2c4cd8c74f9e38f7da774ac3b08a2d013b51e) )
	ROM_LOAD16_BYTE( "95427286.lo", 0x00001, 0x080000, CRC(26ebaf2c) SHA1(c3e5ca75def57d09e1c2973d87733b19ff2c213f) )
	ROM_LOAD16_BYTE( "95427287.hi", 0x00000, 0x080000, CRC(5857ae6e) SHA1(a594044b5c0a9b4cdb988c578c7a383b44694400) )
	ROM_LOAD16_BYTE( "95427330.lo", 0x00001, 0x080000, CRC(42c6d7d4) SHA1(b7d07d97f89cddb571c50f1da0fe3bdecb3e2c8d) )
	ROM_LOAD16_BYTE( "95427331.hi", 0x00000, 0x080000, CRC(dc2ba1f7) SHA1(ac98205a5820d01257aa3470ef0439b5cfb243cc) )
	ROM_LOAD16_BYTE( "p3009p41.hi", 0x00000, 0x080000, CRC(fcdca441) SHA1(75b95121e8fc9cb3a822e9984240278eb87e58dd) )
	ROM_LOAD16_BYTE( "p3009p41.lo", 0x00001, 0x080000, CRC(944c7e39) SHA1(f6fb1f525ae870f6aac4ba85a14c14acf39e9d88) )
	ROM_LOAD16_BYTE( "p3009p71.hi", 0x00000, 0x080000, CRC(53f0ba31) SHA1(9a88e22578074063b5332172fcd652fae4b1ee37) )
	ROM_LOAD16_BYTE( "p3009p71.lo", 0x00001, 0x080000, CRC(ed313688) SHA1(0a9c03f9cce3b5d1d8949b256e688e7ae3c646be) )
	ROM_LOAD16_BYTE( "p3009p72.hi", 0x00000, 0x080000, CRC(83501640) SHA1(adf13bc188da7ebbfac119a9bbadc65c390846da) )
	ROM_LOAD16_BYTE( "p3009p72.lo", 0x00001, 0x080000, CRC(d45399a8) SHA1(baa7f674d73dfbc1bd7afa8cfcc7ec5c3fce7ff0) )
	ROM_LOAD16_BYTE( "p3009s41.hi", 0x00000, 0x080000, CRC(722ecc98) SHA1(8704898bfc63e901532b8fe4b044dc283b57d260) )
	ROM_LOAD16_BYTE( "p3009s41.lo", 0x00001, 0x080000, CRC(efac5e35) SHA1(4de590d3158fc722104af92bb8d83e6d1c0d7224) )
	ROM_LOAD16_BYTE( "p3009s71.hi", 0x00000, 0x080000, CRC(34602c55) SHA1(4447731f8f27e702bc4f44253eae44a5db1deea8) )
	ROM_LOAD16_BYTE( "p3009s71.lo", 0x00001, 0x080000, CRC(2c5afcdd) SHA1(524c9c8e7a9726cdff00e749a94978612b6f7c9e) )
	ROM_LOAD16_BYTE( "p3009s72.hi", 0x00000, 0x080000, CRC(31e26340) SHA1(571cf698d75240cb5c2f9403c1136e44d0509181) )
	ROM_LOAD16_BYTE( "p3009s72.lo", 0x00001, 0x080000, CRC(b4d0dcc9) SHA1(6c51e3bac949e6a906edacb24cf12ba1dae4760a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008699.bin", 0x0000, 0x100000, CRC(6d49b54a) SHA1(d64caa1dae40c3bf536f8739d6995b589c7184b7) )
	ROM_LOAD( "95008700.bin", 0x0000, 0x100000, CRC(49c37b2a) SHA1(5a59a540becb8c83288ae3a15cfac069fd792e74) )
ROM_END



ROM_START( sc_adwta )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1920p44.hi", 0x00000, 0x080000, CRC(50b71a6e) SHA1(a7e387253be2e3b400d8738dc7547b15e39a74ea) )
	ROM_LOAD16_BYTE( "p1920p44.lo", 0x00001, 0x080000, CRC(7b0cac6c) SHA1(45542f7b600da049a69954537cfd83b93471b3e8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1920s44.hi", 0x00000, 0x080000, CRC(3aad0ff3) SHA1(76455165581553ad292db2fdc200f391a2a9a2da) )
	ROM_LOAD16_BYTE( "p1920s44.lo", 0x00001, 0x080000, CRC(d3e80b27) SHA1(1f6c1489b6d0696f49a2f7edb4e7a73aaadc0bea) )
	ROM_LOAD16_BYTE( "p1940p44.hi", 0x00000, 0x080000, CRC(a90332f1) SHA1(67651afefbf94468b254e5d7bd6ed6b3131032db) )
	ROM_LOAD16_BYTE( "p1940p44.lo", 0x00001, 0x080000, CRC(924ac406) SHA1(7aa4d41b3b1ff38ac550e351db198a81356a9a37) )
	ROM_LOAD16_BYTE( "p1940s44.hi", 0x00000, 0x080000, CRC(88961ef0) SHA1(e21ba766037a4bc4c7fd14199f7704ed1bfa22a5) )
	ROM_LOAD16_BYTE( "p1940s44.lo", 0x00001, 0x080000, CRC(627fe077) SHA1(e4da21e50501d0f35a392d1e7dbc26057667eacc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_a40 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414940.lo", 0x00001, 0x080000, CRC(4a069351) SHA1(b6ab6f955519de814da3345c63a62b5d7bfd2d97) )
	ROM_LOAD16_BYTE( "95414941.hi", 0x00000, 0x080000, CRC(786f601b) SHA1(5d327fd9851034d5c51165164ca0a02cd9724900) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414950.lo", 0x00001, 0x080000, CRC(43b9da3c) SHA1(bcc473bb48e090052aab6646738fff750aeaa9f0) )
	ROM_LOAD16_BYTE( "95414951.hi", 0x00000, 0x080000, CRC(1360c672) SHA1(837b4172f05119555fc6874aeaacfdbeeacb381c) )
	ROM_LOAD16_BYTE( "95415940.lo", 0x00001, 0x080000, CRC(6f5cbce8) SHA1(24385d37d801b8f631d000fb8cb21a46c25a06d4) )
	ROM_LOAD16_BYTE( "95415941.hi", 0x00000, 0x080000, CRC(c0f48a14) SHA1(8a97e38661d34a2d9ed1347dbe0976d5d0328d0e) )
	ROM_LOAD16_BYTE( "95416088.lo", 0x00001, 0x080000, CRC(7bebb61c) SHA1(b1228eb50a66f19c7496306d2fa2d72c768d8b91) )
	ROM_LOAD16_BYTE( "95416089.hi", 0x00000, 0x080000, CRC(8a5bf808) SHA1(02336466dbf1ad7155ffc16111037333d11e09b9) )
	ROM_LOAD16_BYTE( "95416090.lo", 0x00001, 0x080000, CRC(23ebede2) SHA1(9b3c3f6fcde88f595d60b986d5f7f551ac6b4dc5) )
	ROM_LOAD16_BYTE( "95416091.hi", 0x00000, 0x080000, CRC(4cc5160d) SHA1(95aa16ec0b36676a17af89b99b47f0d1265e07b5) )
	ROM_LOAD16_BYTE( "95417088.lo", 0x00001, 0x080000, CRC(1f4b5227) SHA1(d58751b06a3f69911d3c2275484bdb7f14dfc2ed) )
	ROM_LOAD16_BYTE( "95417089.hi", 0x00000, 0x080000, CRC(bd6ac464) SHA1(811a99bc9b308d5d80dd001e362112bcd13df899) )
	ROM_LOAD16_BYTE( "95417090.lo", 0x00001, 0x080000, CRC(6a9853be) SHA1(dcf973cfab45656ca8dc597e385e1c3c2eb4ca9a) )
	ROM_LOAD16_BYTE( "95417091.hi", 0x00000, 0x080000, CRC(4c5a4035) SHA1(363072def1061500102acc0806cad70cbab3be37) )
	ROM_LOAD16_BYTE( "95890123.bin", 0x0000, 0x5000, CRC(e3f5466e) SHA1(ae2f45f79d0113e651b8cf5f655a9ceb32a3ddaa) )
	ROM_LOAD16_BYTE( "95890124.bin", 0x0000, 0x5000, CRC(9663025a) SHA1(097246412fd4084c1185d8dfd91e884abc5a3f8a) )
	ROM_LOAD16_BYTE( "95890125.bin", 0x0000, 0x5000, CRC(08d9ce06) SHA1(9087170d6c6edad735ab5a2abbc0a2191aabfd03) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008511.bin", 0x0000, 0x0ff5c3, CRC(6fac2014) SHA1(5b364406f7b5d8f4c54561e3977571e4a47273a0) )
ROM_END




ROM_START( sc_a40cl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416356.lo", 0x00001, 0x080000, CRC(d16af940) SHA1(350623ae459f5c93ae97461d69d20e17b85ca7d0) )
	ROM_LOAD16_BYTE( "95416357.hi", 0x00000, 0x080000, CRC(eb467f83) SHA1(e89dcfbf59845922766122e98b202602574aee8a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416372.lo", 0x00001, 0x080000, CRC(97398b07) SHA1(e84525e64649e4f8b466069f7dd636e1f43bd277) )
	ROM_LOAD16_BYTE( "95416373.hi", 0x00000, 0x080000, CRC(a4c22f0c) SHA1(77d4525922869ec0008c0faae85e45a215a379ad) )
	ROM_LOAD16_BYTE( "95417356.lo", 0x00001, 0x080000, CRC(b69dc96f) SHA1(409eedbd92fc95f13a7c9026d4cf151f081867e2) )
	ROM_LOAD16_BYTE( "95417357.hi", 0x00000, 0x080000, CRC(85bb5163) SHA1(d81258287d42c752d1e577b36c882e53ba6f3d74) )
	ROM_LOAD16_BYTE( "95417372.lo", 0x00001, 0x080000, CRC(f0cebb28) SHA1(ca8a80de389c6986b237f8495b00ae40a0baef31) )
	ROM_LOAD16_BYTE( "95417373.hi", 0x00000, 0x080000, CRC(ca3f01ec) SHA1(f0926248ef4ede28a81afcd50256f7567fa157d3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008527.bin", 0x0000, 0x0ff5c3, CRC(6fac2014) SHA1(5b364406f7b5d8f4c54561e3977571e4a47273a0) )
ROM_END




ROM_START( sc_aztec )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406356.lo", 0x00001, 0x080000, CRC(a67d927d) SHA1(3b038817a2f1171a48a35de56699c2d4f0c89c87) )
	ROM_LOAD16_BYTE( "95406357.hi", 0x00000, 0x080000, CRC(ecf9885f) SHA1(8b1d8685565c4b76eddfad6a0cff9aba7ff2277d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406472.lo", 0x00001, 0x080000, CRC(c510a2d2) SHA1(4bdc0d0bacc1adf6f8426ff7c827d1ca022de653) )
	ROM_LOAD16_BYTE( "95406473.hi", 0x00000, 0x080000, CRC(6358495c) SHA1(a628cb4712177e200c762e6ce3a4c258ab70f739) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004286.snd", 0x0000, 0x080000, CRC(20de4ebe) SHA1(0ea12d0c46f90efd8b040c2374d749fb7b15698e) )
ROM_END




ROM_START( sc_botn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414710.odd", 0x00001, 0x080000, CRC(2f6f3a0d) SHA1(5635280e4b72afe3e2296e3f3657c98a723bba02) )
	ROM_LOAD16_BYTE( "95414711.evn", 0x00000, 0x080000, CRC(df3d473a) SHA1(11b5ecbf8ed897629ee3bff802b7080eadd47c1a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95415710.odd", 0x00001, 0x080000, CRC(18881a99) SHA1(522a104602bf14e5d21d29825a85f718722f18a4) )
	ROM_LOAD16_BYTE( "95415711.evn", 0x00000, 0x080000, CRC(fee029cd) SHA1(aeb5266ee8a286ce3298eecbf50c939bd89bbf9e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008484.bin", 0x0000, 0x0f8e5a, CRC(83e34402) SHA1(e90c3ef784dfce7df2d60b06bc84ec9a21ff9a12) )
ROM_END




ROM_START( sc_broll )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404616.lo", 0x00001, 0x080000, CRC(8012362d) SHA1(2c965dc4d738daf2c51a01394685c9ba093a869c) )
	ROM_LOAD16_BYTE( "95404617.hi", 0x00000, 0x080000, CRC(d59b7244) SHA1(fab180e38ba591b9466c78360ad3673f5c291e04) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405616.lo", 0x00001, 0x080000, CRC(878a70b6) SHA1(9413d5229467f4f3f133a887fe6741c9d16af3c4) )
	ROM_LOAD16_BYTE( "95405617.hi", 0x00000, 0x080000, CRC(816c0779) SHA1(4bd726b1debb8d33e92e29831c01a6067f751d1a) )
	ROM_LOAD16_BYTE( "95406138.lo", 0x00001, 0x080000, CRC(c0f3cf7b) SHA1(403fb2a2a6ab951a0e85f5aa5197860b5af6fbff) )
	ROM_LOAD16_BYTE( "95406139.hi", 0x00000, 0x080000, CRC(37b359dd) SHA1(6f67af8fc17ea0a4b8faacc12dc5cc68b112e956) )
	ROM_LOAD16_BYTE( "95407138.lo", 0x00001, 0x080000, CRC(d85bea83) SHA1(39aa0e58854397ce3a4b449a9a01f235d566fa86) )
	ROM_LOAD16_BYTE( "95407139.hi", 0x00000, 0x080000, CRC(dde76e49) SHA1(a2c428c8afe5b949e9cbf0214c1b8d891d318229) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_bankb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408338.odd", 0x00001, 0x080000, CRC(65b31889) SHA1(a74ce2e27aa5700c89c0882dbf37f21312004ce9) )
	ROM_LOAD16_BYTE( "95408339.evn", 0x00000, 0x080000, CRC(5d404f28) SHA1(a1c5833ba5381115cd3b2e0b62708df0f03c81ac) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409338.odd", 0x00001, 0x080000, CRC(b62db492) SHA1(b4c6114c42c59f1bb3cb47c51af41f03aa4f8f98) )
	ROM_LOAD16_BYTE( "95409339.evn", 0x00000, 0x080000, CRC(ee473c08) SHA1(1f9e672bf20c94b0d5dadf16b4e500a7fae244eb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008350.bin", 0x0000, 0x0e3be3, CRC(b19e617c) SHA1(46eb761ac44fef0ff0f1731b098b067ce6843461) )
ROM_END



ROM_START( sc_bantm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416818.lo", 0x00001, 0x080000, CRC(2b180a7f) SHA1(9945452c202d849da2fbde0ddcb02d504667ccde) )
	ROM_LOAD16_BYTE( "95416819.hi", 0x00000, 0x080000, CRC(55eaabbf) SHA1(e41f90cd79c68bf90bf710604fa6079ebd68fad9) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416820.lo", 0x00001, 0x080000, CRC(813d26c0) SHA1(7d6f6874a88ac9c970f07c9bd90132095b2b8bc0) )
	ROM_LOAD16_BYTE( "95416821.hi", 0x00000, 0x080000, CRC(20d748e1) SHA1(61624c5d5e12b8c054e8b2ba723b6e69531826df) )
	ROM_LOAD16_BYTE( "95416822.lo", 0x00001, 0x080000, CRC(070976b0) SHA1(a9a13c58e75e08be87de798d3efb32a8659abc04) )
	ROM_LOAD16_BYTE( "95416823.hi", 0x00000, 0x080000, CRC(4ec8d8bc) SHA1(581c4f6a80bd9cef4293fcbcf3768a9cef4a1858) )
	ROM_LOAD16_BYTE( "95417818.lo", 0x00001, 0x080000, CRC(bc82d375) SHA1(729f4ef4fe39ad2fcf5adada4444581e7fcfdbf8) )
	ROM_LOAD16_BYTE( "95417819.hi", 0x00000, 0x080000, CRC(ec449e02) SHA1(5ab4989c7306ba33f6b85ab0d9b205cb08bcf6f0) )
	ROM_LOAD16_BYTE( "95417820.lo", 0x00001, 0x080000, CRC(15996b8f) SHA1(3240b1816c19bc2f55f6e96d4055e730308ad4f0) )
	ROM_LOAD16_BYTE( "95417821.hi", 0x00000, 0x080000, CRC(308d8f89) SHA1(fc4ffe2e00323af9413379df7e8a85525f0ca8fd) )
	ROM_LOAD16_BYTE( "95417822.lo", 0x00001, 0x080000, CRC(b042b55b) SHA1(bad809c3925953dbd9d2e62bc11a5b0d921e9b91) )
	ROM_LOAD16_BYTE( "95417823.hi", 0x00000, 0x080000, CRC(adf313b2) SHA1(acaee4877f025fbbe962110dae12bcd7a0db4785) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008962.bin", 0x0000, 0x100000, CRC(3c10480f) SHA1(67c86228b6199e336beaa21b2982ce3cf5867ed1) )
	ROM_LOAD( "95008963.bin", 0x0000, 0x100000, CRC(8ceb0bf8) SHA1(b5712f145ff515c10b0a3b131d0c215a31adbb42) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890434.bin", 0x0000, 0x5000, CRC(37740955) SHA1(c7a9839a4f7f01c916b696a8baedf33d0c146fa3) )
	ROM_LOAD( "95890435.bin", 0x0000, 0x5000, CRC(42e24d61) SHA1(dd915ccf979d61cdb0ff7598d35cdceb43d6d8e9) )
	ROM_LOAD( "95890436.bin", 0x0000, 0x5000, CRC(dc58813d) SHA1(9bad2c6cdacaa016f5239e578600f1ff03f1ed63) )
ROM_END



ROM_START( sc_bar7 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410306.lo", 0x00001, 0x080000, CRC(9b7699a8) SHA1(3f2a6548823f0d9d0019e449806f510df7e73bd9) )
	ROM_LOAD16_BYTE( "95410307.hi", 0x00000, 0x080000, CRC(8082f609) SHA1(e4cc191a668db701ce258d95db771a1372136be6) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95411306.lo", 0x00001, 0x080000, CRC(4d1d4253) SHA1(7c8adadb579b75bda331d1326f298942d971e1f5) )
	ROM_LOAD16_BYTE( "95411307.hi", 0x00000, 0x080000, CRC(a2833a56) SHA1(09cf14966cbfad627227ce6e2fdaabe1521a6aac) )
	ROM_LOAD16_BYTE( "95412716.lo", 0x00001, 0x080000, CRC(9b1fe8a2) SHA1(9d813b3001d9577faa26a44cfffbc2496ac64af8) )
	ROM_LOAD16_BYTE( "95412717.hi", 0x00000, 0x080000, CRC(84e6009f) SHA1(f0ce4ca874d30d3cf3d365f4fe569ab7f710294c) )
	ROM_LOAD16_BYTE( "95413716.lo", 0x00001, 0x080000, CRC(2bb811f4) SHA1(4b12168b4fc9a79d8495ac5e8948546c8ba0a942) )
	ROM_LOAD16_BYTE( "95413717.hi", 0x00000, 0x080000, CRC(9bb208dd) SHA1(08e09486a622e17e5cc0c3f948770e9656fa9096) )
	ROM_LOAD16_BYTE( "95418798.lo", 0x00001, 0x080000, CRC(9811b2cf) SHA1(15b7d94cdf4654fe0da53eb6cb166d3495e521c0) )
	ROM_LOAD16_BYTE( "95418799.hi", 0x00000, 0x080000, CRC(4ca310f4) SHA1(3fdba98bcdd78ee073cb7b973f5d5994b2203e84) )
	ROM_LOAD16_BYTE( "95418836.lo", 0x00001, 0x080000, CRC(ab16028f) SHA1(62c2f7800640e414f3e9cde4296683e41c61366f) )
	ROM_LOAD16_BYTE( "95418837.hi", 0x00000, 0x080000, CRC(a6f7ba18) SHA1(53709568cf9adc5c5218d13de85c5cff1a2e79f7) )
	ROM_LOAD16_BYTE( "95419798.lo", 0x00001, 0x080000, CRC(66a2e7e3) SHA1(6a914e448bee58aaa5c6f17ef13f5bf7e7fc0576) )
	ROM_LOAD16_BYTE( "95419799.hi", 0x00000, 0x080000, CRC(202366f4) SHA1(0aef5696016aada29b03ccff324290063a0b3fd6) )
	ROM_LOAD16_BYTE( "95419836.lo", 0x00001, 0x080000, CRC(0ed80c54) SHA1(9f6b3f12b327537cb9bd6f8f2e50746e279d8ac5) )
	ROM_LOAD16_BYTE( "95419837.hi", 0x00000, 0x080000, CRC(a52b18b0) SHA1(ad7a0f2af97c44e5d50393b542c3cc12ef522b2f) )
	ROM_LOAD16_BYTE( "p1438p41.hi", 0x00000, 0x080000, CRC(acaa3793) SHA1(a07ddd23f889365654a957747984f5c27bd78bdb) )
	ROM_LOAD16_BYTE( "p1438p41.lo", 0x00001, 0x080000, CRC(ec471c4d) SHA1(441f29eab8eab37c315ba323b3bd5217285f9a91) )
	ROM_LOAD16_BYTE( "p1438p51.hi", 0x00000, 0x080000, CRC(46b074fc) SHA1(80860af1dc5ddf34c08a50a50f8bf2fb4038494f) )
	ROM_LOAD16_BYTE( "p1438p51.lo", 0x00001, 0x080000, CRC(e922d2e9) SHA1(2047def0e3ed8baef378c7d7e8ab831667c24ce4) )
	ROM_LOAD16_BYTE( "p1438s41.hi", 0x00000, 0x080000, CRC(ae8b7bdd) SHA1(4c705b6849a2fc39e8a84d8ed367366839a99d29) )
	ROM_LOAD16_BYTE( "p1438s41.lo", 0x00001, 0x080000, CRC(73ccf662) SHA1(e6ede55d18f72a1bfc36cc9ae17e9bee17bb3623) )
	ROM_LOAD16_BYTE( "p1438s51.hi", 0x00000, 0x080000, CRC(449138b2) SHA1(e538d848ed2558c730f419eeb5cac203ec75c146) )
	ROM_LOAD16_BYTE( "p1438s51.lo", 0x00001, 0x080000, CRC(76a938c6) SHA1(d83e3bd3690b8f7edfcb4f46cc19300a4c6620c1) )
	ROM_LOAD16_BYTE( "p3064p11.hi", 0x00000, 0x080000, CRC(c85b105b) SHA1(f29e64f45df751a978c64dffdd4919a99bae4d55) )
	ROM_LOAD16_BYTE( "p3064p11.lo", 0x00001, 0x080000, CRC(637fd529) SHA1(8ba3a1f83e88b2bd91d23c63c648e3fa5a7b7804) )
	ROM_LOAD16_BYTE( "p3064s11.hi", 0x00000, 0x080000, CRC(600bed57) SHA1(f0d1d167bddaa4b38aaff9a3191495b6a3e25492) )
	ROM_LOAD16_BYTE( "p3064s11.lo", 0x00001, 0x080000, CRC(b65e219c) SHA1(872e3ce4cfe1f4b2f98ed32639d972ca9fce44a8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008409.bin", 0x0000, 0x080000, CRC(ec29c758) SHA1(ceb99fb6edcab5c5e1b0ec46d622ee0f2cdb20be) )
	ROM_LOAD( "95008423.bin", 0x0000, 0x100000, CRC(4cab20ee) SHA1(e27221a94e54db340eaf7fc30e722b354c85686d) )
	ROM_LOAD( "95008502.bin", 0x0000, 0x080000, CRC(d9bc2c75) SHA1(b9e637d47287a844a6ff1f0b1d1a34b48a806aad) )
	ROM_REGION( 0x400000, "other", ROMREGION_ERASE00 )
	ROM_LOAD( "95751960.p1", 0x0000, 0x010000, CRC(9f944d0c) SHA1(feb8fe4ce0a8f5c4a034aafec0f5aae29a834e8d) )
ROM_END



ROM_START( sc_batl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412976.lo", 0x00001, 0x080000, CRC(b0bcfe61) SHA1(3d84df125744a884199a759b580c2e5b8f08e4f0) )
	ROM_LOAD16_BYTE( "95412977.hi", 0x00000, 0x080000, CRC(d2ba126f) SHA1(f8c1dd94e97dab14bbaefb708afc0f212b5cd765) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95413976.lo", 0x00001, 0x080000, CRC(7385453f) SHA1(cbfaf78d9cb1bf4968dc65b013b3acef7b2c1d5c) )
	ROM_LOAD16_BYTE( "95413977.hi", 0x00000, 0x080000, CRC(5011ccad) SHA1(a1622d4ce94a61d862228c2b60c1a1d8a6fb0d15) )
	ROM_LOAD16_BYTE( "95418014.lo", 0x00001, 0x080000, CRC(11fc27fe) SHA1(d1c59918e2ee1a7a40879f3a369d7064360f8e7b) )
	ROM_LOAD16_BYTE( "95418015.hi", 0x00000, 0x080000, CRC(9731462c) SHA1(5324f60ef10089030ed57d1d50127a3a0af2bfd5) )
	ROM_LOAD16_BYTE( "95419014.lo", 0x00001, 0x080000, CRC(1e17e7fe) SHA1(c8da03a27ed16c53aeb7637265123ca4474f7b8e) )
	ROM_LOAD16_BYTE( "95419015.hi", 0x00000, 0x080000, CRC(05eb5bfb) SHA1(2f5500c48497671c2aeaee02213417cb58b64666) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008541.bin", 0x0000, 0x100000, CRC(a739cba8) SHA1(b968cfa18c671aaf027909961a843fc01101d68a) )
	ROM_LOAD( "95008542.bin", 0x0000, 0x100000, CRC(686bb7cc) SHA1(4e809f2d1401030127d7afa853189c4fca9742e5) )
ROM_END


ROM_START( sc_bed )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408048.lo", 0x00001, 0x080000, CRC(199ff9a4) SHA1(4702d782f5d9fc342087e24335207694182b2806) )
	ROM_LOAD16_BYTE( "95408049.hi", 0x00000, 0x080000, CRC(9c033822) SHA1(294e3cd4fcf1c8427f0e848aca5773cca17adcf8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409048.lo", 0x00001, 0x080000, CRC(89c1cd2f) SHA1(30cd1daf34384a3683450ff5d0e44e08f299a99a) )
	ROM_LOAD16_BYTE( "95409049.hi", 0x00000, 0x080000, CRC(f1bde252) SHA1(91620e2ad559e37e85b2f5acc42ec24ca9675503) )
	ROM_LOAD16_BYTE( "95414626.lo", 0x00001, 0x080000, CRC(4d26157a) SHA1(93f58e631884577cf3baf6e75788168742013361) )
	ROM_LOAD16_BYTE( "95414627.hi", 0x00000, 0x080000, CRC(34d2055b) SHA1(85232661acd9a6265b780547c700a514e9a00d12) )
	ROM_LOAD16_BYTE( "95414628.lo", 0x00001, 0x080000, CRC(d04a0902) SHA1(ed145edb57d97b13920610f884cbf57efb8d105e) )
	ROM_LOAD16_BYTE( "95414629.hi", 0x00000, 0x080000, CRC(8b254f6c) SHA1(68c0c5090a210baa74886069ec95f7865fd30259) )
	ROM_LOAD16_BYTE( "95415626.lo", 0x00001, 0x080000, CRC(d8071b11) SHA1(366e87eb73b70f892f4aac6b5d4c6124f03fc195) )
	ROM_LOAD16_BYTE( "95415627.hi", 0x00000, 0x080000, CRC(9098dea8) SHA1(e503c3e7546e07cdb9256fb575fdc72640e23d8c) )
	ROM_LOAD16_BYTE( "95415628.lo", 0x00001, 0x080000, CRC(01216587) SHA1(b16cd5eb6692298e98374ecafc02a3bb6a8374ed) )
	ROM_LOAD16_BYTE( "95415629.hi", 0x00000, 0x080000, CRC(5b7b2325) SHA1(95bc921d516bcabc5f72d698c64e09234d7c6a2d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008315.bin", 0x0000, 0x100000, CRC(5098077e) SHA1(8ecba67e3585dc7851f8bacb7c5235959f883143) )
ROM_END



ROM_START( sc_bedcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410640.lo", 0x00001, 0x080000, CRC(1a21a4e8) SHA1(8ce99fc663d2f3d7dda473bd5a081d8bb92d14ff) )
	ROM_LOAD16_BYTE( "95410641.hi", 0x00000, 0x080000, CRC(c98869cc) SHA1(968c2d532dde3845e08a1690d51016b8218d52af) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416134.lo", 0x00001, 0x080000, CRC(9f30e058) SHA1(968a766e5348710267e5b3c01c13357e28a11e47) )
	ROM_LOAD16_BYTE( "95416135.hi", 0x00000, 0x080000, CRC(e32d8535) SHA1(2d0696624d1ff97efe815d19e12901dc74b47e6e) )
	ROM_LOAD16_BYTE( "95416136.lo", 0x00001, 0x080000, CRC(0763400e) SHA1(0cb8801a5ebb92683b4a9b1130d13e265560a747) )
	ROM_LOAD16_BYTE( "95416137.hi", 0x00000, 0x080000, CRC(64111a60) SHA1(df5ac99b67da1f98a9e1f79ac4f73c965678294c) )
	ROM_LOAD16_BYTE( "95417134.lo", 0x00001, 0x080000, CRC(e67e5027) SHA1(887cc032afa2ddc83e814cc1051863432d386cc2) )
	ROM_LOAD16_BYTE( "95417135.hi", 0x00000, 0x080000, CRC(279f7ce0) SHA1(826c586cc97f85dd36dfdece969ddfbb41833b27) )
	ROM_LOAD16_BYTE( "95417136.lo", 0x00001, 0x080000, CRC(7e2df071) SHA1(aacaf1c4a49d62e68902b98994cb6aed3bbb7a02) )
	ROM_LOAD16_BYTE( "95417137.hi", 0x00000, 0x080000, CRC(a0a3e3b5) SHA1(138d682649d0167d1d6bbb1e60a5cbff4a2822b6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008397.bin", 0x0000, 0x0fe1b3, CRC(d59cd40d) SHA1(585e42b66e691ab9a3df5bb7dae4368226861b04) )
ROM_END



ROM_START( sc_bblas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406966.lo", 0x00001, 0x080000, CRC(5009dfa2) SHA1(9ed13c78a22b5d7e490eb5205ff7ed1a543c3ff7) )
	ROM_LOAD16_BYTE( "95406967.hi", 0x00000, 0x080000, CRC(64830e10) SHA1(a5c5ec99fb906c94a551c9c3ded79515d3db9898) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407966.lo", 0x00001, 0x080000, CRC(f3ff24d8) SHA1(6b3f25fbac616ea4d4b38e8f428e7da818ede57b) )
	ROM_LOAD16_BYTE( "95407967.hi", 0x00000, 0x080000, CRC(0a7e20f0) SHA1(0ea65cddf94ead103268d0d3444aaaa46603ea14) )
	ROM_LOAD16_BYTE( "95414284.lo", 0x00001, 0x080000, CRC(401f01c3) SHA1(6b6ca3aa67983b714b6c5f13e31b217e29290e62) )
	ROM_LOAD16_BYTE( "95414285.hi", 0x00000, 0x080000, CRC(e4e98606) SHA1(f8541acd7277ceabdb520e7696bf902452da17a5) )
	ROM_LOAD16_BYTE( "95414630.lo", 0x00001, 0x080000, CRC(b8799cb5) SHA1(5826e3a8876d0a78384584267d7eef6937656036) )
	ROM_LOAD16_BYTE( "95414631.hi", 0x00000, 0x080000, CRC(0177e26f) SHA1(8e91acf82d4c67fd1da66f7784746229083f69ce) )
	ROM_LOAD16_BYTE( "95414632.lo", 0x00001, 0x080000, CRC(cf3dcff8) SHA1(83602af5db08d88b2eefca70fc2f9df841e9c019) )
	ROM_LOAD16_BYTE( "95414633.hi", 0x00000, 0x080000, CRC(a2ad3903) SHA1(ff38e4c9efbbc425c7b02ee33e853ce0e6bdcd77) )
	ROM_LOAD16_BYTE( "95415630.lo", 0x00001, 0x080000, CRC(595b795d) SHA1(8d513952a3c317158a6e4e25dfa4e2c2e8c1ab66) )
	ROM_LOAD16_BYTE( "95415631.hi", 0x00000, 0x080000, CRC(bfd4a0c6) SHA1(21acef7f009a240eaafc6f2b4dc1b17ad24e8412) )
	ROM_LOAD16_BYTE( "95415632.lo", 0x00001, 0x080000, CRC(44f83449) SHA1(cab4b3c63b17467fa0318f524d3feeb6d579bf4d) )
	ROM_LOAD16_BYTE( "95415633.hi", 0x00000, 0x080000, CRC(1c912d92) SHA1(c1f5c1399cb4c56a86c28c4833fa210fc14b8979) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008302", 0x0000, 0x0fea01, CRC(ef880aee) SHA1(00177f6a0bfe2006d8545834ea4fb22427be97c4) )
ROM_END


ROM_START( sc_bigdl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404658.odd", 0x00001, 0x080000, CRC(71e605a1) SHA1(8889118669c0c72181ec50b83234d77a061f623f) )
	ROM_LOAD16_BYTE( "95404659.evn", 0x00000, 0x080000, CRC(6eeb199c) SHA1(e5062b111d442818caa9b60eeff350ade563d760) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405658.odd", 0x00001, 0x080000, CRC(2937ff83) SHA1(d36131383f213ec2aaa0c1aebb38e5ec25ec28ab) )
	ROM_LOAD16_BYTE( "95405659.evn", 0x00000, 0x080000, CRC(38fe6279) SHA1(0d121063322df609c95bf668d672d6f0490c5718) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_bingb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416280.lo", 0x00001, 0x080000, CRC(987d1e51) SHA1(5fba6b545532bf6749543be0978a02600e292368) )
	ROM_LOAD16_BYTE( "95416281.hi", 0x00000, 0x080000, CRC(664987e0) SHA1(c024730b82747896f3b4c87b981d40996d12ac90) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417280.lo", 0x00001, 0x080000, CRC(b30a43aa) SHA1(fe90208cdd3eb5fb1306c32a01c542730ac59fd1) )
	ROM_LOAD16_BYTE( "95417281.hi", 0x00000, 0x080000, CRC(72d88d9b) SHA1(b2152119842f40afa474195015e38f0c45971205) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_bb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414574.odd", 0x00001, 0x080000, CRC(6ff4950c) SHA1(5c3c458f7be55aab03a7fde7ff3c4eac0421e89e) )
	ROM_LOAD16_BYTE( "95414575.evn", 0x00000, 0x080000, CRC(ffa0e513) SHA1(0b68114dbbd87a02e90691de4534de224f7b8ad0) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95415574.odd", 0x00001, 0x080000, CRC(3dc1edac) SHA1(e2c8d4757a470432b4280100d9b6ff40e6eb51af) )
	ROM_LOAD16_BYTE( "95415575.evn", 0x00000, 0x080000, CRC(eb31ef68) SHA1(c666f7cbed7f76fd7806412f248c6d02f5d38028) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008350.bin", 0x0000, 0x0e3be3, CRC(b19e617c) SHA1(46eb761ac44fef0ff0f1731b098b067ce6843461) )
ROM_END



ROM_START( sc_bbclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408698.odd", 0x00001, 0x080000, CRC(456c8642) SHA1(adbad206dc692f2feb2d9c69a8d92addf0cb4692) )
	ROM_LOAD16_BYTE( "95408699.evn", 0x00000, 0x080000, CRC(46780e5d) SHA1(b5c2cd8c7209d18d312108cce16fda30a5a4aac1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410110.odd", 0x00001, 0x080000, CRC(e7c636c6) SHA1(fb8c80feca1d2d21b9cf74684d9e897432c813f7) )
	ROM_LOAD16_BYTE( "95410111.evn", 0x00000, 0x080000, CRC(230ad5c8) SHA1(8eebb8bf6cd5acf174adb9723090f842cfab2b1f) )
	ROM_LOAD16_BYTE( "95410916.odd", 0x00001, 0x080000, CRC(7d097be7) SHA1(1d0344a4bd21e445bcd1809f73dbb62dabd1d96a) )
	ROM_LOAD16_BYTE( "95410917.evn", 0x00000, 0x080000, CRC(253f98a0) SHA1(59451ee64979642192fa6976a426ea540de90723) )
	ROM_LOAD16_BYTE( "95411916.odd", 0x00001, 0x080000, CRC(3dc4b066) SHA1(91bdb0c53da149ec50787995429429dd71deb776) )
	ROM_LOAD16_BYTE( "95411917.evn", 0x00000, 0x080000, CRC(25a0ce98) SHA1(17d4bcec407b3a6488b1d30a9a5651cd8e8b6676) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008383.bin", 0x0000, 0x0f350f, CRC(a93300db) SHA1(4f2864cc71b3fe7ac1b323dfd226c18be83d301f) )
ROM_END



ROM_START( sc_blast )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412330.odd", 0x00001, 0x080000, CRC(9be05578) SHA1(ca51be09995523d959f646e142dc76b79bda9973) )
	ROM_LOAD16_BYTE( "95412331.evn", 0x00000, 0x080000, CRC(b9dd2235) SHA1(7c5b11cdc1f2fdd3118fc495dfb4ceb0bd6acd5b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412332.odd", 0x00001, 0x080000, CRC(3571f826) SHA1(7bb18370bd70d71c4049a40f0676b363b1917467) )
	ROM_LOAD16_BYTE( "95412333.evn", 0x00000, 0x080000, CRC(0a3fc7a1) SHA1(483c7ef030ac48f42538df8cd51d3192b9582ca0) )
	ROM_LOAD16_BYTE( "95413330.odd", 0x00001, 0x080000, CRC(789c06d3) SHA1(ad46c911e6525033c549953e1b45acd0a8512378) )
	ROM_LOAD16_BYTE( "95413331.evn", 0x00000, 0x080000, CRC(6a5fecd4) SHA1(a13012664065c1e9e0f02c76da0dfffe7077d3e9) )
	ROM_LOAD16_BYTE( "95413332.odd", 0x00001, 0x080000, CRC(474fa683) SHA1(3ebe087be82e2c9cf3f1addd7cc19c8a6a07f772) )
	ROM_LOAD16_BYTE( "95413333.evn", 0x00000, 0x080000, CRC(c3cbc622) SHA1(3410b0b8e8d9cc3abcb396775c127a33fffbe73d) )
	ROM_LOAD16_BYTE( "95414620.odd", 0x00001, 0x080000, CRC(2de2f00b) SHA1(f214fe86e7f9a131e0370a4efc724c402c4dfb63) )
	ROM_LOAD16_BYTE( "95414621.evn", 0x00000, 0x080000, CRC(c8309fe3) SHA1(e7e3e81d55ccced33569e3dd3e8f27a075402b49) )
	ROM_LOAD16_BYTE( "95415620.odd", 0x00001, 0x080000, CRC(0d72fde7) SHA1(bbf353792cf8f57a0fa8a7265b027cf102a9ca5f) )
	ROM_LOAD16_BYTE( "95415621.evn", 0x00000, 0x080000, CRC(fde3ad57) SHA1(42120f78c86b051eb904d0c3ee7c7de3d53ae1ad) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_blue )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400329.lo", 0x00001, 0x080000, CRC(32f4c121) SHA1(06eb684a2888bb9dbae9624c36720fda2e949b4c) )
	ROM_LOAD16_BYTE( "95400330.hi", 0x00000, 0x080000, CRC(7b59182d) SHA1(c775b95665ce7c7a2b73db744e86acd445f9c1b2) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400371.lo", 0x00001, 0x080000, CRC(fc5128a0) SHA1(590d323f476d5d9d95bbf797a20eb00845ed28a1) )
	ROM_LOAD16_BYTE( "95400372.hi", 0x00000, 0x080000, CRC(95ca9b7b) SHA1(47fe6d9895345d25dcccb80d4598c0210a80f38d) )
	ROM_LOAD16_BYTE( "95400673.lo", 0x00001, 0x080000, CRC(34984f98) SHA1(3b0a07f0cdca6d2cff91b984fb35d1b19c00b1cb) )
	ROM_LOAD16_BYTE( "95400674.hi", 0x00000, 0x080000, CRC(bf9a02d7) SHA1(07f55774cdc39d169ba6f4171fa51dc96a524f94) )
	ROM_LOAD16_BYTE( "95401329.lo", 0x00001, 0x080000, CRC(eabcd848) SHA1(9cfa385e4a4db0c87ed8686165150c5325e7ebd8) )
	ROM_LOAD16_BYTE( "95401330.hi", 0x00000, 0x080000, CRC(2cacf287) SHA1(389b53d47979a5670292ac8d459bae072112e0f1) )
	ROM_LOAD16_BYTE( "95401331.lo", 0x00001, 0x080000, CRC(f1da5967) SHA1(f6aebc89a3963d314f7b1f60678c7888bae211f5) )
	ROM_LOAD16_BYTE( "95401332.hi", 0x00000, 0x080000, CRC(5eac416c) SHA1(5ffde639f02141979d16ae74d514b0add08b4267) )
	ROM_LOAD16_BYTE( "95401673.lo", 0x00001, 0x080000, CRC(b9b543fb) SHA1(2d8c5ab99003c8f8a36543972a0e037008a36acd) )
	ROM_LOAD16_BYTE( "95401674.hi", 0x00000, 0x080000, CRC(2d401f00) SHA1(117bfd706c517e9f188fd322939027ef71c573a4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_bob )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "94416378.lo", 0x00001, 0x080000, CRC(b0c64d0f) SHA1(3f9e9ca908ef43a293a47e15809246cbd3f6cbcf) )
	ROM_LOAD16_BYTE( "94416379.hi", 0x00000, 0x080000, CRC(42468e3e) SHA1(acc5edd9dba26ca525c632dd3a0c991b7af53075) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416240.lo", 0x00001, 0x080000, CRC(d34a7edf) SHA1(f8de8f16cdfc8fb5bc1b48e8eadb809c2391f590) )
	ROM_LOAD16_BYTE( "95416241.hi", 0x00000, 0x080000, CRC(458613d6) SHA1(888e14b794a788423088d753ee59f4f353818094) )
	ROM_LOAD16_BYTE( "95416380.lo", 0x00001, 0x080000, CRC(985426aa) SHA1(c4e67132e9ad8f6793482615432247190487c989) )
	ROM_LOAD16_BYTE( "95416381.hi", 0x00000, 0x080000, CRC(628b66b1) SHA1(81872397e5225a42a6450a6563c765f5e745346d) )
	ROM_LOAD16_BYTE( "95416660.lo", 0x00001, 0x080000, CRC(50509f00) SHA1(de131ec8a346974ce8ee20863ad4caf27fe80cf1) )
	ROM_LOAD16_BYTE( "95416661.hi", 0x00000, 0x080000, CRC(7450faed) SHA1(8cefb6eb6d88d48b186379a2e3538fbf32642630) )
	ROM_LOAD16_BYTE( "95417240.lo", 0x00001, 0x080000, CRC(c179312d) SHA1(3d09204fb594f2580752b02afb77f34299a111db) )
	ROM_LOAD16_BYTE( "95417241.hi", 0x00000, 0x080000, CRC(68c1e0d8) SHA1(0e674306e0692f1a13fb5c3b9cf1cb326b5c2042) )
	ROM_LOAD16_BYTE( "95417378.lo", 0x00001, 0x080000, CRC(2db95b6e) SHA1(7f757d93350582d5280544b3c1a39226bbb61b59) )
	ROM_LOAD16_BYTE( "95417379.hi", 0x00000, 0x080000, CRC(fc981e2e) SHA1(4839f15f3fafe03b478ccfb468c6679ac0b0fb00) )
	ROM_LOAD16_BYTE( "95417380.lo", 0x00001, 0x080000, CRC(9ce4e63a) SHA1(39a27f693ea72bd2cb8841c36211cef57c84e227) )
	ROM_LOAD16_BYTE( "95417381.hi", 0x00000, 0x080000, CRC(a4395863) SHA1(b1b0b816c443fe41d9a25073e32c248ad4d49210) )
	ROM_LOAD16_BYTE( "95417660.lo", 0x00001, 0x080000, CRC(aeb206a8) SHA1(2747f2f2f062c8f62f7f8087df1c0c84d9ba8e79) )
	ROM_LOAD16_BYTE( "95417661.hi", 0x00000, 0x080000, CRC(796b9d5c) SHA1(a208a0a048e428ffafc2dc0997fde4e83e6c17e1) )
	ROM_LOAD16_BYTE( "95420294.lo", 0x00001, 0x080000, CRC(e065a8b6) SHA1(b6f7edcee40bd54aaef994713c97390c7b92fb8d) )
	ROM_LOAD16_BYTE( "95420295.hi", 0x00000, 0x080000, CRC(40aa6a80) SHA1(b0515a8328caec1c537edca64bb21b82fd476ee7) )
	ROM_LOAD16_BYTE( "95420296.lo", 0x00001, 0x080000, CRC(a5c1910a) SHA1(11f965d47ddc590cf50b4b18c8cc70eeac5c94dd) )
	ROM_LOAD16_BYTE( "95420297.hi", 0x00000, 0x080000, CRC(408a0f12) SHA1(e1323f4e29be14cf9ddf4b4b2643df7f775cb737) )
	ROM_LOAD16_BYTE( "95420298.lo", 0x00001, 0x080000, CRC(1f273842) SHA1(a832ff0816aa2646a1421a784bcc79e73f277c1c) )
	ROM_LOAD16_BYTE( "95420299.hi", 0x00000, 0x080000, CRC(41622e25) SHA1(e09b1db7d14a1226b5e66ec22781b57dd28eba9d) )
	ROM_LOAD16_BYTE( "95421294.lo", 0x00001, 0x080000, CRC(e7eb72e8) SHA1(820e780c3d70600dacf9b633fc5e0c358873c7bd) )
	ROM_LOAD16_BYTE( "95421295.hi", 0x00000, 0x080000, CRC(40ec7987) SHA1(b0bdb684cec649c0337078b58e8c86d037b9b157) )
	ROM_LOAD16_BYTE( "95421296.lo", 0x00001, 0x080000, CRC(65ed3bcc) SHA1(0770c3d75b701c8d643bedbb334f26453b1a59b6) )
	ROM_LOAD16_BYTE( "95421297.hi", 0x00000, 0x080000, CRC(e7755b24) SHA1(0e153b0dfe1b3bad06c95ee6e9b344ffd1d3f93f) )
	ROM_LOAD16_BYTE( "95421298.lo", 0x00001, 0x080000, CRC(bd4c64ad) SHA1(56e0a4ffdf83378fdc1e4a02f37ba83030ebb92b) )
	ROM_LOAD16_BYTE( "95421299.hi", 0x00000, 0x080000, CRC(3e755f3e) SHA1(a7dc615e3661c57945f1dbd7fe22669b4048f97f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )

	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890312.bin", 0x0000, 0x5000, CRC(9dfc2404) SHA1(c35f4197c0e0cd45b35f70cce166497de385b212) )
	ROM_LOAD( "95890313.bin", 0x0000, 0x5000, CRC(e86a6030) SHA1(c7fd1ae68aa60c448a31eb9d4103aa0a8c1892d0) )
	ROM_LOAD( "95890314.bin", 0x0000, 0x5000, CRC(76d0ac6c) SHA1(83d150737f942abf19a480b06dc09e1063bb0e64) )
ROM_END




ROM_START( sc_bobcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416880.lo", 0x00001, 0x080000, CRC(94c1b021) SHA1(588bfdf662157382111780b4689cebaa96f32d3c) )
	ROM_LOAD16_BYTE( "95416881.hi", 0x00000, 0x080000, CRC(242e03e0) SHA1(c4d596e5543852d8d1ede9cf9615d4e6ee0f3209) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417880.lo", 0x00001, 0x080000, CRC(d1960747) SHA1(c95db85832cc8acb29c3ae7066d5109f2621e3ae) )
	ROM_LOAD16_BYTE( "95417881.hi", 0x00000, 0x080000, CRC(d40cfb16) SHA1(3a200fbb3c5fed4d1602f43e7ba2858436a6d35f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008967.bin", 0x0000, 0x0f64c6, CRC(cf1e1c59) SHA1(f7ccbc6ed20aed329c2a199a489686bb8e87edfb) )
ROM_END




ROM_START( sc_bonbx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414234.lo", 0x00001, 0x080000, CRC(68bd7c9a) SHA1(73a798755ce4cfa8fd95d5c3a2bea2a240432a67) )
	ROM_LOAD16_BYTE( "95414235.hi", 0x00000, 0x080000, CRC(6e5c5047) SHA1(c2a5e98f6a2c519a07833a6f3029d5f3fb65c026) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414420.lo", 0x00001, 0x080000, CRC(17c6e99c) SHA1(9194009c4c1d9a1593fac15a57753673dee468a8) )
	ROM_LOAD16_BYTE( "95414421.hi", 0x00000, 0x080000, CRC(8b2954e3) SHA1(ad39ac956d4bbd3ed4b3101cf20e632337b0d4e4) )
	ROM_LOAD16_BYTE( "95414538.lo", 0x00001, 0x080000, CRC(b1560f4d) SHA1(d4d1dc0fd418e8eac617e0a4b8e5b0f67ab248a9) )
	ROM_LOAD16_BYTE( "95414539.hi", 0x00000, 0x080000, CRC(7ff8212d) SHA1(fb52ed0bd0930ed927671755edbfa79ecdbeb211) )
	ROM_LOAD16_BYTE( "95415234.lo", 0x00001, 0x080000, CRC(bfb6e866) SHA1(dac56d11eae1268e9f1c389b65de024ca0319a24) )
	ROM_LOAD16_BYTE( "95415235.hi", 0x00000, 0x080000, CRC(9ee1fe89) SHA1(1dfe5f321c376c161ec374c916f3b08a63b7e3e1) )
	ROM_LOAD16_BYTE( "95415236.lo", 0x00001, 0x080000, CRC(2b4cef52) SHA1(2114331e0f292f1da0fa4bd852c8317384a71a21) )
	ROM_LOAD16_BYTE( "95415237.hi", 0x00000, 0x080000, CRC(bf8065a6) SHA1(bbf2d5f49f9854b92a7f4e2b5e1fc6cfd5072268) )
	ROM_LOAD16_BYTE( "95415238.lo", 0x00001, 0x080000, CRC(0fcac068) SHA1(aba80a5a96ccfd6b9c05e63f28afa5afb810ac5e) )
	ROM_LOAD16_BYTE( "95415239.hi", 0x00000, 0x080000, CRC(73b40b12) SHA1(582cf89b4bb0dcbb189a694158782e7fc2d108ee) )
	ROM_LOAD16_BYTE( "95415418.lo", 0x00001, 0x080000, CRC(861ac22e) SHA1(8d238d52045b90dbbe236b59dc13ed36a2a9f6bd) )
	ROM_LOAD16_BYTE( "95415419.hi", 0x00000, 0x080000, CRC(ba75fe01) SHA1(8ca5b3559c1c9c72035d9926a0e68262f7cd958a) )
	ROM_LOAD16_BYTE( "95415420.lo", 0x00001, 0x080000, CRC(7235848f) SHA1(65e919674920084f530f96788bc8a75997fe7bbe) )
	ROM_LOAD16_BYTE( "95415421.hi", 0x00000, 0x080000, CRC(1a2feb9c) SHA1(e9fdbf8e944c9b758b822949ad2ef4c20b511597) )
	ROM_LOAD16_BYTE( "95415422.lo", 0x00001, 0x080000, CRC(22149879) SHA1(336e41430029385b6c644ed343f65416a1390d8c) )
	ROM_LOAD16_BYTE( "95415423.hi", 0x00000, 0x080000, CRC(14d6ca23) SHA1(88184d5dce82f014867c0b656e3a581f664e9a38) )
	ROM_LOAD16_BYTE( "95415424.lo", 0x00001, 0x080000, CRC(2d491a10) SHA1(4f2600d28f4b1429f95ceff39165e28008446ea1) )
	ROM_LOAD16_BYTE( "95415425.hi", 0x00000, 0x080000, CRC(963b5f3b) SHA1(c1383d2aa5bf7ae8127ecab57632981a74b964cf) )
	ROM_LOAD16_BYTE( "95415538.lo", 0x00001, 0x080000, CRC(a0aaa513) SHA1(f2320884efc2c7b04bf3dddcac2baba40fd007b9) )
	ROM_LOAD16_BYTE( "95415539.hi", 0x00000, 0x080000, CRC(6ac8d11e) SHA1(dca72f4be29d34f6532d01954565bb4213231a48) )
	ROM_LOAD16_BYTE( "95415540.lo", 0x00001, 0x080000, CRC(7550199f) SHA1(a1ef86e143cdf993f63034c884ea341bbda15488) )
	ROM_LOAD16_BYTE( "95415541.hi", 0x00000, 0x080000, CRC(1d68b1d0) SHA1(f269bd3ba2db0c1fdacf88b50b0f3b335685b281) )
	ROM_LOAD16_BYTE( "95415542.lo", 0x00001, 0x080000, CRC(eb8f85d0) SHA1(98b2ef28c800997f26ee50c5d428d4268540eac8) )
	ROM_LOAD16_BYTE( "95415543.hi", 0x00000, 0x080000, CRC(48f17abd) SHA1(761ed166d553306b28084bf243ac4adabbea54e1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_brksp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404458.lo", 0x00001, 0x080000, CRC(89d6e62f) SHA1(8c6df05583e04f705dd4c4c968b7e84ad9bd9d22) )
	ROM_LOAD16_BYTE( "95404459.hi", 0x00000, 0x080000, CRC(ef22a826) SHA1(e7710f8858d905358d7f78be1ce767c080e4b2fa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405458.lo", 0x00001, 0x080000, CRC(31722ba9) SHA1(83b5a20ac2e5f07958f3b42adc5e94cc8dcfeac9) )
	ROM_LOAD16_BYTE( "95405459.hi", 0x00000, 0x080000, CRC(49152b35) SHA1(fba0947c54dbf69bf342f7e192233c83dc4a6025) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008210.bin", 0x0000, 0x1aea2f, CRC(da15a50e) SHA1(2f068526992358789e5f2c347a5adf56a1bfde52) )
ROM_END




ROM_START( sc_brix )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404786.lo", 0x00001, 0x080000, CRC(fa9a8b28) SHA1(20e5ba6d4b4fb8fd2f17043a23b676922de28379) )
	ROM_LOAD16_BYTE( "95404787.hi", 0x00000, 0x080000, CRC(883ab49f) SHA1(8697c2703da16f07639ef3d678a4779b4a68d98a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408176.lo", 0x00001, 0x080000, CRC(87e00ec4) SHA1(2692a72c358b4af6c89393495ca27b986b2ff2a7) )
	ROM_LOAD16_BYTE( "95408177.hi", 0x00000, 0x080000, CRC(19dac202) SHA1(f9b122f06dd988063f5eb7c8fd0a7e07006a4224) )
	ROM_LOAD16_BYTE( "95408510.lo", 0x00001, 0x080000, CRC(5ec0efa2) SHA1(47c56507f5878b7be7e9d222d16aea3904028531) )
	ROM_LOAD16_BYTE( "95408511.hi", 0x00000, 0x080000, CRC(ccb8008d) SHA1(573ed2fdd7e61603d1c6cfa04f1a801b201344ce) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_bugs )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402359.lo", 0x00001, 0x080000, CRC(5fb17f27) SHA1(410070592ac6341aa92df657f92860dba68be579) )
	ROM_LOAD16_BYTE( "95402360.hi", 0x00000, 0x080000, CRC(14e3e3d8) SHA1(701b3c74e18549435deb884f44589c3c23c6a69b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402361.lo", 0x00001, 0x080000, CRC(93daa0c9) SHA1(d793611a572463dfd95686bbdbad8323db819b43) )
	ROM_LOAD16_BYTE( "95402362.hi", 0x00000, 0x080000, CRC(5fe0ba99) SHA1(ae17cad184aeb0f29f88509de780c31a78a7f71a) )
	ROM_LOAD16_BYTE( "95403359.lo", 0x00001, 0x080000, CRC(7d6364ca) SHA1(48343572910b753950afd540b9b06fccc16a708e) )
	ROM_LOAD16_BYTE( "95403360.hi", 0x00000, 0x080000, CRC(2d351aad) SHA1(58675bf335c18306ce16d4745c2f3063d102b176) )
	ROM_LOAD16_BYTE( "95403361.lo", 0x00001, 0x080000, CRC(d36a6c8a) SHA1(e469c83a3e01189eb981c900447669aa06571921) )
	ROM_LOAD16_BYTE( "95403362.hi", 0x00000, 0x080000, CRC(33ff9aa1) SHA1(68e064931af100eb846e1b689ec8d8707d44b60a) )
	ROM_LOAD16_BYTE( "bugsmoney.hi", 0x00000, 0x080000, CRC(14e3e3d8) SHA1(701b3c74e18549435deb884f44589c3c23c6a69b) )
	ROM_LOAD16_BYTE( "bugsmoney.lo", 0x00001, 0x080000, CRC(5fb17f27) SHA1(410070592ac6341aa92df657f92860dba68be579) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_bull )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412888.lo", 0x00001, 0x080000, CRC(ea4916cc) SHA1(6c073331b44049e8ea7ac3081dbb5ec7f33f6866) )
	ROM_LOAD16_BYTE( "95412889.hi", 0x00000, 0x080000, CRC(611a3bd6) SHA1(05c199b673824936c140289b9c302c0b946979b1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412934.lo", 0x00001, 0x080000, CRC(769ff771) SHA1(ad3df6d5887349de8e273fd8fcc1889dc9231c6b) )
	ROM_LOAD16_BYTE( "95412935.hi", 0x00000, 0x080000, CRC(3f811a12) SHA1(5fb6e0e2182374fee69839c8d1d046546eb98233) )
	ROM_LOAD16_BYTE( "95413888.lo", 0x00001, 0x080000, CRC(0a8ff0a7) SHA1(f1dc9393ed81a90bca24360d6dbf26bf7177d14f) )
	ROM_LOAD16_BYTE( "95413889.hi", 0x00000, 0x080000, CRC(cadbc132) SHA1(44a49071ceba94f05ee94bfd30827b0cee14a62c) )
	ROM_LOAD16_BYTE( "95413934.lo", 0x00001, 0x080000, CRC(bab4d554) SHA1(f020ed79df0fcb8f788045cdb77ddf2b964e1553) )
	ROM_LOAD16_BYTE( "95413935.hi", 0x00000, 0x080000, CRC(c81fb05c) SHA1(992e385553ad755f6ef8df04c9e4524340b870bd) )
	ROM_LOAD16_BYTE( "95418146.lo", 0x00001, 0x080000, CRC(5f9108e0) SHA1(a62bebdc729f514476d77893eb5d8f5ed8384abb) )
	ROM_LOAD16_BYTE( "95418147.hi", 0x00000, 0x080000, CRC(f782fd6c) SHA1(3602d451e32a00c523453e7e595b4e34214aa55d) )
	ROM_LOAD16_BYTE( "95418744.lo", 0x00001, 0x080000, CRC(9699eab6) SHA1(aa7ddaf87cacf0dab0895135bc1ec05afd5ea41f) )
	ROM_LOAD16_BYTE( "95418745.hi", 0x00000, 0x080000, CRC(0c628f17) SHA1(f76df3f7f1ec1163f6850ba086eff4e2b97ed7e0) )
	ROM_LOAD16_BYTE( "95418830.lo", 0x00001, 0x080000, CRC(f87a11e3) SHA1(c6637f331005df9d4d5a6bd970d79c2367c8f33e) )
	ROM_LOAD16_BYTE( "95419146.lo", 0x00001, 0x080000, CRC(407082d7) SHA1(55d4253f4404c579a5b3654a52484512e877cf41) )
	ROM_LOAD16_BYTE( "95419147.hi", 0x00000, 0x080000, CRC(7f5ded3f) SHA1(73eac57938d61f9ba94b673c653d4e1668e85b7d) )
	ROM_LOAD16_BYTE( "95419744.lo", 0x00001, 0x080000, CRC(0ba6cdb0) SHA1(93ed4e1daf3bd3e23988051995ac53343c83bc64) )
	ROM_LOAD16_BYTE( "95419745.hi", 0x00000, 0x080000, CRC(1a118bb4) SHA1(5a1df4379a7c90f1b26013d949f86f55f579980b) )
	ROM_LOAD16_BYTE( "95419830.lo", 0x00001, 0x080000, CRC(a652480f) SHA1(de2e1aadbd1d2d64018faef9cd505eb05fbccc71) )
	ROM_LOAD16_BYTE( "p1719p11.hi", 0x00000, 0x080000, CRC(9647d67b) SHA1(944299d64953c472dee486e1a8c479aa275d5ef9) )
	ROM_LOAD16_BYTE( "p1719p11.lo", 0x00001, 0x080000, CRC(c7473a2b) SHA1(4fe8120ce5e39bb2ac33f9659f5bb35a79e5da86) )
	ROM_LOAD16_BYTE( "p1719s11.hi", 0x00000, 0x080000, CRC(6e478e1b) SHA1(148d4dad7466836c1e8f835e0c344a42b128f982) )
	ROM_LOAD16_BYTE( "p1719s11.lo", 0x00001, 0x080000, CRC(8ac0cd1a) SHA1(7e40fd0f1dedfeb2a83e439249edc016cb65c154) )
	ROM_LOAD16_BYTE( "p3318p71.hi", 0x00000, 0x080000, CRC(eb94716e) SHA1(f9ed42da57519b68eb7d9be48115aaf8607d6c93) )
	ROM_LOAD16_BYTE( "p3318p71.lo", 0x00001, 0x080000, CRC(c55f25a4) SHA1(2554e8d1c3547f0e93e1fc5f7e6b42c43c7654b3) )
	ROM_LOAD16_BYTE( "p3318p72.hi", 0x00000, 0x080000, CRC(a8693b6b) SHA1(380fdf5dd8518995d915583e547e94562a4c0f7b) )
	ROM_LOAD16_BYTE( "p3318p72.lo", 0x00001, 0x080000, CRC(657bba1e) SHA1(f8fa202c4057d3e37540d32c15965368bb73accd) )
	ROM_LOAD16_BYTE( "p3318s71.hi", 0x00000, 0x080000, CRC(7481c408) SHA1(13b12c77c66973df75ee32d151ce5be072b0b02e) )
	ROM_LOAD16_BYTE( "p3318s71.lo", 0x00001, 0x080000, CRC(32bf3031) SHA1(e1c1b2207c988d3d4c8bbba386518760dc6c5245) )
	ROM_LOAD16_BYTE( "p3318s72.hi", 0x00000, 0x080000, CRC(20c23a5e) SHA1(c6aa64a99b04fdf87cb56d1f2a15f16f3d3d075b) )
	ROM_LOAD16_BYTE( "p3318s72.lo", 0x00001, 0x080000, CRC(03203e08) SHA1(70566d3d011b0d09dad6edf0812c6c2a6f4a68a6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008520.bin", 0x0000, 0x100000, CRC(ab418ce0) SHA1(39afbd449a21a31016acaffcfb4f6d684db300e7) )
	ROM_LOAD( "95008521.bin", 0x0000, 0x100000, CRC(7fd0f70c) SHA1(e6bf85b9e2528dac5811277ee89599e58e6358b0) )
	ROM_LOAD( "95008544.bin", 0x0000, 0x100000, CRC(19777f20) SHA1(da0cc08b00f9ab565a0e559761adbf7bcd7c327b) )
	ROM_LOAD( "95008575.bin", 0x0000, 0x100000, CRC(715901d2) SHA1(a7d3d0c7b9fc3eefb0df372cdf0cae7abe8bd959) )
	ROM_LOAD( "95009116.bin", 0x0000, 0x100000, CRC(5a01e206) SHA1(38ee3706d9edb68d17c90bb627aa17b4f908d721) )
	ROM_LOAD( "95009117.bin", 0x0000, 0x100000, CRC(c3623829) SHA1(92b0cf89678023bb02394699e2e214389317ec6c) )
ROM_END




ROM_START( sc_bulcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418032.lo", 0x00001, 0x080000, CRC(1eb87819) SHA1(0ce61f22d5038da059325b17a1e68788dff54460) )
	ROM_LOAD16_BYTE( "95418033.hi", 0x00000, 0x080000, CRC(88c17569) SHA1(7c115440e531266d03e8b47b2e86b85b413d4508) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418038.lo", 0x00001, 0x080000, CRC(579346ca) SHA1(1a5226b381e3b443ca978f534245f97648d32488) )
	ROM_LOAD16_BYTE( "95418039.hi", 0x00000, 0x080000, CRC(8be73e67) SHA1(44a79674c49938a2547e4a0ece9f9ad2f2604aaa) )
	ROM_LOAD16_BYTE( "95418302.lo", 0x00001, 0x080000, CRC(b6a10914) SHA1(94f1709700b925c7c4a29bc7045dd83126cc8175) )
	ROM_LOAD16_BYTE( "95418303.hi", 0x00000, 0x080000, CRC(2de75bac) SHA1(ba2686bfe86cb20d62c1eb3312180db6477e3125) )
	ROM_LOAD16_BYTE( "95418362.lo", 0x00001, 0x080000, CRC(2eeb5021) SHA1(2fc456ca457d884c701f32ba6dc0cc367409691f) )
	ROM_LOAD16_BYTE( "95418363.hi", 0x00000, 0x080000, CRC(ff842f06) SHA1(98fa76b55314870869fcbb70fffb1bd81cbb3bb0) )
	ROM_LOAD16_BYTE( "95419032.lo", 0x00001, 0x080000, CRC(386addda) SHA1(397905e5bfde65ac6e6ad6d4531b9faa305bfc4c) )
	ROM_LOAD16_BYTE( "95419033.hi", 0x00000, 0x080000, CRC(006da7dc) SHA1(8af127afc32976146dfc2290bd648f4c910040c5) )
	ROM_LOAD16_BYTE( "95419038.lo", 0x00001, 0x080000, CRC(8365dc75) SHA1(9fc6ee859144b08a791e0357dc4855a50128b8cb) )
	ROM_LOAD16_BYTE( "95419039.hi", 0x00000, 0x080000, CRC(16e44ad9) SHA1(510b6d55591e540700e6a67520330619c8800738) )
	ROM_LOAD16_BYTE( "95419302.lo", 0x00001, 0x080000, CRC(0c58753a) SHA1(ab82c97090cd9673a0a26e9853ea3261fc723268) )
	ROM_LOAD16_BYTE( "95419303.hi", 0x00000, 0x080000, CRC(a3257e7a) SHA1(ba08e5d01b4dd4060493c658f8fec767dfa24d1e) )
	ROM_LOAD16_BYTE( "95419362.lo", 0x00001, 0x080000, CRC(ee0c0a9b) SHA1(04334c242a9b7a6e9e59c0c0588883780e829788) )
	ROM_LOAD16_BYTE( "95419363.hi", 0x00000, 0x080000, CRC(a77691fa) SHA1(988ca1d9b5cf89a33972f4b0128afcfb2b898134) )
	ROM_LOAD16_BYTE( "95422482.lo", 0x00001, 0x080000, CRC(7e158734) SHA1(021648372f8a089325fda98476ad44f66dc4552c) )
	ROM_LOAD16_BYTE( "95422483.hi", 0x00000, 0x080000, CRC(0848d756) SHA1(e428f5771f2bb9e1ebebf0c896ae95aa119faa52) )
	ROM_LOAD16_BYTE( "95423482.lo", 0x00001, 0x080000, CRC(a1d0dff6) SHA1(3146d50a080cb85ac88d6afa1f3f84972b2aa563) )
	ROM_LOAD16_BYTE( "95423483.hi", 0x00000, 0x080000, CRC(6eaa6693) SHA1(36f513bd7bc73c4884464916e5c803ce7da564c7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008547.bin", 0x0000, 0x100000, CRC(33d997ba) SHA1(22c28360757bad350907b145e18a8e438d68f2b1) )
	ROM_LOAD( "95008548.bin", 0x0000, 0x100000, CRC(896bae80) SHA1(264127b6d22c048a0a54e7a63433c3aed6f053e2) )
ROM_END




ROM_START( sc_butch )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418332.lo", 0x00001, 0x080000, CRC(0f2fc032) SHA1(2ed1fed3ae1f31dab5b7f00f0f88b388582a4274) )
	ROM_LOAD16_BYTE( "95418333.hi", 0x00000, 0x080000, CRC(d56262e0) SHA1(3ee37fba8f2a5b74c4d2596e76d724ebb03ba007) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418334.lo", 0x00001, 0x080000, CRC(eafed6e2) SHA1(a38b551ee7ba1d486ef2465c506be710f6300146) )
	ROM_LOAD16_BYTE( "95418335.hi", 0x00000, 0x080000, CRC(aaa386cb) SHA1(003ca24635510f1e92eb269d028b951abdaea7ef) )
	ROM_LOAD16_BYTE( "95418806.lo", 0x00001, 0x080000, CRC(537a03d8) SHA1(a2c7fc1a48b1d3ff9ee49a1dd7754bb6ddd96017) )
	ROM_LOAD16_BYTE( "95418807.hi", 0x00000, 0x080000, CRC(a98ad35b) SHA1(9c7af483afb5d6312c258a5c1c99c1f2ad1dccce) )
	ROM_LOAD16_BYTE( "95418816.lo", 0x00001, 0x080000, CRC(f9f97eed) SHA1(dfb568189cd0f79c9930171b2b21ed6f641c85db) )
	ROM_LOAD16_BYTE( "95418817.hi", 0x00000, 0x080000, CRC(a371016c) SHA1(b8d324592d688247b2f5b1ed8ed709f19abe518b) )
	ROM_LOAD16_BYTE( "95418874.lo", 0x00001, 0x080000, CRC(a0ba18ad) SHA1(4499a64bc23b002c632198f61970db810d7d2d9c) )
	ROM_LOAD16_BYTE( "95418875.hi", 0x00000, 0x080000, CRC(4184a7e2) SHA1(d3a2a45c2b29d3e0b6c4eba57f442673b87fa649) )
	ROM_LOAD16_BYTE( "95418910.lo", 0x00001, 0x080000, CRC(bebc83cd) SHA1(00e4ad7e5b79da90d61005eb2eb56053b919b38a) )
	ROM_LOAD16_BYTE( "95418911.hi", 0x00000, 0x080000, CRC(3a61c8d1) SHA1(b6039a11c97986865e8cfed7acc3adbc8a0506bc) )
	ROM_LOAD16_BYTE( "95418948.lo", 0x00001, 0x080000, CRC(fa68a9af) SHA1(b5a2260cf3fa3eb1cb8cdb923a0c69bebe80c893) )
	ROM_LOAD16_BYTE( "95418949.hi", 0x00000, 0x080000, CRC(cacb0b41) SHA1(7ad01a4b31f601000fed8aa18725c26daade087e) )
	ROM_LOAD16_BYTE( "95419332.lo", 0x00001, 0x080000, CRC(4ae82089) SHA1(06c7a23bf8196876eed775709cc8e8654a4dd01b) )
	ROM_LOAD16_BYTE( "95419333.hi", 0x00000, 0x080000, CRC(db85a7f9) SHA1(ea08240e65809bb49898fa1464c05f2b22409c9d) )
	ROM_LOAD16_BYTE( "95419334.lo", 0x00001, 0x080000, CRC(94825977) SHA1(0a7f5a7ee929f88fd7f3902e93b08c47bd2de7e2) )
	ROM_LOAD16_BYTE( "95419335.hi", 0x00000, 0x080000, CRC(df899d01) SHA1(02c97f953376cdf76d3321b3daac1cb4ca28f07a) )
	ROM_LOAD16_BYTE( "95419806.lo", 0x00001, 0x080000, CRC(34b937e8) SHA1(05af5af7d165235798a432d6fe36ba2bc2f846bb) )
	ROM_LOAD16_BYTE( "95419807.hi", 0x00000, 0x080000, CRC(dfe33c01) SHA1(4c8d74e2c54d419911ba138f8d5ddcfeb6f9f883) )
	ROM_LOAD16_BYTE( "95419816.lo", 0x00001, 0x080000, CRC(d7fc4130) SHA1(99f7b40cc226c1d4c017f9ba08fdfec7024b313b) )
	ROM_LOAD16_BYTE( "95419817.hi", 0x00000, 0x080000, CRC(ecce1743) SHA1(d4552bc518ac2c24fb0f41acd3a123b2a952796b) )
	ROM_LOAD16_BYTE( "95419874.lo", 0x00001, 0x080000, CRC(266f617a) SHA1(abb6c88c81fa3135702fa88e8c40b89aa004f365) )
	ROM_LOAD16_BYTE( "95419875.hi", 0x00000, 0x080000, CRC(79f3a4df) SHA1(0f01fc4c2a1e5c8fea163ae64a76949b9f665c75) )
	ROM_LOAD16_BYTE( "95419910.lo", 0x00001, 0x080000, CRC(12795f7e) SHA1(2fc36d8be93bff5e62c682b5e8b391862656b1cf) )
	ROM_LOAD16_BYTE( "95419911.hi", 0x00000, 0x080000, CRC(8966bbf1) SHA1(23d323f849c8c67328af4fbdf084c7b68964b5fd) )
	ROM_LOAD16_BYTE( "95419948.lo", 0x00001, 0x080000, CRC(2159f20a) SHA1(eb0354ab815656ae35495ab5cbd1e9426c9ad2e3) )
	ROM_LOAD16_BYTE( "95419949.hi", 0x00000, 0x080000, CRC(175efc3b) SHA1(cfaa96cca4ab3e627d3b064d46877ec94fef8cc4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008604.bin", 0x0000, 0x100000, CRC(dede59e0) SHA1(de56b80d0a53fbb18acce2b907f48801e8fced12) )
	ROM_LOAD( "95008605.bin", 0x0000, 0x100000, CRC(3db1a818) SHA1(2c20d39dc0d7eb3996209a0b34afae3cd2eebbdc) )
ROM_END




ROM_START( sc_cabin )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416198.lo", 0x00001, 0x080000, CRC(acd3688e) SHA1(b27d39d8e1fbfd2a20d06773e0397b96af9c1a11) )
	ROM_LOAD16_BYTE( "95416199.hi", 0x00000, 0x080000, CRC(9419cdf9) SHA1(00a3a236dd8f712ffcdb9e5df413563054598c76) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416548.lo", 0x00001, 0x080000, CRC(f4bf09ed) SHA1(f30ff3c295af7e0483ba2604d83274e5430876be) )
	ROM_LOAD16_BYTE( "95416549.hi", 0x00000, 0x080000, CRC(2b30b64b) SHA1(3d65c3333ebd56c3c39590c2c801cd45d0c74dea) )
	ROM_LOAD16_BYTE( "95416550.lo", 0x00001, 0x080000, CRC(328f9f69) SHA1(5cfe84ba80e24cbee5009a7c1a4d8a723d9985d2) )
	ROM_LOAD16_BYTE( "95416551.hi", 0x00000, 0x080000, CRC(e3ad34f0) SHA1(a4a0fb869c43bfbe9d811ffe9f4ee0833895f7fd) )
	ROM_LOAD16_BYTE( "95416864.lo", 0x00001, 0x080000, CRC(73c39f56) SHA1(5bd300d020c522a723ab55da8031f1d323c481bf) )
	ROM_LOAD16_BYTE( "95416865.hi", 0x00000, 0x080000, CRC(7bb6a60d) SHA1(6f88a09c0cf883c2d61666f8491d8a7d268d1e55) )
	ROM_LOAD16_BYTE( "95416866.lo", 0x00001, 0x080000, CRC(e83a4c5a) SHA1(4724f82f609f008166ff2457eaaa76203a29b603) )
	ROM_LOAD16_BYTE( "95416867.hi", 0x00000, 0x080000, CRC(7eced3f5) SHA1(98bb8251b4ec65a7f5fa4c0a5fb2636376fe0c67) )
	ROM_LOAD16_BYTE( "95417198.lo", 0x00001, 0x080000, CRC(8b7549c5) SHA1(6948483265b601904134d3cee265c560062b13cc) )
	ROM_LOAD16_BYTE( "95417199.hi", 0x00000, 0x080000, CRC(7616fdd5) SHA1(fe37395bc9188931b1beac28ef2886cb2384976b) )
	ROM_LOAD16_BYTE( "95417548.lo", 0x00001, 0x080000, CRC(2322f9e3) SHA1(f3a194a017d4e3c08af4316caf22764fb7f68ad4) )
	ROM_LOAD16_BYTE( "95417549.hi", 0x00000, 0x080000, CRC(3b811137) SHA1(59645e6f6c602d6c448576ecc3e8171d35b65cca) )
	ROM_LOAD16_BYTE( "95417550.lo", 0x00001, 0x080000, CRC(fabed74d) SHA1(3c9acd930c146078946132d012d7e713931b4464) )
	ROM_LOAD16_BYTE( "95417551.hi", 0x00000, 0x080000, CRC(4a43de8a) SHA1(2ff08674afa3341b6c6f1330038bf90c6279af80) )
	ROM_LOAD16_BYTE( "95417864.lo", 0x00001, 0x080000, CRC(f551a5c5) SHA1(c8826280430fb69090da1e6ff3f656e45502321d) )
	ROM_LOAD16_BYTE( "95417865.hi", 0x00000, 0x080000, CRC(0de1127e) SHA1(218c48e33ad828d46efe74b73001e31b0afbcbd8) )
	ROM_LOAD16_BYTE( "95417866.lo", 0x00001, 0x080000, CRC(1d287877) SHA1(7730c187ae2941472e695d2130d84e106f7826a7) )
	ROM_LOAD16_BYTE( "95417867.hi", 0x00000, 0x080000, CRC(8035b533) SHA1(ff664de67108f73d3a282079f4ce46fda7fb7b7f) )
	ROM_LOAD16_BYTE( "95420574.lo", 0x00001, 0x080000, CRC(56fb3a4b) SHA1(075d2fb9d1b260b5161c4d3f6f584c3a1aa742ca) )
	ROM_LOAD16_BYTE( "95420575.hi", 0x00000, 0x080000, CRC(4f91bad2) SHA1(69524ea2a902987775e59e352ce91e3de3e9b1b8) )
	ROM_LOAD16_BYTE( "95420576.lo", 0x00001, 0x080000, CRC(685b132b) SHA1(15f53a9cfb69f77356a1b5251c8e8227b55a05c2) )
	ROM_LOAD16_BYTE( "95420577.hi", 0x00000, 0x080000, CRC(3f5ae984) SHA1(b17a1f911025cdb94bb8bb0bd6f7eae86d3458f9) )
	ROM_LOAD16_BYTE( "95420578.lo", 0x00001, 0x080000, CRC(858102df) SHA1(e8b98596bb93176e22352b1d87dc75f721ce9325) )
	ROM_LOAD16_BYTE( "95420579.hi", 0x00000, 0x080000, CRC(3a99188a) SHA1(80ca9140bb10896ac7443e8550ffd9436decf608) )
	ROM_LOAD16_BYTE( "95420580.lo", 0x00001, 0x080000, CRC(19a56973) SHA1(5dc3a78c90d6dc7ff138bfa54d7e7d8276a5bd8b) )
	ROM_LOAD16_BYTE( "95420581.hi", 0x00000, 0x080000, CRC(beb7da8e) SHA1(9d90bc0f3505f9529e3a8cb3087a0ddc770db592) )
	ROM_LOAD16_BYTE( "95421574.lo", 0x00001, 0x080000, CRC(7d259244) SHA1(04cd0b33d58f3ae8da8c55d1ebf7966f4723f305) )
	ROM_LOAD16_BYTE( "95421575.hi", 0x00000, 0x080000, CRC(5910850d) SHA1(d1218443133c23cbdb8f13161b9631be70fb9eae) )
	ROM_LOAD16_BYTE( "95421576.lo", 0x00001, 0x080000, CRC(d56ce8cc) SHA1(297c139d11db4b99ed8ba8e084410062ba77b26c) )
	ROM_LOAD16_BYTE( "95421577.hi", 0x00000, 0x080000, CRC(0a2c4c51) SHA1(f47bb9791ab0afbe3e5755dde719520c0b7b86e3) )
	ROM_LOAD16_BYTE( "95421578.lo", 0x00001, 0x080000, CRC(861d3dcb) SHA1(427b43333aafb8221a5201dfafafe862e5e3b640) )
	ROM_LOAD16_BYTE( "95421579.hi", 0x00000, 0x080000, CRC(43bc1f5e) SHA1(5ee7c2ac4c83bcedd4a880b7f6431e2a2a26728c) )
	ROM_LOAD16_BYTE( "95421580.lo", 0x00001, 0x080000, CRC(9b080907) SHA1(7e3a4474302a786f28e0372444a165474c61895b) )
	ROM_LOAD16_BYTE( "95421581.hi", 0x00000, 0x080000, CRC(84e91010) SHA1(3e455ec15cdad954b8112cceaf3697f2519db9cc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008902.bin", 0x0000, 0x0e7fd3, CRC(c7b0f675) SHA1(e19d4e65d73329a58b9cbc6828c7e0c287f2906a) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890306.bin", 0x0000, 0x5000, CRC(eff2e8d8) SHA1(0749d543bf760b2037330ade671c7ce7ed64b275) )
	ROM_LOAD( "95890307.bin", 0x0000, 0x5000, CRC(9a64acec) SHA1(51c49e8d415d99e61fda99ade43bb925d99f3825) )
	ROM_LOAD( "95890308.bin", 0x0000, 0x5000, CRC(04de60b0) SHA1(cee280d9528f9e167be1c373e7a99f1f2f1bc1c0) )
ROM_END




ROM_START( sc_canca )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404028.lo", 0x00001, 0x080000, CRC(68b5123f) SHA1(feda4dcc17950c99bb91e081425ee3d18eff98bc) )
	ROM_LOAD16_BYTE( "95404029.hi", 0x00000, 0x080000, CRC(c2d52c27) SHA1(6693e0647f8de08d2594dbeba14ff154fa82d00a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405028.lo", 0x00001, 0x080000, CRC(57097d75) SHA1(6eff17e4a0612da502c660e1c864348b5df91339) )
	ROM_LOAD16_BYTE( "95405029.hi", 0x00000, 0x080000, CRC(8312a929) SHA1(d50f70c0d953ec26db72a560e1533c12d84ec281) )
	ROM_LOAD16_BYTE( "95417000.lo", 0x00001, 0x080000, CRC(e3f0f86c) SHA1(f8a2bf2ea1222117b9ff7096ad1920e77838c9f4) )
	ROM_LOAD16_BYTE( "95417001.hi", 0x00000, 0x080000, CRC(9912f9cd) SHA1(c26f90a1c17fcff4be80961f5c9f157418dc0757) )
	ROM_LOAD16_BYTE( "95417002.lo", 0x00001, 0x080000, CRC(690dc008) SHA1(922060edcda9e72161d267d15807584755b2c993) )
	ROM_LOAD16_BYTE( "95417003.hi", 0x00000, 0x080000, CRC(d09ab572) SHA1(e1fdd3e25050b05850764bea086215d5501b486e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004270.bin", 0x0000, 0x0d4379, CRC(c0db303d) SHA1(8929e4901d517e6063dc75ff40cbcd478bb0be8a) )
	ROM_LOAD( "95404028", 0x0000, 0x100000, CRC(3f0ad3b4) SHA1(fc98ec5d5c270eb11ffef6227380174aa48b8cda) )
ROM_END




ROM_START( sc_captn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404222.lo", 0x00001, 0x080000, CRC(ddde5d23) SHA1(7b5638c46b8e38f834eb5e6bc49a10f5128041f0) )
	ROM_LOAD16_BYTE( "95404223.hi", 0x00000, 0x080000, CRC(03ab5609) SHA1(5a2161aca95ceaff41872aeb8575da85df4e8bea) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404684.lo", 0x00001, 0x080000, CRC(526ea454) SHA1(623927d8742beac94d30c7d9ee570e18ee0bc466) )
	ROM_LOAD16_BYTE( "95404685.hi", 0x00000, 0x080000, CRC(8698ce0a) SHA1(542b730c2675c526f8fdef5f76e51f20231703cd) )
	ROM_LOAD16_BYTE( "95405084.lo", 0x00001, 0x080000, CRC(0cbe758f) SHA1(df50e45ee55e5de8a7053bb4d19daad370a54f61) )
	ROM_LOAD16_BYTE( "95405085.hi", 0x00000, 0x080000, CRC(a60cae02) SHA1(d64bf27e10a248f5f9f08c376debb02fed18849d) )
	ROM_LOAD16_BYTE( "95405222.lo", 0x00001, 0x080000, CRC(4924f42d) SHA1(113895ee36d1671384ec01777aaac9dc4bdbbcaa) )
	ROM_LOAD16_BYTE( "95405223.hi", 0x00000, 0x080000, CRC(9f09d8ff) SHA1(3bce6f2cd7df4c006b40c41abaa60b1881fa1e16) )
	ROM_LOAD16_BYTE( "95405684.lo", 0x00001, 0x080000, CRC(45b61657) SHA1(2cbefd0a95fd5b8fe22d6023e7e8b3a6a568aa3a) )
	ROM_LOAD16_BYTE( "95405685.hi", 0x00000, 0x080000, CRC(e7bc8983) SHA1(fa6de12869fd4a043036e8b309bb1886230cdc4a) )
	ROM_LOAD16_BYTE( "95406102.odd", 0x00001, 0x080000, CRC(d38d7367) SHA1(037ff25a30f005bb44a408c1262806f80609b7c6) )
	ROM_LOAD16_BYTE( "95406103.evn", 0x00000, 0x080000, CRC(14109c1f) SHA1(4d88cd173adda2f2bcec2634127165bbd127ec7b) )
	ROM_LOAD16_BYTE( "95407102.odd", 0x00001, 0x080000, CRC(766c1e34) SHA1(f04ea9099c9dfd51781f7b0d86a100ac42937630) )
	ROM_LOAD16_BYTE( "95407103.evn", 0x00000, 0x080000, CRC(6c9eb65c) SHA1(9a43720e9ee8be71dc0c2d526191867eeaa26b7e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008139.bin", 0x0000, 0x0c076f, CRC(8c87abf8) SHA1(2dfdf9202378723db267ed9d8f2abd076b5214d6) )
ROM_END




ROM_START( sc_cari )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420262.lo", 0x00001, 0x080000, CRC(db05dbbd) SHA1(172964a3f64ae1f7ef21bebbe80f7b7f608c2952) )
	ROM_LOAD16_BYTE( "95420263.hi", 0x00000, 0x080000, CRC(7fe167eb) SHA1(7bcfe5daa91f29fd5d25f0189524c496dd8213d7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420610.lo", 0x00001, 0x080000, CRC(732fe359) SHA1(3c035fa7692e9d0d317ded726425129a51a2bddb) )
	ROM_LOAD16_BYTE( "95420611.hi", 0x00000, 0x080000, CRC(be4c7191) SHA1(863cadada0b14dfd57dd3817c525b1603ac1206d) )
	ROM_LOAD16_BYTE( "95420612.lo", 0x00001, 0x080000, CRC(30d13717) SHA1(86ef8ce0e0d4fb304237e0904f3c031b71cf7382) )
	ROM_LOAD16_BYTE( "95420613.hi", 0x00000, 0x080000, CRC(ace67c08) SHA1(315d82bcad9eb36f19a5ee253aef564898c1a8de) )
	ROM_LOAD16_BYTE( "95420614.lo", 0x00001, 0x080000, CRC(c4254d45) SHA1(7a8b17712f0855fabde2fa911430e4ff35407765) )
	ROM_LOAD16_BYTE( "95420615.hi", 0x00000, 0x080000, CRC(65fdf957) SHA1(d042ec7d8d2b35bef973cf22a623b2dd5730a27b) )
	ROM_LOAD16_BYTE( "95420646.lo", 0x00001, 0x080000, CRC(8cfdafbf) SHA1(97c883cd6bd6335a9c55075851278dc38889a24f) )
	ROM_LOAD16_BYTE( "95420647.hi", 0x00000, 0x080000, CRC(df5b5576) SHA1(254062ddf6c190efd528abb5ea4f5fb972856e71) )
	ROM_LOAD16_BYTE( "95420648.lo", 0x00001, 0x080000, CRC(4cae3542) SHA1(9e262fd961b6a322cc9d2942acb87cc412243bc3) )
	ROM_LOAD16_BYTE( "95420649.hi", 0x00000, 0x080000, CRC(75845134) SHA1(77b6980cf3045267b6477662aac3e4aba92f4edf) )
	ROM_LOAD16_BYTE( "95420736.lo", 0x00001, 0x080000, CRC(0b1f4f5f) SHA1(cf77e0752ae70eb4b70601568a97f0cea9f7d803) )
	ROM_LOAD16_BYTE( "95420737.hi", 0x00000, 0x080000, CRC(fd6ad5f0) SHA1(0a62b4221beb681cb7c0eec24a26e42cc3401ae7) )
	ROM_LOAD16_BYTE( "95421262.lo", 0x00001, 0x080000, CRC(e262396e) SHA1(575897863f0840b8a1437fe8b4d03b45c604116a) )
	ROM_LOAD16_BYTE( "95421263.hi", 0x00000, 0x080000, CRC(2c1615e8) SHA1(92c9e5cc8adf5cc2a35b513ef2ee24511761e662) )
	ROM_LOAD16_BYTE( "95421610.lo", 0x00001, 0x080000, CRC(83237c7d) SHA1(2ddc94fbe67f983a1401ec9904d42167455fd750) )
	ROM_LOAD16_BYTE( "95421611.hi", 0x00000, 0x080000, CRC(6307c3e8) SHA1(53a00bbc8b32f7ee320470001c2034f6743836ed) )
	ROM_LOAD16_BYTE( "95421612.lo", 0x00001, 0x080000, CRC(a129c428) SHA1(652f7f7689aa1d03ba3a5805fa6d6aa84c439c95) )
	ROM_LOAD16_BYTE( "95421613.hi", 0x00000, 0x080000, CRC(29418083) SHA1(d08695736dfd3bd65aa0b249a8a53c236f2298af) )
	ROM_LOAD16_BYTE( "95421614.lo", 0x00001, 0x080000, CRC(5aff77f4) SHA1(48fae56a98bca531bb6b4e9cfd3c0424b38c4868) )
	ROM_LOAD16_BYTE( "95421615.hi", 0x00000, 0x080000, CRC(7af7c94d) SHA1(0149d750f80556342de2c013bb6c7cfba2b3d6ef) )
	ROM_LOAD16_BYTE( "95421646.lo", 0x00001, 0x080000, CRC(5bc76dd4) SHA1(565c73f3083a2ba3df2d7ba8111472dd1f00e1a2) )
	ROM_LOAD16_BYTE( "95421647.hi", 0x00000, 0x080000, CRC(ea39887b) SHA1(ef79e55b4729ba8bcc5636e7098554dce4567521) )
	ROM_LOAD16_BYTE( "95421648.lo", 0x00001, 0x080000, CRC(0e294181) SHA1(eb73dc4076f4c7775848c9c4f659e452e038f35d) )
	ROM_LOAD16_BYTE( "95421649.hi", 0x00000, 0x080000, CRC(9c63b4b5) SHA1(fbc6410b9725ad7e5cb2c75373fa2aa5d898dff8) )
	ROM_LOAD16_BYTE( "95421736.lo", 0x00001, 0x080000, CRC(aa99f3ed) SHA1(496a6cd1a451f63bdfa8ebe9b1c849e0a73dd655) )
	ROM_LOAD16_BYTE( "95421737.hi", 0x00000, 0x080000, CRC(620df42a) SHA1(0e3ad649562e3b2919747c78c97d042b23a27d65) )

	ROM_LOAD16_BYTE( "96000070.odd", 0x00001, 0x080000, CRC(65b37a3c) SHA1(560efe0fdbc28f2d0ed900be8c3172c82304dbf1) )
	ROM_LOAD16_BYTE( "96000071.evn", 0x00000, 0x080000, CRC(3c6f2408) SHA1(cf756e2f22be2e912f87231a94d653f250b5c285) )
	ROM_LOAD16_BYTE( "96000072.odd", 0x00001, 0x080000, CRC(61c4a366) SHA1(c07cc61c6539dec81a129270ed31f83c5c3cc4db) )
	ROM_LOAD16_BYTE( "96000073.evn", 0x00000, 0x080000, CRC(98eb005d) SHA1(784bb784666a19ee807001556c6cbdbbf3431e34) )
	ROM_LOAD16_BYTE( "96000074.odd", 0x00001, 0x080000, CRC(e0f23e84) SHA1(47512a50257aeaec46af524ee0ed87dc573a76e2) )
	ROM_LOAD16_BYTE( "96000075.evn", 0x00000, 0x080000, CRC(1eca734d) SHA1(dc2e28d52f8e191a25b77a87c6335271996ce609) )
	ROM_LOAD16_BYTE( "96000076.odd", 0x00001, 0x080000, CRC(dac49cce) SHA1(45553a34c43677070ec4487f097edaf15dbe89d1) )
	ROM_LOAD16_BYTE( "96000077.evn", 0x00000, 0x080000, CRC(e3adc07e) SHA1(f9f128ca375a84afda9be018cac0eb4e0d1a58b3) )
	ROM_LOAD16_BYTE( "96000078.lo", 0x00001, 0x080000, CRC(ae6ae590) SHA1(c59d88f7b1c4668dfde5ae95b099c65fdb31c4fb) )
	ROM_LOAD16_BYTE( "96000079.hi", 0x00000, 0x080000, CRC(a3f81488) SHA1(16e9913d3f55be5b18fa785d10d2c7b1b32fc8fe) )
	ROM_LOAD16_BYTE( "96000080.odd", 0x00001, 0x080000, CRC(7e2d1c8e) SHA1(e204fb308ff0cbd912d9516a248ab0326166b55e) )
	ROM_LOAD16_BYTE( "96000081.evn", 0x00000, 0x080000, CRC(e35aea8e) SHA1(5069f81ec070c6da3b7225e5d6b4c8ced84b0fbf) )
	ROM_LOAD16_BYTE( "96000082.odd", 0x00001, 0x080000, CRC(0b2a8a9a) SHA1(23b8bb2fd9acd0af3a0c10df25a2cba093b8d1f1) )
	ROM_LOAD16_BYTE( "96000083.evn", 0x00000, 0x080000, CRC(feb378a0) SHA1(c498bafe7f86f8da75b4d03aa97f00f12636fff1) )
	ROM_LOAD16_BYTE( "96001082.odd", 0x00001, 0x080000, CRC(8d27a472) SHA1(f3be5fc5836addd2cbdc9a491bd092b75846ce18) )
	ROM_LOAD16_BYTE( "96001083.evn", 0x00000, 0x080000, CRC(2eed14e9) SHA1(36eb7c876331cbdd968c644307183a392777aec1) )
	ROM_LOAD16_BYTE( "97000070.bin", 0x0000, 0x0f8526, CRC(27ba6768) SHA1(708e836f3fc35fabd0a5c8dc9cd8e9327d7bcdc7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008981.bin", 0x0000, 0x0ff245, CRC(3a888f98) SHA1(b113c17acda287200fdcd734a1b384879a5e7101) )
	ROM_LOAD( "caribbeancashsnd1.bin", 0x0000, 0x080000, CRC(89da9fc4) SHA1(d56364e2e71d03d7d8888966b64ff1fab4bfc3e9) )
	ROM_LOAD( "caribbeancashsnd2.bin", 0x0000, 0x080000, CRC(99d33f61) SHA1(7caf3b9540372900e90a7141f14383fe06936a2e) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890474.bin", 0x0000, 0x5000, CRC(bcb54114) SHA1(0236171b34f3e47db9aa253f9605ff6bd21b1460) )
	ROM_LOAD( "95890475.bin", 0x0000, 0x5000, CRC(c9230520) SHA1(5cf9c3d130f114dac633d696e0bf1bda94afb9ee) )
	ROM_LOAD( "95890476.bin", 0x0000, 0x5000, CRC(5799c97c) SHA1(5dab858e61815c04f874f231848c376d8fce1c3d) )
ROM_END




ROM_START( sc_carry )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1113p12.hi", 0x00000, 0x080000, CRC(dbf6b83d) SHA1(1c0d285b2b3d6ca986ad0ddff6e3c2bd8c3745c0) )
	ROM_LOAD16_BYTE( "p1113p12.lo", 0x00001, 0x080000, CRC(d27305c4) SHA1(0931b4dd015bcbafa4e5059d3f36c656115b5866) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1113s12.hi", 0x00000, 0x080000, CRC(73054e1d) SHA1(8d3e017bcd69c845deb52c314ee40739c27ba4c4) )
	ROM_LOAD16_BYTE( "p1113s12.lo", 0x00001, 0x080000, CRC(80e615f7) SHA1(d4ba4b1ee1766cc9aee8fadeb1841a758fb2fc44) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008240.bin", 0x0000, 0x100000, CRC(7c693111) SHA1(6807d78d32e817babd4e1ed2c0b7313d7cc8ebc2) )
ROM_END




ROM_START( sc_cmous )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412114.odd", 0x00001, 0x080000, CRC(f79b62c7) SHA1(a58f58cdfe63ac5a51ca1919d60dadd036d0eec0) )
	ROM_LOAD16_BYTE( "95412115.evn", 0x00000, 0x080000, CRC(dfc00700) SHA1(da9324f35e1d824d394e81dc99218096f78d3f09) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412116.odd", 0x00001, 0x080000, CRC(4bfc675b) SHA1(522bb99b23d6580273cd9aead497cd6216efac59) )
	ROM_LOAD16_BYTE( "95412117.evn", 0x00000, 0x080000, CRC(5fe9d243) SHA1(f4bf0eb4e097c8d46ef62781d157f462b0c7c896) )
	ROM_LOAD16_BYTE( "95413114.odd", 0x00001, 0x080000, CRC(a4be03d3) SHA1(76d9a7f08f134b0bea680d610c924aab8ec8d040) )
	ROM_LOAD16_BYTE( "95413115.evn", 0x00000, 0x080000, CRC(2fe2fff6) SHA1(ad020f291b06fb75ae3e8607fa96431868fbfdda) )
	ROM_LOAD16_BYTE( "95413116.odd", 0x00001, 0x080000, CRC(1384d852) SHA1(c75e3f05bcb4f8c78c5da800267b60b21e75463d) )
	ROM_LOAD16_BYTE( "95413117.evn", 0x00000, 0x080000, CRC(f6986e01) SHA1(1bdf5acff0151313defc50e529d88b200000f1c4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008439.bin", 0x0000, 0x0e94e0, CRC(9bcded46) SHA1(9f1b431ac010f2ab9a8d393b167ff81baf7f86a5) )
	ROM_LOAD( "95008947.bin", 0x0000, 0x0fc44b, CRC(457a86c3) SHA1(e36ba57a981bb0f8b581c4b8e1ddd6e55c24bf00) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890395.bin", 0x0000, 0x5000, CRC(31480d43) SHA1(9ac6254b539d57f79fbb2483948db393ca4823eb) )
	ROM_LOAD( "95890396.bin", 0x0000, 0x5000, CRC(2d9efdff) SHA1(0b6642bb202092eb1ef8791a3a1f2b79ad1b5fff) )
	ROM_LOAD( "95890397.bin", 0x0000, 0x5000, CRC(eec4df6f) SHA1(b4fd028f28fa43d54c6aaf6062ba79a37f232025) )
ROM_END




ROM_START( sc_cburn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "96000038.lo", 0x00001, 0x080000, CRC(e311ce43) SHA1(c9395c886d76a8aabe35a874f10489cdc02bbd35) )
	ROM_LOAD16_BYTE( "96000039.hi", 0x00000, 0x080000, CRC(0f3815a9) SHA1(7b30e5f246a953c864a074981718f9540ba22daf) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "96000040.odd", 0x00001, 0x080000, CRC(da99424b) SHA1(3c74bf35f64a3bc7d301f53a4307c8c4c73059c9) )
	ROM_LOAD16_BYTE( "96000041.evn", 0x00000, 0x080000, CRC(49c6d054) SHA1(88985743f6e56f5c9557a75bb8e0861659d5be28) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "97000034.p1", 0x0000, 0x100000, CRC(f06cb0f1) SHA1(856bdd31a35e93e6f52f88f2ac738cc3fab09c11) )
	ROM_LOAD( "97000034.p2", 0x0000, 0x100000, CRC(cce5a2a7) SHA1(4884e8abe2dde81f70ddc13a3a68d690fc097dae) )
ROM_END




ROM_START( sc_cnfr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95004130.lo", 0x00001, 0x080000, CRC(223e2bd4) SHA1(f8e187cc74e524496c9e5b35260ac56b93e6e83b) )
	ROM_LOAD16_BYTE( "95004131.hi", 0x00000, 0x080000, CRC(3840ffd6) SHA1(d72901b08c11d1f5b16fdb1a8fe57625cc25bd44) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400447.lo", 0x00001, 0x080000, CRC(4e7e04ae) SHA1(bb19a62ad8fee65502fed2a282d0064ce4404cd4) )
	ROM_LOAD16_BYTE( "95400448.hi", 0x00000, 0x080000, CRC(8a411de5) SHA1(fad2f0528666ebd47c1a8ac3deb2146df1489bc8) )
	ROM_LOAD16_BYTE( "95400449.lo", 0x00001, 0x080000, CRC(181a46cb) SHA1(f09c7fd0c840517965edbbd31f86dd2278599246) )
	ROM_LOAD16_BYTE( "95400450.hi", 0x00000, 0x080000, CRC(a81f2ddc) SHA1(07a6d524ccab3c7e098912df605226d0654cb31c) )
	ROM_LOAD16_BYTE( "95400565.lo", 0x00001, 0x080000, CRC(88e0924b) SHA1(51587db4a6af6ea49b1a55fce1c6316f0af78fd1) )
	ROM_LOAD16_BYTE( "95400566.hi", 0x00000, 0x080000, CRC(9f9480f5) SHA1(f5482cbf001c48a4effe2d53ef9b4621ee6be2f4) )
	ROM_LOAD16_BYTE( "95400735.lo", 0x00001, 0x080000, CRC(b866a557) SHA1(92bde33704df07178a2e26324aa73e15fe62fb3d) )
	ROM_LOAD16_BYTE( "95400736.hi", 0x00000, 0x080000, CRC(325d9269) SHA1(e5a2fb03cd2728775b187e9d9142b632c6e15af8) )
	ROM_LOAD16_BYTE( "95400737.lo", 0x00001, 0x080000, CRC(f632cb6a) SHA1(ddde44ec46144e333be0199caea821a6ecee8764) )
	ROM_LOAD16_BYTE( "95400738.hi", 0x00000, 0x080000, CRC(0b93b60f) SHA1(dbcc3012468f8511fba83bd18c94406660a36375) )
	ROM_LOAD16_BYTE( "95401447.lo", 0x00001, 0x080000, CRC(a08b02ba) SHA1(5d6f56937891f042714e90f2c4b2617775282c00) )
	ROM_LOAD16_BYTE( "95401448.hi", 0x00000, 0x080000, CRC(e8b9f8c4) SHA1(8c4b687366c8a5daa2a0325e8e9966afdf7e8618) )
	ROM_LOAD16_BYTE( "95401449.lo", 0x00001, 0x080000, CRC(c1de7cb3) SHA1(fc43bd47c2e83e1ed14a6e96e96d215e5f9e27cd) )
	ROM_LOAD16_BYTE( "95401450.hi", 0x00000, 0x080000, CRC(dc94cc5e) SHA1(0d3262ffd9b8236a8c172ac0cb70fefd3f0cbfed) )
	ROM_LOAD16_BYTE( "95401565.lo", 0x00001, 0x080000, CRC(fa430cee) SHA1(03154148bc73eaef30330ce41aa59df8d816a5f3) )
	ROM_LOAD16_BYTE( "95401566.hi", 0x00000, 0x080000, CRC(c91ead28) SHA1(d3545f4fc715ad35f7a969397c15551659c405ad) )
	ROM_LOAD16_BYTE( "95401735.lo", 0x00001, 0x080000, CRC(faa4b396) SHA1(e00367e61ee6681a571e5dd383b4fbd63ef7d15b) )
	ROM_LOAD16_BYTE( "95401736.hi", 0x00000, 0x080000, CRC(3cba5770) SHA1(e3c41e55f3f6dcb6eb545be6ab5a7558d3208e26) )
	ROM_LOAD16_BYTE( "95401737.lo", 0x00001, 0x080000, CRC(2cee9c3c) SHA1(439af1908be3b1fea2c8c65d07ff274a304b22de) )
	ROM_LOAD16_BYTE( "95401738.hi", 0x00000, 0x080000, CRC(b74dac46) SHA1(1e7338e59c49902321a8678e63f7df3ac5a585ac) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_cad )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410168.odd", 0x00001, 0x080000, CRC(13d2e302) SHA1(64df52857e517bfe8386004ad16b89e1aa2e518c) )
	ROM_LOAD16_BYTE( "95410169.evn", 0x00000, 0x080000, CRC(090d05fc) SHA1(aeea708199ba4f50156550de6d2b4a08ff468b9d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410170.odd", 0x00001, 0x080000, CRC(43436500) SHA1(f3ac4b2d862083691dc068ba3d66dd8ce9dfa10a) )
	ROM_LOAD16_BYTE( "95410171.evn", 0x00000, 0x080000, CRC(792b539e) SHA1(446a7d693ac79774be8b7da35a1113cf28cc4aac) )
	ROM_LOAD16_BYTE( "95410776.odd", 0x00001, 0x080000, CRC(f03c0ced) SHA1(8d2397b7cbb711c2a2555441393111cc874b7dfc) )
	ROM_LOAD16_BYTE( "95410777.evn", 0x00000, 0x080000, CRC(63a89373) SHA1(5f1f0bad94ce070b10ec4e95445ba27762ed90bb) )
	ROM_LOAD16_BYTE( "95410778.odd", 0x00001, 0x080000, CRC(a19ac822) SHA1(9edc5dbdf414ccab400137504a47dd2b700bc59f) )
	ROM_LOAD16_BYTE( "95410779.evn", 0x00000, 0x080000, CRC(830f7598) SHA1(16d2c17e76b89c4634caa3f0559286a1b427ba7e) )
	ROM_LOAD16_BYTE( "95410814.odd", 0x00001, 0x080000, CRC(0c69919d) SHA1(7ea020fb40ddbef11ddfeb05d117555c25e77e68) )
	ROM_LOAD16_BYTE( "95410815.evn", 0x00000, 0x080000, CRC(05d1300b) SHA1(8e7ade1c9765ffcd05879bc4dcc9dc02275a5fd2) )
	ROM_LOAD16_BYTE( "95410816.odd", 0x00001, 0x080000, CRC(2f1bdc0e) SHA1(19f4348801b6882b1154b784496257c79a9bfe60) )
	ROM_LOAD16_BYTE( "95410817.evn", 0x00000, 0x080000, CRC(6690813e) SHA1(40983fc3dd512204d2f5b6f5031de4e852bdb50e) )
	ROM_LOAD16_BYTE( "95411168.odd", 0x00001, 0x080000, CRC(cc599227) SHA1(7e70b3227cc623bd4279b683ea6c2183dd441f70) )
	ROM_LOAD16_BYTE( "95411169.evn", 0x00000, 0x080000, CRC(ba9520e4) SHA1(6748e2b941c8fd78d5f10e83bc539bdb6107c338) )
	ROM_LOAD16_BYTE( "95411170.odd", 0x00001, 0x080000, CRC(9cc81425) SHA1(4db9ff92950ad17011b70d1eac1c12632b4e9a2c) )
	ROM_LOAD16_BYTE( "95411171.evn", 0x00000, 0x080000, CRC(cab37686) SHA1(51cfd291e9c1254ba3ab10f56e03d23db436232b) )
	ROM_LOAD16_BYTE( "95411776.odd", 0x00001, 0x080000, CRC(f973f4c7) SHA1(5e24eb12d8acc4c236c280cc9d45e31e0a73589b) )
	ROM_LOAD16_BYTE( "95411777.evn", 0x00000, 0x080000, CRC(becd988b) SHA1(547e3f982e9c2d392d7254521c2fa3a1682f19ce) )
	ROM_LOAD16_BYTE( "95411778.odd", 0x00001, 0x080000, CRC(6d99f855) SHA1(63236cefbdd3b61c9781c5b1b6a374602ae2dddf) )
	ROM_LOAD16_BYTE( "95411779.evn", 0x00000, 0x080000, CRC(67bc8715) SHA1(b16c478a2d965187818aab4ff948e37ef4baeb3d) )
	ROM_LOAD16_BYTE( "95411814.odd", 0x00001, 0x080000, CRC(4a4c4853) SHA1(8f2d66a1632baed1f9966169f69409b6b7277e2e) )
	ROM_LOAD16_BYTE( "95411815.evn", 0x00000, 0x080000, CRC(7e83b8e0) SHA1(f8c980b9131d56ae2359ff0beca3305e09ec983f) )
	ROM_LOAD16_BYTE( "95411816.odd", 0x00001, 0x080000, CRC(7fc7f90f) SHA1(91e888c28b27d8de42dd1179f3b656f139f87458) )
	ROM_LOAD16_BYTE( "95411817.evn", 0x00000, 0x080000, CRC(5e78d43b) SHA1(8b9042dd49a55d81d8ec6769d3b7546d2c09723c) )
	ROM_LOAD16_BYTE( "95414570.odd", 0x00001, 0x080000, CRC(ffab5ee7) SHA1(942ea0f8602b4c2a6adfa69b39756dca86293157) )
	ROM_LOAD16_BYTE( "95414571.evn", 0x00000, 0x080000, CRC(96da0b9a) SHA1(0f4e4977053aefb82fcccc2cf5de594c56bb2a05) )
	ROM_LOAD16_BYTE( "95415570.odd", 0x00001, 0x080000, CRC(83724d5a) SHA1(fd4d4db9c09b09e36d8e4774be354dad13025678) )
	ROM_LOAD16_BYTE( "95415571.evn", 0x00000, 0x080000, CRC(98a298bb) SHA1(0506a35a99ca3fe66c4c8204d7cae5ab1be72892) )
	ROM_LOAD16_BYTE( "95416426.odd", 0x00001, 0x080000, CRC(b31a4f3c) SHA1(9b61e76235a04cab9309f29cc870e32a071d7952) )
	ROM_LOAD16_BYTE( "95416427.evn", 0x00000, 0x080000, CRC(dc724dc7) SHA1(6a27c8a0872a98943f1db339daced3cc1d6a0da4) )
	ROM_LOAD16_BYTE( "95416428.odd", 0x00001, 0x080000, CRC(d744e04c) SHA1(26ef7f7b65be3e342ca97143c8a86cafb06d2345) )
	ROM_LOAD16_BYTE( "95416429.evn", 0x00000, 0x080000, CRC(7f46c423) SHA1(29769d7b5f03296d1f78119af8836ef82f8c1952) )
	ROM_LOAD16_BYTE( "95417426.odd", 0x00001, 0x080000, CRC(7d3e3c74) SHA1(e3d873b7777d4682ad680057358a08bda4e54e87) )
	ROM_LOAD16_BYTE( "95417427.evn", 0x00000, 0x080000, CRC(2f1341a1) SHA1(bb4cc3c2b2897cc46929089a5e971ebd967d0f46) )
	ROM_LOAD16_BYTE( "95417428.odd", 0x00001, 0x080000, CRC(8e691238) SHA1(76f0df94549e56f379797169a90f80a10e9d7eef) )
	ROM_LOAD16_BYTE( "95417429.evn", 0x00000, 0x080000, CRC(6935c080) SHA1(50ebf1a213525c8c84ce765a203601cbc0f2b36a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008396.bin", 0x0000, 0x0ff641, CRC(f24c5ef6) SHA1(83395f64b79efbd4f3153e5d0a2d2b0d0183f857) )
ROM_END




ROM_START( sc_cadcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "91414812.odd", 0x00001, 0x080000, CRC(363aaaf1) SHA1(c6b38aaea1a992a0bda366d92e5fa8a42ff1a7c1) )
	ROM_LOAD16_BYTE( "91414813.evn", 0x00000, 0x080000, CRC(64c2ad49) SHA1(d13b028db6697d6e8a4cb94900b1b770cebe0c72) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "91415812.odd", 0x00001, 0x080000, CRC(5ea10616) SHA1(171eaec9aeef53767085d3ed3d26b411fe37ea87) )
	ROM_LOAD16_BYTE( "91415813.evn", 0x00000, 0x080000, CRC(fa822d67) SHA1(4499ccfaaacae5afefb2d052168e92166480fe54) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008486.bin", 0x0000, 0x0ff641, CRC(05e8cba2) SHA1(7a99ab3f45588cff0e54a94ffd75df337cff7351) )
ROM_END




ROM_START( sc_cbaz )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408056.lo", 0x00001, 0x080000, CRC(61e1048c) SHA1(25cc77109c1d4f16439affad74924551cdf2ac2d) )
	ROM_LOAD16_BYTE( "95408057.hi", 0x00000, 0x080000, CRC(35ebaa56) SHA1(cda4deb9e5131f0063c04ae88a5ddfdd6a2a2bdd) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408198.lo", 0x00001, 0x080000, CRC(c1b6f768) SHA1(34a8519c6d1e40699a929170c3f438d6ab692fd8) )
	ROM_LOAD16_BYTE( "95408199.hi", 0x00000, 0x080000, CRC(6f36c9f7) SHA1(0637186e549d7031a14b548bdfe081af3024ed12) )
	ROM_LOAD16_BYTE( "95408222.lo", 0x00001, 0x080000, CRC(a7d61704) SHA1(b3f1a39e735f88af10d61391902f50297d38898e) )
	ROM_LOAD16_BYTE( "95408223.hi", 0x00000, 0x080000, CRC(e242e8f8) SHA1(add3d0d46ad1b4e4cd35e1c41fa2a343017abec1) )
	ROM_LOAD16_BYTE( "95408234.lo", 0x00001, 0x080000, CRC(baf0e2c9) SHA1(852e56a5673ec8161699df93349bc2387b0bd625) )
	ROM_LOAD16_BYTE( "95408235.hi", 0x00000, 0x080000, CRC(d0330878) SHA1(823f98e4474f5d105126dec7f657d27281d21611) )
	ROM_LOAD16_BYTE( "95408378.lo", 0x00001, 0x080000, CRC(0cc4756e) SHA1(87c15ef0b718438cfc68f3c29aed5e6ea67c0442) )
	ROM_LOAD16_BYTE( "95408379.hi", 0x00000, 0x080000, CRC(393d7cd2) SHA1(d20d6c14d9ee52da0469b31156e0ff9552416a58) )
	ROM_LOAD16_BYTE( "95409056.lo", 0x00001, 0x080000, CRC(0dae003e) SHA1(e837bc4698f5d65b4864d49e77a5a90efd8f89a0) )
	ROM_LOAD16_BYTE( "95409057.hi", 0x00000, 0x080000, CRC(91a171a5) SHA1(c86e530c6330d54a79e5b60875670cfea9f789e6) )
	ROM_LOAD16_BYTE( "95409198.lo", 0x00001, 0x080000, CRC(547ac730) SHA1(7062f6096369eef21d342a7c35cda0fd617cac5e) )
	ROM_LOAD16_BYTE( "95409199.hi", 0x00000, 0x080000, CRC(9c57c591) SHA1(c0c392fffd68f09fb8cdc9b184a78e7868745413) )
	ROM_LOAD16_BYTE( "95409222.lo", 0x00001, 0x080000, CRC(b2c70c27) SHA1(d3d128d6d2fbc7cc7505b9b50064984c8f008613) )
	ROM_LOAD16_BYTE( "95409223.hi", 0x00000, 0x080000, CRC(ce602fef) SHA1(9e81f69099bc26cbd773b3e66577bd8a47528a82) )
	ROM_LOAD16_BYTE( "95409234.lo", 0x00001, 0x080000, CRC(426e5614) SHA1(e0b44aae40eadf1df88179f7070e245609b505c1) )
	ROM_LOAD16_BYTE( "95409235.hi", 0x00000, 0x080000, CRC(176abe31) SHA1(a2ee1d4eef81aff4884dadfdda16dc1c5cd2b67f) )
	ROM_LOAD16_BYTE( "95409378.lo", 0x00001, 0x080000, CRC(8121f89a) SHA1(04a5201fac956388a788a7828cb6eadfb8a51d40) )
	ROM_LOAD16_BYTE( "95409379.hi", 0x00000, 0x080000, CRC(6f200e30) SHA1(785eb177ae9f952b7e4ee90cb73a51ae0fee3a5e) )
	ROM_LOAD16_BYTE( "95412192.lo", 0x00001, 0x080000, CRC(73c648d9) SHA1(e3dfe8cdeb6ddf2e1e85b73a49ec9cac0377c688) )
	ROM_LOAD16_BYTE( "95412193.hi", 0x00000, 0x080000, CRC(236b73e7) SHA1(2a8abd9393af205f415e94e276bfc7c363175a38) )
	ROM_LOAD16_BYTE( "95413192.lo", 0x00001, 0x080000, CRC(c11e8bd2) SHA1(a5006bd5c4c18ca41611e852a68f2696aa3f3fc8) )
	ROM_LOAD16_BYTE( "95413193.hi", 0x00000, 0x080000, CRC(e73b43ed) SHA1(def6d82f982965feef694802ea75f158e245810b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008317.bin", 0x0000, 0x100000, CRC(05ef55b5) SHA1(5130b9243647b9724998600b5f2ef2bbe7b5b1e5) )
ROM_END




ROM_START( sc_cblas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418026.lo", 0x00001, 0x080000, CRC(a283feca) SHA1(0c94cd66f82c05d723b1b3515c650c1f08a5bf5f) )
	ROM_LOAD16_BYTE( "95418027.hi", 0x00000, 0x080000, CRC(e3143638) SHA1(7bc6484aed013f25045b34fd8e422dc0ac9a8097) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95419020.lo", 0x00001, 0x080000, CRC(e508efb9) SHA1(ff96f63f777b62e0a2fe6c19a7b86c158a08dde0) )
	ROM_LOAD16_BYTE( "95419021.hi", 0x00000, 0x080000, CRC(463ee216) SHA1(5c46f6da686816d4363b57ba60ea9977546e43ed) )
	ROM_LOAD16_BYTE( "95419026.lo", 0x00001, 0x080000, CRC(3ccf4515) SHA1(893c38ea2d35f0cf480da637ece301633ffb792c) )
	ROM_LOAD16_BYTE( "95419027.hi", 0x00000, 0x080000, CRC(55931f20) SHA1(ba42d054d884b86f967f6157a66563c5e0d92c7f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008539.bin", 0x0000, 0x0e0033, CRC(068349f4) SHA1(b27cba3217122397eb7aea0d9a382fda9ee6a43b) )
ROM_END



ROM_START( sc_cconx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400903.lo", 0x00001, 0x080000, CRC(9662c017) SHA1(b4c1d85edd89b71dcea277eb09c001ef6272e511) )
	ROM_LOAD16_BYTE( "95400904.hi", 0x00000, 0x080000, CRC(af0dbca4) SHA1(da929472e75338a499a65ee02beb037ded29b418) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95401901.lo", 0x00001, 0x080000, CRC(a52c16a1) SHA1(f7a0a9c9e02dc104634e58f3d560a3b2a4da9435) )
	ROM_LOAD16_BYTE( "95401902.hi", 0x00000, 0x080000, CRC(f51572ef) SHA1(7e0f9179acb7c47909820ba8a9e9efd7eb63068d) )
	ROM_LOAD16_BYTE( "95402089.lo", 0x00001, 0x080000, CRC(276f1b20) SHA1(00d548b122ec07f0b2f8d2790a61c92445d24dfe) )
	ROM_LOAD16_BYTE( "95402090.hi", 0x00000, 0x080000, CRC(e7248393) SHA1(5d4869044a768d28971d05458ea28eda44ec77b4) )
	ROM_LOAD16_BYTE( "95403089.lo", 0x00001, 0x080000, CRC(b1be7740) SHA1(ca316700aead1596f31447091b0a82befbf4d154) )
	ROM_LOAD16_BYTE( "95403090.hi", 0x00000, 0x080000, CRC(85dc66b2) SHA1(5a10a41379e49a4cb1611a7f7aad53804c581ad1) )
	ROM_LOAD16_BYTE( "95403399.lo", 0x00001, 0x080000, CRC(f403ffc5) SHA1(89d56bd23e9667c366974bfbb4cb5af1f8d846ff) )
	ROM_LOAD16_BYTE( "95403400.hi", 0x00000, 0x080000, CRC(0f7535e2) SHA1(41877b1f95c877ca94d3644a0d86803aba0831f6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_ccrus )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402812.lo", 0x00001, 0x080000, CRC(795a4bef) SHA1(4398773ecacfb66cf7f7b3ae4ffab8723a049df3) )
	ROM_LOAD16_BYTE( "95402813.hi", 0x00000, 0x080000, CRC(e79f42ba) SHA1(ff365e456183f7bef3b64249eb3b497e1b35845f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402880.lo", 0x00001, 0x080000, CRC(839c70fa) SHA1(fb7d483c816dd73c11a75438302e276dfe4e504a) )
	ROM_LOAD16_BYTE( "95402881.hi", 0x00000, 0x080000, CRC(715708f7) SHA1(4f2d44bdb4fe4db7ca51a2727c68af25d786fbd4) )
	ROM_LOAD16_BYTE( "95403812.lo", 0x00001, 0x080000, CRC(33182ed2) SHA1(0c8582bd578876a6fb093c7b712dfc0030a7ec70) )
	ROM_LOAD16_BYTE( "95403813.hi", 0x00000, 0x080000, CRC(1bb8718d) SHA1(abe1a125c205e745778be928be59ccf3d2b1b698) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_cerup )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95405244.lo", 0x00001, 0x080000, CRC(18aa9826) SHA1(d9d3abb9ab92a0b0d9da9107ebae2157c41ba7e6) )
	ROM_LOAD16_BYTE( "95405245.hi", 0x00000, 0x080000, CRC(07482460) SHA1(8d6237bc8d51087bc4ff487c6a5e0db05c742a47) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_cexpl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406596.lo", 0x00001, 0x080000, CRC(08d50241) SHA1(e0818ace6bf77c377d67f2e32b257e34b0c7bcc0) )
	ROM_LOAD16_BYTE( "95406597.hi", 0x00000, 0x080000, CRC(305266ae) SHA1(df3d99955e480e3d75b0fbaae65c6a780e7db46c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406928.lo", 0x00001, 0x080000, CRC(4930390e) SHA1(9f2a5a65a1e67b51756a602b22c2fbf59e4ecffa) )
	ROM_LOAD16_BYTE( "95406929.hi", 0x00000, 0x080000, CRC(05201df8) SHA1(eadc72a23ccc4f5d690099830444471d1911d0dc) )
	ROM_LOAD16_BYTE( "95407596.lo", 0x00001, 0x080000, CRC(04c26bd9) SHA1(993f2ce15b979bce9099a78f49bf7c6fb7171f0a) )
	ROM_LOAD16_BYTE( "95407597.hi", 0x00000, 0x080000, CRC(afb31cc8) SHA1(dcef2320a3fa617a84082b48101142610c6985bc) )
	ROM_LOAD16_BYTE( "95407928.lo", 0x00001, 0x080000, CRC(94c39dfc) SHA1(004acfef0af5153d1fc453d9c1d8a03fd773efa8) )
	ROM_LOAD16_BYTE( "95407929.hi", 0x00000, 0x080000, CRC(72e808ea) SHA1(780d5c2a5d8a8211d0a8dada4c1288a4ad003207) )
	ROM_LOAD16_BYTE( "95408354.lo", 0x00001, 0x080000, CRC(7cb241df) SHA1(2e3018a7eb3b8573fcd0acb6c194bc197d46e87f) )
	ROM_LOAD16_BYTE( "95408355.hi", 0x00000, 0x080000, CRC(cd643bee) SHA1(7f22e4c2bf56b400ee56c15b93ed12e6a4a3649a) )
	ROM_LOAD16_BYTE( "95409354.lo", 0x00001, 0x080000, CRC(51abe89e) SHA1(830b809dd432465f0bc769aed2cedaaf07f94973) )
	ROM_LOAD16_BYTE( "95409355.hi", 0x00000, 0x080000, CRC(f7f1360b) SHA1(76705397348f1c9167cc6e208f08344dd737e627) )
	ROM_LOAD16_BYTE( "95414634.lo", 0x00001, 0x080000, CRC(fabc6e58) SHA1(03f78ae84ec52b08d255c2ee23165250078ffb52) )
	ROM_LOAD16_BYTE( "95414635.hi", 0x00000, 0x080000, CRC(e7e54948) SHA1(5934c0d95d6a4ddac620f2e95e43234686148e5e) )
	ROM_LOAD16_BYTE( "95414636.lo", 0x00001, 0x080000, CRC(2b65f0e2) SHA1(ff730568e1eafd4f3d9ef6d052f003c64e2d4477) )
	ROM_LOAD16_BYTE( "95414637.hi", 0x00000, 0x080000, CRC(7925bd41) SHA1(be47858f8417b023d0b428d1112126d79423f9e9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_chand )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402335.lo", 0x00001, 0x080000, CRC(0da0141b) SHA1(f95ff70b42d4754bb0d4120d8eac4b2283d6acd5) )
	ROM_LOAD16_BYTE( "95402336.hi", 0x00000, 0x080000, CRC(4181da5f) SHA1(370c44aaf628248574c277e56207cc0e879403c8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402337.lo", 0x00001, 0x080000, CRC(199db9a2) SHA1(cae5930ca6b28f7088fa04d1eae35312e787f995) )
	ROM_LOAD16_BYTE( "95402338.hi", 0x00000, 0x080000, CRC(f07cfd86) SHA1(47247efc279c162465cc03d6ae37828bd4e22cfe) )
	ROM_LOAD16_BYTE( "95403335.lo", 0x00001, 0x080000, CRC(879108e2) SHA1(1c1c497f60a8135c030e5ff3e7051746fbacb0aa) )
	ROM_LOAD16_BYTE( "95403336.hi", 0x00000, 0x080000, CRC(84ef4625) SHA1(801cd63e9bd09c6fedee00e9747d107a51a344f4) )
	ROM_LOAD16_BYTE( "95403337.lo", 0x00001, 0x080000, CRC(93aca55b) SHA1(b197e6256a478b3ce68ca11d95865067d8109ef0) )
	ROM_LOAD16_BYTE( "95403338.hi", 0x00000, 0x080000, CRC(351261fc) SHA1(9ddb8ed7f595e623a34c8dd1678ecd71f79ce6f5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_cinv )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400227.lo", 0x00001, 0x080000, CRC(24b47f39) SHA1(891dda304ca8e2cbefc823fcfa07d00890b697e3) )
	ROM_LOAD16_BYTE( "95400228.hi", 0x00000, 0x080000, CRC(210e70b3) SHA1(0d5ab09346b66f716c64df19d9ed4d303f324bc4) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400229.lo", 0x00001, 0x080000, CRC(8bf8798c) SHA1(cfe3026721dec33287f43dbc2857e6a59ad343ca) )
	ROM_LOAD16_BYTE( "95400230.hi", 0x00000, 0x080000, CRC(82d10f41) SHA1(bb7b6c8e9253def4790cb64d6e521f1c8e01bb64) )
	ROM_LOAD16_BYTE( "95400231.lo", 0x00001, 0x080000, CRC(0f0edf40) SHA1(cbb9ecf2b96d2ee5c8124547dd41cab8d464f5c7) )
	ROM_LOAD16_BYTE( "95400232.hi", 0x00000, 0x080000, CRC(92785b93) SHA1(63c6b5de09b3d9f4d883101e554b6101ed25d828) )
	ROM_LOAD16_BYTE( "95400743.lo", 0x00001, 0x080000, CRC(0475a59e) SHA1(db562dda6831398a30673bdf97de143478eb5fa3) )
	ROM_LOAD16_BYTE( "95400744.hi", 0x00000, 0x080000, CRC(ed638e2b) SHA1(d7084f1056836e7cfd58624f272cd4b457204899) )
	ROM_LOAD16_BYTE( "95400745.lo", 0x00001, 0x080000, CRC(3d71c227) SHA1(4ae11541bf9eccc9ec79f4af6395e30ba025dc24) )
	ROM_LOAD16_BYTE( "95400746.hi", 0x00000, 0x080000, CRC(58a98129) SHA1(88412cc3c4cc9d9cbf2765da3ffeb110f29624ea) )
	ROM_LOAD16_BYTE( "95401227.lo", 0x00001, 0x080000, CRC(43666c44) SHA1(b63015980e266e64d24f9fadfd16b112e738b721) )
	ROM_LOAD16_BYTE( "95401228.hi", 0x00000, 0x080000, CRC(591f0cc8) SHA1(12124045a60a0a0830a7b5662797aaa2fc7b906e) )
	ROM_LOAD16_BYTE( "95401229.lo", 0x00001, 0x080000, CRC(0f5317fe) SHA1(46171a27d7cdac2dda2c2ce7d013d8bc0c1f63e6) )
	ROM_LOAD16_BYTE( "95401230.hi", 0x00000, 0x080000, CRC(109444ae) SHA1(27274218e017f0da2ccfd25503e1bffe39266efe) )
	ROM_LOAD16_BYTE( "95401231.lo", 0x00001, 0x080000, CRC(6f4afe14) SHA1(58d19428dfbb14eb17d3f89113744eedf150df21) )
	ROM_LOAD16_BYTE( "95401232.hi", 0x00000, 0x080000, CRC(bddda645) SHA1(8d1cc6b93f5f6b780882968fe82b0f86e11b9c88) )
	ROM_LOAD16_BYTE( "95401743.lo", 0x00001, 0x080000, CRC(73137ddb) SHA1(f3db49badb3786160f8fb03b774e6d577644f29b) )
	ROM_LOAD16_BYTE( "95401744.hi", 0x00000, 0x080000, CRC(e225b17a) SHA1(c9979b65780f87e1409b656144732d0d37372250) )
	ROM_LOAD16_BYTE( "95401745.lo", 0x00001, 0x080000, CRC(274eca45) SHA1(f4f24c4d072d8a4a796820de26ee16507497c13e) )
	ROM_LOAD16_BYTE( "95401746.hi", 0x00000, 0x080000, CRC(fdddf6aa) SHA1(6d32a140df2272361fd8fca3e70030b9cd38f904) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_clash )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410494.lo", 0x00001, 0x080000, CRC(328acbeb) SHA1(dbb05173a2af6a2d2cc73b6a99f0693a8bd6d75b) )
	ROM_LOAD16_BYTE( "95410495.hi", 0x00000, 0x080000, CRC(a6681b69) SHA1(410b003485e3a89c62456f4679fd4b0468e0634c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410496.lo", 0x00001, 0x080000, CRC(99ef95a6) SHA1(2c2353cb8c5805510b67935f47366430d2c1762a) )
	ROM_LOAD16_BYTE( "95410497.hi", 0x00000, 0x080000, CRC(d9d37a25) SHA1(0603761dca1ae8967c03bee0427abfb9c1d6f65c) )
	ROM_LOAD16_BYTE( "95411494.lo", 0x00001, 0x080000, CRC(ce512069) SHA1(d54f67c01956884bcd19cd652b055ea8109983fb) )
	ROM_LOAD16_BYTE( "95411495.hi", 0x00000, 0x080000, CRC(2e5b9fe4) SHA1(a8e71d6c7e49d318ae2c02dd23fb26b52ccea69c) )
	ROM_LOAD16_BYTE( "95411496.lo", 0x00001, 0x080000, CRC(5a8582c3) SHA1(621955185bbc8793f585943e782c03d6f8697919) )
	ROM_LOAD16_BYTE( "95411497.hi", 0x00000, 0x080000, CRC(d6954574) SHA1(a04c349f87157fe8939e210c3875cebf210b2985) )
	ROM_LOAD16_BYTE( "95416264.lo", 0x00001, 0x080000, CRC(7cb7f066) SHA1(c9e9b18a6ecf5933da32532053c3d0c72dbe1d50) )
	ROM_LOAD16_BYTE( "95416265.hi", 0x00000, 0x080000, CRC(0573d517) SHA1(5ad653f61c24896af1c5d5d62989f12bfb181478) )
	ROM_LOAD16_BYTE( "95416266.lo", 0x00001, 0x080000, CRC(807ce8e5) SHA1(b06e21a063cad4f218df9467da0252a239395683) )
	ROM_LOAD16_BYTE( "95416267.hi", 0x00000, 0x080000, CRC(bafe7eae) SHA1(adf083449690a60553b08ffc5f8898f998c2619c) )
	ROM_LOAD16_BYTE( "95417264.lo", 0x00001, 0x080000, CRC(fd362d07) SHA1(7257f8597c2b828f8720c35a6449e91010ea8db1) )
	ROM_LOAD16_BYTE( "95417265.hi", 0x00000, 0x080000, CRC(fb29bec0) SHA1(72adbcae927d8394822cccdc975258b12cc96c0c) )
	ROM_LOAD16_BYTE( "95417266.lo", 0x00001, 0x080000, CRC(029a2e04) SHA1(d213229e50922fbe15011dbad243b6a5bfe7a708) )
	ROM_LOAD16_BYTE( "95417267.hi", 0x00000, 0x080000, CRC(806b734b) SHA1(dcf56ce6e02d409d101726d86fbcdc47a98721ea) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008374.bin", 0x0000, 0x0feb46, CRC(47ea13e2) SHA1(f9b6e23b3857da5f1f364469c8d4deb4f8d836a6) )
ROM_END




ROM_START( sc_cr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404876.odd", 0x00001, 0x080000, CRC(ffd5323a) SHA1(745e90c3fe28de7d361b518cfc5c93bdf7e8bf40) )
	ROM_LOAD16_BYTE( "95404877.evn", 0x00000, 0x080000, CRC(07c84685) SHA1(f0c043c08f605c56a4b448b97de347240794bd72) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406648.odd", 0x00001, 0x080000, CRC(e39cee3b) SHA1(e6891488b6c2aba6b844e16525fa206db7c37e81) )
	ROM_LOAD16_BYTE( "95406649.evn", 0x00000, 0x080000, CRC(3ffc1b08) SHA1(54c6cee809bf9a68060261cef9fe0ab58c42fba8) )
	ROM_LOAD16_BYTE( "95407648.odd", 0x00001, 0x080000, CRC(c3c095ee) SHA1(12ce5a56ec3f8c63ce792b38082aa12bd670c9ab) )
	ROM_LOAD16_BYTE( "95407649.evn", 0x00000, 0x080000, CRC(537c6d08) SHA1(a27b75da63203fd9f21e393c9e8a100f915a6bf5) )
	ROM_LOAD16_BYTE( "95408030.odd", 0x00001, 0x080000, CRC(9c8dd79e) SHA1(82d5631e2d5e1c2d98ea2da080e2f7a3d167a819) )
	ROM_LOAD16_BYTE( "95408031.evn", 0x00000, 0x080000, CRC(e5b3d478) SHA1(ba34f9df49ff1363818bc7c72558860cc54e4b61) )
	ROM_LOAD16_BYTE( "95408308.odd", 0x00001, 0x080000, CRC(cc7c041e) SHA1(1a95daf1cb53d3f2b9d1e26be6b50e7becc160e8) )
	ROM_LOAD16_BYTE( "95408309.evn", 0x00000, 0x080000, CRC(c4948c63) SHA1(fa451d85e384175b515fea97b2b34ae53eaebb33) )
	ROM_LOAD16_BYTE( "95409030.odd", 0x00001, 0x080000, CRC(b6104594) SHA1(1f3a31dff9c7f4fb1d9c9c4669bf8cc1ba4081ae) )
	ROM_LOAD16_BYTE( "95409031.evn", 0x00000, 0x080000, CRC(7769c9af) SHA1(42ee3780e444308ad38de026dee08bf1c31c77f7) )
	ROM_LOAD16_BYTE( "95409308.odd", 0x00001, 0x080000, CRC(a5c41dc2) SHA1(4d63fa341ababca34bad8a8c6a68d4d007ab8d02) )
	ROM_LOAD16_BYTE( "95409309.evn", 0x00000, 0x080000, CRC(1ab2730b) SHA1(ea01f41580dfefc9e011e143a43da334ed4121bc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008245.bin", 0x0000, 0x0ffadf, CRC(6528bb5c) SHA1(d54e1f0a18dbbc91316d57be25e0cf5236e856e6) )
ROM_END



ROM_START( sc_crcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408194.odd", 0x00001, 0x080000, CRC(d45a4fd2) SHA1(f4bbe26a6ffa7ad13a3ad2402b7b8e051d86bb35) )
	ROM_LOAD16_BYTE( "95408195.evn", 0x00000, 0x080000, CRC(ce24bdc2) SHA1(f9e135772fc319d07e8973da0473cc0799771a76) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408422.odd", 0x00001, 0x080000, CRC(4fba1f0f) SHA1(76f8e7fe71d8bcf60c7ac983a955c68066d57a53) )
	ROM_LOAD16_BYTE( "95408423.evn", 0x00000, 0x080000, CRC(fba4d637) SHA1(67c655295317fc9c98f3ec34f0d6a36fb0721591) )
	ROM_LOAD16_BYTE( "95409194.odd", 0x00001, 0x080000, CRC(28d5b378) SHA1(29404c7a85f1a2c1958c574222128b8cd45ed2df) )
	ROM_LOAD16_BYTE( "95409195.evn", 0x00000, 0x080000, CRC(7dbc98da) SHA1(cd9cf1185cb1f96d583d0f004a7055a6268e3f37) )
	ROM_LOAD16_BYTE( "95409422.odd", 0x00001, 0x080000, CRC(17e06e6e) SHA1(c53ef8b7d3a62dda9d101f86b52d032c232971b1) )
	ROM_LOAD16_BYTE( "95409423.evn", 0x00000, 0x080000, CRC(cdab462b) SHA1(f1b597d53b888e42651df9647875a21af8dad1c0) )
	ROM_LOAD16_BYTE( "95410108.odd", 0x00001, 0x080000, CRC(e3d622b0) SHA1(57ca62cd45513fd184f82805051f7219f1aba8fa) )
	ROM_LOAD16_BYTE( "95410109.evn", 0x00000, 0x080000, CRC(7551b505) SHA1(a94c8bccd2808a774981ffc6d470979aba6d9c9f) )
	ROM_LOAD16_BYTE( "95410918.odd", 0x00001, 0x080000, CRC(bae2d17d) SHA1(7809c92c8b5972d55968c2b774b4fe04e1517d75) )
	ROM_LOAD16_BYTE( "95410919.evn", 0x00000, 0x080000, CRC(043a76d0) SHA1(65c08b934c087f08bee373991aa3ac5bcbd96698) )
	ROM_LOAD16_BYTE( "95411918.odd", 0x00001, 0x080000, CRC(7bb37fa4) SHA1(1e7ea0639685bfb24547b4dab61a4a961629acf1) )
	ROM_LOAD16_BYTE( "95411919.evn", 0x00000, 0x080000, CRC(bb38ce31) SHA1(13a97f203cb7887b2ea6b379acb3f3df732b1fcf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008338.bin", 0x0000, 0x0ffadf, CRC(b26edbfe) SHA1(9f5c7a8e6781bad6448f767d19474bbad8024df5) )
ROM_END




ROM_START( sc_cashn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406482.lo", 0x00001, 0x080000, CRC(9cadf511) SHA1(27b02ebea7afb6753df0e2c6486a61da7ffea99b) )
	ROM_LOAD16_BYTE( "95406483.hi", 0x00000, 0x080000, CRC(0993309a) SHA1(15a24d9f618b6f68d983e07896eda45f865661a3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004292.sn1", 0x0000, 0x080000, CRC(e7efab30) SHA1(b2587c14e427fdb51cb5c96e5e017c69f5c134e8) )
	ROM_LOAD( "95004293.sn2", 0x0000, 0x080000, CRC(89584d87) SHA1(935b6e873342aefd1c39bb474c6b780799a0e049) )
ROM_END




ROM_START( sc_cashm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404154.lo", 0x00001, 0x080000, CRC(0bcf30c0) SHA1(7c0b0f0812899f9de09b4ba34da0374631f9eedf) )
	ROM_LOAD16_BYTE( "95404155.hi", 0x00000, 0x080000, CRC(a3421610) SHA1(fb6873ae6953d2565a22e6f3397c2bc1b01491da) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404678.lo", 0x00001, 0x080000, CRC(509fe689) SHA1(f5574ed5a5bbf2c92b6f82f201088d22b826c025) )
	ROM_LOAD16_BYTE( "95404679.hi", 0x00000, 0x080000, CRC(c44e314e) SHA1(0327924b29a05c374a9ff043556e70443e7a0091) )
	ROM_LOAD16_BYTE( "95405154.lo", 0x00001, 0x080000, CRC(56462da7) SHA1(4edd989ff9b0f2941e47392b46b78ab130a7ea38) )
	ROM_LOAD16_BYTE( "95405155.hi", 0x00000, 0x080000, CRC(31caaab1) SHA1(1505c441e73fe1d0050b4fe5fbede0cd108b3a36) )
	ROM_LOAD16_BYTE( "95405678.lo", 0x00001, 0x080000, CRC(45727051) SHA1(6f5836e145cb83d40c445c4f54f02277c7852d9f) )
	ROM_LOAD16_BYTE( "95405679.hi", 0x00000, 0x080000, CRC(02fc0f9c) SHA1(6edf8bbe6d494253c3183bb7869aedbedf2d7b5c) )
	ROM_LOAD16_BYTE( "95406386.lo", 0x00001, 0x080000, CRC(f475bf63) SHA1(d5fb531fb778a8e35a83836dadc2ee7e33ba272b) )
	ROM_LOAD16_BYTE( "95406387.hi", 0x00000, 0x080000, CRC(9db583cb) SHA1(205496712f100e17e91d46849dd341deaa63aa0a) )
	ROM_LOAD16_BYTE( "95407386.lo", 0x00001, 0x080000, CRC(025b77b7) SHA1(793433c1616729a2ccf5489cad52b32a04f9fa15) )
	ROM_LOAD16_BYTE( "95407387.hi", 0x00000, 0x080000, CRC(4d74b9ba) SHA1(3897147aa15c7acb59cc1e502ba712cc944b92be) )
	ROM_LOAD16_BYTE( "95408508.lo", 0x00001, 0x080000, CRC(6d96beb0) SHA1(da274c53fce937e01a095693003ecb67379a7980) )
	ROM_LOAD16_BYTE( "95408509.hi", 0x00000, 0x080000, CRC(084450b4) SHA1(553b2a10e36b0c1f26b0c05c4d2b218f4c5b24b1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008123_1.bin", 0x0000, 0x100000, CRC(9f1fc98b) SHA1(9233ef6a82f8b23066f959957a7561fb33120d46) )
	ROM_LOAD( "95008124_2.bin", 0x0000, 0x100000, CRC(4795c128) SHA1(7b55b39f335b81f6a895ed9beb123464e10a48ee) )
ROM_END




ROM_START( sc_cckey )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410398.lo", 0x00001, 0x080000, CRC(96e93185) SHA1(eb647e8f524339a79aa3a919c9d47cb43162dd81) )
	ROM_LOAD16_BYTE( "95410399.hi", 0x00000, 0x080000, CRC(058e7aeb) SHA1(b6f61cd250d548586328097514be176c85366fa1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410788.lo", 0x00001, 0x080000, CRC(8e9cdf3b) SHA1(9fb8ea12d9595d6b0e7d6cbbc4fb3f58f732e649) )
	ROM_LOAD16_BYTE( "95410789.hi", 0x00000, 0x080000, CRC(51c3ed51) SHA1(50426d5e1124bb77665350ad0a230ef26b678a49) )
	ROM_LOAD16_BYTE( "95410790.lo", 0x00001, 0x080000, CRC(3d6767af) SHA1(85f5147e569a7ce9ef2395ed8ea21efae701c2ad) )
	ROM_LOAD16_BYTE( "95410791.hi", 0x00000, 0x080000, CRC(24667a0d) SHA1(e2ec4eea414ace0f41fa4cf074bdf7ad8f18d2ed) )
	ROM_LOAD16_BYTE( "95410924.lo", 0x00001, 0x080000, CRC(ea76e2e6) SHA1(565ee7a0a6c310dab544348172e4b00aa49ceeca) )
	ROM_LOAD16_BYTE( "95410925.hi", 0x00000, 0x080000, CRC(74ae4798) SHA1(6278b79f050e116a04f302a065be869d24349533) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008425.bin", 0x0000, 0x100000, CRC(99bf2289) SHA1(596fe427dd7abf2779e12e3f20a5ba2eda553f2e) )
ROM_END




ROM_START( sc_ckx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420660.lo", 0x00001, 0x080000, CRC(2ab46dff) SHA1(362da805615cce7f5c191cb5cf98dd2362cecc10) )
	ROM_LOAD16_BYTE( "95420661.hi", 0x00000, 0x080000, CRC(a8fb772e) SHA1(90aea6a48117a84f17df501deea4416ffee104f1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420758.lo", 0x00001, 0x080000, CRC(0a0b0486) SHA1(6eb4ea9f1d6fd8d66b203bcff986ee2f57ed9d77) )
	ROM_LOAD16_BYTE( "95420759.hi", 0x00000, 0x080000, CRC(63637820) SHA1(0e78c2abb2e2ea839b6af68cb8d9dedbb16a1d3d) )
	ROM_LOAD16_BYTE( "95420760.lo", 0x00001, 0x080000, CRC(c1e2be03) SHA1(4e17a0ffe2d34e0d87f173e1450f9cb7ccbd225e) )
	ROM_LOAD16_BYTE( "95420761.hi", 0x00000, 0x080000, CRC(31187236) SHA1(fab73f9e62e43ab9a3104c1a357911cc99f93b38) )
	ROM_LOAD16_BYTE( "95420762.lo", 0x00001, 0x080000, CRC(66f29fe1) SHA1(2eed91eecb15db51117e2351dd80072817b846b8) )
	ROM_LOAD16_BYTE( "95420763.hi", 0x00000, 0x080000, CRC(fe572525) SHA1(d9677d564fd34062e5ba9e6fa382f8bfb4dfd88d) )
	ROM_LOAD16_BYTE( "95421660.lo", 0x00001, 0x080000, CRC(7815578f) SHA1(45525e03c3093c26182490831831a5fba64bef9f) )
	ROM_LOAD16_BYTE( "95421661.hi", 0x00000, 0x080000, CRC(d5ce83b6) SHA1(bbfe89a3f25e358316bd0140f8a0da77dab40bc5) )
	ROM_LOAD16_BYTE( "95421758.lo", 0x00001, 0x080000, CRC(5b7cdf3b) SHA1(8a6aedd2a82c2d02cc954d9ac49b7f4a10ffd0a4) )
	ROM_LOAD16_BYTE( "95421759.hi", 0x00000, 0x080000, CRC(852feca2) SHA1(b537f8090f3d450f9854670c9e13b2c679ddf0d7) )
	ROM_LOAD16_BYTE( "95421760.lo", 0x00001, 0x080000, CRC(001c041b) SHA1(30ca8868a57ff89f258cac9b3d88872b6751958d) )
	ROM_LOAD16_BYTE( "95421761.hi", 0x00000, 0x080000, CRC(6781dc20) SHA1(812cf24aaf3f02dd83b1fc996615fe092809bd47) )
	ROM_LOAD16_BYTE( "95421762.lo", 0x00001, 0x080000, CRC(d6683bf6) SHA1(c2756441043a1097edb540213ca8bef56c432767) )
	ROM_LOAD16_BYTE( "95421763.hi", 0x00000, 0x080000, CRC(6efaba5c) SHA1(abf8dddcdb891396e6dc05a020028fd38890999e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008995.bin", 0x0000, 0x0931b3, CRC(e874bd15) SHA1(8adb32532dd053ca2c4e0987352013310ce197a0) )
ROM_END




ROM_START( sc_casry )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408018.lo", 0x00001, 0x080000, CRC(a921ad37) SHA1(7e8ab72ebe9c0341912a0a27b1ac114eee5dffb7) )
	ROM_LOAD16_BYTE( "95408019.hi", 0x00000, 0x080000, CRC(91ab8fa0) SHA1(59754315338c1a027d5d6be87da524eb588672d7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408126.lo", 0x00001, 0x080000, CRC(4f499073) SHA1(93c79e963183f48c43680e0e4f50277e3cf51fbd) )
	ROM_LOAD16_BYTE( "95408127.hi", 0x00000, 0x080000, CRC(0c653000) SHA1(3c4a3958b8476bb7c36e0948b636ab63cf90354d) )
	ROM_LOAD16_BYTE( "95408158.lo", 0x00001, 0x080000, CRC(0dc6ab53) SHA1(8825515666310afc6559e9f96286f1b78cc16cc3) )
	ROM_LOAD16_BYTE( "95408159.hi", 0x00000, 0x080000, CRC(5e805c7f) SHA1(45d71ab83de1b42ea308a293ddc9a96c5d75c30d) )
	ROM_LOAD16_BYTE( "95409018.lo", 0x00001, 0x080000, CRC(c5cb046b) SHA1(ad6e0508e084d4f8c7372e808203b14e1abf34ca) )
	ROM_LOAD16_BYTE( "95409019.hi", 0x00000, 0x080000, CRC(4cce8458) SHA1(b7d39278edc311dc915123aab84c0cb2f6df014d) )
	ROM_LOAD16_BYTE( "95414354.lo", 0x00001, 0x080000, CRC(bbf6bdc9) SHA1(49c8145f3f4937573797538a19f7dfcf5129020f) )
	ROM_LOAD16_BYTE( "95414355.hi", 0x00000, 0x080000, CRC(a61dd5a9) SHA1(8e3f1d7da70960c079301e46fb37eb5f21430fe6) )
	ROM_LOAD16_BYTE( "95416042.lo", 0x00001, 0x080000, CRC(1fcd054d) SHA1(7e061ecbd2b53af9dea3dd9b7bdccd555cd31286) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )

	ROM_REGION( 0x400000, "other", ROMREGION_ERASE00 )
	// are these just combined hi/lo files?
	ROM_LOAD( "95414354", 0x0000, 0x100000, CRC(eff6d08d) SHA1(4b8ec5aee30e67ab82d04bdf28b65f72eb46e767) )
	ROM_LOAD( "95416042", 0x0000, 0x100000, CRC(f079295d) SHA1(1944e8565ba308eb7fe9436431780b953891ef27) )
ROM_END




ROM_START( sc_casxt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420640.lo", 0x00001, 0x080000, CRC(a3c7226a) SHA1(5c6aaae3d7da11d48172b81c5122b4db64aaa795) )
	ROM_LOAD16_BYTE( "95420641.hi", 0x00000, 0x080000, CRC(2e71cd56) SHA1(68e2e9c35d8bc6cf49cf09b571d89b57943750e3) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420642.lo", 0x00001, 0x080000, CRC(299b543b) SHA1(4c4cee77ac8db935cb78d41d9589b94b54d7d2a3) )
	ROM_LOAD16_BYTE( "95420643.hi", 0x00000, 0x080000, CRC(7dace7c6) SHA1(ec4d65976bec9ceda68e46816d5f0c4b83807942) )
	ROM_LOAD16_BYTE( "95420644.lo", 0x00001, 0x080000, CRC(64a3ffc3) SHA1(bbea1a1a151730fbbe9c9fc40b6fbc1f4cc37bdc) )
	ROM_LOAD16_BYTE( "95420645.hi", 0x00000, 0x080000, CRC(27b754f3) SHA1(01d2a7db79b9252bcc3cb321ec0b40517a63f9d3) )
	ROM_LOAD16_BYTE( "95420712.lo", 0x00001, 0x080000, CRC(76058d49) SHA1(0c05d7dc4f69b62d0ccafaa2fb0f5f95ed196230) )
	ROM_LOAD16_BYTE( "95420713.hi", 0x00000, 0x080000, CRC(ffb7d958) SHA1(054062991db12dd4e5cb05aefe31f165ffb2863d) )
	ROM_LOAD16_BYTE( "95421640.lo", 0x00001, 0x080000, CRC(0ade76b5) SHA1(c79006d18783f574b237a65c6ddcf0bcf1bf034f) )
	ROM_LOAD16_BYTE( "95421641.hi", 0x00000, 0x080000, CRC(bc2a1028) SHA1(333abe3c0cc4d8b13ee87838b62a82b158148e36) )
	ROM_LOAD16_BYTE( "95421642.lo", 0x00001, 0x080000, CRC(d7a9d771) SHA1(da1311158abe1fe8afd792120a0acd9a49c8a989) )
	ROM_LOAD16_BYTE( "95421643.hi", 0x00000, 0x080000, CRC(0402f764) SHA1(9a7ae89cd774dc4b6f7ab977544dcad1238496c7) )
	ROM_LOAD16_BYTE( "95421644.lo", 0x00001, 0x080000, CRC(cdbaab1c) SHA1(b40f6c12faec96fe856320560e50a7ff2fa4b234) )
	ROM_LOAD16_BYTE( "95421645.hi", 0x00000, 0x080000, CRC(b5ec898d) SHA1(cbe7b2495e84383c6f72a8865c3b8fae81d8bab5) )
	ROM_LOAD16_BYTE( "95421712.lo", 0x00001, 0x080000, CRC(3c95e568) SHA1(7308b20b962a1e006db14df9375f0376ab360400) )
	ROM_LOAD16_BYTE( "95421713.hi", 0x00000, 0x080000, CRC(031ccbca) SHA1(7046385ec98c296ed993df06ff081b2dbde8b42e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008854.bin", 0x0000, 0x08cba2, CRC(f7b3ad12) SHA1(08108745f7e048e9aa27777bdc6edeb5d5836a6d) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890718.bin", 0x0000, 0x5000, CRC(dd65993f) SHA1(db2af897e36d7b55ed1d1d2efe350f4802449945) )
	ROM_LOAD( "95890719.bin", 0x0000, 0x5000, CRC(c1b36983) SHA1(2b74336915c7156723e2554f152ed34f6c88a16a) )
	ROM_LOAD( "95890720.bin", 0x0000, 0x5000, CRC(02e94b13) SHA1(2d8fffc631e1a590774131bdea1f0b5ec8c6e8f3) )
ROM_END




ROM_START( sc_chavi )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418088.lo", 0x00001, 0x080000, CRC(56f94ca0) SHA1(7ac6f781f15d0397580e0bd379d60953b081cd42) )
	ROM_LOAD16_BYTE( "95418089.hi", 0x00000, 0x080000, CRC(47f83d4a) SHA1(5b33ac69c81a83b0842755b9c91f2fa295e7dc81) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418090.lo", 0x00001, 0x080000, CRC(e453684f) SHA1(42d0d223f559fab560310e1333d1c7f6e6e82282) )
	ROM_LOAD16_BYTE( "95418091.hi", 0x00000, 0x080000, CRC(8771b305) SHA1(988d40dc2ce2cb68fdb371a67197112e0305c4cd) )
	ROM_LOAD16_BYTE( "95418824.lo", 0x00001, 0x080000, CRC(37967162) SHA1(8eef719d8a22fd4ad059ec30ca7e9d73d6682e5d) )
	ROM_LOAD16_BYTE( "95418825.hi", 0x00000, 0x080000, CRC(bd26bfa6) SHA1(8fc483dd18121c6f07ef3059d4bca29d0ac65c64) )
	ROM_LOAD16_BYTE( "95418826.lo", 0x00001, 0x080000, CRC(9c9ef425) SHA1(017ed1bf26ef346ee447cff6824e0416d48d91ef) )
	ROM_LOAD16_BYTE( "95418827.hi", 0x00000, 0x080000, CRC(1ff95ad0) SHA1(49b3d1a9fe012565f6e772fb3b3704f55bc5039e) )
	ROM_LOAD16_BYTE( "95418898.lo", 0x00001, 0x080000, CRC(fce959fc) SHA1(94bdb62892d46f51a70f2b35718724f3e2de070d) )
	ROM_LOAD16_BYTE( "95418899.hi", 0x00000, 0x080000, CRC(40418dbf) SHA1(192ba131b2da9accf05c09ff899a302862d24c39) )
	ROM_LOAD16_BYTE( "95418900.lo", 0x00001, 0x080000, CRC(75dfc3eb) SHA1(5aade49ac5f857d4ece5d3cd04c2a3b7a188241a) )
	ROM_LOAD16_BYTE( "95418901.hi", 0x00000, 0x080000, CRC(3ce6a0a4) SHA1(6fdbf918f8f6408161bfa3eb06086e47543987cd) )
	ROM_LOAD16_BYTE( "95418950.lo", 0x00001, 0x080000, CRC(f5026eec) SHA1(f535bbd31cc0e08568970f35edc9e366e90669eb) )
	ROM_LOAD16_BYTE( "95418951.hi", 0x00000, 0x080000, CRC(52d24ec0) SHA1(5cd6192b8a8681a49e288e6395dd98769a1e6e30) )
	ROM_LOAD16_BYTE( "95419088.lo", 0x00001, 0x080000, CRC(c15d6376) SHA1(4ef1d50733bbd63157ff3e04d35d2fa3169d387c) )
	ROM_LOAD16_BYTE( "95419089.hi", 0x00000, 0x080000, CRC(4b894464) SHA1(00885b678bc9d70fd8d6d7af25c5c38bdac38115) )
	ROM_LOAD16_BYTE( "95419090.lo", 0x00001, 0x080000, CRC(a393dca3) SHA1(6f0f9cfb3b5aa6ac6ae02d1987fb4c5e1a5a9d63) )
	ROM_LOAD16_BYTE( "95419091.hi", 0x00000, 0x080000, CRC(9f143def) SHA1(377bc77a8f792526d2f9b391b9e28627b1bee55b) )
	ROM_LOAD16_BYTE( "95419824.lo", 0x00001, 0x080000, CRC(e3c25c14) SHA1(90c511378dfa48f24fcac9818efa4c0cccc15620) )
	ROM_LOAD16_BYTE( "95419825.hi", 0x00000, 0x080000, CRC(90614ca8) SHA1(84038b4e0a516d33c6abc9eee75964215bb569fa) )
	ROM_LOAD16_BYTE( "95419826.lo", 0x00001, 0x080000, CRC(8d6220fb) SHA1(c7f6a4680c202f43765e5df0e6b313c53a1607d7) )
	ROM_LOAD16_BYTE( "95419827.hi", 0x00000, 0x080000, CRC(7d9ee9c9) SHA1(c2acc78e834522630fde6136f6b63dac97f721d6) )
	ROM_LOAD16_BYTE( "95419898.lo", 0x00001, 0x080000, CRC(04c42bf4) SHA1(5d40fb2bf1e7e0ea29f21aef83c86835726e78e0) )
	ROM_LOAD16_BYTE( "95419899.hi", 0x00000, 0x080000, CRC(7bea2c2a) SHA1(3cbeb27a22f910014ba1eea0ddd53b48bf071e9c) )
	ROM_LOAD16_BYTE( "95419900.lo", 0x00001, 0x080000, CRC(81ae49c8) SHA1(bc8bf3373b291eaa946b256b4ba645c1dc178495) )
	ROM_LOAD16_BYTE( "95419901.hi", 0x00000, 0x080000, CRC(8ca22714) SHA1(9fe571bc709f399e7d5190377d45f7a3230d9486) )
	ROM_LOAD16_BYTE( "95419950.lo", 0x00001, 0x080000, CRC(b61e99f8) SHA1(eeee32e8d53c00fa70458bdb17a68f6083462f2a) )
	ROM_LOAD16_BYTE( "95419951.hi", 0x00000, 0x080000, CRC(9d2fc746) SHA1(84444065825c83724d4413fd4a516991ef5d03cf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008563.bin", 0x0000, 0x100000, CRC(e4d30521) SHA1(70a2d88842ee40c77011a2ed8ca45f71316d2579) )
ROM_END




ROM_START( sc_chavy )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416842.lo", 0x00001, 0x080000, CRC(be85c187) SHA1(d2743eefe9576270d291b1978737817892af9772) )
	ROM_LOAD16_BYTE( "95416843.hi", 0x00000, 0x080000, CRC(6eaeeb76) SHA1(5bfd47cb2cd2c6bd46a36c527fa018c449d6a710) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416844.lo", 0x00001, 0x080000, CRC(37711221) SHA1(8b2fc0261281ffe7230415cb019b4f5cb939009e) )
	ROM_LOAD16_BYTE( "95416845.hi", 0x00000, 0x080000, CRC(0dd320a9) SHA1(2a41b89c40a1aee32e3283ad1449482cf2d355bc) )
	ROM_LOAD16_BYTE( "95416846.lo", 0x00001, 0x080000, CRC(bc307727) SHA1(5937e8fce2a92f0b3bedf02b0887a2f80b5bb27c) )
	ROM_LOAD16_BYTE( "95416847.hi", 0x00000, 0x080000, CRC(dfbb8862) SHA1(815434c40f554ab72b7cdfd780bb64c2643279b4) )
	ROM_LOAD16_BYTE( "95417842.lo", 0x00001, 0x080000, CRC(eb9fa79e) SHA1(b7830534490417d04638019275da633846b54f41) )
	ROM_LOAD16_BYTE( "95417843.hi", 0x00000, 0x080000, CRC(7ee0cbf0) SHA1(1669ac40c06f65d75a00ddce965cccc6276ade8f) )
	ROM_LOAD16_BYTE( "95417844.lo", 0x00001, 0x080000, CRC(06affe82) SHA1(81b8d93b0085c8bd1285ee89f62a4e15cb3c600a) )
	ROM_LOAD16_BYTE( "95417845.hi", 0x00000, 0x080000, CRC(2b6f50e1) SHA1(2d4d45a1b4f472b958b00f137e3393f39876cfe0) )
	ROM_LOAD16_BYTE( "95417846.lo", 0x00001, 0x080000, CRC(c6f71785) SHA1(db10ccc08a9e46257d7c8b40e0104be5374dbc1b) )
	ROM_LOAD16_BYTE( "95417847.hi", 0x00000, 0x080000, CRC(3731e982) SHA1(0c244ad65c0b11e8f65d22a4cb97c3b459dc46a1) )
	ROM_LOAD16_BYTE( "95420334.lo", 0x00001, 0x080000, CRC(356c3a41) SHA1(e66f97a4145d5161711f31a14ae9fde5318e95c6) )
	ROM_LOAD16_BYTE( "95420335.hi", 0x00000, 0x080000, CRC(2b8ebf58) SHA1(caf40ca340e48d4ddbc44f80d1afdbcd8a88855a) )
	ROM_LOAD16_BYTE( "95420336.lo", 0x00001, 0x080000, CRC(eae1a753) SHA1(36fc6ec520902cdf8b6f73c740bc50f491594d02) )
	ROM_LOAD16_BYTE( "95420337.hi", 0x00000, 0x080000, CRC(aefa6f50) SHA1(1dc93cc2bca7e724b791b9cfb3584c9539637deb) )
	ROM_LOAD16_BYTE( "95420338.lo", 0x00001, 0x080000, CRC(9fdebb0c) SHA1(bedf8d23568559804443342965b2cf64df6ed5d2) )
	ROM_LOAD16_BYTE( "95420339.hi", 0x00000, 0x080000, CRC(fdf9ad5f) SHA1(c58e5a5fa59333de25a546a8da31bd6be6310fde) )
	ROM_LOAD16_BYTE( "95421334.lo", 0x00001, 0x080000, CRC(e8dd78da) SHA1(a578bae1a56e849a908939291a848aa5aa31d5d7) )
	ROM_LOAD16_BYTE( "95421335.hi", 0x00000, 0x080000, CRC(98270994) SHA1(3ba637fa297a329532d35cb56e801fd65d86ede6) )
	ROM_LOAD16_BYTE( "95421336.lo", 0x00001, 0x080000, CRC(476e9be9) SHA1(358ea89949aca559fb48327427402ddd5b0886ec) )
	ROM_LOAD16_BYTE( "95421337.hi", 0x00000, 0x080000, CRC(30b26f24) SHA1(7eca761a22797a6af3aec92a06b0ea5ff446c537) )
	ROM_LOAD16_BYTE( "95421338.lo", 0x00001, 0x080000, CRC(3756ac10) SHA1(9310ccb404923670c746b1c0527df5ee0cba4ab9) )
	ROM_LOAD16_BYTE( "95421339.hi", 0x00000, 0x080000, CRC(0fc25550) SHA1(ea0379141903823ba20acba52e1aaa99cb70aed6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008964.bin", 0x0000, 0x0fc821, CRC(597bc1c8) SHA1(f28d3fe1dd5ccf4d5ff6e1088a392b4713e6d1b5) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890437.bin", 0x0000, 0x5000, CRC(e4c29dae) SHA1(5e81acde46a489b8a9056167e33efec3d2d1b95a) )
	ROM_LOAD( "95890438.bin", 0x0000, 0x5000, CRC(9154d99a) SHA1(61ef137e6db5f8394b948c589c0cee506a48f9ed) )
	ROM_LOAD( "95890439.bin", 0x0000, 0x5000, CRC(0fee15c6) SHA1(3d24e9861c2c7a67a3d4d156b9281e857de30a55) )
ROM_END




ROM_START( sc_chick )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406754.lo", 0x00001, 0x080000, CRC(3df14180) SHA1(6239699d788e9becdba091f1fdd358e11c347d1d) )
	ROM_LOAD16_BYTE( "95406755.hi", 0x00000, 0x080000, CRC(3c37d9cd) SHA1(3285a260362f8391a4c9887d452a56881ed0d275) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008291.bin", 0x0000, 0x0b2877, CRC(8e9f53d4) SHA1(7c91e64d7214e1c08b0976f901713228bb64ee49) )
ROM_END




ROM_START( sc_chub )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400281.lo", 0x00001, 0x080000, CRC(55cffc3e) SHA1(346b77e8f0fc4ba58cb39157ca7ab411b7a1c8e8) )
	ROM_LOAD16_BYTE( "95400282.hi", 0x00000, 0x080000, CRC(e8b704b3) SHA1(7d14b14b3eb21ea9fd85985bb3acf16d691f00a5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400803.lo", 0x00001, 0x080000, CRC(ebc45fd0) SHA1(865a5cc1a2ffa5c8125411787999e06568d560ce) )
	ROM_LOAD16_BYTE( "95400804.hi", 0x00000, 0x080000, CRC(5e10c078) SHA1(eb6a00ff568be24721d6254814464cb209bd8171) )
	ROM_LOAD16_BYTE( "95401803.lo", 0x00001, 0x080000, CRC(3feeeba0) SHA1(e333ed738cee42723528af65c8b3b5b1b24b4bf3) )
	ROM_LOAD16_BYTE( "95401804.hi", 0x00000, 0x080000, CRC(31d342e8) SHA1(302d61748fa24d1c955557118bb4c9cb4997f340) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004109", 0x0000, 0x080000, CRC(2e3e2f6e) SHA1(217197bdbcd27271afce7809de7c49cca4ef3656) )
	ROM_LOAD( "95004110", 0x0000, 0x080000, CRC(29f3caef) SHA1(dddf38b3da4b9756103b32de4d5d12d612223298) )
ROM_END




ROM_START( sc_cla7 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408544.lo", 0x00001, 0x080000, CRC(1e8f68a5) SHA1(134c951ce4c93954c961c6a752faeeb85d6141bb) )
	ROM_LOAD16_BYTE( "95408545.hi", 0x00000, 0x080000, CRC(39590624) SHA1(75e12f094f344468d15297add4cfdb5bd4342eec) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409544.lo", 0x00001, 0x080000, CRC(919ce515) SHA1(23d506c789a3de63eff73b7c18a7e46d5aa4821d) )
	ROM_LOAD16_BYTE( "95409545.hi", 0x00000, 0x080000, CRC(d1ef3f68) SHA1(e72403244167b7534926f22ba471a881f7f88e3e) )
	ROM_LOAD16_BYTE( "95409804.lo", 0x00001, 0x080000, CRC(cfc6ad00) SHA1(193a3dd9cb8ef04a131fa30b51ad9c21f773108b) )
	ROM_LOAD16_BYTE( "95409805.hi", 0x00000, 0x080000, CRC(1d981e1b) SHA1(cdaf1c68c6b30e2e6b4f958967bd6ef6d73a224d) )
	ROM_LOAD16_BYTE( "95409806.lo", 0x00001, 0x080000, CRC(0b9494f9) SHA1(2c3f2378615e532df154df6e926a2e366b36b4ae) )
	ROM_LOAD16_BYTE( "95409807.hi", 0x00000, 0x080000, CRC(ce7e1b3e) SHA1(69e125a90aae7a85ed8161fc22ee03d4783f7488) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004334.bin", 0x0000, 0x080000, CRC(bd8a3d25) SHA1(9dd5d124ce467293417575bf316dc1b371bc3169) )
ROM_END




ROM_START( sc_ccogs )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95409408.odd", 0x00001, 0x080000, CRC(076fd1b8) SHA1(f6089d6a0e8c8f3408842c219bdfe04c3ef9fe24) )
	ROM_LOAD16_BYTE( "95409409.evn", 0x00000, 0x080000, CRC(c2b9efd8) SHA1(cac26ba46ca51f232057534c66701a33a1de5d4a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_cclas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402982.lo", 0x00001, 0x080000, CRC(dd14db28) SHA1(d5a79e40597cd92cf65fc85c751e289b18c39bd0) )
	ROM_LOAD16_BYTE( "95402983.hi", 0x00000, 0x080000, CRC(86f90794) SHA1(c58657e67e02eecc70cc7f088817112f9aae892f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402984.lo", 0x00001, 0x080000, CRC(775c466b) SHA1(50c5e8b6dcd0ef1a85fefb69368c0a1ece5c13d5) )
	ROM_LOAD16_BYTE( "95402985.hi", 0x00000, 0x080000, CRC(aa059e42) SHA1(825fb2c88f5c0d392972ec67b87a74a5fad74e3e) )
	ROM_LOAD16_BYTE( "95403982.lo", 0x00001, 0x080000, CRC(87c6543e) SHA1(7dfcc37224524cfca68112bf506de0b62e6814fc) )
	ROM_LOAD16_BYTE( "95403983.hi", 0x00000, 0x080000, CRC(af55e3a8) SHA1(24fe9caf9eb9a0eb4ccc2ccd38381cb2041b41c8) )
	ROM_LOAD16_BYTE( "95403984.lo", 0x00001, 0x080000, CRC(85185c89) SHA1(51ec08d434a0e11ced42035f7745043377c6a69d) )
	ROM_LOAD16_BYTE( "95403985.hi", 0x00000, 0x080000, CRC(e707f9ea) SHA1(13538dfb781359755a24f8c757851746a3a94180) )
	ROM_LOAD16_BYTE( "95404120.lo", 0x00001, 0x080000, CRC(b2129489) SHA1(41e87d2e2235837ed2399d7bbcca8a51481ec904) )
	ROM_LOAD16_BYTE( "95404121.hi", 0x00000, 0x080000, CRC(780849f1) SHA1(0aeeb86ceace28d858934e1811a5239eaef07155) )
	ROM_LOAD16_BYTE( "95404778.lo", 0x00001, 0x080000, CRC(acc30fb8) SHA1(f2dc37efb302a87052b32aab4029fb59453b4b97) )
	ROM_LOAD16_BYTE( "95404779.hi", 0x00000, 0x080000, CRC(098905e7) SHA1(2fc5efb61419070b924de108af4f3704eed66e9e) )
	ROM_LOAD16_BYTE( "95405120.lo", 0x00001, 0x080000, CRC(d3414d4b) SHA1(b81366013ed361847ffd3f2613a5cfbaea23a90f) )
	ROM_LOAD16_BYTE( "95405121.hi", 0x00000, 0x080000, CRC(e6d79fe7) SHA1(90cab834eae2db75aec5d1a362106fb2c3d2586d) )
	ROM_LOAD16_BYTE( "95405778.lo", 0x00001, 0x080000, CRC(7ae848a5) SHA1(5153ef7d05a97849a6b4af7c1f605ac76c942f66) )
	ROM_LOAD16_BYTE( "95405779.hi", 0x00000, 0x080000, CRC(cfa46d0d) SHA1(64bf0e4889a85cc9a8f95ecdde6f5d1da26085d5) )
	ROM_LOAD16_BYTE( "95406584.lo", 0x00001, 0x080000, CRC(f857f4bd) SHA1(8f619c255c964668dbdb49b015055297c42a5f68) )
	ROM_LOAD16_BYTE( "95406585.hi", 0x00000, 0x080000, CRC(cfb6c220) SHA1(e69644963b353e83320119a8c8c38e2887b6bbcb) )
	ROM_LOAD16_BYTE( "95406694.lo", 0x00001, 0x080000, CRC(78846b8d) SHA1(9709fc0e3c504bd33f69b3edaa22f62439d8fd91) )
	ROM_LOAD16_BYTE( "95406695.hi", 0x00000, 0x080000, CRC(a89f1d49) SHA1(adfc80802e59fc17872ede25a3e95c82f19f8abd) )
	ROM_LOAD16_BYTE( "95406696.lo", 0x00001, 0x080000, CRC(b1bd9dc5) SHA1(9c93c28f8156d661512b1541e4cd8a86f0612ef4) )
	ROM_LOAD16_BYTE( "95406697.hi", 0x00000, 0x080000, CRC(9571c344) SHA1(16e80d31cfdcf0634ed49d2b5fd4efb9bd331fc0) )
	ROM_LOAD16_BYTE( "95406744.lo", 0x00001, 0x080000, CRC(52943d2e) SHA1(44d7a835e087c957b11ab256ca7bc912f9fe5237) )
	ROM_LOAD16_BYTE( "95406745.hi", 0x00000, 0x080000, CRC(763b7dcd) SHA1(bfaa421e8dd55e1d008bc854c8b0c015f717195e) )
	ROM_LOAD16_BYTE( "95406930.lo", 0x00001, 0x080000, CRC(4491aa95) SHA1(a4a92a66cd1bbc57fe193c1fa860af7f96e08abb) )
	ROM_LOAD16_BYTE( "95406931.hi", 0x00000, 0x080000, CRC(6d634e54) SHA1(e29f7bdbe7534b00ace471a6b246f2a08f94b553) )
	ROM_LOAD16_BYTE( "95406970.lo", 0x00001, 0x080000, CRC(4fef064e) SHA1(b65ef9ab2fcc7cfe72f0c728591260c2057f8a84) )
	ROM_LOAD16_BYTE( "95406971.hi", 0x00000, 0x080000, CRC(e9319a05) SHA1(ffc3f4cb772593d9ed0ae9294c621ad100d4c45f) )
	ROM_LOAD16_BYTE( "95406972.lo", 0x00001, 0x080000, CRC(502f0174) SHA1(1d1f9a9e4fc6f978fcd579c4909c19aca20a427b) )
	ROM_LOAD16_BYTE( "95406973.hi", 0x00000, 0x080000, CRC(14eae726) SHA1(907d431355e129c013dab8222e992bc08feb52ae) )
	ROM_LOAD16_BYTE( "95406978.lo", 0x00001, 0x080000, CRC(5900a448) SHA1(2af8fd172c75a9ce2d41f886e3634b5d46975223) )
	ROM_LOAD16_BYTE( "95406979.hi", 0x00000, 0x080000, CRC(5ff4e432) SHA1(65e72ec1276d194ad2e39c14eed83056381d060e) )
	ROM_LOAD16_BYTE( "95407584.lo", 0x00001, 0x080000, CRC(e7158a0f) SHA1(296aabee4df111f2369f2429db45861214ae8c25) )
	ROM_LOAD16_BYTE( "95407585.hi", 0x00000, 0x080000, CRC(67645ec3) SHA1(2682734f52fcf3a33e2c4dc8f2fbcd89b7d0e908) )
	ROM_LOAD16_BYTE( "95407694.lo", 0x00001, 0x080000, CRC(1f9a549a) SHA1(e7a0690c6116ad50ba6727edffbe275a34a6013b) )
	ROM_LOAD16_BYTE( "95407695.hi", 0x00000, 0x080000, CRC(d6f5a80b) SHA1(7af2abda9375662af070b28c26cce61f3a0c7b85) )
	ROM_LOAD16_BYTE( "95407696.lo", 0x00001, 0x080000, CRC(ef6571d8) SHA1(f323fa4d22b0b6fc30239009d0656d1e1f358cc8) )
	ROM_LOAD16_BYTE( "95407697.hi", 0x00000, 0x080000, CRC(5efad9ec) SHA1(db4049e8985b42e9056f8256bf5a00b965d812f1) )
	ROM_LOAD16_BYTE( "95407744.lo", 0x00001, 0x080000, CRC(c9230322) SHA1(2fb7b25f7303c58403d527e4b2d6522730fa4f05) )
	ROM_LOAD16_BYTE( "95407745.hi", 0x00000, 0x080000, CRC(5a4222b3) SHA1(ad7a38fe18e5437e1a545133bcc0b95e1da6113e) )
	ROM_LOAD16_BYTE( "95407930.lo", 0x00001, 0x080000, CRC(358d3d03) SHA1(ba02bf2e32ead55076ac3ad1cef58c7ed52c5276) )
	ROM_LOAD16_BYTE( "95407931.hi", 0x00000, 0x080000, CRC(f145088c) SHA1(111ad347bf6335b14e8ba3d2283b620a6d8e51ab) )
	ROM_LOAD16_BYTE( "95407970.lo", 0x00001, 0x080000, CRC(ab7a1e6b) SHA1(4b9e00b5f8bc7e8caf9f35df946cdd7b3696be0a) )
	ROM_LOAD16_BYTE( "95407971.hi", 0x00000, 0x080000, CRC(6ba1e287) SHA1(83a52387796eb1d559b2db772997535e63acee4c) )
	ROM_LOAD16_BYTE( "95407972.lo", 0x00001, 0x080000, CRC(21cd6a85) SHA1(996923887dc386f5028d08b93993de6a9ca6707f) )
	ROM_LOAD16_BYTE( "95407973.hi", 0x00000, 0x080000, CRC(afa110cf) SHA1(aa81975dd08b8b24d5abe227fd441294de434d49) )
	ROM_LOAD16_BYTE( "95407978.lo", 0x00001, 0x080000, CRC(4bb5dfb7) SHA1(d637236e9b596df295ded57dac2ea0be383841fa) )
	ROM_LOAD16_BYTE( "95407979.hi", 0x00000, 0x080000, CRC(1ae0e535) SHA1(1d2778cdf4e5595fabd1a03ea9b095c1bc549554) )
	ROM_LOAD16_BYTE( "95410746.lo", 0x00001, 0x080000, CRC(58b8f1f8) SHA1(76029beb8adad1b5f90d3452931a087bf023fb69) )
	ROM_LOAD16_BYTE( "95410747.hi", 0x00000, 0x080000, CRC(501846a0) SHA1(edc4ed801f96cc6a373113820c09baa37863afbf) )
	ROM_LOAD16_BYTE( "95410748.lo", 0x00001, 0x080000, CRC(51c3e330) SHA1(ac9a809d7767ca77a138212e622951828b68c09d) )
	ROM_LOAD16_BYTE( "95410749.hi", 0x00000, 0x080000, CRC(48582c9f) SHA1(203036c81cfc816df46eb0daf593357afd75a234) )
	ROM_LOAD16_BYTE( "95411746.lo", 0x00001, 0x080000, CRC(b4737d12) SHA1(a1cd95eaed2c52c254e298b629eb52d310ab390c) )
	ROM_LOAD16_BYTE( "95411747.hi", 0x00000, 0x080000, CRC(53c4e408) SHA1(e99b59477d33c567fabe496af6f8793f0a5aed0b) )
	ROM_LOAD16_BYTE( "95411748.lo", 0x00001, 0x080000, CRC(900015f8) SHA1(70b3a6d129558e358f0f77e1b5f7b4b275458eb9) )
	ROM_LOAD16_BYTE( "95411749.hi", 0x00000, 0x080000, CRC(651fdf91) SHA1(9234a2c5b6e2eb8b98013503fa76e8370740ba96) )
	ROM_LOAD16_BYTE( "95412176.lo", 0x00001, 0x080000, CRC(4f49d67a) SHA1(3c732921baba359980dea01fa992a40b592fa18b) )
	ROM_LOAD16_BYTE( "95412177.hi", 0x00000, 0x080000, CRC(0c5be069) SHA1(73237f14b52a8cd6f1bed26fb2c1df8e1893f855) )
	ROM_LOAD16_BYTE( "95412178.lo", 0x00001, 0x080000, CRC(0a7cabc4) SHA1(03eafd07bb19be2f0392e0531acc3fa7c0bcfe13) )
	ROM_LOAD16_BYTE( "95412179.hi", 0x00000, 0x080000, CRC(dc1be24f) SHA1(3c1454da68b750cabfa3b3de318520ca8b2e0cd0) )
	ROM_LOAD16_BYTE( "95413176.lo", 0x00001, 0x080000, CRC(b89473e7) SHA1(026dd4273cdce7122fedaaf5d9e1665a86e6c8fc) )
	ROM_LOAD16_BYTE( "95413177.hi", 0x00000, 0x080000, CRC(5fe8319c) SHA1(ef201862e9ae8c64498d3e89292074298256410b) )
	ROM_LOAD16_BYTE( "95413178.lo", 0x00001, 0x080000, CRC(7f603811) SHA1(0e930f672379234de65af8d00a5ae0fddf427015) )
	ROM_LOAD16_BYTE( "95413179.hi", 0x00000, 0x080000, CRC(14af9a34) SHA1(b85d1b461e58743bf66dfc4bc6302aabc4b567d9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004250.bin", 0x0000, 0x080000, CRC(5250f18b) SHA1(bbdc556df845753f9ce15dd7dfb2347539dfa00f) )
	ROM_LOAD( "95004251.bin", 0x0000, 0x080000, CRC(7a0a7876) SHA1(f172c8a1fbe214f201e6bf671c2f0534b6d9d395) )
ROM_END




ROM_START( sc_clclo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95425336.lo", 0x00001, 0x080000, CRC(be78cc27) SHA1(250d369c0b9c4047f7f4d28df2035095119f1d54) )
	ROM_LOAD16_BYTE( "95425337.hi", 0x00000, 0x080000, CRC(fd8ad271) SHA1(5ef908d5936782ee49f9d7b4013a3125f8092c6a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008889.bin", 0x0000, 0x0edfec, CRC(fb894b4f) SHA1(60b3f28efda4ecb9f7804540291c8c3b8bead27a) )
ROM_END




ROM_START( sc_clue )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416502.lo", 0x00001, 0x080000, CRC(86604ff8) SHA1(da4694fa4fa272b3ba49177a4eac92acaea1209c) )
	ROM_LOAD16_BYTE( "95416503.hi", 0x00000, 0x080000, CRC(8cf0f42b) SHA1(714fe0fad59b2d16f12c39aae8943734a5202706) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416504.lo", 0x00001, 0x080000, CRC(5d0c4636) SHA1(b47097c2a6e440fc32fa0b36b55cf8e7c3bb5ebd) )
	ROM_LOAD16_BYTE( "95416505.hi", 0x00000, 0x080000, CRC(953a4273) SHA1(09fa4630aa2b8cb9208221ef818df7ba3564b78d) )
	ROM_LOAD16_BYTE( "95416562.lo", 0x00001, 0x080000, CRC(c4b78c45) SHA1(5894b0a63418c30ee2b580acf4b1ddb2ad56296a) )
	ROM_LOAD16_BYTE( "95416563.hi", 0x00000, 0x080000, CRC(b98e38f1) SHA1(9f477028d66c816305a04d307b7c1cd90ce22406) )
	ROM_LOAD16_BYTE( "95417502.lo", 0x00001, 0x080000, CRC(0f112ca9) SHA1(6a8ab713685ea04490745d69ad674c7d6ddc3160) )
	ROM_LOAD16_BYTE( "95417503.hi", 0x00000, 0x080000, CRC(5195ffd3) SHA1(1a7ff27e2747f67de3826de03ddf942961228e22) )
	ROM_LOAD16_BYTE( "95417504.lo", 0x00001, 0x080000, CRC(21766be6) SHA1(9517a0a8dea3cd9f6f951dda7f8f0499010a626f) )
	ROM_LOAD16_BYTE( "95417505.hi", 0x00000, 0x080000, CRC(b605225c) SHA1(aa3283ce31c0a75b44e09d43995c25b63b5ac74e) )
	ROM_LOAD16_BYTE( "95417562.lo", 0x00001, 0x080000, CRC(915e332e) SHA1(8bebc060a81477dbc863e91dfcac96735276c386) )
	ROM_LOAD16_BYTE( "95417563.hi", 0x00000, 0x080000, CRC(f016e591) SHA1(e40b91b2d6ccfafc97be91b6f5a18ebbfdea6a36) )
	ROM_LOAD16_BYTE( "95420376.lo", 0x00001, 0x080000, CRC(7b39a031) SHA1(2b5041fa2ae37dc62e18a0fb264e478808d6aa55) )
	ROM_LOAD16_BYTE( "95420377.hi", 0x00000, 0x080000, CRC(fef0e282) SHA1(ab59343b614dc389022b6225219907177770eda3) )
	ROM_LOAD16_BYTE( "95420554.lo", 0x00001, 0x080000, CRC(004aa4b4) SHA1(7fadd404add64c710fcb60d7b260fba06fc192f0) )
	ROM_LOAD16_BYTE( "95420555.hi", 0x00000, 0x080000, CRC(0f1e5a37) SHA1(2d4589c3c5e6de99374b471230f14231d1e7258a) )
	ROM_LOAD16_BYTE( "95420556.lo", 0x00001, 0x080000, CRC(fd2ca2c4) SHA1(b311e51d03a1d38b1001a0e6fa625a41f6ebf4a2) )
	ROM_LOAD16_BYTE( "95420557.hi", 0x00000, 0x080000, CRC(85a07ec8) SHA1(0e66f7aa5644f8ba7727a5737f6990effd5a41f8) )
	ROM_LOAD16_BYTE( "95421376.lo", 0x00001, 0x080000, CRC(799ec958) SHA1(2d90a9a8079676b2260e94a02f83225b8fc766ab) )
	ROM_LOAD16_BYTE( "95421377.hi", 0x00000, 0x080000, CRC(c963fea2) SHA1(c4e9515d7066c9318cec77da9423f93996d45050) )
	ROM_LOAD16_BYTE( "95421554.lo", 0x00001, 0x080000, CRC(43efa639) SHA1(47aef3c613fa125a288843ac5caf02d76dcf2725) )
	ROM_LOAD16_BYTE( "95421555.hi", 0x00000, 0x080000, CRC(742d6413) SHA1(436892f74c15946672f0037095910163fb488f25) )
	ROM_LOAD16_BYTE( "95421556.lo", 0x00001, 0x080000, CRC(023e4809) SHA1(0f6d8b092ed988b48dba77cecd3117217f43f4f4) )
	ROM_LOAD16_BYTE( "95421557.hi", 0x00000, 0x080000, CRC(dd17ecaa) SHA1(dc264136e21b83fd9a36aa60f34c82af071f4ef4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )

	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890356.bin", 0x0000, 0x5000, CRC(fd78e03f) SHA1(029e2fd7e9cff3793d905d192c889873ad2a0d26) )
	ROM_LOAD( "95890357.bin", 0x0000, 0x5000, CRC(88eea40b) SHA1(5a730add3f9941dfcbfa5cd8f6a6142d19065482) )
	ROM_LOAD( "95890358.bin", 0x0000, 0x5000, CRC(16546857) SHA1(d8b81b3df5e041c83c4f359c487165a6a2d5c513) )
ROM_END




ROM_START( sc_clucl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416678.lo", 0x00001, 0x080000, CRC(c3282fba) SHA1(9d1c0fdde7f59aae6b61a348f852e05a186eb00f) )
	ROM_LOAD16_BYTE( "95416679.hi", 0x00000, 0x080000, CRC(b87c1eeb) SHA1(e39fed7449b2b6d9ae0a957d02c97f5f309682aa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417678.lo", 0x00001, 0x080000, CRC(08ee7c1f) SHA1(ac3df6509d67293e69da9542ad23e87b4f1cbb4f) )
	ROM_LOAD16_BYTE( "95417679.hi", 0x00000, 0x080000, CRC(7254bdc0) SHA1(54bee637fb010515fa49f44c6cb67faecd12e859) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_colos )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406370.lo", 0x00001, 0x080000, CRC(2cc7180b) SHA1(d995e86f174bd7f44abc11c44da8641f1d7d644d) )
	ROM_LOAD16_BYTE( "95406371.hi", 0x00000, 0x080000, CRC(e88bf209) SHA1(346e3e3cbaf82aa34693152ca67ed7cbea045253) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004235.sn1", 0x0000, 0x080000, CRC(e543f4ab) SHA1(7d72f1392fbd43afe390d4f3059b06cd789528d4) )
	ROM_LOAD( "95004236.sn2", 0x0000, 0x080000, CRC(0f26a957) SHA1(b0949534d44dd22b6f676203f52fad978b36d04b) )
ROM_END




ROM_START( sc_cmani )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408022.lo", 0x00001, 0x080000, CRC(e874cb2f) SHA1(4a93d26b6d3f64f850130dc00600ce722c5296bc) )
	ROM_LOAD16_BYTE( "95408023.hi", 0x00000, 0x080000, CRC(627ae9d9) SHA1(1096527a6e2f973cfa8d21aa2ec28102275664da) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408072.lo", 0x00001, 0x080000, CRC(edf065dd) SHA1(2755c0eb52e881b9d5836cd8a4cbac44ee78c0ed) )
	ROM_LOAD16_BYTE( "95408073.hi", 0x00000, 0x080000, CRC(7cd3526a) SHA1(ff6fbcff771da4dcbd2bdae59cdc4821c2169489) )
	ROM_LOAD16_BYTE( "95409022.lo", 0x00001, 0x080000, CRC(771ba795) SHA1(453a3ed1b70ab108682795ebb94757aca2f83029) )
	ROM_LOAD16_BYTE( "95409023.hi", 0x00000, 0x080000, CRC(4e9ce09f) SHA1(9bfde67c5492eabd464bc3e44e01ea2b1d702153) )
	ROM_LOAD16_BYTE( "95409072.lo", 0x00001, 0x080000, CRC(ad1b4196) SHA1(d19d19469cd8f8180c150b7e816442683fb11f14) )
	ROM_LOAD16_BYTE( "95409073.hi", 0x00000, 0x080000, CRC(4034921c) SHA1(a4dee8366390496ad48c89e9ebfba3a706c874cb) )
	ROM_LOAD16_BYTE( "p1308p11.hi", 0x00000, 0x080000, CRC(23e7409f) SHA1(fd5ed768ad5725a26db9f97f45deab8627af01d9) )
	ROM_LOAD16_BYTE( "p1308p11.lo", 0x00001, 0x080000, CRC(6bf123e0) SHA1(da2fde76ad8781b6d3925c02c3879c5025460021) )
	ROM_LOAD16_BYTE( "p1308s11.hi", 0x00000, 0x080000, CRC(b707e2f3) SHA1(d4872fbadb519729c0cbeeba7843973a67f22b4a) )
	ROM_LOAD16_BYTE( "p1308s11.lo", 0x00001, 0x080000, CRC(0f9409d8) SHA1(351bc2b5bb2f4bd9394ceb51bc75c1bd781d9e86) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008295.bin", 0x0000, 0x100000, CRC(a5646d3b) SHA1(9aca69f103f959a85026fd0d0ffb3bd65eebae34) )
ROM_END




ROM_START( sc_cj )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410980.lo", 0x00001, 0x080000, CRC(211d86aa) SHA1(629a8430ffb34ffdcce320fb97e2cc90f150832a) )
	ROM_LOAD16_BYTE( "95410981.hi", 0x00000, 0x080000, CRC(63f665e0) SHA1(7b853d38e92f1d1cd3a892077062b34053b9f104) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410982.lo", 0x00001, 0x080000, CRC(0ee53044) SHA1(62e56ad2251f2908bc8587b126d0f3cff49951cd) )
	ROM_LOAD16_BYTE( "95410983.hi", 0x00000, 0x080000, CRC(86234e04) SHA1(b09ec3987df8a61936539e8f69fbfdc0bea79e08) )
	ROM_LOAD16_BYTE( "95410985.hi", 0x00000, 0x080000, CRC(ac594336) SHA1(7f5ab3d31e71b04a7abb6ccf5bb47144730faaa7) )
	ROM_LOAD16_BYTE( "95410986.lo", 0x00001, 0x080000, CRC(9e1adac0) SHA1(9956dc03286e59470a531fed1b15988c068a15c4) )
	ROM_LOAD16_BYTE( "95410987.hi", 0x00000, 0x080000, CRC(10963bc3) SHA1(6217af547ff9b6a7ca79053694be921067c4d901) )
	ROM_LOAD16_BYTE( "95411980.lo", 0x00001, 0x080000, CRC(9aba66d1) SHA1(1d22e85f999d3199fe25fd673dce3edd212162bc) )
	ROM_LOAD16_BYTE( "95411981.hi", 0x00000, 0x080000, CRC(0e5d2198) SHA1(30e82d04e7ea15cc237056aa5c482de44e182dbf) )
	ROM_LOAD16_BYTE( "95411982.lo", 0x00001, 0x080000, CRC(6cdefe57) SHA1(506f779cc253d74060c6b3e920609f08abbbc884) )
	ROM_LOAD16_BYTE( "95411983.hi", 0x00000, 0x080000, CRC(b8313675) SHA1(e6add1fcd81b2cab99ea9a5d4284a8a5d8ec33ea) )
	ROM_LOAD16_BYTE( "95411986.lo", 0x00001, 0x080000, CRC(080b6a93) SHA1(a3b390561a6756eef99d98291ee308c8cb7ef640) )
	ROM_LOAD16_BYTE( "95411987.hi", 0x00000, 0x080000, CRC(a30e1edb) SHA1(a1b308ad50845c4cdd83cbd8c33b99870e9f5053) )
	ROM_LOAD16_BYTE( "95412558.lo", 0x00001, 0x080000, CRC(7674e02b) SHA1(05bbebd138b8ab3831db2831169d870acb1f5dfb) )
	ROM_LOAD16_BYTE( "95412559.hi", 0x00000, 0x080000, CRC(b09e9822) SHA1(fbfe52703cb904f8eaf4b0c8b9e124adfd24470a) )
	ROM_LOAD16_BYTE( "95412560.lo", 0x00001, 0x080000, CRC(319aef1e) SHA1(774d00e3f01836a79c530dd6e556f416eca35c92) )
	ROM_LOAD16_BYTE( "95412561.hi", 0x00000, 0x080000, CRC(8970b675) SHA1(ae8877cce1d6be05e154511200301a1daeeb9597) )
	ROM_LOAD16_BYTE( "95413558.lo", 0x00001, 0x080000, CRC(29b5cc1c) SHA1(b1265420b1f66f2d75bd0826e98a893a29ab577d) )
	ROM_LOAD16_BYTE( "95413559.hi", 0x00000, 0x080000, CRC(44c8ef1c) SHA1(bc2a630ad76221f4597ec644a6b548b73c51e9bd) )
	ROM_LOAD16_BYTE( "95413560.lo", 0x00001, 0x080000, CRC(291fdd53) SHA1(92af62de2a411566c16461f124d5f6fa969d84a6) )
	ROM_LOAD16_BYTE( "95413561.hi", 0x00000, 0x080000, CRC(e5e6b17f) SHA1(eeaf1a8553d0c507c689c8d216da79e1570a06d8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008427.bin", 0x0000, 0x100000, CRC(a6093378) SHA1(30a64e8857da269cbc0b3febf30a62f5647d10b9) )
ROM_END




ROM_START( sc_cjcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410968.lo", 0x00001, 0x080000, CRC(40da7b1f) SHA1(05920956c2d0ff0567e83ca12a0b032e58a27b9d) )
	ROM_LOAD16_BYTE( "95410969.hi", 0x00000, 0x080000, CRC(dd39e1e6) SHA1(37a4003f8e24dda2b4d4017ac6c68eb69b594521) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412276.lo", 0x00001, 0x080000, CRC(a2867941) SHA1(892e1eb60c3d6b4e2c2ecda2f78fccba9c709464) )
	ROM_LOAD16_BYTE( "95412277.hi", 0x00000, 0x080000, CRC(986d0408) SHA1(f9f82aaa37d345aabf05096662b34ef2eac05af9) )
	ROM_LOAD16_BYTE( "95412356.lo", 0x00001, 0x080000, CRC(9ca19307) SHA1(aab9c1b66201db40621dde95ebe4a62dcf1964eb) )
	ROM_LOAD16_BYTE( "95412357.hi", 0x00000, 0x080000, CRC(077c32f9) SHA1(50a5ca9a647a4388628fa375598737e05be6ef19) )
	ROM_LOAD16_BYTE( "95412516.lo", 0x00001, 0x080000, CRC(d9e554a1) SHA1(545489318be522d5024363386fdc169618a4bdc4) )
	ROM_LOAD16_BYTE( "95412517.hi", 0x00000, 0x080000, CRC(5a6a00b4) SHA1(e7092436bb7e48707651baaef7bc764e5ec2d199) )
	ROM_LOAD16_BYTE( "95413276.lo", 0x00001, 0x080000, CRC(d9987f68) SHA1(5fad0bb476afc021140cdcceccced85a2c55eae9) )
	ROM_LOAD16_BYTE( "95413277.hi", 0x00000, 0x080000, CRC(258db231) SHA1(266500b9c8af7e92c5fa5b2698889300c6c46144) )
	ROM_LOAD16_BYTE( "95413356.lo", 0x00001, 0x080000, CRC(96105d0d) SHA1(281e7f505aa46fa30bcf54ab2f80731a21b4916d) )
	ROM_LOAD16_BYTE( "95413357.hi", 0x00000, 0x080000, CRC(c90696c5) SHA1(0fb26232c3dffd3bdb3fffaee0a242cc2752250b) )
	ROM_LOAD16_BYTE( "95413516.lo", 0x00001, 0x080000, CRC(8b35728b) SHA1(d46e25a897b8bb37b0958fca91fb162afb6051f8) )
	ROM_LOAD16_BYTE( "95413517.hi", 0x00000, 0x080000, CRC(2c03efee) SHA1(52db4cde0c372d3c39a00df6a3c97a6da34f5f64) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008435.bin", 0x0000, 0x100000, CRC(f0b58825) SHA1(124132a510e7473ade3d03fb63f24f120d3a08e4) )
ROM_END




ROM_START( sc_ctl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406758.lo", 0x00001, 0x080000, CRC(d4446eb7) SHA1(25aaf705b83df02176f73b84ef271b24dce47676) )
	ROM_LOAD16_BYTE( "95406759.hi", 0x00000, 0x080000, CRC(74b3fc22) SHA1(925f3cb16a6e62e2b9e4160ce15f97e14cda355d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407758.lo", 0x00001, 0x080000, CRC(cdb926f7) SHA1(d92e42386166053e6aa2f63ecbd227f9cb89f90f) )
	ROM_LOAD16_BYTE( "95407759.hi", 0x00000, 0x080000, CRC(b1fc1032) SHA1(92b34e7391d78a8f1e992dce6f0a3b8a35bf0cda) )
	ROM_LOAD16_BYTE( "95408102.lo", 0x00001, 0x080000, CRC(7186022a) SHA1(a7d32c58fc86d60c46e65bd7153806800fdd79c2) )
	ROM_LOAD16_BYTE( "95408103.hi", 0x00000, 0x080000, CRC(6da649d4) SHA1(bd386437657337a35ec895a9921d9099d2e79bfb) )
	ROM_LOAD16_BYTE( "95408278.lo", 0x00001, 0x080000, CRC(64002efa) SHA1(7375b07f2aa26b46f85d8f5de4e69020a011236e) )
	ROM_LOAD16_BYTE( "95408279.hi", 0x00000, 0x080000, CRC(9adf6fc9) SHA1(7fb4d214fa94789ae3557a95ba87a5c88dc44061) )
	ROM_LOAD16_BYTE( "95409102.lo", 0x00001, 0x080000, CRC(5ea911cf) SHA1(9eb47b7c255275df6ca61d729114fdf4709f8729) )
	ROM_LOAD16_BYTE( "95409103.hi", 0x00000, 0x080000, CRC(829cb2d4) SHA1(50831ebf8ceafbf3120cb1ae5a38aa8c6d6db199) )
	ROM_LOAD16_BYTE( "95409278.lo", 0x00001, 0x080000, CRC(b159af51) SHA1(4ea868782a62b0e93df6cd84fcdbe8f33a505221) )
	ROM_LOAD16_BYTE( "95409279.hi", 0x00000, 0x080000, CRC(2879e6a1) SHA1(0321aafa8a581f4d1e2884104a7dee6c3aab5fb1) )
	ROM_LOAD16_BYTE( "p1340p12.hi", 0x00000, 0x080000, CRC(2dc7259d) SHA1(35f3f9227b6bea85983de3fab0b6553817310a40) )
	ROM_LOAD16_BYTE( "p1340p12.lo", 0x00001, 0x080000, CRC(a77e56ec) SHA1(943bf649ee0bd72bef177dfee12497f3ccc54eab) )
	ROM_LOAD16_BYTE( "p1340p13.hi", 0x00000, 0x080000, CRC(5a0f6848) SHA1(edd3cab79508923d1017b55a392a6d1ea488e733) )
	ROM_LOAD16_BYTE( "p1340p13.lo", 0x00001, 0x080000, CRC(b553c20d) SHA1(93a27c225dedbfa73c0af6f5cfa1a5cb4c91b3a9) )
	ROM_LOAD16_BYTE( "p1340s12.hi", 0x00000, 0x080000, CRC(e48974d9) SHA1(ea1020e8898763999f514135186f3b5dde4b4bc5) )
	ROM_LOAD16_BYTE( "p1340s12.lo", 0x00001, 0x080000, CRC(5a076aa3) SHA1(0ff7dbf7c72e8da6dcbe7e2747aa372bf18120b5) )
	ROM_LOAD16_BYTE( "p1340s13.hi", 0x00000, 0x080000, CRC(3c409fe7) SHA1(4d42b999c090c8b82b7c39ca25aa2d930b15e9d0) )
	ROM_LOAD16_BYTE( "p1340s13.lo", 0x00001, 0x080000, CRC(3d0b5934) SHA1(46aaedf7db345e490412278d5308c03866be7ee5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008225.bin", 0x0000, 0x100000, CRC(b185224e) SHA1(a4b4c618903c4c207de8dae74b55fd2c85a5e4ff) )
ROM_END




ROM_START( sc_ctlcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404804.lo", 0x00001, 0x080000, CRC(7de836c7) SHA1(ba14d6695662bedc5dff2f94fd31dfe9d57a8ddf) )
	ROM_LOAD16_BYTE( "95404805.hi", 0x00000, 0x080000, CRC(83334f9b) SHA1(bc10d7261f0cbdb00424ad7d19cec5137a901f44) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405804.lo", 0x00001, 0x080000, CRC(d2c3d594) SHA1(74aafe256a780c6779fb7302a515c35a0f2c6703) )
	ROM_LOAD16_BYTE( "95405805.hi", 0x00000, 0x080000, CRC(bc8344b0) SHA1(97a7d7bab461ef7cfb1fbb89a992e677afcc4b2d) )
	ROM_LOAD16_BYTE( "95412204.lo", 0x00001, 0x080000, CRC(4b17ab16) SHA1(f5063f66e9886fe2442e2379daaa3fb988509368) )
	ROM_LOAD16_BYTE( "95412205.hi", 0x00000, 0x080000, CRC(0de1e4ff) SHA1(82caf4eba559041e2a8990c81ad09eba49084df7) )
	ROM_LOAD16_BYTE( "95413204.lo", 0x00001, 0x080000, CRC(5c46a67a) SHA1(5b3a3caac83e9a137a8d201ab19187d73df1d4a9) )
	ROM_LOAD16_BYTE( "95413205.hi", 0x00000, 0x080000, CRC(4d879bb9) SHA1(cd48570cd8c02cebcee3bd4dc198ede45f3d5b72) )

	ROM_LOAD16_BYTE( "95780008.lo", 0x00001, 0x100000, CRC(0c81e70d) SHA1(0520fbc3afb9c3306e89d32ba8f01b1a83a47de5) )
	ROM_LOAD16_BYTE( "95780009.hi", 0x00000, 0x100000, CRC(458ea63b) SHA1(4ac8290d3255d992be851a13fc45ef2080edc5ce) )
	ROM_LOAD16_BYTE( "95780024.lo", 0x00001, 0x100000, CRC(654e4428) SHA1(92f6074461bb58120401b0e1981e48d13cd467dd) )
	ROM_LOAD16_BYTE( "95780025.hi", 0x00000, 0x100000, CRC(7397e2e4) SHA1(d22cc364aeb096ca03cd4642a22bd37fe548e2a1) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008181.bin", 0x0000, 0x100000, CRC(9eb3e51e) SHA1(95e90e9574cba0526e495a8b17150a5081c13df8) )
	ROM_LOAD( "95008182.bin", 0x0000, 0x100000, CRC(5d31955a) SHA1(49dbb4f3efc7e03d1763abb3c6db21c81e961735) )
ROM_END




ROM_START( sc_crcc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95004120.lo", 0x00001, 0x080000, CRC(770a9c0f) SHA1(2d06e32b1d07bc9dc51f39f9ba22c9fe8a678ef3) )
	ROM_LOAD16_BYTE( "95004121.hi", 0x00000, 0x080000, CRC(239f389c) SHA1(75d6f9f500aab5f114f8b86c4ca1f8dce6ea2ca4) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406082.lo", 0x00001, 0x080000, CRC(f3495110) SHA1(3c2242818d02cf34d61c696073855d491bdbee22) )
	ROM_LOAD16_BYTE( "95406083.hi", 0x00000, 0x080000, CRC(284933d6) SHA1(2098319ea687069a4f3080f788655a4c6c2ceaca) )
	ROM_LOAD16_BYTE( "95407082.lo", 0x00001, 0x080000, CRC(97da4079) SHA1(a75a9be748281ff6406e1cf6a28b9271b3410751) )
	ROM_LOAD16_BYTE( "95407083.hi", 0x00000, 0x080000, CRC(15ef1bda) SHA1(77dc2a46cbedcb331bade2d121947b32faace179) )
	ROM_LOAD16_BYTE( "club-classic-cops-and-robbers_dat_ac_f65ss.hi", 0x00000, 0x080800, CRC(17f4f78c) SHA1(fdb7be31f00c75c28468c5754d398d9ded8ee6e3) )
	ROM_LOAD16_BYTE( "club-classic-cops-and-robbers_dat_ac_f65ss.lo", 0x00001, 0x080800, CRC(cec630a8) SHA1(91e95a7b89770e75a1b9272e011a7e4dacaa9eeb) )
	ROM_LOAD16_BYTE( "club-classic-cops-and-robbers_pcl_ac_f65ss.hi", 0x00000, 0x080800, CRC(d7699839) SHA1(0bcea4750c5d97a0f63a49bc497a631eb76a52bc) )
	ROM_LOAD16_BYTE( "club-classic-cops-and-robbers_pcl_ac_f65ss.lo", 0x00001, 0x080800, CRC(603f4bf1) SHA1(1fc78567a9bc266ee612f17929d5abd66f011001) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95000611.mtx", 0x0000, 0x007231, CRC(440c355b) SHA1(884eb0fdc5f6c7c4fac4157d1e5f6bddcb70e148) )
ROM_END




ROM_START( sc_crcp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422370.lo", 0x00001, 0x080000, CRC(0ac0260a) SHA1(3492804331ade1868526acb31b2d1753fa1679fe) )
	ROM_LOAD16_BYTE( "95422371.hi", 0x00000, 0x080000, CRC(1daca8f2) SHA1(679b4c53202d87aaba3795c9d273b3b31b4017f2) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422382.lo", 0x00001, 0x080000, CRC(08ef0c6b) SHA1(466fac875912546a72e43b0b76028c9ee6681ba5) )
	ROM_LOAD16_BYTE( "95422383.hi", 0x00000, 0x080000, CRC(795d8e69) SHA1(cd3bb259a18e2420520b6c3975340b1b3b1727e2) )
	ROM_LOAD16_BYTE( "95422392.lo", 0x00001, 0x080000, CRC(e83c2bea) SHA1(ea4ed543476f637236e03249c493c10693ce27b1) )
	ROM_LOAD16_BYTE( "95422393.hi", 0x00000, 0x080000, CRC(ba88c94a) SHA1(0de684f3ac06899df45ecac9a79f13948f02af70) )
	ROM_LOAD16_BYTE( "95422414.lo", 0x00001, 0x080000, CRC(0704cda8) SHA1(8489648edf16bc3317a56d7468e1aaee8789c606) )
	ROM_LOAD16_BYTE( "95422415.hi", 0x00000, 0x080000, CRC(3d131678) SHA1(e7119d77eb946893bbb1c8453ccd3bb62e3b2359) )
	ROM_LOAD16_BYTE( "95423370.lo", 0x00001, 0x080000, CRC(b2aa9e5c) SHA1(889c02f66321aba8027dbf01084c5efe4d2de23c) )
	ROM_LOAD16_BYTE( "95423371.hi", 0x00000, 0x080000, CRC(d7d31dac) SHA1(f98d5d2d19cac3478082e5e92c96607fb65fb5f2) )
	ROM_LOAD16_BYTE( "95423382.lo", 0x00001, 0x080000, CRC(36237b2b) SHA1(e3acccdaa50124ec0c5c8761a53b30a570ed2548) )
	ROM_LOAD16_BYTE( "95423383.hi", 0x00000, 0x080000, CRC(56523529) SHA1(ec984011837542baa74121377a80c5f409930ec1) )
	ROM_LOAD16_BYTE( "95423414.lo", 0x00001, 0x080000, CRC(c8790664) SHA1(7581764fd4fa25931bba117134d55bbfa7a41d54) )
	ROM_LOAD16_BYTE( "95423415.hi", 0x00000, 0x080000, CRC(f9d6d561) SHA1(9703f23b51def222578179ecb7aed44e2067f79b) )
	ROM_LOAD16_BYTE( "95426012.lo", 0x00001, 0x080000, CRC(f6c3c1c2) SHA1(410ef25804f137363e0f38d9bfc1c53214ad0807) )
	ROM_LOAD16_BYTE( "95426013.hi", 0x00000, 0x080000, CRC(2fe467b8) SHA1(237b97b2a2b7a852f6a7e7d2d7f724f2d7101ae4) )
	ROM_LOAD16_BYTE( "95427012.lo", 0x00001, 0x080000, CRC(ad2e89a5) SHA1(7c5ae7276e45e4c37640315519a02d08ba4c9620) )
	ROM_LOAD16_BYTE( "95427013.hi", 0x00000, 0x080000, CRC(b9f831d6) SHA1(53649f39b75e92253d10f6f924bcced9aebf4ccf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008743.bin", 0x0000, 0x100000, CRC(d44e91bf) SHA1(f42a8c8b0ee5f233cddb4b6084a37e45e2490dd9) )
ROM_END




ROM_START( sc_srgc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408094.lo", 0x00001, 0x080000, CRC(28d67004) SHA1(9fddbd4df6d5a9fbe8dee1036aa218f043eba048) )
	ROM_LOAD16_BYTE( "95408095.hi", 0x00000, 0x080000, CRC(c93eb0ed) SHA1(23a0fa64eb77ff7596dbfd020562801d4e349b90) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408166.lo", 0x00001, 0x080000, CRC(132acdbf) SHA1(0dca7f4088fac7ec1c5c7c3e1d444b18304daf93) )
	ROM_LOAD16_BYTE( "95408167.hi", 0x00000, 0x080000, CRC(4ef7c709) SHA1(9f52993848503252c838db3a9dca89dc7d5e0a5d) )
	ROM_LOAD16_BYTE( "95408344.lo", 0x00001, 0x080000, CRC(f80e83ad) SHA1(fd88057a9311b70273f333d1ae73adf164827756) )
	ROM_LOAD16_BYTE( "95408345.hi", 0x00000, 0x080000, CRC(8ebf7b2b) SHA1(c18acb4d9b42a2168d973ecd564fd44de64317d4) )
	ROM_LOAD16_BYTE( "95408412.lo", 0x00001, 0x080000, CRC(8d95a6f3) SHA1(2a94a2fa2d8c7c7418cdb2aba3051b498c319078) )
	ROM_LOAD16_BYTE( "95408413.hi", 0x00000, 0x080000, CRC(25c5d061) SHA1(f07844a9083443b5a7c0262735dffffc2419ed07) )
	ROM_LOAD16_BYTE( "95408606.lo", 0x00001, 0x080000, CRC(3685ee3f) SHA1(20e0b5a539421e5af23bc8d2f38de8a700fba5ce) )
	ROM_LOAD16_BYTE( "95408607.hi", 0x00000, 0x080000, CRC(87168c0d) SHA1(8ec642723223bcd42be1abb7252300a907d151fe) )
	ROM_LOAD16_BYTE( "95408996.lo", 0x00001, 0x080000, CRC(31a5b982) SHA1(331a6d286fb7e8fad92bebdd5596a332f89cd93d) )
	ROM_LOAD16_BYTE( "95408997.hi", 0x00000, 0x080000, CRC(3145b48e) SHA1(c23093780773271f7a8ce507455089ca2a5b4587) )
	ROM_LOAD16_BYTE( "95408998.lo", 0x00001, 0x080000, CRC(01e2faf1) SHA1(af58be5c0a3dc9e21c6e70b14d4a01d008bad16e) )
	ROM_LOAD16_BYTE( "95408999.hi", 0x00000, 0x080000, CRC(73f72639) SHA1(431f1fbe69e9872afe5582408286248e938a6ac9) )
	ROM_LOAD16_BYTE( "95409094.lo", 0x00001, 0x080000, CRC(6ada392d) SHA1(cd4b619bc179011b98ccab13c64eada522696f70) )
	ROM_LOAD16_BYTE( "95409095.hi", 0x00000, 0x080000, CRC(42d196c8) SHA1(99d769a74ee5375a65b1159e16ac6d7890d78257) )
	ROM_LOAD16_BYTE( "95409166.lo", 0x00001, 0x080000, CRC(3f4433a5) SHA1(38ab986c72da1821303635ca18492d59b7c83e45) )
	ROM_LOAD16_BYTE( "95409167.hi", 0x00000, 0x080000, CRC(e9b01ce0) SHA1(1e213c75a8ee91a6e6631b6b6e446e3db0046de1) )
	ROM_LOAD16_BYTE( "95409344.lo", 0x00001, 0x080000, CRC(eb933941) SHA1(1fbf4460ae182fb899e9f22dc9d12ce359cda656) )
	ROM_LOAD16_BYTE( "95409345.hi", 0x00000, 0x080000, CRC(b4ed84de) SHA1(9c0678093df07490326336714c4da78f0c5789ab) )
	ROM_LOAD16_BYTE( "95409412.lo", 0x00001, 0x080000, CRC(8bd3f08b) SHA1(c6f9159f06574c2c60dc19bc06fba7c818925958) )
	ROM_LOAD16_BYTE( "95409413.hi", 0x00000, 0x080000, CRC(295f4d98) SHA1(55840dd97abb347b6e65212fe59fad6fc53ecf51) )
	ROM_LOAD16_BYTE( "95409606.lo", 0x00001, 0x080000, CRC(63beeb71) SHA1(148a8b3ea70e8394748c90d9f34ff33e0a81f260) )
	ROM_LOAD16_BYTE( "95409607.hi", 0x00000, 0x080000, CRC(da789b85) SHA1(94989e9c833a12b38ed263d54ed9fd3dc6b77162) )
	ROM_LOAD16_BYTE( "95409998.lo", 0x00001, 0x080000, CRC(e1ddccd7) SHA1(8bcd48e99ee204b1ee5c79a4a139d9d93cb5c53c) )
	ROM_LOAD16_BYTE( "95409999.hi", 0x00000, 0x080000, CRC(16c8b2e9) SHA1(4ed92b19ae8e7d4328184881c58a2f62ead38299) )
	ROM_LOAD16_BYTE( "95410822.lo", 0x00001, 0x080000, CRC(245b3579) SHA1(41c125629a88969fc73e5323c1e58dc0e4ee499d) )
	ROM_LOAD16_BYTE( "95410823.hi", 0x00000, 0x080000, CRC(15388140) SHA1(90b20280a8d64aaf98243289e5129735924588cb) )
	ROM_LOAD16_BYTE( "95410902.lo", 0x00001, 0x080000, CRC(fb3e58b9) SHA1(a5cbef4cf1c63df207f47685dce369a9f0bb502c) )
	ROM_LOAD16_BYTE( "95410903.hi", 0x00000, 0x080000, CRC(4cf0b6e9) SHA1(25f49509781dda48f45811ac401052c1984929e1) )
	ROM_LOAD16_BYTE( "95411822.lo", 0x00001, 0x080000, CRC(ce575b2e) SHA1(9dc54010b7d4661187a614b8957d4795a94d27ac) )
	ROM_LOAD16_BYTE( "95411823.hi", 0x00000, 0x080000, CRC(2f32da9d) SHA1(d1a7e32c3f4b91d8b1833f10ca42ecd89ff0da05) )
	ROM_LOAD16_BYTE( "95411902.lo", 0x00001, 0x080000, CRC(c798850b) SHA1(3319e2cd8760345777320a39db7f79a58085aeab) )
	ROM_LOAD16_BYTE( "95411903.hi", 0x00000, 0x080000, CRC(1741fc85) SHA1(280d3da25580dbb1ad128ee2dc4e6a97a28a66f3) )
	ROM_LOAD16_BYTE( "95412272.lo", 0x00001, 0x080000, CRC(e59b16fc) SHA1(7ae1549e0595654449af641a8b013ef5cd740de6) )
	ROM_LOAD16_BYTE( "95412273.hi", 0x00000, 0x080000, CRC(08362450) SHA1(79feac74582f3e5485546fc9adf76806bc66d295) )
	ROM_LOAD16_BYTE( "95412444.lo", 0x00001, 0x080000, CRC(d8e39b05) SHA1(a7f2e55e47ee0d1b3f0ca005acb32b26f4d1768d) )
	ROM_LOAD16_BYTE( "95412445.hi", 0x00000, 0x080000, CRC(98f8925c) SHA1(e6ae91e267ca886643d06b686cdddb9f7d1e1574) )
	ROM_LOAD16_BYTE( "95412968.lo", 0x00001, 0x080000, CRC(4313b15b) SHA1(b063b96a3ee4e9dfa720fe978aa30d60cd4f610b) )
	ROM_LOAD16_BYTE( "95412969.hi", 0x00000, 0x080000, CRC(b412e203) SHA1(4ecf6892322882ea0453b929ade5e6e7c3ea9689) )
	ROM_LOAD16_BYTE( "95413272.lo", 0x00001, 0x080000, CRC(3836dc82) SHA1(dda0e02e2c216b54dd0ca417b2993387537293be) )
	ROM_LOAD16_BYTE( "95413273.hi", 0x00000, 0x080000, CRC(7364acbb) SHA1(1e18d9f10dcb022e132588e00ec1c4d18a99f346) )
	ROM_LOAD16_BYTE( "95413444.lo", 0x00001, 0x080000, CRC(44300a32) SHA1(4d24ce3efcb73048de6d62d730d6f596a9db1211) )
	ROM_LOAD16_BYTE( "95413445.hi", 0x00000, 0x080000, CRC(d03f70de) SHA1(109bf51f2fb6a50f3f9ab0df856bb57a48914fca) )
	ROM_LOAD16_BYTE( "95413968.lo", 0x00001, 0x080000, CRC(5d756e67) SHA1(b69e47db4d71c32a7f5a7131652c206b7afd8cd7) )
	ROM_LOAD16_BYTE( "95413969.hi", 0x00000, 0x080000, CRC(45a28f6d) SHA1(1c774d2eea314c663168e8bcbc3ed48c516bab21) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008323.bin", 0x0000, 0x100000, CRC(461dd238) SHA1(cab717b285fb217bf47ebe07bd6e7737cf0517c9) )
ROM_END




ROM_START( sc_crsc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422118.lo", 0x00001, 0x080000, CRC(61ab2086) SHA1(717c1b3e96f9a2f413e6d2b935c976bff730578b) )
	ROM_LOAD16_BYTE( "95422119.hi", 0x00000, 0x080000, CRC(4a6c626c) SHA1(6b8e0d1398d1ecfd26709a68641809fc95f4de0d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422152.lo", 0x00001, 0x080000, CRC(dd719a45) SHA1(361295cbb82cac4cfd2e7d24cfe7a786753129b7) )
	ROM_LOAD16_BYTE( "95422153.hi", 0x00000, 0x080000, CRC(eba64f98) SHA1(54437047b4feee53119e5fd8239ec63c52fe9417) )
	ROM_LOAD16_BYTE( "95422316.lo", 0x00001, 0x080000, CRC(3e71d049) SHA1(90a1b015803e933d94892e244304a430b5e7943e) )
	ROM_LOAD16_BYTE( "95422317.hi", 0x00000, 0x080000, CRC(6723b3df) SHA1(95868c8864624acfc4dc9b68b0417318552b97b7) )
	ROM_LOAD16_BYTE( "95422318.lo", 0x00001, 0x080000, CRC(ccc6070f) SHA1(186f1741c89bc62bff0654bfc0875cdfde873a43) )
	ROM_LOAD16_BYTE( "95422319.hi", 0x00000, 0x080000, CRC(6a21ffcf) SHA1(6977d4c09d019223b6cb3dedca1246ef50069958) )
	ROM_LOAD16_BYTE( "95422510.lo", 0x00001, 0x080000, CRC(08c19d5c) SHA1(f6ef98e305e78ee34a5f2475ebcc7c667d6dd22b) )
	ROM_LOAD16_BYTE( "95422511.hi", 0x00000, 0x080000, CRC(9bccff45) SHA1(826285c960f4424590abe3dffb8fbf98ec0035f1) )
	ROM_LOAD16_BYTE( "95422840.lo", 0x00001, 0x080000, CRC(68ecba68) SHA1(376005c2c75a6e02c4a34ab5fe9697fc2f3d1f50) )
	ROM_LOAD16_BYTE( "95422841.hi", 0x00000, 0x080000, CRC(c36b5e60) SHA1(380b619b7a96a9cc0e75ce14621fa5c457186786) )
	ROM_LOAD16_BYTE( "95423118.lo", 0x00001, 0x080000, CRC(dfbd0942) SHA1(5c7294d61b4f57d41dd9d4f8e0a0764fb4589160) )
	ROM_LOAD16_BYTE( "95423119.hi", 0x00000, 0x080000, CRC(19eb125a) SHA1(706aa0fb1de731322f3ffb04e09584bf3305fe4d) )
	ROM_LOAD16_BYTE( "95423152.lo", 0x00001, 0x080000, CRC(51ec4234) SHA1(d72adeb3ff8e597425787d5196175cddc04cac9b) )
	ROM_LOAD16_BYTE( "95423153.hi", 0x00000, 0x080000, CRC(3d97a39a) SHA1(dc8e9257b28380efd478fc2e80c5cfa2d8554683) )
	ROM_LOAD16_BYTE( "95423316.lo", 0x00001, 0x080000, CRC(131cca2e) SHA1(4870a14efff4378e8b406b1c9a0602ab80ed2349) )
	ROM_LOAD16_BYTE( "95423317.hi", 0x00000, 0x080000, CRC(13827a58) SHA1(c774f1df710fb88db8b86d74d265ffeb17c142d2) )
	ROM_LOAD16_BYTE( "95423318.lo", 0x00001, 0x080000, CRC(dc508639) SHA1(ac87d7c92e043f711ed7562e041aa362955df118) )
	ROM_LOAD16_BYTE( "95423319.hi", 0x00000, 0x080000, CRC(ef41455f) SHA1(1b7b7debd03afc18701b8fa0e5bd6f00e6fbcc79) )
	ROM_LOAD16_BYTE( "95423510.lo", 0x00001, 0x080000, CRC(afd1761c) SHA1(ce9da48e350c9965a6a1b79123e116c72684e37f) )
	ROM_LOAD16_BYTE( "95423511.hi", 0x00000, 0x080000, CRC(d6c85c03) SHA1(072e712af5409a91af33260218c80b194a45b801) )
	ROM_LOAD16_BYTE( "95423840.lo", 0x00001, 0x080000, CRC(b6c225d8) SHA1(f9d3cc542c7e7127f74cc58b7b09ba99c0132525) )
	ROM_LOAD16_BYTE( "95423841.hi", 0x00000, 0x080000, CRC(0499c31a) SHA1(4c7d2bb3c2f4268070ca681833cdbbe51162bfc6) )
	ROM_LOAD16_BYTE( "95426114.lo", 0x00001, 0x080000, CRC(af70f5b8) SHA1(82ce9daf626d990b8ca550be52a1dc3e6109cf5e) )
	ROM_LOAD16_BYTE( "95426115.hi", 0x00000, 0x080000, CRC(37b3f49f) SHA1(8f7f72bb7017052249ca309165d923f1c2ccd9e0) )
	ROM_LOAD16_BYTE( "95426116.lo", 0x00001, 0x080000, CRC(cd991b6f) SHA1(15da97f4f1225afb5b731a4b7570141b4451d989) )
	ROM_LOAD16_BYTE( "95426117.hi", 0x00000, 0x080000, CRC(01030af9) SHA1(d77391942f4b28289888a409c7e81bd36609b9de) )
	ROM_LOAD16_BYTE( "95426164.lo", 0x00001, 0x080000, CRC(31dfd609) SHA1(542bd37903d36318e04b2749e938aa40f530d703) )
	ROM_LOAD16_BYTE( "95426165.hi", 0x00000, 0x080000, CRC(676f0391) SHA1(c5cabdd3696a76d72566f2b56b57f1244d665ca9) )
	ROM_LOAD16_BYTE( "95426292.lo", 0x00001, 0x080000, CRC(101c0006) SHA1(2c92086a791078a6a3dae40f4029e18d092bd8f9) )
	ROM_LOAD16_BYTE( "95426293.hi", 0x00000, 0x080000, CRC(fbcf7149) SHA1(0e34753cd75124af1305099d5abd57e03d2ba6a8) )
	ROM_LOAD16_BYTE( "95426336.lo", 0x00001, 0x080000, CRC(ef76190e) SHA1(6167c6b7e659e7c920933a4979ed6590ce44648e) )
	ROM_LOAD16_BYTE( "95426337.hi", 0x00000, 0x080000, CRC(28114c89) SHA1(674f92c112c0f2a7527e697a032be09fb0acdb6b) )
	ROM_LOAD16_BYTE( "95427114.lo", 0x00001, 0x080000, CRC(ac0beaa0) SHA1(b0aa5af084785ccd64132d3c8a9a438d04224400) )
	ROM_LOAD16_BYTE( "95427115.hi", 0x00000, 0x080000, CRC(3177e176) SHA1(0195d3a81f604e74f8f8033f8a411ee535fb93ac) )
	ROM_LOAD16_BYTE( "95427116.lo", 0x00001, 0x080000, CRC(c73e8d02) SHA1(b6b6d47db75714a063686a91c0a30869719be714) )
	ROM_LOAD16_BYTE( "95427117.hi", 0x00000, 0x080000, CRC(7ba928f6) SHA1(1587767b546288c5f6a0fcebc6b04b008c35d35b) )
	ROM_LOAD16_BYTE( "95427164.lo", 0x00001, 0x080000, CRC(6c2c5331) SHA1(6dc17f34f2eec2d4cf3287b9062e6eb2e0f7156d) )
	ROM_LOAD16_BYTE( "95427165.hi", 0x00000, 0x080000, CRC(1f37b5dc) SHA1(cc3a3e58317930bfcbf563958692c1d23a0dcf65) )
	ROM_LOAD16_BYTE( "95427292.lo", 0x00001, 0x080000, CRC(8e01c277) SHA1(4ef88a3e142083810d1b25da79f892a2be9fa42d) )
	ROM_LOAD16_BYTE( "95427293.hi", 0x00000, 0x080000, CRC(14450bab) SHA1(88888bb85edca3fc26607e63bd57dcf2ce8183a7) )
	ROM_LOAD16_BYTE( "95427336.lo", 0x00001, 0x080000, CRC(17fae461) SHA1(7e8c50ca40aa058bd823cecb64004da0885b2b36) )
	ROM_LOAD16_BYTE( "95427337.hi", 0x00000, 0x080000, CRC(392e4bea) SHA1(15fa1852989aefd45771737cc8c5d62c06354b1d) )
	ROM_LOAD16_BYTE( "p3005p01.hi", 0x00000, 0x080000, CRC(fee3d425) SHA1(c8c7773c96567cad9c553f4e35f39b9a26569f4b) )
	ROM_LOAD16_BYTE( "p3005p01.lo", 0x00001, 0x080000, CRC(e3328108) SHA1(61b17d67abf793f05821afd1cb1032e55b2382e5) )
	ROM_LOAD16_BYTE( "p3005p41.hi", 0x00000, 0x080000, CRC(2ce1f7b7) SHA1(506675ee2d5859c6c29152bbb7fdda83b2b3b90a) )
	ROM_LOAD16_BYTE( "p3005p41.lo", 0x00001, 0x080000, CRC(91464b75) SHA1(8d663507cedc18deec52c11e15bfaf49e75a3560) )
	ROM_LOAD16_BYTE( "p3005p42.hi", 0x00000, 0x080000, CRC(cfc76b53) SHA1(6f380aa861498091a3a7060b399a505b3d6e3efc) )
	ROM_LOAD16_BYTE( "p3005p42.lo", 0x00001, 0x080000, CRC(7a860115) SHA1(ace6181f9ae468434b32999054b0e5b86d40a5dd) )
	ROM_LOAD16_BYTE( "p3005p43.hi", 0x00000, 0x080000, CRC(fcdb8416) SHA1(4afce0424b7d821b7d71872e5e9c535b5d06bcd3) )
	ROM_LOAD16_BYTE( "p3005p43.lo", 0x00001, 0x080000, CRC(bdc918ad) SHA1(b45f8652161b5feef7cf1990e6923c67bc6a41bc) )
	ROM_LOAD16_BYTE( "p3005s01.hi", 0x00000, 0x080000, CRC(d2ac11c0) SHA1(948eb7d43d3109d099b4d89e16efdc947815ee47) )
	ROM_LOAD16_BYTE( "p3005s01.lo", 0x00001, 0x080000, CRC(ece251d2) SHA1(ed6f8e7ba379cefbff093b5fffb6b0764f284a9e) )
	ROM_LOAD16_BYTE( "p3005s41.hi", 0x00000, 0x080000, CRC(e036f445) SHA1(42781749d714e81a4ae48bbffbfe14c58d35906b) )
	ROM_LOAD16_BYTE( "p3005s41.lo", 0x00001, 0x080000, CRC(adde9f0c) SHA1(3292d987b179b4ea72aa3c13a3dca4ad74e038d9) )
	ROM_LOAD16_BYTE( "p3005s42.hi", 0x00000, 0x080000, CRC(eb3907d5) SHA1(3f6922c5e3938bb091194d6917bf896a66e73986) )
	ROM_LOAD16_BYTE( "p3005s42.lo", 0x00001, 0x080000, CRC(7dce5601) SHA1(f3dc52dafb104656014c743ba9ecf8e5917ca0a3) )
	ROM_LOAD16_BYTE( "p3005s43.hi", 0x00000, 0x080000, CRC(a29f5fe9) SHA1(78bb8e1699640d885634b53f2952ea77329da40b) )
	ROM_LOAD16_BYTE( "p3005s43.lo", 0x00001, 0x080000, CRC(93ee0022) SHA1(ee58ad5a04e1ecd89b5cc3236e986135fa422f12) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008681.bin", 0x0000, 0x100000, CRC(7a459110) SHA1(51f0a51af485a0f4e447ee0c22f488a924e45117) )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211581.bin", 0x0000, 0x1000000, CRC(4d451612) SHA1(ec892276b1bfa3d9e9d9d39a722e931c9ab55ec8) )
	ROM_LOAD( "39211582.bin", 0x0000, 0x1000000, CRC(d208a456) SHA1(f53b77299cb85c5b0564b907b2ceb66de8206627) )
	ROM_LOAD( "39211596.bin", 0x0000, 0x1000000, CRC(9814b1b7) SHA1(e6dc1a516f7f73acb1a78502c4baa6fe9589801d) )
	ROM_LOAD( "39211616.bin", 0x0000, 0x1000000, CRC(181d4298) SHA1(c2b3f9123782d6315bb84be0cd51c3dbbc0da728) )
	ROM_LOAD( "39212581.bin", 0x0000, 0x1000000, CRC(8996b649) SHA1(e10b82bc7e1fcebe9742755e3a33c9abe75ba1fa) )
	ROM_LOAD( "39212582.bin", 0x0000, 0x1000000, CRC(599f5d55) SHA1(c4941d754b87ddbd58b19dd4edec2af3a5ddd821) )
	ROM_LOAD( "39212596.bin", 0x0000, 0x1000000, CRC(1152f65c) SHA1(1406667c41e0ed8c07b65df95eb34ca6fe5a2708) )
	ROM_LOAD( "39212606.bin", 0x0000, 0x1000000, CRC(7cfdeb40) SHA1(76e3583dc60464f6b8d503eb0c32d0bf81bc70d6) )
	ROM_LOAD( "39212616.bin", 0x0000, 0x1000000, CRC(d091476a) SHA1(db4f2f1a0bbd22f554265ce5330666f3b1a44862) )
ROM_END




ROM_START( sc_coro )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416526.lo", 0x00001, 0x080000, CRC(f3fedcd0) SHA1(6e76e41dcb2ec9a03947631b439e9dfb3b4959a1) )
	ROM_LOAD16_BYTE( "95416527.hi", 0x00000, 0x080000, CRC(254c9c7b) SHA1(7bcc8ad1e7755362b6873ad0ce84bf0ce8a64a09) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416528.lo", 0x00001, 0x080000, CRC(5fb06486) SHA1(8793d3a5e65aa9326c2ae71361045337cc9491c7) )
	ROM_LOAD16_BYTE( "95416529.hi", 0x00000, 0x080000, CRC(30d24daa) SHA1(912d8ebf13105a13b7aa505abef3a17d0327cd28) )
	ROM_LOAD16_BYTE( "95416530.lo", 0x00001, 0x080000, CRC(2e82f143) SHA1(074db310de493b315f5e0c7cac05103ed919034c) )
	ROM_LOAD16_BYTE( "95416531.hi", 0x00000, 0x080000, CRC(c03c5948) SHA1(aad67f0b14985de08942f43eef23e3a4fb8aeb06) )
	ROM_LOAD16_BYTE( "95416656.lo", 0x00001, 0x080000, CRC(ae8afdc5) SHA1(cec76e7c58533b573b06538558f3705a73793046) )
	ROM_LOAD16_BYTE( "95416657.hi", 0x00000, 0x080000, CRC(4a99a20a) SHA1(5c1aa9a114f0ff13ef4323ab7b4baf882b1c43da) )
	ROM_LOAD16_BYTE( "95416676.lo", 0x00001, 0x080000, CRC(93188ca9) SHA1(09298ed5c43329d539e96e44f01451eb6f9de62f) )
	ROM_LOAD16_BYTE( "95416677.hi", 0x00000, 0x080000, CRC(a1c79ca4) SHA1(dc0dab3bed7dff7746bf643748376fab145c62ff) )
	ROM_LOAD16_BYTE( "95416730.lo", 0x00001, 0x080000, CRC(526fffc9) SHA1(17daa8e30029f831835dcece9f5643669ce724f5) )
	ROM_LOAD16_BYTE( "95416731.hi", 0x00000, 0x080000, CRC(a6a3953f) SHA1(7405c27c31a2383330f59b4ec408ddcbe4d070ef) )
	ROM_LOAD16_BYTE( "95416738.lo", 0x00001, 0x080000, CRC(f6ba008f) SHA1(4acb808ea192354b1c7610f8e144a9e3e9da6699) )
	ROM_LOAD16_BYTE( "95416739.hi", 0x00000, 0x080000, CRC(ef9458d5) SHA1(816b4d02b657e9804b225fd13f4718f061d381a9) )
	ROM_LOAD16_BYTE( "95416742.lo", 0x00001, 0x080000, CRC(5e3c1a6a) SHA1(8d4c83be4f9192df01aa3b04a1a1ce17fe48a2a7) )
	ROM_LOAD16_BYTE( "95416743.hi", 0x00000, 0x080000, CRC(b9020b30) SHA1(3e27080ef2e341b4ce37e803f54ade398a4eaca6) )
	ROM_LOAD16_BYTE( "95416752.lo", 0x00001, 0x080000, CRC(b50fae97) SHA1(9f3afd1c6dfff818155ccaeaf18889224cd6d625) )
	ROM_LOAD16_BYTE( "95416753.hi", 0x00000, 0x080000, CRC(5a88a8dc) SHA1(4f32fb7744af6f05bc9b6ba82f4ca5ccf6c4fa12) )
	ROM_LOAD16_BYTE( "95416758.lo", 0x00001, 0x080000, CRC(6c373887) SHA1(637a2013de57d269afb13648799a02ba2c4a8082) )
	ROM_LOAD16_BYTE( "95416759.hi", 0x00000, 0x080000, CRC(724b9d8a) SHA1(8310626686aa8aa61874812a8b9e8ab19445d428) )
	ROM_LOAD16_BYTE( "95416760.lo", 0x00001, 0x080000, CRC(66c192ae) SHA1(6da0ca25c6f7a1fd434d85ec905e65bbd9f427ce) )
	ROM_LOAD16_BYTE( "95416761.hi", 0x00000, 0x080000, CRC(bdcb5413) SHA1(9f481f3bb39497ae780f8c33f6eba0d36277b705) )
	ROM_LOAD16_BYTE( "95416810.lo", 0x00001, 0x080000, CRC(4c6f6ed6) SHA1(a3642a0ab1ce196ff9495c2a64dcb3c0ada90ee6) )
	ROM_LOAD16_BYTE( "95416811.hi", 0x00000, 0x080000, CRC(748ebac9) SHA1(a2b7447afe0e0e27a2e895ba17623d9d550b90af) )
	ROM_LOAD16_BYTE( "95416812.lo", 0x00001, 0x080000, CRC(eb2d17a6) SHA1(5c35d558213f0e41e401721ec23a8e1fd816ba85) )
	ROM_LOAD16_BYTE( "95416813.hi", 0x00000, 0x080000, CRC(f942c2ad) SHA1(26672aa648cd37af4565da2df07e52ca1cddae2b) )
	ROM_LOAD16_BYTE( "95416814.lo", 0x00001, 0x080000, CRC(c6d9f9f5) SHA1(13c9d0e59f3134d1334d04275991368f14befd4c) )
	ROM_LOAD16_BYTE( "95416815.hi", 0x00000, 0x080000, CRC(1f6f83cc) SHA1(6bd058c650c515d6a4611cbfba15e7a4e4f0083f) )
	ROM_LOAD16_BYTE( "95416816.lo", 0x00001, 0x080000, CRC(c124af64) SHA1(94b010a771bf5927547a271ef8e0adc9c22c7a30) )
	ROM_LOAD16_BYTE( "95416817.hi", 0x00000, 0x080000, CRC(862d2f44) SHA1(f5cf99aa8dc6bd28cf658e4f91bdd30b8987d2c0) )
	ROM_LOAD16_BYTE( "95416838.lo", 0x00001, 0x080000, CRC(0964030d) SHA1(451f681e85223d9bf25e1a3803a178948f3e2cc1) )
	ROM_LOAD16_BYTE( "95416839.hi", 0x00000, 0x080000, CRC(75e641fb) SHA1(655e1694cec922d99b013d52ea008e6f0c87ad4c) )
	ROM_LOAD16_BYTE( "95416904.lo", 0x00001, 0x080000, CRC(af23d81c) SHA1(f2854e93a2992671dcfefaa8b980d95b1ec0a483) )
	ROM_LOAD16_BYTE( "95416905.hi", 0x00000, 0x080000, CRC(de4cf602) SHA1(d71cb4f2746d8c0fa2eeb577296ff8b7b08bcd79) )
	ROM_LOAD16_BYTE( "95416936.lo", 0x00001, 0x080000, CRC(e373dd40) SHA1(c4013c5257188defd2aee5d6e4735ad15bb2fe3e) )
	ROM_LOAD16_BYTE( "95416937.hi", 0x00000, 0x080000, CRC(7a35f640) SHA1(5a02a5a1757af08432051f4d0e3a50720e86961d) )
	ROM_LOAD16_BYTE( "95416938.lo", 0x00001, 0x080000, CRC(0d4c3a8b) SHA1(12feb437793964f91d7f7429f6ce4127452f5866) )
	ROM_LOAD16_BYTE( "95416939.hi", 0x00000, 0x080000, CRC(2c5c2f2f) SHA1(454d7ffc9a9f55a5395e1d863800897f2e2aaa6e) )
	ROM_LOAD16_BYTE( "95417526.lo", 0x00001, 0x080000, CRC(269dd109) SHA1(07b2850cdc31900c1201f06cdbd84094a6703026) )
	ROM_LOAD16_BYTE( "95417527.hi", 0x00000, 0x080000, CRC(9c854630) SHA1(b4960dca60d15f1622deb2b4cc8f62a8ab726f16) )
	ROM_LOAD16_BYTE( "95417528.lo", 0x00001, 0x080000, CRC(5efaa5fe) SHA1(87b8b02b658d9f54f914b74c43369477c98ab862) )
	ROM_LOAD16_BYTE( "95417529.hi", 0x00000, 0x080000, CRC(702b64d4) SHA1(54d2ce728ba08aad1ed2b08e9d3045aadc84f411) )
	ROM_LOAD16_BYTE( "95417530.lo", 0x00001, 0x080000, CRC(5abd5fcf) SHA1(3be0ee04959df05ab7106b3a8016115e5099ad2a) )
	ROM_LOAD16_BYTE( "95417531.hi", 0x00000, 0x080000, CRC(2a686edc) SHA1(0c2ac9d668ae234dd3c2653e23cec70286a12057) )
	ROM_LOAD16_BYTE( "95417676.lo", 0x00001, 0x080000, CRC(787c6632) SHA1(6a0a340747e11f6b3616e232c6ee9dba963d9692) )
	ROM_LOAD16_BYTE( "95417677.hi", 0x00000, 0x080000, CRC(6a1ec675) SHA1(e043b12f08ad8e9894cc5ee715a95571a3866b26) )
	ROM_LOAD16_BYTE( "95417730.lo", 0x00001, 0x080000, CRC(18b31ec3) SHA1(6137bef65eee9d0c7fced36ebf78bd0f73b79847) )
	ROM_LOAD16_BYTE( "95417731.hi", 0x00000, 0x080000, CRC(8715a2a4) SHA1(a3bdcdccc72a2e0ff5a0fab374b0de8fabf03c4e) )
	ROM_LOAD16_BYTE( "95417738.lo", 0x00001, 0x080000, CRC(c549318e) SHA1(5dec93f36a78aca538677c70d8ba5dab6959cd0f) )
	ROM_LOAD16_BYTE( "95417739.hi", 0x00000, 0x080000, CRC(05ab362d) SHA1(af3a39a05960d97d66f63eb8e671a38d14747e60) )
	ROM_LOAD16_BYTE( "95417752.lo", 0x00001, 0x080000, CRC(0860b91a) SHA1(3cb58778418fbffd2fd43d70fcbd4854dc595aa7) )
	ROM_LOAD16_BYTE( "95417753.hi", 0x00000, 0x080000, CRC(0344ba50) SHA1(c8210b78fc2427db3620c5fe5f26b8df28f7e16d) )
	ROM_LOAD16_BYTE( "95417758.lo", 0x00001, 0x080000, CRC(08f4c168) SHA1(3a03d712d8562022a506f81783d8ad7a5b8c55e2) )
	ROM_LOAD16_BYTE( "95417759.hi", 0x00000, 0x080000, CRC(b8c6280b) SHA1(e38227eca891af521e21e936df638e6e64edc0e1) )
	ROM_LOAD16_BYTE( "95417760.lo", 0x00001, 0x080000, CRC(be25eba1) SHA1(9173498cecafd6358e085197dc078a4844b276b4) )
	ROM_LOAD16_BYTE( "95417761.hi", 0x00000, 0x080000, CRC(515d9a6a) SHA1(4bd863d4314a925f63b72a97104c8e44d82d6414) )
	ROM_LOAD16_BYTE( "95417810.lo", 0x00001, 0x080000, CRC(18505dc2) SHA1(32ad173c0499763e0713a7b1ba5a006e3ddc3404) )
	ROM_LOAD16_BYTE( "95417811.hi", 0x00000, 0x080000, CRC(1af74a2a) SHA1(3a8662ca3f23df59475adb8110be7bee034a56e0) )
	ROM_LOAD16_BYTE( "95417812.lo", 0x00001, 0x080000, CRC(66b63a1e) SHA1(10f87531b2e6483340cd2ac08b9987279c4af491) )
	ROM_LOAD16_BYTE( "95417813.hi", 0x00000, 0x080000, CRC(8f704da7) SHA1(cac038ba2b9029af44ca3cdebe19ef3890a60147) )
	ROM_LOAD16_BYTE( "95417814.lo", 0x00001, 0x080000, CRC(132c0444) SHA1(15aab0ed9a72799c1004c91444e655d4df528c2d) )
	ROM_LOAD16_BYTE( "95417815.hi", 0x00000, 0x080000, CRC(8cf8d353) SHA1(a5da98401a0b06537c1656d09a3fce27b56d5870) )
	ROM_LOAD16_BYTE( "95417816.lo", 0x00001, 0x080000, CRC(230cefc3) SHA1(7b2c0c5617243a58fe3f53647f062aa0f573c935) )
	ROM_LOAD16_BYTE( "95417817.hi", 0x00000, 0x080000, CRC(18cdfe08) SHA1(7ae92e7429d0cd0c197a1fead8cce222cf00b83a) )
	ROM_LOAD16_BYTE( "95417838.lo", 0x00001, 0x080000, CRC(1c90823a) SHA1(7787c98aa784f3cfc9443c1ef9ab22dc814b9a80) )
	ROM_LOAD16_BYTE( "95417839.hi", 0x00000, 0x080000, CRC(70d722e7) SHA1(bafeb7828b88a8b25daa9cb6bb4d540f89e71f6f) )
	ROM_LOAD16_BYTE( "95417936.lo", 0x00001, 0x080000, CRC(d3d45e47) SHA1(3dede274c492941c8ca7e0898e262d2b99ec912b) )
	ROM_LOAD16_BYTE( "95417937.hi", 0x00000, 0x080000, CRC(4b0bef9d) SHA1(b9f388ad48b8697ac1c362ddab2b6e314c46e784) )
	ROM_LOAD16_BYTE( "95417938.lo", 0x00001, 0x080000, CRC(26e3bdad) SHA1(2715535a0f0c2f876c3c1d3d7840d50bf1cb7248) )
	ROM_LOAD16_BYTE( "95417939.hi", 0x00000, 0x080000, CRC(417671ed) SHA1(571f57ad2438257cbe517fc618fa12b2de1c808c) )
	ROM_LOAD16_BYTE( "95420088.lo", 0x00001, 0x080000, CRC(652cd122) SHA1(b0d30d6cfc400acbca7b3bafffd899bb82d0b45d) )
	ROM_LOAD16_BYTE( "95420089.hi", 0x00000, 0x080000, CRC(46020943) SHA1(1cd98dfea87128ecdbaaa014c5136c86ee26980c) )
	ROM_LOAD16_BYTE( "95420090.lo", 0x00001, 0x080000, CRC(235f14eb) SHA1(677555098be99e52b26fcad96aec69fe25db4f22) )
	ROM_LOAD16_BYTE( "95420091.hi", 0x00000, 0x080000, CRC(0818ca67) SHA1(27df81ecb455a9602029efe8b106cac5cd0680c2) )
	ROM_LOAD16_BYTE( "95420092.lo", 0x00001, 0x080000, CRC(3cd22ea3) SHA1(51e735c7cd81a2a9c1ea0c94a2d9141fe4158f37) )
	ROM_LOAD16_BYTE( "95420093.hi", 0x00000, 0x080000, CRC(52849e29) SHA1(46d2d119949d747bb0f1fdaa572371cdb227d799) )
	ROM_LOAD16_BYTE( "95420196.lo", 0x00001, 0x080000, CRC(2d71befb) SHA1(a2f83f4a03d8a16d50a7036daca00ffd4e788b93) )
	ROM_LOAD16_BYTE( "95420197.hi", 0x00000, 0x080000, CRC(68fe0186) SHA1(e3b429f3511adb2b75db42193ba67b39dcc30210) )
	ROM_LOAD16_BYTE( "95421088.lo", 0x00001, 0x080000, CRC(28594ba6) SHA1(6d7edd190b16e6097ceee416af06ea285bf15ae8) )
	ROM_LOAD16_BYTE( "95421089.hi", 0x00000, 0x080000, CRC(c39b593e) SHA1(3af0074084576fba592676c897089dfce9838e37) )
	ROM_LOAD16_BYTE( "95421090.lo", 0x00001, 0x080000, CRC(9ac45c6b) SHA1(2c8bd2f8490d08b8cff2196fa38cb6e700779da9) )
	ROM_LOAD16_BYTE( "95421091.hi", 0x00000, 0x080000, CRC(0bf1289a) SHA1(1343b01dd9f1b543c09b1669e8d157bb6f9d390c) )
	ROM_LOAD16_BYTE( "95421092.lo", 0x00001, 0x080000, CRC(b21f91f0) SHA1(1583561132f23b3b10752e51a7401cd06003e784) )
	ROM_LOAD16_BYTE( "95421093.hi", 0x00000, 0x080000, CRC(09498b6c) SHA1(c275da993b004855ea691c54ad7b416f2381a2cc) )
	ROM_LOAD16_BYTE( "95421196.lo", 0x00001, 0x080000, CRC(41474b13) SHA1(d6508367555aa2bb8213d6cb1855299356d6233b) )
	ROM_LOAD16_BYTE( "95421197.hi", 0x00000, 0x080000, CRC(8b175da8) SHA1(ab7503a44edbbe84113bf8411d9c8742cedf8d27) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008939.bin", 0x0000, 0x100000, CRC(02c9a21d) SHA1(7f27a8d706a7d66feafc5faab23ee28ebfa02b53) )
	ROM_LOAD( "95008940.bin", 0x0000, 0x05fdb4, CRC(09c8a19a) SHA1(21a58f8183c29d61c0132c2fc7339e459521a16e) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890365.bin", 0x0000, 0x5000, CRC(12f90bc7) SHA1(09cdfddfa7fb430eccd87d677673f203120bef51) )
	ROM_LOAD( "95890366.bin", 0x0000, 0x5000, CRC(676f4ff3) SHA1(c6a3c2b01b79e9abaa249b548fb59584c63fc682) )
	ROM_LOAD( "95890367.bin", 0x0000, 0x5000, CRC(f9d583af) SHA1(f22e3ed7c4d954a98cec9dc077113761fdcef858) )
	ROM_LOAD( "95890377.bin", 0x0000, 0x5000, CRC(edbf2523) SHA1(8165c2c2f12fd85f706aed31bc3cbd51648440de) )
	ROM_LOAD( "95890378.bin", 0x0000, 0x5000, CRC(f169d59f) SHA1(fa8116f43c25de7af05f1cf8a379a24cce489f21) )
	ROM_LOAD( "95890379.bin", 0x0000, 0x5000, CRC(3233f70f) SHA1(df485c4df31872921c3d97973a7b3e7d4a58446d) )
ROM_END




ROM_START( sc_corcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424078.lo", 0x00001, 0x080000, CRC(73cd70c7) SHA1(d3dea0af57fa949a894e677a51ef490049391a27) )
	ROM_LOAD16_BYTE( "95424079.hi", 0x00000, 0x080000, CRC(725a5f0a) SHA1(7dafea4178e61256d5b874d3828c839fabff1b11) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425078.lo", 0x00001, 0x080000, CRC(9cd82a9c) SHA1(995bd60fa1652c6d4f4027ec57e9ed0d6c76766c) )
	ROM_LOAD16_BYTE( "95425079.hi", 0x00000, 0x080000, CRC(ec7cdcf1) SHA1(7494cf259b767f30c4f39f5d05cbf48558599bee) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008867.bin", 0x0000, 0x100000, CRC(b11779d2) SHA1(720d30445232baa18e613259bded1a6827777de6) )
	ROM_LOAD( "95008868.bin", 0x0000, 0x05fdb4, CRC(424b08e5) SHA1(fc0fe01516c0c6bb20adcf2bf8b1263ff59657e8) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890770.bin", 0x0000, 0x5000, CRC(551ab279) SHA1(39e4c16f3cc708d84762ba5b80c720cbbc123f0d) )
ROM_END




ROM_START( sc_cyc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404970.lo", 0x00001, 0x080000, CRC(663e3409) SHA1(df47da13099f58a8a654904f8433f9236258474e) )
	ROM_LOAD16_BYTE( "95404971.hi", 0x00000, 0x080000, CRC(2ba61311) SHA1(df353431d49822d935645eaf7625d240b5c47edc) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405970.lo", 0x00001, 0x080000, CRC(eab44b04) SHA1(b3f6c43b54b320b5fb8476f79f4dfd1f41693509) )
	ROM_LOAD16_BYTE( "95405971.hi", 0x00000, 0x080000, CRC(a95e3238) SHA1(af32fedb27507b44f0bca97c8c7935a59ba1decf) )
	ROM_LOAD16_BYTE( "95406828.lo", 0x00001, 0x080000, CRC(2eb727fc) SHA1(1228168279a902adb6c4ad9f1b89a9c9566d2cac) )
	ROM_LOAD16_BYTE( "95406829.hi", 0x00000, 0x080000, CRC(455751cb) SHA1(22a7787e97ad2873e0b8d46cb3d2a85c44b432ff) )
	ROM_LOAD16_BYTE( "95407828.lo", 0x00001, 0x080000, CRC(1815d8b6) SHA1(d61f43652e20da551cc4075a0135812ad4b47e8a) )
	ROM_LOAD16_BYTE( "95407829.hi", 0x00000, 0x080000, CRC(a23801ee) SHA1(0b8c375f8615462294afd648177ba46c943767a6) )
	ROM_LOAD16_BYTE( "95408966.lo", 0x00001, 0x080000, CRC(33099885) SHA1(03ffb60d631ce1db0ea3b6bf3f58fe9317be271d) )
	ROM_LOAD16_BYTE( "95408967.hi", 0x00000, 0x080000, CRC(3c5474c8) SHA1(90e259bb9caa719f6f7bdbb3fe9d248b26197afe) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008249.bin", 0x0000, 0x100000, CRC(e8eac90a) SHA1(f79dc6912a8fbeb12c577c402d84ef4780bf4333) )
ROM_END




ROM_START( sc_cyccl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410898.lo", 0x00001, 0x080000, CRC(cfa808d0) SHA1(a9b3e1d847db59ad686eb2e0ebd77b87f8fe4971) )
	ROM_LOAD16_BYTE( "95410899.hi", 0x00000, 0x080000, CRC(c4f0f444) SHA1(253c1f04ade2813c2a9837a933798745315a13f5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410900.lo", 0x00001, 0x080000, CRC(c014291b) SHA1(2bb8724885629ead018ae0d7a78363cf098b0c51) )
	ROM_LOAD16_BYTE( "95410901.hi", 0x00000, 0x080000, CRC(88714020) SHA1(27200edc9024d7fa0584b74ec1501cd947002fce) )
	ROM_LOAD16_BYTE( "95411898.lo", 0x00001, 0x080000, CRC(58bb0891) SHA1(4bf9a7a4f37c8e90aeb9775525d2e3e1c2867e65) )
	ROM_LOAD16_BYTE( "95411899.hi", 0x00000, 0x080000, CRC(93db23d1) SHA1(e59f0c954718415e096619bd4b4c9cd0607057f2) )
	ROM_LOAD16_BYTE( "95411900.lo", 0x00001, 0x080000, CRC(5707295a) SHA1(8aa87deed9be1ad1db553b7c27fc66dbbd2f7046) )
	ROM_LOAD16_BYTE( "95411901.hi", 0x00000, 0x080000, CRC(df5a97b5) SHA1(6b34874c379cf68b411ec4f6546bd6b4096d4147) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008310.bin", 0x0000, 0x100000, CRC(4dddf82d) SHA1(4bab8cdc5f6bf59c3686dfd01f2f96858f776df3) )
ROM_END




ROM_START( sc_count )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1909p13.hi", 0x00000, 0x080000, CRC(bf5b9f9d) SHA1(d9d32838a58440da9921da4b48cff02e76efbf5b) )
	ROM_LOAD16_BYTE( "p1909p13.lo", 0x00001, 0x080000, CRC(3386377d) SHA1(3ae1fdac56cea2dd42038992c0f8dfc33f7a730d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1909s13.hi", 0x00000, 0x080000, CRC(93f8e60c) SHA1(96b0125de0145eceaf077e96b5d1cc4b91f4af72) )
	ROM_LOAD16_BYTE( "p1909s13.lo", 0x00001, 0x080000, CRC(bd50fdf2) SHA1(6d144adf57d48bef29dda5b6f8ecd18011f7febf) )
	ROM_LOAD16_BYTE( "p1929p12.hi", 0x00000, 0x080000, CRC(b5824ce7) SHA1(b7e7a05e187b6d823233218da8a89465d7aa0e75) )
	ROM_LOAD16_BYTE( "p1929p12.lo", 0x00001, 0x080000, CRC(95e21553) SHA1(1f2f67dcf326ed9382944e765b0b508b49efa4c4) )
	ROM_LOAD16_BYTE( "p1929s12.hi", 0x00000, 0x080000, CRC(f97ce062) SHA1(03fe840625a0bd3c4c9c2aa2a93c60e855014d80) )
	ROM_LOAD16_BYTE( "p1929s12.lo", 0x00001, 0x080000, CRC(b377e9d2) SHA1(52e750458af1583682ba951a50b9cd3eefb40987) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008615.bin", 0x0000, 0x100000, CRC(97c602c0) SHA1(cd71c062df3ac700ab72fc992542e08651270ec8) )
	ROM_LOAD( "95008616.bin", 0x0000, 0x100000, CRC(2b80b1a5) SHA1(a94b4402ba738a6369f58c73a5b9d66e0476eeb1) )
ROM_END




ROM_START( sc_crzcs )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95008005.lo", 0x00001, 0x100000, CRC(0b10db9f) SHA1(e0ea7b4f2dd98ef23ab42ffe7a7892e5327f646e) )
	ROM_LOAD16_BYTE( "95008006.hi", 0x00000, 0x100000, CRC(be2cdfd5) SHA1(87e25d6e26052dca8d79fbda705b2df1c06e2c67) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402099.lo", 0x00001, 0x080000, CRC(a4f80337) SHA1(9960f2aeeb820bf8ea9884239ac68a9939007d81) )
	ROM_LOAD16_BYTE( "95402100.hi", 0x00000, 0x080000, CRC(c463bb66) SHA1(b1a5e53207e9e282ab5e1937843da155ddf29f62) )
	ROM_LOAD16_BYTE( "95402101.lo", 0x00001, 0x080000, CRC(75896c5b) SHA1(ee9d40d637add14670dba3668c2fa397198eb7a7) )
	ROM_LOAD16_BYTE( "95402102.hi", 0x00000, 0x080000, CRC(d401814c) SHA1(cc4598363d78bb25c6ea3559eb1fbb607e2c8fd5) )
	ROM_LOAD16_BYTE( "95403099.lo", 0x00001, 0x080000, CRC(63df5b51) SHA1(8644e48ca9282a19ba0bf95414905e7bdacedc85) )
	ROM_LOAD16_BYTE( "95403100.hi", 0x00000, 0x080000, CRC(416b585a) SHA1(d71f7625476fba3568bfe58f7f9fc71a35e5812d) )
	ROM_LOAD16_BYTE( "95403101.lo", 0x00001, 0x080000, CRC(23e43c74) SHA1(eb7bfa6b39eaf4a74194f57310f6b5a965649766) )
	ROM_LOAD16_BYTE( "95403102.hi", 0x00000, 0x080000, CRC(071c1995) SHA1(f34123b4dceca66da4703ef9d6d51647caf02913) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_cclim )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406724.lo", 0x00001, 0x080000, CRC(787224ab) SHA1(16fc90d667991007c59a1048fbe40159cbd3638e) )
	ROM_LOAD16_BYTE( "95406725.hi", 0x00000, 0x080000, CRC(264a8a48) SHA1(3a25188aa1f41c8574553803d31db2709b577dd6) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407724.lo", 0x00001, 0x080000, CRC(3391d197) SHA1(08c396c012b2a829f760f5ce6517c72f48a18fd6) )
	ROM_LOAD16_BYTE( "95407725.hi", 0x00000, 0x080000, CRC(c81a93b5) SHA1(e4e2d933faaba27b15b1534eecfff1cce0893794) )
	ROM_LOAD16_BYTE( "95410048.lo", 0x00001, 0x080000, CRC(44eeea95) SHA1(49a8858e0dc92367902cb109fbb5882601d43a52) )
	ROM_LOAD16_BYTE( "95410049.hi", 0x00000, 0x080000, CRC(8e66c8b8) SHA1(c492fc253798118f2948ab9f1a194cbe463b4111) )
	ROM_LOAD16_BYTE( "95410050.lo", 0x00001, 0x080000, CRC(a618e745) SHA1(98cb72f390392a274f67ab27f6da6929ec960153) )
	ROM_LOAD16_BYTE( "95410051.hi", 0x00000, 0x080000, CRC(b29e6a73) SHA1(37a4cd7e99f4442b1779bf12f7edd7c8da0de4e8) )
	ROM_LOAD16_BYTE( "95410368.lo", 0x00001, 0x080000, CRC(0e919801) SHA1(a7dfde12faa5ef81d1dfee3b9ac331c04ec04a74) )
	ROM_LOAD16_BYTE( "95410369.hi", 0x00000, 0x080000, CRC(7321ff76) SHA1(3db4026a6a210f13a9e8939467c39d58b654af90) )
	ROM_LOAD16_BYTE( "95410570.lo", 0x00001, 0x080000, CRC(9bd660fd) SHA1(e7851a2362e33797eb35ed653edce6ba38613c82) )
	ROM_LOAD16_BYTE( "95410571.hi", 0x00000, 0x080000, CRC(e7af2b9e) SHA1(0d83bad8c845e1b8c07901b97d76f1ac16d006e7) )
	ROM_LOAD16_BYTE( "95410572.lo", 0x00001, 0x080000, CRC(da0273e7) SHA1(36359f7385de064966f2992e9f4b1214669f09b6) )
	ROM_LOAD16_BYTE( "95410573.hi", 0x00000, 0x080000, CRC(e48df4d2) SHA1(83538ef5e5097899755964377fcf43b6f58a683a) )
	ROM_LOAD16_BYTE( "95410602.lo", 0x00001, 0x080000, CRC(5259b29d) SHA1(54b4183cfcd7853826e0c869ff7d4d48dd02927d) )
	ROM_LOAD16_BYTE( "95410603.hi", 0x00000, 0x080000, CRC(30dbb084) SHA1(f806472fa82a01a0dfd394044163e392f45d1ac0) )
	ROM_LOAD16_BYTE( "95411048.lo", 0x00001, 0x080000, CRC(e242f807) SHA1(7ac2d6b3804cee3721241cc30ee4e61aa6dfde5d) )
	ROM_LOAD16_BYTE( "95411049.hi", 0x00000, 0x080000, CRC(24cbd652) SHA1(0c7b57102c708d7837bbd55c5bf1601a573a6528) )
	ROM_LOAD16_BYTE( "95411368.lo", 0x00001, 0x080000, CRC(63c9e46b) SHA1(bc6aa6483fc386f7a8198742bd62ce2359906679) )
	ROM_LOAD16_BYTE( "95411369.hi", 0x00000, 0x080000, CRC(83d90b83) SHA1(c1fcf31eb14c4dce1091b35e388feab391001529) )
	ROM_LOAD16_BYTE( "95411570.lo", 0x00001, 0x080000, CRC(08c32812) SHA1(da29b94d0b2cf6b87cb4f63d6adcb05a0d3af227) )
	ROM_LOAD16_BYTE( "95411571.hi", 0x00000, 0x080000, CRC(005f2d83) SHA1(df3f8434e69215fc0f355bb0bb21b7139bfc9aef) )
	ROM_LOAD16_BYTE( "95411572.lo", 0x00001, 0x080000, CRC(49173b08) SHA1(3f7f22c6a866fe5dda56aa14052aedd9f768bb35) )
	ROM_LOAD16_BYTE( "95411573.hi", 0x00000, 0x080000, CRC(037df2cf) SHA1(8a66e43729a10eb459f11ff9051402da380efd6c) )
	ROM_LOAD16_BYTE( "95411602.lo", 0x00001, 0x080000, CRC(9dca9084) SHA1(e294c7aac3b616893c7f1b14f040cf32534f44ba) )
	ROM_LOAD16_BYTE( "95411603.hi", 0x00000, 0x080000, CRC(fb52e9e7) SHA1(60f21eb0d8391b995c455a7e915812c71beaaba7) )
	ROM_LOAD16_BYTE( "p1129p12.hi", 0x00000, 0x080000, CRC(3172ea1e) SHA1(d0115e8f005fc0bce277e74fcb4f393cb25f07e1) )
	ROM_LOAD16_BYTE( "p1129p12.lo", 0x00001, 0x080000, CRC(7f631417) SHA1(f037a1746576a6ff85e286291feccb933e887971) )
	ROM_LOAD16_BYTE( "p1129p41.hi", 0x00000, 0x080000, CRC(e0803c6a) SHA1(d388c7248b07b76a1e8ab5881387e3bfcc01cfdc) )
	ROM_LOAD16_BYTE( "p1129p41.lo", 0x00001, 0x080000, CRC(749068fd) SHA1(c4f789d58546d365367b9f59d51226580dbf0e3c) )
	ROM_LOAD16_BYTE( "p1129s12.hi", 0x00000, 0x080000, CRC(335e1b6c) SHA1(ca4a854afe6abe1d397fee7bac34ececd6ecf96b) )
	ROM_LOAD16_BYTE( "p1129s12.lo", 0x00001, 0x080000, CRC(eb104c46) SHA1(9cf6d7ca330018a4e1548af4513dff09fcda3f1f) )
	ROM_LOAD16_BYTE( "p1129s41.hi", 0x00000, 0x080000, CRC(b2298a64) SHA1(69be683390abc5f16599599908ad7738280fb116) )
	ROM_LOAD16_BYTE( "p1129s41.lo", 0x00001, 0x080000, CRC(3f42075a) SHA1(cf0b6cb6cfb104346dd7beeeba4288b63d350481) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008243.bin", 0x0000, 0x100000, CRC(b21e073b) SHA1(dfe309490c5c69052041c2121258c17b974f88ed) )
ROM_END




ROM_START( sc_cf )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402217.lo", 0x00001, 0x080000, CRC(5f86e26e) SHA1(293d3700844dcfaf2a5c6e9a4ee817893e11cf1b) )
	ROM_LOAD16_BYTE( "95402218.hi", 0x00000, 0x080000, CRC(72792a3e) SHA1(efbf3fcf7f7b40424c8b7fa46d35c9bb484fe431) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406394.lo", 0x00001, 0x080000, CRC(c07a8695) SHA1(3670e547530452f21a937f34072d812f25a480ce) )
	ROM_LOAD16_BYTE( "95406395.hi", 0x00000, 0x080000, CRC(e469252b) SHA1(a7861f3d215c70b57263501af158f86257bf37c0) )
	ROM_LOAD16_BYTE( "95424544.lo", 0x00001, 0x080000, CRC(287d95b9) SHA1(c820b9913d35171ecda22baf77d85ab8ecd8cf7a) )
	ROM_LOAD16_BYTE( "95424545.hi", 0x00000, 0x080000, CRC(2b66c83f) SHA1(f47f4b1b9241d1dbc2f5d20d283ed0891484e494) )
	ROM_LOAD16_BYTE( "95424546.lo", 0x00001, 0x080000, CRC(57d3e455) SHA1(f0ee335a9d56364aa5c64b2c20dcdef06aa0f5a5) )
	ROM_LOAD16_BYTE( "95425546.lo", 0x00001, 0x080000, CRC(b503d236) SHA1(643cf63185ad796a2c5c3ca6900b2105d00c4f00) )
	ROM_LOAD16_BYTE( "95425547.hi", 0x00000, 0x080000, CRC(4261825a) SHA1(41842a1416ff1b1603881c166904df5ef2ebeedd) )
	ROM_LOAD16_BYTE( "crazyfruits game rom hi.bin", 0x0000, 0x080000, CRC(15d795db) SHA1(7f3d043c4abfb9116e700381cc4c2096c52e6fe7) )
	ROM_LOAD16_BYTE( "crazyfruits game rom low.bin", 0x0000, 0x080000, CRC(0afc9913) SHA1(1b3122d9a16a6f58893d241b96aa8b9145c09151) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	// 3 different sets of sound!
	ROM_LOAD( "crazy sound 1.bin", 0x0000, 0x080000, CRC(31e5785a) SHA1(8da2bd3571640b0ae23e9fdcc2235dcf9d2de122) )
	ROM_LOAD( "crazy sound 2.bin", 0x0000, 0x080000, CRC(bf059b21) SHA1(89a96c593e5385e9b40f694768986691eed4b5c5) )

	ROM_LOAD( "95004150.bin", 0x0000, 0x080000, CRC(7707ea0d) SHA1(efe187a4c64a3a5f8d10e21c269afbb603186ae7) )
	ROM_LOAD( "95004151.bin", 0x0000, 0x080000, CRC(54845756) SHA1(e53dfa8f836044232ee1a8006051ef586ac24d8c) )

	ROM_LOAD( "95004280.sn1", 0x0000, 0x080000, CRC(44d1b0d9) SHA1(2e361a1b65955acecbc26ba47000e4ef6316a22d) )
	//ROM_LOAD( "95004281.bin", 0x0000, 0x080000, CRC(31f057f3) SHA1(a6415eee8499ada43225901dee2d12c93d494658) )
	ROM_LOAD( "95004281.sn2", 0x0000, 0x080000, CRC(31f057f3) SHA1(a6415eee8499ada43225901dee2d12c93d494658) )

	ROM_REGION( 0x400000, "others", ROMREGION_ERASE00 )
	ROM_LOAD( "ccfsnd.bin", 0x0000, 0x02196a, CRC(15e542c2) SHA1(9bd9218b7392c882f68e330619bea7996afd001e) ) // oki sound rom, doubt it belongs here
ROM_END




ROM_START( sc_cfqps )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402950.odd", 0x00001, 0x080000, CRC(f747af02) SHA1(1bb937c9af221c077f19045ab4c9cc8ec56011b1) )
	ROM_LOAD16_BYTE( "95402951.evn", 0x00000, 0x080000, CRC(41ec3adf) SHA1(03f3dc231715e708c567a44ab3128e77229a8f35) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403950.lo", 0x00001, 0x080000, CRC(c40ca42e) SHA1(79333b174d3a7a2466f686e06583a3856460a916) )
	ROM_LOAD16_BYTE( "95403951.hi", 0x00000, 0x080000, CRC(a0d2ffe3) SHA1(eed435b55c80aa72857dd5775bd02225ed17173c) )
	ROM_LOAD16_BYTE( "95408138.odd", 0x00001, 0x080000, CRC(e52a968b) SHA1(0b6583dd52616e7fc05b547be8c39640fdc8d07e) )
	ROM_LOAD16_BYTE( "95408139.evn", 0x00000, 0x080000, CRC(e9ca97d6) SHA1(b35766a89359be7611d53ad0a25ebf82726984db) )
	ROM_LOAD16_BYTE( "95408200.odd", 0x00001, 0x080000, CRC(ed4a1958) SHA1(a86e893b42925c13dd0d30f70f3067000b8251d6) )
	ROM_LOAD16_BYTE( "95408201.evn", 0x00000, 0x080000, CRC(9b2f8f47) SHA1(919226138c16b56db1946070747021407e258583) )
	ROM_LOAD16_BYTE( "95409138.odd", 0x00001, 0x080000, CRC(4b9e2020) SHA1(17c44c71bca03d29356d359435eaa2e86abc41e0) )
	ROM_LOAD16_BYTE( "95409139.evn", 0x00000, 0x080000, CRC(3591305e) SHA1(af8a1d4f9dbd4893f0b60c57bd2cfa954d8ebae2) )
	ROM_LOAD16_BYTE( "95409200.odd", 0x00001, 0x080000, CRC(4a116c08) SHA1(d12a335f20b2e89feda852bbc60772c28e962cbd) )
	ROM_LOAD16_BYTE( "95409201.evn", 0x00000, 0x080000, CRC(b756d039) SHA1(8296ac5aa5c3e52fb04b4c80576eca055d90baa1) )
	ROM_LOAD16_BYTE( "95420248.odd", 0x00001, 0x080000, CRC(473bc41d) SHA1(8ce2dc7b72a261a590175f012970f28d452fb565) )
	ROM_LOAD16_BYTE( "95420249.evn", 0x00000, 0x080000, CRC(a57f732f) SHA1(4870bb60ffce969d47f4c57f9653342cdd6cc03d) )
	ROM_LOAD16_BYTE( "95420324.bin", 0x0000, 0x100000, CRC(41729e8f) SHA1(adb15067f61eb2e4adf537137dd24876749da8a2) )
	ROM_LOAD16_BYTE( "95420324.lo", 0x00001, 0x080000, CRC(14f2328e) SHA1(95a05b37e21ce3c729f2000baeb1308008ad13c2) )
	ROM_LOAD16_BYTE( "95421248.odd", 0x00001, 0x080000, CRC(a4e924be) SHA1(cfd03c51314b8d90226f1ab19e263e958b159dd9) )
	ROM_LOAD16_BYTE( "95421249.evn", 0x00000, 0x080000, CRC(432e8f7a) SHA1(158972ed5d9b23c345f783628b685907f2a73a0c) )
	ROM_LOAD16_BYTE( "95421324.lo", 0x00001, 0x080000, CRC(f720d22d) SHA1(8e39a6c44dcd4b9987dd750a204b596eec21d55b) )
	ROM_LOAD16_BYTE( "95421325.hi", 0x00000, 0x080000, CRC(a10843b9) SHA1(72ed4ba033b0894981e8da53d882104dbe226a8f) )
	ROM_LOAD16_BYTE( "crazyfruits.evn", 0x00000, 0x080000, CRC(7ec3801b) SHA1(77bdd1cbd76bf508c1185c3b4c28a5c14a2bc5a5) )
	ROM_LOAD16_BYTE( "crazyfruits.odd", 0x00001, 0x080000, CRC(d3cd15a1) SHA1(46300e25bf944a0c404670b02fd986ba19899606) )
	ROM_LOAD16_BYTE( "c_fr__pound8.hi", 0x00000, 0x080000, CRC(8657a605) SHA1(05902a98d997aab90147f65dcfbacaa44dca111c) )
	ROM_LOAD16_BYTE( "c_fr__pound8.lo", 0x00001, 0x080000, CRC(246c8c14) SHA1(4e6e5ad37e97efeb6155ce10202ad15f903c61e6) )


	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004101.bin", 0x0000, 0x080000, CRC(31e5785a) SHA1(8da2bd3571640b0ae23e9fdcc2235dcf9d2de122) )
	ROM_LOAD( "95004102.bin", 0x0000, 0x080000, CRC(bf059b21) SHA1(89a96c593e5385e9b40f694768986691eed4b5c5) )
	ROM_LOAD( "95008339.bin", 0x0000, 0x100000, CRC(bae07fa8) SHA1(a86a5d9ff6ac802bd15275f46894374317627e23) )
ROM_END




ROM_START( sc_cfcla )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406710.lo", 0x00001, 0x080000, CRC(a508ee14) SHA1(423a6e9b9f297d30b928051ec8deecd61c33c69e) )
	ROM_LOAD16_BYTE( "95406711.hi", 0x00000, 0x080000, CRC(e18c86fa) SHA1(fdff43a1b07e2c0ac99a0a35e547ef1839c87778) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408106.lo", 0x00001, 0x080000, CRC(72b84862) SHA1(971b67eaefc19b330e58a9fe81897fdf82c3a878) )
	ROM_LOAD16_BYTE( "95408107.hi", 0x00000, 0x080000, CRC(85cc91be) SHA1(ac736c3c97e4b0898c96ddb86d3a5e3c19769a8d) )
	ROM_LOAD16_BYTE( "95408134.lo", 0x00001, 0x080000, CRC(77708a3d) SHA1(2e35c58b2adf6f18173e8549de4a4ca09c501b4e) )
	ROM_LOAD16_BYTE( "95408135.hi", 0x00000, 0x080000, CRC(2444a443) SHA1(2cbe1a40b1fce85ba5304ba71fd9d7af2f1e4ab1) )
	ROM_LOAD16_BYTE( "95408224.lo", 0x00001, 0x080000, CRC(03ec7699) SHA1(5f1abd1baca8a80a277446a9342cf2bd87baaa8a) )
	ROM_LOAD16_BYTE( "95408225.hi", 0x00000, 0x080000, CRC(0f6ea084) SHA1(6773bb4b09186f860606c576c4dcdd4a799e2c59) )
	ROM_LOAD16_BYTE( "95409106.lo", 0x00001, 0x080000, CRC(e0ee6148) SHA1(018df803604419c21aea2291378b57d02156cfb7) )
	ROM_LOAD16_BYTE( "95409107.hi", 0x00000, 0x080000, CRC(1f7655ba) SHA1(9e4064995419b27d61f6ada41a4890ca83fee234) )
	ROM_LOAD16_BYTE( "95409134.lo", 0x00001, 0x080000, CRC(c994a8f9) SHA1(855cffe9848a9b3f3b1ef5fff11a846f0d353b8a) )
	ROM_LOAD16_BYTE( "95409135.hi", 0x00000, 0x080000, CRC(369d6e9e) SHA1(3a7b9743c9be6ea2e74d99bb6b395f332c860c38) )
	ROM_LOAD16_BYTE( "95409224.lo", 0x00001, 0x080000, CRC(b17afef0) SHA1(8fb0111220d8446829e69592c68927bf143fb637) )
	ROM_LOAD16_BYTE( "95409225.hi", 0x00000, 0x080000, CRC(12a0e039) SHA1(ff6c41237645e41fca7208e4ea492a7b2d973144) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "ccfsnd1.bin", 0x0000, 0x080000, CRC(d389aeb3) SHA1(855f3d4bba4922026b1fa963e60c5e58556739c3) )
	ROM_LOAD( "ccfsnd2.bin", 0x0000, 0x080000, CRC(6fbda954) SHA1(812c2c96a9e750daf5ac4a878c63847bfd5a2593) )
ROM_END




ROM_START( sc_cfclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95004144.lo", 0x00001, 0x080000, CRC(9d861825) SHA1(4b8776a014e31f5041f7e172ae69cb172f42fae5) )
	ROM_LOAD16_BYTE( "95004145.hi", 0x00000, 0x080000, CRC(9570fbbc) SHA1(34bdca9ef125e5304b238dd8f1421a888c9ba33e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "cf_club.hi", 0x00000, 0x080000, CRC(ac8ef8f9) SHA1(799795a5d873aa4d896dfb632c1d95ba95e1fe6f) )
	ROM_LOAD16_BYTE( "cf_club.lo", 0x00001, 0x080000, CRC(0fd50a24) SHA1(0b1a5a1f3e879733b949a6ece2f4d872f9c63cf9) )
	ROM_LOAD16_BYTE( "club-crazy-fruits_dat_acss.hi", 0x00000, 0x080000, CRC(fdd21dab) SHA1(95784b4129d4c9cfdef9907eb74417cd9208872a) )
	ROM_LOAD16_BYTE( "club-crazy-fruits_dat_acss.lo", 0x00001, 0x080000, CRC(7a1ab4e2) SHA1(0bf11dc446855931cbd715a72c3e3977dd859e9f) )
	ROM_LOAD16_BYTE( "club-crazy-fruits_std_acss.hi", 0x00000, 0x080000, CRC(2d1327da) SHA1(3918efa25b7589798a3e8b886b8faf98e946e2b1) )
	ROM_LOAD16_BYTE( "club-crazy-fruits_std_acss.lo", 0x00001, 0x080000, CRC(7c114170) SHA1(72fa5aff35d1d9f8c8ae08eb18b8acabb47c7f10) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END





ROM_START( sc_cfdu )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404674.lo", 0x00001, 0x080000, CRC(ac99d914) SHA1(8730754989d2f370e7d5e665a210a4504cbaa85b) )
	ROM_LOAD16_BYTE( "95404675.hi", 0x00000, 0x080000, CRC(4fd4b87b) SHA1(e35fe6afaafe0825c18ef2ac6719a94439ff0989) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405674.lo", 0x00001, 0x080000, CRC(ade7b40d) SHA1(5b9d394f03a683362d6ad01a9773f6116bc96b31) )
	ROM_LOAD16_BYTE( "95405675.hi", 0x00000, 0x080000, CRC(6fa82cc4) SHA1(93fe470fea4c0ff4889163aacec1b95b583c60f6) )
	ROM_LOAD16_BYTE( "95406036.lo", 0x00001, 0x080000, CRC(a5377a56) SHA1(f3779a41704c65ef3e39f706c976a3df4a86d6c1) )
	ROM_LOAD16_BYTE( "95406037.hi", 0x00000, 0x080000, CRC(98361695) SHA1(a9950ccf1689c8cae46febf87b5cd54f74c9cb2d) )
	ROM_LOAD16_BYTE( "95407036.lo", 0x00001, 0x080000, CRC(5143b7ac) SHA1(f5cbfa141f21b698fd87f03ac8da87f7e4215d51) )
	ROM_LOAD16_BYTE( "95407037.hi", 0x00000, 0x080000, CRC(a39db700) SHA1(9699ed670396ae157fdd9c511668d21fd525b88c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008184.bin", 0x0000, 0x100000, CRC(dc98ec1b) SHA1(6b600d7790bb0a90c5309d7e7684e4cca26c5a50) )
ROM_END




ROM_START( sc_cfg )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410398.lo", 0x00001, 0x080000, CRC(96e93185) SHA1(eb647e8f524339a79aa3a919c9d47cb43162dd81) )
	ROM_LOAD16_BYTE( "95410399.hi", 0x00000, 0x080000, CRC(058e7aeb) SHA1(b6f61cd250d548586328097514be176c85366fa1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410788.lo", 0x00001, 0x080000, CRC(8e9cdf3b) SHA1(9fb8ea12d9595d6b0e7d6cbbc4fb3f58f732e649) )
	ROM_LOAD16_BYTE( "95410789.hi", 0x00000, 0x080000, CRC(51c3ed51) SHA1(50426d5e1124bb77665350ad0a230ef26b678a49) )
	ROM_LOAD16_BYTE( "95410790.lo", 0x00001, 0x080000, CRC(3d6767af) SHA1(85f5147e569a7ce9ef2395ed8ea21efae701c2ad) )
	ROM_LOAD16_BYTE( "95410791.hi", 0x00000, 0x080000, CRC(24667a0d) SHA1(e2ec4eea414ace0f41fa4cf074bdf7ad8f18d2ed) )
	ROM_LOAD16_BYTE( "95410924.lo", 0x00001, 0x080000, CRC(ea76e2e6) SHA1(565ee7a0a6c310dab544348172e4b00aa49ceeca) )
	ROM_LOAD16_BYTE( "95410925.hi", 0x00000, 0x080000, CRC(74ae4798) SHA1(6278b79f050e116a04f302a065be869d24349533) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008425.bin", 0x0000, 0x100000, CRC(99bf2289) SHA1(596fe427dd7abf2779e12e3f20a5ba2eda553f2e) )
ROM_END




ROM_START( sc_cfgcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95409996.lo", 0x00001, 0x080000, CRC(85828d04) SHA1(d97eeff91d3fef7dd07b41491c43c5ccfc70fc4e) )
	ROM_LOAD16_BYTE( "95409997.hi", 0x00000, 0x080000, CRC(bb7e5ead) SHA1(ed7641c357f30fd22cb15234de801f695f86733a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95411398.lo", 0x00001, 0x080000, CRC(383bbb6f) SHA1(a099e95e90f0851bc9ce844a516ddf1228c1810d) )
	ROM_LOAD16_BYTE( "95411399.hi", 0x00000, 0x080000, CRC(3c58839e) SHA1(0338a9f17953bcf56815682d6c1fe59c2a29d2d6) )
	ROM_LOAD16_BYTE( "95411788.lo", 0x00001, 0x080000, CRC(b4bb51fb) SHA1(dec9a98da24ebf8e943e39cec8ee7dfade159678) )
	ROM_LOAD16_BYTE( "95411789.hi", 0x00000, 0x080000, CRC(5c0bb85e) SHA1(2a0b73d91cfd6eb260b70e303e041ff4274c631e) )
	ROM_LOAD16_BYTE( "95411790.lo", 0x00001, 0x080000, CRC(3c07b2ed) SHA1(eea25b20df32ea3bbddfde0e20d2a95b1ad48c06) )
	ROM_LOAD16_BYTE( "95411791.hi", 0x00000, 0x080000, CRC(0079353e) SHA1(f2b0b192c33d677fe477cb9167300e7d8160dc20) )
	ROM_LOAD16_BYTE( "95411966.lo", 0x00001, 0x080000, CRC(e060fe6b) SHA1(8cbb79f92ad51b23972942cbc419e6c0c84b2ed5) )
	ROM_LOAD16_BYTE( "95411967.hi", 0x00000, 0x080000, CRC(7e139d6b) SHA1(4f7e410093be3da1fe4eda345f61f828b1f37d53) )
	ROM_LOAD16_BYTE( "95412068.lo", 0x00001, 0x080000, CRC(55357b73) SHA1(d0caf69b096e2184b0bfacbff029cf7abad8d8c2) )
	ROM_LOAD16_BYTE( "95412069.hi", 0x00000, 0x080000, CRC(eb542bba) SHA1(59951b1f52f2306db94b81487d3e31562a2d8bd3) )
	ROM_LOAD16_BYTE( "95412916.lo", 0x00001, 0x080000, CRC(f99ec6f6) SHA1(0e57c3643bb1d2e95c250af5f1855df48dd78638) )
	ROM_LOAD16_BYTE( "95412917.hi", 0x00000, 0x080000, CRC(0bdf8b04) SHA1(d7cbc1c263650702398e5fb71c98b1fbed475e0a) )
	ROM_LOAD16_BYTE( "95413068.lo", 0x00001, 0x080000, CRC(011b03f2) SHA1(39990725843577592782bef3771c3e81a882735e) )
	ROM_LOAD16_BYTE( "95413069.hi", 0x00000, 0x080000, CRC(ebefcf57) SHA1(b0ad18af2d4a5a49b78bb7dbae3cd1700f6a50fd) )
	ROM_LOAD16_BYTE( "95413916.lo", 0x00001, 0x080000, CRC(8b41a755) SHA1(3791163f0cc1c17b094a8aed972a2c55004ef13c) )
	ROM_LOAD16_BYTE( "95413917.hi", 0x00000, 0x080000, CRC(e659878e) SHA1(b7dab901e9f1aadc033858b81ce0882bbe9d63ed) )
	ROM_LOAD16_BYTE( "95418104.lo", 0x00001, 0x080000, CRC(8b10b5bc) SHA1(aed9c66988f3c6aa719c66d6ef70b9ea7930122c) )
	ROM_LOAD16_BYTE( "95418105.hi", 0x00000, 0x080000, CRC(b9182340) SHA1(190232c0edb38dcc5e8c719b4cf93b4e12cde336) )
	ROM_LOAD16_BYTE( "95418150.lo", 0x00001, 0x080000, CRC(cef9cc8c) SHA1(fd88fc99e5845247ec2d2bb1d6b113c90bf1a951) )
	ROM_LOAD16_BYTE( "95418151.hi", 0x00000, 0x080000, CRC(3850c9c6) SHA1(899e963871873d7628be8cde4fc0bd4d4686fcff) )
	ROM_LOAD16_BYTE( "95419104.lo", 0x00001, 0x080000, CRC(584167fd) SHA1(5dce3a9028695fe41d113cd8ce13abe1722bf668) )
	ROM_LOAD16_BYTE( "95419105.hi", 0x00000, 0x080000, CRC(3c8f9644) SHA1(67abbad1d54998e292c7364d0711e40da5c1b843) )
	ROM_LOAD16_BYTE( "95419150.lo", 0x00001, 0x080000, CRC(59d7f74c) SHA1(6bfeb7b2be440998d69deb722ef9d56d526bedab) )
	ROM_LOAD16_BYTE( "95419151.hi", 0x00000, 0x080000, CRC(f0f795b6) SHA1(8b4bec4061a2e28ff8b9fd58e578c77ec2227f93) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008577.bin", 0x0000, 0x100000, CRC(f18f1116) SHA1(ba47360e7b489c1bcded786dd1efe518b62b039e) )
ROM_END




ROM_START( sc_crzgn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95004248.lo", 0x00001, 0x080000, CRC(4fff74c5) SHA1(2704a15e3afd73848c8f3963920f606310b86963) )
	ROM_LOAD16_BYTE( "95004249.hi", 0x00000, 0x080000, CRC(2c8cdeb1) SHA1(771bcc907be91be2d178b87a76b72bd3cc07fe30) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402452.lo", 0x00001, 0x080000, CRC(7483d8a2) SHA1(24c1749b142104d817ffbc0df706d91f0649054b) )
	ROM_LOAD16_BYTE( "95402453.hi", 0x00000, 0x080000, CRC(c48f4d13) SHA1(2f5f5b5e267c4df3cdaec12b7fda79272d3d0843) )
	ROM_LOAD16_BYTE( "95402676.lo", 0x00001, 0x080000, CRC(8bd3558f) SHA1(8b5c84f7bc2974f1850b0e03710f90b45ce8bd0d) )
	ROM_LOAD16_BYTE( "95402677.hi", 0x00000, 0x080000, CRC(b2c68af0) SHA1(110a09ad80d144f1d4c8ccf5feb30967b8f82237) )
	ROM_LOAD16_BYTE( "95403452.lo", 0x00001, 0x080000, CRC(94e3081f) SHA1(ea80369b6b39b4ec8977a7fe24cb1c1f3e70e52a) )
	ROM_LOAD16_BYTE( "95403453.hi", 0x00000, 0x080000, CRC(4187ae2f) SHA1(436ff74daa1ee45bf7b391565acecbd7da8af69d) )
	ROM_LOAD16_BYTE( "95403676.lo", 0x00001, 0x080000, CRC(cef89cf8) SHA1(e54ec7c619442abf7b44d1b6d50c8507121bb300) )
	ROM_LOAD16_BYTE( "95403677.hi", 0x00000, 0x080000, CRC(55368ced) SHA1(ec660706f5de64f433e73a86273a4a8e080333b9) )
	ROM_LOAD16_BYTE( "95404186.lo", 0x00001, 0x080000, CRC(d0997272) SHA1(fc3c5712a40fe940dd4781994e6d746da690b0bb) )
	ROM_LOAD16_BYTE( "95404187.hi", 0x00000, 0x080000, CRC(41f50ee9) SHA1(06e0af8d991eb124432b69744de50e7746c1b492) )
	ROM_LOAD16_BYTE( "95405186.lo", 0x00001, 0x080000, CRC(4135c3d6) SHA1(f5e3b56a5ffe3c9fd4aa670ee96b3a005457d6e3) )
	ROM_LOAD16_BYTE( "95405187.hi", 0x00000, 0x080000, CRC(89a8de4c) SHA1(4adc348fd9eb1bdd385a38435970673ac49617f0) )
	ROM_LOAD16_BYTE( "95406638.lo", 0x00001, 0x080000, CRC(c80a180b) SHA1(7a849df85295a4901a95642ee8265da9d928d1ac) )
	ROM_LOAD16_BYTE( "95406639.hi", 0x00000, 0x080000, CRC(96737d40) SHA1(20e84b085b8ee67c8ddf51d5c9fea6f8fdf6fca8) )
	ROM_LOAD16_BYTE( "95406640.lo", 0x00001, 0x080000, CRC(7a08b774) SHA1(1cb245f177760da1a1884974427dec8a241ec0d2) )
	ROM_LOAD16_BYTE( "95406641.hi", 0x00000, 0x080000, CRC(c5b8c740) SHA1(3ceb8b27e3fbbcb6d62f9873c7b7b5f1db984bf0) )
	ROM_LOAD16_BYTE( "95406642.lo", 0x00001, 0x080000, CRC(d7b890dc) SHA1(811484235803f0283a8af98b540cf3e7d82257e9) )
	ROM_LOAD16_BYTE( "95406643.hi", 0x00000, 0x080000, CRC(5bc90bfa) SHA1(d62a2d434ccda2ac5fdfd5503f822db94e09c7ca) )
	ROM_LOAD16_BYTE( "95407638.lo", 0x00001, 0x080000, CRC(bdceb0a8) SHA1(a258b8045eb06e67e5e424bd288aefe5e3c1f8e7) )
	ROM_LOAD16_BYTE( "95407639.hi", 0x00000, 0x080000, CRC(564a9d5f) SHA1(af02a0c0a4594620540907d9467d3b63005e4230) )
	ROM_LOAD16_BYTE( "95407640.lo", 0x00001, 0x080000, CRC(57e4df74) SHA1(1ff36d566b57a5968803abb6c3e89842294f47e7) )
	ROM_LOAD16_BYTE( "95407641.hi", 0x00000, 0x080000, CRC(43ec0214) SHA1(d7964762922b2944d9e3d6ea50418d8cb54c89a5) )
	ROM_LOAD16_BYTE( "95407642.lo", 0x00001, 0x080000, CRC(3473e373) SHA1(724a21668d958e062986a1644b3a313cf8606550) )
	ROM_LOAD16_BYTE( "95407643.hi", 0x00000, 0x080000, CRC(2f42ea78) SHA1(50fe758b6f09bd5af441cf5267f00e3416db12df) )
	ROM_LOAD16_BYTE( "95410020.lo", 0x00001, 0x080000, CRC(7301bf72) SHA1(30d1bdb8c08ad69353b2c00b6c83801d76b9cac8) )
	ROM_LOAD16_BYTE( "95410021.hi", 0x00000, 0x080000, CRC(2e1f5465) SHA1(5e6d830183825581426a5a16dad6e076fcc1e86b) )
	ROM_LOAD16_BYTE( "95410022.lo", 0x00001, 0x080000, CRC(cb7e2efa) SHA1(00eb8f7fd1a5b8a45867598c9043be3cf75dc555) )
	ROM_LOAD16_BYTE( "95410023.hi", 0x00000, 0x080000, CRC(c86873fe) SHA1(2be2445cc8a21441484d9f29bc9e64b26513389e) )
	ROM_LOAD16_BYTE( "95410024.lo", 0x00001, 0x080000, CRC(77698831) SHA1(d580d24f95b8a975e7edd188355d192dd2474757) )
	ROM_LOAD16_BYTE( "95410025.hi", 0x00000, 0x080000, CRC(7c8b6324) SHA1(fcf82edbf1e11e2b054658241848f3c6031c23ac) )
	ROM_LOAD16_BYTE( "95410026.lo", 0x00001, 0x080000, CRC(10be06c8) SHA1(c01917e0b707fd583cc2ed7c1e3ce6c540b79880) )
	ROM_LOAD16_BYTE( "95410027.hi", 0x00000, 0x080000, CRC(10298e0c) SHA1(f4e1eda6df1d0efef68c6920936d93f08cc3ffb7) )
	ROM_LOAD16_BYTE( "95410028.lo", 0x00001, 0x080000, CRC(905a72ab) SHA1(5898dccaa83d4a2437891cefb7b9408e15b44f97) )
	ROM_LOAD16_BYTE( "95410029.hi", 0x00000, 0x080000, CRC(eb406ca4) SHA1(f73104ca3fed3b8605ff03fe0d8ec212df29db45) )
	ROM_LOAD16_BYTE( "95410366.lo", 0x00001, 0x080000, CRC(a8e9ade8) SHA1(8f4f9012adc35e82b1cc10b9efc8b42fb2eb8cb8) )
	ROM_LOAD16_BYTE( "95410367.hi", 0x00000, 0x080000, CRC(d8381915) SHA1(fe228ad80da15e6cadc2ac6e622dadc6d009bdf5) )
	ROM_LOAD16_BYTE( "95410574.lo", 0x00001, 0x080000, CRC(8dba48b3) SHA1(67a76020720665dd15693360ce7d486273cf908e) )
	ROM_LOAD16_BYTE( "95410575.hi", 0x00000, 0x080000, CRC(8f7f617a) SHA1(fa4fa2446cb15c1b961e32d8ece39198b1f73c9a) )
	ROM_LOAD16_BYTE( "95410576.lo", 0x00001, 0x080000, CRC(09681a4f) SHA1(7fa5d871a485467f0076e0549e14d157807d9d83) )
	ROM_LOAD16_BYTE( "95410577.hi", 0x00000, 0x080000, CRC(745628fd) SHA1(be1ef5ba07ed9e4c9fd931e95440ba4d8db41c12) )
	ROM_LOAD16_BYTE( "95410578.lo", 0x00001, 0x080000, CRC(84abd1a5) SHA1(ec77d438563a3856e3541045d5fbbd450f8e285b) )
	ROM_LOAD16_BYTE( "95410579.hi", 0x00000, 0x080000, CRC(7bb2bd0b) SHA1(4f3b59c1296383391cc7b16e3f1258019c58a7fd) )
	ROM_LOAD16_BYTE( "95410580.lo", 0x00001, 0x080000, CRC(4abde8b8) SHA1(3a745514c9eb461656313949564bde999385d7a0) )
	ROM_LOAD16_BYTE( "95410581.hi", 0x00000, 0x080000, CRC(31278443) SHA1(75f49f2d20c0d6123d8d19d1cd98dc7ba7af15d8) )
	ROM_LOAD16_BYTE( "95410596.lo", 0x00001, 0x080000, CRC(29aa05be) SHA1(12d3171d5ad86694ea5a80a4fe829387ceb98cdd) )
	ROM_LOAD16_BYTE( "95410597.hi", 0x00000, 0x080000, CRC(a05af0b5) SHA1(e63b8a698a3576e84ce9a0cc187bf226004ea8b9) )
	ROM_LOAD16_BYTE( "95410598.lo", 0x00001, 0x080000, CRC(d8b370c9) SHA1(f61cbfa97363d62942d74c5769084ede4c4e7c3e) )
	ROM_LOAD16_BYTE( "95410599.hi", 0x00000, 0x080000, CRC(ca0e4d6a) SHA1(e3b0ee85d2fdeb959951cbd8d2b4251a9c91ad13) )
	ROM_LOAD16_BYTE( "95411021.hi", 0x00000, 0x080000, CRC(3066a181) SHA1(350cf285a756328022bae3a0bd8f13d00e29e805) )
	ROM_LOAD16_BYTE( "95411022.lo", 0x00001, 0x080000, CRC(4ee458ad) SHA1(7dcbca3828fe99256ecfa1ac3a9b3757717f5fee) )
	ROM_LOAD16_BYTE( "95411023.hi", 0x00000, 0x080000, CRC(5aed69d8) SHA1(53de1e5f19c8f319728fc11085ccc7db7e21cc4b) )
	ROM_LOAD16_BYTE( "95411024.lo", 0x00001, 0x080000, CRC(b6f5548b) SHA1(687c228877ce4b36952ec735eca7cc3e69fce789) )
	ROM_LOAD16_BYTE( "95411025.hi", 0x00000, 0x080000, CRC(e3ab8770) SHA1(569ff2adfee8a08f96e397234dedac9af22903bd) )
	ROM_LOAD16_BYTE( "95411026.lo", 0x00001, 0x080000, CRC(d8996549) SHA1(53830639574e58c8bf96fd3aaeed66e773f119ee) )
	ROM_LOAD16_BYTE( "95411027.hi", 0x00000, 0x080000, CRC(e135da8a) SHA1(cc57026825b2afc6bd21fe43adac05b199607d36) )
	ROM_LOAD16_BYTE( "95411028.lo", 0x00001, 0x080000, CRC(1ac217da) SHA1(fe6043a5c7e8209bd5de87c0facd3a4e7f57196c) )
	ROM_LOAD16_BYTE( "95411029.hi", 0x00000, 0x080000, CRC(eb406ca4) SHA1(f73104ca3fed3b8605ff03fe0d8ec212df29db45) )
	ROM_LOAD16_BYTE( "95411366.lo", 0x00001, 0x080000, CRC(af0c09af) SHA1(7098ba77c9800b2c288bfb9fb24ff946cc0e7c34) )
	ROM_LOAD16_BYTE( "95411367.hi", 0x00000, 0x080000, CRC(2333d361) SHA1(4bf7491df76f59a8698c817ab7e9a309a505d8dc) )
	ROM_LOAD16_BYTE( "95411574.lo", 0x00001, 0x080000, CRC(ebdcb06a) SHA1(995a13cf4f57753da882e71e1023fccc017784fb) )
	ROM_LOAD16_BYTE( "95411575.hi", 0x00000, 0x080000, CRC(6810315f) SHA1(01071ad50661f4e8e2f7e0ce2e90274b57f47a3a) )
	ROM_LOAD16_BYTE( "95411576.lo", 0x00001, 0x080000, CRC(d85d0230) SHA1(0e4e0b2b8067e870265d66c193166773e1f0d983) )
	ROM_LOAD16_BYTE( "95411577.hi", 0x00000, 0x080000, CRC(7853e33c) SHA1(f956dc2148453bfc0d89ace9ea5c01545ade73c9) )
	ROM_LOAD16_BYTE( "95411578.lo", 0x00001, 0x080000, CRC(7498b6c3) SHA1(ee787369e09a7e90237ce3cedd86c3735ad317b2) )
	ROM_LOAD16_BYTE( "95411579.hi", 0x00000, 0x080000, CRC(90d826ef) SHA1(368a5af3bb7a3f85394fd8988515a9cd9798fb66) )
	ROM_LOAD16_BYTE( "95411580.lo", 0x00001, 0x080000, CRC(2266553a) SHA1(7b11dbbe7cb6803e7ed6fbea94dd2355b7eddd82) )
	ROM_LOAD16_BYTE( "95411581.hi", 0x00000, 0x080000, CRC(5003c3ca) SHA1(f15acfc5e14dc62221626f71e32a3788e27d6a73) )
	ROM_LOAD16_BYTE( "95411596.lo", 0x00001, 0x080000, CRC(1a7b740e) SHA1(61121d9c883f36b610ec4b9b0f49fa7dadece011) )
	ROM_LOAD16_BYTE( "95411597.hi", 0x00000, 0x080000, CRC(12632fe5) SHA1(aa4db2387fa88f1ec7150c128ab42f5e568f8bca) )
	ROM_LOAD16_BYTE( "95411598.lo", 0x00001, 0x080000, CRC(4b632ca0) SHA1(2e44df78cf5838f13ab16aa065be1214b9a203d5) )
	ROM_LOAD16_BYTE( "95411599.hi", 0x00000, 0x080000, CRC(42a29fdf) SHA1(4c38e1da31cfd9043bd46b8b549ae74afcfdb497) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_crzky )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406634.lo", 0x00001, 0x080000, CRC(777a328a) SHA1(9bfe4fb4ebdc89d43be9d0a11f5a4ccfc2191e12) )
	ROM_LOAD16_BYTE( "95406635.hi", 0x00000, 0x080000, CRC(f8b6e2c3) SHA1(61a7f607c0ab74d82fc04827d4381ced108b9b83) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406722.lo", 0x00001, 0x080000, CRC(ebcb20ea) SHA1(9be110af57919efbd9cdff7d89746b557e3e2df0) )
	ROM_LOAD16_BYTE( "95406723.hi", 0x00000, 0x080000, CRC(76613d1b) SHA1(2fed1c09fce5af13d88ab570612fb2f756dabbc8) )
	ROM_LOAD16_BYTE( "95406802.lo", 0x00001, 0x080000, CRC(2e62ebb1) SHA1(d946ef00f0bb15529e744bcd5f0b83abd135f176) )
	ROM_LOAD16_BYTE( "95406803.hi", 0x00000, 0x080000, CRC(d84dc003) SHA1(fc7dd44bda2ce3ddd23559c226dd81adaea9dba5) )
	ROM_LOAD16_BYTE( "95407634.lo", 0x00001, 0x080000, CRC(24152e9a) SHA1(8fba1c2d6c51c416fdf6e2ca309a163584647633) )
	ROM_LOAD16_BYTE( "95407635.hi", 0x00000, 0x080000, CRC(67c8ce9d) SHA1(5aa4de657e4fceb85b37e8207b5f852ef0aa22fb) )
	ROM_LOAD16_BYTE( "95407722.lo", 0x00001, 0x080000, CRC(a58ec2c5) SHA1(0c7582062dc95b4e1cf805d7cd2c9f9364ee006d) )
	ROM_LOAD16_BYTE( "95407723.hi", 0x00000, 0x080000, CRC(9fd991f0) SHA1(e25271116a40b94ff54bcd2230fddf0d880df478) )
	ROM_LOAD16_BYTE( "95407802.lo", 0x00001, 0x080000, CRC(381a8b19) SHA1(79f899e432d246a7f47fca34204fbfec6cacc6a9) )
	ROM_LOAD16_BYTE( "95407803.hi", 0x00000, 0x080000, CRC(e38e9009) SHA1(9cc8ba488711b9f6cb2d597abdd10c46d2113e39) )
	ROM_LOAD16_BYTE( "95410042.lo", 0x00001, 0x080000, CRC(cc2479f3) SHA1(8ccebd62df3d69b6ceb252883ba209902eb17060) )
	ROM_LOAD16_BYTE( "95410043.hi", 0x00000, 0x080000, CRC(dc52c32b) SHA1(0b6c0a2c80b73592f70b29f7175c831bf6716bd3) )
	ROM_LOAD16_BYTE( "95410044.lo", 0x00001, 0x080000, CRC(7ca79549) SHA1(c74fb92f192d9d8bf60ff38a126a3876703385a0) )
	ROM_LOAD16_BYTE( "95410370.lo", 0x00001, 0x080000, CRC(e53a9a74) SHA1(71a3a3762703a7fa06fd51d1d70e50578a726dcc) )
	ROM_LOAD16_BYTE( "95410371.hi", 0x00000, 0x080000, CRC(0e8bb647) SHA1(785bc1a8b379bf75c31c55aaf35b6c0189946af3) )
	ROM_LOAD16_BYTE( "95410566.lo", 0x00001, 0x080000, CRC(3a052a51) SHA1(c98f8b53188716ab674b3c2839cf6bc837c88ec2) )
	ROM_LOAD16_BYTE( "95410567.hi", 0x00000, 0x080000, CRC(f6db5850) SHA1(c78ccda4f5f86406f6e5c059980c548a7b0d9751) )
	ROM_LOAD16_BYTE( "95410568.lo", 0x00001, 0x080000, CRC(3d528d96) SHA1(8b22b4ea0142e33756c92ec232a32a24961810f1) )
	ROM_LOAD16_BYTE( "95410569.hi", 0x00000, 0x080000, CRC(ad86af8e) SHA1(1bf37e6308612dd03e92f4b95b3525b39c007aa8) )
	ROM_LOAD16_BYTE( "95410600.lo", 0x00001, 0x080000, CRC(e6445e23) SHA1(71c22c6968673e773c749f34c178ae8424c2b157) )
	ROM_LOAD16_BYTE( "95410601.hi", 0x00000, 0x080000, CRC(2f965559) SHA1(e5ef95e18ff6a0eb953853ea485613876fdff7a2) )
	ROM_LOAD16_BYTE( "95411042.lo", 0x00001, 0x080000, CRC(17d4aa90) SHA1(20dbd3315cc0dc24a7d00b8709f6ce8821d1b74b) )
	ROM_LOAD16_BYTE( "95411043.hi", 0x00000, 0x080000, CRC(b4116fb1) SHA1(70d728ad4c2a8810465d4b2f4f922c455fa36070) )
	ROM_LOAD16_BYTE( "95411044.lo", 0x00001, 0x080000, CRC(38cc4eed) SHA1(f3b3de3913787a6459af00f2a17c63eaf757dec3) )
	ROM_LOAD16_BYTE( "95411045.hi", 0x00000, 0x080000, CRC(8524d0e4) SHA1(e0c654a8e1109a5faa3b18e8609a9f4d4a780364) )
	ROM_LOAD16_BYTE( "95411370.lo", 0x00001, 0x080000, CRC(4b0ddf07) SHA1(bb99fae2bc11cb6ce23aba74b41d20b0fce38ad3) )
	ROM_LOAD16_BYTE( "95411371.hi", 0x00000, 0x080000, CRC(4d22117f) SHA1(19a9aa05989d41a4485d4bce71989046d3ec2c67) )
	ROM_LOAD16_BYTE( "95411566.lo", 0x00001, 0x080000, CRC(74b44419) SHA1(5a3474b39a626567ced29aa5d3e62803b755445f) )
	ROM_LOAD16_BYTE( "95411567.hi", 0x00000, 0x080000, CRC(a051758d) SHA1(20d0e0ebd855e84c5c0ee49a3fff7264c07a47ac) )
	ROM_LOAD16_BYTE( "95411568.lo", 0x00001, 0x080000, CRC(73e3e3de) SHA1(d4154b83dac8045d7a578c06ec98a74c79e6d6a1) )
	ROM_LOAD16_BYTE( "95411569.hi", 0x00000, 0x080000, CRC(fb0c8253) SHA1(e9ed1d6ddfa7cb52906b1d0873a1d768c6bb7d50) )
	ROM_LOAD16_BYTE( "95411600.lo", 0x00001, 0x080000, CRC(9db954e7) SHA1(ac2a4a2151dd59c1bf18735ff00909cfc869d897) )
	ROM_LOAD16_BYTE( "95411601.hi", 0x00000, 0x080000, CRC(e7c3ae92) SHA1(125f29c228b745828ec74bb964e84f4d16bf728d) )
	ROM_LOAD16_BYTE( "95412394.lo", 0x00001, 0x080000, CRC(6f8aac4f) SHA1(9b513aaf02e062499245592da17e7ce78f794c99) )
	ROM_LOAD16_BYTE( "95412395.hi", 0x00000, 0x080000, CRC(680ea9bc) SHA1(9e790db3d856a66a70d1f2432da646444a936d8c) )
	ROM_LOAD16_BYTE( "95412396.lo", 0x00001, 0x080000, CRC(688dd067) SHA1(fd8cae7da036f741a31a2d40f3e99db499d9fba5) )
	ROM_LOAD16_BYTE( "95412397.hi", 0x00000, 0x080000, CRC(e82f0e8d) SHA1(4158a5aa70324ef18a1cf9358b4d1a9ae3684553) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008242.bin", 0x0000, 0x100000, CRC(7d5c1356) SHA1(efab297024650c95a0abb1296b2ebabd09b299a8) )
ROM_END




ROM_START( sc_crzwl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400143.lo", 0x00001, 0x080000, CRC(e3a08e29) SHA1(9e85b34197aa67a1e60e610dfcf4cf900cc473ab) )
	ROM_LOAD16_BYTE( "95400144.hi", 0x00000, 0x080000, CRC(a5bf5824) SHA1(e41652a84d449f85eefaeed4ebc59cd95b35d2ac) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400147.lo", 0x00001, 0x080000, CRC(3e6b5552) SHA1(a6aa55fd7aa718190a6e9b01b0f6c0501b49e3d2) )
	ROM_LOAD16_BYTE( "95400148.hi", 0x00000, 0x080000, CRC(ee857272) SHA1(5760b56164071c0529a0c369d190666dd07949e9) )
	ROM_LOAD16_BYTE( "95400221.lo", 0x00001, 0x080000, CRC(670b73c5) SHA1(5145e1fd89decb46bf7654edf136c6549913e132) )
	ROM_LOAD16_BYTE( "95400222.hi", 0x00000, 0x080000, CRC(63bff045) SHA1(51252cf325ddf70fe48a4d6b1728d1f3f8d94025) )
	ROM_LOAD16_BYTE( "95400575.lo", 0x00001, 0x080000, CRC(966f3bd7) SHA1(d353e3e06d9bd6b27265352a9b9c6522fa5cda21) )
	ROM_LOAD16_BYTE( "95400576.hi", 0x00000, 0x080000, CRC(6f593a71) SHA1(9798eebf143c5f06026df321a17d89c2d3df6f62) )
	ROM_LOAD16_BYTE( "95401143.lo", 0x00001, 0x080000, CRC(d1187eb7) SHA1(aa2f1c4b295cc6856b5a70fd959aa054d15702e9) )
	ROM_LOAD16_BYTE( "95401144.hi", 0x00000, 0x080000, CRC(74df981d) SHA1(65092734a13b24040078094b6c69a58379d5ebc1) )
	ROM_LOAD16_BYTE( "95401147.lo", 0x00001, 0x080000, CRC(c88395c6) SHA1(20efe173b8487b8a333540065ee87f406a1cbcb3) )
	ROM_LOAD16_BYTE( "95401148.hi", 0x00000, 0x080000, CRC(f5cd1160) SHA1(b32415eb5aa5f6125d39f3eb371d369b12c61a50) )
	ROM_LOAD16_BYTE( "95401221.lo", 0x00001, 0x080000, CRC(41ced3a9) SHA1(e240ce8ed0c0b9fca61211522850f104e856069d) )
	ROM_LOAD16_BYTE( "95401222.hi", 0x00000, 0x080000, CRC(768f0076) SHA1(ee42b8b794b700855c03d67e565363b31f8ffa6d) )
	ROM_LOAD16_BYTE( "95401575.lo", 0x00001, 0x080000, CRC(f1c3a87a) SHA1(8ae813b2f232dd1c0b2943506cac59470371ce32) )
	ROM_LOAD16_BYTE( "95401576.hi", 0x00000, 0x080000, CRC(f0b84017) SHA1(124bc1653f33a52aafad11d6fe9e8990bf7765fe) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_cccsh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400693.lo", 0x00001, 0x080000, CRC(61896fc5) SHA1(416e97956b5591820c8f51126f823efc0351fe1f) )
	ROM_LOAD16_BYTE( "95400694.hi", 0x00000, 0x080000, CRC(05d6f641) SHA1(0936aa69368e895f21c9ffd51db1dc548c39bd67) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400695.lo", 0x00001, 0x080000, CRC(ca6ed067) SHA1(84e3519c692b0e461038f5e4ec2ac6a6027138f7) )
	ROM_LOAD16_BYTE( "95400696.hi", 0x00000, 0x080000, CRC(455a774a) SHA1(7f0eb430416d954f48de62747258d85f20215664) )
	ROM_LOAD16_BYTE( "95400837.lo", 0x00001, 0x080000, CRC(eb40ea39) SHA1(56c9a00288149458145c29f2677f9b4eef208f51) )
	ROM_LOAD16_BYTE( "95400838.hi", 0x00000, 0x080000, CRC(062c8198) SHA1(b53101722982075779f02ad189a9a7600678eebc) )
	ROM_LOAD16_BYTE( "95401693.lo", 0x00001, 0x080000, CRC(e7837b9e) SHA1(6017362906e49b7fa254d183282b6e1ff4c28102) )
	ROM_LOAD16_BYTE( "95401694.hi", 0x00000, 0x080000, CRC(cd1c5bb2) SHA1(7a682252655d67baa0da896af123b23fc1b170fc) )
	ROM_LOAD16_BYTE( "95401695.lo", 0x00001, 0x080000, CRC(38ef25be) SHA1(ac4923e7466e1b254daed43099ea38eba7d70437) )
	ROM_LOAD16_BYTE( "95401696.hi", 0x00000, 0x080000, CRC(25409cb3) SHA1(fe1216a1237f65635f3cc5584a3cdeedee6f7b88) )
	ROM_LOAD16_BYTE( "95401837.lo", 0x00001, 0x080000, CRC(8a25ae47) SHA1(ebf00a93e1707070701a77adcb71f47b16bdb99e) )
	ROM_LOAD16_BYTE( "95401838.hi", 0x00000, 0x080000, CRC(99cdfbfe) SHA1(5193d050d4d295f856b0a5a4163c07449a869edf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004173", 0x0000, 0x080000, CRC(67970fed) SHA1(938414921a0956841ce4447471b7663f5c2c2d4f) )
	ROM_LOAD( "95004174", 0x0000, 0x080000, CRC(1f1dd01f) SHA1(6ed312c1e50056bf3cae156e595b26374d7d4816) )
ROM_END




ROM_START( sc_ccc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406348.lo", 0x00001, 0x080000, CRC(1c6a6eaa) SHA1(b053cbb9756a36f1a775d18316c9fc305cd97978) )
	ROM_LOAD16_BYTE( "95406349.hi", 0x00000, 0x080000, CRC(c9742e04) SHA1(0662126a8b05bfc3e60bb4a3c659070814f73305) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004282.snd", 0x0000, 0x080000, CRC(e17fb009) SHA1(27fa336c8576bd4a2414f4d71857e9113102cb3d) )
ROM_END




ROM_START( sc_crnjw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412658.lo", 0x00001, 0x080000, CRC(2d60552e) SHA1(d4bee760079e727909a97a0c78ebcb56686c8ec4) )
	ROM_LOAD16_BYTE( "95412659.hi", 0x00000, 0x080000, CRC(0bd73c6e) SHA1(a388758932d9cf66556fe90cf79975660f5c1ab8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412722.lo", 0x00001, 0x080000, CRC(3a6af4a3) SHA1(ca49bb59a3f6ae748dcbfcf1a9b5802647cdef06) )
	ROM_LOAD16_BYTE( "95412723.hi", 0x00000, 0x080000, CRC(29959756) SHA1(2197c2b81777ec3053a314c491effce064c4ce29) )
	ROM_LOAD16_BYTE( "95413658.lo", 0x00001, 0x080000, CRC(9660aff0) SHA1(77593512c29941694bd008b251f6f3aec5176ab8) )
	ROM_LOAD16_BYTE( "95413659.hi", 0x00000, 0x080000, CRC(07d2f7af) SHA1(d4b315655c7f991eb465de1f6cb622ec7ff2b062) )
	ROM_LOAD16_BYTE( "95413722.lo", 0x00001, 0x080000, CRC(1fb92642) SHA1(9cb3a432841fcdd5e863a5c77a431299c2a534f8) )
	ROM_LOAD16_BYTE( "95413723.hi", 0x00000, 0x080000, CRC(e3bd347d) SHA1(02a996e7f2e81f12b0d05810370763ea02c7bf6c) )
	ROM_LOAD16_BYTE( "c_jewels.hi", 0x00000, 0x080000, CRC(b1ddedd3) SHA1(e5eb9f25a4e385e17c97c1fd67cba991c5f832bd) )
	ROM_LOAD16_BYTE( "c_jewels.lo", 0x00001, 0x080000, CRC(3e8812bc) SHA1(66ad13ef56a6d95a82565e3de53b199f0426a156) )
	ROM_LOAD16_BYTE( "g95426714.lo", 0x00001, 0x080000, CRC(c2d3f6d6) SHA1(fb5532a9f23c7f9740d55eb411f543b75e3b8ae6) )
	ROM_LOAD16_BYTE( "g95426715.hi", 0x00000, 0x080000, CRC(bd812886) SHA1(2452499bc7c6ca51e8f6ed53c182a756e90bf9a0) )
	ROM_LOAD16_BYTE( "g95426894.lo", 0x00001, 0x080000, CRC(cc1d8324) SHA1(aae871fb7400e661f60f174491f4f2192dd12ebd) )
	ROM_LOAD16_BYTE( "g95426895.hi", 0x00000, 0x080000, CRC(40820ce7) SHA1(e65c939563acd9ebe2d342116f884418b5562279) )
	ROM_LOAD16_BYTE( "g95427714.lo", 0x00001, 0x080000, CRC(1866575e) SHA1(7f772562a7a2d961777c5df55e4a62931934522e) )
	ROM_LOAD16_BYTE( "g95427715.hi", 0x00000, 0x080000, CRC(db62827f) SHA1(96086d1976e443d026fc9534d861f3117b2d901a) )
	ROM_LOAD16_BYTE( "g95427894.lo", 0x00001, 0x080000, CRC(f18d39dd) SHA1(9633a857faa91cde927978bc3d06c2b1840d65ec) )
	ROM_LOAD16_BYTE( "g95427895.hi", 0x00000, 0x080000, CRC(961802c6) SHA1(ae8da626d508e4a7697ef1911c2183da97b0f0cc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008469.bin", 0x0000, 0x100000, CRC(07df5a41) SHA1(56dacba05e26258e50085f78dfe965196917addf) )
	ROM_LOAD( "95009176.bin", 0x0000, 0x100000, CRC(d1db2564) SHA1(641f94108df9dffde599012018d944e3848f50ed) )
	ROM_LOAD( "95009177.bin", 0x0000, 0x100000, CRC(e574cc1c) SHA1(760284d60d336571495da921ff666ac5725d7c19) )
ROM_END



ROM_START( sc_db )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416326.lo", 0x00001, 0x080000, CRC(131c13b5) SHA1(9fbce59022f8489d156296c3aa5a0acc1c62ffe5) )
	ROM_LOAD16_BYTE( "95416327.hi", 0x00000, 0x080000, CRC(5dbcfdb6) SHA1(f017cad0eb55937936f3908add20aaa0321e8b8d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_daylt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400033.p1", 0x0000, 0x080000, CRC(7b8dffcd) SHA1(200323dfdc92faf6853d70583a56e3b37b159f1c) )
	ROM_LOAD16_BYTE( "95400034.p2", 0x0000, 0x080000, CRC(eba8544f) SHA1(cd806adb836d0b6ed3eb16cdcd826ea47efbb9d9) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400035.p1", 0x0000, 0x080000, CRC(775b57e2) SHA1(6a3bc25ecca0cab421092661cb9d622c0934d042) )
	ROM_LOAD16_BYTE( "95400036.p2", 0x0000, 0x080000, CRC(edc97be8) SHA1(a0cf8d63fa34e724ee89e221cf1aa80ce02598c1) )
	ROM_LOAD16_BYTE( "95400043.lo", 0x00001, 0x080000, CRC(56fb448b) SHA1(009712cd122d10cdb4dfbf472eaaefb879935fce) )
	ROM_LOAD16_BYTE( "95400044.hi", 0x00000, 0x080000, CRC(7f39c4c6) SHA1(09114c34d5ae778494f29a5696725787e4d7c294) )
	ROM_LOAD16_BYTE( "95400045.lo", 0x00001, 0x080000, CRC(6048bbd4) SHA1(d14137a7ff99abfe49ef11e30d4f693eb4c90960) )
	ROM_LOAD16_BYTE( "95400046.hi", 0x00000, 0x080000, CRC(212e9e63) SHA1(41a4cd3f02a96419e0ccd90b1e2c94b3ceddc36a) )
	ROM_LOAD16_BYTE( "95400467.lo", 0x00001, 0x080000, CRC(1e654bb1) SHA1(0a51059d8e4e67b64ec3efe2d09684c954ef3b2f) )
	ROM_LOAD16_BYTE( "95400468.hi", 0x00000, 0x080000, CRC(59e20e36) SHA1(4e90679a7fd4a2a686f628d43e4579b54e0f65b7) )
	ROM_LOAD16_BYTE( "95400469.lo", 0x00001, 0x080000, CRC(475554d3) SHA1(1979061e8abf24a7e36053ad206b8dcb92bba864) )
	ROM_LOAD16_BYTE( "95400470.hi", 0x00000, 0x080000, CRC(0f19fa57) SHA1(76aaba9e09fb7d545a8cf7082604d0c462243410) )
	ROM_LOAD16_BYTE( "95400523.lo", 0x00001, 0x080000, CRC(3b4d349d) SHA1(954b47fa04737d73914c09712d58007de9660fc0) )
	ROM_LOAD16_BYTE( "95400524.hi", 0x00000, 0x080000, CRC(19a92a95) SHA1(0dcc4e22e80bea3ddc3d0f1df37340d319bf05c4) )
	ROM_LOAD16_BYTE( "95401033.p1", 0x0000, 0x080000, CRC(c4101114) SHA1(12db5bde5f2f5ed196205def4c94c2d9c7f01bbd) )
	ROM_LOAD16_BYTE( "95401034.p2", 0x0000, 0x080000, CRC(b14778f1) SHA1(7dea26452d7f30a0f1f16c1ad82e2e5362311ea7) )
	ROM_LOAD16_BYTE( "95401035.p1", 0x0000, 0x080000, CRC(7487f54a) SHA1(2f9f2f39e7d23fe945d1ee12472003104a08fbde) )
	ROM_LOAD16_BYTE( "95401036.p2", 0x0000, 0x080000, CRC(ae8c3a9c) SHA1(c79ad8ac58971532f4dbbad555928651c3b33b30) )
	ROM_LOAD16_BYTE( "95401043.lo", 0x00001, 0x080000, CRC(025dd133) SHA1(3e489f1d9e521b2fcec201eb8988168978d9b48b) )
	ROM_LOAD16_BYTE( "95401044.hi", 0x00000, 0x080000, CRC(6a9662cd) SHA1(014fa14fc756cca096b57d56f0fdf660b316a669) )
	ROM_LOAD16_BYTE( "95401045.lo", 0x00001, 0x080000, CRC(188cf175) SHA1(4771852ac5ece7a40e0ab434d3126c278bb71a56) )
	ROM_LOAD16_BYTE( "95401046.hi", 0x00000, 0x080000, CRC(8b838089) SHA1(703ce9992b66c38da83dc1af29c8ec39b2067261) )
	ROM_LOAD16_BYTE( "95401467.lo", 0x00001, 0x080000, CRC(fe7ced21) SHA1(88da3772f7af86ec8c24b4e428dbe6a0faf33139) )
	ROM_LOAD16_BYTE( "95401468.hi", 0x00000, 0x080000, CRC(be12082b) SHA1(694a534046f0595562e370b18db60a7c40e84e57) )
	ROM_LOAD16_BYTE( "95401469.lo", 0x00001, 0x080000, CRC(39932455) SHA1(21d7a1653484811e344eaa8e568abcf48270d220) )
	ROM_LOAD16_BYTE( "95401470.hi", 0x00000, 0x080000, CRC(3acac8e3) SHA1(7b2289a1b011cf7ad0f777871c78525f98fd5ac7) )
	ROM_LOAD16_BYTE( "95401523.lo", 0x00001, 0x080000, CRC(db54920d) SHA1(1ac7b7e011b27528404c7e2ef42796b23f015eba) )
	ROM_LOAD16_BYTE( "95401524.hi", 0x00000, 0x080000, CRC(fe592c88) SHA1(16b79165f2847c74e6708b17be6cc725382129d9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "daylsnd1.bin", 0x0000, 0x080000, CRC(4510d156) SHA1(b001bdf3bfad6124647f640065b411c07c8cf555) )
	ROM_LOAD( "daylsnd2.bin", 0x0000, 0x080000, CRC(71a1428f) SHA1(029ae979f192bcd7704ae78aba14815acdabe60f) )
ROM_END




ROM_START( sc_dnd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418428.lo", 0x00001, 0x080000, CRC(e3402379) SHA1(54eb1c75e174083fb6e913c231706fd192ca8b22) )
	ROM_LOAD16_BYTE( "95418429.hi", 0x00000, 0x080000, CRC(a7c8a115) SHA1(987485c9db6b9e05b6fc60307535533a931db7f2) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418430.lo", 0x00001, 0x080000, CRC(16632394) SHA1(76fc5f14d2b0895959580979d9973094fa10c63a) )
	ROM_LOAD16_BYTE( "95418431.hi", 0x00000, 0x080000, CRC(25e91233) SHA1(8814c4f48299f07e1836ff4e86ceead5fc91e7c9) )
	ROM_LOAD16_BYTE( "95418446.lo", 0x00001, 0x080000, CRC(bb3df08e) SHA1(d1ae172cff3776b008d1b08772e2589dcc06f75e) )
	ROM_LOAD16_BYTE( "95418447.hi", 0x00000, 0x080000, CRC(03ade18d) SHA1(c74f431245c1854577232c1c10b3a9868e59d38f) )
	ROM_LOAD16_BYTE( "95418528.lo", 0x00001, 0x080000, CRC(d0192ab5) SHA1(b1e98d901ea0ea0010f02e76c296418da775a8c6) )
	ROM_LOAD16_BYTE( "95418529.hi", 0x00000, 0x080000, CRC(10ce1fa8) SHA1(a207f8c1b4fa40f95f5c3cba64648f87efa5d903) )
	ROM_LOAD16_BYTE( "95418582.lo", 0x00001, 0x080000, CRC(e77addb2) SHA1(37655aba352008d468b0b155a8178addf1f1bb85) )
	ROM_LOAD16_BYTE( "95418583.hi", 0x00000, 0x080000, CRC(01c82328) SHA1(367ae0f2b4b08d194c567ea48f4576f68c921dde) )
	ROM_LOAD16_BYTE( "95418610.lo", 0x00001, 0x080000, CRC(6b25fe94) SHA1(f926758df4fceb8422fb6165497d5353cb51355b) )
	ROM_LOAD16_BYTE( "95418611.hi", 0x00000, 0x080000, CRC(b1dd987d) SHA1(46e8e8015da8cdee87c202fbdfaf5b5ab157fcef) )
	ROM_LOAD16_BYTE( "95418624.lo", 0x00001, 0x080000, CRC(d92cc819) SHA1(dbb5879b5290d3c217b237bd4c59865cf57e154c) )
	ROM_LOAD16_BYTE( "95418625.hi", 0x00000, 0x080000, CRC(52f037cf) SHA1(0a4b8b2937577b103cf1e4eb47234687aae643c3) )
	ROM_LOAD16_BYTE( "95418626.lo", 0x00001, 0x080000, CRC(8825bac7) SHA1(b732499056718e0002e69ad92fd1a0dc1ddecfee) )
	ROM_LOAD16_BYTE( "95418627.hi", 0x00000, 0x080000, CRC(38dde058) SHA1(74c729a4f7597a38ed645a638d1f09ab13b1fa93) )
	ROM_LOAD16_BYTE( "95418628.lo", 0x00001, 0x080000, CRC(534e6f8b) SHA1(8b89b691eac6415344e5e91a6682cd2030ffba6e) )
	ROM_LOAD16_BYTE( "95418708.lo", 0x00001, 0x080000, CRC(30a98bc2) SHA1(5caf982d2853ce39294445ab89474906e2e41981) )
	ROM_LOAD16_BYTE( "95418709.hi", 0x00000, 0x080000, CRC(9c657c50) SHA1(e72296e193693c3a9ff33632fb0db9c64fe75a97) )
	ROM_LOAD16_BYTE( "95418740.lo", 0x00001, 0x080000, CRC(d1cc7151) SHA1(c350c2a61e6dc927fdde3f57dadf07ffb7a74172) )
	ROM_LOAD16_BYTE( "95418741.hi", 0x00000, 0x080000, CRC(369f411b) SHA1(e24e60c2707a99e664b049bb2bace837423871ab) )
	ROM_LOAD16_BYTE( "95418752.lo", 0x00001, 0x080000, CRC(ea381dee) SHA1(e68557b00fbbac86d7c153470050da0980751fa1) )
	ROM_LOAD16_BYTE( "95418753.hi", 0x00000, 0x080000, CRC(de953115) SHA1(98443f633997be3e7a8c43e6692a9dd0c4fcf0b1) )
	ROM_LOAD16_BYTE( "95419428.lo", 0x00001, 0x080000, CRC(72a46f10) SHA1(933a5990fbe1ede6f3527315d8ea111e2814fa83) )
	ROM_LOAD16_BYTE( "95419429.hi", 0x00000, 0x080000, CRC(7aadaaed) SHA1(19c452644db9da1ed5741173473b23a95e2133f5) )
	ROM_LOAD16_BYTE( "95419430.lo", 0x00001, 0x080000, CRC(1a510dfc) SHA1(e4620c76a56539e93d90d7f9729b4daab2278256) )
	ROM_LOAD16_BYTE( "95419431.hi", 0x00000, 0x080000, CRC(d4f546b5) SHA1(10d9df4dec30f9f1a9ffecd8c74de491a20ddf56) )
	ROM_LOAD16_BYTE( "95419446.lo", 0x00001, 0x080000, CRC(7f5dc09c) SHA1(022d368063398c3ec206c5576fff54e20ffc73c3) )
	ROM_LOAD16_BYTE( "95419447.hi", 0x00000, 0x080000, CRC(dd8b1ee5) SHA1(8d59e3f762dd4338706017d1717d06a7a718fbd9) )
	ROM_LOAD16_BYTE( "95419528.lo", 0x00001, 0x080000, CRC(0498ed27) SHA1(cab277385393410dbe54a72f7f778d67aeb42ba1) )
	ROM_LOAD16_BYTE( "95419529.hi", 0x00000, 0x080000, CRC(524a6e36) SHA1(0f8639a83eefcb3cf8f7541a2a77e984cf1688d5) )
	ROM_LOAD16_BYTE( "95419582.lo", 0x00001, 0x080000, CRC(43e7545f) SHA1(53356002ab07f5e9e1df13eef1f1b65c44a9b7b7) )
	ROM_LOAD16_BYTE( "95419583.hi", 0x00000, 0x080000, CRC(39bf2015) SHA1(1884f7f79c5e6cc6b78929d7f4e743dd02fceddc) )
	ROM_LOAD16_BYTE( "95419610.lo", 0x00001, 0x080000, CRC(cfb87779) SHA1(c8df9cce5f3bc58fad35702f653f1ea5613f3cac) )
	ROM_LOAD16_BYTE( "95419611.hi", 0x00000, 0x080000, CRC(89aa9b40) SHA1(1369d2c92b41ecbf930c67adc1ca1ff74896d85c) )
	ROM_LOAD16_BYTE( "95419624.lo", 0x00001, 0x080000, CRC(ac6733b8) SHA1(7f67cdf1b3b8d3ac5d2424aadd9c81fe8340f613) )
	ROM_LOAD16_BYTE( "95419625.hi", 0x00000, 0x080000, CRC(a3733571) SHA1(3bbf7087b8446120f2f3e8d664efef5196ce9b0d) )
	ROM_LOAD16_BYTE( "95419626.lo", 0x00001, 0x080000, CRC(17b5d2ad) SHA1(7068b73fb1ec4a56d7121be4e548674ad2bb7ef6) )
	ROM_LOAD16_BYTE( "95419627.hi", 0x00000, 0x080000, CRC(39e34c28) SHA1(b75456e108c8acf363cd83f80be294b6bfecce90) )
	ROM_LOAD16_BYTE( "95419628.lo", 0x00001, 0x080000, CRC(5a6f07e9) SHA1(db21ee37d9a4fd421593fc9eb8ef27bad6788c4e) )
	ROM_LOAD16_BYTE( "95419629.hi", 0x00000, 0x080000, CRC(cdf330d0) SHA1(aa5030ae3ec64ce4ead9688e51bfcd8ff1bbf543) )
	ROM_LOAD16_BYTE( "95419708.lo", 0x00001, 0x080000, CRC(2c553048) SHA1(6c550e359226386612163f0a018ce20c66af530a) )
	ROM_LOAD16_BYTE( "95419709.hi", 0x00000, 0x080000, CRC(872d1f42) SHA1(bb249b3aadfb8448d144f36bbda7397ff7464057) )
	ROM_LOAD16_BYTE( "95419740.lo", 0x00001, 0x080000, CRC(be5583a6) SHA1(62889d112060f7876fee9d88315a6f6082ac3a81) )
	ROM_LOAD16_BYTE( "95419741.hi", 0x00000, 0x080000, CRC(d051eb76) SHA1(7fb107cfdd628f2196e15b98b38eb90540883ddf) )
	ROM_LOAD16_BYTE( "95419752.lo", 0x00001, 0x080000, CRC(c06b60aa) SHA1(b40e4412db1f57511e0b2586fd65df56874a23bb) )
	ROM_LOAD16_BYTE( "95419753.hi", 0x00000, 0x080000, CRC(76da2127) SHA1(2a06c5fb329a6045671f92073c2e1dd78dc79769) )
	ROM_LOAD16_BYTE( "95422013.hi", 0x00000, 0x080000, CRC(8a511e54) SHA1(c377ee713618348ba2a9983c7556c9f3adba9e92) )
	ROM_LOAD16_BYTE( "95422024.lo", 0x00001, 0x080000, CRC(b5481bbb) SHA1(43e6e81e0ddcf6f2bf6bf301348cf17f37ec7d6c) )
	ROM_LOAD16_BYTE( "95422025.hi", 0x00000, 0x080000, CRC(8a28b1a4) SHA1(bc895c4e3061f95c3136437df30a5d88df794146) )
	ROM_LOAD16_BYTE( "95422028.lo", 0x00001, 0x080000, CRC(55ecfc66) SHA1(ba6b8befe37318ecec9cce1ea3029afa701f1cff) )
	ROM_LOAD16_BYTE( "95422035.hi", 0x00000, 0x080000, CRC(3212c177) SHA1(a627628ae1ceab8cc933e6591a36b41a3c1c651a) )
	ROM_LOAD16_BYTE( "95422036.lo", 0x00001, 0x080000, CRC(b1d048dc) SHA1(bde75f8797ebd668eb8c9cf6c05da562874df540) )
	ROM_LOAD16_BYTE( "95422037.hi", 0x00000, 0x080000, CRC(2d881f97) SHA1(aec94590f8cd7d21b386804b05bd53c9dee17968) )
	ROM_LOAD16_BYTE( "95422038.lo", 0x00001, 0x080000, CRC(c75da829) SHA1(b240a1aa1056c3227a23ae1df37eacece7832a97) )
	ROM_LOAD16_BYTE( "95422440.lo", 0x00001, 0x080000, CRC(a4c27e23) SHA1(1de762b8e78da0249c36316f3af25c5c2ee1c68f) )
	ROM_LOAD16_BYTE( "95422441.hi", 0x00000, 0x080000, CRC(7a8e9785) SHA1(4510a86664d6c50c1b62d63c679fde203bfb31ef) )
	ROM_LOAD16_BYTE( "95422442.lo", 0x00001, 0x080000, CRC(77d044a9) SHA1(e13af74b1aa5a35e0a041607ea4fd9a3e472c173) )
	ROM_LOAD16_BYTE( "95422443.hi", 0x00000, 0x080000, CRC(1b40f9e2) SHA1(1bdeeb429e4669964d805d3cb0f22038427dd567) )
	ROM_LOAD16_BYTE( "95422450.lo", 0x00001, 0x080000, CRC(d300fe2c) SHA1(f2a5770d5c51a316fdbe31fa588eaccf94cb6639) )
	ROM_LOAD16_BYTE( "95422451.hi", 0x00000, 0x080000, CRC(af1e0a64) SHA1(e494bb57cb26100ce31b9ef2b9ab1963d434973d) )
	ROM_LOAD16_BYTE( "95422564.lo", 0x00001, 0x080000, CRC(1f63b69b) SHA1(733cb1959e4f63b7a45ba39e93375d49271cc2ba) )
	ROM_LOAD16_BYTE( "95422565.hi", 0x00000, 0x080000, CRC(dbf27ae1) SHA1(4bd2be6f2fccf050bbbd2ea4d0a5b4246ca9da2c) )
	ROM_LOAD16_BYTE( "95422568.lo", 0x00001, 0x080000, CRC(2999d09e) SHA1(806275be7850b48332fdb85f4d78e616a16c12ab) )
	ROM_LOAD16_BYTE( "95422569.hi", 0x00000, 0x080000, CRC(273c2338) SHA1(b44e176fa97b40975825cdb6b3f8dfa753535162) )
	ROM_LOAD16_BYTE( "95422832.lo", 0x00001, 0x080000, CRC(44fbc398) SHA1(dc84091f82a718401c967c25ffe756ae1186a38d) )
	ROM_LOAD16_BYTE( "95422833.hi", 0x00000, 0x080000, CRC(80729e3f) SHA1(6d5fd934548c6254ed2ec9c9c77ffcce1eca039b) )
	ROM_LOAD16_BYTE( "95422862.lo", 0x00001, 0x080000, CRC(41f7ba62) SHA1(a7ad0dfdc477194e09df97331b75309c7aa976ea) )
	ROM_LOAD16_BYTE( "95422863.hi", 0x00000, 0x080000, CRC(a7883de1) SHA1(812b17621f3ac4b0252b44ec32b81145b4212637) )
	ROM_LOAD16_BYTE( "95422866.lo", 0x00001, 0x080000, CRC(9fd063d1) SHA1(6e7dc034c2b6da609b5f200e4ede20faecf1104c) )
	ROM_LOAD16_BYTE( "95422867.hi", 0x00000, 0x080000, CRC(982b5826) SHA1(46be9e735c16300553a4b37d6d98ff97cdb43aed) )
	ROM_LOAD16_BYTE( "95422886.lo", 0x00001, 0x080000, CRC(1b926605) SHA1(f97b91c73dd330f1848a879faf949085c23d53b6) )
	ROM_LOAD16_BYTE( "95422887.hi", 0x00000, 0x080000, CRC(5f37e87a) SHA1(f1b86a3fb968be14787fb508d1fccb464cec2c4d) )
	ROM_LOAD16_BYTE( "95422890.lo", 0x00001, 0x080000, CRC(ae29311c) SHA1(1bdd12b2cd2e96d4704da044b251fdb111ee0cb1) )
	ROM_LOAD16_BYTE( "95422891.hi", 0x00000, 0x080000, CRC(d79559eb) SHA1(ef5f27b5b84bf1072f1b5a13ee17143a06515712) )
	ROM_LOAD16_BYTE( "95423013.hi", 0x00000, 0x080000, CRC(6ffa0b3f) SHA1(c66684d0e22be90d4300786a2163b85a7a50ba63) )
	ROM_LOAD16_BYTE( "95423024.lo", 0x00001, 0x080000, CRC(a825a790) SHA1(5bb676900881c93ef885e72c07a29b001a911a09) )
	ROM_LOAD16_BYTE( "95423025.hi", 0x00000, 0x080000, CRC(a98a0ead) SHA1(e1624b73b4f058edcdc3aa49f6ea55afd642938c) )
	ROM_LOAD16_BYTE( "95423028.lo", 0x00001, 0x080000, CRC(6a81fb48) SHA1(9e75c7601efd70aa91f9306b0ffd8d0a515912f6) )
	ROM_LOAD16_BYTE( "95423035.hi", 0x00000, 0x080000, CRC(848dd7bf) SHA1(64745b42a830fcb36cbe63f08a6e105605824677) )
	ROM_LOAD16_BYTE( "95423036.lo", 0x00001, 0x080000, CRC(e484b7fb) SHA1(6489fe890ca6cfeb4eb2043253c6bd0bab185724) )
	ROM_LOAD16_BYTE( "95423037.hi", 0x00000, 0x080000, CRC(e2c36879) SHA1(8978ed2c7c1510b62eedb0353e435b89b648670a) )
	ROM_LOAD16_BYTE( "95423038.lo", 0x00001, 0x080000, CRC(00adce65) SHA1(917a882f6e28198795ee056914433dd1ce361803) )
	ROM_LOAD16_BYTE( "95423440.lo", 0x00001, 0x080000, CRC(214d9f3a) SHA1(bf693dd08db022b51123dc0fdb07d16315444be0) )
	ROM_LOAD16_BYTE( "95423441.hi", 0x00000, 0x080000, CRC(4558b059) SHA1(cd37a546499b7314614edffb3e9f311cbcf8b510) )
	ROM_LOAD16_BYTE( "95423442.lo", 0x00001, 0x080000, CRC(a3b28d50) SHA1(42646bc8b3f8d36e9450f74fa7f77a67e60f82cc) )
	ROM_LOAD16_BYTE( "95423443.hi", 0x00000, 0x080000, CRC(0fb14bef) SHA1(3c80f62f86e0e248e8cc9cefc94e4d12c9cf63ca) )
	ROM_LOAD16_BYTE( "95423450.lo", 0x00001, 0x080000, CRC(6c884748) SHA1(72b458ef784c380d06074c3c5ae3dcbadd896307) )
	ROM_LOAD16_BYTE( "95423451.hi", 0x00000, 0x080000, CRC(f25bf41d) SHA1(47324b8c747405d68b193ca376929b3e49225037) )
	ROM_LOAD16_BYTE( "95423564.lo", 0x00001, 0x080000, CRC(13a2bc2d) SHA1(646dd4abff1c2a7f08aabcde1aa7850505f0893f) )
	ROM_LOAD16_BYTE( "95423565.hi", 0x00000, 0x080000, CRC(aa269dbc) SHA1(7b91147ebbc48d1ff6a79d16b381989db829add8) )
	ROM_LOAD16_BYTE( "95423832.lo", 0x00001, 0x080000, CRC(62329f06) SHA1(7d531a7afaa0e7a04969afb4f1ef765f8552af3d) )
	ROM_LOAD16_BYTE( "95423833.hi", 0x00000, 0x080000, CRC(ae915afa) SHA1(20938b42fa53c04ea4ac0eb563615bd1ce6f0725) )
	ROM_LOAD16_BYTE( "95423862.lo", 0x00001, 0x080000, CRC(758f1697) SHA1(ca40ee7d8f9d32745e1fb26f1d08fc3d7f9857f4) )
	ROM_LOAD16_BYTE( "95423863.hi", 0x00000, 0x080000, CRC(9ce6e813) SHA1(55ab2bba5b2bb356807e9b0182d5260b1b6efa10) )
	ROM_LOAD16_BYTE( "95423866.lo", 0x00001, 0x080000, CRC(f99b2b86) SHA1(f04e154c1887d4225075802e3618261bf444ae26) )
	ROM_LOAD16_BYTE( "95423867.hi", 0x00000, 0x080000, CRC(fe6b1130) SHA1(2de60e150829acde7f7f3453fd5397ed549ab421) )
	ROM_LOAD16_BYTE( "95423886.lo", 0x00001, 0x080000, CRC(6e0b8c7e) SHA1(cac697895f0a8a7d3a31389b7719a54eb300f465) )
	ROM_LOAD16_BYTE( "95423887.hi", 0x00000, 0x080000, CRC(8b04bb99) SHA1(fea2cd96a2cc0f7bf5439020a2fbc35ee26cc558) )
	ROM_LOAD16_BYTE( "95423890.lo", 0x00001, 0x080000, CRC(9b6d3415) SHA1(b14bc3ede63184f7d3be0703e7170f85671350d5) )
	ROM_LOAD16_BYTE( "95423891.hi", 0x00000, 0x080000, CRC(58c37a50) SHA1(09fde3c464bab08b95e2609cde64cf2fc4ddce7e) )
	ROM_LOAD16_BYTE( "95423940.lo", 0x00001, 0x080000, CRC(845e82af) SHA1(7ebbe59e8eafc3517806e72fd759a61da282e5fc) )
	ROM_LOAD16_BYTE( "95423941.hi", 0x00000, 0x080000, CRC(2aef2c9a) SHA1(8a940c6f6f3fe4ee6625012cf61bde7b78260ddd) )
	ROM_LOAD16_BYTE( "95426152.lo", 0x00001, 0x080000, CRC(b304710b) SHA1(443568b0acc8381992a1a8bfe77c9bed714fb05c) )
	ROM_LOAD16_BYTE( "95426153.hi", 0x00000, 0x080000, CRC(f02a1df7) SHA1(9fc0fc6ecc5287012cf9ad2e01c4781f91b9541c) )
	ROM_LOAD16_BYTE( "95426154.lo", 0x00001, 0x080000, CRC(17169e09) SHA1(e9e6752ab858c1d14253d27842c269c8e9e6fb5f) )
	ROM_LOAD16_BYTE( "95426155.hi", 0x00000, 0x080000, CRC(7eb7893e) SHA1(a97f35be2d494da19dcb6f4b235a83d46fabba3e) )
	ROM_LOAD16_BYTE( "95426168.lo", 0x00001, 0x080000, CRC(be51f52d) SHA1(e61b385c52ea1f2dca2c615518f9a419075d1a4e) )
	ROM_LOAD16_BYTE( "95426169.hi", 0x00000, 0x080000, CRC(c4c30953) SHA1(33645e956be7c5367dfab4704a7c8fbdd79f4126) )
	ROM_LOAD16_BYTE( "95426170.lo", 0x00001, 0x080000, CRC(99951add) SHA1(640401c6b412dd0d2a186a134e4fb77c92001614) )
	ROM_LOAD16_BYTE( "95426171.hi", 0x00000, 0x080000, CRC(eb65bbe5) SHA1(f8c384086a335a02985ed938b405fffd4aa37bbb) )
	ROM_LOAD16_BYTE( "95426464.lo", 0x00001, 0x080000, CRC(6dbb8ceb) SHA1(f79bc7f047ab5fca012d1d92672d34309ec159dc) )
	ROM_LOAD16_BYTE( "95426465.hi", 0x00000, 0x080000, CRC(89e9b45c) SHA1(246e69129bc80ec0263be7cd6dd02f859f550606) )
	ROM_LOAD16_BYTE( "95427152.lo", 0x00001, 0x080000, CRC(58da107f) SHA1(297916acc353ac2c70218b84a5ed870513d649f1) )
	ROM_LOAD16_BYTE( "95427153.hi", 0x00000, 0x080000, CRC(6f0b8161) SHA1(41f2454b05fb226720a813626b387b8f29a7e203) )
	ROM_LOAD16_BYTE( "95427154.lo", 0x00001, 0x080000, CRC(745ac559) SHA1(3fff27727fdf6b34f4500bc42dacacb9a807e848) )
	ROM_LOAD16_BYTE( "95427155.hi", 0x00000, 0x080000, CRC(15a28fd8) SHA1(4fe2fb60d447bfcc4996643badcf5440b76a951d) )
	ROM_LOAD16_BYTE( "95427168.lo", 0x00001, 0x080000, CRC(3f2659e2) SHA1(37db9a4c54fb790a5d4bc7b335c4b92e1d88261e) )
	ROM_LOAD16_BYTE( "95427169.hi", 0x00000, 0x080000, CRC(af31b846) SHA1(ac168ce36c09f1770520a2a9d3f4ace88f97c463) )
	ROM_LOAD16_BYTE( "95427170.lo", 0x00001, 0x080000, CRC(65cf387c) SHA1(3436e81927c00551d3eaa7d21922187ac9b93bf5) )
	ROM_LOAD16_BYTE( "95427171.hi", 0x00000, 0x080000, CRC(f4021af5) SHA1(15eb7c36da5ab02a14021ec02af5861431bb318b) )
	ROM_LOAD16_BYTE( "95427464.lo", 0x00001, 0x080000, CRC(ab9bc5f4) SHA1(c36f5b6acdce0432c0227832618cb0ab8fec3dd2) )
	ROM_LOAD16_BYTE( "95427465.hi", 0x00000, 0x080000, CRC(a744775e) SHA1(78591fa7a4c733a456d442903003e4dc3ab7ba8d) )
	ROM_LOAD16_BYTE( "p1964p01.hi", 0x00000, 0x080000, CRC(b99ee66e) SHA1(3f0a046661070b29604e85e29c233b31e5de1c83) )
	ROM_LOAD16_BYTE( "p1964p01.lo", 0x00001, 0x080000, CRC(50480af0) SHA1(fbd5dd20e7e23700d4e039a1a9b17e8d83b86421) )
	ROM_LOAD16_BYTE( "p1964p12.hi", 0x00000, 0x080000, CRC(44c95076) SHA1(aa0bd2dff04e5d1c8973612fb57c88095eb2b40e) )
	ROM_LOAD16_BYTE( "p1964p12.lo", 0x00001, 0x080000, CRC(fcf337ed) SHA1(fc4bf9d1564e54f23f4d9c216c1ec2587c846c47) )
	ROM_LOAD16_BYTE( "p1964p13.hi", 0x00000, 0x080000, CRC(84e732e0) SHA1(80bb7f1046791f94f895fa14b4c5fc7b768e81db) )
	ROM_LOAD16_BYTE( "p1964p13.lo", 0x00001, 0x080000, CRC(6028bc0d) SHA1(f060e2bd4ad362a6e99ccc44b965fc1d5389e137) )
	ROM_LOAD16_BYTE( "p1964p14.hi", 0x00000, 0x080000, CRC(7af2660b) SHA1(692532287053cc899bcf94bebb5526fda5e094b4) )
	ROM_LOAD16_BYTE( "p1964p14.lo", 0x00001, 0x080000, CRC(f2786267) SHA1(a7fcfe231284c142a8bdb6a4361b5bcff9cf168b) )
	ROM_LOAD16_BYTE( "p1964p21.hi", 0x00000, 0x080000, CRC(a32b78aa) SHA1(1acd470d7023dfce9a88f74cf28cce939dac4d5b) )
	ROM_LOAD16_BYTE( "p1964p21.lo", 0x00001, 0x080000, CRC(e8dc4915) SHA1(d1ba8c081cf2ea3fd95e7a8d296239e18fde9908) )
	ROM_LOAD16_BYTE( "p1964pa2.hi", 0x00000, 0x080000, CRC(039d2202) SHA1(74dff4553a67cde468655b849f67c08f9bbeba00) )
	ROM_LOAD16_BYTE( "p1964pa2.lo", 0x00001, 0x080000, CRC(d59725a5) SHA1(50babe37853e776c88e2be9b44a4422e3391f2dc) )
	ROM_LOAD16_BYTE( "p1964pa3.hi", 0x00000, 0x080000, CRC(a1dab479) SHA1(2be3549906ac681842a5269e6014e78cc95715e4) )
	ROM_LOAD16_BYTE( "p1964pa3.lo", 0x00001, 0x080000, CRC(24cb5334) SHA1(e0c1d3ad6ca14a9ab66531dabf70f2cc4c7d2166) )
	ROM_LOAD16_BYTE( "p1964pa5.hi", 0x00000, 0x080000, CRC(d3a4858d) SHA1(bb818752ae761c7ff379df4903eb2771b05d059f) )
	ROM_LOAD16_BYTE( "p1964pa5.lo", 0x00001, 0x080000, CRC(dc8a4f2b) SHA1(18883c15fb9ed19a3ee7b436fa8327be942fdd29) )
	ROM_LOAD16_BYTE( "p1964pb1.hi", 0x00000, 0x080000, CRC(658e3793) SHA1(4b142c79031d053a614c62c964e02645bb6d28dd) )
	ROM_LOAD16_BYTE( "p1964pb1.lo", 0x00001, 0x080000, CRC(04eface9) SHA1(7a3f93c63d6cfa5b7814d76fd875f704ec617df4) )
	ROM_LOAD16_BYTE( "p1964s01.hi", 0x00000, 0x080000, CRC(d0fcdf89) SHA1(00ff2b7131ec0f3d87f58aa843f9a1aad2c33f61) )
	ROM_LOAD16_BYTE( "p1964s01.lo", 0x00001, 0x080000, CRC(549c0843) SHA1(f706cbc7be60a1261304398d876ef10ad695ad5d) )
	ROM_LOAD16_BYTE( "p1964s12.hi", 0x00000, 0x080000, CRC(f4d29330) SHA1(b86e601fb176ed963d6ef68e76f4d306b595e911) )
	ROM_LOAD16_BYTE( "p1964s12.lo", 0x00001, 0x080000, CRC(6efc8f49) SHA1(b13bd8f7f740f27a79c583d51c398c481081ea81) )
	ROM_LOAD16_BYTE( "p1964s13.hi", 0x00000, 0x080000, CRC(45935f32) SHA1(25d5411d8d247075ee3421f65e2d2a6c51451848) )
	ROM_LOAD16_BYTE( "p1964s13.lo", 0x00001, 0x080000, CRC(1ae19e19) SHA1(05e0ee034e7185b51f0e1b6ef77ae8670b020cbf) )
	ROM_LOAD16_BYTE( "p1964s14.hi", 0x00000, 0x080000, CRC(14319187) SHA1(9f678b14287c96dc586259d1a6ecda91cc62e434) )
	ROM_LOAD16_BYTE( "p1964s14.lo", 0x00001, 0x080000, CRC(24e13c44) SHA1(53e0c49e510245615bb6cd5acf6bf5b8cc8de173) )
	ROM_LOAD16_BYTE( "p1964s21.hi", 0x00000, 0x080000, CRC(0a12b6c4) SHA1(4a5ff6647d3e63aaf917d9d21dabe270dab179d1) )
	ROM_LOAD16_BYTE( "p1964s21.lo", 0x00001, 0x080000, CRC(e77a2694) SHA1(1cdcf91b5a7d6ec252af19930c9533798e1679a6) )
	ROM_LOAD16_BYTE( "p1964sa2.hi", 0x00000, 0x080000, CRC(361beeff) SHA1(cbd6aa20247df7b9e540b38b7e9199e557f62be7) )
	ROM_LOAD16_BYTE( "p1964sa2.lo", 0x00001, 0x080000, CRC(491d0137) SHA1(e5ad054adc7bbbb89bf7112d564f51b3c1924afa) )
	ROM_LOAD16_BYTE( "p1964sa3.hi", 0x00000, 0x080000, CRC(fcf198da) SHA1(60280812fd7148edfe52eb07f2c81b77384641a9) )
	ROM_LOAD16_BYTE( "p1964sa3.lo", 0x00001, 0x080000, CRC(be729a5a) SHA1(34d29c9d041b97a008112f6c18a194767f1839ca) )
	ROM_LOAD16_BYTE( "p1964sa5.hi", 0x00000, 0x080000, CRC(6e97cb56) SHA1(a6335601c8163430be430cff6d075562cc49200b) )
	ROM_LOAD16_BYTE( "p1964sa5.lo", 0x00001, 0x080000, CRC(80d9d806) SHA1(ae089e2618e80dac8afbb5b97b9c75512974488a) )
	ROM_LOAD16_BYTE( "p1964sb1.hi", 0x00000, 0x080000, CRC(03c6811c) SHA1(32ea6379932589076dec0bbdf5c9255c374ec334) )
	ROM_LOAD16_BYTE( "p1964sb1.lo", 0x00001, 0x080000, CRC(7254d4b6) SHA1(7f4ef8e05fddc1d03c3073ae7b3cb5894200a039) )
	ROM_LOAD16_BYTE( "p3003p42.hi", 0x00000, 0x080000, CRC(6884132e) SHA1(0a864012b36887de2dc1290bb93d533e45f7e85a) )
	ROM_LOAD16_BYTE( "p3003p42.lo", 0x00001, 0x080000, CRC(46fd164a) SHA1(c7c70773a1327200fa58818f3d23cabb48ab4ba5) )
	ROM_LOAD16_BYTE( "p3003s42.hi", 0x00000, 0x080000, CRC(f04b7cd3) SHA1(b3b2c77d6458d901da4aa7057f2c4a9bf67df759) )
	ROM_LOAD16_BYTE( "p3003s42.lo", 0x00001, 0x080000, CRC(71d96983) SHA1(e896334a9ea517bbc20eb06eb8682b7a884b37e6) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	// Regular
	ROM_LOAD( "95008606.bin", 0x0000, 0x100000, CRC(c63c8663) SHA1(4718baf87340fe93ccfe642a1a0cdb9d9dcac57f) ) // 0 (1907)  DOND SOUNDS 11
	ROM_LOAD( "95008607.bin", 0x0000, 0x100000, CRC(a615514f) SHA1(d4ff7d4fe6f1dd1d7b00cc504f90b2921aa5e8fb) ) // 1

	//  Casino
	ROM_LOAD( "95008631.bin", 0x0000, 0x100000, CRC(7208854a) SHA1(a02de60cfcbafe5da4f67596ab65237f5b5f41b7) ) // 0 (1954) DOND SOUNDS 11

	ROM_LOAD( "95008632.bin", 0x0000, 0x100000, CRC(fd81a317) SHA1(1e597fd58aab5a7a8321dc4daf138ee07b42c094) ) // 0 (1945) DOND SOUNDS 11
	ROM_LOAD( "95008633.bin", 0x0000, 0x100000, CRC(a7a445d4) SHA1(dbb1938c33ce654c2d4aa3b6af8c210f5aad2ae3) ) // 1

	//  Casino
	ROM_LOAD( "95008661.bin", 0x0000, 0x100000, CRC(2d9ebcd5) SHA1(d824a227420cbe616aca6e2fd279af691ddfd87a) ) // 0 (1945) DOND SOUNDS 12

	ROM_LOAD( "95008680.bin", 0x0000, 0x100000, CRC(9bd439d1) SHA1(5e71d04e5697e92998bae28f7352ea7742cafe07) ) // 0 (1964) DOND SOUNDS 11

	ROM_LOAD( "95008698.bin", 0x0000, 0x100000, CRC(8eea7754) SHA1(7612c128d6c062bba3477d55aee3089e1255f61e) ) // 0 (1964) DOND SOUNDS 12

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211141.bin", 0x0000, 0x1000000, CRC(ef885c23) SHA1(bf874a7d5df40bc89a77aeaf6e9fb849360efbb5) )
	ROM_LOAD( "39211152.bin", 0x0000, 0x1000000, CRC(2d9c8289) SHA1(c983a0ea439cd3281c6e9f39292ac9597055b385) )
	ROM_LOAD( "39211161.bin", 0x0000, 0x1000000, CRC(2c3e8205) SHA1(dd55563acf8390d4b75672c2aa91e373b27ac841) )
	ROM_LOAD( "39211162.bin", 0x0000, 0x1000000, CRC(6ec309e4) SHA1(5e3bd4b7c3bd4714ac642642fbe918b0a12e2fff) )
	ROM_LOAD( "39211171.bin", 0x0000, 0x1000000, CRC(a80f967a) SHA1(bc8dc5c2d30ec38a9119d577114f5e5813f38749) )
	ROM_LOAD( "39212141.bin", 0x0000, 0x1000000, CRC(cd2b9a5c) SHA1(ce616657c0caec5b7a4418acd6c7af008e04fd9d) )
	ROM_LOAD( "39212152.bin", 0x0000, 0x1000000, CRC(ddc8ec20) SHA1(b009420fd3ba202b9cf1782b44e682de0c706cb8) )
	ROM_LOAD( "39212153.bin", 0x0000, 0x1000000, CRC(7dee1072) SHA1(03f28c90a594b909255d8fb4bf2cdaba2f70c60b) )
	ROM_LOAD( "39212161.bin", 0x0000, 0x1000000, CRC(5e5d63f4) SHA1(116a90f124700d434d0b7291451ee8759b3ca0d0) )
	ROM_LOAD( "39212162.bin", 0x0000, 0x1000000, CRC(b55998b9) SHA1(925a311954b1c0daf9f38eaaac33d861eb6259df) )
	ROM_LOAD( "39212171.bin", 0x0000, 0x1000000, CRC(666fe2b4) SHA1(8baf5f8682f3937b4b49f8db93f3a21e8764c990) )
	ROM_LOAD( "p1945p41.bin", 0x0000, 0x1000000, CRC(f8fbf79e) SHA1(1c1c351443373a1cf95c9ec3fe95f4b84645ece9) )
	ROM_LOAD( "p1945p42.bin", 0x0000, 0x1000000, CRC(7a95bf89) SHA1(274feb54f50a59a8dc1352cee27e4330b58431dd) )
	ROM_LOAD( "p1945p43.bin", 0x0000, 0x1000000, CRC(a0fc0903) SHA1(c51fda41eb3effd1f7052050a1104fc7fa9bfcbf) )
	ROM_LOAD( "p1945s41.bin", 0x0000, 0x1000000, CRC(f2767208) SHA1(7efcfc2456843c20c64185e4aed13067383e3f7a) )
	ROM_LOAD( "p1945s42.bin", 0x0000, 0x1000000, CRC(40f970c4) SHA1(59edf22b239686184a6170766969e0c6ec4f5a0e) )
	ROM_LOAD( "p1945s43.bin", 0x0000, 0x1000000, CRC(8c6dcf0e) SHA1(6503c58453f589077316d8bf3c5d07777fea0fdd) )
	ROM_LOAD( "p1965p01.bin", 0x0000, 0x1000000, CRC(2f0777f1) SHA1(30d6b3f4a38114fcb51203f86b2784e67b9f7d52) )
	ROM_LOAD( "p1965p12.bin", 0x0000, 0x1000000, CRC(3a5e9a27) SHA1(73decbe70f15329844c78b81052657523302fcbc) )
	ROM_LOAD( "p1965s01.bin", 0x0000, 0x1000000, CRC(1d9c2051) SHA1(e70c414e95995fcbce800e2a16049d3550ae6d1c) )
	ROM_LOAD( "p1965s12.bin", 0x0000, 0x1000000, CRC(c4f520a3) SHA1(ed2655cf024f6c1d2579701cc24b606ca7be05ae) )
ROM_END




ROM_START( sc_dndbb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422662.lo", 0x00001, 0x080000, CRC(11343f00) SHA1(65664a87d704cfb14088080d8be1e3f66ecc3f4a) )
	ROM_LOAD16_BYTE( "95422663.hi", 0x00000, 0x080000, CRC(211f19ea) SHA1(d5ec234083472160100c51b19b32a490d4aa0c6c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422664.lo", 0x00001, 0x080000, CRC(af24377d) SHA1(9c1f8373071de8eca8a498453375db26e27aa3e1) )
	ROM_LOAD16_BYTE( "95422665.hi", 0x00000, 0x080000, CRC(31e74642) SHA1(6b738af6d35af25cabb0e7cd7c5a011cae166788) )
	ROM_LOAD16_BYTE( "95422778.lo", 0x00001, 0x080000, CRC(739c07d7) SHA1(3e5d8fea4d357358f16b76f8a692df281d03cdaf) )
	ROM_LOAD16_BYTE( "95422779.hi", 0x00000, 0x080000, CRC(2000c2cf) SHA1(e72ac5615e194f9d691eb9ad88f84ef8f17894a5) )
	ROM_LOAD16_BYTE( "95423662.lo", 0x00001, 0x080000, CRC(789d483a) SHA1(665af3ff6bd5fe8f392932d7dcd4b978255bcf80) )
	ROM_LOAD16_BYTE( "95423663.hi", 0x00000, 0x080000, CRC(67bf5bfe) SHA1(e76e8ffb350c71f643f3e599201bc3d00faca51f) )
	ROM_LOAD16_BYTE( "95423664.lo", 0x00001, 0x080000, CRC(06e23750) SHA1(1973d9b37d3c2d73885cbb847fe98e56a635b006) )
	ROM_LOAD16_BYTE( "95423665.hi", 0x00000, 0x080000, CRC(c9ab6972) SHA1(60721c3c0bed04ae3c19bbaf59b993a8f7ea5df7) )
	ROM_LOAD16_BYTE( "95423778.lo", 0x00001, 0x080000, CRC(55a5b079) SHA1(a3739f8e753bf050b67c43dd27d71a53f5bc5b01) )
	ROM_LOAD16_BYTE( "95423779.hi", 0x00000, 0x080000, CRC(3bce6107) SHA1(7f7b11ff409cf3010cb821d5ed8cbc66a25ba8a8) )
	ROM_LOAD16_BYTE( "95426048.lo", 0x00001, 0x080000, CRC(e5ec350e) SHA1(8726e7aa69db463c739cdfbbd092a489bfcc8466) )
	ROM_LOAD16_BYTE( "95426049.hi", 0x00000, 0x080000, CRC(9bf0ea8f) SHA1(5333a23a1b067b4836f6dbe7c34868802078c217) )
	ROM_LOAD16_BYTE( "95426050.lo", 0x00001, 0x080000, CRC(db98f3e1) SHA1(72494a2a7a00ccc474e039f68ec107f230c2e104) )
	ROM_LOAD16_BYTE( "95426051.hi", 0x00000, 0x080000, CRC(fa0b3bff) SHA1(9142a3ba525268f56b75b424816524c33bb1df3a) )
	ROM_LOAD16_BYTE( "95426308.lo", 0x00001, 0x080000, CRC(959cffe8) SHA1(8600b48081c84eafcdd5cbf3d4047c1713f64253) )
	ROM_LOAD16_BYTE( "95426309.hi", 0x00000, 0x080000, CRC(6038fd5c) SHA1(b8f36483334f2fb215cc5be4f75d9895a1ed4ac0) )
	ROM_LOAD16_BYTE( "95426392.lo", 0x00001, 0x080000, CRC(6708a3ef) SHA1(f8838e9dc0d6cad1178632574a99eb423a69a6a0) )
	ROM_LOAD16_BYTE( "95426393.hi", 0x00000, 0x080000, CRC(8a857a9b) SHA1(7cf7802a0aa985b7278098264c950f7a75e8661b) )
	ROM_LOAD16_BYTE( "95426414.lo", 0x00001, 0x080000, CRC(e1cd19de) SHA1(f0a08fd513b96742970abedabea4d4ba6cc8b05b) )
	ROM_LOAD16_BYTE( "95426415.hi", 0x00000, 0x080000, CRC(542e1930) SHA1(d99e54c17147374cbf153c6ed52df9be6d4e03ba) )
	ROM_LOAD16_BYTE( "95427048.lo", 0x00001, 0x080000, CRC(3b362075) SHA1(b7f1c480b790a5e2495ec32d32528e2c5c5c8693) )
	ROM_LOAD16_BYTE( "95427049.hi", 0x00000, 0x080000, CRC(f6552779) SHA1(e70cfd6882ae11ea3cf91a76e9bb6ac2df3e3869) )
	ROM_LOAD16_BYTE( "95427050.lo", 0x00001, 0x080000, CRC(72dbb305) SHA1(0cafd52a51ec69b0a30823c972230801c59a9575) )
	ROM_LOAD16_BYTE( "95427051.hi", 0x00000, 0x080000, CRC(020a5849) SHA1(14b2eee9e624a90b74fd9b71f10f8d677a71cfb8) )
	ROM_LOAD16_BYTE( "95427308.lo", 0x00001, 0x080000, CRC(beaec88a) SHA1(dbf04c3a2eca9a36a55579b42da2297754d4b455) )
	ROM_LOAD16_BYTE( "95427309.hi", 0x00000, 0x080000, CRC(f5ae80ed) SHA1(4d3353318c29ef7e6b14246177833c46632404d0) )
	ROM_LOAD16_BYTE( "95427392.lo", 0x00001, 0x080000, CRC(b03acc5a) SHA1(26b9a8a002dcd6fbc016e5f7b1097c6c77fbb849) )
	ROM_LOAD16_BYTE( "95427393.hi", 0x00000, 0x080000, CRC(0a0785c3) SHA1(63dca03f9146d55287c95ce199705e1ab8a5af31) )
	ROM_LOAD16_BYTE( "95427414.lo", 0x00001, 0x080000, CRC(40f21aca) SHA1(0120c77b4812970d2624e85c05c5195956a1716d) )
	ROM_LOAD16_BYTE( "95427415.hi", 0x00000, 0x080000, CRC(f218587b) SHA1(1ecb5c781fddc4639d4966ff2ecf360d38a9a1e6) )
	ROM_LOAD16_BYTE( "p3209p11.hi", 0x00000, 0x080000, CRC(ad8b4195) SHA1(78ee9b45aae3515c5a0d5cbde3c776fcad71036f) )
	ROM_LOAD16_BYTE( "p3209p11.lo", 0x00001, 0x080000, CRC(73e5f820) SHA1(d19ce0b2a1b696e3838f89e60d0c380a15e0e036) )
	ROM_LOAD16_BYTE( "p3209s11.hi", 0x00000, 0x080000, CRC(9415d4e3) SHA1(b56f192eca0e540c6a84aaa04fe711e46afdbb7e) )
	ROM_LOAD16_BYTE( "p3209s11.lo", 0x00001, 0x080000, CRC(59ce4bb8) SHA1(2e60656b151f00501b040f99cd42dd6126cedde1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008788.bin", 0x0000, 0x100000, CRC(51384d64) SHA1(3af87bcc7fb4881ae671d9cbb484fb6a2a534cce) )
	ROM_LOAD( "95008789.bin", 0x0000, 0x100000, CRC(4f2d72c3) SHA1(f167ad8d7178682833e7e9efcc393b5826108d70) )
ROM_END



ROM_START( sc_dndcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418402.lo", 0x00001, 0x080000, CRC(afd68b50) SHA1(2553aeaeb344bc659da4faf1522a883e5da6962b) )
	ROM_LOAD16_BYTE( "95418403.hi", 0x00000, 0x080000, CRC(47c7a8b5) SHA1(1117caaf9ebf651f0f8988c0a79a0dda2b08e769) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418404.lo", 0x00001, 0x080000, CRC(ed598e25) SHA1(05d5c0224ff341bbb330ba6dd1dcf303c197439c) )
	ROM_LOAD16_BYTE( "95418405.hi", 0x00000, 0x080000, CRC(4d8b9a91) SHA1(e212d79da66e5dc33da8cca75654857763b02071) )
	ROM_LOAD16_BYTE( "95418406.lo", 0x00001, 0x080000, CRC(08151444) SHA1(325e0c3967995bd1b834ae650caefbf6e24059b0) )
	ROM_LOAD16_BYTE( "95418407.hi", 0x00000, 0x080000, CRC(40eb2214) SHA1(8f999222e8aa5706fef8ec789242983eec4b351b) )
	ROM_LOAD16_BYTE( "95418702.lo", 0x00001, 0x080000, CRC(d14266fd) SHA1(96c00ef152e557eacb4c27e51f3c034aecf5057b) )
	ROM_LOAD16_BYTE( "95418703.hi", 0x00000, 0x080000, CRC(9b98c457) SHA1(a4729864939793a3311115ecd2aa43d69d979ede) )
	ROM_LOAD16_BYTE( "95418892.lo", 0x00001, 0x080000, CRC(2368bbb6) SHA1(61a13578ac2516c9821ba875691c1f8009785b03) )
	ROM_LOAD16_BYTE( "95418893.hi", 0x00000, 0x080000, CRC(1c2d5159) SHA1(3bafb9c60a9f4237f89519fa07158f53000c08a8) )
	ROM_LOAD16_BYTE( "95418991.hi", 0x00000, 0x080000, CRC(94612065) SHA1(562faef92e2f7d44e06a8cc9d11f7ad041f0ef49) )
	ROM_LOAD16_BYTE( "95418992.lo", 0x00001, 0x080000, CRC(2bddf06e) SHA1(59e2c78e8da681fa842605b4834eb2e1440f9ad7) )
	ROM_LOAD16_BYTE( "95419402.lo", 0x00001, 0x080000, CRC(d04aaebd) SHA1(c598dcde46b20760ce3af55820b9c9026ceeb062) )
	ROM_LOAD16_BYTE( "95419403.hi", 0x00000, 0x080000, CRC(b59808a3) SHA1(8ffb0bea90b740a2845c4e88ea2479a479f6e8c6) )
	ROM_LOAD16_BYTE( "95419404.lo", 0x00001, 0x080000, CRC(b618fb02) SHA1(5602b6aca6be28e539e158e0efd67e90762e27dd) )
	ROM_LOAD16_BYTE( "95419405.hi", 0x00000, 0x080000, CRC(5a59647a) SHA1(3f3ad2dd60ddf7d22debebfa105f2f866bab4858) )
	ROM_LOAD16_BYTE( "95419406.lo", 0x00001, 0x080000, CRC(5a4f938b) SHA1(db7d5bad6af7cf116b6c74ff236538d7916fce9c) )
	ROM_LOAD16_BYTE( "95419407.hi", 0x00000, 0x080000, CRC(ca3aa841) SHA1(5e9e87aff7b0d4ba2f3a005803aec726eb5abbbe) )
	ROM_LOAD16_BYTE( "95419702.lo", 0x00001, 0x080000, CRC(fd9d2ffc) SHA1(1339b014b2ce00db1debdd1e9114924cead84058) )
	ROM_LOAD16_BYTE( "95419703.hi", 0x00000, 0x080000, CRC(c0b6d803) SHA1(89564578207c769065069ba6d498c40cf00a0d11) )
	ROM_LOAD16_BYTE( "95419892.lo", 0x00001, 0x080000, CRC(6fb61650) SHA1(2a89170ddca11fb86edb5072ed4841260c7b1501) )
	ROM_LOAD16_BYTE( "95419893.hi", 0x00000, 0x080000, CRC(ec0fa9af) SHA1(880aebf71e327ea4275c4ddc0756143e807ee98a) )
	ROM_LOAD16_BYTE( "95419991.hi", 0x00000, 0x080000, CRC(69ba0af5) SHA1(2468d881695f9fba308a72f1d4ea202d43b3da9b) )
	ROM_LOAD16_BYTE( "95419992.lo", 0x00001, 0x080000, CRC(79d9ebe5) SHA1(cc0e75af683a742407de65d2854644a9be9937df) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	// club dond
	ROM_LOAD( "95008629.bin", 0x0000, 0x100000, CRC(6f7cf500) SHA1(bf3db728872251116b32aa2c44f72a87d29b13d2) )
	ROM_LOAD( "95008630.bin", 0x0000, 0x100000, CRC(5dfda41e) SHA1(6d61d0eedc6a1599777f47d3880689f954f326c9) )
	// beat the banker
	ROM_LOAD( "95008713.bin", 0x0000, 0x100000, CRC(7311db5e) SHA1(24a4b3f44fa6dbbe756b0acac2b513c6e92cdf26) )
	ROM_LOAD( "95008714.bin", 0x0000, 0x100000, CRC(c6ebc845) SHA1(6a135f42940b8c44422736650e369fa12b51e0df) )
	// twin
	ROM_LOAD( "95008727.bin", 0x0000, 0x100000, CRC(b4c343a0) SHA1(d67faa1bcac1547cdc68874a411624f5c025cdbd) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211185.bin", 0x0000, 0x1000000, CRC(c29804d6) SHA1(6586056c1cbbf8089c72a3e3e433beeaa8e9c882) )
	ROM_LOAD( "39211194.bin", 0x0000, 0x1000000, CRC(2526cdfc) SHA1(6383ed07096b9c6438d957474a30d4f274e1db0c) )
	ROM_LOAD( "39211379.bin", 0x0000, 0x1000000, CRC(3b497e7c) SHA1(f8fc3cd4e03e8510146649b22e343284a480d349) )
	ROM_LOAD( "39212185.bin", 0x0000, 0x1000000, CRC(78a5adeb) SHA1(9b4fe8462a9ba8376a7543a7f7409593861465d0) )
	ROM_LOAD( "39212194.bin", 0x0000, 0x1000000, CRC(ebbad166) SHA1(8d1ddad198cd5c5ec40d75ea9ee97792eef5e32e) )
	ROM_LOAD( "39212379.bin", 0x0000, 0x1000000, CRC(d90dc869) SHA1(c85e857b965dba5675f8c3db4347b182949ce3a2) )
ROM_END



ROM_START( sc_dnddd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426042.lo", 0x00001, 0x080000, CRC(b89fdf2c) SHA1(4330486e29841bd04a1db2d6ca25adc8f8f2eb8d) )
	ROM_LOAD16_BYTE( "95426043.hi", 0x00000, 0x080000, CRC(e3f3fc13) SHA1(2b0af338866fe188aec75a02c106e2a38e4e5a9e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426256.lo", 0x00001, 0x080000, CRC(7a478879) SHA1(72c990648462280b1fceacaa1c417a3017b013e2) )
	ROM_LOAD16_BYTE( "95426257.hi", 0x00000, 0x080000, CRC(48b86836) SHA1(12497dd1a32f2dda146a53b89be56894499227e8) )
	ROM_LOAD16_BYTE( "95426300.lo", 0x00001, 0x080000, CRC(921e2253) SHA1(28869d93239dd79c1ee79c6a42554cb9f1a612b1) )
	ROM_LOAD16_BYTE( "95426301.hi", 0x00000, 0x080000, CRC(23e2e613) SHA1(357e6e8f3c8967ab5dfa86403206a1a0c86b635a) )
	ROM_LOAD16_BYTE( "95426384.lo", 0x00001, 0x080000, CRC(259fd056) SHA1(d725d41f3f6e5238b576a7b5d61bd1710b9979f6) )
	ROM_LOAD16_BYTE( "95426385.hi", 0x00000, 0x080000, CRC(15528f92) SHA1(a6ba5c7af907f558f9c09abf6bd43384fb4b96bd) )
	ROM_LOAD16_BYTE( "95426408.lo", 0x00001, 0x080000, CRC(773683e0) SHA1(5094f03ea89c95e9b7493fc67cebe16147fe15d0) )
	ROM_LOAD16_BYTE( "95426409.hi", 0x00000, 0x080000, CRC(2ed78190) SHA1(2cdab06d9c9ce5b5da777e9f8519ef517224d27e) )
	ROM_LOAD16_BYTE( "95426454.lo", 0x00001, 0x080000, CRC(77ecf5c3) SHA1(3b82c434db1f26ebf690f74b80df4af2242b4f2f) )
	ROM_LOAD16_BYTE( "95426455.hi", 0x00000, 0x080000, CRC(14caae1a) SHA1(c26517d21db7b86c2677a97284149da5b4eaee7f) )
	ROM_LOAD16_BYTE( "95426456.lo", 0x00001, 0x080000, CRC(38c66ba2) SHA1(61367219ed92daf00d241ca8fe708bb7678112a0) )
	ROM_LOAD16_BYTE( "95426457.hi", 0x00000, 0x080000, CRC(f19437d0) SHA1(75d07f4e5b124a823d14917ee4000df79e57a521) )
	ROM_LOAD16_BYTE( "95427042.lo", 0x00001, 0x080000, CRC(7707c79d) SHA1(a1b44af3b70587a09d9786dc086f7d195e1654a1) )
	ROM_LOAD16_BYTE( "95427043.hi", 0x00000, 0x080000, CRC(2881c6f4) SHA1(aab514ce48ff7f4bc58cfb641612a53bb8f7a78d) )
	ROM_LOAD16_BYTE( "95427256.lo", 0x00001, 0x080000, CRC(77950394) SHA1(ef3d07516215ea24c07da596b986c27b36d3ca3e) )
	ROM_LOAD16_BYTE( "95427257.hi", 0x00000, 0x080000, CRC(ecf383d4) SHA1(f32dc4c571a545db23115931a0ded717e8a51ccd) )
	ROM_LOAD16_BYTE( "95427300.lo", 0x00001, 0x080000, CRC(ed013729) SHA1(9d532f99a21227707237ca067ff539a89b9aa7bf) )
	ROM_LOAD16_BYTE( "95427301.hi", 0x00000, 0x080000, CRC(e5c4a338) SHA1(3896ae61ea09e6d889011db8c2346efa5e03525d) )
	ROM_LOAD16_BYTE( "95427384.lo", 0x00001, 0x080000, CRC(40f8448c) SHA1(56cd82ae2a119fa4c83309584cbb2cfd7e6f0212) )
	ROM_LOAD16_BYTE( "95427385.hi", 0x00000, 0x080000, CRC(ce033842) SHA1(ce63003cfd563f1e310fd536a683c676266c7250) )
	ROM_LOAD16_BYTE( "95427408.lo", 0x00001, 0x080000, CRC(53425c8f) SHA1(f5aaa6e9e6f8e2e3d974e04ed5a433d907fa0e6d) )
	ROM_LOAD16_BYTE( "95427409.hi", 0x00000, 0x080000, CRC(0ffa7f69) SHA1(56279cfd9bd0f5e7303074b0a9da07c5d122fcfb) )
	ROM_LOAD16_BYTE( "95427454.lo", 0x00001, 0x080000, CRC(964cffa6) SHA1(bf22daf259a71e9294b14e935c97646b2a003210) )
	ROM_LOAD16_BYTE( "95427455.hi", 0x00000, 0x080000, CRC(fdc1d8a1) SHA1(0979e031bb479a75cf077a641b66d39f42496d13) )
	ROM_LOAD16_BYTE( "95427456.lo", 0x00001, 0x080000, CRC(7c5bb19f) SHA1(f5b0a88555114424e54c8fb6cf35b44af8a0adf2) )
	ROM_LOAD16_BYTE( "95427457.hi", 0x00000, 0x080000, CRC(b991be45) SHA1(97c17c23dc4068bbc942ddf8160f5037f9796dc2) )
	ROM_LOAD16_BYTE( "p3215p71.hi", 0x00000, 0x080000, CRC(8d22a123) SHA1(1756b2d49de3d50eacb6b0db3d2aeacac05bc6fd) )
	ROM_LOAD16_BYTE( "p3215p71.lo", 0x00001, 0x080000, CRC(ad0c35f0) SHA1(f9e391626206008d7465e003f595ece0ffd81863) )
	ROM_LOAD16_BYTE( "p3215s71.hi", 0x00000, 0x080000, CRC(34f2676c) SHA1(1d70e41f612fdcacb1325430f2270dfe038178fa) )
	ROM_LOAD16_BYTE( "p3215s71.lo", 0x00001, 0x080000, CRC(7b1c7113) SHA1(4f4937b08adf121eb741b0ccb0bc8223a74c619c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	// dond double
	ROM_LOAD( "95008804.bin", 0x0000, 0x100000, CRC(19fd19fa) SHA1(db68a40d8bb3de130c6d5777217fb3c3a4c13d17) )
	ROM_LOAD( "95008805.bin", 0x0000, 0x100000, CRC(f497337d) SHA1(9e827116f8b1d882cfcd0b56aaede9de14b2e943) )
	// double deluxe
	ROM_LOAD( "95009137.bin", 0x0000, 0x100000, CRC(1d1fe8df) SHA1(d3aebec1a956d563de96069b587ebd2d40123497) )
	ROM_LOAD( "95009138.bin", 0x0000, 0x100000, CRC(c16971e0) SHA1(45df220ffe61db6a5319f495ff36efa793d428a4) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211494.bin", 0x0000, 0x1000000, CRC(64424b51) SHA1(604fc08e4754f23f54496693c95c050dccf810b2) )
	ROM_LOAD( "39212494.bin", 0x0000, 0x1000000, CRC(3d5d3877) SHA1(cee45ac7c11a6fa729233b65ae0dddf12eb18276) )
ROM_END



ROM_START( sc_dndhf )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422100.lo", 0x00001, 0x080000, CRC(ef20047c) SHA1(a15ee86dcef409def327a93c1c9370d1a3bf65d3) )
	ROM_LOAD16_BYTE( "95422101.hi", 0x00000, 0x080000, CRC(70f84961) SHA1(e1686922aa1dfa865ce50a2b272b93b4e508a9d6) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422228.lo", 0x00001, 0x080000, CRC(82f78314) SHA1(8f361b4beeb56be44305739c24c937dd0185f154) )
	ROM_LOAD16_BYTE( "95422229.hi", 0x00000, 0x080000, CRC(d756da26) SHA1(dc92e197a487f808e83b04407a5c065f713ca90b) )
	ROM_LOAD16_BYTE( "95422230.lo", 0x00001, 0x080000, CRC(46165367) SHA1(b6febfc3c9afa1597da251137e359e42e39fa5b7) )
	ROM_LOAD16_BYTE( "95422231.hi", 0x00000, 0x080000, CRC(bfa73daa) SHA1(d475fb98035ef91ef85d9695bdbbaf5a09582c4a) )
	ROM_LOAD16_BYTE( "95422308.lo", 0x00001, 0x080000, CRC(e657d78c) SHA1(458686ff094da445f5cb9af0ad808b83700c8544) )
	ROM_LOAD16_BYTE( "95422309.hi", 0x00000, 0x080000, CRC(eead5e54) SHA1(28ac82a045905b3609e7266a373610f49973fad6) )
	ROM_LOAD16_BYTE( "95422596.lo", 0x00001, 0x080000, CRC(ff7962f7) SHA1(9b8e5b33c8e1775acc1a6d577db8e46e1856fa91) )
	ROM_LOAD16_BYTE( "95422597.hi", 0x00000, 0x080000, CRC(7650faf1) SHA1(1510258c89e69015c017f9296edb8ff1ea75eb8e) )
	ROM_LOAD16_BYTE( "95422600.lo", 0x00001, 0x080000, CRC(56020991) SHA1(499c54789b00b49fbac93ce24381747ba0577087) )
	ROM_LOAD16_BYTE( "95422601.hi", 0x00000, 0x080000, CRC(554d6021) SHA1(2f529bf2e04f57fe398046feb05c19fc307e9a95) )
	ROM_LOAD16_BYTE( "95422836.lo", 0x00001, 0x080000, CRC(f7fc9434) SHA1(b54fced671375c2483667bc7c94d9671ab6b7165) )
	ROM_LOAD16_BYTE( "95422837.hi", 0x00000, 0x080000, CRC(14f361d4) SHA1(713014d42bb1cfb7a6301ca04dd84063d3adbaf1) )
	ROM_LOAD16_BYTE( "95423100.lo", 0x00001, 0x080000, CRC(9bad6823) SHA1(5c8f6e504150fa96098bc94e0c6148e33abe1b85) )
	ROM_LOAD16_BYTE( "95423101.hi", 0x00000, 0x080000, CRC(946d24ac) SHA1(5dd17f88a46a13bbff91affb444281e2eec7e2e9) )
	ROM_LOAD16_BYTE( "95423228.lo", 0x00001, 0x080000, CRC(9ca8837d) SHA1(79ce2af1d545ca0cdd7766469c13633b6683d7d1) )
	ROM_LOAD16_BYTE( "95423229.hi", 0x00000, 0x080000, CRC(199933c7) SHA1(5f0d5c6a8e3d7b6ed6130b64e5d3ec699e643384) )
	ROM_LOAD16_BYTE( "95423230.lo", 0x00001, 0x080000, CRC(e77d4d22) SHA1(81bddb29f9a5af8f675c07ab4786e28dda478390) )
	ROM_LOAD16_BYTE( "95423231.hi", 0x00000, 0x080000, CRC(e911cbcc) SHA1(6bf0cf7081f49adf082dfe5bc489941baf89b177) )
	ROM_LOAD16_BYTE( "95423308.lo", 0x00001, 0x080000, CRC(450e2862) SHA1(ca71471c51a64645d291dc94ae48e8cee34d0ae0) )
	ROM_LOAD16_BYTE( "95423309.hi", 0x00000, 0x080000, CRC(40ee947e) SHA1(1dd35d4d1de3a4c65bc626297225f06005ca1c9f) )
	ROM_LOAD16_BYTE( "95423596.lo", 0x00001, 0x080000, CRC(d3f68f15) SHA1(20144d6dc67e961b15b8caf39e93ca2978954104) )
	ROM_LOAD16_BYTE( "95423597.hi", 0x00000, 0x080000, CRC(c0eb6227) SHA1(511ca5bffe9d98896bb3130c80d2078e2a544a5d) )
	ROM_LOAD16_BYTE( "95423600.lo", 0x00001, 0x080000, CRC(df07ffcf) SHA1(71ea3c48c73f571052900d03cff94038825260d5) )
	ROM_LOAD16_BYTE( "95423601.hi", 0x00000, 0x080000, CRC(bb49fe58) SHA1(c147521b25e55a13258a178f247be07843c4941c) )
	ROM_LOAD16_BYTE( "95423836.lo", 0x00001, 0x080000, CRC(949a7f5c) SHA1(09e7c6ee6d3c3f04ae6d0233cf9bbb88d63fc864) )
	ROM_LOAD16_BYTE( "95423837.hi", 0x00000, 0x080000, CRC(a0dc9c07) SHA1(40829266eac6eef4bf7bd261ac8d40dc8e2b51e1) )
	ROM_LOAD16_BYTE( "95426110.lo", 0x00001, 0x080000, CRC(fb34d047) SHA1(0af2dc94aff2f8962f0c59a80fbea695b047d093) )
	ROM_LOAD16_BYTE( "95426111.hi", 0x00000, 0x080000, CRC(f631827b) SHA1(5958c68537435b5550b061f1d6c950e03a9c5e5f) )
	ROM_LOAD16_BYTE( "95426112.lo", 0x00001, 0x080000, CRC(7169a030) SHA1(34048ecf1b9b154b94963830ce033ec081accc84) )
	ROM_LOAD16_BYTE( "95426113.hi", 0x00000, 0x080000, CRC(cffdf2f8) SHA1(8d7ae835f4a50fa8e6ba3f7c9ff7041547b1daaa) )
	ROM_LOAD16_BYTE( "95426158.lo", 0x00001, 0x080000, CRC(563a6a0a) SHA1(ae6a95179f8ef9afd72cdd7182f6988570dc7ce9) )
	ROM_LOAD16_BYTE( "95426159.hi", 0x00000, 0x080000, CRC(7730beba) SHA1(f8471d9f69b0a29af65a9186dda1410c6bc9c886) )
	ROM_LOAD16_BYTE( "95426294.lo", 0x00001, 0x080000, CRC(beffedcc) SHA1(dad489454cc48c9c0c735dbcadd7d1353a1850b7) )
	ROM_LOAD16_BYTE( "95426295.hi", 0x00000, 0x080000, CRC(02ad5e2c) SHA1(5cbd7dcd37676c5253429e59c92620318ecd8ebc) )
	ROM_LOAD16_BYTE( "95426338.lo", 0x00001, 0x080000, CRC(318a1f6a) SHA1(bef02e8cbaf957ab80e2c29a684490c9aa713244) )
	ROM_LOAD16_BYTE( "95426339.hi", 0x00000, 0x080000, CRC(74f30c4e) SHA1(122a8654a514b1214c56e1d4b2ed5215220951a2) )
	ROM_LOAD16_BYTE( "95427110.lo", 0x00001, 0x080000, CRC(ae499e60) SHA1(cf1a5e618cca77466b70061c829a8fa9dd9b96d3) )
	ROM_LOAD16_BYTE( "95427111.hi", 0x00000, 0x080000, CRC(4d8c41a6) SHA1(5baa34496a653ed311333ae4b921fecd5ae8b383) )
	ROM_LOAD16_BYTE( "95427112.lo", 0x00001, 0x080000, CRC(56dfc7b2) SHA1(757257d9c9178d587b906840bccdfdfe81095d2c) )
	ROM_LOAD16_BYTE( "95427113.hi", 0x00000, 0x080000, CRC(51bb8182) SHA1(00cebd6109d82b4f3199d6eb21395060f246cc8b) )
	ROM_LOAD16_BYTE( "95427158.lo", 0x00001, 0x080000, CRC(add49a6e) SHA1(c57824b411a879fa0b2889c94a5e2c9f34848844) )
	ROM_LOAD16_BYTE( "95427159.hi", 0x00000, 0x080000, CRC(7f91c4a2) SHA1(d010de737e9ebedc52ba691057045a68474bc9d3) )
	ROM_LOAD16_BYTE( "95427294.lo", 0x00001, 0x080000, CRC(c85cc648) SHA1(073dc34789e23258dfe128d5eadf8e3317c07cd2) )
	ROM_LOAD16_BYTE( "95427295.hi", 0x00000, 0x080000, CRC(d85e3b26) SHA1(26cdbca382441785038199a12a0dea8d9f09f7c7) )
	ROM_LOAD16_BYTE( "95427338.lo", 0x00001, 0x080000, CRC(c095e219) SHA1(cbed56490174460c882b3c1cc634eac1787bca6b) )
	ROM_LOAD16_BYTE( "95427339.hi", 0x00000, 0x080000, CRC(3221dc69) SHA1(376ce5802c47cdebe364432aa0254d48e077cb0f) )
	ROM_LOAD16_BYTE( "p3008p01.hi", 0x00000, 0x080000, CRC(543fc78b) SHA1(e1aff6d3bca1fba509855c8cd83f6cd8160dbbc3) )
	ROM_LOAD16_BYTE( "p3008p01.lo", 0x00001, 0x080000, CRC(50b9424c) SHA1(819de4fa51ca8d520a5dbce1d204daaf44b62b94) )
	ROM_LOAD16_BYTE( "p3008s01.hi", 0x00000, 0x080000, CRC(4a2e02e4) SHA1(be028657c2cfc5d3caafaea4664f37d24a584f2a) )
	ROM_LOAD16_BYTE( "p3008s01.lo", 0x00001, 0x080000, CRC(3f455777) SHA1(b0182a0b2981d9cbc914c30438a23f13c271cffa) )
	ROM_LOAD16_BYTE( "p3038p71.hi", 0x00000, 0x080000, CRC(65c029f2) SHA1(4e6fe3c6994dcc0e110aad0db290ba5cd88b3909) )
	ROM_LOAD16_BYTE( "p3038p71.lo", 0x00001, 0x080000, CRC(ac32e361) SHA1(05aad77374366091d4d92938284e7b913962c022) )
	ROM_LOAD16_BYTE( "p3038p72.hi", 0x00000, 0x080000, CRC(0378fbc2) SHA1(24358afa5c6048c35602525a282ba80fdf0868ec) )
	ROM_LOAD16_BYTE( "p3038p72.lo", 0x00001, 0x080000, CRC(56798d91) SHA1(67c5c7009a5455d1ee512ba80434793a7a9cd1d5) )
	ROM_LOAD16_BYTE( "p3038s71.hi", 0x00000, 0x080000, CRC(a560026f) SHA1(612e25ede337af886f9df29bd9e0f0a01d2599cd) )
	ROM_LOAD16_BYTE( "p3038s71.lo", 0x00001, 0x080000, CRC(439af563) SHA1(791ecfa413407c4907bd90984289c745dc8adf4d) )
	ROM_LOAD16_BYTE( "p3038s72.hi", 0x00000, 0x080000, CRC(8a730875) SHA1(ec2a73a6437f1c5bc9d2d6b64ef051765a686556) )
	ROM_LOAD16_BYTE( "p3038s72.lo", 0x00001, 0x080000, CRC(3742986a) SHA1(23cf803ac3a313fc8a5994ea95351c28bfb282d0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008705.bin", 0x0000, 0x100000, CRC(09e02843) SHA1(a6ac658c857eca2aca0bacda423dd012434e93bc) )
	ROM_LOAD( "95008706.bin", 0x0000, 0x100000, CRC(805e7eb8) SHA1(107c6ba26e37d8f2eec81b62c3edf3efb7e44ca2) )
ROM_END



ROM_START( sc_dndys )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95423674.lo", 0x00001, 0x080000, CRC(1fb53dcb) SHA1(d1b99b29d95f1dd2b2ce1d7c846387112c7cceed) )
	ROM_LOAD16_BYTE( "95423675.hi", 0x00000, 0x080000, CRC(61cd5b49) SHA1(7d3dbc05655b48af9edf84e95e0ffe6ff62068fa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426268.lo", 0x00001, 0x080000, CRC(ab252eb0) SHA1(d2964cc5f5d3e6fbad512931bd18b186697ade8e) )
	ROM_LOAD16_BYTE( "95426269.hi", 0x00000, 0x080000, CRC(0741454a) SHA1(34b17cd7a4dbffd45ec0d939dce41e708852d892) )
	ROM_LOAD16_BYTE( "95426312.lo", 0x00001, 0x080000, CRC(3a13df56) SHA1(84770607327a16ad0f64588578ab423d41be7006) )
	ROM_LOAD16_BYTE( "95426313.hi", 0x00000, 0x080000, CRC(be2643d5) SHA1(64249cff5a31afb5b1e4e17dfdaa2404021c5321) )
	ROM_LOAD16_BYTE( "95426394.lo", 0x00001, 0x080000, CRC(94a2f378) SHA1(27281ac1c17cbfd21fec4a049b7907d87addeb14) )
	ROM_LOAD16_BYTE( "95426395.hi", 0x00000, 0x080000, CRC(59304a7d) SHA1(7110fb450b0f04e28bab5f7d5eee997dc5f4f761) )
	ROM_LOAD16_BYTE( "95427064.lo", 0x00001, 0x080000, CRC(febb3430) SHA1(2214a6377030622fc08917ef57338934cd207077) )
	ROM_LOAD16_BYTE( "95427065.hi", 0x00000, 0x080000, CRC(1ac94731) SHA1(96ca407b2b0199b679d8feb568dcfa267c3afaf0) )
	ROM_LOAD16_BYTE( "95427066.lo", 0x00001, 0x080000, CRC(4bdfccda) SHA1(ec72bc6fce4ac4c1074d928270f6018602fabd96) )
	ROM_LOAD16_BYTE( "95427067.hi", 0x00000, 0x080000, CRC(dc8c2384) SHA1(2a936c935730ce61d487659e0be72c7a2164bc73) )
	ROM_LOAD16_BYTE( "95427268.lo", 0x00001, 0x080000, CRC(7c318a2d) SHA1(c664d8343d1138facb33505869c8ec18e40e50fe) )
	ROM_LOAD16_BYTE( "95427269.hi", 0x00000, 0x080000, CRC(3e6f9575) SHA1(3d09e122f4c7c7f253ccf24b7ca9390b28e5f4f4) )
	ROM_LOAD16_BYTE( "95427312.lo", 0x00001, 0x080000, CRC(28fca839) SHA1(b40f8b42f4832fd679499faae6a710b780d3ec27) )
	ROM_LOAD16_BYTE( "95427313.hi", 0x00000, 0x080000, CRC(76764fc0) SHA1(eb6d638e3c68a65abce45cd7b71f7da158b431fc) )
	ROM_LOAD16_BYTE( "95427394.lo", 0x00001, 0x080000, CRC(ce683a22) SHA1(2876748fcb6952d2817a6df5ba7900206a6a457c) )
	ROM_LOAD16_BYTE( "95427395.hi", 0x00000, 0x080000, CRC(8a514a3d) SHA1(18e40ec25715a01c839751d0d73aad2e38ea54ed) )
	ROM_LOAD16_BYTE( "p3207p01.hi", 0x00000, 0x080000, CRC(9a91557f) SHA1(bc53eb7a7bfd2857cf6b323bd3f45ea6c1ddbf0c) )
	ROM_LOAD16_BYTE( "p3207p01.lo", 0x00001, 0x080000, CRC(f3196c98) SHA1(1e4d5435b37e0198285041adf0fb7c86e6059d5e) )
	ROM_LOAD16_BYTE( "p3207s01.hi", 0x00000, 0x080000, CRC(47f5b397) SHA1(45ce9945ac9131abf5590d34b2aa1ac103f249c6) )
	ROM_LOAD16_BYTE( "p3207s01.lo", 0x00001, 0x080000, CRC(e3f70ec2) SHA1(fd97662eb5efa0aa1c2a501e741405a6067c8e69) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008779.bin", 0x0000, 0x100000, CRC(cf04d115) SHA1(3255b58cd4fba7d231ca35c00d1cb70da1f6cfbd) )
	ROM_LOAD( "95008780.bin", 0x0000, 0x100000, CRC(ec270dbe) SHA1(f649ffd4530feed491dc050f40aa0205f4bfdd89) )
ROM_END


ROM_START( sc_dndlp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426298.lo", 0x00001, 0x080000, CRC(e75e8a81) SHA1(441904c2f1cd72ed269a1bd7157076cf54b325e9) )
	ROM_LOAD16_BYTE( "95426299.hi", 0x00000, 0x080000, CRC(9c167e80) SHA1(97d642a81efc3261388b8d2a1c6747ea61497715) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426342.lo", 0x00001, 0x080000, CRC(24a01b4a) SHA1(e3418d9c690897244deb4483b1472ed9b6557db3) )
	ROM_LOAD16_BYTE( "95426343.hi", 0x00000, 0x080000, CRC(f8382df6) SHA1(0cbbc0afefd2a61baad30cbdb916572b4d97ea7d) )
	ROM_LOAD16_BYTE( "95426368.lo", 0x00001, 0x080000, CRC(94435433) SHA1(edc64f6cefb9022b07eedd1b7c4cfcdc40e0a4e9) )
	ROM_LOAD16_BYTE( "95426369.hi", 0x00000, 0x080000, CRC(df0e9933) SHA1(b4d5329366bcc74e284a05f3b71a50267f65c05b) )
	ROM_LOAD16_BYTE( "95426406.lo", 0x00001, 0x080000, CRC(833d04fa) SHA1(3485c1ff0d5267af9fb888c35b56330c79733d1a) )
	ROM_LOAD16_BYTE( "95426407.hi", 0x00000, 0x080000, CRC(dbb5ff57) SHA1(126bacb47fccbfd4ebcddf841490a15676d5da6a) )
	ROM_LOAD16_BYTE( "95426444.lo", 0x00001, 0x080000, CRC(641db9da) SHA1(b11d3f4cb28ba4252b29b558372f3562ea8191f0) )
	ROM_LOAD16_BYTE( "95426445.hi", 0x00000, 0x080000, CRC(f52f60d9) SHA1(1d4f1002dc8a4bd84d92cdba1e9b5547166c01d8) )
	ROM_LOAD16_BYTE( "95426458.lo", 0x00001, 0x080000, CRC(ed53f87f) SHA1(0ad1e2c1dc51591fd318294aa1a0be46533c27a6) )
	ROM_LOAD16_BYTE( "95426459.hi", 0x00000, 0x080000, CRC(63264e53) SHA1(07e5ccb9f68f273b74f65d22306352ce33338d34) )
	ROM_LOAD16_BYTE( "95426536.lo", 0x00001, 0x080000, CRC(3ee26d10) SHA1(73b9dd35f4c16ce9081c06f47de3c091f7162e0b) )
	ROM_LOAD16_BYTE( "95426537.hi", 0x00000, 0x080000, CRC(9fec9ab5) SHA1(e11c735a921987712d954f0f29434cfb4189be8b) )
	ROM_LOAD16_BYTE( "95426538.lo", 0x00001, 0x080000, CRC(7e1d4da1) SHA1(014e03e18dfd09bda9926f4ec554d6c6e90301f2) )
	ROM_LOAD16_BYTE( "95426539.hi", 0x00000, 0x080000, CRC(8bbf4c0d) SHA1(95a1174aaa48b736c6e338aea7f811b2e83a9d83) )
	ROM_LOAD16_BYTE( "95426668.lo", 0x00001, 0x080000, CRC(8203c055) SHA1(8ed86a63272181a61fee273a31d1295f787e7c6c) )
	ROM_LOAD16_BYTE( "95426669.hi", 0x00000, 0x080000, CRC(d2ef1fb3) SHA1(28969bf1a4e71c1ccfca9202de905c12abaeed47) )
	ROM_LOAD16_BYTE( "95426708.lo", 0x00001, 0x080000, CRC(250aaa63) SHA1(62fa96fc8ccd90b02efda13fa488bf1c6e1ca3b8) )
	ROM_LOAD16_BYTE( "95426709.hi", 0x00000, 0x080000, CRC(e3b860b0) SHA1(901812e4bbed6f13ec94268ef542950695979ae7) )
	ROM_LOAD16_BYTE( "95427298.lo", 0x00001, 0x080000, CRC(96b21b18) SHA1(4941f3ec390938af36ed273a47c1a8df8af01d67) )
	ROM_LOAD16_BYTE( "95427299.hi", 0x00000, 0x080000, CRC(57fe8998) SHA1(3af7aa8df889456b3fd938ffaea03fe034be6534) )
	ROM_LOAD16_BYTE( "95427342.lo", 0x00001, 0x080000, CRC(230de91f) SHA1(05e39076a18be9848b04045c77e9dcb03b09fcca) )
	ROM_LOAD16_BYTE( "95427343.hi", 0x00000, 0x080000, CRC(0b1e35fe) SHA1(74e269c20aa8676e646285840f3563bd2248982c) )
	ROM_LOAD16_BYTE( "95427368.lo", 0x00001, 0x080000, CRC(dac70842) SHA1(9edf10b7fd58f9208e67705ba5f3df8930e3dc41) )
	ROM_LOAD16_BYTE( "95427369.hi", 0x00000, 0x080000, CRC(f1afd79d) SHA1(f0f6d842648d6c9e3ce24a7dbf7b780fdc5ced10) )
	ROM_LOAD16_BYTE( "95427406.lo", 0x00001, 0x080000, CRC(d491c686) SHA1(6647edf5cc5888e0a9bd3bee9130c8c443c2fbd1) )
	ROM_LOAD16_BYTE( "95427407.hi", 0x00000, 0x080000, CRC(a83719fa) SHA1(eccd97caafde4ef9d65c8a9e424e1962dd16f7ad) )
	ROM_LOAD16_BYTE( "95427444.lo", 0x00001, 0x080000, CRC(55a609c4) SHA1(7636216e2c93ea59936ed43fd7d5fb7048643518) )
	ROM_LOAD16_BYTE( "95427445.hi", 0x00000, 0x080000, CRC(b4590c35) SHA1(49207ada280d6bb565f005e2e7964d26f0937e49) )
	ROM_LOAD16_BYTE( "95427458.lo", 0x00001, 0x080000, CRC(41936151) SHA1(d68abd4cc7e340a3706b3a52bbe1a79f0ac07a79) )
	ROM_LOAD16_BYTE( "95427459.hi", 0x00000, 0x080000, CRC(87cc61b4) SHA1(d6d2cd815161f41921c4ec28f4259cd6f62bc995) )
	ROM_LOAD16_BYTE( "95427536.lo", 0x00001, 0x080000, CRC(e85cf664) SHA1(e35e1bc7818b483a8f8eb67547af2765aaa74213) )
	ROM_LOAD16_BYTE( "95427537.hi", 0x00000, 0x080000, CRC(a5483213) SHA1(b4b332ea7e1740ff07dc5565d1134137896b4640) )
	ROM_LOAD16_BYTE( "95427538.lo", 0x00001, 0x080000, CRC(abc79346) SHA1(7dc2b5dea36d1c746ac03caa2f96e46039e2eb0d) )
	ROM_LOAD16_BYTE( "95427539.hi", 0x00000, 0x080000, CRC(9a6529bb) SHA1(f8c409f994a848ad6748db317fa2acb52977f59d) )
	ROM_LOAD16_BYTE( "95427668.lo", 0x00001, 0x080000, CRC(57a902c6) SHA1(e6aff87c9eca5c433b155a856c1ed6ccb45318fc) )
	ROM_LOAD16_BYTE( "95427669.hi", 0x00000, 0x080000, CRC(a05ed29b) SHA1(2e7538e2399d16694b85e46ceff54c34335b7f9a) )
	ROM_LOAD16_BYTE( "95427708.lo", 0x00001, 0x080000, CRC(f1817ebb) SHA1(00459c5d268a62ee3f612079a1860c1b67729dce) )
	ROM_LOAD16_BYTE( "95427709.hi", 0x00000, 0x080000, CRC(a4342102) SHA1(99c83845556085be69937025c26d998c2d60727d) )
	ROM_LOAD16_BYTE( "p3212p11.hi", 0x00000, 0x080000, CRC(818659ee) SHA1(66bee5b92cce62b4caccc59decec5d808e89ee18) )
	ROM_LOAD16_BYTE( "p3212p11.lo", 0x00001, 0x080000, CRC(c6104c88) SHA1(9f1a400cae00c5587d16e9073447c2a38c8f36a3) )
	ROM_LOAD16_BYTE( "p3212p12.hi", 0x00000, 0x080000, CRC(3e1dcc7d) SHA1(8d6eb4e7d5cfbc67e5cf922a853ca9c642aa32aa) )
	ROM_LOAD16_BYTE( "p3212p12.lo", 0x00001, 0x080000, CRC(4baac8d0) SHA1(ed68fc2b234fed44ad4e2fde0cfc1c9c6845ed97) )
	ROM_LOAD16_BYTE( "p3212p13.hi", 0x00000, 0x080000, CRC(c25b0254) SHA1(d4f1f80f30c18dc67a802dfc0d651e4d3a2c3c97) )
	ROM_LOAD16_BYTE( "p3212p13.lo", 0x00001, 0x080000, CRC(959ee1e3) SHA1(328347a9fe86678aed76d669f92ad76b0bfa9ce5) )
	ROM_LOAD16_BYTE( "p3212p14.hi", 0x00000, 0x080000, CRC(226cfe89) SHA1(c7755878e2dc0f5062b0c0329fef342262469173) )
	ROM_LOAD16_BYTE( "p3212p14.lo", 0x00001, 0x080000, CRC(7f4dc672) SHA1(2550879c400ce07fb8dfa612f4c0f0c342db2545) )
	ROM_LOAD16_BYTE( "p3212s11.hi", 0x00000, 0x080000, CRC(12740b8e) SHA1(a9a1d0f38811c75295ded490adb8492812ef6efa) )
	ROM_LOAD16_BYTE( "p3212s11.lo", 0x00001, 0x080000, CRC(02820c15) SHA1(c57e780119519dfeac905da27edb9de717be2340) )
	ROM_LOAD16_BYTE( "p3212s12.hi", 0x00000, 0x080000, CRC(8ca399b2) SHA1(a2f75b8c88d40c0e75fa3612cf077d15d29a97bf) )
	ROM_LOAD16_BYTE( "p3212s12.lo", 0x00001, 0x080000, CRC(c2f778e1) SHA1(89c7204728acced07210fec01f5c370b20468bd4) )
	ROM_LOAD16_BYTE( "p3212s13.hi", 0x00000, 0x080000, CRC(646a4ea7) SHA1(9b8455179e1129db5d72a3c79ee176214107042d) )
	ROM_LOAD16_BYTE( "p3212s13.lo", 0x00001, 0x080000, CRC(6e6885e3) SHA1(3edc678bf20b05cd52217442bcf93e9255a624a2) )
	ROM_LOAD16_BYTE( "p3212s14.hi", 0x00000, 0x080000, CRC(895101c7) SHA1(f9b61d57a028c5fc365d00db9c9a4661335a7cbe) )
	ROM_LOAD16_BYTE( "p3212s14.lo", 0x00001, 0x080000, CRC(7d504257) SHA1(78c2d95d96905a983a218024b6ea01d0c2cded8c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008792.bin", 0x0000, 0x100000, CRC(2e7e1a5a) SHA1(000cb48c67b7f23d00318d37206c2df426c79281) )
	ROM_LOAD( "95008793.bin", 0x0000, 0x100000, CRC(4b91b638) SHA1(b97cb1d22f91a791fc4d47bbae8965882898a317) )
ROM_END



ROM_START( sc_dndra )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422486.lo", 0x00001, 0x080000, CRC(bc7d0e20) SHA1(fba43a73629d563de1e8fb19b5d0f584a444c5e1) )
	ROM_LOAD16_BYTE( "95422487.hi", 0x00000, 0x080000, CRC(60d7aa64) SHA1(28c51f574706c1a96079f9ff8b5e280c0a8e3e8e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422488.lo", 0x00001, 0x080000, CRC(8dd30c4f) SHA1(54705053681607c87b2aa6e3b6d2c9aed1c92030) )
	ROM_LOAD16_BYTE( "95422489.hi", 0x00000, 0x080000, CRC(48836820) SHA1(4063670cc6be1dab844b3de2ea994b799f38d1fe) )
	ROM_LOAD16_BYTE( "95423486.lo", 0x00001, 0x080000, CRC(d5325d3f) SHA1(b18245474a7785a94460b7ab3b58f073be78c832) )
	ROM_LOAD16_BYTE( "95423487.hi", 0x00000, 0x080000, CRC(552e5c5f) SHA1(2424b0bb3cc9280cf9fd88c1651aa4db093b15b0) )
	ROM_LOAD16_BYTE( "95423488.lo", 0x00001, 0x080000, CRC(fffdb21e) SHA1(f9b4d3f8a3ab4b373eea1d296c3ce923fb95c8d8) )
	ROM_LOAD16_BYTE( "95423489.hi", 0x00000, 0x080000, CRC(b81bae78) SHA1(26824ba85a8462572dc4d94426ba87558e62970e) )
	ROM_LOAD16_BYTE( "95426080.lo", 0x00001, 0x080000, CRC(80a7760d) SHA1(2bd48037ed2ddb9720f62854b0eba24ee2e85bd4) )
	ROM_LOAD16_BYTE( "95426081.hi", 0x00000, 0x080000, CRC(183ce976) SHA1(34bdbb5da232ae44f16deff8026d3155e5f7527e) )
	ROM_LOAD16_BYTE( "95426082.lo", 0x00001, 0x080000, CRC(77cbb34c) SHA1(75a76d05e6da46d4881e62c8ed95a27e87cf0566) )
	ROM_LOAD16_BYTE( "95426083.hi", 0x00000, 0x080000, CRC(83308070) SHA1(8eb9923095ab98fb416664c6854ddcbd4ec3888e) )
	ROM_LOAD16_BYTE( "95426396.lo", 0x00001, 0x080000, CRC(54a61a29) SHA1(ac715c7c0f208de1e4522f8a28ca4b7ee7ac9033) )
	ROM_LOAD16_BYTE( "95426397.hi", 0x00000, 0x080000, CRC(2183f67d) SHA1(51054ff5c26e9ea5ddc64630f4db1dfa08950111) )
	ROM_LOAD16_BYTE( "95426416.lo", 0x00001, 0x080000, CRC(35c794c9) SHA1(6ddadede71064ec75d6fc521df5cc9486029948a) )
	ROM_LOAD16_BYTE( "95426417.hi", 0x00000, 0x080000, CRC(ef7802cd) SHA1(6428370e3e5b950f55ae3685b9e82dd213fd92ee) )
	ROM_LOAD16_BYTE( "95427080.lo", 0x00001, 0x080000, CRC(957fbbf1) SHA1(df90ec57ca6a2d9f595ac43e7bbdf26d1d862cfe) )
	ROM_LOAD16_BYTE( "95427081.hi", 0x00000, 0x080000, CRC(d24bc15b) SHA1(3bdf96d7e91d9d252861a81176b6c20f14e27021) )
	ROM_LOAD16_BYTE( "95427082.lo", 0x00001, 0x080000, CRC(047d2776) SHA1(85e4210af45990e112324701dafcc3a83b342253) )
	ROM_LOAD16_BYTE( "95427083.hi", 0x00000, 0x080000, CRC(2e91181b) SHA1(fb881415d26a8d2b7f773188e6edffc9babaa582) )
	ROM_LOAD16_BYTE( "95427396.lo", 0x00001, 0x080000, CRC(64b0cfab) SHA1(89a958774b1d1d9d1b326a45ccb04fa68677bbb1) )
	ROM_LOAD16_BYTE( "95427397.hi", 0x00000, 0x080000, CRC(03786a87) SHA1(1b5756c1cb77ffd9935f94fd1bb54eef0f37ea12) )
	ROM_LOAD16_BYTE( "95427416.lo", 0x00001, 0x080000, CRC(f025b0ba) SHA1(ad1bc747e3cb6ece6041fd5335f893148a330b67) )
	ROM_LOAD16_BYTE( "95427417.hi", 0x00000, 0x080000, CRC(4f15c978) SHA1(16ceb67160b3d83d58db2d4fcce2bb5d46fc02b7) )
	ROM_LOAD16_BYTE( "p3201p71.hi", 0x00000, 0x080000, CRC(27086da6) SHA1(4a8e10fa47f6467f6d14611e81c25e79a1ee1173) )
	ROM_LOAD16_BYTE( "p3201p71.lo", 0x00001, 0x080000, CRC(e0cb8eac) SHA1(e8b6fbb7f4d19d5c9fb8891c23f3293d37067946) )
	ROM_LOAD16_BYTE( "p3201p72.hi", 0x00000, 0x080000, CRC(2536bc62) SHA1(c3a84a78311c63358f69003c1540f2560249e318) )
	ROM_LOAD16_BYTE( "p3201p72.lo", 0x00001, 0x080000, CRC(560988a7) SHA1(1f0e01f88803c98affbba3e7cf720282866e8d72) )
	ROM_LOAD16_BYTE( "p3201p73.hi", 0x00000, 0x080000, CRC(dff3a0b4) SHA1(98b8e5538d5a80f9cc67d7f9a9d1cfe0f72bf2fc) )
	ROM_LOAD16_BYTE( "p3201p73.lo", 0x00001, 0x080000, CRC(614476cb) SHA1(df1eab8ce8083c74f9168fe1ae5d0af17ef46e8a) )
	ROM_LOAD16_BYTE( "p3201s71.hi", 0x00000, 0x080000, CRC(239e71e0) SHA1(69de5f6663eb3d74bbcee5c8f8461204c38ac6e7) )
	ROM_LOAD16_BYTE( "p3201s71.lo", 0x00001, 0x080000, CRC(254f4647) SHA1(3b8667633ad1558e35ff6742fbfbb97bf6058bf8) )
	ROM_LOAD16_BYTE( "p3201s72.hi", 0x00000, 0x080000, CRC(bf6e0a69) SHA1(21b958a8995a7adaf240991c1815527d0b51dcb3) )
	ROM_LOAD16_BYTE( "p3201s72.lo", 0x00001, 0x080000, CRC(828d9065) SHA1(bfdf0f310e8d1b87dbb3e60722241dbfa407d7dd) )
	ROM_LOAD16_BYTE( "p3201s73.hi", 0x00000, 0x080000, CRC(cf22263f) SHA1(37d34ccd6a2cc7ee7858885f56226aa59cb8d40a) )
	ROM_LOAD16_BYTE( "p3201s73.lo", 0x00001, 0x080000, CRC(5ee67237) SHA1(f4b1d6281fa5c406e7f76e1397963539070df6ab) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008752.bin", 0x0000, 0x100000, CRC(82bfd510) SHA1(857f294d46d64275b15c56187bbbc19e2aa0f5bc) )
	ROM_LOAD( "95008753.bin", 0x0000, 0x100000, CRC(ee0b5da9) SHA1(f6cb6037f525df504c1ba8106f19990ecf8d1bd2) )
ROM_END



ROM_START( sc_dndbd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422666.lo", 0x00001, 0x080000, CRC(6da9be2f) SHA1(c4aa54797d5407c80ae980bf2820292bf90fbfbf) )
	ROM_LOAD16_BYTE( "95422667.hi", 0x00000, 0x080000, CRC(c7981c1e) SHA1(01589186cf63a0e03dfd1ed96898717dcb2c3dcc) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422894.lo", 0x00001, 0x080000, CRC(56e5027f) SHA1(af8afab10f309ecb40d7c7861dcccb397f92dccc) )
	ROM_LOAD16_BYTE( "95422895.hi", 0x00000, 0x080000, CRC(04b08719) SHA1(64355b5711b069b9328bdc98fdc6815bceb08504) )
	ROM_LOAD16_BYTE( "95422896.lo", 0x00001, 0x080000, CRC(4490c973) SHA1(13b869e65b299de353e8e56049b990e1e7e6aeca) )
	ROM_LOAD16_BYTE( "95422897.hi", 0x00000, 0x080000, CRC(c884eebd) SHA1(fd9b194e8a7a4988abded1325e3ceb993a32edc4) )
	ROM_LOAD16_BYTE( "95423894.lo", 0x00001, 0x080000, CRC(5ee4a59e) SHA1(e64ab0fb59d9013da76bd88c548000322c9955be) )
	ROM_LOAD16_BYTE( "95423895.hi", 0x00000, 0x080000, CRC(320046fc) SHA1(0c7c76b22ff1ccccfc27dde25236da6fb834e027) )
	ROM_LOAD16_BYTE( "95423896.lo", 0x00001, 0x080000, CRC(d7ca472f) SHA1(bc9f1ea75fe42a9a1462fc3b4755d6c11853bd21) )
	ROM_LOAD16_BYTE( "95423897.hi", 0x00000, 0x080000, CRC(fbd289b9) SHA1(7dedc2d8ac28ad313dd1688a01bda4cd74fc68b4) )
	ROM_LOAD16_BYTE( "95426124.lo", 0x00001, 0x080000, CRC(193b1d2f) SHA1(6c84b99acc231d25d79e8878a14ce01787c44980) )
	ROM_LOAD16_BYTE( "95426125.hi", 0x00000, 0x080000, CRC(266f5e60) SHA1(ad787ff57f7eb40a0f02d3daf573ad01d4fd5e7c) )
	ROM_LOAD16_BYTE( "95426302.lo", 0x00001, 0x080000, CRC(8d7a23fb) SHA1(0a9d746eb3f032d774294df9ad1bb0515be21397) )
	ROM_LOAD16_BYTE( "95426303.hi", 0x00000, 0x080000, CRC(5a758509) SHA1(733c8b82e6210e64be1a85a3295273ec0990a8d2) )
	ROM_LOAD16_BYTE( "95426370.lo", 0x00001, 0x080000, CRC(201fbd94) SHA1(6c5b819e20d9dc7237d99320953fc33d6357faf8) )
	ROM_LOAD16_BYTE( "95426371.hi", 0x00000, 0x080000, CRC(cbc533ad) SHA1(03daec7b71e5cc7168dfb86199e45ec4553dae77) )
	ROM_LOAD16_BYTE( "95426386.lo", 0x00001, 0x080000, CRC(cf6cb721) SHA1(961a63d1173e5784853a0fad4d8e94859144023a) )
	ROM_LOAD16_BYTE( "95426387.hi", 0x00000, 0x080000, CRC(20e8fc23) SHA1(71477bd6a1d482751b0cc0158d0d5d963fe63703) )
	ROM_LOAD16_BYTE( "95427124.lo", 0x00001, 0x080000, CRC(707491a9) SHA1(ad1c529bf133c22e0585094342951710d200ae89) )
	ROM_LOAD16_BYTE( "95427125.hi", 0x00000, 0x080000, CRC(4e8f2ced) SHA1(e804bf36dcbfd465af874134afa773a0c1add0fb) )
	ROM_LOAD16_BYTE( "95427302.lo", 0x00001, 0x080000, CRC(05659829) SHA1(cdd34e493563361d4a48099bc23c2a4157f29b8e) )
	ROM_LOAD16_BYTE( "95427303.hi", 0x00000, 0x080000, CRC(53dc417e) SHA1(a3feef757f97d0b393c57356734a49f72cdb8dfc) )
	ROM_LOAD16_BYTE( "95427370.lo", 0x00001, 0x080000, CRC(154f9a59) SHA1(10464571fd505813f472d1ef0f153b93e167e03d) )
	ROM_LOAD16_BYTE( "95427371.hi", 0x00000, 0x080000, CRC(b47b7d87) SHA1(0ecac57740f6f82d11a6fa38c2dce3a101b52772) )
	ROM_LOAD16_BYTE( "95427386.lo", 0x00001, 0x080000, CRC(4ceadcfc) SHA1(37fca1d7ade327c6f54845a2f67133f5122e59d5) )
	ROM_LOAD16_BYTE( "95427387.hi", 0x00000, 0x080000, CRC(c8774dc7) SHA1(c2f5d75676b1af3e84d21310bd3d3a472a92b8aa) )
	ROM_LOAD16_BYTE( "p3210p71.hi", 0x00000, 0x080000, CRC(cfd11c31) SHA1(6826fd6b46793a42b7bc446a34effe981a893ee3) )
	ROM_LOAD16_BYTE( "p3210p71.lo", 0x00001, 0x080000, CRC(2f48b987) SHA1(7ac930e1c58dcf62e9b613ec4cc444ad6303a33d) )
	ROM_LOAD16_BYTE( "p3210p73.hi", 0x00000, 0x080000, CRC(ec47b51c) SHA1(36fe889b2961fcef2f0b1790d18b379bcbfcb182) )
	ROM_LOAD16_BYTE( "p3210p73.lo", 0x00001, 0x080000, CRC(ce0ee1c9) SHA1(4d29a6158714c67172a5e6a86db48635f78b0cfe) )
	ROM_LOAD16_BYTE( "p3210s71.hi", 0x00000, 0x080000, CRC(a3361b74) SHA1(79710fd876f493dadef5d6f7c02e36e12fe0033c) )
	ROM_LOAD16_BYTE( "p3210s71.lo", 0x00001, 0x080000, CRC(2fce4f8a) SHA1(d03bcae4f1731aacad907ca6bd752e19f7e5ece7) )
	ROM_LOAD16_BYTE( "p3210s73.hi", 0x00000, 0x080000, CRC(ede2599c) SHA1(eb49189e4db10d3c20951035d796faba8aa6f238) )
	ROM_LOAD16_BYTE( "p3210s73.lo", 0x00001, 0x080000, CRC(3ae378c2) SHA1(3c57abb05099c47dde00942cee4925cb75357f2a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008790.bin", 0x0000, 0x100000, CRC(3c56a8b6) SHA1(8c06aa725233f4feb7c2e703f203cf9b0c6669a1) )
	ROM_LOAD( "95008791.bin", 0x0000, 0x100000, CRC(7378a4a8) SHA1(af9dd1fcbd8b77fab4afc85a325c0eb011f35e3a) )
ROM_END



ROM_START( sc_dndbr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422150.lo", 0x00001, 0x080000, CRC(10b1d71f) SHA1(442ce4e98fd7ab7678339ca520353fc7f98e353e) )
	ROM_LOAD16_BYTE( "95422151.hi", 0x00000, 0x080000, CRC(c07dd832) SHA1(076eef9b1b4f527b866634e2522c0fc06eb2b582) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422154.lo", 0x00001, 0x080000, CRC(2593d490) SHA1(3d3b4375c37eb8faa65304d874d54b16459ae504) )
	ROM_LOAD16_BYTE( "95422155.hi", 0x00000, 0x080000, CRC(5e8c0dc2) SHA1(eea1d5016870058e65c33cef7da944f9a7854837) )
	ROM_LOAD16_BYTE( "95422298.lo", 0x00001, 0x080000, CRC(1925aed8) SHA1(a8e9f69c80270efd5e8587f54ed4259e306a6e90) )
	ROM_LOAD16_BYTE( "95422299.hi", 0x00000, 0x080000, CRC(8130eaa3) SHA1(7c7621ae5bca158fe83b5596da0bd2f9a027e127) )
	ROM_LOAD16_BYTE( "95422322.lo", 0x00001, 0x080000, CRC(e353fb01) SHA1(b65f6d6e0b396a0e9fb939605c118d40676c6d97) )
	ROM_LOAD16_BYTE( "95422323.hi", 0x00000, 0x080000, CRC(27cc917f) SHA1(742e8d9b3a134f3d187febc747966ba378ac9877) )
	ROM_LOAD16_BYTE( "95422430.lo", 0x00001, 0x080000, CRC(12a6c08e) SHA1(4c003012110187799841df7e85dfe8874afaf878) )
	ROM_LOAD16_BYTE( "95422431.hi", 0x00000, 0x080000, CRC(d7a1080e) SHA1(64a537e37980a6f918a3c43a391aea003a8b5a2d) )
	ROM_LOAD16_BYTE( "95422462.lo", 0x00001, 0x080000, CRC(bfc9a904) SHA1(1bcb566fdcbaeab46ef0958b4270248edfb459cc) )
	ROM_LOAD16_BYTE( "95422463.hi", 0x00000, 0x080000, CRC(d9fdf257) SHA1(4982e1652c481fb494c481b34b8affb009c835fa) )
	ROM_LOAD16_BYTE( "95422504.lo", 0x00001, 0x080000, CRC(4a0f3dca) SHA1(0e36042e969c8d049c0ac8dc027cc0b8699570d0) )
	ROM_LOAD16_BYTE( "95422505.hi", 0x00000, 0x080000, CRC(c6b55463) SHA1(429d3d191f3e3a814c12daa0fa1eefe03c25b218) )
	ROM_LOAD16_BYTE( "95422802.lo", 0x00001, 0x080000, CRC(9c9868f7) SHA1(72a2162568032775ca5cb8283d3437314a453a45) )
	ROM_LOAD16_BYTE( "95422803.hi", 0x00000, 0x080000, CRC(4d2f0f6c) SHA1(95fe69b8bafd6780ac32e76d1c43f449c941ecc4) )
	ROM_LOAD16_BYTE( "95423150.lo", 0x00001, 0x080000, CRC(b0a8336a) SHA1(c4f2a1cae19858ec136f85d3624100be6f3c044f) )
	ROM_LOAD16_BYTE( "95423151.hi", 0x00000, 0x080000, CRC(527c2a60) SHA1(ef1c057582d7ef2a6d7bdc4e9658326f0536a69d) )
	ROM_LOAD16_BYTE( "95423154.lo", 0x00001, 0x080000, CRC(6c7bb586) SHA1(1c30a83f451cd168e06dc1249c071b66d01b2c43) )
	ROM_LOAD16_BYTE( "95423155.hi", 0x00000, 0x080000, CRC(5ee307c4) SHA1(df8b23ed617120c041fb5e52746b12aaa77083f7) )
	ROM_LOAD16_BYTE( "95423298.lo", 0x00001, 0x080000, CRC(499229f5) SHA1(398f4276c86133b17f95871e399f0195ae7aaa04) )
	ROM_LOAD16_BYTE( "95423299.hi", 0x00000, 0x080000, CRC(3d855dd0) SHA1(351bb1191bedb5d22b289fd0b3ae8f5c5c9ebf94) )
	ROM_LOAD16_BYTE( "95423322.lo", 0x00001, 0x080000, CRC(1c701b97) SHA1(d41eb80fd3f8a9525173a35199cbe7526b0898fe) )
	ROM_LOAD16_BYTE( "95423323.hi", 0x00000, 0x080000, CRC(09b53479) SHA1(3783163cb2a1502c8b59d230116c6d6c42fb356d) )
	ROM_LOAD16_BYTE( "95423430.lo", 0x00001, 0x080000, CRC(d95f3e3a) SHA1(6805a7eb1ea84b10721ebe863de09608e5d3643d) )
	ROM_LOAD16_BYTE( "95423431.hi", 0x00000, 0x080000, CRC(242bd27b) SHA1(7183fc705a9a60e2e7cd38d7dc2ee99231df6ccb) )
	ROM_LOAD16_BYTE( "95423462.lo", 0x00001, 0x080000, CRC(43b8cd87) SHA1(724d60e39d1b69b3766eb3f86e5f56ffc227d13f) )
	ROM_LOAD16_BYTE( "95423463.hi", 0x00000, 0x080000, CRC(ecca1f40) SHA1(a49396bfe41ff18e4bc44051e9dbfccf9604d738) )
	ROM_LOAD16_BYTE( "95423504.lo", 0x00001, 0x080000, CRC(92e3a59d) SHA1(52c5c48f3d8feceb64bb3ea544db2461b9bcd2f0) )
	ROM_LOAD16_BYTE( "95423505.hi", 0x00000, 0x080000, CRC(2c806756) SHA1(8e9e44e8a1ad527ae3f90f6bf25734b5648f87bb) )
	ROM_LOAD16_BYTE( "95423802.lo", 0x00001, 0x080000, CRC(07f38e50) SHA1(0975fc113086c39f3970dee8d3bbed42c4ba853c) )
	ROM_LOAD16_BYTE( "95423803.hi", 0x00000, 0x080000, CRC(f7efe16f) SHA1(52a990f39cf99af51787b6749ff78a98151957de) )
	ROM_LOAD16_BYTE( "95426056.lo", 0x00001, 0x080000, CRC(c9a92cd3) SHA1(d2364fbc976c9aa67a8410c5754f957b60c86f16) )
	ROM_LOAD16_BYTE( "95426057.hi", 0x00000, 0x080000, CRC(8b730a59) SHA1(d016748e68b89057fe3df57bdccdd84fbdc309a9) )
	ROM_LOAD16_BYTE( "95426058.lo", 0x00001, 0x080000, CRC(4d37ac05) SHA1(0bed1340613a52fa22811788d43cb54d61678d12) )
	ROM_LOAD16_BYTE( "95426059.hi", 0x00000, 0x080000, CRC(5b9ffcd7) SHA1(300f5236aec96ba814d01e7b914fa293939e24b4) )
	ROM_LOAD16_BYTE( "95426288.lo", 0x00001, 0x080000, CRC(0414dea3) SHA1(cd8bf53eb3cc970c47d1b4235d5e2e0b56a8e1fb) )
	ROM_LOAD16_BYTE( "95426289.hi", 0x00000, 0x080000, CRC(cdf8fabe) SHA1(7deaaab4bdf93e4caddba11bd2876560e26f4758) )
	ROM_LOAD16_BYTE( "95426332.lo", 0x00001, 0x080000, CRC(cc96ab08) SHA1(660f1b1f04a8614a98eb61c824d2f77648e6496d) )
	ROM_LOAD16_BYTE( "95426333.hi", 0x00000, 0x080000, CRC(d1cb3f47) SHA1(ba090e2cc438927fc6156e58d7651c7ee97b9091) )
	ROM_LOAD16_BYTE( "95427056.lo", 0x00001, 0x080000, CRC(e0712d84) SHA1(13c32179c7f78c6d020ea613ede92bee8396e32c) )
	ROM_LOAD16_BYTE( "95427057.hi", 0x00000, 0x080000, CRC(1a097df2) SHA1(3fba0d7d1289c0fdd79da3b548bfc94b7fe617ef) )
	ROM_LOAD16_BYTE( "95427058.lo", 0x00001, 0x080000, CRC(e3cf1d56) SHA1(265815afc3f535cc0433dcea9c541ce054159b8a) )
	ROM_LOAD16_BYTE( "95427059.hi", 0x00000, 0x080000, CRC(5cd8faac) SHA1(7a64d26423c274a9d0a243a3422a7bf37dc8d961) )
	ROM_LOAD16_BYTE( "95427288.lo", 0x00001, 0x080000, CRC(82f456e6) SHA1(6f3a282bcbf80c1e948d50227fee93c1cc6d6053) )
	ROM_LOAD16_BYTE( "95427289.hi", 0x00000, 0x080000, CRC(65c8444c) SHA1(42ce3791ea3384f4704725a296e99912d7758c55) )
	ROM_LOAD16_BYTE( "95427332.lo", 0x00001, 0x080000, CRC(639ea20c) SHA1(d4cab4bfdeb843169a11355e34162677a045121b) )
	ROM_LOAD16_BYTE( "95427333.hi", 0x00000, 0x080000, CRC(654cfe7c) SHA1(316f201009343ecfa3397e97407e4f7566950a3a) )
	ROM_LOAD16_BYTE( "p3011p01.hi", 0x00000, 0x080000, CRC(668c910c) SHA1(765c45d37f1a1f1f35709c7c6de74ddf081cf275) )
	ROM_LOAD16_BYTE( "p3011p01.lo", 0x00001, 0x080000, CRC(eaab8c27) SHA1(939975e613aa421d5e23a1d620f07cd49cd20d81) )
	ROM_LOAD16_BYTE( "p3011p41.hi", 0x00000, 0x080000, CRC(5018bf9b) SHA1(e9fa0178b9c866648c955f9d0afce55dc3c8e01c) )
	ROM_LOAD16_BYTE( "p3011p41.lo", 0x00001, 0x080000, CRC(d7d4d793) SHA1(77db3549607f112d307bff1e8cc41be670915967) )
	ROM_LOAD16_BYTE( "p3011p72.hi", 0x00000, 0x080000, CRC(de759c0b) SHA1(b9ccc2e7ac3e87f65b8921fabe59b23d1f1f0cf6) )
	ROM_LOAD16_BYTE( "p3011p72.lo", 0x00001, 0x080000, CRC(5dbf7b6f) SHA1(39a5642af03d20c07a7b9781259ed3d1d3a91e97) )
	ROM_LOAD16_BYTE( "p3011pe1.hi", 0x00000, 0x080000, CRC(421d83b8) SHA1(29eda16c7bc3cdf145090e7dfbf3c6b1a8fd81b4) )
	ROM_LOAD16_BYTE( "p3011pe1.lo", 0x00001, 0x080000, CRC(109caf89) SHA1(f3fe4a8f70c86f55ca5378056f4e6d61bc88b7da) )
	ROM_LOAD16_BYTE( "p3011s01.hi", 0x00000, 0x080000, CRC(46cfec27) SHA1(23862773a4682a18c1082082831a1ed5a27460d5) )
	ROM_LOAD16_BYTE( "p3011s01.lo", 0x00001, 0x080000, CRC(70e74304) SHA1(a39edc2431a6cdfb10bbb676acec7c0c0243f5e1) )
	ROM_LOAD16_BYTE( "p3011s41.hi", 0x00000, 0x080000, CRC(8fde35ce) SHA1(1dfa0e260779aaed8e9207c39c9e1776ec468058) )
	ROM_LOAD16_BYTE( "p3011s41.lo", 0x00001, 0x080000, CRC(3c8f3e91) SHA1(2d6b0643940c283c304a3f15381b1093323e4b1c) )
	ROM_LOAD16_BYTE( "p3011s72.hi", 0x00000, 0x080000, CRC(8523c4d7) SHA1(f365a3b9a24b686afa1866382cef3cf6ee88de19) )
	ROM_LOAD16_BYTE( "p3011s72.lo", 0x00001, 0x080000, CRC(32aa2e4e) SHA1(7fb19c72d021780672871ee2ea27074cbe4af233) )
	ROM_LOAD16_BYTE( "p3011se1.hi", 0x00000, 0x080000, CRC(6e547687) SHA1(ea1a56a5afb179437c9b9f5ee52cade531aa2dca) )
	ROM_LOAD16_BYTE( "p3011se1.lo", 0x00001, 0x080000, CRC(03467347) SHA1(4675bd87d61dc811a2f4525d00a220d11c7eb258) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008723.bin", 0x0000, 0x100000, CRC(6e1d9bd5) SHA1(92b2fd0b75a195af6ddfbdee3316f8af4bc4eb1a) )
	ROM_LOAD( "95008724.bin", 0x0000, 0x100000, CRC(309c1bf1) SHA1(82811b503a06e30a915eebdbdbcd63b567f241c1) )
ROM_END



ROM_START( sc_dndcc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422390.lo", 0x00001, 0x080000, CRC(6bf4e3e6) SHA1(dc4add26d606053a1003ef54c54321fef38966be) )
	ROM_LOAD16_BYTE( "95422391.hi", 0x00000, 0x080000, CRC(84aa4dd6) SHA1(b63d4eca7841017e4e1ca9b3abb973dc9273027c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422392.lo", 0x00001, 0x080000, CRC(e83c2bea) SHA1(ea4ed543476f637236e03249c493c10693ce27b1) )
	ROM_LOAD16_BYTE( "95422393.hi", 0x00000, 0x080000, CRC(ba88c94a) SHA1(0de684f3ac06899df45ecac9a79f13948f02af70) )
	ROM_LOAD16_BYTE( "95422500.lo", 0x00001, 0x080000, CRC(d349ecbf) SHA1(d438db7f2e1647bd87b416721ca8d9f53d196a84) )
	ROM_LOAD16_BYTE( "95422501.hi", 0x00000, 0x080000, CRC(4da063fd) SHA1(1332fb94f6cc3e959488cd514469a2dd3c1be9c6) )
	ROM_LOAD16_BYTE( "95422782.lo", 0x00001, 0x080000, CRC(6e038242) SHA1(e1e4799aaaee1007154490a3cade13567d599799) )
	ROM_LOAD16_BYTE( "95422783.hi", 0x00000, 0x080000, CRC(53f64815) SHA1(cd30f5d5ebeaa2c77ea9205c28ef65ecc5ed9c88) )
	ROM_LOAD16_BYTE( "95423390.lo", 0x00001, 0x080000, CRC(9a0c32bb) SHA1(7325dbcc5b448803314f0e299f832081f1db9a5f) )
	ROM_LOAD16_BYTE( "95423391.hi", 0x00000, 0x080000, CRC(7c7efdf0) SHA1(b94190d5ee1bc4b82fb2ab500f9cf2253c47a7d4) )
	ROM_LOAD16_BYTE( "95423392.lo", 0x00001, 0x080000, CRC(1284ed1a) SHA1(ccaa8abd4c0274d1187e58c16a553e8f7c960c87) )
	ROM_LOAD16_BYTE( "95423500.lo", 0x00001, 0x080000, CRC(128b7b26) SHA1(d229562614c159e515b520273e4802f1bdf6da27) )
	ROM_LOAD16_BYTE( "95423501.hi", 0x00000, 0x080000, CRC(9283b144) SHA1(91303b655a7ea8fb3837b2c8b520c067e2950af5) )
	ROM_LOAD16_BYTE( "95423804.lo", 0x00001, 0x080000, CRC(c9c507b7) SHA1(8814b353a072c1cc0f3f35256ea89d7a67558f6d) )
	ROM_LOAD16_BYTE( "95423805.hi", 0x00000, 0x080000, CRC(d5f71e0e) SHA1(d1c96c12140d189ca2a4ea56e6279bb32eb0194b) )
	ROM_LOAD16_BYTE( "95426052.lo", 0x00001, 0x080000, CRC(a98e6967) SHA1(40cf2aac490dfbb1aa28eb3af7325d831f22460e) )
	ROM_LOAD16_BYTE( "95426053.hi", 0x00000, 0x080000, CRC(135f0688) SHA1(bde939e11eae1342eb32495e88d67f507bb841ad) )
	ROM_LOAD16_BYTE( "95426054.lo", 0x00001, 0x080000, CRC(0de246f9) SHA1(5d4b884c2539c8aa3b209289f9580b9308018801) )
	ROM_LOAD16_BYTE( "95426055.hi", 0x00000, 0x080000, CRC(29884b00) SHA1(261000bae35d3d48f085f5c6526523f5e076ba35) )
	ROM_LOAD16_BYTE( "95426322.lo", 0x00001, 0x080000, CRC(133a2d50) SHA1(458dc9a1434a94f022826f24ee929b2a707b56ab) )
	ROM_LOAD16_BYTE( "95426323.hi", 0x00000, 0x080000, CRC(b8d80583) SHA1(dac5c0ef75dae496803ae274ac28ac904b54ab0e) )
	ROM_LOAD16_BYTE( "95426400.lo", 0x00001, 0x080000, CRC(d41f2cf8) SHA1(5c41dafdeedb4ff0dc988de1367f26f2ddf0e412) )
	ROM_LOAD16_BYTE( "95426401.hi", 0x00000, 0x080000, CRC(dfb30753) SHA1(8f41e2c1976cefcab122bdc48437e02a0d3539c0) )
	ROM_LOAD16_BYTE( "95427052.lo", 0x00001, 0x080000, CRC(bb2f094a) SHA1(b90f35be18e39b003590635152f864be67567997) )
	ROM_LOAD16_BYTE( "95427053.hi", 0x00000, 0x080000, CRC(818a702c) SHA1(cf0633cd1c4836a4947063b42a0fd0360879349d) )
	ROM_LOAD16_BYTE( "95427054.lo", 0x00001, 0x080000, CRC(30397fe0) SHA1(f8181e08dd7b68e07706bd0b14ff126f4f97aff5) )
	ROM_LOAD16_BYTE( "95427055.hi", 0x00000, 0x080000, CRC(40a88ac1) SHA1(a2212609e27df356b68ab595da3bde789be88280) )
	ROM_LOAD16_BYTE( "95427322.lo", 0x00001, 0x080000, CRC(3338519c) SHA1(95aefe3c8c688917bde07d9965ff647dbf7280ac) )
	ROM_LOAD16_BYTE( "95427323.hi", 0x00000, 0x080000, CRC(93dc915a) SHA1(cefd62f72d322a7c5729857bec05fc240bdae853) )
	ROM_LOAD16_BYTE( "95427400.lo", 0x00001, 0x080000, CRC(e9eab94b) SHA1(c856f5632b3e14232e3f2c47ad03eda7b9b983eb) )
	ROM_LOAD16_BYTE( "95427401.hi", 0x00000, 0x080000, CRC(045202fa) SHA1(6a183f17c023ef43416572860c5261271e701cf0) )
	ROM_LOAD16_BYTE( "p3017p71.hi", 0x00000, 0x080000, CRC(2cbfa80a) SHA1(d31d57360700e2b22569168fbbd769570e0e257e) )
	ROM_LOAD16_BYTE( "p3017p71.lo", 0x00001, 0x080000, CRC(e80f176a) SHA1(f66e4165209396646442fb640b90f7fe48fc884e) )
	ROM_LOAD16_BYTE( "p3017pf1.hi", 0x00000, 0x080000, CRC(dccfc4e7) SHA1(7caed83dffa0fd6bccdc80acdc6b0a619d2d4045) )
	ROM_LOAD16_BYTE( "p3017pf1.lo", 0x00001, 0x080000, CRC(58d2c26b) SHA1(e9bc7afb62550842949fda472f3cae83377a3a84) )
	ROM_LOAD16_BYTE( "p3017pf2.hi", 0x00000, 0x080000, CRC(d1a87204) SHA1(3e9ef9c8d00be9970b6f3def0d2b977cb8899a27) )
	ROM_LOAD16_BYTE( "p3017pf2.lo", 0x00001, 0x080000, CRC(a3697ce1) SHA1(57b0cc7cd75c746033b9ca490574a4925f6d39a1) )
	ROM_LOAD16_BYTE( "p3017pg1.hi", 0x00000, 0x080000, CRC(0fd1ef51) SHA1(bfabe358d647e46f3c24e716422d201f910b9d81) )
	ROM_LOAD16_BYTE( "p3017pg1.lo", 0x00001, 0x080000, CRC(d006fe79) SHA1(920566666d184ab8f57bd92159a3bb6c35052fc2) )
	ROM_LOAD16_BYTE( "p3017pg2.hi", 0x00000, 0x080000, CRC(acb4e681) SHA1(966a83967bdfed941abea200b25fe1a06440016d) )
	ROM_LOAD16_BYTE( "p3017pg2.lo", 0x00001, 0x080000, CRC(8d4b0e8e) SHA1(c48d3aa33911e13ff9af0aca06afe05a72adf3f9) )
	ROM_LOAD16_BYTE( "p3017s71.hi", 0x00000, 0x080000, CRC(df5bd3b0) SHA1(b70190082947a7a1c2aea4bceb12cc032e35b59d) )
	ROM_LOAD16_BYTE( "p3017s71.lo", 0x00001, 0x080000, CRC(2639b43d) SHA1(6b06b122239093cc47af360d4eee7d9cc850dc8f) )
	ROM_LOAD16_BYTE( "p3017sf1.hi", 0x00000, 0x080000, CRC(3fd02a1b) SHA1(0eb81600349b1a745f24f662fe054148688ba966) )
	ROM_LOAD16_BYTE( "p3017sf1.lo", 0x00001, 0x080000, CRC(d2e45159) SHA1(f4557ba7f97016fba81e6b977981444a3d797a14) )
	ROM_LOAD16_BYTE( "p3017sf2.hi", 0x00000, 0x080000, CRC(47651875) SHA1(f7c48a0e56bd9b748ede58916529aeec8240304f) )
	ROM_LOAD16_BYTE( "p3017sf2.lo", 0x00001, 0x080000, CRC(f7f4333d) SHA1(9e651b1a6422935776dc6eb4276016ea45a21297) )
	ROM_LOAD16_BYTE( "p3017sg1.hi", 0x00000, 0x080000, CRC(2db61930) SHA1(7516dd7ef4ae78afe0fb2a12412e5c9912928aeb) )
	ROM_LOAD16_BYTE( "p3017sg1.lo", 0x00001, 0x080000, CRC(142ed198) SHA1(b4d28917502a2c4f147db115ff637c321dacaa9e) )
	ROM_LOAD16_BYTE( "p3017sg2.hi", 0x00000, 0x080000, CRC(43dd9130) SHA1(c137f3de719c7d41f99e0725bba5be3394af57d6) )
	ROM_LOAD16_BYTE( "p3017sg2.lo", 0x00001, 0x080000, CRC(086f50be) SHA1(082c6469c5611a1e8f9dbcd80339f38657ddc2b4) )
	ROM_LOAD16_BYTE( "p3250p11.hi", 0x00000, 0x080000, CRC(cdd8e6fd) SHA1(c125f8af8193eeec3b143fae185100b490251dae) )
	ROM_LOAD16_BYTE( "p3250p11.lo", 0x00001, 0x080000, CRC(0303361b) SHA1(aafa4a680dd919afccba269affde34599164d9d2) )
	ROM_LOAD16_BYTE( "p3250p12.hi", 0x00000, 0x080000, CRC(c91b43c1) SHA1(a3337f0880d2d7b4e6cb0ea3e2824d0661eb6004) )
	ROM_LOAD16_BYTE( "p3250p12.lo", 0x00001, 0x080000, CRC(38e01a0a) SHA1(178b31725aca4a2676c50466f3d4b61fa831d7e3) )
	ROM_LOAD16_BYTE( "p3250s11.hi", 0x00000, 0x080000, CRC(f985e611) SHA1(b0436688b83a0900e41fb61a1c09438f9f8663ac) )
	ROM_LOAD16_BYTE( "p3250s11.lo", 0x00001, 0x080000, CRC(11dec07e) SHA1(171345b38f07a5bc1f09d98fe0802a353bafa7c6) )
	ROM_LOAD16_BYTE( "p3250s12.hi", 0x00000, 0x080000, CRC(7c3de312) SHA1(eaa216152f5e59b029fdb034baebd8c4fbd29794) )
	ROM_LOAD16_BYTE( "p3250s12.lo", 0x00001, 0x080000, CRC(fd2d6f53) SHA1(be1b3ac89b6cece9f34498bd4f1a0541da689df5) )
	ROM_LOAD16_BYTE( "p3362p71.hi", 0x00000, 0x080000, CRC(a6fe0aef) SHA1(10a17944dbca7624ed451d7187edc89c582ecb8b) )
	ROM_LOAD16_BYTE( "p3362p71.lo", 0x00001, 0x080000, CRC(a8cf3b5c) SHA1(d802560eb43c51571f39389011ec3e5bae68659f) )
	ROM_LOAD16_BYTE( "p3362s71.hi", 0x00000, 0x080000, CRC(2f609ab3) SHA1(2e0cf0b2dc91f4bc3bb9c6dcc2716491eef01c99) )
	ROM_LOAD16_BYTE( "p3362s71.lo", 0x00001, 0x080000, CRC(2af6741f) SHA1(62e396cfc3a8198e6b62b3d07d9894ed9d8e5f89) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008746.bin", 0x0000, 0x100000, CRC(ef3c39b9) SHA1(21b9788080de68acd436608d7d46fd9663d1589b) )
	ROM_LOAD( "95008747.bin", 0x0000, 0x100000, CRC(9f9b638f) SHA1(5eae49f8a9571f8fade9acf0fc80ea3d70cc9e18) )

	ROM_LOAD( "95008840.bin", 0x0000, 0x100000, CRC(2aa17d67) SHA1(43bdee1b3d0a0bf28f672620867fa3dc95727fbc) )
	ROM_LOAD( "95008841.bin", 0x0000, 0x100000, CRC(594a9cd7) SHA1(667fa3106327ce4ff23877f2d48d3e3e360848d0) )

	ROM_LOAD( "95009131.bin", 0x0000, 0x100000, CRC(59a9e50a) SHA1(15d79b177a1e926cd5aee0f969f5ef8b30fac203) )
	ROM_LOAD( "95009132.bin", 0x0000, 0x100000, CRC(5e8a7ca6) SHA1(419ecc6ac15004bdd83bcd5b3e00d9dcd0d24936) )
ROM_END



ROM_START( sc_dnddw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422472.lo", 0x00001, 0x080000, CRC(f97160be) SHA1(76f495ed1ec7901a4529f7106b081864345308c4) )
	ROM_LOAD16_BYTE( "95422473.hi", 0x00000, 0x080000, CRC(adde9c8c) SHA1(b5cc059af817ba49087fc68001c52bc0be3ac974) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422474.lo", 0x00001, 0x080000, CRC(2d263524) SHA1(202f0a095b4a10979105dfa1e189c8eb0f2fb18e) )
	ROM_LOAD16_BYTE( "95422475.hi", 0x00000, 0x080000, CRC(a8ca5e00) SHA1(308f0d38a70e26a9f55731957206c2c11c41a5b8) )
	ROM_LOAD16_BYTE( "95422860.lo", 0x00001, 0x080000, CRC(76bd11a3) SHA1(10f54c15c56fb1350eba3608301a0cb4c370ac3f) )
	ROM_LOAD16_BYTE( "95422861.hi", 0x00000, 0x080000, CRC(d33408b1) SHA1(773b97fc78c13df084f85cfa21cb0da156392631) )
	ROM_LOAD16_BYTE( "95423472.lo", 0x00001, 0x080000, CRC(12151eae) SHA1(0dc319849c03b9525844f3097201f4b5811dd84d) )
	ROM_LOAD16_BYTE( "95423473.hi", 0x00000, 0x080000, CRC(bcbfca3c) SHA1(8ac07a77d128f166c681f9528b08654cd7d4f304) )
	ROM_LOAD16_BYTE( "95423474.lo", 0x00001, 0x080000, CRC(c0bb2d73) SHA1(7782e69fbdedede4dc625441ce428db922964527) )
	ROM_LOAD16_BYTE( "95423475.hi", 0x00000, 0x080000, CRC(9d33a1d6) SHA1(d78f271521ccf8d89b26b10a3772077caa0267c1) )
	ROM_LOAD16_BYTE( "95423860.lo", 0x00001, 0x080000, CRC(4772372f) SHA1(61479cec9bf0a407670f37d0c81430f26d49d546) )
	ROM_LOAD16_BYTE( "95423861.hi", 0x00000, 0x080000, CRC(78fa784f) SHA1(5891fe0c32a988e7ac36492a33dcd2521b928dc0) )
	ROM_LOAD16_BYTE( "95426174.lo", 0x00001, 0x080000, CRC(c78e421b) SHA1(54b065ffae73e39ef7d410d7488f7df7fd6923c1) )
	ROM_LOAD16_BYTE( "95426175.hi", 0x00000, 0x080000, CRC(11e52921) SHA1(14c792918b0b09b6903b2506baa0ef3b67787c29) )
	ROM_LOAD16_BYTE( "95426176.lo", 0x00001, 0x080000, CRC(005ac134) SHA1(d3921e5c6856bd9d7410cd91bff134db2e48361b) )
	ROM_LOAD16_BYTE( "95426177.hi", 0x00000, 0x080000, CRC(6202ee1f) SHA1(17e317e47d4f6b2542c12d6646b8e58b6ece8394) )
	ROM_LOAD16_BYTE( "95426272.lo", 0x00001, 0x080000, CRC(b55f8e84) SHA1(722a7568dab93c6e6717787f98c3ac1c4f0dfc52) )
	ROM_LOAD16_BYTE( "95426273.hi", 0x00000, 0x080000, CRC(d6c652e2) SHA1(51f21b2c8d6ba814f3a8fd880fc4c0a088e4a0fc) )
	ROM_LOAD16_BYTE( "95426418.lo", 0x00001, 0x080000, CRC(5300fde3) SHA1(5bc0ed8507a9c154dc92732fc86f2e12de462eda) )
	ROM_LOAD16_BYTE( "95426419.hi", 0x00000, 0x080000, CRC(c616445b) SHA1(842592e30aa3c94e26348c0f6a3bfaa3d1fc441f) )
	ROM_LOAD16_BYTE( "95427174.lo", 0x00001, 0x080000, CRC(d796a1bd) SHA1(a4e8e2142b852f1aa67cac9bb12b490d9c72f6a5) )
	ROM_LOAD16_BYTE( "95427175.hi", 0x00000, 0x080000, CRC(c8fd8e4e) SHA1(2837297b745dd44388067df3d905413f05e02d10) )
	ROM_LOAD16_BYTE( "95427176.lo", 0x00001, 0x080000, CRC(579ffa4c) SHA1(b6ef21dbdb4255db29fa9b901fde26ddf01cd823) )
	ROM_LOAD16_BYTE( "95427177.hi", 0x00000, 0x080000, CRC(3f822d83) SHA1(0f2bf3769e7c61b7f1a7c77bd06dfccf64929a57) )
	ROM_LOAD16_BYTE( "95427272.lo", 0x00001, 0x080000, CRC(c16a327e) SHA1(aa125f3e4ae640050ca117ab79d2e212125da540) )
	ROM_LOAD16_BYTE( "95427273.hi", 0x00000, 0x080000, CRC(e4fefd0f) SHA1(5fb8700e4b8cf7493de64f5c6c24c98386256727) )
	ROM_LOAD16_BYTE( "95427418.lo", 0x00001, 0x080000, CRC(52c3f9f3) SHA1(d1af94901702bde90ddd99aed37a8e6adea13eb9) )
	ROM_LOAD16_BYTE( "95427419.hi", 0x00000, 0x080000, CRC(1f32ae61) SHA1(d6172884ca7a8837c40f40b0a89a4886de1e05fc) )
	ROM_LOAD16_BYTE( "p3202p01.hi", 0x00000, 0x080000, CRC(c4dbbc10) SHA1(eaf716c867db96001cd4011bdf34088ef7b63c23) )
	ROM_LOAD16_BYTE( "p3202p01.lo", 0x00001, 0x080000, CRC(9ce75b13) SHA1(3981602a789ce0e435fd35143edb1b39cfd5a101) )
	ROM_LOAD16_BYTE( "p3202s01.hi", 0x00000, 0x080000, CRC(104f2021) SHA1(889a347fa799b00bff196bd3fd8a1257ce07bb2f) )
	ROM_LOAD16_BYTE( "p3202s01.lo", 0x00001, 0x080000, CRC(6c490f0f) SHA1(661bfc67aaea82e34de2d606a1779f4102ded05a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008754.bin", 0x0000, 0x100000, CRC(d2c3e3e5) SHA1(3d21c812456618471a331d596760ea8746afc036) )
	ROM_LOAD( "95008755.bin", 0x0000, 0x100000, CRC(e6906180) SHA1(81215fd3dfe315123d5b028047a93e30baa52b5d) )
ROM_END



ROM_START( sc_dnddf )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422284.lo", 0x00001, 0x080000, CRC(eb0f6493) SHA1(fe3efe77d8686cbe24562ba617a9fdc6a0b966cc) )
	ROM_LOAD16_BYTE( "95422285.hi", 0x00000, 0x080000, CRC(a6d37a4d) SHA1(4f9bb99f70af06fc0a010aa03916780f8358357f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422286.lo", 0x00001, 0x080000, CRC(f39fd151) SHA1(a9464702f2c2219b19653b3ffd16f788b25ee36a) )
	ROM_LOAD16_BYTE( "95422287.hi", 0x00000, 0x080000, CRC(d4cccb65) SHA1(8fabfccfdb04a5583b7aeb9a93678fdc530c324c) )
	ROM_LOAD16_BYTE( "95422456.lo", 0x00001, 0x080000, CRC(3bcd2b48) SHA1(6d60fcd8d7d6f4585954f77c4d29d08787727f53) )
	ROM_LOAD16_BYTE( "95422457.hi", 0x00000, 0x080000, CRC(cbfb2069) SHA1(016f64a65787f2d0752502334b898a4a198b2385) )
	ROM_LOAD16_BYTE( "95422502.lo", 0x00001, 0x080000, CRC(75f83e37) SHA1(fadaec98363926cedd4529c5737bb012f0f6612a) )
	ROM_LOAD16_BYTE( "95422503.hi", 0x00000, 0x080000, CRC(d4130535) SHA1(213905095265db0c430b5216861d60f5ae9b0780) )
	ROM_LOAD16_BYTE( "95422682.lo", 0x00001, 0x080000, CRC(616cf372) SHA1(09c494c31c4e4387879924c61e40472854b0698f) )
	ROM_LOAD16_BYTE( "95422683.hi", 0x00000, 0x080000, CRC(a5306717) SHA1(8665d2cfec7e3b6eb370b9bd14532aa91e6b363a) )
	ROM_LOAD16_BYTE( "95423284.lo", 0x00001, 0x080000, CRC(1b5d3e9f) SHA1(c6d0284df73e6b10b5f74cd2de3b948869b8d1d7) )
	ROM_LOAD16_BYTE( "95423285.hi", 0x00000, 0x080000, CRC(01086558) SHA1(257ec02fd1d00076a0fa710cd0443a2ade32dd7b) )
	ROM_LOAD16_BYTE( "95423287.hi", 0x00000, 0x080000, CRC(76a0bf55) SHA1(01500a0951dcff87ecb5f0d5741e8a6127a7c40b) )
	ROM_LOAD16_BYTE( "95423456.lo", 0x00001, 0x080000, CRC(9efff5a9) SHA1(58613b6b0a2bff824e7a5cbc1b80cecbe3ad3e17) )
	ROM_LOAD16_BYTE( "95423457.hi", 0x00000, 0x080000, CRC(9bcb67c7) SHA1(db791d68fd72131d51f119a7e8f6914e3d7038a0) )
	ROM_LOAD16_BYTE( "95423502.lo", 0x00001, 0x080000, CRC(fbadd21c) SHA1(ec3f6f468624063d108ac8b02f6d371e1789d555) )
	ROM_LOAD16_BYTE( "95423503.hi", 0x00000, 0x080000, CRC(e4a3f201) SHA1(469247460df805751c8a489f0154469a1f67fc2d) )
	ROM_LOAD16_BYTE( "95423666.lo", 0x00001, 0x080000, CRC(b324f0bc) SHA1(6e2dcec5ec0e7415064c4855401429ff13b3d320) )
	ROM_LOAD16_BYTE( "95423667.hi", 0x00000, 0x080000, CRC(4673fd1b) SHA1(523256163119d48751698dff864bc4dbceb9fbe2) )
	ROM_LOAD16_BYTE( "95426060.lo", 0x00001, 0x080000, CRC(f3b08078) SHA1(c8bb1b5d2fa7e49b09e17cc2980faf0cd9ff01a5) )
	ROM_LOAD16_BYTE( "95426061.hi", 0x00000, 0x080000, CRC(ddde776b) SHA1(8e103a619fdc976d5d2784c65c46cb3278c12748) )
	ROM_LOAD16_BYTE( "95426062.lo", 0x00001, 0x080000, CRC(fdf23ab5) SHA1(cb3107c7b47a2563fef817e72d29d7cbef229587) )
	ROM_LOAD16_BYTE( "95426063.hi", 0x00000, 0x080000, CRC(254e02f9) SHA1(5eb0945b209fb04c7fda394a31ad739d12e4fae6) )
	ROM_LOAD16_BYTE( "95426284.lo", 0x00001, 0x080000, CRC(fb462241) SHA1(c28db0b4a0fd637ffefc8eba79e4f2eb47923832) )
	ROM_LOAD16_BYTE( "95426285.hi", 0x00000, 0x080000, CRC(9c0711ce) SHA1(60cb6de9fdbac5e034ef0af11546df28546434e5) )
	ROM_LOAD16_BYTE( "95426328.lo", 0x00001, 0x080000, CRC(f90c2141) SHA1(ac04d077773c1dc308fcd46b7aaa740d0b90e327) )
	ROM_LOAD16_BYTE( "95426329.hi", 0x00000, 0x080000, CRC(ab0ab0c2) SHA1(6d4ee13533bed1260a67227055584e531a211e5b) )
	ROM_LOAD16_BYTE( "95427060.lo", 0x00001, 0x080000, CRC(318432f1) SHA1(65ad45a682e771aae7caac824891ccc66d3bd203) )
	ROM_LOAD16_BYTE( "95427061.hi", 0x00000, 0x080000, CRC(5d733694) SHA1(0ae447411ecc6bf0d8cceb42a3da2684b9488b66) )
	ROM_LOAD16_BYTE( "95427062.lo", 0x00001, 0x080000, CRC(4830608e) SHA1(fc4e5dbfbde09e42a0e806a19ba020c16125fbc9) )
	ROM_LOAD16_BYTE( "95427063.hi", 0x00000, 0x080000, CRC(340810fd) SHA1(08ffaf1cdaaafceb9a40f6550848abc4098c040e) )
	ROM_LOAD16_BYTE( "95427284.lo", 0x00001, 0x080000, CRC(5f07e80d) SHA1(23fbbf203e95ce13df929fb776d764438131600f) )
	ROM_LOAD16_BYTE( "95427285.hi", 0x00000, 0x080000, CRC(30c3c90d) SHA1(3a2940a3619147c7cd948e7dee0a6d1924892c98) )
	ROM_LOAD16_BYTE( "95427328.lo", 0x00001, 0x080000, CRC(8c1f3034) SHA1(6d8c57ca65837fc55a6c089743b3ab496668e424) )
	ROM_LOAD16_BYTE( "95427329.hi", 0x00000, 0x080000, CRC(f6247ac6) SHA1(910a44ae4540582dad41e368f75f48b2f134e642) )
	ROM_LOAD16_BYTE( "p3014p71.hi", 0x00000, 0x080000, CRC(2e401da4) SHA1(35dfaeecd8a7986e79f2e9f68b30911fc70d477c) )
	ROM_LOAD16_BYTE( "p3014p71.lo", 0x00001, 0x080000, CRC(403ea361) SHA1(5f63e5eb36f9479533abc54c85fe64d90cd82655) )
	ROM_LOAD16_BYTE( "p3014p72.hi", 0x00000, 0x080000, CRC(7948f231) SHA1(f118990d671d906b31b8853acbbf314986aa9447) )
	ROM_LOAD16_BYTE( "p3014p72.lo", 0x00001, 0x080000, CRC(75bfcdbb) SHA1(8c7167d5fa3e085012ab733704c9947c253828ba) )
	ROM_LOAD16_BYTE( "p3014s71.hi", 0x00000, 0x080000, CRC(c1752c29) SHA1(07a873407c27158fc8975df7dd966adf04bd454c) )
	ROM_LOAD16_BYTE( "p3014s71.lo", 0x00001, 0x080000, CRC(ea5dca3e) SHA1(0b9a7f88f5d50798e1f3c18607b74603f15d7cee) )
	ROM_LOAD16_BYTE( "p3014s72.hi", 0x00000, 0x080000, CRC(04a3ace6) SHA1(bf7ad6bbace77fb4871a3e70d3b55ea4c8be14e1) )
	ROM_LOAD16_BYTE( "p3014s72.lo", 0x00001, 0x080000, CRC(7e9ae598) SHA1(c3ac01dabbcff1b33ea204db882e330713ffb84a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008738.bin", 0x0000, 0x100000, CRC(2a06f488) SHA1(666bd9c8091edda4b003fa586e5ae270831c119f) )
	ROM_LOAD( "95008739.bin", 0x0000, 0x100000, CRC(33d677b0) SHA1(5283d23671e340e3fda4eb4c6795d1d56b073206) )
ROM_END




ROM_START( sc_dndpg )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95425512.lo", 0x00001, 0x080000, CRC(1e66031a) SHA1(b149806fe7c0a996dfda4abcd00aa7ae9b126a7b) )
	ROM_LOAD16_BYTE( "95425513.hi", 0x00000, 0x080000, CRC(a668aaae) SHA1(593f846687aa7d851fb38e62046c6174dfa088f5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426232.lo", 0x00001, 0x080000, CRC(fa9c8cc7) SHA1(2190f76cfa94c69fcc153cadb360f84b306203cb) )
	ROM_LOAD16_BYTE( "95426233.hi", 0x00000, 0x080000, CRC(44af356d) SHA1(b162527e089e39baab1fbd35927c926676c50e63) )
	ROM_LOAD16_BYTE( "95426254.lo", 0x00001, 0x080000, CRC(110cf29d) SHA1(98b42fc9024ce41e301136725da4732f1ae5577a) )
	ROM_LOAD16_BYTE( "95426255.hi", 0x00000, 0x080000, CRC(bbc13ad8) SHA1(ff3bc9369c74c5e82466363c8a2c1f80ba88d47e) )
	ROM_LOAD16_BYTE( "95426340.lo", 0x00001, 0x080000, CRC(351c1470) SHA1(ff43accf90b4c3f062b73537715cb13b26c3f35a) )
	ROM_LOAD16_BYTE( "95426341.hi", 0x00000, 0x080000, CRC(45d767a4) SHA1(0b607e04a43cba6b930dbc5bc97f38e3d02630f7) )
	ROM_LOAD16_BYTE( "95426366.lo", 0x00001, 0x080000, CRC(fe9c0d28) SHA1(178c7f2cdfc28079c5a4b507095a032ecd2ee7a9) )
	ROM_LOAD16_BYTE( "95426367.hi", 0x00000, 0x080000, CRC(ee8fb979) SHA1(14b138a7c9c6358dda8331ca55cd1223883a8222) )
	ROM_LOAD16_BYTE( "95426380.lo", 0x00001, 0x080000, CRC(70b248f1) SHA1(ad608dc7f58411275480f3f916775ba0000706b1) )
	ROM_LOAD16_BYTE( "95426381.hi", 0x00000, 0x080000, CRC(f9646a03) SHA1(b40466a0f4ef5ee097dd049384cea04a60654e11) )
	ROM_LOAD16_BYTE( "95426404.lo", 0x00001, 0x080000, CRC(d76543dc) SHA1(9a31cafccdc3c0f8f8598cefe42be658f2e577f1) )
	ROM_LOAD16_BYTE( "95426405.hi", 0x00000, 0x080000, CRC(782b119b) SHA1(7c08e01f85aa0cca5332b51ff52c1e36aee6fc94) )
	ROM_LOAD16_BYTE( "95426426.lo", 0x00001, 0x080000, CRC(e31ce5cc) SHA1(ea447fd1518f2c426733dbc733eadd9a84d55c3f) )
	ROM_LOAD16_BYTE( "95426427.hi", 0x00000, 0x080000, CRC(3e58dec4) SHA1(3a0dbaab826296fa59a83da2c524512442e185f5) )
	ROM_LOAD16_BYTE( "95426446.lo", 0x00001, 0x080000, CRC(ddd0c767) SHA1(f5b1ed561a39de2bc08fb5648a2a3788d91db271) )
	ROM_LOAD16_BYTE( "95426447.hi", 0x00000, 0x080000, CRC(9c7c988a) SHA1(0de04d25fb9dc316820f3f7a0c306531ee7380fc) )
	ROM_LOAD16_BYTE( "95426448.lo", 0x00001, 0x080000, CRC(0d0329e4) SHA1(53a4ee777865f9d5e99e82e5406b62a5ebcfe2c6) )
	ROM_LOAD16_BYTE( "95426449.hi", 0x00000, 0x080000, CRC(89a88879) SHA1(61a3eb35caad027bb0255110a171ca1316ce9571) )
	ROM_LOAD16_BYTE( "95426570.lo", 0x00001, 0x080000, CRC(e0b4620b) SHA1(663ae8b6f0acc3dbe3ba5e7371c82fd694182a7b) )
	ROM_LOAD16_BYTE( "95426571.hi", 0x00000, 0x080000, CRC(b4d87788) SHA1(ab722de9fd11757def819bfe50f3755e4f788e24) )
	ROM_LOAD16_BYTE( "95426596.lo", 0x00001, 0x080000, CRC(cdef5990) SHA1(2dfb32351fd8e6eff337a927a6c6a36364489fa9) )
	ROM_LOAD16_BYTE( "95426597.hi", 0x00000, 0x080000, CRC(78594563) SHA1(14b6c2b9e04eb9c4ae84542ebbe21341da74fca5) )
	ROM_LOAD16_BYTE( "95426666.lo", 0x00001, 0x080000, CRC(128c14fa) SHA1(b942d78ba79469b71387ffa47d5884b7730823dc) )
	ROM_LOAD16_BYTE( "95426667.hi", 0x00000, 0x080000, CRC(de2697ce) SHA1(6b5cf49f4d3baae0a05d2325b871b4a63f1ffb9e) )
	ROM_LOAD16_BYTE( "95426702.lo", 0x00001, 0x080000, CRC(01cfd953) SHA1(e75b3d21b8491e39a047aa0e5eb7cabe1ea53d87) )
	ROM_LOAD16_BYTE( "95426703.hi", 0x00000, 0x080000, CRC(d7d22dfb) SHA1(c8b767a535aaf82ae684959701b99c173b3b1191) )
	ROM_LOAD16_BYTE( "95426810.lo", 0x00001, 0x080000, CRC(4a137784) SHA1(7b4f70192ea8e1d4f2cd2fa56bc464d8031d5236) )
	ROM_LOAD16_BYTE( "95426811.hi", 0x00000, 0x080000, CRC(598477f3) SHA1(614c84cb83d394cf372384f24046e84e3e13a25b) )
	ROM_LOAD16_BYTE( "95427232.lo", 0x00001, 0x080000, CRC(6693042f) SHA1(6d06160a6964ed0047b3526a34f8e3890518e63a) )
	ROM_LOAD16_BYTE( "95427233.hi", 0x00000, 0x080000, CRC(1e98badb) SHA1(5c02735ce82518b8008dc656e0d1bb3d4946aa83) )
	ROM_LOAD16_BYTE( "95427254.lo", 0x00001, 0x080000, CRC(fb9b8e54) SHA1(49188caffe06bc268a8b8c18c4afc076d2b72b8f) )
	ROM_LOAD16_BYTE( "95427255.hi", 0x00000, 0x080000, CRC(74c2c2fc) SHA1(de4863f8a7e9e41655f16f09a38c16f2dc865646) )
	ROM_LOAD16_BYTE( "95427340.lo", 0x00001, 0x080000, CRC(54ab16c7) SHA1(e3117bf540c4854bb594c27e5de7c590b89c4530) )
	ROM_LOAD16_BYTE( "95427341.hi", 0x00000, 0x080000, CRC(66807abf) SHA1(b75d9cfd7f5e3a7c2407ad7f61daf79ec5a50564) )
	ROM_LOAD16_BYTE( "95427366.lo", 0x00001, 0x080000, CRC(728301da) SHA1(b457d1ab5e58ab86918e74721f7163bc7857525d) )
	ROM_LOAD16_BYTE( "95427367.hi", 0x00000, 0x080000, CRC(eda3fb25) SHA1(94482e87f2516adee23dc6745ca80aac23433e83) )
	ROM_LOAD16_BYTE( "95427380.lo", 0x00001, 0x080000, CRC(90ab59fe) SHA1(a6c04779e12952e633d12790cb92efe6f773246a) )
	ROM_LOAD16_BYTE( "95427381.hi", 0x00000, 0x080000, CRC(41978897) SHA1(431a84d2bb41d788b5528ce5ecbfede4ce4d4927) )
	ROM_LOAD16_BYTE( "95427404.lo", 0x00001, 0x080000, CRC(adca905e) SHA1(0643bfc4b64df6ace3bfb399ec4a13f518bc5add) )
	ROM_LOAD16_BYTE( "95427405.hi", 0x00000, 0x080000, CRC(d4886745) SHA1(b1d0786d5cfcbfd0b6670de70000f6d6e6500c37) )
	ROM_LOAD16_BYTE( "95427426.lo", 0x00001, 0x080000, CRC(5144c846) SHA1(6c346d0ad497de903fe35c2c076696076585670e) )
	ROM_LOAD16_BYTE( "95427427.hi", 0x00000, 0x080000, CRC(d8f6433b) SHA1(4cc8f2a1fd1a916804a2de9e6668521489d776f5) )
	ROM_LOAD16_BYTE( "95427446.lo", 0x00001, 0x080000, CRC(2578e7a7) SHA1(417230f706b0a1e1a32b0f0a39752e9a9bef2a57) )
	ROM_LOAD16_BYTE( "95427447.hi", 0x00000, 0x080000, CRC(da7bd1d8) SHA1(7f6e1a8b990f54374fda2162edd6bac85367e0e3) )
	ROM_LOAD16_BYTE( "95427448.lo", 0x00001, 0x080000, CRC(db667b80) SHA1(145fd4b7d05eef01bb1d5bb457f809ec8cfff021) )
	ROM_LOAD16_BYTE( "95427449.hi", 0x00000, 0x080000, CRC(a1efbe17) SHA1(3b62e18751a95f39fae8b5a63d9e798b6bad4a3f) )
	ROM_LOAD16_BYTE( "95427570.lo", 0x00001, 0x080000, CRC(4ef77665) SHA1(3b8795744bb825bead456acdc15ca5a9063ca02e) )
	ROM_LOAD16_BYTE( "95427571.hi", 0x00000, 0x080000, CRC(93e43f00) SHA1(d8f8cc577b5e570d3c0ed21b272f5a0c2498ccad) )
	ROM_LOAD16_BYTE( "95427596.lo", 0x00001, 0x080000, CRC(159ec691) SHA1(423d07ff54e9e7bc9376141168df497f1d60ad43) )
	ROM_LOAD16_BYTE( "95427597.hi", 0x00000, 0x080000, CRC(ea465981) SHA1(edff2ec9e273e07aed73792cf8624c58075cf847) )
	ROM_LOAD16_BYTE( "95427666.lo", 0x00001, 0x080000, CRC(3624bdaa) SHA1(17d9918476ff23400a55ce72f4b038545ece6668) )
	ROM_LOAD16_BYTE( "95427667.hi", 0x00000, 0x080000, CRC(35166051) SHA1(57d6758794597414883426b0112cb984513faf86) )
	ROM_LOAD16_BYTE( "95427702.lo", 0x00001, 0x080000, CRC(57bf542e) SHA1(bf1dc998d3472ebfd35e8778dfe5a561c6728d12) )
	ROM_LOAD16_BYTE( "95427703.hi", 0x00000, 0x080000, CRC(98693c7d) SHA1(88fd28dfc5bc9d3bd00c18d7c3d248770a35e883) )
	ROM_LOAD16_BYTE( "95427810.lo", 0x00001, 0x080000, CRC(da6d842e) SHA1(434db0bfac4293fc826890d39af541fb0685425d) )
	ROM_LOAD16_BYTE( "95427811.hi", 0x00000, 0x080000, CRC(c7be037f) SHA1(22faa06d1a7bfda44a731403f13c4b28a4cdfd92) )
	ROM_LOAD16_BYTE( "p3220p11.hi", 0x00000, 0x080000, CRC(5ebe8890) SHA1(9acac09d17582bc0c2b51005b0d17a371e5a2415) )
	ROM_LOAD16_BYTE( "p3220p11.lo", 0x00001, 0x080000, CRC(f68cfed0) SHA1(be6f5abea8a3595212caefc6f2d91da41ea6ffaf) )
	ROM_LOAD16_BYTE( "p3220p12.hi", 0x00000, 0x080000, CRC(ab9c4e42) SHA1(2faa0863a281920d35c9ff31be8bf5daa689fb6f) )
	ROM_LOAD16_BYTE( "p3220p12.lo", 0x00001, 0x080000, CRC(801d9e1e) SHA1(b406a17dd0973984e7be67cd38509495e20ccf10) )
	ROM_LOAD16_BYTE( "p3220s11.hi", 0x00000, 0x080000, CRC(0de2519f) SHA1(99d17ae50aee2eaf7cf26d8b5e65512fe6358b23) )
	ROM_LOAD16_BYTE( "p3220s11.lo", 0x00001, 0x080000, CRC(6f022e6c) SHA1(99c52203962df4fec88fe1fc96593b9dd5bcabbe) )
	ROM_LOAD16_BYTE( "p3220s12.hi", 0x00000, 0x080000, CRC(b2f62e15) SHA1(8eac8db5009e23dfda03fbae126e17568e410da7) )
	ROM_LOAD16_BYTE( "p3220s12.lo", 0x00001, 0x080000, CRC(0fc2da88) SHA1(55b3214f37e50e1630704f11d218949c7d1c8fca) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008822.bin", 0x0000, 0x100000, CRC(16411f05) SHA1(11f2d17b6647b9d9e713e38bab6604e4feb51432) )
	ROM_LOAD( "95008823.bin", 0x0000, 0x100000, CRC(4f7bab89) SHA1(bbb203cff3212571c313e8f22f9083980baf2566) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211613.bin", 0x0000, 0x1000000, CRC(98495946) SHA1(4c3d5d0731dfdaad37cee317a5d862ff46665ebd) )
	ROM_LOAD( "39212613.bin", 0x0000, 0x1000000, CRC(1b0deb8f) SHA1(e27aafa91f5a9ca9064e6e89af5f86c305715efc) )
ROM_END




ROM_START( sc_dndtp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418704.lo", 0x00001, 0x080000, CRC(95f494e1) SHA1(f4f8aa5974e335c907fa03ba88ebf7fdf69dbb2a) )
	ROM_LOAD16_BYTE( "95418705.hi", 0x00000, 0x080000, CRC(ab485cec) SHA1(59524b6f03649b93cc7b0832790c9151a2710787) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418706.lo", 0x00001, 0x080000, CRC(2b785234) SHA1(32ff01a1a64d4caa4d539d2e09189fffc635b382) )
	ROM_LOAD16_BYTE( "95418707.hi", 0x00000, 0x080000, CRC(d7c370ff) SHA1(00e49802ba0deb375072057eadacfdac749f6928) )
	ROM_LOAD16_BYTE( "95418728.lo", 0x00001, 0x080000, CRC(7e29bd08) SHA1(01715e41e1b057a5db050b6c24a7ada11125d9b3) )
	ROM_LOAD16_BYTE( "95418729.hi", 0x00000, 0x080000, CRC(28e38bfb) SHA1(9166e3555f97a6c4882e42c4d2f4ec6d67341f01) )
	ROM_LOAD16_BYTE( "95418730.lo", 0x00001, 0x080000, CRC(435b531f) SHA1(9959786e7d193d8d02438e9e76a8bc068d3175e0) )
	ROM_LOAD16_BYTE( "95418731.hi", 0x00000, 0x080000, CRC(9f5ba2e5) SHA1(1699b4fced4e8118e122022bbcbe3e3c37fa6bba) )
	ROM_LOAD16_BYTE( "95418784.lo", 0x00001, 0x080000, CRC(49a401ea) SHA1(0f0c0b7decd64d5b06d5451691f4bc24ec071c7b) )
	ROM_LOAD16_BYTE( "95418785.hi", 0x00000, 0x080000, CRC(9e2714a1) SHA1(4ff3fda8da04e5971acf2f6491fb6d2a261494b4) )
	ROM_LOAD16_BYTE( "95418786.lo", 0x00001, 0x080000, CRC(0d7db391) SHA1(38fddfafd801ad32e6ac6352fdb292cd42c01e94) )
	ROM_LOAD16_BYTE( "95418787.hi", 0x00000, 0x080000, CRC(7e07e449) SHA1(3233cd3db92b56b85ad3a61682786bfada48e616) )
	ROM_LOAD16_BYTE( "95418872.lo", 0x00001, 0x080000, CRC(fbebbf50) SHA1(2bbabf6dde06ad2f58d030df0b6b5d91b2805604) )
	ROM_LOAD16_BYTE( "95418873.hi", 0x00000, 0x080000, CRC(d3089997) SHA1(6958596a60473861e44aebc48732aeb6a8b11c21) )
	ROM_LOAD16_BYTE( "95418944.lo", 0x00001, 0x080000, CRC(12a79908) SHA1(0c420fb3318ee74e1b0e9a10f0617fff26dbbb2c) )
	ROM_LOAD16_BYTE( "95418945.hi", 0x00000, 0x080000, CRC(1de9312b) SHA1(6878a48bc516dc0b63c7c62b57603e28224460b2) )
	ROM_LOAD16_BYTE( "95419704.lo", 0x00001, 0x080000, CRC(400835ac) SHA1(f521c2f79ab1f19370ee0c903a6e136f09828d63) )
	ROM_LOAD16_BYTE( "95419705.hi", 0x00000, 0x080000, CRC(f325b428) SHA1(c014d6433b2144d12c521bb7ff9468b4fe9b582a) )
	ROM_LOAD16_BYTE( "95419706.lo", 0x00001, 0x080000, CRC(bd8b7ca9) SHA1(ea2e441d9cd3676d8fdd095c7debb561a1059b4e) )
	ROM_LOAD16_BYTE( "95419707.hi", 0x00000, 0x080000, CRC(26df2479) SHA1(6f842e5b72a3c3b91135a60c52be8e54f53309d0) )
	ROM_LOAD16_BYTE( "95419728.lo", 0x00001, 0x080000, CRC(534b968e) SHA1(83e5267022ad8aa57335b5d4b136bd478c417f18) )
	ROM_LOAD16_BYTE( "95419729.hi", 0x00000, 0x080000, CRC(bb986c64) SHA1(6e0e3560866c718e7968e2241bafa348b544af62) )
	ROM_LOAD16_BYTE( "95419730.lo", 0x00001, 0x080000, CRC(644d007a) SHA1(76ea3e81c53a9db058a386f685d1a534671be2f7) )
	ROM_LOAD16_BYTE( "95419731.hi", 0x00000, 0x080000, CRC(2cc387fd) SHA1(d1cb8774eebf1b623b2dab55654b16c2f7f396b7) )
	ROM_LOAD16_BYTE( "95419784.lo", 0x00001, 0x080000, CRC(c6fd42bd) SHA1(33edc9bcd7d45295a4bc830dc8b8ef817b9751e5) )
	ROM_LOAD16_BYTE( "95419785.hi", 0x00000, 0x080000, CRC(413f47b9) SHA1(0bef7b7fdfb43103cacd9f91b00a4a2fead81f70) )
	ROM_LOAD16_BYTE( "95419786.lo", 0x00001, 0x080000, CRC(799dd38a) SHA1(f8b0c5734b698e453b496b94db42b2de30da0fc5) )
	ROM_LOAD16_BYTE( "95419787.hi", 0x00000, 0x080000, CRC(cf7dcf89) SHA1(83be5f970028115eb3fc1bb0b37278a18a5d8ee2) )
	ROM_LOAD16_BYTE( "95419872.lo", 0x00001, 0x080000, CRC(e910d376) SHA1(1c225979c8a27bfc9ae244c4aca2184553b040c7) )
	ROM_LOAD16_BYTE( "95419873.hi", 0x00000, 0x080000, CRC(afb8116a) SHA1(3f4416cdcd30a53ad8da12f54089e9c09f98cfac) )
	ROM_LOAD16_BYTE( "95419944.lo", 0x00001, 0x080000, CRC(09446373) SHA1(21c15a082a20294e2b086c74f2da4cb17b052c2c) )
	ROM_LOAD16_BYTE( "95419945.hi", 0x00000, 0x080000, CRC(4499476a) SHA1(261d393b03d2238053ffcf1783cb4a3a6e733ed7) )
	ROM_LOAD16_BYTE( "95422001.hi", 0x00000, 0x080000, CRC(ecc2de87) SHA1(92f58870eddece79645651aa325595a130233194) )
	ROM_LOAD16_BYTE( "95422004.lo", 0x00001, 0x080000, CRC(419bd389) SHA1(ff8dcc4413a669c7f32155f98bab93e168d8e926) )
	ROM_LOAD16_BYTE( "95422005.hi", 0x00000, 0x080000, CRC(779b8aeb) SHA1(8510615e5adaf78f03a6fdf4862cec2f9f6eb002) )
	ROM_LOAD16_BYTE( "95422006.lo", 0x00001, 0x080000, CRC(78228f0d) SHA1(811cde456cb5dbd53c4cace3033c22c549de8f99) )
	ROM_LOAD16_BYTE( "95422009.hi", 0x00000, 0x080000, CRC(4360ee22) SHA1(98b08fdcf3efdb9d056f7c2f213a3e5d650686a7) )
	ROM_LOAD16_BYTE( "95422010.lo", 0x00001, 0x080000, CRC(aa27467d) SHA1(28e834b798ce2778cec8001fa553a9d82094ef73) )
	ROM_LOAD16_BYTE( "95422104.lo", 0x00001, 0x080000, CRC(8beebb7f) SHA1(5c7c9b53852ed1b53a7ab2bdd659ccfd1027ee7b) )
	ROM_LOAD16_BYTE( "95422105.hi", 0x00000, 0x080000, CRC(b890efee) SHA1(f4a04f7ab3289795a0441aeda04420c0a94e3713) )
	ROM_LOAD16_BYTE( "95422560.lo", 0x00001, 0x080000, CRC(7ea0fcf7) SHA1(f35cf6614b0d0e4b622886a52f2af289ad5e42a1) )
	ROM_LOAD16_BYTE( "95422561.hi", 0x00000, 0x080000, CRC(4a96c226) SHA1(394293f4a04c0d55920f3629f395aaa0a7e6c863) )
	ROM_LOAD16_BYTE( "95422854.lo", 0x00001, 0x080000, CRC(803e9182) SHA1(79e31359916aab21d73942d0cf73fc393bd5fad2) )
	ROM_LOAD16_BYTE( "95422855.hi", 0x00000, 0x080000, CRC(bc307337) SHA1(0486fdc75b057fec7916b55b0e942902fc09117c) )
	ROM_LOAD16_BYTE( "95423001.hi", 0x00000, 0x080000, CRC(e26228e7) SHA1(e2cffbf1ef5fd5bb126917599efb40c2195f5a9b) )
	ROM_LOAD16_BYTE( "95423004.lo", 0x00001, 0x080000, CRC(a6074967) SHA1(318ab8e2387190571dd530a233de04d6740ccb2f) )
	ROM_LOAD16_BYTE( "95423005.hi", 0x00000, 0x080000, CRC(7189a970) SHA1(b5f9ce0011d18dd300068d39dd3e80261552634c) )
	ROM_LOAD16_BYTE( "95423006.lo", 0x00001, 0x080000, CRC(cc8d9bb5) SHA1(0be48fed507ab933590c6a6baa434071d0ddfb60) )
	ROM_LOAD16_BYTE( "95423009.hi", 0x00000, 0x080000, CRC(38a4e959) SHA1(dd0c9c07a0eab6d77a09cae3ed78a3e034289398) )
	ROM_LOAD16_BYTE( "95423010.lo", 0x00001, 0x080000, CRC(62f9f024) SHA1(46bfb758ed6508b4e01779038a5a94da22e7b3b7) )
	ROM_LOAD16_BYTE( "95423104.lo", 0x00001, 0x080000, CRC(f589546e) SHA1(5589f70ded14169625a7d0d0c20570b6331f4c4e) )
	ROM_LOAD16_BYTE( "95423105.hi", 0x00000, 0x080000, CRC(7f19996b) SHA1(026c5c9ec9e3fffba22f3b41342624bf939a792b) )
	ROM_LOAD16_BYTE( "95423560.lo", 0x00001, 0x080000, CRC(dd45b408) SHA1(6164f8fb344a6ae3eca05dd287469397d1ce28ab) )
	ROM_LOAD16_BYTE( "95423561.hi", 0x00000, 0x080000, CRC(d91f1c00) SHA1(8f51a52335c1dccf6a3ca7f4979fccbef5126cf9) )
	ROM_LOAD16_BYTE( "95423854.lo", 0x00001, 0x080000, CRC(e69e8798) SHA1(2f2b0a18cc951919e31cb3cef9ad0e18cf95608b) )
	ROM_LOAD16_BYTE( "95423855.hi", 0x00000, 0x080000, CRC(4b41bd66) SHA1(23ef72f41e533b3b840f81264f39591f0d7c4bb4) )
	ROM_LOAD16_BYTE( "95426140.lo", 0x00001, 0x080000, CRC(8add007d) SHA1(d83b5b9d22c99e81d9af2b52840e29d6363b1132) )
	ROM_LOAD16_BYTE( "95426141.hi", 0x00000, 0x080000, CRC(b9b0d254) SHA1(3ea53e041cab25dd7d8dba951461320f58556d6d) )
	ROM_LOAD16_BYTE( "95426142.lo", 0x00001, 0x080000, CRC(776b28c2) SHA1(f6cca110df664dadf0529540678340bc8072c3eb) )
	ROM_LOAD16_BYTE( "95426143.hi", 0x00000, 0x080000, CRC(52253aa7) SHA1(4eae55f63841afefec79c411054d74123f614cc8) )
	ROM_LOAD16_BYTE( "95427140.lo", 0x00001, 0x080000, CRC(ed5abd3b) SHA1(ea6ec8646d7250f36f1fde34d07907d3b2322d29) )
	ROM_LOAD16_BYTE( "95427141.hi", 0x00000, 0x080000, CRC(8013d590) SHA1(43fbce8ab63873e8b875b9f35d7a8d777ae2b4db) )
	ROM_LOAD16_BYTE( "95427142.lo", 0x00001, 0x080000, CRC(adbf6808) SHA1(4cc1ed6d692107ff22c199fba708d52418259cd9) )
	ROM_LOAD16_BYTE( "95427143.hi", 0x00000, 0x080000, CRC(d961af03) SHA1(04f2f2d424257996c496f762403647307c499bd5) )
	ROM_LOAD16_BYTE( "p3003p42.hi", 0x00000, 0x080000, CRC(6884132e) SHA1(0a864012b36887de2dc1290bb93d533e45f7e85a) )
	ROM_LOAD16_BYTE( "p3003p42.lo", 0x00001, 0x080000, CRC(46fd164a) SHA1(c7c70773a1327200fa58818f3d23cabb48ab4ba5) )
	ROM_LOAD16_BYTE( "p3003p43.hi", 0x00000, 0x080000, CRC(81ff5970) SHA1(8e3d6dfcfd3fa69bdb0ee391ad3257813fd88349) )
	ROM_LOAD16_BYTE( "p3003p43.lo", 0x00001, 0x080000, CRC(00720267) SHA1(98b30f4bea5e284ab15f230794982d754b3221f0) )
	ROM_LOAD16_BYTE( "p3003s42.hi", 0x00000, 0x080000, CRC(f04b7cd3) SHA1(b3b2c77d6458d901da4aa7057f2c4a9bf67df759) )
	ROM_LOAD16_BYTE( "p3003s42.lo", 0x00001, 0x080000, CRC(71d96983) SHA1(e896334a9ea517bbc20eb06eb8682b7a884b37e6) )
	ROM_LOAD16_BYTE( "p3003s43.hi", 0x00000, 0x080000, CRC(7935ef60) SHA1(6bc427dc8a313e767240154158ba6eb729d38626) )
	ROM_LOAD16_BYTE( "p3003s43.lo", 0x00001, 0x080000, CRC(1d6aa120) SHA1(edefc11b1bb35fb44c416b34f6f1da20502728ad) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008673.bin", 0x0000, 0x100000, CRC(4b8d1e0b) SHA1(8cba9632abb2800f8e9a45d1bf0abbc9abe8cb8c) )
	ROM_LOAD( "95008674.bin", 0x0000, 0x100000, CRC(66236e20) SHA1(222fefdeddb22eb290302528a8f937468ccd5698) )
ROM_END




ROM_START( sc_dndww )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418860.lo", 0x00001, 0x080000, CRC(955480f9) SHA1(a35484c215cc966bfd3309054ef9e00c470e6644) )
	ROM_LOAD16_BYTE( "95418861.hi", 0x00000, 0x080000, CRC(87ce7115) SHA1(953ccb59b8002c7d3b1c09097a49999a4fe74167) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418862.lo", 0x00001, 0x080000, CRC(fbba7955) SHA1(189a9681232ef808d749060eb31aef964e0f5479) )
	ROM_LOAD16_BYTE( "95418863.hi", 0x00000, 0x080000, CRC(7fee6bca) SHA1(b6bded7923d5c00929259f30537d665dbb62867c) )
	ROM_LOAD16_BYTE( "95418990.lo", 0x00001, 0x080000, CRC(d40b5d13) SHA1(12a6d2f628a46fa0c27d61636afa05291756f301) )
	ROM_LOAD16_BYTE( "95418993.hi", 0x00000, 0x080000, CRC(27a65baf) SHA1(506b20c825698210ea07096c6b0892fd0ce7ee42) )
	ROM_LOAD16_BYTE( "95418996.lo", 0x00001, 0x080000, CRC(0d7d5a31) SHA1(bf4db52a1af006b625269f1dafe29f2b76642d04) )
	ROM_LOAD16_BYTE( "95418997.hi", 0x00000, 0x080000, CRC(419a89db) SHA1(015883e4a44067a6d092f7042eb3ef536f4eadb8) )
	ROM_LOAD16_BYTE( "95419860.lo", 0x00001, 0x080000, CRC(68f7a054) SHA1(eaaab4e7d5dac40e50f098df2edf1109ac5f6d1c) )
	ROM_LOAD16_BYTE( "95419861.hi", 0x00000, 0x080000, CRC(a8f4dafb) SHA1(663b08bda6a708ca502ed194aa2682d4d3d9867f) )
	ROM_LOAD16_BYTE( "95419862.lo", 0x00001, 0x080000, CRC(8e28ba13) SHA1(3a762f4eeedf36249ba1b81d7601033dc59c63ab) )
	ROM_LOAD16_BYTE( "95419863.hi", 0x00000, 0x080000, CRC(99bf979f) SHA1(60d233eb1186787b2525e19fdf825eb489a6db8e) )
	ROM_LOAD16_BYTE( "95419990.lo", 0x00001, 0x080000, CRC(5225460f) SHA1(5868d1f79e1741debf68d8f022b5f937b5a9ca8f) )
	ROM_LOAD16_BYTE( "95419993.hi", 0x00000, 0x080000, CRC(e546a0e7) SHA1(070677430430c35ab5ca616f7688e700b72e9e5f) )
	ROM_LOAD16_BYTE( "95419996.lo", 0x00001, 0x080000, CRC(524dfc58) SHA1(e7e01c40f01442888a575c874d1423ee8c179849) )
	ROM_LOAD16_BYTE( "95421707.hi", 0x00000, 0x080000, CRC(4011a5d6) SHA1(27f2c94d5a39926cc837ccf86363c7b969ce6858) )
	ROM_LOAD16_BYTE( "95422000.lo", 0x00001, 0x080000, CRC(7bb6d900) SHA1(05203cad5e0d61da1188efec23fee7014a03588f) )
	ROM_LOAD16_BYTE( "95422065.hi", 0x00000, 0x080000, CRC(b3444633) SHA1(c0c7473475fb8f06731aaa0aac73d914f087a1ee) )
	ROM_LOAD16_BYTE( "95422068.lo", 0x00001, 0x080000, CRC(0cc6467c) SHA1(097713378eb7091323837754ae3ebd5e2a2d423b) )
	ROM_LOAD16_BYTE( "95422069.hi", 0x00000, 0x080000, CRC(6297e0ef) SHA1(88c97ff6d8f085a07c10298f2568eacb83ac4fbd) )
	ROM_LOAD16_BYTE( "95422106.lo", 0x00001, 0x080000, CRC(47fdf423) SHA1(9d43b04057729f278d10cf791b5f0674e445aaca) )
	ROM_LOAD16_BYTE( "95422107.hi", 0x00000, 0x080000, CRC(fb5e2d1d) SHA1(d33f67ee35b99ff11b3960ac82eac8fe09df00b9) )
	ROM_LOAD16_BYTE( "95422254.lo", 0x00001, 0x080000, CRC(c9297465) SHA1(deb6900bb4fc8b811ff65b7926423f69dabb5124) )
	ROM_LOAD16_BYTE( "95422255.hi", 0x00000, 0x080000, CRC(7f3109e4) SHA1(6575865929caca6b8b4657dddb6734aea599d5e9) )
	ROM_LOAD16_BYTE( "95422294.lo", 0x00001, 0x080000, CRC(f02056ce) SHA1(6de6720064fce6bc52445a33a327493c54c64cb2) )
	ROM_LOAD16_BYTE( "95422295.hi", 0x00000, 0x080000, CRC(408331c2) SHA1(6790fbbe41c92201fbdd4e21f2611a9152543353) )
	ROM_LOAD16_BYTE( "95422296.lo", 0x00001, 0x080000, CRC(7f59b663) SHA1(d094f5dfb74ff2fe8933b7f09035c120997d3d13) )
	ROM_LOAD16_BYTE( "95422297.hi", 0x00000, 0x080000, CRC(744b489a) SHA1(95dfd61b860fb148e41414cfc98793f614dfd40a) )
	ROM_LOAD16_BYTE( "95422512.lo", 0x00001, 0x080000, CRC(6fefd208) SHA1(fb0109ce3398e02181e4f3aef8f6a968fcaf426a) )
	ROM_LOAD16_BYTE( "95422513.hi", 0x00000, 0x080000, CRC(cf951b24) SHA1(2ab79ae80a427659cd3b2d03ebd93bbeaabc215a) )
	ROM_LOAD16_BYTE( "95422514.lo", 0x00001, 0x080000, CRC(53454e22) SHA1(f5fb64197e5e4ea24ed8e6a7155bef83f7d6d301) )
	ROM_LOAD16_BYTE( "95422515.hi", 0x00000, 0x080000, CRC(2dd854e0) SHA1(bbbf0c2c0420494a6853c93df40813e375896ebf) )
	ROM_LOAD16_BYTE( "95422552.lo", 0x00001, 0x080000, CRC(af6f5c75) SHA1(a88216152ce5d47dfc3e354fc0667f370acc0769) )
	ROM_LOAD16_BYTE( "95422553.hi", 0x00000, 0x080000, CRC(cc278af5) SHA1(79aeed9de0930add4d83557ac9a13909bb38738c) )
	ROM_LOAD16_BYTE( "95422714.lo", 0x00001, 0x080000, CRC(3ae68439) SHA1(f28c59c59516534ae52acf3ff34fb369ae2e76f4) )
	ROM_LOAD16_BYTE( "95422715.hi", 0x00000, 0x080000, CRC(3ea32328) SHA1(b35cd4b9cdd411706eedc888cc25064e234bf5ed) )
	ROM_LOAD16_BYTE( "95422772.lo", 0x00001, 0x080000, CRC(69d8ff83) SHA1(c2eb2b9d01ec8f2a3d01bd7b5656abbd4b532edd) )
	ROM_LOAD16_BYTE( "95422773.hi", 0x00000, 0x080000, CRC(a7db59d9) SHA1(2938874327538110cb7fb3881f07f11820704587) )
	ROM_LOAD16_BYTE( "95423000.lo", 0x00001, 0x080000, CRC(c8e6d149) SHA1(07414881aeb787563cb122cce5121889816ba348) )
	ROM_LOAD16_BYTE( "95423068.lo", 0x00001, 0x080000, CRC(75f3254a) SHA1(5eb72ee3bac51b46c3108c4b559016fbe33cad22) )
	ROM_LOAD16_BYTE( "95423069.hi", 0x00000, 0x080000, CRC(9c0dc2c3) SHA1(97a56d9ddbf2198bc9e175784bf22de7a61ed04e) )
	ROM_LOAD16_BYTE( "95423106.lo", 0x00001, 0x080000, CRC(487342c5) SHA1(bf1fa98544e2e40ff7034c168778c85355c277f8) )
	ROM_LOAD16_BYTE( "95423107.hi", 0x00000, 0x080000, CRC(a4dfbfea) SHA1(ea60a20f75472a4849915b7c7e101accf3673a66) )
	ROM_LOAD16_BYTE( "95423254.lo", 0x00001, 0x080000, CRC(cbbee6c6) SHA1(b5da1b079f64d3b85dd07ceff1ec3d7dc4f271f0) )
	ROM_LOAD16_BYTE( "95423255.hi", 0x00000, 0x080000, CRC(e246e6bc) SHA1(6bb0f7ac3e455aed48b9e95f8ded6bc81e8f2e3b) )
	ROM_LOAD16_BYTE( "95423294.lo", 0x00001, 0x080000, CRC(31e3f048) SHA1(3584f654dc180524c35db0cae6d57e8f93bf8d7f) )
	ROM_LOAD16_BYTE( "95423295.hi", 0x00000, 0x080000, CRC(179fa1c3) SHA1(8647a23209c3ec4534b4b08a9d205797d64598df) )
	ROM_LOAD16_BYTE( "95423296.lo", 0x00001, 0x080000, CRC(6d0e4dd2) SHA1(461c1a1caed4ce32b2cc88cc9efdbb05ede763c5) )
	ROM_LOAD16_BYTE( "95423297.hi", 0x00000, 0x080000, CRC(a4821da7) SHA1(7305e3bcea0cb21ee632321ecb4204922bbdf116) )
	ROM_LOAD16_BYTE( "95423512.lo", 0x00001, 0x080000, CRC(d65ae210) SHA1(39cb429d530dfad61bb9019a3f5719a7c85ecea8) )
	ROM_LOAD16_BYTE( "95423513.hi", 0x00000, 0x080000, CRC(6c20c600) SHA1(b3fb9d68f1551e59440fa09ff4d9ea23728ad1af) )
	ROM_LOAD16_BYTE( "95423514.lo", 0x00001, 0x080000, CRC(15b0accb) SHA1(4c39f84bdb234216429e8d2b0b0719b8ca0c3c93) )
	ROM_LOAD16_BYTE( "95423515.hi", 0x00000, 0x080000, CRC(8822010e) SHA1(b536e302958aa95ec2d64e0405b5836202dd7b66) )
	ROM_LOAD16_BYTE( "95423552.lo", 0x00001, 0x080000, CRC(867f9c98) SHA1(7974c0915326c88b201e3b8c354906e105d14ac0) )
	ROM_LOAD16_BYTE( "95423553.hi", 0x00000, 0x080000, CRC(a0be983d) SHA1(0f6ed13532465c9ecfddc73351b00425a62a26fa) )
	ROM_LOAD16_BYTE( "95423714.lo", 0x00001, 0x080000, CRC(98913f7f) SHA1(30c863b96c3ef7d37f34344354a5efae5f3be80e) )
	ROM_LOAD16_BYTE( "95423715.hi", 0x00000, 0x080000, CRC(eaf9cefe) SHA1(c3bff3c5204ce65e3ed9257962ccdc6196920590) )
	ROM_LOAD16_BYTE( "95423772.lo", 0x00001, 0x080000, CRC(1a08c512) SHA1(a72a8999c42c1c0a4fed8fe2b59ec52332c8dd35) )
	ROM_LOAD16_BYTE( "95423773.hi", 0x00000, 0x080000, CRC(78311fed) SHA1(c422a46f085504f26e4bb2702816890a721daa06) )
	ROM_LOAD16_BYTE( "95426136.lo", 0x00001, 0x080000, CRC(259a5a75) SHA1(c8ce7566105ef2e4f46c96ce703f90328080932e) )
	ROM_LOAD16_BYTE( "95426137.hi", 0x00000, 0x080000, CRC(265940e0) SHA1(d5bcc9f44e6d288fcdeec4b39a768a76abb25b6f) )
	ROM_LOAD16_BYTE( "95426138.lo", 0x00001, 0x080000, CRC(da9454eb) SHA1(2a1b21b114cc584cc64a57ab59e88eb5274b2432) )
	ROM_LOAD16_BYTE( "95426139.hi", 0x00000, 0x080000, CRC(e96e0f34) SHA1(9233794df825b1a201ee5fa1fb40329cc1c41b73) )
	ROM_LOAD16_BYTE( "95427136.lo", 0x00001, 0x080000, CRC(6da2c608) SHA1(a23bf30b7ade522ff128bdb26a6c544269950991) )
	ROM_LOAD16_BYTE( "95427137.hi", 0x00000, 0x080000, CRC(cb455c65) SHA1(6bbfa5b0119b4c5765f03f5c322df5e1817974d0) )
	ROM_LOAD16_BYTE( "95427138.lo", 0x00001, 0x080000, CRC(a9928e67) SHA1(10c99f2ab3f25e55788633e57f7155e06897a42b) )
	ROM_LOAD16_BYTE( "95427139.hi", 0x00000, 0x080000, CRC(191eed85) SHA1(9896f3e4c24fd649868454f141fd67b7e12ca822) )
	ROM_LOAD16_BYTE( "p3006p41.hi", 0x00000, 0x080000, CRC(0fdaa9e0) SHA1(0aa5c92d61fd1b434a094d75a9177425524542f0) )
	ROM_LOAD16_BYTE( "p3006p41.lo", 0x00001, 0x080000, CRC(50a78738) SHA1(4e27e491a1f21800b3e70eecfa6ff61e7e472ffa) )
	ROM_LOAD16_BYTE( "p3006s41.hi", 0x00000, 0x080000, CRC(a7bbe3ff) SHA1(386cac772b78bb6948f787c6f1f50077d6dd0303) )
	ROM_LOAD16_BYTE( "p3006s41.lo", 0x00001, 0x080000, CRC(a100e18b) SHA1(2dce17ac4f823dda62da7a8589ef488b9e8dee3d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008730.bin", 0x0000, 0x100000, CRC(e2aebdb0) SHA1(d22fee7ff3d5912ea9a7440ec82de52a7d016090) )
ROM_END




ROM_START( sc_dndtr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426372.lo", 0x00001, 0x080000, CRC(772e3c92) SHA1(6eb73c4663c2820b2d111baf8c9756bb808b8e21) )
	ROM_LOAD16_BYTE( "95426373.hi", 0x00000, 0x080000, CRC(373381d3) SHA1(c3ed6b7c0bffd6817a72dc2a58abe1242732e1d7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426420.lo", 0x00001, 0x080000, CRC(31604ce1) SHA1(222b278ad7469e8db8bc9a48739688fe1f6d1a4a) )
	ROM_LOAD16_BYTE( "95426421.hi", 0x00000, 0x080000, CRC(80b5b150) SHA1(6225e47c4411569a0337c5e5f602e83d27185715) )
	ROM_LOAD16_BYTE( "95426466.lo", 0x00001, 0x080000, CRC(7e941269) SHA1(3a000a18f6fbc3bdcd33dee6b334e25973a7336d) )
	ROM_LOAD16_BYTE( "95426467.hi", 0x00000, 0x080000, CRC(f76217ec) SHA1(103a751c876ed804e6dddf02fcc9d08e808750ae) )
	ROM_LOAD16_BYTE( "95426468.lo", 0x00001, 0x080000, CRC(dcde303d) SHA1(c885a428d188d66e2cf61b28f3e9c71e3dc61053) )
	ROM_LOAD16_BYTE( "95426469.hi", 0x00000, 0x080000, CRC(175e6a70) SHA1(847f21612b42b50b0788e6980e458312749afbad) )
	ROM_LOAD16_BYTE( "95426664.lo", 0x00001, 0x080000, CRC(41cd4608) SHA1(8cc3568fc83d5d66a00808857a08d0e0bbbc363d) )
	ROM_LOAD16_BYTE( "95426665.hi", 0x00000, 0x080000, CRC(3cacdecb) SHA1(2775e20f9a69077130c9c55b55140bc0b0dbf79a) )
	ROM_LOAD16_BYTE( "95426700.lo", 0x00001, 0x080000, CRC(11d5772c) SHA1(c0128c1b6d8f8f1efa334e7a75ef16be85895b2e) )
	ROM_LOAD16_BYTE( "95426701.hi", 0x00000, 0x080000, CRC(9f6a98ca) SHA1(af1f454261b3ca6fd6cfdbd5748de9fa6d67503b) )
	ROM_LOAD16_BYTE( "95427372.lo", 0x00001, 0x080000, CRC(83fd5056) SHA1(cf8b233bae2aee18b39847f022037a9a0e54663c) )
	ROM_LOAD16_BYTE( "95427373.hi", 0x00000, 0x080000, CRC(bd6fe15e) SHA1(716d0ba7768d8819a3dbad15911f15608b92a9e4) )
	ROM_LOAD16_BYTE( "95427420.lo", 0x00001, 0x080000, CRC(42c84630) SHA1(0f1385adccbe167e8d68ae3aa1fe4f1ad6eda32d) )
	ROM_LOAD16_BYTE( "95427421.hi", 0x00000, 0x080000, CRC(afe268f7) SHA1(2ba6d9c4d902c843e2c2785f3cf817521a221759) )
	ROM_LOAD16_BYTE( "95427466.lo", 0x00001, 0x080000, CRC(42aab7e2) SHA1(fa1f63233b32675e6e637ab4ae10a6fce5dcd76a) )
	ROM_LOAD16_BYTE( "95427467.hi", 0x00000, 0x080000, CRC(d79e07ba) SHA1(f5a1f67beff046922e11c4676ecc17bfeca3df91) )
	ROM_LOAD16_BYTE( "95427468.lo", 0x00001, 0x080000, CRC(127334f0) SHA1(c851ce8b355cfb51e6288f117ee41dba7e48969d) )
	ROM_LOAD16_BYTE( "95427469.hi", 0x00000, 0x080000, CRC(537f91aa) SHA1(b63b9ed4d21225f0d979107d2d03a49b6d7ae2a4) )
	ROM_LOAD16_BYTE( "95427664.lo", 0x00001, 0x080000, CRC(42daf573) SHA1(6a75b010bc5e45cc1b258f4a8c335158d55fb8af) )
	ROM_LOAD16_BYTE( "95427665.hi", 0x00000, 0x080000, CRC(76d228d2) SHA1(7ffbfe6220a4a4ee716f3cc1ca320c158db0d1a6) )
	ROM_LOAD16_BYTE( "95427700.lo", 0x00001, 0x080000, CRC(03b1f74b) SHA1(a645df6f5e008e97ed69d11945b2e64c89a3c63d) )
	ROM_LOAD16_BYTE( "95427701.hi", 0x00000, 0x080000, CRC(1ff5b8e1) SHA1(ee20c9f18342a2f021d7624ee15f2d667a5ee8c6) )
	ROM_LOAD16_BYTE( "p3304p71.hi", 0x00000, 0x080000, CRC(7a637d7b) SHA1(f887f24dd79118d2ff20d957b95ed6dfac0d34b7) )
	ROM_LOAD16_BYTE( "p3304p71.lo", 0x00001, 0x080000, CRC(8b1373c5) SHA1(cf750a549ec2f96f2c237e44a0767fdd7765b953) )
	ROM_LOAD16_BYTE( "p3304s71.hi", 0x00000, 0x080000, CRC(f11527af) SHA1(f2c2ce48716d961e1df31dd391205381d7df1e4e) )
	ROM_LOAD16_BYTE( "p3304s71.lo", 0x00001, 0x080000, CRC(6a5f17cf) SHA1(e7d2f7a9a1b4071b2f33de3dfb1ca211f9ee07f8) )
	ROM_LOAD16_BYTE( "p3504p71.hi", 0x00000, 0x080000, CRC(ee41fba9) SHA1(3bb177a197155628aa356a4eb632e7e80d74c954) )
	ROM_LOAD16_BYTE( "p3504p71.lo", 0x00001, 0x080000, CRC(3d0681d4) SHA1(8e3b5ab249dd7d93ad6751ae31fbd5d89537e66e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008832.bin", 0x0000, 0x100000, CRC(1d2aa204) SHA1(52ad7a6ea369198b48d593de508f317ed11e84de) )
	ROM_LOAD( "95008833.bin", 0x0000, 0x100000, CRC(92f462f6) SHA1(c0782639d4cd2653a3d14e1b422c2d6117dac029) )
ROM_END




ROM_START( sc_dndwb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418586.lo", 0x00001, 0x080000, CRC(be0491f5) SHA1(19b5d4f0c19932b550bbecc5090eda4874681e39) )
	ROM_LOAD16_BYTE( "95418587.hi", 0x00000, 0x080000, CRC(dd05943c) SHA1(993c3bd14e9924101e0beae5e6c101163dcd7787) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418588.lo", 0x00001, 0x080000, CRC(6f9a6192) SHA1(bf283b077387f9cf14e948375ed84736594bf5b9) )
	ROM_LOAD16_BYTE( "95418589.hi", 0x00000, 0x080000, CRC(e3e6c4c8) SHA1(51d755ee8633e406e6cb81993155531b856e51e3) )
	ROM_LOAD16_BYTE( "95418942.lo", 0x00001, 0x080000, CRC(9990ffa1) SHA1(8adb93f05eef8f149103d40d89d93ddb034a91a8) )
	ROM_LOAD16_BYTE( "95418943.hi", 0x00000, 0x080000, CRC(43116ed8) SHA1(1698afb7be73b5bd9702603a740953c6987fef4e) )
	ROM_LOAD16_BYTE( "95419586.lo", 0x00001, 0x080000, CRC(6d1c95d7) SHA1(5326ed6076b83f400fecda5e48b0c89ec275232d) )
	ROM_LOAD16_BYTE( "95419587.hi", 0x00000, 0x080000, CRC(5a702fe0) SHA1(ac6004a2466bbbabe456e2a41e98096a1b37c71c) )
	ROM_LOAD16_BYTE( "95419588.lo", 0x00001, 0x080000, CRC(87d638b7) SHA1(5d48f65bd2a98452bb5a3a73c49aa6ba8c0c201e) )
	ROM_LOAD16_BYTE( "95419589.hi", 0x00000, 0x080000, CRC(982b1a1b) SHA1(4dabb83cdb2efa80a56375626ff45d5a4133970f) )
	ROM_LOAD16_BYTE( "95419942.lo", 0x00001, 0x080000, CRC(d12c7227) SHA1(d8d99d9500cdeea4d5b0f304e4e6d4a0df5994af) )
	ROM_LOAD16_BYTE( "95419943.hi", 0x00000, 0x080000, CRC(091f96dc) SHA1(0011c0dbee6ca76cf84e81417156a7339e850075) )
	ROM_LOAD16_BYTE( "95422011.hi", 0x00000, 0x080000, CRC(3fd5debb) SHA1(d511226c039f2b41c3122863a9764adc4a9330bf) )
	ROM_LOAD16_BYTE( "95422012.lo", 0x00001, 0x080000, CRC(ac5e4e54) SHA1(498a97153c1e8a552ace97b8f8e2d15f1ee39752) )
	ROM_LOAD16_BYTE( "95422013.hi", 0x00000, 0x080000, CRC(8a511e54) SHA1(c377ee713618348ba2a9983c7556c9f3adba9e92) )
	ROM_LOAD16_BYTE( "95422102.lo", 0x00001, 0x080000, CRC(f87ae97d) SHA1(3971c6fdf8fc15cb9a140827e41a05a11667dd9c) )
	ROM_LOAD16_BYTE( "95422103.hi", 0x00000, 0x080000, CRC(4ad8550b) SHA1(7f56c66f19144073db04a133191d84903f47d681) )
	ROM_LOAD16_BYTE( "95422132.lo", 0x00001, 0x080000, CRC(8f4cd776) SHA1(61ee48942cc597bc2c962be08d95e35652fdcbad) )
	ROM_LOAD16_BYTE( "95422133.hi", 0x00000, 0x080000, CRC(6ea4be95) SHA1(a77791df59db5e269452fea09f4ef8f73b967bd6) )
	ROM_LOAD16_BYTE( "95422134.lo", 0x00001, 0x080000, CRC(38b550a2) SHA1(93a370c191f85e43e06f2f5b203e5dfdca235651) )
	ROM_LOAD16_BYTE( "95422135.hi", 0x00000, 0x080000, CRC(f260b959) SHA1(74107a5dfcef94aa8ca39f2de6cea26c12d856ad) )
	ROM_LOAD16_BYTE( "95422556.lo", 0x00001, 0x080000, CRC(afce35e7) SHA1(518f29c042858608e010caa38dd90287cebbb1ad) )
	ROM_LOAD16_BYTE( "95422557.hi", 0x00000, 0x080000, CRC(6698379b) SHA1(248213bc007c86a656b2ceb32b711ec195ae415d) )
	ROM_LOAD16_BYTE( "95422720.lo", 0x00001, 0x080000, CRC(ef9f7e88) SHA1(de887513092db4b7ca5682c7a8e4d0ba607b6bad) )
	ROM_LOAD16_BYTE( "95422721.hi", 0x00000, 0x080000, CRC(1571e4e2) SHA1(ed45392b451d919058ed5de61b05573cbef14fb7) )
	ROM_LOAD16_BYTE( "95423011.hi", 0x00000, 0x080000, CRC(a27f40db) SHA1(78c8eff3c6066005b5b044c95aef0bb0fb53ac18) )
	ROM_LOAD16_BYTE( "95423012.lo", 0x00001, 0x080000, CRC(5cc9b4fa) SHA1(055ee6e8d72f547fb6ec0b23893a06f3ede70474) )
	ROM_LOAD16_BYTE( "95423013.hi", 0x00000, 0x080000, CRC(6ffa0b3f) SHA1(c66684d0e22be90d4300786a2163b85a7a50ba63) )
	ROM_LOAD16_BYTE( "95423102.lo", 0x00001, 0x080000, CRC(c1bb8676) SHA1(a8b2985c6d5d6263824342119ccd33151e132a94) )
	ROM_LOAD16_BYTE( "95423103.hi", 0x00000, 0x080000, CRC(cf20c129) SHA1(5e114a9d6aa77c47d6547e8ed3f5b2c9af8af496) )
	ROM_LOAD16_BYTE( "95423132.lo", 0x00001, 0x080000, CRC(54c15f7e) SHA1(9ef7ea85ec528d229dada944b588b3fca4db04ad) )
	ROM_LOAD16_BYTE( "95423133.hi", 0x00000, 0x080000, CRC(909530bf) SHA1(d04e6653a4664e5ca20c80eee597781cc99d6726) )
	ROM_LOAD16_BYTE( "95423134.lo", 0x00001, 0x080000, CRC(0844e446) SHA1(cc0438e07219cbca1d82ece5c26932d21996da74) )
	ROM_LOAD16_BYTE( "95423135.hi", 0x00000, 0x080000, CRC(7bfb1e3e) SHA1(37a5788c901e64c9ca0962fd41aabd27f3b99942) )
	ROM_LOAD16_BYTE( "95423556.lo", 0x00001, 0x080000, CRC(4fac2a67) SHA1(8661c3a6d6dba5df0cb6535774dcc8aff822255f) )
	ROM_LOAD16_BYTE( "95423557.hi", 0x00000, 0x080000, CRC(dd0a03bb) SHA1(d84c0123d348df3eb3b7a896de6b48ce86c0ff48) )
	ROM_LOAD16_BYTE( "95423720.lo", 0x00001, 0x080000, CRC(e5569acb) SHA1(66cf3ac740df77126c6046e5aebf5472d3945449) )
	ROM_LOAD16_BYTE( "95423721.hi", 0x00000, 0x080000, CRC(51fc5e13) SHA1(6ecd147cd4334171902056b7673c1d876a9db1d3) )
	ROM_LOAD16_BYTE( "95426144.lo", 0x00001, 0x080000, CRC(b926b107) SHA1(063cc4439353a8453156831828f19ac7f9f0d641) )
	ROM_LOAD16_BYTE( "95426145.hi", 0x00000, 0x080000, CRC(3e4887ac) SHA1(87b4784a282f7b4290f053ed403034e3956a5f64) )
	ROM_LOAD16_BYTE( "95426146.lo", 0x00001, 0x080000, CRC(bd780980) SHA1(22f90f83fbf7286aa5b6c40a6a53af22104b6dec) )
	ROM_LOAD16_BYTE( "95426147.hi", 0x00000, 0x080000, CRC(dc30a7b7) SHA1(e5cd6d452226946a1a683177ff0695e606dccc43) )
	ROM_LOAD16_BYTE( "95426518.lo", 0x00001, 0x080000, CRC(e8933cf4) SHA1(5ceef82c04a2b3ed7f95cb741b6b41389c7cfee6) )
	ROM_LOAD16_BYTE( "95426519.hi", 0x00000, 0x080000, CRC(0f66c859) SHA1(45737070d10bd4157dd155e5998172ebd9dfed51) )
	ROM_LOAD16_BYTE( "95427144.lo", 0x00001, 0x080000, CRC(6096d317) SHA1(b1ca489719930a25392be879880a449c4d6364c0) )
	ROM_LOAD16_BYTE( "95427145.hi", 0x00000, 0x080000, CRC(8792ca0f) SHA1(2b6994c13e0c4ef15134cda8fa33f87c890e5994) )
	ROM_LOAD16_BYTE( "95427146.lo", 0x00001, 0x080000, CRC(2c98681c) SHA1(b616d2546804182b0d41c14fa3133f58224ee8cb) )
	ROM_LOAD16_BYTE( "95427147.hi", 0x00000, 0x080000, CRC(486bc407) SHA1(9dca9bb55ffb090fa8a59da2df0ebba26a5adb5d) )
	ROM_LOAD16_BYTE( "95427518.lo", 0x00001, 0x080000, CRC(ce0d637c) SHA1(3cf4862eb6fd02afe9edde7a528a1fb0222d67e4) )
	ROM_LOAD16_BYTE( "95427519.hi", 0x00000, 0x080000, CRC(4d5a88b8) SHA1(d540644356ef9822bb8b620a629c81cc76b9c5e3) )
	ROM_LOAD16_BYTE( "p1962p31.hi", 0x00000, 0x080000, CRC(79243d5a) SHA1(8a79bc44c9fddf73dfe17ab37879695cca744a0b) )
	ROM_LOAD16_BYTE( "p1962p31.lo", 0x00001, 0x080000, CRC(7bbf2cd1) SHA1(2144693a40cf6f4b01b73fc87443ce65d5af2599) )
	ROM_LOAD16_BYTE( "p1962pa1.hi", 0x00000, 0x080000, CRC(1f9d9036) SHA1(af06ebf8588461c4610120d3017f690fbcf0e3d9) )
	ROM_LOAD16_BYTE( "p1962pa1.lo", 0x00001, 0x080000, CRC(590f9bca) SHA1(fee28ce0bf673089466e95b7b801b06877a2a120) )
	ROM_LOAD16_BYTE( "p1962s31.hi", 0x00000, 0x080000, CRC(054c01d4) SHA1(3a23032086099e57c2f49e279f07a79db2327721) )
	ROM_LOAD16_BYTE( "p1962s31.lo", 0x00001, 0x080000, CRC(ef171906) SHA1(d032fad147d99e128e7ffa51f7e1f7411b846b7c) )
	ROM_LOAD16_BYTE( "p1962sa1.hi", 0x00000, 0x080000, CRC(7e21a4a0) SHA1(beefb35266ea84c01e8c0771a79ea7d8571f79d5) )
	ROM_LOAD16_BYTE( "p1962sa1.lo", 0x00001, 0x080000, CRC(0a4cc805) SHA1(4b7dab1a6d1d4f2a970c185623bfd146e966d14c) )
	ROM_LOAD16_BYTE( "p3071p41.hi", 0x00000, 0x080000, CRC(fb849f6e) SHA1(1886dd42d66babf23f476c81c1f2508a52a1c8e4) )
	ROM_LOAD16_BYTE( "p3071p41.lo", 0x00001, 0x080000, CRC(0c52446d) SHA1(e9f18ec19893a733faac70f361c6d91fe314482a) )
	ROM_LOAD16_BYTE( "p3071p71.hi", 0x00000, 0x080000, CRC(7418e4bc) SHA1(606db0530f58399f0760dd5d677b38238d9ddd0c) )
	ROM_LOAD16_BYTE( "p3071p71.lo", 0x00001, 0x080000, CRC(59a8f426) SHA1(96e673663f4085d8c90089da0f386ab553f8cfee) )
	ROM_LOAD16_BYTE( "p3071p72.hi", 0x00000, 0x080000, CRC(a11cfd09) SHA1(313ccca5353a25f6d7f31138ad6e1b62db1fdc48) )
	ROM_LOAD16_BYTE( "p3071p72.lo", 0x00001, 0x080000, CRC(5cdf3447) SHA1(86ec21741eb1f5c54e6307f439fe689aba7e9e4d) )
	ROM_LOAD16_BYTE( "p3071p73.hi", 0x00000, 0x080000, CRC(55bae06a) SHA1(379e588ea8ac7c06edded33d47df211fc1b5bbab) )
	ROM_LOAD16_BYTE( "p3071p73.lo", 0x00001, 0x080000, CRC(b587e08a) SHA1(43ee1d8057f4d200b1fd4e195931b43ec45771d9) )
	ROM_LOAD16_BYTE( "p3071s41.hi", 0x00000, 0x080000, CRC(ff8e8267) SHA1(6a188fd90a94cb071dbfb4a7ab4ff28724149c9d) )
	ROM_LOAD16_BYTE( "p3071s41.lo", 0x00001, 0x080000, CRC(3c9534a7) SHA1(398d6af0f29ed6eff776ee31c56a6899f83a5ce8) )
	ROM_LOAD16_BYTE( "p3071s71.hi", 0x00000, 0x080000, CRC(48c9062c) SHA1(17266340e250dac5b255e936853b4f6c3fd41149) )
	ROM_LOAD16_BYTE( "p3071s71.lo", 0x00001, 0x080000, CRC(52e410a8) SHA1(6fdaadfb9275891e1ef4c157019859b644c5b77d) )
	ROM_LOAD16_BYTE( "p3071s72.hi", 0x00000, 0x080000, CRC(9a93ab2d) SHA1(e8153cfb73b3026f6a16b7d1c9368d4ca0a22003) )
	ROM_LOAD16_BYTE( "p3071s72.lo", 0x00001, 0x080000, CRC(dfc1d11f) SHA1(2cd30fc1d520d7315142bdcf4ef6ca061b037fa8) )
	ROM_LOAD16_BYTE( "p3071s73.hi", 0x00000, 0x080000, CRC(35c40c93) SHA1(4b790b4858f5df39c62dbb67907db29b014655da) )
	ROM_LOAD16_BYTE( "p3071s73.lo", 0x00001, 0x080000, CRC(7b44a5b8) SHA1(6cbd0e8668771277bf9187f063e45f8dd30cb780) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008651.bin", 0x0000, 0x100000, CRC(c3738d54) SHA1(bf3c62e196a2cea144868729f136000a7b924c3d) )
	ROM_LOAD( "95008652.bin", 0x0000, 0x100000, CRC(ba8f5b62) SHA1(2683623e8b90d5e9586295d720aa1d985b416117) )
	ROM_LOAD( "95008715.bin", 0x0000, 0x100000, CRC(1796b604) SHA1(9045f9424e6447d696a6fdd7f5bdcbfda4b57c90) )
	ROM_LOAD( "95008766.bin", 0x0000, 0x100000, CRC(62accb81) SHA1(ed0456cefed2fbf9a1cfd911f871262e892a4ce8) )
	ROM_LOAD( "95008767.bin", 0x0000, 0x100000, CRC(0aa49d8a) SHA1(a2baffc495656f0b5426b720cac298a78774b7fa) )
ROM_END




ROM_START( sc_deepi )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408252.lo", 0x00001, 0x080000, CRC(c7f6892f) SHA1(0792b3e59812f7da515c3e95d5ed33eea3b46712) )
	ROM_LOAD16_BYTE( "95408253.hi", 0x00000, 0x080000, CRC(adbf060e) SHA1(2cdda24e129dc24e1d38ad3b5889fa6d9335f1f4) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408266.lo", 0x00001, 0x080000, CRC(9d81fef2) SHA1(2e6688fe232932425c29cfce26532c85241a802e) )
	ROM_LOAD16_BYTE( "95408267.hi", 0x00000, 0x080000, CRC(7943c442) SHA1(9913b97fcd7751352b86a5cf2059daefe063d362) )
	ROM_LOAD16_BYTE( "95408522.lo", 0x00001, 0x080000, CRC(65039069) SHA1(7bb43c5df91bc364103c9f0201fd1bfb19d72b3d) )
	ROM_LOAD16_BYTE( "95408523.hi", 0x00000, 0x080000, CRC(4e49a56a) SHA1(4f7b973b93944d8dc6b20f4808970193049f322b) )
	ROM_LOAD16_BYTE( "95409226.lo", 0x00001, 0x080000, CRC(44da86a6) SHA1(d2738b798c0750a7020fbb339be556a7815fbd36) )
	ROM_LOAD16_BYTE( "95409227.hi", 0x00000, 0x080000, CRC(1de99322) SHA1(df7acf9ed94d3ffce3ea416f75b9506bbcc3b8fe) )
	ROM_LOAD16_BYTE( "95409266.lo", 0x00001, 0x080000, CRC(9fe37468) SHA1(f9590784fc42f4e87be3baa83f115d734aa9d69c) )
	ROM_LOAD16_BYTE( "95409267.hi", 0x00000, 0x080000, CRC(02114ca9) SHA1(fc0a350785053ac662c0b0f9af95ebf5a0fa7d1c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008329.bin", 0x0000, 0x100000, CRC(427dad17) SHA1(f8834dfbe6608abb08d6214cd87ec809df963805) )
ROM_END




ROM_START( sc_derby )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404036.lo", 0x00001, 0x080000, CRC(91349f85) SHA1(10e8b89191736e3b75db992c0fda6cd892dd90dc) )
	ROM_LOAD16_BYTE( "95404037.hi", 0x00000, 0x080000, CRC(bea0e501) SHA1(c88a6f2e1b2c59d6d9244a2143658ba014a64fbc) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404038.lo", 0x00001, 0x080000, CRC(4615673e) SHA1(a54dfbdb6b23088f6917404ede04346d43cc26a0) )
	ROM_LOAD16_BYTE( "95404039.hi", 0x00000, 0x080000, CRC(04cc451f) SHA1(5dd238e0f252403a691875878d65ebe89835c02e) )
	ROM_LOAD16_BYTE( "95405036.lo", 0x00001, 0x080000, CRC(c809ce64) SHA1(8162bf6187cebb9c27fb77fca02799033d440ed7) )
	ROM_LOAD16_BYTE( "95405037.hi", 0x00000, 0x080000, CRC(0da79621) SHA1(9f4a608acc3b6189267433125afa7c684bd3102d) )
	ROM_LOAD16_BYTE( "95405038.lo", 0x00001, 0x080000, CRC(b6c6dca5) SHA1(00c13f81cbe5e97f1b4a4eb2c7094d32015a2702) )
	ROM_LOAD16_BYTE( "95405039.hi", 0x00000, 0x080000, CRC(ae615bf5) SHA1(2ac593015297285852291ef2a31baa8a5a22cd41) )
	ROM_LOAD16_BYTE( "95406004.lo", 0x00001, 0x080000, CRC(ecf75c7f) SHA1(52c3e3711ca9aee6b2cf53aea787319d4730520d) )
	ROM_LOAD16_BYTE( "95406005.hi", 0x00000, 0x080000, CRC(b3dc324b) SHA1(744dcc8e8d28e84ab698fa87af6cc96c379eac5d) )
	ROM_LOAD16_BYTE( "95407004.lo", 0x00001, 0x080000, CRC(95ae5b75) SHA1(06ec9d10eddbb28642a86a6f95aa31e3b9919329) )
	ROM_LOAD16_BYTE( "95407005.hi", 0x00000, 0x080000, CRC(bf46afb2) SHA1(df6c1dfa93584327df1dd345424984880ce55c19) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008129.bin", 0x0000, 0x100000, CRC(4892cf07) SHA1(9ce745f4b3aee623a7855e2fee4cc35de20646a3) )
	ROM_LOAD( "95008130.bin", 0x0000, 0x100000, CRC(b9bfde2a) SHA1(25329d5b93318586095715111fbbb854bba394b9) )
ROM_END




ROM_START( sc_dmine )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406818.lo", 0x00001, 0x080000, CRC(5e2e861e) SHA1(0feaffd721a8e0ad9443e6d0e3f03a52c26dcb7c) )
	ROM_LOAD16_BYTE( "95406819.hi", 0x00000, 0x080000, CRC(6b2a7eeb) SHA1(090f3c0c1c3a3dcf7c90f4a87173e56ff5c2218d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406942.lo", 0x00001, 0x080000, CRC(bad861e1) SHA1(9328640b6eebcc9f92f8364454e004a9b6be63cc) )
	ROM_LOAD16_BYTE( "95406943.hi", 0x00000, 0x080000, CRC(d4779226) SHA1(15f4c742bad6992f0ee105f86e06c53286088616) )
	ROM_LOAD16_BYTE( "95407818.lo", 0x00001, 0x080000, CRC(d5f7fd35) SHA1(d281937d8bc1499c9554e8037421ad55284a0621) )
	ROM_LOAD16_BYTE( "95407819.hi", 0x00000, 0x080000, CRC(5f58b617) SHA1(d2acb87838bcd4c109ed1a8d9e460757b7365ef5) )
	ROM_LOAD16_BYTE( "95407942.lo", 0x00001, 0x080000, CRC(6250fc4a) SHA1(a133ab1c8d4d35145bf94e73856da4603e8e6579) )
	ROM_LOAD16_BYTE( "95407943.hi", 0x00000, 0x080000, CRC(f5aafcd1) SHA1(afcec150a7229dc28dbdf61addc80efcecc460df) )
	ROM_LOAD16_BYTE( "95408012.lo", 0x00001, 0x080000, CRC(41a21296) SHA1(3351baaadd1b6431e9e2d75586d6912e28e372e5) )
	ROM_LOAD16_BYTE( "95408013.hi", 0x00000, 0x080000, CRC(32399a20) SHA1(516413c5e7420d56f99a1e4353524dce8225c624) )
	ROM_LOAD16_BYTE( "95408096.lo", 0x00001, 0x080000, CRC(9c9f8a16) SHA1(39792c7a83abf490d246323a46e19d3f1c85128d) )
	ROM_LOAD16_BYTE( "95408097.hi", 0x00000, 0x080000, CRC(008dad9d) SHA1(76ead1488b30877e765d5cce21297d40ca090fdd) )
	ROM_LOAD16_BYTE( "95408098.lo", 0x00001, 0x080000, CRC(1728a865) SHA1(8ba012714248dd704fd9beff5cbd1d44b8efcff1) )
	ROM_LOAD16_BYTE( "95408099.hi", 0x00000, 0x080000, CRC(dba2489b) SHA1(e6cc050c6009e7c36884192fed9e4a032444f007) )
	ROM_LOAD16_BYTE( "95408140.lo", 0x00001, 0x080000, CRC(24ac1211) SHA1(3d08e4bd48772d991f9aad151166ad5c3f5d1880) )
	ROM_LOAD16_BYTE( "95408141.hi", 0x00000, 0x080000, CRC(da5c88f0) SHA1(fadd11a79dbd9c875d77e350699701db13546e50) )
	ROM_LOAD16_BYTE( "95408940.lo", 0x00001, 0x080000, CRC(6f1cf5ca) SHA1(f80dc758b1c001ff6f4cf9638483a5ecd20ad125) )
	ROM_LOAD16_BYTE( "95408941.hi", 0x00000, 0x080000, CRC(fe62569a) SHA1(94ec8b29344407df85dd8e0c83a59e7030ec7f60) )
	ROM_LOAD16_BYTE( "95409012.lo", 0x00001, 0x080000, CRC(69abd3b2) SHA1(b4dd5228b83b165939cb192bfd38b1a84c6191c0) )
	ROM_LOAD16_BYTE( "95409013.hi", 0x00000, 0x080000, CRC(881ec829) SHA1(5762a9049b0361691b199b2c4e7d471a7b4a8811) )
	ROM_LOAD16_BYTE( "95409096.lo", 0x00001, 0x080000, CRC(62ba6707) SHA1(9f80511e34e5ece4c95923bb504164abbd0facdc) )
	ROM_LOAD16_BYTE( "95409097.hi", 0x00000, 0x080000, CRC(2f21f8f2) SHA1(02a3d26eda63fe2dff8cf19bb6612cae0958b847) )
	ROM_LOAD16_BYTE( "95409098.lo", 0x00001, 0x080000, CRC(81d32a7a) SHA1(6dbafd421790d877fc5b5699475e02e75092c441) )
	ROM_LOAD16_BYTE( "95409099.hi", 0x00000, 0x080000, CRC(db912573) SHA1(bc21c43349cafdaebc4de69828fd6e18d1722fb9) )
	ROM_LOAD16_BYTE( "95409140.lo", 0x00001, 0x080000, CRC(f89e4577) SHA1(297b242f24b7c3c8727a122915ab447544700455) )
	ROM_LOAD16_BYTE( "95409141.hi", 0x00000, 0x080000, CRC(30b5f293) SHA1(15649fa022517ec9f129fd59aa720314bb099c1d) )
	ROM_LOAD16_BYTE( "95409940.lo", 0x00001, 0x080000, CRC(83657234) SHA1(14502246599dc4fbe00202e4cad6a191c861fc3b) )
	ROM_LOAD16_BYTE( "95409941.hi", 0x00000, 0x080000, CRC(974f9fb2) SHA1(5b0c48e908041d5d8df71de3a65af5ccb28ab469) )
	ROM_LOAD16_BYTE( "95410944.lo", 0x00001, 0x080000, CRC(1fae3ff3) SHA1(a7676c29002c4be1086510284f8bf495ec6ca86c) )
	ROM_LOAD16_BYTE( "95410945.hi", 0x00000, 0x080000, CRC(a1825e26) SHA1(c3ceca1859f02350f888acc5c03052f3575bc57f) )
	ROM_LOAD16_BYTE( "95411944.lo", 0x00001, 0x080000, CRC(28f9cf69) SHA1(b3f058c6cf54406047ddd302fce0244c82ec6bc3) )
	ROM_LOAD16_BYTE( "95411945.hi", 0x00000, 0x080000, CRC(4688d69f) SHA1(106c5c913797acd4e47c8187bbb5f3ded28b9c27) )
	ROM_LOAD16_BYTE( "95411946.lo", 0x00001, 0x080000, CRC(57ef124d) SHA1(a821ba0d06b958a76314a9fc1b58c6591d81a957) )
	ROM_LOAD16_BYTE( "95411947.hi", 0x00000, 0x080000, CRC(b7460c04) SHA1(a2588fe81e55a886a46f324cb9945272447b4eb1) )
	ROM_LOAD16_BYTE( "p1307p11.hi", 0x00000, 0x080000, CRC(41721838) SHA1(4d08a48bd60ee1ed615aed6af48a0392881a15de) )
	ROM_LOAD16_BYTE( "p1307p11.lo", 0x00001, 0x080000, CRC(cf36f797) SHA1(1d538d3fd9f59b37ac2a60e67f1ad2fca6b29d01) )
	ROM_LOAD16_BYTE( "p1307s11.hi", 0x00000, 0x080000, CRC(177a69e8) SHA1(14b49bb00b120f024d08296e489a470cf258956a) )
	ROM_LOAD16_BYTE( "p1307s11.lo", 0x00001, 0x080000, CRC(ad8678be) SHA1(d16197c807aec0bd61481be427cd4dd37236962b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008293.bin", 0x0000, 0x100000, CRC(acbed8e1) SHA1(607dafa2215632d02c34e65b79bf1341b981f63b) )
ROM_END




ROM_START( sc_druby )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1439p41.hi", 0x00000, 0x080000, CRC(d90e997b) SHA1(ddf9065bc5cd3710cd900028890e5a1825bf1513) )
	ROM_LOAD16_BYTE( "p1439p41.lo", 0x00001, 0x080000, CRC(20e7ae21) SHA1(e499b8593e5ded1b7e4dbe906fe1b38cb9eff413) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1439p51.hi", 0x00000, 0x080000, CRC(edf42b2a) SHA1(3dde924c44b18a6ab1980f313f20d0c474b43f5a) )
	ROM_LOAD16_BYTE( "p1439p51.lo", 0x00001, 0x080000, CRC(dd701d6c) SHA1(8d0ae2f3426cee81fa3941240312fc3bcf66c2b4) )
	ROM_LOAD16_BYTE( "p1439s40.lo", 0x00001, 0x080000, CRC(c4b2786d) SHA1(6c6d46cd1d4645a8eb89915c07a8844ce4ccdb26) )
	ROM_LOAD16_BYTE( "p1439s41.hi", 0x00000, 0x080000, CRC(d36c4b18) SHA1(2048183e83032af1653e7dc294c6c7ca501d55fe) )
	ROM_LOAD16_BYTE( "p1439s41.lo", 0x00001, 0x080000, CRC(c4b2786d) SHA1(6c6d46cd1d4645a8eb89915c07a8844ce4ccdb26) )
	ROM_LOAD16_BYTE( "p1439s51.hi", 0x00000, 0x080000, CRC(e796f949) SHA1(aaffdbbc56f01311ac3dbc04c2a90a7d6f25e7ac) )
	ROM_LOAD16_BYTE( "p1439s51.lo", 0x00001, 0x080000, CRC(3925cb20) SHA1(e9f9ebbad35461f616aae4bf6ab553a58b63d18a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008423.bin", 0x0000, 0x100000, CRC(4cab20ee) SHA1(e27221a94e54db340eaf7fc30e722b354c85686d) )
	ROM_REGION( 0x400000, "others", ROMREGION_ERASE00 )
	ROM_LOAD( "95730028.bin", 0x0000, 0x008000, CRC(015f3760) SHA1(74dfd188f4a7ad057fda45a349e684be37a3f6bc) )
	ROM_LOAD( "95730068.bin", 0x0000, 0x008000, CRC(2bcbcf0d) SHA1(30dbb5ec3be34520ad89aedead42e1eda7841b63) )
ROM_END




ROM_START( sc_disco )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400955.lo", 0x00001, 0x080000, CRC(62c923ef) SHA1(e1590557d5fd0927108ce1b1a134c7ee76525566) )
	ROM_LOAD16_BYTE( "95400956.hi", 0x00000, 0x080000, CRC(728ab93f) SHA1(554b6208074f6ef2bf9045569da569c179c84201) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402271.lo", 0x00001, 0x080000, CRC(d93a7b38) SHA1(c15eb45392ecbe2f7596042a1737cc2cecea066d) )
	ROM_LOAD16_BYTE( "95402272.hi", 0x00000, 0x080000, CRC(1902724f) SHA1(c6f6fa5eba7a4cf043f047a2113cbd5c0139a1ef) )
	ROM_LOAD16_BYTE( "95403341.lo", 0x00001, 0x080000, CRC(6913bf28) SHA1(c721933d63de2b0d5ba4b68541801f3e7677086a) )
	ROM_LOAD16_BYTE( "95403342.hi", 0x00000, 0x080000, CRC(ce9d6c1e) SHA1(68d31f3e003c30d11a349c51823407eccf7f2534) )
	ROM_LOAD16_BYTE( "95404638.lo", 0x00001, 0x080000, CRC(e088d182) SHA1(51eaa23cab3455412ec5e8407f75f9226e92dbd2) )
	ROM_LOAD16_BYTE( "95404639.hi", 0x00000, 0x080000, CRC(7080c3b5) SHA1(fc8916f5d39dd02083d77e123818cf794d674ff3) )
	ROM_LOAD16_BYTE( "95405638.lo", 0x00001, 0x080000, CRC(69ed0c5e) SHA1(a90665bf635cb71977cf026fd6a00440a16f3696) )
	ROM_LOAD16_BYTE( "95405639.hi", 0x00000, 0x080000, CRC(face1fd8) SHA1(a830e5fc2f8171296585b3431d45d9a25c6554fb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004220", 0x0000, 0x080000, CRC(530be6ac) SHA1(eede25d9d8a429dace91c1dc37ce4da7152b1836) )
	ROM_LOAD( "95004221", 0x0000, 0x080000, CRC(0b2020c9) SHA1(75c7af9312ea1b84df66a640fac903aedac5a0eb) )
ROM_END




ROM_START( sc_ddosh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408058.lo", 0x00001, 0x080000, CRC(953fc9c3) SHA1(d2f9a9875126ea0a9807abdad73f48c146617763) )
	ROM_LOAD16_BYTE( "95408059.hi", 0x00000, 0x080000, CRC(4ac58478) SHA1(b452af3db3e91d659eaa641ae589a603c9d3e595) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408184.lo", 0x00001, 0x080000, CRC(2125d1b3) SHA1(56ff3ac713d8da3ebac4ebe2e342a60ef665bbec) )
	ROM_LOAD16_BYTE( "95408185.hi", 0x00000, 0x080000, CRC(0ad032e9) SHA1(e6af4938b8b3ea3e25bc5ab426d6506e1ac72df6) )
	ROM_LOAD16_BYTE( "95408960.lo", 0x00001, 0x080000, CRC(f7953cd6) SHA1(fc20c51460397b57e976abcf5491f257619dc81f) )
	ROM_LOAD16_BYTE( "95408961.hi", 0x00000, 0x080000, CRC(c340ac9d) SHA1(c08e257f79bec391b5fe642a5609078d64efdc25) )
	ROM_LOAD16_BYTE( "95408962.lo", 0x00001, 0x080000, CRC(4e01227d) SHA1(28d9307a4eb5d573ad969d4afe1b630738971b9d) )
	ROM_LOAD16_BYTE( "95408963.hi", 0x00000, 0x080000, CRC(0be07c6c) SHA1(2f1271d3be31ec9fd9fd216ec6a6b7b21e9cbcc1) )
	ROM_LOAD16_BYTE( "95409058.lo", 0x00001, 0x080000, CRC(44b55b53) SHA1(b60cd2e5b9ca4bb529739f3d66adc32131c7c5a0) )
	ROM_LOAD16_BYTE( "95409059.hi", 0x00000, 0x080000, CRC(53f0bf8a) SHA1(5bedb9d9436dab53560aea6ce940802451debcf6) )
	ROM_LOAD16_BYTE( "95409184.lo", 0x00001, 0x080000, CRC(5f521844) SHA1(713a333ab64c93e807f1cdd11680087d9b6992bd) )
	ROM_LOAD16_BYTE( "95409185.hi", 0x00000, 0x080000, CRC(ed2034f4) SHA1(dfadea956683a6d5ec3c9c58d21a331051a7d7ec) )
	ROM_LOAD16_BYTE( "95409960.lo", 0x00001, 0x080000, CRC(9ded56aa) SHA1(939c3c2ee623c9d54706ec5a6fe00cc9eb716ab7) )
	ROM_LOAD16_BYTE( "95409961.hi", 0x00000, 0x080000, CRC(53341c67) SHA1(7dd692935564ed9de7c87e371822a7da6e609667) )
	ROM_LOAD16_BYTE( "95409962.lo", 0x00001, 0x080000, CRC(884c4711) SHA1(9f2f252605b5fbcd6e468558c120c066155e1bf2) )
	ROM_LOAD16_BYTE( "95409963.hi", 0x00000, 0x080000, CRC(12942dbd) SHA1(a97416b0fe2d434a8df071e73839f53d865c4d9e) )
	ROM_LOAD16_BYTE( "95410554.lo", 0x00001, 0x080000, CRC(548d63de) SHA1(b08a7b0df804077d3d21b81cd94fbd6fc07fc586) )
	ROM_LOAD16_BYTE( "95410555.hi", 0x00000, 0x080000, CRC(56333835) SHA1(803944338f3c4ebc909776fe0631fc7053222f5f) )
	ROM_LOAD16_BYTE( "95410556.lo", 0x00001, 0x080000, CRC(b802d16c) SHA1(eef08384549d02730b4aeab84e0db419366d7fad) )
	ROM_LOAD16_BYTE( "95410557.hi", 0x00000, 0x080000, CRC(bc129faf) SHA1(2dde04dc0ea7023c17162c05d35b62ffccce6fdf) )
	ROM_LOAD16_BYTE( "95411554.lo", 0x00001, 0x080000, CRC(182a5bf0) SHA1(649aab4636e530006b8dbd695f4d74d0d6c9baf6) )
	ROM_LOAD16_BYTE( "95411555.hi", 0x00000, 0x080000, CRC(0ec186c9) SHA1(4c014089ef942efe67de667b14ec66c19476cc90) )
	ROM_LOAD16_BYTE( "95411556.lo", 0x00001, 0x080000, CRC(970e1df8) SHA1(b8d614fb50ee472ff42d6fc4135b70948567cc8b) )
	ROM_LOAD16_BYTE( "95411557.hi", 0x00000, 0x080000, CRC(5778044b) SHA1(09a09f666b65de59cde8f2a5ad9ac52297ad4d7a) )
	ROM_LOAD16_BYTE( "95412434.lo", 0x00001, 0x080000, CRC(00b23cd4) SHA1(0d2257006b8fdac23caab8dbc696ce131b50f6f3) )
	ROM_LOAD16_BYTE( "95412435.hi", 0x00000, 0x080000, CRC(86ab1cbc) SHA1(e9dbd1421274f5a024187063edd4a138b0835899) )
	ROM_LOAD16_BYTE( "95413434.lo", 0x00001, 0x080000, CRC(b4f57152) SHA1(fcca12a12b7ddd4021828938546c9118bdbbf557) )
	ROM_LOAD16_BYTE( "95413435.hi", 0x00000, 0x080000, CRC(394fba09) SHA1(0fcd4c6b6dade2f2f902c6244c303cb1e344f855) )
	ROM_LOAD16_BYTE( "p1309p12.hi", 0x00000, 0x080000, CRC(3a256edb) SHA1(ed4821063e9e717e73875cba0742ca695c402cba) )
	ROM_LOAD16_BYTE( "p1309p12.lo", 0x00001, 0x080000, CRC(e8cc8f24) SHA1(5f5ceaafcefe36e74b9548c4289889cac5914bba) )
	ROM_LOAD16_BYTE( "p1309s12.hi", 0x00000, 0x080000, CRC(a6dbb7b3) SHA1(596655bd858645b242185d00a730c608cba7b519) )
	ROM_LOAD16_BYTE( "p1309s12.lo", 0x00001, 0x080000, CRC(e4dc9264) SHA1(03d01247555a58ed4e0ed048144f615f6a33d351) )

	ROM_LOAD16_BYTE( "p1309p11.hi", 0x00000, 0x080000, CRC(558e6289) SHA1(9dc2247ade861776dc265ac394fe23e1d0a33186) )
	ROM_LOAD16_BYTE( "p1309p11.lo", 0x00001, 0x080000, CRC(9859cdfc) SHA1(7ac807df1f3f303296bd663466b2fbf8c37e330c) )
	ROM_LOAD16_BYTE( "p1309s11.hi", 0x00000, 0x080000, CRC(bc0034c4) SHA1(1ce19865e1058710b63403dd9add1a553df460cd) )
	ROM_LOAD16_BYTE( "p1309s11.lo", 0x00001, 0x080000, CRC(79f196ae) SHA1(cf37eb02b2a0ec8ba6482ae33f604b41eae23671) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008299.bin", 0x0000, 0x100000, CRC(fee81425) SHA1(188cb7275963193a39571d3e4da3b9f6693a79d0) )
ROM_END



ROM_START( sc_dbldm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416168.odd", 0x00001, 0x080000, CRC(7724358b) SHA1(ffd57d13d08d05287382e07a433037d6cd002d1e) )
	ROM_LOAD16_BYTE( "95416169.evn", 0x00000, 0x080000, CRC(87b9ce5c) SHA1(b5f9bc9b7428c5537e9d7b2e1adc07a0c78422b2) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008540.bin", 0x0000, 0x0ff77d, CRC(752628b0) SHA1(42b07736549b0e5e9d15cccd4922fac1e4135687) )
ROM_END




ROM_START( sc_dblfr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406316.odd", 0x00001, 0x080000, CRC(748869bb) SHA1(14c4eac2af716d4c0f281649392a0722a71f08dc) )
	ROM_LOAD16_BYTE( "95406317.evn", 0x00000, 0x080000, CRC(2108c5cd) SHA1(08ef8ef16f0ada502b4f18d05cb63219af3bca29) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406446.odd", 0x00001, 0x080000, CRC(62766923) SHA1(e57ecc5003b82c3a63d509a60da6c1d3a1edc9bb) )
	ROM_LOAD16_BYTE( "95406447.evn", 0x00000, 0x080000, CRC(fe684a83) SHA1(496974fb88856d618849d02f2cc38b0ab633fe02) )
	ROM_LOAD16_BYTE( "95407316.odd", 0x00001, 0x080000, CRC(74cf5619) SHA1(2095bb73ab69c7c9f187ec0f3b1a0914da23326c) )
	ROM_LOAD16_BYTE( "95407317.evn", 0x00000, 0x080000, CRC(36da3b26) SHA1(9331c2e8b7ede871e94e918d8071ca6d12c81998) )
	ROM_LOAD16_BYTE( "95407446.odd", 0x00001, 0x080000, CRC(62315681) SHA1(0c90b9e919060848bb2b04fb250bf55f841d70c7) )
	ROM_LOAD16_BYTE( "95407447.evn", 0x00000, 0x080000, CRC(e9bab468) SHA1(66a960247792e94039a8e3b56377b480e487fec2) )
	ROM_LOAD16_BYTE( "95416680.lo", 0x00001, 0x080000, CRC(f37bc848) SHA1(4e842b8e48432b7cb8aae47ddebfe01eafc112ce) )
	ROM_LOAD16_BYTE( "95416681.hi", 0x00000, 0x080000, CRC(b93dc6c4) SHA1(52044ea62a3edd2009d7c18da285009e75ee817c) )
	ROM_LOAD16_BYTE( "95417680.lo", 0x00001, 0x080000, CRC(d60c67d5) SHA1(f3b66d89c4cc625c6497a3eeabd133df7f00384a) )
	ROM_LOAD16_BYTE( "95417681.hi", 0x00000, 0x080000, CRC(a5937541) SHA1(90283dee8352fdbc67c132b01c7306cae58a8004) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004307.bin", 0x0000, 0x080000, CRC(69b55ce9) SHA1(c635add8001dc7c5c81ffcae05b2b83bb37e9e72) )
ROM_END




ROM_START( sc_darw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404764.odd", 0x00001, 0x080000, CRC(dabfaa87) SHA1(4225d5ed0985f727ec3899134ff78c3f7a9066c9) )
	ROM_LOAD16_BYTE( "95404765.evn", 0x00000, 0x080000, CRC(2febc6c8) SHA1(1fb4f4f609a0159f97c07fef5ca1c6b1f8788da2) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405764.odd", 0x00001, 0x080000, CRC(a4f5508d) SHA1(baadfd23afb0eb2d97eada9860a1b7dc7c9afe6b) )
	ROM_LOAD16_BYTE( "95405765.evn", 0x00000, 0x080000, CRC(e5c365e3) SHA1(5e151aad3f4645b74f3f8f221e6ab48adfc4e8f1) )
	ROM_LOAD16_BYTE( "95406116.odd", 0x00001, 0x080000, CRC(be00430f) SHA1(f71dbd4ecca434893950f035775b702f99632cec) )
	ROM_LOAD16_BYTE( "95406117.evn", 0x00000, 0x080000, CRC(519cf9ab) SHA1(18cfa58f919247f9b4d9f035723dee9eed43c688) )
	ROM_LOAD16_BYTE( "95407116.odd", 0x00001, 0x080000, CRC(f3487dcc) SHA1(6a7226421397fee2582a3800b2cd9d514605327d) )
	ROM_LOAD16_BYTE( "95407117.evn", 0x00000, 0x080000, CRC(3ec02d03) SHA1(1d12632bfb54e46dee45acf04148d9dafc19d2ed) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008214.bin", 0x0000, 0x0e7add, CRC(423575e6) SHA1(52d9a22824b0ee828095f99dcc5209787f5a2c32) )
ROM_END




ROM_START( sc_dhh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418234.lo", 0x00001, 0x080000, CRC(e54495af) SHA1(3113c0831fed8b1e79a23eefb943389b761174ce) )
	ROM_LOAD16_BYTE( "95418235.hi", 0x00000, 0x080000, CRC(bd8d114b) SHA1(f243831139332b4a4f82cc68494078bee06f8f69) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418304.lo", 0x00001, 0x080000, CRC(d3f9fc98) SHA1(979bea6f5b9930f3e9475366143bde53b93374af) )
	ROM_LOAD16_BYTE( "95418305.hi", 0x00000, 0x080000, CRC(8fcad8a5) SHA1(a704dccc5e0283e25c75a99933b2b8c8947c1b84) )
	ROM_LOAD16_BYTE( "95418492.lo", 0x00001, 0x080000, CRC(45d0a32d) SHA1(607648b6333365d21d712b87c857339566fdd99b) )
	ROM_LOAD16_BYTE( "95418493.hi", 0x00000, 0x080000, CRC(6e727d28) SHA1(07cc1f223252fa3dbc122b3bac9b4502f23aaf79) )
	ROM_LOAD16_BYTE( "95418494.lo", 0x00001, 0x080000, CRC(5b9ae752) SHA1(52fad5c24d205b2e401cd87de89aabfca1e99564) )
	ROM_LOAD16_BYTE( "95418495.hi", 0x00000, 0x080000, CRC(8116da15) SHA1(8057d1536e4647a68eed384060a0ecd23b7d9aba) )
	ROM_LOAD16_BYTE( "95419234.lo", 0x00001, 0x080000, CRC(d6ebf891) SHA1(33a62ea3e82400e5be27dd007e2c744a357b301a) )
	ROM_LOAD16_BYTE( "95419235.hi", 0x00000, 0x080000, CRC(b0017541) SHA1(18c8d5ab7bea6b229dcbc525aed827f747bc9243) )
	ROM_LOAD16_BYTE( "95419304.lo", 0x00001, 0x080000, CRC(4e774459) SHA1(949aaecc5ea01b1761e029da4f42dbc915903259) )
	ROM_LOAD16_BYTE( "95419305.hi", 0x00000, 0x080000, CRC(1b28a792) SHA1(2f0f7cb6404d35d07fbc9c35036301d92644ca37) )
	ROM_LOAD16_BYTE( "95419492.lo", 0x00001, 0x080000, CRC(05f2625e) SHA1(d77517420fbbe198213ee4f0634252c259f8b8c8) )
	ROM_LOAD16_BYTE( "95419493.hi", 0x00000, 0x080000, CRC(59dc177c) SHA1(cb1eb80a71bf2745881e6b073ba6aeb009b6a850) )
	ROM_LOAD16_BYTE( "95419494.lo", 0x00001, 0x080000, CRC(d0e4b7e3) SHA1(e1f1a17fdef63163770de4505675e70d369327c0) )
	ROM_LOAD16_BYTE( "95419495.hi", 0x00000, 0x080000, CRC(acce7f23) SHA1(3489826d5b8e049838e05679a982e5ed1c8a5cec) )
	ROM_LOAD16_BYTE( "95422966.lo", 0x00001, 0x080000, CRC(a0a41d59) SHA1(995b501fa6516b7b7b48cf87c437a9873552b504) )
	ROM_LOAD16_BYTE( "95422967.hi", 0x00000, 0x080000, CRC(81c24fe4) SHA1(6694b5f9a32d45db5d110083b3e9808ab4554506) )
	ROM_LOAD16_BYTE( "95423966.lo", 0x00001, 0x080000, CRC(28ebaa72) SHA1(0e0ec5ebff3f2860d7aadb6200fce07aad2361c2) )
	ROM_LOAD16_BYTE( "95423967.hi", 0x00000, 0x080000, CRC(ecd590c4) SHA1(c406792454714f564e1460efe396ea37d30ac01d) )
	ROM_LOAD16_BYTE( "95426230.lo", 0x00001, 0x080000, CRC(af4df562) SHA1(71c6d0b4cf3e9972e947d183b04bc3ea95c78373) )
	ROM_LOAD16_BYTE( "95426231.hi", 0x00000, 0x080000, CRC(613b3a22) SHA1(20c1a67112f3a681b1a5236b68c29a9185308ee3) )
	ROM_LOAD16_BYTE( "95426236.lo", 0x00001, 0x080000, CRC(7d73f0ae) SHA1(446f2cdb76fa353ede0e53fa9873237e9def78e1) )
	ROM_LOAD16_BYTE( "95426237.hi", 0x00000, 0x080000, CRC(b215f36d) SHA1(669829c2f86a8262ee4b0c8a76d52241deeff2d6) )
	ROM_LOAD16_BYTE( "95427230.lo", 0x00001, 0x080000, CRC(d46701ec) SHA1(af827fd9368bb480f29f04c452c4c2cf33e120ba) )
	ROM_LOAD16_BYTE( "95427231.hi", 0x00000, 0x080000, CRC(ed311139) SHA1(c0a1fafc3000faf5659f224080671103b3a1665a) )
	ROM_LOAD16_BYTE( "95427236.lo", 0x00001, 0x080000, CRC(3fa0f89d) SHA1(ac14fd39924f959cc9d89a214c47c3ee85f43eea) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008586.bin", 0x0000, 0x100000, CRC(43fde3ad) SHA1(662402449b025bbf75a10c3b1ac746d9359b0b0d) )
	ROM_LOAD( "95008587.bin", 0x0000, 0x100000, CRC(6f7a607f) SHA1(da3c8aaa69b30f10f122a9bde49d987dd0950474) )
ROM_END




ROM_START( sc_dough )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418044.lo", 0x00001, 0x080000, CRC(c25b15cd) SHA1(85e509a83b443a415480baf74299ee7d7cc58215) )
	ROM_LOAD16_BYTE( "95418045.hi", 0x00000, 0x080000, CRC(76f2652b) SHA1(52bedca861f582d30eb9960f1be70a8392179a34) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418046.lo", 0x00001, 0x080000, CRC(1358dc76) SHA1(d09cf2473cf5c786f6a9c61c44d792227b444536) )
	ROM_LOAD16_BYTE( "95418047.hi", 0x00000, 0x080000, CRC(163416eb) SHA1(837bd735d54228e471e34d65ba05508d7d2e85da) )
	ROM_LOAD16_BYTE( "95419044.lo", 0x00001, 0x080000, CRC(281fff41) SHA1(3d709f68a2a06d4e57c3ceb34abd8c80740f09f4) )
	ROM_LOAD16_BYTE( "95419045.hi", 0x00000, 0x080000, CRC(37134542) SHA1(77a485ed9c311c83d504d376a07425ece9612b8b) )
	ROM_LOAD16_BYTE( "95419046.lo", 0x00001, 0x080000, CRC(857e5267) SHA1(218770e60423af3dc6b20f0bf1f87173213f95ca) )
	ROM_LOAD16_BYTE( "95419047.hi", 0x00000, 0x080000, CRC(acb97317) SHA1(1da2955b336140121c48d30958761dd3e3cccd43) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008505.bin", 0x0000, 0x100000, CRC(e18549be) SHA1(7062f05b6245c4188ed68a51dc7fbc8b138698f4) )
ROM_END




ROM_START( sc_ducks )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416442.lo", 0x00001, 0x080000, CRC(d113671a) SHA1(a6f8249138d9f38645daefd150fe213b564b24e1) )
	ROM_LOAD16_BYTE( "95416443.hi", 0x00000, 0x080000, CRC(66b1264c) SHA1(9df605167b69f40f0c4feb8ef2a4d7e760faf2e0) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416444.lo", 0x00001, 0x080000, CRC(8d0f6ea6) SHA1(5fafaba8931327f57bd0952ed69fac5cc8a8b3d6) )
	ROM_LOAD16_BYTE( "95416445.hi", 0x00000, 0x080000, CRC(56dfa592) SHA1(99eb7a50c9372d1ce3bd1da80106b3e85a2f3c23) )
	ROM_LOAD16_BYTE( "95417440.lo", 0x00001, 0x080000, CRC(c28ddc31) SHA1(e32e2cdf19a4ae432bc570765580c4cceb888ba8) )
	ROM_LOAD16_BYTE( "95417441.hi", 0x00000, 0x080000, CRC(00921b61) SHA1(88b9a9d1820ccfe73707b12dc3aef9c044e9c41b) )
	ROM_LOAD16_BYTE( "95417442.lo", 0x00001, 0x080000, CRC(21c3aa78) SHA1(7cbb26353e6292392fc4ef0ab3c405cb5788f177) )
	ROM_LOAD16_BYTE( "95417443.hi", 0x00000, 0x080000, CRC(4b70fc11) SHA1(04de2fe94df00f2befaa36b2a2dd79142ace3503) )
	ROM_LOAD16_BYTE( "95417444.lo", 0x00001, 0x080000, CRC(01af39ba) SHA1(92730609807f919dff98dbf1aadd983686d43bbf) )
	ROM_LOAD16_BYTE( "95417445.hi", 0x00000, 0x080000, CRC(b0e04c87) SHA1(9350d7e6d9cf8a4cece3f70b3a7f58ab0c8b4dc4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )

	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890347.bin", 0x0000, 0x5000, CRC(9faa9c11) SHA1(5e2add80ad17a27dd7b5b0a298ea6753b6adca11) )
	ROM_LOAD( "95890348.bin", 0x0000, 0x5000, CRC(ea3cd825) SHA1(0ecef82b32b0166ef5f8deecd7a85fd52fc66bf8) )
	ROM_LOAD( "95890349.bin", 0x0000, 0x5000, CRC(74861479) SHA1(7ba29931336985b96995688afdfe2b83a7602a84) )
ROM_END




ROM_START( sc_duckq )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408196.odd", 0x00001, 0x080000, CRC(59931e53) SHA1(adcf354276620862cb7fd39051747a3f53e4c07a) )
	ROM_LOAD16_BYTE( "95408197.evn", 0x00000, 0x080000, CRC(1e57ba10) SHA1(6d6a5dcb14a2ea1b91fa10bc136841ba237568ff) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409196.odd", 0x00001, 0x080000, CRC(a562a45d) SHA1(65d854e9b7b46b0b8426aa022bf7694f4613bcc3) )
	ROM_LOAD16_BYTE( "95409197.evn", 0x00000, 0x080000, CRC(f7407914) SHA1(66b3abafc75e2545a34846f3e7f8f0940a4d28a1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008337.bin", 0x0000, 0x0fd2ce, CRC(d452995e) SHA1(3a8196f44078a4730ec18f16ce3a68b647205a29) )
ROM_END




ROM_START( sc_dyna )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404578.lo", 0x00001, 0x080000, CRC(8b01fbfd) SHA1(91f54598a4b2a6cf9e48197aad58d86085cce25c) )
	ROM_LOAD16_BYTE( "95404579.hi", 0x00000, 0x080000, CRC(49a12485) SHA1(57b3a7e0a0eb035b5a2fa8238ec762b128d4dee9) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405578.lo", 0x00001, 0x080000, CRC(1446edf7) SHA1(6eb07646f3865044dbd9a3aa829ebe10113fc734) )
	ROM_LOAD16_BYTE( "95405579.hi", 0x00000, 0x080000, CRC(f8db0f45) SHA1(66d995da3868e77c0a3e2f0802c571acf5b8f465) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008209.bin", 0x0000, 0x100000, CRC(7845c5e7) SHA1(14cd505e11149b6bdfa0e8a92236f3229f7a2a0e) )
ROM_END




ROM_START( sc_easy )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404392.lo", 0x00001, 0x080000, CRC(6532f057) SHA1(40ce4e1cb784cd9abab1a10d3b95cf72eecea17d) )
	ROM_LOAD16_BYTE( "95404393.hi", 0x00000, 0x080000, CRC(1f969ae9) SHA1(a69ea773b8bd34815a0b5c6791f0237ac00fbd32) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404394.lo", 0x00001, 0x080000, CRC(6dd51d85) SHA1(a093d08e4d7a798e7725df3b6a421185396c44c2) )
	ROM_LOAD16_BYTE( "95404395.hi", 0x00000, 0x080000, CRC(b5879699) SHA1(3f680a6905b4affce4add04f13eb0eb44346cf10) )
	ROM_LOAD16_BYTE( "95404434.lo", 0x00001, 0x080000, CRC(025a3264) SHA1(40d1cb1fa925824a65846f654ba83e7745a6b283) )
	ROM_LOAD16_BYTE( "95404435.hi", 0x00000, 0x080000, CRC(4e75b8f5) SHA1(63967ac37b3ae56ea155b9f80aaba10ff41a37b2) )
	ROM_LOAD16_BYTE( "95405392.lo", 0x00001, 0x080000, CRC(ec96482b) SHA1(d2f2772c605179c08d34f00088d00df22fce7dad) )
	ROM_LOAD16_BYTE( "95405393.hi", 0x00000, 0x080000, CRC(670ea673) SHA1(23d43528c40ae604c9d6ae3d60a31ee4f4ea14e3) )
	ROM_LOAD16_BYTE( "95405434.lo", 0x00001, 0x080000, CRC(23095d0f) SHA1(db245af58e0af9deb053be7cd65cec9f9abbb173) )
	ROM_LOAD16_BYTE( "95405435.hi", 0x00000, 0x080000, CRC(e96df0f8) SHA1(b85972c4ea9338b3efe2ff2b2f275b5c53b8ff66) )
	ROM_LOAD16_BYTE( "95406026.lo", 0x00001, 0x080000, CRC(40b4ad10) SHA1(e9041da69445dd2a08dbb48ec842040c66b788c3) )
	ROM_LOAD16_BYTE( "95406027.hi", 0x00000, 0x080000, CRC(39eb0bf5) SHA1(229044913c99b0a92e5962eda6c70ec62c3e6b72) )
	ROM_LOAD16_BYTE( "95406688.lo", 0x00001, 0x080000, CRC(ce13282c) SHA1(2e778af1de70d3e5d11df54ff85fc50645d85f08) )
	ROM_LOAD16_BYTE( "95406689.hi", 0x00000, 0x080000, CRC(a05771f9) SHA1(7c234c49ad2d74ba150cc73da4adbfe733c5b224) )
	ROM_LOAD16_BYTE( "95406690.lo", 0x00001, 0x080000, CRC(d72a4e94) SHA1(ef7ad4e2662b68679b84eb9418c1e9fb7c84e29c) )
	ROM_LOAD16_BYTE( "95406691.hi", 0x00000, 0x080000, CRC(9ecd06c6) SHA1(83ef6bbd7a0c84b3e8c40217aa86d9c14b4521a5) )
	ROM_LOAD16_BYTE( "95406884.lo", 0x00001, 0x080000, CRC(c17c9f70) SHA1(20c68c07be855e2f7aff1154072ad60140987c5a) )
	ROM_LOAD16_BYTE( "95406885.hi", 0x00000, 0x080000, CRC(26702794) SHA1(06bcad6234be52f812b4fa3468adca13b16afbe4) )
	ROM_LOAD16_BYTE( "95406886.lo", 0x00001, 0x080000, CRC(37e0a39a) SHA1(5430af8a09719883a16e88e3c63dfe4f67f7c231) )
	ROM_LOAD16_BYTE( "95406887.hi", 0x00000, 0x080000, CRC(8e11985d) SHA1(7122d1fdf48953adee04d915f61be4e87d80cd26) )
	ROM_LOAD16_BYTE( "95407026.lo", 0x00001, 0x080000, CRC(3c207a4f) SHA1(9c8c100765b84ed50c2faa81b26efa8e639ef994) )
	ROM_LOAD16_BYTE( "95407027.hi", 0x00000, 0x080000, CRC(d2819011) SHA1(410f40284b3d261d384e0017522518511f6ca105) )
	ROM_LOAD16_BYTE( "95407688.lo", 0x00001, 0x080000, CRC(802b17b9) SHA1(ee56083fdb1d45c27095c7561690d1a39154c0e6) )
	ROM_LOAD16_BYTE( "95407689.hi", 0x00000, 0x080000, CRC(713a971c) SHA1(05cd1f6feec4c5296fe9da82a860d56117939cdb) )
	ROM_LOAD16_BYTE( "95407690.lo", 0x00001, 0x080000, CRC(37218f3f) SHA1(3fe41a27f60b621f4d39eb8c9cc27a56481227b5) )
	ROM_LOAD16_BYTE( "95407691.hi", 0x00000, 0x080000, CRC(1986504b) SHA1(126fc4486bcd2931849b2b51c694bb54403d7a8e) )
	ROM_LOAD16_BYTE( "95407884.lo", 0x00001, 0x080000, CRC(24c50f8a) SHA1(75f98fc5dcffad2f47c012be66c157bd73f00cf3) )
	ROM_LOAD16_BYTE( "95407885.hi", 0x00000, 0x080000, CRC(c3e37e0e) SHA1(eebd6264ee9efb955fee96017af2ea2678bbca8b) )
	ROM_LOAD16_BYTE( "95407886.lo", 0x00001, 0x080000, CRC(3a41067c) SHA1(2e776a26a2436ba969220bf41832875a9bcd588c) )
	ROM_LOAD16_BYTE( "95407887.hi", 0x00000, 0x080000, CRC(8c087f60) SHA1(4c0624d4c56d64008b12c8435f901fb732bbe506) )
	ROM_LOAD16_BYTE( "p1326p11.hi", 0x00000, 0x080000, CRC(873c7a05) SHA1(201c287c36bf11832ea3736cee7a4b8bbe9f4254) )
	ROM_LOAD16_BYTE( "p1326p11.lo", 0x00001, 0x080000, CRC(14101cd8) SHA1(b808c8447047b98306843e01fa3f2722e9d37769) )
	ROM_LOAD16_BYTE( "p1326p41.hi", 0x00000, 0x080000, CRC(490e389d) SHA1(e1cfe5a64804662e637e3f05eea13902e4ba55a8) )
	ROM_LOAD16_BYTE( "p1326p41.lo", 0x00001, 0x080000, CRC(764150c3) SHA1(1f22f22c72379ec9c1ca0da787366a8368c56303) )
	ROM_LOAD16_BYTE( "p1326s11.hi", 0x00000, 0x080000, CRC(ae417ea4) SHA1(ba3876cfc9d7787d3a14b100f3f9e185b08cd207) )
	ROM_LOAD16_BYTE( "p1326s11.lo", 0x00001, 0x080000, CRC(3a5cbcd0) SHA1(c36979d9b0045dbb103a665bde5a97a0a4a3b9b0) )
	ROM_LOAD16_BYTE( "p1326s41.hi", 0x00000, 0x080000, CRC(e74d9798) SHA1(67a43317844a455addb624deea516354854ee0a8) )
	ROM_LOAD16_BYTE( "p1326s41.lo", 0x00001, 0x080000, CRC(b74196f7) SHA1(67ab1a115bb2656951f187f47d6c4b9dca7481c0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008195.bin", 0x0000, 0x100000, CRC(e032e67a) SHA1(062f48bd2c38b51ffba8cda7860bb37abad40c71) )
	ROM_LOAD( "95008196.bin", 0x0000, 0x100000, CRC(4a23e184) SHA1(2d1c1d92c9cdccd95ca4f466a2d7765def7d990b) )
	ROM_LOAD( "95008288.bin", 0x0000, 0x100000, CRC(da74e2d3) SHA1(a16b3d6c0590b0ccc7b2488a2f23383a332c332a) )
ROM_END




ROM_START( sc_emmer )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420072.lo", 0x00001, 0x080000, CRC(95baff43) SHA1(b5cefff519282cada89155ef25665f78960149cf) )
	ROM_LOAD16_BYTE( "95420073.hi", 0x00000, 0x080000, CRC(f35cb8e7) SHA1(65e56c481b2df75dbfa3febe9988fe7f1d858b04) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420074.lo", 0x00001, 0x080000, CRC(04abd6e7) SHA1(e5625b7004bb1870f4f07d44abe87f7371ab85f5) )
	ROM_LOAD16_BYTE( "95420075.hi", 0x00000, 0x080000, CRC(fa8ef4c2) SHA1(71af90541143ccc9a9a8e41a38959a13121255f8) )
	ROM_LOAD16_BYTE( "95420128.lo", 0x00001, 0x080000, CRC(73505beb) SHA1(f59b0369688867a68983ee2437ca98bc6ecab6a7) )
	ROM_LOAD16_BYTE( "95420129.hi", 0x00000, 0x080000, CRC(a13583a1) SHA1(f546a457e7103314c9b78ec471297b1744d0f108) )
	ROM_LOAD16_BYTE( "95421072.lo", 0x00001, 0x080000, CRC(38be125f) SHA1(6de5be192dfb9c6efde712da833a2fbaad896ea4) )
	ROM_LOAD16_BYTE( "95421073.hi", 0x00000, 0x080000, CRC(ca709361) SHA1(556677e27e3164fcf3ac119be5276cac34256451) )
	ROM_LOAD16_BYTE( "95421074.lo", 0x00001, 0x080000, CRC(ea40002d) SHA1(da3949e45bbf7eeba432b72492f156f4dece8582) )
	ROM_LOAD16_BYTE( "95421075.hi", 0x00000, 0x080000, CRC(028ae706) SHA1(5a74859ac7ee5985fcf96d493017b4c8a012a0ac) )
	ROM_LOAD16_BYTE( "95421128.lo", 0x00001, 0x080000, CRC(c7431807) SHA1(78bf3727f99f70c660d39fdb8b7dd91902c510db) )
	ROM_LOAD16_BYTE( "95421129.hi", 0x00000, 0x080000, CRC(cd008039) SHA1(7233658bddc7dfd4de2ba4fdc5da946dcfb116c6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008973.bin", 0x0000, 0x0fc2ce, CRC(a6ef4f4c) SHA1(4749e008e8cd0a7f92da85fcbf1a9dfd9fd5e721) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890452.bin", 0x0000, 0x5000, CRC(193927ce) SHA1(fe02d1d1519139199fbb743ce0e67b810261e9a2) )
	ROM_LOAD( "95890453.bin", 0x0000, 0x5000, CRC(6caf63fa) SHA1(86657e0e14eac91f91bd4da4c04b88c8ee28de45) )
	ROM_LOAD( "95890454.bin", 0x0000, 0x5000, CRC(f215afa6) SHA1(0e28affa6557474856087dbeeb0a3127616b7fe6) )
ROM_END




ROM_START( sc_evol )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410180.lo", 0x00001, 0x080000, CRC(af8ac67c) SHA1(668381e48400a7ad8186212ef00e9881824baf82) )
	ROM_LOAD16_BYTE( "95410181.hi", 0x00000, 0x080000, CRC(ebeb4589) SHA1(1909a92c1e29b2424480aeb21650543da91089cb) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410182.lo", 0x00001, 0x080000, CRC(54fefbd7) SHA1(c181e65766e11c397a5376c1abbc6b285fda853a) )
	ROM_LOAD16_BYTE( "95410183.hi", 0x00000, 0x080000, CRC(e8d7216a) SHA1(c93239f759781a8ba854ed19fe6cd328f022c17c) )
	ROM_LOAD16_BYTE( "95410804.lo", 0x00001, 0x080000, CRC(dac7d3ec) SHA1(918f353d8685b7808da211ec86cc3f456c6141ee) )
	ROM_LOAD16_BYTE( "95410805.hi", 0x00000, 0x080000, CRC(afcd340c) SHA1(91659ded6d0643b3c9b9061a1f08e8f110f548c2) )
	ROM_LOAD16_BYTE( "95410806.lo", 0x00001, 0x080000, CRC(6207f59d) SHA1(c9a8acb118a3e23a6e8edb7b664b94f68d61c58b) )
	ROM_LOAD16_BYTE( "95410807.hi", 0x00000, 0x080000, CRC(f9cc95ae) SHA1(5f4805e6f45462baf3a8fc920ae8988b6d744f78) )
	ROM_LOAD16_BYTE( "95411180.lo", 0x00001, 0x080000, CRC(c4f794fb) SHA1(a32f4baa20c8d2d62f09a54e849ddf18ec59bedc) )
	ROM_LOAD16_BYTE( "95411181.hi", 0x00000, 0x080000, CRC(9cbc06a3) SHA1(0687b66effefa68655e5cd58aee58f43a90f33c4) )
	ROM_LOAD16_BYTE( "95411182.lo", 0x00001, 0x080000, CRC(3f83a950) SHA1(44f21c6a93d15bec6d146d387ea87672358d9d31) )
	ROM_LOAD16_BYTE( "95411183.hi", 0x00000, 0x080000, CRC(9f806240) SHA1(b0678feec7187089ba684e0f736e39491f89fea9) )
	ROM_LOAD16_BYTE( "95411804.lo", 0x00001, 0x080000, CRC(cd30c648) SHA1(1d3467f96947e62547ad90a762c82887c96b1e20) )
	ROM_LOAD16_BYTE( "95411805.hi", 0x00000, 0x080000, CRC(fba51709) SHA1(69aad603b0bd97cfa0845743570be943f4e9d493) )
	ROM_LOAD16_BYTE( "95411806.lo", 0x00001, 0x080000, CRC(dd2fa51a) SHA1(81f549f4361f1ad49adc3f8823eab1d417fdce94) )
	ROM_LOAD16_BYTE( "95411807.hi", 0x00000, 0x080000, CRC(4a54b0b6) SHA1(26473624772a8d32b28fc23609daf1c1a5fe3ff7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "evolsnd.p1", 0x0000, 0x100000, CRC(13e18cc3) SHA1(114301af1abf86cdd9c2f01b316d257bb1ca086d) )
	ROM_LOAD( "evolsnd.p2", 0x0000, 0x08399a, CRC(345f3f11) SHA1(dd4d4f0f32650304cc6010b8f059c23dd5535919) )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211246.bin", 0x0000, 0x4d858a, CRC(edabdb3d) SHA1(cdda311e94cdb22432a4b37edb411717a391720e) )
ROM_END




ROM_START( sc_fguy )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426014.lo", 0x00001, 0x080000, CRC(409ed279) SHA1(173e285a8515e06239bb4755b007ab81878212f3) )
	ROM_LOAD16_BYTE( "95426015.hi", 0x00000, 0x080000, CRC(37ce818c) SHA1(91457fd347d76ce380dfd73c3ca5cc0dcba65907) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426016.lo", 0x00001, 0x080000, CRC(d1a13822) SHA1(9275ee0a1db886bffc7c4390bb3e7408b8e9cd93) )
	ROM_LOAD16_BYTE( "95426017.hi", 0x00000, 0x080000, CRC(0c4616e1) SHA1(f1b460aacbe1ae996f80419b6995e81580bf4876) )
	ROM_LOAD16_BYTE( "95426388.lo", 0x00001, 0x080000, CRC(6a769ec1) SHA1(42d8b4d31feae3070eaabc74d84ee731c8075a97) )
	ROM_LOAD16_BYTE( "95426389.hi", 0x00000, 0x080000, CRC(19b625c4) SHA1(609b6f63db423ac46f953bf8934137ea176a9147) )
	ROM_LOAD16_BYTE( "95426410.lo", 0x00001, 0x080000, CRC(25cfd853) SHA1(2328165ff0a7752dba37189740a462e9aba0ea2a) )
	ROM_LOAD16_BYTE( "95426411.hi", 0x00000, 0x080000, CRC(c5714aed) SHA1(ae29257ebcf1ddeadb41302b4a448142baa88ad2) )
	ROM_LOAD16_BYTE( "95427014.lo", 0x00001, 0x080000, CRC(6890caf2) SHA1(87998eb35701f9e9f4737db611a807a87ef3be2a) )
	ROM_LOAD16_BYTE( "95427015.hi", 0x00000, 0x080000, CRC(4b02d014) SHA1(e94ce848c979e60ab7718439bcf60a59103cc01a) )
	ROM_LOAD16_BYTE( "95427016.lo", 0x00001, 0x080000, CRC(6587831c) SHA1(34c1a7498ae82f54fdd68350c86077e6c5232c03) )
	ROM_LOAD16_BYTE( "95427017.hi", 0x00000, 0x080000, CRC(47a8cd87) SHA1(baad39e3fab06d61da9dd725e176c920a5f0657f) )
	ROM_LOAD16_BYTE( "95427388.lo", 0x00001, 0x080000, CRC(e1776d0a) SHA1(efb4af41c8c795d6e14cf7b0a6cac51021dd9dfd) )
	ROM_LOAD16_BYTE( "95427389.hi", 0x00000, 0x080000, CRC(c838eeee) SHA1(718776e5086b00278f70452a0141e07cbbdae3d4) )
	ROM_LOAD16_BYTE( "95427410.lo", 0x00001, 0x080000, CRC(af8d7e22) SHA1(22100e1e3588880f9de1bd92348221aae6e3fdc9) )
	ROM_LOAD16_BYTE( "95427411.hi", 0x00000, 0x080000, CRC(0c41bf21) SHA1(a704ed754b7bc62fa3bb75ebc789fe7990e206ec) )
	ROM_LOAD16_BYTE( "p3213p11.hi", 0x00000, 0x080000, CRC(d7776670) SHA1(13002e513bd6c17a5755ac30b2b6a5a462ace5d9) )
	ROM_LOAD16_BYTE( "p3213p11.lo", 0x00001, 0x080000, CRC(c65fff31) SHA1(b2200b68673d6ef2427965484c23ac5cf2343986) )
	ROM_LOAD16_BYTE( "p3213s11.hi", 0x00000, 0x080000, CRC(1ab8b3c5) SHA1(c0d901ae3b3ea00073d731e3a10efba60ebbf020) )
	ROM_LOAD16_BYTE( "p3213s11.lo", 0x00001, 0x080000, CRC(314b0288) SHA1(6a24fce8aa9bcf67014ceae4b7a11be0de4ed7c4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008813.bin", 0x0000, 0x100000, CRC(e5548d68) SHA1(ac20af71cedd0c6d61d6a28afa8d700c1446e442) )
	ROM_LOAD( "95008814.bin", 0x0000, 0x100000, CRC(06f3165c) SHA1(936a8c1d31bca93a5b985e89c48a1faaef602ae0) )
	ROM_LOAD( "95009118.bin", 0x0000, 0x100000, CRC(f6ce47b9) SHA1(bb3917a3eed718e23dc37b1ffe93f2e349990d3c) )
	ROM_LOAD( "95009119.bin", 0x0000, 0x100000, CRC(9d96e3fd) SHA1(5d2d3939a2f1f765c2272f7747a0eea7d0cf1bf8) )
ROM_END




ROM_START( sc_fastf )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406520.lo", 0x00001, 0x080000, CRC(228c868f) SHA1(889ae1e5d417baff64020f20af3bddd1d5ef1478) )
	ROM_LOAD16_BYTE( "95406521.hi", 0x00000, 0x080000, CRC(b2cefd93) SHA1(8660cb32390202ef00f8ab2a0c8f81d6630030fa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407520.lo", 0x00001, 0x080000, CRC(26a0557b) SHA1(a93f8cdf102a56c2df56a5cac6571cd909f72da9) )
	ROM_LOAD16_BYTE( "95407521.hi", 0x00000, 0x080000, CRC(a8b832f1) SHA1(87fde3dc3983545addd2eaa3af9726aab2b3743f) )
	ROM_LOAD16_BYTE( "95408082.lo", 0x00001, 0x080000, CRC(c85c8c84) SHA1(5bfd32b96e6b05f314c0964e562929088eb8257b) )
	ROM_LOAD16_BYTE( "95408083.hi", 0x00000, 0x080000, CRC(73a1474e) SHA1(b4ea15cee9da90f8451e82a2e4a17f3b69ca630e) )
	ROM_LOAD16_BYTE( "95409082.lo", 0x00001, 0x080000, CRC(d3b7ef4b) SHA1(1ac796a9154fd643074efd33b7d630fb55b489f2) )
	ROM_LOAD16_BYTE( "95409083.hi", 0x00000, 0x080000, CRC(99f570da) SHA1(f13faf0bbff2e539ee0713acb50ed939d704a5da) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008272.bin", 0x0000, 0x0fafac, CRC(a9bdc1e2) SHA1(60ff02ff4906d8b0f6392cccb96976b912c61e2d) )
	ROM_REGION( 0x400000, "other", ROMREGION_ERASE00 )
	ROM_LOAD( "95408082", 0x0000, 0x100000, CRC(763c8d84) SHA1(c1fa038666179082b521eb0851874fb0f6bd916d) ) // combined hi-lo?
ROM_END






ROM_START( sc_ffru )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404050.lo", 0x00001, 0x080000, CRC(d036045d) SHA1(e3ccf3947094cc6ebb21dec2922c7b407f07ffca) )
	ROM_LOAD16_BYTE( "95404051.hi", 0x00000, 0x080000, CRC(0f58d8c5) SHA1(90d8296c422ba51da59825b63d6f5c96368aa136) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404980.odd", 0x00001, 0x080000, CRC(c3fee8e1) SHA1(22a9add77a301609f9b531919745f1ac5a9887ca) )
	ROM_LOAD16_BYTE( "95404981.evn", 0x00000, 0x080000, CRC(13988c83) SHA1(94b31887b331952c68b3091a94b82880fc91643f) )
	ROM_LOAD16_BYTE( "95405050.lo", 0x00001, 0x080000, CRC(eae778b6) SHA1(317c751a981d173f8426518e917749aebc4bba27) )
	ROM_LOAD16_BYTE( "95405051.hi", 0x00000, 0x080000, CRC(780f9bef) SHA1(7edd383137a5dbf2eb69eced075c3e1610784487) )
	ROM_LOAD16_BYTE( "95405980.odd", 0x00001, 0x080000, CRC(7b608cfe) SHA1(17e2e5f4cbbc561090207e0b5806ed398a7e3550) )
	ROM_LOAD16_BYTE( "95405981.evn", 0x00000, 0x080000, CRC(64509991) SHA1(9eccf9db8b7fc68971ce949c0de2d2e806936fbe) )
	ROM_LOAD16_BYTE( "95406106.odd", 0x00001, 0x080000, CRC(3ad26b02) SHA1(313df363bb5545fb23020fa943cbbc47d3717731) )
	ROM_LOAD16_BYTE( "95406107.evn", 0x00000, 0x080000, CRC(62b76432) SHA1(322fffd89bcbb87fe2e9cbe195269ab371fae0e6) )
	ROM_LOAD16_BYTE( "95407106.odd", 0x00001, 0x080000, CRC(5c89918a) SHA1(6caf663d4263ab504a6374bebadb9c9e7c54a959) )
	ROM_LOAD16_BYTE( "95407107.evn", 0x00000, 0x080000, CRC(873a3acf) SHA1(bd71c8cbfe2311eb90281b35ea0644cb611c07e8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "ff_snd.bin", 0x0000, 0x0e54bf, CRC(9d1b711d) SHA1(29386915460b8be92fc5f79177efaf05b7f613cd) )
	ROM_LOAD( "ff_snd1.bin", 0x0000, 0x080000, CRC(3f0cb386) SHA1(a400177b1e3b986ba5ddfa5f549180b006ced5a2) )
	ROM_LOAD( "ff_snd2.bin", 0x0000, 0x080000, CRC(88d7cc1a) SHA1(7cb45ccc41f0c4a842595598f6f30b78e6c42480) )
ROM_END




ROM_START( sc_fbspn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418098.lo", 0x00001, 0x080000, CRC(525427ef) SHA1(839b52b81d53aa4d0607e274bd575ed2887a0f92) )
	ROM_LOAD16_BYTE( "95418099.hi", 0x00000, 0x080000, CRC(746a44c1) SHA1(5d70aeea4e430ae5d063c7c85b634a8009a67ac1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418100.lo", 0x00001, 0x080000, CRC(dd69a98d) SHA1(399a8fa0ff3b533bbd03e3e5cfd0779dcd476c94) )
	ROM_LOAD16_BYTE( "95418101.hi", 0x00000, 0x080000, CRC(98f20476) SHA1(8267752f6d5bae080c20ab61a326f16eba8a1084) )
	ROM_LOAD16_BYTE( "95419098.lo", 0x00001, 0x080000, CRC(9edb2064) SHA1(5ee2ba64c99acc92e6d6748451de6def478e38ea) )
	ROM_LOAD16_BYTE( "95419099.hi", 0x00000, 0x080000, CRC(1fdc7007) SHA1(998fd6c328387e13bbf15852f588687f3313c428) )
	ROM_LOAD16_BYTE( "95419100.lo", 0x00001, 0x080000, CRC(6b0ff803) SHA1(a90aadf711dcdd16d3550039a447f0d2b5f3a8c3) )
	ROM_LOAD16_BYTE( "95419101.hi", 0x00000, 0x080000, CRC(114938bd) SHA1(e4d7ac26d3dcec7fa28e6e7d8934c9a7e0f2ee0a) )
	ROM_LOAD16_BYTE( "95422200.lo", 0x00001, 0x080000, CRC(1fe607e8) SHA1(0142f4c0d0deee37453158208aed4c3cb0cccc36) )
	ROM_LOAD16_BYTE( "95422201.hi", 0x00000, 0x080000, CRC(0f155036) SHA1(7f294f1ba28d3eeca6898d3cd83692b8cca2bc3c) )
	ROM_LOAD16_BYTE( "95423200.lo", 0x00001, 0x080000, CRC(8a0eb98c) SHA1(fadd69f1af668307f7728e92e282acd3ae8859a5) )
	ROM_LOAD16_BYTE( "95423201.hi", 0x00000, 0x080000, CRC(379e95d8) SHA1(3c677a80b17617c4f1eb8f5ae683b807f16c039d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008526.bin", 0x0000, 0x100000, CRC(81890751) SHA1(1e9cedc07c9028eb65620371d9fcf73ae84ad274) )
ROM_END




ROM_START( sc_fever )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404004.lo", 0x00001, 0x080000, CRC(0e523716) SHA1(5ed17450e06af9dfb22950e520819a9b80be4cdb) )
	ROM_LOAD16_BYTE( "95404005.hi", 0x00000, 0x080000, CRC(9662b52b) SHA1(6db549f79a9f2ce036649ae24407f29e8f35d89b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404088.lo", 0x00001, 0x080000, CRC(5f42bc75) SHA1(85243a31f8970372eae24878fdd06fd1ceed45a6) )
	ROM_LOAD16_BYTE( "95404089.hi", 0x00000, 0x080000, CRC(9a93aaa6) SHA1(2a822a32cc475539b4e664d3dfcea8b8302247d9) )
	ROM_LOAD16_BYTE( "95404122.lo", 0x00001, 0x080000, CRC(c7f52065) SHA1(18212106c516c605e25bf48680f1d33d33df2366) )
	ROM_LOAD16_BYTE( "95404123.hi", 0x00000, 0x080000, CRC(f232ec9b) SHA1(08c87d4c15fa9f75d3aef3b6e10bbca926be7724) )
	ROM_LOAD16_BYTE( "95404124.lo", 0x00001, 0x080000, CRC(a401074a) SHA1(6b20007c06111508092dcd93e42bc26d857a2a6d) )
	ROM_LOAD16_BYTE( "95404125.hi", 0x00000, 0x080000, CRC(3b8014d0) SHA1(5cf28bbf1ff11228db89d2b9cefb278c4700fbbd) )
	ROM_LOAD16_BYTE( "95405004.lo", 0x00001, 0x080000, CRC(ef33ebb8) SHA1(d4790118780a8bdba46ed8b23915408e15526132) )
	ROM_LOAD16_BYTE( "95405005.hi", 0x00000, 0x080000, CRC(ec91c788) SHA1(a6794c08efb91dcc97274992e809955b249cbdc1) )
	ROM_LOAD16_BYTE( "95405088.lo", 0x00001, 0x080000, CRC(1af6ed10) SHA1(021f2eda22c0f4bae8f37f8d8a2767057c9a959c) )
	ROM_LOAD16_BYTE( "95405089.hi", 0x00000, 0x080000, CRC(337d40dc) SHA1(3bf4773a8497b8af9ed4f477b8adb72ade968c6f) )
	ROM_LOAD16_BYTE( "95405122.lo", 0x00001, 0x080000, CRC(ba3e100d) SHA1(8f92bfb78a873a65b254588ef0e82181199f7aba) )
	ROM_LOAD16_BYTE( "95405123.hi", 0x00000, 0x080000, CRC(d682219d) SHA1(0be17d37fc382ec365beb5eb400cf6b21584b3d1) )
	ROM_LOAD16_BYTE( "95405124.lo", 0x00001, 0x080000, CRC(e3578368) SHA1(1e7b97059c7dcbcc8110e0e7af398c54d9fe9d33) )
	ROM_LOAD16_BYTE( "95405125.hi", 0x00000, 0x080000, CRC(f1078e7b) SHA1(7c212518ca3a40ecf9247376dfd5dfa3539d9971) )
	ROM_LOAD16_BYTE( "95406012.lo", 0x00001, 0x080000, CRC(d3e3e350) SHA1(46cb90aec65f6676f143b5647a953fa4c6f3aced) )
	ROM_LOAD16_BYTE( "95406013.hi", 0x00000, 0x080000, CRC(3d98bede) SHA1(52640e1d06d606a2a2c8940a83ad0e9b9bffa347) )
	ROM_LOAD16_BYTE( "95406360.lo", 0x00001, 0x080000, CRC(b0ab3f6b) SHA1(48bb1faba0917d16558221f4c0d1cd6a3fa72767) )
	ROM_LOAD16_BYTE( "95406361.hi", 0x00000, 0x080000, CRC(88874cc3) SHA1(8afe9b666eac553380f9bb80459491a7b4811793) )
	ROM_LOAD16_BYTE( "95406782.lo", 0x00001, 0x080000, CRC(7346b7d3) SHA1(24ff011729419b454430d7c4f92c4618338d7ec0) )
	ROM_LOAD16_BYTE( "95406783.hi", 0x00000, 0x080000, CRC(fe3d7b7c) SHA1(7618444990a85d227850009393e130d128fe035f) )
	ROM_LOAD16_BYTE( "95407012.lo", 0x00001, 0x080000, CRC(d6c56e82) SHA1(9e3fa0cfc7c9541b9637110677fa0b2f0911e450) )
	ROM_LOAD16_BYTE( "95407013.hi", 0x00000, 0x080000, CRC(4bf15184) SHA1(e01acf9551209161692d204723debb85d0822f10) )
	ROM_LOAD16_BYTE( "95408920.lo", 0x00001, 0x080000, CRC(e29cf521) SHA1(c0b2211030caf5ff37bb6ffb813a0dfd7b72963d) )
	ROM_LOAD16_BYTE( "95408921.hi", 0x00000, 0x080000, CRC(db3025ee) SHA1(e21f56adee4eda6a77618e82f6b029955e939741) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004239.sn1", 0x0000, 0x080000, CRC(12c4d8eb) SHA1(a404bce7eb1a1148cba4a4d8326ea36e31e881b4) )
	ROM_LOAD( "95004240.sn2", 0x0000, 0x080000, CRC(a990a2c4) SHA1(2630dc0408359f32d05ecfd5bcc81789854e5229) )
	ROM_LOAD( "95008137.bin", 0x0000, 0x100000, CRC(f74f3916) SHA1(659b160db41e46a53149688f8677e73a78f22e63) )
	ROM_LOAD( "95008138.bin", 0x0000, 0x100000, CRC(68563cdd) SHA1(df92dadecf9242bfa147e3134039266e9016faea) )
ROM_END




ROM_START( sc_fpitc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402956.lo", 0x00001, 0x080000, CRC(b2b602bd) SHA1(70c6959bb5c6d3e61fdd9954808e83141cc8a4f4) )
	ROM_LOAD16_BYTE( "95402957.hi", 0x00000, 0x080000, CRC(2e598dab) SHA1(806d738b2b8a201671ecfb45e112d2342025ee64) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402958.lo", 0x00001, 0x080000, CRC(0fdcf790) SHA1(c71e273ee8ae9f11ed9df037aa8f250ca014b949) )
	ROM_LOAD16_BYTE( "95402959.hi", 0x00000, 0x080000, CRC(c53a6bbb) SHA1(16149a78302bf67b9c53d5497fd4e85dfc244d66) )
	ROM_LOAD16_BYTE( "95402960.lo", 0x00001, 0x080000, CRC(bf04a142) SHA1(ec0611a975799f7f0c442f805e8157daad0c338e) )
	ROM_LOAD16_BYTE( "95402961.hi", 0x00000, 0x080000, CRC(8b9c46f1) SHA1(410122c661ff83f960c0e0024ad89d06268aa101) )
	ROM_LOAD16_BYTE( "95402962.lo", 0x00001, 0x080000, CRC(244ce405) SHA1(ca2fdaa8eb4b40eb84e77317487ffa7eff419051) )
	ROM_LOAD16_BYTE( "95402963.hi", 0x00000, 0x080000, CRC(cb2b0e33) SHA1(65a704ab0b2e4ddc8bbefbf53a0e4ec7b10cb05e) )
	ROM_LOAD16_BYTE( "95403956.lo", 0x00001, 0x080000, CRC(131b5532) SHA1(7ca7179f4226e155090143739b58bdce2bbcccfd) )
	ROM_LOAD16_BYTE( "95403957.hi", 0x00000, 0x080000, CRC(a67d44fe) SHA1(5f8a0156de995006680d55cfd164bec9294d4d20) )
	ROM_LOAD16_BYTE( "95403958.lo", 0x00001, 0x080000, CRC(c0d150c2) SHA1(a899e69437776722001055b90816fc2f1f585a60) )
	ROM_LOAD16_BYTE( "95403959.hi", 0x00000, 0x080000, CRC(abfdfe42) SHA1(3ca007a9f61acf79c987a870c736fb9c4bbc19d7) )
	ROM_LOAD16_BYTE( "95403960.lo", 0x00001, 0x080000, CRC(895da1a6) SHA1(3cfbd9a0fbf15c48e5da949efa3137b20100987d) )
	ROM_LOAD16_BYTE( "95403961.hi", 0x00000, 0x080000, CRC(ab6979e5) SHA1(620164ad61ed5760b96e55fdac1f01aacae4d3c9) )
	ROM_LOAD16_BYTE( "95403962.lo", 0x00001, 0x080000, CRC(c4a4c20c) SHA1(d2d47b9a2d77c95f58a5be63be96208f45207fc6) )
	ROM_LOAD16_BYTE( "95403963.hi", 0x00000, 0x080000, CRC(30ce6ed8) SHA1(2a938114a8f7fdc7f1265a345316d954b12d1260) )
	ROM_LOAD16_BYTE( "95406002.lo", 0x00001, 0x080000, CRC(4e242877) SHA1(08639639d2f7fb671d66a1e9848726890318ba6d) )
	ROM_LOAD16_BYTE( "95406003.hi", 0x00000, 0x080000, CRC(3577d50e) SHA1(86e622176386c19a39c0cefec19984a0b96b682b) )
	ROM_LOAD16_BYTE( "95406064.lo", 0x00001, 0x080000, CRC(980b69ec) SHA1(3b5acb46fdf03c6ce30df5f3e8e12557020f917b) )
	ROM_LOAD16_BYTE( "95406065.hi", 0x00000, 0x080000, CRC(62db32ae) SHA1(001022d7e544b1e9966b361e88be7078936d43a6) )
	ROM_LOAD16_BYTE( "95407002.lo", 0x00001, 0x080000, CRC(d54a79ad) SHA1(d76fc8a846ea38fff2d774a8dcfb2661750349f2) )
	ROM_LOAD16_BYTE( "95407003.hi", 0x00000, 0x080000, CRC(0edc749b) SHA1(0da9e663f74596529a0eaa9c695bf720fc90137d) )
	ROM_LOAD16_BYTE( "95407064.lo", 0x00001, 0x080000, CRC(989d7797) SHA1(3834d69d57a7e41a36791df63a07e7103e8436d8) )
	ROM_LOAD16_BYTE( "95407065.hi", 0x00000, 0x080000, CRC(b324a4af) SHA1(0bba58991e134ee49102052b22446e8706335233) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008091.bin", 0x0000, 0x100000, CRC(81a28437) SHA1(99b9e5c04c2ab7e9aba0b9b8a0bacee424a079de) )
	ROM_LOAD( "95008092.bin", 0x0000, 0x100000, CRC(0987737f) SHA1(bab6bf1ffd3df5465c87996795b1c25f5e863beb) )
ROM_END




ROM_START( sc_fevnx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406864.lo", 0x00001, 0x080000, CRC(9f7846ac) SHA1(d2e5b218f395974545f5c723259153af0d1b8bf4) )
	ROM_LOAD16_BYTE( "95406865.hi", 0x00000, 0x080000, CRC(f54c556d) SHA1(dce5c622be6324080877dfb09bcb60533caba07b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406990.lo", 0x00001, 0x080000, CRC(3880104f) SHA1(1c9b7dd1712f524b4dfa9d83cae59699c7c6b3e6) )
	ROM_LOAD16_BYTE( "95406991.hi", 0x00000, 0x080000, CRC(ea59f14b) SHA1(51e36d5ede267872e4dbb59236804034243bba63) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004318.sn1", 0x0000, 0x080000, CRC(bb5d74bd) SHA1(104dd8b2faedce3382533c755ca05d03ec2bc50a) )
	ROM_LOAD( "95004319.sn2", 0x0000, 0x080000, CRC(73dc297e) SHA1(a826e7d0b88b9e01ceab21a2a92f69f15b402acb) )
ROM_END




ROM_START( sc_film )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "pr6973p21.hi", 0x00000, 0x080000, CRC(70722d50) SHA1(79cb6544ff7f7813cb1c2d64cf4fadcf9b091708) )
	ROM_LOAD16_BYTE( "pr6973p21.lo", 0x00001, 0x080000, CRC(9ecc1838) SHA1(1aea40281a174a39866aef668e78b031e4337be1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "pr6973s21.hi", 0x00000, 0x080000, CRC(e9ff42c0) SHA1(9227868e031b26ecc20416e51cd02b417f449819) )
	ROM_LOAD16_BYTE( "pr6973s21.lo", 0x00001, 0x080000, CRC(2a2e974f) SHA1(ec6cf9e79c651f84f6371a27e7814da0e6b6650d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_fcc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95004103.lo", 0x00001, 0x080000, CRC(9926f103) SHA1(f29a0d25eebd0a0990cd165116b425b795ed62e0) )
	ROM_LOAD16_BYTE( "95004104.hi", 0x00000, 0x080000, CRC(bec75a23) SHA1(cdf895081ebf3afb52d5bfaab29f713800c85fc9) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400775.lo", 0x00001, 0x080000, CRC(b543a3ad) SHA1(42f1c69adcbf7acc48dad98085f3f9e3a69f3342) )
	ROM_LOAD16_BYTE( "95400776.hi", 0x00000, 0x080000, CRC(0bbab14f) SHA1(97e5d7d0f57c81232a06f89b486b2833f0ec8640) )
	ROM_LOAD16_BYTE( "club-firecracker_dat_ac_67pss.hi", 0x00000, 0x080000, CRC(f62d7c6b) SHA1(a8e680074880f33313fe4ad6805d70910a4d8a48) )
	ROM_LOAD16_BYTE( "club-firecracker_dat_ac_67pss.lo", 0x00001, 0x080000, CRC(cd7ccd11) SHA1(47f7b89a2b27966de21eb08845108e7da2542227) )
	ROM_LOAD16_BYTE( "club-firecracker_dat_ac_varss.hi", 0x00000, 0x080000, CRC(5e736802) SHA1(6cd0800ab8a96f057080c857c8ae696da71f58bd) )
	ROM_LOAD16_BYTE( "club-firecracker_dat_ac_varss.lo", 0x00001, 0x080000, CRC(479efeef) SHA1(9115b184c14cc1fb1cdda0db0f6d39b396d424c9) )
	ROM_LOAD16_BYTE( "club-firecracker_std_ac_67pss.hi", 0x00000, 0x080000, CRC(6b2e08d5) SHA1(11a870bae9881df116727c942e724320557fac83) )
	ROM_LOAD16_BYTE( "club-firecracker_std_ac_67pss.lo", 0x00001, 0x080000, CRC(09315677) SHA1(bd9421275331707e1ad24d7d248b8dddb1bf75ee) )
	ROM_LOAD16_BYTE( "club-firecracker_std_ac_varss.hi", 0x00000, 0x080000, CRC(0bbab14f) SHA1(97e5d7d0f57c81232a06f89b486b2833f0ec8640) )
	ROM_LOAD16_BYTE( "club-firecracker_std_ac_varss.lo", 0x00001, 0x080000, CRC(b543a3ad) SHA1(42f1c69adcbf7acc48dad98085f3f9e3a69f3342) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "fcsound", 0x0000, 0x080000, CRC(bec75a23) SHA1(cdf895081ebf3afb52d5bfaab29f713800c85fc9) )
	ROM_REGION( 0x400000, "other", ROMREGION_ERASE00 )
	ROM_LOAD( "club-firecracker_mtx_ass.bin", 0x0000, 0x010000, CRC(c23ffee9) SHA1(b4f2542e8ed0b282a439e523baa6cd43c5b2cb50) ) // DMD?
ROM_END




ROM_START( sc_fire )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406968.lo", 0x00001, 0x080000, CRC(4fc1f8f3) SHA1(001ca9f18fb11af66a8dc9e11d59981165db5fd1) )
	ROM_LOAD16_BYTE( "95406969.hi", 0x00000, 0x080000, CRC(2a676181) SHA1(aec4c37116f46d16096a297cc7001245f1aa5ec7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407968.lo", 0x00001, 0x080000, CRC(274bb010) SHA1(44c20ddf693f48db871d99cfab1b41b5490bb28b) )
	ROM_LOAD16_BYTE( "95407969.hi", 0x00000, 0x080000, CRC(2af837b9) SHA1(35de190685946709517ac00f61a9138d9ced4561) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008307.bin", 0x0000, 0x100000, CRC(e1b9b37c) SHA1(96bc9cb530f94b77c3243b2d9d743aeed209d64d) )
ROM_END




ROM_START( sc_fwp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402988.lo", 0x00001, 0x080000, CRC(c71b9b6b) SHA1(9eb529cf0355e48f32b8ba7f544b27c2bda77af4) )
	ROM_LOAD16_BYTE( "95402989.hi", 0x00000, 0x080000, CRC(b372b601) SHA1(ca251f96781254d1887eb0bbe1b12726b8eff1e0) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403986.lo", 0x00001, 0x080000, CRC(5feed224) SHA1(d8c2c70c4d12b3c4a177d8ef32a4b19c9b056872) )
	ROM_LOAD16_BYTE( "95403987.hi", 0x00000, 0x080000, CRC(c5d72a23) SHA1(986bec61f5d3191419a652b2ca0e2e671f2ef81d) )
	ROM_LOAD16_BYTE( "95410344.lo", 0x00001, 0x080000, CRC(99f6aa75) SHA1(867defde4560d6676e3dbc124315be97fc6935c7) )
	ROM_LOAD16_BYTE( "95410345.hi", 0x00000, 0x080000, CRC(5c65c5b0) SHA1(f491fb87ba7eaa8d9d4acc31b1a561ed013c01ec) )
	ROM_LOAD16_BYTE( "95411344.lo", 0x00001, 0x080000, CRC(55442a51) SHA1(022f27999dfedf779d8546541ccbb9cd1da03f0c) )
	ROM_LOAD16_BYTE( "95411345.hi", 0x00000, 0x080000, CRC(f911b233) SHA1(87a9039cff2247888faa83754529e4f8382a520d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "5wayssnd.bin", 0x0000, 0x0f0833, CRC(0f165ccb) SHA1(709c91845cbe6b17c888e143eb121d649a221418) )
ROM_END




ROM_START( sc_fwpcs )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402830.lo", 0x00001, 0x080000, CRC(60667ba0) SHA1(d16f064a0f6c746349695582ad3d1611806ff0ef) )
	ROM_LOAD16_BYTE( "95402831.hi", 0x00000, 0x080000, CRC(eaa38666) SHA1(8a0f8ab18cd97b01c9244a19a22a2cc44584ca52) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402832.lo", 0x00001, 0x080000, CRC(882a61fa) SHA1(d8284d5a9d0fc553fa09c9765e564d49d8e8c86c) )
	ROM_LOAD16_BYTE( "95402833.hi", 0x00000, 0x080000, CRC(17fd9dde) SHA1(d55c1b2bc810410ad74c7d3c74587be5ae581738) )
	ROM_LOAD16_BYTE( "95402986.lo", 0x00001, 0x080000, CRC(64b9fc1c) SHA1(72e8b16bb8b16f10a669917a4cef029cb5447225) )
	ROM_LOAD16_BYTE( "95402987.hi", 0x00000, 0x080000, CRC(dc7d47e9) SHA1(f393c791857301192fab520b7e4e5775ed15c71e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_fbcrz )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400385.lo", 0x00001, 0x080000, CRC(853d5017) SHA1(37f3cf0aadaee24a82d5cb8b6e1f18d7f4481642) )
	ROM_LOAD16_BYTE( "95400386.hi", 0x00000, 0x080000, CRC(ca1e4ae6) SHA1(67ea3066434f2766c0f16d612767ae694ed7680e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400387.lo", 0x00001, 0x080000, CRC(f24b4dcc) SHA1(9d48bcd22c231cf99dd6874be99a8affe287db9e) )
	ROM_LOAD16_BYTE( "95400388.hi", 0x00000, 0x080000, CRC(ef90f929) SHA1(44b65090438ff5df06e152c9c2b2778ad58db318) )
	ROM_LOAD16_BYTE( "95400533.lo", 0x00001, 0x080000, CRC(0129ebce) SHA1(9ca5f4d6abf639a9b54ea488d5dfa4f8e079a65e) )
	ROM_LOAD16_BYTE( "95400534.hi", 0x00000, 0x080000, CRC(d2a18245) SHA1(0a574df85255ec4ea8c1e2c884cd3617e5663e33) )
	ROM_LOAD16_BYTE( "95400747.lo", 0x00001, 0x080000, CRC(c2a2dede) SHA1(709ddc5e2a2da011f07a4d93195a03b2fe9bb191) )
	ROM_LOAD16_BYTE( "95400748.hi", 0x00000, 0x080000, CRC(571f1f23) SHA1(35039811aaa40e47984c576fdc447480ec41a96a) )
	ROM_LOAD16_BYTE( "95400749.lo", 0x00001, 0x080000, CRC(8709908c) SHA1(d740a66701974351a33dc8bc399bef78a17c1c70) )
	ROM_LOAD16_BYTE( "95400750.hi", 0x00000, 0x080000, CRC(16ac7ea9) SHA1(2e45f74eaf2e00f5a8550197998779cea0596eb7) )
	ROM_LOAD16_BYTE( "95401385.lo", 0x00001, 0x080000, CRC(25d68337) SHA1(abe7d0c7b9301253ae75c3c61834d551121170fd) )
	ROM_LOAD16_BYTE( "95401386.hi", 0x00000, 0x080000, CRC(9daacb4b) SHA1(4c8bcc331069007a92ace7cac58a26a2533e076e) )
	ROM_LOAD16_BYTE( "95401387.lo", 0x00001, 0x080000, CRC(faebf38d) SHA1(e92f825265e534fd79011c3ac445524c5a46ee55) )
	ROM_LOAD16_BYTE( "95401388.hi", 0x00000, 0x080000, CRC(96bf2922) SHA1(c2ee3b4f20b6ae7c25b94ee5a24cdfd53ecb2811) )
	ROM_LOAD16_BYTE( "95401533.lo", 0x00001, 0x080000, CRC(4325328c) SHA1(1de2fe68680267447572c7aca8f5bbe96017d38b) )
	ROM_LOAD16_BYTE( "95401534.hi", 0x00000, 0x080000, CRC(16f1b24f) SHA1(94f18624c036a9b6a543daf80ad3c23c20cf1acc) )
	ROM_LOAD16_BYTE( "95401747.lo", 0x00001, 0x080000, CRC(af0890aa) SHA1(e35d0bc7db95fccd3bc1e08843c8600c9d3f085f) )
	ROM_LOAD16_BYTE( "95401748.hi", 0x00000, 0x080000, CRC(9d37bc08) SHA1(a58d2b05f568dc7e348c0dd9014ddd2df668e372) )
	ROM_LOAD16_BYTE( "95401749.lo", 0x00001, 0x080000, CRC(b33d055c) SHA1(b1048654c754f2cd25e94e2eb95529fe7d560566) )
	ROM_LOAD16_BYTE( "95401750.hi", 0x00000, 0x080000, CRC(8476637e) SHA1(2df9d3f9c48057dccd1dd28a5702684c530f3e6c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )

	ROM_REGION( 0x400000, "others", ROMREGION_ERASE00 )
	// DMD?
	ROM_LOAD( "95751937.hex", 0x0000, 0x025f91, CRC(8f412e97) SHA1(a5ff924fbc327114e59d75de644ed0d5cd7fa6b3) )
	ROM_LOAD( "95751937.bin", 0x0000, 0x010000, CRC(4a99ee11) SHA1(335398ebc64bbfe86e2652ac080a5943dd413928) )
ROM_END




ROM_START( sc_fd7th )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400123.lo", 0x00001, 0x080000, CRC(fff100ca) SHA1(6e6012c9e3d057791a8353995c347152c6e6a452) )
	ROM_LOAD16_BYTE( "95400124.hi", 0x00000, 0x080000, CRC(fa841b79) SHA1(cb1f0c35f2e73f557c57027d2370ed179afa77e2) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400239.lo", 0x00001, 0x080000, CRC(14692e18) SHA1(e608df4bb40667a168186d29ef8d99d371d3d570) )
	ROM_LOAD16_BYTE( "95400240.hi", 0x00000, 0x080000, CRC(fc290b75) SHA1(41d93251cd1c4a6bab26bfcbc59855b15ba4989d) )
	ROM_LOAD16_BYTE( "95400241.lo", 0x00001, 0x080000, CRC(b43e1871) SHA1(678299fdd6b5eb08ca044fdda7aa6538435b5c36) )
	ROM_LOAD16_BYTE( "95400242.hi", 0x00000, 0x080000, CRC(ca0cc6b3) SHA1(a8a43916887f9ae65b0f2510b3df1cbd4ae53800) )
	ROM_LOAD16_BYTE( "95400475.lo", 0x00001, 0x080000, CRC(b911fdc7) SHA1(e8698af72b0ccf7b64b56a2b5fdbed1a42f9490c) )
	ROM_LOAD16_BYTE( "95400476.hi", 0x00000, 0x080000, CRC(d8330fc0) SHA1(a96de3319e260d240d4e71ceb2b195bc73264829) )
	ROM_LOAD16_BYTE( "95400477.lo", 0x00001, 0x080000, CRC(79508577) SHA1(63222e05eece6f30828179342a065fb093b28d9b) )
	ROM_LOAD16_BYTE( "95400478.hi", 0x00000, 0x080000, CRC(0d0cb0e8) SHA1(f482f79b4f128c22cd121c91b3e5740031bf2473) )
	ROM_LOAD16_BYTE( "95401123.lo", 0x00001, 0x080000, CRC(e7b11fd4) SHA1(9127e8b5ba39f6c4553c2b41c43310111d1c4aeb) )
	ROM_LOAD16_BYTE( "95401124.hi", 0x00000, 0x080000, CRC(4586a398) SHA1(ecbe605cb8b5e080f2dd667e09d044c1371b9369) )
	ROM_LOAD16_BYTE( "95401239.lo", 0x00001, 0x080000, CRC(606eec9c) SHA1(66c5d4f39d4f7f660ac8d52e7821c2c78ee69b3e) )
	ROM_LOAD16_BYTE( "95401240.hi", 0x00000, 0x080000, CRC(e4bdcacf) SHA1(4207ff3e8f1771d378343d1b03770289c42038d6) )
	ROM_LOAD16_BYTE( "95401241.lo", 0x00001, 0x080000, CRC(f8d18ff0) SHA1(95bed4d487473c67f52753356921c06a36d9e8a2) )
	ROM_LOAD16_BYTE( "95401242.hi", 0x00000, 0x080000, CRC(544c469d) SHA1(dbf87656d1f43986c45a6119c38894fd25af8768) )
	ROM_LOAD16_BYTE( "95401475.lo", 0x00001, 0x080000, CRC(df44e314) SHA1(0adcdc6014d1b0a69d53977ce02688a86c13b316) )
	ROM_LOAD16_BYTE( "95401476.hi", 0x00000, 0x080000, CRC(509fdd75) SHA1(a038ab9463d2b5a1e7abad9d501c1503de724682) )
	ROM_LOAD16_BYTE( "95401477.lo", 0x00001, 0x080000, CRC(c3c16a14) SHA1(e98b7d36fe498851fbb2a0cc5491014c4168c5ae) )
	ROM_LOAD16_BYTE( "95401478.hi", 0x00000, 0x080000, CRC(0cad4aa0) SHA1(da501db50c30e359d295349725b6a6965e3dab3b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "frankie snd1.bin", 0x0000, 0x080000, CRC(5d74001e) SHA1(f157706c0970af9b396c2973774c828ed1c0d275) )
	ROM_LOAD( "frankie snd2.bin", 0x0000, 0x080000, CRC(8863c8e6) SHA1(0e852155cb2d50d8f0b892c055b37e9955fd8da4) )
ROM_END




ROM_START( sc_frboo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400997.lo", 0x00001, 0x080000, CRC(5874bfd8) SHA1(0e965980d3aaeba99a2af6e1d6a192e9ab792d49) )
	ROM_LOAD16_BYTE( "95400998.hi", 0x00000, 0x080000, CRC(a5a68143) SHA1(be8e19df24b216999b272b42c3926faba2a0704c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95401997.lo", 0x00001, 0x080000, CRC(9753385c) SHA1(315592bcdb295953639bcd4024f655fa838a6a43) )
	ROM_LOAD16_BYTE( "95401998.hi", 0x00000, 0x080000, CRC(b1a8dd00) SHA1(574325504370138a00427cbc2e89b915586a9e66) )
	ROM_LOAD16_BYTE( "95402007.lo", 0x00001, 0x080000, CRC(78c9db57) SHA1(036eaa3e45f806d23b705221b17ee1d3c52bb489) )
	ROM_LOAD16_BYTE( "95402008.hi", 0x00000, 0x080000, CRC(762f00bc) SHA1(96b43f2ef8dbd8f615c5a05a8af52dc40605c2c2) )
	ROM_LOAD16_BYTE( "95403007.lo", 0x00001, 0x080000, CRC(95a9bd51) SHA1(d7939e9f780d06aadeee9e7f5cff1d1fb11c8f9f) )
	ROM_LOAD16_BYTE( "95403008.hi", 0x00000, 0x080000, CRC(c528739c) SHA1(8446e01e7747fca2b85744cf50c6a6fe1939ef7c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END





ROM_START( sc_frenz )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404436.lo", 0x00001, 0x080000, CRC(6b428b51) SHA1(8460f3156cc2e69d3d05377e33caea7eb66aeb56) )
	ROM_LOAD16_BYTE( "95404437.hi", 0x00000, 0x080000, CRC(4ead56c3) SHA1(4ca9799fd3b01224205624085fe36a05a171f9a5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404438.lo", 0x00001, 0x080000, CRC(65c9050c) SHA1(818f60883d7b9563d67eae8041b9fa2ab63a3720) )
	ROM_LOAD16_BYTE( "95404439.hi", 0x00000, 0x080000, CRC(7c113dfa) SHA1(854ec8b001b8b093fac972c782f19afe6235c241) )
	ROM_LOAD16_BYTE( "95405436.lo", 0x00001, 0x080000, CRC(0b3a4357) SHA1(2213cab13f013d8f48dae4e8a8c03f19d35a478e) )
	ROM_LOAD16_BYTE( "95405437.hi", 0x00000, 0x080000, CRC(b3b4c984) SHA1(1c7a48b49de06f9ca0935593c2eaf9c03bd1735d) )
	ROM_LOAD16_BYTE( "95405438.lo", 0x00001, 0x080000, CRC(991343fc) SHA1(e4e2b9fad42c22179d22e3b4efefc1422b117320) )
	ROM_LOAD16_BYTE( "95405439.hi", 0x00000, 0x080000, CRC(ce28e2aa) SHA1(8b4fbcfb96e6caf0edabd6ba80d0ea0e63e275a4) )
	ROM_LOAD16_BYTE( "95406028.lo", 0x00001, 0x080000, CRC(d63540f9) SHA1(48ab12f30b7fbdb539d35f6ffc54da0f7152e699) )
	ROM_LOAD16_BYTE( "95406029.hi", 0x00000, 0x080000, CRC(63e3f490) SHA1(46923775fc67bbf760307ebeb185c15a473e3252) )
	ROM_LOAD16_BYTE( "95407028.lo", 0x00001, 0x080000, CRC(f9f08c54) SHA1(04a55755f1c0966f799ca6b6f77198600af69eb6) )
	ROM_LOAD16_BYTE( "95407029.hi", 0x00000, 0x080000, CRC(63e3f490) SHA1(46923775fc67bbf760307ebeb185c15a473e3252) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008052.bin", 0x0000, 0x100000, CRC(36b422b2) SHA1(1ee085393922b46588a604c5e88ad454357711bb) )
ROM_END




ROM_START( sc_ftopi )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404704.odd", 0x00001, 0x080000, CRC(a838f0cc) SHA1(c67d700baaac6b64cc0e241cfa87d4a38f87d7c7) )
	ROM_LOAD16_BYTE( "95404705.evn", 0x00000, 0x080000, CRC(d025d84e) SHA1(66d8a523a573161cf419deefd02fa7f1ca59339d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405704.odd", 0x00001, 0x080000, CRC(30f083a5) SHA1(340ee2e605ddd3aee972588c3c455095f710bdf8) )
	ROM_LOAD16_BYTE( "95405705.evn", 0x00000, 0x080000, CRC(17a94aec) SHA1(c9f4d1576f5439e6935bacb7f3ba6c590c56769c) )
	ROM_LOAD16_BYTE( "95406646.odd", 0x00001, 0x080000, CRC(a65da5cf) SHA1(2d75a1aa00a88bead5a1af06d5aa981ae00d29a7) )
	ROM_LOAD16_BYTE( "95406647.evn", 0x00000, 0x080000, CRC(4115232f) SHA1(5af4065b9aa45ab55f2d37864ee24929a6e41275) )
	ROM_LOAD16_BYTE( "95407646.odd", 0x00001, 0x080000, CRC(c45ddb69) SHA1(444eb64b410d2c9aa9d0fced90c79796d22fbe2f) )
	ROM_LOAD16_BYTE( "95407647.evn", 0x00000, 0x080000, CRC(79622012) SHA1(2a6896998279e0fd0b81ba99167cf05b9f8c6b3f) )
	ROM_LOAD16_BYTE( "95408028.odd", 0x00001, 0x080000, CRC(ff994b16) SHA1(9754d6195b909ace734280a0abe2b77e9bd312eb) )
	ROM_LOAD16_BYTE( "95408029.evn", 0x00000, 0x080000, CRC(80f850f7) SHA1(cef3269c70f3a6eca8d6c64c75445fa0451e6cde) )
	ROM_LOAD16_BYTE( "95408306.odd", 0x00001, 0x080000, CRC(cdf9b2b2) SHA1(7c4cc9ddbf5aff242c2efbe733746c888d159d57) )
	ROM_LOAD16_BYTE( "95408307.evn", 0x00000, 0x080000, CRC(e3100ef0) SHA1(e976990e567bd3afdbb963289ac679d528d750af) )
	ROM_LOAD16_BYTE( "95408660.odd", 0x00001, 0x080000, CRC(04717087) SHA1(94e514e1ce9acdde71f25399ad416b03363a13be) )
	ROM_LOAD16_BYTE( "95408661.evn", 0x00000, 0x080000, CRC(0c58bf56) SHA1(5fb6d053dc37d29bee94c8ca093446b5f75e5e27) )
	ROM_LOAD16_BYTE( "95409028.odd", 0x00001, 0x080000, CRC(b3c7510a) SHA1(ce220b9f8352c48f6e69519e9506605ff49b5a0e) )
	ROM_LOAD16_BYTE( "95409029.evn", 0x00000, 0x080000, CRC(d895b833) SHA1(9e479407261c0278c47ac5eeb05a2c3320220c4a) )
	ROM_LOAD16_BYTE( "95409306.odd", 0x00001, 0x080000, CRC(244c8915) SHA1(d8093c9fa98cc0b5438c3344ecb74adfb1998fe5) )
	ROM_LOAD16_BYTE( "95409307.evn", 0x00000, 0x080000, CRC(da59a1bd) SHA1(6cc373416b575821d597b586d3f3abfdd2a7d546) )
	ROM_LOAD16_BYTE( "95409660.odd", 0x00001, 0x080000, CRC(0ef83ee4) SHA1(d8c81fa951dc2a58fbca8a5dc99ad513f2eed5b4) )
	ROM_LOAD16_BYTE( "95409661.evn", 0x00000, 0x080000, CRC(0381d63f) SHA1(3b1717aa4d87a7ded6b1e454ca27da6c520e94f8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "frtsnd.bin", 0x0000, 0x0a6326, CRC(f718f2f0) SHA1(eccedf4eda8eda34633b917165e063d2fbb03abf) )
ROM_END




ROM_START( sc_frsu )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402409.lo", 0x00001, 0x080000, CRC(f28d3873) SHA1(dc84f08e550e80ed94a3658737f3e844503f02f7) )
	ROM_LOAD16_BYTE( "95402410.hi", 0x00000, 0x080000, CRC(cabe32f9) SHA1(68ef4c7459f9ae92f3186f51817710abd1b0fdbd) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403409.lo", 0x00001, 0x080000, CRC(b82b6741) SHA1(f806b31b6dfed2ea6f64204c0edd19ba217ee001) )
	ROM_LOAD16_BYTE( "95403410.hi", 0x00000, 0x080000, CRC(9c341f24) SHA1(2c8a494234bab0af359fca8fa2ad2b53e33e5b20) )
	ROM_LOAD16_BYTE( "95406532.lo", 0x00001, 0x080000, CRC(f38776fb) SHA1(1ae7b7ce1977d4e4fb574fd6ed990f9803eb0465) )
	ROM_LOAD16_BYTE( "95406533.hi", 0x00000, 0x080000, CRC(7666fedf) SHA1(276937de5917edd46e73d7baccd6d9ed658cb276) )
	ROM_LOAD16_BYTE( "95407532.lo", 0x00001, 0x080000, CRC(a927b36f) SHA1(df3c04c3a7d9e709d45f517740cd1b955c160986) )
	ROM_LOAD16_BYTE( "95407533.hi", 0x00000, 0x080000, CRC(924a5a6a) SHA1(6ade1ea32a2ce9e55f8d23e78cd53ec03c8756b2) )
	ROM_LOAD16_BYTE( "95410052.lo", 0x00001, 0x080000, CRC(66690b85) SHA1(0e1ff97d138b1001dc439c7d30eaa65cd687fa9f) )
	ROM_LOAD16_BYTE( "95410053.hi", 0x00000, 0x080000, CRC(f4c9306a) SHA1(66cf87a6b1125823c8a8792d079955e25f9519c7) )
	ROM_LOAD16_BYTE( "95410056.lo", 0x00001, 0x080000, CRC(f8fc19f2) SHA1(416fb661c6c711a592310e85bedd12159b38e4c5) )
	ROM_LOAD16_BYTE( "95410057.hi", 0x00000, 0x080000, CRC(8ce4554b) SHA1(eea25e6e2b5a54414ed30103e729d22a5970a62d) )
	ROM_LOAD16_BYTE( "95411052.lo", 0x00001, 0x080000, CRC(f6775350) SHA1(3f1cb7c0a7fb9e7d1aea5502d9dc8ce4d25d8866) )
	ROM_LOAD16_BYTE( "95411053.hi", 0x00000, 0x080000, CRC(c78c23e1) SHA1(5a89a27d0eee0731b14d1fb84b87a03478d3b500) )
	ROM_LOAD16_BYTE( "95411056.lo", 0x00001, 0x080000, CRC(5e69e9e1) SHA1(06554561a2e6f8c89423c6c987965318edfb94ad) )
	ROM_LOAD16_BYTE( "95411057.hi", 0x00000, 0x080000, CRC(1578401e) SHA1(1d0ee4f9cacad2e0e54a0ce4b4b0fd6589a3de44) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004229.bin", 0x0000, 0x080000, CRC(fe94f724) SHA1(6cebd17d277f1fa88982158d5ac9422f6f16bc3b) )
	ROM_LOAD( "95004230.bin", 0x0000, 0x080000, CRC(4b0a6a18) SHA1(6df706b4431cc97318df612c9533c34085cd341d) )
ROM_END




ROM_START( sc_fmj )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420152.lo", 0x00001, 0x080000, CRC(9de7051b) SHA1(9969cd08aa9afeffd670910f3dbbf0f83e919db3) )
	ROM_LOAD16_BYTE( "95420153.hi", 0x00000, 0x080000, CRC(b26f0d81) SHA1(65e6e8a680374f263a07d886e695bcb5a413189e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420270.lo", 0x00001, 0x080000, CRC(4c2bd704) SHA1(edf227733a887025f64181410796666fbdbe6f7c) )
	ROM_LOAD16_BYTE( "95420271.hi", 0x00000, 0x080000, CRC(d131fedd) SHA1(d80cda766aab890b933b5573dacfa1e9ebfd44b6) )
	ROM_LOAD16_BYTE( "95420272.lo", 0x00001, 0x080000, CRC(477e538f) SHA1(db7ed34aa111162fe85090ca06a3d80db44b93af) )
	ROM_LOAD16_BYTE( "95420273.hi", 0x00000, 0x080000, CRC(94480a10) SHA1(6d16c74de9dd369814918a589b602651d8db6f5d) )
	ROM_LOAD16_BYTE( "95421152.lo", 0x00001, 0x080000, CRC(ddd9560c) SHA1(ba3dcd145aa94764c0e476c1eddc7f3d7ab2b119) )
	ROM_LOAD16_BYTE( "95421153.hi", 0x00000, 0x080000, CRC(4a21afe7) SHA1(2b50914dc66e04c4fedeefd2795c3668529ce2eb) )
	ROM_LOAD16_BYTE( "95421270.lo", 0x00001, 0x080000, CRC(c0357d4e) SHA1(a7a5090bb597c6558eacae4dbcd39243af1b2897) )
	ROM_LOAD16_BYTE( "95421271.hi", 0x00000, 0x080000, CRC(a3444399) SHA1(f5544f9e09ba70316735f5f6b7a9353e43846793) )
	ROM_LOAD16_BYTE( "95421272.lo", 0x00001, 0x080000, CRC(ed8b3914) SHA1(304e1592b09702771623a110be1ea12f5bba93d4) )
	ROM_LOAD16_BYTE( "95421273.hi", 0x00000, 0x080000, CRC(7ff83544) SHA1(1bc94725775bbd04792137bf79d02a84f2ba444b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008982.bin", 0x0000, 0x0fe74c, CRC(c5ce4a41) SHA1(abbecddba4dd4691240df112138fa95f1e125a85) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890477.bin", 0x0000, 0x5000, CRC(a7dd60c5) SHA1(dfa3a89939cec2225d975984caf4703d83708b85) )
	ROM_LOAD( "95890478.bin", 0x0000, 0x5000, CRC(d24b24f1) SHA1(0c3a9c9579bb1066ea3e82e58b65d3bcac7fe900) )
	ROM_LOAD( "95890479.bin", 0x0000, 0x5000, CRC(4cf1e8ad) SHA1(924b454aa9c7340374b98201fbbaf922b836d779) )
ROM_END




ROM_START( sc_fullt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412334.odd", 0x00001, 0x080000, CRC(fa047f3c) SHA1(ccd3cdee630c1fc602669ee33b7a5b930e06884e) )
	ROM_LOAD16_BYTE( "95412335.evn", 0x00000, 0x080000, CRC(39214d9f) SHA1(7a8a758856f9bfb068564e295bc4b71782789178) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412336.odd", 0x00001, 0x080000, CRC(dd162e93) SHA1(4337bd2108ca874f0c3a3570739f1650a056c440) )
	ROM_LOAD16_BYTE( "95412337.evn", 0x00000, 0x080000, CRC(709b89e9) SHA1(02c572e53404b37ca1d94a451d7a64ca7f378631) )
	ROM_LOAD16_BYTE( "95413334.odd", 0x00001, 0x080000, CRC(5c248e22) SHA1(d04d7c581a2e213ce501a8211d8f1d1115f96bda) )
	ROM_LOAD16_BYTE( "95413335.evn", 0x00000, 0x080000, CRC(2c11bdac) SHA1(701a23b3187a8e107ff966c8f29a8d70384720fa) )
	ROM_LOAD16_BYTE( "95413336.odd", 0x00001, 0x080000, CRC(7405e6c9) SHA1(61f1e053ff0f484c9ac9ff5f80a0aff286f6ba6d) )
	ROM_LOAD16_BYTE( "95413337.evn", 0x00000, 0x080000, CRC(469419f5) SHA1(dbba72da97cba59a96d98a647adc7825d591af3b) )
	ROM_LOAD16_BYTE( "95414508.odd", 0x00001, 0x080000, CRC(2b6d1ae2) SHA1(9e09c2e838bb599d2cf155cebe8b9d10e6dc86cb) )
	ROM_LOAD16_BYTE( "95414509.evn", 0x00000, 0x080000, CRC(dc35c2c8) SHA1(4b3a7bbf6e74ff0278d21f3ed755de9dd44fe9bb) )
	ROM_LOAD16_BYTE( "95414510.odd", 0x00001, 0x080000, CRC(c0d8ef81) SHA1(0e6c1d6cb2762a7b777acf10dfd5077bcea65e64) )
	ROM_LOAD16_BYTE( "95414511.evn", 0x00000, 0x080000, CRC(469791e0) SHA1(4335d4cd8cf49181a49130ed0f4a5c9cd6a5b470) )
	ROM_LOAD16_BYTE( "95414738.odd", 0x00001, 0x080000, CRC(84beebed) SHA1(44e36819aca9595cf57d0c9318f6c318fcb342b6) )
	ROM_LOAD16_BYTE( "95414739.evn", 0x00000, 0x080000, CRC(24b419e2) SHA1(e68b3eacfec21fe7ce28b2283f5a02778862d176) )
	ROM_LOAD16_BYTE( "95415508.odd", 0x00001, 0x080000, CRC(a1323401) SHA1(19887bcc93b6fddf6740b01fee12597100f4b8cf) )
	ROM_LOAD16_BYTE( "95415509.evn", 0x00000, 0x080000, CRC(a424beb3) SHA1(9bd29e8c0ba127e5ec8914e76f4b8f2a8cb979b0) )
	ROM_LOAD16_BYTE( "95415510.odd", 0x00001, 0x080000, CRC(61fab1cf) SHA1(a3b6c2588517b01599ef76cba05f3bcaaf33e360) )
	ROM_LOAD16_BYTE( "95415511.evn", 0x00000, 0x080000, CRC(7344a354) SHA1(747ddbd1cb3c4a01cba6ad8447def2995c3fe31d) )
	ROM_LOAD16_BYTE( "95415738.odd", 0x00001, 0x080000, CRC(d8fa18be) SHA1(5667f9eecede0dbb9f042530cec8bfc94e6427a9) )
	ROM_LOAD16_BYTE( "95415739.evn", 0x00000, 0x080000, CRC(24b419e2) SHA1(e68b3eacfec21fe7ce28b2283f5a02778862d176) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008449.bin", 0x0000, 0x0fde7d, CRC(9e3ce927) SHA1(00ce43a0ca94e81ac90f53c647e40ac6cb454937) )
ROM_END




ROM_START( sc_gamcs )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406354.lo", 0x00001, 0x080000, CRC(846e59e4) SHA1(a9cf980080f571f5b246209a28071da714e326ac) )
	ROM_LOAD16_BYTE( "95406355.hi", 0x00000, 0x080000, CRC(139af67f) SHA1(491a08293324673b42a032a7b3241f573cf4b0e4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004285.snd", 0x0000, 0x080000, CRC(034a84a6) SHA1(f5b815d943fe9f7eaff4358657426be5260753bf) )
ROM_END





ROM_START( sc_game )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406470.lo", 0x00001, 0x080000, CRC(8471230a) SHA1(d72eef5b8addbaa60d1bda9b3e62b48728ddc818) )
	ROM_LOAD16_BYTE( "95406471.hi", 0x00000, 0x080000, CRC(7dc7e054) SHA1(9ad9c218fb55ba2841fd75dbcdb56d1f1dbc41e9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004285.snd", 0x0000, 0x080000, CRC(034a84a6) SHA1(f5b815d943fe9f7eaff4358657426be5260753bf) )
ROM_END




ROM_START( sc_ziggy )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420166.lo", 0x00001, 0x080000, CRC(a1f64ad8) SHA1(4cfb0fae5a7d3a8323958019e5813f422d3b3fba) )
	ROM_LOAD16_BYTE( "95420167.hi", 0x00000, 0x080000, CRC(4e4bfed4) SHA1(9a39c9d607cfa905ba93b0e4838ee7cf7d43789a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420168.lo", 0x00001, 0x080000, CRC(86518fea) SHA1(9a8e97f7bbd7ba51967c06633ff597f03cfb2ea8) )
	ROM_LOAD16_BYTE( "95420169.hi", 0x00000, 0x080000, CRC(bae83963) SHA1(b47302d0d725b6c890349b0449decf6f9a28e77f) )
	ROM_LOAD16_BYTE( "95420482.lo", 0x00001, 0x080000, CRC(a46303eb) SHA1(74c997ee7ba5e93ac0eda373761946f21449e177) )
	ROM_LOAD16_BYTE( "95420483.hi", 0x00000, 0x080000, CRC(6bdd94aa) SHA1(44c6e07b5d308020a79d57b0974a134a595982d7) )
	ROM_LOAD16_BYTE( "95420484.lo", 0x00001, 0x080000, CRC(b1079049) SHA1(d6addd044b7529e033ced032709d55f77c41cfb3) )
	ROM_LOAD16_BYTE( "95420485.hi", 0x00000, 0x080000, CRC(ddb84927) SHA1(48ee3072c423fe7be5ecc31dc57acc31cd8576b8) )
	ROM_LOAD16_BYTE( "95421166.lo", 0x00001, 0x080000, CRC(4cfa8c0c) SHA1(f9612a80dde3d7054c03cb727835db5c40911f2c) )
	ROM_LOAD16_BYTE( "95421167.hi", 0x00000, 0x080000, CRC(6ae0a0fe) SHA1(5802e5fa5e9a18fa66ab541790af1ad62023a4c2) )
	ROM_LOAD16_BYTE( "95421168.lo", 0x00001, 0x080000, CRC(9731db4e) SHA1(4e849eabc58dec4420697d2c205db8dd0614fb32) )
	ROM_LOAD16_BYTE( "95421169.hi", 0x00000, 0x080000, CRC(0c997a9e) SHA1(3c13a9986fd2fb057f396f853d6495cd39c8b545) )
	ROM_LOAD16_BYTE( "95421482.lo", 0x00001, 0x080000, CRC(19e07df0) SHA1(23862138c21ed236f3ff37b3151ac271450a04af) )
	ROM_LOAD16_BYTE( "95421483.hi", 0x00000, 0x080000, CRC(f70321c1) SHA1(986a98e8a866e31c81bb94fbecb5f8ec826e704d) )
	ROM_LOAD16_BYTE( "95421484.lo", 0x00001, 0x080000, CRC(34924d7a) SHA1(721594c08780a80b9019f4cde2a01cde25fd415d) )
	ROM_LOAD16_BYTE( "95421485.hi", 0x00000, 0x080000, CRC(791d07f7) SHA1(b9f0133d60eafab983e3a45c6dbbec03d5b9f24b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008472.bin", 0x0000, 0x0ece7a, CRC(12a9ec95) SHA1(1c3634b27718b1ce496c02c7dd6ef29800d1d2ee) )
ROM_END




ROM_START( sc_glad )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416666.lo", 0x00001, 0x080000, CRC(f7cc7b09) SHA1(1901d800342420dafbe4a17563dbf891fa3bc77b) )
	ROM_LOAD16_BYTE( "95416667.hi", 0x00000, 0x080000, CRC(832e48d0) SHA1(78efa50cec3b64346a67b03e60e2fb2f2879059d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416726.lo", 0x00001, 0x080000, CRC(a2c85e44) SHA1(81e719ab0b29dcf264dbdd6d67f0d0f95de62a67) )
	ROM_LOAD16_BYTE( "95416727.hi", 0x00000, 0x080000, CRC(2a54392c) SHA1(9ad1874cce0ac5437a2652b03229700aae366d82) )
	ROM_LOAD16_BYTE( "95416728.lo", 0x00001, 0x080000, CRC(d64caa35) SHA1(7bc5e51a46e6b2b7dcc3f759b9522a98fe6bd82c) )
	ROM_LOAD16_BYTE( "95416729.hi", 0x00000, 0x080000, CRC(d35bc8ed) SHA1(7c174a180df7c39bb93de750c2a6238fd18a750e) )
	ROM_LOAD16_BYTE( "95417666.lo", 0x00001, 0x080000, CRC(eab5fb98) SHA1(a64a9d3ed989d15508c3b9bb6d07f4f821297ad3) )
	ROM_LOAD16_BYTE( "95417667.hi", 0x00000, 0x080000, CRC(fed19dd2) SHA1(24c0f6a411fd44a42ebbcc861a27edc8c2897768) )
	ROM_LOAD16_BYTE( "95417726.lo", 0x00001, 0x080000, CRC(58b916ae) SHA1(4c0e47512802b758e164b6ad6b5d8bf2db2b8e2f) )
	ROM_LOAD16_BYTE( "95417727.hi", 0x00000, 0x080000, CRC(ccd8738e) SHA1(0a9dce84f97ba3fa97415c154cbaf1fe87ee969f) )
	ROM_LOAD16_BYTE( "95417728.lo", 0x00001, 0x080000, CRC(659080a7) SHA1(480077c90fba6bc473e3082dd5971f9bd6df4c7d) )
	ROM_LOAD16_BYTE( "95417729.hi", 0x00000, 0x080000, CRC(8f577431) SHA1(21e50eb9a1bda0a5f6895a57009bf69dcab50cd3) )
	ROM_LOAD16_BYTE( "95420106.lo", 0x00001, 0x080000, CRC(4f9aa405) SHA1(9433f5c668cd5178bde8fb0d47aa662d20f257d5) )
	ROM_LOAD16_BYTE( "95420107.hi", 0x00000, 0x080000, CRC(22a53136) SHA1(fc89ea546420328cd13bc0cce2b242c824488395) )
	ROM_LOAD16_BYTE( "95420536.lo", 0x00001, 0x080000, CRC(62e06fe4) SHA1(d052d6706d48c3b53a1cc9186f4d9505ac76b0b9) )
	ROM_LOAD16_BYTE( "95420537.hi", 0x00000, 0x080000, CRC(0250dc89) SHA1(6ff351e0448643fe9ec64abae3b0afa90e042b41) )
	ROM_LOAD16_BYTE( "95420538.lo", 0x00001, 0x080000, CRC(b4e9c9ea) SHA1(d92fd73d55ad015e3e828750fb73e860feccada6) )
	ROM_LOAD16_BYTE( "95420539.hi", 0x00000, 0x080000, CRC(5a023a25) SHA1(012649e0273bc35a654778d847c612c78212a102) )
	ROM_LOAD16_BYTE( "95421106.lo", 0x00001, 0x080000, CRC(92160b66) SHA1(828f85794e6b658fba0efe9bcb77dcf01a0cd91e) )
	ROM_LOAD16_BYTE( "95421107.hi", 0x00000, 0x080000, CRC(8407f80a) SHA1(c5e6ad8bfb2a1fa02f85e92ac62c7799c8904931) )
	ROM_LOAD16_BYTE( "95421536.lo", 0x00001, 0x080000, CRC(b73ada13) SHA1(0f6546d798c01b6ffa2ccb1374db93a80d616e2e) )
	ROM_LOAD16_BYTE( "95421537.hi", 0x00000, 0x080000, CRC(3e8f8b50) SHA1(5b076205191e388204c0c7e62bc9b6c3798c3164) )
	ROM_LOAD16_BYTE( "95421538.lo", 0x00001, 0x080000, CRC(ee50532a) SHA1(35a28ab419e8a5178a8a253c9d5121617073088f) )
	ROM_LOAD16_BYTE( "95421539.hi", 0x00000, 0x080000, CRC(e47d28f0) SHA1(3eab678f79b602da07c1491c75fc08020c394e8e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_gldcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416882.lo", 0x00001, 0x080000, CRC(ee246097) SHA1(a17d4a494a6b2d3d608fddb82214e3456d817b15) )
	ROM_LOAD16_BYTE( "95416883.hi", 0x00000, 0x080000, CRC(f05997a4) SHA1(04861a9923ba437717d03f98e1670cfce45ef489) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417882.lo", 0x00001, 0x080000, CRC(0a292b22) SHA1(0af7b907f44969b3e02728ad059679915043ee2c) )
	ROM_LOAD16_BYTE( "95417883.hi", 0x00000, 0x080000, CRC(f0baaee4) SHA1(33dffbeedba02002ec09b58ee2fe4b81a838379b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008968.bin", 0x0000, 0x0f4e4e, CRC(23e718a6) SHA1(1c781380d6b4fb307af6cb81be830159ce610352) )
ROM_END




ROM_START( sc_gd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404358.lo", 0x00001, 0x080000, CRC(03e321ba) SHA1(a30645b2a001033f75ce99c28c36ed2f095edc03) )
	ROM_LOAD16_BYTE( "95404359.hi", 0x00000, 0x080000, CRC(b297dc83) SHA1(e8afce70a181fb951d3b75cd4d0c5feb08e2d0ab) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404360.lo", 0x00001, 0x080000, CRC(4985a746) SHA1(f45c805b5a0e2acdc14e0079d1d56762e072ca5a) )
	ROM_LOAD16_BYTE( "95404361.hi", 0x00000, 0x080000, CRC(a813558e) SHA1(cfd1560dfc03e5023f2ae0474f87c0090d716472) )
	ROM_LOAD16_BYTE( "95405358.lo", 0x00001, 0x080000, CRC(9801b0bb) SHA1(e188b41ccde297597311f678d9a7ac7954835de1) )
	ROM_LOAD16_BYTE( "95405359.hi", 0x00000, 0x080000, CRC(dc2faf38) SHA1(d47e886d593e6849675e119e97ac935bc3d7a23a) )
	ROM_LOAD16_BYTE( "95405360.lo", 0x00001, 0x080000, CRC(7b4870ed) SHA1(d3eb89520c834cab36ca5c2b92653f1d1d218e36) )
	ROM_LOAD16_BYTE( "95405361.hi", 0x00000, 0x080000, CRC(22e4f4ab) SHA1(379cd01acdfa49f10bb90aeaad288ec1a02b3d5c) )
	ROM_LOAD16_BYTE( "95406024.lo", 0x00001, 0x080000, CRC(f09c2a2a) SHA1(6b194e51f7aa5620e0b561ad5d0a2eb9057ab0d4) )
	ROM_LOAD16_BYTE( "95406025.hi", 0x00000, 0x080000, CRC(8e3ac428) SHA1(6bb7d6d660e8121d1db260180ab164066fd73475) )
	ROM_LOAD16_BYTE( "95406496.lo", 0x00001, 0x080000, CRC(b8a36ee5) SHA1(1350aea8c3f9ca2365dea3d19254208ea0226b42) )
	ROM_LOAD16_BYTE( "95406497.hi", 0x00000, 0x080000, CRC(7abb8c9b) SHA1(776ec56ef3f33098ec61c8aa02ce15b7ed2dc3b8) )
	ROM_LOAD16_BYTE( "95407024.lo", 0x00001, 0x080000, CRC(c05f10d2) SHA1(7fc4165734a3cbf5f4cd77831bf1956d76712fc3) )
	ROM_LOAD16_BYTE( "95407025.hi", 0x00000, 0x080000, CRC(e1f946b8) SHA1(735111ea681d52ab2fa0152347314b194fbbb9c7) )
	ROM_LOAD16_BYTE( "95407496.lo", 0x00001, 0x080000, CRC(b9843bb7) SHA1(007c0409de40e4d400c00cbe361d2010f13ee446) )
	ROM_LOAD16_BYTE( "95407497.hi", 0x00000, 0x080000, CRC(c88253cb) SHA1(b51e8104695e84db4af9ce4bfab7cc5a90470657) )
	ROM_LOAD16_BYTE( "p3509p71.hi", 0x00000, 0x080000, CRC(01fa71eb) SHA1(0ccf5f994e995d1ba772561fa168714ed89543df) )
	ROM_LOAD16_BYTE( "p3509p71.lo", 0x00001, 0x080000, CRC(9f2ab639) SHA1(02c940c783820c08ac533543809a2fb87e7f563d) )
	ROM_LOAD16_BYTE( "p3509s71.hi", 0x00000, 0x080000, CRC(b7743603) SHA1(d87301810af34e0946d2713e26f9a4d0e17d6d29) )
	ROM_LOAD16_BYTE( "p3509s71.lo", 0x00001, 0x080000, CRC(4374588e) SHA1(59814e287386414e446fbbc1414499b5a17723cb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008187.bin", 0x0000, 0x100000, CRC(1fbbc7cc) SHA1(6e19b582a3654bbbcf65b8f42bd556029f43e8cb) )
	ROM_LOAD( "95008188.bin", 0x0000, 0x100000, CRC(a74b23a7) SHA1(f7948edfb5524eaf80039c07ca7a9f76883f5a6f) )
	ROM_LOAD( "95009061.bin", 0x0000, 0x100000, CRC(c4cad720) SHA1(ce67af8d9e0b2f4f79d38b7a01dfc5ff7323e162) )
	ROM_LOAD( "95009062.bin", 0x0000, 0x100000, CRC(509761d3) SHA1(6a133cc33bac6a1696de98a4961572a86cefc1c8) )
ROM_END




ROM_START( sc_gdmz )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414404.lo", 0x00001, 0x080000, CRC(0d68a264) SHA1(d84550a601778f135cea158cfe274ee409ec27d8) )
	ROM_LOAD16_BYTE( "95414405.hi", 0x00000, 0x080000, CRC(7b0da5f0) SHA1(3cabfeebfdc707cfe75c8ef72db741b33abc7ac6) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414406.lo", 0x00001, 0x080000, CRC(04c88d78) SHA1(0a5d26caa8b3861b228ac39c7cc512e4f6359234) )
	ROM_LOAD16_BYTE( "95414407.hi", 0x00000, 0x080000, CRC(b1b5b7e4) SHA1(aef0e8a3d688d22e5465551ddb28c0b0105b6f58) )
	ROM_LOAD16_BYTE( "95420134.lo", 0x00001, 0x080000, CRC(86537cdd) SHA1(e026961508de73921368986a5fdc19e586ea9909) )
	ROM_LOAD16_BYTE( "95420135.hi", 0x00000, 0x080000, CRC(5f4fc0ca) SHA1(ce425ee451a83157e5da0d7a2747c7d5b653b67c) )
	ROM_LOAD16_BYTE( "95421134.lo", 0x00001, 0x080000, CRC(603a0237) SHA1(94b5ab8e850634e800072680ceab3c12c3d2be26) )
	ROM_LOAD16_BYTE( "95421135.hi", 0x00000, 0x080000, CRC(cfa548a4) SHA1(032fe4d1da5d49c1226ae198621676093678d5db) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008980.bin", 0x0000, 0x0fe431, CRC(c09277a0) SHA1(227609194f7d7e8b00cbd5cb94f8679f8fff71c6) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890471.bin", 0x0000, 0x5000, CRC(98fce599) SHA1(559534c3b33c6390a06b2e97e4c595055c8c4fea) )
	ROM_LOAD( "95890472.bin", 0x0000, 0x5000, CRC(ed6aa1ad) SHA1(83b69606398a30cb9c2ebc2f7406ef3215afab9e) )
	ROM_LOAD( "95890473.bin", 0x0000, 0x5000, CRC(73d06df1) SHA1(6959ee1b1c05398bc95430fea3590e5a86dd4312) )
ROM_END




ROM_START( sc_gdclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406460.lo", 0x00001, 0x080000, CRC(ffadb4bb) SHA1(6bf47af974b3d7eab99c54f92228b8ee60c92261) )
	ROM_LOAD16_BYTE( "95406461.hi", 0x00000, 0x080000, CRC(70f5e1c3) SHA1(c5bbad6856f7e52827098f8fa7b70658af3741fe) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406462.lo", 0x00001, 0x080000, CRC(621fb28b) SHA1(4ce482a1e31d195cbcabe41c0d5a38f532fe7375) )
	ROM_LOAD16_BYTE( "95406463.hi", 0x00000, 0x080000, CRC(180706d1) SHA1(748b28df7f6860785097b887370f4bb95b23bb7e) )
	ROM_LOAD16_BYTE( "95407460.lo", 0x00001, 0x080000, CRC(9c25e8c1) SHA1(ba2780002a72805836c46e9f40a323a2b5c93b0a) )
	ROM_LOAD16_BYTE( "95407461.hi", 0x00000, 0x080000, CRC(e132397f) SHA1(d1e0581467fb5277721472ed3dc808da863bea8f) )
	ROM_LOAD16_BYTE( "95407462.lo", 0x00001, 0x080000, CRC(80fb6588) SHA1(4c4aa0d4ca780eb801409dd76d65230827717d1a) )
	ROM_LOAD16_BYTE( "95407463.hi", 0x00000, 0x080000, CRC(ddf6cc93) SHA1(c341c465f8c78d0df78e94d31169eb90cc169e78) )
	ROM_LOAD16_BYTE( "95408210.lo", 0x00001, 0x080000, CRC(0718c80a) SHA1(aff944fe848744519151abfdd88558c2c1494e57) )
	ROM_LOAD16_BYTE( "95408211.hi", 0x00000, 0x080000, CRC(0e72bbe9) SHA1(928b8ff011e1954e223e7b58635ae002e74e243b) )
	ROM_LOAD16_BYTE( "95409210.lo", 0x00001, 0x080000, CRC(b0e98730) SHA1(e4cb43b59a39410f999e4f2a2886e7c36b2b8543) )
	ROM_LOAD16_BYTE( "95409211.hi", 0x00000, 0x080000, CRC(e7fa2ed5) SHA1(c64377bf4964cfb6c1cadfa28059bdcc56c94e51) )
	ROM_LOAD16_BYTE( "95412200.lo", 0x00001, 0x080000, CRC(f57f37bd) SHA1(bc0d0e448f08e00a94468ffe1a6bdb2b5808cb47) )
	ROM_LOAD16_BYTE( "95412201.hi", 0x00000, 0x080000, CRC(17a6fa5e) SHA1(305ca3f40fa2cb2dfe7461baf19b7077149d943c) )
	ROM_LOAD16_BYTE( "95412842.lo", 0x00001, 0x080000, CRC(a4676445) SHA1(bb34b9d3453254b4d19f5f13c2dca65e9b7fede3) )
	ROM_LOAD16_BYTE( "95412843.hi", 0x00000, 0x080000, CRC(21912d54) SHA1(50bbc4adf70468b079835b4e210d6ff648db95ff) )
	ROM_LOAD16_BYTE( "95413200.lo", 0x00001, 0x080000, CRC(245188b5) SHA1(36ead091cc28d070ce306ca3c9216491c709e2b3) )
	ROM_LOAD16_BYTE( "95413201.hi", 0x00000, 0x080000, CRC(367b94a9) SHA1(6df95d32eb447a351098548da76314300bf8ff5c) )
	ROM_LOAD16_BYTE( "95413842.lo", 0x00001, 0x080000, CRC(b5418f2a) SHA1(7d806eddfb3e9a1aed29d1962d48c96656c929d0) )
	ROM_LOAD16_BYTE( "95413843.hi", 0x00000, 0x080000, CRC(163f4700) SHA1(2513bf9e306f2eafc48d29a2d79f7c26d6d384b3) )
	ROM_LOAD16_BYTE( "95426422.lo", 0x00001, 0x080000, CRC(2f0675eb) SHA1(287bb87e372bc0fca568cb63c62bcc81e448935a) )
	ROM_LOAD16_BYTE( "95426423.hi", 0x00000, 0x080000, CRC(69ca79cd) SHA1(15c59d0ec009cbc73b40767b9194b9cd8220d336) )
	ROM_LOAD16_BYTE( "95426450.lo", 0x00001, 0x080000, CRC(5229a543) SHA1(0d523a0bedfc19fa62702f6472f1112d26e2356a) )
	ROM_LOAD16_BYTE( "95426451.hi", 0x00000, 0x080000, CRC(cd6288f8) SHA1(530e53e3e66965872217224947423a097cf960ca) )
	ROM_LOAD16_BYTE( "95426498.lo", 0x00001, 0x080000, CRC(1239da8f) SHA1(436763e75c1729aa37bee74981c53ebec139fe41) )
	ROM_LOAD16_BYTE( "95426499.hi", 0x00000, 0x080000, CRC(ace06244) SHA1(94b6be0b30976525743ff97f62c465c52bdc3aab) )
	ROM_LOAD16_BYTE( "95427422.lo", 0x00001, 0x080000, CRC(a940f61f) SHA1(b66099d74a5a2bc3d639ff7dee1e6871e5464c66) )
	ROM_LOAD16_BYTE( "95427423.hi", 0x00000, 0x080000, CRC(fc57ca0f) SHA1(9b2de50e5ef010edae5f112a13416074e685f2a5) )
	ROM_LOAD16_BYTE( "95427450.lo", 0x00001, 0x080000, CRC(229112f2) SHA1(93567719f3facd9da6cf076a5e95c6c6482c8e31) )
	ROM_LOAD16_BYTE( "95427451.hi", 0x00000, 0x080000, CRC(bca120fa) SHA1(8abb14bbb1d29872457fc24bc2311309e17c79eb) )
	ROM_LOAD16_BYTE( "95427498.lo", 0x00001, 0x080000, CRC(8c1c667c) SHA1(d3f5e92fa347e2c207a9c7e4d1d5a6fac20a8937) )
	ROM_LOAD16_BYTE( "95427499.hi", 0x00000, 0x080000, CRC(00744041) SHA1(6fb9db03bfcac3ca2687117c056970a62b3ea034) )
	ROM_LOAD16_BYTE( "p1137p11.hi", 0x00000, 0x080000, CRC(8213a2c4) SHA1(a547fc96a53800643bddc66b6f596baacf888a92) )
	ROM_LOAD16_BYTE( "p1137p11.lo", 0x00001, 0x080000, CRC(686d17fb) SHA1(3c6da76aa4872b1a5bf09e984fbac0cfdf4f6264) )
	ROM_LOAD16_BYTE( "p1137s11.hi", 0x00000, 0x080000, CRC(252c2257) SHA1(6b5acdc869d1eb535711016c1840f6ff9acde8aa) )
	ROM_LOAD16_BYTE( "p1137s11.lo", 0x00001, 0x080000, CRC(9316e977) SHA1(4ef00e2ae9ca533a684dbd625924eca8fec56c4f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008248.bin", 0x0000, 0x100000, CRC(abfba7ee) SHA1(95b61b34080196d745cc00ae32a333edb111da89) )
ROM_END




ROM_START( sc_gfev )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412110.lo", 0x00001, 0x080000, CRC(8bf4bdd1) SHA1(33106003c3ba80ec918ffd0b5ac61e6cab8cb60a) )
	ROM_LOAD16_BYTE( "95412111.hi", 0x00000, 0x080000, CRC(7eae9cee) SHA1(51f4426c6bcac7e53f296ad1f9592cd3272fd91a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416146.lo", 0x00001, 0x080000, CRC(d4a039fb) SHA1(7a0094695b6bb909250e81cbb096e67d4654957b) )
	ROM_LOAD16_BYTE( "95416147.hi", 0x00000, 0x080000, CRC(3fbce341) SHA1(498081059fa07460c6ede28c4b313747236254b6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95416146.bin", 0x0000, 0x100000, CRC(17e92fa0) SHA1(7dea5166f3f70e5d249da56f01bbe2267ce43d6a) )
ROM_END




ROM_START( sc_gball )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404206.lo", 0x00001, 0x080000, CRC(bb853407) SHA1(498aad2cf2948d7fbef673186823af6a7dbefd95) )
	ROM_LOAD16_BYTE( "95404207.hi", 0x00000, 0x080000, CRC(e4e3f4e0) SHA1(ab8a8eeb5661d6cd3ba5d25f2082c06ac8c343ac) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404208.lo", 0x00001, 0x080000, CRC(fc080cdf) SHA1(86084d70e6a68afe3f788661b78cfb8df3bb8104) )
	ROM_LOAD16_BYTE( "95404209.hi", 0x00000, 0x080000, CRC(6e4d776f) SHA1(0e09b78e138215ceb693bc86a3fe6d7320da9431) )
	ROM_LOAD16_BYTE( "95405206.lo", 0x00001, 0x080000, CRC(79f07bc2) SHA1(e85ddf4c18573894ecd51fec283cc46becb8aacc) )
	ROM_LOAD16_BYTE( "95405207.hi", 0x00000, 0x080000, CRC(2c295913) SHA1(a8bf658c6ec248e7f53485ce778e9679eae62504) )
	ROM_LOAD16_BYTE( "95405208.lo", 0x00001, 0x080000, CRC(3e7d431a) SHA1(b7975bbbf369d2eb6b8fad5c7200e0007ce2365b) )
	ROM_LOAD16_BYTE( "95405209.hi", 0x00000, 0x080000, CRC(a687da9c) SHA1(99cbc48fe2c9c28fb3b68107402af10c2a7f39fa) )
	ROM_LOAD16_BYTE( "95412492.lo", 0x00001, 0x080000, CRC(963ccd4c) SHA1(4d6991080ed4dcd3affce900ee7d467319100d6a) )
	ROM_LOAD16_BYTE( "95412493.hi", 0x00000, 0x080000, CRC(b259c913) SHA1(a2bf15be684bcb762937e4af49fc1139ade8ea34) )
	ROM_LOAD16_BYTE( "95412498.lo", 0x00001, 0x080000, CRC(68f12b56) SHA1(13a0520ce2a6e4df14e88e5564d3691e58e4cef1) )
	ROM_LOAD16_BYTE( "95412499.hi", 0x00000, 0x080000, CRC(2359aa3d) SHA1(d054e96d3f969c54b77a634d3ab6f4b3458855cf) )
	ROM_LOAD16_BYTE( "95412612.lo", 0x00001, 0x080000, CRC(612afa6d) SHA1(886fd0df386abbc1609792d3e0e35b6554693c14) )
	ROM_LOAD16_BYTE( "95412613.hi", 0x00000, 0x080000, CRC(2e2826d2) SHA1(f4b20ae1758e55a16cab6338d0f712212776d8dd) )
	ROM_LOAD16_BYTE( "95412614.lo", 0x00001, 0x080000, CRC(3a9207e8) SHA1(87dc40b8c6ea8d40fb899fd1bb7550fc5d65ece0) )
	ROM_LOAD16_BYTE( "95412615.hi", 0x00000, 0x080000, CRC(1ef5def8) SHA1(97614ccc4cd62b49492dd065d0a9b7920846e71e) )
	ROM_LOAD16_BYTE( "95413492.lo", 0x00001, 0x080000, CRC(3123302d) SHA1(61aea9ee55dd906bd17ed3181c5ac252eadbbc03) )
	ROM_LOAD16_BYTE( "95413493.hi", 0x00000, 0x080000, CRC(2924e1e3) SHA1(ee78f5bf6f69dc5e8186f699bd52a3c19f986e73) )
	ROM_LOAD16_BYTE( "95413498.lo", 0x00001, 0x080000, CRC(8db258f8) SHA1(a9bcc6fa2537c05fbe9292188935086f3e89b0f3) )
	ROM_LOAD16_BYTE( "95413499.hi", 0x00000, 0x080000, CRC(6ff98900) SHA1(ea30390fa74f852d9dfcd5e933149a37089b9005) )
	ROM_LOAD16_BYTE( "95413612.lo", 0x00001, 0x080000, CRC(1b48a527) SHA1(9f740ddbeef6f3a0f11d3f79f0893faa25bffe29) )
	ROM_LOAD16_BYTE( "95413613.hi", 0x00000, 0x080000, CRC(f40d7d2b) SHA1(ef6fc79fa39240291d26b6e99c6d78630b282464) )
	ROM_LOAD16_BYTE( "95413614.lo", 0x00001, 0x080000, CRC(235a0b49) SHA1(2f9dd0b8daf069f9e3b00dca8e54f505748dae09) )
	ROM_LOAD16_BYTE( "95413615.hi", 0x00000, 0x080000, CRC(c1a82ebd) SHA1(f50e649f5544a5f5c2facb13dc2bfbc7cf12212d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008161.bin", 0x0000, 0x080000, CRC(ecd13fd9) SHA1(51d11b9133d4e840ce9afd7cf716520ea0fc0343) )
	ROM_LOAD( "95008162.bin", 0x0000, 0x080000, CRC(b4b4a5c5) SHA1(d0748decfaee7da52d2f6a4bc0877be4243ed6fb) )
	ROM_LOAD( "95008465.bin", 0x0000, 0x100000, CRC(5d1fa2c9) SHA1(c12de2b89f0bcb8f1b35630fffd205fd9d5b9777) )
	ROM_LOAD( "95008466.bin", 0x0000, 0x100000, CRC(418068ab) SHA1(342939e9bcc1d213bc2f52666cc3765442e18635) )
ROM_END




ROM_START( sc_gg )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404762.lo", 0x00001, 0x080000, CRC(613941b4) SHA1(4cc1441b94913d597aa88e973f4514f7278a7cc9) )
	ROM_LOAD16_BYTE( "95404763.hi", 0x00000, 0x080000, CRC(dbec56ec) SHA1(bb8f2395afe8d5193320d627ef722c1105b02826) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406768.lo", 0x00001, 0x080000, CRC(dec1db93) SHA1(b22b874e5ff5da46e2783544781d7387f98dd4fc) )
	ROM_LOAD16_BYTE( "95406769.hi", 0x00000, 0x080000, CRC(1f47e9d3) SHA1(88bf64e5e7e7bcbba2cc24ac8b9421b38b6b060e) )
	ROM_LOAD16_BYTE( "95407768.lo", 0x00001, 0x080000, CRC(4f1398fa) SHA1(3c3c9710330dfe7af06daa44bf6ba8efdc14eacc) )
	ROM_LOAD16_BYTE( "95407769.hi", 0x00000, 0x080000, CRC(8039c58d) SHA1(ac0fc21e93daff06d383bba3f309867b054aafc4) )
	ROM_LOAD16_BYTE( "95407770.lo", 0x00001, 0x080000, CRC(94da2109) SHA1(6bf1bc1b916678c727d64070d334e9418f3be95c) )
	ROM_LOAD16_BYTE( "95407771.hi", 0x00000, 0x080000, CRC(dff20663) SHA1(3f3525c45602220ba1bd8599ae9f5e4cc249899a) )
	ROM_LOAD16_BYTE( "95407772.lo", 0x00001, 0x080000, CRC(bb731d03) SHA1(f56dd26c93cb5fad4e7b5d43ad7395be35482b1f) )
	ROM_LOAD16_BYTE( "95407773.hi", 0x00000, 0x080000, CRC(7148b4ca) SHA1(caf979f86fea994fb0d304c8c88920aba89ca25e) )
	ROM_LOAD16_BYTE( "95408086.lo", 0x00001, 0x080000, CRC(cd0b1ea9) SHA1(ebb5023afa24876d97417db50aa675ec29c0351b) )
	ROM_LOAD16_BYTE( "95408087.hi", 0x00000, 0x080000, CRC(0a21efb4) SHA1(5765431cfc61521d55e00d7fdd2e08f0ef37d12c) )
	ROM_LOAD16_BYTE( "95410406.lo", 0x00001, 0x080000, CRC(6cdefd78) SHA1(f1d1646c852ecf25551b93ff97666508ec1676c7) )
	ROM_LOAD16_BYTE( "95410407.hi", 0x00000, 0x080000, CRC(40c516b5) SHA1(e9dff71a3674acc8ab9b7e6386d42f30322af3ca) )
	ROM_LOAD16_BYTE( "95411406.lo", 0x00001, 0x080000, CRC(1e277091) SHA1(8d4482c94c943e2d53ce4d7da74bf8f8410d275d) )
	ROM_LOAD16_BYTE( "95411407.hi", 0x00000, 0x080000, CRC(02de3113) SHA1(ba9f402561595dfc676049801afffa53b1ab572b) )
	ROM_LOAD16_BYTE( "95414396.lo", 0x00001, 0x080000, CRC(1160d686) SHA1(b531823f970e09c808e2efb284951c79091b44b1) )
	ROM_LOAD16_BYTE( "95414397.hi", 0x00000, 0x080000, CRC(886f6d1f) SHA1(532f53d2c9956212ea0086b92c1dad38b417ad9e) )
	ROM_LOAD16_BYTE( "95414398.lo", 0x00001, 0x080000, CRC(9449cf3a) SHA1(7bad738f8fd64c776b12578fd038397d4d079206) )
	ROM_LOAD16_BYTE( "95414399.hi", 0x00000, 0x080000, CRC(c8af9c12) SHA1(8701aad284a792993af2a06dddd20d19b0f4ceb6) )
	ROM_LOAD16_BYTE( "95414478.lo", 0x00001, 0x080000, CRC(4128b79c) SHA1(b5fc3e3c8a20afa895a575d4d1552f722cbb5bc5) )
	ROM_LOAD16_BYTE( "95414479.hi", 0x00000, 0x080000, CRC(34a4ef4c) SHA1(2cb5ef9b6423b5fd7dabf55548d85ea54b24ff0c) )
	ROM_LOAD16_BYTE( "95414552.lo", 0x00001, 0x080000, CRC(7136db21) SHA1(d871a0cb436a0f7e83bcd70dc389949763d76511) )
	ROM_LOAD16_BYTE( "95414553.hi", 0x00000, 0x080000, CRC(d05c13d2) SHA1(d5dde00f8af3856e515ed9a1a9e8c936a7cfd288) )
	ROM_LOAD16_BYTE( "95414792.lo", 0x00001, 0x080000, CRC(448b5aee) SHA1(85e091be6bb04f81b176e69b0db6aab7f293d1fa) )
	ROM_LOAD16_BYTE( "95414793.hi", 0x00000, 0x080000, CRC(3a9c62c7) SHA1(15899911c70e35cc2a9c803707791b1cab4d8251) )
	ROM_LOAD16_BYTE( "95414798.lo", 0x00001, 0x080000, CRC(2bd29667) SHA1(c8bf4fb72b858dbb777cf90bbc6e0368111aea79) )
	ROM_LOAD16_BYTE( "95414799.hi", 0x00000, 0x080000, CRC(3c8358b2) SHA1(0243526b7490f518793db804e85cc952e6000881) )
	ROM_LOAD16_BYTE( "95414814.lo", 0x00001, 0x080000, CRC(2d2a1fb6) SHA1(62b6496a12e022991f63adeae32e2b9cca974b52) )
	ROM_LOAD16_BYTE( "95414815.hi", 0x00000, 0x080000, CRC(0257ff33) SHA1(1c9eb81d55fd7c76572e9f84a7765c16471cf110) )
	ROM_LOAD16_BYTE( "95414956.lo", 0x00001, 0x080000, CRC(e6ce40a0) SHA1(6f8abc42fac35492393f72d3edfa81273e5a7c6e) )
	ROM_LOAD16_BYTE( "95414957.hi", 0x00000, 0x080000, CRC(627dbb26) SHA1(2798b7c154dd1d177b11926c76b78ab8b1150d82) )
	ROM_LOAD16_BYTE( "95414958.lo", 0x00001, 0x080000, CRC(3b02336b) SHA1(fedab56766e09924c1b5fc26ad9bcddda00fcc98) )
	ROM_LOAD16_BYTE( "95414959.hi", 0x00000, 0x080000, CRC(ac32f8bb) SHA1(784553498a7b5264afb90ffb597d6a070ef1612c) )
	ROM_LOAD16_BYTE( "95414970.lo", 0x00001, 0x080000, CRC(ab09550b) SHA1(004f858e5bcda93653efa511f66d33cbe20a44d1) )
	ROM_LOAD16_BYTE( "95414971.hi", 0x00000, 0x080000, CRC(e137aff0) SHA1(50a2a6819034ca5b04c704da7cfaf029bdc031b2) )
	ROM_LOAD16_BYTE( "95414992.lo", 0x00001, 0x080000, CRC(8d9880be) SHA1(7ba6f3eb8145f56f4c360fdfdb525135e4e053f1) )
	ROM_LOAD16_BYTE( "95414993.hi", 0x00000, 0x080000, CRC(1cfaa847) SHA1(69186bb277ccb644901a26a6e061250f0f5fed13) )
	ROM_LOAD16_BYTE( "95415396.lo", 0x00001, 0x080000, CRC(c7fa8e2e) SHA1(6b79f66de1c4f229add425ba2135ec41bd478606) )
	ROM_LOAD16_BYTE( "95415397.hi", 0x00000, 0x080000, CRC(2ff91444) SHA1(581ab1010085ca9ba487f7ff3e47ea6b0adb0ce1) )
	ROM_LOAD16_BYTE( "95415398.lo", 0x00001, 0x080000, CRC(42d39792) SHA1(4b24ef5632da8a4a4b699e212b7e3f2c6db4b801) )
	ROM_LOAD16_BYTE( "95415399.hi", 0x00000, 0x080000, CRC(bcbb2ba8) SHA1(a6586e8296d461359e5cdc7e2a53e745c4d47927) )
	ROM_LOAD16_BYTE( "95415400.lo", 0x00001, 0x080000, CRC(3b3e1044) SHA1(496fa7b86e3e5077ee926ef06daacdd741d58e93) )
	ROM_LOAD16_BYTE( "95415401.hi", 0x00000, 0x080000, CRC(d2a1f5cf) SHA1(5b733aa8d84f5b28ea3d877b93616d38aa97a13f) )
	ROM_LOAD16_BYTE( "95415404.lo", 0x00001, 0x080000, CRC(b59fc2d1) SHA1(236b233f5ece509d1628e3ff1cf051dfa044f5d8) )
	ROM_LOAD16_BYTE( "95415405.hi", 0x00000, 0x080000, CRC(a88f6b11) SHA1(ad171d40710854b96bc37167f5c6217b7331e9bf) )
	ROM_LOAD16_BYTE( "95415406.lo", 0x00001, 0x080000, CRC(bc3fedcd) SHA1(d656f7dc0fa30759125b9c997a41192246044434) )
	ROM_LOAD16_BYTE( "95415407.hi", 0x00000, 0x080000, CRC(62377905) SHA1(e151253110a1425fbb89fe60035d439edfb677b5) )
	ROM_LOAD16_BYTE( "95415408.lo", 0x00001, 0x080000, CRC(cc1ee1af) SHA1(6cd6ccca6bad75599c34ac86f79af3c9c15df626) )
	ROM_LOAD16_BYTE( "95415409.hi", 0x00000, 0x080000, CRC(19d9f4c5) SHA1(99567dc1500f54e8bddeccaac8f2757a80c7541e) )
	ROM_LOAD16_BYTE( "95415552.lo", 0x00001, 0x080000, CRC(18c42d46) SHA1(9b18345670067258664aba6a6c1fe86cd8b9ca4c) )
	ROM_LOAD16_BYTE( "95415553.hi", 0x00000, 0x080000, CRC(ca2adcb0) SHA1(9ffb8deb732443772e500bdef58e41e0836f3f3c) )
	ROM_LOAD16_BYTE( "95415792.lo", 0x00001, 0x080000, CRC(9312f684) SHA1(9fd3ada1125225b3b448415a1b9dc9f7e56461a6) )
	ROM_LOAD16_BYTE( "95415793.hi", 0x00000, 0x080000, CRC(0dad5eab) SHA1(5bae9c5403d2db632811c7fcd170975c254a3567) )
	ROM_LOAD16_BYTE( "95415794.lo", 0x00001, 0x080000, CRC(c07ac457) SHA1(5a5bd8be1647d1ac0e25d63787289417c978db6f) )
	ROM_LOAD16_BYTE( "95415795.hi", 0x00000, 0x080000, CRC(7afe1d2d) SHA1(edb6b2d4c8f62895f5f77538c689ace93746f69d) )
	ROM_LOAD16_BYTE( "95415796.lo", 0x00001, 0x080000, CRC(4e748bde) SHA1(3228fb7e3d39d8c0d44a08d9cb53555907e6cffe) )
	ROM_LOAD16_BYTE( "95415797.hi", 0x00000, 0x080000, CRC(43f71bb6) SHA1(5835abd2e978c9964c63718eed2907636e0997ee) )
	ROM_LOAD16_BYTE( "95415798.lo", 0x00001, 0x080000, CRC(ff9798a5) SHA1(f7d72f113425c6a914cc3c6f3c6d393ae6455fbd) )
	ROM_LOAD16_BYTE( "95415799.hi", 0x00000, 0x080000, CRC(cfe254d4) SHA1(a233532461420d77a0c93df3a697d3352472a35f) )
	ROM_LOAD16_BYTE( "95415814.lo", 0x00001, 0x080000, CRC(cd739a1d) SHA1(b80f07958ef26d071668d89260db46b1cb22231c) )
	ROM_LOAD16_BYTE( "95415815.hi", 0x00000, 0x080000, CRC(e745f7f6) SHA1(6adb886f2e270fd826768cb7f701e2fdc5f4c161) )
	ROM_LOAD16_BYTE( "95415956.lo", 0x00001, 0x080000, CRC(3b91d734) SHA1(89764625ad2f7f86e291caf53551656590473cab) )
	ROM_LOAD16_BYTE( "95415957.hi", 0x00000, 0x080000, CRC(925f43d0) SHA1(d6a994b35a16822ec4f5832a953b6504a27ebac6) )
	ROM_LOAD16_BYTE( "95415958.lo", 0x00001, 0x080000, CRC(7d2f448f) SHA1(b0d8612b6848648266f50eef902fe780eaef31c7) )
	ROM_LOAD16_BYTE( "95415959.hi", 0x00000, 0x080000, CRC(09d9d900) SHA1(5e56343c25bc643072dbe2a707ab6f7e245d6cae) )
	ROM_LOAD16_BYTE( "95415992.lo", 0x00001, 0x080000, CRC(208987db) SHA1(cd4221f93a4979262e32fed351585784bed8cf83) )
	ROM_LOAD16_BYTE( "95415993.hi", 0x00000, 0x080000, CRC(0bb70094) SHA1(694dae18704c26ae4f3162c383ecfdb3328796a5) )
	ROM_LOAD16_BYTE( "95416016.lo", 0x00001, 0x080000, CRC(943624e5) SHA1(f0a976991bc295e334ae33dedf2752760e586c57) )
	ROM_LOAD16_BYTE( "95416017.hi", 0x00000, 0x080000, CRC(f0155180) SHA1(51a5e99937508a15317d56588cf261da8dbd8b01) )
	ROM_LOAD16_BYTE( "95416054.lo", 0x00001, 0x080000, CRC(9aa4dec5) SHA1(5a2f80df9f69836e08a576c1121addaa76558ee6) )
	ROM_LOAD16_BYTE( "95416055.hi", 0x00000, 0x080000, CRC(212eb6a8) SHA1(e45b6ba6747d9969a1515cc88434ba2e5965574b) )
	ROM_LOAD16_BYTE( "95416124.lo", 0x00001, 0x080000, CRC(537e86dc) SHA1(592661deadf3cdbbbe7506fc3e362b5de72d9282) )
	ROM_LOAD16_BYTE( "95416125.hi", 0x00000, 0x080000, CRC(15c575ac) SHA1(6fec7d27b19f2c1b84c4ce83613d5d6af3df0053) )
	ROM_LOAD16_BYTE( "95416132.lo", 0x00001, 0x080000, CRC(7e24c13f) SHA1(7d23880df34163322935f0e8cf4dd5cd37b3fcb5) )
	ROM_LOAD16_BYTE( "95416133.hi", 0x00000, 0x080000, CRC(8014fa57) SHA1(e356ff476da0cfd4cc6c7194bf83c21067c66870) )
	ROM_LOAD16_BYTE( "95417016.lo", 0x00001, 0x080000, CRC(34529f02) SHA1(ea720107b89d69d1e673dd00a8e59eb670074817) )
	ROM_LOAD16_BYTE( "95417017.hi", 0x00000, 0x080000, CRC(cc7bc094) SHA1(3f62b9ee21a330d5bcda8a3f89f23322ffcb6e1f) )
	ROM_LOAD16_BYTE( "95417054.lo", 0x00001, 0x080000, CRC(d3e2fdbc) SHA1(80d4a40a5a00c7452d3985bfcbf663751f731052) )
	ROM_LOAD16_BYTE( "95417055.hi", 0x00000, 0x080000, CRC(57d80fca) SHA1(30de0c5fc027be579b88ef6134078deb959a6e5e) )
	ROM_LOAD16_BYTE( "95417124.lo", 0x00001, 0x080000, CRC(a7bcf290) SHA1(56669bfd91f42863526987fc2e1b98dc8cc12d6d) )
	ROM_LOAD16_BYTE( "95417125.hi", 0x00000, 0x080000, CRC(f7373810) SHA1(56b3b6a2d9fb8a291f9edb023c47c24fd5c05d23) )
	ROM_LOAD16_BYTE( "95417126.lo", 0x00001, 0x080000, CRC(b8184d23) SHA1(d6bfa2fe512f5a26e1beaa728837a06ae110f560) )
	ROM_LOAD16_BYTE( "95417127.hi", 0x00000, 0x080000, CRC(ec1f3c3a) SHA1(214b91ffc2743c04d3030ed1bf005f1ebc124e1a) )
	ROM_LOAD16_BYTE( "95417132.lo", 0x00001, 0x080000, CRC(5e6d4f71) SHA1(7aa3bae2651d51a5f46606a43d708484b05ee887) )
	ROM_LOAD16_BYTE( "95417133.hi", 0x00000, 0x080000, CRC(87c015a5) SHA1(5e031909b746e0051da218fc396a8b1b71a45674) )
	ROM_LOAD16_BYTE( "95417382.lo", 0x00001, 0x080000, CRC(51e487cc) SHA1(8de22e386ac9107b85d8c79ca7e8c662a81a5dfc) )
	ROM_LOAD16_BYTE( "95417383.hi", 0x00000, 0x080000, CRC(b48c6cf0) SHA1(7a83fcdec48a95335ed190c7e9951e081b645d3b) )
	ROM_LOAD16_BYTE( "95417384.lo", 0x00001, 0x080000, CRC(51b709db) SHA1(26a4ae234604867f3b8f02ec3de5dc506f99df97) )
	ROM_LOAD16_BYTE( "95417385.hi", 0x00000, 0x080000, CRC(9acb994e) SHA1(629f6f8d0908b088bfe0eda01b2bdaad5de65607) )
	ROM_LOAD16_BYTE( "95417386.lo", 0x00001, 0x080000, CRC(a219590a) SHA1(8191d239939914b0d4ec5884a35c8eafada1cccf) )
	ROM_LOAD16_BYTE( "95417387.hi", 0x00000, 0x080000, CRC(74fbce05) SHA1(8297336ed15f27cf6b15396377774211b79f8d49) )
	ROM_LOAD16_BYTE( "95417388.lo", 0x00001, 0x080000, CRC(761ebd3c) SHA1(f7690ca38ea445dc4171aed786004e467729ce8d) )
	ROM_LOAD16_BYTE( "95417389.hi", 0x00000, 0x080000, CRC(ba347108) SHA1(e78a3f963ae39fbbc1751370335e5a9034fac47a) )
	ROM_LOAD16_BYTE( "95420132.lo", 0x00001, 0x080000, CRC(76d87518) SHA1(bd21827b69206b6c4cb9ac97bd80759e472bce7d) )
	ROM_LOAD16_BYTE( "95420133.hi", 0x00000, 0x080000, CRC(c2e67303) SHA1(8bdab8dc5544a21c2527dcac5ef055e3134106ea) )
	ROM_LOAD16_BYTE( "95420142.lo", 0x00001, 0x080000, CRC(74478a35) SHA1(daf6257b7efdd620989c062fa645179066315d39) )
	ROM_LOAD16_BYTE( "95420143.hi", 0x00000, 0x080000, CRC(02ce5d1b) SHA1(4d52b0f953d339762d87488c49a827c060681746) )
	ROM_LOAD16_BYTE( "95420144.lo", 0x00001, 0x080000, CRC(5d5003b4) SHA1(d47c6ed8f7c186d53c01166323782576a222ee48) )
	ROM_LOAD16_BYTE( "95420145.hi", 0x00000, 0x080000, CRC(b4d8a5f6) SHA1(4140e2e52e6faa8bedeacdd1c3cc3d67708ce12d) )
	ROM_LOAD16_BYTE( "95420154.lo", 0x00001, 0x080000, CRC(9fbc7014) SHA1(4e710a91501bc63bdc0dc4a13d5decfa241ebfa7) )
	ROM_LOAD16_BYTE( "95420155.hi", 0x00000, 0x080000, CRC(1eedeb0f) SHA1(dae2fcfb38e85117023555ef62281af83ae4900c) )
	ROM_LOAD16_BYTE( "95421132.lo", 0x00001, 0x080000, CRC(6bcb4a83) SHA1(b67cbb9f632de3c82a22b0aa73ca4aff2c2b2c78) )
	ROM_LOAD16_BYTE( "95421133.hi", 0x00000, 0x080000, CRC(27c3abbc) SHA1(14cf53851597267d3e86254d0a21f0e2abbf9bba) )
	ROM_LOAD16_BYTE( "95421142.lo", 0x00001, 0x080000, CRC(68328252) SHA1(4b233adf661135d7e2bf35fca115b58648f3a58b) )
	ROM_LOAD16_BYTE( "95421143.hi", 0x00000, 0x080000, CRC(ff55c3b8) SHA1(558059252a59ade38b8686fde6ffc9e6c3153fad) )
	ROM_LOAD16_BYTE( "95421144.lo", 0x00001, 0x080000, CRC(cb267fff) SHA1(0c06432f5ca41227293ed281b87f717e72f59ba8) )
	ROM_LOAD16_BYTE( "95421145.hi", 0x00000, 0x080000, CRC(4dfac3ec) SHA1(68036cd8521130081a999d9cd3a01cb27b5a437b) )
	ROM_LOAD16_BYTE( "95421154.lo", 0x00001, 0x080000, CRC(66098ecf) SHA1(86b5971d26ec95440170508e7a6dc6cbfc6b3b19) )
	ROM_LOAD16_BYTE( "95421155.hi", 0x00000, 0x080000, CRC(fc87ee07) SHA1(d979843995213a0a6f6efede741309cdcdaba231) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008515.bin", 0x0000, 0x0ab5c3, CRC(70cd8480) SHA1(2da34a0c1d9d84471005f5d6491499e707c0b0d4) )
	ROM_LOAD( "95008958.bin", 0x0000, 0x0435d3, CRC(31ffdb64) SHA1(e48cfa2e5b158555b4ba204fc1175810b81cbbed) )
	ROM_LOAD( "95008992.bin", 0x0000, 0x0aa536, CRC(aad10089) SHA1(d8a32f66432ee901be05435e8930d3897f4b4e33) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890410.bin", 0x0000, 0x5000, CRC(9588ae1d) SHA1(ae45d9e0272b2b048b99e337def1acfb2524597e) )
	ROM_LOAD( "95890411.bin", 0x0000, 0x5000, CRC(895e5ea1) SHA1(070df49baca709f69fa1e522b21e42b716af0ba5) )
	ROM_LOAD( "95890412.bin", 0x0000, 0x5000, CRC(4a047c31) SHA1(aeb969801c89b60a644b4ffc2e1bbb73f6d61643) )
ROM_END




ROM_START( sc_ggcas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406766.lo", 0x00001, 0x080000, CRC(7aead8cd) SHA1(ff75939c2ae19163e15eecd81200f9fa17998cbc) )
	ROM_LOAD16_BYTE( "95406767.hi", 0x00000, 0x080000, CRC(7003bb2e) SHA1(20a7b0b4c85ee99d72e6296d3a905fab0a5a1d69) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406770.lo", 0x00001, 0x080000, CRC(08c703cf) SHA1(c99ff567af7dd3b75d8041147d994d7c8da4dfb8) )
	ROM_LOAD16_BYTE( "95406771.hi", 0x00000, 0x080000, CRC(7b278ba8) SHA1(ec46ac2bc35a477d816b34b42f943e0e2d0c66b0) )
	ROM_LOAD16_BYTE( "95406772.lo", 0x00001, 0x080000, CRC(0ae6fcff) SHA1(1aeaa2f55fd72386f4379c1160b0f3f0167ffc86) )
	ROM_LOAD16_BYTE( "95406773.hi", 0x00000, 0x080000, CRC(05c35548) SHA1(cfa131c6e1480ef9a8e5304fa242e3a843937de7) )
	ROM_LOAD16_BYTE( "95407766.lo", 0x00001, 0x080000, CRC(f2dee74f) SHA1(9afc799b699dda20a3e91a4e392d705dbe11fc83) )
	ROM_LOAD16_BYTE( "95407767.hi", 0x00000, 0x080000, CRC(d577ccad) SHA1(fb82a45bbe900bad2149986e5df69d236915982f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_gnc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408052.lo", 0x00001, 0x080000, CRC(fea41987) SHA1(0012decf9467db65e7fc5a957909c8bd3223df3f) )
	ROM_LOAD16_BYTE( "95408053.hi", 0x00000, 0x080000, CRC(2794c569) SHA1(9b7bf233fdf3c475ef5617e78b7002dc3fcbf416) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408392.lo", 0x00001, 0x080000, CRC(0b15aa9c) SHA1(ae15977b13a16f56ab0b38f9a2f3c058ce9fb86a) )
	ROM_LOAD16_BYTE( "95408393.hi", 0x00000, 0x080000, CRC(115ad467) SHA1(8a89c579da9e43b53230d6bf026150b810ca1372) )
	ROM_LOAD16_BYTE( "95409052.lo", 0x00001, 0x080000, CRC(0b36a055) SHA1(52dbbc7727e27c7cb802aba46a3b14859feb3b77) )
	ROM_LOAD16_BYTE( "95409053.hi", 0x00000, 0x080000, CRC(73fce66c) SHA1(c0a5a238a654944875802a088de50c66ad00776d) )
	ROM_LOAD16_BYTE( "95409392.lo", 0x00001, 0x080000, CRC(87c6be05) SHA1(c15c14d8ca25674ef8f7d7f8a287c57ca75889e4) )
	ROM_LOAD16_BYTE( "95409393.hi", 0x00000, 0x080000, CRC(c2474cbe) SHA1(33fe7d07bf7945035e84560b0c6cb8f3a2c7a9dc) )
	ROM_LOAD16_BYTE( "95410358.lo", 0x00001, 0x080000, CRC(75a784dc) SHA1(c53575e3406a6de2e59ac3ae6a14d936d773316b) )
	ROM_LOAD16_BYTE( "95410359.hi", 0x00000, 0x080000, CRC(5d0694fe) SHA1(a4561e12fd221f07dcac9061bba7eadb012b8578) )
	ROM_LOAD16_BYTE( "95411358.lo", 0x00001, 0x080000, CRC(121e42db) SHA1(16f5b557aad85e426a30341e830c1b39d7ebc045) )
	ROM_LOAD16_BYTE( "95411359.hi", 0x00000, 0x080000, CRC(aef8cea0) SHA1(04472d96d7796f00ddf1d25a228c0806797906f7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_ghost )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416694.lo", 0x00001, 0x080000, CRC(39c14d15) SHA1(10722511af8aeac80e48c8910ee6a7c3dd0cbaf9) )
	ROM_LOAD16_BYTE( "95416695.hi", 0x00000, 0x080000, CRC(2de60335) SHA1(8249afd9237d7ad8c6643a93084768edf66e3971) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416696.lo", 0x00001, 0x080000, CRC(e227eef0) SHA1(a7164790b7cd8fc4522e4a90e193b9e5e00b757d) )
	ROM_LOAD16_BYTE( "95416697.hi", 0x00000, 0x080000, CRC(ed085935) SHA1(459befa07a553c31021c84392a31c93ff633112e) )
	ROM_LOAD16_BYTE( "95416754.lo", 0x00001, 0x080000, CRC(d5a70201) SHA1(025bca73253c6d3a716892d40c590c1ca70831a1) )
	ROM_LOAD16_BYTE( "95416755.hi", 0x00000, 0x080000, CRC(926c7df5) SHA1(79fd13d6f4fc0d9d1f308db6b7793313d2513e26) )
	ROM_LOAD16_BYTE( "95416782.lo", 0x00001, 0x080000, CRC(240534ce) SHA1(9d82334bc7472219b88962fe40afa9030b7c01ab) )
	ROM_LOAD16_BYTE( "95416783.hi", 0x00000, 0x080000, CRC(6c7f4033) SHA1(38c8527392647423124099c32725aadd6b0f0482) )
	ROM_LOAD16_BYTE( "95416958.lo", 0x00001, 0x080000, CRC(1b587f98) SHA1(37242dc9611de47f80fca32a4f35ac69b69bfa0d) )
	ROM_LOAD16_BYTE( "95416959.hi", 0x00000, 0x080000, CRC(6a722439) SHA1(5eeaefde3eb2978aee6578b96e92d9cb402d6ebf) )
	ROM_LOAD16_BYTE( "95417694.lo", 0x00001, 0x080000, CRC(7e730d77) SHA1(e431deefcadcb36c7732f947b52ad882f84a40ea) )
	ROM_LOAD16_BYTE( "95417695.hi", 0x00000, 0x080000, CRC(48435e53) SHA1(227feaca9cb35f04c3947f1891320ecb7f98389d) )
	ROM_LOAD16_BYTE( "95417754.lo", 0x00001, 0x080000, CRC(f15a8c51) SHA1(8219edf45a1d0c001c2902e6f0849dc0aa9ffa14) )
	ROM_LOAD16_BYTE( "95417755.hi", 0x00000, 0x080000, CRC(39ffcf6f) SHA1(3c50ce386c8d1f037890af3ce1528e30efdfba84) )
	ROM_LOAD16_BYTE( "95417782.lo", 0x00001, 0x080000, CRC(742e0f21) SHA1(0c7589cb2db52f00b42157b21ba79dd9e7d24185) )
	ROM_LOAD16_BYTE( "95417783.hi", 0x00000, 0x080000, CRC(54971536) SHA1(7fdf1fc4a0d661319e4e4668ad70ff2d0ad282e5) )
	ROM_LOAD16_BYTE( "95417958.lo", 0x00001, 0x080000, CRC(a0281b11) SHA1(cc952039d2ae9117ee9b25e718b1cfa1a6a44056) )
	ROM_LOAD16_BYTE( "95417959.hi", 0x00000, 0x080000, CRC(b69f2462) SHA1(5a17d135c94d78a8cf45b53a7d143ab3d41ba013) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008594.bin", 0x0000, 0x0b2ad7, CRC(3f7767d0) SHA1(b7ca39a42b59d1ac2088412fbb5f987b68f0189a) )
ROM_END



ROM_START( sc_ggrid )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408318.odd", 0x00001, 0x080000, CRC(6de26970) SHA1(fe43e4ed9aa2b8843db987f47dbe3a9b3bf78fda) )
	ROM_LOAD16_BYTE( "95408319.evn", 0x00000, 0x080000, CRC(a618fc9f) SHA1(320125c222163eef03b4fb3f663871c22fc4ff61) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408320.odd", 0x00001, 0x080000, CRC(e03bfaa5) SHA1(a85b3198fede56182d4c6a8f66737a43620ad94a) )
	ROM_LOAD16_BYTE( "95408321.evn", 0x00000, 0x080000, CRC(84270b86) SHA1(c78f4c939810bd83832a3bb54e6bf51b5393c741) )
	ROM_LOAD16_BYTE( "95408524.odd", 0x00001, 0x080000, CRC(19a1d2d0) SHA1(e90cb1c7eee650887510d68094a4f0109469809b) )
	ROM_LOAD16_BYTE( "95408525.evn", 0x00000, 0x080000, CRC(ed20b2b2) SHA1(dbd4119eb72c1304b20839a0ebfa6da0aa0320ae) )
	ROM_LOAD16_BYTE( "95408526.odd", 0x00001, 0x080000, CRC(173460df) SHA1(dc7dfd9a004d262c1935e0fed2cb9fb6463637be) )
	ROM_LOAD16_BYTE( "95408527.evn", 0x00000, 0x080000, CRC(292672a2) SHA1(60aa190df0c5565eb6b2143e74b9cb106235f87c) )
	ROM_LOAD16_BYTE( "95408936.odd", 0x00001, 0x080000, CRC(dc598886) SHA1(2ec6cee160b25033421881f5f76f366619ef0f8b) )
	ROM_LOAD16_BYTE( "95408937.evn", 0x00000, 0x080000, CRC(bbf36c44) SHA1(317726644cbced27d89087bd7b58de446c93bbd5) )
	ROM_LOAD16_BYTE( "95409318.odd", 0x00001, 0x080000, CRC(04527589) SHA1(f1eef3602e819ce19f2ce7fb9d4b4eeaa513eabc) )
	ROM_LOAD16_BYTE( "95409319.evn", 0x00000, 0x080000, CRC(f2ef89a2) SHA1(e6863ef9ed5cb0d43ae9443b6f79fe31e72b177e) )
	ROM_LOAD16_BYTE( "95409320.odd", 0x00001, 0x080000, CRC(898be65c) SHA1(5086970ee8a95ccd9d291dbf1ac56abec340aab7) )
	ROM_LOAD16_BYTE( "95409321.evn", 0x00000, 0x080000, CRC(d0d07ebb) SHA1(b2f63f3860e904ce138819474b30a851cad52007) )
	ROM_LOAD16_BYTE( "95409524.odd", 0x00001, 0x080000, CRC(ebdf54c8) SHA1(9e311f79c2d9bc2883f42a0543b49991ba4930bf) )
	ROM_LOAD16_BYTE( "95409525.evn", 0x00000, 0x080000, CRC(81a0c4b2) SHA1(5a167834e657348523d6d421b3926c2f7d947020) )
	ROM_LOAD16_BYTE( "95409526.odd", 0x00001, 0x080000, CRC(e54ae6c7) SHA1(b71de332efaf2f4340918b2f0fd932c6f772248e) )
	ROM_LOAD16_BYTE( "95409527.evn", 0x00000, 0x080000, CRC(45a604a2) SHA1(41fa4fc68585b5a5e8915d54fc269e87ec414743) )
	ROM_LOAD16_BYTE( "95410768.odd", 0x00001, 0x080000, CRC(b0badd85) SHA1(5a38c6a3f5cc99d5af0d659d6e61c99d259f4843) )
	ROM_LOAD16_BYTE( "95410769.evn", 0x00000, 0x080000, CRC(32a4e1bb) SHA1(45ff4a4a432bad8208ad4027d70b3ec635791e61) )
	ROM_LOAD16_BYTE( "95410770.odd", 0x00001, 0x080000, CRC(de71458e) SHA1(1541d3b52d79b2b18d1413fc01a9f83439382a05) )
	ROM_LOAD16_BYTE( "95410771.evn", 0x00000, 0x080000, CRC(1b822802) SHA1(bea0a4d3f285c080ea7d5b7b0a00a8f598923685) )
	ROM_LOAD16_BYTE( "95411768.odd", 0x00001, 0x080000, CRC(f40284a1) SHA1(f6a13523ff5f63f8664624118b00dc32edcd8f92) )
	ROM_LOAD16_BYTE( "95411769.evn", 0x00000, 0x080000, CRC(c327e305) SHA1(84c8e0f3516a2f0b81e874f814390407dacf50aa) )
	ROM_LOAD16_BYTE( "95411770.odd", 0x00001, 0x080000, CRC(7c2ba1dc) SHA1(1f639e88f216564b4b95c78fa3e48f233d5921b0) )
	ROM_LOAD16_BYTE( "95411771.evn", 0x00000, 0x080000, CRC(59990fa4) SHA1(5e25f3c487f4971e74a814fefd84d7b1aba54d04) )
	ROM_LOAD16_BYTE( "95414696.odd", 0x00001, 0x080000, CRC(ab6c313c) SHA1(36b1b3917a049088c05f2cdce53f7d851d6be5e6) )
	ROM_LOAD16_BYTE( "95414697.evn", 0x00000, 0x080000, CRC(68c70d54) SHA1(eaec9da8bf9a849925e85e3cfd66c632da2e282f) )
	ROM_LOAD16_BYTE( "95415696.odd", 0x00001, 0x080000, CRC(64d6a62b) SHA1(23c999542004aaf100cd05919138b27f56b2c0c1) )
	ROM_LOAD16_BYTE( "95415697.evn", 0x00000, 0x080000, CRC(cc12809f) SHA1(68925025498630b57d23ecc92ad7e8221525d12b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008346.bin", 0x0000, 0x0e486b, CRC(1ec79154) SHA1(d6aff554e882e6f689caed383db79c752c9e672b) )
ROM_END




ROM_START( sc_ggcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410136.odd", 0x00001, 0x080000, CRC(b833c07d) SHA1(d3eba62f20ae0d72df9ec52ade3b958539046f57) )
	ROM_LOAD16_BYTE( "95410137.evn", 0x00000, 0x080000, CRC(b6b100d7) SHA1(a44bde13b49c975018381c0813ba81d57ae996ca) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410906.odd", 0x00001, 0x080000, CRC(3b662c9d) SHA1(905d24b6d7fc025131df5589566ab6b1ec946208) )
	ROM_LOAD16_BYTE( "95410907.evn", 0x00000, 0x080000, CRC(b4e1e4e9) SHA1(6ba91db947a9bc991d3e04f946973440be043a6d) )
	ROM_LOAD16_BYTE( "95411906.odd", 0x00001, 0x080000, CRC(359d3081) SHA1(cd471e8dde352f361a7d21bc160ff1edeec140b2) )
	ROM_LOAD16_BYTE( "95411907.evn", 0x00000, 0x080000, CRC(1ed3ac3b) SHA1(4a2697d7a8092f8f84d51e76a46d85b4559553a7) )
	ROM_LOAD16_BYTE( "95412160.odd", 0x00001, 0x080000, CRC(30861779) SHA1(c722bb4e074298f8c9bee05d0bd5778bcedb10b8) )
	ROM_LOAD16_BYTE( "95412161.evn", 0x00000, 0x080000, CRC(797565dc) SHA1(79f4331904267c45fd41d41871a06352e78f01d7) )
	ROM_LOAD16_BYTE( "95413160.odd", 0x00001, 0x080000, CRC(ea99ee09) SHA1(a319083b848fd433d5b3ebc2b41ec80e181ac782) )
	ROM_LOAD16_BYTE( "95413161.evn", 0x00000, 0x080000, CRC(4f7af5c0) SHA1(a86f11fa1692a552229a5ec7213c69f385ab9e33) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008400.bin", 0x0000, 0x0e486b, CRC(78704d20) SHA1(c5f62434785b10d2bff5bcf415c2236b4f1ee551) )
	ROM_LOAD( "95410136.bin", 0x0000, 0x100000, CRC(4fec2f97) SHA1(0415c26bc043ffded1325bb28b12086c1e13f161) )
ROM_END




ROM_START( sc_goldo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95401621.lo", 0x00001, 0x080000, CRC(9999b865) SHA1(99ff2ed2b73abf278c5c7253702b6cb654c9a946) )
	ROM_LOAD16_BYTE( "95401622.hi", 0x00000, 0x080000, CRC(3075719d) SHA1(392d5fdce4253e0cc88cb0f283605a2b189aa792) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95401639.lo", 0x00001, 0x080000, CRC(b19dd39d) SHA1(418d6d97036072c2ecb48167878c07f2c9549103) )
	ROM_LOAD16_BYTE( "95401640.hi", 0x00000, 0x080000, CRC(4863dc90) SHA1(e5ce472e04c135d3553de66bd34d8b436ef6bd71) )
	ROM_LOAD16_BYTE( "95401645.lo", 0x00001, 0x080000, CRC(9c334258) SHA1(2da7df5fb8fc07128a5f2a0416a070f7f1fc846c) )
	ROM_LOAD16_BYTE( "95401646.hi", 0x00000, 0x080000, CRC(fc55479b) SHA1(c19c70e51ca6dd850afd2d1527af89939a2630fb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004165.bin", 0x0000, 0x080000, CRC(c52f4218) SHA1(2648f3ef35d68bdd14a0a773151157dae0271067) )
	ROM_LOAD( "95004166.bin", 0x0000, 0x080000, CRC(a77f1337) SHA1(e292c87fa8e643846cc0ddd7b9a585429b7efdd6) )
ROM_END




ROM_START( sc_gocas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400623.lo", 0x00001, 0x080000, CRC(51a41329) SHA1(af87c760715996fd5b52a8a45e1bcb6f7f7747bd) )
	ROM_LOAD16_BYTE( "95400624.hi", 0x00000, 0x080000, CRC(f04779ce) SHA1(2268e8502e265a62dbfc6a7d3b64847a2ba0e370) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95401623.lo", 0x00001, 0x080000, CRC(623d6dd3) SHA1(fede0f19764927ee45f2b167c33e73dd3e4e540d) )
	ROM_LOAD16_BYTE( "95401624.hi", 0x00000, 0x080000, CRC(d3e74fd9) SHA1(0d3c1c264290727cf01e6f9f6bec43e52423917c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_gshot )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416228.odd", 0x00001, 0x080000, CRC(b8e2b203) SHA1(586be00bc166003705af43d8bb48102e93bb40ea) )
	ROM_LOAD16_BYTE( "95416229.evn", 0x00000, 0x080000, CRC(96d6b36b) SHA1(3d4544805a2c38a42a9eccb3456a7956da506e23) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416230.lo", 0x00001, 0x080000, CRC(54f4f94d) SHA1(9fb208cda0d963bce229f52fce6b8d44abd98a35) )
	ROM_LOAD16_BYTE( "95416231.hi", 0x00000, 0x080000, CRC(b8893573) SHA1(16037c6aa3b44ab4d49a8cddef16a347b6e0c84c) )
	ROM_LOAD16_BYTE( "95417228.odd", 0x00001, 0x080000, CRC(a087308c) SHA1(5fbe69cbfa177d86351254b30fa8a5a95a3ad726) )
	ROM_LOAD16_BYTE( "95417229.evn", 0x00000, 0x080000, CRC(113c5e8f) SHA1(56c303ff2e7a110c7cc08a720e1ec307892807ce) )
	ROM_LOAD16_BYTE( "95417230.odd", 0x00001, 0x080000, CRC(fab286d5) SHA1(f215bfd5449de3fcda604a0a764c390fc2b55496) )
	ROM_LOAD16_BYTE( "95417231.evn", 0x00000, 0x080000, CRC(98f5a1cc) SHA1(7d16ccdfa5f84ec7a5e7c759c7665d9130ccbfd3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008904.bin", 0x0000, 0x0b32a1, CRC(6e11054e) SHA1(45ff06ce84cf1675747976b11e144a43d96977ac) )
ROM_END




ROM_START( sc_goldw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408416.lo", 0x00001, 0x080000, CRC(0ba687f0) SHA1(503756236a3e215b38e439d6d2833730cdd866e9) )
	ROM_LOAD16_BYTE( "95408417.hi", 0x00000, 0x080000, CRC(722a756e) SHA1(afbf108239484c177ead3925d990ca45b33951ca) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409416.lo", 0x00001, 0x080000, CRC(ae198161) SHA1(15ab3284ae508b896129b7474b1f506a73bca982) )
	ROM_LOAD16_BYTE( "95409417.hi", 0x00000, 0x080000, CRC(3f776d99) SHA1(a58c91d2293ed54d2c7ec2ab0eeacb0b16c562e6) )
	ROM_LOAD16_BYTE( "958402.11 10p no enrich.bin", 0x0000, 0x008000, CRC(00ed0ab4) SHA1(60e6a4abcf74ed705007cda699cdf8f52160a683) )
	ROM_LOAD16_BYTE( "958402.12 10p no enrich.bin", 0x0000, 0x008000, CRC(51af0108) SHA1(e6333e2879f7b2b3b558b6909e177f3101f503e6) )
	ROM_LOAD16_BYTE( "p1431p11.hi", 0x00000, 0x080000, CRC(93910114) SHA1(afb3a756a9667401dbb4299c09139769275a1603) )
	ROM_LOAD16_BYTE( "p1431p11.lo", 0x00001, 0x080000, CRC(636c0743) SHA1(7e5ab61193ee3b387462205a06a9fc386f8fd81d) )
	ROM_LOAD16_BYTE( "p1431s11.hi", 0x00000, 0x080000, CRC(93c51760) SHA1(a3613d5c257772e7c3e02485eb859d306a316625) )
	ROM_LOAD16_BYTE( "p1431s11.lo", 0x00001, 0x080000, CRC(2228a427) SHA1(61133938b6389478833bac49228888d0e27a91a8) )
	ROM_LOAD16_BYTE( "p1437p41.hi", 0x00000, 0x080000, CRC(d5e38e06) SHA1(85be2c45747ee2e80614cd455ea6525e89c53de6) )
	ROM_LOAD16_BYTE( "p1437p41.lo", 0x00001, 0x080000, CRC(c31f15ff) SHA1(57247c02adc0e8f2826f11f6a80ccda1f668b274) )
	ROM_LOAD16_BYTE( "p1437p51.hi", 0x00000, 0x080000, CRC(d0bcbd31) SHA1(21700e771355776ea3b87113ac4f6b4e55732392) )
	ROM_LOAD16_BYTE( "p1437p51.lo", 0x00001, 0x080000, CRC(62378c3e) SHA1(0f5dc74b1ac4b294d3dac34e303d8a1de1001046) )
	ROM_LOAD16_BYTE( "p1437s41.hi", 0x00000, 0x080000, CRC(73f7f759) SHA1(6ef14b597ce94693f5db7f1b13daf91f218147a4) )
	ROM_LOAD16_BYTE( "p1437s41.lo", 0x00001, 0x080000, CRC(f49e4698) SHA1(1580070484c998175921f93fd0be2c12e1e7fefc) )
	ROM_LOAD16_BYTE( "p1437s51.hi", 0x00000, 0x080000, CRC(76a8c46e) SHA1(8bd5e7806bd03ef3b17a3b7291049fdc1708ef07) )
	ROM_LOAD16_BYTE( "p1437s51.lo", 0x00001, 0x080000, CRC(55b6df59) SHA1(6ce2dd23078a9411d8937f1e27f59e6fc337e406) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008356.bin", 0x0000, 0x080000, CRC(c8f1ca20) SHA1(13136df35c09fea102c5176e249436f9e64616a5) )
	ROM_LOAD( "95008423.bin", 0x0000, 0x100000, CRC(4cab20ee) SHA1(e27221a94e54db340eaf7fc30e722b354c85686d) )
ROM_END




ROM_START( sc_gx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400965.lo", 0x00001, 0x080000, CRC(24f32a91) SHA1(5bb3ebb618ccbc31ead3a740a4920d2a5758d8ff) )
	ROM_LOAD16_BYTE( "95400966.hi", 0x00000, 0x080000, CRC(482551a8) SHA1(64a85c2ed6ffd30dbca792fcad8c1d71276a7060) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404506.lo", 0x00001, 0x080000, CRC(a5ae17f5) SHA1(10b9b4107b4d4667852b12185923cd1daac40930) )
	ROM_LOAD16_BYTE( "95404507.hi", 0x00000, 0x080000, CRC(d9da7d19) SHA1(313724aa544d660f5bf9c9fa8cf9042c621590dc) )
	ROM_LOAD16_BYTE( "95405506.lo", 0x00001, 0x080000, CRC(a18a6c36) SHA1(e19b1e7e8855c558ad016eed0e0dbd1506c0a6cc) )
	ROM_LOAD16_BYTE( "95405507.hi", 0x00000, 0x080000, CRC(ce0883f2) SHA1(0969f95cbce2639f7b8be96fd5691e2960781e16) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004185", 0x0000, 0x080000, CRC(86756ea2) SHA1(86180e038a9bb3a3a700af1ddc571794e6948165) )
ROM_END




ROM_START( sc_gxcas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400965.lo", 0x00001, 0x080000, CRC(24f32a91) SHA1(5bb3ebb618ccbc31ead3a740a4920d2a5758d8ff) )
	ROM_LOAD16_BYTE( "95400966.hi", 0x00000, 0x080000, CRC(482551a8) SHA1(64a85c2ed6ffd30dbca792fcad8c1d71276a7060) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400967.lo", 0x00001, 0x080000, CRC(efd704bf) SHA1(11e73d0966caace5d8b7889a6d829848612bc22f) )
	ROM_LOAD16_BYTE( "95400968.hi", 0x00000, 0x080000, CRC(c78378e6) SHA1(a9bccac373f4626ecaac4ea1a25d618471497d32) )
	ROM_LOAD16_BYTE( "95401965.lo", 0x00001, 0x080000, CRC(4dc1eb17) SHA1(bf9ce47cf86798c693d8f35c4039f52a49c473e5) )
	ROM_LOAD16_BYTE( "95401966.hi", 0x00000, 0x080000, CRC(1235e18c) SHA1(fd6dd2166d635988b82cf25b346205d33ee5986d) )
	ROM_LOAD16_BYTE( "95401967.lo", 0x00001, 0x080000, CRC(ef4eb480) SHA1(ef1394868aa7e516d70c0742c481685d6325470f) )
	ROM_LOAD16_BYTE( "95401968.hi", 0x00000, 0x080000, CRC(7afc98e7) SHA1(c6128ab36d227cda3a552ed740d7308651c42df2) )
	ROM_LOAD16_BYTE( "95401969.lo", 0x00001, 0x080000, CRC(8679a51f) SHA1(ccf0d3b6008fa3a5aa802bd987523eb8f8ae8898) )
	ROM_LOAD16_BYTE( "95401970.hi", 0x00000, 0x080000, CRC(6143c28a) SHA1(1458e1b1784d1aa1c1ca4dabde8362ddf6c8f0b2) )
	ROM_LOAD16_BYTE( "95406414.lo", 0x00001, 0x080000, CRC(00ec6327) SHA1(95533c2653c09a5badd165dd475a79599e407e07) )
	ROM_LOAD16_BYTE( "95406415.hi", 0x00000, 0x080000, CRC(419314e8) SHA1(04d5e6f4d29fa6cd219cf24c901e61699c038b17) )
	ROM_LOAD16_BYTE( "95407414.lo", 0x00001, 0x080000, CRC(4b33fec9) SHA1(0a4cab128ae980aa72e06a507a127dec49dcafb1) )
	ROM_LOAD16_BYTE( "95407415.hi", 0x00000, 0x080000, CRC(3ac19c03) SHA1(cb0f797ade8d6f812fa771d2f61b8d04d4a4a609) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004185", 0x0000, 0x080000, CRC(86756ea2) SHA1(86180e038a9bb3a3a700af1ddc571794e6948165) )
ROM_END




ROM_START( sc_gx3 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406838.lo", 0x00001, 0x080000, CRC(affe53c0) SHA1(70f08858126842e52cee1de9938dd5a0efa349c7) )
	ROM_LOAD16_BYTE( "95406839.hi", 0x00000, 0x080000, CRC(6ef1f574) SHA1(9005d34dbf43cfe6d657944bccf5060c82ea9359) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406840.lo", 0x00001, 0x080000, CRC(1a9d8d9a) SHA1(7ec948b9031232015137b16b7e90f4884b856a69) )
	ROM_LOAD16_BYTE( "95406841.hi", 0x00000, 0x080000, CRC(7f5c4b78) SHA1(6370d009fdd41e491fd681d6f73f83fee62e2ba4) )
	ROM_LOAD16_BYTE( "95406842.lo", 0x00001, 0x080000, CRC(2bc5dc58) SHA1(59db45be261c64c44ca9c2e9cdb7b0112b6f7e3b) )
	ROM_LOAD16_BYTE( "95406843.hi", 0x00000, 0x080000, CRC(f0c1edb0) SHA1(2c1ba2ae57c124c4958de940e0144d3fd1eb9271) )
	ROM_LOAD16_BYTE( "95406844.lo", 0x00001, 0x080000, CRC(cb93e0d8) SHA1(585a4fb6445d0f7254406334a6d98a012923ffd1) )
	ROM_LOAD16_BYTE( "95406845.hi", 0x00000, 0x080000, CRC(ddf94be9) SHA1(8e20822f93f01db6a676c8f017bfc43110f6a968) )
	ROM_LOAD16_BYTE( "95407838.lo", 0x00001, 0x080000, CRC(a0c6f51e) SHA1(3b1247794e15fbac08442f30440c583727e50878) )
	ROM_LOAD16_BYTE( "95407839.hi", 0x00000, 0x080000, CRC(c621b37e) SHA1(1f053eea3f494450284c4a7a5136978c2051166a) )
	ROM_LOAD16_BYTE( "95407840.lo", 0x00001, 0x080000, CRC(0698a60f) SHA1(97a7291e50530336d9775d1526dbb3e05fdbb72d) )
	ROM_LOAD16_BYTE( "95407841.hi", 0x00000, 0x080000, CRC(2a959235) SHA1(163fe57c0f51d00034b5c1609611a5770bf47686) )
	ROM_LOAD16_BYTE( "95407842.lo", 0x00001, 0x080000, CRC(acd3068e) SHA1(c0fc0493acf77a56333b3f12f312ae2e951c6ad3) )
	ROM_LOAD16_BYTE( "95407843.hi", 0x00000, 0x080000, CRC(89ee3dbb) SHA1(177e02e3702cb7d229b2a19fc64370573baa3668) )
	ROM_LOAD16_BYTE( "95407844.lo", 0x00001, 0x080000, CRC(fa8ec856) SHA1(25c4b5f71000515ef75bdbb93cfcc330ed264983) )
	ROM_LOAD16_BYTE( "95407845.hi", 0x00000, 0x080000, CRC(3471ded5) SHA1(2039b862bc23436ef8579a3b5a314a4a34e15608) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_goud )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406468.lo", 0x00001, 0x080000, CRC(b3b7de39) SHA1(c7e5cb4327e6f247baeceda6e814858299309f9d) )
	ROM_LOAD16_BYTE( "95406469.hi", 0x00000, 0x080000, CRC(a0d912fa) SHA1(9d444227f8b8d161600e92dd38f31cf380100369) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004288.sn1", 0x0000, 0x080000, CRC(ae6d0680) SHA1(467d0127e2a63ca031ebf2816dde99273b513913) )
	ROM_LOAD( "95004289.sn2", 0x0000, 0x080000, CRC(9c88f3c8) SHA1(1152077f59cc28726f1428a9fdaf2c92ddef6c73) )
ROM_END




ROM_START( sc_gag )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400381.lo", 0x00001, 0x080000, CRC(d1eed62d) SHA1(21e69bd5153c9839c18a3ef16a395ac9b2723e1b) )
	ROM_LOAD16_BYTE( "95400382.hi", 0x00000, 0x080000, CRC(06625ae8) SHA1(6005098914fb248c2a96bec7e867bc2a70bdbf46) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400619.lo", 0x00001, 0x080000, CRC(b56f01da) SHA1(42e9160909d2861935b3bfb10b46eb9689e26f28) )
	ROM_LOAD16_BYTE( "95400620.hi", 0x00000, 0x080000, CRC(ae208c83) SHA1(1b76de915352fb12ff14d8d88aa2e43876700e01) )
	ROM_LOAD16_BYTE( "95401383.lo", 0x00001, 0x080000, CRC(5d29d7d0) SHA1(625136fce9f971b5813865a02464b449a5b15c8c) )
	ROM_LOAD16_BYTE( "95401384.hi", 0x00000, 0x080000, CRC(ae3787d9) SHA1(449e3d0d8e74f27bda6c9d8faa04fdd6e9ac44fd) )
	ROM_LOAD16_BYTE( "95401619.lo", 0x00001, 0x080000, CRC(53a162d3) SHA1(478003404707f5d0d6edf484242a9d93d19b909f) )
	ROM_LOAD16_BYTE( "95401620.hi", 0x00000, 0x080000, CRC(f835f766) SHA1(0523b5e94caad7c54d00a1daac0e2d923e6604d4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004132.1_1", 0x0000, 0x080000, CRC(17320a32) SHA1(113ab1db5227fe17053969dd98f94f0b3b7555f5) )
	ROM_LOAD( "95004132.1_2", 0x0000, 0x080000, CRC(03593875) SHA1(a5f6730664b1bbfdb7b98b41379e9b240f43c53c) )
ROM_END



ROM_START( sc_gcb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416202.lo", 0x00001, 0x080000, CRC(cc3bf680) SHA1(9eb5ef3ef9f54f9586eea3896c5c5503df3509c4) )
	ROM_LOAD16_BYTE( "95416203.hi", 0x00000, 0x080000, CRC(6b80152e) SHA1(9da9f4d9e84e9e4706a16770f307d99368af7293) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416204.lo", 0x00001, 0x080000, CRC(3ad1f80f) SHA1(55588937af95664f42b8e0c919782c977e47cf41) )
	ROM_LOAD16_BYTE( "95416205.hi", 0x00000, 0x080000, CRC(aafa7c22) SHA1(3e6f62448a630b76835081aec6df01cd746a902a) )
	ROM_LOAD16_BYTE( "95416250.lo", 0x00001, 0x080000, CRC(eaebc504) SHA1(3d0f913ac5a82099b5061ae9d22da106ad74adb3) )
	ROM_LOAD16_BYTE( "95416251.hi", 0x00000, 0x080000, CRC(3f48ac28) SHA1(7aff6aba17e5541ba947d4cea29768bd6c7a35a8) )
	ROM_LOAD16_BYTE( "95416252.lo", 0x00001, 0x080000, CRC(f04cb098) SHA1(dc3dbf2e01b34317e41df6aa5ca4fb5e890e7b2e) )
	ROM_LOAD16_BYTE( "95416253.hi", 0x00000, 0x080000, CRC(53fe6b01) SHA1(15ad70286dfccce999076f9b4b948bfc91bae80d) )
	ROM_LOAD16_BYTE( "95416358.lo", 0x00001, 0x080000, CRC(1fbfbe2d) SHA1(95a605f9ae2648ca1b7dc84a3125f2be3552536d) )
	ROM_LOAD16_BYTE( "95416359.hi", 0x00000, 0x080000, CRC(6c0a35b5) SHA1(63c48613ba132fe449cb3b46e7501d38b195db24) )
	ROM_LOAD16_BYTE( "95416362.lo", 0x00001, 0x080000, CRC(0d7707a5) SHA1(10f3b3a1da9949aac0f0603528fe8bb2228e1f72) )
	ROM_LOAD16_BYTE( "95416363.hi", 0x00000, 0x080000, CRC(f23a9e15) SHA1(e9006a5e6499750a3bb7396a71eeb39596e46912) )
	ROM_LOAD16_BYTE( "95417202.lo", 0x00001, 0x080000, CRC(08f5f698) SHA1(a79c1ea1b2d31685fb4fdd6af56decfb47e01f75) )
	ROM_LOAD16_BYTE( "95417203.hi", 0x00000, 0x080000, CRC(cf5598e5) SHA1(a48ad625fa3a25a1212d117f9d7a7538e24c07de) )
	ROM_LOAD16_BYTE( "95417204.lo", 0x00001, 0x080000, CRC(4f9f5cda) SHA1(71b91e8ff66b7aa65a364230da9a307f56913072) )
	ROM_LOAD16_BYTE( "95417205.hi", 0x00000, 0x080000, CRC(ea03555c) SHA1(8baa5f4bd4c16ecd314e51418f855b7856d4ab90) )
	ROM_LOAD16_BYTE( "95417250.lo", 0x00001, 0x080000, CRC(2a173447) SHA1(48773d3ef13c90faecd369c456f9e7fe4d98fb53) )
	ROM_LOAD16_BYTE( "95417251.hi", 0x00000, 0x080000, CRC(9639106a) SHA1(c5bd833bdec0d5fb657205116f6a3af525005663) )
	ROM_LOAD16_BYTE( "95417252.lo", 0x00001, 0x080000, CRC(7989fec8) SHA1(bf4b5c1ce09ffda902c486ee71b0fb2ab6db340d) )
	ROM_LOAD16_BYTE( "95417253.hi", 0x00000, 0x080000, CRC(47f03742) SHA1(11eeee14240d4e9ff0dd924e1df457ad6e08f329) )
	ROM_LOAD16_BYTE( "g_b_cash.hi", 0x0000, 0x080000, CRC(1620b7f9) SHA1(67b7f805a7a7c95b27938710158ca5cb070503d0) )
	ROM_LOAD16_BYTE( "g_b_cash.lo", 0x0000, 0x080000, CRC(3471962b) SHA1(45579c4e7fca4eef46488fc4e16cbd76af9a7cae) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_ggg )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95419997.hi", 0x00000, 0x080000, CRC(183005fb) SHA1(78aef9641ff2e4517b546f6316eb6ead5032bc0e) )
	ROM_LOAD16_BYTE( "95420668.lo", 0x00001, 0x080000, CRC(afef1626) SHA1(00d676d0ed36ddf4255d26779b3319f61319a9cb) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420669.hi", 0x00000, 0x080000, CRC(6e273bf4) SHA1(35ba48892d9ea3ebcb00fe33c75ee8e7949ab421) )
	ROM_LOAD16_BYTE( "95420671.hi", 0x00000, 0x080000, CRC(d314c373) SHA1(47b2d10eccc2b25ac3324f5c5b95e9d092e1d2ff) )
	ROM_LOAD16_BYTE( "95420672.lo", 0x00001, 0x080000, CRC(88dd2622) SHA1(dc30308638d602b76e828cf6c98605a9fb7589b6) )
	ROM_LOAD16_BYTE( "95420673.hi", 0x00000, 0x080000, CRC(309a5f9c) SHA1(8592127022c84bc6c36b744d8fa0d44a1bc38ea0) )
	ROM_LOAD16_BYTE( "95420674.lo", 0x00001, 0x080000, CRC(f83a5079) SHA1(f8e6918690bc77288d2097aeb5af4634e5522fb6) )
	ROM_LOAD16_BYTE( "95420675.hi", 0x00000, 0x080000, CRC(ccf7c8ff) SHA1(c3996b17f1fce785e3892e6d5434a1d27b61c6f0) )
	ROM_LOAD16_BYTE( "95420676.lo", 0x00001, 0x080000, CRC(6c841f87) SHA1(873d60cb447529f42d9f4cb0fe05d7c464a10473) )
	ROM_LOAD16_BYTE( "95420677.hi", 0x00000, 0x080000, CRC(afe9543e) SHA1(2c88a0120762372f349c098c8e346626198a7635) )
	ROM_LOAD16_BYTE( "95420678.lo", 0x00001, 0x080000, CRC(5d1d9b26) SHA1(ed9594f794bd582bb54e7c824272b7321b6ae2ef) )
	ROM_LOAD16_BYTE( "95420679.hi", 0x00000, 0x080000, CRC(910215de) SHA1(5e3d9ab721ea008e33754ac8237f82c106114364) )
	ROM_LOAD16_BYTE( "95420680.lo", 0x00001, 0x080000, CRC(22a8623d) SHA1(22b75306e0ee2944e45739c380fc68338f2534f7) )
	ROM_LOAD16_BYTE( "95420681.hi", 0x00000, 0x080000, CRC(47dfc03a) SHA1(6fcacce499a8aa17a5b821511ffb1434d7f43850) )
	ROM_LOAD16_BYTE( "95420682.lo", 0x00001, 0x080000, CRC(e41bce75) SHA1(db07f0c55c40d527df795f860ff2317af1f030b3) )
	ROM_LOAD16_BYTE( "95420683.hi", 0x00000, 0x080000, CRC(00b92dfe) SHA1(e77cc410b591eace2b40c5fdbf0fc99f0379c771) )
	ROM_LOAD16_BYTE( "95420688.lo", 0x00001, 0x080000, CRC(6d7c6ed2) SHA1(1004c5027a60ba2cbdd488a4d49fee3c369d7c74) )
	ROM_LOAD16_BYTE( "95420689.hi", 0x00000, 0x080000, CRC(cea637a1) SHA1(68120b95741938d1df56eeb933968eb80144ec5a) )
	ROM_LOAD16_BYTE( "95420690.lo", 0x00001, 0x080000, CRC(f06826b2) SHA1(ed3f6d54252fe6edd4490c86291212365c2f9177) )
	ROM_LOAD16_BYTE( "95420691.hi", 0x00000, 0x080000, CRC(74cf31ec) SHA1(d0e68a25266e7f9308afb4840329a638d97e3ad1) )
	ROM_LOAD16_BYTE( "95420692.lo", 0x00001, 0x080000, CRC(c95de79a) SHA1(be7b6ca447fdc1d4ffaab2b4c6c69e344d093e1e) )
	ROM_LOAD16_BYTE( "95420693.hi", 0x00000, 0x080000, CRC(9ca69f5d) SHA1(1fecabfc8ee0b97bdf73116b16adf02fd214e15d) )
	ROM_LOAD16_BYTE( "95420707.hi", 0x00000, 0x080000, CRC(e672491b) SHA1(34ce10a9e3e999a3eefeadd354c3ebe7f42952e5) )
	ROM_LOAD16_BYTE( "95420722.lo", 0x00001, 0x080000, CRC(7f7dbf95) SHA1(b02ababb851518e2f9d79f8c5b7bab828d5cd8ba) )
	ROM_LOAD16_BYTE( "95420723.hi", 0x00000, 0x080000, CRC(997a3b21) SHA1(5b4524848e8c4ad47f2b72d29791e32d67c88d0e) )
	ROM_LOAD16_BYTE( "95420782.lo", 0x00001, 0x080000, CRC(13b65d83) SHA1(c2065db6d4b978148a49750af368b51d9438ddbc) )
	ROM_LOAD16_BYTE( "95420783.hi", 0x00000, 0x080000, CRC(e6bd569b) SHA1(b668b661e7afd1c951fa50bfce564e24b712a723) )
	ROM_LOAD16_BYTE( "95421668.lo", 0x00001, 0x080000, CRC(6f4964c8) SHA1(14948920079694791a66dfd1f07b22badb37bc57) )
	ROM_LOAD16_BYTE( "95421669.hi", 0x00000, 0x080000, CRC(23e030cf) SHA1(85c70ee8f906b48fb75692ec9e58e9072b1a731d) )
	ROM_LOAD16_BYTE( "95421672.lo", 0x00001, 0x080000, CRC(297c1a93) SHA1(7d0f8c6998f2970e1cce94a71fa4327edc66e07e) )
	ROM_LOAD16_BYTE( "95421673.hi", 0x00000, 0x080000, CRC(0e6202a7) SHA1(b47433908dbc8f1a237d13bf013a292c8e10d457) )
	ROM_LOAD16_BYTE( "95421674.lo", 0x00001, 0x080000, CRC(f1934864) SHA1(a30341ba11dbea1bd4b93e9d9a8fcd60e763aec3) )
	ROM_LOAD16_BYTE( "95421675.hi", 0x00000, 0x080000, CRC(c37e7f84) SHA1(206d6fe336c4d66f1ee36b0d3d98ff3a58768281) )
	ROM_LOAD16_BYTE( "95421676.lo", 0x00001, 0x080000, CRC(c6b43eaf) SHA1(7e714ef9d84bb525539e311aed7e12a0a51d4476) )
	ROM_LOAD16_BYTE( "95421677.hi", 0x00000, 0x080000, CRC(96b39469) SHA1(c4f431d74d961d04b733b92867e46330c362c314) )
	ROM_LOAD16_BYTE( "95421678.lo", 0x00001, 0x080000, CRC(8e5aa825) SHA1(e30fa52a7fabcdda207e3bb604d0808006d0a24b) )
	ROM_LOAD16_BYTE( "95421679.hi", 0x00000, 0x080000, CRC(8ea625d4) SHA1(2875e8fc4b861e13f2a97e3e6c38d1ac83ade5dd) )
	ROM_LOAD16_BYTE( "95421680.lo", 0x00001, 0x080000, CRC(8dc426bb) SHA1(018c11e6c21a7b72b76fae1fbd76e35d5214d7b5) )
	ROM_LOAD16_BYTE( "95421681.hi", 0x00000, 0x080000, CRC(921c9d46) SHA1(da705ca5476263bb7417bf3de4fa73a24625172e) )
	ROM_LOAD16_BYTE( "95421682.lo", 0x00001, 0x080000, CRC(df227550) SHA1(8a34835e18209328d84d83a1a4070e5838cca664) )
	ROM_LOAD16_BYTE( "95421683.hi", 0x00000, 0x080000, CRC(8320c53a) SHA1(97ffa9b10b27915c23dba5beb8b823b6a1010cd7) )
	ROM_LOAD16_BYTE( "95421688.lo", 0x00001, 0x080000, CRC(cb3c7d09) SHA1(8fc0a9dedb94f67997ebed49123a9fe9bb39725e) )
	ROM_LOAD16_BYTE( "95421689.hi", 0x00000, 0x080000, CRC(2c2c2eeb) SHA1(a76754657ca3d036c3d054ad8e5feabb8bf3e71f) )
	ROM_LOAD16_BYTE( "95421690.lo", 0x00001, 0x080000, CRC(70c1a986) SHA1(b3e9d41de8fd766677ad1bbc53e3b328f273f7d3) )
	ROM_LOAD16_BYTE( "95421691.hi", 0x00000, 0x080000, CRC(471dca82) SHA1(d5e73c4fd18029262abd50b1b0269c3c3b6bd5c9) )
	ROM_LOAD16_BYTE( "95421692.lo", 0x00001, 0x080000, CRC(cb08f4ab) SHA1(6fd4ccc6224e3fb9038caadf0934e66bc88c0990) )
	ROM_LOAD16_BYTE( "95421693.hi", 0x00000, 0x080000, CRC(c0109286) SHA1(d66dd01f87dd6ecc212b935bdc8719b7cfa92315) )
	ROM_LOAD16_BYTE( "95421722.lo", 0x00001, 0x080000, CRC(2c7ad6b5) SHA1(6b922ab897da233074813cf5e32960974a46f27c) )
	ROM_LOAD16_BYTE( "95421723.hi", 0x00000, 0x080000, CRC(bda8844f) SHA1(ed7c5575cb23dc359b868b65744e1bf6bfd92c85) )
	ROM_LOAD16_BYTE( "95421782.lo", 0x00001, 0x080000, CRC(623c7d94) SHA1(eb757679cdbf9a8657a8c4012ba39d7256e7af16) )
	ROM_LOAD16_BYTE( "95421783.hi", 0x00000, 0x080000, CRC(dc5cf5b8) SHA1(abf35663582034ad4d62624b4814006de2d194bf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008992.bin", 0x0000, 0x0aa536, CRC(aad10089) SHA1(d8a32f66432ee901be05435e8930d3897f4b4e33) )
	ROM_LOAD( "95009015.bin", 0x0000, 0x0b7821, CRC(8b6ca362) SHA1(4c50935b6d1038738ce631fbdc359416197b8c03) )
	ROM_REGION( 0x400000, "pivs", ROMREGION_ERASE00 )
	ROM_LOAD( "95890730.bin", 0x0000, 0x5000, CRC(9673d1ce) SHA1(fee90139fc8de5e7b6dfe741b4852a363c17eb93) )
	ROM_LOAD( "95890731.bin", 0x0000, 0x5000, CRC(8aa52172) SHA1(441a649e3da00556a8ea966a88ee9b58b4943d3b) )
	ROM_LOAD( "95890732.bin", 0x0000, 0x5000, CRC(49ff03e2) SHA1(f8b77c97f2b1bb5de06f4c9835275ae9b83d0988) )
ROM_END




ROM_START( sc_greed )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1317p11.hi", 0x00000, 0x080000, CRC(8218f6f7) SHA1(2d8f0df098fa6cf23497eab05b0219a0ca448bda) )
	ROM_LOAD16_BYTE( "p1317p11.lo", 0x00001, 0x080000, CRC(fb049b80) SHA1(dab68cb21be72cdac8165b6915e664b5b3810d30) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1317s11.hi", 0x00000, 0x080000, CRC(3ef66b70) SHA1(8d856a5673374594f77f835017560348bd5f56d2) )
	ROM_LOAD16_BYTE( "p1317s11.lo", 0x00001, 0x080000, CRC(f6f37bb4) SHA1(3645568c8acc7ab4d4f10576b107b40d1c9644b0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008325.bin", 0x0000, 0x100000, CRC(82356c95) SHA1(bbf9dc2e4ca20a35a8bc581e322956e17f220022) )
ROM_END




ROM_START( sc_gunp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422360.lo", 0x00001, 0x080000, CRC(ff22816b) SHA1(29cdd9fe245f62e9455ec3bf2ebff069b2ac182d) )
	ROM_LOAD16_BYTE( "95422361.hi", 0x00000, 0x080000, CRC(80a12c2e) SHA1(c92a69e4b849e73d42c045ce10a7f9f2d2ea3a9c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422362.lo", 0x00001, 0x080000, CRC(219225d1) SHA1(b2134e94a8fba0644003789942ea8689caf27b0c) )
	ROM_LOAD16_BYTE( "95422363.hi", 0x00000, 0x080000, CRC(8f489ba6) SHA1(f2f92332a09b4a811b01601fcae05a75ea418a0d) )
	ROM_LOAD16_BYTE( "95422592.lo", 0x00001, 0x080000, CRC(b546b3bf) SHA1(ce84f806b2648ebb3582a6a68797f347b41d5e17) )
	ROM_LOAD16_BYTE( "95422593.hi", 0x00000, 0x080000, CRC(74c6b5d2) SHA1(a46a8ee5a77b8310492fd272320db481c30c79f8) )
	ROM_LOAD16_BYTE( "95422752.lo", 0x00001, 0x080000, CRC(82368f14) SHA1(d5d2fe0b9c31bd9dede3953ceeebc533c5102cac) )
	ROM_LOAD16_BYTE( "95422753.hi", 0x00000, 0x080000, CRC(4ba46041) SHA1(ce076fc1027f09f0ab201abf2ec26116df077f93) )
	ROM_LOAD16_BYTE( "95422754.lo", 0x00001, 0x080000, CRC(1231d677) SHA1(8c9af6034319a66a1aef442f5d4fdc206900f433) )
	ROM_LOAD16_BYTE( "95422755.hi", 0x00000, 0x080000, CRC(67d94e3c) SHA1(02ee70541cd0991a34c6652b197c4f97e581f0b0) )
	ROM_LOAD16_BYTE( "95423360.lo", 0x00001, 0x080000, CRC(66be2471) SHA1(98932c263ed59dc76a8879e5f95ea37a573b0006) )
	ROM_LOAD16_BYTE( "95423361.hi", 0x00000, 0x080000, CRC(15227d9d) SHA1(206e95c4c4158ed3421a0eb287a8d777cf0578bc) )
	ROM_LOAD16_BYTE( "95423362.lo", 0x00001, 0x080000, CRC(76983aff) SHA1(4a857e9980f0d624d5983ad6bba9b1ac114ce79a) )
	ROM_LOAD16_BYTE( "95423363.hi", 0x00000, 0x080000, CRC(5ec237ef) SHA1(3521a763f7a4d22b79c79895888385b02e8720c5) )
	ROM_LOAD16_BYTE( "95423592.lo", 0x00001, 0x080000, CRC(5860325d) SHA1(69cab9605953ca7e93fe2dd58c1bbdf74eb79ff6) )
	ROM_LOAD16_BYTE( "95423593.hi", 0x00000, 0x080000, CRC(eb8aa03a) SHA1(574683035f635cd2edcadab6b40a9b8f34850fe8) )
	ROM_LOAD16_BYTE( "95423754.lo", 0x00001, 0x080000, CRC(ce12c28a) SHA1(65f77811d6cc518e592c855577b373497d856e4d) )
	ROM_LOAD16_BYTE( "95423755.hi", 0x00000, 0x080000, CRC(0f92017c) SHA1(ad30f594e0c338675957547aa1de521b8406d633) )
	ROM_LOAD16_BYTE( "95426118.lo", 0x00001, 0x080000, CRC(697b7c27) SHA1(257b4cd5132a336217bf3ff1eabba8ff460ccbae) )
	ROM_LOAD16_BYTE( "95426119.hi", 0x00000, 0x080000, CRC(fcee9f17) SHA1(87934f4d8c0cc55cea87dc6027f656ab4587914e) )
	ROM_LOAD16_BYTE( "95426120.lo", 0x00001, 0x080000, CRC(d72e3bb4) SHA1(cd9c074f05e10c216a3392689a9a0ff217a235c1) )
	ROM_LOAD16_BYTE( "95426121.hi", 0x00000, 0x080000, CRC(657ab411) SHA1(8aacb39864580fb8724fa9284142f94518efb707) )
	ROM_LOAD16_BYTE( "95426276.lo", 0x00001, 0x080000, CRC(1437f193) SHA1(516e745335ebb27c91e033292b946605a0ea3898) )
	ROM_LOAD16_BYTE( "95426277.hi", 0x00000, 0x080000, CRC(88bc027d) SHA1(d4cdb691131889071e583c91eeb594fa22dc489e) )
	ROM_LOAD16_BYTE( "95426320.lo", 0x00001, 0x080000, CRC(b3d3761b) SHA1(38a9990809998329e03e7a6559efedfba0e7bc4c) )
	ROM_LOAD16_BYTE( "95426321.hi", 0x00000, 0x080000, CRC(bc368bf0) SHA1(a1466380a4aac8fd96a9c987870e2ede9c26ce9b) )
	ROM_LOAD16_BYTE( "95426398.lo", 0x00001, 0x080000, CRC(abc5b4e3) SHA1(bd2996273328b04e22d65e7737901479b3f2dc59) )
	ROM_LOAD16_BYTE( "95426399.hi", 0x00000, 0x080000, CRC(d9f8d9ca) SHA1(c634146ade7fdca71c6b2fbc6f7149639a4d4677) )
	ROM_LOAD16_BYTE( "95427118.lo", 0x00001, 0x080000, CRC(f453ade4) SHA1(49274318d5d31c2fd63b912994870024400405f1) )
	ROM_LOAD16_BYTE( "95427119.hi", 0x00000, 0x080000, CRC(ccf9ede7) SHA1(32fe6022b2da290a41521f47ce91b5048c7b91cc) )
	ROM_LOAD16_BYTE( "95427120.lo", 0x00001, 0x080000, CRC(b9761612) SHA1(df6826e0a8bb9076ed6b6142688c54d56f4233ed) )
	ROM_LOAD16_BYTE( "95427121.hi", 0x00000, 0x080000, CRC(557a4665) SHA1(f757a4d3f61dde1c41de833872dfa9411121414e) )
	ROM_LOAD16_BYTE( "95427276.lo", 0x00001, 0x080000, CRC(bce351c9) SHA1(58b93bedcccb79cef1b23f61cf0308331299c034) )
	ROM_LOAD16_BYTE( "95427277.hi", 0x00000, 0x080000, CRC(39db7e38) SHA1(27dc16145711576962dbe943eac5c9f2ef9c0c70) )
	ROM_LOAD16_BYTE( "95427320.lo", 0x00001, 0x080000, CRC(ad4fddfd) SHA1(528a5c924f0d6cd5aefccfc2d25bc37648c9f846) )
	ROM_LOAD16_BYTE( "95427321.hi", 0x00000, 0x080000, CRC(67a534ad) SHA1(04bf1bf63222855374d106b07940241d09c899c8) )
	ROM_LOAD16_BYTE( "95427398.lo", 0x00001, 0x080000, CRC(94520a24) SHA1(692fbd63481fec92391dda6dfcb99308eb9d4658) )
	ROM_LOAD16_BYTE( "95427399.hi", 0x00000, 0x080000, CRC(b2d2f327) SHA1(bbaac6bce520ee957b30a3fe42fa9686ffe135e5) )
	ROM_LOAD16_BYTE( "p3016p71.hi", 0x00000, 0x080000, CRC(1dc4ab56) SHA1(1f47429af60d55547f5f14235c29cb1a343778cd) )
	ROM_LOAD16_BYTE( "p3016p71.lo", 0x00001, 0x080000, CRC(23a21435) SHA1(935875e89860017d4672397f32aff605af37db4c) )
	ROM_LOAD16_BYTE( "p3016s71.hi", 0x00000, 0x080000, CRC(a8c8fb0b) SHA1(d79717de7a2577fa0a67271b68671c7ae752bcfc) )
	ROM_LOAD16_BYTE( "p3016s71.lo", 0x00001, 0x080000, CRC(63dde41b) SHA1(b858eda07805c7149e296657bbf98c9e343209e8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008744.bin", 0x0000, 0x100000, CRC(be8313a2) SHA1(247ec0b2140d261bf5e7ab21cedb4ad2fd708ca7) )
	ROM_LOAD( "95008745.bin", 0x0000, 0x100000, CRC(355caf88) SHA1(82951c00efd27533ccbc78b46cd5b69be5c3e26d) )
ROM_END




ROM_START( sc_hf )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404214.lo", 0x00001, 0x080000, CRC(b942937b) SHA1(acd32234c251286be8358a55ac7487c550c9b6ac) )
	ROM_LOAD16_BYTE( "95404215.hi", 0x00000, 0x080000, CRC(70742de7) SHA1(e509704e4112657783f4100239ba4bf029c6d6bd) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404220.lo", 0x00001, 0x080000, CRC(93a0020e) SHA1(c92457a4b2890a7bd53f229919a51f28d465c2bb) )
	ROM_LOAD16_BYTE( "95404221.hi", 0x00000, 0x080000, CRC(a412bf9c) SHA1(6276e8bbc88ee90aef93ec74357ee85ef0a9c6ae) )
	ROM_LOAD16_BYTE( "95404286.lo", 0x00001, 0x080000, CRC(6e1fa391) SHA1(14985afb407c96f0ce4b140b1486e2e4db68ae5f) )
	ROM_LOAD16_BYTE( "95404287.hi", 0x00000, 0x080000, CRC(2509ed7d) SHA1(b7b4d968052968a96b23b14c5f6dac29ebeb21a6) )
	ROM_LOAD16_BYTE( "95405214.lo", 0x00001, 0x080000, CRC(8cb9fc00) SHA1(9c6edeedfea9e6f2b582a429e3d5e82f32caef89) )
	ROM_LOAD16_BYTE( "95405215.hi", 0x00000, 0x080000, CRC(26fe003a) SHA1(641c6712a26f9eb1a757353467e339d2b57b93df) )
	ROM_LOAD16_BYTE( "95405220.lo", 0x00001, 0x080000, CRC(045d91b8) SHA1(6c3563279b4d615c8ecdee52fb4ba9db8588f107) )
	ROM_LOAD16_BYTE( "95405221.hi", 0x00000, 0x080000, CRC(02c60052) SHA1(76806c4ef25a426e8080a75fbd028c8808597fcd) )
	ROM_LOAD16_BYTE( "95405286.lo", 0x00001, 0x080000, CRC(6e1d414a) SHA1(f95a35d443779b1addc875061cec752cc1b9b03a) )
	ROM_LOAD16_BYTE( "95405287.hi", 0x00000, 0x080000, CRC(fa11be65) SHA1(42bb3baf08b55d07a8b0787d57ca0875e6f7cfbc) )
	ROM_LOAD16_BYTE( "95406018.lo", 0x00001, 0x080000, CRC(47b8d0ce) SHA1(0196ee3a78f9165fb6ee529f5a81881edc475276) )
	ROM_LOAD16_BYTE( "95406019.hi", 0x00000, 0x080000, CRC(f7ed0d65) SHA1(eeeebcc309e1605bc0ef7a0433b48dfccade9a7c) )
	ROM_LOAD16_BYTE( "95407018.lo", 0x00001, 0x080000, CRC(f6f9d680) SHA1(1332423e3f38f00c160d1b790285c4d43584eb14) )
	ROM_LOAD16_BYTE( "95407019.hi", 0x00000, 0x080000, CRC(727ab861) SHA1(866d1e15fb4951fc2d7c574265b6a026e9abe37f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008163.bin", 0x0000, 0x100000, CRC(0d8abe3c) SHA1(e3dc45ca8aea3113c5884ae3af9216f627ce71ba) )
ROM_END




ROM_START( sc_hfcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404100.lo", 0x00001, 0x080000, CRC(73fcd433) SHA1(45ad1b4a47b3a593f3e29f498f13dd9db01d621c) )
	ROM_LOAD16_BYTE( "95404101.hi", 0x00000, 0x080000, CRC(d7322d67) SHA1(29d0fb47c9606db8d86be21d1091876bedfa84b8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405100.lo", 0x00001, 0x080000, CRC(796fd1f5) SHA1(566cbbc900e3b7bb1872e8fce6b57d6ae7264c8e) )
	ROM_LOAD16_BYTE( "95405101.hi", 0x00000, 0x080000, CRC(70a4543c) SHA1(812438549faeac96f00143a25e037e43cd401562) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004272.bin", 0x0000, 0x080000, CRC(843cea31) SHA1(1d3a524600c8a0b7d6e3a32cad71f7f53c8190a1) )
	ROM_LOAD( "95004273.bin", 0x0000, 0x080000, CRC(c0782f35) SHA1(d763f7f8377c97129485522b201413e35c9c5760) )
ROM_END




ROM_START( sc_hapnt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406816.lo", 0x00001, 0x080000, CRC(e94df07f) SHA1(6c37860d0284cc1526c1711a9033d2d413ad09dd) )
	ROM_LOAD16_BYTE( "95406817.hi", 0x00000, 0x080000, CRC(a7d5a893) SHA1(fcff244e8b53be074fdb8b4f88bd1f514ada8ab4) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407816.lo", 0x00001, 0x080000, CRC(5cec8ea5) SHA1(c2724e8cbf261a209b0b55cde22493d9ac3c19b0) )
	ROM_LOAD16_BYTE( "95407817.hi", 0x00000, 0x080000, CRC(ad3ae839) SHA1(018d2850c94d379aaba98d9815c29932748745c7) )
	ROM_LOAD16_BYTE( "95408046.lo", 0x00001, 0x080000, CRC(85555e8d) SHA1(3ab297896829794b3aa48924431fc1a9239946f4) )
	ROM_LOAD16_BYTE( "95408047.hi", 0x00000, 0x080000, CRC(d1003e56) SHA1(e51c8871d8bc93c16507a7cd06f8499fdc93d6af) )
	ROM_LOAD16_BYTE( "95408100.lo", 0x00001, 0x080000, CRC(4aef5042) SHA1(a8e1e83bd1baf3432f775ff6b1acc5b03ccda697) )
	ROM_LOAD16_BYTE( "95408101.hi", 0x00000, 0x080000, CRC(aa3b70e2) SHA1(86f38715d820717f69c08d8ca52828305f071461) )
	ROM_LOAD16_BYTE( "95408230.lo", 0x00001, 0x080000, CRC(238710bf) SHA1(827593474d179524b7c2a25c264a5b9e99e6e153) )
	ROM_LOAD16_BYTE( "95408231.hi", 0x00000, 0x080000, CRC(35081642) SHA1(61dbcf6ff57fe0ec3742831e8a13a03450f3cd63) )
	ROM_LOAD16_BYTE( "95408502.lo", 0x00001, 0x080000, CRC(591041d3) SHA1(d9522f4131727b2a9ae5884039bc1c265817fa46) )
	ROM_LOAD16_BYTE( "95408503.hi", 0x00000, 0x080000, CRC(c35d692f) SHA1(bfec485ba52c7a5a6c2565b02e1e9477d7fef55d) )
	ROM_LOAD16_BYTE( "95409046.lo", 0x00001, 0x080000, CRC(a099171c) SHA1(5487abb941d53c96fb5139438ba5258dc168dc40) )
	ROM_LOAD16_BYTE( "95409047.hi", 0x00000, 0x080000, CRC(9f1ed231) SHA1(a95440f3225f3428309816e08852bf07f313395e) )
	ROM_LOAD16_BYTE( "95409100.lo", 0x00001, 0x080000, CRC(12f704dc) SHA1(fd1add5cfef1c24fc15cb7d623b1e4903d092f82) )
	ROM_LOAD16_BYTE( "95409101.hi", 0x00000, 0x080000, CRC(2a9b4c44) SHA1(7be9b24007935ece47d73d2cfb2ba5693e50bc58) )
	ROM_LOAD16_BYTE( "95409230.lo", 0x00001, 0x080000, CRC(b16303a5) SHA1(549b64d3ec0460fa45ff0b98b4271eb2ae272e17) )
	ROM_LOAD16_BYTE( "95409231.hi", 0x00000, 0x080000, CRC(5149f6c5) SHA1(4a31d7fa699f0deb04fb50d0fe0347b6a4d01c57) )
	ROM_LOAD16_BYTE( "95409502.lo", 0x00001, 0x080000, CRC(26d6f19c) SHA1(1d88a105db4c2cec181a143bded5c1aaf5a32731) )
	ROM_LOAD16_BYTE( "95409503.hi", 0x00000, 0x080000, CRC(2fbf988f) SHA1(04a3bda0266e2d1430ae5223499f326972ee951c) )
	ROM_LOAD16_BYTE( "95410960.lo", 0x00001, 0x080000, CRC(09417c00) SHA1(6d10896bf290c58b6fdb5d735b423a9d2d7db5d7) )
	ROM_LOAD16_BYTE( "95410961.hi", 0x00000, 0x080000, CRC(1611d748) SHA1(b5ae00a1e1adaf7af912b3f21fb0cb7b414996b3) )
	ROM_LOAD16_BYTE( "95410962.lo", 0x00001, 0x080000, CRC(64cecf4d) SHA1(63f9f5fda15e99a249ea869105461c6d1db0a01a) )
	ROM_LOAD16_BYTE( "95410963.hi", 0x00000, 0x080000, CRC(758108b0) SHA1(4de01d82d5ff01adfa3907adb46d666dd9979734) )
	ROM_LOAD16_BYTE( "95410964.lo", 0x00001, 0x080000, CRC(fbf06b79) SHA1(8130b8e9f5f18399963db8206f0d6c9ed0312fce) )
	ROM_LOAD16_BYTE( "95410965.hi", 0x00000, 0x080000, CRC(a91e7166) SHA1(accaa8c05fe6754b4ac1cf6eee5713de239968ce) )
	ROM_LOAD16_BYTE( "95411960.lo", 0x00001, 0x080000, CRC(e4f6033a) SHA1(4bde8c65639e952e4120c9a538d709a88e2a7982) )
	ROM_LOAD16_BYTE( "95411961.hi", 0x00000, 0x080000, CRC(f17e876d) SHA1(d90123e04cbf6935ee9cb62abbfa5cabed83c5b5) )
	ROM_LOAD16_BYTE( "p1306p12.hi", 0x00000, 0x080000, CRC(ea9c501d) SHA1(31f912906f562a04053f58ebed3c7bd0ee864434) )
	ROM_LOAD16_BYTE( "p1306p12.lo", 0x00001, 0x080000, CRC(d9aaad4c) SHA1(d0ccc3fc4cf1dbda58086fdba2ea0f10f94e1cd6) )
	ROM_LOAD16_BYTE( "p1306p13.hi", 0x00000, 0x080000, CRC(6170b940) SHA1(82f06d54d5ea732b9e88a4ef97ce353c7db6e826) )
	ROM_LOAD16_BYTE( "p1306p13.lo", 0x00001, 0x080000, CRC(d99cff8f) SHA1(abf1e61cdfe3bc77f69bb9f981795d7978bcf23a) )
	ROM_LOAD16_BYTE( "p1306s12.hi", 0x00000, 0x080000, CRC(dee0e44f) SHA1(0d60c2fafaa1fe334a44dc02e139d371048fc7f7) )
	ROM_LOAD16_BYTE( "p1306s12.lo", 0x00001, 0x080000, CRC(1c4a3b34) SHA1(3310133354ebfde433763136447a5f6d6a470d02) )
	ROM_LOAD16_BYTE( "p1306s13.hi", 0x00000, 0x080000, CRC(3fa9a172) SHA1(106c083892e83e3b925ca1b78b1653bc3ec2a81f) )
	ROM_LOAD16_BYTE( "p1306s13.lo", 0x00001, 0x080000, CRC(6aa080d1) SHA1(124750321d644714f6c41c9e1a19f6707ac43d5f) )
	ROM_LOAD16_BYTE( "p1327p12.hi", 0x00000, 0x080000, CRC(734e60a9) SHA1(911f6c78654020c03b3e906aaf37ce3751f1cd85) )
	ROM_LOAD16_BYTE( "p1327p12.lo", 0x00001, 0x080000, CRC(d1d169e0) SHA1(41540cee7ca0fbe2c93a1c55f0f9e9c933ed3f3b) )
	ROM_LOAD16_BYTE( "p1327p13.hi", 0x00000, 0x080000, CRC(d3141aff) SHA1(7c75e47e1a36979177c220edacc5256342c3405c) )
	ROM_LOAD16_BYTE( "p1327p13.lo", 0x00001, 0x080000, CRC(b80f3b5f) SHA1(8b1a3daadb67b2d147184ab7213abe9c29791c6e) )
	ROM_LOAD16_BYTE( "p1327p41.hi", 0x00000, 0x080000, CRC(0a0305da) SHA1(c4ed571484d13fed4adc83d96efabe060a6452a5) )
	ROM_LOAD16_BYTE( "p1327p41.lo", 0x00001, 0x080000, CRC(f0001712) SHA1(5be70eaedca55c4098f236763206cf32bb1c2f4d) )
	ROM_LOAD16_BYTE( "p1327p42.hi", 0x00000, 0x080000, CRC(c6e34460) SHA1(63ae0930b7b0c104edee067a0e13c0a90c2d027c) )
	ROM_LOAD16_BYTE( "p1327p42.lo", 0x00001, 0x080000, CRC(5e055385) SHA1(e42d7a0668bd1069c20bd519c37c1fcacabffca2) )
	ROM_LOAD16_BYTE( "p1327p61.hi", 0x00000, 0x080000, CRC(27a9e9a7) SHA1(9489bc73a3c806de974a82397c0d9907bcb3b9e5) )
	ROM_LOAD16_BYTE( "p1327p61.lo", 0x00001, 0x080000, CRC(13e3aa1e) SHA1(8bd97ebaa6b56e7c846cde2f0b61173c0332c120) )
	ROM_LOAD16_BYTE( "p1327p71.hi", 0x00000, 0x080000, CRC(d9dd087b) SHA1(872a52bcb42df863407ecb796c8768a02d3614d9) )
	ROM_LOAD16_BYTE( "p1327p71.lo", 0x00001, 0x080000, CRC(6cbef7a3) SHA1(11b6dfd24595fd10ce31e3f6361c6e9a7880c6c9) )
	ROM_LOAD16_BYTE( "p1327s12.hi", 0x00000, 0x080000, CRC(9aae872b) SHA1(fbd5e402d76bfc2b6e99667b6c97f851fc482abb) )
	ROM_LOAD16_BYTE( "p1327s12.lo", 0x00001, 0x080000, CRC(c964b987) SHA1(422b59e1ca2f3105ab28b33f4e95314ee525882f) )
	ROM_LOAD16_BYTE( "p1327s13.hi", 0x00000, 0x080000, CRC(fc9dcc8a) SHA1(20605e20cdb643384f6c268d9e52b362d7369786) )
	ROM_LOAD16_BYTE( "p1327s13.lo", 0x00001, 0x080000, CRC(e2327afa) SHA1(bd1c0334fbc5ae4c386ad389c0ec619344c26656) )
	ROM_LOAD16_BYTE( "p1327s41.hi", 0x00000, 0x080000, CRC(cd03727a) SHA1(fcc802a62d60bb084ea3451730bc685212510320) )
	ROM_LOAD16_BYTE( "p1327s41.lo", 0x00001, 0x080000, CRC(346db912) SHA1(83435a6bb3e557a04040cd221474df23c39aa507) )
	ROM_LOAD16_BYTE( "p1327s42.hi", 0x00000, 0x080000, CRC(2e737e11) SHA1(d1447129e4e1c888527371f1c5625d3e33d9d187) )
	ROM_LOAD16_BYTE( "p1327s42.lo", 0x00001, 0x080000, CRC(3916863f) SHA1(d0949fcc6414f42d292a04bd0d056cc51a10371c) )
	ROM_LOAD16_BYTE( "p1327s61.hi", 0x00000, 0x080000, CRC(d3429de9) SHA1(4e5f6df4a557dd0aa061a0b7c4d30b8f01f1d958) )
	ROM_LOAD16_BYTE( "p1327s61.lo", 0x00001, 0x080000, CRC(76e3c418) SHA1(1ec77288096715894e0e179024205fa9dfaf3909) )
	ROM_LOAD16_BYTE( "p1327s71.hi", 0x00000, 0x080000, CRC(2d367c35) SHA1(547ba184d465d90296150595f35a5c4b012108c6) )
	ROM_LOAD16_BYTE( "p1327s71.lo", 0x00001, 0x080000, CRC(09be99a5) SHA1(d9ad6f8e4487c7fdf129478ac967d4c0aa96a0f9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008290.bin", 0x0000, 0x100000, CRC(427fc43d) SHA1(c63154c7f2bb3e7ec78e31268a8040d0eb131f2f) )
	ROM_LOAD( "95008312.bin", 0x0000, 0x100000, CRC(cf33e14d) SHA1(33382be257a145784d9de7050b5c90f725241de4) )
ROM_END




ROM_START( sc_heatw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406486.lo", 0x00001, 0x080000, CRC(79961a2d) SHA1(4a7b8960daa24aa5a496914550e3101f55a060a4) )
	ROM_LOAD16_BYTE( "95406487.hi", 0x00000, 0x080000, CRC(a243da42) SHA1(7c94d43f1ee0b78b257c278d04331447427c94cf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004287.snd", 0x0000, 0x080000, CRC(7a86c853) SHA1(60a5582f43cda30e9c48a1207ee1a4cafdce0276) )
ROM_END




ROM_START( sc_helrd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408462.lo", 0x00001, 0x080000, CRC(d88b84da) SHA1(8f1dee5e598e92ee82e0c323505041d107bbd38e) )
	ROM_LOAD16_BYTE( "95408463.hi", 0x00000, 0x080000, CRC(324102f4) SHA1(68b2e13149e42af5e7fc1e3968ebb086722ea51e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004326.snd", 0x0000, 0x080000, CRC(193851ca) SHA1(de71622b6d50d039bd625189303191d316bdc671) )
ROM_END




ROM_START( sc_helrs )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408640.lo", 0x00001, 0x080000, CRC(d5426f9d) SHA1(5f36371e396b4735977bceb9f8c58f00483457da) )
	ROM_LOAD16_BYTE( "95408641.hi", 0x00000, 0x080000, CRC(74129aa9) SHA1(01617c4e9b7f64ec49a259cf50e27a05a8096fc8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004326.snd", 0x0000, 0x080000, CRC(193851ca) SHA1(de71622b6d50d039bd625189303191d316bdc671) )
ROM_END




ROM_START( sc_hellb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406678.lo", 0x00001, 0x080000, CRC(82fa3872) SHA1(c1de9c35998c710f22eb95283a5a21d8e22c3c30) )
	ROM_LOAD16_BYTE( "95406679.hi", 0x00000, 0x080000, CRC(5b0767c6) SHA1(3a0245ba5822ab3faa74a1f06a3c1648fa97ee40) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408312.lo", 0x00001, 0x080000, CRC(45a2dd84) SHA1(cdd41b2f58138c9dc92cca8f8f92945b7a18d285) )
	ROM_LOAD16_BYTE( "95408313.hi", 0x00000, 0x080000, CRC(ec35f697) SHA1(752b7aa50145024f55ad7c2724f76dcda22f8701) )
	ROM_LOAD16_BYTE( "95408314.lo", 0x00001, 0x080000, CRC(9c97a1b8) SHA1(856508f6e744a66d8f7d5a4627397c8f3ea48fe8) )
	ROM_LOAD16_BYTE( "95408315.hi", 0x00000, 0x080000, CRC(5939c02c) SHA1(0fc62072c1cc76b287f259d32a0ea0e0856a34b4) )
	ROM_LOAD16_BYTE( "95408608.lo", 0x00001, 0x080000, CRC(773f7c6a) SHA1(5f4f07f9a29feeda398711f93c4c8fe80d039f54) )
	ROM_LOAD16_BYTE( "95408609.hi", 0x00000, 0x080000, CRC(bdeecd6f) SHA1(f703548e968539cf82d6894264e18c96de77a514) )
	ROM_LOAD16_BYTE( "95409312.lo", 0x00001, 0x080000, CRC(928296c5) SHA1(384fe4873a83991513db17405b2fbf442e3fe275) )
	ROM_LOAD16_BYTE( "95409313.hi", 0x00000, 0x080000, CRC(5fadd38f) SHA1(7775ddfdddf075f3aeb1acc4034bbceeec451fb0) )
	ROM_LOAD16_BYTE( "95409314.lo", 0x00001, 0x080000, CRC(4bb7eaf9) SHA1(8c3545fd3d8b3dde3ef5125ce612024caed395db) )
	ROM_LOAD16_BYTE( "95409315.hi", 0x00000, 0x080000, CRC(eaa1e534) SHA1(9ec4d0027abbce8e2f3cb50042fb8ae2043da00d) )
	ROM_LOAD16_BYTE( "95409608.lo", 0x00001, 0x080000, CRC(57c4bff8) SHA1(7df25f3441c0582c1c4b4b5bf1f32d486c9f22ff) )
	ROM_LOAD16_BYTE( "95409609.hi", 0x00000, 0x080000, CRC(139b8f22) SHA1(72c1eb1b61df3ba6872f1ad6831a6bd7a5dc8582) )
	ROM_LOAD16_BYTE( "95410546.lo", 0x00001, 0x080000, CRC(4746bac9) SHA1(ecbf0cc1887726fef2bfb8d3c358a1eb5970f1ba) )
	ROM_LOAD16_BYTE( "95410547.hi", 0x00000, 0x080000, CRC(b6a1da76) SHA1(d28d3fdc65623fbaed57b2f23e0705b5e353fd81) )
	ROM_LOAD16_BYTE( "95410548.lo", 0x00001, 0x080000, CRC(e5c3aaa3) SHA1(af13fff2f73400abdb207bce0476ec8b2a305e7c) )
	ROM_LOAD16_BYTE( "95410549.hi", 0x00000, 0x080000, CRC(428d932a) SHA1(edf6b155b7cfc5882a2ac13aa3bf554073a6b06f) )
	ROM_LOAD16_BYTE( "95411546.lo", 0x00001, 0x080000, CRC(8ca1aa2b) SHA1(90409c9c0ae4a482d657c47ef90945303c49075d) )
	ROM_LOAD16_BYTE( "95411547.hi", 0x00000, 0x080000, CRC(8d0a7be3) SHA1(11880744f08028045cea20f4a4c6878d2e5c0338) )
	ROM_LOAD16_BYTE( "95411548.lo", 0x00001, 0x080000, CRC(60105ee2) SHA1(8f0ebefab1d59ae089e0e29af2bfef06fa50b89a) )
	ROM_LOAD16_BYTE( "95411549.hi", 0x00000, 0x080000, CRC(a5e2c30f) SHA1(89bbced9533fe3a6c4c21c92a78d4f5909911315) )
	ROM_LOAD16_BYTE( "p1402p12.hi", 0x00000, 0x080000, CRC(42548acf) SHA1(cc36dbe058a8296f65b123d5e1d21a58ac53252a) )
	ROM_LOAD16_BYTE( "p1402p12.lo", 0x00001, 0x080000, CRC(d34211b0) SHA1(ae316d09872dab241222269231ffc9a7a5f50b83) )
	ROM_LOAD16_BYTE( "p1402s12.hi", 0x00000, 0x080000, CRC(3ecd9836) SHA1(c4a367d7efcde4b71e65b551aa830f881beb9cd7) )
	ROM_LOAD16_BYTE( "p1402s12.lo", 0x00001, 0x080000, CRC(49778505) SHA1(4cf60e9844e30216a64a1a45fadeba780614a180) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004211.bin", 0x0000, 0x080000, CRC(2e729642) SHA1(c8dcdce52f930b3fa894c46907691a28a5499a16) )
	ROM_LOAD( "95008341.bin", 0x0000, 0x100000, CRC(486e5395) SHA1(0ad68f271f4839d50a790b7f4427e1f1f1933bd4) )
ROM_END





ROM_START( sc_hdd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400539.lo", 0x00001, 0x080000, CRC(ff4cf9de) SHA1(19638ee079aaf78eded317689e1a1adc28e16e20) )
	ROM_LOAD16_BYTE( "95400540.hi", 0x00000, 0x080000, CRC(d9facac7) SHA1(989f4564ecb13efdb9f3aa351c5b66a8046f6330) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400713.lo", 0x00001, 0x080000, CRC(a3fd4b50) SHA1(d238d42146081ce45cf0e1464dda1b7bc0a47173) )
	ROM_LOAD16_BYTE( "95400714.hi", 0x00000, 0x080000, CRC(3e70fea8) SHA1(e2b8900f9e19e7e11bbda48ba6d8e33b62d6767d) )
	ROM_LOAD16_BYTE( "95400717.lo", 0x00001, 0x080000, CRC(0bc9cd2b) SHA1(c8a2adef36f1ca91ab2f9c0f0a23d6fb4af0e01a) )
	ROM_LOAD16_BYTE( "95400718.hi", 0x00000, 0x080000, CRC(a0120196) SHA1(e1c0972f87b0ce68560e7b2441d7aed45142ddc4) )
	ROM_LOAD16_BYTE( "95401539.lo", 0x00001, 0x080000, CRC(e8d5bb5e) SHA1(31254b4d020eca29bcf1a51ce561923f020e884f) )
	ROM_LOAD16_BYTE( "95401540.hi", 0x00000, 0x080000, CRC(da26686f) SHA1(6aa5653268933b0d0df9201824a18348b96646e7) )
	ROM_LOAD16_BYTE( "95401541.lo", 0x00001, 0x080000, CRC(7b1e00aa) SHA1(d3896783e79e78a71f2e83d5b7a20bd86caab87f) )
	ROM_LOAD16_BYTE( "95401542.hi", 0x00000, 0x080000, CRC(a96d59d6) SHA1(010d3ad6fcb9df84ca0343ddb1cba972492fe154) )
	ROM_LOAD16_BYTE( "95401713.lo", 0x00001, 0x080000, CRC(1499cccf) SHA1(d47c54033bdb26399838e3234da8d6c30d0da32b) )
	ROM_LOAD16_BYTE( "95401714.hi", 0x00000, 0x080000, CRC(957c1a0a) SHA1(b315221517027707bd0e66486c86e4615814639c) )
	ROM_LOAD16_BYTE( "95401717.lo", 0x00001, 0x080000, CRC(bcad4ab4) SHA1(5248f225012d12f978f107bc1810fa96ee437679) )
	ROM_LOAD16_BYTE( "95401718.hi", 0x00000, 0x080000, CRC(0b1ee534) SHA1(ba6c50b2f2cd94f7b614eb9ae38d3a9c4c95e3cf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_himi )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406314.lo", 0x00001, 0x080000, CRC(3261fa40) SHA1(9c9c6a5c186c04b8944dc53c71eb91b95032099b) )
	ROM_LOAD16_BYTE( "95406315.hi", 0x00000, 0x080000, CRC(00ac5eb7) SHA1(d028d0d807548cb3b35186559961cc4b02610d2c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406630.lo", 0x00001, 0x080000, CRC(9b5a9254) SHA1(aeb70462bd0459692556c25645c186990d0239c6) )
	ROM_LOAD16_BYTE( "95406631.hi", 0x00000, 0x080000, CRC(6d672785) SHA1(95f8e5c76c0cc778d1e2cc6f2c442fb33db85f7f) )
	ROM_LOAD16_BYTE( "95407314.lo", 0x00001, 0x080000, CRC(0bf964fb) SHA1(169e2f58ee7c7a9dad628bde83db8ce02fe46112) )
	ROM_LOAD16_BYTE( "95407315.hi", 0x00000, 0x080000, CRC(d2103c26) SHA1(00ad4ac6dbbf083eacb8a74db3503d5a340111b1) )
	ROM_LOAD16_BYTE( "95407630.lo", 0x00001, 0x080000, CRC(9857010a) SHA1(8bb8a9f920eadb7db53ab8ce035a89a6fc3c2f76) )
	ROM_LOAD16_BYTE( "95407631.hi", 0x00000, 0x080000, CRC(4ff9bde2) SHA1(2a84d799e23b77a907cb47d20673c298009a6082) )
	ROM_LOAD16_BYTE( "95408226.lo", 0x00001, 0x080000, CRC(8064537e) SHA1(4a93fc2daa2fd0c00959be35f42b1df16b72d88c) )
	ROM_LOAD16_BYTE( "95408227.hi", 0x00000, 0x080000, CRC(11730edb) SHA1(5768f4e003a81adbde850f0ca6d78e025e35be9f) )
	ROM_LOAD16_BYTE( "95414294.lo", 0x00001, 0x080000, CRC(1270edf8) SHA1(2b349f483dbdb6340ce0a36373dabded6e64fa9d) )
	ROM_LOAD16_BYTE( "95414295.hi", 0x00000, 0x080000, CRC(c35e8bf3) SHA1(696f1fc8ba4e8fe161df7a1813ed9299df664941) )
	ROM_LOAD16_BYTE( "95414296.lo", 0x00001, 0x080000, CRC(3483183b) SHA1(e1bf97d764f64be849629b861c74c6471a932309) )
	ROM_LOAD16_BYTE( "95414297.hi", 0x00000, 0x080000, CRC(0288ef0c) SHA1(7b10ff4e83e569a368be6bd41e99943bcd3e90c9) )
	ROM_LOAD16_BYTE( "95415294.lo", 0x00001, 0x080000, CRC(ee4b8561) SHA1(7b48f86a0b2113b9e62c444013a6ab0204d9bcff) )
	ROM_LOAD16_BYTE( "95415295.hi", 0x00000, 0x080000, CRC(3242df75) SHA1(ca8dc4035bef9035ca1e1677410ca0f54c085c6d) )
	ROM_LOAD16_BYTE( "95415296.lo", 0x00001, 0x080000, CRC(c8b870a2) SHA1(cc9dfa0b78b41da2d93c310d6b40aa483ab7c92c) )
	ROM_LOAD16_BYTE( "95415297.hi", 0x00000, 0x080000, CRC(f394bb8a) SHA1(3ed3013a0eb3f6daafa2861edde44b9729b0a132) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008268.bin", 0x0000, 0x0ff264, CRC(6d5e7041) SHA1(bcc7b5c000aa8c25818aa063cd74f998484224a2) )
ROM_END




ROM_START( sc_hi5 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402946.lo", 0x00001, 0x080000, CRC(f771bfa5) SHA1(f774666e66eaef49ef3fe3ef093b7bd8ab9223f7) )
	ROM_LOAD16_BYTE( "95402947.hi", 0x00000, 0x080000, CRC(41154e48) SHA1(355be96950e238e3caea7d8b51d197c23e4749af) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402948.lo", 0x00001, 0x080000, CRC(046caffe) SHA1(15f35b1baa44a9dd2d2772abb9da71a02d565760) )
	ROM_LOAD16_BYTE( "95402949.hi", 0x00000, 0x080000, CRC(c4215d0c) SHA1(4fc25fecc598950cc9edb25ccda516abe3bf9f70) )
	ROM_LOAD16_BYTE( "95402964.lo", 0x00001, 0x080000, CRC(e6d80d1d) SHA1(fd22d0cd6611e4ec778968103c36bceab1d202f1) )
	ROM_LOAD16_BYTE( "95402965.hi", 0x00000, 0x080000, CRC(c16d6b5b) SHA1(d013ae1dc3739d5259c293ff2e0c2425ceec51ec) )
	ROM_LOAD16_BYTE( "95402966.lo", 0x00001, 0x080000, CRC(e07555c5) SHA1(98b21c65e238d1a3749d5f0021110df1910db1c4) )
	ROM_LOAD16_BYTE( "95402967.hi", 0x00000, 0x080000, CRC(59302818) SHA1(ea7b3c1604bf403ac2c3dca7bf780203390203dd) )
	ROM_LOAD16_BYTE( "95403946.lo", 0x00001, 0x080000, CRC(dbbdd3bc) SHA1(df9efd737b467dc502f77cc779923f4eca0ba8d7) )
	ROM_LOAD16_BYTE( "95403947.hi", 0x00000, 0x080000, CRC(785ce105) SHA1(82bccb49096c2b3b2d1440177d80c4d4c78f937d) )
	ROM_LOAD16_BYTE( "95403948.lo", 0x00001, 0x080000, CRC(f7b890ff) SHA1(47c192f3a9a258bf44b903dabfccc30eeef4cbbb) )
	ROM_LOAD16_BYTE( "95403949.hi", 0x00000, 0x080000, CRC(e45dc9b3) SHA1(c83852613b0bbb90751b32f4441f2688345e1624) )
	ROM_LOAD16_BYTE( "95403964.lo", 0x00001, 0x080000, CRC(d22732b4) SHA1(95a368d244a3eadc638a9f6c43aeda87db690444) )
	ROM_LOAD16_BYTE( "95403965.hi", 0x00000, 0x080000, CRC(cdf7f6a2) SHA1(415257fc2944b0e989ac76e0f6afa52502bee02d) )
	ROM_LOAD16_BYTE( "95403966.lo", 0x00001, 0x080000, CRC(5c26b8d9) SHA1(e38042a45981d6336812b614f5b6cdabc53f54d0) )
	ROM_LOAD16_BYTE( "95403967.hi", 0x00000, 0x080000, CRC(57d7ed01) SHA1(286bf64b455e572fe392191885ef3e2076ae22c9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008107.bin", 0x0000, 0x100000, CRC(f2b5a284) SHA1(c2b427aa59a233eedefff55d3afdc120f486af83) )
	ROM_LOAD( "95008108.bin", 0x0000, 0x100000, CRC(c8bd435d) SHA1(cc78030ae92424db3ba572f355d12db7f9291bd7) )
ROM_END




ROM_START( sc_sprng )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406592.lo", 0x00001, 0x080000, CRC(fbf0d51a) SHA1(320430a66f8d793ffa55b1f3bfa293deb9122ca3) )
	ROM_LOAD16_BYTE( "95406593.hi", 0x00000, 0x080000, CRC(5697bdc7) SHA1(c1e3952dd66772159b193a99bf4c8fbf92e0cf2f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008276.bin", 0x0000, 0x0f7b99, CRC(e13380bd) SHA1(f4ec3f2d4d8f20e82324fda89e5383a9689bf02a) )
ROM_END




ROM_START( sc_hill )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412954.lo", 0x00001, 0x080000, CRC(0349a398) SHA1(209c6f8282a3ef95a20ce92db85b9b7e8e179bfd) )
	ROM_LOAD16_BYTE( "95412955.hi", 0x00000, 0x080000, CRC(336302b6) SHA1(560a71c9de9e11d0a82e048f49ab4bfe4e112ea8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412982.lo", 0x00001, 0x080000, CRC(74eb09da) SHA1(ddc5d159727b0a5c7c17d5e14e5ab1e6214bcc39) )
	ROM_LOAD16_BYTE( "95412983.hi", 0x00000, 0x080000, CRC(4b5de886) SHA1(df937ca98c29fd7d7f2b2943e9b625d0f67cc555) )
	ROM_LOAD16_BYTE( "95413954.lo", 0x00001, 0x080000, CRC(f71a75d2) SHA1(1f1c88513e4aeae694bab21d0b566a5c566771b1) )
	ROM_LOAD16_BYTE( "95413955.hi", 0x00000, 0x080000, CRC(490e56e2) SHA1(c27b01c773e00aa18084b25df2d145f4948a696f) )
	ROM_LOAD16_BYTE( "95413982.lo", 0x00001, 0x080000, CRC(e649181c) SHA1(d197bc0d65e59b0ac0b1fd344213b5db3b11d7af) )
	ROM_LOAD16_BYTE( "95413983.hi", 0x00000, 0x080000, CRC(054304e1) SHA1(14ca648a59cc66a262abb2f0628a6f39772490eb) )

	ROM_LOAD16_BYTE( "hillbill.p1", 0x00000, 0x080000, CRC(997165fa) SHA1(12ffd1b841fcf9b2cd88abb35f540ef2731cbc5e) )
	ROM_LOAD16_BYTE( "hillbill.p2", 0x00001, 0x080000, CRC(2572af4d) SHA1(9ad6e90a751b483d04189a3f03d76439bc04856b) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008494.bin", 0x0000, 0x100000, CRC(b2a2d2ca) SHA1(f9cd50c043dd58e4c92f94e4255c2fcb47963d39) )
ROM_END




ROM_START( sc_hilo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404330.lo", 0x00001, 0x080000, CRC(8e7952a0) SHA1(1092a4aa124e2d07efe4fc92bd43cc23a49cca9b) )
	ROM_LOAD16_BYTE( "95404331.hi", 0x00000, 0x080000, CRC(02b4fb75) SHA1(6e310c1e80c7f6640d2bb98e8b60b49d86137674) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404452.lo", 0x00001, 0x080000, CRC(b51678d8) SHA1(3b877975b1386691e2b377916f91e0248bd35f56) )
	ROM_LOAD16_BYTE( "95404453.hi", 0x00000, 0x080000, CRC(cd0aaa2f) SHA1(3c04bb3db09b988b83abc0cc49c6cc30ce2d5648) )
	ROM_LOAD16_BYTE( "95405330.lo", 0x00001, 0x080000, CRC(23067f38) SHA1(6feedee27bfc4f201576e80a072c8624f9848320) )
	ROM_LOAD16_BYTE( "95405331.hi", 0x00000, 0x080000, CRC(271c7551) SHA1(37228f0ceb0104a587671c7841244a8ffd6cf3e1) )
	ROM_LOAD16_BYTE( "95405452.lo", 0x00001, 0x080000, CRC(11bf33a6) SHA1(a8b0419528bb8bee028b27974d03512f37ce201f) )
	ROM_LOAD16_BYTE( "95405453.hi", 0x00000, 0x080000, CRC(002393d5) SHA1(24c288d119e88487273e5918af7bd2dc523ee791) )
	ROM_LOAD16_BYTE( "95406020.lo", 0x00001, 0x080000, CRC(e643afed) SHA1(6cba7056deaa963a7c7edc5a078787071fb64a03) )
	ROM_LOAD16_BYTE( "95406021.hi", 0x00000, 0x080000, CRC(b5206525) SHA1(7e69f45e921fd5ff651557acfd7ffe5afda4aa7c) )
	ROM_LOAD16_BYTE( "95406902.lo", 0x00001, 0x080000, CRC(87f40bc0) SHA1(69d33596d62bbf2019bae2d6cd5b486cdf9d5b45) )
	ROM_LOAD16_BYTE( "95406903.hi", 0x00000, 0x080000, CRC(6b6e2f21) SHA1(e20aa98988e21530d765480c048fa93e3e14c603) )
	ROM_LOAD16_BYTE( "95406904.lo", 0x00001, 0x080000, CRC(0ec41240) SHA1(e011501ae8e75765b451921f04350caaa04b7c2a) )
	ROM_LOAD16_BYTE( "95406905.hi", 0x00000, 0x080000, CRC(55f66037) SHA1(5139cb3e29696ac9dce142852b4db7d301b1761d) )
	ROM_LOAD16_BYTE( "95407020.lo", 0x00001, 0x080000, CRC(b415a33b) SHA1(653a0d9f682e894871720efbd4ee2fba49516ce4) )
	ROM_LOAD16_BYTE( "95407021.hi", 0x00000, 0x080000, CRC(09fe7f6c) SHA1(7c3822ce57ef45cec6e251a545c5378cfa54d999) )
	ROM_LOAD16_BYTE( "95407902.lo", 0x00001, 0x080000, CRC(a76eed40) SHA1(25d15035dce6e37d6cf8b28070166d457e038057) )
	ROM_LOAD16_BYTE( "95407903.hi", 0x00000, 0x080000, CRC(8c31e25f) SHA1(5757c01ec0535eb0ecdbcef2be13cf520b6eca5e) )
	ROM_LOAD16_BYTE( "95407904.lo", 0x00001, 0x080000, CRC(64b34099) SHA1(2e6956fe25072dea9bc1566bae0cdfe1676eb3ef) )
	ROM_LOAD16_BYTE( "95407905.hi", 0x00000, 0x080000, CRC(42e12406) SHA1(3eea44d6f46338e0c22bce2ea8770f885ac0c7fa) )
	ROM_LOAD16_BYTE( "95408332.lo", 0x00001, 0x080000, CRC(4d1c053a) SHA1(6dc8327897e976bd50a13ae73951e10fb3c4dbda) )
	ROM_LOAD16_BYTE( "95408333.hi", 0x00000, 0x080000, CRC(324c50af) SHA1(dcb7e2eb5d08d0827a1ca6480c1aeac7cd705a5f) )
	ROM_LOAD16_BYTE( "95409332.lo", 0x00001, 0x080000, CRC(4ad6ab9a) SHA1(1c7d151dac97758a43d8c85f9b625a37627384f0) )
	ROM_LOAD16_BYTE( "95409333.hi", 0x00000, 0x080000, CRC(cd60de97) SHA1(ec827addeaf97fce58024a2baae75ec1a1bf9bb0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008177.bin", 0x0000, 0x100000, CRC(4dad5ea3) SHA1(efa226af2bae5bab25deb3507a635412b0f031e8) )
	ROM_LOAD( "95008178.bin", 0x0000, 0x100000, CRC(3a59e427) SHA1(7d530426a57dd9651aef51730b0b8a5324f81024) )
ROM_END




ROM_START( sc_hiss )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416268.odd", 0x00001, 0x080000, CRC(193027b5) SHA1(95a6a11dea8609048e4f00b6c2bc2e48a8174263) )
	ROM_LOAD16_BYTE( "95416269.evn", 0x00000, 0x080000, CRC(f4782903) SHA1(870340d75d19a876aeb71449424dc41b03a0a6ce) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416506.odd", 0x00001, 0x080000, CRC(b362b7e0) SHA1(6363a70310debd9948f152d6f08fa323dd7fbb09) )
	ROM_LOAD16_BYTE( "95416507.evn", 0x00000, 0x080000, CRC(9c933840) SHA1(a781bf357eb6012a2d28b4d5369f8a60e2a92cab) )
	ROM_LOAD16_BYTE( "95416508.odd", 0x00001, 0x080000, CRC(a65a629a) SHA1(cef0a84f669852655b1b085f52f9dbc11d0f9cfb) )
	ROM_LOAD16_BYTE( "95416509.evn", 0x00000, 0x080000, CRC(2c09b047) SHA1(0854921111d7303e66fdd67c0f917a6f2574641b) )
	ROM_LOAD16_BYTE( "95417268.odd", 0x00001, 0x080000, CRC(f6424b2d) SHA1(2ad4e9ed0f5f89e4fa0e758cb74c17ae0a956b15) )
	ROM_LOAD16_BYTE( "95417269.evn", 0x00000, 0x080000, CRC(709c9253) SHA1(a1075c726ba0d4ad1a4288ce7da9e890773d0393) )
	ROM_LOAD16_BYTE( "95417506.odd", 0x00001, 0x080000, CRC(1c39af09) SHA1(0b9b502afc1d4c885eaeec6b2ac75bc44545c4bb) )
	ROM_LOAD16_BYTE( "95417507.evn", 0x00000, 0x080000, CRC(2d7645b8) SHA1(b809e577cddb42293d8dca1b84bee549e1b32a1c) )
	ROM_LOAD16_BYTE( "95417508.odd", 0x00001, 0x080000, CRC(460ebd98) SHA1(7de8e862c88d4b41c158eeb7a41c7ace43a43f24) )
	ROM_LOAD16_BYTE( "95417509.evn", 0x00000, 0x080000, CRC(8b009f24) SHA1(879211fa80e48d0842bd610580c698cfc28ced76) )
	ROM_LOAD16_BYTE( "95420402.lo", 0x00001, 0x080000, CRC(99eaf0ba) SHA1(cf57f189587fa19658ffc55a05fba113eb5e40e2) )
	ROM_LOAD16_BYTE( "95420403.hi", 0x00000, 0x080000, CRC(36e4a630) SHA1(b825d0141c805d6e4cb5ed5753987037014f7256) )
	ROM_LOAD16_BYTE( "95420404.lo", 0x00001, 0x080000, CRC(4fab20fd) SHA1(85d0f10d8499ab03474e96df7c1e0e816e89441a) )
	ROM_LOAD16_BYTE( "95420405.hi", 0x00000, 0x080000, CRC(4b42567e) SHA1(d7faa5786ab4ade9ef80e081e8475b54e0c9da1e) )
	ROM_LOAD16_BYTE( "95420752.lo", 0x00001, 0x080000, CRC(06e74bfb) SHA1(240a62a3855925345296ce0fc4e8f47b97a33d3d) )
	ROM_LOAD16_BYTE( "95420753.hi", 0x00000, 0x080000, CRC(931c2306) SHA1(ba182abda4e4a91d4132223c16686e3d54206f7f) )
	ROM_LOAD16_BYTE( "95421402.lo", 0x00001, 0x080000, CRC(376f101f) SHA1(f4124abf660c55e68561ec810fb306c8f00a53bf) )
	ROM_LOAD16_BYTE( "95421403.hi", 0x00000, 0x080000, CRC(aee8c285) SHA1(d4d03a8d17b8ab36e66f143ffc03325a267f3833) )
	ROM_LOAD16_BYTE( "95421404.lo", 0x00001, 0x080000, CRC(88453934) SHA1(0e77d294aba735b9dcab5a3c5fc931066582f7e3) )
	ROM_LOAD16_BYTE( "95421405.hi", 0x00000, 0x080000, CRC(7425dd4f) SHA1(3c4ed325911092f923d37d321585e2bb23d71e66) )
	ROM_LOAD16_BYTE( "95421752.lo", 0x00001, 0x080000, CRC(5addeeae) SHA1(49e13faf64b8e8f895af32b1cbbef083a72ad185) )
	ROM_LOAD16_BYTE( "95421753.hi", 0x00000, 0x080000, CRC(7c733653) SHA1(f47d960bd2fad92486d80182be68d0187a3c0ce2) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008910.bin", 0x0000, 0x0fff2c, CRC(e5079d76) SHA1(0c44060d695e44720e7c34a9a142bdccd86ee943) )
ROM_END




ROM_START( sc_hitsh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406076.lo", 0x00001, 0x080000, CRC(bf3c9301) SHA1(695ac8edd5e6bbf32d9a8bc6d8586ed0e194b1cd) )
	ROM_LOAD16_BYTE( "95406077.hi", 0x00000, 0x080000, CRC(d3081ee2) SHA1(07eb41b8bb0ee3c5dcaf4c9413e7818e2a1c18b8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406310.lo", 0x00001, 0x080000, CRC(d6a639ab) SHA1(0760d5947de187290603a31deb925e7b9157344d) )
	ROM_LOAD16_BYTE( "95406311.hi", 0x00000, 0x080000, CRC(8e341ac0) SHA1(76a6499605d25c15eb7b35e5b4376313d8d47aa9) )
	ROM_LOAD16_BYTE( "95407076.lo", 0x00001, 0x080000, CRC(3bb596e6) SHA1(12794b97feb3d7c8fba576b1259ee06662d397df) )
	ROM_LOAD16_BYTE( "95407077.hi", 0x00000, 0x080000, CRC(23e959fe) SHA1(20a94acff8ff31aa0ee209dbaae0d7071e6d8324) )
	ROM_LOAD16_BYTE( "95407310.lo", 0x00001, 0x080000, CRC(59e647ba) SHA1(8793fd542e85d7b5b7e8fb2364a800e9eea7fd61) )
	ROM_LOAD16_BYTE( "95407311.hi", 0x00000, 0x080000, CRC(b9b4c722) SHA1(8d165226b4f0a437b9da7431b76505386eaa4115) )
	ROM_LOAD16_BYTE( "95408272.lo", 0x00001, 0x080000, CRC(582e3280) SHA1(e5f78e94bb2d1eb0a673cc1103dd910b9bf1c582) )
	ROM_LOAD16_BYTE( "95408273.hi", 0x00000, 0x080000, CRC(448102ea) SHA1(582190bc07bcc03e0846c68e5b08795de1b3c74b) )
	ROM_LOAD16_BYTE( "95409272.lo", 0x00001, 0x080000, CRC(2fb376c7) SHA1(ba875aa81c705c9a4b7edb65d9574c720b533769) )
	ROM_LOAD16_BYTE( "95409273.hi", 0x00000, 0x080000, CRC(3d3184d9) SHA1(1825bc5379e58db7319f391fca4d690a0dcb4b9c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008239.bin", 0x0000, 0x100000, CRC(cc12346b) SHA1(dd3656a3024c3d26348482c3aa04e0f6638053f7) )
ROM_END




ROM_START( sc_holyw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402151.lo", 0x00001, 0x080000, CRC(324c130b) SHA1(43088cf08ae96753b72c15c8b10bd508eb21935b) )
	ROM_LOAD16_BYTE( "95402152.hi", 0x00000, 0x080000, CRC(c491344e) SHA1(c67475afbcf736852eb5f63cf821f6d2460a4d19) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402153.lo", 0x00001, 0x080000, CRC(d78406fa) SHA1(2bad25ee032beb35def924cc30cfb0f6cacacbfd) )
	ROM_LOAD16_BYTE( "95402154.hi", 0x00000, 0x080000, CRC(7a23bcb9) SHA1(49ba57c4f45602a8454b405a7750bf08cbb062ea) )
	ROM_LOAD16_BYTE( "95403151.lo", 0x00001, 0x080000, CRC(2ed32d9f) SHA1(294ecb67e49db4fbaeece6c50d93bf857562cc03) )
	ROM_LOAD16_BYTE( "95403152.hi", 0x00000, 0x080000, CRC(d09f680d) SHA1(375e2c9dd07c3f1f4c5ab1b1001c6b74dc5e018a) )
	ROM_LOAD16_BYTE( "95403153.lo", 0x00001, 0x080000, CRC(2ceb3e73) SHA1(8816b6c2759bc5817a9e9b8484b828f0bb56fe22) )
	ROM_LOAD16_BYTE( "95403154.hi", 0x00000, 0x080000, CRC(e9585b26) SHA1(309c554e2bff84d47337b8b1b73dc4a8aac9c9bf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008071.bin", 0x0000, 0x100000, CRC(005c5847) SHA1(9d8a801e70f5b1c07d46a4f6e9fab22adf5a9415) )
	ROM_LOAD( "95008072.bin", 0x0000, 0x100000, CRC(78756706) SHA1(56b744ec5cb431b30c13bc748d323ebe14727546) )
ROM_END






ROM_START( sc_hotdg )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1916p12.hi", 0x00000, 0x080000, CRC(0cae3d8f) SHA1(a8599ba8bb48934f4717695e9f54d5f086a30f54) )
	ROM_LOAD16_BYTE( "p1916p12.lo", 0x00001, 0x080000, CRC(aad6a266) SHA1(98d42dcdd93c800a9b4a93636f3b7dc85137248e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1916p42.hi", 0x00000, 0x080000, CRC(24002fad) SHA1(a7d240726de1a78ccd032019cdd2c1a528f68ee4) )
	ROM_LOAD16_BYTE( "p1916p42.lo", 0x00001, 0x080000, CRC(2e33fc1a) SHA1(a0d9d0935e2c2bb3eb4b5a6c2d34e21d124b8376) )
	ROM_LOAD16_BYTE( "p1916p43.hi", 0x00000, 0x080000, CRC(7ddda754) SHA1(347d0586b054f463a3572b78c38237da4e9f46b9) )
	ROM_LOAD16_BYTE( "p1916p43.lo", 0x00001, 0x080000, CRC(63edfe15) SHA1(986bf6845a084d2a06ffc94765b1e56d3dd0a5a4) )
//  ROM_LOAD16_BYTE( "p1916p43.txt", 0x0000, 0x0000e6, CRC(927a6140) SHA1(24263491ea82ba45dc3bc2560df1773e0bb76ead) )
	ROM_LOAD16_BYTE( "p1916s12.hi", 0x00000, 0x080000, CRC(53ead733) SHA1(2f7ddca4662078fd1f221274cf420f0bc2fce714) )
	ROM_LOAD16_BYTE( "p1916s12.lo", 0x00001, 0x080000, CRC(2e6a0755) SHA1(62db870df95deb645e22925f6ce234598bbbefeb) )
	ROM_LOAD16_BYTE( "p1916s42.hi", 0x00000, 0x080000, CRC(0f72d194) SHA1(52dd33c58d720dfb97d008715dda2965786db129) )
	ROM_LOAD16_BYTE( "p1916s42.lo", 0x00001, 0x080000, CRC(266d2ce7) SHA1(dbd4d5892e6efdcbf72928be7595336d5c04f035) )
	ROM_LOAD16_BYTE( "p1916s43.hi", 0x00000, 0x080000, CRC(5cdb8043) SHA1(4ccce12a13ca65a25aa5936cc81445a93734c2d7) )
	ROM_LOAD16_BYTE( "p1916s43.lo", 0x00001, 0x080000, CRC(09cf7a39) SHA1(099441349ec9b9cc1fb0c43172623cc2c1ca90af) )
	ROM_LOAD16_BYTE( "p1936p42.hi", 0x00000, 0x080000, CRC(ae8e4467) SHA1(555ae664fdb85ad4ea3abd20189c5823ebcc16a0) )
	ROM_LOAD16_BYTE( "p1936p42.lo", 0x00001, 0x080000, CRC(1975e059) SHA1(f7edd621806c4045f3f3fb062c41e943f2028639) )
	ROM_LOAD16_BYTE( "p1936p43.lo", 0x00001, 0x080000, CRC(61ba3980) SHA1(38c3ffdd004467e39679eafc04892d5c4dbf761f) )
	ROM_LOAD16_BYTE( "p1936s42.hi", 0x00000, 0x080000, CRC(1bb44d7b) SHA1(f2cae86ad19cd2c951410a4cbb71b20e87a90ef8) )
	ROM_LOAD16_BYTE( "p1936s42.lo", 0x00001, 0x080000, CRC(78c3dbad) SHA1(c78225d108dc1a8f289ae6fd7f6cd78a6eea1d00) )
	ROM_LOAD16_BYTE( "p1936s43.hi", 0x00000, 0x080000, CRC(476c133f) SHA1(2c65820aec9fe4b9e92a2b3dc694f380856dea21) )
	ROM_LOAD16_BYTE( "p1936s43.lo", 0x00001, 0x080000, CRC(e8057da6) SHA1(dc9415d58a449597df8edce880eae19630b04c98) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_hotpr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402476.lo", 0x00001, 0x080000, CRC(e45bbd52) SHA1(a2cea405455404958b2ea7f55bbf38093400aafe) )
	ROM_LOAD16_BYTE( "95402477.hi", 0x00000, 0x080000, CRC(4c1d0262) SHA1(34b266a921f5e4270e099812d6132351e1d9ca32) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402492.lo", 0x00001, 0x080000, CRC(cf58b928) SHA1(356b95461b7981a89a3a5f4c9971bd7ec1aa9a66) )
	ROM_LOAD16_BYTE( "95402493.hi", 0x00000, 0x080000, CRC(ffbb6a98) SHA1(9f561c0ab52019f17302b0f87ec9d9e5631238a7) )
	ROM_LOAD16_BYTE( "95403476.lo", 0x00001, 0x080000, CRC(6a6a1bf5) SHA1(f72b34efd391234ffa08993a832dc3497a136477) )
	ROM_LOAD16_BYTE( "95403477.hi", 0x00000, 0x080000, CRC(bc2ca284) SHA1(427fde72e3aba0b84b30d2f5bd0d5cbe480be84f) )
	ROM_LOAD16_BYTE( "95403492.lo", 0x00001, 0x080000, CRC(5a14b4f1) SHA1(421cf94634cb49fe91f7022aa89a7e845e509e93) )
	ROM_LOAD16_BYTE( "95403493.hi", 0x00000, 0x080000, CRC(7717b82d) SHA1(16658464ef1cc8a36a1a95471ec1cb6e97f7b80b) )
	ROM_LOAD16_BYTE( "95404356.lo", 0x00001, 0x080000, CRC(ec7e87d8) SHA1(2562930cf42ee4c4583532320ab5dd21cb415f50) )
	ROM_LOAD16_BYTE( "95404357.hi", 0x00000, 0x080000, CRC(16081ab9) SHA1(2187eec6b881fedcf6be46259d6f4001ed1a2b25) )
	ROM_LOAD16_BYTE( "95405356.lo", 0x00001, 0x080000, CRC(b3857f12) SHA1(a7743a104cef0225148549aba6939c3d36d7045f) )
	ROM_LOAD16_BYTE( "95405357.hi", 0x00000, 0x080000, CRC(abe8ac80) SHA1(7176d8bbbbfb02bce56724ea47b62bd95feaa256) )
	ROM_REGION( 0x800000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "hotpropertysnd1.bin", 0x0000, 0x100000, CRC(f06cb0f1) SHA1(856bdd31a35e93e6f52f88f2ac738cc3fab09c11) )
	ROM_LOAD( "hotpropertysnd2.bin", 0x0000, 0x100000, CRC(cce5a2a7) SHA1(4884e8abe2dde81f70ddc13a3a68d690fc097dae) )
	// bad dumps of snd1?
	ROM_LOAD( "95008015.lo", 0x00000, 0x800000, CRC(6553f5b9) SHA1(17ab5162f4fd3fa5a56641f0b1cbc31c0fe1a52c) )
	ROM_LOAD( "95008016.lo", 0x00000, 0x800000, CRC(6553f5b9) SHA1(17ab5162f4fd3fa5a56641f0b1cbc31c0fe1a52c) )
	// more alternates, or are these Monopoly Hot Property?
	ROM_LOAD( "hot_p.sn1", 0x0000, 0x080000, CRC(c918da0e) SHA1(7eebd41c70be65b1455bafd4087246f41a8b3622) )
	ROM_LOAD( "hot_p.sn2", 0x0000, 0x080000, CRC(31fa3827) SHA1(aa099bfda63d3627cab2b5f12fe0ec7d8600f90e) )

ROM_END




ROM_START( sc_hotrd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418236.lo", 0x00001, 0x080000, CRC(5d269eef) SHA1(cb5771b2e7d59b94140db9fc534b9ea468e32297) )
	ROM_LOAD16_BYTE( "95418237.hi", 0x00000, 0x080000, CRC(d47fe059) SHA1(8eb3a2cde00c8db17daaad945705e718a7f47930) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418238.lo", 0x00001, 0x080000, CRC(97fcc01f) SHA1(35b382fc2b3b582f234818e358d8785bb1617563) )
	ROM_LOAD16_BYTE( "95418239.hi", 0x00000, 0x080000, CRC(452c6e2f) SHA1(badc230257478bb2c73eca9015b9e3e8ca8f022b) )
	ROM_LOAD16_BYTE( "95419236.lo", 0x00001, 0x080000, CRC(3497d99f) SHA1(7d97d826e48714ace13cfe683f40338004744bf1) )
	ROM_LOAD16_BYTE( "95419237.hi", 0x00000, 0x080000, CRC(a982f4ad) SHA1(7e37822ebd9e1373c9aa259a3c30dc29b1077bb8) )
	ROM_LOAD16_BYTE( "95419238.lo", 0x00001, 0x080000, CRC(59f27ac5) SHA1(01714e84735c6b694c33971ec5027cf553ab1422) )
	ROM_LOAD16_BYTE( "95419239.hi", 0x00000, 0x080000, CRC(a1e79c90) SHA1(caacc2bda9aa86b42d343dda55134da29b774372) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008571.bin", 0x0000, 0x100000, CRC(50331772) SHA1(84aa448320210bfa8ea656f59cc4a320a0a46a32) )
ROM_END




ROM_START( sc_hotsh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426378.lo", 0x00001, 0x080000, CRC(b2becc3e) SHA1(d4caf998396ef2c05e28d4420f79f92e9e8d6587) )
	ROM_LOAD16_BYTE( "95426379.hi", 0x00000, 0x080000, CRC(8eac9f24) SHA1(33796e805f62fdf5a06b9f9039b3ba4f26e42c69) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426432.lo", 0x00001, 0x080000, CRC(8fe78f1a) SHA1(08914988aa4b2cdead5d703e3fc4d72a22e57424) )
	ROM_LOAD16_BYTE( "95426433.hi", 0x00000, 0x080000, CRC(33ab3fb0) SHA1(a2e9f93595259ad43fd22f4447f524d3a5a9b4f8) )
	ROM_LOAD16_BYTE( "95426492.lo", 0x00001, 0x080000, CRC(7748a9e4) SHA1(e7c05ffd0818806a14e85d877a930d8a29d3772f) )
	ROM_LOAD16_BYTE( "95426493.hi", 0x00000, 0x080000, CRC(eb082ebb) SHA1(a12db425c4f574d243d9efc92bb7aee5e9c52bb1) )
	ROM_LOAD16_BYTE( "95426494.lo", 0x00001, 0x080000, CRC(83f08974) SHA1(1fca9ceb3e8cfee276069b5b60a41554b8dc2068) )
	ROM_LOAD16_BYTE( "95426495.hi", 0x00000, 0x080000, CRC(10224462) SHA1(0d7b0689629daabb2f84f7c3d441b8b7d5637c83) )
	ROM_LOAD16_BYTE( "95426662.lo", 0x00001, 0x080000, CRC(7a1da6e9) SHA1(7d5105a552581bc6e9c51efa6a0133db764bb450) )
	ROM_LOAD16_BYTE( "95426663.hi", 0x00000, 0x080000, CRC(f91c2a59) SHA1(2465b73fa5f0f307dff5dddc5b731a88b68d2758) )
	ROM_LOAD16_BYTE( "95426706.lo", 0x00001, 0x080000, CRC(fee0a9cb) SHA1(577c61d3592a8a9312f3a93954cf74ea34f62900) )
	ROM_LOAD16_BYTE( "95426707.hi", 0x00000, 0x080000, CRC(95e2c0f0) SHA1(a82831233060522e92018ad578ae7720498ec19f) )
	ROM_LOAD16_BYTE( "95426806.lo", 0x00001, 0x080000, CRC(31c2e00c) SHA1(f6e891326b43373f0c76256838c2bae0abaa9c6e) )
	ROM_LOAD16_BYTE( "95426807.hi", 0x00000, 0x080000, CRC(fbcded97) SHA1(5b633c0c84bb75ac3a477d7653df6480246041ec) )
	ROM_LOAD16_BYTE( "95427378.lo", 0x00001, 0x080000, CRC(6e791528) SHA1(9041d2b3b32586f07ebd063d9546ae4ab0a01211) )
	ROM_LOAD16_BYTE( "95427379.hi", 0x00000, 0x080000, CRC(7a72e8dd) SHA1(eea65ad5357a91f6566bba7dd080f70e3787d500) )
	ROM_LOAD16_BYTE( "95427432.lo", 0x00001, 0x080000, CRC(ea984167) SHA1(114e62c31287eb5eabaf55ab2366bc11d723da54) )
	ROM_LOAD16_BYTE( "95427433.hi", 0x00000, 0x080000, CRC(ac23eb84) SHA1(4a6279bcf2506f818c65d673caf667f97f7bd7ed) )
	ROM_LOAD16_BYTE( "95427492.lo", 0x00001, 0x080000, CRC(c4f6b00f) SHA1(cdc30c397b70f81ac71af1a9412318204e45a45d) )
	ROM_LOAD16_BYTE( "95427493.hi", 0x00000, 0x080000, CRC(65addb38) SHA1(c503b49ee656e192e602b78b4128e35e1b70a045) )
	ROM_LOAD16_BYTE( "95427494.lo", 0x00001, 0x080000, CRC(8dece917) SHA1(7d2ef3b1d3c67e056e8217cf08588787445b9b62) )
	ROM_LOAD16_BYTE( "95427495.hi", 0x00000, 0x080000, CRC(57d41514) SHA1(f3e24b6ed4495b928b75f9be9705f45cea9872ea) )
	ROM_LOAD16_BYTE( "95427662.lo", 0x00001, 0x080000, CRC(46e7e3ec) SHA1(31101380d68273461dd8c4a0165412b9c27c01d5) )
	ROM_LOAD16_BYTE( "95427663.hi", 0x00000, 0x080000, CRC(72e5da79) SHA1(76ad619f8de621b238a597d484a05cf5dc96b500) )
	ROM_LOAD16_BYTE( "95427706.lo", 0x00001, 0x080000, CRC(80203185) SHA1(b79b2674cd024ffe34a66bdd75702e80e35ee291) )
	ROM_LOAD16_BYTE( "95427707.hi", 0x00000, 0x080000, CRC(217834e6) SHA1(3d83e7dc6e9469bc9d84046a3ee50eb9b3e36f22) )
	ROM_LOAD16_BYTE( "95427806.lo", 0x00001, 0x080000, CRC(9e99b3d3) SHA1(7a33d7722be6be998f98a4d0ad20ee11247191f3) )
	ROM_LOAD16_BYTE( "95427807.hi", 0x00000, 0x080000, CRC(2ba65e5e) SHA1(387ff5b15602033d3a96551ae5e167680c2545c4) )
	ROM_LOAD16_BYTE( "p3211p11.hi", 0x00000, 0x080000, CRC(0b6a1b71) SHA1(d3275c100884f89593747d904f519eb562103954) )
	ROM_LOAD16_BYTE( "p3211p11.lo", 0x00001, 0x080000, CRC(2942b947) SHA1(e43b95175d3a0410a03c57a1f31971058db8e461) )
	ROM_LOAD16_BYTE( "p3211p12.hi", 0x00000, 0x080000, CRC(3e8bd55d) SHA1(f6df6572d05f078b1c1c06504b470043a1cab575) )
	ROM_LOAD16_BYTE( "p3211p12.lo", 0x00001, 0x080000, CRC(4ab31d56) SHA1(76013ec461909b0e0e9ac1230d997fe52c31d697) )
	ROM_LOAD16_BYTE( "p3211p14.hi", 0x00000, 0x080000, CRC(5b338215) SHA1(0773e07fef62eb20f8e2534a87cba1f47328dd48) )
	ROM_LOAD16_BYTE( "p3211p14.lo", 0x00001, 0x080000, CRC(5b0c156c) SHA1(bbec0bb77e5b2049b7a659db8879bdb484cb31eb) )
	ROM_LOAD16_BYTE( "p3211s11.hi", 0x00000, 0x080000, CRC(c7e65025) SHA1(71701b719e4f41788baf61ff02ccce695098e9f0) )
	ROM_LOAD16_BYTE( "p3211s11.lo", 0x00001, 0x080000, CRC(1a7ffa79) SHA1(7460053653cf7faf401058cdf10e18166b539188) )
	ROM_LOAD16_BYTE( "p3211s12.hi", 0x00000, 0x080000, CRC(e2140ecf) SHA1(149e7e82a425c49a707606853625fe18e5b472c4) )
	ROM_LOAD16_BYTE( "p3211s12.lo", 0x00001, 0x080000, CRC(63f95c98) SHA1(66e7eca7627fd7920ea9bf99b9edd474c4f8078f) )
	ROM_LOAD16_BYTE( "p3211s14.hi", 0x00000, 0x080000, CRC(dda94558) SHA1(3477387ae0f3d10e0c8008e7408ab5a09854d878) )
	ROM_LOAD16_BYTE( "p3211s14.lo", 0x00001, 0x080000, CRC(af9d682e) SHA1(0a3a5c2b6374e9d0692ec88698e9ef7a59dd4b48) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008382.bin", 0x0000, 0x100000, CRC(cbf27ec8) SHA1(5be29fb836688e63d90e5a5108c6bdec09dd12a5) )
ROM_END




ROM_START( sc_h6cl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418148.lo", 0x00001, 0x080000, CRC(bf360c94) SHA1(0f07c1985a85579cbf5aba555cd492552a4b1c34) )
	ROM_LOAD16_BYTE( "95418149.hi", 0x00000, 0x080000, CRC(d540c97c) SHA1(5093a6c94d2dc1436d1add924c1af90cf83ad977) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418194.lo", 0x00001, 0x080000, CRC(ebe57e4a) SHA1(df9564a00e38988689371e65b56f02ca57fec262) )
	ROM_LOAD16_BYTE( "95418195.hi", 0x00000, 0x080000, CRC(b76d4561) SHA1(0cd08d51ee08a9179a1f700f7718ae43ce6c35fb) )
	ROM_LOAD16_BYTE( "95419148.lo", 0x00001, 0x080000, CRC(770d4c2e) SHA1(b7407179c6747601cd83826d14607450eb889e6b) )
	ROM_LOAD16_BYTE( "95419149.hi", 0x00000, 0x080000, CRC(99a8fc66) SHA1(23a6c0a29f060c7d8b419da45dbc6e1078f27ed2) )
	ROM_LOAD16_BYTE( "95419194.lo", 0x00001, 0x080000, CRC(9e659d8a) SHA1(5656847d2e1925645238f18bfd9019548339bdeb) )
	ROM_LOAD16_BYTE( "95419195.hi", 0x00000, 0x080000, CRC(29b29377) SHA1(d456b366533a022cafe23b2eaa563aa56c387ce7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008576.bin", 0x0000, 0x100000, CRC(15d77734) SHA1(db314df1dc558ce66d3c4d62895ab699d36bdf46) )
ROM_END




ROM_START( sc_hotwd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408156.lo", 0x00001, 0x080000, CRC(6d2f16a8) SHA1(5aeb5f1fb578e40e093c39e97af0ae68d9b84a61) )
	ROM_LOAD16_BYTE( "95408157.hi", 0x00000, 0x080000, CRC(40bfed36) SHA1(faade9bbce8dca6f29dd2e115208507935ce5c06) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409156.lo", 0x00001, 0x080000, CRC(c625f300) SHA1(b0cab60d228f0bd2f66289068f0ae8473acf6fe7) )
	ROM_LOAD16_BYTE( "95409157.hi", 0x00000, 0x080000, CRC(854e2774) SHA1(7bc443d5add0bc886fec7f336766556bb18ec5cf) )
	ROM_LOAD16_BYTE( "95410742.lo", 0x00001, 0x080000, CRC(cf7541be) SHA1(82f1b92a36446c7bf1d8b474aa42b91e247cd959) )
	ROM_LOAD16_BYTE( "95410743.hi", 0x00000, 0x080000, CRC(f10d6882) SHA1(6f02952351ad16a88057bb8a702748b0f257fb1a) )
	ROM_LOAD16_BYTE( "95410744.lo", 0x00001, 0x080000, CRC(15b02f78) SHA1(471192b014e4fbaaff9279aff56397f3e536d405) )
	ROM_LOAD16_BYTE( "95410745.hi", 0x00000, 0x080000, CRC(d2e37099) SHA1(5c52c24239328b1d8e944cd4728de7c8c77a9905) )
	ROM_LOAD16_BYTE( "95411742.lo", 0x00001, 0x080000, CRC(5e52421a) SHA1(faa1c38a9f57c79e417fa3fda40a7e2f5f50a4f9) )
	ROM_LOAD16_BYTE( "95411743.hi", 0x00000, 0x080000, CRC(fe4b57d3) SHA1(26d3924f7a298fc5b3a23ad1cb54cf5593c5af4a) )
	ROM_LOAD16_BYTE( "95411744.lo", 0x00001, 0x080000, CRC(4e133d64) SHA1(939cbc5e4e28c5c519b2c0288f64220fcb1a4cd2) )
//  ROM_LOAD16_BYTE( "95411744.txt", 0x0000, 0x0000ce, CRC(af120df5) SHA1(65c0f5b10cb80024f455d54514cbb077ac6f3d32) )
	ROM_LOAD16_BYTE( "95411745.hi", 0x00000, 0x080000, CRC(5437310d) SHA1(1b02985c32e9e381a85c57da8c8e1bf79e1ad7a6) )
	ROM_LOAD16_BYTE( "p1311p11.hi", 0x00000, 0x080000, CRC(0cffb3d1) SHA1(15f11f612f2fc7d5b1b418c2c55cb14ca8b023a2) )
	ROM_LOAD16_BYTE( "p1311p11.lo", 0x00001, 0x080000, CRC(f5584b61) SHA1(f2a4bab089a574a93ca26571cda82e4c1275663a) )
	ROM_LOAD16_BYTE( "p1311p12.hi", 0x00000, 0x080000, CRC(a8d989c9) SHA1(38fa0909c4572c67e67d48afa51312a654669fbe) )
	ROM_LOAD16_BYTE( "p1311p12.lo", 0x00001, 0x080000, CRC(75f723ef) SHA1(40eb02aa77e6d515883def4346d825e8f3a85e6f) )
	ROM_LOAD16_BYTE( "p1311p13.hi", 0x00000, 0x080000, CRC(b1da1f1f) SHA1(8f042f4a2c8442bbbeacbf6aae6b95a36e8c09c4) )
	ROM_LOAD16_BYTE( "p1311p13.lo", 0x00001, 0x080000, CRC(c76afc6f) SHA1(43e2999c46d0e2e157660dc0e2729393e5fa1f03) )
	ROM_LOAD16_BYTE( "p1311p15.hi", 0x00000, 0x080000, CRC(1a01e95b) SHA1(9382b739f7e364e252dfeef28fb4b88e99bc8923) )
	ROM_LOAD16_BYTE( "p1311p15.lo", 0x00001, 0x080000, CRC(a1e5d6ca) SHA1(b670904a7e12c7686b72598e16f1b23683a1f94f) )
	ROM_LOAD16_BYTE( "p1311s11.hi", 0x00000, 0x080000, CRC(f527759d) SHA1(4f9ccaf11ce0a0a9691aa2c304d92152cb4048f0) )
	ROM_LOAD16_BYTE( "p1311s11.lo", 0x00001, 0x080000, CRC(77fb5395) SHA1(88f417d2ee5884dd6ceb1fb9ee5b91b81f6b8c30) )
	ROM_LOAD16_BYTE( "p1311s12.hi", 0x00000, 0x080000, CRC(c364eeca) SHA1(e2a6ebbd23329ab517dcedc57ad9df911bff6d4c) )
	ROM_LOAD16_BYTE( "p1311s12.lo", 0x00001, 0x080000, CRC(ac7674bd) SHA1(f45f83c044bb6761b5c466662d946eb3bccff02c) )
	ROM_LOAD16_BYTE( "p1311s13.hi", 0x00000, 0x080000, CRC(592ae4bd) SHA1(42d0d6240dd590867b9f5d56797f98d45313a9a0) )
	ROM_LOAD16_BYTE( "p1311s13.lo", 0x00001, 0x080000, CRC(be15bbb3) SHA1(477bd708c1a6953ecae4d54ba3bb826e1e7a7d13) )
	ROM_LOAD16_BYTE( "p1311s15.hi", 0x00000, 0x080000, CRC(a5c375e3) SHA1(3eb1ab2b99ced4d6ad411491d30afd4242830c72) )
	ROM_LOAD16_BYTE( "p1311s15.lo", 0x00001, 0x080000, CRC(a71d1ce2) SHA1(cd3a34f130c83e29640e3f02983eda76169b5611) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008309.bin", 0x0000, 0x100000, CRC(8cd75778) SHA1(5d75c10b32477faa24c73ad03de75914385787f6) )
	ROM_LOAD( "95008334.bin", 0x0000, 0x100000, CRC(0c334241) SHA1(3e5bde03330a5684a2a40fa94b33345039cd3755) )
ROM_END




ROM_START( sc_hyde )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404528.lo", 0x00001, 0x080000, CRC(09b4c86d) SHA1(53bc826958a247a2cec07d71898942c13f581e24) )
	ROM_LOAD16_BYTE( "95404529.hi", 0x00000, 0x080000, CRC(d4155fa6) SHA1(79dfc0128239973bea55a818fafbc2f8c5595b4f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405528.lo", 0x00001, 0x080000, CRC(80113a3d) SHA1(bdbfdf73dfb2db3cf9bc2f79419c462a6a0c44be) )
	ROM_LOAD16_BYTE( "95405529.hi", 0x00000, 0x080000, CRC(8dd94d2a) SHA1(e87ddd95306d530de8a4ae391518821839b67acf) )
	ROM_LOAD16_BYTE( "95406142.lo", 0x00001, 0x080000, CRC(8366d2dc) SHA1(975689eff5c5fde2ee0fb6dce23a3361b0761d78) )
	ROM_LOAD16_BYTE( "95406143.hi", 0x00000, 0x080000, CRC(bd10d110) SHA1(a9c620d862261770c09eb39eb84d9cdda5319baa) )
	ROM_LOAD16_BYTE( "95407142.lo", 0x00001, 0x080000, CRC(cd8bf33c) SHA1(7eba0c1118de807a13267541860e60b9f63a03e3) )
	ROM_LOAD16_BYTE( "95407143.hi", 0x00000, 0x080000, CRC(59a3239d) SHA1(1cb89245e53a8a35cf86dac5db37ab656e44cc40) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_hyper )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406308.lo", 0x00001, 0x080000, CRC(027e5d34) SHA1(68812625408bcd4ece0be429974f3a767c9f6b6b) )
	ROM_LOAD16_BYTE( "95406309.hi", 0x00000, 0x080000, CRC(2ac47aae) SHA1(a44a66e50d649cefd070d12ae5c1aa96926376c0) )
	ROM_LOAD16_BYTE( "95407162.lo", 0x00001, 0x080000, CRC(e751dc77) SHA1(da52a96b4d32d8c8efeea82b28d4c6abf9afc298) )
	ROM_LOAD16_BYTE( "95407163.hi", 0x00000, 0x080000, CRC(309e2d9e) SHA1(e692251d7a1aa24d080da9bb8f1d7134fdea31be) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_celeb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412424.lo", 0x00001, 0x080000, CRC(391bf7c3) SHA1(02c316aa45dd404d9ddb46120ec206ec8830f211) )
	ROM_LOAD16_BYTE( "95412425.hi", 0x00000, 0x080000, CRC(62784b29) SHA1(ceb750d2a053073d62e4935a94ff4ddbba1a20ec) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412450.lo", 0x00001, 0x080000, CRC(3ecc7ad0) SHA1(d412f6ee4d5555b81cd8880624fe0d6a74bd7162) )
	ROM_LOAD16_BYTE( "95412451.hi", 0x00000, 0x080000, CRC(b2175e84) SHA1(5c9b1fad20e1e24878f412f3aae1633a76fdc2d6) )
	ROM_LOAD16_BYTE( "95412452.lo", 0x00001, 0x080000, CRC(ad38d950) SHA1(ceece0814ee5d436b39fe115020812da89c14e47) )
	ROM_LOAD16_BYTE( "95412453.hi", 0x00000, 0x080000, CRC(252415c3) SHA1(6b561d9301105050804b2cac18703fe862fff651) )
	ROM_LOAD16_BYTE( "95412568.lo", 0x00001, 0x080000, CRC(2fc69a9d) SHA1(df7a49bc9da5292189adf8b72acfeb8b0c2abebc) )
	ROM_LOAD16_BYTE( "95412569.hi", 0x00000, 0x080000, CRC(893c2f30) SHA1(84575fd6e815f4978e6fbacf3c5b27313636e98b) )
	ROM_LOAD16_BYTE( "95412582.lo", 0x00001, 0x080000, CRC(e7be047f) SHA1(a0c20b6463f48cd632ed9e97ba12b8cba818baa8) )
	ROM_LOAD16_BYTE( "95412583.hi", 0x00000, 0x080000, CRC(3195b94e) SHA1(af6d32f6e0f1c55ab8e066782e12a0dfef8b6c30) )
	ROM_LOAD16_BYTE( "95413424.lo", 0x00001, 0x080000, CRC(0a399355) SHA1(9402446df85a74515cdc48c693d3feca70946c03) )
	ROM_LOAD16_BYTE( "95413425.hi", 0x00000, 0x080000, CRC(0381d540) SHA1(55fc831b4ad4a10728de34c813de08e0565d3952) )
	ROM_LOAD16_BYTE( "95413452.lo", 0x00001, 0x080000, CRC(1ee613ac) SHA1(df7db88998cb92aab42af3b8c71181ae57dc2887) )
	ROM_LOAD16_BYTE( "95413453.hi", 0x00000, 0x080000, CRC(dbe1282c) SHA1(4a400ecc8c1eabad236e80b937988894723c4209) )
	ROM_LOAD16_BYTE( "95413568.lo", 0x00001, 0x080000, CRC(591c333d) SHA1(d7ee1da41f2ff761d6b354cae887ad5ec1e480a4) )
	ROM_LOAD16_BYTE( "95413569.hi", 0x00000, 0x080000, CRC(fc6be370) SHA1(8459c6c029d65d5313a6086f44f5c990dfbf4ed4) )
	ROM_LOAD16_BYTE( "95413582.lo", 0x00001, 0x080000, CRC(94dcfcb6) SHA1(f5ce361a949ce881fa1fc77522947aadc7659f6b) )
	ROM_LOAD16_BYTE( "95413583.hi", 0x00000, 0x080000, CRC(c69cb5d8) SHA1(bf57bad6445807d338d2eeab626bf93dd363b834) )
	ROM_LOAD16_BYTE( "celebs5.hi", 0x00000, 0x080000, CRC(2db750d2) SHA1(b16e38f82e5661c654f0a82f64b00e840042ec05) )
	ROM_LOAD16_BYTE( "celebs5.lo", 0x00001, 0x080000, CRC(4b13ea1e) SHA1(40cfb21c296531f7cbc97f34b26efe65df03e3a8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008440.bin", 0x0000, 0x100000, CRC(72a98e5d) SHA1(5f3e441d6c3fa2373284cee704630028cf7800ad) )
	ROM_LOAD( "95008441.bin", 0x0000, 0x100000, CRC(d7382975) SHA1(f5a4d92f243ec745f91d008d623b43dfa024635c) )
ROM_END




ROM_START( sc_inspn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416702.lo", 0x00001, 0x080000, CRC(043ede54) SHA1(479fd31d1eedbf7ac45422f0a5299ad4beb9eadc) )
	ROM_LOAD16_BYTE( "95416703.hi", 0x00000, 0x080000, CRC(7fa5e2ff) SHA1(92aa510ad144cbe884d5f7b82e3ebbbb05b2eec3) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416704.lo", 0x00001, 0x080000, CRC(15151797) SHA1(06ac7be17907f79d86cb7bffe3abf1ee63d7ff0f) )
	ROM_LOAD16_BYTE( "95416705.hi", 0x00000, 0x080000, CRC(a783b113) SHA1(55c9ca17144b4806e719cba923f5f906173e2ef5) )
	ROM_LOAD16_BYTE( "95417702.lo", 0x00001, 0x080000, CRC(e6088c2e) SHA1(471ca3116ce3554cc80bd945a113af650a54a81b) )
	ROM_LOAD16_BYTE( "95417703.hi", 0x00000, 0x080000, CRC(c8ecffdc) SHA1(26730d51e437f6b1701a73dacb34d25c6edbe536) )
	ROM_LOAD16_BYTE( "95417704.lo", 0x00001, 0x080000, CRC(8abaac7b) SHA1(f1028f673738973e843a986a751bcb122c891fff) )
	ROM_LOAD16_BYTE( "95417705.hi", 0x00000, 0x080000, CRC(793a1843) SHA1(194a176c4b145111fdd70496dbe1809b36816b29) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008909.bin", 0x0000, 0x0face9, CRC(e79bdfa0) SHA1(b31362a2d14c17b1367b45ea8734e408a2899fc2) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890327.bin", 0x0000, 0x5000, CRC(f63a2e4f) SHA1(2982130035f122a3d9a4f4a277bc272c9613562b) )
	ROM_LOAD( "95890328.bin", 0x0000, 0x5000, CRC(83ac6a7b) SHA1(e4aae883b1070278314c6d388a132d362a059c5b) )
	ROM_LOAD( "95890329.bin", 0x0000, 0x5000, CRC(1d16a627) SHA1(985d526178de176869fdad3c4264f47de14d4d7f) )
ROM_END




ROM_START( sc_ijob )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422376.lo", 0x00001, 0x080000, CRC(c1e81dba) SHA1(146ffbbe4c5da6bbfd73250a09d355ed91498539) )
	ROM_LOAD16_BYTE( "95422377.hi", 0x00000, 0x080000, CRC(ba0bd975) SHA1(0948ca47ffc906e10a9ebc1105e9aafc1d325d24) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422378.lo", 0x00001, 0x080000, CRC(8ff38628) SHA1(8477f92c088475c3256c361a608130d86cab23f9) )
	ROM_LOAD16_BYTE( "95422379.hi", 0x00000, 0x080000, CRC(319f75dc) SHA1(7629b792052fe0107f4a00da6b8166c985c96e06) )
	ROM_LOAD16_BYTE( "95422480.lo", 0x00001, 0x080000, CRC(31919954) SHA1(aba76190875478b78a672660bf925d869d5f0391) )
	ROM_LOAD16_BYTE( "95422481.hi", 0x00000, 0x080000, CRC(7fc2155a) SHA1(5de2de8f5061e1cf3d6c0d3628397beb249aabf9) )
	ROM_LOAD16_BYTE( "95422586.lo", 0x00001, 0x080000, CRC(9d5f65d3) SHA1(208344ff0fa960802261d974c53b9e016d6b71b7) )
	ROM_LOAD16_BYTE( "95422587.hi", 0x00000, 0x080000, CRC(f1931c78) SHA1(9aed7e12edb415dbe3e78ab81ec0775c168b31d2) )
	ROM_LOAD16_BYTE( "95422590.lo", 0x00001, 0x080000, CRC(00deb75d) SHA1(dff99d61579f53bd41e6885293e30b30b0dfc9db) )
	ROM_LOAD16_BYTE( "95422591.hi", 0x00000, 0x080000, CRC(07479fb5) SHA1(0a4a4e9751e51ea2bb9444861537bf64338594fb) )
	ROM_LOAD16_BYTE( "95422876.lo", 0x00001, 0x080000, CRC(fc9a9eb1) SHA1(2c8db0cf9d60c52b06a11cd973b634759e111d36) )
	ROM_LOAD16_BYTE( "95422877.hi", 0x00000, 0x080000, CRC(eb99528b) SHA1(46897348b16f8a6172502bdb1bebdb2db49a2aed) )
	ROM_LOAD16_BYTE( "95423376.lo", 0x00001, 0x080000, CRC(cdd90a5c) SHA1(785dafbac3db909c3d69ce80e14154fac58f614d) )
	ROM_LOAD16_BYTE( "95423377.hi", 0x00000, 0x080000, CRC(b3813d77) SHA1(ee5fbdd623abbf88a362881f30cc645ea75e8d83) )
	ROM_LOAD16_BYTE( "95423378.lo", 0x00001, 0x080000, CRC(c692c68e) SHA1(145b0deba57d596cc66d6c1a7259f78ea3823f94) )
	ROM_LOAD16_BYTE( "95423379.hi", 0x00000, 0x080000, CRC(920e7a50) SHA1(3af29d8f77a80c5a9d8e8c3d200fd1898777340a) )
	ROM_LOAD16_BYTE( "95423480.lo", 0x00001, 0x080000, CRC(fd21edb8) SHA1(424827cb40fa9fb5ac831319b711c06a41b3b136) )
	ROM_LOAD16_BYTE( "95423481.hi", 0x00000, 0x080000, CRC(9249f37d) SHA1(7624bccaf5382a0fb4645bf77bd5415b2a2f6eaf) )
	ROM_LOAD16_BYTE( "95423586.lo", 0x00001, 0x080000, CRC(1737cf65) SHA1(e29ffc76e4dec2ea77aaf345ab035ef03983ad17) )
	ROM_LOAD16_BYTE( "95423587.hi", 0x00000, 0x080000, CRC(ecf4da0a) SHA1(f4e6b83a74e32d4c59f0c67564e6969458aaab46) )
	ROM_LOAD16_BYTE( "95423590.lo", 0x00001, 0x080000, CRC(434b2e9f) SHA1(5c586b81ff8ae36a1bc42a08643d7bcac2c4930c) )
	ROM_LOAD16_BYTE( "95423591.hi", 0x00000, 0x080000, CRC(896cfc1e) SHA1(6fe85fd536d2285d1921bafd5fceceac59093479) )
	ROM_LOAD16_BYTE( "95423876.lo", 0x00001, 0x080000, CRC(3909f9c2) SHA1(e7ca2b26d9102aa8404239ca445089f05c720554) )
	ROM_LOAD16_BYTE( "95423877.hi", 0x00000, 0x080000, CRC(49549dd0) SHA1(eae316d5402958232777548ae6ff478721a8b3fa) )
	ROM_LOAD16_BYTE( "95426076.lo", 0x00001, 0x080000, CRC(9aca7761) SHA1(6998382d3f5867802a429f755875f1e12a6f1dd5) )
	ROM_LOAD16_BYTE( "95426077.hi", 0x00000, 0x080000, CRC(8d979dec) SHA1(6beeae68a6a2af27ce37366f8ccaeea0dd37f2d9) )
	ROM_LOAD16_BYTE( "95426274.lo", 0x00001, 0x080000, CRC(3ec8d159) SHA1(ca7ec3e05f34fdafa270e2850bbcb1873e298f27) )
	ROM_LOAD16_BYTE( "95426275.hi", 0x00000, 0x080000, CRC(5c2a2eea) SHA1(1e3f7ee4ac09c0edaeed81a49e9e5d112bd65643) )
	ROM_LOAD16_BYTE( "95426318.lo", 0x00001, 0x080000, CRC(9a1d2dd1) SHA1(6016ad4db9d566ada8642ea8fd377e3133754e37) )
	ROM_LOAD16_BYTE( "95426319.hi", 0x00000, 0x080000, CRC(23a5204c) SHA1(ade96b23d61e29b5b194a0acef97b07d7671a026) )
	ROM_LOAD16_BYTE( "95426460.lo", 0x00001, 0x080000, CRC(3d738a1e) SHA1(f1f7e24f95e284b31633bad4673b41e8e9bd4f5a) )
	ROM_LOAD16_BYTE( "95426461.hi", 0x00000, 0x080000, CRC(eec70c63) SHA1(557bb62d9dd9eec978278b5954861546cf3f1523) )
	ROM_LOAD16_BYTE( "95426462.lo", 0x00001, 0x080000, CRC(16a3ae53) SHA1(ea8b612828e83db585d02def48adc69bcdc1910d) )
	ROM_LOAD16_BYTE( "95426463.hi", 0x00000, 0x080000, CRC(73bf9be3) SHA1(afec4aba74496a1b3bf3472907904cb07f681987) )
	ROM_LOAD16_BYTE( "95427076.lo", 0x00001, 0x080000, CRC(06a0d769) SHA1(58cb11b2eb0e1166d9f3e121aedf85cff692ecdf) )
	ROM_LOAD16_BYTE( "95427077.hi", 0x00000, 0x080000, CRC(e235e8e5) SHA1(7a6601649dcb3897390aa11a35286f254045cbf9) )
	ROM_LOAD16_BYTE( "95427274.lo", 0x00001, 0x080000, CRC(30efe63b) SHA1(6842d7c36a75a64abaccf3bed1c657e26868e5d2) )
	ROM_LOAD16_BYTE( "95427275.hi", 0x00000, 0x080000, CRC(39a1266b) SHA1(c87e04d20ae87fb528c1668ea4a7f2e0c5df5e62) )
	ROM_LOAD16_BYTE( "95427318.lo", 0x00001, 0x080000, CRC(abcd391a) SHA1(3e7403dc84e162a734dee9f43b8fe07c3d073a04) )
	ROM_LOAD16_BYTE( "95427319.hi", 0x00000, 0x080000, CRC(30538c7f) SHA1(b4ab374e0a5ed644274ba767644c839dadd3e79a) )
	ROM_LOAD16_BYTE( "95427460.lo", 0x00001, 0x080000, CRC(020fd6d7) SHA1(fe1a4c8196359fc18fb89d5b52d73b2df95c97b8) )
	ROM_LOAD16_BYTE( "95427461.hi", 0x00000, 0x080000, CRC(167ad51d) SHA1(be27d3c14376f232306dc261810842ec031a7399) )
	ROM_LOAD16_BYTE( "95427462.lo", 0x00001, 0x080000, CRC(9d305f15) SHA1(4a224e679447e46dafeed3b89b658b9c47e41d48) )
	ROM_LOAD16_BYTE( "95427463.hi", 0x00000, 0x080000, CRC(32d24f72) SHA1(182f56fc3e459a9801fb726b0f54a62b632f937f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008764.bin", 0x0000, 0x100000, CRC(995c0c63) SHA1(7459e92ad80d4eb61008a011bf5ae3a1d5cb8f9d) )
	ROM_LOAD( "95008765.bin", 0x0000, 0x0fb251, CRC(3c2feab2) SHA1(797ef43d2166c0522f6da5dd17bf4443f08891a5) )
ROM_END




ROM_START( sc_ijclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424322.lo", 0x00001, 0x080000, CRC(e43f64c5) SHA1(292df6d16317bc27def74e2f5d47509a07c52f48) )
	ROM_LOAD16_BYTE( "95424323.hi", 0x00000, 0x080000, CRC(a9c5f9e0) SHA1(008262a03cc85858da6f0ba01564ce4703895a6b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008888.bin", 0x0000, 0x0fc30c, CRC(71ad9f31) SHA1(40d42bbe7e3d38cab48006a4f0d4d25d2b56a647) )
	ROM_REGION( 0x5000, "pics", ROMREGION_ERASE00 )
	ROM_LOAD( "95891060.bin", 0x0000, 0x5000, CRC(791ebcf2) SHA1(88298c6d1eec718b84e51aae447ffd74493a27f4) )
ROM_END




ROM_START( sc_jack )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406962.lo", 0x00001, 0x080000, CRC(a95fce04) SHA1(89d0263fb09fcc9b50027bf67ffd0040af9c865d) )
	ROM_LOAD16_BYTE( "95406963.hi", 0x00000, 0x080000, CRC(e867aecb) SHA1(4438e91863da3876b4a66db0795ff8d631475f6e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407962.lo", 0x00001, 0x080000, CRC(cd36442b) SHA1(8b6f5a693a3322061d5e4b26c7f8e13be7cfc226) )
	ROM_LOAD16_BYTE( "95407963.hi", 0x00000, 0x080000, CRC(3be5602a) SHA1(b0e88873332e56bcbf5bc6d0d8c5045dd4266ce2) )
	ROM_LOAD16_BYTE( "95408250.lo", 0x00001, 0x080000, CRC(1f7c738b) SHA1(28210387c42dcb84ff8800bbe349d2a4a57c4081) )
	ROM_LOAD16_BYTE( "95408251.hi", 0x00000, 0x080000, CRC(75a33c8d) SHA1(e44ab3d463d808e12da81bf77661e140f5abc642) )
	ROM_LOAD16_BYTE( "95409250.lo", 0x00001, 0x080000, CRC(9541120e) SHA1(6546164e1976a966bb8f326b8c989f7b67ae1153) )
	ROM_LOAD16_BYTE( "95409251.hi", 0x00000, 0x080000, CRC(deafd82f) SHA1(b94ef921ee96375483363911cbfebaf4ce84bf62) )
	ROM_LOAD16_BYTE( "95414342.lo", 0x00001, 0x080000, CRC(00211b9b) SHA1(502cd4a1d25fe5eae58c3cdf83963fee4a9aaea9) )
	ROM_LOAD16_BYTE( "95414343.hi", 0x00000, 0x080000, CRC(38f41741) SHA1(df4091f8ddc12149cfd8c65b726f2e76583f2825) )
	ROM_LOAD16_BYTE( "95414344.lo", 0x00001, 0x080000, CRC(19048ce1) SHA1(7a602d6bb4a11659987c40d799a086e3aa3cc28e) )
	ROM_LOAD16_BYTE( "95414345.hi", 0x00000, 0x080000, CRC(83666578) SHA1(26103607be053284ea7789f1dae12cd0cfc0aa08) )
	ROM_LOAD16_BYTE( "95415342.lo", 0x00001, 0x080000, CRC(8bf53e5d) SHA1(bd997dd053d64f5dee5bf044d4797ab73d06ff7b) )
	ROM_LOAD16_BYTE( "95415343.hi", 0x00000, 0x080000, CRC(4c7ff6c3) SHA1(6acb0f177a7c85923abf4c48f020ce845fa62c18) )
	ROM_LOAD16_BYTE( "95415344.lo", 0x00001, 0x080000, CRC(1404e8b3) SHA1(db53f3ca3a9d690efd1f5391f24ce60cbbcde343) )
	ROM_LOAD16_BYTE( "95415345.hi", 0x00000, 0x080000, CRC(ed041da0) SHA1(2bd065eb1854fef93c793b7f83cfe3271aaa7cfa) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008289.bin", 0x0000, 0x0ffb45, CRC(76d2af0f) SHA1(0460ecc4f80cceb6861b8b0ebf59f0e87bf2b38c) )
	ROM_LOAD( "jack the kipper sound 1 maz fc64.bin", 0x0000, 0x100000, CRC(f31090f9) SHA1(4e9edfdf6472b4229d4393cb3033134f6b27920b) )
ROM_END




ROM_START( sc_jjok )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412588.lo", 0x00001, 0x080000, CRC(c1bd880f) SHA1(985b162876f8d2971b4630a6001da020cd2785a2) )
	ROM_LOAD16_BYTE( "95412589.hi", 0x00000, 0x080000, CRC(1f083bd2) SHA1(300656a971b6172f2bbf6e5156af58f5589b2e8a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412718.lo", 0x00001, 0x080000, CRC(a7e2c60e) SHA1(febe7eb08d56d8d1b47a92952ee2b7c8d96cb5f3) )
	ROM_LOAD16_BYTE( "95412719.hi", 0x00000, 0x080000, CRC(a8d93a87) SHA1(d996cd711780aa316ea7e0ee40f20a3455742bf1) )
	ROM_LOAD16_BYTE( "95413588.lo", 0x00001, 0x080000, CRC(dbc1e95d) SHA1(30af0b19422cc35201fbbd533db358d1f7881cf8) )
	ROM_LOAD16_BYTE( "95413589.hi", 0x00000, 0x080000, CRC(ce90b42f) SHA1(0da6f8e1579cee0b7a1bb2d2828470971da85afb) )
	ROM_LOAD16_BYTE( "95413718.lo", 0x00001, 0x080000, CRC(331295e4) SHA1(4bf8b112acc881b4094a2b72c999d439c94e81b8) )
	ROM_LOAD16_BYTE( "95413719.hi", 0x00000, 0x080000, CRC(910fc3f2) SHA1(dc8949aa989793754584817b9a56c6dfcfc0e705) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_jjunc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406800.lo", 0x00001, 0x080000, CRC(b8981604) SHA1(871007167d0d5cae6343679c682eaef1222dac77) )
	ROM_LOAD16_BYTE( "95406801.hi", 0x00000, 0x080000, CRC(d2b9d2c6) SHA1(597707368ed54946b230f0136fb0e694e468e7a2) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406860.lo", 0x00001, 0x080000, CRC(23e4ca88) SHA1(422f5ad5008d6c8a16784473432b59e0a66d95d3) )
	ROM_LOAD16_BYTE( "95406861.hi", 0x00000, 0x080000, CRC(cf0c37a8) SHA1(71a9e48dcc05d33cfdfe4cab92ae1b2858112800) )
	ROM_LOAD16_BYTE( "95407800.lo", 0x00001, 0x080000, CRC(897974c6) SHA1(c206f698ecb5e55b1448306a8bb7448c93bf080c) )
	ROM_LOAD16_BYTE( "95407801.hi", 0x00000, 0x080000, CRC(1b4dd345) SHA1(d4473a1d10e722834f66b0ba5f0493b03d235033) )
	ROM_LOAD16_BYTE( "95407860.lo", 0x00001, 0x080000, CRC(d89c7947) SHA1(a2c96d82806f25c5eaf7b531252d88cdc09ee089) )
	ROM_LOAD16_BYTE( "95407861.hi", 0x00000, 0x080000, CRC(94222bfc) SHA1(a4bc7d85ca99890d24d83ba4f347d4f19db49026) )
	ROM_LOAD16_BYTE( "95408032.lo", 0x00001, 0x080000, CRC(769e2950) SHA1(6144b8d222177b4bfc10919a70eb4ce39b898b43) )
	ROM_LOAD16_BYTE( "95408033.hi", 0x00000, 0x080000, CRC(d0871eaa) SHA1(8175b7129d5ae0f49792f06af82fc2f19161fdfe) )
	ROM_LOAD16_BYTE( "95408280.lo", 0x00001, 0x080000, CRC(bf7e7125) SHA1(effd754236c85bae963a9d5c019ef31b1acf24da) )
	ROM_LOAD16_BYTE( "95408281.hi", 0x00000, 0x080000, CRC(9ba5ac3f) SHA1(21aab8ab476edccb127d76d7538533fa3e22dceb) )
	ROM_LOAD16_BYTE( "95409032.lo", 0x00001, 0x080000, CRC(da329b3e) SHA1(f546c0dff49b8633f3aa0566c6f8e793718f1723) )
	ROM_LOAD16_BYTE( "95409033.hi", 0x00000, 0x080000, CRC(792c3c23) SHA1(aa137a6baaeff81601e0f0174e13a19029b7105d) )
	ROM_LOAD16_BYTE( "95409280.lo", 0x00001, 0x080000, CRC(315237b8) SHA1(4bdbec479fcf8ea1f951a1494ee17b6564dab2d0) )
	ROM_LOAD16_BYTE( "95409281.hi", 0x00000, 0x080000, CRC(738cc34b) SHA1(106c06b4eec272cfe25ea7475b41e1f8f7c4cf4c) )
	ROM_LOAD16_BYTE( "p1304p13.hi", 0x00000, 0x080000, CRC(99c6920f) SHA1(917e60be1f1bdb1a8f2b060523a154c7532a8118) )
	ROM_LOAD16_BYTE( "p1304p13.lo", 0x00001, 0x080000, CRC(5a19ff3c) SHA1(d600039dd85f9d2db3925e250587d1cdcbcb9eaf) )
	ROM_LOAD16_BYTE( "p1304s13.hi", 0x00000, 0x080000, CRC(39f32b92) SHA1(d8f664c9fc2d099642b706bf8cee2d216dd72aad) )
	ROM_LOAD16_BYTE( "p1304s13.lo", 0x00001, 0x080000, CRC(558a4765) SHA1(36ea6375f09e270630941fab84746938ae46fb79) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008284.bin", 0x0000, 0x100000, CRC(f90feeb8) SHA1(672abc79a88b2237fa584d12b9123a2baeec83b8) )
ROM_END




ROM_START( sc_jjucl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410318.lo", 0x00001, 0x080000, CRC(044d9908) SHA1(0cbc58f77b729638981ac06590532fa69797e448) )
	ROM_LOAD16_BYTE( "95410319.hi", 0x00000, 0x080000, CRC(1583ec1f) SHA1(22aa9d80f1af130546564d34abc1dd715f9388d1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410362.lo", 0x00001, 0x080000, CRC(6d2f7d2f) SHA1(05333d9dcf99a93a17efabb56378798680cd302b) )
	ROM_LOAD16_BYTE( "95410363.hi", 0x00000, 0x080000, CRC(e0c11468) SHA1(2bdd844d088085789780c736eb29a36565083964) )
	ROM_LOAD16_BYTE( "95411318.lo", 0x00001, 0x080000, CRC(2166860e) SHA1(20b316648036372813ebb7c13727c71e80fa2413) )
	ROM_LOAD16_BYTE( "95411319.hi", 0x00000, 0x080000, CRC(c7c715cc) SHA1(9123671fbd916c5721d2d000dc6a6389190f0a22) )
	ROM_LOAD16_BYTE( "95411362.lo", 0x00001, 0x080000, CRC(e14945b6) SHA1(4fd878199cc5ebcaaa6f980304fb59cced401c2a) )
	ROM_LOAD16_BYTE( "95411363.hi", 0x00000, 0x080000, CRC(b90d06e4) SHA1(c216ff7a4e385f3e1ee09bdcf236c583fe674c3a) )
	ROM_LOAD16_BYTE( "95411828.lo", 0x00001, 0x080000, CRC(3ed33435) SHA1(530c660abfae693b83f6f3917c98fec8fec0ef70) )
	ROM_LOAD16_BYTE( "95411829.hi", 0x00000, 0x080000, CRC(ed588fed) SHA1(b9454795ce089f04b7af792c523514597de0bd08) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008395.bin", 0x0000, 0x100000, CRC(619865d6) SHA1(9e76267140709ae2ca09ea0866fc0b27b94d26af) )
ROM_END




ROM_START( sc_jiggn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402838.lo", 0x00001, 0x080000, CRC(fbfc9210) SHA1(77029afbf7852c4fba5774184bdbef018e447247) )
	ROM_LOAD16_BYTE( "95402839.hi", 0x00000, 0x080000, CRC(b449febc) SHA1(41cc4edb267e108316c5947ae7bb3111de54a12f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004179", 0x0000, 0x080000, CRC(fd2521e8) SHA1(58027efa8110004fc4d823dc19d4de115a925711) )
	ROM_LOAD( "95004180", 0x0000, 0x080000, CRC(7750b004) SHA1(4c6cb7a5c4b69ca1d65b57271798ac17cd06ce61) )
ROM_END




ROM_START( sc_jiggr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400769.lo", 0x00001, 0x080000, CRC(7b03c84c) SHA1(ce5fe064c928aa3afba6cf43caab7a08af537d98) )
	ROM_LOAD16_BYTE( "95400770.hi", 0x00000, 0x080000, CRC(67fe5696) SHA1(994f482008b526d82801481a84f7d7d0fc82366c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400917.lo", 0x00001, 0x080000, CRC(280e5e5c) SHA1(202913d7647d34ef91bfba9a5c4c024ed1a4a1f2) )
	ROM_LOAD16_BYTE( "95400918.hi", 0x00000, 0x080000, CRC(67b18ac9) SHA1(18bd935d2900616e744c6587bfd649821ffeba28) )
	ROM_LOAD16_BYTE( "95401769.lo", 0x00001, 0x080000, CRC(118c2aa4) SHA1(c401ac1c36435cd90f14a74e8c3d7c7597a5a959) )
	ROM_LOAD16_BYTE( "95401770.hi", 0x00000, 0x080000, CRC(cfb146a4) SHA1(0eef6ce82d4994037caddffdbd58a115663042a3) )
	ROM_LOAD16_BYTE( "95401917.lo", 0x00001, 0x080000, CRC(6f879e2b) SHA1(d6d2d55b37e0ec39950b2e67e55bd0ef4b4c402e) )
	ROM_LOAD16_BYTE( "95401918.hi", 0x00000, 0x080000, CRC(70637422) SHA1(5251a43e1bb76a68e901a4cd3f73ecee45e50737) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_jive )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408432.lo", 0x00001, 0x080000, CRC(4696c1be) SHA1(81910be1c328faca834c93de3a15d2e0d2d79ae0) )
	ROM_LOAD16_BYTE( "95408433.hi", 0x00000, 0x080000, CRC(3d9369c7) SHA1(bed1ec96e9793af7efe1b10a3cd101cc378e45af) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416058.lo", 0x00001, 0x080000, CRC(22089a87) SHA1(16d4aa89635f796bbfa593e1a3836cbc65191064) )
	ROM_LOAD16_BYTE( "95416059.hi", 0x00000, 0x080000, CRC(39017969) SHA1(c6d9df634a8d4cd31ba464e0d241ac24772b62d6) )
	ROM_LOAD16_BYTE( "95416824.lo", 0x00001, 0x080000, CRC(8fd82043) SHA1(4e92abc737ec6286853ba4e300a1ecc8d61e1b07) )
	ROM_LOAD16_BYTE( "95416825.hi", 0x00000, 0x080000, CRC(81a3000d) SHA1(aa863edd7e48c8c8467b73c49be4dc09669c0e5c) )
	ROM_LOAD16_BYTE( "95417058.lo", 0x00001, 0x080000, CRC(860c88b5) SHA1(cd7cd906150be0e3b0930d835573b95f85222bd5) )
	ROM_LOAD16_BYTE( "95417059.hi", 0x00000, 0x080000, CRC(6c57f61c) SHA1(611eeb0c9bacf745d2c31dabf3622e9a1665f574) )
	ROM_LOAD16_BYTE( "95417824.lo", 0x00001, 0x080000, CRC(2bdc3271) SHA1(50bd25be63607df7b995022c5b90fac9d5d34140) )
	ROM_LOAD16_BYTE( "95417825.hi", 0x00000, 0x080000, CRC(d4f58f78) SHA1(629196af54c388b0d2a23554b91a2f40f14f6f07) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_jolly )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406836.odd", 0x00001, 0x080000, CRC(2cc39f4c) SHA1(8d107bf5773e2d00ea296317652f388838737a6b) )
	ROM_LOAD16_BYTE( "95406837.evn", 0x00000, 0x080000, CRC(b0d52da0) SHA1(1cab78990cb7ed5b7663344d0f9a61fb8eefdb48) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407836.odd", 0x00001, 0x080000, CRC(82681921) SHA1(459ab8cd347ba1c812d5ef7d7fc42b86a9db9794) )
	ROM_LOAD16_BYTE( "95407837.evn", 0x00000, 0x080000, CRC(3ba55dbd) SHA1(a5bc3d4df74f84865cf11700ef113fc942b1a637) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008254.bin", 0x0000, 0x0f9355, CRC(4742beac) SHA1(2f060a5f54719fdf5aea1077d8d5de6534b41f0c) )
ROM_END




ROM_START( sc_juicy )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404882.lo", 0x00001, 0x080000, CRC(ab8732fd) SHA1(2cb28bc7aee41b06aecd36e27ea95451b432287b) )
	ROM_LOAD16_BYTE( "95404883.hi", 0x00000, 0x080000, CRC(3d153f79) SHA1(cb20abdfd4ec55b840494f7cf328038f82867f2d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404982.lo", 0x00001, 0x080000, CRC(467c6e2a) SHA1(c281c11c7ea8c22e21a5886881be9a47d143e449) )
	ROM_LOAD16_BYTE( "95404983.hi", 0x00000, 0x080000, CRC(e4afbd59) SHA1(645d124b94b68806f4cc4f929320bf57c6b1a5cc) )
	ROM_LOAD16_BYTE( "95405882.lo", 0x00001, 0x080000, CRC(5634668c) SHA1(14261d853ef9bbe6b7efc6e16ef5929f4613d494) )
	ROM_LOAD16_BYTE( "95405883.hi", 0x00000, 0x080000, CRC(cfe5903e) SHA1(2e80aaaf37aa6d344cf05563d0ef48b556e65fc6) )
	ROM_LOAD16_BYTE( "95405982.lo", 0x00001, 0x080000, CRC(8c7e6c23) SHA1(f9d20a67af07cbf4751aa5e35fd8abf1756b1b52) )
	ROM_LOAD16_BYTE( "95405983.hi", 0x00000, 0x080000, CRC(b1f9322c) SHA1(8e1804e3ba06ae58b0da41b8333654b6d3cc36f2) )
	ROM_LOAD16_BYTE( "95406484.lo", 0x00001, 0x080000, CRC(43d59f13) SHA1(e38a385e3e2e5a65bc2f22b5eb5097664fd35565) )
	ROM_LOAD16_BYTE( "95406485.hi", 0x00000, 0x080000, CRC(17191ba8) SHA1(c7f13e50cdc7a4115b8062d59f2db792255a2058) )
	ROM_LOAD16_BYTE( "95407484.lo", 0x00001, 0x080000, CRC(515b9ac0) SHA1(f2f5e6e2139aa1e1e73d165b94778187c4063c88) )
	ROM_LOAD16_BYTE( "95407485.hi", 0x00000, 0x080000, CRC(08d2882a) SHA1(44262f577b8b17bd833a1ba454d93861bb8e3968) )
	ROM_LOAD16_BYTE( "95408212.lo", 0x00001, 0x080000, CRC(fac3dcb4) SHA1(eb6aa0a97422d735ab26c697448957e23a76e8e1) )
	ROM_LOAD16_BYTE( "95408213.hi", 0x00000, 0x080000, CRC(3b7bd219) SHA1(765a87418034d83b6401ba8c53993edf7aa60973) )
	ROM_LOAD16_BYTE( "95409212.lo", 0x00001, 0x080000, CRC(60c1521e) SHA1(9c0d96918802a49651d44b3850c77b63a3f6f18d) )
	ROM_LOAD16_BYTE( "95409213.hi", 0x00000, 0x080000, CRC(0cd5b84d) SHA1(ef87a40f67207c80b96221a5ad397d5cc803a3b7) )
	ROM_LOAD16_BYTE( "95410828.lo", 0x00001, 0x080000, CRC(933e838e) SHA1(501f681aba7a787061947efe92fd8451ce903b2c) )
	ROM_LOAD16_BYTE( "95410829.hi", 0x00000, 0x080000, CRC(b40bcb59) SHA1(e00b5eb3e68f1217bc69622b25f2340aaa6a289d) )
	ROM_LOAD16_BYTE( "95412202.lo", 0x00001, 0x080000, CRC(be13c0c6) SHA1(400d0b395f15d6d75ef06f16cc99d8005b4de286) )
	ROM_LOAD16_BYTE( "95412203.hi", 0x00000, 0x080000, CRC(ac436887) SHA1(a9b022349a4b22438643b01298b51c1770816c3e) )
	ROM_LOAD16_BYTE( "95413202.lo", 0x00001, 0x080000, CRC(8d0b8d19) SHA1(4e10280fc81d9b08ed6a8c3af8c83ff5c43719f7) )
	ROM_LOAD16_BYTE( "95413203.hi", 0x00000, 0x080000, CRC(100224f6) SHA1(2f7aeca8f074177dab9af8d006a9660380a659eb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008216.bin", 0x0000, 0x100000, CRC(1fcf52e3) SHA1(0e585678cb928e107343ebc64f77434ac6a62555) )
	ROM_LOAD( "95008217.bin", 0x0000, 0x100000, CRC(995f77f6) SHA1(ac964bc58490448cd3b5a1ed0c7636c2354c8c7d) )
ROM_END




ROM_START( sc_jjc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414638.lo", 0x00001, 0x080000, CRC(37a200e7) SHA1(7729e150eff90884e6fad437f02855b0d1f4aaab) )
	ROM_LOAD16_BYTE( "95414639.hi", 0x00000, 0x080000, CRC(8b3d2c9b) SHA1(abfd57df10d092d6ae4262757004d4f5bf031d8f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414640.lo", 0x00001, 0x080000, CRC(fb011587) SHA1(8a794e2372719255425908ca3124db9d00a2c671) )
	ROM_LOAD16_BYTE( "95414641.hi", 0x00000, 0x080000, CRC(915a68f4) SHA1(fe4783d9af03e5ddd20a9260c5caf1c607c73ceb) )
	ROM_LOAD16_BYTE( "95415638.lo", 0x00001, 0x080000, CRC(7dd83a80) SHA1(538e2dc8887e9a636f078af131c50b90153c59fe) )
	ROM_LOAD16_BYTE( "95415639.hi", 0x00000, 0x080000, CRC(21903271) SHA1(79e846b208a5235df570323128986085581d2ddf) )
	ROM_LOAD16_BYTE( "95415640.lo", 0x00001, 0x080000, CRC(38391c5f) SHA1(56232d4f2b8c28097368c668e94815c864514b14) )
	ROM_LOAD16_BYTE( "95415641.hi", 0x00000, 0x080000, CRC(2f667c65) SHA1(c208a6273237df8fdbd2a8889d96b705731bb1e0) )
	ROM_LOAD16_BYTE( "95416338.lo", 0x00001, 0x080000, CRC(416c2f1d) SHA1(7aa986a9a52dd857da4443657fbc0f101f03e9f4) )
	ROM_LOAD16_BYTE( "95416339.hi", 0x00000, 0x080000, CRC(e2b1e7a3) SHA1(646714b13061d5f0495414acd549d6ff3ac3ccce) )
	ROM_LOAD16_BYTE( "95417338.lo", 0x00001, 0x080000, CRC(c1bc5ff7) SHA1(0b886ea05f7005150040106adc626f33e9cf3352) )
	ROM_LOAD16_BYTE( "95417339.hi", 0x00000, 0x080000, CRC(8c4cc943) SHA1(e37e47dde1e1d7f6558b715cde0b4a7cd28302f6) )
	ROM_LOAD16_BYTE( "95420416.lo", 0x00001, 0x080000, CRC(53890cdf) SHA1(3f8058bbae4b02c01bd7b9cc0ecb0b790c463784) )
	ROM_LOAD16_BYTE( "95420417.hi", 0x00000, 0x080000, CRC(cbe8b021) SHA1(6b2dcb53d1b121adcdbe4a767dc4e024321b1e0c) )
	ROM_LOAD16_BYTE( "95420418.lo", 0x00001, 0x080000, CRC(318e0964) SHA1(461e32f31cc8d03182475e5d8fd11b72dff15c78) )
	ROM_LOAD16_BYTE( "95420419.hi", 0x00000, 0x080000, CRC(98a5c16c) SHA1(0529fda8b45e423805c03166148df7beb4898259) )
	ROM_LOAD16_BYTE( "95421416.lo", 0x00001, 0x080000, CRC(11a5509a) SHA1(1a5f96f4b061e254af625710156b216dbfaf61e0) )
	ROM_LOAD16_BYTE( "95421417.hi", 0x00000, 0x080000, CRC(7105e0f5) SHA1(f7ed5bc4562cc70f15beb887e4db72af2fd5e65e) )
	ROM_LOAD16_BYTE( "95421418.lo", 0x00001, 0x080000, CRC(fd185e8b) SHA1(e8a662ba2f4d32b0cbc307c38512c3c5cc8b10cb) )
	ROM_LOAD16_BYTE( "95421419.hi", 0x00000, 0x080000, CRC(fb626016) SHA1(9bc68d6450058628aaaf4c62e8269823c7ee6fe5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_jjf )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95004085.lo", 0x00001, 0x080000, CRC(1b1f3455) SHA1(8733193640b907cf0aae3bc474dd4f1766c6e74c) )
	ROM_LOAD16_BYTE( "95004086.hi", 0x00000, 0x080000, CRC(5b678da4) SHA1(05c3760b35e77ea70401e47762dcbf0cc779ea3c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400167.lo", 0x00001, 0x080000, CRC(0ae29a7d) SHA1(4ba10d961c00573419be0dbc9ae219a3df9c7299) )
	ROM_LOAD16_BYTE( "95400168.hi", 0x00000, 0x080000, CRC(7de0e701) SHA1(42e5d59fee152a4ba259c5ac472c67c7a292c895) )
	ROM_LOAD16_BYTE( "95400255.lo", 0x00001, 0x080000, CRC(6551fe1e) SHA1(905b11090927cbedea88f2119f5961cae023e5c5) )
	ROM_LOAD16_BYTE( "95400256.hi", 0x00000, 0x080000, CRC(b6487501) SHA1(bcc3c7d1b229e38d414796a95d44f7a35d87a841) )
	ROM_LOAD16_BYTE( "95400257.lo", 0x00001, 0x080000, CRC(25ba4d94) SHA1(f2ff4fbbe8c5fbee3b4439a6e699f4ec7be3964b) )
	ROM_LOAD16_BYTE( "95400258.hi", 0x00000, 0x080000, CRC(de5a9aec) SHA1(3e3c7d2648293be74f4ac3ae755edcc8d7ffb80b) )
	ROM_LOAD16_BYTE( "95400751.lo", 0x00001, 0x080000, CRC(e7988177) SHA1(e4dd00aecca03d28ad2f356ce1e79504840c2ce3) )
	ROM_LOAD16_BYTE( "95400752.hi", 0x00000, 0x080000, CRC(abc8fc7e) SHA1(99c6ff52e1348fb82e07cc45fb5fbf2f6d2059e6) )
	ROM_LOAD16_BYTE( "95400753.lo", 0x00001, 0x080000, CRC(a4190022) SHA1(82e9e68e9f36d3d0b95b91c2e3814f8446099ba2) )
	ROM_LOAD16_BYTE( "95400754.hi", 0x00000, 0x080000, CRC(e21ac2b9) SHA1(830d7b60260f0a89ee474df8ff3beee1bd68c4a9) )
	ROM_LOAD16_BYTE( "95400935.lo", 0x00001, 0x080000, CRC(a970ba37) SHA1(2d49f337752cbde9ea75f61aa3c34582b8e1eb43) )
	ROM_LOAD16_BYTE( "95400936.hi", 0x00000, 0x080000, CRC(fa531aa7) SHA1(0277a7e552a516bccd60408a68d1feca2536c553) )
	ROM_LOAD16_BYTE( "95400937.lo", 0x00001, 0x080000, CRC(b80c9c9a) SHA1(708f1a41fa1ddb6c2e06c9deaabdb33004b0065d) )
	ROM_LOAD16_BYTE( "95400938.hi", 0x00000, 0x080000, CRC(7e56ea21) SHA1(a05168313a60a939c78c880376bd2006042a8f45) )
	ROM_LOAD16_BYTE( "95401167.lo", 0x00001, 0x080000, CRC(e5a2e444) SHA1(7012ba695111ac2d1d651be2e00d73aff017c692) )
	ROM_LOAD16_BYTE( "95401168.hi", 0x00000, 0x080000, CRC(cd3b3689) SHA1(808277be3d2163dde8d9a7ce5b73dff12c4cd518) )
	ROM_LOAD16_BYTE( "95401255.lo", 0x00001, 0x080000, CRC(d271a4a7) SHA1(b72a84c06ae171875da775a5d70556d2fcab5cf6) )
	ROM_LOAD16_BYTE( "95401256.hi", 0x00000, 0x080000, CRC(d6529ef8) SHA1(599b432337b5b3c46749f5f36c6d33b0df862126) )
	ROM_LOAD16_BYTE( "95401257.lo", 0x00001, 0x080000, CRC(2d2e7e17) SHA1(f941e4c1ca3d28954bc5414da67d0c7fba9a0393) )
	ROM_LOAD16_BYTE( "95401258.hi", 0x00000, 0x080000, CRC(786d19ff) SHA1(ad1f3b3172aff887ea9407ca362c15248b59ad1c) )
	ROM_LOAD16_BYTE( "95401751.lo", 0x00001, 0x080000, CRC(4310e660) SHA1(1383e6a497807207560a5d8745e51bbaa155bf95) )
	ROM_LOAD16_BYTE( "95401752.hi", 0x00000, 0x080000, CRC(c891e317) SHA1(d98a8cf225b4c976bb7b822cb6bc5a628a1eb03e) )
	ROM_LOAD16_BYTE( "95401753.lo", 0x00001, 0x080000, CRC(d837ff93) SHA1(1020cce3817c0b0ad22fab26c2a265d90924d0b0) )
	ROM_LOAD16_BYTE( "95401754.hi", 0x00000, 0x080000, CRC(2437aa53) SHA1(4079cb900f4834d879d1b2f9e116b0ec4f96b4df) )
	ROM_LOAD16_BYTE( "95401935.lo", 0x00001, 0x080000, CRC(2309aba4) SHA1(a08d8363019c72552196a1caabfb449d65775b6e) )
	ROM_LOAD16_BYTE( "95401936.hi", 0x00000, 0x080000, CRC(9b775d2e) SHA1(bf816312b28a81c070ac6230193751ec7687977e) )
	ROM_LOAD16_BYTE( "95401937.lo", 0x00001, 0x080000, CRC(e73ce3c9) SHA1(942d67857a30380d53f82ff4e92ad51fe4488ada) )
	ROM_LOAD16_BYTE( "95401938.hi", 0x00000, 0x080000, CRC(e3cac8a7) SHA1(48130018e74c32a5863c9d8696c288fbeaee6bdc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_jbuck )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402494.lo", 0x00001, 0x080000, CRC(b9c2e7a2) SHA1(3b0805c35e9a19d29c4810d42f1815da5dba61b2) )
	ROM_LOAD16_BYTE( "95402495.hi", 0x00000, 0x080000, CRC(f3d89390) SHA1(91bc7945845f41687d7159cc273bef7d852f3363) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403494.lo", 0x00001, 0x080000, CRC(8357c809) SHA1(9d143108aa0ea04c351be337c1b0f16b5298f1f5) )
	ROM_LOAD16_BYTE( "95403495.hi", 0x00000, 0x080000, CRC(0322e5b7) SHA1(c306db0c71dcb6862ad97cb725e16a56d7a8c4ca) )
	ROM_LOAD16_BYTE( "95404074.lo", 0x00001, 0x080000, CRC(e3db5121) SHA1(1114493ea5515a5c45e35ebb279f39a752eec31b) )
	ROM_LOAD16_BYTE( "95404075.hi", 0x00000, 0x080000, CRC(7c3986c2) SHA1(475c4c8dc4b75b54ef61cf67266fb10df16bc2fd) )
	ROM_LOAD16_BYTE( "95405074.lo", 0x00001, 0x080000, CRC(feb57a06) SHA1(bde1fa35d6f99f6e67be8c9479c3df64ab3c48e9) )
	ROM_LOAD16_BYTE( "95405075.hi", 0x00000, 0x080000, CRC(b511d792) SHA1(b198fb4a0b2bc5221b3dc367a8f40ea2ccb84516) )
	ROM_LOAD16_BYTE( "j_buckhi", 0x00000, 0x080000, CRC(f75eb5d2) SHA1(ccd0bbde1f450c26bb64ffcc9480d53ca9fae74b) )
	ROM_LOAD16_BYTE( "j_bucklo", 0x00001, 0x080000, CRC(8c4a6503) SHA1(e7267c8e58f57928e5f0da433b646633c7e7f5ba) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_kalei )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412220.odd", 0x00001, 0x080000, CRC(18604726) SHA1(3b1f32c6cf75e1c1edb744feb59fb2303c9ecc5e) )
	ROM_LOAD16_BYTE( "95412221.evn", 0x00000, 0x080000, CRC(f9c58d01) SHA1(668bebcfdfbe5d888d69d4e6d1b483e63f8378ed) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412222.odd", 0x00001, 0x080000, CRC(0f417f5c) SHA1(9c54da76ccd31c6dad41ab1eea6453c2879598f3) )
	ROM_LOAD16_BYTE( "95412223.evn", 0x00000, 0x080000, CRC(0a5beeb5) SHA1(899d8b3c0ebe733e875b067c80b0215e901c6a7f) )
	ROM_LOAD16_BYTE( "95413220.odd", 0x00001, 0x080000, CRC(1731eca0) SHA1(74fe81b2bddcf1ceeaecc996c224384f6a1f9824) )
	ROM_LOAD16_BYTE( "95413221.evn", 0x00000, 0x080000, CRC(cc89e98d) SHA1(bdfce2a956b7bae55a714b78c08a35c1525e6ceb) )
	ROM_LOAD16_BYTE( "95413222.odd", 0x00001, 0x080000, CRC(c34a9ea9) SHA1(f1b7e010657dc3014b65aebf6bd82b8ba9fdd160) )
	ROM_LOAD16_BYTE( "95413223.evn", 0x00000, 0x080000, CRC(ba1f6905) SHA1(34372198bd94c86eaeb49ed9454081033c106d74) )
	ROM_LOAD16_BYTE( "95414476.odd", 0x00001, 0x080000, CRC(f5624cfc) SHA1(4270eed4fe75a3c54ff7484031e6ae7a9b8a7298) )
	ROM_LOAD16_BYTE( "95414477.evn", 0x00000, 0x080000, CRC(ad443b30) SHA1(d677ee56a1a90b005ea6ea3c436831c353c9a821) )
	ROM_LOAD16_BYTE( "95415476.odd", 0x00001, 0x080000, CRC(18b4c3fe) SHA1(8e96dbd39fb07c1a744c1969121e2fdba74568e7) )
	ROM_LOAD16_BYTE( "95415477.evn", 0x00000, 0x080000, CRC(3d7c283f) SHA1(da2efff240baa2c6e290f23591092dbd802922b4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008444.bin", 0x0000, 0x0f8d34, CRC(a6a6c950) SHA1(97b9859a8795a5890156ce68f71b3f67707efdd2) )
ROM_END




ROM_START( sc_kkong )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414472.lo", 0x00001, 0x080000, CRC(cf4099ca) SHA1(5501c3bdabe84900f77c451a404cfbd40bf1a152) )
	ROM_LOAD16_BYTE( "95414473.hi", 0x00000, 0x080000, CRC(61698cee) SHA1(d74c02affe9c37ce99778407d6b3afc84b45a98f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414580.lo", 0x00001, 0x080000, CRC(5ccc7f67) SHA1(8768f774e8b2607a0b553b6659138fb627caf77d) )
	ROM_LOAD16_BYTE( "95414581.hi", 0x00000, 0x080000, CRC(34878d64) SHA1(35a5e34172df2029263cd240ae8b5efff9794d30) )
	ROM_LOAD16_BYTE( "95415472.lo", 0x00001, 0x080000, CRC(a6f270d0) SHA1(9debde5f2476b981fd5d2e5b24f47d18a4163a00) )
	ROM_LOAD16_BYTE( "95415473.hi", 0x00000, 0x080000, CRC(f06f3391) SHA1(551f29c9d1d35906efff85b164f26ee12bd924ea) )
	ROM_LOAD16_BYTE( "95415580.lo", 0x00001, 0x080000, CRC(ea33d976) SHA1(4dcd684fd997f7031fa51f207051f49fe2e4ce09) )
	ROM_LOAD16_BYTE( "95415581.hi", 0x00000, 0x080000, CRC(39bcead5) SHA1(9f005e57dbfd03fc2f0fb76cd51e91a98a2e9028) )
	ROM_LOAD16_BYTE( "95416720.lo", 0x00001, 0x080000, CRC(4462a7b8) SHA1(c0ee3138e4ecaec4f80696b23222c8991e414224) )
	ROM_LOAD16_BYTE( "95416721.hi", 0x00000, 0x080000, CRC(6b25c34d) SHA1(8511a7ecca3a2a9ba137cd01136a15b14b1d9acc) )
	ROM_LOAD16_BYTE( "95416770.lo", 0x00001, 0x080000, CRC(d868edc1) SHA1(7f08df6e36adc421e3755e069beeb15f894f284b) )
	ROM_LOAD16_BYTE( "95416771.hi", 0x00000, 0x080000, CRC(6fc88c82) SHA1(10dcac8054ede67759db6f64aa7c952130b2ecca) )
	ROM_LOAD16_BYTE( "95416772.lo", 0x00001, 0x080000, CRC(6cdd2db0) SHA1(7fd6b972f1b2a59d9e1de9ceba28a0c90dff33d6) )
	ROM_LOAD16_BYTE( "95416773.hi", 0x00000, 0x080000, CRC(2b69b383) SHA1(ad5abc445f6dd7341bd29e2e0a359bda04241120) )
	ROM_LOAD16_BYTE( "95417720.lo", 0x00001, 0x080000, CRC(009ad96e) SHA1(49cb002ad376db10e68f6ba25309c68194f24f9f) )
	ROM_LOAD16_BYTE( "95417721.hi", 0x00000, 0x080000, CRC(8c5c2a09) SHA1(d4ab6e21e4110159ca0494b0f83864731653b784) )
	ROM_LOAD16_BYTE( "95417770.lo", 0x00001, 0x080000, CRC(420aeaa9) SHA1(f0f11046e54591f7fa4fcc19bdd8fef6598c8d40) )
	ROM_LOAD16_BYTE( "95417771.hi", 0x00000, 0x080000, CRC(01aaf45a) SHA1(d64b69d2d18ca44e94045d40b71428a1efd6d999) )
	ROM_LOAD16_BYTE( "95417772.lo", 0x00001, 0x080000, CRC(a2ab959f) SHA1(fca03e13fb6e514d7bc1a548c80d41754e2c1b4f) )
	ROM_LOAD16_BYTE( "95417773.hi", 0x00000, 0x080000, CRC(6795513c) SHA1(b7bf4e4f639eb81de23fc5ac57cc2db05a23c3a1) )

	ROM_LOAD16_BYTE( "king kon.hi", 0x00000, 0x080000, CRC(859bcf1a) SHA1(6d2f81640f2045916b3bad52673de0c14a549a8f) )
	ROM_LOAD16_BYTE( "king kon.lo", 0x00001, 0x080000, CRC(95e8e7d1) SHA1(6a6af285a2ebf197ed4f14e5275bdd2d1ebc5283) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_knok )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402460.lo", 0x00001, 0x080000, CRC(01bbbd5d) SHA1(d1bc964004efa8e086393d3ebb54ef0df5e0bfc7) )
	ROM_LOAD16_BYTE( "95402461.hi", 0x00000, 0x080000, CRC(d419b46f) SHA1(1f94e4d548df9b8a83efa4e94f30fe894c5ac9ac) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403460.lo", 0x00001, 0x080000, CRC(abef773b) SHA1(452ebe0345cb1cc2ee9919c79eac781272bae125) )
	ROM_LOAD16_BYTE( "95403461.hi", 0x00000, 0x080000, CRC(3376e44a) SHA1(0e06edb0635aa41250f5035988965154d22a6ff4) )
	ROM_LOAD16_BYTE( "95406644.lo", 0x00001, 0x080000, CRC(aa84894a) SHA1(a85bcceb8d5a7c30e4503e7e85d800ae22e689a3) )
	ROM_LOAD16_BYTE( "95406645.hi", 0x00000, 0x080000, CRC(15bb7e3a) SHA1(36ca2317ca53d8414b0c826b8885f6c9a4bbe3a2) )
	ROM_LOAD16_BYTE( "95407644.lo", 0x00001, 0x080000, CRC(067db0c5) SHA1(66ac948515952caa7e8118bae223611ae06440d3) )
	ROM_LOAD16_BYTE( "95407645.hi", 0x00000, 0x080000, CRC(c84123fa) SHA1(a063be3d45179eb7bbf7653bb6f536cb9badf122) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_lasv )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406372.lo", 0x00001, 0x080000, CRC(0db28e23) SHA1(2e78b18dbc7f9941eabfc3ac07c212f69fa30b95) )
	ROM_LOAD16_BYTE( "95406373.hi", 0x00000, 0x080000, CRC(2bac3c58) SHA1(a9b821a98ba6bcf46b0679753d50970bfb0221cc) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406952.lo", 0x00001, 0x080000, CRC(c28032cc) SHA1(24bc23d6c97d0c52183d42b03b776184a124e1a8) )
	ROM_LOAD16_BYTE( "95406953.hi", 0x00000, 0x080000, CRC(59f73c1d) SHA1(4f488c15f265348c1d6fb15e657ad81a30ae3e50) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004261.snd", 0x0000, 0x080000, CRC(a2fbd1f1) SHA1(7ae7108235f4b9758282506558054b056d92abed) )
ROM_END




ROM_START( sc_lir )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404132.lo", 0x00001, 0x080000, CRC(2d9b3911) SHA1(bddcc91f85208e1bdd4c823e36196425d376c1a6) )
	ROM_LOAD16_BYTE( "95404133.hi", 0x00000, 0x080000, CRC(1a3d4273) SHA1(77ee2e8a67a1cb6f59dfadc6f56e465916a34bfc) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404136.lo", 0x00001, 0x080000, CRC(4ca0a1b3) SHA1(7ed9d052a64d642fca67630208667d1d0b5de565) )
	ROM_LOAD16_BYTE( "95404137.hi", 0x00000, 0x080000, CRC(ed11a1b5) SHA1(ee19681c277c74d2ea15a0d335d73249c069b9a9) )
	ROM_LOAD16_BYTE( "95404138.lo", 0x00001, 0x080000, CRC(77a72b5c) SHA1(10a6e2bab024d505c560f0e6cf8aed0058ec286d) )
	ROM_LOAD16_BYTE( "95404139.hi", 0x00000, 0x080000, CRC(491414b0) SHA1(ebf0e82913f0cb0a9d9d7c74b79a0f6442705211) )
	ROM_LOAD16_BYTE( "95405132.lo", 0x00001, 0x080000, CRC(e2eb1d48) SHA1(fc2add0043e65306cf09c88f63c84bbb5a72330b) )
	ROM_LOAD16_BYTE( "95405133.hi", 0x00000, 0x080000, CRC(157b7d22) SHA1(12736f9b0889aa30fd8730f556e4e3eb5e35fb65) )
	ROM_LOAD16_BYTE( "95405136.lo", 0x00001, 0x080000, CRC(18e6b65f) SHA1(87852dabbd203ae5fa61e8379bc4779fd74e3548) )
	ROM_LOAD16_BYTE( "95405137.hi", 0x00000, 0x080000, CRC(3e936f54) SHA1(e91ec474bba76e16715eac18fffb83855c9fd992) )
	ROM_LOAD16_BYTE( "95405138.lo", 0x00001, 0x080000, CRC(4b25c296) SHA1(f7bda012cd28ee58214131b254e3a63b389c39c2) )
	ROM_LOAD16_BYTE( "95405139.hi", 0x00000, 0x080000, CRC(4b694c50) SHA1(3023dbd0f42bc47a89501c4c91b761316c19ed70) )
	ROM_LOAD16_BYTE( "95406010.lo", 0x00001, 0x080000, CRC(e076a371) SHA1(2bfee5563a0cf5ec0591eba0401840f416ba2e0b) )
	ROM_LOAD16_BYTE( "95406011.hi", 0x00000, 0x080000, CRC(add37113) SHA1(aa5c1569b2a6a2ff9ec30742e604d7e013157e46) )
	ROM_LOAD16_BYTE( "95406540.lo", 0x00001, 0x080000, CRC(80d13d97) SHA1(3879840b874106c7a79578eb200102797777a261) )
	ROM_LOAD16_BYTE( "95406541.hi", 0x00000, 0x080000, CRC(96a75813) SHA1(12442e1eeff23c9e61bc37f5542cab0923a45a5d) )
	ROM_LOAD16_BYTE( "95407010.lo", 0x00001, 0x080000, CRC(eb15044f) SHA1(8b09f38a44bc85305f739c819c9dd57ec3cd328d) )
	ROM_LOAD16_BYTE( "95407011.hi", 0x00000, 0x080000, CRC(043d9b69) SHA1(fe89c9c7ad931796179fb9da798f03a503b09f2a) )
	ROM_LOAD16_BYTE( "95407540.lo", 0x00001, 0x080000, CRC(8acd7c90) SHA1(fea4b8e191efe54af34aef98a37e8123b18830ce) )
	ROM_LOAD16_BYTE( "95407541.hi", 0x00000, 0x080000, CRC(3272d5d8) SHA1(4d57b7a06fccb2e47b7e05273759479ea811b981) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008103.bin", 0x0000, 0x100000, CRC(74ec1e6c) SHA1(1636192a63afcb060ee9453d24d7deb3a6776f51) )
	ROM_LOAD( "95008104.bin", 0x0000, 0x100000, CRC(b11bd959) SHA1(1739035495a14fedcbc67b724e7595693425d15f) )
ROM_END




ROM_START( sc_lined )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406410.lo", 0x00001, 0x080000, CRC(059a6162) SHA1(e0dfcc4314a961e11ac7850b49196dc99c1311e7) )
	ROM_LOAD16_BYTE( "95406411.hi", 0x00000, 0x080000, CRC(d5d1be58) SHA1(e9404372432969403b19da1599670f0493ebdcde) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407410.lo", 0x00001, 0x080000, CRC(43640651) SHA1(36131e4e820d538e1ac66770ab393b4a35cbd861) )
	ROM_LOAD16_BYTE( "95407411.hi", 0x00000, 0x080000, CRC(b4f5f9d1) SHA1(d2cde0ab4fbc5343c21cc87212b76e6dc17fb5f4) )
	ROM_LOAD16_BYTE( "95410312.lo", 0x00001, 0x080000, CRC(518b3c02) SHA1(29a518e44741a12374da153033bb062a1d880ecb) )
	ROM_LOAD16_BYTE( "95410313.hi", 0x00000, 0x080000, CRC(42a8b9cf) SHA1(f9dc766e89e58dc0a2892a32b443880c964117e8) )
	ROM_LOAD16_BYTE( "95411312.lo", 0x00001, 0x080000, CRC(e197d593) SHA1(d572fa6648fb54ffa080a4b5afb592649214f08f) )
	ROM_LOAD16_BYTE( "95411313.hi", 0x00000, 0x080000, CRC(7b8fcb79) SHA1(55597a75b3426e17e6f010986f9001fe4cff502f) )
	ROM_LOAD16_BYTE( "95412044.lo", 0x00001, 0x080000, CRC(20cdffd7) SHA1(c7cda44e258b63d066e6920fee238828b8538e26) )
	ROM_LOAD16_BYTE( "95412045.hi", 0x00000, 0x080000, CRC(95b7d9d5) SHA1(343e7d6643efe3227be3aae350b8f2e692eb444e) )
	ROM_LOAD16_BYTE( "95413050.lo", 0x00001, 0x080000, CRC(45ee70bb) SHA1(3a0e4faf76d20c37c2252309c6a174efbe60b6fd) )
	ROM_LOAD16_BYTE( "95413051.hi", 0x00000, 0x080000, CRC(ab28333a) SHA1(a6de1dac24dba8c6346b9938418edec638a3d6cf) )
	ROM_LOAD16_BYTE( "95417004.lo", 0x00001, 0x080000, CRC(ed8b10ea) SHA1(c75d5008ced3eab9b3dfb4ff2aa63412a93f6641) )
	ROM_LOAD16_BYTE( "95417005.hi", 0x00000, 0x080000, CRC(e7ff7a50) SHA1(9ab9e06338b96f35ebc70062685572eab4956cc7) )
	ROM_LOAD16_BYTE( "95417006.lo", 0x00001, 0x080000, CRC(3c24a417) SHA1(e273681e530cb2a47e1d864f7787a1fe55d47385) )
	ROM_LOAD16_BYTE( "95417007.hi", 0x00000, 0x080000, CRC(ced02db2) SHA1(7ccfbcd1b4b1ac4bf597449df949659c7b6a1d35) )
	ROM_LOAD16_BYTE( "95417008.lo", 0x00001, 0x080000, CRC(450e112d) SHA1(8c1f90494eb6c393f5906b07c1eda5553c0be236) )
	ROM_LOAD16_BYTE( "95417009.hi", 0x00000, 0x080000, CRC(ef05af27) SHA1(148318f8a156a42350ca6085daf8034bd2b90c8d) )
	ROM_LOAD16_BYTE( "95417010.lo", 0x00001, 0x080000, CRC(2438a69c) SHA1(5f9c94e5167d70322940999179ca7406c5466b2e) )
	ROM_LOAD16_BYTE( "95417011.hi", 0x00000, 0x080000, CRC(27801fe1) SHA1(aedfdbff63e98dbba48ee986d9638ff4c2635b63) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004241.bin", 0x0000, 0x080000, CRC(e524fd19) SHA1(af0bcf9cf75592beb928f78a915875f3e3ecedac) )
	ROM_LOAD( "95004242.bin", 0x0000, 0x080000, CRC(6d86611e) SHA1(2ec6a6745446502a77c10c487b75b59be1fc266e) )
	ROM_REGION( 0x400000, "others", ROMREGION_ERASE00 )
	ROM_LOAD( "95410312", 0x0000, 0x100000, CRC(0290613c) SHA1(34613f20d3f883d357220c2137778c57f7f11c12) ) // just a combined rom?
ROM_END




ROM_START( sc_ldcas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404020.lo", 0x00001, 0x080000, CRC(91b6e2a8) SHA1(a748451e1345032277c85c68611a37e3413d1c71) )
	ROM_LOAD16_BYTE( "95404021.hi", 0x00000, 0x080000, CRC(3f78523d) SHA1(bb3198fb2d1b1bad29c839f2b19d783a02b6cb67) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404022.lo", 0x00001, 0x080000, CRC(9f74e76c) SHA1(1fa9b169cfd7d428cfdc5b1601d9d7297f9b15db) )
	ROM_LOAD16_BYTE( "95404023.hi", 0x00000, 0x080000, CRC(ed927579) SHA1(6333dab7c18ed333a2d14a3057a518cfaf098029) )
	ROM_LOAD16_BYTE( "95404026.lo", 0x00001, 0x080000, CRC(8606d116) SHA1(984a188f3e67264580cd5c1abcc411776b7869e1) )
	ROM_LOAD16_BYTE( "95404027.hi", 0x00000, 0x080000, CRC(a95075fb) SHA1(482b73503993b7604b1b55fb6391987ad500510b) )
	ROM_LOAD16_BYTE( "95405020.lo", 0x00001, 0x080000, CRC(4b88d22f) SHA1(9349fe3054a6ea83cb11bbcca490761821746621) )
	ROM_LOAD16_BYTE( "95405021.hi", 0x00000, 0x080000, CRC(057209e0) SHA1(fd2aac60358f2a69b72e314f65f13d3294c5696f) )
	ROM_LOAD16_BYTE( "95405024.lo", 0x00001, 0x080000, CRC(2992e70b) SHA1(d76dbcbecb57e4bd0ed2611fa9fec6cd4fae5b82) )
	ROM_LOAD16_BYTE( "95405025.hi", 0x00000, 0x080000, CRC(11321f24) SHA1(8733a4120f1eadb5b1f122e41cc074c71b8d1f77) )
	ROM_LOAD16_BYTE( "95405026.lo", 0x00001, 0x080000, CRC(775b7c9a) SHA1(1fd89fc9d156fb2b185c36c39cee69fc7fdf6b87) )
	ROM_LOAD16_BYTE( "95405027.hi", 0x00000, 0x080000, CRC(841786f5) SHA1(211f2bd6cc116dd68e05e0f48b787aeafde5cc93) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_ldvcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424452.lo", 0x00001, 0x080000, CRC(4cfa9136) SHA1(f72eee294de4a4f44d1449d331a16ad84d30f902) )
	ROM_LOAD16_BYTE( "95424453.hi", 0x00000, 0x080000, CRC(2ba88d72) SHA1(7444fcd0c784d5026a5b629958cd37bd70780f66) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008897.bin", 0x0000, 0x0ff4f6, CRC(3b459b50) SHA1(ba4aa9bcf42cd95f366fbe51c343680cd3fbcd47) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891079.bin", 0x0000, 0x5000, CRC(378bb888) SHA1(054cdcad83a3909c8c17852f3848c7a7c4daae31) )
ROM_END




ROM_START( sc_ldvl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420972.lo", 0x00001, 0x080000, CRC(92a3c6ab) SHA1(dbfe3c6e9b751dad14993a9ed18a966f7587569b) )
	ROM_LOAD16_BYTE( "95420973.hi", 0x00000, 0x080000, CRC(eabf2e76) SHA1(9a14afd1a5f8fcd02c43172038323cea53512ac4) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95421972.lo", 0x00001, 0x080000, CRC(14c9318b) SHA1(69a0c1ad26488402cdf8b9e1904ce6ba159f448d) )
	ROM_LOAD16_BYTE( "95421973.hi", 0x00000, 0x080000, CRC(392e6b98) SHA1(f1600ab27c587cd5b141e721e740c73a08fd563e) )
	ROM_LOAD16_BYTE( "95424494.lo", 0x00001, 0x080000, CRC(ad821007) SHA1(0498b98222806344d5b29d1866922e705f4bd861) )
	ROM_LOAD16_BYTE( "95424495.hi", 0x00000, 0x080000, CRC(e5934cc5) SHA1(8641f90f0e1d47bee9d01e75552d94c368f50c87) )
	ROM_LOAD16_BYTE( "95424524.lo", 0x00001, 0x080000, CRC(d323cf89) SHA1(f384be0014e08984cb72275ac3ee163a0975222b) )
	ROM_LOAD16_BYTE( "95424525.hi", 0x00000, 0x080000, CRC(fa2b69df) SHA1(84b86aec04f9ba8001a61665d6d4ced7918eb18a) )
	ROM_LOAD16_BYTE( "95424534.lo", 0x00001, 0x080000, CRC(40d2de6a) SHA1(9e6e91d68976e9316f3c001cead6f7419bc4c2e0) )
	ROM_LOAD16_BYTE( "95424535.hi", 0x00000, 0x080000, CRC(6f67a83f) SHA1(37355719a6660f2c8bf2d30fe44c44f99828d6af) )
	ROM_LOAD16_BYTE( "95424536.lo", 0x00001, 0x080000, CRC(25c304a4) SHA1(7c9210b08e392f9501708c39d33e9546ad60f174) )
	ROM_LOAD16_BYTE( "95424537.hi", 0x00000, 0x080000, CRC(90499606) SHA1(0c017102c286c9b76aa93a426866c4ee1f3da10b) )
	ROM_LOAD16_BYTE( "95425494.lo", 0x00001, 0x080000, CRC(8532bb68) SHA1(c090a7150297ac76dcbd86ce2b42c30f37746935) )
	ROM_LOAD16_BYTE( "95425495.hi", 0x00000, 0x080000, CRC(e72f6e48) SHA1(79570758a8211a1f9d22ae521ba1a84c7d3eb3b5) )
	ROM_LOAD16_BYTE( "95425524.lo", 0x00001, 0x080000, CRC(446a9058) SHA1(a934093af01643c0b66e50b04e419abb90e7e952) )
	ROM_LOAD16_BYTE( "95425525.hi", 0x00000, 0x080000, CRC(34a5acdb) SHA1(c23f7571a103cb645689e13c99891174fb783dde) )
	ROM_LOAD16_BYTE( "95425534.lo", 0x00001, 0x080000, CRC(5171fa1e) SHA1(b465747669956087e2ded1ddcc113cb20b9c3500) )
	ROM_LOAD16_BYTE( "95425535.hi", 0x00000, 0x080000, CRC(e6a44159) SHA1(64855a21c320d41450c6d5737f1c876493a0e5a3) )
	ROM_LOAD16_BYTE( "95425536.lo", 0x00001, 0x080000, CRC(7d5fc6d2) SHA1(eec138baa134c9ca4e67bbe9ed4a73e06e4ac4ae) )
	ROM_LOAD16_BYTE( "95425537.hi", 0x00000, 0x080000, CRC(a271557a) SHA1(7f7f41164c4bda1cefef3ffd68858677917fef7e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008866.bin", 0x0000, 0x0ff4f6, CRC(de0f7488) SHA1(dc9d546efa940f0cc69afb296bda0f07f82a4258) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890764.bin", 0x0000, 0x5000, CRC(15baa871) SHA1(9d3f021cfde738bc68d99f072160aee3eeaf8798) )
	ROM_LOAD( "95890765.bin", 0x0000, 0x5000, CRC(602cec45) SHA1(94f97824a90c4771e8c1fbab2cb41723b786f7be) )
	ROM_LOAD( "95890766.bin", 0x0000, 0x5000, CRC(fe962019) SHA1(e7283db78ac104bb47a37e5e81d50cd81db477f5) )
ROM_END




ROM_START( sc_lockb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404756.lo", 0x00001, 0x080000, CRC(a2670248) SHA1(a295dbbbccc355b7635b1379c0d375b23ab294a6) )
	ROM_LOAD16_BYTE( "95404757.hi", 0x00000, 0x080000, CRC(dffb76b3) SHA1(37445588cda91a051a0ebf2ffee3a1c8fd14bc8d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405756.lo", 0x00001, 0x080000, CRC(a688e6ce) SHA1(fa4c2f892227199025abe9469bfc8e19beb2c528) )
	ROM_LOAD16_BYTE( "95405757.hi", 0x00000, 0x080000, CRC(a6d4a6b8) SHA1(6ce186dcdaddb9463f55b642cf091842616b5f2c) )
	ROM_LOAD16_BYTE( "95406038.lo", 0x00001, 0x080000, CRC(32d179dc) SHA1(95f6966d8ae1220cf1edae543b5eeff04cc6418f) )
	ROM_LOAD16_BYTE( "95406039.hi", 0x00000, 0x080000, CRC(948c0821) SHA1(571501f02fb8aa9d2b78305e6eb407a323c455bd) )
	ROM_LOAD16_BYTE( "95407038.lo", 0x00001, 0x080000, CRC(ca9be660) SHA1(b3a1d3ede11353b62231613a2d49e938a970751e) )
	ROM_LOAD16_BYTE( "95407039.hi", 0x00000, 0x080000, CRC(296cbe18) SHA1(5d06660721762e244078be0fa2e876b9b256bfbb) )
	ROM_LOAD16_BYTE( "95408270.lo", 0x00001, 0x080000, CRC(1f2dc3d2) SHA1(d41f3a17c56c620204d7950d0e47763ec745ff7c) )
	ROM_LOAD16_BYTE( "95408271.hi", 0x00000, 0x080000, CRC(aa555d95) SHA1(b703e308ab7041ca93bacef586cf3448bb96d4a9) )
	ROM_LOAD16_BYTE( "95408350.lo", 0x00001, 0x080000, CRC(f1fe6ad4) SHA1(e1d7fc107a98ec9e7553a4bde586c09ffc4ee51c) )
	ROM_LOAD16_BYTE( "95408351.hi", 0x00000, 0x080000, CRC(37e7738c) SHA1(f988adeac8eb3708be2f43ee76e708b570cb7662) )
	ROM_LOAD16_BYTE( "95409270.lo", 0x00001, 0x080000, CRC(48e6703e) SHA1(ba7d0341d6e53c57d69c8430beacc075c0ac0379) )
	ROM_LOAD16_BYTE( "95409271.hi", 0x00000, 0x080000, CRC(d039790e) SHA1(61ace5427f1785bcb67d66e1f7a4ed6ad0ed9cdf) )
	ROM_LOAD16_BYTE( "95409350.lo", 0x00001, 0x080000, CRC(9bf283d3) SHA1(be5068c4702f3e26311c7c0843dd60304fea147d) )
	ROM_LOAD16_BYTE( "95409351.hi", 0x00000, 0x080000, CRC(d541cb84) SHA1(7562f2e95148c2e30729105522bf9d00996d83c9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008223.bin", 0x0000, 0x100000, CRC(1b938782) SHA1(501567017e5097c616b90623b16e503b5ab941fd) )
ROM_END




ROM_START( sc_lkbcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406660.lo", 0x00001, 0x080000, CRC(6b47d48e) SHA1(6ddb9638e8bee9b82cdeaa72736fbeb62d0bdeb3) )
	ROM_LOAD16_BYTE( "95406661.hi", 0x00000, 0x080000, CRC(287aeded) SHA1(5b0b9af07bcf9eeae15bc1d4a27681a246ee417f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406810.lo", 0x00001, 0x080000, CRC(67375225) SHA1(5381fe140096d969c313c3e1b7377a569c3301d8) )
	ROM_LOAD16_BYTE( "95406811.hi", 0x00000, 0x080000, CRC(1d7031b2) SHA1(04827897f35009c1e8f0776fcc93eaf5756d072a) )
	ROM_LOAD16_BYTE( "95407660.lo", 0x00001, 0x080000, CRC(e210b047) SHA1(9922637d996ef76078de4206edb065e2a8ed61d3) )
	ROM_LOAD16_BYTE( "95407661.hi", 0x00000, 0x080000, CRC(329374b7) SHA1(8c28e1b788fa902ef23fee414f7706d824860b0e) )
	ROM_LOAD16_BYTE( "95407810.lo", 0x00001, 0x080000, CRC(b9144106) SHA1(6c97a5b3eab1172b89c923f7c4febae826ec19dd) )
	ROM_LOAD16_BYTE( "95407811.hi", 0x00000, 0x080000, CRC(283c553e) SHA1(e68b2c265351e84336644973eb93b79af9058ad7) )
	ROM_LOAD16_BYTE( "95408040.lo", 0x00001, 0x080000, CRC(2175a392) SHA1(b4e82c8e9b15f644c2a8d00e3d309e3d219105fa) )
	ROM_LOAD16_BYTE( "95408041.hi", 0x00000, 0x080000, CRC(feb97ec7) SHA1(bab549172ac3537180dbffb06a391deb3d24c555) )
	ROM_LOAD16_BYTE( "95408348.lo", 0x00001, 0x080000, CRC(314bb7de) SHA1(2b469b5904131f8d5a59a2d380ed7e8aa54198cb) )
	ROM_LOAD16_BYTE( "95408349.hi", 0x00000, 0x080000, CRC(a776d21d) SHA1(bfa3c42bfb0d7c35b362df877f1f1acb867bff8c) )
	ROM_LOAD16_BYTE( "95409040.lo", 0x00001, 0x080000, CRC(b468a2c9) SHA1(670297a776188b9b3c36369ff6c0e4a9e741f942) )
	ROM_LOAD16_BYTE( "95409041.hi", 0x00000, 0x080000, CRC(9307a4b7) SHA1(3900ff654cf3161c7c7bec0143841344a6753450) )
	ROM_LOAD16_BYTE( "95409348.lo", 0x00001, 0x080000, CRC(e9535725) SHA1(ce6970d6531f14ba5a63261b0d36fd743f195c12) )
	ROM_LOAD16_BYTE( "95409349.hi", 0x00000, 0x080000, CRC(5391762f) SHA1(719372b44e9b5b0c071e5b991c2757459171881f) )
	ROM_LOAD16_BYTE( "95412198.lo", 0x00001, 0x080000, CRC(9295556a) SHA1(38a8ac18b15982b626ef0e7fbbee2507a57e236b) )
	ROM_LOAD16_BYTE( "95412199.hi", 0x00000, 0x080000, CRC(448574bf) SHA1(f9c9802d7d8fbe195bc1b2c9bbf7a71d81402603) )
	ROM_LOAD16_BYTE( "95413198.lo", 0x00001, 0x080000, CRC(bb7df1d5) SHA1(1dc0aedcd1bae533d0dd6c3639557eb14fbc115d) )
	ROM_LOAD16_BYTE( "95413199.hi", 0x00000, 0x080000, CRC(9a3cddef) SHA1(f04bbaf181eda99f2d627373f349f0d27bb46bb5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008285.bin", 0x0000, 0x100000, CRC(c6a5033b) SHA1(9c7abea9052f606dd501e359a4fc4b69860c5269) )
ROM_END




ROM_START( sc_lotrr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410394.lo", 0x00001, 0x080000, CRC(d557f534) SHA1(9efd379e6197a94ec14642871a24c94f71e9a24b) )
	ROM_LOAD16_BYTE( "95410395.hi", 0x00000, 0x080000, CRC(10314cd5) SHA1(c784bb54c73d959f0e3f35a1e8bb18b139df4eb5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410396.lo", 0x00001, 0x080000, CRC(2a3a7527) SHA1(26460b7bf3b7b0908bc3c2dcd6ee28b1980f5e24) )
	ROM_LOAD16_BYTE( "95410397.hi", 0x00000, 0x080000, CRC(0ec51414) SHA1(8703d411222f88b46316d0bb435fff93c092fef2) )
	ROM_LOAD16_BYTE( "95410614.lo", 0x00001, 0x080000, CRC(39b70b6b) SHA1(feda79017224771822335ecd2a9c29c69c7a5aa5) )
	ROM_LOAD16_BYTE( "95410615.hi", 0x00000, 0x080000, CRC(d5ed8948) SHA1(63f4fd2fd5de601cee0668d74b7a8907643024ff) )
	ROM_LOAD16_BYTE( "95410626.lo", 0x00001, 0x080000, CRC(dd2020ce) SHA1(02926072b4c2450eb5f5220a92d008acbc2eae33) )
	ROM_LOAD16_BYTE( "95410627.hi", 0x00000, 0x080000, CRC(e82db72a) SHA1(697350b6694c3cc1d1a2a56a2757e40892dcd194) )
	ROM_LOAD16_BYTE( "95410628.lo", 0x00001, 0x080000, CRC(dcd4fb17) SHA1(5b799d1781985295d096e6531c8889adac93c32e) )
	ROM_LOAD16_BYTE( "95410629.hi", 0x00000, 0x080000, CRC(3092caa2) SHA1(aa271b2deeed72c0683838c360fd95839071f89d) )
	ROM_LOAD16_BYTE( "95410950.lo", 0x00001, 0x080000, CRC(33875be7) SHA1(4e2e092e2fa2f1ea9b7f4d748b182f5a9c3ffb3b) )
	ROM_LOAD16_BYTE( "95410951.hi", 0x00000, 0x080000, CRC(72553949) SHA1(91927ef336d367364f61dfe31c016c8e9a2bf99e) )
	ROM_LOAD16_BYTE( "95411394.lo", 0x00001, 0x080000, CRC(b5b840e9) SHA1(c30b0a0b2b5783ad6948a72cf81cba75f17a0c22) )
	ROM_LOAD16_BYTE( "95411395.hi", 0x00000, 0x080000, CRC(6658a38f) SHA1(5827af96fd9a8ff1dc0ad7a166303eee083b66ec) )
	ROM_LOAD16_BYTE( "95411614.lo", 0x00001, 0x080000, CRC(a2a230d7) SHA1(55f0a16bed44bceb94c578ed84df857ce95cf55d) )
	ROM_LOAD16_BYTE( "95411615.hi", 0x00000, 0x080000, CRC(bb8ff190) SHA1(9fec418e8d7540a54c79885236a30016acac70cf) )
	ROM_LOAD16_BYTE( "95411626.lo", 0x00001, 0x080000, CRC(c6c96d4d) SHA1(c03172ae532a8a4f925aab57134e6662a349c3a7) )
	ROM_LOAD16_BYTE( "95411627.hi", 0x00000, 0x080000, CRC(4dc69691) SHA1(19fe57968e0a1f905b3c5bcdcc728c29ecab9048) )
	ROM_LOAD16_BYTE( "95411628.lo", 0x00001, 0x080000, CRC(c73db694) SHA1(0974f02f6b033448dbe5853128402aaa3a74ff65) )
	ROM_LOAD16_BYTE( "95411629.hi", 0x00000, 0x080000, CRC(9579eb19) SHA1(1544a6a1511f2b81286a8903bb5bba50833f86e2) )
	ROM_LOAD16_BYTE( "95411950.lo", 0x00001, 0x080000, CRC(ec42d7f8) SHA1(fed3e0d17f671db1d3060ab9d8ae5d9bf45c9dbc) )
	ROM_LOAD16_BYTE( "95411951.hi", 0x00000, 0x080000, CRC(a7c31009) SHA1(d2db9721b6967810e02f28ce20e1ded6598eb08d) )
	ROM_LOAD16_BYTE( "95412574.lo", 0x00001, 0x080000, CRC(653cd804) SHA1(35e3346581a72ad29af7afe88266910d46ef043a) )
	ROM_LOAD16_BYTE( "95412575.hi", 0x00000, 0x080000, CRC(4227e0b5) SHA1(a8ae560d537cfb1bea25ac271deed501e7b655f4) )
	ROM_LOAD16_BYTE( "95412576.lo", 0x00001, 0x080000, CRC(074e4d44) SHA1(051dfe059170cb03f921b7f3a2d5352edd86cbe1) )
	ROM_LOAD16_BYTE( "95412577.hi", 0x00000, 0x080000, CRC(979476d8) SHA1(b4be828f6c37039234438f0dc0b73c17bcbceebe) )
	ROM_LOAD16_BYTE( "95413574.lo", 0x00001, 0x080000, CRC(796749c9) SHA1(e2940a8184537570b71eabd675ea44f23055798c) )
	ROM_LOAD16_BYTE( "95413575.hi", 0x00000, 0x080000, CRC(147949f2) SHA1(39b435b8f5b9490b3592e0cbff01b11c249ecea2) )
	ROM_LOAD16_BYTE( "95413576.lo", 0x00001, 0x080000, CRC(367be3bb) SHA1(0cc3829fab1b7e9472ec8012b95720444252ed33) )
	ROM_LOAD16_BYTE( "95413577.hi", 0x00000, 0x080000, CRC(d24a64d8) SHA1(ce1f8ec91926bd22be929dadd3e974354ad930d1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008413.bin", 0x0000, 0x100000, CRC(66d6fd58) SHA1(dff5cc3f09fb4082fde4d5d4a9ecfe00cbce7242) )
	ROM_LOAD( "95008414.bin", 0x0000, 0x100000, CRC(8ec846ac) SHA1(3f66cbe5bc7190406425488beccb3e1d15356b1a) )
ROM_END




ROM_START( sc_lotrf )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406762.lo", 0x00001, 0x080000, CRC(c098f523) SHA1(4139fbbf2cb07c2430c17bab2363f1d20842a407) )
	ROM_LOAD16_BYTE( "95406763.hi", 0x00000, 0x080000, CRC(dcd11097) SHA1(fa0fc2873dd568f43d3c45b40a43cb2f1c04739c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406882.lo", 0x00001, 0x080000, CRC(ca19c5ac) SHA1(674245c293642425225c0c93b625b03d20c191cf) )
	ROM_LOAD16_BYTE( "95406883.hi", 0x00000, 0x080000, CRC(be029534) SHA1(20d2db4d32a09627a8949e5fcae8f67d6707b545) )
	ROM_LOAD16_BYTE( "95407762.lo", 0x00001, 0x080000, CRC(29d01c1a) SHA1(88dc82758ff0d276558348af7954fa0f05152f60) )
	ROM_LOAD16_BYTE( "95407763.hi", 0x00000, 0x080000, CRC(5815fb7a) SHA1(99d1643d7e0ba1e1692d4c633347861ceade4001) )
	ROM_LOAD16_BYTE( "95407882.lo", 0x00001, 0x080000, CRC(791847c8) SHA1(edfa061f8472f30b134646205ec23e234cfae01d) )
	ROM_LOAD16_BYTE( "95407883.hi", 0x00000, 0x080000, CRC(d1c117a4) SHA1(c250ec310cf18ddc1a9c8666983812b29ff93c53) )
	ROM_LOAD16_BYTE( "95408034.lo", 0x00001, 0x080000, CRC(62512ad2) SHA1(9c540efa24caf9c376ccd261fda7c95a56acbadc) )
	ROM_LOAD16_BYTE( "95408035.hi", 0x00000, 0x080000, CRC(432ac324) SHA1(fb9b69f885cc2af8b39dc0820500133d8b136f66) )
	ROM_LOAD16_BYTE( "95408036.lo", 0x00001, 0x080000, CRC(74adbd87) SHA1(6320b606eb2ac2188660325a9a21bf69bf61af1c) )
	ROM_LOAD16_BYTE( "95408037.hi", 0x00000, 0x080000, CRC(a0c8a398) SHA1(486a51853878019c371030c70c601cef0b32f54e) )
	ROM_LOAD16_BYTE( "95409034.lo", 0x00001, 0x080000, CRC(ff2f081e) SHA1(75a95fe3647a66329f437258805f20ded758ce5a) )
	ROM_LOAD16_BYTE( "95409035.hi", 0x00000, 0x080000, CRC(85252b53) SHA1(a7bbf8c2e32513138d3c7d39ed773ddad30d7d0c) )
	ROM_LOAD16_BYTE( "95409036.lo", 0x00001, 0x080000, CRC(223d1401) SHA1(0e654d29476bc3f0c6c8fc529330000df4634add) )
	ROM_LOAD16_BYTE( "95409037.hi", 0x00000, 0x080000, CRC(6cc5d28f) SHA1(070162696f0a043d58df6c8f82a06ff4ad0b6a65) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008251.bin", 0x0000, 0x100000, CRC(2af25e80) SHA1(fb606e434ac99eee6e114d6639f28f0fa1e7ffb3) )
	ROM_LOAD( "95008252.bin", 0x0000, 0x100000, CRC(fbca1cfb) SHA1(27c610af14b10d1d72774186fd3afc12d5db925e) )
ROM_END




ROM_START( sc_lotr2 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408152.lo", 0x00001, 0x080000, CRC(051730dc) SHA1(1c6fe0d5a049d9808920854ca295eea816c9c206) )
	ROM_LOAD16_BYTE( "95408153.hi", 0x00000, 0x080000, CRC(a855fa62) SHA1(3a82fabb5ccd69fa9f578c1ee23a3c79cc6ee172) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408208.lo", 0x00001, 0x080000, CRC(005ce3ea) SHA1(45d2b86e291f231f054b1c4cb81ff745a77a3e44) )
	ROM_LOAD16_BYTE( "95408209.hi", 0x00000, 0x080000, CRC(b2536b9f) SHA1(4c1e7fb5cf9a5df30c0a48516e687ed87ef4fcb1) )
	ROM_LOAD16_BYTE( "95408548.lo", 0x00001, 0x080000, CRC(71697972) SHA1(00c5299293931ff2c135541c29a5cb48cea77e68) )
	ROM_LOAD16_BYTE( "95408549.hi", 0x00000, 0x080000, CRC(65e6822e) SHA1(f9672bf4e5d97e3c7a9b0c0bd6f05852c6f90982) )
	ROM_LOAD16_BYTE( "95409152.lo", 0x00001, 0x080000, CRC(75c4cad2) SHA1(308221608389158d4b3c9215ae6b4fa0694516ab) )
	ROM_LOAD16_BYTE( "95409153.hi", 0x00000, 0x080000, CRC(b43b2980) SHA1(c3bf20d55719f567d5cbb64dabe6289099b89a75) )
	ROM_LOAD16_BYTE( "95409208.lo", 0x00001, 0x080000, CRC(7336a670) SHA1(879f903e63c138f234e411c665db88da02c2f71e) )
	ROM_LOAD16_BYTE( "95409209.hi", 0x00000, 0x080000, CRC(1fdc8f56) SHA1(5132821d8e27f4d8ad7ba02759494cce8a1996b6) )
	ROM_LOAD16_BYTE( "95409548.lo", 0x00001, 0x080000, CRC(e5f8d2ec) SHA1(a5718f9fa4a4705a25425d39230ab8ced037b323) )
	ROM_LOAD16_BYTE( "95409549.hi", 0x00000, 0x080000, CRC(071e670f) SHA1(fb3c39ae927c6eda5e229bca0d5a645807d5c7fc) )
	ROM_LOAD16_BYTE( "95410558.lo", 0x00001, 0x080000, CRC(d60a2b02) SHA1(baca25b69b7669d0c97f9cde09ad26bba0944e32) )
	ROM_LOAD16_BYTE( "95410559.hi", 0x00000, 0x080000, CRC(1a567317) SHA1(a2fa2bbde9ced1e3a7b364c5ee35048169216486) )
	ROM_LOAD16_BYTE( "95410560.lo", 0x00001, 0x080000, CRC(ff25fd5a) SHA1(47a458f3bde3831bd31f4ff43e1650fb8a2189ba) )
	ROM_LOAD16_BYTE( "95410561.hi", 0x00000, 0x080000, CRC(a8afbd1f) SHA1(ae174e04ca288caa75d221fff904e3a215cb0c1d) )
	ROM_LOAD16_BYTE( "95411558.lo", 0x00001, 0x080000, CRC(6476bcf7) SHA1(a8ccfcec79b8cddaa51a96b5a801b7abf481061f) )
	ROM_LOAD16_BYTE( "95411559.hi", 0x00000, 0x080000, CRC(9d23c8cb) SHA1(073644f8bdb41a88dc4107164bd74e27bdc9efb8) )
	ROM_LOAD16_BYTE( "95411560.lo", 0x00001, 0x080000, CRC(fe4828cf) SHA1(71ccc824675082d16f1dc5848a20e06c6c4b5a0c) )
	ROM_LOAD16_BYTE( "95411561.hi", 0x00000, 0x080000, CRC(007ffb15) SHA1(a5ee74bd53a97faa41c428873a23d1eba41ea587) )
	ROM_LOAD16_BYTE( "95412412.lo", 0x00001, 0x080000, CRC(63cde735) SHA1(e6179c97bf18ed8a29ce7fea7cefa3f1a0a638e9) )
	ROM_LOAD16_BYTE( "95412413.hi", 0x00000, 0x080000, CRC(146ae98a) SHA1(e8d3694fd7aeee029196718d901b853bf0b6d1e0) )
	ROM_LOAD16_BYTE( "95413412.lo", 0x00001, 0x080000, CRC(de8c97d7) SHA1(dd8af3671809f8da04b3c6069fc9ca83cc907d8e) )
	ROM_LOAD16_BYTE( "95413413.hi", 0x00000, 0x080000, CRC(e1752ace) SHA1(2524300ec0fa2f760b686c7cc1ee6f200bc2411e) )
	ROM_LOAD16_BYTE( "p1315p11.hi", 0x00000, 0x080000, CRC(6efd6376) SHA1(6820dc5dea912935e0497cb60e45b350e2c62d56) )
	ROM_LOAD16_BYTE( "p1315p11.lo", 0x00001, 0x080000, CRC(cd46cf6e) SHA1(52bdf42178d1e456373e34b9b1d3e5f9ba75b3d5) )
	ROM_LOAD16_BYTE( "p1315s11.hi", 0x00000, 0x080000, CRC(d60911d4) SHA1(16823f0d904746bf0b6025810f68cd0dc687939c) )
	ROM_LOAD16_BYTE( "p1315s11.lo", 0x00001, 0x080000, CRC(54fb7c51) SHA1(c5ce97f0dfc0a30f37fb77e6aca623cc0a44963c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008320.bin", 0x0000, 0x100000, CRC(8ba801e3) SHA1(4d6a009c2f4f4478276f1227af6315b4be90fc87) )
	ROM_LOAD( "95008321.bin", 0x0000, 0x100000, CRC(42482ddc) SHA1(304961f267b85bc599dd64c97c14f34b2913dd59) )
ROM_END




ROM_START( sc_ltr2c )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408310.lo", 0x00001, 0x080000, CRC(915911cc) SHA1(23f8127be17a72f41a878d1dcb91d01be018f0a9) )
	ROM_LOAD16_BYTE( "95408311.hi", 0x00000, 0x080000, CRC(3b02b5c4) SHA1(7c8ad446df6b6695cce6ebf0c743ff721957f2d9) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408552.lo", 0x00001, 0x080000, CRC(32421027) SHA1(00a2a8dd7aefb2f0695ac9802742cafa61c901c9) )
	ROM_LOAD16_BYTE( "95408553.hi", 0x00000, 0x080000, CRC(ac2e7fea) SHA1(742153d17113618c07a8788432f576e2f54f3d97) )
	ROM_LOAD16_BYTE( "95408580.lo", 0x00001, 0x080000, CRC(a481bc4a) SHA1(7d55806502fd4e8300c53f9afe6db0571398363e) )
	ROM_LOAD16_BYTE( "95408581.hi", 0x00000, 0x080000, CRC(d5ba2c90) SHA1(e14ef19f137adb7fb5d4a0e9bbfe7f0828fc0bde) )
	ROM_LOAD16_BYTE( "95408582.lo", 0x00001, 0x080000, CRC(832650ae) SHA1(50e8e3a4f4c8a846258f9a5f4e37a20d0bd889cb) )
	ROM_LOAD16_BYTE( "95408583.hi", 0x00000, 0x080000, CRC(51d6b708) SHA1(97283827944a4e3c40aff1823f22ee1dc23e28e8) )
	ROM_LOAD16_BYTE( "95409310.lo", 0x00001, 0x080000, CRC(b7ddce2b) SHA1(da5d49ac7bfdf16f802f6fa555eb95b3e192ad18) )
	ROM_LOAD16_BYTE( "95409311.hi", 0x00000, 0x080000, CRC(e2dc12a4) SHA1(24749fbdd0779bfcc7c0a8317699504db5a0be8b) )
	ROM_LOAD16_BYTE( "95409552.lo", 0x00001, 0x080000, CRC(9d7d56c8) SHA1(142d8c7a39fe36b80b98c7000a4e158c6af8cf3e) )
	ROM_LOAD16_BYTE( "95409553.hi", 0x00000, 0x080000, CRC(738bf842) SHA1(6f146749c403c48f5968978c8ea9127fe3fa3c29) )
	ROM_LOAD16_BYTE( "95409580.lo", 0x00001, 0x080000, CRC(8a2b6c03) SHA1(c64ed66d851f3f384a219179dea6226d1d3d5301) )
	ROM_LOAD16_BYTE( "95409581.hi", 0x00000, 0x080000, CRC(64c3cf8f) SHA1(5fb7e3dc294f75106a244bfef899661c7588bb67) )
	ROM_LOAD16_BYTE( "95409582.lo", 0x00001, 0x080000, CRC(28e31a7b) SHA1(e4326b3e24c60287dc914e1536cbad910db60563) )
	ROM_LOAD16_BYTE( "95409583.hi", 0x00000, 0x080000, CRC(52e38587) SHA1(2c39f8ae729ed760608049cb44688d379d7fbc54) )
	ROM_LOAD16_BYTE( "95410832.lo", 0x00001, 0x080000, CRC(c1fda633) SHA1(ded61163a7d725f8260bc4ab58107af1710eec32) )
	ROM_LOAD16_BYTE( "95410833.hi", 0x00000, 0x080000, CRC(af3fcae8) SHA1(a19d9c63fb0a83e358391c358d457b09d93d8b76) )
	ROM_LOAD16_BYTE( "95410834.lo", 0x00001, 0x080000, CRC(2f478901) SHA1(b9de9e98bdba53bce60f0a765387f9001eafff5b) )
	ROM_LOAD16_BYTE( "95410835.hi", 0x00000, 0x080000, CRC(83fee9d8) SHA1(bcd35c40ea5be84bf255df15f78a68f9a630f848) )
	ROM_LOAD16_BYTE( "95411832.lo", 0x00001, 0x080000, CRC(175b6bee) SHA1(3d3885cb8cd26a6c559d36e8e8fefa79ae56d0a6) )
	ROM_LOAD16_BYTE( "95411833.hi", 0x00000, 0x080000, CRC(b477a9fa) SHA1(a7bf76775b58fb8cc9e18c42a75d3da562b5fc31) )
	ROM_LOAD16_BYTE( "95411834.lo", 0x00001, 0x080000, CRC(5aa1bc5d) SHA1(1a4e705a189ffb5d9c685faf5cd3f8a088a0dfa6) )
	ROM_LOAD16_BYTE( "95411835.hi", 0x00000, 0x080000, CRC(47318fea) SHA1(a7255a9004493bb609d3e7aaa09631a9cc27b5cc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008342.bin", 0x0000, 0x100000, CRC(44f48bf6) SHA1(2b36fb9ca6eb9cb35cf67e580d736c711d96ea25) )
	ROM_LOAD( "95008343.bin", 0x0000, 0x100000, CRC(f35a7927) SHA1(f2a93c8ff4699c7e6572a7a43b6b2bc50683594c) )
ROM_END




ROM_START( sc_lotrt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408274.lo", 0x00001, 0x080000, CRC(8d93666b) SHA1(cac29eaae1000abdf69d073109e03050aeee630b) )
	ROM_LOAD16_BYTE( "95408275.hi", 0x00000, 0x080000, CRC(95e4cf85) SHA1(a203564752af2d4821dd384e0a0670d5e565dd5f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409274.lo", 0x00001, 0x080000, CRC(1f61cac5) SHA1(334bf47adfbf2eddda1200681851084bd4380bbd) )
	ROM_LOAD16_BYTE( "95409275.hi", 0x00000, 0x080000, CRC(09464173) SHA1(9db97e339d66175909217960b2e863b72b238d15) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008517.bin", 0x0000, 0x100000, CRC(8092eaeb) SHA1(fea226ea7fb97226c79132aa67b89078f67cd920) )
	ROM_LOAD( "95008518.bin", 0x0000, 0x100000, CRC(6ac28d4e) SHA1(cdf50c856324130156115259efbfb7553480c749) )
ROM_END




ROM_START( sc_luck7 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406912.lo", 0x00001, 0x080000, CRC(ccc83e2a) SHA1(a12204a8e7e4fb93cb594152fb605a571ada9c21) )
	ROM_LOAD16_BYTE( "95406913.hi", 0x00000, 0x080000, CRC(3b33e4c7) SHA1(d3912d229bfb0092623bad3a19885449944ab06a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410286.lo", 0x00001, 0x080000, CRC(143befbe) SHA1(f99970ccdcbcc011837ba5e610f6bdf6f1659bf9) )
	ROM_LOAD16_BYTE( "95410287.hi", 0x00000, 0x080000, CRC(3b680008) SHA1(0b0ea12ca15ab136e38fd96f1b3776d25157cb47) )
	ROM_LOAD16_BYTE( "95410290.lo", 0x00001, 0x080000, CRC(682a2618) SHA1(b360a6566ffda0e7f5e776a12c251ffc1328a84a) )
	ROM_LOAD16_BYTE( "95410291.hi", 0x00000, 0x080000, CRC(d45c4426) SHA1(abf155b1cf3ec3b08c913c9b58f31455d81a5ba6) )
	ROM_LOAD16_BYTE( "95411286.lo", 0x00001, 0x080000, CRC(d6dce05d) SHA1(cd6d4503016a26f99efce5b25c995304aec8fa29) )
	ROM_LOAD16_BYTE( "95411287.hi", 0x00000, 0x080000, CRC(23fcc1b2) SHA1(99c4ee053c93a5007cfe680e9f30eb8b64b5e1a3) )
	ROM_LOAD16_BYTE( "95415994.lo", 0x00001, 0x080000, CRC(4d0d5fb6) SHA1(5a54d9fe966852d59cff449625568c212b6da2ed) )
	ROM_LOAD16_BYTE( "95415995.hi", 0x00000, 0x080000, CRC(98220928) SHA1(7c5eac3fc3bb53de42b9600224f0549768939379) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "lucky7s.bin", 0x0000, 0x200000, CRC(93002e7d) SHA1(50edf9064fb3bc9fd13efc65be6b12a4329fdb41) )
ROM_END




ROM_START( sc_luckb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404198.lo", 0x00001, 0x080000, CRC(d5071084) SHA1(c70cce06cda15d8ce9bc38eb659613d97d86391c) )
	ROM_LOAD16_BYTE( "95404199.hi", 0x00000, 0x080000, CRC(382d104c) SHA1(585475851401e3346dea7b79e3f77cd78aaef66b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404210.lo", 0x00001, 0x080000, CRC(b8467858) SHA1(0ef2941a98f36ec25a91b0a7970e70269cbbb078) )
	ROM_LOAD16_BYTE( "95404211.hi", 0x00000, 0x080000, CRC(49af67fb) SHA1(e424d5a70cd113b9c14da9490efe1c9763b82a8b) )
	ROM_LOAD16_BYTE( "95404212.lo", 0x00001, 0x080000, CRC(69a62011) SHA1(5ca44dcab6eb6c1e96d672a05df7da9d384daa94) )
	ROM_LOAD16_BYTE( "95404213.hi", 0x00000, 0x080000, CRC(71977d1d) SHA1(cd3bedb10b58f0ca8d0ecf5cf4416409e0c9fd58) )
	ROM_LOAD16_BYTE( "95405198.lo", 0x00001, 0x080000, CRC(d9f7970d) SHA1(1f68be10f90ffbdc141c57b50708fde097fe04c9) )
	ROM_LOAD16_BYTE( "95405199.hi", 0x00000, 0x080000, CRC(6cda6571) SHA1(c93536563f1947cd94274059645a791a4da25a6a) )
	ROM_LOAD16_BYTE( "95405210.lo", 0x00001, 0x080000, CRC(a7190577) SHA1(27adb7ba1bf66521c5b36a34b96a79e94e727984) )
	ROM_LOAD16_BYTE( "95405211.hi", 0x00000, 0x080000, CRC(12817baf) SHA1(79ce82d0af2b4ca7038dadf338d968385d9d64d1) )
	ROM_LOAD16_BYTE( "95405212.lo", 0x00001, 0x080000, CRC(76f95d3e) SHA1(15df0222a31708f71604e0cba1bd1863d426715e) )
	ROM_LOAD16_BYTE( "95405213.hi", 0x00000, 0x080000, CRC(2ab96149) SHA1(3fdae3ba95c3e76688358f01605188f0f98d13d9) )
	ROM_LOAD16_BYTE( "95406556.lo", 0x00001, 0x080000, CRC(42caab1a) SHA1(edb343270922d3f0fcd85c8edfd8a0a21249fbf2) )
	ROM_LOAD16_BYTE( "95406557.hi", 0x00000, 0x080000, CRC(6c5298d7) SHA1(d8eaad0c68fb6c523d3ecf8b3342f6f190715366) )
	ROM_LOAD16_BYTE( "95406720.lo", 0x00001, 0x080000, CRC(617e5530) SHA1(a1cbfecef284ca211fbe952a178a3f21a88b826b) )
	ROM_LOAD16_BYTE( "95406721.hi", 0x00000, 0x080000, CRC(db36db09) SHA1(c96c72d7f61c96b199d0d4e9cc095dbf51bec03e) )
	ROM_LOAD16_BYTE( "95407556.lo", 0x00001, 0x080000, CRC(5f8c33d7) SHA1(b1ee5527d33c35dfe3a7a3b22cf71845a84514d7) )
	ROM_LOAD16_BYTE( "95407557.hi", 0x00000, 0x080000, CRC(6549b7e0) SHA1(9dced4501cd7300f58f194bfa39a13940567001b) )
	ROM_LOAD16_BYTE( "95407720.lo", 0x00001, 0x080000, CRC(ca3b6b30) SHA1(e3b841b5ce34c3653e2c6798e60ec069c01673d7) )
	ROM_LOAD16_BYTE( "95407721.hi", 0x00000, 0x080000, CRC(a20a761a) SHA1(6992c04552eb74001dbbdd7f972039c1a4cff992) )
	ROM_LOAD16_BYTE( "95408232.lo", 0x00001, 0x080000, CRC(4756a519) SHA1(95a833bba170817f4f84cd2bf7d92b6c1f9c4d2f) )
	ROM_LOAD16_BYTE( "95408233.hi", 0x00000, 0x080000, CRC(db609b6f) SHA1(ec6f5f2c103c8b8b64b7dc38e302a0fb1181304f) )
	ROM_LOAD16_BYTE( "95409232.lo", 0x00001, 0x080000, CRC(2dfdd2c1) SHA1(21690662b28280bca0a033f6ae9407a1130caafb) )
	ROM_LOAD16_BYTE( "95409233.hi", 0x00000, 0x080000, CRC(0943afc6) SHA1(5fd0462edb15ab61e0cfb7f8d761de82811cca71) )
	ROM_LOAD16_BYTE( "95410030.lo", 0x00001, 0x080000, CRC(3259b382) SHA1(83a6d86de7c1fdb954b73a142c029a3f0176b2f5) )
	ROM_LOAD16_BYTE( "95410031.hi", 0x00000, 0x080000, CRC(1000c265) SHA1(8ea5202d2e3f7cf03404b50bbbe9229caf22dc68) )
	ROM_LOAD16_BYTE( "95410032.lo", 0x00001, 0x080000, CRC(441fda92) SHA1(3dc93712042d67ce8d31dce617bc5befd340caa8) )
	ROM_LOAD16_BYTE( "95410033.hi", 0x00000, 0x080000, CRC(9a5884a6) SHA1(c79d5a444f9130105cf999fc50200159957c8cd6) )
	ROM_LOAD16_BYTE( "95410034.lo", 0x00001, 0x080000, CRC(6f0c08f4) SHA1(62a656dd8d131dba27f2f960fa8c460016d565d8) )
	ROM_LOAD16_BYTE( "95410035.hi", 0x00000, 0x080000, CRC(f00b16d6) SHA1(be880bbf30779f98d646c0965fbce18c281fde63) )
	ROM_LOAD16_BYTE( "95410036.lo", 0x00001, 0x080000, CRC(9b750a29) SHA1(7f94ddf82b89fdf85ace86aaebe2399ab6ea5849) )
	ROM_LOAD16_BYTE( "95410037.hi", 0x00000, 0x080000, CRC(a1eee41d) SHA1(e28758e66f66c3c3343a7941e3e86846e73fea8a) )
	ROM_LOAD16_BYTE( "95410038.lo", 0x00001, 0x080000, CRC(32104c8e) SHA1(0c503de053b058b6bb92c44926318c49d443026a) )
	ROM_LOAD16_BYTE( "95410039.hi", 0x00000, 0x080000, CRC(f18c980d) SHA1(b7035cd07a6443804716fcf7ddb21a246d12460b) )
	ROM_LOAD16_BYTE( "95410586.lo", 0x00001, 0x080000, CRC(8e9a9b58) SHA1(8f8d750f6e51341d84c6a3c8808bb20d08b74ac3) )
	ROM_LOAD16_BYTE( "95410587.hi", 0x00000, 0x080000, CRC(1214cce0) SHA1(7d5f95197e27e9285ce5167fcbec5a017605a238) )
	ROM_LOAD16_BYTE( "95410588.lo", 0x00001, 0x080000, CRC(e8270188) SHA1(000f8903471916adc81664a9ba175699c89aa78b) )
	ROM_LOAD16_BYTE( "95410589.hi", 0x00000, 0x080000, CRC(26a7dbe8) SHA1(f89faf2c1c027b29e6780cc0da3374315394ea97) )
	ROM_LOAD16_BYTE( "95410590.lo", 0x00001, 0x080000, CRC(dbaca336) SHA1(2eb78c89d0477046a0ca1603752d953ec35958e3) )
	ROM_LOAD16_BYTE( "95410591.hi", 0x00000, 0x080000, CRC(6bd51308) SHA1(0d8d1481b5b3c591d94dcb6e853159d79eba8795) )
	ROM_LOAD16_BYTE( "95411030.lo", 0x00001, 0x080000, CRC(1fba23d6) SHA1(ef9b8719b5d0314b896b3288d1e9656f770def09) )
	ROM_LOAD16_BYTE( "95411031.hi", 0x00000, 0x080000, CRC(5cb4ea7d) SHA1(244805a353de49a6613a6aa417cce29745b29909) )
	ROM_LOAD16_BYTE( "95411032.lo", 0x00001, 0x080000, CRC(1af5a90d) SHA1(d2a892953d85c2fc0b7ea7e4e545b82ba113bbb0) )
	ROM_LOAD16_BYTE( "95411033.hi", 0x00000, 0x080000, CRC(e855daf5) SHA1(a01bfb4b4c21800e7d0608dc4a91d1b6a6974ae2) )
	ROM_LOAD16_BYTE( "95411034.lo", 0x00001, 0x080000, CRC(16db1d8f) SHA1(40af45feec9f3dbbe6a2c6b7b5eedfb6e15b5323) )
	ROM_LOAD16_BYTE( "95411035.hi", 0x00000, 0x080000, CRC(42ad9fbe) SHA1(1bac16930866625fa19a736111d54a2db831f8f0) )
	ROM_LOAD16_BYTE( "95411036.lo", 0x00001, 0x080000, CRC(aa37b87c) SHA1(327ec2da7fe526f9b681ca24d426cbbd860239b7) )
	ROM_LOAD16_BYTE( "95411037.hi", 0x00000, 0x080000, CRC(1fc9fe4b) SHA1(5a8b31ae46f0a06e7b40bbb656ebc6b3b8d9b4c6) )
	ROM_LOAD16_BYTE( "95411038.lo", 0x00001, 0x080000, CRC(c31ff079) SHA1(eab0d2acf9f3a343c9a71088c2944ccff1808eff) )
	ROM_LOAD16_BYTE( "95411039.hi", 0x00000, 0x080000, CRC(3dfbb430) SHA1(6b9adb872637dd5516029a8921ca99e7254288bd) )
	ROM_LOAD16_BYTE( "95411586.lo", 0x00001, 0x080000, CRC(8f074336) SHA1(2ac3ff2edf02db7eae3da808eb809f732263b0da) )
	ROM_LOAD16_BYTE( "95411587.hi", 0x00000, 0x080000, CRC(ce4f6b68) SHA1(37d6321a7a80261e81e4e42cbc439784b9f41f07) )
	ROM_LOAD16_BYTE( "95411589.hi", 0x00000, 0x080000, CRC(d9c31c4f) SHA1(e260e5e7acea8433a8235720b70f7a90045abb93) )
	ROM_LOAD16_BYTE( "95411590.lo", 0x00001, 0x080000, CRC(da317b58) SHA1(6f4ae388476f3030b8197352c51cf4ae83c2f691) )
	ROM_LOAD16_BYTE( "95411591.hi", 0x00000, 0x080000, CRC(b78eb480) SHA1(c748ecd064be708ba908e7689bc6c042d66b2698) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008161.bin", 0x0000, 0x080000, CRC(ecd13fd9) SHA1(51d11b9133d4e840ce9afd7cf716520ea0fc0343) )
	ROM_LOAD( "95008162.bin", 0x0000, 0x080000, CRC(b4b4a5c5) SHA1(d0748decfaee7da52d2f6a4bc0877be4243ed6fb) )
	ROM_LOAD( "95008167.bin", 0x0000, 0x080000, CRC(13aaf063) SHA1(70ab005c867c0c8f63b16722f4fc3ba0c935a96f) )
	ROM_LOAD( "95008168.bin", 0x0000, 0x080000, CRC(71aebb68) SHA1(479b3915552be029d459d3f05ccf668c21f05554) )
ROM_END




ROM_START( sc_magci )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414684.odd", 0x00001, 0x080000, CRC(f2259f9e) SHA1(09407e802851b995b72647e0b3c3f5dfb06074d0) )
	ROM_LOAD16_BYTE( "95414685.evn", 0x00000, 0x080000, CRC(3899b757) SHA1(ba03059073822a3008c6222232e53c9740a49169) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414686.odd", 0x00001, 0x080000, CRC(1d0dc678) SHA1(6f555e8836cb06cfc62295c0e446790e60e254c2) )
	ROM_LOAD16_BYTE( "95414687.evn", 0x00000, 0x080000, CRC(57a2a756) SHA1(33a7df99b01134129f9c57df3d117552cd3e4517) )
	ROM_LOAD16_BYTE( "95414688.odd", 0x00001, 0x080000, CRC(9fb7a7e2) SHA1(6ae25302a4e4b18776b9c7f2c602cecfea63c929) )
	ROM_LOAD16_BYTE( "95414689.evn", 0x00000, 0x080000, CRC(1d506b89) SHA1(6afd34571461800b2c84d444b1ee18f45574a793) )
	ROM_LOAD16_BYTE( "95414750.odd", 0x00001, 0x080000, CRC(ba2c853e) SHA1(ce1bb19171636437cc59aa1030d7cb11c917a9a7) )
	ROM_LOAD16_BYTE( "95414751.evn", 0x00000, 0x080000, CRC(fd25ed47) SHA1(556e22439461a295f7f66ec17b69c0647f1259ab) )
	ROM_LOAD16_BYTE( "95414768.odd", 0x00001, 0x080000, CRC(85619860) SHA1(621aa8a063f5be226a022f7480ea3acfcd68dac0) )
	ROM_LOAD16_BYTE( "95414769.evn", 0x00000, 0x080000, CRC(9346a662) SHA1(3891e1cb52e5848eb641fdc4714c1bcb64beebdf) )
	ROM_LOAD16_BYTE( "95414770.odd", 0x00001, 0x080000, CRC(d6dfaa33) SHA1(c443662c2c18156093937e04bcd7fa1b79d5f743) )
	ROM_LOAD16_BYTE( "95414771.evn", 0x00000, 0x080000, CRC(8b6f7f4c) SHA1(d4b4e6a5bd1a17a2dbe55328a5af4481fad45828) )
	ROM_LOAD16_BYTE( "95414772.odd", 0x00001, 0x080000, CRC(4d50f05b) SHA1(86457bb2cbf35ac2c0f45a6d4cbb0ed66ce6336d) )
	ROM_LOAD16_BYTE( "95414773.evn", 0x00000, 0x080000, CRC(43a8b33c) SHA1(32ad816185a45fba2ee003c8dfa3c899bb4db31b) )
	ROM_LOAD16_BYTE( "95414838.odd", 0x00001, 0x080000, CRC(992c1a25) SHA1(5342d945bf7688556b918a658c6506a70869ff5f) )
	ROM_LOAD16_BYTE( "95414839.evn", 0x00000, 0x080000, CRC(b95af506) SHA1(e006c24f70c7eec2b92ad3278115c27320987041) )
	ROM_LOAD16_BYTE( "95414902.odd", 0x00001, 0x080000, CRC(7114c603) SHA1(63df6b634e05487b3ba5396f61e7aacdd8e7550c) )
	ROM_LOAD16_BYTE( "95414903.evn", 0x00000, 0x080000, CRC(c577c2f6) SHA1(95032c7bdf71a1a513fb59133bd20ec519409843) )
	ROM_LOAD16_BYTE( "95414904.odd", 0x00001, 0x080000, CRC(7a6f6426) SHA1(154ab05d57c0af47ab6ed02d49916458aac42608) )
	ROM_LOAD16_BYTE( "95414905.evn", 0x00000, 0x080000, CRC(6de110ce) SHA1(910f52ca9d9716cfcfa12b262554ff06049b10c0) )
	ROM_LOAD16_BYTE( "95414906.odd", 0x00001, 0x080000, CRC(8995a5ca) SHA1(28c74f4f9b6e35731046445e9b5e53cea22973ea) )
	ROM_LOAD16_BYTE( "95414907.evn", 0x00000, 0x080000, CRC(0c10d778) SHA1(9d7c983b4e10c5fd25050e56bbb5c1d99cbae8df) )
	ROM_LOAD16_BYTE( "95415684.odd", 0x00001, 0x080000, CRC(d34e389b) SHA1(11dd8424e2d22c390621eb423d6cc0d142eb54f3) )
	ROM_LOAD16_BYTE( "95415685.evn", 0x00000, 0x080000, CRC(de571d3a) SHA1(95cc43cf09480c457c22087bd696d00ebb439e70) )
	ROM_LOAD16_BYTE( "95415686.odd", 0x00001, 0x080000, CRC(988c1320) SHA1(90f46b0fec3ab57794526e991b002e8a5d85ae20) )
	ROM_LOAD16_BYTE( "95415687.evn", 0x00000, 0x080000, CRC(ff72e15c) SHA1(a9dc73697b44d4ecc3a9627cf877335641f5d7c6) )
	ROM_LOAD16_BYTE( "95415688.odd", 0x00001, 0x080000, CRC(1a3672ba) SHA1(c5a7c47e1610466e92731009639f447f9ef0ed95) )
	ROM_LOAD16_BYTE( "95415689.evn", 0x00000, 0x080000, CRC(b5802d83) SHA1(90089e237f0485129cd2e9439e43ed887b047b5a) )
	ROM_LOAD16_BYTE( "95415750.odd", 0x00001, 0x080000, CRC(247a654c) SHA1(912beb51fb47fa7e952006d08ff983f3af411b8e) )
	ROM_LOAD16_BYTE( "95415751.evn", 0x00000, 0x080000, CRC(c6111aea) SHA1(5c36e39a1fd50c6b4bafdb6cb98394abf44c78f7) )
	ROM_LOAD16_BYTE( "95415768.odd", 0x00001, 0x080000, CRC(1b377812) SHA1(5a3c3c78bb70cedf647f806d3225d3bfb760ef89) )
	ROM_LOAD16_BYTE( "95415769.evn", 0x00000, 0x080000, CRC(a87251cf) SHA1(f78c603e61787cee6dd0c9e11140ae1bd7672caf) )
	ROM_LOAD16_BYTE( "95415770.odd", 0x00001, 0x080000, CRC(69cb728e) SHA1(a6372ddd4f6e7418947ee644eac107fbc56479c3) )
	ROM_LOAD16_BYTE( "95415771.evn", 0x00000, 0x080000, CRC(34f29195) SHA1(b818a939a3d457d2d4e791bbdede7d8f05418bdb) )
	ROM_LOAD16_BYTE( "95415772.odd", 0x00001, 0x080000, CRC(f24428e6) SHA1(b18c491debfd4fe7b4188a918d1f07e225f1ed2d) )
	ROM_LOAD16_BYTE( "95415773.evn", 0x00000, 0x080000, CRC(fc355de5) SHA1(f296a5f47fcbd91317eff215463aa7b7986854c9) )
	ROM_LOAD16_BYTE( "95415838.odd", 0x00001, 0x080000, CRC(e58d13b7) SHA1(776527e45c9d8147d0ca742d695f1038a3d3c870) )
	ROM_LOAD16_BYTE( "95415839.evn", 0x00000, 0x080000, CRC(25672dc8) SHA1(0afeb0b594764960d0de3297feef17c676363746) )
	ROM_LOAD16_BYTE( "95415902.odd", 0x00001, 0x080000, CRC(fe2d3c97) SHA1(9041f53deb3fc2af5bc8c69f583459189c0b13b1) )
	ROM_LOAD16_BYTE( "95415903.evn", 0x00000, 0x080000, CRC(780822f7) SHA1(4c1b5b6fd623ceeb0430592fa3461c3802d0d812) )
	ROM_LOAD16_BYTE( "95415904.odd", 0x00001, 0x080000, CRC(48297eb3) SHA1(e971690405b243714117bcc5d6e47ac901363195) )
	ROM_LOAD16_BYTE( "95415905.evn", 0x00000, 0x080000, CRC(dda5977e) SHA1(e3dbf9639e792e3623705450259fe474f2fe5dec) )
	ROM_LOAD16_BYTE( "95415906.odd", 0x00001, 0x080000, CRC(bbd3bf5f) SHA1(beafcf49ce5cf1db7419df9e08cc3435f01ede74) )
	ROM_LOAD16_BYTE( "95415907.evn", 0x00000, 0x080000, CRC(bc5450c8) SHA1(ec5d634bfb1cc54bb98a309d3d03996ef3c65e60) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008480.bin", 0x0000, 0x0c4846, CRC(025a1417) SHA1(6f522e71b4707829c98f77551f7cd4f2910f15b5) )
ROM_END




ROM_START( sc_magic )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408202.odd", 0x00001, 0x080000, CRC(6480c47f) SHA1(77e818bf71cb9e03359e4cedf3c5d0be40adf9ed) )
	ROM_LOAD16_BYTE( "95408203.evn", 0x00000, 0x080000, CRC(54682bf5) SHA1(2572ebb837a5666d026be9bcbc76a779c279d429) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408370.odd", 0x00001, 0x080000, CRC(4c157395) SHA1(061fc05bc8efbf4b37dd6e2b919b829723d9411d) )
	ROM_LOAD16_BYTE( "95408371.evn", 0x00000, 0x080000, CRC(63e386eb) SHA1(68264c6c3fe577bf91a0d76a67c9ccefcbaf929e) )
	ROM_LOAD16_BYTE( "95409202.odd", 0x00001, 0x080000, CRC(90a6e7cd) SHA1(bb24462fe9dcbdfc7e894644039f1990c44d30df) )
	ROM_LOAD16_BYTE( "95409203.evn", 0x00000, 0x080000, CRC(c56e948a) SHA1(885cddc36c0aa541a3fa4a03a6ccfb26b07a7064) )
	ROM_LOAD16_BYTE( "95409370.odd", 0x00001, 0x080000, CRC(b7ea394e) SHA1(b81d9ff9ca228ab9eb064ccbe471d1c2e7a4e5dc) )
	ROM_LOAD16_BYTE( "95409371.evn", 0x00000, 0x080000, CRC(fd3c50fd) SHA1(fecd5b2b9816171986a3aaf4889a13a0c231ae92) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008340.bin", 0x0000, 0x0ff5d7, CRC(1371b0d9) SHA1(aa8c23a86cbd5e8274bb035c1132da11d71fd2f8) )
ROM_END




ROM_START( sc_manic )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418954.lo", 0x00001, 0x080000, CRC(3758a20f) SHA1(870bd48a697ef4bf28675a12c9dc00da27693ea2) )
	ROM_LOAD16_BYTE( "95418955.hi", 0x00000, 0x080000, CRC(ee9bbdd7) SHA1(65ea3d6e74c0b44659ba121dc32f05b2f4df101e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418956.lo", 0x00001, 0x080000, CRC(a01460ca) SHA1(b7112e726e016d3e6a8d5a61dd64cf3bd0e7188b) )
	ROM_LOAD16_BYTE( "95418957.hi", 0x00000, 0x080000, CRC(35fb3cdb) SHA1(984bf00ff02b83cc44fa6746b1ab7ce7a387171d) )
	ROM_LOAD16_BYTE( "95419954.lo", 0x00001, 0x080000, CRC(e4935b60) SHA1(226dc89b4046f315c01edcd222ed1676687c7b1e) )
	ROM_LOAD16_BYTE( "95419955.hi", 0x00000, 0x080000, CRC(e4c66930) SHA1(e32c4f1cd0f8db0723d0dd42016d8a4a1b075bc2) )
	ROM_LOAD16_BYTE( "95419956.lo", 0x00001, 0x080000, CRC(e58342d1) SHA1(aa3cd1c8324f1731d84ad087ddb7b620b8c1c8f1) )
	ROM_LOAD16_BYTE( "95419957.hi", 0x00000, 0x080000, CRC(686efd41) SHA1(6d30b574886603bc737a132adbc4d5ac503a4527) )
	ROM_LOAD16_BYTE( "95422039.hi", 0x00000, 0x080000, CRC(c9c8661b) SHA1(c8ad798e4807da659015a9925cdb0eb6e837a9af) )
	ROM_LOAD16_BYTE( "95422040.lo", 0x00001, 0x080000, CRC(3c6cbcac) SHA1(102776c47d924d1c027217095aa33ef09e935bea) )
	ROM_LOAD16_BYTE( "95422041.hi", 0x00000, 0x080000, CRC(9d3177e6) SHA1(ec939b5b2508c7d420e34efc4d06bb71070e699e) )
	ROM_LOAD16_BYTE( "95422064.lo", 0x00001, 0x080000, CRC(82b62da6) SHA1(8c7f9bab82027dcdba3c3587d607a3deabeb5e47) )
	ROM_LOAD16_BYTE( "95422130.lo", 0x00001, 0x080000, CRC(7c591231) SHA1(b2e23a0c9887fcdea2a9cae0dc7d0569725f7430) )
	ROM_LOAD16_BYTE( "95422131.hi", 0x00000, 0x080000, CRC(70c795a4) SHA1(830246c935328ae6ed2212df1fd0ebaf7b50922c) )
	ROM_LOAD16_BYTE( "95422220.lo", 0x00001, 0x080000, CRC(7f46c357) SHA1(6b5cf3b6c6bae254c4194b4e9c378179e3b954fd) )
	ROM_LOAD16_BYTE( "95422221.hi", 0x00000, 0x080000, CRC(d465b976) SHA1(29c7ac7cf03bb4bd79b75a4cf7862175ffa58cfc) )
	ROM_LOAD16_BYTE( "95422602.lo", 0x00001, 0x080000, CRC(3b418150) SHA1(82124b1a3baa711bdd0883d06d8c58fb19755230) )
	ROM_LOAD16_BYTE( "95422603.hi", 0x00000, 0x080000, CRC(6f6a87ad) SHA1(736f386546fd849133fd389d1d06d67eccfd2951) )
	ROM_LOAD16_BYTE( "95422606.lo", 0x00001, 0x080000, CRC(9a280f93) SHA1(a7b5d01dc60457e34ceb2ebca868c2c2b6051b67) )
	ROM_LOAD16_BYTE( "95422607.hi", 0x00000, 0x080000, CRC(f940ab5b) SHA1(bc61e1b9a11a235f90231e1d68659b2a0435adea) )
	ROM_LOAD16_BYTE( "95422848.lo", 0x00001, 0x080000, CRC(fbe5a0c2) SHA1(4e537a9d92ce074faec6ef05410260aceefb1102) )
	ROM_LOAD16_BYTE( "95422849.hi", 0x00000, 0x080000, CRC(6c713bf1) SHA1(844bc26a49cb84697dbc33990ff79b31a83f6e1c) )
	ROM_LOAD16_BYTE( "95423039.hi", 0x00000, 0x080000, CRC(556af108) SHA1(7a88c1311ab7aa7773dd6b70a3891ebbe2d340d1) )
	ROM_LOAD16_BYTE( "95423040.lo", 0x00001, 0x080000, CRC(8d9478a2) SHA1(a4e4ea0444bc6b449e388194a4637940b7f083c8) )
	ROM_LOAD16_BYTE( "95423041.hi", 0x00000, 0x080000, CRC(104ec1d5) SHA1(36c6516cde84cdd75f8e83469756c17b8d7bdd6e) )
	ROM_LOAD16_BYTE( "95423064.lo", 0x00001, 0x080000, CRC(2b38fff9) SHA1(1fa95721790787c9199b7b2f05d591c233c6af05) )
	ROM_LOAD16_BYTE( "95423065.hi", 0x00000, 0x080000, CRC(c9a9b34f) SHA1(14630d4343fd509e1f6312ce539eeaf7e95f8869) )
	ROM_LOAD16_BYTE( "95423130.lo", 0x00001, 0x080000, CRC(3adbe9d3) SHA1(ff798442dd3d9613653c27aed4e584be9955c77f) )
	ROM_LOAD16_BYTE( "95423131.hi", 0x00000, 0x080000, CRC(ec9fe351) SHA1(1db66081159e45f66935bfe626e1f8dc0d0a28fb) )
	ROM_LOAD16_BYTE( "95423220.lo", 0x00001, 0x080000, CRC(69c473bb) SHA1(21573b9122994a936791d90c3b2ab43147a8e671) )
	ROM_LOAD16_BYTE( "95423221.hi", 0x00000, 0x080000, CRC(3dcadd66) SHA1(9c62d85f455ff5cf0c14c0afc22e895b335ce1be) )
	ROM_LOAD16_BYTE( "95423602.lo", 0x00001, 0x080000, CRC(d274e0aa) SHA1(bd582efc40256c9c41a2c388645ee572d43bd022) )
	ROM_LOAD16_BYTE( "95423603.hi", 0x00000, 0x080000, CRC(97ac122a) SHA1(a0d5ab34c3761dadd068ec2c62a859a4382630fa) )
	ROM_LOAD16_BYTE( "95423606.lo", 0x00001, 0x080000, CRC(24d8c137) SHA1(7af4e6a5d60cbab11dcf8db6d6b4016485ffbbb1) )
	ROM_LOAD16_BYTE( "95423607.hi", 0x00000, 0x080000, CRC(56a4fd89) SHA1(9d86f3a36fd69480aeaeef5c307ecd348ab2bb39) )
	ROM_LOAD16_BYTE( "95423848.lo", 0x00001, 0x080000, CRC(7cc1b546) SHA1(a244749c02fb571b2c9ec58a850d2956d00825dc) )
	ROM_LOAD16_BYTE( "95423849.hi", 0x00000, 0x080000, CRC(5d1b2ec1) SHA1(58a373d7aeb51ae9decac196e2a4093c0d296409) )
	ROM_LOAD16_BYTE( "95426160.lo", 0x00001, 0x080000, CRC(24fd7f44) SHA1(4631c7e8a7a7e4284bcddb7d678d027e11811961) )
	ROM_LOAD16_BYTE( "95426161.hi", 0x00000, 0x080000, CRC(8c9d61ed) SHA1(06133837c46d701ee235b6fc49dcf6e5506e3ba7) )
	ROM_LOAD16_BYTE( "95426162.lo", 0x00001, 0x080000, CRC(47fb3a1f) SHA1(41cff1666dd890fc18ac8110f6e4c598ca5826a9) )
	ROM_LOAD16_BYTE( "95426163.hi", 0x00000, 0x080000, CRC(525a8b91) SHA1(1e8a6bc2c140bbfe4297ec786535c30412dad05c) )
	ROM_LOAD16_BYTE( "95427160.lo", 0x00001, 0x080000, CRC(862c8680) SHA1(80e065396cc29ebec3ba657ba4777da634bec80c) )
	ROM_LOAD16_BYTE( "95427161.hi", 0x00000, 0x080000, CRC(8d0b8065) SHA1(3aeae265d5e65cdf57d105fa80058868378cd053) )
	ROM_LOAD16_BYTE( "95427162.lo", 0x00001, 0x080000, CRC(355bd2da) SHA1(035f715984db286db6f7ebd0c751fea872d4c98b) )
	ROM_LOAD16_BYTE( "95427163.hi", 0x00000, 0x080000, CRC(98fd15cf) SHA1(39f012e15d0d6f687399388a3ab0abbaf5f7db89) )
	ROM_LOAD16_BYTE( "p3004p41.hi", 0x00000, 0x080000, CRC(40e95a09) SHA1(83dc70405ec508cce10b4740c10b14e3563306bd) )
	ROM_LOAD16_BYTE( "p3004p41.lo", 0x00001, 0x080000, CRC(8db63e76) SHA1(eef45761e39ee007a694ac3971c97b1e8b046d25) )
	ROM_LOAD16_BYTE( "p3004p43.hi", 0x00000, 0x080000, CRC(5b3e487e) SHA1(86b3a3cdb5988a4eaef031fc03c605af968f721b) )
	ROM_LOAD16_BYTE( "p3004p43.lo", 0x00001, 0x080000, CRC(cdcf44b6) SHA1(16d1672c6e35659cda22c11357bcb0b3b197e3e0) )
	ROM_LOAD16_BYTE( "p3004p44.hi", 0x00000, 0x080000, CRC(150b1ffc) SHA1(23433e39127a6aef4770aaba6f18b44beb5887eb) )
	ROM_LOAD16_BYTE( "p3004p44.lo", 0x00001, 0x080000, CRC(5e9eaa65) SHA1(d680b621370e332735bf1a3f48c1deff810053e1) )
	ROM_LOAD16_BYTE( "p3004s41.hi", 0x00000, 0x080000, CRC(2ead5734) SHA1(8b5677a38300178edc5afc8e903714a0d7f79c90) )
	ROM_LOAD16_BYTE( "p3004s41.lo", 0x00001, 0x080000, CRC(cd8b7fa6) SHA1(df3392dc4f5a970ecc2a6a37966507cfa2c5481a) )
	ROM_LOAD16_BYTE( "p3004s43.hi", 0x00000, 0x080000, CRC(befacc80) SHA1(41dcacb2f6e6e6bd2f5dd7ee0f78d9bb06d91197) )
	ROM_LOAD16_BYTE( "p3004s43.lo", 0x00001, 0x080000, CRC(4e42a679) SHA1(2f23f70c93bc81b0667ae78b2ffdcc50cfc2735d) )
	ROM_LOAD16_BYTE( "p3004s44.hi", 0x00000, 0x080000, CRC(a9b34b7c) SHA1(9fd57ca197fc4309b943fc2b0731c5af4db1d7f5) )
	ROM_LOAD16_BYTE( "p3004s44.lo", 0x00001, 0x080000, CRC(419e18dd) SHA1(491b029eaf05ac6c08a26141f36c32b22d9955e8) )
	ROM_LOAD16_BYTE( "p3034p41.hi", 0x00000, 0x080000, CRC(b021f5cd) SHA1(5822c6589345e6796137cd58d747823ff2ee78c2) )
	ROM_LOAD16_BYTE( "p3034p41.lo", 0x00001, 0x080000, CRC(56afeb99) SHA1(763eda91a8a9a2579bc9bfdba1adf39098ed7b56) )
	ROM_LOAD16_BYTE( "p3034p42.hi", 0x00000, 0x080000, CRC(21c7fcbc) SHA1(4956e633f1dec59d023dc91ab56fb0e04f270645) )
	ROM_LOAD16_BYTE( "p3034p42.lo", 0x00001, 0x080000, CRC(760fafaa) SHA1(6295cf876527f20f77614443150a0ae48a07bc83) )
	ROM_LOAD16_BYTE( "p3034s41.hi", 0x00000, 0x080000, CRC(02ab75c4) SHA1(f93bcea32f8801c5deb1020e96d074bdb5197099) )
	ROM_LOAD16_BYTE( "p3034s41.lo", 0x00001, 0x080000, CRC(37f8f591) SHA1(761ca79e6accf6df9324d3a81f174326a5b26a9c) )
	ROM_LOAD16_BYTE( "p3034s42.hi", 0x00000, 0x080000, CRC(ed59aa13) SHA1(9e21f633307592d7a33ba0c14a78e2bd986f60e0) )
	ROM_LOAD16_BYTE( "p3034s42.lo", 0x00001, 0x080000, CRC(41ed34c8) SHA1(ca4b30a6575b06dcb6b56ab872cfa70b1eac5c46) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008684.bin", 0x0000, 0x100000, CRC(52b7d26e) SHA1(ba6629dbad8d00c132c0ddf6a8a41ddc99231c75) )
	ROM_LOAD( "95008685.bin", 0x0000, 0x100000, CRC(dc9717c0) SHA1(27234bb7c7e7bd1f395972ce2958d55e84005313) )
ROM_END




ROM_START( sc_maxim )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404176.lo", 0x00001, 0x080000, CRC(e94f5a8c) SHA1(93e9bb0b82cc93a510b1b4b73cc1e2175a014b33) )
	ROM_LOAD16_BYTE( "95404177.hi", 0x00000, 0x080000, CRC(255ee22d) SHA1(e8544ecaff119be4cbe8d79463ad4092a9a717a7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404364.lo", 0x00001, 0x080000, CRC(d514c3b4) SHA1(bfe4646ee88bb67610ffcc5ecc6457e6549db797) )
	ROM_LOAD16_BYTE( "95404365.hi", 0x00000, 0x080000, CRC(6df0669a) SHA1(0432dd9804e08128ae7dd8a02d1f76b191ec06fa) )
	ROM_LOAD16_BYTE( "95405176.lo", 0x00001, 0x080000, CRC(c24dfbd0) SHA1(3ae94e0b89bb181017b730c18c3cad4af16600d2) )
	ROM_LOAD16_BYTE( "95405177.hi", 0x00000, 0x080000, CRC(c1724698) SHA1(7d82e95d2e071d02826bfecb07e43fbfd538382b) )
	ROM_LOAD16_BYTE( "95405202.lo", 0x00001, 0x080000, CRC(532d0c71) SHA1(7d3ea71f41707cb43367c630f66893553c1d8f9c) )
	ROM_LOAD16_BYTE( "95405203.hi", 0x00000, 0x080000, CRC(7fa1421c) SHA1(fb1b6fc074a9ec744bb9396b000c7ef25eb99cad) )
	ROM_LOAD16_BYTE( "95405364.lo", 0x00001, 0x080000, CRC(79f8b340) SHA1(546a6ce09f65ca09cbcda88afaf52a3680b9c444) )
	ROM_LOAD16_BYTE( "95405365.hi", 0x00000, 0x080000, CRC(bc90a6a3) SHA1(7eb1b129c4bd94696d094a521e670ad73cf05380) )
	ROM_LOAD16_BYTE( "95406730.lo", 0x00001, 0x080000, CRC(c90ea797) SHA1(03a8c34d388dda04db95ba119a38c0ee41c5d479) )
	ROM_LOAD16_BYTE( "95406731.hi", 0x00000, 0x080000, CRC(c60d54a9) SHA1(0bee4710db80098c02afca7b4b1752593b6308c4) )
	ROM_LOAD16_BYTE( "95407730.lo", 0x00001, 0x080000, CRC(a5f9b515) SHA1(1df39e1f3ab6f9b8010b5728e7aad936019d4ee4) )
	ROM_LOAD16_BYTE( "95407731.hi", 0x00000, 0x080000, CRC(40464305) SHA1(dfbae3227e4f55c598fef806179695b2ffa27df2) )

	ROM_LOAD16_BYTE( "maximus.hi", 0x00001, 0x080000, CRC(f8b22a33) SHA1(0756f4ce4cc4da0b5920c64e03cb5eb5bc1124c6) )
	ROM_LOAD16_BYTE( "maximus.lo", 0x00000, 0x080000, CRC(0a95c98e) SHA1(b72ceba01926b011065b180f1290742b3ff16268) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008151.bin", 0x0000, 0x184af2, CRC(775d8471) SHA1(d784e25f52e6df18da9eabf93e6b50de5217c374) )
ROM_END




ROM_START( sc_maxcc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410910.lo", 0x00001, 0x080000, CRC(b55d74f4) SHA1(8218e7cfd3e3265db5c57fb4c91a8a6660249f3d) )
	ROM_LOAD16_BYTE( "95410911.hi", 0x00000, 0x080000, CRC(1d521acf) SHA1(28568a89288ba7986a8ee1b9de4caaff9f8b2ba8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410912.lo", 0x00001, 0x080000, CRC(2cf07e5e) SHA1(0bf59aca078bef1ed8c0358f98c1b9d5c4bc2834) )
	ROM_LOAD16_BYTE( "95410913.hi", 0x00000, 0x080000, CRC(1434b7d8) SHA1(8b4ee571ba3fe60db5bbab841f1a26e92670a5c9) )
	ROM_LOAD16_BYTE( "95411910.lo", 0x00001, 0x080000, CRC(7f811220) SHA1(2e2c61a0345d0f0334a8acb3f1afc28ef4ff99d2) )
	ROM_LOAD16_BYTE( "95411911.hi", 0x00000, 0x080000, CRC(bac46394) SHA1(79144ba540085480b12201b97aa64e6a0f2ab6c5) )
	ROM_LOAD16_BYTE( "95411912.lo", 0x00001, 0x080000, CRC(e62c188a) SHA1(8bf25fa6318a6de9a92e09f1dc9a4eb2ff728098) )
	ROM_LOAD16_BYTE( "95411913.hi", 0x00000, 0x080000, CRC(b3a2ce83) SHA1(0c6baf68846277ef7effa6566ef849a4c2c18dc6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_mmm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416792.lo", 0x00001, 0x080000, CRC(4b1ae1cd) SHA1(2b3523032995517dfd46835c2f3483b4da9f4eef) )
	ROM_LOAD16_BYTE( "95416793.hi", 0x00000, 0x080000, CRC(4d02586f) SHA1(7543b55d0aa1a83e5061d4456006a8412579ece7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416950.lo", 0x00001, 0x080000, CRC(a1a42db1) SHA1(c676e72a9a4c9399dfbcc98b50845dd71cc96c1c) )
	ROM_LOAD16_BYTE( "95416951.hi", 0x00000, 0x080000, CRC(ff46f109) SHA1(3163548003146b20da266c5344a2e610eed346e6) )
	ROM_LOAD16_BYTE( "95416952.lo", 0x00001, 0x080000, CRC(060e7fe9) SHA1(6a01b5a07673ca618c887dc5f0f2427a72692404) )
	ROM_LOAD16_BYTE( "95416953.hi", 0x00000, 0x080000, CRC(dbecceb1) SHA1(4f3643003a67c52c9e5e4c31bc596fdd567a9b1a) )
	ROM_LOAD16_BYTE( "95417792.lo", 0x00001, 0x080000, CRC(b4145441) SHA1(c468b712077d58943195f1ceac7b6015f8f80286) )
	ROM_LOAD16_BYTE( "95417793.hi", 0x00000, 0x080000, CRC(e4335ab0) SHA1(2d521a5a4ce726deaf697635d212e4886fecb878) )
	ROM_LOAD16_BYTE( "95417950.lo", 0x00001, 0x080000, CRC(c46efd5f) SHA1(18a5bdd00fce9db6ca12c46407affc5cff69021e) )
	ROM_LOAD16_BYTE( "95417951.hi", 0x00000, 0x080000, CRC(544a15ab) SHA1(4997c67cc238265238835764a25cff54588e2a4b) )
	ROM_LOAD16_BYTE( "95417952.lo", 0x00001, 0x080000, CRC(92a4b8a1) SHA1(0f88fa8544dd6608b5ddce31c2ba7b5525ccc4e6) )
	ROM_LOAD16_BYTE( "95417953.hi", 0x00000, 0x080000, CRC(3127af1d) SHA1(2d483b8cc1c873bbcf5f142f10cc0399d5bc49ec) )
	ROM_LOAD16_BYTE( "95420198.lo", 0x00001, 0x080000, CRC(e807d9b2) SHA1(f39c9538e4b1d5c58e05a9d5f8175e7b01e87e95) )
	ROM_LOAD16_BYTE( "95420199.hi", 0x00000, 0x080000, CRC(0d32d35d) SHA1(743ab7d17c6bf71655c932dee2ec588db05fdf4f) )
	ROM_LOAD16_BYTE( "95420200.lo", 0x00001, 0x080000, CRC(6eff6750) SHA1(bb8f7904653299f5caaf5a9ef8dfcdcf75da5bda) )
	ROM_LOAD16_BYTE( "95420201.hi", 0x00000, 0x080000, CRC(5b1ad2e0) SHA1(97a3436ced57849a5a852248d342c875c015d61e) )
	ROM_LOAD16_BYTE( "95420202.lo", 0x00001, 0x080000, CRC(6eda8626) SHA1(1a5a563d0c3b6cccbf8c8fad7b4b01010a6cb6cb) )
	ROM_LOAD16_BYTE( "95420203.hi", 0x00000, 0x080000, CRC(079e8554) SHA1(2d7b5fe3b452bd3a33139bb73b43a5230dd7501b) )
	ROM_LOAD16_BYTE( "95421198.lo", 0x00001, 0x080000, CRC(af505287) SHA1(297c86c15a5ef29a4c40535e64ee7d96e778d4b1) )
	ROM_LOAD16_BYTE( "95421199.hi", 0x00000, 0x080000, CRC(2281800b) SHA1(3fd26e5f63ac03331e291a852187c5cfea3338d0) )
	ROM_LOAD16_BYTE( "95421200.lo", 0x00001, 0x080000, CRC(d1233024) SHA1(aed4e4b89f89f4bc1beaa49310c3237548d270a0) )
	ROM_LOAD16_BYTE( "95421201.hi", 0x00000, 0x080000, CRC(5a088c8d) SHA1(624f410471f8d40cc172784b9ec41883b3424161) )
	ROM_LOAD16_BYTE( "95421202.lo", 0x00001, 0x080000, CRC(4203aa0b) SHA1(3f7c2e83c71a6308778cbf693c587399f96fafa6) )
	ROM_LOAD16_BYTE( "95421203.hi", 0x00000, 0x080000, CRC(13f57bf4) SHA1(0d72148383b265dd2d0bf94915e044e907a56e28) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008944.bin", 0x0000, 0x0c76af, CRC(d2683fa2) SHA1(ebccd3da695cc69826493ac9e745b8dc2ce2ab8c) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890425.bin", 0x0000, 0x5000, CRC(fde2f6d4) SHA1(e62c28175138ed7d92c1e00c0a07a8e1f4a41ad2) )
	ROM_LOAD( "95890426.bin", 0x0000, 0x5000, CRC(8874b2e0) SHA1(0ba474cd47a65a5120df20b0f1ffcfe0aa51b0c5) )
	ROM_LOAD( "95890427.bin", 0x0000, 0x5000, CRC(16ce7ebc) SHA1(8561cf7808f09a92af8715999000684c1bef11bb) )
ROM_END




ROM_START( sc_miljo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406346.lo", 0x00001, 0x080000, CRC(5b884ddb) SHA1(b289b0c7d3206ca60af62b6e60cfca778d61d8e0) )
	ROM_LOAD16_BYTE( "95406347.hi", 0x00000, 0x080000, CRC(e89954d8) SHA1(d9642d3ca8b56f85f0825f4154041171cf523efd) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "96406346.lo", 0x00001, 0x080000, CRC(5b884ddb) SHA1(b289b0c7d3206ca60af62b6e60cfca778d61d8e0) )
	ROM_LOAD16_BYTE( "96406347.hi", 0x00000, 0x080000, CRC(e89954d8) SHA1(d9642d3ca8b56f85f0825f4154041171cf523efd) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004305.sn1", 0x0000, 0x080000, CRC(1fffefe8) SHA1(e4dd8ee3ac82c598b50fe49afeddf11bcca96581) )
	ROM_LOAD( "95004306.sn2", 0x0000, 0x080000, CRC(afc501d4) SHA1(9a28381a7c1c047d6e7bb70736d2c8308c8911a3) )
ROM_END




ROM_START( sc_milja )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406516.lo", 0x00001, 0x080000, CRC(a315dc08) SHA1(3319a76cfe3f15128f2c1fc4cac2a9137ba4c2ce) )
	ROM_LOAD16_BYTE( "95406517.hi", 0x00000, 0x080000, CRC(865d821a) SHA1(74e3676d1db927d5b5848ee67c376f29b14b976b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004305.sn1", 0x0000, 0x080000, CRC(1fffefe8) SHA1(e4dd8ee3ac82c598b50fe49afeddf11bcca96581) )
	ROM_LOAD( "95004306.sn2", 0x0000, 0x080000, CRC(afc501d4) SHA1(9a28381a7c1c047d6e7bb70736d2c8308c8911a3) )
ROM_END




ROM_START( sc_mbags )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400435.lo", 0x00001, 0x080000, CRC(92164f6e) SHA1(4e53bf94e9fea7fbffd306c1bdcf20b6ac4e7b35) )
	ROM_LOAD16_BYTE( "95400436.hi", 0x00000, 0x080000, CRC(7017062c) SHA1(1ed616fb44fdf689baaede095b3c59e4bab0face) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400437.lo", 0x00001, 0x080000, CRC(06e2ab4c) SHA1(7795e7391be900e8f0dc6cf2ed6456898ec6e07a) )
	ROM_LOAD16_BYTE( "95400438.hi", 0x00000, 0x080000, CRC(32dda7ce) SHA1(b30ba112e3a734b01cc6d4424df3844b408d5a6a) )
	ROM_LOAD16_BYTE( "95401435.lo", 0x00001, 0x080000, CRC(3652929f) SHA1(542413554aa80749308e6d6e4f1a133390be5a9a) )
	ROM_LOAD16_BYTE( "95401436.hi", 0x00000, 0x080000, CRC(70885014) SHA1(4bea5236ed7190c136893fd106f7b9d1c9b7fc3f) )
	ROM_LOAD16_BYTE( "95401437.lo", 0x00001, 0x080000, CRC(19cf5563) SHA1(1d0ec3beeb242df8cd5af05f65ff4d10986507e3) )
	ROM_LOAD16_BYTE( "95401438.hi", 0x00000, 0x080000, CRC(5e5dd1ce) SHA1(65331052bd3583591bf10762d2f48ce16d7a152f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_mgr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406738.lo", 0x00001, 0x080000, CRC(91e156b8) SHA1(3439f79e68c445960cf41b1f8a2b60e166e28024) )
	ROM_LOAD16_BYTE( "95406739.hi", 0x00000, 0x080000, CRC(2e2ba90c) SHA1(cc09e392dbba2f75ed72fbff8c0ec6e47922cc0b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407738.lo", 0x00001, 0x080000, CRC(6a1a091d) SHA1(93371ab90612ae6000d3cc6c3ddca8f90db803db) )
	ROM_LOAD16_BYTE( "95407739.hi", 0x00000, 0x080000, CRC(cf883e87) SHA1(74edbaff54944f2a1ed6e7d99bbd9047dbd9fb4b) )
	ROM_LOAD16_BYTE( "95410592.lo", 0x00001, 0x080000, CRC(578476ff) SHA1(ca115ed9a04efea369de6dbc7e0c999b0276e24e) )
	ROM_LOAD16_BYTE( "95410593.hi", 0x00000, 0x080000, CRC(63bc7162) SHA1(15629023e84ae7a1b19201d24c0f74edd45c05e3) )
	ROM_LOAD16_BYTE( "95410594.lo", 0x00001, 0x080000, CRC(5d5ef370) SHA1(46253f4e6ac2b226b9cfb0c318dc3537700ab3db) )
	ROM_LOAD16_BYTE( "95410595.hi", 0x00000, 0x080000, CRC(b24010eb) SHA1(ea3ea23665a5b9dcc5f861aad720313f832ee248) )
	ROM_LOAD16_BYTE( "95411592.lo", 0x00001, 0x080000, CRC(d7865d1f) SHA1(203ef7d6ed1babd74c2d5dcc497347fa13a4c909) )
	ROM_LOAD16_BYTE( "95411593.hi", 0x00000, 0x080000, CRC(57ceb99e) SHA1(6997e1e3dbe389d990c97eebd7397546e33bfb73) )
	ROM_LOAD16_BYTE( "95411594.lo", 0x00001, 0x080000, CRC(34ec80ae) SHA1(61373d443505f7656e56d1f0fe0ffdc61153db47) )
	ROM_LOAD16_BYTE( "95411595.hi", 0x00000, 0x080000, CRC(78f7e5f8) SHA1(4993018f22d7223b1b0e1ed11899564298d666e6) )
	ROM_LOAD16_BYTE( "95412214.lo", 0x00001, 0x080000, CRC(569b2591) SHA1(0e5c1e14e9b8de49e02a1efc02f50b6d632a2fa5) )
	ROM_LOAD16_BYTE( "95412215.hi", 0x00000, 0x080000, CRC(cff9aefa) SHA1(c8a973429cec99010a4886ad88cde820ecbdf435) )
	ROM_LOAD16_BYTE( "95413214.lo", 0x00001, 0x080000, CRC(645e63ff) SHA1(78e7e7a210eed5e8086483f7e8dac2a8f2cc4b91) )
	ROM_LOAD16_BYTE( "95413215.hi", 0x00000, 0x080000, CRC(1ce43623) SHA1(9748d4df64f4282a141ca2907630badfdeb5c3bd) )
	ROM_LOAD16_BYTE( "p1132p72.hi", 0x00000, 0x080000, CRC(9cbaee34) SHA1(1d5713a4cd1f74c97b0879c2850fa994639f2370) )
	ROM_LOAD16_BYTE( "p1132p72.lo", 0x00001, 0x080000, CRC(fb327c69) SHA1(b799290d2e4d0f071e7d97ab4817d8fdc14f9c2c) )
	ROM_LOAD16_BYTE( "p1132s72.hi", 0x00000, 0x080000, CRC(06f9462c) SHA1(865c4cab26b9265e0da1e53bdbd9fa1df1e1ea34) )
	ROM_LOAD16_BYTE( "p1132s72.lo", 0x00001, 0x080000, CRC(3392c0b4) SHA1(231cd4ad13cb71d44e1bb0d6b4eb22ecd5240d8c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008212.bin", 0x0000, 0x100000, CRC(1d0fffb3) SHA1(da7e10479b1ba9e67af94feaa20702bae687168f) )
	ROM_LOAD( "snd_mgo.p1", 0x0000, 0x100000, CRC(b2f8dd11) SHA1(2db747a0c422d7dd18972f80ba94570c69564c9b) )
ROM_END




ROM_START( sc_mmad )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416292.lo", 0x00001, 0x080000, CRC(6085bc70) SHA1(1232ca906257e281fb7dbe7b8e8bd1a5dfeee3c0) )
	ROM_LOAD16_BYTE( "95416293.hi", 0x00000, 0x080000, CRC(a3f1a116) SHA1(a3647d6091c00f785bde930543869173bb21b45d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416294.lo", 0x00001, 0x080000, CRC(146f4b75) SHA1(70ac7756ac6e52113bf7afef783622e07a300ef6) )
	ROM_LOAD16_BYTE( "95416295.hi", 0x00000, 0x080000, CRC(ce018f99) SHA1(10df73d5ded92f033653f9f2ba35fd57bc4b49be) )
	ROM_LOAD16_BYTE( "95416296.lo", 0x00001, 0x080000, CRC(74669322) SHA1(e3c101e30e3e26e1bf4335cd47cb9de0bcb29341) )
	ROM_LOAD16_BYTE( "95416297.hi", 0x00000, 0x080000, CRC(23d37d4b) SHA1(474018fcbbfa49255217f75a43c27a4dc0bde424) )
	ROM_LOAD16_BYTE( "95417292.lo", 0x00001, 0x080000, CRC(e8fd792a) SHA1(b1f826c0f1dd4a6b84a67a3f2e50a9517f91ef74) )
	ROM_LOAD16_BYTE( "95417293.hi", 0x00000, 0x080000, CRC(c272846e) SHA1(645c1e7d7452de44319d70722d51c5e192fe8230) )
	ROM_LOAD16_BYTE( "95417294.lo", 0x00001, 0x080000, CRC(46b0ff94) SHA1(47b6014fee6837a519142a48b4b5c4d030f409f7) )
	ROM_LOAD16_BYTE( "95417295.hi", 0x00000, 0x080000, CRC(2699252c) SHA1(8bfa96fc12c867e8e09d71064f91babd39f13e16) )
	ROM_LOAD16_BYTE( "95417296.lo", 0x00001, 0x080000, CRC(28e3e75a) SHA1(bacbc50c0e85f3ee5606fda43515bfa6721af0ac) )
	ROM_LOAD16_BYTE( "95417297.hi", 0x00000, 0x080000, CRC(35b8870e) SHA1(b7f2ff0c31fe31a92477aebc8503489e271e793a) )
	ROM_LOAD16_BYTE( "95420440.lo", 0x00001, 0x080000, CRC(40a0c5b7) SHA1(11ccb76c795e5d80a82d217bb7321c8e39cb33ee) )
	ROM_LOAD16_BYTE( "95420441.hi", 0x00000, 0x080000, CRC(31a5b3e1) SHA1(b4cd4f15579c8b5036554da07c06e16c4c4dc731) )
	ROM_LOAD16_BYTE( "95420542.lo", 0x00001, 0x080000, CRC(e0844e00) SHA1(e29fed68345b99e206cf075cf549f3ecfcd6050c) )
	ROM_LOAD16_BYTE( "95420543.hi", 0x00000, 0x080000, CRC(9c38669e) SHA1(f80c7ba42c1e1b0581d3aa427388689e80c2a054) )
	ROM_LOAD16_BYTE( "95420544.lo", 0x00001, 0x080000, CRC(d1ad5cae) SHA1(5215d303068d9b221d0b65fca33d8b87dcb2ef6d) )
	ROM_LOAD16_BYTE( "95421440.lo", 0x00001, 0x080000, CRC(f3a57e0d) SHA1(a04ec2967029e8cef6621add046ceff63ab85896) )
	ROM_LOAD16_BYTE( "95421441.hi", 0x00000, 0x080000, CRC(794bacd7) SHA1(d292b87abd417c94f9643a50c9b2c2dd12bcfda1) )
	ROM_LOAD16_BYTE( "95421542.lo", 0x00001, 0x080000, CRC(c0e2e259) SHA1(1bf56cd771dcc62922e86adf9ad83301d731666b) )
	ROM_LOAD16_BYTE( "95421544.lo", 0x00001, 0x080000, CRC(05cec61a) SHA1(6ab25749d7d893ff03a96d64a2fb556706b6c89a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008519.bin", 0x0000, 0x0fe4d6, CRC(e16efe22) SHA1(144e93e01967f343607ee8cee6add3d8ac8f5f28) )
ROM_END



ROM_START( sc_mspid )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406748.lo", 0x00001, 0x080000, CRC(6c058276) SHA1(ffbb2a1e304a127fa4549f9ea9e59bfae2c5e094) )
	ROM_LOAD16_BYTE( "95406749.hi", 0x00000, 0x080000, CRC(f2bfbb44) SHA1(3c5edc37ebf81fcff8fce1c6bc0ad1f7e067c46b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406750.lo", 0x00001, 0x080000, CRC(83872be6) SHA1(6154db41a864e0e07b07a912db102f971118bd55) )
	ROM_LOAD16_BYTE( "95406751.hi", 0x00000, 0x080000, CRC(0db3369f) SHA1(69b1d8fe06d7629addf6c8ce0da9543795deea0b) )
	ROM_LOAD16_BYTE( "95406878.lo", 0x00001, 0x080000, CRC(74b21587) SHA1(e43577582ad3437574b74fd3be532f6394c5dfd6) )
	ROM_LOAD16_BYTE( "95406879.hi", 0x00000, 0x080000, CRC(4b536557) SHA1(9e610a433ea86480566ddfe61cfff539fee37da3) )
	ROM_LOAD16_BYTE( "95406880.lo", 0x00001, 0x080000, CRC(dc591daa) SHA1(e886ced9a0a8e4e85b49c28497ffa51b09540a51) )
	ROM_LOAD16_BYTE( "95406881.hi", 0x00000, 0x080000, CRC(8c2a3da5) SHA1(9baa87cd559834547b8742f0af8f721d49388825) )
	ROM_LOAD16_BYTE( "95407748.lo", 0x00001, 0x080000, CRC(28f00d53) SHA1(e2e06f70cf4cb689ceba0dae336f249fd181b1b8) )
	ROM_LOAD16_BYTE( "95407749.hi", 0x00000, 0x080000, CRC(a90161cd) SHA1(e368abd3cf5dfc73bdf064054ca51b1c91ac3a1d) )
	ROM_LOAD16_BYTE( "95407750.lo", 0x00001, 0x080000, CRC(6ff48c21) SHA1(1d075660c011718b287d3480f18a6c90d6f63cd8) )
	ROM_LOAD16_BYTE( "95407751.hi", 0x00000, 0x080000, CRC(dcbf02d3) SHA1(366234b594566440736e46a04928928d5af398f9) )
	ROM_LOAD16_BYTE( "95407878.lo", 0x00001, 0x080000, CRC(c82a2b79) SHA1(bd92b6da3c5775e0b4227047d32d42ce263119a9) )
	ROM_LOAD16_BYTE( "95407879.hi", 0x00000, 0x080000, CRC(781c5db8) SHA1(19369ebb7d2e30a56ce604634f3ac793020d6f71) )
	ROM_LOAD16_BYTE( "95407880.lo", 0x00001, 0x080000, CRC(3a123bca) SHA1(40fc796068b7ca8ab0785a22551b6482bd7c14c1) )
	ROM_LOAD16_BYTE( "95407881.hi", 0x00000, 0x080000, CRC(906b8303) SHA1(56a6a5be5f2e5e3fc883ed01e33859121ea10eda) )
	ROM_LOAD16_BYTE( "95412216.lo", 0x00001, 0x080000, CRC(a356b7d9) SHA1(e9926885ffd144c8ac76653f42409dd1e15d2c3b) )
	ROM_LOAD16_BYTE( "95412217.hi", 0x00000, 0x080000, CRC(e309001c) SHA1(44ac7d6a510f926b8b23f46619712b77d48ac308) )
	ROM_LOAD16_BYTE( "95413216.lo", 0x00001, 0x080000, CRC(c01ebf68) SHA1(d0a719436e713272d580fd2feb73dfc33b764a55) )
	ROM_LOAD16_BYTE( "95413217.hi", 0x00000, 0x080000, CRC(96bc4dee) SHA1(1c51cd7ddeef79af384cb0f86dc43bce7315fa27) )
	ROM_LOAD16_BYTE( "p1325p61.hi", 0x00000, 0x080000, CRC(6208c47a) SHA1(7748316b68aa9c3716fc3cf7b220b8b505e55e90) )
	ROM_LOAD16_BYTE( "p1325p61.lo", 0x00001, 0x080000, CRC(ab3bfc9e) SHA1(219e0f666f09552f392619a671c46d20d121355f) )
	ROM_LOAD16_BYTE( "p1325p71.hi", 0x00000, 0x080000, CRC(ea9bfc91) SHA1(aca22c2136df717be6a4fb656fb0a88cced91216) )
	ROM_LOAD16_BYTE( "p1325p71.lo", 0x00001, 0x080000, CRC(cebb2b61) SHA1(0b2df3671e8fbc7733e7de100aab3edc5ed82bb8) )
	ROM_LOAD16_BYTE( "p1325s61.hi", 0x00000, 0x080000, CRC(8c5b91e2) SHA1(6706296c25fab574139b51b824bf6e8453cd95aa) )
	ROM_LOAD16_BYTE( "p1325s61.lo", 0x00001, 0x080000, CRC(09388780) SHA1(7045d6f31bc6a7fe7b23903faef417116ee7a90a) )
	ROM_LOAD16_BYTE( "p1325s71.hi", 0x00000, 0x080000, CRC(04c8a909) SHA1(84cbe5e7294f181a845b0aa0f487b8080710df60) )
	ROM_LOAD16_BYTE( "p1325s71.lo", 0x00001, 0x080000, CRC(6cb8507f) SHA1(cdabdd98a658b12b88e2d71d7582ac51c798f301) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008278.bin", 0x0000, 0x100000, CRC(8fc20733) SHA1(6ede5578fa11cb3322291958d6e1ef8f6cd99da0) )
ROM_END




ROM_START( sc_monsp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406476.lo", 0x00001, 0x080000, CRC(c1ffdeb4) SHA1(e600dc090edc996cd5bde0bf24b3c1fa0e4a19aa) )
	ROM_LOAD16_BYTE( "95406477.hi", 0x00000, 0x080000, CRC(3a932d01) SHA1(e1488f522680bda99b4b46a61acc8e3c1ad68f6f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95424496.lo", 0x00001, 0x080000, CRC(707f0a4d) SHA1(49bf6cae5e614b0976ae01577c31ef362c4820b6) )
	ROM_LOAD16_BYTE( "95424497.hi", 0x00000, 0x080000, CRC(8e00f6bb) SHA1(fea7d48bfe1c40efd54b1fe851930b3bf2bd1cf2) )
	ROM_LOAD16_BYTE( "95425496.lo", 0x00001, 0x080000, CRC(3f968c3c) SHA1(9ee5665bbd73e76dd887b2e3982bb57c74b98a42) )
	ROM_LOAD16_BYTE( "95425497.hi", 0x00000, 0x080000, CRC(a44aaa2e) SHA1(ea03a114ad222093556ed44fbad14c67a4cc4aaf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004291.snd", 0x0000, 0x080000, CRC(0ea304f7) SHA1(3d524e108cd12e83956fec3997316a92a9e0898d) )
	ROM_LOAD( "95008183.bin", 0x0000, 0x080000, CRC(ab29f841) SHA1(908603184c3f7ead278dabd224d60e5362cdafbe) )
	ROM_LOAD( "95008184.bin", 0x0000, 0x080000, CRC(45ef95ea) SHA1(1e1126b542621e723eaf6e38918162fe701247e0) )
ROM_END




ROM_START( sc_msclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404560.lo", 0x00001, 0x080000, CRC(f592f85b) SHA1(74b93613c529c1a1c7d073099485d306d716b6da) )
	ROM_LOAD16_BYTE( "95404561.hi", 0x00000, 0x080000, CRC(0e2737a7) SHA1(8c8b8862cd557ed1633e50908e868c2fac620a6d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404562.lo", 0x00001, 0x080000, CRC(ec68d4e7) SHA1(de18a505066909e0e9ea3e130a1fc4c58499e101) )
	ROM_LOAD16_BYTE( "95404563.hi", 0x00000, 0x080000, CRC(38e618ea) SHA1(7a98588bb3ccbf16484a4a2dc1c7dfebb9d2398a) )
	ROM_LOAD16_BYTE( "95404694.lo", 0x00001, 0x080000, CRC(dc31e3e8) SHA1(8c8810395079c75535cb9ae7055d079092a78848) )
	ROM_LOAD16_BYTE( "95404695.hi", 0x00000, 0x080000, CRC(533e6c92) SHA1(a732cdeefb8892eee1acd673d758140829c82549) )
	ROM_LOAD16_BYTE( "95405560.lo", 0x00001, 0x080000, CRC(5fb17d06) SHA1(fd090f0d8353482379148c42c57d87204962b11e) )
	ROM_LOAD16_BYTE( "95405561.hi", 0x00000, 0x080000, CRC(3e95fa7b) SHA1(45f04deaecd11ca747bb78b983da2e7e63536b1b) )
	ROM_LOAD16_BYTE( "95405562.lo", 0x00001, 0x080000, CRC(287268ca) SHA1(e20e45598ffb08ba637b6230599e289a6274c22a) )
	ROM_LOAD16_BYTE( "95405563.hi", 0x00000, 0x080000, CRC(2290d788) SHA1(3e4f862dd03e1fd17e72a7c46e4879581f9137f7) )
	ROM_LOAD16_BYTE( "95405694.lo", 0x00001, 0x080000, CRC(fc7109a3) SHA1(a8a2afd761884dd23a52a575803238eca7b209df) )
	ROM_LOAD16_BYTE( "95405695.hi", 0x00000, 0x080000, CRC(cb684ff5) SHA1(925f9b87c535c6a057bbfd99f7afc252b0b86f52) )
	ROM_LOAD16_BYTE( "95406582.lo", 0x00001, 0x080000, CRC(30df16ef) SHA1(9efbaa66fa555b6031b3c1333f6ae424a2eb7a86) )
	ROM_LOAD16_BYTE( "95406583.hi", 0x00000, 0x080000, CRC(ac0ebd13) SHA1(aabca87b9fa5101cf1ffbbd7eb876c36dcd64a9c) )
	ROM_LOAD16_BYTE( "95407582.lo", 0x00001, 0x080000, CRC(4ed1ba89) SHA1(888af17d5ed0639bae85c6b556e9d34246ffbfb9) )
	ROM_LOAD16_BYTE( "95407583.hi", 0x00000, 0x080000, CRC(94217174) SHA1(2d61ec0c48aa1ba5eceddd22f92a0399e430f406) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008191.bin", 0x0000, 0x100000, CRC(4d392e0c) SHA1(798ba07fdb0bebe5367f58b1e13226827153e0e8) )
ROM_END




ROM_START( sc_mtb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400129.lo", 0x00001, 0x080000, CRC(62b2b663) SHA1(afc783cb7cfef9647d0c23a6f3fb0740e551bee8) )
	ROM_LOAD16_BYTE( "95400130.hi", 0x00000, 0x080000, CRC(beef2251) SHA1(e8804cde6fb887674179cd5c97f50f6d098ec31e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400245.lo", 0x00001, 0x080000, CRC(4cae99b6) SHA1(193cba2cda19325e0badd1646d96f737880117fb) )
	ROM_LOAD16_BYTE( "95400246.hi", 0x00000, 0x080000, CRC(cfb8885d) SHA1(678e68e0e05d5e7727ec89406e99d431ca700e78) )
	ROM_LOAD16_BYTE( "95400317.lo", 0x00001, 0x080000, CRC(8a0cb5e6) SHA1(09c79d72a58ce479ff37dfdb6ea496a061aec475) )
	ROM_LOAD16_BYTE( "95400318.hi", 0x00000, 0x080000, CRC(193d7b0b) SHA1(3ac2c3496b65b3be2867440e81a37c95a0fca79c) )
	ROM_LOAD16_BYTE( "95400939.lo", 0x00001, 0x080000, CRC(258ad3b3) SHA1(116a9287e3c31ac2ec43752b3c42578bf1c4446b) )
	ROM_LOAD16_BYTE( "95400940.hi", 0x00000, 0x080000, CRC(0ffa3f82) SHA1(01815f6216494cfb3aaee37cdaec63355ec6f329) )
	ROM_LOAD16_BYTE( "95400941.lo", 0x00001, 0x080000, CRC(7ae8e888) SHA1(ee56614a69687b653338487b9aac1a60a00aff48) )
	ROM_LOAD16_BYTE( "95400942.hi", 0x00000, 0x080000, CRC(72d9adc2) SHA1(5e5b10be4a081471b55b82a25a3a6660e3a2880e) )
	ROM_LOAD16_BYTE( "95401129.lo", 0x00001, 0x080000, CRC(5b8f1193) SHA1(58ada999ac499093db2f123006c89c5993e99567) )
	ROM_LOAD16_BYTE( "95401130.hi", 0x00000, 0x080000, CRC(1b0403ea) SHA1(93319e4a900fccdc0f93a6583d8676a7ab188664) )
	ROM_LOAD16_BYTE( "95401245.lo", 0x00001, 0x080000, CRC(f656ba7c) SHA1(9a47388c13420f917e0790efcfb2b3a939a27c53) )
	ROM_LOAD16_BYTE( "95401246.hi", 0x00000, 0x080000, CRC(c3bd439c) SHA1(f64d51f8c23688f11ffdad64cb697433252c87c3) )
	ROM_LOAD16_BYTE( "95401317.lo", 0x00001, 0x080000, CRC(825724b7) SHA1(a467956f63e72f88e13ba95a7af74e6b222d016f) )
	ROM_LOAD16_BYTE( "95401318.hi", 0x00000, 0x080000, CRC(2e0c4767) SHA1(95e272235efc2a96ab7a337e91727e240222c4d4) )
	ROM_LOAD16_BYTE( "95401939.lo", 0x00001, 0x080000, CRC(ff226fb7) SHA1(63410d9f141106af7c1ad11a0ebbe1be026fad6e) )
	ROM_LOAD16_BYTE( "95401940.hi", 0x00000, 0x080000, CRC(9dbf746d) SHA1(1b1c9f3a96401d6c204be7cbe37278f7d792d46e) )
	ROM_LOAD16_BYTE( "mtb15hi", 0x0000, 0x080000, CRC(24651e35) SHA1(33c03b791bbb123e53bf3789cfadae425a02eaa4) )
	ROM_LOAD16_BYTE( "mtb15lo", 0x00001, 0x080000, CRC(5aa9718a) SHA1(98b2fe64114b33fa30e3276b9da5959b43abb626) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "mtb_snd1.bin", 0x0000, 0x080000, CRC(4abca575) SHA1(8f0e3fd169cbf0876368dac335bf81ab0601c923) )
	ROM_LOAD( "mtb_snd2.bin", 0x0000, 0x080000, CRC(034a49dc) SHA1(aac70d867856f13f5948e81ed3ca7f2746edf134) )
ROM_END




ROM_START( sc_mtbcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400897.lo", 0x00001, 0x080000, CRC(3a39861b) SHA1(e9e8b85e7bb1611c2231d60b869bcc2b6d866c2a) )
	ROM_LOAD16_BYTE( "95400898.hi", 0x00000, 0x080000, CRC(8b17b182) SHA1(6c0cc15b8073363eeab12f6d886bebd0c110378b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400949.lo", 0x00001, 0x080000, CRC(7e55715c) SHA1(190b6d67960daaee5e04f656de794a558b61f76d) )
	ROM_LOAD16_BYTE( "95400950.hi", 0x00000, 0x080000, CRC(ceeaf667) SHA1(d5bf6f7461aaa8267f57cc490680a1609f377a55) )
	ROM_LOAD16_BYTE( "95400971.lo", 0x00001, 0x080000, CRC(d73de9fe) SHA1(2d4785d93ab5d6fdfb813ab4589e3a99584447de) )
	ROM_LOAD16_BYTE( "95400972.hi", 0x00000, 0x080000, CRC(190734b4) SHA1(8afb11c904f9cd6d9fff9ed8837d0ff6b569ebff) )
	ROM_LOAD16_BYTE( "95400979.lo", 0x00001, 0x080000, CRC(1ae05217) SHA1(84b1fdc2ba7fa3978bbba0558017d7c193fd2263) )
	ROM_LOAD16_BYTE( "95400980.hi", 0x00000, 0x080000, CRC(e195e22b) SHA1(28104aec1f4c7525c01c379c63de91fc458627db) )
	ROM_LOAD16_BYTE( "95401897.lo", 0x00001, 0x080000, CRC(e642920b) SHA1(c24995e6a08114d2e1cb594654623916aa0f8983) )
	ROM_LOAD16_BYTE( "95401898.hi", 0x00000, 0x080000, CRC(8b88e7ba) SHA1(469d94858edeab75393c3fef2a7cd74022cc47b7) )
	ROM_LOAD16_BYTE( "95401949.lo", 0x00001, 0x080000, CRC(13b00b79) SHA1(22c2822c26e8979e2a38de95ee294a0173afd66b) )
	ROM_LOAD16_BYTE( "95401950.hi", 0x00000, 0x080000, CRC(bb5fbb95) SHA1(245a032654d937b7aca29e05e8c0eb973706eb5f) )
	ROM_LOAD16_BYTE( "95401971.lo", 0x00001, 0x080000, CRC(90b70d6c) SHA1(40c9e16010584d1183286f8d8c497e0569ca8cb4) )
	ROM_LOAD16_BYTE( "95401972.hi", 0x00000, 0x080000, CRC(6ff18dd6) SHA1(9aaf3b15f95603ae1b6f8a4459dfb3e200e866af) )
	ROM_LOAD16_BYTE( "95401979.lo", 0x00001, 0x080000, CRC(0f8a8828) SHA1(b3a7479549a76784d67c528f9d2bd8f2b0f4cccb) )
	ROM_LOAD16_BYTE( "95401980.hi", 0x00000, 0x080000, CRC(1266833c) SHA1(7d6a18bac50b81a9f2b727005887141bdef46e29) )
	ROM_LOAD16_BYTE( "club-money-to-burn_dat_ac_1000pnd-50p(1)ss.hi", 0x00000, 0x080000, CRC(6baafc2d) SHA1(fb775e0d431a2c31b3f6c565cddaad5d22d9d122) )
	ROM_LOAD16_BYTE( "club-money-to-burn_dat_ac_1000pnd-50p(1)ss.lo", 0x00001, 0x080000, CRC(179f0787) SHA1(6815167bee95e88cf628128a88065a66983a7489) )
	ROM_LOAD16_BYTE( "club-money-to-burn_dat_ac_1000pnd-50p(2)ss.hi", 0x00000, 0x080000, CRC(3539277b) SHA1(2a602de4a3b3d6336e4f0be15b9bd3d9e730c571) )
	ROM_LOAD16_BYTE( "club-money-to-burn_dat_ac_1000pnd-50p(2)ss.lo", 0x00001, 0x080000, CRC(9cc4bf96) SHA1(db0cd119346b5ffce1bdf19e595f085bef93747d) )
	ROM_LOAD16_BYTE( "club-money-to-burn_dat_ac_1000pnd-50p(3)ss.hi", 0x00000, 0x080000, CRC(82d9d864) SHA1(02f6fe87364d5afece5a7289ac74bd66345b53ea) )
	ROM_LOAD16_BYTE( "club-money-to-burn_dat_ac_1000pnd-50p(3)ss.lo", 0x00001, 0x080000, CRC(902c1902) SHA1(15e00073cb818af46a37357304d2a8ef7f256f09) )
	ROM_LOAD16_BYTE( "club-money-to-burn_dat_ac_1000pnd-50p(4)ss.hi", 0x00000, 0x080000, CRC(75a15cea) SHA1(d34e20273c1ed7b7a11100a68462775930f7c39f) )
	ROM_LOAD16_BYTE( "club-money-to-burn_dat_ac_1000pnd-50p(4)ss.lo", 0x00001, 0x080000, CRC(0f5d2f5b) SHA1(725c1cf317cac74a6f0e0185a46ff0c7c399432d) )
	ROM_LOAD16_BYTE( "club-money-to-burn_std_ac_1000pnd-50p(1)ss.hi", 0x00000, 0x080000, CRC(d596e8bc) SHA1(7fbf3bac2c96034714ce3b83077f737c5bd93afc) )
	ROM_LOAD16_BYTE( "club-money-to-burn_std_ac_1000pnd-50p(1)ss.lo", 0x00001, 0x080000, CRC(a4ea7d69) SHA1(ae949626d8784570145bc2e51b6389454ead73f8) )
	ROM_LOAD16_BYTE( "club-money-to-burn_std_ac_1000pnd-50p(2)ss.hi", 0x00000, 0x080000, CRC(decceaa7) SHA1(1e13bf0eb30280932028f0b52cbf45e461f5ab5e) )
	ROM_LOAD16_BYTE( "club-money-to-burn_std_ac_1000pnd-50p(2)ss.lo", 0x00001, 0x080000, CRC(b57323fd) SHA1(b9a43b16ff347cf3d87a064468c0f507c87ef819) )
	ROM_LOAD16_BYTE( "club-money-to-burn_std_ac_1000pnd-50p(3)ss.hi", 0x00000, 0x080000, CRC(64882431) SHA1(21184508e6e2878fa5d8b300ad5f9ef7ab75c223) )
	ROM_LOAD16_BYTE( "club-money-to-burn_std_ac_1000pnd-50p(3)ss.lo", 0x00001, 0x080000, CRC(8ab940ad) SHA1(a4170464e3d08f0a925ab6d302f0d0a7ab03ed94) )
	ROM_LOAD16_BYTE( "club-money-to-burn_std_ac_1000pnd-50p(4)ss.hi", 0x00000, 0x080000, CRC(df931438) SHA1(3fd98e4a3f79b84576c33481296a878dca56afce) )
	ROM_LOAD16_BYTE( "club-money-to-burn_std_ac_1000pnd-50p(4)ss.lo", 0x00001, 0x080000, CRC(dadd9222) SHA1(679a87c43b42662e99ad4307b49b5f3a12e8b28d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008009.lo", 0x00001, 0x100000, CRC(b9334137) SHA1(e7481688e18b56bddee4a2eff219f83ac5180082) )
	ROM_LOAD( "95008010.hi", 0x00000, 0x100000, CRC(cb197b7e) SHA1(56fb416a98bc2875df11024518babf4a07418a79) )
ROM_END




ROM_START( sc_m2m )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400661.lo", 0x00001, 0x080000, CRC(6775b569) SHA1(59f65a1ef40185bfe85544a6f9a7236bdfcb4955) )
	ROM_LOAD16_BYTE( "95400662.hi", 0x00000, 0x080000, CRC(fbd04554) SHA1(03a5ed0d1caecfe477c02dbe48fd18ac3114dadd) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95401661.lo", 0x00001, 0x080000, CRC(37f46275) SHA1(cbcfc7d903cb5bc58ed3b98552fec1adba35c130) )
	ROM_LOAD16_BYTE( "95401662.hi", 0x00000, 0x080000, CRC(262a1894) SHA1(7efd6a6f621c253238c323920799ed7de9bda908) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_monob )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408402.lo", 0x00001, 0x080000, CRC(c1da598d) SHA1(1d27d6bfc253d632154ffe9c7946ad5d8d9213e6) )
	ROM_LOAD16_BYTE( "95408403.hi", 0x00000, 0x080000, CRC(0d8342eb) SHA1(67887e7481b530316ea691658dd173b88ce7cfd8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408418.lo", 0x00001, 0x080000, CRC(25ea7673) SHA1(14ff3d2a48d66f8d68160d4b3272ae0f13038112) )
	ROM_LOAD16_BYTE( "95408419.hi", 0x00000, 0x080000, CRC(cb7061d5) SHA1(a9460217b961cf557ca0065cd5d52f912c3439a5) )
	ROM_LOAD16_BYTE( "95408984.lo", 0x00001, 0x080000, CRC(e16bb9bf) SHA1(f3b9fa43bcc10ae632879aa5cae354826410796b) )
	ROM_LOAD16_BYTE( "95408985.hi", 0x00000, 0x080000, CRC(726da105) SHA1(c1f3788408bcf279b94e24df445575de15fc2eda) )
	ROM_LOAD16_BYTE( "95408986.lo", 0x00001, 0x080000, CRC(6be0db3e) SHA1(2771294694e61219e23fc0d5bed3a5d9de500245) )
	ROM_LOAD16_BYTE( "95408987.hi", 0x00000, 0x080000, CRC(66e68347) SHA1(e1fb1b92ac80023dc03467a7a6a0b76edccdbb8c) )
	ROM_LOAD16_BYTE( "95408988.lo", 0x00001, 0x080000, CRC(463d4019) SHA1(8f4a7918bfb57b29ec0ef7cba581de679a644b12) )
	ROM_LOAD16_BYTE( "95408989.hi", 0x00000, 0x080000, CRC(96746590) SHA1(5adac78a0abd49daec5f45f0dd67336a748cba2a) )
	ROM_LOAD16_BYTE( "95409402.lo", 0x00001, 0x080000, CRC(c0e526b3) SHA1(9abcc41a19ae04a9955a69a601208170607418d4) )
	ROM_LOAD16_BYTE( "95409403.hi", 0x00000, 0x080000, CRC(5112c591) SHA1(cdb7e621440eeb941807cb074fc9b61e8a747fcb) )
	ROM_LOAD16_BYTE( "95409418.lo", 0x00001, 0x080000, CRC(1d7b2ed6) SHA1(f2a8793c00ca18dfe9762f12cfdf24e1d212f4f2) )
	ROM_LOAD16_BYTE( "95409419.hi", 0x00000, 0x080000, CRC(4724a186) SHA1(8292d704770eba4da5b838ee32ebef7aff064901) )
	ROM_LOAD16_BYTE( "95409984.lo", 0x00001, 0x080000, CRC(7cf821df) SHA1(b911265f797c0246e4dd2ea4d876a5ace25913c2) )
	ROM_LOAD16_BYTE( "95409985.hi", 0x00000, 0x080000, CRC(99ac44d3) SHA1(8cf10839b536a190230cce7eb6bc45bc770fdf08) )
	ROM_LOAD16_BYTE( "95409986.lo", 0x00001, 0x080000, CRC(53783f19) SHA1(027b475755d71fa2f0010a80fb7e1669a6e8bef1) )
	ROM_LOAD16_BYTE( "95409987.hi", 0x00000, 0x080000, CRC(e0e3d8e5) SHA1(16438e7a7198bc0a85c1fa776f1da752fabbee96) )
	ROM_LOAD16_BYTE( "95409988.lo", 0x00001, 0x080000, CRC(4a8ee93a) SHA1(41bcc485bbfe2b708666120b8ae0eea5200c2f5c) )
	ROM_LOAD16_BYTE( "95409989.hi", 0x00000, 0x080000, CRC(5f8472bf) SHA1(d91602ceb62b57129ad979cda0f56f652da1e650) )
	ROM_LOAD16_BYTE( "95410490.lo", 0x00001, 0x080000, CRC(d20f7858) SHA1(7342489ab73bada6cd8ecc28d6229016a882a20a) )
	ROM_LOAD16_BYTE( "95410491.hi", 0x00000, 0x080000, CRC(99334dc1) SHA1(923b2019430c4a1a92dfbd8a5c63565d8b15d19c) )
	ROM_LOAD16_BYTE( "95410492.lo", 0x00001, 0x080000, CRC(fb5f8442) SHA1(428da1f86dd25f6bb8dfa717a9c81e5dbd6ee6c9) )
	ROM_LOAD16_BYTE( "95410493.hi", 0x00000, 0x080000, CRC(6ce25c4e) SHA1(ef51417b20e19bbeb412db9521ff97806d09439a) )
	ROM_LOAD16_BYTE( "95411490.lo", 0x00001, 0x080000, CRC(4e3abd7d) SHA1(a20e7196999977ae5c94b53f37666c08e645b61d) )
	ROM_LOAD16_BYTE( "95411491.hi", 0x00000, 0x080000, CRC(ee640eeb) SHA1(ef62e86d3f0dd73e666752f951dd51d1348d03d9) )
	ROM_LOAD16_BYTE( "95411492.lo", 0x00001, 0x080000, CRC(1a742a79) SHA1(d30aa680edddb4e5cabf5db054aa2a3b3c5b7b90) )
	ROM_LOAD16_BYTE( "95411493.hi", 0x00000, 0x080000, CRC(23c21c59) SHA1(84c71bff621fac7ce6440e7d24e6e8be8682556c) )
	ROM_LOAD16_BYTE( "monopoly_95408986_std_low.bin", 0x0000, 0x080000, CRC(6be0db3e) SHA1(2771294694e61219e23fc0d5bed3a5d9de500245) )
	ROM_LOAD16_BYTE( "monopoly_95408987_std_high.bin", 0x0000, 0x080000, CRC(66e68347) SHA1(e1fb1b92ac80023dc03467a7a6a0b76edccdbb8c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008359.bin", 0x0000, 0x0e89fa, CRC(763e4367) SHA1(c44b70f8336c2d6c00cd0dde9b6ca014667c59a6) )
	ROM_LOAD( "monopoly95008359_sound1.bin", 0x0000, 0x100000, CRC(93f005f2) SHA1(d2351982d6352d9793efac617ac9fb9569f229c6) )
ROM_END




ROM_START( sc_monod )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406090.lo", 0x00001, 0x080000, CRC(cdbb460a) SHA1(cb971677888b3f9c54a784f3a69f93a9a94a488d) )
	ROM_LOAD16_BYTE( "95406091.hi", 0x00000, 0x080000, CRC(8aac1d84) SHA1(fbb7f6467a79f6a55c488621fe6efe981584c5a4) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408334.lo", 0x00001, 0x080000, CRC(a27c87d6) SHA1(4f5b56cd925f6d1fbcd58697dd17370d14e61d53) )
	ROM_LOAD16_BYTE( "95408335.hi", 0x00000, 0x080000, CRC(48564e37) SHA1(1658603b38ec1e94968c036f061f649cb90c1522) )
	ROM_LOAD16_BYTE( "95408512.lo", 0x00001, 0x080000, CRC(86a22467) SHA1(3bcb64029b95fc34d014067281e139830fa165ef) )
	ROM_LOAD16_BYTE( "95408513.hi", 0x00000, 0x080000, CRC(c86ea35a) SHA1(d2265d556c884919d1fe400e34595aea96ef4f70) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_monop )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408978.lo", 0x00001, 0x080000, CRC(b27e529e) SHA1(f73fcd70f48789914958890972a85ee1f1e7cb58) )
	ROM_LOAD16_BYTE( "95408979.hi", 0x00000, 0x080000, CRC(04da3c33) SHA1(9f9d1b5410813b54d671f2f0272f93e0edefa769) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410474.lo", 0x00001, 0x080000, CRC(5612849e) SHA1(154aa5e60e09a70d3b8e22df959d9593ffd5c25c) )
	ROM_LOAD16_BYTE( "95410475.hi", 0x00000, 0x080000, CRC(e28212d1) SHA1(e3b0fe66f675ed3b7ebdab244e2e269842bed143) )
	ROM_LOAD16_BYTE( "95412170.lo", 0x00001, 0x080000, CRC(7907cfb1) SHA1(1a2df03640b8ac67d17410a472dab7392873b044) )
	ROM_LOAD16_BYTE( "95412171.hi", 0x00000, 0x080000, CRC(4b7999be) SHA1(0f5431ebd037a44269aba212190ea4e6f10bb621) )
	ROM_LOAD16_BYTE( "95413170.lo", 0x00001, 0x080000, CRC(e99a0858) SHA1(013c8455cf09f341bb43e048edfd0a9755c3ae37) )
	ROM_LOAD16_BYTE( "95413171.hi", 0x00000, 0x080000, CRC(071a2d39) SHA1(60500127a6b3666bc1b220ed73090476820a3584) )
	ROM_LOAD16_BYTE( "95414454.lo", 0x00001, 0x080000, CRC(9faebd13) SHA1(d9253d30803836cc8e8eff6587878659a9e71267) )
	ROM_LOAD16_BYTE( "95414455.hi", 0x00000, 0x080000, CRC(1b17644b) SHA1(ac53525daf0780345ea87749a5f8e8e9dc5b61c8) )
	ROM_LOAD16_BYTE( "95414460.lo", 0x00001, 0x080000, CRC(24a640d4) SHA1(030a5b1349f35bd2c1fff3135d2a9562999b61fc) )
	ROM_LOAD16_BYTE( "95414461.hi", 0x00000, 0x080000, CRC(ca2658cf) SHA1(f78eaa3fb69392b5c673e4801e177a424a8f90d5) )
	ROM_LOAD16_BYTE( "95414462.lo", 0x00001, 0x080000, CRC(a7a0c83e) SHA1(a24ab4d8667c6fab2bc1893e0a3b50bedac43b5c) )
	ROM_LOAD16_BYTE( "95414463.hi", 0x00000, 0x080000, CRC(6410d507) SHA1(9b6aeb4683456bd82269a717124c49162cb24878) )
	ROM_LOAD16_BYTE( "95414480.lo", 0x00001, 0x080000, CRC(9d678b10) SHA1(26a2aad2f7bced36e8ad85c3fbe781df7d698c09) )
	ROM_LOAD16_BYTE( "95414481.hi", 0x00000, 0x080000, CRC(e0f15310) SHA1(6ee52b756f3a69c96cec5d7363abb5e77227004f) )
	ROM_LOAD16_BYTE( "95414492.lo", 0x00001, 0x080000, CRC(8164956c) SHA1(25e79399fd2e23ebbde581896c32285b4fbb06f2) )
	ROM_LOAD16_BYTE( "95414493.hi", 0x00000, 0x080000, CRC(3bf28321) SHA1(efddbb5ebcf15d74361d039334d21d52cc5fbe9a) )
	ROM_LOAD16_BYTE( "95414494.lo", 0x00001, 0x080000, CRC(2b2bab9c) SHA1(8b1b4bb62e2f7d47d4b598815731b969f3ab1ba5) )
	ROM_LOAD16_BYTE( "95414495.hi", 0x00000, 0x080000, CRC(ba683acd) SHA1(15b33c74abd86d26f7b03b121e766e240a23ec1e) )
	ROM_LOAD16_BYTE( "95414784.lo", 0x00001, 0x080000, CRC(95591c90) SHA1(24dfc4dd1d3b6d05d9a123bcd7441c78f10866a5) )
	ROM_LOAD16_BYTE( "95414785.hi", 0x00000, 0x080000, CRC(09bbf43c) SHA1(78e94f61333ccf7603fd083832cee7114584f593) )
	ROM_LOAD16_BYTE( "95414790.lo", 0x00001, 0x080000, CRC(a7121df8) SHA1(638902dea8950c5668911b3c88a7bcf0af8acf54) )
	ROM_LOAD16_BYTE( "95414791.hi", 0x00000, 0x080000, CRC(04036214) SHA1(b1ee059c44f285e10b56ef5643d8fc68bb1e4502) )
	ROM_LOAD16_BYTE( "95414944.lo", 0x00001, 0x080000, CRC(cae778fc) SHA1(b1424f98457d1d5b7011b72cc5dfb3d1f7128ad0) )
	ROM_LOAD16_BYTE( "95414945.hi", 0x00000, 0x080000, CRC(eb440e83) SHA1(8e57cf0d88611fd6d63422cc345c603fe4bd8f95) )
	ROM_LOAD16_BYTE( "95414946.lo", 0x00001, 0x080000, CRC(f01aedbc) SHA1(a8c7bb88faf502611875cd632aef0829dc56b469) )
	ROM_LOAD16_BYTE( "95414947.hi", 0x00000, 0x080000, CRC(b9186430) SHA1(b8d71dce43ee9fc4e8634af0d2d5d35bf290ba91) )
	ROM_LOAD16_BYTE( "95414948.lo", 0x00001, 0x080000, CRC(6f7cfe6e) SHA1(d4953815dfd058714715470bba4264c08dbfeaba) )
	ROM_LOAD16_BYTE( "95414949.hi", 0x00000, 0x080000, CRC(cecf1348) SHA1(79adbfd95ecda81cb4dccab05f162133a916ca89) )
	ROM_LOAD16_BYTE( "95415454.lo", 0x00001, 0x080000, CRC(895b8d82) SHA1(017baf2971576638d4b8f976f99e6097abe193e4) )
	ROM_LOAD16_BYTE( "95415455.hi", 0x00000, 0x080000, CRC(37f16d0d) SHA1(76430ae7e79d9312cbea4b49e0b707f46b48a56a) )
	ROM_LOAD16_BYTE( "95415456.lo", 0x00001, 0x080000, CRC(3031b8db) SHA1(7aaa9b9a585f0407177d4959992000d2d77d4d69) )
	ROM_LOAD16_BYTE( "95415457.hi", 0x00000, 0x080000, CRC(990f11aa) SHA1(549ae1cebaf6069300dc9048cae448235d69587b) )
	ROM_LOAD16_BYTE( "95415458.lo", 0x00001, 0x080000, CRC(81091dce) SHA1(64d5352d2c5bccba496834dc2fe61e3fe9c3e49f) )
	ROM_LOAD16_BYTE( "95415459.hi", 0x00000, 0x080000, CRC(a9a46e04) SHA1(82a019172bf2a6d440528e19c7c09e7b1c9d4980) )
	ROM_LOAD16_BYTE( "95415460.lo", 0x00001, 0x080000, CRC(05fd1a11) SHA1(69eeb4430453ce192f8f3869096e59c7335ea598) )
	ROM_LOAD16_BYTE( "95415461.hi", 0x00000, 0x080000, CRC(41c97eea) SHA1(246f7ad3f0a73e407b2ca6818bd02b1832f75344) )
	ROM_LOAD16_BYTE( "95415462.lo", 0x00001, 0x080000, CRC(82fab458) SHA1(22b78f17eec971cc4ccd5cf61387983f53c88f2e) )
	ROM_LOAD16_BYTE( "95415463.hi", 0x00000, 0x080000, CRC(ade4d484) SHA1(ae6e942780c951370b9ed19d209d533dc20e9f59) )
	ROM_LOAD16_BYTE( "95415464.lo", 0x00001, 0x080000, CRC(33346ded) SHA1(2cca98cc51bdf2f3ebffdab9983c48d6689e0562) )
	ROM_LOAD16_BYTE( "95415465.hi", 0x00000, 0x080000, CRC(7f27c676) SHA1(ee5972174f307b11cc4c18fa3b2dd3b0543e8401) )
	ROM_LOAD16_BYTE( "95415466.lo", 0x00001, 0x080000, CRC(560cc6d3) SHA1(d3df1cd502dc9e2513d89389e8d13f6b1967c99c) )
	ROM_LOAD16_BYTE( "95415467.hi", 0x00000, 0x080000, CRC(7046b475) SHA1(a3bba1a11490c16495148d3a8f486d1716f877a5) )
	ROM_LOAD16_BYTE( "95415480.lo", 0x00001, 0x080000, CRC(bbd9a433) SHA1(0de5c345569eb266affaf4bdb8c0d353cf757f9b) )
	ROM_LOAD16_BYTE( "95415481.hi", 0x00000, 0x080000, CRC(26dc3bfa) SHA1(07c2e9c0a68e860ddeb6ece5e9c94eaf572dd93d) )
	ROM_LOAD16_BYTE( "95415494.lo", 0x00001, 0x080000, CRC(2bffa151) SHA1(fbf1a18a92434a19be1f53d2967ffca3b0b1da6a) )
	ROM_LOAD16_BYTE( "95415495.hi", 0x00000, 0x080000, CRC(1f831b76) SHA1(bf91cb69d482aba9df2fc5e7404df8f610b57ae3) )
	ROM_LOAD16_BYTE( "95415784.lo", 0x00001, 0x080000, CRC(7f9bcded) SHA1(117e652fcc29c2acffba13c0082ac10c52f983e2) )
	ROM_LOAD16_BYTE( "95415785.hi", 0x00000, 0x080000, CRC(0885584c) SHA1(6ad16cb00535198b21a91574f953f2437c57ef1d) )
	ROM_LOAD16_BYTE( "95415786.lo", 0x00001, 0x080000, CRC(e639315d) SHA1(24fad5452338161e0838249229118608fb09417f) )
	ROM_LOAD16_BYTE( "95415787.hi", 0x00000, 0x080000, CRC(7e896b08) SHA1(887d25ee15784d7b672f1d85d17fa04d98ed2e31) )
	ROM_LOAD16_BYTE( "95415788.lo", 0x00001, 0x080000, CRC(cf1ab197) SHA1(eb1e166e057505b0957871c2f00b08a97428ca7c) )
	ROM_LOAD16_BYTE( "95415789.hi", 0x00000, 0x080000, CRC(297508d2) SHA1(86933487fb4c63f0159f3b133509db503a4c6229) )
	ROM_LOAD16_BYTE( "95415790.lo", 0x00001, 0x080000, CRC(34ff1c8e) SHA1(41cfc6ef8ed15fa4ce368bd9a4e0a7e46be362db) )
	ROM_LOAD16_BYTE( "95415791.hi", 0x00000, 0x080000, CRC(83e98ff0) SHA1(70c69ee23383530d0252b84895027af2d651fd07) )
	ROM_LOAD16_BYTE( "95415948.lo", 0x00001, 0x080000, CRC(b26d891e) SHA1(092dfbbe19b79a07df2d635b19da62a8c54d60e1) )
	ROM_LOAD16_BYTE( "95415949.hi", 0x00000, 0x080000, CRC(05d91c13) SHA1(593478fb88717a32e36a67d277a8620d643dfec5) )
	ROM_LOAD16_BYTE( "95415950.lo", 0x00001, 0x080000, CRC(a83ec6a0) SHA1(df9312566530018e3b7f5af5b083423d7a738040) )
	ROM_LOAD16_BYTE( "95415951.hi", 0x00000, 0x080000, CRC(9af2b8b7) SHA1(1e810de18cae8cd2cf77e542d705956d25bd9492) )
	ROM_LOAD16_BYTE( "95416018.lo", 0x00001, 0x080000, CRC(63401675) SHA1(1b30d39abbdfda0b159ffab9a45148ac5115f957) )
	ROM_LOAD16_BYTE( "95416019.hi", 0x00000, 0x080000, CRC(751deaca) SHA1(c9a0bccbc944b9f20975b2c9f487ad10c6b91239) )
	ROM_LOAD16_BYTE( "95416020.lo", 0x00001, 0x080000, CRC(03cc1803) SHA1(f8930e37be21059de9ffc1f0265f12dbc3122e86) )
	ROM_LOAD16_BYTE( "95416021.hi", 0x00000, 0x080000, CRC(bb5f02b2) SHA1(8de3181c611fae440f26d901913dac40adf7804e) )
	ROM_LOAD16_BYTE( "95417018.lo", 0x00001, 0x080000, CRC(1165520d) SHA1(b463c530f5581d5f8f168a606931efdbb859a2a2) )
	ROM_LOAD16_BYTE( "95417019.hi", 0x00000, 0x080000, CRC(dd52faf8) SHA1(ee58ec64dfffbaf0d846afd7ea7ba4a513b33869) )
	ROM_LOAD16_BYTE( "95417020.lo", 0x00001, 0x080000, CRC(a7ce7d6f) SHA1(481bb67c33e45af67f3e25adb0c96737a8c81fa4) )
	ROM_LOAD16_BYTE( "95417021.hi", 0x00000, 0x080000, CRC(e293103e) SHA1(d8f0e3292ae545c729e639b097ead9aedacc7089) )
	ROM_LOAD16_BYTE( "95420488.lo", 0x00001, 0x080000, CRC(33d94d81) SHA1(2d7274636e99ea6b78bdb85676f04fc10d37f973) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008391.bin", 0x0000, 0x0ec7b3, CRC(fad36ca8) SHA1(67918353945429183befba56ab891a1d138f2e8b) )
	ROM_LOAD( "95008514.bin", 0x0000, 0x0ed840, CRC(2608cbde) SHA1(4831570fbc825592781e6473173d6ec911a0054d) )

	ROM_REGION( 0x400000, "others", ROMREGION_ERASE00 )
	ROM_LOAD( "95408978.bin", 0x0000, 0x100000, CRC(ee15a4d5) SHA1(7a41140903ab1599a8261c2f60de635261299195) ) // just combined rom?

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211239.bin", 0x0000, 0x6a78e0, CRC(024795a6) SHA1(aba82d4a61efaa4c48750fc62e6a369aa2a8df9d) )
	ROM_LOAD( "39211250.bin", 0x0000, 0x6a791a, CRC(21909cb4) SHA1(28c028469e899659cbcca007f59ee3509d8b0f7a) )
	ROM_LOAD( "39211251.bin", 0x0000, 0x6a7a5e, CRC(ebbf403c) SHA1(ea993d78c41a71677ec3eacb6d11260037aeaac8) )
	ROM_LOAD( "39211260.bin", 0x0000, 0x6a839a, CRC(fa8e2b2a) SHA1(1749fbd7515574b77b083c5dc81c2071a089c52d) )
	ROM_LOAD( "39211262.bin", 0x0000, 0x6a6792, CRC(994ac3ab) SHA1(1b56fa251d32f20210ec695a789a4bd8c7bfe8ed) )
	ROM_LOAD( "39211263.bin", 0x0000, 0x6a664e, CRC(dc1c15f5) SHA1(a844b41e6c5a96b3165dfc000e525c35a34455ab) )
	ROM_LOAD( "39212239.bin", 0x0000, 0x6a78e0, CRC(838be734) SHA1(2a44c212cd6c2ba66661aa635ddb726fa9636d3c) )
	ROM_LOAD( "39212250.bin", 0x0000, 0x6a791a, CRC(a5ceface) SHA1(7fc03517b81e999e26c7ac55ffa6a4afa86e5717) )
	ROM_LOAD( "39212251.bin", 0x0000, 0x6a7a5e, CRC(abc6ee9c) SHA1(480db09f6a06d542347cbae6aa7192c5bfccbd48) )
	ROM_LOAD( "39212260.bin", 0x0000, 0x6a839a, CRC(c041863e) SHA1(afec88e97b65a3ed1d57085407abd4167007ed72) )
	ROM_LOAD( "39212262.bin", 0x0000, 0x6a6792, CRC(b8a7d34c) SHA1(e36964250a6e247030546ca4f181c9a70a89f61d) )
	ROM_LOAD( "39212263.bin", 0x0000, 0x6a664e, CRC(3bde8adb) SHA1(0ac2d4619cf2ca637fbdea867662b38de2661e1a) )
ROM_END




ROM_START( sc_mcas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412230.lo", 0x00001, 0x080000, CRC(45f66b73) SHA1(049bfdbd73a2b8bd8222d0c1eca15c2d64414d51) )
	ROM_LOAD16_BYTE( "95412231.hi", 0x00000, 0x080000, CRC(aac2e0a4) SHA1(e652dfd759128323b0f40a4a4118186a1dd57c23) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414526.lo", 0x00001, 0x080000, CRC(ea7dba5e) SHA1(e3f803ab5c4101e11084c30279679839ba60717f) )
	ROM_LOAD16_BYTE( "95414527.hi", 0x00000, 0x080000, CRC(7095fbe4) SHA1(8b52db7d3ca52747a31894a88c7acecda1af277a) )
	ROM_LOAD16_BYTE( "95414752.lo", 0x00001, 0x080000, CRC(21b6f763) SHA1(7dab85f5da4ec18fe94b5f203ce7724784ff36d1) )
	ROM_LOAD16_BYTE( "95414753.hi", 0x00000, 0x080000, CRC(bbe5e9a6) SHA1(7b915f711453ad0e078ab2aabd384138782a395a) )
	ROM_LOAD16_BYTE( "95414758.lo", 0x00001, 0x080000, CRC(bcda234a) SHA1(e48563941e26fa900587ac2de4b0858deb467b3e) )
	ROM_LOAD16_BYTE( "95414759.hi", 0x00000, 0x080000, CRC(f8c45405) SHA1(f22c42cc38e2da2ca6f74c57cfbca3c2c9bd924f) )
	ROM_LOAD16_BYTE( "95415520.lo", 0x00001, 0x080000, CRC(9293c6ac) SHA1(ac65fb59f0da86031ea8f3b1249f75685105152c) )
	ROM_LOAD16_BYTE( "95415521.hi", 0x00000, 0x080000, CRC(91534979) SHA1(d1618a40c4cc32e0f825603b58cacaa9b59da0a3) )
	ROM_LOAD16_BYTE( "95415522.lo", 0x00001, 0x080000, CRC(2cbfa7b1) SHA1(295dee90b19612879d12c72675f8327a2b1f0d2a) )
	ROM_LOAD16_BYTE( "95415523.hi", 0x00000, 0x080000, CRC(c13bb898) SHA1(c52449e479c5629851a89d43f9f29fb7373aeca2) )
	ROM_LOAD16_BYTE( "95415526.lo", 0x00001, 0x080000, CRC(b91074c3) SHA1(a78b20fc978a177910dbbe45a37dc5d7d5d5f9dc) )
	ROM_LOAD16_BYTE( "95415527.hi", 0x00000, 0x080000, CRC(d5e18c67) SHA1(842d28e15b8e24f551449144947ceabafd54d021) )
	ROM_LOAD16_BYTE( "95415752.lo", 0x00001, 0x080000, CRC(a001f1a7) SHA1(29405a687e1c8bad471f96fdb2b091074f33475b) )
	ROM_LOAD16_BYTE( "95415753.hi", 0x00000, 0x080000, CRC(8e36db12) SHA1(155999b67b4a01a5d5f8e460e2a49e023cb63146) )
	ROM_LOAD16_BYTE( "95415754.lo", 0x00001, 0x080000, CRC(6fdff81a) SHA1(3517866f169aa05d728878b974b971cb9b1d198c) )
	ROM_LOAD16_BYTE( "95415755.hi", 0x00000, 0x080000, CRC(3c94180f) SHA1(498d617c29b99159e34dab4a07d8c38e22331176) )
	ROM_LOAD16_BYTE( "95415756.lo", 0x00001, 0x080000, CRC(c28a5aed) SHA1(2b6fa68615352ef327a5d44bced1456d89c50e1c) )
	ROM_LOAD16_BYTE( "95415757.hi", 0x00000, 0x080000, CRC(f9242cf5) SHA1(32cfd4cdc121d74673b6ebd04ccee1d0328b7928) )
	ROM_LOAD16_BYTE( "95415758.lo", 0x00001, 0x080000, CRC(2625469c) SHA1(517be2d09e6c3146a8ecf57fbedc1a9a28a2cf44) )
	ROM_LOAD16_BYTE( "95415759.hi", 0x00000, 0x080000, CRC(3daac87f) SHA1(8748df6ea4e7f35b71f53b79c16979d23b8981f9) )
	ROM_LOAD16_BYTE( "95420669.hi", 0x00000, 0x080000, CRC(6e273bf4) SHA1(35ba48892d9ea3ebcb00fe33c75ee8e7949ab421) )
	ROM_LOAD16_BYTE( "95420670.lo", 0x00001, 0x080000, CRC(26a16559) SHA1(1fe601d1dd6f98c83b548accae07864ee84a2f45) )
	ROM_LOAD16_BYTE( "95420671.hi", 0x00000, 0x080000, CRC(d314c373) SHA1(47b2d10eccc2b25ac3324f5c5b95e9d092e1d2ff) )
	ROM_LOAD16_BYTE( "95420679.hi", 0x00000, 0x080000, CRC(910215de) SHA1(5e3d9ab721ea008e33754ac8237f82c106114364) )
	ROM_LOAD16_BYTE( "95420694.lo", 0x00001, 0x080000, CRC(902cbf08) SHA1(974b67da5c2da372a47569add00f593328de8f30) )
	ROM_LOAD16_BYTE( "95420695.hi", 0x00000, 0x080000, CRC(4b5d5013) SHA1(e0600a752b7ca05fd1f274ee3bbe8e14257a8806) )
	ROM_LOAD16_BYTE( "95420696.lo", 0x00001, 0x080000, CRC(cd735a28) SHA1(cf98337fc4e6097d2aa12ab76499fa0205a86e40) )
	ROM_LOAD16_BYTE( "95420697.hi", 0x00000, 0x080000, CRC(6200691c) SHA1(0912e9bc70a1a320b0705fbe2bc08eda4c329934) )
	ROM_LOAD16_BYTE( "95420698.lo", 0x00001, 0x080000, CRC(2ff54095) SHA1(312e91a6051ef5e8cf96bca0cf1a585f1ed98a3c) )
	ROM_LOAD16_BYTE( "95420699.hi", 0x00000, 0x080000, CRC(e1ac2e31) SHA1(562fbf0bf8fb23c36e8515413ffcc38991ca5543) )
	ROM_LOAD16_BYTE( "95420700.lo", 0x00001, 0x080000, CRC(437922ab) SHA1(dde8166aeff6b59f9f144d6706f2e39fdba697f5) )
	ROM_LOAD16_BYTE( "95420701.hi", 0x00000, 0x080000, CRC(2823836d) SHA1(92d915bd185a51d9827de77093531cf3e0808101) )
	ROM_LOAD16_BYTE( "95420702.lo", 0x00001, 0x080000, CRC(a701f08b) SHA1(937e04b45d292672bfe09973a997302b1428e2bb) )
	ROM_LOAD16_BYTE( "95420703.hi", 0x00000, 0x080000, CRC(f982b514) SHA1(74e9518795311d29a85ae87ba76ae9d154f46bf6) )
	ROM_LOAD16_BYTE( "95420704.lo", 0x00001, 0x080000, CRC(b3e43ead) SHA1(4d9af5ca64121cde14ff80933f0a8482e55a4749) )
	ROM_LOAD16_BYTE( "95420705.hi", 0x00000, 0x080000, CRC(bf4377b9) SHA1(80a07b4952873e7c7f936aaeec1516be8f65db90) )
	ROM_LOAD16_BYTE( "95420706.lo", 0x00001, 0x080000, CRC(498e2e13) SHA1(d8c7580a6b9e1143b940d28c37cc7729d57046c9) )
	ROM_LOAD16_BYTE( "95420707.hi", 0x00000, 0x080000, CRC(e672491b) SHA1(34ce10a9e3e999a3eefeadd354c3ebe7f42952e5) )
	ROM_LOAD16_BYTE( "95420708.lo", 0x00001, 0x080000, CRC(a3b73f0c) SHA1(4f816bd2cf10f97f954cc0b42cf5b0e147904d84) )
	ROM_LOAD16_BYTE( "95420709.hi", 0x00000, 0x080000, CRC(510bf078) SHA1(12d632ee343a37575d2eb2e059ec7f05330938a6) )
	ROM_LOAD16_BYTE( "95420710.lo", 0x00001, 0x080000, CRC(bae1c0fe) SHA1(2630a115d3c47c75a4fbc152ab890234ac1c41e7) )
	ROM_LOAD16_BYTE( "95420711.hi", 0x00000, 0x080000, CRC(f7283222) SHA1(5cdc163ffd8f1d31f107506d1af668563e7f165b) )
	ROM_LOAD16_BYTE( "95420718.lo", 0x00001, 0x080000, CRC(8ec09243) SHA1(1008e28918926c0198d19bc1a90c59fc8a75efaf) )
	ROM_LOAD16_BYTE( "95420719.hi", 0x00000, 0x080000, CRC(19b843c2) SHA1(d133fdcba113dbb9c596c14bc7be15fdd08763c7) )
	ROM_LOAD16_BYTE( "95420740.lo", 0x00001, 0x080000, CRC(9d96a632) SHA1(264c74f98e86bf1358b8534e316e0df08cdabdb3) )
	ROM_LOAD16_BYTE( "95420741.hi", 0x00000, 0x080000, CRC(925773b7) SHA1(0b8088128eee9e6b82b5f1417fb649cb7926f088) )
	ROM_LOAD16_BYTE( "95420780.lo", 0x00001, 0x080000, CRC(37465003) SHA1(42488e61bd48d06659f5954626046ac2ca48b315) )
	ROM_LOAD16_BYTE( "95420781.hi", 0x00000, 0x080000, CRC(6e824600) SHA1(fb2254aeec9848d4c56b9ef8ca214db3ed0cadfb) )
	ROM_LOAD16_BYTE( "95421679.hi", 0x00000, 0x080000, CRC(8ea625d4) SHA1(2875e8fc4b861e13f2a97e3e6c38d1ac83ade5dd) )
	ROM_LOAD16_BYTE( "95421694.lo", 0x00001, 0x080000, CRC(16e77364) SHA1(c4d7de59bb0bdd5d49efdc60c8d0d68ae3dbe9f4) )
	ROM_LOAD16_BYTE( "95421695.hi", 0x00000, 0x080000, CRC(6360bc4a) SHA1(c9b689eadb055505bf2df8864bf3321b5df4060b) )
	ROM_LOAD16_BYTE( "95421696.lo", 0x00001, 0x080000, CRC(9aad3266) SHA1(59f3a0895a22bd5a828cf872423ac30628ae326c) )
	ROM_LOAD16_BYTE( "95421697.hi", 0x00000, 0x080000, CRC(b4c09ab7) SHA1(d6f3bcff3c9db175bd4594f733b8fbda3ebb3aca) )
	ROM_LOAD16_BYTE( "95421698.lo", 0x00001, 0x080000, CRC(254b46c7) SHA1(d37ad7c5ed0f90ce1d17a5b0a6973a92342d8ded) )
	ROM_LOAD16_BYTE( "95421699.hi", 0x00000, 0x080000, CRC(5aea25f7) SHA1(b30d2e6ce8fa8da2d8c78e27edd958b79287a690) )
	ROM_LOAD16_BYTE( "95421700.lo", 0x00001, 0x080000, CRC(05e1bec3) SHA1(7ab1652379ffbc83d6d1c73c85973e802bbcc66b) )
	ROM_LOAD16_BYTE( "95421701.hi", 0x00000, 0x080000, CRC(4c09c20e) SHA1(e0eae6c57428427a9ddc7abedc45aac8599c384b) )
	ROM_LOAD16_BYTE( "95421702.lo", 0x00001, 0x080000, CRC(9d27d446) SHA1(6a7f04e99851e09e56e4d5f9746d36882ffc016e) )
	ROM_LOAD16_BYTE( "95421703.hi", 0x00000, 0x080000, CRC(1a4cb8ab) SHA1(df9ff6c4278c36745a4ca702ab73efb77c334da0) )
	ROM_LOAD16_BYTE( "95421704.lo", 0x00001, 0x080000, CRC(39d716cf) SHA1(6672254ac9f6c36cf164388a7a2de0f7ae0508c5) )
	ROM_LOAD16_BYTE( "95421705.hi", 0x00000, 0x080000, CRC(1e98fc98) SHA1(afee5b517089f490b5c4438c3902d2385be42b3a) )
	ROM_LOAD16_BYTE( "95421706.lo", 0x00001, 0x080000, CRC(82886cd7) SHA1(781ee991fc97cc13f91417abaa98ec5ac400a502) )
	ROM_LOAD16_BYTE( "95421707.hi", 0x00000, 0x080000, CRC(4011a5d6) SHA1(27f2c94d5a39926cc837ccf86363c7b969ce6858) )
	ROM_LOAD16_BYTE( "95421708.lo", 0x00001, 0x080000, CRC(4c8b9c5b) SHA1(42c333c83f2a55189ba70330bb3e8215abac05fb) )
	ROM_LOAD16_BYTE( "95421709.hi", 0x00000, 0x080000, CRC(5bbfc742) SHA1(361a76bff97f9dd645ec80ff390686bb4b7270ec) )
	ROM_LOAD16_BYTE( "95421710.lo", 0x00001, 0x080000, CRC(1ae0d8a7) SHA1(42eb858e5402465e735a1d4d4f0aace7c82b9a82) )
	ROM_LOAD16_BYTE( "95421711.hi", 0x00000, 0x080000, CRC(5075729f) SHA1(bd66ad9445b86aeab2876bab1923c8bc6ca9058f) )
	ROM_LOAD16_BYTE( "95421718.lo", 0x00001, 0x080000, CRC(9103b282) SHA1(2d247067c10840cc21bb7c84e8b587538c66f1fd) )
	ROM_LOAD16_BYTE( "95421719.hi", 0x00000, 0x080000, CRC(73f21b2a) SHA1(0f876862771fefb33909f4667b8f740fdd1a56af) )
	ROM_LOAD16_BYTE( "95421740.lo", 0x00001, 0x080000, CRC(f46033be) SHA1(4dc7541fb2c0741127b1232db2028e4836a67318) )
	ROM_LOAD16_BYTE( "95421741.hi", 0x00000, 0x080000, CRC(80c9040d) SHA1(6e6a81189f815071d6275f7399bd6b0fdc8e59a3) )
	ROM_LOAD16_BYTE( "95421780.lo", 0x00001, 0x080000, CRC(84543a44) SHA1(db5998172cbad9cfab939dc028e49889d2bec83f) )
	ROM_LOAD16_BYTE( "95421781.hi", 0x00000, 0x080000, CRC(2fbd7aaa) SHA1(c7e76a7fb74c49c207496c47c90403f027eda33b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008436.bin", 0x0000, 0x0e6369, CRC(32e8df77) SHA1(fa044287970d4e54af53ff492eabc50afa9a7a92) )
	ROM_LOAD( "95008991.bin", 0x0000, 0x0ec7b3, CRC(fad36ca8) SHA1(67918353945429183befba56ab891a1d138f2e8b) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890727.bin", 0x0000, 0x5000, CRC(10ec3f00) SHA1(986bfce992e113bab26eea8d1981905a54367b94) )
	ROM_LOAD( "95890728.bin", 0x0000, 0x5000, CRC(0c3acfbc) SHA1(ff39c8236d5bd44c7d238edd1827af5aebc46e5c) )
	ROM_LOAD( "95890729.bin", 0x0000, 0x5000, CRC(cf60ed2c) SHA1(df015b71567d6762b4c8ea6ad6d719cefdfdc60f) )
ROM_END




ROM_START( sc_mclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416076.lo", 0x00001, 0x080000, CRC(5e535679) SHA1(c187e0862166d3941abb899e25f50952a7a3007b) )
	ROM_LOAD16_BYTE( "95416077.hi", 0x00000, 0x080000, CRC(59fd4d20) SHA1(f1db12abe6fea293961150162a33af3abb759e71) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416200.lo", 0x00001, 0x080000, CRC(c352ef5c) SHA1(de3c4c30733bbfbe40c71663b80d9978d6c91e4f) )
	ROM_LOAD16_BYTE( "95416201.hi", 0x00000, 0x080000, CRC(9fced013) SHA1(356666bed633da24c8eb6cb5df20fd5dd3eee41f) )
	ROM_LOAD16_BYTE( "95416422.lo", 0x00001, 0x080000, CRC(42d8151e) SHA1(c008ce3d50026bfc904d2c79e61e76c4d9c4bd63) )
	ROM_LOAD16_BYTE( "95416423.hi", 0x00000, 0x080000, CRC(6f45ab49) SHA1(2b0686008f5e666a679c2af4e0c167d8a9af5444) )
	ROM_LOAD16_BYTE( "95417076.lo", 0x00001, 0x080000, CRC(0def1790) SHA1(08b52da7573be42b123b1dc9dbb1ba5424b49ff0) )
	ROM_LOAD16_BYTE( "95417077.hi", 0x00000, 0x080000, CRC(889d8d19) SHA1(738509fbf69bf85c6aa6a91723d3414612d28121) )
	ROM_LOAD16_BYTE( "95417200.lo", 0x00001, 0x080000, CRC(aa9b06c0) SHA1(435426c3da265b1d23e89b9844e323c1791e6955) )
	ROM_LOAD16_BYTE( "95417201.hi", 0x00000, 0x080000, CRC(89228288) SHA1(b80852e995033c5aa31d846dd6fa69c112c9446c) )
	ROM_LOAD16_BYTE( "95417422.lo", 0x00001, 0x080000, CRC(699587f5) SHA1(0c0b90b88d04cfd58a122d9a5807328da44d84d4) )
	ROM_LOAD16_BYTE( "95417423.hi", 0x00000, 0x080000, CRC(fe431436) SHA1(cdc55d1caa8c8e0b20440a477fee1f360c35c4f5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_mdlx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416018.lo", 0x00001, 0x080000, CRC(63401675) SHA1(1b30d39abbdfda0b159ffab9a45148ac5115f957) )
	ROM_LOAD16_BYTE( "95416019.hi", 0x00000, 0x080000, CRC(751deaca) SHA1(c9a0bccbc944b9f20975b2c9f487ad10c6b91239) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008514.bin", 0x0000, 0x0ed840, CRC(2608cbde) SHA1(4831570fbc825592781e6473173d6ec911a0054d) )
ROM_END




ROM_START( sc_mdm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426472.lo", 0x00001, 0x080000, CRC(4c1bc459) SHA1(6bcbf1caea6910f716cc3636bb5fdf17b99f8734) )
	ROM_LOAD16_BYTE( "95426473.hi", 0x00000, 0x080000, CRC(e52a5716) SHA1(4707cc1857dc72fd42f5cd208f547d20f4dfd303) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426660.lo", 0x00001, 0x080000, CRC(b533a2ae) SHA1(21671734a5f0d442bc25d0e946e91f7a790f36f0) )
	ROM_LOAD16_BYTE( "95426661.hi", 0x00000, 0x080000, CRC(59b4d908) SHA1(82ef3bf1fa6d6ae641bcbc5748ec585c73436b9e) )
	ROM_LOAD16_BYTE( "95426698.lo", 0x00001, 0x080000, CRC(8a8eef91) SHA1(357926a4af0fa52291d3b2df2d2a5255efa00477) )
	ROM_LOAD16_BYTE( "95426699.hi", 0x00000, 0x080000, CRC(e1afee66) SHA1(0219cc8c54f53c13a36afa4a5de227e1e6aa197e) )
	ROM_LOAD16_BYTE( "95427472.lo", 0x00001, 0x080000, CRC(a3f5058b) SHA1(8fa6a8e04ae5bd8a78b2479abc97e565c30b2050) )
	ROM_LOAD16_BYTE( "95427473.hi", 0x00000, 0x080000, CRC(6b862885) SHA1(ba908f12ab5a7803571650fbac1dec4f51a8d983) )
	ROM_LOAD16_BYTE( "95427660.lo", 0x00001, 0x080000, CRC(9778aca2) SHA1(f0b2158012d93f1dd3bdd9af45ff72ee34799f2b) )
	ROM_LOAD16_BYTE( "95427661.hi", 0x00000, 0x080000, CRC(bacfd623) SHA1(bf7a9841b1a6dce97091965bf0594b85690d0487) )
	ROM_LOAD16_BYTE( "95427698.lo", 0x00001, 0x080000, CRC(73292c8c) SHA1(7b55bc288e00c2862949a5f610735e56e13a1a70) )
	ROM_LOAD16_BYTE( "95427699.hi", 0x00000, 0x080000, CRC(735b72ac) SHA1(432cd5941e072a84b070c9fb136ec670ab013f76) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_mhn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420796.lo", 0x00001, 0x080000, CRC(556c7064) SHA1(3dd303fc26102093306fb371d700b4864fb7c035) )
	ROM_LOAD16_BYTE( "95420797.hi", 0x00000, 0x080000, CRC(28e3d8a8) SHA1(0b2427c55e0181d01ec743afe1264cf661e1698e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95421796.lo", 0x00001, 0x080000, CRC(69363a0d) SHA1(82dfc0bac3310b00169b2594b4c42ad154c7a7a7) )
	ROM_LOAD16_BYTE( "95421797.hi", 0x00000, 0x080000, CRC(dfc0b777) SHA1(439455b72493d6fb56a32452fafe34a72d543689) )
	ROM_LOAD16_BYTE( "95424492.lo", 0x00001, 0x080000, CRC(33207db3) SHA1(b2af1a29eee50f0e965bcf5804fa8c26f721a410) )
	ROM_LOAD16_BYTE( "95424493.hi", 0x00000, 0x080000, CRC(449e66fe) SHA1(05350ebbadfe92d42f11d80d52afcb43c1efffd9) )
	ROM_LOAD16_BYTE( "95424522.lo", 0x00001, 0x080000, CRC(47173638) SHA1(95f5c59bb1d986b1be0cab4d0642f7c6f2cc4d21) )
	ROM_LOAD16_BYTE( "95424523.hi", 0x00000, 0x080000, CRC(25dd80e8) SHA1(8da9991f3afaa7f0d7e6fbd9ca91fd8ebd66208f) )
	ROM_LOAD16_BYTE( "95424532.lo", 0x00001, 0x080000, CRC(38669184) SHA1(4d0a27d155b63fdaeb75746e0ba904663ceba209) )
	ROM_LOAD16_BYTE( "95424533.hi", 0x00000, 0x080000, CRC(e47900a7) SHA1(28839a52130b0a484870a8750a47b3eee8298b9e) )
	ROM_LOAD16_BYTE( "95425492.lo", 0x00001, 0x080000, CRC(6e62911d) SHA1(99c6b45e81372f8a6f95f199b6bbf35a1900aa05) )
	ROM_LOAD16_BYTE( "95425493.hi", 0x00000, 0x080000, CRC(ddb2ca2a) SHA1(bcdf63ffb4192c28fe4752279549d3e6d01ce5a3) )
	ROM_LOAD16_BYTE( "95425522.lo", 0x00001, 0x080000, CRC(589587c2) SHA1(43d5d74e4c0809168025a90790956b501b7ae759) )
	ROM_LOAD16_BYTE( "95425523.hi", 0x00000, 0x080000, CRC(b6d31074) SHA1(ca5358100c46e978aba5520a551371dd31dbe341) )
	ROM_LOAD16_BYTE( "95425532.lo", 0x00001, 0x080000, CRC(e402011f) SHA1(99391e096e6d3d422a0dc97259d9879b49d02326) )
	ROM_LOAD16_BYTE( "95425533.hi", 0x00000, 0x080000, CRC(c6951851) SHA1(66212e50c31c05a3ac0900d2180790055f672664) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008857.bin", 0x0000, 0x0f2fe8, CRC(a7f64802) SHA1(8a667ebf29feaffb2676ebd770b570c1015f3c2a) )
ROM_END




ROM_START( sc_mhp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422108.lo", 0x00001, 0x080000, CRC(3bf85c25) SHA1(0d73f8280c60aeaa2cb21729d4f1b449e07b7ae5) )
	ROM_LOAD16_BYTE( "95422109.hi", 0x00000, 0x080000, CRC(b695e6fc) SHA1(7988d0a1566021b49b0cb0ef980b975407c34a7c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422180.lo", 0x00001, 0x080000, CRC(26b8e28a) SHA1(ccfad8b9decfdb3db130ec21410cc1575ee7d1dc) )
	ROM_LOAD16_BYTE( "95422181.hi", 0x00000, 0x080000, CRC(12cea172) SHA1(7b59efc59c17826587efb9ac13888a175810c5b7) )
	ROM_LOAD16_BYTE( "95422350.lo", 0x00001, 0x080000, CRC(a802eef0) SHA1(bc0911bdfad7e7ed47add4cf24e85a40eb827f71) )
	ROM_LOAD16_BYTE( "95422351.hi", 0x00000, 0x080000, CRC(fd5a96a9) SHA1(6ced84eca2a33dda51378835b1b01edc57d25d95) )
	ROM_LOAD16_BYTE( "95422352.lo", 0x00001, 0x080000, CRC(a407395d) SHA1(a61050c97161a3fb602fc1287d7b016798bd84e2) )
	ROM_LOAD16_BYTE( "95422353.hi", 0x00000, 0x080000, CRC(b8e09157) SHA1(546f87587ff32d631e4483934f9c16a165a36dc3) )
	ROM_LOAD16_BYTE( "95422388.lo", 0x00001, 0x080000, CRC(d11a0c9e) SHA1(2ddea95b8098b5fa0b05b2ba6cd33f3d4b460d61) )
	ROM_LOAD16_BYTE( "95422389.hi", 0x00000, 0x080000, CRC(f402886f) SHA1(94e1c0802969d9714816d3fbcf1558d7105a3dc3) )
	ROM_LOAD16_BYTE( "95422578.lo", 0x00001, 0x080000, CRC(73d1951c) SHA1(6c72397c733dd2a440897c65b6e0523967cdad01) )
	ROM_LOAD16_BYTE( "95422579.hi", 0x00000, 0x080000, CRC(d62c27bf) SHA1(fc0df223e08893df7d5bd37bf7d4724621325e8c) )
	ROM_LOAD16_BYTE( "95423108.lo", 0x00001, 0x080000, CRC(68ae1dd9) SHA1(7d2965922a8c4a9b6585bb25b53e68f3fa0d3d75) )
	ROM_LOAD16_BYTE( "95423109.hi", 0x00000, 0x080000, CRC(f0900f32) SHA1(66937c9b588cc4fca77855ac2583f951944822d8) )
	ROM_LOAD16_BYTE( "95423180.lo", 0x00001, 0x080000, CRC(0a33f3d1) SHA1(31d1457927a91454d649633de64b056e1075d63f) )
	ROM_LOAD16_BYTE( "95423181.hi", 0x00000, 0x080000, CRC(ccf2df4f) SHA1(380380f0e929d4f9677690752a2940fedfb51394) )
	ROM_LOAD16_BYTE( "95423350.lo", 0x00001, 0x080000, CRC(7fecf279) SHA1(c0addf49a032986ec61213fe2fefcfa0bbac828f) )
	ROM_LOAD16_BYTE( "95423351.hi", 0x00000, 0x080000, CRC(4e9325b5) SHA1(3726e0989648744226b389dde4e8689eb288b1b8) )
	ROM_LOAD16_BYTE( "95423352.lo", 0x00001, 0x080000, CRC(c38d46b5) SHA1(eab08c165a1ec97421d2b641e2a1dfaf9f52b6cf) )
	ROM_LOAD16_BYTE( "95423353.hi", 0x00000, 0x080000, CRC(f244c7e0) SHA1(e0e1bb889999e7ec8ab785654219ff78d29a4f34) )
	ROM_LOAD16_BYTE( "95423388.lo", 0x00001, 0x080000, CRC(aa09bd94) SHA1(769c5f4438f36361e5f0a1af935d3d2004559a4b) )
	ROM_LOAD16_BYTE( "95423389.hi", 0x00000, 0x080000, CRC(a69ab735) SHA1(b87a9de0d61c203da9ecb9cb6e24734275e32f37) )
	ROM_LOAD16_BYTE( "95423578.lo", 0x00001, 0x080000, CRC(ff734c1a) SHA1(0773decf2aa97d33f8096421c9cc2d31fbf35ccf) )
	ROM_LOAD16_BYTE( "95423579.hi", 0x00000, 0x080000, CRC(73dd2448) SHA1(96e5c1352f3676ec9269c561ad72a59a7ca35b43) )
	ROM_LOAD16_BYTE( "95426094.lo", 0x00001, 0x080000, CRC(358eec20) SHA1(2a30491ecf4361860e4663df662924c79fc69211) )
	ROM_LOAD16_BYTE( "95426095.hi", 0x00000, 0x080000, CRC(ce2b8548) SHA1(0ef8cfba7a36a44ed3bf614c40ba1577546f59b7) )
	ROM_LOAD16_BYTE( "95426290.lo", 0x00001, 0x080000, CRC(fd6af641) SHA1(78f08c7361cb0658548519af6703263e729b36c0) )
	ROM_LOAD16_BYTE( "95426291.hi", 0x00000, 0x080000, CRC(e519cae8) SHA1(2fcf46fe46300fd37a288abbcf3933c2087d6f4d) )
	ROM_LOAD16_BYTE( "95426334.lo", 0x00001, 0x080000, CRC(377dbfb0) SHA1(d2ee6ffbcc545843defd0de1c5afd5dc4f979200) )
	ROM_LOAD16_BYTE( "95426335.hi", 0x00000, 0x080000, CRC(d7bfcc80) SHA1(25dc446557822ef682a35ffe083b72cbdde56f88) )
	ROM_LOAD16_BYTE( "95426504.lo", 0x00001, 0x080000, CRC(24f24564) SHA1(81c1ca3ac5968cf446119b8c6fd00881f7d3e2e3) )
	ROM_LOAD16_BYTE( "95426505.hi", 0x00000, 0x080000, CRC(14fd13b3) SHA1(7eb6e86f3b03255542a9b42ae07a4157ca0c65f2) )
	ROM_LOAD16_BYTE( "95426506.lo", 0x00001, 0x080000, CRC(73becfde) SHA1(9985fe2acfeb5a13f80e839247b5d29c0cacf87b) )
	ROM_LOAD16_BYTE( "95426507.hi", 0x00000, 0x080000, CRC(c8508d0b) SHA1(35c67b0c4ce5f3805a5481a8d558e67004357184) )
	ROM_LOAD16_BYTE( "95427094.lo", 0x00001, 0x080000, CRC(3fa03265) SHA1(d95defc1021774a70eab43a7b589ea1e505d2f73) )
	ROM_LOAD16_BYTE( "95427095.hi", 0x00000, 0x080000, CRC(c695e5d1) SHA1(301369834eb7fd7d4c1b86aa886d0e41a145255b) )
	ROM_LOAD16_BYTE( "95427290.lo", 0x00001, 0x080000, CRC(5cca2853) SHA1(92f8e7ae7ffe8aacf733804cf8117ec3544dbc24) )
	ROM_LOAD16_BYTE( "95427291.hi", 0x00000, 0x080000, CRC(15e2297e) SHA1(0b588bd3fea05ab59f6af539d43d1ccb536ffa3e) )
	ROM_LOAD16_BYTE( "95427334.lo", 0x00001, 0x080000, CRC(f04a3764) SHA1(8ac0e6e75f904e2d199af8d14d40e32fd1b8edf6) )
	ROM_LOAD16_BYTE( "95427335.hi", 0x00000, 0x080000, CRC(2575f364) SHA1(1f28b768fae048ef95263354126717c3a37941b7) )
	ROM_LOAD16_BYTE( "95427504.lo", 0x00001, 0x080000, CRC(4f8abdf7) SHA1(f9e8f96153eb14be481e0a3c9121cf0c9d49bd1a) )
	ROM_LOAD16_BYTE( "95427505.hi", 0x00000, 0x080000, CRC(94e1925c) SHA1(d7227cf4d5839cfba949cf97f024a38e922b3a03) )
	ROM_LOAD16_BYTE( "95427506.lo", 0x00001, 0x080000, CRC(1d225c6b) SHA1(8b3aa35436d6a2ba1f4537df90493268f596d941) )
	ROM_LOAD16_BYTE( "95427507.hi", 0x00000, 0x080000, CRC(497ac6c3) SHA1(6aa76eb22ff5290710e13b01d0bac463cda01ead) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008707.bin", 0x0000, 0x100000, CRC(88ffdb28) SHA1(724a2fe6703d4e5aab7d3989be9d3ae4dc8ab057) )
	ROM_LOAD( "95008708.bin", 0x0000, 0x100000, CRC(fa8aa99e) SHA1(bd4dd726b0af371d9b8589de461316990c3232dc) )
ROM_END




ROM_START( sc_mmb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426674.lo", 0x00001, 0x080000, CRC(4e009780) SHA1(8cf7d95da7c6a22427ad5ebe1b9c23bfa6f95cc3) )
	ROM_LOAD16_BYTE( "95426675.hi", 0x00000, 0x080000, CRC(ee7f46d1) SHA1(2d48bf0f94cb0c82b68e524e3a1ce2f6e0003e63) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426858.lo", 0x00001, 0x080000, CRC(9dcce7dc) SHA1(aada98497549dd6ed09b40d40cf159774b7c5f1d) )
	ROM_LOAD16_BYTE( "95426859.hi", 0x00000, 0x080000, CRC(6c0b7245) SHA1(769f4a58d5c255542a80e22029b53afd1563c523) )
	ROM_LOAD16_BYTE( "95427674.lo", 0x00001, 0x080000, CRC(eeb9b80c) SHA1(bac65da1a18503bfb7c4bac6b4494cd87a80f516) )
	ROM_LOAD16_BYTE( "95427675.hi", 0x00000, 0x080000, CRC(86c56bd8) SHA1(6de0ba751777e2a9a40d3a2eaf853a8db98da001) )
	ROM_LOAD16_BYTE( "95427858.lo", 0x00001, 0x080000, CRC(9b17bdfe) SHA1(91a97ca373f404dc20580ed0f5568589e38fb5a9) )
	ROM_LOAD16_BYTE( "95427859.hi", 0x00000, 0x080000, CRC(b534464c) SHA1(0c68a25020a5dfd37e85db629540096e7ee0dd5d) )
	ROM_LOAD16_BYTE( "p1911p11.hi", 0x00000, 0x080000, CRC(2478cc2f) SHA1(218219e503f3299f83b3a09f6e947cf912f23184) )
	ROM_LOAD16_BYTE( "p1911p11.lo", 0x00001, 0x080000, CRC(e19055a0) SHA1(e4f4116bb634e6960cdf6553f5bccb017839b931) )
	ROM_LOAD16_BYTE( "p1911s11.hi", 0x00000, 0x080000, CRC(e4c6844e) SHA1(4243f9989d3d7565802ccb50c43004aaf4d40b7a) )
	ROM_LOAD16_BYTE( "p1911s11.lo", 0x00001, 0x080000, CRC(5c51fde3) SHA1(825d0bbab81f9add9850362d5779c941ec779c7e) )
	ROM_LOAD16_BYTE( "p1931p11.hi", 0x00000, 0x080000, CRC(9452efb8) SHA1(c05e354130194fec75c29affb1e6c33cbe2cf84b) )
	ROM_LOAD16_BYTE( "p1931p11.lo", 0x00001, 0x080000, CRC(41d918b9) SHA1(6522370275e4a49e2e77d03ae2b2205ba992a494) )
	ROM_LOAD16_BYTE( "p1931s11.hi", 0x00000, 0x080000, CRC(c173fc27) SHA1(65dd2d16e3919731a9f20db458604c3272a20dec) )
	ROM_LOAD16_BYTE( "p1931s11.lo", 0x00001, 0x080000, CRC(393f7e53) SHA1(9990e5c0c7c12b3883d856b41cbb3141719f97a5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008612.bin", 0x0000, 0x100000, CRC(5f76152c) SHA1(c9f0ac000ec0b11ac3ba5eb5ff7e3dc2084f6744) )
	ROM_LOAD( "95008613.bin", 0x0000, 0x100000, CRC(df266121) SHA1(ece6b5a42ec3d18d97cffe3e6c98c6e6cd34682b) )
	ROM_LOAD( "95009168.bin", 0x0000, 0x100000, CRC(1ad311a5) SHA1(bd7728423cd855ea58fe21097d3d3db5a7e08339) )
	ROM_LOAD( "95009169.bin", 0x0000, 0x100000, CRC(23a8705f) SHA1(a36e71706cee64b56958fe4aefba8b85d2369e38) )
ROM_END




ROM_START( sc_mrh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420628.lo", 0x00001, 0x080000, CRC(1ea11921) SHA1(ba10d6d8120563b8c141d867d1a019948c7ee9bd) )
	ROM_LOAD16_BYTE( "95420629.hi", 0x00000, 0x080000, CRC(70f2cbad) SHA1(f13f5e8816ca8d5940d6eb69641bfd5aa86480ed) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420630.lo", 0x00001, 0x080000, CRC(5fd725e1) SHA1(6e12ed87a99a07e5a677ce138adfd0c4585bb9eb) )
	ROM_LOAD16_BYTE( "95420631.hi", 0x00000, 0x080000, CRC(afcbfcc2) SHA1(a9656cb6f644cafba5a64508dab2cdeeb1a457a1) )
	ROM_LOAD16_BYTE( "95420632.lo", 0x00001, 0x080000, CRC(aeb00018) SHA1(fd402b878b4e7b2d6206e4a8a444639f7b56f9a6) )
	ROM_LOAD16_BYTE( "95420633.hi", 0x00000, 0x080000, CRC(72e50b04) SHA1(9eb0b5b2c7d8ca15556d0cf65fb304092a77e69a) )
	ROM_LOAD16_BYTE( "95420714.lo", 0x00001, 0x080000, CRC(5c33260c) SHA1(a030666dab276bbaaa4c3c00b89d111b09fdbba4) )
	ROM_LOAD16_BYTE( "95420715.hi", 0x00000, 0x080000, CRC(5484b193) SHA1(36b5ab84e28a7978bb5f83169decce5abc0a0f00) )
	ROM_LOAD16_BYTE( "95421628.lo", 0x00001, 0x080000, CRC(151d9586) SHA1(41817b82e067e16adf9f47bd53d527a51ffb628f) )
	ROM_LOAD16_BYTE( "95421629.hi", 0x00000, 0x080000, CRC(691f2f62) SHA1(8e1602b64f8848088da0da6410c2eef3959165a1) )
	ROM_LOAD16_BYTE( "95421630.lo", 0x00001, 0x080000, CRC(e4b078ce) SHA1(bc59f503beff592f420c7337c805a1c184e4a118) )
	ROM_LOAD16_BYTE( "95421631.hi", 0x00000, 0x080000, CRC(13526f8e) SHA1(a326dd4d09b12b664101c5db6ccf037162137654) )
	ROM_LOAD16_BYTE( "95421632.lo", 0x00001, 0x080000, CRC(a50c8cbf) SHA1(e59dc27940ce414d409d97ac4f38a930784f4e54) )
	ROM_LOAD16_BYTE( "95421633.hi", 0x00000, 0x080000, CRC(6b08efcb) SHA1(613fe0d6a21f69bf3fad46c42c5a2b75f9a239e1) )
	ROM_LOAD16_BYTE( "95421714.lo", 0x00001, 0x080000, CRC(ba991634) SHA1(b465109375f795a88582007d89b9c7e99e9aa17e) )
	ROM_LOAD16_BYTE( "95421715.hi", 0x00000, 0x080000, CRC(234f15a2) SHA1(a1cee0ad3ad7ae89b11edd54f3524e6852e916ab) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008852.bin", 0x0000, 0x0c845b, CRC(265db01b) SHA1(6b9b62eded887ec528bb53b255d539122124eccc) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890721.bin", 0x0000, 0x5000, CRC(766aaa4d) SHA1(bd1bfd7209e4d54e1fc798b720b749dd7ce8f9e6) )
	ROM_LOAD( "95890722.bin", 0x0000, 0x5000, CRC(6abc5af1) SHA1(61ef7254ab948899df9de693227e0eff2ad22e74) )
	ROM_LOAD( "95890723.bin", 0x0000, 0x5000, CRC(a9e67861) SHA1(2ce81fb21e709438c63d5eb74d107e6dc1905dd2) )
ROM_END




ROM_START( sc_mrrcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424586.lo", 0x00001, 0x080000, CRC(6f4da0cf) SHA1(4a671f62de1a1af48cd3754b7a1d60c005ce9dfb) )
	ROM_LOAD16_BYTE( "95424587.hi", 0x00000, 0x080000, CRC(89e2b659) SHA1(c7f1e6cb5b04aff30bb5997cef50fa7a621334f7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425586.lo", 0x00001, 0x080000, CRC(03bfa76e) SHA1(ca73d02dddf5e5091f1b26cb6b3f9c5db8ea071d) )
	ROM_LOAD16_BYTE( "95425587.hi", 0x00000, 0x080000, CRC(0c204d84) SHA1(31a4f5021b2b12bdf930ed13268c52961aab3cbf) )
	ROM_LOAD16_BYTE( "99990558.lo", 0x00001, 0x080000, CRC(ae3f79e9) SHA1(0b086425f1091d01a71bcfaa33627f9b8b66632a) )
	ROM_LOAD16_BYTE( "99990559.hi", 0x00000, 0x080000, CRC(e9c6849d) SHA1(e3b846b5ec06f7048cde44ca1ae45c235476695a) )
	ROM_LOAD16_BYTE( "99991558.lo", 0x00001, 0x080000, CRC(b78a36ad) SHA1(a6728544e10e7578cc6b2c6a06d031fe1e30980e) )
	ROM_LOAD16_BYTE( "99991559.hi", 0x00000, 0x080000, CRC(c87db6c9) SHA1(6f100cbfd4a94f8f01fba7996bc59fdfc3b20ce5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_mr2r )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420330.lo", 0x00001, 0x080000, CRC(4003a508) SHA1(691b1e7caa9fc91837da062bbb751b32cccdee4f) )
	ROM_LOAD16_BYTE( "95420331.hi", 0x00000, 0x080000, CRC(4c03423a) SHA1(c83acfd8b447d06c9d669c9e4e861a4c3351761a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420332.lo", 0x00001, 0x080000, CRC(28cc177a) SHA1(51f8970179425c13672c9e34cb614f1b18e04f17) )
	ROM_LOAD16_BYTE( "95420333.hi", 0x00000, 0x080000, CRC(8dc8a01b) SHA1(0bd60e3d251b7d6b93382e60718acad399d0e9c5) )
	ROM_LOAD16_BYTE( "95420406.lo", 0x00001, 0x080000, CRC(8d338fd2) SHA1(1348f1752eeae7a248db30de2ba616fd9266dc0f) )
	ROM_LOAD16_BYTE( "95420407.hi", 0x00000, 0x080000, CRC(c543321a) SHA1(7bacc04e6c4bac72fdf3fe689fee0169fe839e45) )
	ROM_LOAD16_BYTE( "95420770.lo", 0x00001, 0x080000, CRC(8fa276c7) SHA1(d77dc0a50646bf23c6f495f836fde6c1861ddc54) )
	ROM_LOAD16_BYTE( "95420771.hi", 0x00000, 0x080000, CRC(96c42c86) SHA1(e672b3db0f8a39d214f7cca23cca257fe962afd6) )
	ROM_LOAD16_BYTE( "95421330.lo", 0x00001, 0x080000, CRC(cb5f8077) SHA1(bed2f3988c85c200588a5d2d4d8966abd6d04be8) )
	ROM_LOAD16_BYTE( "95421331.hi", 0x00000, 0x080000, CRC(f4f00d8d) SHA1(c5fe43dd46b886fbe1041f64cd8898e4f05bc2b7) )
	ROM_LOAD16_BYTE( "95421332.lo", 0x00001, 0x080000, CRC(dc119644) SHA1(bc9cda8fdd4fb1fa2820e9c60362afbece502e3f) )
	ROM_LOAD16_BYTE( "95421333.hi", 0x00000, 0x080000, CRC(cf732a87) SHA1(68b8922baaf26dc6f3775db2e1dbe7f53b812561) )
	ROM_LOAD16_BYTE( "95421406.lo", 0x00001, 0x080000, CRC(3060e53a) SHA1(06241b1475dff0e321450e67935537f4a659dc4f) )
	ROM_LOAD16_BYTE( "95421407.hi", 0x00000, 0x080000, CRC(1d42890a) SHA1(4b6f1eb7fc290170c2c4b5eda988b59321c67ab0) )
	ROM_LOAD16_BYTE( "95421770.lo", 0x00001, 0x080000, CRC(4a98a8e2) SHA1(72f476ce32b6157db54da84a684b96ff0d6f180a) )
	ROM_LOAD16_BYTE( "95421771.hi", 0x00000, 0x080000, CRC(9b2ce058) SHA1(a724bbaf757953f3ce452bf53025dd875c33e016) )
	ROM_LOAD16_BYTE( "95424570.lo", 0x00001, 0x080000, CRC(b21d4863) SHA1(cb2daf306d17fe2508ab45a5b7d8f94af7343e71) )
	ROM_LOAD16_BYTE( "95424571.hi", 0x00000, 0x080000, CRC(757f8d60) SHA1(1d0918a5c34528d905e7ecf62abb1412d28b40d9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008893.bin", 0x0000, 0x0f2fe8, CRC(a7f64802) SHA1(8a667ebf29feaffb2676ebd770b570c1015f3c2a) )
//  ROM_LOAD( "95008983.bin", 0x0000, 0x0f2fe8, CRC(a7f64802) SHA1(8a667ebf29feaffb2676ebd770b570c1015f3c2a) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890480.bin", 0x0000, 0x5000, CRC(3618777f) SHA1(97ab5be3bcdbe1c94e638c4dceac69bbfe359a0e) )
	ROM_LOAD( "95890481.bin", 0x0000, 0x5000, CRC(438e334b) SHA1(69b132ea3cbe31d31fd6fa6b915ddc2f4e66f068) )
	ROM_LOAD( "95890482.bin", 0x0000, 0x5000, CRC(dd34ff17) SHA1(b057c4a70066e8e8f9657e16adc4e0bfb6f00494) )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211501.bin", 0x0000, 0x6bb25b, CRC(94f73ba5) SHA1(1979b6cfd7968ad4d0c117742fafbb8b55a4e89e) )
	ROM_LOAD( "39211506.bin", 0x0000, 0x94ee0b, CRC(dee9ea83) SHA1(f66e5b63e10e0759ebb33a84d21d24d0f9452293) )
	ROM_LOAD( "39211510.bin", 0x0000, 0x94ee43, CRC(3f0124ff) SHA1(f44d4688472d8c46ce449033d7e2f1a57ea05574) )
	ROM_LOAD( "39211511.bin", 0x0000, 0x94ef97, CRC(051b150b) SHA1(6b1371d7157b69b7fdffaba6e9fa6c41912179b3) )
	ROM_LOAD( "39212506.bin", 0x0000, 0x94ee0b, CRC(aef402bb) SHA1(4d0d58339a9c51ab5a33eebf9443ac43efced01d) )
	ROM_LOAD( "39212510.bin", 0x0000, 0x94ee43, CRC(cec862b6) SHA1(b9b433218cef13d63e672f9e90649f44cf6aca72) )
	ROM_LOAD( "39212511.bin", 0x0000, 0x94ef97, CRC(5a84f20f) SHA1(62d2ea8b462b53acf9b47cf3589cbdd455b5a5ad) )
ROM_END




ROM_START( sc_mww )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416102.lo", 0x00001, 0x080000, CRC(c319cc0c) SHA1(e23b06c2d17b38d1d382dbfb042c5ad6ecdb26ed) )
	ROM_LOAD16_BYTE( "95416103.hi", 0x00000, 0x080000, CRC(6f550690) SHA1(d789c49de952d49153c7dd8da6f22b89fa1e0f6b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416104.lo", 0x00001, 0x080000, CRC(e6ec72cd) SHA1(9f12723de1b55c7df8dfc7910c9e904f7c0a801a) )
	ROM_LOAD16_BYTE( "95416105.hi", 0x00000, 0x080000, CRC(dff1c3a7) SHA1(b2adae2cfd1b6000eb12d28def081b9327dcce97) )
	ROM_LOAD16_BYTE( "95417102.lo", 0x00001, 0x080000, CRC(831cdf78) SHA1(53ad6afa40fcc4772dd494524f3b21540ccc9686) )
	ROM_LOAD16_BYTE( "95417103.hi", 0x00000, 0x080000, CRC(82b4c266) SHA1(f266dddff4bde4de1947f478c3995fa5ba5ae713) )
	ROM_LOAD16_BYTE( "95417104.lo", 0x00001, 0x080000, CRC(0be18ced) SHA1(07dacb30aa629f100b7514ed4c46a0287345a324) )
	ROM_LOAD16_BYTE( "95417105.hi", 0x00000, 0x080000, CRC(bc5c665f) SHA1(a8807b90ec3b0f79bd34663d676802e48ca6491e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008593.bin", 0x0000, 0x06a118, CRC(e4aee21b) SHA1(bda104a05bd2c0d4506f389c54e8842dc20d84b0) )

	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890162.bin", 0x0000, 0x5000, CRC(acf9118a) SHA1(b2c9073f0496de62d66edbc1da5546b9239ac1ba) )
	ROM_LOAD( "95890163.bin", 0x0000, 0x5000, CRC(b02fe136) SHA1(ac52b411f8117564a8dae25b19c9395e9030bfa0) )
	ROM_LOAD( "95890164.bin", 0x0000, 0x5000, CRC(7375c3a6) SHA1(8e5340e201261ccd8b47334f5d23e8adb33d031f) )
	ROM_LOAD( "95890387.bin", 0x0000, 0x5000, CRC(7e8703c6) SHA1(139dab5081ce9bdfade8c2a188562d98a15f8bb2) )
	ROM_LOAD( "95890388.bin", 0x0000, 0x5000, CRC(6251f37a) SHA1(3c8beafa021b6f4d32bd46f3fd755a7f877414ea) )
	ROM_LOAD( "95890389.bin", 0x0000, 0x5000, CRC(a10bd1ea) SHA1(e575a7cd0d40a7282aee2b7cd9f4801408ff846d) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211269.bin", 0x0000, 0x7a0866, CRC(0fae0667) SHA1(5356149061413c71b662371aa08f616a28ddbafb) )
	ROM_LOAD( "39211270.bin", 0x0000, 0x7a097a, CRC(13cb2a2a) SHA1(f00bf3647abf0593eb0708aee103dfd42e623bef) )
ROM_END




ROM_START( sc_mwwcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416422.lo", 0x00001, 0x080000, CRC(42d8151e) SHA1(c008ce3d50026bfc904d2c79e61e76c4d9c4bd63) )
	ROM_LOAD16_BYTE( "95416423.hi", 0x00000, 0x080000, CRC(6f45ab49) SHA1(2b0686008f5e666a679c2af4e0c167d8a9af5444) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_mont )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406130.odd", 0x00001, 0x080000, CRC(25f17613) SHA1(57cc7ae5145647aed9420ecc0a02250031b139b1) )
	ROM_LOAD16_BYTE( "95406131.evn", 0x00000, 0x080000, CRC(912c65f2) SHA1(04575ab3fea080fc6391bc4a058cfe16fce55bfa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406456.odd", 0x00001, 0x080000, CRC(e5fe4e0b) SHA1(808007536543d4c32558aef2e0b282344d65257e) )
	ROM_LOAD16_BYTE( "95406457.evn", 0x00000, 0x080000, CRC(31666e1b) SHA1(a7cb32963119ad11d2783be6db851e88d5547651) )
	ROM_LOAD16_BYTE( "95406522.odd", 0x00001, 0x080000, CRC(35c44bdd) SHA1(fdb9dbc57ceea898926af5d8c318c9d0f17f2965) )
	ROM_LOAD16_BYTE( "95406523.evn", 0x00000, 0x080000, CRC(2db29889) SHA1(56a917b2d830b8b15fe5fd8868fb8b1fc0d7c023) )
	ROM_LOAD16_BYTE( "95406600.odd", 0x00001, 0x080000, CRC(7ef84fd0) SHA1(ae70d29f505b0ec14c584220bb053090e4392d52) )
	ROM_LOAD16_BYTE( "95406601.evn", 0x00000, 0x080000, CRC(17fa1234) SHA1(e62a2be4878c8d92f20aa3c3a17e79d49d2ae880) )
	ROM_LOAD16_BYTE( "95406670.odd", 0x00001, 0x080000, CRC(3438bd18) SHA1(c10b6c0a4f65c1d252ca0d62df037ea3710f1cb3) )
	ROM_LOAD16_BYTE( "95406671.evn", 0x00000, 0x080000, CRC(242c6c4a) SHA1(bb02adf354ad8a6b7aecc166024978e34b1f3eb5) )
	ROM_LOAD16_BYTE( "95407130.odd", 0x00001, 0x080000, CRC(790f0c8c) SHA1(d754f4560fc611be159c84794cc148dcfb4fd857) )
	ROM_LOAD16_BYTE( "95407131.evn", 0x00000, 0x080000, CRC(39fc23f8) SHA1(3fb1443e23afd34bc5af4e69d4b6bf33a103b62b) )
	ROM_LOAD16_BYTE( "95407456.odd", 0x00001, 0x080000, CRC(e67f0701) SHA1(ef52ef52f5ebe9abcebb903dd44b37ddf100fbe2) )
	ROM_LOAD16_BYTE( "95407457.evn", 0x00000, 0x080000, CRC(1ec393cd) SHA1(02892ebf9a1a6cdd43543f37ac42106abc62744b) )
	ROM_LOAD16_BYTE( "95407522.odd", 0x00001, 0x080000, CRC(351104f9) SHA1(42faae9d9d9946cbb817005962bb27a2d4d5c0b4) )
	ROM_LOAD16_BYTE( "95407523.evn", 0x00000, 0x080000, CRC(0d515a0e) SHA1(e6009efbc1d49d136eb2a05dfb88ca579bbe2a36) )
	ROM_LOAD16_BYTE( "95407600.odd", 0x00001, 0x080000, CRC(2206354f) SHA1(3edef3ca4a48bcd1aad076870abe8dc6a36d6eb6) )
	ROM_LOAD16_BYTE( "95407601.evn", 0x00000, 0x080000, CRC(bf2a543e) SHA1(5b690920d9a84f9f881636b36e33556686d3c19f) )
	ROM_LOAD16_BYTE( "95407670.odd", 0x00001, 0x080000, CRC(8ff0380b) SHA1(349f187294fef7ea1dc627c53c2c24f6fbc877fd) )
	ROM_LOAD16_BYTE( "95407671.evn", 0x00000, 0x080000, CRC(dbd7fdd5) SHA1(c0fc28f95b5a17e68b787ebca7e32f1300c6407c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004314.bin", 0x0000, 0x0ccf04, CRC(0faba601) SHA1(1f21e39c2a9a18dd74292e68456c725ec2631aac) )
ROM_END




ROM_START( sc_motor )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400263.lo", 0x00001, 0x080000, CRC(cd80f6a1) SHA1(09aea111a65752ec9b9cf077440b68ad7733b46e) )
	ROM_LOAD16_BYTE( "95400264.hi", 0x00000, 0x080000, CRC(22e90f9d) SHA1(a1c2f0741e0752c97576259e282640f363e04ed0) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400313.lo", 0x00001, 0x080000, CRC(520c22f5) SHA1(61dd0b2226cdc1f3fadfb86adacaf719f5813a9f) )
	ROM_LOAD16_BYTE( "95400314.hi", 0x00000, 0x080000, CRC(d3c0fb2f) SHA1(fc3bf6b5086e77c145aefa77243c99860461ddce) )
	ROM_LOAD16_BYTE( "95400739.lo", 0x00001, 0x080000, CRC(1acee4c3) SHA1(63bc20f8f42c41399e56eb051fd90c90b8f55c0f) )
	ROM_LOAD16_BYTE( "95400740.hi", 0x00000, 0x080000, CRC(766729ed) SHA1(56c532c1d4988b25c4dd2f152fd6b7a39fcec46a) )
	ROM_LOAD16_BYTE( "95400741.lo", 0x00001, 0x080000, CRC(a15d5538) SHA1(a5366e06f144c1d9688d1b2aadcac4675664ffdc) )
	ROM_LOAD16_BYTE( "95400742.hi", 0x00000, 0x080000, CRC(fb1cc6fd) SHA1(7a4c5be6effada69da9fd5c377cd0e1ec13ff6c5) )
	ROM_LOAD16_BYTE( "95401263.lo", 0x00001, 0x080000, CRC(90594e45) SHA1(96ff726390beb7cdb61f4d550d5ac7fe1ed95cfb) )
	ROM_LOAD16_BYTE( "95401264.hi", 0x00000, 0x080000, CRC(4c14217d) SHA1(a2a9b7fa8b80cfad283e787973838208559c4683) )
	ROM_LOAD16_BYTE( "95401313.lo", 0x00001, 0x080000, CRC(56e7edfc) SHA1(8bb14e38b1196621300a6b0c7e86f39bdd08fd43) )
	ROM_LOAD16_BYTE( "95401314.hi", 0x00000, 0x080000, CRC(0f9b5ca7) SHA1(80b19c852ff0e9767da23cae8f08501dad55d7b1) )
	ROM_LOAD16_BYTE( "95401739.lo", 0x00001, 0x080000, CRC(2b1efd88) SHA1(25adffecc8ef5e1333d27b3a03715007cef353ed) )
	ROM_LOAD16_BYTE( "95401740.hi", 0x00000, 0x080000, CRC(626975ae) SHA1(1136ea45699764a27cdd05ad932c9936d63561c8) )
	ROM_LOAD16_BYTE( "95401741.lo", 0x00001, 0x080000, CRC(20344fa3) SHA1(d508485d312ddfc2fb13b443863d92f1c7e13276) )
	ROM_LOAD16_BYTE( "95401742.hi", 0x00000, 0x080000, CRC(e3880747) SHA1(60193e810abc726dbc9249112da49e6a95f3dc58) )
	ROM_LOAD16_BYTE( "mmay15hi", 0x0000, 0x080000, CRC(03365045) SHA1(cc041206a7872c5bd90d7feed3b2b760c4e785ab) )
	ROM_LOAD16_BYTE( "mmay15lo", 0x00001, 0x080000, CRC(da0479fc) SHA1(815a1905714c27915db5bef765e44ba810d362d3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_mou )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408478.odd", 0x00001, 0x080000, CRC(05cb62cf) SHA1(70f332e132d259f8b6aaeff2a6b62a10eba5a45c) )
	ROM_LOAD16_BYTE( "95408479.evn", 0x00000, 0x080000, CRC(fab6b737) SHA1(1e3ba6d441c7bf0b9e502a41cf2a6e5040d15aed) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409478.odd", 0x00001, 0x080000, CRC(bc02d1df) SHA1(861bb8ea19a3a08d9189f6f5f33e9f0eef460936) )
	ROM_LOAD16_BYTE( "95409479.evn", 0x00000, 0x080000, CRC(5266f13d) SHA1(ae4e38140537719ed2e31d2dca069a5b1c74d147) )
	ROM_LOAD16_BYTE( "95409480.odd", 0x00001, 0x080000, CRC(9378e444) SHA1(c8dcba47df2b710e802d36d5903f45bb0fd3195b) )
	ROM_LOAD16_BYTE( "95409481.evn", 0x00000, 0x080000, CRC(047e17ac) SHA1(80bb56775f5dbe988bb79024693af592bc8cc638) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008364.bin", 0x0000, 0x0e98ac, CRC(47aae23d) SHA1(0964a4f68c3688ebd65daf317b17e1341fcd3ceb) )
ROM_END




ROM_START( sc_nmtj )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414622.lo", 0x00001, 0x080000, CRC(c5187261) SHA1(5b9e891faf7469707b92470a5446c853597e2374) )
	ROM_LOAD16_BYTE( "95414623.hi", 0x00000, 0x080000, CRC(266f953b) SHA1(11f6f3a76a4cd0565646d045b15132dfe32c2107) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420442.lo", 0x00001, 0x080000, CRC(64e269e8) SHA1(25c5c3ff3ee7ce6b7d6f78445c5118eb59d0e54b) )
	ROM_LOAD16_BYTE( "95420443.hi", 0x00000, 0x080000, CRC(de19cd37) SHA1(000f9ffdadc0032549534d49987bbbdee509e655) )
	ROM_LOAD16_BYTE( "95420444.lo", 0x00001, 0x080000, CRC(cf082e36) SHA1(5c4dbc75c16ff6b204c692d602d72684ab1b8d3c) )
	ROM_LOAD16_BYTE( "95420445.hi", 0x00000, 0x080000, CRC(7c0d797a) SHA1(f1463d9c276943d4ff8ab98f37561cd17650891c) )
	ROM_LOAD16_BYTE( "95421442.lo", 0x00001, 0x080000, CRC(2071bb77) SHA1(8fd3b5cfa2832bd0095d8708f6ed63ded1011d3f) )
	ROM_LOAD16_BYTE( "95421443.hi", 0x00000, 0x080000, CRC(e31d8600) SHA1(448fbd78be8fd4097c2e66b7058dc50cf4f8bc87) )
	ROM_LOAD16_BYTE( "95421444.lo", 0x00001, 0x080000, CRC(705b0523) SHA1(80752ae5f151de850a9746506de7cdcc9cf2f2a6) )
	ROM_LOAD16_BYTE( "95421445.hi", 0x00000, 0x080000, CRC(a81ef149) SHA1(7004b0910d133a2756cf37e7496242900a7845d2) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008472.bin", 0x0000, 0x0fe798, CRC(a522157a) SHA1(f1fea963579cb8caddd5fcbfa36e33dc35c6e2a0) )
ROM_END




ROM_START( sc_nmare )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3002p41.hi", 0x00000, 0x080000, CRC(89b45502) SHA1(c5e8e23f639a8f2aa6845381025b91a5a5055eba) )
	ROM_LOAD16_BYTE( "p3002p41.lo", 0x00001, 0x080000, CRC(46a9ba39) SHA1(5cb404da937fd68febf311d9e2f3f5011dc476f5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3002p42.hi", 0x00000, 0x080000, CRC(61ba58db) SHA1(6994b71b580c1797dc297cb12e5748913973c7f3) )
	ROM_LOAD16_BYTE( "p3002p42.lo", 0x00001, 0x080000, CRC(2e0c5ada) SHA1(11c1f77ab61adec2341cdc88da1636cf7539e64c) )
	ROM_LOAD16_BYTE( "p3002s41.hi", 0x00000, 0x080000, CRC(6f3dc856) SHA1(b4d3f7d3ac58b2935a9a35e6f963b307e6747af7) )
	ROM_LOAD16_BYTE( "p3002s41.lo", 0x00001, 0x080000, CRC(0d5939f3) SHA1(344d309405d5356c7f3acbffc4ea0605b9b566b3) )
	ROM_LOAD16_BYTE( "p3002s42.hi", 0x00000, 0x080000, CRC(fe60eb5c) SHA1(5e882ffcc7fde96ad6a680fe8c09f828d8a007fc) )
	ROM_LOAD16_BYTE( "p3002s42.lo", 0x00001, 0x080000, CRC(31ad3c43) SHA1(83d6c998142b64ee10fff7d6560af11b060fe525) )
	ROM_LOAD16_BYTE( "p3032p42.hi", 0x00000, 0x080000, CRC(74afcad4) SHA1(2e7d9d630bea6cc841120275fb7ab7fcb0edde60) )
	ROM_LOAD16_BYTE( "p3032p42.lo", 0x00001, 0x080000, CRC(5af5bf0c) SHA1(2006da5a756407d04a29627a9844c59afb0e4cf7) )
	ROM_LOAD16_BYTE( "p3032p43.hi", 0x00000, 0x080000, CRC(641ecc20) SHA1(bc044d63a123cebceb8ecce5272a8e32304e5c67) )
	ROM_LOAD16_BYTE( "p3032p43.lo", 0x00001, 0x080000, CRC(80864fd0) SHA1(1a2bf2bd0a4072ddb84c4044c8e561d0e5da97bc) )
	ROM_LOAD16_BYTE( "p3032s42.hi", 0x00000, 0x080000, CRC(6d3a87dc) SHA1(c3c0373c488b1a4ac10ce558abdb0af805dab603) )
	ROM_LOAD16_BYTE( "p3032s42.lo", 0x00001, 0x080000, CRC(67d31b18) SHA1(96f47b2028a654aace09d7d7fd97c471510a4e93) )
	ROM_LOAD16_BYTE( "p3032s43.hi", 0x00000, 0x080000, CRC(3853a1c8) SHA1(03af94d1257b1d5ec5ccec1370429be78249a437) )
	ROM_LOAD16_BYTE( "p3032s43.lo", 0x00001, 0x080000, CRC(63646ff3) SHA1(76a09b3a231bb17dbe77fd99a85370eb4cb6993e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008664.bin", 0x0000, 0x100000, CRC(54d245d7) SHA1(503db10681bc1d6cf1cffb2a6f818c5d912a7f56) )
	ROM_LOAD( "95008665.bin", 0x0000, 0x100000, CRC(79a00527) SHA1(b8207d3a81e97b2233fea1df883a4128388570e4) )
	ROM_LOAD( "95008703.bin", 0x0000, 0x100000, CRC(5c095089) SHA1(ffba71efccf4679c2b29ab620e67f3fa45ff19d4) )
	ROM_LOAD( "95008704.bin", 0x0000, 0x100000, CRC(61e5d6f4) SHA1(6d221e0b3dce7507253bb7f07d99d03025d813cb) )
ROM_END




ROM_START( sc_nudit )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408000.lo", 0x00001, 0x080000, CRC(20f44215) SHA1(17c4424edcae989c9d3fbd9a6fbf61d808882bda) )
	ROM_LOAD16_BYTE( "95408001.hi", 0x00000, 0x080000, CRC(dbf69b04) SHA1(dfa4aa0e00ab24436b682c760f5734697bc1b110) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408002.lo", 0x00001, 0x080000, CRC(30c1e8ae) SHA1(0c7d14461d8324205f98159f5bc2d7c3e9c98c7a) )
	ROM_LOAD16_BYTE( "95408003.hi", 0x00000, 0x080000, CRC(e0e2fbf5) SHA1(973b315170d7ceaf022ba29c8a46088ab6958102) )
	ROM_LOAD16_BYTE( "95409002.lo", 0x00001, 0x080000, CRC(8ddb40dc) SHA1(cfbd0ba995472f5447cc40dcec59aab12a82efab) )
	ROM_LOAD16_BYTE( "95409003.hi", 0x00000, 0x080000, CRC(a1257efb) SHA1(4f21c5f2c992f688e0e592b6790e4d3e6bb7c7ae) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95404303.bin", 0x0000, 0x080000, CRC(adb71c93) SHA1(e91165b0280da9f79415b1cd7bb2ff8c1ea974fe) )
	ROM_LOAD( "95404304.bin", 0x0000, 0x080000, CRC(96190422) SHA1(0e3192d959f1ea4296474684f04847c50a983400) )
ROM_END




ROM_START( sc_oyf )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1310p11.hi", 0x00000, 0x080000, CRC(27ca7b83) SHA1(b7f3398d14b6360bc589bd490f3321b790eebe39) )
	ROM_LOAD16_BYTE( "p1310p11.lo", 0x00001, 0x080000, CRC(28504c4b) SHA1(60bff4f680114909520b4d978e7afbb2b22aaeec) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1310s11.hi", 0x00000, 0x080000, CRC(5028d55f) SHA1(fa96b81b91bc2a0c2708b30721f38a4fb6d1886f) )
	ROM_LOAD16_BYTE( "p1310s11.lo", 0x00001, 0x080000, CRC(9e6a1b0e) SHA1(ff7272cd732c922bc750d95844f7e70f450a6042) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008301.bin", 0x0000, 0x100000, CRC(0e042883) SHA1(2e73e5a49bcc525edfddf56e0d4ef5137116eec2) )
ROM_END




ROM_START( sc_opses )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404580.lo", 0x00001, 0x080000, CRC(ee8ddc11) SHA1(dd91b9e8845e057979680406814cd8269d6bde89) )
	ROM_LOAD16_BYTE( "95404581.hi", 0x00000, 0x080000, CRC(36628cef) SHA1(9c863b911bac71a2d1efbc76df13d8ff4c73cc0a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405580.lo", 0x00001, 0x080000, CRC(61d0aaa5) SHA1(f47232e37fd82f28b3e31811878949549b6df84d) )
	ROM_LOAD16_BYTE( "95405581.hi", 0x00000, 0x080000, CRC(42763b55) SHA1(74b2323f5f997b7ebfa32e571b022ab115a1567f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008211.bin", 0x0000, 0x100000, CRC(535fbad0) SHA1(25804a47e20dcfe364f49195da0ab057bce31266) )
ROM_END




ROM_START( sc_outlw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400825.lo", 0x00001, 0x080000, CRC(39333b8f) SHA1(2e0919bd311c3aa53cf834954a1b00013615b00a) )
	ROM_LOAD16_BYTE( "95400826.hi", 0x00000, 0x080000, CRC(a242f394) SHA1(67ecead37f703941e2d7827d81d1419f935a4a1a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400827.lo", 0x00001, 0x080000, CRC(de4a58e3) SHA1(b364e19e740b0ef2079d6ee8e87c5ddbdaff0308) )
	ROM_LOAD16_BYTE( "95400828.hi", 0x00000, 0x080000, CRC(26b46e52) SHA1(e1aff225b9b2196ae3f80fc6130c244a230207c1) )
	ROM_LOAD16_BYTE( "95401825.lo", 0x00001, 0x080000, CRC(1639b71a) SHA1(1442038fa4f6f03d92437942fe8f796382e82923) )
	ROM_LOAD16_BYTE( "95401826.hi", 0x00000, 0x080000, CRC(e0c6820a) SHA1(6e0c685edc9b7c8a12ac16928fac02c67cfa27f8) )
	ROM_LOAD16_BYTE( "95401827.lo", 0x00001, 0x080000, CRC(f61a55a6) SHA1(ffbfdfcb27b8580f201c98c1960e252014d9f2df) )
	ROM_LOAD16_BYTE( "95401828.hi", 0x00000, 0x080000, CRC(ae87eadf) SHA1(d2d7b7364a1240b2690708a452f42a8c8b076c93) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_pacmn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400861.lo", 0x00001, 0x080000, CRC(e4949979) SHA1(a00bcd8c839b14b9e1e4b21a8c78a9be789e0cf7) )
	ROM_LOAD16_BYTE( "95400862.hi", 0x00000, 0x080000, CRC(b1cd18f0) SHA1(b34a7d5595d3abad45e0cd027c217ac5b2bb3088) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402111.lo", 0x00001, 0x080000, CRC(e88b337a) SHA1(ecf7c3fb5e68fba9cbccada502022ae942992699) )
	ROM_LOAD16_BYTE( "95402112.hi", 0x00000, 0x080000, CRC(1f17de1d) SHA1(6576f40cf4dc8fd3de1fd121d5a4c19536da87c5) )
	ROM_LOAD16_BYTE( "95403111.lo", 0x00001, 0x080000, CRC(259141c0) SHA1(4bb6d8614696548f1f81f6c2045bde45d4316927) )
	ROM_LOAD16_BYTE( "95403112.hi", 0x00000, 0x080000, CRC(26c12768) SHA1(41dbde2bbc7df5bb9e50d9380f8199345ae1989c) )
	ROM_LOAD16_BYTE( "96000001.lo", 0x00001, 0x080000, CRC(250b6446) SHA1(d4aaaf1f0eb6833fb90bdfcc46100853db007c98) )
	ROM_LOAD16_BYTE( "96000002.hi", 0x00000, 0x080000, CRC(85aded4d) SHA1(a087e3e82664806858f2b36917a56d5326c79544) )
	ROM_LOAD16_BYTE( "96000016.odd", 0x00001, 0x080000, CRC(4e1d764e) SHA1(9c2a5ae820a95448558ed12cbe87a9353c054d44) )
	ROM_LOAD16_BYTE( "96000017.evn", 0x00000, 0x080000, CRC(eaf93528) SHA1(d4464eae9cd015e33f305d0458086e845199b8cd) )
	ROM_LOAD16_BYTE( "96003001.lo", 0x00001, 0x080000, CRC(70e21196) SHA1(0b7098da61df73f72ba459b1e8e9b6e92aef07d8) )
	ROM_LOAD16_BYTE( "96003002.hi", 0x00000, 0x080000, CRC(4ebbe216) SHA1(aca58b3a2d8368014b738ce15d677dbcca885cc5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004183", 0x0000, 0x080000, CRC(4b28f610) SHA1(fff01c890a8c109bb4b522ee2391c15abdc2758c) )
	ROM_LOAD( "95004184", 0x0000, 0x080000, CRC(bee11fdd) SHA1(b5ce97108812e296c92a000444c1fb7a11286de4) )
	ROM_LOAD( "97000000.evn", 0x00000, 0x080000, CRC(5b13fe7b) SHA1(1bd32e577914ab4e3bc3282261f8c3cdf015b85d) )
	ROM_LOAD( "97000000.odd", 0x00001, 0x080000, CRC(8bab1c78) SHA1(ddc915a8c56473ba4d67d8c62c66105dd622b593) )
	ROM_LOAD( "95004199.hi", 0x00000, 0x080000, CRC(0ecfc531) SHA1(15e20eedf4b7d9102c40834612d111559b4dcbca) )
	ROM_LOAD( "95004199.lo", 0x00001, 0x080000, CRC(3a9605c8) SHA1(ce1c94fe26eac9e145e94539f62f2bde740e5b9a) )

ROM_END




ROM_START( sc_paccs )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400871.lo", 0x00001, 0x080000, CRC(25b49ba8) SHA1(6017db6a11531707f15becc1ce0d00e01927cf72) )
	ROM_LOAD16_BYTE( "95400872.hi", 0x00000, 0x080000, CRC(49a6199a) SHA1(eb2ab3f8c094d44e033a7c23158cb382aa35a48b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400879.lo", 0x00001, 0x080000, CRC(4ec97800) SHA1(558bd1e63c892bc4423f5f4fcf74750c06cf9e09) )
	ROM_LOAD16_BYTE( "95400880.hi", 0x00000, 0x080000, CRC(16924c38) SHA1(126bca53f0ba2007bfb04e37503059d0302401a4) )
	ROM_LOAD16_BYTE( "95401871.lo", 0x00001, 0x080000, CRC(c43e6e09) SHA1(59ead71e88569c5c008133eb2a8ec3cd0f01425f) )
	ROM_LOAD16_BYTE( "95401872.hi", 0x00000, 0x080000, CRC(a0b1da9e) SHA1(7b48121b38c3752d478ee126a57a2bc447854dba) )
	ROM_LOAD16_BYTE( "95401879.lo", 0x00001, 0x080000, CRC(2547d8a0) SHA1(98b17cd44bea21e976412b5fb16ef26611b4f08b) )
	ROM_LOAD16_BYTE( "95401880.hi", 0x00000, 0x080000, CRC(b03a9913) SHA1(18e18d3ca1cbcc4bd5c49dc247a1a78cd9962009) )
	ROM_LOAD16_BYTE( "95402642.lo", 0x00001, 0x080000, CRC(3a58b754) SHA1(6e11940cef39fec8f066c086f33e3db9fd340c4d) )
	ROM_LOAD16_BYTE( "95402643.hi", 0x00000, 0x080000, CRC(4c9988ff) SHA1(b1ac7ea07e88f10ee6169699ce8b1e9e7f0da67d) )
	ROM_LOAD16_BYTE( "95406408.lo", 0x00001, 0x080000, CRC(8cd20c6c) SHA1(c958f3c4312f85b53fc865e66c3fc89b48813053) )
	ROM_LOAD16_BYTE( "95406409.hi", 0x00000, 0x080000, CRC(861850cf) SHA1(bbd071188b29f5641d6a97bd5f9e7e9174248443) )
	ROM_LOAD16_BYTE( "95407408.lo", 0x00001, 0x080000, CRC(bfbb0455) SHA1(8bbb4134b2b5d23057f9f3f85dd13181d472e974) )
	ROM_LOAD16_BYTE( "95407409.hi", 0x00000, 0x080000, CRC(358075d7) SHA1(7354a26d3d146f9a653f09163b082ee612a37ce3) )
	ROM_LOAD16_BYTE( "95414432.lo", 0x00001, 0x080000, CRC(b5ff58f6) SHA1(d5b707dc1a21b975a2494537851aef53e97bcf1f) )
	ROM_LOAD16_BYTE( "95414433.hi", 0x00000, 0x080000, CRC(a446fd8a) SHA1(4bd318dff1b4ab579196c6067f163bbda874c35c) )
	ROM_LOAD16_BYTE( "95415428.lo", 0x00001, 0x080000, CRC(b9a45ec8) SHA1(abcb37550f9555d6764b8dbf0f96259e1a63cc9a) )
	ROM_LOAD16_BYTE( "95415429.hi", 0x00000, 0x080000, CRC(b974d62c) SHA1(5d72ea9eb22038b4539aff3c322b1842ecc44006) )
	ROM_LOAD16_BYTE( "95415430.lo", 0x00001, 0x080000, CRC(9d9b61af) SHA1(cc3b82ef50ca7d35173fc1e1525c714d70304da5) )
	ROM_LOAD16_BYTE( "95415431.hi", 0x00000, 0x080000, CRC(641cc3ce) SHA1(efaa5707761836683374866553b68cd7cd05795e) )
	ROM_LOAD16_BYTE( "95415432.lo", 0x00001, 0x080000, CRC(b38aef45) SHA1(c9415665965010e6fcffe4168194591efafab83f) )
	ROM_LOAD16_BYTE( "95415433.hi", 0x00000, 0x080000, CRC(c8c68b8a) SHA1(60456c69cb8379474d30824d53e84d6ba73e0da0) )
	ROM_LOAD16_BYTE( "95415502.lo", 0x00001, 0x080000, CRC(370afd1c) SHA1(7e9f32fe4166e61bffe46d704c9fd5479d63f4ed) )
	ROM_LOAD16_BYTE( "95415503.hi", 0x00000, 0x080000, CRC(f90a4b9a) SHA1(87cf19d6754995003e18cd71b27d395925743a53) )
	ROM_LOAD16_BYTE( "95415504.lo", 0x00001, 0x080000, CRC(0c33ee13) SHA1(16dc6abae6dfa8bad3b4a8a3774af013e9d148a6) )
	ROM_LOAD16_BYTE( "95415505.hi", 0x00000, 0x080000, CRC(a25ff920) SHA1(52c46165ebbd8812df4943dbd5d82e4e4455430b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_paccl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406246.lo", 0x00001, 0x080000, CRC(1d855616) SHA1(8cc6ca3019be7efd384ee272725ad2f42307efa8) )
	ROM_LOAD16_BYTE( "95406247.hi", 0x00000, 0x080000, CRC(14c97bd9) SHA1(cb5005251417efacd459fc596b71e1db09a82458) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406418.lo", 0x00001, 0x080000, CRC(f1d245c6) SHA1(56bedeca7bcb94bb0acfd28d923aa9ad4f8e35c0) )
	ROM_LOAD16_BYTE( "95406419.hi", 0x00000, 0x080000, CRC(3abdcc9c) SHA1(47594fad060345e8e011fb0763f5246ddd3b6e7d) )
	ROM_LOAD16_BYTE( "95407246.lo", 0x00001, 0x080000, CRC(098515f1) SHA1(5dce61b818d5035a65dd52897b32976715a335c6) )
	ROM_LOAD16_BYTE( "95407247.hi", 0x00000, 0x080000, CRC(b1bd0c5a) SHA1(e54320c557822ba99baccac9dbd0c937419bd21f) )
	ROM_LOAD16_BYTE( "95407418.lo", 0x00001, 0x080000, CRC(56614d56) SHA1(5432a4986412f60e220fa2217c98cc98843cc319) )
	ROM_LOAD16_BYTE( "95407419.hi", 0x00000, 0x080000, CRC(87c22c9d) SHA1(d466f8dfaf0b472b0fca11086354c2141ed0559e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008145.bin", 0x0000, 0x100000, CRC(e2ec54f8) SHA1(bb1c40b13151ed1e3c7ba603506701457392bb8b) )
	ROM_LOAD( "pacmancsnd.bin", 0x0000, 0x0bbb33, CRC(c505aa18) SHA1(a99bd1c4101269e2eb2b6becf210d9991fee1da1) )
ROM_END




ROM_START( sc_pacpl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402323.lo", 0x00001, 0x080000, CRC(cfbed405) SHA1(65d68f1631bf3310b1e835c75474c947f6d4c2be) )
	ROM_LOAD16_BYTE( "95402324.hi", 0x00000, 0x080000, CRC(fad234c2) SHA1(3dbd04c7c21b0a1986e93b2bae447f76822c5a5d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402325.lo", 0x00001, 0x080000, CRC(6a54edec) SHA1(704f382885c11c46e8e8d3a9d10591ec780d8c37) )
	ROM_LOAD16_BYTE( "95402326.hi", 0x00000, 0x080000, CRC(8cf81ef2) SHA1(12f0974088ff6ac4c165fe56c7f6291d9c9cc192) )
	ROM_LOAD16_BYTE( "95402389.lo", 0x00001, 0x080000, CRC(784cbdc6) SHA1(860acce2f2379651a209c4f66ffe23b328adb39b) )
	ROM_LOAD16_BYTE( "95402390.hi", 0x00000, 0x080000, CRC(34699bae) SHA1(d42e599a679774263230cfc75104f8c8412bd01f) )
	ROM_LOAD16_BYTE( "95402606.lo", 0x00001, 0x080000, CRC(788934dc) SHA1(f0ba520072253a5f78f4b29a4dc71e135675defe) )
	ROM_LOAD16_BYTE( "95402607.hi", 0x00000, 0x080000, CRC(f7d100fc) SHA1(6281f5891b60651d1f94a982689dc17a8b2bdefb) )
	ROM_LOAD16_BYTE( "95403321.lo", 0x00001, 0x080000, CRC(aefa20af) SHA1(966b9124f5a09e129d68471cfa0a87d813456482) )
	ROM_LOAD16_BYTE( "95403322.hi", 0x00000, 0x080000, CRC(592c15ce) SHA1(c87e47993ede5aa8cbb06a569bd1a9ea5d623274) )
	ROM_LOAD16_BYTE( "95403325.lo", 0x00001, 0x080000, CRC(20131ca7) SHA1(c76b198745f48ff629a967ffa1130c1c713966e2) )
	ROM_LOAD16_BYTE( "95403326.hi", 0x00000, 0x080000, CRC(056a6037) SHA1(e13eb112ed2e0d2f92c476f84c4992e2790c477a) )
	ROM_LOAD16_BYTE( "95403389.lo", 0x00001, 0x080000, CRC(153b660c) SHA1(4389778d63a214cc40fa810483c8939eca2d0d1a) )
	ROM_LOAD16_BYTE( "95403390.hi", 0x00000, 0x080000, CRC(bcc5491b) SHA1(54a50df19fbab4c1ab50320b1c4566ab59935f46) )
	ROM_LOAD16_BYTE( "95403606.lo", 0x00001, 0x080000, CRC(17493df2) SHA1(a55cb6042b4898b6c9a9212cfa89a8c264d7ce7a) )
	ROM_LOAD16_BYTE( "95403607.hi", 0x00000, 0x080000, CRC(ec0635d6) SHA1(b5abca113bb6665e940848fcb0356d417e5d1a8a) )
	ROM_LOAD16_BYTE( "pman_pl.hi", 0x00000, 0x080000, CRC(51b0a5d2) SHA1(8208bbd7072e857967a555abf26cf3f7ef9a0178) )
	ROM_LOAD16_BYTE( "pman_pl.lo", 0x00001, 0x080000, CRC(508f918f) SHA1(203ddc867626ce94988e7465b44f26afed206e3e) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008049", 0x0000, 0x0ff7f5, CRC(efb3c1aa) SHA1(345ad862a329eedf7c016ddd809c8b60185d9962) )
ROM_END




ROM_START( sc_pmani )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406164.lo", 0x00001, 0x080000, CRC(4fce0eed) SHA1(6a81206be65fa897e3e8180b16ffe78e98996def) )
	ROM_LOAD16_BYTE( "95406165.hi", 0x00000, 0x080000, CRC(d059e343) SHA1(98f14670580da750968feb182f37b0eb1e028a6f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407164.lo", 0x00001, 0x080000, CRC(e50826d7) SHA1(b0fdcf4a645f3481e82a38dd4cf8859dbdc14eaa) )
	ROM_LOAD16_BYTE( "95407165.hi", 0x00000, 0x080000, CRC(93e33ead) SHA1(fef1e8534506f86e93096f5d07439ace5e8649c1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008201.bin", 0x0000, 0x100000, CRC(4e0358c5) SHA1(b9d8b78c77f87eebb9408a4ea1b9fd3a64ae724d) )
ROM_END




ROM_START( sc_party )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404102.lo", 0x00001, 0x080000, CRC(5c3f1160) SHA1(d4411fd99fac9d4c2ecfd8965dc2c42da090a344) )
	ROM_LOAD16_BYTE( "95404103.hi", 0x00000, 0x080000, CRC(94f8cefa) SHA1(ee528535ca9840e1cfd315cf04bf8ae79a2f87f4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008113.bin", 0x0000, 0x100000, CRC(7e54f87c) SHA1(b64e4da7c088ba2f328d6adcfd0a3824d98a5f31) )
	ROM_LOAD( "95008114.bin", 0x0000, 0x100000, CRC(594fef43) SHA1(8549d372ffb0194823afc11992d8a16f6caed2ff) )
ROM_END




ROM_START( sc_paytm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406364.lo", 0x00001, 0x080000, CRC(21300456) SHA1(41da31b42c99fee5602028c48217f7de6d551c94) )
	ROM_LOAD16_BYTE( "95406365.hi", 0x00000, 0x080000, CRC(805d8f51) SHA1(200cb1bda1360905264b0219e1a4d86a6a84d7c4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004224.sn1", 0x0000, 0x080000, CRC(74382d29) SHA1(bd0323b7208e9b03e2d8468f7d4603fb4a3fe394) )
	ROM_LOAD( "95004225.sn2", 0x0000, 0x080000, CRC(23efa88d) SHA1(af52ec3dcb45a2ea26eaa273c783134402105168) )
ROM_END




ROM_START( sc_pgold )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404232.lo", 0x00001, 0x080000, CRC(47c60203) SHA1(12afaedd713ffeda0fc41715dcb4d411cc05d186) )
	ROM_LOAD16_BYTE( "95404233.hi", 0x00000, 0x080000, CRC(6d8d283d) SHA1(d09b24b67fcb31f2ad13a0904ac00b8ee0b86201) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404234.lo", 0x00001, 0x080000, CRC(c3636257) SHA1(3bb86ec3d1b3a447120bc7b5225bfccf67e68c4a) )
	ROM_LOAD16_BYTE( "95404235.hi", 0x00000, 0x080000, CRC(f0879aae) SHA1(01cb5eea7b04597f0b39a14afebfa0d840bb8582) )
	ROM_LOAD16_BYTE( "95405232.lo", 0x00001, 0x080000, CRC(3560fc87) SHA1(8d03dd35d9e43e449ad55c2ae2ae521e64ef1bec) )
	ROM_LOAD16_BYTE( "95405233.hi", 0x00000, 0x080000, CRC(0a782f76) SHA1(143ce5a7e1e61f767138f375fc399e2209a9df6e) )
	ROM_LOAD16_BYTE( "95405234.lo", 0x00001, 0x080000, CRC(bb89b7e7) SHA1(c9a4702bbabfa8d94f5fb907fa2a3f740bab0086) )
	ROM_LOAD16_BYTE( "95405235.hi", 0x00000, 0x080000, CRC(8a7284ac) SHA1(4b712f3cd9b9d8bb69a2445bd020ee591c82de35) )
	ROM_LOAD16_BYTE( "95406014.lo", 0x00001, 0x080000, CRC(9c78f654) SHA1(313659c08a9818ccb93ef9c2a5b43b37619669ba) )
	ROM_LOAD16_BYTE( "95406015.hi", 0x00000, 0x080000, CRC(1c84a153) SHA1(db485aa57672e81849e18c642a8c4099e9e1a93c) )
	ROM_LOAD16_BYTE( "95406734.lo", 0x00001, 0x080000, CRC(e983d8db) SHA1(045c1f73cacfdcbdfbea74ed23287120433e3341) )
	ROM_LOAD16_BYTE( "95406735.hi", 0x00000, 0x080000, CRC(c082ae45) SHA1(5985b87924d44155f55806772e406d3dcaf6b506) )
	ROM_LOAD16_BYTE( "95407014.lo", 0x00001, 0x080000, CRC(9e7db6c3) SHA1(a38dd6a2110e65e40f96fc02494a3e21846c1bb0) )
	ROM_LOAD16_BYTE( "95407015.hi", 0x00000, 0x080000, CRC(c1e1aaab) SHA1(829113b8c324f4ecf4a6137b6a2a3a6bf062be3b) )
	ROM_LOAD16_BYTE( "95408068.lo", 0x00001, 0x080000, CRC(8932a906) SHA1(eca4706dd62e089ad9ce781b2ede0759dbe44bd9) )
	ROM_LOAD16_BYTE( "95408069.hi", 0x00000, 0x080000, CRC(f56fff18) SHA1(e123bd7f1af75218dbbef82b33e7c21d882f8105) )
	ROM_LOAD16_BYTE( "95408144.lo", 0x00001, 0x080000, CRC(ee67e3d6) SHA1(963160426e1b2d4399132ff0df9662dc1d46c121) )
	ROM_LOAD16_BYTE( "95408145.hi", 0x00000, 0x080000, CRC(b6e8a6d8) SHA1(d443aac2967229de4d6feae634efae9f3cd2f361) )
	ROM_LOAD16_BYTE( "95412692.lo", 0x00001, 0x080000, CRC(fdc94cd2) SHA1(163d6e10f96dd8f4d0788903bde8dc67525e21d1) )
	ROM_LOAD16_BYTE( "95412693.hi", 0x00000, 0x080000, CRC(a12e1001) SHA1(13c80763ec13152e1176f7140b8e580a2eed99e9) )
	ROM_LOAD16_BYTE( "95426522.lo", 0x00001, 0x080000, CRC(b282e34e) SHA1(cb7b8193596514f7d22a1aa69e0d476208269b82) )
	ROM_LOAD16_BYTE( "95426523.hi", 0x00000, 0x080000, CRC(66d53278) SHA1(77e3b2939fcded78f003389d831b375914257934) )
	ROM_LOAD16_BYTE( "95427522.lo", 0x00001, 0x080000, CRC(b2b6c8ca) SHA1(318bc3f9f0ff73d193d188fddbb0f70856bb2878) )
	ROM_LOAD16_BYTE( "95427523.hi", 0x00000, 0x080000, CRC(a40ae63f) SHA1(00eda3771154648aaa757f88fd7b1188034e1fa6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004316.snd", 0x0000, 0x080000, CRC(94a9ec9c) SHA1(bab1a431e2857b9db9fa3f3ef28f150e19c4ae50) )
	ROM_LOAD( "95008141.bin", 0x0000, 0x100000, CRC(e1b214dc) SHA1(811f6ec42961496f8cd9fb3434ab6a07457ca61a) )
	ROM_LOAD( "95008142.bin", 0x0000, 0x100000, CRC(faa84d52) SHA1(f5139df5e9ff95fab3c01ac2b1aa44b1d939bf7a) )
ROM_END




ROM_START( sc_potp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412720.lo", 0x00001, 0x080000, CRC(d51f9f14) SHA1(2ef9e9458a9030a2c3bc172b6bc6bbf343e702c9) )
	ROM_LOAD16_BYTE( "95412721.hi", 0x00000, 0x080000, CRC(d67679f5) SHA1(0f723214a5c53227a7a0e2de85c01d9f1f54c8a0) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412932.lo", 0x00001, 0x080000, CRC(6499d5d3) SHA1(1af2ae64715d057a97280fd7552d7d8f1579e13e) )
	ROM_LOAD16_BYTE( "95412933.hi", 0x00000, 0x080000, CRC(b29923bb) SHA1(e735d74a85730a7b37f10eed24e9e18384c16135) )
	ROM_LOAD16_BYTE( "95413720.lo", 0x00001, 0x080000, CRC(7f47c7cd) SHA1(1f133bcf13f3cf4ce8d7916f44e72af107cd7b11) )
	ROM_LOAD16_BYTE( "95413721.hi", 0x00000, 0x080000, CRC(e93f0aef) SHA1(0ddcc3a7e748c1b162dbd683c40b62bd8baa28c3) )
	ROM_LOAD16_BYTE( "95413932.lo", 0x00001, 0x080000, CRC(57b80a9d) SHA1(55f27889a327c7f7508b307d9d30ab1289503acb) )
	ROM_LOAD16_BYTE( "95413933.hi", 0x00000, 0x080000, CRC(5505bdf6) SHA1(ad6d581a4d5b6b7f2e45795076806bf14cdedcff) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008483.bin", 0x0000, 0x100000, CRC(d208755d) SHA1(f87b9b7dc077f4a1bf141ae8ca1e985796c4bada) )

ROM_END




ROM_START( sc_pp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416520.lo", 0x00001, 0x080000, CRC(82217da7) SHA1(1df7dcd4f15ef32cdaba3fa13fc9c46682de9bb5) )
	ROM_LOAD16_BYTE( "95416521.hi", 0x00000, 0x080000, CRC(d8ddcaed) SHA1(c10339a165b540ae4cecaf3d88965242ed5fddfa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416858.lo", 0x00001, 0x080000, CRC(8c07665e) SHA1(ac47662fd882e1d32bf2f999b33bf5a43dd0312b) )
	ROM_LOAD16_BYTE( "95416859.hi", 0x00000, 0x080000, CRC(153ac6c4) SHA1(28d081cb11ebdc810b7a1366b0f214fbdf087e24) )
	ROM_LOAD16_BYTE( "95416974.lo", 0x00001, 0x080000, CRC(58590ce5) SHA1(7379ab51da46035c6529928ab3d06ab2da8e7372) )
	ROM_LOAD16_BYTE( "95416975.hi", 0x00000, 0x080000, CRC(a5c664a5) SHA1(5c43bcc430ffa2ffbb1bb40e7e2b7ebf6090beb4) )
	ROM_LOAD16_BYTE( "95417858.lo", 0x00001, 0x080000, CRC(2f7e13e9) SHA1(dcb5b7eec25375d6dc414bd23a022da38f1118e0) )
	ROM_LOAD16_BYTE( "95417859.hi", 0x00000, 0x080000, CRC(e7a4948a) SHA1(84704b1c9bd97a41e4e9b879cb1e5da36edaa4fc) )
	ROM_LOAD16_BYTE( "95417974.lo", 0x00001, 0x080000, CRC(61ed19fd) SHA1(6ff13778f7c33ca1fe535303f3a7b538558ee9a1) )
	ROM_LOAD16_BYTE( "95417975.hi", 0x00000, 0x080000, CRC(ff877e93) SHA1(2cb8f201bd2079a601b2f6d9ff331f56a960b931) )
	ROM_LOAD16_BYTE( "95420094.lo", 0x00001, 0x080000, CRC(12c9c9ef) SHA1(ef62abad003f1f037f096213c1f216e0f1b06e13) )
	ROM_LOAD16_BYTE( "95420095.hi", 0x00000, 0x080000, CRC(71137836) SHA1(438d5e7bb1ae21a99086e95fda441329ef785f19) )
	ROM_LOAD16_BYTE( "95420096.lo", 0x00001, 0x080000, CRC(b216176c) SHA1(f2b201ba7bb0743b8469eac1eb5789e24984d806) )
	ROM_LOAD16_BYTE( "95420097.hi", 0x00000, 0x080000, CRC(e59cc3c3) SHA1(c6c4508e9baec9f3957c4b2e3c76aeb0b82c8771) )
	ROM_LOAD16_BYTE( "95420098.lo", 0x00001, 0x080000, CRC(b5803419) SHA1(68f1752d8fc4b99e9c9f81212f9a374a8bc08531) )
	ROM_LOAD16_BYTE( "95420099.hi", 0x00000, 0x080000, CRC(fd8a979c) SHA1(e922886fac70f4af1c31161a61b7164d4ec31a68) )
	ROM_LOAD16_BYTE( "95420180.lo", 0x00001, 0x080000, CRC(519fd41a) SHA1(288261243c0350290f01225c29ecf405b6c50f5f) )
	ROM_LOAD16_BYTE( "95420181.hi", 0x00000, 0x080000, CRC(9888d297) SHA1(abeef73fbd887b5b001de016a003f5b8c71ebc34) )
	ROM_LOAD16_BYTE( "95421094.lo", 0x00001, 0x080000, CRC(92c46cb0) SHA1(accd8976632386f3dbf779cf90f57e6c340a147d) )
	ROM_LOAD16_BYTE( "95421095.hi", 0x00000, 0x080000, CRC(13edda42) SHA1(fb82700f46802356b884768dd2f3fa1b3e2b2718) )
	ROM_LOAD16_BYTE( "95421096.lo", 0x00001, 0x080000, CRC(6c6a7030) SHA1(cf197e300a16d7e22fceb56440efcc32c6b234bd) )
	ROM_LOAD16_BYTE( "95421097.hi", 0x00000, 0x080000, CRC(9e64dd46) SHA1(82b719066d430b2c2249db11f909504165a5462f) )
	ROM_LOAD16_BYTE( "95421098.lo", 0x00001, 0x080000, CRC(db67d892) SHA1(f09ad9f53af922dedceba30e293e2350d770d3e8) )
	ROM_LOAD16_BYTE( "95421099.hi", 0x00000, 0x080000, CRC(2c5d0216) SHA1(f3948ff75e55ea72a3ee949ffcbc0914342099e0) )
	ROM_LOAD16_BYTE( "95421180.lo", 0x00001, 0x080000, CRC(3f783891) SHA1(cfcf1c4c0a7a1e8f1d49cabb8ffd9c6a901d5789) )
	ROM_LOAD16_BYTE( "95421181.hi", 0x00000, 0x080000, CRC(495f471d) SHA1(cc3e320986eda11d41d8932e63a4c90331c51984) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008942.bin", 0x0000, 0x0ebc96, CRC(42765fbc) SHA1(ab5b9240a8e71695897fd55a1385b64f63ce52c8) )
	ROM_LOAD( "95008948.bin", 0x0000, 0x08b98b, CRC(35e995c5) SHA1(9d12a3002423e9434bcd76fe13f9fc0891354e40) )
	ROM_LOAD( "95008953.bin", 0x0000, 0x0fabc8, CRC(12d96e7a) SHA1(4f5179b5817e471b891f377f0bec81dcb4a2077c) )

	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890380.bin", 0x0000, 0x5000, CRC(1ba73039) SHA1(6f07fa6f412e92c5a55be15f8cce7aa6f5e8dca0) )
	ROM_LOAD( "95890381.bin", 0x0000, 0x5000, CRC(0771c085) SHA1(5eb89b14c03cac0f56d057dc2c0c7210cc9443ea) )
	ROM_LOAD( "95890382.bin", 0x0000, 0x5000, CRC(c42be215) SHA1(4da4820ee08a102a2a49ce64a49f66c9548b8ab1) )
	ROM_LOAD( "95890398.bin", 0x0000, 0x5000, CRC(007c15b3) SHA1(8330f7e8d2dc062118016d8f003df48930a5aeb8) )
	ROM_LOAD( "95890399.bin", 0x0000, 0x5000, CRC(1caae50f) SHA1(1e978f7f4851384cd800ebecd9beeff1a5df8156) )
	ROM_LOAD( "95890400.bin", 0x0000, 0x5000, CRC(dff0c79f) SHA1(aae28c245a672417962cd19388e4d5c401708911) )


	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211267.bin", 0x0000, 0xb071f3, CRC(51d49618) SHA1(0053ecf1b2d2ad20444f05daf80138d4c8c0c885) )
	ROM_LOAD( "39211268.bin", 0x0000, 0xb08064, CRC(9d8248f4) SHA1(b20b682fa0e058e39608e4b54ced3eec56c4ec08) )
	ROM_LOAD( "39211279.bin", 0x0000, 0xc0da36, CRC(dfa112e8) SHA1(1097e0bf7a49b75ebe04a92d2c3794993ec73c41) )
	ROM_LOAD( "39211280.bin", 0x0000, 0xc0e902, CRC(7c52816b) SHA1(1a5552893dcd91a1928d0526ce5ecaaac0f7f29b) )
	ROM_LOAD( "39211281.bin", 0x0000, 0x43a386, CRC(a429eb90) SHA1(2374ebff3fc5ab1780a82454bcb4856c97492781) )
	ROM_LOAD( "39211321.bin", 0x0000, 0x43a9d4, CRC(6e1b8538) SHA1(04504ceff81f2350cc090eabfd2f53a70b4d647f) )
	ROM_LOAD( "39212267.bin", 0x0000, 0xb071f3, CRC(fcfaac08) SHA1(08aab0b6525ca3f30c3fe849641f5afe9dfa3db3) )
	ROM_LOAD( "39212268.bin", 0x0000, 0xb08064, CRC(9882907c) SHA1(5ab2fa1b999f6e5d27207e64a9445476df7582cf) )
	ROM_LOAD( "39212280.bin", 0x0000, 0xc0e902, CRC(f10abe2b) SHA1(9af09874f16e957906bef69d5377c0c744d337de) )
	ROM_LOAD( "39212281.bin", 0x0000, 0x43a386, CRC(9b460cee) SHA1(54b561e9afc3cf325c82f9c105698d026daa769c) )
	ROM_LOAD( "39212321.bin", 0x0000, 0x43a9d4, CRC(7bdfaeea) SHA1(652cb88ba6f2ecc1bcc98a2581aa3e4c65ba757b) )

ROM_END




ROM_START( sc_ppcr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416698.lo", 0x00001, 0x080000, CRC(9fd536c7) SHA1(fb778f1a92656aca4061a40cb427db1d6c66d7e7) )
	ROM_LOAD16_BYTE( "95416699.hi", 0x00000, 0x080000, CRC(247da932) SHA1(0955ffed8ed1caed6cfa67905244ef2ac312ba60) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416700.lo", 0x00001, 0x080000, CRC(4fb2c37a) SHA1(963fe4116504a1bd6c1f95526a26050d9b66744f) )
	ROM_LOAD16_BYTE( "95416701.hi", 0x00000, 0x080000, CRC(aca4c3c5) SHA1(eec31ce0a1ddec520dcfca9af1f8eeeabc94bde4) )
	ROM_LOAD16_BYTE( "95416724.lo", 0x00001, 0x080000, CRC(65cd7765) SHA1(8f97eeefabdfdbc8106202a7bbbe2bf3f7ce888c) )
	ROM_LOAD16_BYTE( "95416725.hi", 0x00000, 0x080000, CRC(852a0886) SHA1(c1292aff6cbb1a56ae6594f44920fc2d8af0a044) )
	ROM_LOAD16_BYTE( "95416826.lo", 0x00001, 0x080000, CRC(f8bf2500) SHA1(ebf0319aa819efc8d09cbaef95809df979481bb2) )
	ROM_LOAD16_BYTE( "95416827.hi", 0x00000, 0x080000, CRC(68bd68c4) SHA1(b6b5968d3d03ae9a6d9560a8b5c25326506ae730) )
	ROM_LOAD16_BYTE( "95416832.lo", 0x00001, 0x080000, CRC(584def0c) SHA1(7c317037a623de360552a59ef3ee7b70b3b86a29) )
	ROM_LOAD16_BYTE( "95416833.hi", 0x00000, 0x080000, CRC(c8b55d3e) SHA1(4cbcc13d5a6fc7dcbc6a00ff3dddbf559fd32984) )
	ROM_LOAD16_BYTE( "95416834.lo", 0x00001, 0x080000, CRC(9bfc8503) SHA1(a8869273b72ade538a5e142c4d690055bae42139) )
	ROM_LOAD16_BYTE( "95416835.hi", 0x00000, 0x080000, CRC(44c55957) SHA1(2645ce9545a5ea79d4b1863e0efe93263a485568) )
	ROM_LOAD16_BYTE( "95416836.lo", 0x00001, 0x080000, CRC(5f939ed9) SHA1(5cdb4cd793c6827ec9af0df88f7d41b91b4cde2b) )
	ROM_LOAD16_BYTE( "95416837.hi", 0x00000, 0x080000, CRC(37943187) SHA1(d2e25fac6baff7d46a654323c464334db750e648) )
	ROM_LOAD16_BYTE( "95417698.lo", 0x00001, 0x080000, CRC(7848b042) SHA1(bc3afbc7891b19b450116a55f417897c2d6e8a18) )
	ROM_LOAD16_BYTE( "95417699.hi", 0x00000, 0x080000, CRC(3e0979b1) SHA1(c541961d41d0289a6650363a5d8939d8d7c6ca88) )
	ROM_LOAD16_BYTE( "95417724.lo", 0x00001, 0x080000, CRC(40ba241d) SHA1(960dc1058b828f02a7fc07acf63be987c9497cbc) )
	ROM_LOAD16_BYTE( "95417725.hi", 0x00000, 0x080000, CRC(f8525222) SHA1(ab795042a46f84cad59e9f454ee145c0d49418df) )
	ROM_LOAD16_BYTE( "95417826.lo", 0x00001, 0x080000, CRC(08c8969d) SHA1(4d4686ccd481e7469f171d058bfd91ef1765dc49) )
	ROM_LOAD16_BYTE( "95417827.hi", 0x00000, 0x080000, CRC(67d77ad1) SHA1(d246c477e07986265eb795a064c9229110ee3391) )
	ROM_LOAD16_BYTE( "95417832.lo", 0x00001, 0x080000, CRC(c820b768) SHA1(d3ae773e93b74e3fc549d15388720dc70aa0f7d0) )
	ROM_LOAD16_BYTE( "95417833.hi", 0x00000, 0x080000, CRC(583e354d) SHA1(db0fa0e1663fab6fc63e4e37dddedae8c7550fa5) )
	ROM_LOAD16_BYTE( "95417834.lo", 0x00001, 0x080000, CRC(6b8b369e) SHA1(42aaacc9e9d7dc1f695581558ef87a46ffe2dea5) )
	ROM_LOAD16_BYTE( "95417835.hi", 0x00000, 0x080000, CRC(4baf4b42) SHA1(5914d22f35033a61db21d84cf0008bd4a48c881f) )
	ROM_LOAD16_BYTE( "95420244.lo", 0x00001, 0x080000, CRC(3ca46788) SHA1(35692ac22c25154ae07afab544752b076dd676e1) )
	ROM_LOAD16_BYTE( "95420245.hi", 0x00000, 0x080000, CRC(7128f8c4) SHA1(4a86803915da6eedc83256ce58d949bfd0656bd8) )
	ROM_LOAD16_BYTE( "95420246.lo", 0x00001, 0x080000, CRC(c79ed8a1) SHA1(1ddbb846e8eba6989e17b17244ea3d6b94a9b90f) )
	ROM_LOAD16_BYTE( "95420247.hi", 0x00000, 0x080000, CRC(8f729313) SHA1(481cfbae269e15c3378861f563af6fa3cbc7f6c6) )
	ROM_LOAD16_BYTE( "95421244.lo", 0x00001, 0x080000, CRC(7a7ed952) SHA1(069001a6f9df69ea96a4f3c0df5f05a4b8010e7f) )
	ROM_LOAD16_BYTE( "95421245.hi", 0x00000, 0x080000, CRC(af7e2ac6) SHA1(20b1a7f0bb4848c1aa5ea70d46c0878e8b1c0075) )
	ROM_LOAD16_BYTE( "95421246.lo", 0x00001, 0x080000, CRC(8144667b) SHA1(c405b14470c040fad9feedcc380bca3d8fa5e3b5) )
	ROM_LOAD16_BYTE( "95421247.hi", 0x00000, 0x080000, CRC(51244111) SHA1(22bcafaf3be09af115fc65d43fbba22bf24624a4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008950.bin", 0x0000, 0x0fabc8, CRC(291b1b0d) SHA1(9d4149d2eb1303742dcba6e0e6d1b914f8a4019e) )
ROM_END




ROM_START( sc_ppclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416532.odd", 0x00001, 0x080000, CRC(7fa63d03) SHA1(2953fc769c93067d9f9833fdf219277dc1c1dd3d) )
	ROM_LOAD16_BYTE( "95416533.evn", 0x00000, 0x080000, CRC(3f202212) SHA1(f611948bea5daa8a52c4c9223d35a62de44520b1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416582.odd", 0x00001, 0x080000, CRC(574d2e58) SHA1(1356f9048aa200654160cd51bdd3b86f80aac8d1) )
	ROM_LOAD16_BYTE( "95416583.evn", 0x00000, 0x080000, CRC(b89f1718) SHA1(d32640919d71f13b2febf3eb91eb5f230f6f5168) )
	ROM_LOAD16_BYTE( "95417532.odd", 0x00001, 0x080000, CRC(d7480cb5) SHA1(c2a718abf8a7557bebef8f6f65d44ff54d8ecb8d) )
	ROM_LOAD16_BYTE( "95417533.evn", 0x00000, 0x080000, CRC(c1e51ffd) SHA1(d0f9028998b17e9faaade381f1b23c48d6f592f1) )
	ROM_LOAD16_BYTE( "95417582.odd", 0x00001, 0x080000, CRC(e0598606) SHA1(2f0f009430d869a1a84d7650128d8c6c08cc6fc3) )
	ROM_LOAD16_BYTE( "95417583.evn", 0x00000, 0x080000, CRC(123209f2) SHA1(510d9776d6efad63d5b81b58d23d624e6a91d94f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008934.bin", 0x0000, 0x100000, CRC(87290522) SHA1(27deddd66b0ac9a0f4fe526f0eda7f6b2e73a8b6) )
	ROM_LOAD( "95008935.bin", 0x0000, 0x100000, CRC(7517053c) SHA1(d83019c52b8c78539359e9277864717c76fae0ce) )
ROM_END




ROM_START( sc_ppctc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422464.lo", 0x00001, 0x080000, CRC(0ba5370e) SHA1(37b54888de5a966f03f6656ca7b49fd8dd019e26) )
	ROM_LOAD16_BYTE( "95422465.hi", 0x00000, 0x080000, CRC(f17bd040) SHA1(2c2db2f50530fe8f31f763f53a1b324ad1dffce5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422690.lo", 0x00001, 0x080000, CRC(4d2fb15d) SHA1(bf0a5a2148ab22427721473748115c2eab62778b) )
	ROM_LOAD16_BYTE( "95422691.hi", 0x00000, 0x080000, CRC(bf0ca534) SHA1(640a462b40429e67eb4f91b929709a5b5189841b) )
	ROM_LOAD16_BYTE( "95422692.lo", 0x00001, 0x080000, CRC(5e3c95b0) SHA1(4fd32cf02a649dffac187b95f81dc4a103d56c99) )
	ROM_LOAD16_BYTE( "95422693.hi", 0x00000, 0x080000, CRC(d89a9ba8) SHA1(5f35bd1fc52ee5bab5ab7eeba6de1f7f84294f05) )
	ROM_LOAD16_BYTE( "95423464.lo", 0x00001, 0x080000, CRC(a8a14b06) SHA1(4bb2579e92ed2a5ed8457d63ac64236201076dd1) )
	ROM_LOAD16_BYTE( "95423465.hi", 0x00000, 0x080000, CRC(2c6a4641) SHA1(94d5e7629b5dc35258983538933e1353eb374673) )
	ROM_LOAD16_BYTE( "95423692.lo", 0x00001, 0x080000, CRC(84ac0e1e) SHA1(815376b520e31b1ccb6be53ef41284c82911012e) )
	ROM_LOAD16_BYTE( "95423693.hi", 0x00000, 0x080000, CRC(a1bb733d) SHA1(c5e602a851c09b87aec6a842bc76eeaf02104ee8) )
	ROM_LOAD16_BYTE( "95426126.lo", 0x00001, 0x080000, CRC(e9fc5d74) SHA1(73f4f8ca4cd0bfa75d6b8220de6dabe94ecc3ce5) )
	ROM_LOAD16_BYTE( "95426127.hi", 0x00000, 0x080000, CRC(60fd3c5b) SHA1(dd983b8b562cac1fd985e8024a7c468488c907a2) )
	ROM_LOAD16_BYTE( "95426128.lo", 0x00001, 0x080000, CRC(ec488c0b) SHA1(037ff47f20d8f1d2f5cfd5c260213ed32289f3ae) )
	ROM_LOAD16_BYTE( "95426129.hi", 0x00000, 0x080000, CRC(fb89adfe) SHA1(c1d5e00f0d2a659e95efcd3c41687196a1431c26) )
	ROM_LOAD16_BYTE( "95426266.lo", 0x00001, 0x080000, CRC(16ea49d3) SHA1(ebd48cecaf1ed697290b11a3b57c152e1c77b75d) )
	ROM_LOAD16_BYTE( "95426267.hi", 0x00000, 0x080000, CRC(d299bd7c) SHA1(2b5900391478628b4b479d44e877f0d164089116) )
	ROM_LOAD16_BYTE( "95426310.lo", 0x00001, 0x080000, CRC(309202fa) SHA1(ff452f80980e17421bee5b040232768d6175ffc6) )
	ROM_LOAD16_BYTE( "95426311.hi", 0x00000, 0x080000, CRC(81893269) SHA1(e3fe9dfface46586a10a2a318dbb6855a7d60804) )
	ROM_LOAD16_BYTE( "95426434.lo", 0x00001, 0x080000, CRC(37352ee1) SHA1(3e238ca82bbcf6fb75d5f3bc94f9d2c623076ee1) )
	ROM_LOAD16_BYTE( "95426435.hi", 0x00000, 0x080000, CRC(810defdc) SHA1(5e7b2cfaebba7042ec2937a899c64f17ab599a2b) )
	ROM_LOAD16_BYTE( "95426436.lo", 0x00001, 0x080000, CRC(fed3d211) SHA1(f5396be03f6f38d89400f6ceb5f7bd1fd41ef067) )
	ROM_LOAD16_BYTE( "95426437.hi", 0x00000, 0x080000, CRC(4df47290) SHA1(83277d83f61e7ea85fc69463da86496e0e1eba60) )
	ROM_LOAD16_BYTE( "95427126.lo", 0x00001, 0x080000, CRC(6663ebf4) SHA1(fae1c2eee4da774fbc9dd5ffc3e724e8af735810) )
	ROM_LOAD16_BYTE( "95427127.hi", 0x00000, 0x080000, CRC(dfe36f86) SHA1(86c1df753344826fa54249e6810765a12dd8e2ff) )
	ROM_LOAD16_BYTE( "95427128.lo", 0x00001, 0x080000, CRC(99f16112) SHA1(4bfe2aed95dafd57bb2533e8fbe181681f3abbeb) )
	ROM_LOAD16_BYTE( "95427129.hi", 0x00000, 0x080000, CRC(055affdc) SHA1(0e1cdb2b4ff8e219898e5f1bd0bc1bfcb9ab8efc) )
	ROM_LOAD16_BYTE( "95427266.lo", 0x00001, 0x080000, CRC(4b5f4373) SHA1(77523f5cd56842616e1283a26af3c4201b338eed) )
	ROM_LOAD16_BYTE( "95427267.hi", 0x00000, 0x080000, CRC(3cc3d99c) SHA1(c28fb51cb3f254c3f8c78b57b923d5a34368ef13) )
	ROM_LOAD16_BYTE( "95427310.lo", 0x00001, 0x080000, CRC(bb56330a) SHA1(433f63bcc52a7229682f57cdcb66f14341b3844e) )
	ROM_LOAD16_BYTE( "95427311.hi", 0x00000, 0x080000, CRC(adaca46e) SHA1(4e8359fae8b47aebb3b6b3dddfbd18f5088159f8) )
	ROM_LOAD16_BYTE( "95427434.lo", 0x00001, 0x080000, CRC(1345ed9f) SHA1(482578d3ae071700d74b795ecb7d4c07f2f19992) )
	ROM_LOAD16_BYTE( "95427435.hi", 0x00000, 0x080000, CRC(025eef01) SHA1(186fe5136d787cbab233c515cae905a0a50c3d61) )
	ROM_LOAD16_BYTE( "95427436.lo", 0x00001, 0x080000, CRC(9160be79) SHA1(cd49cbe395e6e4c2fd51f1af7d8e260aeeba0ca6) )
	ROM_LOAD16_BYTE( "95427437.hi", 0x00000, 0x080000, CRC(b7d1dc1c) SHA1(1439831d81c6faa82b4b2db3f8b0900e62fc932a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008785.bin", 0x0000, 0x100000, CRC(4f2284e6) SHA1(4a85bce29d9ae7181aef8874d46928e397ba915a) )
	ROM_LOAD( "95008786.bin", 0x0000, 0x100000, CRC(2c96e78e) SHA1(feab56483b6075ffcf8f60f8c573198ee91e7d64) )
ROM_END




ROM_START( sc_ppdym )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420184.lo", 0x00001, 0x080000, CRC(4fabac48) SHA1(726375dfcd6ae398cc8f0e881397eb0725cd9dfe) )
	ROM_LOAD16_BYTE( "95420185.hi", 0x00000, 0x080000, CRC(9b633133) SHA1(98407648c17234d618b7043dbd98c8366c68ac01) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420252.lo", 0x00001, 0x080000, CRC(e631e32e) SHA1(517b3293c557d54663af4da8d50d666024e7bf81) )
	ROM_LOAD16_BYTE( "95420253.hi", 0x00000, 0x080000, CRC(bec22413) SHA1(d0af3cb560875fbc3315379e8ff8d42c5d3b1b99) )
	ROM_LOAD16_BYTE( "95420254.lo", 0x00001, 0x080000, CRC(dc00db5a) SHA1(ee7fd8be5138584c21621573ce4af2818605767e) )
	ROM_LOAD16_BYTE( "95420255.hi", 0x00000, 0x080000, CRC(55dd6e02) SHA1(73468521c7ac3b89479a4c0a5a989a379ac356c5) )
	ROM_LOAD16_BYTE( "95420256.lo", 0x00001, 0x080000, CRC(c31e185b) SHA1(a3d6c19ca5f0977e365daec5bcb92d96ee5353af) )
	ROM_LOAD16_BYTE( "95420257.hi", 0x00000, 0x080000, CRC(20139ac8) SHA1(3319b4cb7d747895b119d814b2af7cb4a1d46d58) )
	ROM_LOAD16_BYTE( "95420258.lo", 0x00001, 0x080000, CRC(17abf764) SHA1(f5c7f2c859c0326e1e760c2c25fa1d66710291a5) )
	ROM_LOAD16_BYTE( "95420259.hi", 0x00000, 0x080000, CRC(4f4f4e60) SHA1(d483639e0330bc72f0877bd41123a7d80af69175) )
	ROM_LOAD16_BYTE( "95420260.lo", 0x00001, 0x080000, CRC(b15be884) SHA1(a40a6681c47f19454f3bfb0d1e2b22d50ac92bf0) )
	ROM_LOAD16_BYTE( "95420261.hi", 0x00000, 0x080000, CRC(7ab8cac4) SHA1(0751e27cc6d71f818f954690ad8cfb6ae3393e5c) )
	ROM_LOAD16_BYTE( "95421184.lo", 0x00001, 0x080000, CRC(d7534170) SHA1(a7f85af72642070f113f1d54cc67dc25ab15f882) )
	ROM_LOAD16_BYTE( "95421185.hi", 0x00000, 0x080000, CRC(fd29bd92) SHA1(3ce5999dddc3492402d5d1f45a4f020dbbc8645c) )
	ROM_LOAD16_BYTE( "95421252.lo", 0x00001, 0x080000, CRC(1f5eddad) SHA1(f8d7177619fc01f23a2cbdc62e2d4dfd86a047ac) )
	ROM_LOAD16_BYTE( "95421253.hi", 0x00000, 0x080000, CRC(f2e18ca3) SHA1(ae67fc735382769d806f8e4b592dd9b9dc18b73d) )
	ROM_LOAD16_BYTE( "95421254.lo", 0x00001, 0x080000, CRC(c642306d) SHA1(aefca567a8a4b04b816355043bd9341736b69a41) )
	ROM_LOAD16_BYTE( "95421255.hi", 0x00000, 0x080000, CRC(c7eaacc2) SHA1(b98bfb1707f016c346ae3d1ac9de35b919e15ac4) )
	ROM_LOAD16_BYTE( "95421256.lo", 0x00001, 0x080000, CRC(61b0a402) SHA1(5a3a41ab78aefa710658d559a512fb0fa1d35481) )
	ROM_LOAD16_BYTE( "95421257.hi", 0x00000, 0x080000, CRC(ae1b225e) SHA1(9d31e5ab3c7b191bd21636328886457edcf4f161) )
	ROM_LOAD16_BYTE( "95421258.lo", 0x00001, 0x080000, CRC(b5054b3d) SHA1(475c124e9f1e6ff36af1cb11213be25aa36e218a) )
	ROM_LOAD16_BYTE( "95421259.hi", 0x00000, 0x080000, CRC(c147f6f6) SHA1(a3dffa78141da38a6af91c8c6f6ecda265d2ac86) )
	ROM_LOAD16_BYTE( "95421260.lo", 0x00001, 0x080000, CRC(9b598668) SHA1(e792859d3ac54cfa5f61174f4e3caa278b70811c) )
	ROM_LOAD16_BYTE( "95421261.hi", 0x00000, 0x080000, CRC(cf1bd3c7) SHA1(de899932f85f86b1f8631ff5d86f567ab1fcba2c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008984.bin", 0x0000, 0x0e6770, CRC(8257c559) SHA1(9088fd4d28ad9701767a2a255164e7201410c33a) )
	ROM_LOAD( "95008989.bin", 0x0000, 0x0e6770, CRC(fb60e407) SHA1(50f7ed9d2106db2f1e746081d7ca768177e7680c) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890483.bin", 0x0000, 0x5000, CRC(0ee68077) SHA1(163a46b16da238123cd542a62119dbaa726fca1b) )
	ROM_LOAD( "95890484.bin", 0x0000, 0x5000, CRC(123070cb) SHA1(4f3b313c3f7bd43120dd390fd9a187523838f559) )
	ROM_LOAD( "95890485.bin", 0x0000, 0x5000, CRC(d16a525b) SHA1(7358a180b1db0e2c5f4442481e9483a1170974a1) )
ROM_END




ROM_START( sc_ppsag )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416850.lo", 0x00001, 0x080000, CRC(aae094f5) SHA1(cc52856f2e4e408efa87512eb2d6e48a3d73bf18) )
	ROM_LOAD16_BYTE( "95416851.hi", 0x00000, 0x080000, CRC(e2e5b214) SHA1(ee0944deb1b6a4157d79b78432af562147dbab45) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416852.lo", 0x00001, 0x080000, CRC(47305788) SHA1(e1c8cfb955e1a57d1ae4a8403d06a2aacf7d97b0) )
	ROM_LOAD16_BYTE( "95416853.hi", 0x00000, 0x080000, CRC(36d86975) SHA1(2836fc304fd4d2a195280f46e726551420e8841b) )
	ROM_LOAD16_BYTE( "95416854.lo", 0x00001, 0x080000, CRC(6ccf70e6) SHA1(07ffcccc9b659d2aa3dd24c13248d518f5cf60f0) )
	ROM_LOAD16_BYTE( "95416855.hi", 0x00000, 0x080000, CRC(39058a12) SHA1(64252b0aa3a11dde76cb349c00d216fbdf867f0f) )
	ROM_LOAD16_BYTE( "95417850.lo", 0x00001, 0x080000, CRC(e35588b6) SHA1(c8aaa985046c8b3ade60eabc829a93526574385d) )
	ROM_LOAD16_BYTE( "95417851.hi", 0x00000, 0x080000, CRC(2fc88c61) SHA1(03474d91ae0f8e1ce5ef2ec18c82c84c7df32cb0) )
	ROM_LOAD16_BYTE( "95417852.lo", 0x00001, 0x080000, CRC(2fcc1a03) SHA1(ba33b093d511dcadd1eccb1752acd5d94083641b) )
	ROM_LOAD16_BYTE( "95417853.hi", 0x00000, 0x080000, CRC(bbb254aa) SHA1(7f5af2dd430ad5c3c0af453c6dcb71e8f855b808) )
	ROM_LOAD16_BYTE( "95417854.lo", 0x00001, 0x080000, CRC(7d6b16b9) SHA1(77faab5358a889cd957826ef62f836ac8a0d2a20) )
	ROM_LOAD16_BYTE( "95417855.hi", 0x00000, 0x080000, CRC(0dd3449b) SHA1(42c875cd8814fda08a2b92a76357c485f85c43b9) )
	ROM_LOAD16_BYTE( "95420650.lo", 0x00001, 0x080000, CRC(f9909656) SHA1(f1ba1eb0e4bd9dd2c78989d4af4ad5a14f205fd3) )
	ROM_LOAD16_BYTE( "95420651.hi", 0x00000, 0x080000, CRC(0027e675) SHA1(c0adc5d429b5585419d5c73dbca341358873c52a) )
	ROM_LOAD16_BYTE( "95420652.lo", 0x00001, 0x080000, CRC(716f0145) SHA1(1c2a177c46c86dc5d82b134daf38bcb0a2dbc0a1) )
	ROM_LOAD16_BYTE( "95420653.hi", 0x00000, 0x080000, CRC(c1f2b832) SHA1(747cce25da72a41299d906e2d6488ecddca93076) )
	ROM_LOAD16_BYTE( "95420654.lo", 0x00001, 0x080000, CRC(b027d88a) SHA1(ee8c6192903388efd03e43da5f587a7f56c8bd3d) )
	ROM_LOAD16_BYTE( "95420655.hi", 0x00000, 0x080000, CRC(d0b01358) SHA1(708bd126479af6efe135a75bea5c44fb21de245e) )
	ROM_LOAD16_BYTE( "95420656.lo", 0x00001, 0x080000, CRC(a9f86751) SHA1(342ac92cde5655d4c542022629c7800bc81b1d7d) )
	ROM_LOAD16_BYTE( "95420657.hi", 0x00000, 0x080000, CRC(672112b3) SHA1(7e829e730eef6fdff56231186207b45802f23718) )
	ROM_LOAD16_BYTE( "95420658.lo", 0x00001, 0x080000, CRC(502c16e0) SHA1(399d497c715acfc4100db687362d3ff9fa344431) )
	ROM_LOAD16_BYTE( "95420659.hi", 0x00000, 0x080000, CRC(1333317e) SHA1(2192318f4b109b621996c978132fc2184c8edddc) )
	ROM_LOAD16_BYTE( "95421650.lo", 0x00001, 0x080000, CRC(0ff59c56) SHA1(96b39ae9c10f15c3a43f03c7f12a4ac500ea0fdd) )
	ROM_LOAD16_BYTE( "95421651.hi", 0x00000, 0x080000, CRC(9247e99e) SHA1(c14b23d56baec2e1732d7d2c9017e206dd672bb0) )
	ROM_LOAD16_BYTE( "95421652.lo", 0x00001, 0x080000, CRC(5c2a90f0) SHA1(6916b6a264f7808cb2ef219881254a0339260b85) )
	ROM_LOAD16_BYTE( "95421653.hi", 0x00000, 0x080000, CRC(ddb93395) SHA1(07a469e42f2ef4c1c02228ceb18f58c391e895f2) )
	ROM_LOAD16_BYTE( "95421654.lo", 0x00001, 0x080000, CRC(25562da8) SHA1(6cf97a68ebd12c2cb8795aedbdc74679e119f81f) )
	ROM_LOAD16_BYTE( "95421655.hi", 0x00000, 0x080000, CRC(9d149db2) SHA1(f087e587b8daaf1a41c548ac0794abaa8f4bb393) )
	ROM_LOAD16_BYTE( "95421656.lo", 0x00001, 0x080000, CRC(45398da6) SHA1(af6952b9a5d3227b7a0a4cbffb28300bf1382b70) )
	ROM_LOAD16_BYTE( "95421657.hi", 0x00000, 0x080000, CRC(1d6c679b) SHA1(3e472ec667b5be18d2c9a60bcd7332b07ab36804) )
	ROM_LOAD16_BYTE( "95421658.lo", 0x00001, 0x080000, CRC(9da87bb1) SHA1(af75053155beaa91c505ad76d091a3fe53eb886f) )
	ROM_LOAD16_BYTE( "95421659.hi", 0x00000, 0x080000, CRC(a28b47c1) SHA1(1360564809d47d581f4d18de9e48ae51e24f59f6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008975.bin", 0x0000, 0x100000, CRC(0203bef7) SHA1(01b1f3225eb97303a3ddc678ad51aef90d2bb84a) )
ROM_END




ROM_START( sc_pptp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416532.odd", 0x00001, 0x080000, CRC(7fa63d03) SHA1(2953fc769c93067d9f9833fdf219277dc1c1dd3d) )
	ROM_LOAD16_BYTE( "95416533.evn", 0x00000, 0x080000, CRC(3f202212) SHA1(f611948bea5daa8a52c4c9223d35a62de44520b1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008934.bin", 0x0000, 0x100000, CRC(87290522) SHA1(27deddd66b0ac9a0f4fe526f0eda7f6b2e73a8b6) )
	ROM_LOAD( "95008935.bin", 0x0000, 0x100000, CRC(7517053c) SHA1(d83019c52b8c78539359e9277864717c76fae0ce) )
ROM_END




ROM_START( sc_pipe )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408732.lo", 0x00001, 0x080000, CRC(4cc1d302) SHA1(74a8e5b457a51285245d58c14afe0cf3835c44bf) )
	ROM_LOAD16_BYTE( "95408733.hi", 0x00000, 0x080000, CRC(78dc99e5) SHA1(67f38232da9aeeb33c4e600bcee3b5c552a2a387) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409732.lo", 0x00001, 0x080000, CRC(35e374ee) SHA1(a79caff9a0dfb0048a83a932d70f9034a9ed2820) )
	ROM_LOAD16_BYTE( "95409733.hi", 0x00000, 0x080000, CRC(391b1ceb) SHA1(e9016f80695f9812676df3899758d38bee19e765) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95408732", 0x0000, 0x100000, CRC(f283b171) SHA1(6976f32bc88ec58c897df41aef51508f5fd92e9f) )
	ROM_LOAD( "95408732.bin", 0x0000, 0x100000, CRC(f283b171) SHA1(6976f32bc88ec58c897df41aef51508f5fd92e9f) )
	ROM_LOAD( "pipingsnd.bin", 0x0000, 0x0c50d9, CRC(ff240faa) SHA1(f0961b3207c0c8779479c773d1453ac4ff376bd2) )

	ROM_REGION( 0x400000, "others", ROMREGION_ERASE00 )
	ROM_LOAD( "95409732.bin", 0x0000, 0x100000, CRC(1d3875c0) SHA1(73a59320cf3ef30535bb5617106354ca271e3db4) ) // combined?
ROM_END




ROM_START( sc_plumb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "91414380.odd", 0x00001, 0x080000, CRC(81fc3ea4) SHA1(21b92e7cbba5b13def9275a994bb96bda7991f5c) )
	ROM_LOAD16_BYTE( "91414381.evn", 0x00000, 0x080000, CRC(3ab009fb) SHA1(e0e1e3a83ebce24c8363c51f4c1e731dced4f818) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "91415380.odd", 0x00001, 0x080000, CRC(7d72768f) SHA1(1fef9b6701e561814f00484e2e480707d0038410) )
	ROM_LOAD16_BYTE( "91415381.evn", 0x00000, 0x080000, CRC(3a2f5fc3) SHA1(958628b151402cb93ea5a899049889f0e09d87e1) )
	ROM_LOAD16_BYTE( "95410914.odd", 0x00001, 0x080000, CRC(01affca7) SHA1(37b8c3dd3c695bb281afe7ebb19bb929b7220072) )
	ROM_LOAD16_BYTE( "95410915.evn", 0x00000, 0x080000, CRC(05f5a2ee) SHA1(f6e4de5a61495e8325c940c2984cfa2099b7b766) )
	ROM_LOAD16_BYTE( "95411914.odd", 0x00001, 0x080000, CRC(942e5500) SHA1(a211f37198bfdc49859e0abf271a52272e38fc65) )
	ROM_LOAD16_BYTE( "95411915.evn", 0x00000, 0x080000, CRC(eddccd9a) SHA1(d5e21cefb8e5341f3d6cc2d5e93e80fc390fe4a2) )
	ROM_LOAD16_BYTE( "95412162.odd", 0x00001, 0x080000, CRC(092eafc4) SHA1(e23b25850c441569e329cc0edb766d81fc3872cc) )
	ROM_LOAD16_BYTE( "95412163.evn", 0x00000, 0x080000, CRC(7d858ac1) SHA1(c947c345dc8ee9b37f8d05be7741792402956e18) )
	ROM_LOAD16_BYTE( "95413162.odd", 0x00001, 0x080000, CRC(f5a0e7ef) SHA1(306ccc811b551a6090363c6b19177f8552f598be) )
	ROM_LOAD16_BYTE( "95413163.evn", 0x00000, 0x080000, CRC(7d1adcf9) SHA1(f174e06efe0b6e714ab3a8496326a14b1d3ae0d7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008430.bin", 0x0000, 0x0c690f, CRC(29059625) SHA1(4e46f794726b778e03f67ab3ec3cd4cb71be0b64) )
ROM_END




ROM_START( sc_polem )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400283.lo", 0x00001, 0x080000, CRC(c03a6f6b) SHA1(d333cf1348e8d52f8402d70e03c7b94638f2550a) )
	ROM_LOAD16_BYTE( "95400284.hi", 0x00000, 0x080000, CRC(3f8a3d85) SHA1(d6388a41002f22094792230b1f381bf7363642ca) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400373.lo", 0x00001, 0x080000, CRC(2a7df310) SHA1(b4556d086cc2889b1757c38524f7748d851134bf) )
	ROM_LOAD16_BYTE( "95400374.hi", 0x00000, 0x080000, CRC(e60935ad) SHA1(a453d835e219ea4552026237e99fd00cefa24bc2) )
	ROM_LOAD16_BYTE( "95400605.lo", 0x00001, 0x080000, CRC(5665ea74) SHA1(e25d11640eb81d8be99d16f33322648e3f5c89b8) )
	ROM_LOAD16_BYTE( "95400606.hi", 0x00000, 0x080000, CRC(9a37c598) SHA1(3865444a452937c79f7c2e2288a0a6bd35b4d635) )
	ROM_LOAD16_BYTE( "95401285.lo", 0x00001, 0x080000, CRC(42fbf8ac) SHA1(b06e6ffcb750b6bfde8b4f084acd22f0d4edce35) )
	ROM_LOAD16_BYTE( "95401286.hi", 0x00000, 0x080000, CRC(5ae2c2f1) SHA1(3313754716f438761e82dcb5dd64c8c34c09f337) )
	ROM_LOAD16_BYTE( "95401605.lo", 0x00001, 0x080000, CRC(fffd9ae2) SHA1(f47a3ed9b66526cf4b73d3cc5fda644e329f22bc) )
	ROM_LOAD16_BYTE( "95401606.hi", 0x00000, 0x080000, CRC(280e1ac8) SHA1(275ecae649c323f9d716cc7e549e3e25428cffaf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	// might not be for this set
	ROM_LOAD( "pole_p.sn1", 0x000000, 0x080000, CRC(cbb7b019) SHA1(1404ff5fe2c3e54370a79ea141617e58e56217e9) )
	ROM_LOAD( "pole_p.sn2", 0x080000, 0x080000, CRC(95d9939b) SHA1(29d03f2f2d33a807df002271e14b614bae3d10e4) )

ROM_END




ROM_START( sc_polen )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p7012s13.hi", 0x00000, 0x080000, CRC(83367285) SHA1(4ba6bfc0d33607eadcb0600d0318cf682840008c) )
	ROM_LOAD16_BYTE( "p7012s13.lo", 0x00001, 0x080000, CRC(3ef0e8ce) SHA1(a9c12c8a8c47a2a69559cffc9b9a74f3ceb6ebe8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "polesnd1.bin", 0x0000, 0x080000, CRC(09f720e3) SHA1(1a5c581b16b974e949679c3d71696984755f3c7c) )
	ROM_LOAD( "polesnd2.bin", 0x0000, 0x080000, CRC(80c2702b) SHA1(6c7b1d535d8f1eeb25a1a84ccf9e97b3e453af6d) )
ROM_END




ROM_START( sc_polic )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408136.odd", 0x00001, 0x080000, CRC(94c881c6) SHA1(81c180ec446a43c7281f4cb405d78bde12b67007) )
	ROM_LOAD16_BYTE( "95408137.evn", 0x00000, 0x080000, CRC(4df0a90a) SHA1(63c568f9478e70edae45809d040c2a8e7f3619c0) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408514.odd", 0x00001, 0x080000, CRC(fea13625) SHA1(5fa2b331b00b7771c71fd3f3bcda0dbe69321d9f) )
	ROM_LOAD16_BYTE( "95408515.evn", 0x00000, 0x080000, CRC(b847bdd8) SHA1(02ed59dc67ef9acee005e7346fd407de8dba8f22) )
	ROM_LOAD16_BYTE( "95409136.odd", 0x00001, 0x080000, CRC(1df681c9) SHA1(a2afb717e3bd6b95ff22806b0c032317760d1f30) )
	ROM_LOAD16_BYTE( "95409137.evn", 0x00000, 0x080000, CRC(d0f3ddb4) SHA1(216ea4bd35b786947e213915defea2cb7abc5f3a) )
	ROM_LOAD16_BYTE( "95409514.odd", 0x00001, 0x080000, CRC(73288dc0) SHA1(c1350ea22cbeed9d9914eb2437ba067d3194f444) )
	ROM_LOAD16_BYTE( "95409515.evn", 0x00000, 0x080000, CRC(69277de1) SHA1(17fb6ec5de1aad51e83c8a547d8d99e43d5a19b8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008327.bin", 0x0000, 0x0d24fe, CRC(767251af) SHA1(9cc9f4f2c6f6762a1929b845521549256e9b9f4f) )
ROM_END




ROM_START( sc_pony )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410818.lo", 0x00001, 0x080000, CRC(f32862a6) SHA1(25014beb93fc8fa71a060d1a1147e3633ae7a975) )
	ROM_LOAD16_BYTE( "95410819.hi", 0x00000, 0x080000, CRC(0a181038) SHA1(616ec4ae6b6371b39e443ac14a98c3ed432b85cc) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410820.lo", 0x00001, 0x080000, CRC(717559ad) SHA1(4748ab9dd5b48b24abf906cf3a66621ba9da9a70) )
	ROM_LOAD16_BYTE( "95410821.hi", 0x00000, 0x080000, CRC(64f25da0) SHA1(5472714e8caafb743e84d3e4bfd6050fe84dcbed) )
	ROM_LOAD16_BYTE( "95411818.lo", 0x00001, 0x080000, CRC(1216e85c) SHA1(e75b0ff8c77c83fc4d554a83421c2e5abaf8231b) )
	ROM_LOAD16_BYTE( "95411819.hi", 0x00000, 0x080000, CRC(93f39632) SHA1(18e1fe98a5a1300f161606683e63562d30d4be1c) )
	ROM_LOAD16_BYTE( "95412413.hi", 0x00000, 0x080000, CRC(146ae98a) SHA1(e8d3694fd7aeee029196718d901b853bf0b6d1e0) )
	ROM_LOAD16_BYTE( "95412414.lo", 0x00001, 0x080000, CRC(15f51b2c) SHA1(95866a81d56f4d1b454e92cef4d7c3c77545516d) )
	ROM_LOAD16_BYTE( "95412416.lo", 0x00001, 0x080000, CRC(b0cd85c0) SHA1(87b79c9073f65069eb0bb6742827f56149a11841) )
	ROM_LOAD16_BYTE( "95412417.hi", 0x00000, 0x080000, CRC(f6b9e24a) SHA1(96b0b85fcf7f7720326ffd99a5090771920679aa) )
	ROM_LOAD16_BYTE( "95412570.lo", 0x00001, 0x080000, CRC(d5574439) SHA1(ec44555d33644fe3c1f91592eb38716293580c5e) )
	ROM_LOAD16_BYTE( "95412571.hi", 0x00000, 0x080000, CRC(b5353d72) SHA1(3dd462578316125af3b16259633bf58077a52054) )
	ROM_LOAD16_BYTE( "95412572.lo", 0x00001, 0x080000, CRC(b73917fc) SHA1(215e1b312bd31daf9b5240263749d2a9ad10b397) )
	ROM_LOAD16_BYTE( "95412573.hi", 0x00000, 0x080000, CRC(e05230c7) SHA1(d5b7687f3c8cf854fd882db3f7dee6085503e092) )
	ROM_LOAD16_BYTE( "95413414.lo", 0x00001, 0x080000, CRC(099871db) SHA1(6ad202c2ac3cd79d6895e8ff1b6286fd3d27f207) )
	ROM_LOAD16_BYTE( "95413415.hi", 0x00000, 0x080000, CRC(109696d7) SHA1(af102a1e92e1d61071b01e2cdab0f79900c2b3de) )
	ROM_LOAD16_BYTE( "95413416.lo", 0x00001, 0x080000, CRC(299d0d93) SHA1(cb290d4f2df5eaf8a512a7f76c9ee89bf8ef36f4) )
	ROM_LOAD16_BYTE( "95413417.hi", 0x00000, 0x080000, CRC(0586a54d) SHA1(bbc095f9774519df59dcb5752b58c2820382d7f5) )
	ROM_LOAD16_BYTE( "95413570.lo", 0x00001, 0x080000, CRC(f0cd5b4a) SHA1(4a64785406a0cf6ccee883f96046616f37d28192) )
	ROM_LOAD16_BYTE( "95413571.hi", 0x00000, 0x080000, CRC(671b829c) SHA1(42bd1a88408cbff7bb0cd42c27396d377135ed04) )
	ROM_LOAD16_BYTE( "95413572.lo", 0x00001, 0x080000, CRC(ab9b41f7) SHA1(7d5af49807722755be5dbc7bad6e39094157bf65) )
	ROM_LOAD16_BYTE( "95413573.hi", 0x00000, 0x080000, CRC(e8197256) SHA1(e61b601a4969aa29a6fc9e1099a3293bfa5f1741) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008408.bin", 0x0000, 0x100000, CRC(a28ef50e) SHA1(c5080418585a37ea63372b427c7e67b8c010f40c) )
ROM_END




ROM_START( sc_popey )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422942.lo", 0x00001, 0x080000, CRC(7a6e1be3) SHA1(d57281ca12ca9ff1b7bb3c6fa10d2f42bef93ffd) )
	ROM_LOAD16_BYTE( "95422943.hi", 0x00000, 0x080000, CRC(ca6a8fa6) SHA1(2d0ca03086fadb467f7886ab9a1ab4c240f18bf7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422944.lo", 0x00001, 0x080000, CRC(6574748c) SHA1(a68b472344c1e9578f5385db40043e96c40529ec) )
	ROM_LOAD16_BYTE( "95422945.hi", 0x00000, 0x080000, CRC(1e567cd4) SHA1(f9be5b9c95d3d5e46fbf9370e3678e07a747a0da) )
	ROM_LOAD16_BYTE( "95423942.lo", 0x00001, 0x080000, CRC(0ec64fe9) SHA1(450f5deb83968b3a02ea65f919c767eb9e66346a) )
	ROM_LOAD16_BYTE( "95423943.hi", 0x00000, 0x080000, CRC(2af8755b) SHA1(d0ae0805cadf28c75dbad9e352c3d0c0189b2b2e) )
	ROM_LOAD16_BYTE( "95423944.lo", 0x00001, 0x080000, CRC(f62e0c94) SHA1(01ed67146c8a66db3d7ee644aaa217292e9eab94) )
	ROM_LOAD16_BYTE( "95423945.hi", 0x00000, 0x080000, CRC(47f7918c) SHA1(241acbb11894c73b8db2f4b7faaeba8367efe8c6) )
	ROM_LOAD16_BYTE( "95426390.lo", 0x00001, 0x080000, CRC(8f002e83) SHA1(7d20c51ffcb0cfb98109e85aee77dd55c9ede039) )
	ROM_LOAD16_BYTE( "95426391.hi", 0x00000, 0x080000, CRC(280060b2) SHA1(7b602b482e5ba0d567a632653223cc7ce2ca05d5) )
	ROM_LOAD16_BYTE( "95426412.lo", 0x00001, 0x080000, CRC(67b78fb2) SHA1(25db065628407714aa22110db08d613be58dcc2d) )
	ROM_LOAD16_BYTE( "95426413.hi", 0x00000, 0x080000, CRC(4c45c138) SHA1(3d44ee85cbbd80166a0f9ab3eb0e8131125aa64f) )
	ROM_LOAD16_BYTE( "95427390.lo", 0x00001, 0x080000, CRC(feb87ed6) SHA1(214c5f6e488cd428ca39c548affb339a31b85998) )
	ROM_LOAD16_BYTE( "95427391.hi", 0x00000, 0x080000, CRC(e9b15649) SHA1(48475a6547d33d876abfd10794850c313e8e7f27) )
	ROM_LOAD16_BYTE( "95427412.lo", 0x00001, 0x080000, CRC(ca63ceff) SHA1(24aff1c4415215e4dc99979e96570d872c757d4b) )
	ROM_LOAD16_BYTE( "95427413.hi", 0x00000, 0x080000, CRC(afa7dbe5) SHA1(6cc2c80082734c2f9a0ef4f472ba8b61431e443b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008798.bin", 0x0000, 0x100000, CRC(916cb144) SHA1(c75fa7a27be4e8dbd85fa074f6228877b5c86fc9) )
	ROM_LOAD( "95008799.bin", 0x0000, 0x100000, CRC(2f4c8eb6) SHA1(ca02b32705352735c4217aa20e9bc82eac8c3645) )
ROM_END




ROM_START( sc_potsh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410908.odd", 0x00001, 0x080000, CRC(e4982864) SHA1(fce3f36b19bf084fa9f3644f30d5b57b2e370e90) )
	ROM_LOAD16_BYTE( "95410909.evn", 0x00000, 0x080000, CRC(e50630e3) SHA1(52b44577e4d306c9b48e7c52c8906f5b48268c06) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95411908.odd", 0x00001, 0x080000, CRC(1dcd6b86) SHA1(f734801b89a1d12d86aaba0c0af5a4d4216f56dc) )
	ROM_LOAD16_BYTE( "95411909.evn", 0x00000, 0x080000, CRC(f1086ca0) SHA1(5263ad310c514e6f8b8c4dd423e093d8181bdf15) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008431.bin", 0x0000, 0x0ffeaf, CRC(400843fd) SHA1(35a0195b120e61c40e8f5e193b44f9fcb5b7d99d) )
ROM_END




ROM_START( sc_pog )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418746.lo", 0x00001, 0x080000, CRC(6ec2f94f) SHA1(6ea688cc7c69c0a50ba59cd1e3c55a67f4b8b980) )
	ROM_LOAD16_BYTE( "95418747.hi", 0x00000, 0x080000, CRC(899d9f95) SHA1(170803aec2875223424a09326d74a335b2a1efa6) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418748.lo", 0x00001, 0x080000, CRC(e4532be2) SHA1(8e30052f398da4b5503f43b4da84515aea0609e4) )
	ROM_LOAD16_BYTE( "95418749.hi", 0x00000, 0x080000, CRC(ddd43bef) SHA1(e8a987a01d3d5ec34fbb2f7751ae0c5738fe2d0e) )
	ROM_LOAD16_BYTE( "95418831.hi", 0x00000, 0x080000, CRC(f00cd02c) SHA1(aad7c56f6e62ab234f13b9542da045cac5b961f1) )
	ROM_LOAD16_BYTE( "95418832.lo", 0x00001, 0x080000, CRC(8cf1e293) SHA1(c3dcb8da31a4509b6845f0c3df9058f82a369919) )
	ROM_LOAD16_BYTE( "95418833.hi", 0x00000, 0x080000, CRC(d314c0ae) SHA1(06307af500d28d05518c67f554955567d2d0e1ca) )
	ROM_LOAD16_BYTE( "95419746.lo", 0x00001, 0x080000, CRC(fde32cb2) SHA1(2627f19e787cd9f88d53e3dab6cfd5809912e39c) )
	ROM_LOAD16_BYTE( "95419747.hi", 0x00000, 0x080000, CRC(2dd74466) SHA1(023af3659bbb31856364e33de1b3a03579248310) )
	ROM_LOAD16_BYTE( "95419748.lo", 0x00001, 0x080000, CRC(4a18ab52) SHA1(9230678bf1103a509a6d633ee23f314cee98df4b) )
	ROM_LOAD16_BYTE( "95419749.hi", 0x00000, 0x080000, CRC(b288ef47) SHA1(419f22abe8bd8b5dd79e5b1610a6c4551af1abe8) )
	ROM_LOAD16_BYTE( "95419831.hi", 0x00000, 0x080000, CRC(c47e18d0) SHA1(6a2f89c2f5501d6f0c1af89ce20adc9c1a09deb1) )
	ROM_LOAD16_BYTE( "95419832.lo", 0x00001, 0x080000, CRC(7e455361) SHA1(5f0ecd8ff94c720b378ea5b7523b9a8fc89e10c4) )
	ROM_LOAD16_BYTE( "95419833.hi", 0x00000, 0x080000, CRC(36999e53) SHA1(e818fd7f758f312fe1308bd9c448e70b02fb991e) )
	ROM_LOAD16_BYTE( "95422096.lo", 0x00001, 0x080000, CRC(634b915f) SHA1(a64fa41d97d209774e403650e75f02039c714050) )
	ROM_LOAD16_BYTE( "95422097.hi", 0x00000, 0x080000, CRC(393eeb18) SHA1(a73ddeaad545fc72e7bb970cc5884837df991412) )
	ROM_LOAD16_BYTE( "95422098.lo", 0x00001, 0x080000, CRC(df9436de) SHA1(007f9b44c213975114e93300482238ecfb22e62e) )
	ROM_LOAD16_BYTE( "95422099.hi", 0x00000, 0x080000, CRC(f943ec13) SHA1(d422a99531ae4ef7b04faa63aae3fa19b5135e7c) )
	ROM_LOAD16_BYTE( "95423097.hi", 0x00000, 0x080000, CRC(6c02b85d) SHA1(be8c898788cc826812a16eece855ce3f21cb1740) )
	ROM_LOAD16_BYTE( "95423098.lo", 0x00001, 0x080000, CRC(5115ce33) SHA1(0038f1b1f7849f526ad857a0613ae5d9fd0160fe) )
	ROM_LOAD16_BYTE( "95423099.hi", 0x00000, 0x080000, CRC(8f28229d) SHA1(c3a26273baf1c081cedc01446846115acad1e318) )
	ROM_LOAD16_BYTE( "95426442.lo", 0x00001, 0x080000, CRC(021dbcd3) SHA1(129c49001c9fb87277b1da0fe997822cd68d6833) )
	ROM_LOAD16_BYTE( "95426443.hi", 0x00000, 0x080000, CRC(974f325d) SHA1(790efeff7b7a3f72a1cf1235771a7757cf844676) )
	ROM_LOAD16_BYTE( "95427442.lo", 0x00001, 0x080000, CRC(a461d588) SHA1(93fb5c6b145e5b4291ef3720fad5d527d27ebbda) )
	ROM_LOAD16_BYTE( "95427443.hi", 0x00000, 0x080000, CRC(f3bcb341) SHA1(0bbfb2d661c99a9dbc5547e73c775b6e1a7cb8b5) )
	ROM_LOAD16_BYTE( "g95426376.lo", 0x00001, 0x080000, CRC(9f6b3222) SHA1(044065bfa7f68474351f08c9e1535bd4a590d258) )
	ROM_LOAD16_BYTE( "g95426377.hi", 0x00000, 0x080000, CRC(02d55db3) SHA1(20e23360cebef9bc93ee2cc21d5851ffddf97e22) )
	ROM_LOAD16_BYTE( "g95426574.lo", 0x00001, 0x080000, CRC(2713029a) SHA1(255162dff74f9a68c91b5e3f08423d27b078ebcd) )
	ROM_LOAD16_BYTE( "g95426575.hi", 0x00000, 0x080000, CRC(3e12bf73) SHA1(00419f72131e341a350056f06e12eddfa3a93dca) )
	ROM_LOAD16_BYTE( "g95426622.lo", 0x00001, 0x080000, CRC(fbc0286a) SHA1(0b9b1fef673fac90357799c54aa9b51a0bb97086) )
	ROM_LOAD16_BYTE( "g95426623.hi", 0x00000, 0x080000, CRC(778fbd39) SHA1(b7087cba148d8b1f700a765f6556c48d08c00a4e) )
	ROM_LOAD16_BYTE( "g95427376.lo", 0x00001, 0x080000, CRC(932ba997) SHA1(07247a44c79e7afbe9de887c29051fbbf0a34ed3) )
	ROM_LOAD16_BYTE( "g95427377.hi", 0x00000, 0x080000, CRC(154e6413) SHA1(2e3d73ffe1f080ce7e223ed31c11242cdb48c5a5) )
	ROM_LOAD16_BYTE( "g95427574.lo", 0x00001, 0x080000, CRC(8c1b9871) SHA1(2e2e02c911e45f71a363ffe85f05d76058cc7049) )
	ROM_LOAD16_BYTE( "g95427575.hi", 0x00000, 0x080000, CRC(e0929b71) SHA1(85d0c52e53e5a414426da91b1d6496a750e519c1) )
	ROM_LOAD16_BYTE( "g95427622.lo", 0x00001, 0x080000, CRC(c0629d24) SHA1(8077566d177a5b77d591fca916d7a860854e21f0) )
	ROM_LOAD16_BYTE( "g95427623.hi", 0x00000, 0x080000, CRC(993cea6e) SHA1(94030b5062e31c32a08421ce0420af11227a9bd8) )
	ROM_LOAD16_BYTE( "p1918p42.hi", 0x00000, 0x080000, CRC(9e0c7ebc) SHA1(e81fd6dbb13a25afde4849e54b0f71c0f6a83ad7) )
	ROM_LOAD16_BYTE( "p1918p42.lo", 0x00001, 0x080000, CRC(330226ed) SHA1(001953a954c73d380d772a3779f104c1dd277505) )
	ROM_LOAD16_BYTE( "p1918s42.hi", 0x00000, 0x080000, CRC(30780d72) SHA1(6731996c6f2addf70d9abae828853dde85df4585) )
	ROM_LOAD16_BYTE( "p1918s42.lo", 0x00001, 0x080000, CRC(b9829456) SHA1(5c5f250857cc2f96f8e1761402bd46e05df0b549) )
	ROM_LOAD16_BYTE( "p1938p42.hi", 0x00000, 0x080000, CRC(c5798bd9) SHA1(4031e72a04db4b8a0248c47a62ec2e9c275e8b73) )
	ROM_LOAD16_BYTE( "p1938p42.lo", 0x00001, 0x080000, CRC(72bfe669) SHA1(8f9b384c67cb0ee70b004195b05a4271a9a08ffe) )
	ROM_LOAD16_BYTE( "p1938s42.hi", 0x00000, 0x080000, CRC(ae02b67f) SHA1(c873985cc941a6ce334b4ce23db1117bcaf95fad) )
	ROM_LOAD16_BYTE( "p1938s42.lo", 0x00001, 0x080000, CRC(4e80e631) SHA1(8fe73e1fa1961b1ea693e394f88e453daf065305) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008750.bin", 0x0000, 0x100000, CRC(25a94ab7) SHA1(9ee3a1acb2734a5663d925fa050c15d154f79678) )
	ROM_LOAD( "95008751.bin", 0x0000, 0x100000, CRC(53c97577) SHA1(5ec3868967073b4ed429fed943fbcd568a85b4f3) )
ROM_END




ROM_START( sc_pogcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422368.lo", 0x00001, 0x080000, CRC(3d34c353) SHA1(9bab4bf469ed5c877bfb567e0cc4155b0dc37ac1) )
	ROM_LOAD16_BYTE( "95422369.hi", 0x00000, 0x080000, CRC(98b01d37) SHA1(cd7d8334c7dd0078cebf066cc1ae0cc503743036) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422932.lo", 0x00001, 0x080000, CRC(2c5ea61c) SHA1(56a8e6b8392ca76c864eab8060ce1cfbe04b9e54) )
	ROM_LOAD16_BYTE( "95422933.hi", 0x00000, 0x080000, CRC(ec3d6a90) SHA1(5b030940775fdb4286efdd7357a276707d9eabde) )
	ROM_LOAD16_BYTE( "95423368.lo", 0x00001, 0x080000, CRC(0c9a2240) SHA1(eab6b824b87a570b4236b649d138bb6babf6d766) )
	ROM_LOAD16_BYTE( "95423369.hi", 0x00000, 0x080000, CRC(dd96eb1f) SHA1(c2fae68a39ddf476ac11fc03158ed5ecfbc6fc1a) )
	ROM_LOAD16_BYTE( "95423932.lo", 0x00001, 0x080000, CRC(03cacc64) SHA1(99b776c529115da34413b507cdc20491bfdbd09e) )
	ROM_LOAD16_BYTE( "95423933.hi", 0x00000, 0x080000, CRC(45faea1b) SHA1(1c6d8072086e2e0345bbae42978338eaa15e8304) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008750.bin", 0x0000, 0x100000, CRC(25a94ab7) SHA1(9ee3a1acb2734a5663d925fa050c15d154f79678) )
	ROM_LOAD( "95008751.bin", 0x0000, 0x100000, CRC(53c97577) SHA1(5ec3868967073b4ed429fed943fbcd568a85b4f3) )
ROM_END




ROM_START( sc_pwcrz )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400189.lo", 0x00001, 0x080000, CRC(2f864cad) SHA1(21431025b4c4c00496ec039dfb4f7e2623b0924b) )
	ROM_LOAD16_BYTE( "95400190.hi", 0x00000, 0x080000, CRC(6e2fbddf) SHA1(f27ea2a12fcec1d2376b99385babe99ff55c409d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400251.lo", 0x00001, 0x080000, CRC(d7071cf3) SHA1(ec86d2db77058538a34484ae7be79092f83ce289) )
	ROM_LOAD16_BYTE( "95400252.hi", 0x00000, 0x080000, CRC(aa9ffa8f) SHA1(da55df6754c4e80a086303361ef1ed347ef425ba) )
	ROM_LOAD16_BYTE( "95400253.lo", 0x00001, 0x080000, CRC(94dd9c1d) SHA1(483f58aa3a30a4750d525829087ac1ce0161fc8f) )
	ROM_LOAD16_BYTE( "95400254.hi", 0x00000, 0x080000, CRC(3e9c7197) SHA1(853f8cba3ece11f01958266a27b4492d56b80f34) )
	ROM_LOAD16_BYTE( "95400755.lo", 0x00001, 0x080000, CRC(a6044a3e) SHA1(e61a56d91ac0f57d53e38280e57b4e6d5a995a0f) )
	ROM_LOAD16_BYTE( "95400756.hi", 0x00000, 0x080000, CRC(b404f71a) SHA1(5c3b794ec6653b3e15c111b549ae57deaa918f1e) )
	ROM_LOAD16_BYTE( "95400757.lo", 0x00001, 0x080000, CRC(25f9f84e) SHA1(785d22b4250ab2c95766fff4fbff0cde30593155) )
	ROM_LOAD16_BYTE( "95400758.hi", 0x00000, 0x080000, CRC(fe3cdb98) SHA1(302f578750296315ac274887f95450d42350b6b0) )
	ROM_LOAD16_BYTE( "95401189.lo", 0x00001, 0x080000, CRC(d3bc5e7e) SHA1(a5d10ed68c12aa6e455de1d8671ad76533dd014e) )
	ROM_LOAD16_BYTE( "95401190.hi", 0x00000, 0x080000, CRC(e95a0603) SHA1(d2fac221068b1e816d2218d64a99a17322fe670e) )
	ROM_LOAD16_BYTE( "95401251.lo", 0x00001, 0x080000, CRC(2e5ce4ce) SHA1(66e4fe46b7029f376b537746956cae62a65c6944) )
	ROM_LOAD16_BYTE( "95401253.lo", 0x00001, 0x080000, CRC(571369c5) SHA1(d954cca70643ac78400c425f6185a21f2c38af63) )
	ROM_LOAD16_BYTE( "95401254.hi", 0x00000, 0x080000, CRC(72ffc510) SHA1(0197fe9f49329d2f75e82ce1bc03439a87a4d20f) )
	ROM_LOAD16_BYTE( "95401755.lo", 0x00001, 0x080000, CRC(372f7486) SHA1(43922692ff8cfff0bc1c317911d465444abbc779) )
	ROM_LOAD16_BYTE( "95401756.hi", 0x00000, 0x080000, CRC(44260fec) SHA1(621605bd28ec568b4adf4ebcad983bea0a03c2b8) )
	ROM_LOAD16_BYTE( "95401757.lo", 0x00001, 0x080000, CRC(f4b4b9b0) SHA1(25764f6325fd99921572c9a3a4df27c040164f4b) )
	ROM_LOAD16_BYTE( "95401758.hi", 0x00000, 0x080000, CRC(3b5247e2) SHA1(b1e086aefd27b5c44cb765a29ff87b27998e2d22) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_pwrpl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416764.lo", 0x00001, 0x080000, CRC(2565da29) SHA1(a12f7479f112fcdbccf9814ba403ac2382fd2010) )
	ROM_LOAD16_BYTE( "95416765.hi", 0x00000, 0x080000, CRC(bcf9b9af) SHA1(dd442f37c1e76de90eac23539f300465054e7f60) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416766.lo", 0x00001, 0x080000, CRC(9e8b8582) SHA1(72885776aeb2a3275ab2f147630e8befaa0b0294) )
	ROM_LOAD16_BYTE( "95416767.hi", 0x00000, 0x080000, CRC(4dc170ed) SHA1(aa3c687fc36122c2c209b452a308b7fc92e546e4) )
	ROM_LOAD16_BYTE( "95416768.lo", 0x00001, 0x080000, CRC(79e6a345) SHA1(817fa12fb2931f9229f860324d3f717e0a11e806) )
	ROM_LOAD16_BYTE( "95416769.hi", 0x00000, 0x080000, CRC(2090e32d) SHA1(5c19c734f4e9de24ac0ad3bf9f0df2b509bd4749) )
	ROM_LOAD16_BYTE( "95417764.lo", 0x00001, 0x080000, CRC(0a527024) SHA1(9870841fc4c6d8ad236cc721d0a04853a9626a6a) )
	ROM_LOAD16_BYTE( "95417765.hi", 0x00000, 0x080000, CRC(e5de2f39) SHA1(9420ee35da44bebdf14a1d62e22a0e66f71449f8) )
	ROM_LOAD16_BYTE( "95417766.lo", 0x00001, 0x080000, CRC(47991649) SHA1(8e828d208ac39455a504e1bf3d18fb30f5c7a6cf) )
	ROM_LOAD16_BYTE( "95417767.hi", 0x00000, 0x080000, CRC(6d31f070) SHA1(2b80be37bb3db9b3ef362c7bcfb0aa8aa310b4d9) )
	ROM_LOAD16_BYTE( "95417768.lo", 0x00001, 0x080000, CRC(0075667d) SHA1(505ac584ef95ba453e5fe7fdaf02c7a7ba73cbc1) )
	ROM_LOAD16_BYTE( "95417769.hi", 0x00000, 0x080000, CRC(b024e400) SHA1(c3e68ab2e23704fa0602e9c51666a2f8dfd354b1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_pwrsg )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406126.odd", 0x00001, 0x080000, CRC(2960dd7c) SHA1(4d19cd24abd2b0f0c7bbc6b69e6482d59021be57) )
	ROM_LOAD16_BYTE( "95406127.evn", 0x00000, 0x080000, CRC(67188a1a) SHA1(bf5453f513a3bdbfa207f2cdde5ce65624ccdff5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406128.odd", 0x00001, 0x080000, CRC(ba811b21) SHA1(c0bfd222af7a7d8626b6bb7fb9f10af974c836dd) )
	ROM_LOAD16_BYTE( "95406129.evn", 0x00000, 0x080000, CRC(bff58455) SHA1(429926241668973e8e053d8a0b1114bf73dd614e) )
	ROM_LOAD16_BYTE( "95407126.odd", 0x00001, 0x080000, CRC(bfcc64f7) SHA1(9e6779e45e32b89b82540e6b47bd901ac8e636f8) )
	ROM_LOAD16_BYTE( "95407127.evn", 0x00000, 0x080000, CRC(12adc7e8) SHA1(47e6e9721fb2b270e46e3713c6559f2e84579140) )
	ROM_LOAD16_BYTE( "95407128.odd", 0x00001, 0x080000, CRC(4a6aa63e) SHA1(23c507ccc7c62a14e73dcb3d0d799f68891d6bb8) )
	ROM_LOAD16_BYTE( "95407129.evn", 0x00000, 0x080000, CRC(e57a6249) SHA1(346ce6a4556fcafe47eb969d15a70bcb0e9d4d5f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008257.bin", 0x0000, 0x0dc608, CRC(ac648ab0) SHA1(58c919be129388ca9c34cad177520175ef08cfaa) )
ROM_END



ROM_START( sc_pwrbl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412926.lo", 0x00001, 0x080000, CRC(4edb4645) SHA1(a2eeab7c922e855ac570da59ff1c14946a9dd2b5) )
	ROM_LOAD16_BYTE( "95412927.hi", 0x00000, 0x080000, CRC(fca5a985) SHA1(0631df75cd07a328a255e012159b9330930bc031) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412990.lo", 0x00001, 0x080000, CRC(4233a005) SHA1(ce85698f6c7fe770fb153768f9975523e9653356) )
	ROM_LOAD16_BYTE( "95412991.hi", 0x00000, 0x080000, CRC(995c5200) SHA1(ae440a73887d2138fddd932800c4ec272fb5fcc2) )
	ROM_LOAD16_BYTE( "95413926.lo", 0x00001, 0x080000, CRC(391f3610) SHA1(ef73ccd1fcd15284aa721bb3bbba40d8d3fcf64b) )
	ROM_LOAD16_BYTE( "95413927.hi", 0x00000, 0x080000, CRC(b476f6f1) SHA1(b5d4eab67e61d551b7b6fa5dc12e4fadb25db1f2) )
	ROM_LOAD16_BYTE( "95413990.lo", 0x00001, 0x080000, CRC(dd259ef7) SHA1(dfacaa9f7e4b8e8de2decfde31e79b1ec37feab2) )
	ROM_LOAD16_BYTE( "95413991.hi", 0x00000, 0x080000, CRC(a35609dd) SHA1(97d014479f7a8e9dbc0058358ce897c50679e737) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008496.bin", 0x0000, 0x100000, CRC(66b32a17) SHA1(3adaa7067f91c071ca70e4c8b1c3d07f0402e1bb) )
ROM_END



ROM_START( sc_pwrbq )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400945.lo", 0x00001, 0x080000, CRC(8b7067a6) SHA1(df5aaa774cc0021e99e98abc1ac13edb92e68e6e) )
	ROM_LOAD16_BYTE( "95400946.hi", 0x00000, 0x080000, CRC(02804a36) SHA1(9fc1f69f0ed73ca9ee4fb2df3a0b477a9379cf52) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95401945.lo", 0x00001, 0x080000, CRC(ca34aba7) SHA1(2890dbaff083f98ea76bb22d6f453c8bd62591eb) )
	ROM_LOAD16_BYTE( "95401946.hi", 0x00000, 0x080000, CRC(9164fb91) SHA1(5a8b44bc342f483794cdb977ae60f32c905da347) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_pircl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426804.lo", 0x00001, 0x080000, CRC(e4c540db) SHA1(9d0227887abf9408cb36f47349cdec28a0520d18) )
	ROM_LOAD16_BYTE( "95426805.hi", 0x00000, 0x080000, CRC(34dbe319) SHA1(4541b6dcde089682806ab733c693e0f8afed2687) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426874.lo", 0x00001, 0x080000, CRC(f247e544) SHA1(e970ed7050a5a7190e895b0777ed14aff3bd252c) )
	ROM_LOAD16_BYTE( "95426875.hi", 0x00000, 0x080000, CRC(90e8fbeb) SHA1(a5ba9f97e1713eb5c4a01a2f9a9743fb4d7aea51) )
	ROM_LOAD16_BYTE( "95427804.lo", 0x00001, 0x080000, CRC(5f11f3b9) SHA1(51aaa4f9b847895c2c632e958511d16d44b90590) )
	ROM_LOAD16_BYTE( "95427805.hi", 0x00000, 0x080000, CRC(5fa7e6ad) SHA1(4432ccc19b210bf11ae1b6ce355a56dd315ad1e9) )
	ROM_LOAD16_BYTE( "95427874.lo", 0x00001, 0x080000, CRC(81cf3df9) SHA1(6884eba96eca6bf3b9c2b7afdd00c910fb1ff15e) )
	ROM_LOAD16_BYTE( "95427875.hi", 0x00000, 0x080000, CRC(ffe1f743) SHA1(e05e54bfe4070419ad9ce4b63cbd877778b37ccf) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009200.bin", 0x0000, 0x100000, CRC(45392f4b) SHA1(9a71834e52480f87ab303c22efe15157b8f25b5c) )
	ROM_LOAD( "95009201.bin", 0x0000, 0x100000, CRC(3aece97c) SHA1(fc469870fef892da0a4aa49077c7746315933d40) )
ROM_END



ROM_START( sc_pir )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406550.lo", 0x00001, 0x080000, CRC(4552e341) SHA1(38a2c2f06c42390ad584dd99f4e3ae9de090b84d) )
	ROM_LOAD16_BYTE( "95406551.hi", 0x00000, 0x080000, CRC(1da38ce3) SHA1(7810b415290f259ad4a27e9c88860f35e2e372ad) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406892.lo", 0x00001, 0x080000, CRC(1e56abd5) SHA1(d1accb9c75c3cbbc84cb1b09e9e3cb8ca7477fcc) )
	ROM_LOAD16_BYTE( "95406893.hi", 0x00000, 0x080000, CRC(2c851bc9) SHA1(808cb84e533f16fa9c0768c186cf6a69995f0442) )
	ROM_LOAD16_BYTE( "95407550.lo", 0x00001, 0x080000, CRC(5a311b60) SHA1(a8366956339c07530119fb03d430ea5123f99d66) )
	ROM_LOAD16_BYTE( "95407551.hi", 0x00000, 0x080000, CRC(72595aa2) SHA1(ac3f7106e19922d47d21498085aff833164516c7) )
	ROM_LOAD16_BYTE( "95407892.lo", 0x00001, 0x080000, CRC(56622f7f) SHA1(452f940179b5c0c17b1ffd9bdd7e3d184b4ea55a) )
	ROM_LOAD16_BYTE( "95407893.hi", 0x00000, 0x080000, CRC(7630ea84) SHA1(dddab23e48e34a58f89dc7dc73c3ea49796fbbcd) )
	ROM_LOAD16_BYTE( "95408276.lo", 0x00001, 0x080000, CRC(ddea06a4) SHA1(b231c4aca0e63f9feec9757732459169f9f0b874) )
	ROM_LOAD16_BYTE( "95408277.hi", 0x00000, 0x080000, CRC(bad595ae) SHA1(4a8b59b2c47ba37ef63df30408b6a6ea72dd91f7) )
	ROM_LOAD16_BYTE( "95409276.lo", 0x00001, 0x080000, CRC(bd702e84) SHA1(af75b80f4fcbe1a72241b492b7050e9447032acc) )
	ROM_LOAD16_BYTE( "95409277.hi", 0x00000, 0x080000, CRC(8e380b6a) SHA1(0e8e8870eae6e1c955cf2c95b0cc77ba478724b0) )
	ROM_LOAD16_BYTE( "p1303p11.hi", 0x00000, 0x080000, CRC(6ce5b2fc) SHA1(53bc0da9f15934d5e854311056f8dc27fd13be6a) )
	ROM_LOAD16_BYTE( "p1303p11.lo", 0x00001, 0x080000, CRC(674be85d) SHA1(a38e6c2e04d03edf90b51d5c637f46a154798484) )
	ROM_LOAD16_BYTE( "p1303s11.hi", 0x00000, 0x080000, CRC(934c2667) SHA1(829ce31538491f06d1dbe68481a35fbd9923b08b) )
	ROM_LOAD16_BYTE( "p1303s11.lo", 0x00001, 0x080000, CRC(5bb368be) SHA1(bdd07f05f880df8fa89d4734810ce0836f9cb5b3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008264.bin", 0x0000, 0x100000, CRC(c3301cf1) SHA1(59e3c5c8ab7be1901800d493fe98e72dd24c181c) )
ROM_END


ROM_START( sc_pen1 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402474.lo", 0x00001, 0x080000, CRC(962934e9) SHA1(de067a858b4501d4691e9972dd2bd2828ce4ba8a) )
	ROM_LOAD16_BYTE( "95402475.hi", 0x00000, 0x080000, CRC(e5a40536) SHA1(dc5861550e5b29635a8aa351b58acb18f3c3afb1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402490.lo", 0x00001, 0x080000, CRC(bb271055) SHA1(19d7874592e9808df2b52ef13e0967c9bc6b2334) )
	ROM_LOAD16_BYTE( "95402491.hi", 0x00000, 0x080000, CRC(2adfee72) SHA1(825c0ca523ad27aab3dd13cdd35a25ecf15ed607) )
	ROM_LOAD16_BYTE( "95403474.lo", 0x00001, 0x080000, CRC(78026e40) SHA1(658a45827c4bf697fa67041a532eb6e2d36cb2d1) )
	ROM_LOAD16_BYTE( "95403475.hi", 0x00000, 0x080000, CRC(cf1ff33b) SHA1(b13b29cc0cfc56ed003d8efb17b4113d03a78a80) )
	ROM_LOAD16_BYTE( "95403490.lo", 0x00001, 0x080000, CRC(6aa7ae48) SHA1(30d56b86d648843ebeda8ed2f0e360ead6790e1e) )
	ROM_LOAD16_BYTE( "95403491.hi", 0x00000, 0x080000, CRC(352633ff) SHA1(865d634fddc9467aa52f49bdc13bb8b38194e6a6) )
	ROM_LOAD16_BYTE( "p_enemy.hi", 0x00000, 0x080000, CRC(394b222b) SHA1(1bc185c4518f04705438266f42ec74deed44373c) )
	ROM_LOAD16_BYTE( "p_enemy.lo", 0x00001, 0x080000, CRC(03db99ce) SHA1(2880db69e5fc12ff2fc1eccd1e9198c8b28f23d2) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "pub-en.s1", 0x0000, 0x080000, CRC(7e3f4295) SHA1(b7a2c538d79663a3d21f89311195619158fa7197) ) //need testing
	ROM_LOAD( "pub-en.s2", 0x0000, 0x080000, CRC(637d3c0f) SHA1(193964efc28e56b05f39099a696dd3e9119b80dd) )

	ROM_REGION( 0x400000, "others", ROMREGION_ERASE00 )
	ROM_LOAD( "pbemydot", 0x0000, 0x010000, CRC(b056d3d4) SHA1(6c1dbc6fcb4761c25f9cc8123e9f0fe791488c19) ) // DMD rom? Possibly SC2 DM01
ROM_END


ROM_START( sc_quart )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406524.lo", 0x00001, 0x080000, CRC(99a0ae2c) SHA1(a1021485036741c14cb3de0a464795ee3eb7959d) )
	ROM_LOAD16_BYTE( "95406525.hi", 0x00000, 0x080000, CRC(a8ce8629) SHA1(ae892b70d64f0e0e696f66c4931e77c6ecdda088) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406794.lo", 0x00001, 0x080000, CRC(ecc36997) SHA1(1791fc75463cbc23beb2cb1284af207c6c2bcde6) )
	ROM_LOAD16_BYTE( "95406795.hi", 0x00000, 0x080000, CRC(bc4a70f6) SHA1(15774d64073228a19db0bb68b6783b0125c02074) )
	ROM_LOAD16_BYTE( "95406822.lo", 0x00001, 0x080000, CRC(f645320f) SHA1(d70d8d002e004f943d4862dd6f5a039f4ea153bc) )
	ROM_LOAD16_BYTE( "95406823.hi", 0x00000, 0x080000, CRC(a43f6610) SHA1(2f2be5da9122ab1384c0f8260ec284dcd4f3b8c5) )
	ROM_LOAD16_BYTE( "95406826.lo", 0x00001, 0x080000, CRC(b558e625) SHA1(588d70decefbf0e509c1347a158d7d31ac04dc5d) )
	ROM_LOAD16_BYTE( "95406827.hi", 0x00000, 0x080000, CRC(50b760fe) SHA1(c6e34e6e42ad9f72eb4563226579a3c29ddccc78) )
	ROM_LOAD16_BYTE( "95406832.lo", 0x00001, 0x080000, CRC(daa6c09c) SHA1(3cdc353d61034e1ae3acb0d9a53fd848ae80a94a) )
	ROM_LOAD16_BYTE( "95406833.hi", 0x00000, 0x080000, CRC(adbc76a9) SHA1(25c3591dc1d56864eaa7e966d67a8157c3a21675) )
	ROM_LOAD16_BYTE( "95406834.lo", 0x00001, 0x080000, CRC(ed0fb304) SHA1(6c1f9e670748eef170adaaf49f726b2275be79ad) )
	ROM_LOAD16_BYTE( "95406835.hi", 0x00000, 0x080000, CRC(60c0223a) SHA1(138d291e49c13075c9ca98a5eceffbc24f611341) )
	ROM_LOAD16_BYTE( "95406862.lo", 0x00001, 0x080000, CRC(0fcda4b1) SHA1(bea31ba740dbf2180592fb063b9892df9bee461a) )
	ROM_LOAD16_BYTE( "95406863.hi", 0x00000, 0x080000, CRC(bd74a605) SHA1(15e2ef668ce18dcacb8b74d62b46c75a75c1c49e) )
	ROM_LOAD16_BYTE( "95406900.lo", 0x00001, 0x080000, CRC(c074cd8a) SHA1(bc12dff4678e74dd5cdf14134ba9f227ba376d88) )
	ROM_LOAD16_BYTE( "95406901.hi", 0x00000, 0x080000, CRC(732da92f) SHA1(495a79dedf6eb3dde04a70a4fd850670d8f1708a) )
	ROM_LOAD16_BYTE( "95406918.lo", 0x00001, 0x080000, CRC(cf430afd) SHA1(9852252a4593d6da37c9a03a8d77813eb0e495c3) )
	ROM_LOAD16_BYTE( "95406919.hi", 0x00000, 0x080000, CRC(04e43a9d) SHA1(04c2c3ff9269a96367ce8c9316347f51cdf5f310) )
	ROM_LOAD16_BYTE( "95406926.lo", 0x00001, 0x080000, CRC(1e43f8e0) SHA1(3dc4ef31d09907a9267b026359300fea0becf5b6) )
	ROM_LOAD16_BYTE( "95406927.hi", 0x00000, 0x080000, CRC(672b9510) SHA1(d7eeff4d850ffb04bbb1efc2d073af351a42ee99) )
	ROM_LOAD16_BYTE( "95408008.lo", 0x00001, 0x080000, CRC(d7f437d9) SHA1(1edf3b1197757a5fa7268affc8a4bedd0a477d48) )
	ROM_LOAD16_BYTE( "95408009.hi", 0x00000, 0x080000, CRC(2d7dbaf6) SHA1(807baec953ee67af2b52d9637247d8062c446140) )
	ROM_LOAD16_BYTE( "95408010.lo", 0x00001, 0x080000, CRC(80c9c166) SHA1(7c329ba6d4582405a7faf26a45b27700595eddbe) )
	ROM_LOAD16_BYTE( "95408011.hi", 0x00000, 0x080000, CRC(50d454b0) SHA1(60052ffe0f8108dac657bb1015a4e6e713b459eb) )
	ROM_LOAD16_BYTE( "95408088.lo", 0x00001, 0x080000, CRC(72f48774) SHA1(b67b26c3eccfdef7c4b105842ab7aeee875b2a01) )
	ROM_LOAD16_BYTE( "95408089.hi", 0x00000, 0x080000, CRC(bb69a047) SHA1(b83e411b90261948e1fba0c71753d7252ba59e9f) )
	ROM_LOAD16_BYTE( "95408214.lo", 0x00001, 0x080000, CRC(6232bc32) SHA1(30b03f7b66b7c2b7fe56ae99a0e845a2c53758a9) )
	ROM_LOAD16_BYTE( "95408215.hi", 0x00000, 0x080000, CRC(b516cbb4) SHA1(8fd2d9920186454a3c1dc75968cf6b42770f15c9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_qmodo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "69000164.odd", 0x00001, 0x080000, CRC(7a881601) SHA1(e8bd5aa7c38fda69afbefb4234bb2773e3d3d4cb) )
	ROM_LOAD16_BYTE( "69000165.evn", 0x00000, 0x080000, CRC(d8d3e1f6) SHA1(39cd99c7bc7e148b9b74c1e0e24ccc324be9b391) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "69001164.odd", 0x00001, 0x080000, CRC(d2e6460f) SHA1(46f8a94ab5d50bb6392deb674fce46398901bd0d) )
	ROM_LOAD16_BYTE( "69001165.evn", 0x00000, 0x080000, CRC(53a391eb) SHA1(7cd7d049efcc8f6d73392565c777a2fa97214dfc) )
	ROM_LOAD16_BYTE( "96000164.odd", 0x00001, 0x080000, CRC(7458baf6) SHA1(67b09ea4e5dd084a70e704651033344e9753091f) )
	ROM_LOAD16_BYTE( "96000165.evn", 0x00000, 0x080000, CRC(e5fbe12e) SHA1(445636889a95f4ef5c6e3f7edae9d232677eef6e) )
	ROM_LOAD16_BYTE( "96001164.odd", 0x00001, 0x080000, CRC(dc36eaf8) SHA1(67b28c9c18b14c143f6596b7dd4caaccd649ae76) )
	ROM_LOAD16_BYTE( "96001165.evn", 0x00000, 0x080000, CRC(6e8b9133) SHA1(d220ffdb192807f55800d50fdd859a1b96570384) )
	ROM_LOAD16_BYTE( "96001166.odd", 0x00001, 0x080000, CRC(b51e0720) SHA1(2acf3dd03846c40acaf5f59a6527b8f2dc16b627) )
	ROM_LOAD16_BYTE( "96001167.evn", 0x00000, 0x080000, CRC(f09591d1) SHA1(604dfd124ec01806edd1abf69c15cc77fdfa61a9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "97000080.bin", 0x0000, 0x0ea2e7, CRC(060bf37a) SHA1(732fa84ed0145f931557e3fef66276370dde6884) )
ROM_END


ROM_START( sc_quidr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406420.odd", 0x00001, 0x080000, CRC(b7ddca3d) SHA1(58c3b2cd9da48af451631f761df7e279f1dc719d) )
	ROM_LOAD16_BYTE( "95406421.evn", 0x00000, 0x080000, CRC(022cde42) SHA1(17cb42c98dc6eab5d3e0d11bd4e4f07e6164a648) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407420.odd", 0x00001, 0x080000, CRC(4a5fa168) SHA1(b8d2ace1d5e96c897d215ac1a3c9c97d6d9cb904) )
	ROM_LOAD16_BYTE( "95407421.evn", 0x00000, 0x080000, CRC(a66605b1) SHA1(b0a0b738bd24c7d6ad407334b802aaa88bda99b0) )
	ROM_LOAD16_BYTE( "95408148.odd", 0x00001, 0x080000, CRC(108bc690) SHA1(2cca06fae553df95c7cd26d1d764be23bba1f746) )
	ROM_LOAD16_BYTE( "95408149.evn", 0x00000, 0x080000, CRC(17a4f66e) SHA1(b9771298a0c31d8cff6123b05ef45600c9670ca9) )
	ROM_LOAD16_BYTE( "95409148.odd", 0x00001, 0x080000, CRC(66c866ba) SHA1(43ed90a240b0cc143d0dbb6616fcab9704e2cedd) )
	ROM_LOAD16_BYTE( "95409149.evn", 0x00000, 0x080000, CRC(6211bb9c) SHA1(344b3f9c3d653f30af242e12df2f1a23334d59b9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008269.bin", 0x0000, 0x0e5ee2, CRC(b61e664a) SHA1(9ee423015b5532cc4c06ddb76846800fa325074c) )
ROM_END


ROM_START( sc_quidv )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420788.lo", 0x00001, 0x080000, CRC(fdfb704b) SHA1(19e71d2650e824e16c2d42bb0c68a98b7bd81d2e) )
	ROM_LOAD16_BYTE( "95420789.hi", 0x00000, 0x080000, CRC(f325013c) SHA1(ea601e27f5c61110b8cf669e206db289b4731521) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95421788.lo", 0x00001, 0x080000, CRC(64610205) SHA1(bd9ce6e6e6060db22ec049a042354a986eb9cdfc) )
	ROM_LOAD16_BYTE( "95421789.hi", 0x00000, 0x080000, CRC(ae1900b6) SHA1(6c868810ea0510d7de40fe0129c72f1d7e42aff9) )
	ROM_LOAD16_BYTE( "95424490.lo", 0x00001, 0x080000, CRC(6f94b7de) SHA1(3dafcd2046b12e4c74bbb281c860476f01ed90c8) )
	ROM_LOAD16_BYTE( "95424491.hi", 0x00000, 0x080000, CRC(8f5507f7) SHA1(41678c4346784b3e4badb05eabcaa5a0561a7e6f) )
	ROM_LOAD16_BYTE( "95424520.lo", 0x00001, 0x080000, CRC(0505c85b) SHA1(171cc6b54dfc3d4c45a9dc279c0fa45bb266dac8) )
	ROM_LOAD16_BYTE( "95424521.hi", 0x00000, 0x080000, CRC(364c9909) SHA1(29e674a109d5987bbcb53f4c32dae0f6736e7e40) )
	ROM_LOAD16_BYTE( "95424564.lo", 0x00001, 0x080000, CRC(7d26ebca) SHA1(c63ba51e924cf61bf81a52fe3fa403ff681a6259) )
	ROM_LOAD16_BYTE( "95424565.hi", 0x00000, 0x080000, CRC(52436e90) SHA1(a37e3b956bacff1e7c2a4688904202f34c120929) )
	ROM_LOAD16_BYTE( "95424566.lo", 0x00001, 0x080000, CRC(b442d3dd) SHA1(06cb10771be71f723550f99c2218d5ee81acd67b) )
	ROM_LOAD16_BYTE( "95424567.hi", 0x00000, 0x080000, CRC(f7a10d39) SHA1(7d0da378ed1cc8286daa7e54c65db074510808c5) )
	ROM_LOAD16_BYTE( "95424652.lo", 0x00001, 0x080000, CRC(6ca57650) SHA1(29e183d47fe80f9e051049189a294c217b93f78e) )
	ROM_LOAD16_BYTE( "95424653.hi", 0x00000, 0x080000, CRC(01518c58) SHA1(531e3b689b87b1f0eb888e2224d58b91ed266e07) )
	ROM_LOAD16_BYTE( "95425490.lo", 0x00001, 0x080000, CRC(83c0c0c7) SHA1(30d03ab7e1c893ab96b6ddc3153141803e4193dc) )
	ROM_LOAD16_BYTE( "95425491.hi", 0x00000, 0x080000, CRC(d2497dc6) SHA1(787ca5debf6f823234862c68e1685e8f2ef74ac2) )
	ROM_LOAD16_BYTE( "95425520.lo", 0x00001, 0x080000, CRC(c320d329) SHA1(26acaa18d96f48ecd7a049f95f770c8a0369f18a) )
	ROM_LOAD16_BYTE( "95425521.hi", 0x00000, 0x080000, CRC(3bc04fd1) SHA1(bd9d695efbc847b706058c8473a3a17f566de6ab) )
	ROM_LOAD16_BYTE( "95425564.lo", 0x00001, 0x080000, CRC(53eb62d1) SHA1(a619211efadcbec74db9751ca3d0f10254ebc2a6) )
	ROM_LOAD16_BYTE( "95425565.hi", 0x00000, 0x080000, CRC(f37b0c31) SHA1(c1a3f7841f226180c6743b03904139a9dd250a1d) )
	ROM_LOAD16_BYTE( "95425566.lo", 0x00001, 0x080000, CRC(fcff0da8) SHA1(b8bb3b94a972bef05301f616b5be82881e67d124) )
	ROM_LOAD16_BYTE( "95425567.hi", 0x00000, 0x080000, CRC(31e60a27) SHA1(a38b05f5cefdbff03ac162c7ee9aff1146425f08) )
	ROM_LOAD16_BYTE( "95425652.lo", 0x00001, 0x080000, CRC(a99e0bed) SHA1(8082362471da6890d1b3f47006e1fe9e1bc10270) )
	ROM_LOAD16_BYTE( "95425653.hi", 0x00000, 0x080000, CRC(760f55cf) SHA1(d72c60ac5d2cc3dcd611509b2003c54cb33782bc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008993.bin", 0x0000, 0x0fab1c, CRC(e99defa5) SHA1(43954ec9acfedc86794d577d1e3058320264471e) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890703.bin", 0x0000, 0x5000, CRC(c87e0232) SHA1(c8de2c6b4f327ffd5b6bdb1248df1ba5573b21f0) )
	ROM_LOAD( "95890704.bin", 0x0000, 0x5000, CRC(bde84606) SHA1(0fe8285d862b97fee2a5a43082294a061b01bb16) )
	ROM_LOAD( "95890705.bin", 0x0000, 0x5000, CRC(23528a5a) SHA1(ac5b5a16a1e96a600be3760bd82cae2903459c24) )
ROM_END


ROM_START( sc_redad )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408932.lo", 0x00001, 0x080000, CRC(d7b60d0a) SHA1(b4dc76c7e29a8da1cf67f9afc1988d25be560829) )
	ROM_LOAD16_BYTE( "95408933.hi", 0x00000, 0x080000, CRC(ad81c654) SHA1(e9db646056cce57d05b8ca59a8ae3a5d9b03bff9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004266.snd", 0x0000, 0x080000, CRC(457fffbf) SHA1(ede2adc836ba4904cdf3d1ed825f9128c27b2b58) )
ROM_END


ROM_START( sc_redal )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406366.lo", 0x00001, 0x080000, CRC(b1e1d63b) SHA1(920f1ab872bcd6c594569b7272bcfdeb59607cd1) )
	ROM_LOAD16_BYTE( "95406367.hi", 0x00000, 0x080000, CRC(c11107ee) SHA1(a8cebcbc82787d8ccfa07795821f04364ae9ba94) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004266.snd", 0x0000, 0x080000, CRC(457fffbf) SHA1(ede2adc836ba4904cdf3d1ed825f9128c27b2b58) )
ROM_END


ROM_START( sc_rdrag )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414714.odd", 0x00001, 0x080000, CRC(465e2488) SHA1(0d70c1cc2549a60871f0d80cebc8674a042411ac) )
	ROM_LOAD16_BYTE( "95414715.evn", 0x00000, 0x080000, CRC(77ab8399) SHA1(913f02c2242b473348a146adf8a2900b76e587b6) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95415714.odd", 0x00001, 0x080000, CRC(6db75b2e) SHA1(18b7a9b9afa8e7cdf505bf28c68cd63e44588cd9) )
	ROM_LOAD16_BYTE( "95415715.evn", 0x00000, 0x080000, CRC(8b13e696) SHA1(8d8f8d23ebd3de1f02968a753b8503ec7d4461a0) )
	ROM_LOAD16_BYTE( "95416070.odd", 0x00001, 0x080000, CRC(632a3587) SHA1(e67e1ffe0c667de68b57e638ff2325cbf96b9af9) )
	ROM_LOAD16_BYTE( "95416071.evn", 0x00000, 0x080000, CRC(3fa9ce1b) SHA1(aa4721b7b7228223819fb1eeef97e44cb692cf56) )
	ROM_LOAD16_BYTE( "95416244.odd", 0x00001, 0x080000, CRC(425a82b4) SHA1(2b316ad7e71d339ca38d507800a6b641bf52ee9f) )
	ROM_LOAD16_BYTE( "95416245.evn", 0x00000, 0x080000, CRC(8a7e9138) SHA1(a49d461e46063cc00716b2d6db6ec7a742612a57) )
	ROM_LOAD16_BYTE( "95416414.odd", 0x00001, 0x080000, CRC(5a090bb8) SHA1(d03cec018bca0b9922d97be6a0140ac7da376496) )
	ROM_LOAD16_BYTE( "95416415.evn", 0x00000, 0x080000, CRC(a42c8f94) SHA1(0bdf520be9c2b0cb6fc2538563c9a4693951cb58) )
	ROM_LOAD16_BYTE( "95417070.odd", 0x00001, 0x080000, CRC(26060bfd) SHA1(7e71d28525fc1198d2eb868a93cf2c3327df0322) )
	ROM_LOAD16_BYTE( "95417071.evn", 0x00000, 0x080000, CRC(4727e458) SHA1(64b9990dfabeb2b8580a62cfa0dc76746e622651) )
	ROM_LOAD16_BYTE( "95417244.odd", 0x00001, 0x080000, CRC(c848d8dc) SHA1(e32416a6676a69e6e603746fada31851b0fae836) )
	ROM_LOAD16_BYTE( "95417245.evn", 0x00000, 0x080000, CRC(bcee571c) SHA1(6b8d95c74124565584c353fe15b037ffa8b78807) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008485.bin", 0x0000, 0x0e7e1d, CRC(037269cd) SHA1(7b528427740c9f1b28e00d9b45ebeb5e77ca9ead) )
	ROM_LOAD( "95008525.bin", 0x0000, 0x0e7e1d, CRC(0c7aa11d) SHA1(3d028d2d5558056e84626ba66f7c22286be34bd9) )
ROM_END


ROM_START( sc_rdrcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416070.odd", 0x00001, 0x080000, CRC(632a3587) SHA1(e67e1ffe0c667de68b57e638ff2325cbf96b9af9) )
	ROM_LOAD16_BYTE( "95416071.evn", 0x00000, 0x080000, CRC(3fa9ce1b) SHA1(aa4721b7b7228223819fb1eeef97e44cb692cf56) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416414.odd", 0x00001, 0x080000, CRC(5a090bb8) SHA1(d03cec018bca0b9922d97be6a0140ac7da376496) )
	ROM_LOAD16_BYTE( "95416415.evn", 0x00000, 0x080000, CRC(a42c8f94) SHA1(0bdf520be9c2b0cb6fc2538563c9a4693951cb58) )
	ROM_LOAD16_BYTE( "95417070.odd", 0x00001, 0x080000, CRC(26060bfd) SHA1(7e71d28525fc1198d2eb868a93cf2c3327df0322) )
	ROM_LOAD16_BYTE( "95417071.evn", 0x00000, 0x080000, CRC(4727e458) SHA1(64b9990dfabeb2b8580a62cfa0dc76746e622651) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008525.bin", 0x0000, 0x0e7e1d, CRC(0c7aa11d) SHA1(3d028d2d5558056e84626ba66f7c22286be34bd9) )
ROM_END


ROM_START( sc_ibiza )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400425.lo", 0x00001, 0x080000, CRC(0543b316) SHA1(25b7e9f9c581d68a2585c52bb6e7e3c15984833f) )
	ROM_LOAD16_BYTE( "95400426.hi", 0x00000, 0x080000, CRC(a70f478b) SHA1(b33b5d61ae4c1d5fa62007de132052b54e835f8e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400427.lo", 0x00001, 0x080000, CRC(532b9127) SHA1(44f229ff98ced01179d05846e244a61bda45609f) )
	ROM_LOAD16_BYTE( "95400428.hi", 0x00000, 0x080000, CRC(88931a42) SHA1(5eb01bc146c0fb8ea5f94f256ff026cdd9b33447) )
	ROM_LOAD16_BYTE( "95400845.lo", 0x00001, 0x080000, CRC(e328f5a0) SHA1(7bb30b505c04bcdc7e606e66320b9b9f3aa90f5e) )
	ROM_LOAD16_BYTE( "95400846.hi", 0x00000, 0x080000, CRC(c60d7bd0) SHA1(7d91a55d30feb6259b883aacd5cd064ee92cfa04) )
	ROM_LOAD16_BYTE( "95400847.lo", 0x00001, 0x080000, CRC(3d3f90a8) SHA1(b78a7d3714b6a8d1b5963911b512fe0ba0a61e12) )
	ROM_LOAD16_BYTE( "95400848.hi", 0x00000, 0x080000, CRC(c8fd1e4b) SHA1(ed5ed8acef9001765a9594ec4a02bf7a535b1423) )
	ROM_LOAD16_BYTE( "95401425.lo", 0x00001, 0x080000, CRC(0ceab636) SHA1(6bcafe81c7ea7b1ec514d8c3c039642e68c1aada) )
	ROM_LOAD16_BYTE( "95401426.hi", 0x00000, 0x080000, CRC(354a0c64) SHA1(c891916f594a36caad4eba3590b65a2bebf71da0) )
	ROM_LOAD16_BYTE( "95401427.lo", 0x00001, 0x080000, CRC(35ca2819) SHA1(fdcde2a0593af963961f10ed8f2d78b91dd462ba) )
	ROM_LOAD16_BYTE( "95401428.hi", 0x00000, 0x080000, CRC(39e93182) SHA1(087f5ac9616ea2aba0c24b0b9ec6a8db71ae65a9) )
	ROM_LOAD16_BYTE( "95401845.lo", 0x00001, 0x080000, CRC(72934f1d) SHA1(652c0c8c79b0c3e810d172d8773487783a90d3e9) )
	ROM_LOAD16_BYTE( "95401846.hi", 0x00000, 0x080000, CRC(57949297) SHA1(0b088286a6692951a3d214429324b947f0b7a7eb) )
	ROM_LOAD16_BYTE( "95401847.lo", 0x00001, 0x080000, CRC(482da4f3) SHA1(1fb12a3e4e10dea1e33fd4587790a30e1397b102) )
	ROM_LOAD16_BYTE( "95401848.hi", 0x00000, 0x080000, CRC(dc6c1430) SHA1(0a027f8f52b7bcc7a9608c2d67be10686c1060c5) )
	ROM_LOAD16_BYTE( "95402081.lo", 0x00001, 0x080000, CRC(2d5822a8) SHA1(a3e4e911f708a4a7c0790080aae60791585c43b3) )
	ROM_LOAD16_BYTE( "95402082.hi", 0x00000, 0x080000, CRC(9e066bbc) SHA1(8ec9df0ce0753e37fadce56a056a942b2393e9a0) )
	ROM_LOAD16_BYTE( "95403081.lo", 0x00001, 0x080000, CRC(877bab81) SHA1(40e13e96918bfae99db3e600ae82e1e23d04560c) )
	ROM_LOAD16_BYTE( "95403082.hi", 0x00000, 0x080000, CRC(fc61d8a5) SHA1(92ceb83d01a0a5dfde0e39732a4c57df553145ed) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_rhx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406852.lo", 0x00001, 0x080000, CRC(0554768a) SHA1(1e9052b22bb06c6542b4c54de713951857aa2c88) )
	ROM_LOAD16_BYTE( "95406853.hi", 0x00000, 0x080000, CRC(9362a952) SHA1(1df9645079fedc186317ca7871e31ef220211069) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407852.lo", 0x00001, 0x080000, CRC(6b93bc11) SHA1(40edb1c42a4c4f64425bf127cad732beb8f9beec) )
	ROM_LOAD16_BYTE( "95407853.hi", 0x00000, 0x080000, CRC(0264162d) SHA1(9bb17e44b3ce6e323eec92a01e2dda03322f8ae6) )
	ROM_LOAD16_BYTE( "95408654.lo", 0x00001, 0x080000, CRC(99972de1) SHA1(ae30fd6b32ef13542fa6e3bc3f565ce5395877de) )
	ROM_LOAD16_BYTE( "95408655.hi", 0x00000, 0x080000, CRC(dc5bd5fb) SHA1(f7e994a2416b01304e75f25609c75e164b347620) )
	ROM_LOAD16_BYTE( "95410078.lo", 0x00001, 0x080000, CRC(0c148324) SHA1(7110b5467601aac4551188ec0a1c9caee1c97692) )
	ROM_LOAD16_BYTE( "95410079.hi", 0x00000, 0x080000, CRC(1cb3de28) SHA1(fe0b9fb4db18b3e98480b46b14ca37b7dae013c6) )
	ROM_LOAD16_BYTE( "95410126.lo", 0x00001, 0x080000, CRC(1ddc4a15) SHA1(6391efb041dba04fa5eb8f0474cc9b90dd5e52e4) )
	ROM_LOAD16_BYTE( "95410127.hi", 0x00000, 0x080000, CRC(4bb4ea72) SHA1(de5ca8394ce36ae4866da67cbc37ea91df4fbe6c) )
	ROM_LOAD16_BYTE( "95411078.lo", 0x00001, 0x080000, CRC(1b8a607f) SHA1(977353289c673470203e6bdd2623a597eb6018e4) )
	ROM_LOAD16_BYTE( "95411079.hi", 0x00000, 0x080000, CRC(ce90ea81) SHA1(39a6f733d93fe19a829424d68e087f89c10e6c2d) )
	ROM_LOAD16_BYTE( "95411082.lo", 0x00001, 0x080000, CRC(81e37de1) SHA1(a7332a4ce1156a2aaf6c100268607e94fce524fa) )
	ROM_LOAD16_BYTE( "95411083.hi", 0x00000, 0x080000, CRC(8e51bd5e) SHA1(3f91ea8b6140c83cda41a5ccedd2b5398737a41c) )
	ROM_LOAD16_BYTE( "95411084.lo", 0x00001, 0x080000, CRC(9357b033) SHA1(db9dd0391422ea1bf57e03b9a95d2333cccc1b50) )
	ROM_LOAD16_BYTE( "95411085.hi", 0x00000, 0x080000, CRC(41a7f320) SHA1(2d3b3adf880ac01dd99b155d12287f162168225b) )
	ROM_LOAD16_BYTE( "95411126.lo", 0x00001, 0x080000, CRC(516cb51a) SHA1(609e62dd2d896ca979e3d29b0f1e9a762e6d3464) )
	ROM_LOAD16_BYTE( "95411127.hi", 0x00000, 0x080000, CRC(f517a8db) SHA1(c01460d8bc427b963310ef9c877c882556ad7aef) )
	ROM_LOAD16_BYTE( "95414438.lo", 0x00001, 0x080000, CRC(791af926) SHA1(9cdf96ca38321039009fb6dbb4bc265ae70d5b31) )
	ROM_LOAD16_BYTE( "95414439.hi", 0x00000, 0x080000, CRC(e38dbeff) SHA1(e236a68f178a11848e4149d64f59fde60e8b9ce6) )
	ROM_LOAD16_BYTE( "95414444.lo", 0x00001, 0x080000, CRC(61084ddd) SHA1(0a23528c1d62ef12815bb0506fb0f5aa0ad293d2) )
	ROM_LOAD16_BYTE( "95414445.hi", 0x00000, 0x080000, CRC(edf41a38) SHA1(a5d05d61dd22337261a48294dc4ebcfd36eb9d5c) )
	ROM_LOAD16_BYTE( "95414446.lo", 0x00001, 0x080000, CRC(035837b2) SHA1(a42db070e73b1312b048bbb910b4221e5ff7a69c) )
	ROM_LOAD16_BYTE( "95414447.hi", 0x00000, 0x080000, CRC(5492ef73) SHA1(33355c3a4fbc4b27d672b4f81840bf7e487c6637) )
	ROM_LOAD16_BYTE( "95414452.lo", 0x00001, 0x080000, CRC(d47b1c72) SHA1(78763cac3d466b31d8906979994014a2fd345f97) )
	ROM_LOAD16_BYTE( "95414453.hi", 0x00000, 0x080000, CRC(0740d1c0) SHA1(f2b44de002349d279aa2cd149480fc49ac5af2c7) )
	ROM_LOAD16_BYTE( "95414806.lo", 0x00001, 0x080000, CRC(16528856) SHA1(9f8f762f79f99e45ed6164b87072e37e8bf21de2) )
	ROM_LOAD16_BYTE( "95414807.hi", 0x00000, 0x080000, CRC(2dc6c2e6) SHA1(310586d48423e4adeb15fe0eb38335a17cb6b87d) )
	ROM_LOAD16_BYTE( "95414816.lo", 0x00001, 0x080000, CRC(0f64c8f3) SHA1(5af17158aea35b2f327a024f0e246a94f683e70b) )
	ROM_LOAD16_BYTE( "95414817.hi", 0x00000, 0x080000, CRC(3e0c4a86) SHA1(996b845990e5a5bda0123653f362955e4ead193a) )
	ROM_LOAD16_BYTE( "95415438.lo", 0x00001, 0x080000, CRC(113d926a) SHA1(116a7280a7fcd0e50f658fee7221793aca5b930e) )
	ROM_LOAD16_BYTE( "95415439.hi", 0x00000, 0x080000, CRC(b8a3a2ab) SHA1(c944302fab42df7353ac08a05fe47c3ed427e9bc) )
	ROM_LOAD16_BYTE( "95415444.lo", 0x00001, 0x080000, CRC(1efdd87a) SHA1(c73b398ae5a8018c77ee34b8cea85951eb9b0b9e) )
	ROM_LOAD16_BYTE( "95415445.hi", 0x00000, 0x080000, CRC(b83dc375) SHA1(45a89a0c12f5548e54978a40a2faf6763eb36c7b) )
	ROM_LOAD16_BYTE( "95415446.lo", 0x00001, 0x080000, CRC(6f1b6c55) SHA1(4c8ee6501889af1f9083eea003fb26aed6a3ca86) )
	ROM_LOAD16_BYTE( "95415447.hi", 0x00000, 0x080000, CRC(9df9b8c8) SHA1(390b4a671937618c44216f327b951c508dff61f0) )
	ROM_LOAD16_BYTE( "95415448.lo", 0x00001, 0x080000, CRC(9a6a7ed5) SHA1(47ef7ba41607c1a71e4fbd7ef8c449c579bbabd7) )
	ROM_LOAD16_BYTE( "95415450.lo", 0x00001, 0x080000, CRC(f2a25f7a) SHA1(828f3311efd749692feaa3fad8fd2ed57368c0c7) )
	ROM_LOAD16_BYTE( "95415451.hi", 0x00000, 0x080000, CRC(05e0264c) SHA1(a18b1df3a2afa9700756d5a3f6266510b5b2e5ec) )
	ROM_LOAD16_BYTE( "95415452.lo", 0x00001, 0x080000, CRC(5ea22ab0) SHA1(dc1fea55478afdf10d8aa2b053243372471eb486) )
	ROM_LOAD16_BYTE( "95415453.hi", 0x00000, 0x080000, CRC(6922a918) SHA1(ef2369254d93fb1d72e9fecce0e75a4767ca8b6b) )
	ROM_LOAD16_BYTE( "95415806.lo", 0x00001, 0x080000, CRC(befea624) SHA1(0d569f9a70daea45de960978293bf19e05638665) )
	ROM_LOAD16_BYTE( "95415807.hi", 0x00000, 0x080000, CRC(2dc6c2e6) SHA1(310586d48423e4adeb15fe0eb38335a17cb6b87d) )
	ROM_LOAD16_BYTE( "95415816.lo", 0x00001, 0x080000, CRC(5833771e) SHA1(36d92e5ba85ee2b928a574e8bf2293f07533c76f) )
	ROM_LOAD16_BYTE( "95415817.hi", 0x00000, 0x080000, CRC(d4587d12) SHA1(59cf56d99decb5d6fa7585018419e1785bea131b) )
	ROM_LOAD16_BYTE( "95415818.lo", 0x00001, 0x080000, CRC(9afab3b5) SHA1(ba9071418919fb908ac36fcf9015efb29dcfd76e) )
	ROM_LOAD16_BYTE( "95415819.hi", 0x00000, 0x080000, CRC(bf316cb0) SHA1(447a269df3fdbb09238dbab63e452f47a04f54fd) )
	ROM_LOAD16_BYTE( "95415820.lo", 0x00001, 0x080000, CRC(653ab4fe) SHA1(23b49134fbde1df7efa8cca17299b7af8dc41aaa) )
	ROM_LOAD16_BYTE( "95415821.hi", 0x00000, 0x080000, CRC(09905beb) SHA1(9b8b3ea20af18afd3edc42a5fcea4ea5918db561) )
	ROM_LOAD16_BYTE( "95416096.lo", 0x00001, 0x080000, CRC(bda7acc7) SHA1(889b7deccbaa5da41f6afaa4ad588bb0ebb791a3) )
	ROM_LOAD16_BYTE( "95416097.hi", 0x00000, 0x080000, CRC(ba1b24f3) SHA1(5f322aa2fdd34e2c8dde46aa97a6a811ea3ac4e6) )
	ROM_LOAD16_BYTE( "95416100.lo", 0x00001, 0x080000, CRC(1ab8533b) SHA1(45af053b06d4d727bfdb79634d9864d4b643f82a) )
	ROM_LOAD16_BYTE( "95416101.hi", 0x00000, 0x080000, CRC(ac69a840) SHA1(6bdc9ad202e167996e1ae722718df766a2150eb1) )
	ROM_LOAD16_BYTE( "95417038.lo", 0x00001, 0x080000, CRC(eecdeae9) SHA1(13befc1cecf06ed722072ed453e684add9a35e74) )
	ROM_LOAD16_BYTE( "95417039.hi", 0x00000, 0x080000, CRC(3541f97b) SHA1(cc3c31e9ab6cf64fec2331016f55ba1458f5c557) )
	ROM_LOAD16_BYTE( "95417040.lo", 0x00001, 0x080000, CRC(1bc53810) SHA1(a8592f0bb0ec22200121fb4af938ebd13208c0e4) )
	ROM_LOAD16_BYTE( "95417041.hi", 0x00000, 0x080000, CRC(684adf97) SHA1(913337747159ed504deb42e48616e5cd9e8e0218) )
	ROM_LOAD16_BYTE( "95417096.lo", 0x00001, 0x080000, CRC(c8e40798) SHA1(e98a1357d943b46e39a5cc781df30b3445b6bad0) )
	ROM_LOAD16_BYTE( "95417097.hi", 0x00000, 0x080000, CRC(efd2fdbe) SHA1(bdaab9afd52e4514b7f6e49b0812f11446fa04f5) )
	ROM_LOAD16_BYTE( "95417100.lo", 0x00001, 0x080000, CRC(aa530f1b) SHA1(979ab4a9e6cf3a2e72c3c7ca7da07b01527902f8) )
	ROM_LOAD16_BYTE( "95417101.hi", 0x00000, 0x080000, CRC(04b9ee4a) SHA1(c1e823dbab97fd9da0836bf85fa33dc6657568fc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008331.bin", 0x0000, 0x100000, CRC(b41748dd) SHA1(458409a4d2f6444af564ebe28d80e110fdb845b6) )
	ROM_LOAD( "95008927.bin", 0x0000, 0x0f1c08, CRC(38fccc48) SHA1(9ef11b3fbe3bbd3c5b74cee2c35581f3e41cb372) )
ROM_END


ROM_START( sc_rhxcs )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420716.lo", 0x00001, 0x080000, CRC(a713a289) SHA1(327b2e3e0313582743061685638d70846ccf711a) )
	ROM_LOAD16_BYTE( "95420717.hi", 0x00000, 0x080000, CRC(a3c88ba3) SHA1(af5c4931f133dccebd8d2ec9be6e74eba707f3ee) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420728.lo", 0x00001, 0x080000, CRC(a8e2ca7b) SHA1(3bc886f3e89b22b02a7450cbb4c9a3de87d72e35) )
	ROM_LOAD16_BYTE( "95420729.hi", 0x00000, 0x080000, CRC(7901b640) SHA1(54aaed0ecdb5d3e3b6eb1fbbba79ae65e74c26e4) )
	ROM_LOAD16_BYTE( "95420730.lo", 0x00001, 0x080000, CRC(421349f0) SHA1(f4dbe6c050325ec060a5fdbefe8a9bb96d8339bd) )
	ROM_LOAD16_BYTE( "95420731.hi", 0x00000, 0x080000, CRC(c6c0611b) SHA1(246c7b7b940af9ead6ceecca16b07957b116d98e) )
	ROM_LOAD16_BYTE( "95420732.lo", 0x00001, 0x080000, CRC(c4cba892) SHA1(ae54fa1b3f0d4e35c3b4a3efe1674e6949ce146b) )
	ROM_LOAD16_BYTE( "95420733.hi", 0x00000, 0x080000, CRC(2c963e42) SHA1(3f45d2be7bb0652de3859167efa9338c2d661e3d) )
	ROM_LOAD16_BYTE( "95421716.lo", 0x00001, 0x080000, CRC(302719b9) SHA1(3e9df6d227a901c4f19028cd8e4b6fa640209ac5) )
	ROM_LOAD16_BYTE( "95421717.hi", 0x00000, 0x080000, CRC(3b022f78) SHA1(bb1798468fe99c269712bc06bff8613ae03c81e7) )
	ROM_LOAD16_BYTE( "95421728.lo", 0x00001, 0x080000, CRC(860a9d46) SHA1(a5e40599138947f4a24af6415ac0fc906c52fa97) )
	ROM_LOAD16_BYTE( "95421729.hi", 0x00000, 0x080000, CRC(6d7d63eb) SHA1(2f56f210eb5b09e0d2a66e396cff9a54c064a1de) )
	ROM_LOAD16_BYTE( "95421730.lo", 0x00001, 0x080000, CRC(5af48ed1) SHA1(23e35c7863e97bf3e4bd07302db916b41d30c9b1) )
	ROM_LOAD16_BYTE( "95421731.hi", 0x00000, 0x080000, CRC(0c051de0) SHA1(c8310e09f2b586bb6d80cb38cf084265436a6836) )
	ROM_LOAD16_BYTE( "95421732.lo", 0x00001, 0x080000, CRC(ea23ffaf) SHA1(beff9c081f9d73964531609de9cc1a521315d23e) )
	ROM_LOAD16_BYTE( "95421733.hi", 0x00000, 0x080000, CRC(38eaebe9) SHA1(ea3d4d58726f4dee143d41a09b87ccf467e4fdb3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008853.bin", 0x0000, 0x0d11f1, CRC(c055b73c) SHA1(0c668e1733a089f95c61d1fe50fde2d4217e0e5f) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890724.bin", 0x0000, 0x5000, CRC(118e80ca) SHA1(9cd3dc111710224a8916f7b0f24e8997a9d98a8c) )
	ROM_LOAD( "95890725.bin", 0x0000, 0x5000, CRC(0d587076) SHA1(b470b3f1c1c82526c9dd08ae7dedbdc38bfb334d) )
	ROM_LOAD( "95890726.bin", 0x0000, 0x5000, CRC(ce0252e6) SHA1(9d6f69de70647e12d8352bc73922393006602797) )
ROM_END


ROM_START( sc_rhxcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408050.lo", 0x00001, 0x080000, CRC(aa97ebde) SHA1(888bd0361a52928f5781fca6b1f2d0c4b19e715f) )
	ROM_LOAD16_BYTE( "95408051.hi", 0x00000, 0x080000, CRC(f2b1bb5b) SHA1(3d1e8afa800bb8a2808620246189a7b2cd5acc45) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408380.lo", 0x00001, 0x080000, CRC(a6b34b32) SHA1(29008a8164f96704f4f28318c53bb1e7e5e7050d) )
	ROM_LOAD16_BYTE( "95408381.hi", 0x00000, 0x080000, CRC(1bdea091) SHA1(1125631cede992df92891715ff5b6447aaa4bcaa) )
	ROM_LOAD16_BYTE( "95409050.lo", 0x00001, 0x080000, CRC(7ba8ed4e) SHA1(e940d0bf4f555e9089f74177f40dd2f6cf1f5e28) )
	ROM_LOAD16_BYTE( "95409051.hi", 0x00000, 0x080000, CRC(c91a1ace) SHA1(9b3018c397a759cf48e9417e62e6cf98d34f948a) )
	ROM_LOAD16_BYTE( "95409380.lo", 0x00001, 0x080000, CRC(41686594) SHA1(a93702f7887b9fd8cfc69ab0ec8d76903e7bc094) )
	ROM_LOAD16_BYTE( "95409381.hi", 0x00000, 0x080000, CRC(1bdea091) SHA1(1125631cede992df92891715ff5b6447aaa4bcaa) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008313.bin", 0x0000, 0x0c8958, CRC(4850fb2b) SHA1(9dde245c5b4afd6dbfd33372dff35fcbeefc2fe4) )
ROM_END


ROM_START( sc_redsq )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416590.lo", 0x00001, 0x080000, CRC(4d08d688) SHA1(fe9e65553d9e8df7231c9a959b4a7c9f05de1e01) )
	ROM_LOAD16_BYTE( "95416591.hi", 0x00000, 0x080000, CRC(0d4d40fc) SHA1(1e671db1f035117a57f96b5c8343f602501f5ba9) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416592.lo", 0x00001, 0x080000, CRC(d20ea5e4) SHA1(0f8a1481826ea6b4f7ce20b4cb3fcf28497e9b6b) )
	ROM_LOAD16_BYTE( "95416593.hi", 0x00000, 0x080000, CRC(c173bad0) SHA1(d4ca8791c9ef322c798c0bcd8c7783743564e794) )
	ROM_LOAD16_BYTE( "95416594.lo", 0x00001, 0x080000, CRC(cb6f3107) SHA1(cc50705d5140de0ce40eeb6850d543eb0e0ef84a) )
	ROM_LOAD16_BYTE( "95416595.hi", 0x00000, 0x080000, CRC(3a7818fe) SHA1(522e7d2b0c1fe9df0833b141a836089b04d5879d) )
	ROM_LOAD16_BYTE( "95417590.lo", 0x00001, 0x080000, CRC(2c7c829c) SHA1(d540309dfea5240316c0d10e410d5cf7f9e0b9c5) )
	ROM_LOAD16_BYTE( "95417591.hi", 0x00000, 0x080000, CRC(52b4ca1d) SHA1(0a86824ebde3d9b33a2cd58a81b9232bde76bfd4) )
	ROM_LOAD16_BYTE( "95417592.lo", 0x00001, 0x080000, CRC(fe827ca9) SHA1(2d9c19e172dc4901c9bfca78ed08310d2a1d6372) )
	ROM_LOAD16_BYTE( "95417593.hi", 0x00000, 0x080000, CRC(5a2c49af) SHA1(d6de2f5c6bc92cac83c2ec771352d391c32a2a16) )
	ROM_LOAD16_BYTE( "95417594.lo", 0x00001, 0x080000, CRC(575161bb) SHA1(9172582651f4e0da39a859a49ddff4833e18094b) )
	ROM_LOAD16_BYTE( "95417595.hi", 0x00000, 0x080000, CRC(c8b428ef) SHA1(b54c3cefa51eb4563ec39c5d23fe50588e3f6ee0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008920.bin", 0x0000, 0x0f8d12, CRC(ac69f283) SHA1(4b62d2759f82effea988310df5ca92dd9f417a6d) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890350.bin", 0x0000, 0x5000, CRC(3e015e16) SHA1(c3a180d3611f46c9d7e93309d751b2422ec672cc) )
	ROM_LOAD( "95890351.bin", 0x0000, 0x5000, CRC(4b971a22) SHA1(205feec301bb69bf461fc4377704f675b5664944) )
	ROM_LOAD( "95890352.bin", 0x0000, 0x5000, CRC(d52dd67e) SHA1(8e5623d1fe4e096b1a19a153b0d2184424642469) )
ROM_END


ROM_START( sc_r2r )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404582.lo", 0x00001, 0x080000, CRC(e14d88a0) SHA1(a0096849a68403753a11ab41bd8271625bf5f068) )
	ROM_LOAD16_BYTE( "95404583.hi", 0x00000, 0x080000, CRC(fd06feea) SHA1(c634d39ec9e4d0587a52b5bf9cfd99e27027a2ef) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405582.lo", 0x00001, 0x080000, CRC(9eff3047) SHA1(366591ad30ebbc1b1ba42b965d006b97842f1745) )
	ROM_LOAD16_BYTE( "95405583.hi", 0x00000, 0x080000, CRC(bd6081ac) SHA1(089d47a2e6da1657680829f55d990a41b2b9144a) )
	ROM_LOAD16_BYTE( "95406140.lo", 0x00001, 0x080000, CRC(144a5fcb) SHA1(4e75518bfda43043bfb412aaa92c650b16bf5704) )
	ROM_LOAD16_BYTE( "95406141.hi", 0x00000, 0x080000, CRC(5607f264) SHA1(494ae1f1dc292e65ade7458ac86926062b578203) )
	ROM_LOAD16_BYTE( "95407140.lo", 0x00001, 0x080000, CRC(2e4ccefd) SHA1(8f7a9f18e3445dc3487814220f9dbe37aef2e9da) )
	ROM_LOAD16_BYTE( "95407141.hi", 0x00000, 0x080000, CRC(2150b14e) SHA1(6b15020f1c3ffb220be077cde3b1002f2838a756) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_relcz )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404576.lo", 0x00001, 0x080000, CRC(b4a35013) SHA1(af54ef71e891708cf55f2fa0eb93fca1b184a174) )
	ROM_LOAD16_BYTE( "95404577.hi", 0x00000, 0x080000, CRC(d2f649d4) SHA1(bbb6b9f4f8b7f0844189dca0eff8c19e81772b7d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405576.lo", 0x00001, 0x080000, CRC(40a1b8e3) SHA1(a18ba3ad2336f407ba6e1a7f829edde5f5a8c357) )
	ROM_LOAD16_BYTE( "95405577.hi", 0x00000, 0x080000, CRC(6313342c) SHA1(5d103a557c48d9d63c259bfdae4277b5b0d140a6) )
	ROM_LOAD16_BYTE( "95406022.lo", 0x00001, 0x080000, CRC(c44007bb) SHA1(7191f6982d53c1fb7e75f55bf47c292cfd8a42bb) )
	ROM_LOAD16_BYTE( "95406023.hi", 0x00000, 0x080000, CRC(f53ee5a5) SHA1(65f4556c8f8366cbfaedbb34b44077e2c1534e32) )
	ROM_LOAD16_BYTE( "95407022.lo", 0x00001, 0x080000, CRC(0a34c0a3) SHA1(406c40db39f3d97cdf178936117144e37e69f497) )
	ROM_LOAD16_BYTE( "95407023.hi", 0x00000, 0x080000, CRC(5d71f597) SHA1(7905aac99abe5cf4e0fe7833c64998cd2c7658cd) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008185.bin", 0x0000, 0x100000, CRC(d41a9b86) SHA1(9269000ec8d81b24e04a98b63e3294d56439820d) )
	ROM_LOAD( "95008186.bin", 0x0000, 0x100000, CRC(8f5bfdaf) SHA1(ecba8cacc83224d75b8076c6fd5fe46863a0689e) )
ROM_END


ROM_START( sc_rotc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410882.lo", 0x00001, 0x080000, CRC(2a29ed0c) SHA1(319d34e88e65ea3c1f8c3686760561af6fea6342) )
	ROM_LOAD16_BYTE( "95410883.hi", 0x00000, 0x080000, CRC(a204a346) SHA1(281bff93f769c9d0b7168ef2c1ac8baca4255d8e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414572.lo", 0x00001, 0x080000, CRC(c5ffd5a6) SHA1(0abab951024fc537e13fa73e918af64ca84b2ce4) )
	ROM_LOAD16_BYTE( "95414573.hi", 0x00000, 0x080000, CRC(69eafaf6) SHA1(6088df4ef481c335d3f2922a226f4c9f79680618) )
	ROM_LOAD16_BYTE( "95414808.lo", 0x00001, 0x080000, CRC(dc600bd3) SHA1(399557efb637d0ed348d0fa6c4bdc49f6f07ce05) )
	ROM_LOAD16_BYTE( "95414809.hi", 0x00000, 0x080000, CRC(f8da204c) SHA1(060a8eb733a05fbe70aa520ba05b8983cdfcf73f) )
	ROM_LOAD16_BYTE( "95415572.lo", 0x00001, 0x080000, CRC(3840e0d9) SHA1(e17223ce9062bb8958dbc01721b6cb863947613c) )
	ROM_LOAD16_BYTE( "95415573.hi", 0x00000, 0x080000, CRC(0a2cb3a7) SHA1(26e35b7edf2fe9cdf35bd31e8fbf5d6aac805542) )
	ROM_LOAD16_BYTE( "95415808.lo", 0x00001, 0x080000, CRC(cfc11a14) SHA1(a2294bb40c5dc80434342c0557542ccd6a256415) )
	ROM_LOAD16_BYTE( "95415809.hi", 0x00000, 0x080000, CRC(bb60fda2) SHA1(1ec35aa55ad0894b974978e53ffb1d4e559221e0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "rotcsnd.bin", 0x0000, 0x100000, CRC(301147a2) SHA1(49a31e1e3c8af19e524f4f4b68533e4b2cc5e03d) )
ROM_END


ROM_START( sc_rvlnx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408168.lo", 0x00001, 0x080000, CRC(f1c731cf) SHA1(f7b7b7ee0fe04eb38683b01c2be0d3a28175adc5) )
	ROM_LOAD16_BYTE( "95408169.hi", 0x00000, 0x080000, CRC(b3addfca) SHA1(2001653d5d11af59e5f6807e8f209310b4b16a54) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD16_BYTE( "95004320.snd", 0x0000, 0x080000, CRC(b20c0557) SHA1(f61df4a80751571caf4d44add753b5477c13b7f0) )
ROM_END


ROM_START( sc_rvl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406362.lo", 0x00001, 0x080000, CRC(e9a34f99) SHA1(49ea9a2187c6077800b6f44e0cc9a63a3f93b508) )
	ROM_LOAD16_BYTE( "95406363.hi", 0x00000, 0x080000, CRC(4da07a11) SHA1(fa0154e163e3702cb434295ac6ba8961ffa3819c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004259.sn1", 0x0000, 0x080000, CRC(c26ed994) SHA1(da336ab76c1c148906c734d7239b2b83a05ec083) )
	ROM_LOAD( "95004260.sn2", 0x0000, 0x080000, CRC(1a32d1bd) SHA1(e88ba7b8b353ea168a689e1d2be8c753a56f8f1d) )
ROM_END


ROM_START( sc_revo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404540.lo", 0x00001, 0x080000, CRC(f8ea2471) SHA1(35f1d139c3963c07025cccec1afc85d7a151bf56) )
	ROM_LOAD16_BYTE( "95404541.hi", 0x00000, 0x080000, CRC(0c67e582) SHA1(f6818350f9f123efc9a215f167dce43a90104f67) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404542.lo", 0x00001, 0x080000, CRC(9ba820d6) SHA1(21787ba15a288a672d28014f0f3553c619dd20b4) )
	ROM_LOAD16_BYTE( "95404543.hi", 0x00000, 0x080000, CRC(9e622e0f) SHA1(c262765d73006239fd5084ba6ec1a21146464f9a) )
	ROM_LOAD16_BYTE( "95405540.lo", 0x00001, 0x080000, CRC(bec4cd27) SHA1(d3ebf89d05c251dd202f21fa729f637d80ac1a96) )
	ROM_LOAD16_BYTE( "95405541.hi", 0x00000, 0x080000, CRC(f17e7ac5) SHA1(dad87fa51363d1417e6d1759817d300c8e57fdad) )
	ROM_LOAD16_BYTE( "95405542.lo", 0x00001, 0x080000, CRC(fbf13fcc) SHA1(88109812bb8b41282aa3375af83b18a52231b438) )
	ROM_LOAD16_BYTE( "95405543.hi", 0x00000, 0x080000, CRC(d29eccb0) SHA1(ad5360ca3ac4b2506619ca9a6ecb0e63a83bfc80) )
	ROM_LOAD16_BYTE( "95406144.lo", 0x00001, 0x080000, CRC(983403fb) SHA1(a8eb30a37e898ca1908d83cc503d94ebf92d6172) )
	ROM_LOAD16_BYTE( "95406145.hi", 0x00000, 0x080000, CRC(756aad16) SHA1(58a5b98c987eeaf2292679cefc91248d349d3a08) )
	ROM_LOAD16_BYTE( "95407144.lo", 0x00001, 0x080000, CRC(a4b8628d) SHA1(e8cff42fdace858f54422999078afd1403fdc021) )
	ROM_LOAD16_BYTE( "95407145.hi", 0x00000, 0x080000, CRC(84e9afa8) SHA1(128bd2dc01c7aabaa36a3be379db8073c93482e9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008871.bin", 0x0000, 0x0fd182, CRC(e4f3b731) SHA1(ef829105e1b45c307546127ba85f5e0e5403ab98) )
ROM_END


ROM_START( sc_rich )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402930.lo", 0x00001, 0x080000, CRC(94654103) SHA1(7c4cd1df0530e4d6f76c3f59849a356f7b6aaab6) )
	ROM_LOAD16_BYTE( "95402931.hi", 0x00000, 0x080000, CRC(c8d8e1cb) SHA1(07853c8f8135366cc85ad8cb3b98de9afefeaf46) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402934.lo", 0x00001, 0x080000, CRC(250add32) SHA1(0b0c2c339ca08240706630543d60041568237f5e) )
	ROM_LOAD16_BYTE( "95402935.hi", 0x00000, 0x080000, CRC(ec58cd31) SHA1(d58e84e6656e0cc82f88d79f5aa009a6b644b18f) )
	ROM_LOAD16_BYTE( "95402936.lo", 0x00001, 0x080000, CRC(c0271a19) SHA1(243556b9e661f9cebd08cc3985a4430f30e8abcd) )
	ROM_LOAD16_BYTE( "95402937.hi", 0x00000, 0x080000, CRC(f346abb2) SHA1(b1752d1d91eda82e90c0dc9dc21df8ac4f33a369) )
	ROM_LOAD16_BYTE( "95402944.lo", 0x00001, 0x080000, CRC(6dfeaecf) SHA1(627eab4076d323f727a88f129fdf10336debe03e) )
	ROM_LOAD16_BYTE( "95402945.hi", 0x00000, 0x080000, CRC(60fe347d) SHA1(7e8d7373a9a294980c427ce872190eed0ac18ebf) )
	ROM_LOAD16_BYTE( "95403930.lo", 0x00001, 0x080000, CRC(f5e21802) SHA1(eb6cac61f63e8bd4f0d267aa9de0a0eb4d46bdfd) )
	ROM_LOAD16_BYTE( "95403931.hi", 0x00000, 0x080000, CRC(d982b154) SHA1(fb22115bf429569887cc9d6e4ed42efc002ee8c5) )
	ROM_LOAD16_BYTE( "95403934.lo", 0x00001, 0x080000, CRC(234c2e0c) SHA1(a4bea103d2e14b76586d9793bc63824b4116931d) )
	ROM_LOAD16_BYTE( "95403935.hi", 0x00000, 0x080000, CRC(e535c4c9) SHA1(76dcc670bf06f28e48266e7c76a3714fcbf15d09) )
	ROM_LOAD16_BYTE( "95403936.lo", 0x00001, 0x080000, CRC(335e3640) SHA1(e42384a3e6e848aa189e612409e4922343b99c8f) )
	ROM_LOAD16_BYTE( "95403937.hi", 0x00000, 0x080000, CRC(ab912677) SHA1(4b39d83f14c92f5c7dbb2656d2029d0192a1de58) )
	ROM_LOAD16_BYTE( "95403944.lo", 0x00001, 0x080000, CRC(53b9846a) SHA1(bbd43ecb6b4cad3f582b8535d39c8a0416342112) )
	ROM_LOAD16_BYTE( "95403945.hi", 0x00000, 0x080000, CRC(591c7edf) SHA1(92cd0961760499ae363f4dec7bd8bd35b1ca3f26) )
	ROM_LOAD16_BYTE( "95406452.lo", 0x00001, 0x080000, CRC(cbfa4c42) SHA1(abd848cda7f1bf52829fb32933685147e88b7a05) )
	ROM_LOAD16_BYTE( "95406453.hi", 0x00000, 0x080000, CRC(f0230716) SHA1(757926182944b4181986dc577075ee842e716b4c) )
	ROM_LOAD16_BYTE( "95406454.lo", 0x00001, 0x080000, CRC(6daea98f) SHA1(3a7b5bfa005de416e3e1d496765db6db0383bda2) )
	ROM_LOAD16_BYTE( "95406455.hi", 0x00000, 0x080000, CRC(3c3a3e43) SHA1(6a19c672b60975ed63b3cde0dec9a023ee1b18c2) )
	ROM_LOAD16_BYTE( "95407452.lo", 0x00001, 0x080000, CRC(e0e80388) SHA1(40a80ba6930dde57cc15a8371a5a38ef2a851423) )
	ROM_LOAD16_BYTE( "95407453.hi", 0x00000, 0x080000, CRC(8a39fca7) SHA1(88dbb4a4d01b90bbc8c8c1497dbf55f0bf408556) )
	ROM_LOAD16_BYTE( "95407454.lo", 0x00001, 0x080000, CRC(0e1ef2e5) SHA1(dc8e037b6b01e014cf0ea2f5cf92b6adfa2d92a6) )
	ROM_LOAD16_BYTE( "95407455.hi", 0x00000, 0x080000, CRC(d52b4419) SHA1(99376a27b4439a2d6dab47c689f06d735d41e102) )
	ROM_LOAD16_BYTE( "r_geez.hi", 0x00000, 0x080000, CRC(c1c510bf) SHA1(6b4483e2b732f6b212087c019de2e870b777dd97) )
	ROM_LOAD16_BYTE( "r_geez.lo", 0x00001, 0x080000, CRC(c34f5939) SHA1(a2b0ebafee568ff1a9534c59afe50495c1815d2f) )


	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008084.lo", 0x00001, 0x100000, CRC(2231c842) SHA1(2180109949281b053313c8a8de33496d31d4279e) )
	ROM_LOAD( "95008085.hi", 0x00000, 0x100000, CRC(eb748aa3) SHA1(b81acfbceb5ff9df8bb30d3da82deea70bfce2fe) )
ROM_END


ROM_START( sc_rio )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406350.lo", 0x00001, 0x080000, CRC(0f036800) SHA1(3fda07eaf2f325e50e0532e7dc2e4431eb3546ee) )
	ROM_LOAD16_BYTE( "95406351.hi", 0x00000, 0x080000, CRC(90fe320b) SHA1(2ba801956df119211cdb2d4e42b94fffaaf8dad8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004309.snd", 0x0000, 0x080000, CRC(60eb25fc) SHA1(66f3ac8bc1be99eda07c71f63ebc818014ef7800) )
ROM_END


ROM_START( sc_rttt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408382.lo", 0x00001, 0x080000, CRC(c11a966b) SHA1(cb6f942426910c550bdc0d86f3bfa8579c35f081) )
	ROM_LOAD16_BYTE( "95408383.hi", 0x00000, 0x080000, CRC(9f7a5fca) SHA1(62405e5d4c3279b5a451aa507c8c6feb9b14e5c8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409382.lo", 0x00001, 0x080000, CRC(5b10f3fc) SHA1(5601f1dbe04d6db7a4af2be395b0b4fbb9e1f5df) )
	ROM_LOAD16_BYTE( "95409383.hi", 0x00000, 0x080000, CRC(76f2caf6) SHA1(d13c034f056c170393c0466fc14ee0179cfdbb8b) )
	ROM_LOAD16_BYTE( "95410486.lo", 0x00001, 0x080000, CRC(146ec9ff) SHA1(88d53838b575c37cb492aa7727ac3b5fb6d32156) )
	ROM_LOAD16_BYTE( "95410487.hi", 0x00000, 0x080000, CRC(50b19298) SHA1(e37a83f644eab65fd7d876f9fa4561f0cbe58067) )
	ROM_LOAD16_BYTE( "95410488.lo", 0x00001, 0x080000, CRC(620e861a) SHA1(2416baf3d195134ea34b135ba1c2dc710ec2e1b8) )
	ROM_LOAD16_BYTE( "95410489.hi", 0x00000, 0x080000, CRC(0f6cd4b6) SHA1(fbfb6380186de3be380e28cdecec8bfc1ea29a89) )
	ROM_LOAD16_BYTE( "95411486.lo", 0x00001, 0x080000, CRC(85c38552) SHA1(ed7c9b73fa75f7e589dd734ec584a48101557798) )
	ROM_LOAD16_BYTE( "95411487.hi", 0x00000, 0x080000, CRC(e3b6e1b8) SHA1(c85926dab78169a445894e173f4661d0f2bc05dc) )
	ROM_LOAD16_BYTE( "95411488.lo", 0x00001, 0x080000, CRC(de68cc2f) SHA1(c0ae038a42f2ba227f0195813cb76a2265808600) )
	ROM_LOAD16_BYTE( "95411489.hi", 0x00000, 0x080000, CRC(16c6b97c) SHA1(90223eb9c873d61a9ffa605ddcbdc369c7c87305) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008306.bin", 0x0000, 0x100000, CRC(9c61f2ff) SHA1(5f000dcb2ec694fa8578f32fa485e61ad065e3d5) )
ROM_END


ROM_START( sc_roksc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410426.odd", 0x00001, 0x080000, CRC(75b7f366) SHA1(b09cb427f847bae090fcf165ccb80d35ead6bc81) )
	ROM_LOAD16_BYTE( "95410427.evn", 0x00000, 0x080000, CRC(af854394) SHA1(9909840c1c7ccfb3874af0a4be562e7dd8ae6e2a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410784.odd", 0x00001, 0x080000, CRC(c1ca7dcb) SHA1(cbb389e6aa0ff50c4c2880c78708345c8a207bec) )
	ROM_LOAD16_BYTE( "95410785.evn", 0x00000, 0x080000, CRC(d5cbba23) SHA1(014d8057f1d28da72c6d5e0169bc73feeed1e918) )
	ROM_LOAD16_BYTE( "95411426.odd", 0x00001, 0x080000, CRC(6d5b8ab9) SHA1(3a223084b6542bc78956ab32a368bfb9b4ee6034) )
	ROM_LOAD16_BYTE( "95411427.evn", 0x00000, 0x080000, CRC(5e06412a) SHA1(1b30fc33418b351efc9cffad9f6fc59833ca899c) )
	ROM_LOAD16_BYTE( "95411784.odd", 0x00001, 0x080000, CRC(d0720971) SHA1(78787976966a00875031130a81d4be6cd5aab866) )
	ROM_LOAD16_BYTE( "95411785.evn", 0x00000, 0x080000, CRC(e265d077) SHA1(a7dd5b0025338d76aa6df015a07192829a3c17be) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008405.bin", 0x0000, 0x0fec18, CRC(847c5cbb) SHA1(cd304c31bd1f87e6b2444b50450ab9dd42ca79eb) )
ROM_END


ROM_START( sc_rogds )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406306.odd", 0x00001, 0x080000, CRC(c552e1fb) SHA1(dbda6881e47e526485225a088103f568cd38b36b) )
	ROM_LOAD16_BYTE( "95406307.evn", 0x00000, 0x080000, CRC(b9a0000b) SHA1(31d21d294331bc0d7c46aaf447fa3562286bc1cc) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406658.odd", 0x00001, 0x080000, CRC(87cc73ac) SHA1(dba0d665329d78e028290951657676671bb36317) )
	ROM_LOAD16_BYTE( "95406659.evn", 0x00000, 0x080000, CRC(efdbeb0b) SHA1(0b0d104c6662a5801d33925d76b7b1b0afba149f) )
	ROM_LOAD16_BYTE( "95407658.odd", 0x00001, 0x080000, CRC(2eeed088) SHA1(399f4f3e3e71ff65086fd2ed73f2a517a3980aee) )
	ROM_LOAD16_BYTE( "95407659.evn", 0x00000, 0x080000, CRC(f80915e0) SHA1(5564c47c5668f97d594840856a5f8c1fe0438ebe) )
	ROM_LOAD16_BYTE( "95407808.odd", 0x00001, 0x080000, CRC(83bd9eca) SHA1(09dcb17b5326ba1d29a6ebf2ec7c990f7e18c21a) )
	ROM_LOAD16_BYTE( "95407809.evn", 0x00000, 0x080000, CRC(827c0acc) SHA1(3322d5d4598a0680f915347f2c7e748ddcbc78b2) )
	ROM_LOAD16_BYTE( "95408132.odd", 0x00001, 0x080000, CRC(aa609a02) SHA1(2a7c9a7017b383f2642671ad912273a5182afa51) )
	ROM_LOAD16_BYTE( "95408133.evn", 0x00000, 0x080000, CRC(fa7af483) SHA1(6f1ab822522f8e7867b23727648dd89c93a594da) )
	ROM_LOAD16_BYTE( "95409042.odd", 0x00001, 0x080000, CRC(8242a18d) SHA1(fe4024530d05479e6cff184b0532d0b94d500054) )
	ROM_LOAD16_BYTE( "95409043.evn", 0x00000, 0x080000, CRC(af0d81c2) SHA1(0a04f02a31fafe883ef16ee2c408a763fbbbbe0f) )
	ROM_LOAD16_BYTE( "95409132.odd", 0x00001, 0x080000, CRC(40ec2c64) SHA1(c3d8e3ca0e49d996492b4482fc999489b26e2177) )
	ROM_LOAD16_BYTE( "95409133.evn", 0x00000, 0x080000, CRC(9bc1e532) SHA1(81a976d4df906e408d10134f4f183d8cf1eb52f4) )
	ROM_LOAD16_BYTE( "95409324.odd", 0x00001, 0x080000, CRC(fcd86b8c) SHA1(f8f682a502ad45e79ff982afc77e08801e071cbe) )
	ROM_LOAD16_BYTE( "95409325.evn", 0x00000, 0x080000, CRC(9958fd88) SHA1(298b2c0852339ef7589c88fbb4400277c18818a4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008256.bin", 0x0000, 0x0fafa4, CRC(6d70436f) SHA1(adf7d18d9fcbb216ee461183951c1ab2972b8ef7) )
ROM_END


ROM_START( sc_rmo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402972.lo", 0x00001, 0x080000, CRC(0d12366a) SHA1(311bc72e4684428ec393c04d5b51dbb6f497d548) )
	ROM_LOAD16_BYTE( "95402973.hi", 0x00000, 0x080000, CRC(77ecbc6f) SHA1(1c8b5de1c489b700517313ef8ed6dd157cc20b82) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403972.lo", 0x00001, 0x080000, CRC(89eb3046) SHA1(480f36e938b69d4df50754267e7d251c549d437f) )
	ROM_LOAD16_BYTE( "95403973.hi", 0x00000, 0x080000, CRC(3b8f08e8) SHA1(3577a9304a6e5ee69c508dacb037f76325f40020) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_rt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404322.lo", 0x00001, 0x080000, CRC(53980334) SHA1(8f00235ababdf087aa892047dbdca974043729fd) )
	ROM_LOAD16_BYTE( "95404323.hi", 0x00000, 0x080000, CRC(f74bbef3) SHA1(86a5c120c99771c2ee3197718cb424d0691a39c5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405322.lo", 0x00001, 0x080000, CRC(ab08bdfc) SHA1(a721dffb8ece74bf6552f2ed3e2e886788a648e7) )
	ROM_LOAD16_BYTE( "95405323.hi", 0x00000, 0x080000, CRC(f536e613) SHA1(9457a7897fdc2c20725426a12d9cab0b07be4e6e) )
	ROM_LOAD16_BYTE( "95405324.lo", 0x00001, 0x080000, CRC(1ee0bf92) SHA1(a8c402468e20743baa5b4c35c7b0e2cf71cc01f9) )
	ROM_LOAD16_BYTE( "95405325.hi", 0x00000, 0x080000, CRC(c96cfed2) SHA1(c48dbcd885d19d06dbec30d794b9f63d9d902f6d) )
	ROM_LOAD16_BYTE( "95406146.lo", 0x00001, 0x080000, CRC(76cba54b) SHA1(d9017ed89d3c4e13544048e331cf863995f5ae41) )
	ROM_LOAD16_BYTE( "95406147.hi", 0x00000, 0x080000, CRC(b5ac6ae6) SHA1(aeef1cc4aee31cfa2f8b9264e969c37655d98a39) )
	ROM_LOAD16_BYTE( "95407146.lo", 0x00001, 0x080000, CRC(b30a7f7b) SHA1(3323295e2bb342dfb5246f1c59244d061a0f7c8f) )
	ROM_LOAD16_BYTE( "95407147.hi", 0x00000, 0x080000, CRC(5d1a53aa) SHA1(66d9184c67566745c0db5b5c453a612f3af5b148) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008203_1.bin", 0x0000, 0x100000, CRC(778a18e5) SHA1(2ad4d0259f08786f50928064a4d345ffa6bb52e2) )
	ROM_LOAD( "95008204_2.bin", 0x0000, 0x100000, CRC(ef036383) SHA1(cb26a334fe043c6aba312dc6d3fe91bd93e0cb2f) )
ROM_END


ROM_START( sc_rtclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404716.lo", 0x00001, 0x080000, CRC(24355f67) SHA1(e1f3367cc8bb59e1906a1c8ae9ebe355ac3f2183) )
	ROM_LOAD16_BYTE( "95404717.hi", 0x00000, 0x080000, CRC(f285afa5) SHA1(1ad30b6a4fdb045ac259e5f5eaae0a7383cdb804) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405716.lo", 0x00001, 0x080000, CRC(e0b46a90) SHA1(47e7abef29065f9cb0a41aa5b584785952532de7) )
	ROM_LOAD16_BYTE( "95405717.hi", 0x00000, 0x080000, CRC(854dbab7) SHA1(83bb4503adec83f415a09f7f0303577e8caee174) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_rollo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400265.lo", 0x00001, 0x080000, CRC(d0d8bd41) SHA1(bf7e223cbbf7a79d7c62b389a492d0b1842917c6) )
	ROM_LOAD16_BYTE( "95400266.hi", 0x00000, 0x080000, CRC(d5472cf1) SHA1(00b055401fbbf46f12919ec13c34cef2e14d4d1f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400267.lo", 0x00001, 0x080000, CRC(da2b4d37) SHA1(a56074f1ba0985d3b20c2e6ffab8e66430f98da7) )
	ROM_LOAD16_BYTE( "95400268.hi", 0x00000, 0x080000, CRC(e91c87cb) SHA1(203e0365b692d445f3c56ee0858e5fae69d53b75) )
	ROM_LOAD16_BYTE( "95400667.lo", 0x00001, 0x080000, CRC(067efd8e) SHA1(ed4c793a95b859d882ef1018a9b5a8a7d2e00443) )
	ROM_LOAD16_BYTE( "95400668.hi", 0x00000, 0x080000, CRC(e1980c74) SHA1(a94fd00cf1750f2051cf2769969d41b8e4e56be3) )
	ROM_LOAD16_BYTE( "95401265.lo", 0x00001, 0x080000, CRC(ce0a645e) SHA1(83f2a9e3de766ae6a7eb54895f519e8185bf4251) )
	ROM_LOAD16_BYTE( "95401266.hi", 0x00000, 0x080000, CRC(29601fc6) SHA1(d764143252da6e5fe9bff960558f0441f0a6baa9) )
	ROM_LOAD16_BYTE( "95401267.lo", 0x00001, 0x080000, CRC(4df4bcd5) SHA1(f4c2f193b0d0d11b62107dd7ddbac631a7cc70f7) )
	ROM_LOAD16_BYTE( "95401268.hi", 0x00000, 0x080000, CRC(55c29d82) SHA1(3c08d26b57954da271ad594ef906c23c45780c83) )
	ROM_LOAD16_BYTE( "95401611.lo", 0x00001, 0x080000, CRC(3a2193ce) SHA1(4a9cae94870c269e594484626c2e7f2d4f8f8f48) )
	ROM_LOAD16_BYTE( "95401612.hi", 0x00000, 0x080000, CRC(75c4080c) SHA1(22294cc777f2ca520b4f49eee77cbf50e0102f84) )
	ROM_LOAD16_BYTE( "95401613.lo", 0x00001, 0x080000, CRC(301ab7c6) SHA1(04db05b2b154c466438a3adf7053e4801da55dee) )
	ROM_LOAD16_BYTE( "95401614.hi", 0x00000, 0x080000, CRC(dc7164d2) SHA1(f8bb3db8d758da605f3f02ed492194caf824fefd) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_rosts )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422964.lo", 0x00001, 0x080000, CRC(18e28827) SHA1(b02ea8af0a5b8f32b9f25aa7cf9683134874accf) )
	ROM_LOAD16_BYTE( "95422965.hi", 0x00000, 0x080000, CRC(b47d1661) SHA1(22c71e58f16950f14653cee18851c7a6c0a8c543) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95423964.lo", 0x00001, 0x080000, CRC(b2693c9f) SHA1(dc2bf944e6ec46f03d4a43ebe106f43c210f017a) )
	ROM_LOAD16_BYTE( "95423965.hi", 0x00000, 0x080000, CRC(68be548e) SHA1(13e3e87a17d981a8a9eeaa0084a951768a093528) )
	ROM_LOAD16_BYTE( "95426022.lo", 0x00001, 0x080000, CRC(e9f60087) SHA1(cfb1f351c02e790d8116a5293a031e2412465daa) )
	ROM_LOAD16_BYTE( "95426023.hi", 0x00000, 0x080000, CRC(bdea13e2) SHA1(f6e76d9ba144c34141211a6983cda893c11d254c) )
	ROM_LOAD16_BYTE( "95426024.lo", 0x00001, 0x080000, CRC(344ae121) SHA1(3b6b24492ba0e7d22adb9a8b152ebc61b433af17) )
	ROM_LOAD16_BYTE( "95426025.hi", 0x00000, 0x080000, CRC(543eb055) SHA1(8468395c2a805751cfd8d67f9a124ede4bca269e) )
	ROM_LOAD16_BYTE( "95426190.lo", 0x00001, 0x080000, CRC(e30e32fa) SHA1(2ba28026492210724c93e3319c578658f056e68d) )
	ROM_LOAD16_BYTE( "95426191.hi", 0x00000, 0x080000, CRC(6c2e6c1b) SHA1(1fb0463ca155c8facc765d66e0119d72e085331c) )
	ROM_LOAD16_BYTE( "95426242.lo", 0x00001, 0x080000, CRC(8e98e510) SHA1(2f122ff8b329542376153c43d1cabc2d5a221edf) )
	ROM_LOAD16_BYTE( "95426243.hi", 0x00000, 0x080000, CRC(652dd45c) SHA1(3618fe3f2dc28d05b24a40ee75409a114833f07b) )
	ROM_LOAD16_BYTE( "95426478.lo", 0x00001, 0x080000, CRC(33f36f2b) SHA1(5975137c3a1a67f4fe104154c64bdec507bcd1fa) )
	ROM_LOAD16_BYTE( "95426479.hi", 0x00000, 0x080000, CRC(f4198f7b) SHA1(29b4c4bd2f7af9373b310dfdab9c96a6e631437d) )
	ROM_LOAD16_BYTE( "95426480.lo", 0x00001, 0x080000, CRC(f9b6864d) SHA1(cc9e91391e7aea6c11e7d5a544030ccc7fbbafbe) )
	ROM_LOAD16_BYTE( "95426481.hi", 0x00000, 0x080000, CRC(2f8f519a) SHA1(d8b3c255e1dc490ae7edd0add77b3d752591c39b) )
	ROM_LOAD16_BYTE( "95427022.lo", 0x00001, 0x080000, CRC(46ce1b66) SHA1(4d9fae2e73ed120617b073238ba605a27cfd39e4) )
	ROM_LOAD16_BYTE( "95427023.hi", 0x00000, 0x080000, CRC(75360937) SHA1(b2ac6731d37ab17a1762502c553edbe74c95c145) )
	ROM_LOAD16_BYTE( "95427024.lo", 0x00001, 0x080000, CRC(01da3740) SHA1(b765683f2944351217a61c2aacfb09f959e5ad00) )
	ROM_LOAD16_BYTE( "95427025.hi", 0x00000, 0x080000, CRC(8956a0e0) SHA1(c8d070fce0336f63df05d18dd860337cba9dda1a) )
	ROM_LOAD16_BYTE( "95427190.lo", 0x00001, 0x080000, CRC(6d9bb3cf) SHA1(22829b63c4b714f26418691cff4c4c38f3767a08) )
	ROM_LOAD16_BYTE( "95427191.hi", 0x00000, 0x080000, CRC(a5a34e52) SHA1(3b0b17177b41256d7c52dc6dc4ce58323f854f12) )
	ROM_LOAD16_BYTE( "95427242.lo", 0x00001, 0x080000, CRC(11826e47) SHA1(712dffaafc5c1c9dbae430187dd53ed711fe016c) )
	ROM_LOAD16_BYTE( "95427243.hi", 0x00000, 0x080000, CRC(2e6e312e) SHA1(2abd8fafe1bb21bcaddc39f70c23eb9d457ab311) )
	ROM_LOAD16_BYTE( "95427478.lo", 0x00001, 0x080000, CRC(099c6270) SHA1(763e0669282854ae4ba22772d1a3d823c9ff4325) )
	ROM_LOAD16_BYTE( "95427479.hi", 0x00000, 0x080000, CRC(23e447f0) SHA1(a7a84761c30492c04354af10f6b539d18e16dc4c) )
	ROM_LOAD16_BYTE( "95427480.lo", 0x00001, 0x080000, CRC(ce66e59b) SHA1(2ec6cf2f9cdda4cc3c259506d3f7fb089eef6afa) )
	ROM_LOAD16_BYTE( "95427481.hi", 0x00000, 0x080000, CRC(a9ec2b1f) SHA1(14e815cc451316aa6ff3456e0c1d881236dbe6af) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008820.bin", 0x0000, 0x100000, CRC(31c0d215) SHA1(7d0172de75e54a7c00b7c28e21d738e64597f4f5) )
	ROM_LOAD( "95008821.bin", 0x0000, 0x100000, CRC(9c934f26) SHA1(2598870f724a2b070c5f791a2d30e582f87c06da) )
ROM_END


ROM_START( sc_r66 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406780.lo", 0x00001, 0x080000, CRC(8b4efa73) SHA1(48d613a19a3b7486c1975c48c4a89af85d69bf23) )
	ROM_LOAD16_BYTE( "95406781.hi", 0x00000, 0x080000, CRC(2745101d) SHA1(3ea55d20c17285f18bdfa68032df359fbf14b94d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_rovrt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416804.lo", 0x00001, 0x080000, CRC(4753f2ea) SHA1(6c0e7a890d89fe98cf1ad19bb1d6658be92c0233) )
	ROM_LOAD16_BYTE( "95416805.hi", 0x00000, 0x080000, CRC(db3bf6ce) SHA1(ad10d7d0df5d63cecf41d111545fc64313d9db88) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416946.lo", 0x00001, 0x080000, CRC(9a265667) SHA1(9c9b657f6001e9d17887266daf308b01a40ce59f) )
	ROM_LOAD16_BYTE( "95416947.hi", 0x00000, 0x080000, CRC(862c85c0) SHA1(b38478b4ac96a28cf2c3c2dbc7f8707616c1c8ec) )
	ROM_LOAD16_BYTE( "95417804.lo", 0x00001, 0x080000, CRC(40098300) SHA1(de7d3966c46ba58d49efcea568ba8d52fc53a1bc) )
	ROM_LOAD16_BYTE( "95417805.hi", 0x00000, 0x080000, CRC(c39f21d0) SHA1(585ac468849a788b47e3dbf9f41dbc618e67405a) )
	ROM_LOAD16_BYTE( "95417946.lo", 0x00001, 0x080000, CRC(21a84f30) SHA1(72be0e23eed1e01bdde6a54d5b4acbd108e25d8b) )
	ROM_LOAD16_BYTE( "95417947.hi", 0x00000, 0x080000, CRC(c8ad3f9f) SHA1(d05be750ad2c0d8c6c354deae5778e201131a9ec) )
	ROM_LOAD16_BYTE( "95420208.lo", 0x00001, 0x080000, CRC(69c11c3d) SHA1(5269060fa78a929e379fa46d993d630534307cdc) )
	ROM_LOAD16_BYTE( "95420209.hi", 0x00000, 0x080000, CRC(614b3dd1) SHA1(a04fb9c173afd2d54948dbbd1ab7979cceeb1c31) )
	ROM_LOAD16_BYTE( "95420210.lo", 0x00001, 0x080000, CRC(24abcd30) SHA1(56b260b9ba3898342e369430bc28051b1bbbd24e) )
	ROM_LOAD16_BYTE( "95420211.hi", 0x00000, 0x080000, CRC(da42162b) SHA1(a535c58c5fa537ea10b42d351cbbe41b2d60d104) )
	ROM_LOAD16_BYTE( "95420212.lo", 0x00001, 0x080000, CRC(649be5c0) SHA1(8952ac77959cad7f1a8a6983a5b16a7b7ad529c1) )
	ROM_LOAD16_BYTE( "95420213.hi", 0x00000, 0x080000, CRC(d40394d7) SHA1(a4f8d1cb5c3aa0e03fbb72e0a07da79083b54703) )
	ROM_LOAD16_BYTE( "95421208.lo", 0x00001, 0x080000, CRC(f982c649) SHA1(45c6e7460fe5ae11e972ff117b1af6ddc8acb3cc) )
	ROM_LOAD16_BYTE( "95421209.hi", 0x00000, 0x080000, CRC(1b4df6b3) SHA1(ab1e94315f3841f4abc3f2729152d85dc42bfc9a) )
	ROM_LOAD16_BYTE( "95421210.lo", 0x00001, 0x080000, CRC(63bbf772) SHA1(08e142a90e28711803cb2d90962550f73b7dcb69) )
	ROM_LOAD16_BYTE( "95421211.hi", 0x00000, 0x080000, CRC(e935824a) SHA1(94cc55ac52e347debe7ff6d97323a67dd58f13dd) )
	ROM_LOAD16_BYTE( "95421212.lo", 0x00001, 0x080000, CRC(b807c4a8) SHA1(a9f9b4d27e455ea0bbf62984ff2c24200b07505c) )
	ROM_LOAD16_BYTE( "95421213.hi", 0x00000, 0x080000, CRC(9f657ccd) SHA1(bdf9300dbc74ecc0ba677865606bdc763cbe0f44) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008961.bin", 0x0000, 0x0feba0, CRC(174f22f8) SHA1(e96c7019a48f1499c4b766e1fb700b2d4db59d5e) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890431.bin", 0x0000, 0x5000, CRC(a3d4624e) SHA1(4d66727af8cd1f10708635655777d80fe99e02af) )
	ROM_LOAD( "95890432.bin", 0x0000, 0x5000, CRC(d642267a) SHA1(9f2d0cd87e6acfebd855a7669c862dc20f1a52e3) )
	ROM_LOAD( "95890433.bin", 0x0000, 0x5000, CRC(48f8ea26) SHA1(156a83c1980483b12577fdb680d85a3f0f7bfdbd) )
ROM_END


ROM_START( sc_rbank )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406094.lo", 0x00001, 0x080000, CRC(de8b2571) SHA1(ad057935168af2021769743547d07100743c9da8) )
	ROM_LOAD16_BYTE( "95406095.hi", 0x00000, 0x080000, CRC(716fb2cc) SHA1(a7bf94c099bf973a1b70f6d51bf48ebc6ff03d19) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407094.lo", 0x00001, 0x080000, CRC(04b1d972) SHA1(22525822e359ad55c2954c15c7a69d41760a0db5) )
	ROM_LOAD16_BYTE( "95407095.hi", 0x00000, 0x080000, CRC(d4cd5d6b) SHA1(d05b165d0c4703ebb2941f0a91acafd7c2a65024) )
	// from Royal Banker (unk) set
	ROM_LOAD16_BYTE( "p1111p11.hi", 0x00000, 0x080000, CRC(7c0ed03c) SHA1(c2bbcb840f554710217a6632889966d546d1c067) )
	ROM_LOAD16_BYTE( "p1111p11.lo", 0x00001, 0x080000, CRC(a7c8a2be) SHA1(e44e46efbb1db9bfadef0b4ce9aebd0c5d293fce) )
	ROM_LOAD16_BYTE( "p1111s11.hi", 0x00000, 0x080000, CRC(03ea6d4f) SHA1(1f5eec50a2f630de42224dc1b3d3dc22d8ab3ed6) )
	ROM_LOAD16_BYTE( "p1111s11.lo", 0x00001, 0x080000, CRC(1c0609da) SHA1(cf929fe9497d4f27130ea0ad4d0167b9e47b564d) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008233.bin", 0x0000, 0x100000, CRC(ebdb6017) SHA1(ca723483f6a7ae6512fa4abc4437c1f8eb606784) )
	ROM_LOAD( "95008234.bin", 0x0000, 0x100000, CRC(4b7ac02a) SHA1(29c51906e5ca1e0c9c70db86e3a24f08be06b7e0) )
ROM_END


ROM_START( sc_royle )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404464.lo", 0x00001, 0x080000, CRC(841e5431) SHA1(831780c92dd3287bb603d112e4a1a73e74495488) )
	ROM_LOAD16_BYTE( "95404465.hi", 0x00000, 0x080000, CRC(0ef18715) SHA1(0a589081d8b9ef809c028be5507cae68e159a998) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404466.lo", 0x00001, 0x080000, CRC(a8e2d7bb) SHA1(2213e76e33605300a3bf937d6a789bfe8f1f8597) )
	ROM_LOAD16_BYTE( "95404467.hi", 0x00000, 0x080000, CRC(71c6af83) SHA1(eecf28a757ff026c3e15ed9d1bdc08c6110e701e) )
	ROM_LOAD16_BYTE( "95405464.lo", 0x00001, 0x080000, CRC(da825d15) SHA1(6dde7438d20ddcbd924e57890537fc170222dc70) )
	ROM_LOAD16_BYTE( "95405465.hi", 0x00000, 0x080000, CRC(3b22b5a1) SHA1(f8e15ea4e918720432f164a7c1be5a9cd0cc6813) )
	ROM_LOAD16_BYTE( "95405466.lo", 0x00001, 0x080000, CRC(78461edd) SHA1(a662f0eb8f8a51dd2e6ac0fe1b0e4297f92f60b6) )
	ROM_LOAD16_BYTE( "95405467.hi", 0x00000, 0x080000, CRC(bdcc34a5) SHA1(e1b7d718c6b69c0c92b44c922f82d77b6d4930a1) )
	ROM_LOAD16_BYTE( "95406098.lo", 0x00001, 0x080000, CRC(2460a66b) SHA1(ecc1ae23754e6803605c6b00a0724fe746ba193e) )
	ROM_LOAD16_BYTE( "95406099.hi", 0x00000, 0x080000, CRC(336665ae) SHA1(5cafd7af10411e4062d8bcbd628491e6f4fcbccf) )
	ROM_LOAD16_BYTE( "95406672.lo", 0x00001, 0x080000, CRC(aee4a8fe) SHA1(2b5e4d3ba93fbb81d25ec0fe1193d4720fc0b7f8) )
	ROM_LOAD16_BYTE( "95406673.hi", 0x00000, 0x080000, CRC(1a18dfa1) SHA1(34b584f0cdc3853cda3809652187f195eaa7818d) )
	ROM_LOAD16_BYTE( "95406906.lo", 0x00001, 0x080000, CRC(ebff3078) SHA1(f4ad541b35b21ebb0df358736d4e46b48edfbb96) )
	ROM_LOAD16_BYTE( "95406907.hi", 0x00000, 0x080000, CRC(0f077253) SHA1(59713b2bb50774d436b4362ba78786cdea2d3cc4) )
	ROM_LOAD16_BYTE( "95406908.lo", 0x00001, 0x080000, CRC(2795a21d) SHA1(b7c9f66cc1e4c960362f762a16c882404b9fb5d4) )
	ROM_LOAD16_BYTE( "95406909.hi", 0x00000, 0x080000, CRC(55fa0ec5) SHA1(12161b38f8b118fbbc734bdcf50b99c8d95f5b63) )
	ROM_LOAD16_BYTE( "95407098.lo", 0x00001, 0x080000, CRC(f32c77b5) SHA1(ae34fdd58dbc2996d2756a340dd01048e830f742) )
	ROM_LOAD16_BYTE( "95407099.hi", 0x00000, 0x080000, CRC(68ac92b6) SHA1(16773d09a825597324d3b367fa2de8c10ff97459) )
	ROM_LOAD16_BYTE( "95407672.lo", 0x00001, 0x080000, CRC(e559f474) SHA1(9c141e23b8ecd7053bcca3adcee9a8ccfd6b72a3) )
	ROM_LOAD16_BYTE( "95407673.hi", 0x00000, 0x080000, CRC(b430d148) SHA1(93734e6ccf4de2d43d45cb83a2bcc04f5b9de3aa) )
	ROM_LOAD16_BYTE( "95407906.lo", 0x00001, 0x080000, CRC(a5098e31) SHA1(568890e85a26ff1c866d1a8b736c8cfa004560fc) )
	ROM_LOAD16_BYTE( "95407907.hi", 0x00000, 0x080000, CRC(ae2d1838) SHA1(f6ad0c37fdc848a35e4faf990867aa1ea77360a0) )
	ROM_LOAD16_BYTE( "95407908.lo", 0x00001, 0x080000, CRC(dbe1fea7) SHA1(190209b1682037c3f8d552f1ed644af2653aa8aa) )
	ROM_LOAD16_BYTE( "95407909.hi", 0x00000, 0x080000, CRC(18d106e9) SHA1(74c78448c36b640095361dd69012c60f61386278) )
	ROM_LOAD16_BYTE( "95410204.lo", 0x00001, 0x080000, CRC(355a16d7) SHA1(febf66802f24cc792c6cf19f27df6a3151aec814) )
	ROM_LOAD16_BYTE( "95410205.hi", 0x00000, 0x080000, CRC(f826a3f2) SHA1(4f6b985455ccf327c559f248b7c7d5357b45f626) )
	ROM_LOAD16_BYTE( "95411204.lo", 0x00001, 0x080000, CRC(e7b11b3f) SHA1(cd728702b8fcf13fc5ba236322f69a28fd52e1bb) )
	ROM_LOAD16_BYTE( "95411205.hi", 0x00000, 0x080000, CRC(8e6ebfd0) SHA1(4670068164dc530699578affc18837472c4540a7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008207.bin", 0x0000, 0x100000, CRC(269f845f) SHA1(eaddeaebdafd3f237b6af5c3539da407a6782210) )
	ROM_LOAD( "95008208.bin", 0x0000, 0x100000, CRC(07d4d9fa) SHA1(841fead29de19da0436f937614de50e1f07ebc8b) )
ROM_END




ROM_START( sc_srrm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404006.lo", 0x00001, 0x080000, CRC(ffe9dc77) SHA1(ccc632499675f65767a7a3ef275fd723fc09bc27) )
	ROM_LOAD16_BYTE( "95404007.hi", 0x00000, 0x080000, CRC(8fb7c4d0) SHA1(257f187ba4c20ea066392c7b337c7c3331c58175) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406222.lo", 0x00001, 0x080000, CRC(80598518) SHA1(cf84165bb6589ac85925bcfc1981ff873e5a5d5d) )
	ROM_LOAD16_BYTE( "95406223.hi", 0x00000, 0x080000, CRC(1fd3a457) SHA1(c316ed2dae0e36f5c3f982405ef9ad2963cb763e) )
	ROM_LOAD16_BYTE( "95407222.lo", 0x00001, 0x080000, CRC(6f7dc46d) SHA1(aeeab3c5ae5b1ae31851023b2ed904f32b969d49) )
	ROM_LOAD16_BYTE( "95407223.hi", 0x00000, 0x080000, CRC(bb06299c) SHA1(9ff3a72c6e4e0781d2334e035b1678f7b2286e52) )
	ROM_LOAD16_BYTE( "95410266.lo", 0x00001, 0x080000, CRC(578253f1) SHA1(dabb77e75e063e34b1171f21f67889156c887ea9) )
	ROM_LOAD16_BYTE( "95410267.hi", 0x00000, 0x080000, CRC(e7221566) SHA1(fbedd365d68dd635319a9d450b8e37884d966cae) )
	ROM_LOAD16_BYTE( "95410708.lo", 0x00001, 0x080000, CRC(527242f4) SHA1(664bdca3e0eb8b07096e2189e9217eb895aa745b) )
	ROM_LOAD16_BYTE( "95410709.hi", 0x00000, 0x080000, CRC(4f4d535b) SHA1(f0eae6ad80863dfd579a26e4944baede7ee09cff) )
	ROM_LOAD16_BYTE( "95411266.lo", 0x00001, 0x080000, CRC(73a583d8) SHA1(b8f62440486342497bee7284325ce08e7758fd74) )
	ROM_LOAD16_BYTE( "95411267.hi", 0x00000, 0x080000, CRC(76bbfc21) SHA1(5d00d407a586f7a0643d053f9f0f8cb1dc61ef49) )
	ROM_LOAD16_BYTE( "95411706.lo", 0x00001, 0x080000, CRC(4be8b65d) SHA1(791a932b4f171adeac60bc74d02a7216b293fc26) )
	ROM_LOAD16_BYTE( "95411707.hi", 0x00000, 0x080000, CRC(047312b3) SHA1(493d5aa69e6ddaba4e9896d1dc56b6a9c09411fb) )
	ROM_LOAD16_BYTE( "95411708.lo", 0x00001, 0x080000, CRC(7226ed52) SHA1(9e227395ac7ae717f8b089aa95b9cdeb060b5c0f) )
	ROM_LOAD16_BYTE( "95411709.hi", 0x00000, 0x080000, CRC(e6a3b921) SHA1(403c47404979effaac311c89c6f3b398c6e8af48) )
	ROM_LOAD16_BYTE( "95414878.lo", 0x00001, 0x080000, CRC(9d7b2bbb) SHA1(a8ae0a0610f951fbf449427ef5ee4e579962cf43) )
	ROM_LOAD16_BYTE( "95414879.hi", 0x00000, 0x080000, CRC(efd3ee89) SHA1(34962978b8905009960d011b28fc963fc4acde0f) )
	ROM_LOAD16_BYTE( "95414884.lo", 0x00001, 0x080000, CRC(48d909cd) SHA1(97a56db61e5402da37a379f2063f0e091c665de0) )
	ROM_LOAD16_BYTE( "95414885.hi", 0x00000, 0x080000, CRC(e087b180) SHA1(e847eab2e30219552960317dc4a9ae276f743214) )
	ROM_LOAD16_BYTE( "95415878.lo", 0x00001, 0x080000, CRC(e126007d) SHA1(2b37fabde61d4fb13ea8218a0ae48ec73d9f505d) )
	ROM_LOAD16_BYTE( "95415879.hi", 0x00000, 0x080000, CRC(c121443c) SHA1(1b1b3d5ee3b9443b0162176d6fd27fd4009edde1) )
	ROM_LOAD16_BYTE( "95415880.lo", 0x00001, 0x080000, CRC(b64b442a) SHA1(8aea42f76493479acaebabc82c16efc1d5ceedd1) )
	ROM_LOAD16_BYTE( "95415881.hi", 0x00000, 0x080000, CRC(88d6be22) SHA1(94f0a069850bf77e907f13945cfb24d602fca24d) )
	ROM_LOAD16_BYTE( "95415882.lo", 0x00001, 0x080000, CRC(e2afb025) SHA1(4897da226711686e0d5cfc90166a6a1bafdcd383) )
	ROM_LOAD16_BYTE( "95415883.hi", 0x00000, 0x080000, CRC(f0630dd0) SHA1(d54ecac93b508dd7717600c27ed0a762abd5d6d1) )
	ROM_LOAD16_BYTE( "95415884.lo", 0x00001, 0x080000, CRC(ee121385) SHA1(486f13da7d94edb82f91ff52127433b3ce36e736) )
	ROM_LOAD16_BYTE( "95415885.hi", 0x00000, 0x080000, CRC(52be6ed0) SHA1(4e7803710a4692ba6b21ea87bce31eb485135433) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008155.bin", 0x0000, 0x100000, CRC(2c12d323) SHA1(78199130f15b90f2c8f932f40d7e1e0e0646ce57) )
	ROM_LOAD( "95008156.bin", 0x0000, 0x100000, CRC(775dd1cd) SHA1(2b0ffa326ae53b60dbda6eb1f066b2ea29e6dd26) )
ROM_END


ROM_START( sc_srrca )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404146.lo", 0x00001, 0x080000, CRC(f8eadd61) SHA1(13307ed8e90fe23eff44580bbae97587f80e450d) )
	ROM_LOAD16_BYTE( "95404147.hi", 0x00000, 0x080000, CRC(b28cd756) SHA1(880ab382b60073f2d3087850bfc3d1d2e8cc206e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404148.lo", 0x00001, 0x080000, CRC(5f7ca43a) SHA1(0c26522aba68b0f8de038733cc28a95a6ad70145) )
	ROM_LOAD16_BYTE( "95404149.hi", 0x00000, 0x080000, CRC(d8087251) SHA1(5229d73dc7f4bf32741f514c1cbcfb9111c095f5) )
	ROM_LOAD16_BYTE( "95404152.lo", 0x00001, 0x080000, CRC(e66ed420) SHA1(02b75c17db48cb573fbf9aa969ddde1b1298b27a) )
	ROM_LOAD16_BYTE( "95404153.hi", 0x00000, 0x080000, CRC(5070e8d7) SHA1(9894b146409bcb0249f21a6b95eba4b2f44e6519) )
	ROM_LOAD16_BYTE( "95405146.lo", 0x00001, 0x080000, CRC(56c01000) SHA1(08445f6200c015d0bff8c873e664d058b3d550fc) )
	ROM_LOAD16_BYTE( "95405147.hi", 0x00000, 0x080000, CRC(777d1d14) SHA1(5e51ae0d98c2d3c298bf972f80f0e91e04df1f52) )
	ROM_LOAD16_BYTE( "95405150.lo", 0x00001, 0x080000, CRC(1c46c5e7) SHA1(6a1b06fa5f8ce23cedbf1484c38eee00a73dfab2) )
	ROM_LOAD16_BYTE( "95405151.hi", 0x00000, 0x080000, CRC(9629a2e1) SHA1(029c6c57dad1f4c81b97c10cb1d9f06cd5af1bb3) )
	ROM_LOAD16_BYTE( "95405152.lo", 0x00001, 0x080000, CRC(18b4fd76) SHA1(228b68a4ebb5d6809911fa7fa29573293e253db8) )
	ROM_LOAD16_BYTE( "95405153.hi", 0x00000, 0x080000, CRC(6741d4bb) SHA1(fe98ef93a3b99dc5b5d7adb1afb8ac607bb0b6f4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_smtm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416774.lo", 0x00001, 0x080000, CRC(69c428c1) SHA1(820ee15cd362c59b045b7c8367d090bb0cba8b52) )
	ROM_LOAD16_BYTE( "95416775.hi", 0x00000, 0x080000, CRC(fe319548) SHA1(d5c4ea5a0e5eb11bebcba5df00932b38d562a83d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416744.lo", 0x00001, 0x080000, CRC(4582bb6a) SHA1(70189c6602dc258baa8c7273820b1b5e9696ab3e) ) // from something else?
	ROM_LOAD16_BYTE( "95417774.lo", 0x00001, 0x080000, CRC(c7c3a41f) SHA1(0af495f5d387b53c3d8640ecccaeac3152b26ee5) )
	ROM_LOAD16_BYTE( "95417775.hi", 0x00000, 0x080000, CRC(776b8acb) SHA1(cf9f92a548caf101815094e32e5b1f2e3e6e85cb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95416744.bin", 0x0000, 0x100000, CRC(3aa90fed) SHA1(d399f67bbe1d6f58d4c0a9e322156055cf3dccdc) )
ROM_END


ROM_START( sc_showt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422250.lo", 0x00001, 0x080000, CRC(f5ccf736) SHA1(515020f2caeaa17da5c24cec7dd7591cd1bd1c9f) )
	ROM_LOAD16_BYTE( "95422251.hi", 0x00000, 0x080000, CRC(353cc294) SHA1(182dd862b0827ac843531ac471b28a1e0dba8452) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422252.lo", 0x00001, 0x080000, CRC(2ec78ee9) SHA1(998d4e2caef456351465c3aee7512a4a4df2a764) )
	ROM_LOAD16_BYTE( "95422253.hi", 0x00000, 0x080000, CRC(a2a4a262) SHA1(b6ef2f708c7c7a8a7d54553187770a6b70268726) )
	ROM_LOAD16_BYTE( "95422264.lo", 0x00001, 0x080000, CRC(60f0aaa4) SHA1(5959317094e03e520d2fa09912bba317f09bb18d) )
	ROM_LOAD16_BYTE( "95422265.hi", 0x00000, 0x080000, CRC(250e5f22) SHA1(21c57910c4e998287dcd7de2c09e6f2393e34561) )
	ROM_LOAD16_BYTE( "95422266.lo", 0x00001, 0x080000, CRC(cd90c3a6) SHA1(7e87d8972bddaeecd370ea90cfe401b31e45cf3a) )
	ROM_LOAD16_BYTE( "95422267.hi", 0x00000, 0x080000, CRC(94408414) SHA1(a6e093020f8eef4390fe9de8314bf7ef7e4a3fdd) )
	ROM_LOAD16_BYTE( "95422282.lo", 0x00001, 0x080000, CRC(8dd2c938) SHA1(c4f51b27e51dc0a37ccf65731029497d9078b093) )
	ROM_LOAD16_BYTE( "95422283.hi", 0x00000, 0x080000, CRC(c4562c9b) SHA1(39355f1a9ffcfcc9da8fb650cc2bcdca298a4013) )
	ROM_LOAD16_BYTE( "95422508.lo", 0x00001, 0x080000, CRC(2331b6d8) SHA1(925f62a8b899210dd5b9fad84978757c581423b7) )
	ROM_LOAD16_BYTE( "95422509.hi", 0x00000, 0x080000, CRC(8b039dca) SHA1(3c881ad34e1406749cd80d71754febe618c13fea) )
	ROM_LOAD16_BYTE( "95422760.lo", 0x00001, 0x080000, CRC(1375e194) SHA1(05292e05c469890eebdfa125a293a7a27b41d77d) )
	ROM_LOAD16_BYTE( "95422761.hi", 0x00000, 0x080000, CRC(e0aec359) SHA1(75a241a6e170f691eea7552bbb8dc97e40b723d3) )
	ROM_LOAD16_BYTE( "95423250.lo", 0x00001, 0x080000, CRC(3245a8a6) SHA1(9341ff47bb9a2d22f49c114234daec283ad7e879) )
	ROM_LOAD16_BYTE( "95423251.hi", 0x00000, 0x080000, CRC(40a0ec3a) SHA1(3e32e96f0484cb15ec24e659218c815732905277) )
	ROM_LOAD16_BYTE( "95423252.lo", 0x00001, 0x080000, CRC(6d9b8534) SHA1(7024eb9a8b45e1bf5c5916c5d772b13e70aac234) )
	ROM_LOAD16_BYTE( "95423253.hi", 0x00000, 0x080000, CRC(b89a0320) SHA1(879240f499bb16df3edc9e714bb4125e330ce863) )
	ROM_LOAD16_BYTE( "95423264.lo", 0x00001, 0x080000, CRC(72a1d258) SHA1(4e2989f1a5826907200ed2b90c96d68bf4b2f272) )
	ROM_LOAD16_BYTE( "95423265.hi", 0x00000, 0x080000, CRC(f45d4470) SHA1(d5598c079bc69bab8e205a0713b7f04b7f2a1645) )
	ROM_LOAD16_BYTE( "95423266.lo", 0x00001, 0x080000, CRC(d57d3dc9) SHA1(388ef7d70e39b1cf7c490b5728a41d56c13e89bb) )
	ROM_LOAD16_BYTE( "95423267.hi", 0x00000, 0x080000, CRC(1a0dc2a4) SHA1(93b17f39436078245df3e3ada3525b397372717d) )
	ROM_LOAD16_BYTE( "95423282.lo", 0x00001, 0x080000, CRC(0f797a89) SHA1(d877282a0fc6a8e8324df461c16c50da9c58f586) )
	ROM_LOAD16_BYTE( "95423283.hi", 0x00000, 0x080000, CRC(7a6f6a99) SHA1(1863e215a03c0e97c6aea97d8cc23d219bffb1cd) )
	ROM_LOAD16_BYTE( "95423508.lo", 0x00001, 0x080000, CRC(f6c86a6d) SHA1(feb7bc7d0014a4030ed0582412f31f9fa0ca2452) )
	ROM_LOAD16_BYTE( "95423509.hi", 0x00000, 0x080000, CRC(d305bd12) SHA1(9cab958cbd54b16344356768c2b910e972740290) )
	ROM_LOAD16_BYTE( "95423760.lo", 0x00001, 0x080000, CRC(27e3af32) SHA1(d441367f254304c1b7e2f4a40384f222080fbdfb) )
	ROM_LOAD16_BYTE( "95423761.hi", 0x00000, 0x080000, CRC(e522bc87) SHA1(1c8e8ad395696e9dad4e1b7bbd7ff4fff772771b) )
	ROM_LOAD16_BYTE( "95426100.lo", 0x00001, 0x080000, CRC(134e8595) SHA1(1179b81c96eefb8bf45d87b436d6dea66532ac99) )
	ROM_LOAD16_BYTE( "95426101.hi", 0x00000, 0x080000, CRC(1f86c133) SHA1(d3c43165f3c9204b7add58203d8d59c621d5b30b) )
	ROM_LOAD16_BYTE( "95426280.lo", 0x00001, 0x080000, CRC(df58a77a) SHA1(4873fb57d1f7305638655e662290382ec8f71d83) )
	ROM_LOAD16_BYTE( "95426281.hi", 0x00000, 0x080000, CRC(fc06f41f) SHA1(23543ed0bd3f3d19254b13b025f3bb7d72069074) )
	ROM_LOAD16_BYTE( "95426324.lo", 0x00001, 0x080000, CRC(0667479b) SHA1(082b16a0fadc9d61a088df06512950730d9832f7) )
	ROM_LOAD16_BYTE( "95426325.hi", 0x00000, 0x080000, CRC(ea6c453d) SHA1(41895b44bb8df868bd114ab08be91934fb11e8f1) )
	ROM_LOAD16_BYTE( "95427100.lo", 0x00001, 0x080000, CRC(aee5e883) SHA1(a6e0fb073bf067ab285f5576142e00ad68810244) )
	ROM_LOAD16_BYTE( "95427101.hi", 0x00000, 0x080000, CRC(a9fe4ca9) SHA1(cf94044216ef6db34409263854a7fef8952e06bc) )
	ROM_LOAD16_BYTE( "95427280.lo", 0x00001, 0x080000, CRC(9f6eb87a) SHA1(8ec853dcfc2ab70aa9b354a7d53830fb98372b72) )
	ROM_LOAD16_BYTE( "95427281.hi", 0x00000, 0x080000, CRC(dffa8c35) SHA1(d73cb184593d1f2c1d60c9e71c130317f5302624) )
	ROM_LOAD16_BYTE( "95427324.lo", 0x00001, 0x080000, CRC(43084b24) SHA1(22e0bde5857510f614e8290f08897507f807046f) )
	ROM_LOAD16_BYTE( "95427325.hi", 0x00000, 0x080000, CRC(f734a6a5) SHA1(1fb3613a0b0a2552e304db587838396a2e4001c4) )
	ROM_LOAD16_BYTE( "p3013p72.hi", 0x00000, 0x080000, CRC(4a2bb3f4) SHA1(c83e20f1481fd6be86f9b8bc3bbc075b984602d0) )
	ROM_LOAD16_BYTE( "p3013p72.lo", 0x00001, 0x080000, CRC(0c356331) SHA1(b1539d2f191ea00265674b13ca8098f91462f545) )
	ROM_LOAD16_BYTE( "p3013p73.hi", 0x00000, 0x080000, CRC(33584a9f) SHA1(9c4fb053feb1be7e80466d83e04190a045ba0739) )
	ROM_LOAD16_BYTE( "p3013p73.lo", 0x00001, 0x080000, CRC(04a0ef49) SHA1(9d08c72b4c243892ea21e82bf6daf21f218c1b60) )
	ROM_LOAD16_BYTE( "p3013s72.hi", 0x00000, 0x080000, CRC(a7fa33b6) SHA1(fdbbb4ad615570a80b8e96a2cda64655ae079e39) )
	ROM_LOAD16_BYTE( "p3013s72.lo", 0x00001, 0x080000, CRC(44921322) SHA1(ffd0d5ff9a0d013f43c031e60b7db9208d98d5bc) )
	ROM_LOAD16_BYTE( "p3013s73.hi", 0x00000, 0x080000, CRC(a7e54de1) SHA1(72ac11cbc9c75da11a3064e1b48533db60d3ba8f) )
	ROM_LOAD16_BYTE( "p3013s73.lo", 0x00001, 0x080000, CRC(9a696a93) SHA1(c051803e47d73ab33abb539e58e83630940e1d77) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008656.bin", 0x0000, 0x100000, CRC(632a4cbb) SHA1(455e6242f5c5c1a0d84aadfdda33873e8e7b2418) )
	ROM_LOAD( "95008657.bin", 0x0000, 0x100000, CRC(aa68db50) SHA1(52ee314549fac989dd9ee494144ee3bbb99ee283) )
	ROM_LOAD( "95008734.bin", 0x0000, 0x100000, CRC(8b469657) SHA1(514b3f4cbbafb3cee618b9ce0bae572f1a4fcf7b) )
	ROM_LOAD( "95008735.bin", 0x0000, 0x100000, CRC(fa614cc1) SHA1(e5ecce4936a8db267b08b938ab5bc7500cf98f99) )
	ROM_LOAD( "95008777.bin", 0x0000, 0x100000, CRC(1ff19229) SHA1(6db08982ee923ef4568caf76e05088574f99fc36) )
	ROM_LOAD( "95008778.bin", 0x0000, 0x100000, CRC(2f2f3ee1) SHA1(cade826fec6c07a1fffa548c96404da83db14dd7) )
ROM_END


ROM_START( sc_sidsp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414360.lo", 0x00001, 0x080000, CRC(400906d3) SHA1(a6c262ae56b9c72468f78994c26fd3890b2d063d) )
	ROM_LOAD16_BYTE( "95414361.hi", 0x00000, 0x080000, CRC(2c6dd3e0) SHA1(ffb7954321a14cc60ae47804c8769b375044dc9a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414362.lo", 0x00001, 0x080000, CRC(872a1583) SHA1(163f2a2ba9b9217a4443ac7ce55140beec32892b) )
	ROM_LOAD16_BYTE( "95414363.hi", 0x00000, 0x080000, CRC(75114c56) SHA1(2b15418b617b162654a984fbe577177f7cdacbd4) )
	ROM_LOAD16_BYTE( "95415360.lo", 0x00001, 0x080000, CRC(309770ea) SHA1(39563d896cc2b38ee5cd854dab612bb3f46f0621) )
	ROM_LOAD16_BYTE( "95415361.hi", 0x00000, 0x080000, CRC(6e76f446) SHA1(cdb311bdf882297f0ab28580bb196804ae437b76) )
	ROM_LOAD16_BYTE( "95415362.lo", 0x00001, 0x080000, CRC(d7332409) SHA1(3f193cfdf9f3e34748338bb22caade1a7224f8d9) )
	ROM_LOAD16_BYTE( "95415363.hi", 0x00000, 0x080000, CRC(1ad2cec6) SHA1(9c6926659022984548535e1c643f97e8c515707f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008369.bin", 0x0000, 0x100000, CRC(76ea0074) SHA1(6cc4f320d8e331477569dfc7e961afd30a4ce7b2) )
ROM_END


ROM_START( sc_s2k )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404262.lo", 0x00001, 0x080000, CRC(61f5fb08) SHA1(06ed3b9cc1c4f59e4a756199678979a8b54a956d) )
	ROM_LOAD16_BYTE( "95404263.hi", 0x00000, 0x080000, CRC(eb492e7e) SHA1(cfbcd2004b6ff020024f238387253a8235be0cdd) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_sirpz )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402472.lo", 0x00001, 0x080000, CRC(c6e6205e) SHA1(8e1cf99c6c5cf75f178c45454e6127a389324988) )
	ROM_LOAD16_BYTE( "95402473.hi", 0x00000, 0x080000, CRC(9b72e647) SHA1(dd8bce757ddca76d81ab0d47a68269432dd5ea64) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406412.lo", 0x00001, 0x080000, CRC(bce7413e) SHA1(8e858e08cfe74960de908d052af872ca7f47ba6c) )
	ROM_LOAD16_BYTE( "95406413.hi", 0x00000, 0x080000, CRC(6ae91540) SHA1(2c0d48ed5415cc03fa8b75964f65d5b9a2f63f72) )
	ROM_LOAD16_BYTE( "95407412.lo", 0x00001, 0x080000, CRC(c5d4005e) SHA1(96a9bbd3ea6f7ce30412bc2eb4db802ceac465e2) )
	ROM_LOAD16_BYTE( "95407413.hi", 0x00000, 0x080000, CRC(942c28af) SHA1(d52d248e4827ab191def4fb75feec96356455f5c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "sound_1", 0x0000, 0x080000, CRC(e5e1b0d5) SHA1(bfdc90e09534b97d9a6b6804284c80800db1aff7) )
	ROM_LOAD( "sound_2", 0x0000, 0x080000, CRC(3f8c71ed) SHA1(3bab20e8f6af2cfb8c7bba04b29f5aec4c692c1b) )
ROM_END


ROM_START( sc_stl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400445.lo", 0x00001, 0x080000, CRC(b68e7c56) SHA1(cdeae27d53cbfb97d64905a77d59fe5fbd8becf1) )
	ROM_LOAD16_BYTE( "95400446.hi", 0x00000, 0x080000, CRC(33aa01e7) SHA1(dcdffcb29c151429e28206661196c73109fe125c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400455.lo", 0x00001, 0x080000, CRC(70f5318e) SHA1(46100f779da2248f2e2c9b6606a0443b7f635878) )
	ROM_LOAD16_BYTE( "95400456.hi", 0x00000, 0x080000, CRC(7186ec69) SHA1(a60018b482285eaba50d786de54733294cbb74ff) )
	ROM_LOAD16_BYTE( "95400727.lo", 0x00001, 0x080000, CRC(4de69e56) SHA1(12aec2759ea240c4bd40696c633af29b4d9d4102) )
	ROM_LOAD16_BYTE( "95400728.hi", 0x00000, 0x080000, CRC(30d7c59c) SHA1(970dedcb5b701d8b9e5ead869c890b7a85edd760) )
	ROM_LOAD16_BYTE( "95400729.lo", 0x00001, 0x080000, CRC(a75e26af) SHA1(af0e402f1827046dee34cbce5176be818751da51) )
	ROM_LOAD16_BYTE( "95400730.hi", 0x00000, 0x080000, CRC(c6b400c8) SHA1(f72cce91496068750adb574e70844c5fb41abf17) )
	ROM_LOAD16_BYTE( "95401445.lo", 0x00001, 0x080000, CRC(1aaa8b8c) SHA1(fde14888b76f7f24b66dfbfb1cb771825f15a4a7) )
	ROM_LOAD16_BYTE( "95401446.hi", 0x00000, 0x080000, CRC(05a591fb) SHA1(30857a7de58d83578e81e120488bf328c85b883d) )
	ROM_LOAD16_BYTE( "95401455.lo", 0x00001, 0x080000, CRC(05c4e4d0) SHA1(03d7c0721b90e533c00d50225d8554c7dd7c5708) )
	ROM_LOAD16_BYTE( "95401456.hi", 0x00000, 0x080000, CRC(99af831d) SHA1(7fb6eaa3c218050965822a2dec31b27858526fc9) )
	ROM_LOAD16_BYTE( "95401727.lo", 0x00001, 0x080000, CRC(c3041a35) SHA1(c552a626daf350c176e82276db94baca8e552844) )
	ROM_LOAD16_BYTE( "95401728.hi", 0x00000, 0x080000, CRC(53118ccd) SHA1(8ba68b954a78fbf1ccd9a6666c6ba9375a90cb6b) )
	ROM_LOAD16_BYTE( "95401729.lo", 0x00001, 0x080000, CRC(6d7eab9c) SHA1(6b06511271c634e98466f5d02d653af63154fed4) )
	ROM_LOAD16_BYTE( "95401730.hi", 0x00000, 0x080000, CRC(e98eab26) SHA1(b40796400c0f2283f405a997e4c23a5f9dc77be1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "sk_t_lim.sn1", 0x0000, 0x080000, CRC(1b88bf7d) SHA1(76a8453fd2f8375030f69a3a569b45daceb3e4f7) ) //Need testing
	ROM_LOAD( "sk_t_lim.sn2", 0x0000, 0x080000, CRC(b3ecf658) SHA1(bf4ce85a3662df6dacfa42e3b4f9dfd6bba43b24) )

ROM_END


ROM_START( sc_smk7 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95004163.lo", 0x00001, 0x080000, CRC(fd8fd1a9) SHA1(a6c1bfefc7200f9ad429bf166d0deeb6092e9e4d) )
	ROM_LOAD16_BYTE( "95004164.hi", 0x00000, 0x080000, CRC(9d8d69d3) SHA1(345ea1b517828cd4b140ec91e7014176cd45f6ad) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p6924s13.hi", 0x00000, 0x080000, CRC(b44ee4ee) SHA1(9386208a15591bbc1e8126f7392bd42022d835cf) )
	ROM_LOAD16_BYTE( "p6924s13.lo", 0x00001, 0x080000, CRC(dee55fcc) SHA1(b6f09f264406f5446f7e4fa849a09930077a8cc7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_srrcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424580.lo", 0x00001, 0x080000, CRC(79e66ea0) SHA1(33a02a83c56089b88cdb17ecbe1036fe9d5037af) )
	ROM_LOAD16_BYTE( "95424581.hi", 0x00000, 0x080000, CRC(f542d47b) SHA1(a30e5ee2d28832cc0fd99065702cd8a9503ef0ab) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95424592.lo", 0x00001, 0x080000, CRC(61e05d2c) SHA1(e55365b128fa1e87c18985199df8d3c67f5241af) )
	ROM_LOAD16_BYTE( "95424593.hi", 0x00000, 0x080000, CRC(44bf9a57) SHA1(36cb644726d25b1265093765913206625feb4954) )
	ROM_LOAD16_BYTE( "95425580.lo", 0x00001, 0x080000, CRC(aeecddaf) SHA1(7b9eb93f220fec610c3585c16284d00a385f3757) )
	ROM_LOAD16_BYTE( "95425581.hi", 0x00000, 0x080000, CRC(61d04727) SHA1(09d695db3c2e65f94424cda0585854265b353e66) )
	ROM_LOAD16_BYTE( "95425592.lo", 0x00001, 0x080000, CRC(c9482297) SHA1(7d1f5496a4c0941c58b0453ee4ca4a37104183b5) )
	ROM_LOAD16_BYTE( "95425593.hi", 0x00000, 0x080000, CRC(71b4bbca) SHA1(9295b7070dc458ec9c3db5a7d3a848829c8232c7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_srr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406756.lo", 0x00001, 0x080000, CRC(3aab4e4f) SHA1(b53b7b241245a21c886efb801a5ee89d0d8ccf76) )
	ROM_LOAD16_BYTE( "95406757.hi", 0x00000, 0x080000, CRC(f8eb81f3) SHA1(8b9049d1fa089486da84fb86099c7d3c1cade3a7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406774.lo", 0x00001, 0x080000, CRC(576f5be1) SHA1(3697ea7ff205d43ada74e31818ef8f75d4a387b9) )
	ROM_LOAD16_BYTE( "95406775.hi", 0x00000, 0x080000, CRC(0f7a6230) SHA1(36db91b31c99539975c26f6be71456f31d52ca90) )
	ROM_LOAD16_BYTE( "95407756.lo", 0x00001, 0x080000, CRC(74f51f1a) SHA1(966116eedcc86a1217e8917a918f569cec1c101d) )
	ROM_LOAD16_BYTE( "95407757.hi", 0x00000, 0x080000, CRC(9953f1e1) SHA1(1f6e18ef48d507d88d14155f6d57c52141b85636) )
	ROM_LOAD16_BYTE( "95407774.lo", 0x00001, 0x080000, CRC(1c33317e) SHA1(7aa11025a7fadcb510c0a165a867bc78fe0c3ec6) )
	ROM_LOAD16_BYTE( "95407775.hi", 0x00000, 0x080000, CRC(4795d34a) SHA1(26f41b9fbda2c3670d99e5956ebe08b4465768de) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008213.bin", 0x0000, 0x100000, CRC(e8f82b1d) SHA1(9357f587d638289b2cd5029e5895f69097d69089) )
ROM_END


ROM_START( sc_slad )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408992.lo", 0x00001, 0x080000, CRC(52b25a9c) SHA1(a886bbb06fc446551d03b7fccdc51b0c7426f554) )
	ROM_LOAD16_BYTE( "95408993.hi", 0x00000, 0x080000, CRC(34232091) SHA1(aff81aefc6816df5fbe121a365597b1efd255b91) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408994.lo", 0x00001, 0x080000, CRC(7952dd9b) SHA1(b314dfc941594b379c0bf3ac8a215f9da8fce5ad) )
	ROM_LOAD16_BYTE( "95408995.hi", 0x00000, 0x080000, CRC(1fa6cbc9) SHA1(4602ee52f7c3cdc4ea6624cf9269c934e45026ec) )
	ROM_LOAD16_BYTE( "95409992.lo", 0x00001, 0x080000, CRC(4c8a4ac5) SHA1(4587a6f9b5224fd3001f70902b6dcbf6b10133a1) )
	ROM_LOAD16_BYTE( "95409993.hi", 0x00000, 0x080000, CRC(8a1f3400) SHA1(d4e94be6c8738ced82bf6399b7ab12c95a91d92f) )
	ROM_LOAD16_BYTE( "95409994.lo", 0x00001, 0x080000, CRC(676acdc2) SHA1(60bed4e1ce0bcb95cd4d47dfa17dfc0312715a60) )
	ROM_LOAD16_BYTE( "95409995.hi", 0x00000, 0x080000, CRC(a19adf58) SHA1(783f91b89ab95523803d2ebf547ab37a9f864ebe) )
	ROM_LOAD16_BYTE( "95410302.lo", 0x00001, 0x080000, CRC(e32e673f) SHA1(a7ca66b1f7a0d82980ee897833adf0841ee7e112) )
	ROM_LOAD16_BYTE( "95410303.hi", 0x00000, 0x080000, CRC(f963061b) SHA1(2774a2d951965f30cc85d1bf34c6ca736702cea5) )
	ROM_LOAD16_BYTE( "95410304.lo", 0x00001, 0x080000, CRC(1fb69849) SHA1(3d141b737dd40754b8cd38b5cd7c4983996c7898) )
	ROM_LOAD16_BYTE( "95410305.hi", 0x00000, 0x080000, CRC(e3a0d283) SHA1(77a6e24ed71af08aaf82d0593edf2c38365f8c49) )
	ROM_LOAD16_BYTE( "95410534.lo", 0x00001, 0x080000, CRC(b00320aa) SHA1(1bdec452515dcb2abc30bef98d9d36d5d8b4989d) )
	ROM_LOAD16_BYTE( "95410535.hi", 0x00000, 0x080000, CRC(a4b21fd0) SHA1(e8266d159b029c3a2b2a8d724c1d8d25d2826a9c) )
	ROM_LOAD16_BYTE( "95410536.lo", 0x00001, 0x080000, CRC(79619469) SHA1(15bb102661beb22428e88bd7971f2e4edb6602fd) )
	ROM_LOAD16_BYTE( "95410537.hi", 0x00000, 0x080000, CRC(3784724f) SHA1(3ed02356b842a5acbea43a3c18f812dca5aeea3b) )
	ROM_LOAD16_BYTE( "95410836.lo", 0x00001, 0x080000, CRC(b50072a5) SHA1(5c4603576a9a2efe2a03d3ad98026124ec57f1fb) )
	ROM_LOAD16_BYTE( "95410837.hi", 0x00000, 0x080000, CRC(1b9c675f) SHA1(2e62c9149d7f8fc4af63bcb8399259197cb4108e) )
	ROM_LOAD16_BYTE( "95410838.lo", 0x00001, 0x080000, CRC(f4925ba2) SHA1(d606b1e3e936d1f4c924484cc36ee99146b5b41b) )
	ROM_LOAD16_BYTE( "95410839.hi", 0x00000, 0x080000, CRC(04e4bf17) SHA1(98ab9f35ff9e5cfdd62fefb1ca5c09b41a821eb4) )
	ROM_LOAD16_BYTE( "95411302.lo", 0x00001, 0x080000, CRC(81a3b37a) SHA1(1a97579cf3745ff56724d93f7432459846e46ef5) )
	ROM_LOAD16_BYTE( "95411303.hi", 0x00000, 0x080000, CRC(e99d7d63) SHA1(de191bcf38713319cfd26be394ee4ee57ebb4022) )
	ROM_LOAD16_BYTE( "95411304.lo", 0x00001, 0x080000, CRC(de0a8ae8) SHA1(7108f81f621ef90a9c298a53249e48b991d1cd0e) )
	ROM_LOAD16_BYTE( "95411305.hi", 0x00000, 0x080000, CRC(ba4c99a5) SHA1(9a2cdd9310690f1ca358049f8c8e08ee3a43e924) )
	ROM_LOAD16_BYTE( "95411534.lo", 0x00001, 0x080000, CRC(558c61a8) SHA1(bf6dfdf44b4f7b9fd0719869492acb03b41a0564) )
	ROM_LOAD16_BYTE( "95411535.hi", 0x00000, 0x080000, CRC(409ebb65) SHA1(c7d52e277d29477dc937fabc1efcf26184411501) )
	ROM_LOAD16_BYTE( "95411536.lo", 0x00001, 0x080000, CRC(8aeb7eb0) SHA1(f3ec56069ce1cf0a9f41b6e8f91d246c96ca7ce5) )
	ROM_LOAD16_BYTE( "95411537.hi", 0x00000, 0x080000, CRC(2ccc115d) SHA1(cbf13da1f27a054a0c5ca35d66a6903b0738c2ab) )
	ROM_LOAD16_BYTE( "95411836.lo", 0x00001, 0x080000, CRC(19607aa0) SHA1(3818ea45d13f5c510b9aa68a91d1042382112d2c) )
	ROM_LOAD16_BYTE( "95411837.hi", 0x00000, 0x080000, CRC(9f357e2b) SHA1(ba4dfa42f5b9b56f0d0fc0b9a5a6f3f4a9d320ec) )
	ROM_LOAD16_BYTE( "95411838.lo", 0x00001, 0x080000, CRC(58f253a7) SHA1(45372be7175a6dfd7f53f81d4b605b4c462d1962) )
	ROM_LOAD16_BYTE( "95411839.hi", 0x00000, 0x080000, CRC(804da663) SHA1(f5fbf8d701a907cdddf0f0adced4485444ba9cad) )
	ROM_LOAD16_BYTE( "sna&lad.hi", 0x00000, 0x080000, CRC(70180308) SHA1(5833aca21637e9a9dbeca087e0a4e3f25a0ecf42) )//Whitbread
	ROM_LOAD16_BYTE( "sna&lad.lo", 0x00001, 0x080000, CRC(50147f4a) SHA1(70361cab074fe00048a5bf48fd4faf4ad39d46f5) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008375.bin", 0x0000, 0x100000, CRC(967e41ec) SHA1(4ca9eb1db89b6f918b416f1c68805c4306850c7a) )
ROM_END


ROM_START( sc_slc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410364.lo", 0x00001, 0x080000, CRC(5edb97a0) SHA1(6a6a3c97a3db1041b39b0eb3a1dd7dec1f088320) )
	ROM_LOAD16_BYTE( "95410365.hi", 0x00000, 0x080000, CRC(b8a37850) SHA1(e96f995f04f87c7054aa73c5726f3830286f3b1a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410824.lo", 0x00001, 0x080000, CRC(9bf7c418) SHA1(3fe26a20efd9c870b9483b483fe659ed74e00ca7) )
	ROM_LOAD16_BYTE( "95410825.hi", 0x00000, 0x080000, CRC(651ed291) SHA1(054d6eded1ca4b530499155358a034ee26059ce9) )
	ROM_LOAD16_BYTE( "95410904.lo", 0x00001, 0x080000, CRC(ae4fcc00) SHA1(693435829da9cb95c2ac90080ecb96af11c05a8e) )
	ROM_LOAD16_BYTE( "95410905.hi", 0x00000, 0x080000, CRC(318fe4d6) SHA1(30e9d0cc3957ad747baf38b41d278d35cb76e1eb) )
	ROM_LOAD16_BYTE( "95411364.lo", 0x00001, 0x080000, CRC(1e9ea645) SHA1(450d64e756bd8d184c399ce1797a1220a65e2e2d) )
	ROM_LOAD16_BYTE( "95411365.hi", 0x00000, 0x080000, CRC(ad0cde5b) SHA1(0e9597020603d269f1771e328494b3b51448a50d) )
	ROM_LOAD16_BYTE( "95411824.lo", 0x00001, 0x080000, CRC(3ce1e43a) SHA1(5f6cbfe0ce93992b890f70483ec7c0277f089c0a) )
	ROM_LOAD16_BYTE( "95411825.hi", 0x00000, 0x080000, CRC(bba77bc1) SHA1(365f8552e8be5d5a541b0ce93b6290bc6365199a) )
	ROM_LOAD16_BYTE( "95411904.lo", 0x00001, 0x080000, CRC(2c3c30e6) SHA1(196574323ea99a6d06ba9cf1d3674581bd0886f0) )
	ROM_LOAD16_BYTE( "95411905.hi", 0x00000, 0x080000, CRC(730b9548) SHA1(35b6efc63b7733163303c5d3a4c483f1f7bf41f2) )
	ROM_LOAD16_BYTE( "95412594.lo", 0x00001, 0x080000, CRC(5f11978d) SHA1(c6e5e0a38c3372bcba0fe63b77542c6788730ecf) )
	ROM_LOAD16_BYTE( "95412595.hi", 0x00000, 0x080000, CRC(da2d1421) SHA1(76b7a77d4edebe00d65c199131970638b20d0322) )
	ROM_LOAD16_BYTE( "95412600.lo", 0x00001, 0x080000, CRC(fbc49ba2) SHA1(771e4077f3878c1666edba557ba1fd5bc96047d5) )
	ROM_LOAD16_BYTE( "95412601.hi", 0x00000, 0x080000, CRC(b3b8fc20) SHA1(4345c7a38070c8f9b0f5656cb7c093719a331f08) )
	ROM_LOAD16_BYTE( "95412602.lo", 0x00001, 0x080000, CRC(146ec9ab) SHA1(4f148c841914fab8b180e0289cb5a3da6132b364) )
	ROM_LOAD16_BYTE( "95412603.hi", 0x00000, 0x080000, CRC(d11384df) SHA1(3d82beb57cd4adcd4062dbd95ea35c90e3a31d6d) )
	ROM_LOAD16_BYTE( "95412604.lo", 0x00001, 0x080000, CRC(17042620) SHA1(3029b9d0b98539bb165d20312e6e059c79c53c6e) )
	ROM_LOAD16_BYTE( "95412605.hi", 0x00000, 0x080000, CRC(07cf24fa) SHA1(97f90929195e778365e732272f3268886d61af63) )
	ROM_LOAD16_BYTE( "95413594.lo", 0x00001, 0x080000, CRC(ab6f448d) SHA1(f97779fc3ea91e3966de2ccbdb71dcda33d9011e) )
	ROM_LOAD16_BYTE( "95413595.hi", 0x00000, 0x080000, CRC(8dbda8b6) SHA1(f86a02c162ace296fc773045dadbcfe965cf67e2) )
	ROM_LOAD16_BYTE( "95413600.lo", 0x00001, 0x080000, CRC(de181a14) SHA1(88603d7875b826eeeff884d1bf96f64b87151102) )
	ROM_LOAD16_BYTE( "95413601.hi", 0x00000, 0x080000, CRC(b817cc50) SHA1(e256ee3f2d51cabaa4c7eac53c620de106838d61) )
	ROM_LOAD16_BYTE( "95413602.lo", 0x00001, 0x080000, CRC(f36f9226) SHA1(2574cb9f9cc2af31b8024b57c17112da7139d153) )
	ROM_LOAD16_BYTE( "95413603.hi", 0x00000, 0x080000, CRC(6633f546) SHA1(0554c4a291f943517e0e86bfafc78dd0e90c595e) )
	ROM_LOAD16_BYTE( "95413604.lo", 0x00001, 0x080000, CRC(c3a24dab) SHA1(fd994fe7823272bb13e407e52efe707528a20015) )
	ROM_LOAD16_BYTE( "95413605.hi", 0x00000, 0x080000, CRC(aa164a89) SHA1(a3f4826eaca7708f0447b52f29c01fba2e42e767) )
	ROM_LOAD16_BYTE( "p1423s12.hi", 0x00000, 0x080000, CRC(207f125d) SHA1(f107859bad37697f3eb90e36aeb31cad1c640a70) )
	ROM_LOAD16_BYTE( "p1423s12.lo", 0x00001, 0x080000, CRC(8234f892) SHA1(b5d551ef2fb44cf0e2c231278b83dc9ccbea69dd) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008412.bin", 0x0000, 0x100000, CRC(197edb63) SHA1(f1851029f6870d41d6aaf2df0a49fc54f5c79e4c) )
ROM_END


ROM_START( sc_solgl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404070.lo", 0x00001, 0x080000, CRC(81f9301e) SHA1(5a4a5d6cd24191d4b4496c049e3f8a4fc5c5c5fe) )
	ROM_LOAD16_BYTE( "95404071.hi", 0x00000, 0x080000, CRC(e1dc5a5d) SHA1(bd24dc8600571549c4b46cf565c16bd15207ab7d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404072.lo", 0x00001, 0x080000, CRC(3178ea33) SHA1(e50495daaf821491c54bfb5e5e9926c9340addc6) )
	ROM_LOAD16_BYTE( "95404073.hi", 0x00000, 0x080000, CRC(31099405) SHA1(3b1896c98e82532a536d3275eddb0930e7e708de) )
	ROM_LOAD16_BYTE( "95405070.lo", 0x00001, 0x080000, CRC(40a616da) SHA1(3557c8a85cb0482210af05c4cdbb64a5bee41067) )
	ROM_LOAD16_BYTE( "95405071.hi", 0x00000, 0x080000, CRC(b48ad528) SHA1(a806be0170392c58a0b341113ed3d8c813ce350a) )
	ROM_LOAD16_BYTE( "95405072.lo", 0x00001, 0x080000, CRC(15aa920a) SHA1(fda0f038a43235501d1f8016bd06f1fea6e15df4) )
	ROM_LOAD16_BYTE( "95405073.hi", 0x00000, 0x080000, CRC(51137ffc) SHA1(d94469e5addf7826c756f98b1e951833ea2bcc98) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008159.bin", 0x0000, 0x100000, CRC(e6ad55e4) SHA1(4bea205a9e6e2832cd06d0d5c96599f2a83f8fec) )
	ROM_LOAD( "95008160.bin", 0x0000, 0x100000, CRC(d52329ca) SHA1(e0feebe0d0ec13cd15cf4af1023246a1a3a9adc7) )
ROM_END


ROM_START( sc_slih )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410436.lo", 0x00001, 0x080000, CRC(4df1436f) SHA1(a7c516e1d26dc6fca08e64937e91e2174afdf315) )
	ROM_LOAD16_BYTE( "95410437.hi", 0x00000, 0x080000, CRC(254f9b81) SHA1(0462e21acdea74baabfe15bd9282421fd0d15e99) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95411436.lo", 0x00001, 0x080000, CRC(5da6d35d) SHA1(66dc43728e38df61d30ae893928fbcdec8a2466b) )
	ROM_LOAD16_BYTE( "95411437.hi", 0x00000, 0x080000, CRC(a3048c2d) SHA1(1c24420464cb8690dcc0a1c317edb432ae61bc0f) )
	ROM_LOAD16_BYTE( "95412262.lo", 0x00001, 0x080000, CRC(625046fc) SHA1(57a390800ae51f4a5e3f93b0ed87fa2275ea2c78) )
	ROM_LOAD16_BYTE( "95412263.hi", 0x00000, 0x080000, CRC(40db5742) SHA1(e63878a2e45a12392567f60ee6ddfe3af5511be7) )
	ROM_LOAD16_BYTE( "95413262.lo", 0x00001, 0x080000, CRC(709eaf2f) SHA1(ccb457e1b38387c6d0072a4310856cd09588c03a) )
	ROM_LOAD16_BYTE( "95413263.hi", 0x00000, 0x080000, CRC(a5c95f87) SHA1(bb8f98ddcd78b1d9fddb271592f87d89a4ab51c0) )
	ROM_LOAD16_BYTE( "95414576.lo", 0x00001, 0x080000, CRC(c77150a5) SHA1(9c23b3432c48166b2a592af6b654c0ae3729c564) )
	ROM_LOAD16_BYTE( "95414577.hi", 0x00000, 0x080000, CRC(ed060c33) SHA1(e5b7bfc55b84c0d42d1bc73f7ad4e21bab9645a6) )
	ROM_LOAD16_BYTE( "95415576.lo", 0x00001, 0x080000, CRC(e904571b) SHA1(84856fe533d24538b988625a73b67b952c1b6b8a) )
	ROM_LOAD16_BYTE( "95415577.hi", 0x00000, 0x080000, CRC(c17f534d) SHA1(4ceab2363f647dbe8a610e8c12a0ec7d24664a54) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_sace )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408060.odd", 0x00001, 0x080000, CRC(078c36c1) SHA1(4937cc861048189172737b8441d2bc97e359b467) )
	ROM_LOAD16_BYTE( "95408061.evn", 0x00000, 0x080000, CRC(36c760e8) SHA1(2eb760d303486102cfccb924062b77a3679f7bfa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409060.odd", 0x00001, 0x080000, CRC(a10cdb78) SHA1(34ddb81b622036cd3d86dd48e80e8c036020cbfa) )
	ROM_LOAD16_BYTE( "95409061.evn", 0x00000, 0x080000, CRC(185c314e) SHA1(557da30f4d1679ed17de3308e1e5234deba30c85) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008270.bin", 0x0000, 0x0fde91, CRC(5c87d4ce) SHA1(6fce212a89334a9595411aa2d20bde5e3fae4710) )
ROM_END


ROM_START( sc_sbust )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406134.odd", 0x00001, 0x080000, CRC(f8c56233) SHA1(35b87458cc43de52233a771526423fed4648804e) )
	ROM_LOAD16_BYTE( "95406135.evn", 0x00000, 0x080000, CRC(597dc269) SHA1(bc3f4f0118990c9dd25a2f5bc0fe1ee42fc3392e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407134.odd", 0x00001, 0x080000, CRC(49e962a2) SHA1(067fbb01c28f3b6818e0c4e3baeb258916ee08cc) )
	ROM_LOAD16_BYTE( "95407135.evn", 0x00000, 0x080000, CRC(6fed044d) SHA1(fa2dd3b0fa50f205c092d175a2cdffea48d98cb0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008255.bin", 0x0000, 0x0d55db, CRC(feef5ac9) SHA1(83b7de3bd3a1fa3f5ae17f102cc54467d564740f) )
ROM_END


ROM_START( sc_spice )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418330.lo", 0x00001, 0x080000, CRC(6eff1334) SHA1(355889f2e2c801bfcefcbcb48ec404efec08b01f) )
	ROM_LOAD16_BYTE( "95418331.hi", 0x00000, 0x080000, CRC(b90c3877) SHA1(ca8b09f40605d2f652a1a3992268292c9282685a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418376.lo", 0x00001, 0x080000, CRC(f5d1d605) SHA1(83cbbedd35260fc4a66d0dba935ee61cf1939ed0) )
	ROM_LOAD16_BYTE( "95418377.hi", 0x00000, 0x080000, CRC(4fce1d68) SHA1(36c81646d76e0bc89146fcbbfbad661c2320b4c8) )
	ROM_LOAD16_BYTE( "95418488.lo", 0x00001, 0x080000, CRC(f8de81a8) SHA1(2cede8dc509bab58e7613611ca9a7aec4713acf5) )
	ROM_LOAD16_BYTE( "95418489.hi", 0x00000, 0x080000, CRC(170454a4) SHA1(3c5dc1a19a58bf72a90d74d1ba9f970dc11833fb) )
	ROM_LOAD16_BYTE( "95418490.lo", 0x00001, 0x080000, CRC(c5aa6ec1) SHA1(0e58498cf4d17d832a61b14bd9c696f8dfd7329b) )
	ROM_LOAD16_BYTE( "95418491.hi", 0x00000, 0x080000, CRC(17f83aa4) SHA1(dcc4d6f840e6b781ef77d809b2186a67a2ac2870) )
	ROM_LOAD16_BYTE( "95419330.lo", 0x00001, 0x080000, CRC(c55c813f) SHA1(6d5e62b741185ae1582ba2b78aab4d6cbbe5c9e6) )
	ROM_LOAD16_BYTE( "95419331.hi", 0x00000, 0x080000, CRC(9b92a210) SHA1(2aaba50b3ddd458e7c785c224d04dc87a4c30b5c) )
	ROM_LOAD16_BYTE( "95419376.lo", 0x00001, 0x080000, CRC(5f66dde4) SHA1(62318dda642830b829636efa02b2051824ffe1f7) )
	ROM_LOAD16_BYTE( "95419377.hi", 0x00000, 0x080000, CRC(3ae406a2) SHA1(d042cb577229e30f31735e8c461821b3d7c8ed59) )
	ROM_LOAD16_BYTE( "95419488.lo", 0x00001, 0x080000, CRC(c17394ee) SHA1(384ecc4450d161459cadff6c6b8b05cd2c50562a) )
	ROM_LOAD16_BYTE( "95419489.hi", 0x00000, 0x080000, CRC(9e962a61) SHA1(2a5984ff26e0ae4c24b0efa1cc3321a609db93f9) )
	ROM_LOAD16_BYTE( "95419490.lo", 0x00001, 0x080000, CRC(c3efc68a) SHA1(f429e79c6368cf32103fafbbdea3cc492ccdeffc) )
	ROM_LOAD16_BYTE( "95419491.hi", 0x00000, 0x080000, CRC(de0c3b27) SHA1(10071cea522168afa9847a0f9bb71ab93d5ccdbc) )
	ROM_LOAD16_BYTE( "95422968.lo", 0x00001, 0x080000, CRC(1be00ec6) SHA1(805769692fce2ad70ee71c3a82f63f90e58186d4) )
	ROM_LOAD16_BYTE( "95422969.hi", 0x00000, 0x080000, CRC(b3c7d7f3) SHA1(0d66b1930e765c4cc91e8028584b4632ba00bb44) )
	ROM_LOAD16_BYTE( "95423968.lo", 0x00001, 0x080000, CRC(a96eda7e) SHA1(7ec117adb50821f99fda5def3f7851ed880fcf15) )
	ROM_LOAD16_BYTE( "95423969.hi", 0x00000, 0x080000, CRC(dff7d5ef) SHA1(f8c8630bad47d9dfb1e4f3d2b090cdb66a51195c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008585.bin", 0x0000, 0x100000, CRC(2f15c4a4) SHA1(df543cd6ebecbbd3922bb8550e4bf349fd8eb45c) )
ROM_END


ROM_START( sc_swywm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416370.lo", 0x00001, 0x080000, CRC(c318c638) SHA1(f9e9bc1dabd51901bd6bd5fda7d9b808cd323c21) )
	ROM_LOAD16_BYTE( "95416371.hi", 0x00000, 0x080000, CRC(3c583cc6) SHA1(9cd0e6010e3e8d13acb6efba5a962c3db2daa65a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416430.lo", 0x00001, 0x080000, CRC(7529d6c8) SHA1(a507ca105574727294224cb6667ab404c65b1a40) )
	ROM_LOAD16_BYTE( "95416431.hi", 0x00000, 0x080000, CRC(cc782058) SHA1(3bfa22816786b3c58c95d9094b301166ee47d4c9) )
	ROM_LOAD16_BYTE( "95416432.lo", 0x00001, 0x080000, CRC(f5601034) SHA1(c5a56dff371072cb29c54cfbfdc56b348fba59ba) )
	ROM_LOAD16_BYTE( "95416433.hi", 0x00000, 0x080000, CRC(fbf45904) SHA1(1069db1049c8796ea203453c544ac46d14cab174) )
	ROM_LOAD16_BYTE( "95417370.lo", 0x00001, 0x080000, CRC(32232445) SHA1(4ccef584781987e73cecef8932620bcec6e1efe7) )
	ROM_LOAD16_BYTE( "95417371.hi", 0x00000, 0x080000, CRC(e647d430) SHA1(5ae9258149dace4999e62fa6369aa78064739575) )
	ROM_LOAD16_BYTE( "95417430.lo", 0x00001, 0x080000, CRC(c089e7b9) SHA1(d65828ae971870019d3eac1cefb6d3c2b648e85a) )
	ROM_LOAD16_BYTE( "95417431.hi", 0x00000, 0x080000, CRC(cdd9da10) SHA1(497548e7433866c1d73c9b4c5db753209f1d9d17) )
	ROM_LOAD16_BYTE( "95417432.lo", 0x00001, 0x080000, CRC(c724c19a) SHA1(2b41031d422798cdc539e2b5e45d7b93d68c65e3) )
	ROM_LOAD16_BYTE( "95417433.hi", 0x00000, 0x080000, CRC(5285e546) SHA1(c668e7bd64dd0001e6bcd9730af24ebd1b72adb7) )
	ROM_LOAD16_BYTE( "95420306.lo", 0x00001, 0x080000, CRC(14f6e069) SHA1(c3af8f51b17c078e9293d514cb2bbe4045bfb66a) )
	ROM_LOAD16_BYTE( "95420307.hi", 0x00000, 0x080000, CRC(f6dedbc3) SHA1(23a433453cd518b3d17770e4d5638877eaecb5ae) )
	ROM_LOAD16_BYTE( "95420308.lo", 0x00001, 0x080000, CRC(7e2795e2) SHA1(b896c1b93456551d49c4bcaf1a55606617c4a3ba) )
	ROM_LOAD16_BYTE( "95420309.hi", 0x00000, 0x080000, CRC(9a054b54) SHA1(a42fafcf5ad34e2a32cb50e0330c5a53b4a8b4b4) )
	ROM_LOAD16_BYTE( "95420310.lo", 0x00001, 0x080000, CRC(063632dc) SHA1(d2690329b063b795818df9115650aeeb6e1c3266) )
	ROM_LOAD16_BYTE( "95420311.hi", 0x00000, 0x080000, CRC(9466cee9) SHA1(264c26172e4df7c3be6099008418e5c365b178db) )
	ROM_LOAD16_BYTE( "95421306.lo", 0x00001, 0x080000, CRC(36527439) SHA1(7d1b8d18b8689992bc16106fed655fd930f682a9) )
	ROM_LOAD16_BYTE( "95421307.hi", 0x00000, 0x080000, CRC(ee60c6dc) SHA1(ed74e4a4833c4a01f0ec3be456fb48269520e725) )
	ROM_LOAD16_BYTE( "95421308.lo", 0x00001, 0x080000, CRC(ee95a1b9) SHA1(927adf4edc9de6b96ecd3867944da0ba117263cd) )
	ROM_LOAD16_BYTE( "95421309.hi", 0x00000, 0x080000, CRC(d6d71c6d) SHA1(243150d221e345045762b19a5ef7c4955cd4df6b) )
	ROM_LOAD16_BYTE( "95421310.lo", 0x00001, 0x080000, CRC(678d45a4) SHA1(15564d8a1daa34e9d1e87704902cd4caf1eae212) )
	ROM_LOAD16_BYTE( "95421311.hi", 0x00000, 0x080000, CRC(f05c6424) SHA1(6003546566a42f27476811dc3512c17d861b017d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_splgb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402161.lo", 0x00001, 0x080000, CRC(fd49e035) SHA1(ebfea772f9d60a9429a6545fa495b72d159c1b80) )
	ROM_LOAD16_BYTE( "95402162.hi", 0x00000, 0x080000, CRC(d8050b29) SHA1(0cf738e2ef9f8c9973a3148be338759eb769fe84) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403161.lo", 0x00001, 0x080000, CRC(5bf7949d) SHA1(0705a98f7819a15de1d18240dc7496e57e2d89b9) )
	ROM_LOAD16_BYTE( "95403162.hi", 0x00000, 0x080000, CRC(cfd7f5c2) SHA1(0368881aaee9e5b153807c01c9ef7021ed10d031) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_spred )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404606.lo", 0x00001, 0x080000, CRC(14507a00) SHA1(01d711155b66a8252ce8cafb03db585ea624095d) )
	ROM_LOAD16_BYTE( "95404607.hi", 0x00000, 0x080000, CRC(cc4b76d2) SHA1(28a7e1d6ecefd228557e97a90c49bffff0cb335c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_stag )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95008017.lo", 0x00001, 0x100000, CRC(dab74220) SHA1(321f765e1908b65ec9d3e64bb33533d78c9cc58a) )
	ROM_LOAD16_BYTE( "95008018.hi", 0x00000, 0x100000, CRC(ba328f08) SHA1(99880f22c2cac61b32c3e2a574b9b30daefefb3e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406092.lo", 0x00001, 0x080000, CRC(71347a4f) SHA1(5dbaa874b6c4e29d225005815830e5101c5c7105) )
	ROM_LOAD16_BYTE( "95406093.hi", 0x00000, 0x080000, CRC(acc83bb2) SHA1(17ff4b8cad7d63597703cbc2febd0a8a112b3612) )
	ROM_LOAD16_BYTE( "95407092.lo", 0x00001, 0x080000, CRC(978b63cb) SHA1(50f475de4754e21d9394aee1815e05e4f3c87ae0) )
	ROM_LOAD16_BYTE( "95407093.hi", 0x00000, 0x080000, CRC(cb804832) SHA1(31472e58798e0438f17d7d74a90d04e109fa6231) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_starp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400153.lo", 0x00001, 0x080000, CRC(7d2efaa9) SHA1(321a15e844a0b3102687c92de7a545cb6906121a) )
	ROM_LOAD16_BYTE( "95400154.hi", 0x00000, 0x080000, CRC(caede04c) SHA1(d623cc28f87f3afd3d2e4bfe27eaa11cd324a5ce) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400249.lo", 0x00001, 0x080000, CRC(32a874cb) SHA1(f6d7f3b4c2f6562ec68bfd3357afceb7780c438a) )
	ROM_LOAD16_BYTE( "95400250.hi", 0x00000, 0x080000, CRC(8ff5ce78) SHA1(3a4581e29f09c79bf686caaa92f413f125ca0ee8) )
	ROM_LOAD16_BYTE( "95400319.lo", 0x00001, 0x080000, CRC(63575baa) SHA1(d8fa40d39a77098c180001f33f0f2ca1891fcf1b) )
	ROM_LOAD16_BYTE( "95400320.hi", 0x00000, 0x080000, CRC(07de30c2) SHA1(2820f3fe2f1450ba3b99d417a1c75fa23170c68d) )
	ROM_LOAD16_BYTE( "95400839.lo", 0x00001, 0x080000, CRC(7180e28b) SHA1(4cd776032a3d2ee2fddfc6fb96cfa8d26c2d3bf0) )
	ROM_LOAD16_BYTE( "95400840.hi", 0x00000, 0x080000, CRC(7c26b453) SHA1(adca4cb4ce1c9dcbade7b925bc4e2e86da26f3f0) )
	ROM_LOAD16_BYTE( "95400841.lo", 0x00001, 0x080000, CRC(fda7fa90) SHA1(56c8e52e6e73e77aceaf8a83dd463b66dfd69404) )
	ROM_LOAD16_BYTE( "95400842.hi", 0x00000, 0x080000, CRC(09bf64c4) SHA1(73d24ab4c62cacf572f56e481252483ec4437a50) )
	ROM_LOAD16_BYTE( "95401153.lo", 0x00001, 0x080000, CRC(642c9f39) SHA1(44772e8e3029f5c28e65a071a67e4cdc12e222fd) )
	ROM_LOAD16_BYTE( "95401154.hi", 0x00000, 0x080000, CRC(550c9a2a) SHA1(39c76f413b74fcd6f15402a69d7d9dd9989273af) )
	ROM_LOAD16_BYTE( "95401249.lo", 0x00001, 0x080000, CRC(0515b13b) SHA1(0bf59f485655a177b8c7c922685be34f15b5bc9b) )
	ROM_LOAD16_BYTE( "95401250.hi", 0x00000, 0x080000, CRC(9a5a6873) SHA1(22574e541f0798950c2ce4b027cefd2d867f445b) )
	ROM_LOAD16_BYTE( "95401319.lo", 0x00001, 0x080000, CRC(caa9045a) SHA1(7f0523ad65cb96ca0dee4a3b26e0c1ae29ac5867) )
	ROM_LOAD16_BYTE( "95401320.hi", 0x00000, 0x080000, CRC(5fb3d806) SHA1(cf9df40d6adbb82b1fe76f70e95adeb1ccb0eafd) )
	ROM_LOAD16_BYTE( "95401839.lo", 0x00001, 0x080000, CRC(68d075de) SHA1(090104001364a19cf50fde46666d00e2f264c15c) )
	ROM_LOAD16_BYTE( "95401840.hi", 0x00000, 0x080000, CRC(2708a807) SHA1(eca3925cea8723e29a42d3d7ec9cae6aab448ba4) )
	ROM_LOAD16_BYTE( "95401841.lo", 0x00001, 0x080000, CRC(4c27509e) SHA1(bd31292e30305e41f2e4f46422e4763578211174) )
	ROM_LOAD16_BYTE( "95401842.hi", 0x00000, 0x080000, CRC(1356fd9e) SHA1(b2b01e98cfd857621fc29fe7ab3d5a4d6ecbaf3d) )
	ROM_LOAD16_BYTE( "sprz15hi", 0x0000, 0x080000, CRC(ee6891f2) SHA1(b148917e207eabd51ccf4ac87125383e4338e4dc) )
	ROM_LOAD16_BYTE( "sprz15lo", 0x00001, 0x080000, CRC(9bd0fa39) SHA1(2a5b5db8d6318d9050e9650efb37c7dadedc40fd) )
	ROM_LOAD16_BYTE( "starp247.lo", 0x00001, 0x080000, CRC(075f3e8d) SHA1(1a2e96cff3809a5844f7d76108ae3ef796b1bc97) )
	ROM_LOAD16_BYTE( "starp248.hi", 0x00000, 0x080000, CRC(b1ad5194) SHA1(0ecc9a790bef001ba8ce889639e5a290d322346c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "star prize snd1.bin", 0x0000, 0x080000, CRC(9f7f7442) SHA1(576e5e92455455ad18ae596a9dae500a17912faa) )
	ROM_LOAD( "star prize snd2.bin", 0x0000, 0x080000, CRC(0ae992b5) SHA1(b3a8ba472aa3a6785678a554a7fe789f9f3dc6c0) )
ROM_END


ROM_START( sc_strbr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406478.lo", 0x00001, 0x080000, CRC(44d83c82) SHA1(18d2b7e5436a888cee0edffc9cc89becd6eee492) )
	ROM_LOAD16_BYTE( "95406479.hi", 0x00000, 0x080000, CRC(80bfda8f) SHA1(64b5d7b15339cd72419ab291b87adbc464a6154e) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406742.lo", 0x00001, 0x080000, CRC(e6581ca0) SHA1(0e9b76524d6395067dbd6813d9299256592c1639) )
	ROM_LOAD16_BYTE( "95406743.hi", 0x00000, 0x080000, CRC(2601e7d6) SHA1(bde092ccae97d5a17fdce96da2b589713a730eff) )
	ROM_LOAD16_BYTE( "95408044.lo", 0x00001, 0x080000, CRC(6ad12ec0) SHA1(5db838200681eb7d4210af1503656001c37154d4) )
	ROM_LOAD16_BYTE( "95408045.hi", 0x00000, 0x080000, CRC(3d34c484) SHA1(7d8b401ac900c0666b849d545143af5c126b0d84) )
	ROM_LOAD16_BYTE( "95408150.lo", 0x00001, 0x080000, CRC(77bc3d52) SHA1(ca03facce088c7773aff292c6e2a8ae0601c6c7d) )
	ROM_LOAD16_BYTE( "95408151.hi", 0x00000, 0x080000, CRC(3ddb4e61) SHA1(789d6bf967d1b790dcf8e9d72c2174f2f3b42fc0) )
	ROM_LOAD16_BYTE( "95408588.lo", 0x00001, 0x080000, CRC(6bf697b3) SHA1(53e326858be5005f03707ea975e39ea5536de23c) )
	ROM_LOAD16_BYTE( "95408589.hi", 0x00000, 0x080000, CRC(c0106b47) SHA1(a794d18d1dca1555f16d26a5b0a7c0f233a51d10) )
	ROM_LOAD16_BYTE( "sbar713.bin", 0x0000, 0x010000, CRC(c7e26d6e) SHA1(1e270d4f5de92083f54cc3fe246b2bc1d2f441b3) )
	ROM_LOAD16_BYTE( "sbar714.bin", 0x0000, 0x010000, CRC(57dbca5f) SHA1(22a6fcf1e11dd9ba2b3f73cd7520e2b4a740a893) )
	ROM_LOAD16_BYTE( "sbar715.bin", 0x0000, 0x010000, CRC(e9192085) SHA1(a030e81f54338bcb8667c59bad9a6b35a41bbd9f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004290.snd", 0x0000, 0x080000, CRC(488972c2) SHA1(4cd9bbb6df0fbaf9b8dd93294046c71c82bf4b5b) )
ROM_END


ROM_START( sc_stirc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402938.lo", 0x00001, 0x080000, CRC(7e97188b) SHA1(5e7c7e00b0ef5c25b0a9456bbfa8982786cfde8a) )
	ROM_LOAD16_BYTE( "95402939.hi", 0x00000, 0x080000, CRC(2d9542df) SHA1(3569113432dd4d59ae2e30025da2dae8f78d89a8) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402942.lo", 0x00001, 0x080000, CRC(0ef41837) SHA1(5ac992670e155a46bf85e1fef5a2b4c5a297666e) )
	ROM_LOAD16_BYTE( "95402943.hi", 0x00000, 0x080000, CRC(a7dcf62d) SHA1(6077b1cb3c2247abcf99fde50226598418b9f0c2) )
	ROM_LOAD16_BYTE( "95403938.lo", 0x00001, 0x080000, CRC(4cd8f0d5) SHA1(4057870619de65b9e50dfc5807ca514d576e9f2d) )
	ROM_LOAD16_BYTE( "95403939.hi", 0x00000, 0x080000, CRC(854504d5) SHA1(112de9c078b4d9ede043fcc288ee02a0671b959f) )
	ROM_LOAD16_BYTE( "95403940.lo", 0x00001, 0x080000, CRC(8f9e4d10) SHA1(38244028ac3f903971bd6e2786339a321d181df0) )
	ROM_LOAD16_BYTE( "95403941.hi", 0x00000, 0x080000, CRC(335ceb9f) SHA1(453937f56815bbbc87b251366d14d38e979482f9) )
	ROM_LOAD16_BYTE( "95404126.lo", 0x00001, 0x080000, CRC(76c867e5) SHA1(5eb6a1e03b397ba847588b5b07d350e74d9e681d) )
	ROM_LOAD16_BYTE( "95404127.hi", 0x00000, 0x080000, CRC(8243db7b) SHA1(d36e3e38aaf6b0fd05757179f715ecaa2d07777a) )
	ROM_LOAD16_BYTE( "95405126.lo", 0x00001, 0x080000, CRC(27a13e76) SHA1(114ab715f6c3e15feee1f36f473faec69815098d) )
	ROM_LOAD16_BYTE( "95405127.hi", 0x00000, 0x080000, CRC(8fe7eaf2) SHA1(f9e8dc96a2a74ab7861f05e88ec42dc893babbca) )
	ROM_LOAD16_BYTE( "95406284.lo", 0x00001, 0x080000, CRC(5a1c0cec) SHA1(0a0dac529cf1eae20d552c7d2d6bb27d6dfbc9c7) )
	ROM_LOAD16_BYTE( "95406285.hi", 0x00000, 0x080000, CRC(39171d86) SHA1(66062b366a26e19bbf0b0ae887e2d20be63236e7) )
	ROM_LOAD16_BYTE( "95406684.lo", 0x00001, 0x080000, CRC(8e3bce31) SHA1(50d6d55a110e72d0fa1aabafae0f8abe1a6d2343) )
	ROM_LOAD16_BYTE( "95406685.hi", 0x00000, 0x080000, CRC(4f800fca) SHA1(261e63bc273625c07e0a9765183a5723627cf27e) )
	ROM_LOAD16_BYTE( "95407284.lo", 0x00001, 0x080000, CRC(e8e5eb7b) SHA1(3dc0691bf3f0f60c266b57dca121755e5fae0f89) )
	ROM_LOAD16_BYTE( "95407285.hi", 0x00000, 0x080000, CRC(f0e31c05) SHA1(5806213c3c88db20941fb3891c9c79d4cd4da3b1) )
	ROM_LOAD16_BYTE( "95407684.lo", 0x00001, 0x080000, CRC(23c68fc1) SHA1(5a51a98fa7eaa9bca98f47ff10491f505a7a4f1e) )
	ROM_LOAD16_BYTE( "95407685.hi", 0x00000, 0x080000, CRC(5852f121) SHA1(ca6e548a4b687f8f6eba6bd9dc8118b9ec2ab967) )
	ROM_LOAD16_BYTE( "st_crazy.lo", 0x00001, 0x080000, CRC(2a95d06a) SHA1(b9b17f6f54062f738c0595637c9be8fedac49546) )
	ROM_LOAD16_BYTE( "st_crazy.hi", 0x00000, 0x080000, CRC(0f409002) SHA1(5822c523426eb1a6b3af719720b5b92d2d4ac200) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008117.bin", 0x0000, 0x197791, CRC(9d555ddf) SHA1(753b838fa7f64317b64fe0ae0ee7e6484f2a5af3) )
ROM_END


ROM_START( sc_strk )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416484.lo", 0x00001, 0x080000, CRC(1717074a) SHA1(936e10b53f1b44270c96091a60f470425f6baaad) )
	ROM_LOAD16_BYTE( "95416485.hi", 0x00000, 0x080000, CRC(86531e46) SHA1(0b7a911c827bdbabd1d889a04290aca083c43945) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416490.lo", 0x00001, 0x080000, CRC(dc674c3e) SHA1(1a087ad8d8931fbfd2ad9d3eca116674941c8805) )
	ROM_LOAD16_BYTE( "95416491.hi", 0x00000, 0x080000, CRC(4c584b02) SHA1(f0dc5c30759fd1d541ab26abcb2af1a21cae2f97) )
	ROM_LOAD16_BYTE( "95416644.lo", 0x00001, 0x080000, CRC(600c42b5) SHA1(d1af081e9781aa0817960810cf30f931ee345547) )
	ROM_LOAD16_BYTE( "95416645.hi", 0x00000, 0x080000, CRC(5499f16a) SHA1(cdbc7d88b5bf68ce227a3fa8ca45f3b7d8c028cd) )
	ROM_LOAD16_BYTE( "95416650.lo", 0x00001, 0x080000, CRC(247ae490) SHA1(a96cbeb3c956871cd84900dbb2b0ca6c1e0d198d) )
	ROM_LOAD16_BYTE( "95416651.hi", 0x00000, 0x080000, CRC(21435b22) SHA1(675364e906561c7901137f5cb4927f55d0b633fc) )
	ROM_LOAD16_BYTE( "95417484.lo", 0x00001, 0x080000, CRC(8c6f8d43) SHA1(e5c4fff6cb92042b5d8f6101e8e5478839c6a7bc) )
	ROM_LOAD16_BYTE( "95417485.hi", 0x00000, 0x080000, CRC(2cfe00ac) SHA1(507f2b7b0992b2644386c895dcfd5531c2b80fe2) )
	ROM_LOAD16_BYTE( "95417490.lo", 0x00001, 0x080000, CRC(5d690955) SHA1(e87882308d60331d9ff83506f83e9b5e9e43a228) )
	ROM_LOAD16_BYTE( "95417491.hi", 0x00000, 0x080000, CRC(1594598e) SHA1(b0031c0892be74427862f61886282799b0c634f9) )
	ROM_LOAD16_BYTE( "95417602.lo", 0x00001, 0x080000, CRC(f9e99405) SHA1(37609f6347f89ef39ebc284bf3eb70b97e21a8a6) )
	ROM_LOAD16_BYTE( "95417603.hi", 0x00000, 0x080000, CRC(2034db37) SHA1(13b71d5c7f8886d59b2924ecb54fd52900ea07b6) )
	ROM_LOAD16_BYTE( "95417604.lo", 0x00001, 0x080000, CRC(d9c257c9) SHA1(861f32993d81e5bef6a4040fe424ef4fca7bb581) )
	ROM_LOAD16_BYTE( "95417605.hi", 0x00000, 0x080000, CRC(2824e731) SHA1(abc7172d8aa1b09fa7a426e5fbec78cba009b5c0) )
	ROM_LOAD16_BYTE( "95417644.lo", 0x00001, 0x080000, CRC(d4a6f36c) SHA1(140c44d150b26a9214aa9c4daf9cb3a7c8477b17) )
	ROM_LOAD16_BYTE( "95417645.hi", 0x00000, 0x080000, CRC(4d045b2c) SHA1(2dedf3a2fd01c165b7ba5260243a27d013f08092) )
	ROM_LOAD16_BYTE( "95417646.lo", 0x00001, 0x080000, CRC(328509c5) SHA1(61518a77a5d17259f9b0bd1eca48d16f91fe19b7) )
	ROM_LOAD16_BYTE( "95417647.hi", 0x00000, 0x080000, CRC(51f8dbf3) SHA1(535e7a4d437e5ab98b9ce9dac4b093ed9de84ea0) )
	ROM_LOAD16_BYTE( "95417648.lo", 0x00001, 0x080000, CRC(237de5b6) SHA1(21fc8de3ba885b7ea9b9077a5c6d041131e4a811) )
	ROM_LOAD16_BYTE( "95417649.hi", 0x00000, 0x080000, CRC(a65b98f8) SHA1(039a153fe962de7eda18f2ff9467e718e941e816) )
	ROM_LOAD16_BYTE( "95417650.lo", 0x00001, 0x080000, CRC(5a8f3064) SHA1(ca05350bf10500d4f1b58f9a3c94255eb6a6784a) )
	ROM_LOAD16_BYTE( "95417651.hi", 0x00000, 0x080000, CRC(5a8e85f1) SHA1(b3fab14196b8435ac8d6b9d9980940a336780fc9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008492.bin", 0x0000, 0x0fa055, CRC(4f37c766) SHA1(352dc95bb1f0fe31db233ac731618acb3046681e) )
ROM_END


ROM_START( sc_strka )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408360.odd", 0x00001, 0x080000, CRC(e3781af6) SHA1(6e7d2d120d04c79f39f2a8794ab95096eae07c1f) )
	ROM_LOAD16_BYTE( "95408361.evn", 0x00000, 0x080000, CRC(396c29b7) SHA1(70d44b4887afa5464edf91c80ff4842bcb15bcbb) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409360.odd", 0x00001, 0x080000, CRC(a2826287) SHA1(bd45e5a1043ab22d6aef205d3dcacb17b150f6c8) )
	ROM_LOAD16_BYTE( "95409361.evn", 0x00000, 0x080000, CRC(2cc38fbc) SHA1(d9d9baa12347578b057f1c963f3cdc7e3e94b4d6) )
	ROM_LOAD16_BYTE( "95409362.odd", 0x00001, 0x080000, CRC(722143e7) SHA1(a4d2059f103021cc315ce3697eeabc27c90058bd) )
	ROM_LOAD16_BYTE( "95409363.evn", 0x00000, 0x080000, CRC(2448c93e) SHA1(3c5023d768f50ebb96322bc78d5cb51fcb2a2ce7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008353.bin", 0x0000, 0x0fbc01, CRC(593626e0) SHA1(f348d6ea347efa706b1587235241231562c447d3) )
ROM_END


ROM_START( sc_sf )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404372.lo", 0x00001, 0x080000, CRC(07b9d1e2) SHA1(386356eb2c7c8b82978700e466f5d55e82b72b5f) )
	ROM_LOAD16_BYTE( "95404373.hi", 0x00000, 0x080000, CRC(68e73d68) SHA1(43d3229afb3085522dc7e04e0015020e3681cb7d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405226.lo", 0x00001, 0x080000, CRC(943c5377) SHA1(ca9d1fb6cb09f690a82e3bd057c81f88f49b8cb5) )
	ROM_LOAD16_BYTE( "95405227.hi", 0x00000, 0x080000, CRC(79d8a0a0) SHA1(420f8a6f8bc1fbdb442bc7bdfa6c8b8891e3f6c6) )
	ROM_LOAD16_BYTE( "95405372.lo", 0x00001, 0x080000, CRC(76022704) SHA1(be9158bf045b24777a118b054e2e29f3c1d939f2) )
	ROM_LOAD16_BYTE( "95405373.hi", 0x00000, 0x080000, CRC(94c00e5f) SHA1(9d1fcf9365008ec394e3d497e7115875a7938ccd) )
	ROM_LOAD16_BYTE( "95406148.lo", 0x00001, 0x080000, CRC(758f60aa) SHA1(3f7d47319c86b0e7ffb08aff8ac0e1c7d22cb175) )
	ROM_LOAD16_BYTE( "95406149.hi", 0x00000, 0x080000, CRC(4383447b) SHA1(cf70714c76c66455fb57e06ea6d4ddc458f897b6) )
	ROM_LOAD16_BYTE( "95407148.lo", 0x00001, 0x080000, CRC(b5ee08d4) SHA1(f170d32ae41be7d0a01fcee690a1a94380c44d19) )
	ROM_LOAD16_BYTE( "95407149.hi", 0x00000, 0x080000, CRC(aa0bd147) SHA1(a569d7714d6b6ce7d52e02c24cfcdc1e8049805c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_strx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95004209.lo", 0x00001, 0x080000, CRC(40247425) SHA1(54c8540f9ce45b8b02f6616233b81e33af804f63) )
	ROM_LOAD16_BYTE( "95004210.hi", 0x00000, 0x080000, CRC(6f6ce2c8) SHA1(7e9ce336a1307b8290196d58c7419996d0758ab9) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406048.lo", 0x00001, 0x080000, CRC(6c20e6ad) SHA1(3cd8b65a15f60e1aadd4917fc2a5b4cc024058b0) )
	ROM_LOAD16_BYTE( "95406049.hi", 0x00000, 0x080000, CRC(a2aa51e1) SHA1(f2bf95fa63b2e1bd0613c278a00063dfa18db9c5) )
	ROM_LOAD16_BYTE( "95407048.lo", 0x00001, 0x080000, CRC(8903611d) SHA1(1b12dd9d1ab35d625952d12066d027466264bb19) )
	ROM_LOAD16_BYTE( "95407049.hi", 0x00000, 0x080000, CRC(ed8a11f6) SHA1(0d4f37dfecf362c282f17dc55dc0957296a974e6) )
	ROM_LOAD16_BYTE( "p1114p11.hi", 0x00000, 0x080000, CRC(5d9b7b41) SHA1(20fcc012b15d2b7df9c59b080b9a440bc4b4dfe3) )
	ROM_LOAD16_BYTE( "p1114p11.lo", 0x00001, 0x080000, CRC(d063e941) SHA1(87ad78ff49890b21c2d75a8417885e86479278c3) )
	ROM_LOAD16_BYTE( "p1114s11.hi", 0x00000, 0x080000, CRC(1664bc68) SHA1(d06799ad3a3b975c30235b25689c3e42c8e832ac) )
	ROM_LOAD16_BYTE( "p1114s11.lo", 0x00001, 0x080000, CRC(3b2ad23c) SHA1(14554d5eb51ae0ecc9fcebdfd50f027f0ece78c3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008247.bin", 0x0000, 0x100000, CRC(0817596f) SHA1(250db171d1f7893883ffbcfdd3fd3f6e62524bdc) )
ROM_END


ROM_START( sc_suscl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420890.lo", 0x00001, 0x080000, CRC(0765de84) SHA1(3fe611f34982cd734d7356b54d2cc60acf96b7c4) )
	ROM_LOAD16_BYTE( "95420891.hi", 0x00000, 0x080000, CRC(1cec5a68) SHA1(91485071a476ebf725daae9868e826a5bb45cb46) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420968.lo", 0x00001, 0x080000, CRC(c588de92) SHA1(18a4215f7bd5f8d4cf6a4b81654496d94d0949c3) )
	ROM_LOAD16_BYTE( "95420969.hi", 0x00000, 0x080000, CRC(49517bf0) SHA1(a62562377c362d227f5028f6607b8b924570f1fb) )
	ROM_LOAD16_BYTE( "95421890.lo", 0x00001, 0x080000, CRC(b2a0e9a0) SHA1(e771b3932f68d063592965d40dacd137029c669d) )
	ROM_LOAD16_BYTE( "95421891.hi", 0x00000, 0x080000, CRC(aae9e840) SHA1(a06e8328219eccd7c9c7169fcc49d32fd263d6b7) )
	ROM_LOAD16_BYTE( "95421968.lo", 0x00001, 0x080000, CRC(bd6d5125) SHA1(900ddd697279f5cd4c57a9a1827be9fb28c9bb5f) )
	ROM_LOAD16_BYTE( "95421969.hi", 0x00000, 0x080000, CRC(6fa7aaee) SHA1(fb0e9ccf68f7356eeb5b5db630701e25bd2ebed6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008865.bin", 0x0000, 0x0f4505, CRC(8e375291) SHA1(d7563adf330023f4fe47c11eb9ef77d593c3eaab) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890751.bin", 0x0000, 0x5000, CRC(57c944b0) SHA1(5f9aadffda6e83780e89c64315c8289a7d364ef6) )
ROM_END


ROM_START( sc_sus )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416732.lo", 0x00001, 0x080000, CRC(78bb861e) SHA1(ba80e658f04d8d24676155df0f89b478df9ddc11) )
	ROM_LOAD16_BYTE( "95416733.hi", 0x00000, 0x080000, CRC(a4a347d0) SHA1(7e9c0679fdaff59a7fe56c6a7ceedda2e0b56786) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416734.lo", 0x00001, 0x080000, CRC(063f8d39) SHA1(f24452a43863a4a546b587f5ca5a6bf5439a4646) )
	ROM_LOAD16_BYTE( "95416735.hi", 0x00000, 0x080000, CRC(2d37baeb) SHA1(5b4dc145f9a6b773d4adb98d76593218dd571465) )
	ROM_LOAD16_BYTE( "95416736.lo", 0x00001, 0x080000, CRC(f7666a31) SHA1(ce3ac0c27253ae6114f45111211ae0c8480ed5e3) )
	ROM_LOAD16_BYTE( "95416737.hi", 0x00000, 0x080000, CRC(c57a5865) SHA1(5d4b52ba10ff1fee90e27174a08923ea52d6ccb3) )
	ROM_LOAD16_BYTE( "95416798.lo", 0x00001, 0x080000, CRC(b0fe16d2) SHA1(fa10b63dba55c834a5facb0d624b1015fbe04c2e) )
	ROM_LOAD16_BYTE( "95416799.hi", 0x00000, 0x080000, CRC(eeb20d9c) SHA1(acc3ba10a2c9858f862ceca3ebe00512f2ce0088) )
	ROM_LOAD16_BYTE( "95416942.lo", 0x00001, 0x080000, CRC(2c83e6ae) SHA1(e72e92540e28d16a0ab5d195910617f4982b9254) )
	ROM_LOAD16_BYTE( "95416943.hi", 0x00000, 0x080000, CRC(42d9e362) SHA1(f23d3fb5c848cf91f9103cac26effea787ff467c) )
	ROM_LOAD16_BYTE( "95416944.lo", 0x00001, 0x080000, CRC(358420bf) SHA1(66ccfd25784a22353e59b6eea070ad0c08807a51) )
	ROM_LOAD16_BYTE( "95416945.hi", 0x00000, 0x080000, CRC(6bc624fb) SHA1(55c5951ca282fcc9552e6e396a4330fb0938fdba) )
	ROM_LOAD16_BYTE( "95417732.lo", 0x00001, 0x080000, CRC(b279d17c) SHA1(4f44ec13fde326ccc61a75827245267d82ea64e3) )
	ROM_LOAD16_BYTE( "95417733.hi", 0x00000, 0x080000, CRC(938e7b0d) SHA1(0b62020e57a972c54b2b5f204178089b3870daef) )
	ROM_LOAD16_BYTE( "95417734.lo", 0x00001, 0x080000, CRC(c2d76377) SHA1(a85f2dbbb108a77196923586c491549309f92d61) )
	ROM_LOAD16_BYTE( "95417735.hi", 0x00000, 0x080000, CRC(fd0466bd) SHA1(1d2098833bed139781cad58d4d5e45649cc0018f) )
	ROM_LOAD16_BYTE( "95417736.lo", 0x00001, 0x080000, CRC(6512d3fa) SHA1(d81fd18c79128e98a2ad60ace8bb0793a790471f) )
	ROM_LOAD16_BYTE( "95417737.hi", 0x00000, 0x080000, CRC(797ab456) SHA1(fb36d009dce251db38e54aa1801ee3e82a69cb76) )
	ROM_LOAD16_BYTE( "95417798.lo", 0x00001, 0x080000, CRC(013e9bb0) SHA1(002e444df92b1d9859510ad15e3b19780c18a147) )
	ROM_LOAD16_BYTE( "95417799.hi", 0x00000, 0x080000, CRC(74ac42ff) SHA1(af5242a5e44d77cedf8972212548781206ccf9e9) )
	ROM_LOAD16_BYTE( "95417942.lo", 0x00001, 0x080000, CRC(e2b601a1) SHA1(93c83935a62f1c9db120c2fde362b0be6f045780) )
	ROM_LOAD16_BYTE( "95417943.hi", 0x00000, 0x080000, CRC(85a5fe57) SHA1(9e2e67cb4f436429249183cea492612c40d6b0c5) )
	ROM_LOAD16_BYTE( "95417944.lo", 0x00001, 0x080000, CRC(d29bf31f) SHA1(60bd5c27bf124730fda61d70a90e429b06b35f1a) )
	ROM_LOAD16_BYTE( "95417945.hi", 0x00000, 0x080000, CRC(17aa310a) SHA1(05f37da89f0fbac3d103c6b5d8f0d82d16ef58fe) )
	ROM_LOAD16_BYTE( "95420060.lo", 0x00001, 0x080000, CRC(3fc36ff9) SHA1(090abdaf1419b0344660c6bb2c5aaf8a8e5e9647) )
	ROM_LOAD16_BYTE( "95420061.hi", 0x00000, 0x080000, CRC(52792164) SHA1(cad125aedc699de11abbc3584ea878e91eead78a) )
	ROM_LOAD16_BYTE( "95420062.lo", 0x00001, 0x080000, CRC(8cd3d9d1) SHA1(14cf332cf954214a94a3237e45c48e3f1a962f2d) )
	ROM_LOAD16_BYTE( "95420063.hi", 0x00000, 0x080000, CRC(c9d14375) SHA1(b4f87ef6837530cf83c541157d9b56f7c525c191) )
	ROM_LOAD16_BYTE( "95420126.lo", 0x00001, 0x080000, CRC(e3b01116) SHA1(35d793963a3f22319ee368cee7c5b9403ecba5a1) )
	ROM_LOAD16_BYTE( "95420127.hi", 0x00000, 0x080000, CRC(b0ba53e3) SHA1(968bb739443c4d4145c1f5dc9ce75bdf2a54c670) )
	ROM_LOAD16_BYTE( "95421060.lo", 0x00001, 0x080000, CRC(db3426ad) SHA1(3ba837042f4ede7556811379020c488d1b0b2cc1) )
	ROM_LOAD16_BYTE( "95421061.hi", 0x00000, 0x080000, CRC(b7013fc4) SHA1(b1c0e4c5581b64b4b3058c89368d963841622c34) )
	ROM_LOAD16_BYTE( "95421062.lo", 0x00001, 0x080000, CRC(925edae7) SHA1(bec77a12c7ff5ea34cfdc007ff7dfe600c3f746d) )
	ROM_LOAD16_BYTE( "95421063.hi", 0x00000, 0x080000, CRC(05269d0d) SHA1(48e8e9cc0220e98a66fda811ddbc8c6ebb26f56f) )
	ROM_LOAD16_BYTE( "95421126.lo", 0x00001, 0x080000, CRC(491c57d9) SHA1(c97c4866dead95064ac5a13ab61b279c67474d5d) )
	ROM_LOAD16_BYTE( "95421127.hi", 0x00000, 0x080000, CRC(7920ee8d) SHA1(2470c468973ed814c1114e88b45d950e82716767) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008960.bin", 0x0000, 0x0f4505, CRC(a3279a7d) SHA1(da3cc1f3c0b9301e9b4d9f5253cafa3a9385be56) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890413.bin", 0x0000, 0x5000, CRC(5cdcd7cc) SHA1(7eaf28a20ca68c7edda1ee0cb5efefd00831c024) )
	ROM_LOAD( "95890414.bin", 0x0000, 0x5000, CRC(294a93f8) SHA1(f81f4cdb1b7e9107835f54702772c4e5f18d9731) )
	ROM_LOAD( "95890415.bin", 0x0000, 0x5000, CRC(b7f05fa4) SHA1(4cfbb0c7752edc6a0df8f9b6ab77f3fb9cd8db8e) )
ROM_END


ROM_START( sc_s6c )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "club-super-6_dat_ac_250pnd_p65ss.hi", 0x00000, 0x080000, CRC(6a0d7c4a) SHA1(e2529e42d3942ead051632ff106749e6be72baaa) )
	ROM_LOAD16_BYTE( "club-super-6_dat_ac_250pnd_p65ss.lo", 0x00001, 0x080000, CRC(174d52ef) SHA1(c7bc96f2da4eb8b0d707fe7588e7262daa625e44) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "club-super-6_dat_ac_250pndss.hi", 0x00000, 0x080000, CRC(1df2874e) SHA1(f3bbcef21d387e0b2e83cb450f050ffd752671bc) )
	ROM_LOAD16_BYTE( "club-super-6_dat_ac_250pndss.lo", 0x00001, 0x080000, CRC(018015a6) SHA1(23a6ae78c2e5787eac98152325da114da8617a1e) )
	ROM_LOAD16_BYTE( "club-super-6_std_ac_250pnd_p65ss.hi", 0x00000, 0x080000, CRC(c3e39630) SHA1(cca733107bce7ea1391f03069bc9b8eaee9e1b4c) )
	ROM_LOAD16_BYTE( "club-super-6_std_ac_250pnd_p65ss.lo", 0x00001, 0x080000, CRC(06d1ef16) SHA1(533d245bca5382b9a30b7cf48d2e28b790ec8a69) )
	ROM_LOAD16_BYTE( "club-super-6_std_ac_250pndss.hi", 0x00000, 0x080000, CRC(b41c6d34) SHA1(1a64f14ccd57bd5957d653188da9391a9e965d6e) )
	ROM_LOAD16_BYTE( "club-super-6_std_ac_250pndss.lo", 0x00001, 0x080000, CRC(101ca85f) SHA1(d9b41c20e821d6af5e418b954328b7fbcdc3ef31) )
	ROM_LOAD16_BYTE( "s6217lo", 0x00001, 0x080000, CRC(ee72e713) SHA1(9ff3201808421fae2bbcab8f15a9b74ac7c6b153) )
	ROM_LOAD16_BYTE( "s6218hi", 0x0000, 0x080000, CRC(4a7709e9) SHA1(d9b8062604c9cb2720fbd6c018b14808ca85b9db) )
	ROM_LOAD16_BYTE( "super6hi", 0x0000, 0x080000, CRC(4ff2489c) SHA1(fedd80cbe9a48682a89bd0c36b4db20a494cdf13) )
	ROM_LOAD16_BYTE( "super6lo", 0x00001, 0x080000, CRC(d11b6a66) SHA1(fd2e647679f764be3b2c21e295f3f10645fef3ec) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004095.p1", 0x0000, 0x080000, CRC(d9d7b876) SHA1(fdd9b5f07665b7b7edd198e00d3b005b32d1609c) )
	ROM_LOAD( "95004096.p1", 0x0000, 0x080000, CRC(fb8e103f) SHA1(fd8e2c8ae1e459f7426aa6b5de20f91dfae7bec9) )
ROM_END


ROM_START( sc_sdr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400453.lo", 0x00001, 0x080000, CRC(3d8eb03c) SHA1(802b05db351004a999c1881e1d33cbc1af250041) )
	ROM_LOAD16_BYTE( "95400454.hi", 0x00000, 0x080000, CRC(15f51ee7) SHA1(079fe958f159b3af70039b2bcbfa5afe9ecffe53) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400665.lo", 0x00001, 0x080000, CRC(659950fe) SHA1(c435e45ff7c4dae3416b1c1e9332b35b55814c54) )
	ROM_LOAD16_BYTE( "95400666.hi", 0x00000, 0x080000, CRC(4e94bf2a) SHA1(5f1abae2a5fd5cd317698bb731f49b3887049aad) )
	ROM_LOAD16_BYTE( "95401453.lo", 0x00001, 0x080000, CRC(13622e8c) SHA1(7459caebdebe31c9504b682423452c450e0cac10) )
	ROM_LOAD16_BYTE( "95401454.hi", 0x00000, 0x080000, CRC(01fb42a4) SHA1(f2741aced5571342fb45bc6a8c55f0a968547b59) )
	ROM_LOAD16_BYTE( "95401665.lo", 0x00001, 0x080000, CRC(0660ec51) SHA1(ad61471e5a7879bc793a4f2bc70a2023947aeb31) )
	ROM_LOAD16_BYTE( "95401666.hi", 0x00000, 0x080000, CRC(2cf30c33) SHA1(b79a303dc45622156f70bd500a5aff88595e2de1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_sslam )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3081p00.hi", 0x00000, 0x080000, CRC(04ae62f9) SHA1(d3786f27c4647196c64bc521ea09ad7828205ebf) )
	ROM_LOAD16_BYTE( "p3081p00.lo", 0x00001, 0x080000, CRC(623a4eeb) SHA1(9e71edc28a4ca2f5df579ce2b769c7643525b4fc) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3081s00.hi", 0x00000, 0x080000, CRC(7d4eee54) SHA1(b9b2a0642eb286f5753a91d2f9184e609aaa8a2e) )
	ROM_LOAD16_BYTE( "p3081s00.lo", 0x00001, 0x080000, CRC(c11a0e2f) SHA1(f095698d49846445fd54a4ecd02a484ccd4ff40c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008731.bin", 0x0000, 0x100000, CRC(b6f92b76) SHA1(69be21d12940dc415816dd3c77f4eb2c1bd1a555) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211387.bin", 0x0000, 0x1000000, CRC(315c9b47) SHA1(75659d9888fdbc83cd2559e88d4c47c90309956f) )
	ROM_LOAD( "p3084p12.bin", 0x0000, 0x1000000, CRC(f08e517d) SHA1(dc6f622d025fabad8302735188757a6f645ad2e3) )
	ROM_LOAD( "p3084s11.bin", 0x0000, 0x1000000, CRC(d51a0816) SHA1(6ff1b486f29395d7f7fbe726c6c8bc185f145f93) )
	ROM_LOAD( "p3084s12.bin", 0x0000, 0x1000000, CRC(7d33e52d) SHA1(6591834c60103f71211449355c592473180c33d9) )
ROM_END


ROM_START( sc_sstep )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "96000126.odd", 0x00001, 0x080000, CRC(c7307b16) SHA1(67f920428cfd224e7c1b34ccfd336645e30b04f4) )
	ROM_LOAD16_BYTE( "96000127.evn", 0x00000, 0x080000, CRC(7a380957) SHA1(d800bb9341b216249fd3eae0e97f61da57f50efa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "96000128.odd", 0x00001, 0x080000, CRC(762681f6) SHA1(0a7756fa1a82efdec31b8f544e403aeaa3d13ee9) )
	ROM_LOAD16_BYTE( "96000129.evn", 0x00000, 0x080000, CRC(d3d3de05) SHA1(d786ce6a081a04c49096c126832e88c4b29d2d86) )
	ROM_LOAD16_BYTE( "96000144.odd", 0x00001, 0x080000, CRC(8e097545) SHA1(cefba0da599b690083631ab14afc617b588f5eea) )
	ROM_LOAD16_BYTE( "96000145.evn", 0x00000, 0x080000, CRC(f6577c93) SHA1(050080efe421e157b4bf19d9e150f096e9dfcd98) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "97000120.bin", 0x0000, 0x080000, CRC(d887ca0a) SHA1(b1fd4633ca47fe1d99c9938af48768cd0cf451c6) )
ROM_END


ROM_START( sc_supst )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416186.lo", 0x00001, 0x080000, CRC(030d89c3) SHA1(68fd5954d8983de6871bbd606f17f76099bc5f4e) )
	ROM_LOAD16_BYTE( "95416187.hi", 0x00000, 0x080000, CRC(cb7766f3) SHA1(5562d8ceb0ebea053d45698bc411a13eccea6e3c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417186.lo", 0x00001, 0x080000, CRC(c3fced7d) SHA1(6f13a1c2c1fab635b70c43f625c2caef977685e6) )
	ROM_LOAD16_BYTE( "95417187.hi", 0x00000, 0x080000, CRC(e5ec3755) SHA1(04ea1d3cf5ffa9b9b74d0bf849610e99373629f2) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_swbak )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416584.lo", 0x00001, 0x080000, CRC(6a391e3e) SHA1(2356f172565c73f9ee48b174831e39401770eabe) )
	ROM_LOAD16_BYTE( "95416585.hi", 0x00000, 0x080000, CRC(485bec6b) SHA1(1f591352d4d6a5a668ad69e49131e58d507edac3) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416586.lo", 0x00001, 0x080000, CRC(f8cf5af2) SHA1(f2d813c7b05ffd711edbe8164de33349d77c1ba5) )
	ROM_LOAD16_BYTE( "95416587.hi", 0x00000, 0x080000, CRC(b724ad4c) SHA1(72922fd1b23617d766e87b287fcbd1e8f0b76a69) )
	ROM_LOAD16_BYTE( "95416588.lo", 0x00001, 0x080000, CRC(9c007a4f) SHA1(31332a645230c717f1d9a9447c06e127978e8003) )
	ROM_LOAD16_BYTE( "95416589.hi", 0x00000, 0x080000, CRC(0e6ffd03) SHA1(78ac544888eea619b013d49b557f5bb8f394a649) )
	ROM_LOAD16_BYTE( "95417584.lo", 0x00001, 0x080000, CRC(7f77c234) SHA1(74f438838747e874fe5e5c568431c936cad6cf6c) )
	ROM_LOAD16_BYTE( "95417585.hi", 0x00000, 0x080000, CRC(ac32e805) SHA1(aed5dd9c7ce77686d8908b5d39f2527e8b037792) )
	ROM_LOAD16_BYTE( "95417586.lo", 0x00001, 0x080000, CRC(66c13a0e) SHA1(9c21be21e5f41ac15fedba52422c9e31cdeabb9a) )
	ROM_LOAD16_BYTE( "95417587.hi", 0x00000, 0x080000, CRC(53f242c2) SHA1(e4d46b6edabe2976d951314c4fe73b2f5cb3110b) )
	ROM_LOAD16_BYTE( "95417588.lo", 0x00001, 0x080000, CRC(fbf9abcd) SHA1(eb4dc4d0832b7b39d84e0b24b6bafa76c8fc2403) )
	ROM_LOAD16_BYTE( "95417589.hi", 0x00000, 0x080000, CRC(facb0515) SHA1(f54a8b509ea137ce67059075ce5052b643000284) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008929.bin", 0x0000, 0x0f973a, CRC(016f4cc0) SHA1(763c6bf389e0c1e83d903d7aec23ac1a53261e7c) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890368.bin", 0x0000, 0x5000, CRC(01900e28) SHA1(c3e86b917b48249bdf0f1072f0cf5fa4b749d834) )
	ROM_LOAD( "95890369.bin", 0x0000, 0x5000, CRC(74064a1c) SHA1(0c254916fd56026dfd0df2abb4dc1c0b2dff1a7d) )
	ROM_LOAD( "95890370.bin", 0x0000, 0x5000, CRC(eabc8640) SHA1(41a5f5530289672563210d3ef71eb896cf6b3d5d) )
ROM_END


ROM_START( sc_taekw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406628.odd", 0x00001, 0x080000, CRC(2bec7587) SHA1(606d0fab58d86cf089098e8668db99f4a0af63ca) )
	ROM_LOAD16_BYTE( "95406629.evn", 0x00000, 0x080000, CRC(b8357f6e) SHA1(54b5d4327b462f8945bc0dafa8200c3158e871fd) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407628.odd", 0x00001, 0x080000, CRC(c2c48ca1) SHA1(d324f18c8a86e12d48bb0f453d28bd657e575f9e) )
	ROM_LOAD16_BYTE( "95407629.evn", 0x00000, 0x080000, CRC(72828a7d) SHA1(8224773d5e07af109e949f8d976f714ecc96fcdd) )
	ROM_LOAD16_BYTE( "95409328.odd", 0x00001, 0x080000, CRC(49eaf56b) SHA1(50b15f22b21b48909d1ab0b3a048a3144808fb20) )
	ROM_LOAD16_BYTE( "95409329.evn", 0x00000, 0x080000, CRC(e3709b15) SHA1(74528076471f339cfe1a11dbfa5db3fe893f495d) )
	ROM_LOAD16_BYTE( "95410764.odd", 0x00001, 0x080000, CRC(9c832577) SHA1(53f4c063f518e7e47ee2a62b4e12276905c0a856) )
	ROM_LOAD16_BYTE( "95410765.evn", 0x00000, 0x080000, CRC(b4773b41) SHA1(06a800bdf5717b8a1d87d494fa8fc86627c01917) )
	ROM_LOAD16_BYTE( "95410766.odd", 0x00001, 0x080000, CRC(4b465873) SHA1(2a5fc9c240b709482197e90c283bc10c5a3bedd4) )
	ROM_LOAD16_BYTE( "95410767.evn", 0x00000, 0x080000, CRC(a360986c) SHA1(f855b6065bf1832a8a6bd70de606f42a8b9fd91a) )
	ROM_LOAD16_BYTE( "95411764.odd", 0x00001, 0x080000, CRC(ee13bef8) SHA1(b54577e1eacf051e74d61dd675b740f888364a1d) )
	ROM_LOAD16_BYTE( "95411765.evn", 0x00000, 0x080000, CRC(3cdbe9f4) SHA1(377ae83afb4fa203e51028754856aaf93521f0fe) )
	ROM_LOAD16_BYTE( "95411766.odd", 0x00001, 0x080000, CRC(6140dd05) SHA1(3dd1d50f4cbc1a6ac684da3d7646fa4a3d39e908) )
	ROM_LOAD16_BYTE( "95411767.evn", 0x00000, 0x080000, CRC(8f19c712) SHA1(8f39d589a8841626177a6613ae7afdc680681f26) )
	ROM_LOAD16_BYTE( "95414300.odd", 0x00001, 0x080000, CRC(e46fa6f8) SHA1(6a3c5547fc011a5168eca205697c5fe0810aca6a) )
	ROM_LOAD16_BYTE( "95414301.evn", 0x00000, 0x080000, CRC(1737b892) SHA1(e641cea174c130003435b9b1a13740195d09ec3d) )
	ROM_LOAD16_BYTE( "95414302.odd", 0x00001, 0x080000, CRC(095e61ff) SHA1(6d6340b595047f9eebe9e025092da9b7fbbe0c1a) )
	ROM_LOAD16_BYTE( "95414303.evn", 0x00000, 0x080000, CRC(8bb752bb) SHA1(b06e9949ec8c1374202fcd1116b5535f90198d29) )
	ROM_LOAD16_BYTE( "95415300.odd", 0x00001, 0x080000, CRC(a197c77b) SHA1(fdb1df9647b6409ad477c33088c7bad82ac96530) )
	ROM_LOAD16_BYTE( "95415301.evn", 0x00000, 0x080000, CRC(2f40bbaf) SHA1(ab14d5e5eef0c225bfdfeea9e4939b8d0ed5a1a1) )
	ROM_LOAD16_BYTE( "95415302.odd", 0x00001, 0x080000, CRC(4ca6007c) SHA1(1445aed62119258874f19b8b1113171c9bed9d1c) )
	ROM_LOAD16_BYTE( "95415303.evn", 0x00000, 0x080000, CRC(b3c05186) SHA1(cb442b1e2e51cde3fc705c02da2f6a57e2d3816e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008283.bin", 0x0000, 0x0fd772, CRC(59a3924c) SHA1(ceba9236db0b26eb79feabc9564eb6dec10c4ab9) )
ROM_END


ROM_START( sc_taknt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406760.lo", 0x00001, 0x080000, CRC(54952a27) SHA1(a2f80249cecd0129dae67ee1b99d90e51ce79db6) )
	ROM_LOAD16_BYTE( "95406761.hi", 0x00000, 0x080000, CRC(9b87e3d0) SHA1(ae1cee519938828eef3c97a04c7b6080e9f13f49) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407760.lo", 0x00001, 0x080000, CRC(d873b140) SHA1(aedc72d2804ebf1cc4fb04c54ffc1fba1e192363) )
	ROM_LOAD16_BYTE( "95407761.hi", 0x00000, 0x080000, CRC(73e60179) SHA1(9c0913b8a9dba5794a01bdcb02b15cdde976da26) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008273.bin", 0x0000, 0x100000, CRC(c8695859) SHA1(5998d1f3467e522d4fa5ad6cf75b86ae1760fdd6) )
ROM_END


ROM_START( sc_takcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408062.lo", 0x00001, 0x080000, CRC(bb70c78a) SHA1(187409c94b89b3990e464beef0a78d1c7fe6038d) )
	ROM_LOAD16_BYTE( "95408063.hi", 0x00000, 0x080000, CRC(7f85a7bd) SHA1(5355d2ac07790796379f376ff334d0c17cc913f6) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408190.lo", 0x00001, 0x080000, CRC(64f7f871) SHA1(96174a64b2d049b1792ae61596c1cf0826daa296) )
	ROM_LOAD16_BYTE( "95408191.hi", 0x00000, 0x080000, CRC(0ac54f9f) SHA1(342c2e0663bec2ff3bbb0f411595766a5e5a1d84) )
	ROM_LOAD16_BYTE( "95408192.lo", 0x00001, 0x080000, CRC(aa7275f1) SHA1(8dd3acbd0e60b6eb7c81030c4639b5671a5c1932) )
	ROM_LOAD16_BYTE( "95408193.hi", 0x00000, 0x080000, CRC(237c9b8f) SHA1(c8e06a8a01754651888a5ae37e40108e5fd74f4e) )
	ROM_LOAD16_BYTE( "95408216.lo", 0x00001, 0x080000, CRC(e375e8bc) SHA1(9022511264ba3c4eaf6ed4a5ff76ea23ba6bbd83) )
	ROM_LOAD16_BYTE( "95408217.hi", 0x00000, 0x080000, CRC(111fa110) SHA1(61061fb4e487f79806499edcaa7b8d0e47c5858e) )
	ROM_LOAD16_BYTE( "95409062.lo", 0x00001, 0x080000, CRC(e37d3f32) SHA1(db8a9c03312367899f260380a40d621d151c6897) )
	ROM_LOAD16_BYTE( "95409063.hi", 0x00000, 0x080000, CRC(69f6a31e) SHA1(09184ac75cd6e01f04517d71d54b8fc7646aa98d) )
	ROM_LOAD16_BYTE( "95409192.lo", 0x00001, 0x080000, CRC(00202d5f) SHA1(c84bbf956fa711765575a69a29454952455bd0ad) )
	ROM_LOAD16_BYTE( "95409193.hi", 0x00000, 0x080000, CRC(c7503f3a) SHA1(00a3bb77f590f87ac28e7a64f7e329b30ee45b3a) )
	ROM_LOAD16_BYTE( "95409216.lo", 0x00001, 0x080000, CRC(2741fd41) SHA1(40a8e44096fd023acbc0e8d88cbb111f7d0b1c74) )
	ROM_LOAD16_BYTE( "95409217.hi", 0x00000, 0x080000, CRC(a70084d3) SHA1(40de10c882948e379823afb088453ab423697feb) )
	ROM_LOAD16_BYTE( "95412196.lo", 0x00001, 0x080000, CRC(32082a2c) SHA1(04e8832f8e0786b7308ef047fe82b19eb34a944b) )
	ROM_LOAD16_BYTE( "95412197.hi", 0x00000, 0x080000, CRC(24260e5d) SHA1(5b68817b3a20e542a827284847204fc9b028d27f) )
	ROM_LOAD16_BYTE( "95413196.lo", 0x00001, 0x080000, CRC(44d33d52) SHA1(468d2e34c636233b80ded6fad1d0c21ddd0326a0) )
	ROM_LOAD16_BYTE( "95413197.hi", 0x00000, 0x080000, CRC(336ba68e) SHA1(961690dbe9321ab6ac3f4d7445e09d84acbfe3b4) )
	ROM_LOAD16_BYTE( "p1323p11.hi", 0x00000, 0x080000, CRC(957b4bfe) SHA1(9e862d7e2b9fa4ff2b65375706d65abffabbaff1) )
	ROM_LOAD16_BYTE( "p1323p11.lo", 0x00001, 0x080000, CRC(e7fccbef) SHA1(cbde295fc4049004a59d803457a2fdf8566fafe9) )
	ROM_LOAD16_BYTE( "p1323s11.hi", 0x00000, 0x080000, CRC(c1d0ae13) SHA1(64427a39b674b48889f7db18213cb8736056e579) )
	ROM_LOAD16_BYTE( "p1323s11.lo", 0x00001, 0x080000, CRC(8a5a3f35) SHA1(4fd85f1be400e401b48f8a0ad621f1d6f314ce8b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008314.bin", 0x0000, 0x100000, CRC(64d2a26a) SHA1(f01944363e77bf33b44a06224e44828b065fdee4) )
ROM_END


ROM_START( sc_ttpie )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418244.lo", 0x00001, 0x080000, CRC(7af562cd) SHA1(2e1e6d388baff84da4ab61b465a4c7dad99bef08) )
	ROM_LOAD16_BYTE( "95418245.hi", 0x00000, 0x080000, CRC(0939fed1) SHA1(614df000cc8153cd724f56079af2d88af0716221) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418282.lo", 0x00001, 0x080000, CRC(e88a7afe) SHA1(c478af44d2980e48c9642c3e98354141a596e617) )
	ROM_LOAD16_BYTE( "95418283.hi", 0x00000, 0x080000, CRC(31f34712) SHA1(0f3c0660957adf4f304f027c85b27005c259ffb1) )
	ROM_LOAD16_BYTE( "95418484.lo", 0x00001, 0x080000, CRC(55001073) SHA1(cf81787d83004eecec27a4543fbc0b8f20d28fd8) )
	ROM_LOAD16_BYTE( "95418485.hi", 0x00000, 0x080000, CRC(943aee32) SHA1(d07d05a0b4a6a8688428a83174b9def2db96095e) )
	ROM_LOAD16_BYTE( "95418486.lo", 0x00001, 0x080000, CRC(2f0ca4a3) SHA1(77d6a4702b6c6f13e6297ed715e1b6ed0586659c) )
	ROM_LOAD16_BYTE( "95418487.hi", 0x00000, 0x080000, CRC(eb426c2e) SHA1(58fe6c6fd145f93bb3097505401e08012eada6b8) )
	ROM_LOAD16_BYTE( "95418670.lo", 0x00001, 0x080000, CRC(8ca1c291) SHA1(2f9ad8a5f4533327c828eb441f408a98ad86794d) )
	ROM_LOAD16_BYTE( "95418671.hi", 0x00000, 0x080000, CRC(bab3dbde) SHA1(da3a589c45d529eb328ba051f8fcf92bbae01023) )
	ROM_LOAD16_BYTE( "95418672.lo", 0x00001, 0x080000, CRC(42a53e2d) SHA1(9d1b775f79b9e7f0f8fb14b80aefeb106cccd6af) )
	ROM_LOAD16_BYTE( "95418673.hi", 0x00000, 0x080000, CRC(dde604bf) SHA1(9d0af3886ef491945357ea8a5bac68121bf954b5) )
	ROM_LOAD16_BYTE( "95419244.lo", 0x00001, 0x080000, CRC(cbeabf23) SHA1(450313719011d3c9063fa8449e86d8fbf641979d) )
	ROM_LOAD16_BYTE( "95419245.hi", 0x00000, 0x080000, CRC(3cd01968) SHA1(cd0d3ad190541e1f8806daf5a8c7b71def406bec) )
	ROM_LOAD16_BYTE( "95419282.lo", 0x00001, 0x080000, CRC(558d912f) SHA1(c5e6fed235ac7616e56f6fb4a161148943569a61) )
	ROM_LOAD16_BYTE( "95419283.hi", 0x00000, 0x080000, CRC(e7835704) SHA1(fa2769cb248df57b60f3849261c91e4cd7fc9cf5) )
	ROM_LOAD16_BYTE( "95419484.lo", 0x00001, 0x080000, CRC(912fed2e) SHA1(c7efc626e19cd0253c4dc7117a3346e36b6de8f9) )
	ROM_LOAD16_BYTE( "95419485.hi", 0x00000, 0x080000, CRC(8e4c2150) SHA1(72ee84d6d6a01475d29ab8b1380d7a7d2272b609) )
	ROM_LOAD16_BYTE( "95419486.lo", 0x00001, 0x080000, CRC(cb60a8c6) SHA1(aa6750558076370726d0edc768f25490f3cdd051) )
	ROM_LOAD16_BYTE( "95419487.hi", 0x00000, 0x080000, CRC(be14e35b) SHA1(f55119b0ed555a8ef3a8e06ac49c8a7333df53a7) )
	ROM_LOAD16_BYTE( "95419670.lo", 0x00001, 0x080000, CRC(c38bf8c9) SHA1(bc3125e754208e90578433ca6c6982443c98482d) )
	ROM_LOAD16_BYTE( "95419671.hi", 0x00000, 0x080000, CRC(6890ef77) SHA1(2e7d13a2e511f991faa1c1a34913927f7e64df50) )
	ROM_LOAD16_BYTE( "95419672.lo", 0x00001, 0x080000, CRC(99a5a2bc) SHA1(d0664bdcc5a66cf95256c5f896d31a8c3aed2217) )
	ROM_LOAD16_BYTE( "95419673.hi", 0x00000, 0x080000, CRC(57a8d8d2) SHA1(b1a32590cbe29552f047b52de66b57da8d4655cd) )
	ROM_LOAD16_BYTE( "95422029.hi", 0x00000, 0x080000, CRC(d53e86be) SHA1(72f1b6b21f284b27bd63fcea90826a88c6b16bef) )
	ROM_LOAD16_BYTE( "95422032.lo", 0x00001, 0x080000, CRC(c5ae746d) SHA1(c66d5ed13934953507a8fed1d733b5062fc77b98) )
	ROM_LOAD16_BYTE( "95422033.hi", 0x00000, 0x080000, CRC(24ca3563) SHA1(8b1c822c44fb65186bdd5004b9de7e98a048f13f) )
	ROM_LOAD16_BYTE( "95422034.lo", 0x00001, 0x080000, CRC(1951dbd0) SHA1(d89fe65d272290c871e127ab17d2e03d0eb7a6e2) )
	ROM_LOAD16_BYTE( "95422970.lo", 0x00001, 0x080000, CRC(32b28b53) SHA1(ad9999f28239296a470d1120335415ac3d8e84d3) )
	ROM_LOAD16_BYTE( "95422971.hi", 0x00000, 0x080000, CRC(b8a184f6) SHA1(122443d162f287dbc4da893f370a9cbffba00280) )
	ROM_LOAD16_BYTE( "95423029.hi", 0x00000, 0x080000, CRC(29828640) SHA1(a90ae840318f4ea3d662645735a352d0e7382b6b) )
	ROM_LOAD16_BYTE( "95423032.lo", 0x00001, 0x080000, CRC(58f16ef9) SHA1(2e50650c3863c11eb606869c0b402192e8e412b4) )
	ROM_LOAD16_BYTE( "95423033.hi", 0x00000, 0x080000, CRC(fe9c70dc) SHA1(98cc409fc0753be3ab23c2986e92a96413471dd1) )
	ROM_LOAD16_BYTE( "95423034.lo", 0x00001, 0x080000, CRC(c5c161e9) SHA1(6a2f0b6c0c2db66957b1cc26f1c35273224c24f4) )
	ROM_LOAD16_BYTE( "95423970.lo", 0x00001, 0x080000, CRC(522a5e74) SHA1(7365f414f1c907f71322649474d77a69e211413f) )
	ROM_LOAD16_BYTE( "95423971.hi", 0x00000, 0x080000, CRC(0db07610) SHA1(9ef0e66301a63c756bc212daabb49718fdbf3c3a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008579.bin", 0x0000, 0x100000, CRC(b3741823) SHA1(77890bf89b848fa2222e885aeb51f05f033143ba) )
ROM_END


ROM_START( sc_ttp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400569.lo", 0x00001, 0x080000, CRC(b862aba4) SHA1(68c9cd5c05bdc73ea455ecb320760f4b27f70f36) )
	ROM_LOAD16_BYTE( "95400570.hi", 0x00000, 0x080000, CRC(dbd9166f) SHA1(a7690f7f87257daa329fd35a96602fdd38b5c9c7) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400573.lo", 0x00001, 0x080000, CRC(471e1036) SHA1(4058d341620dc4012a22c1f7a3e804f46ee71f5a) )
	ROM_LOAD16_BYTE( "95400574.hi", 0x00000, 0x080000, CRC(53ec8d50) SHA1(69ef502406b5770ed6d3722a2d48be3f02c047a4) )
	ROM_LOAD16_BYTE( "95400581.lo", 0x00001, 0x080000, CRC(0f14ac4b) SHA1(e02c5474cf236507d4ef980123039c9b125b1171) )
	ROM_LOAD16_BYTE( "95400582.hi", 0x00000, 0x080000, CRC(529fbaad) SHA1(9807f06e202ba5d83432cbcb2ac1ec51f69b60cd) )
	ROM_LOAD16_BYTE( "95401569.lo", 0x00001, 0x080000, CRC(512ca74f) SHA1(d4feb496033db25941f25b5fd2d3aa7d0ea949d5) )
	ROM_LOAD16_BYTE( "95401570.hi", 0x00000, 0x080000, CRC(311277c3) SHA1(43ce32bd16c81862cc65e008ce0f36d354e88ed5) )
	ROM_LOAD16_BYTE( "95401571.lo", 0x00001, 0x080000, CRC(eccd6a24) SHA1(bca44c81b6eebe0d2ae308f1adde34b6670876cc) )
	ROM_LOAD16_BYTE( "95401572.hi", 0x00000, 0x080000, CRC(47e235f0) SHA1(90ea66e3b44519d456730fb8094c6963c13f8e3f) )
	ROM_LOAD16_BYTE( "95401581.lo", 0x00001, 0x080000, CRC(47962069) SHA1(e050947f32a18d0a8a21d7eeabb24ed4cf978b6d) )
	ROM_LOAD16_BYTE( "95401582.hi", 0x00000, 0x080000, CRC(51431805) SHA1(aca3b8431f2eb4eba447b38056171fa15f071799) )
	ROM_LOAD16_BYTE( "95401585.lo", 0x00001, 0x080000, CRC(fab5c9f2) SHA1(347d250fbc4a8d793ccaa0c3e805a8d67b9629db) )
	ROM_LOAD16_BYTE( "95401586.hi", 0x00000, 0x080000, CRC(feba871e) SHA1(e4d3b3bdb90dee9f5eeeedb7e5febd71eefb4e12) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004148.bin", 0x0000, 0x080000, CRC(6b352d5b) SHA1(b32f08828aad1c8cf0281faa387c9a1536fbd382) )
ROM_END


ROM_START( sc_typ )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3001p41.hi", 0x00000, 0x080000, CRC(e2748f7f) SHA1(895f441cc3019fa52a226e428e449f78d2bf78b8) )
	ROM_LOAD16_BYTE( "p3001p41.lo", 0x00001, 0x080000, CRC(bb208986) SHA1(44f98d8c37ef2d7a22f93ed5a62ac7c3cbe9c258) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3001p42.hi", 0x00000, 0x080000, CRC(8b3e94f4) SHA1(4bfc1b5179af439aa1370ba202eb7eb2bb9375e7) )
	ROM_LOAD16_BYTE( "p3001p42.lo", 0x00001, 0x080000, CRC(8fb76c4c) SHA1(f5486b934d83460787075973281a23beb83f101b) )
	ROM_LOAD16_BYTE( "p3001s41.hi", 0x00000, 0x080000, CRC(791a5b14) SHA1(8fd9da104ae6b95e4c651bd164f3b421f85c4050) )
	ROM_LOAD16_BYTE( "p3001s41.lo", 0x00001, 0x080000, CRC(0d6eabd8) SHA1(83773fb597bc994a442fc5317bd81a0565816a7d) )
	ROM_LOAD16_BYTE( "p3001s42.hi", 0x00000, 0x080000, CRC(7314531f) SHA1(6d5f9becd5e0ca11cd37b018ccac4ec196c0cfb5) )
	ROM_LOAD16_BYTE( "p3001s42.lo", 0x00001, 0x080000, CRC(16ad6b11) SHA1(f24ac0fe97ea1f6f36a6ca75e602d819e50489ab) )
	ROM_LOAD16_BYTE( "p3031p42.hi", 0x00000, 0x080000, CRC(90422595) SHA1(3f619bf0e41c5be4db1c8ca6d7f1cb979f594350) )
	ROM_LOAD16_BYTE( "p3031p42.lo", 0x00001, 0x080000, CRC(29b9543e) SHA1(c25f16db87389c96b74430f65fd0e4a1aebb1e6d) )
	ROM_LOAD16_BYTE( "p3031p43.hi", 0x00000, 0x080000, CRC(80d5f625) SHA1(f0a6e99eae79421c783dfe3350dd0cb53fb05e24) )
	ROM_LOAD16_BYTE( "p3031p43.lo", 0x00001, 0x080000, CRC(4b65a0f2) SHA1(4e0eab56f674707d2698042a3f57b2d1e72dd69f) )
	ROM_LOAD16_BYTE( "p3031s42.hi", 0x00000, 0x080000, CRC(74ca573a) SHA1(123190e08a9f40d9081ba9b1d0733e750e351734) )
	ROM_LOAD16_BYTE( "p3031s42.lo", 0x00001, 0x080000, CRC(7a595068) SHA1(d8219205bcee2129fc821f2f472882758b4b2fbd) )
	ROM_LOAD16_BYTE( "p3031s43.hi", 0x00000, 0x080000, CRC(4a3ff790) SHA1(3d506a3a131c0d50cd93f650db6589cc152da7cf) )
	ROM_LOAD16_BYTE( "p3031s43.lo", 0x00001, 0x080000, CRC(a819d070) SHA1(f495deba11ee663571fa5aafd3bae1f62dccedf8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008662.bin", 0x0000, 0x100000, CRC(51959c94) SHA1(8a4b68460da4223071e33158747ae0ea18b83a52) )
	ROM_LOAD( "95008663.bin", 0x0000, 0x100000, CRC(839687b2) SHA1(a9fd3645eb903cb52b348dd8313f0d953d5a5ec0) )
ROM_END


ROM_START( sc_tempt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402638.lo", 0x00001, 0x080000, CRC(f857ccfd) SHA1(bbef92c4682a9a491dcdb82569ca84e7dc2b95ee) )
	ROM_LOAD16_BYTE( "95402639.hi", 0x00000, 0x080000, CRC(97fef5fb) SHA1(dde5375e864d6b84abf67c698bfa1443594b7caa) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402640.lo", 0x00001, 0x080000, CRC(af1b6f7d) SHA1(3ded3642bb5209267d68188f7718312db3d9d351) )
	ROM_LOAD16_BYTE( "95402641.hi", 0x00000, 0x080000, CRC(4e30a12b) SHA1(0d2cbe6c3e5cd92758b5c840ae3c61f558276c38) )
	ROM_LOAD16_BYTE( "95403638.lo", 0x00001, 0x080000, CRC(6d10d513) SHA1(5bbce9d10d547bba4a2639bb57d8f4ffe546f01c) )
	ROM_LOAD16_BYTE( "95403639.hi", 0x00000, 0x080000, CRC(12f616c7) SHA1(04dbe7d7c0649878718214fab945a4dca3a4a3be) )
	ROM_LOAD16_BYTE( "95403640.lo", 0x00001, 0x080000, CRC(8d9c0c0d) SHA1(e9d7ce40e0a8c84d128a59fbddcb792e6d8206a9) )
	ROM_LOAD16_BYTE( "95403641.hi", 0x00000, 0x080000, CRC(20cd8fcb) SHA1(6388c3a2f267c6d16f74ebef9f86c86971c90abd) )
	ROM_LOAD16_BYTE( "95406062.lo", 0x00001, 0x080000, CRC(902622d4) SHA1(414814fb077a452873c9db0c37b66d6f20cb211b) )
	ROM_LOAD16_BYTE( "95406063.hi", 0x00000, 0x080000, CRC(7a8ec2b0) SHA1(0c7ccfdba6365c4f49ea569a2485f7b42a16dedf) )
	ROM_LOAD16_BYTE( "95406932.lo", 0x00001, 0x080000, CRC(a4dca430) SHA1(7de4040493bf595ecc01fd308b3a4efd46d36c75) )
	ROM_LOAD16_BYTE( "95406933.hi", 0x00000, 0x080000, CRC(93a734e4) SHA1(2312f33b2d84ebe0af1a76423b6394d617cdf703) )
	ROM_LOAD16_BYTE( "95407062.lo", 0x00001, 0x080000, CRC(35a32fd4) SHA1(8af600c67b1ec21a127077cf5f50752bc788592d) )
	ROM_LOAD16_BYTE( "95407063.hi", 0x00000, 0x080000, CRC(426697b5) SHA1(a8dfd5b1a4404b5a123a2b1ca075623978490058) )
	ROM_LOAD16_BYTE( "95407932.lo", 0x00001, 0x080000, CRC(42445fdd) SHA1(b9b133d183cb4104b493b9ef4535ad54ded95ba8) )
	ROM_LOAD16_BYTE( "95407933.hi", 0x00000, 0x080000, CRC(c5dfc2a2) SHA1(37f302fbaf2b658371545caff6f0b2ebe6228d00) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008654.bin", 0x0000, 0x100000, CRC(9963724c) SHA1(90d22b11934e95fd2bfda026dcde51dcd74f93cc) )
	ROM_LOAD( "95008655.bin", 0x0000, 0x100000, CRC(12735319) SHA1(166fbcc5828fd26ace63eed127427cbd0c81570d) )
ROM_END


ROM_START( sc_tetri )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402427.lo", 0x00001, 0x080000, CRC(62395361) SHA1(aab5bd825d8070dbe04c224189caa2285d478b30) )
	ROM_LOAD16_BYTE( "95402428.hi", 0x00000, 0x080000, CRC(871c2de1) SHA1(d0d01cb72d9a34b325748d9fc96e2bc4c7ccc801) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402666.lo", 0x00001, 0x080000, CRC(a0ae1eb6) SHA1(eae2364fdaecd816216f191e3829f056878b1d54) )
	ROM_LOAD16_BYTE( "95402667.hi", 0x00000, 0x080000, CRC(b433a747) SHA1(8d458b4f8d04d39b45ec818de93dc9fdfcf64af2) )
	ROM_LOAD16_BYTE( "95402718.lo", 0x00001, 0x080000, CRC(7558a203) SHA1(ef5ccf3d5299a9d01c009dc91c888a598bc73d33) )
	ROM_LOAD16_BYTE( "95402719.hi", 0x00000, 0x080000, CRC(73d9b634) SHA1(e2ea94b645fd0d542a3d7ac0968a226a91aa5cea) )
	ROM_LOAD16_BYTE( "95402776.lo", 0x00001, 0x080000, CRC(5485c0af) SHA1(080e37acd6dc6fe54e25872d19749a902cc4d22e) )
	ROM_LOAD16_BYTE( "95402777.hi", 0x00000, 0x080000, CRC(88edd93d) SHA1(729ed52e1bded9b189388387a7ccb263250bebfa) )
	ROM_LOAD16_BYTE( "95403427.lo", 0x00001, 0x080000, CRC(e1520224) SHA1(ba4da04b3caa4ce7733c12d59c0b831d253a56d5) )
	ROM_LOAD16_BYTE( "95403428.hi", 0x00000, 0x080000, CRC(c8a33bce) SHA1(e21a1c42e9d5ff91c2e003ab99799930aa404f2c) )
	ROM_LOAD16_BYTE( "95403666_lo.bin", 0x0000, 0x080000, CRC(2e177c3b) SHA1(66b58e3292eac398b10459a33063457c6629e86e) )
	ROM_LOAD16_BYTE( "95403667_hi.bin", 0x0000, 0x080000, CRC(61a8baa2) SHA1(5a74e357fee5575e92c33e0a353a45f63b98c26d) )
	ROM_LOAD16_BYTE( "95403772lo", 0x00001, 0x080000, CRC(61e52bae) SHA1(dc5701068d849f2b83eef488c5972aa977e0cefc) )
	ROM_LOAD16_BYTE( "95403773hi", 0x0000, 0x080000, CRC(135d2457) SHA1(112b71f6a8b5013db42b3b75b8b11eed0f3d9764) )
	ROM_LOAD16_BYTE( "95403774.lo", 0x00001, 0x080000, CRC(f37ba971) SHA1(6b28f592722592eeae15facc598c2f580321f351) )
	ROM_LOAD16_BYTE( "95403775.hi", 0x00000, 0x080000, CRC(864280e8) SHA1(b513c70254c179131ba84a0f8e863e36440ec8ea) )
	ROM_LOAD16_BYTE( "95404382.lo", 0x00001, 0x080000, CRC(f17456cb) SHA1(37af77ee1d2016aa730c6dc34a33295a3a3e46ab) )
	ROM_LOAD16_BYTE( "95404383.hi", 0x00000, 0x080000, CRC(ff1c5391) SHA1(a09d97c1f3fcdcfc253e0e91874eda226f6dd5ba) )
	ROM_LOAD16_BYTE( "95405382.lo", 0x00001, 0x080000, CRC(7a132018) SHA1(a5fa629df3a41e49d5a5ed82da2758bb4fc2470b) )
	ROM_LOAD16_BYTE( "95405383.hi", 0x00000, 0x080000, CRC(03a4369e) SHA1(6c963cdd16207663605edc854c11b4d4cf77ff94) )
	ROM_LOAD16_BYTE( "95406156.lo", 0x00001, 0x080000, CRC(573e0679) SHA1(5baa0d8ae514e5c7d3aa52107368226e324d521c) )
	ROM_LOAD16_BYTE( "95406157.hi", 0x00000, 0x080000, CRC(e8c90675) SHA1(86e8631040e40fbf003fcc7ecb7bd68239f023c9) )
	ROM_LOAD16_BYTE( "95407156.lo", 0x00001, 0x080000, CRC(c938c7a0) SHA1(3f4e1f5f24b4a23116f6b84b95831d2028b55296) )
	ROM_LOAD16_BYTE( "95407157.hi", 0x00000, 0x080000, CRC(36eff91d) SHA1(9dbb86fbaa43348e42d12aa6732c6d9881029ddc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008097_1.bin", 0x0000, 0x100000, CRC(01a251eb) SHA1(0cb63736065b97956f02710867ac11609b1f282c) )
	ROM_LOAD( "95008098_2.bin", 0x0000, 0x100000, CRC(5ebcfd20) SHA1(be415d965732b3fde47684dacdfe93711182faf4) )
ROM_END


ROM_START( sc_lions )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400421.lo", 0x00001, 0x080000, CRC(3caa5aa3) SHA1(e85f8b61a5d2424cf43bf14a3548ada41f585c34) )
	ROM_LOAD16_BYTE( "95400422.hi", 0x00000, 0x080000, CRC(8135ffc1) SHA1(71c686ff116a0fb0da196025c519e59caa8d7539) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400431.lo", 0x00001, 0x080000, CRC(9f51e8d7) SHA1(aaf09fb80852803016851390fa3b095b02cb8609) )
	ROM_LOAD16_BYTE( "95400432.hi", 0x00000, 0x080000, CRC(2b07b713) SHA1(222fb6c2b48484694e1d0c853fdc0e5ff36bfb47) )
	ROM_LOAD16_BYTE( "95400597.lo", 0x00001, 0x080000, CRC(8a1ef3f6) SHA1(0a76135465f7d571780fb9e4e096350f29889918) )
	ROM_LOAD16_BYTE( "95400598.hi", 0x00000, 0x080000, CRC(3ad50b6a) SHA1(caae3c7397fabea264238f29c7c85a4d25fa81f9) )
	ROM_LOAD16_BYTE( "95401421.lo", 0x00001, 0x080000, CRC(f9f4b4f2) SHA1(ccd165d94d9b30b122a8950235e30191c7193ec2) )
	ROM_LOAD16_BYTE( "95401422.hi", 0x00000, 0x080000, CRC(b69b9595) SHA1(e3ccb82b12f1122a5df663a644975d192b9bc3cb) )
	ROM_LOAD16_BYTE( "95401423.lo", 0x00001, 0x080000, CRC(26c0cce6) SHA1(9bd74003c570a61163cc2e09929f4907cfb26144) )
	ROM_LOAD16_BYTE( "95401424.hi", 0x00000, 0x080000, CRC(bd8798ea) SHA1(c6970dddb699ece8f94303b770374e3b6b529e12) )
	ROM_LOAD16_BYTE( "95401431.lo", 0x00001, 0x080000, CRC(5a0f0686) SHA1(e994e68a8912b37d3b84724c65713b4193ae04bf) )
	ROM_LOAD16_BYTE( "95401432.hi", 0x00000, 0x080000, CRC(1ca9dd47) SHA1(9eee1ee86a7358b691e675c538f8ac20517484c0) )
	ROM_LOAD16_BYTE( "95401597.lo", 0x00001, 0x080000, CRC(5f9b800c) SHA1(f50477c702913af9debccf44b9d9c3f97c4e7cb1) )
	ROM_LOAD16_BYTE( "95401598.hi", 0x00000, 0x080000, CRC(894d2e72) SHA1(50a0af7d7a1f21e76ecea9174b74dff05a7e9cb5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004142.bin", 0x0000, 0x080000, CRC(aee399f7) SHA1(54c9683f2f3159122ef35855fe19380f1a2771ca) )
ROM_END


ROM_START( sc_tic2 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402644.lo", 0x00001, 0x080000, CRC(5f7e15ee) SHA1(640928d71ce75c447ce4453b7f84c1723aeee41e) )
	ROM_LOAD16_BYTE( "95402645.hi", 0x00000, 0x080000, CRC(3579696d) SHA1(44439ae8fa5c20db1f24657661b6303c42f91709) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402646.lo", 0x00001, 0x080000, CRC(87389e10) SHA1(2bff29fde2e73426f01c854caa5899a1db196a84) )
	ROM_LOAD16_BYTE( "95402647.hi", 0x00000, 0x080000, CRC(f6cf7e5c) SHA1(1fc223388e5d94bd4e92740c68a668b92a939917) )
	ROM_LOAD16_BYTE( "95402672.lo", 0x00001, 0x080000, CRC(49af7863) SHA1(b58eecc60afa4f4937dc04d7c3600af200bdbf29) )
	ROM_LOAD16_BYTE( "95402673.hi", 0x00000, 0x080000, CRC(a5823498) SHA1(5200b3af9cbeb4ab110ee4690d5a8bafb8c83387) )
	ROM_LOAD16_BYTE( "95403644.lo", 0x00001, 0x080000, CRC(4d906e99) SHA1(28d2b341e414fb342af95766f98ad558df3d8e71) )
	ROM_LOAD16_BYTE( "95403645.hi", 0x00000, 0x080000, CRC(6ff68f71) SHA1(e7a51bea03ca9261304eec6f34e3d6d8aa59d4aa) )
	ROM_LOAD16_BYTE( "95403672.lo", 0x00001, 0x080000, CRC(1ec80db0) SHA1(196e81d2c72385c341dfee1df9ba123c077dd450) )
	ROM_LOAD16_BYTE( "95403673.hi", 0x00000, 0x080000, CRC(2e6d12bd) SHA1(0bf59b9844ba5946f73011e7af390e35e836c6f6) )
	ROM_LOAD16_BYTE( "95406404.lo", 0x00001, 0x080000, CRC(03929a61) SHA1(14317ee7a50efb5e25f7e6c928c3830cbd6f9879) )
	ROM_LOAD16_BYTE( "95406405.hi", 0x00000, 0x080000, CRC(fbdb0804) SHA1(c1b6578420ecca300254bae9087b5de07342e902) )
	ROM_LOAD16_BYTE( "95407404.lo", 0x00001, 0x080000, CRC(0981631b) SHA1(a05389b016098333e1624b059b21247408a8cbe0) )
	ROM_LOAD16_BYTE( "95407405.hi", 0x00000, 0x080000, CRC(f402616d) SHA1(d9319a67f11ee4652fc767cb17e6e59900bc10b9) )
	ROM_LOAD16_BYTE( "95410220.lo", 0x00001, 0x080000, CRC(0244fbe1) SHA1(3744e169f7d39df905f8a90fbbd5e384fdabdb6f) )
	ROM_LOAD16_BYTE( "95410221.hi", 0x00000, 0x080000, CRC(d5880d07) SHA1(fd9373df8a879db1cbbbdcc417e32fa889b738b9) )
	ROM_LOAD16_BYTE( "95411220.lo", 0x00001, 0x080000, CRC(6f9e123a) SHA1(178f079dfb51537c24e5dba06e83bf1f0cb76c07) )
	ROM_LOAD16_BYTE( "95411221.hi", 0x00000, 0x080000, CRC(58642ea6) SHA1(6b2bd7b8950200a098d2095f7def0f97db9793f1) )
	ROM_LOAD16_BYTE( "95412300.lo", 0x00001, 0x080000, CRC(63fd59a5) SHA1(3063fa7b420da2380774e20cbac390da78e268fc) )
	ROM_LOAD16_BYTE( "95412301.hi", 0x00000, 0x080000, CRC(7999b416) SHA1(71ef7b363e467ce79c65acb3973a441f9535826a) )
	ROM_LOAD16_BYTE( "95413300.lo", 0x00001, 0x080000, CRC(5910aade) SHA1(40c8dd00078e089e5c0c5d17a75896ef199533d2) )
	ROM_LOAD16_BYTE( "95413301.hi", 0x00000, 0x080000, CRC(875c89f9) SHA1(ae68d772c4f73f95091ae499d66c5adddc3cad6c) )
	ROM_LOAD16_BYTE( "95413306.lo", 0x00001, 0x080000, CRC(730c27ef) SHA1(e3d371b2ab184970177b89c792fd21bb12fbd1cb) )
	ROM_LOAD16_BYTE( "95413307.hi", 0x00000, 0x080000, CRC(46db37f4) SHA1(d54aa4f580255d3fc37cc32f58985d64f0e62954) )
	ROM_LOAD16_BYTE( "95415932.lo", 0x00001, 0x080000, CRC(7a4c9542) SHA1(e9cede4592e00c3ab7cb9eeb767a679fafd2bb75) )
	ROM_LOAD16_BYTE( "95415933.hi", 0x00000, 0x080000, CRC(628f5395) SHA1(c793f9ae49d9527b1683d429c248ae11bcab421f) )
	ROM_LOAD16_BYTE( "95415934.lo", 0x00001, 0x080000, CRC(aca05c76) SHA1(dddfe148e6be5f774262d6bad81e0a6f5fe1a3c5) )
	ROM_LOAD16_BYTE( "95415935.hi", 0x00000, 0x080000, CRC(7275ce41) SHA1(2c4989cffb56db1c73d6eaa0c135a579d0b8106f) )
	ROM_LOAD16_BYTE( "95417026.lo", 0x00001, 0x080000, CRC(80dacc34) SHA1(7d7b48bcc4b2c088961ba63e8d0633b1235ceb72) )
	ROM_LOAD16_BYTE( "95417027.hi", 0x00000, 0x080000, CRC(b42c7e79) SHA1(cf2e47c3014040b97ad4ebcb31a8f782f1ec0077) )
	ROM_LOAD16_BYTE( "95417028.lo", 0x00001, 0x080000, CRC(97c97c8d) SHA1(e5212802312fb8efdaf5fe13e40b8fcadfe299a8) )
	ROM_LOAD16_BYTE( "95417029.hi", 0x00000, 0x080000, CRC(47082b8e) SHA1(278f380fa0e036bdec08d75f55cbe83e7944bf3b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004231_1.bin", 0x0000, 0x080000, CRC(af1512be) SHA1(4196820fa06b5e09f7108894ca89fc43e4ac3da5) )
	ROM_LOAD( "95004232_2.bin", 0x0000, 0x080000, CRC(bddddec8) SHA1(3dd7dab9ad3e4475cd10c675bbc5a5fd28cf953e) )
ROM_END


ROM_START( sc_tbana )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406070.lo", 0x00001, 0x080000, CRC(396f9515) SHA1(abd0f6f67103b99c72f517f000602eff7512d2e5) )
	ROM_LOAD16_BYTE( "95406071.hi", 0x00000, 0x080000, CRC(aae6b041) SHA1(53841ca78007de20642ef15e18017b1519ff0bda) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407070.lo", 0x00001, 0x080000, CRC(3797ad14) SHA1(0edca4df3626935e75c30237acdb50f60ce165f2) )
	ROM_LOAD16_BYTE( "95407071.hi", 0x00000, 0x080000, CRC(8a4a53d4) SHA1(026111764dedfd030cb824d89fcf45c7c1ebd76f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008229.bin", 0x0000, 0x100000, CRC(003f9c3d) SHA1(38ea111096e84e77e727fb784992b525767f5b0c) )
ROM_END


ROM_START( sc_tbox )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406948.lo", 0x00001, 0x080000, CRC(54c8a319) SHA1(e1ec970b0031f89822efe6f9751ca3c2b0338d25) )
	ROM_LOAD16_BYTE( "95406949.hi", 0x00000, 0x080000, CRC(48d8cd13) SHA1(bab50430c53b5dde848698f1a97140e1bfeb895f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414778.lo", 0x00001, 0x080000, CRC(487c5cc4) SHA1(a9145aba9402d86ab70c46f09c85f6f3d46fd205) )
	ROM_LOAD16_BYTE( "95414779.hi", 0x00000, 0x080000, CRC(2873e6b2) SHA1(81c9a4505367402924793720a753e035972e38ce) )
	ROM_LOAD16_BYTE( "95414828.lo", 0x00001, 0x080000, CRC(498fd1c1) SHA1(12827f2538b6affb095ffa5b5f6350490664a332) )
	ROM_LOAD16_BYTE( "95414829.hi", 0x00000, 0x080000, CRC(b8935360) SHA1(2f9b9ea2ba3041a7372b138dc2bfdd98813ca0ad) )
	ROM_LOAD16_BYTE( "95414926.lo", 0x00001, 0x080000, CRC(ee169b9c) SHA1(f9cc88955e2647530571aff5c7384b018415a042) )
	ROM_LOAD16_BYTE( "95414927.hi", 0x00000, 0x080000, CRC(8a602459) SHA1(2aea959105938abe734f823f10babec29d7c3425) )
	ROM_LOAD16_BYTE( "95414942.lo", 0x00001, 0x080000, CRC(19c6636a) SHA1(da21ad5208544a24f9e3dad23ee20318b5bb64af) )
	ROM_LOAD16_BYTE( "95414943.hi", 0x00000, 0x080000, CRC(21c68cb2) SHA1(e0ea75ef06fe9e91138371cb415797a84bbc49ce) )
	ROM_LOAD16_BYTE( "95415774.lo", 0x00001, 0x080000, CRC(0d4016bf) SHA1(b82058a82b8d06604dd960b506fdfe836ede769c) )
	ROM_LOAD16_BYTE( "95415775.hi", 0x00000, 0x080000, CRC(3e889448) SHA1(6729784afc2d968bcf2dcfa5b6051efbf3fab7f9) )
	ROM_LOAD16_BYTE( "95415776.lo", 0x00001, 0x080000, CRC(ef75f453) SHA1(16d6a5ab415026108187fc55dfd0b1a3a9efc3e9) )
	ROM_LOAD16_BYTE( "95415777.hi", 0x00000, 0x080000, CRC(af76919b) SHA1(c344de9eafd22383c05ad972c8e71898e01d6310) )
	ROM_LOAD16_BYTE( "95415778.lo", 0x00001, 0x080000, CRC(e5377604) SHA1(58d2fb3683477e104f064120bd974873977517da) )
	ROM_LOAD16_BYTE( "95415779.hi", 0x00000, 0x080000, CRC(d56a79f5) SHA1(52ae9a2179cd69cf56c96e946ed7d3b8eb977c31) )
	ROM_LOAD16_BYTE( "95415828.lo", 0x00001, 0x080000, CRC(e4c4fb01) SHA1(4e5fbf06a994ec8c08ba592305346df61300ab3d) )
	ROM_LOAD16_BYTE( "95415829.hi", 0x00000, 0x080000, CRC(458acc27) SHA1(ee1037070fa799479db203a4f73aa76faaa58885) )
	ROM_LOAD16_BYTE( "95415926.lo", 0x00001, 0x080000, CRC(cf6706dd) SHA1(8430d2528f6390b3bbb7882d6388b1d996e30cbd) )
	ROM_LOAD16_BYTE( "95415927.hi", 0x00000, 0x080000, CRC(8b5e8829) SHA1(386ead851e3ff7546d071c09a6882d89f7c9b765) )
	ROM_LOAD16_BYTE( "95415942.lo", 0x00001, 0x080000, CRC(8efebd16) SHA1(bd6e043f2346006769f44fecb375219a3f7c2868) )
	ROM_LOAD16_BYTE( "95415943.hi", 0x00000, 0x080000, CRC(4dd9ac8a) SHA1(d22ac1c4710888b9d103325a3f6aa6a5a2d92b6b) )
	ROM_LOAD16_BYTE( "95416098.lo", 0x00001, 0x080000, CRC(40e7887c) SHA1(9ff0c5895b8453da276a888863ef97386c95de97) )
	ROM_LOAD16_BYTE( "95416099.hi", 0x00000, 0x080000, CRC(e3697e0b) SHA1(badcc5d35f95c568fb21f22b39f25b65a337f15a) )
	ROM_LOAD16_BYTE( "95416142.lo", 0x00001, 0x080000, CRC(be042d98) SHA1(bafb71c0d4579b73e2b04e4834220e6be5928fba) )
	ROM_LOAD16_BYTE( "95416143.hi", 0x00000, 0x080000, CRC(a4ac3bdf) SHA1(c3e82fe7fb62d0128fca1b9aa9cbcfb3b12217b5) )
	ROM_LOAD16_BYTE( "95416176.lo", 0x00001, 0x080000, CRC(835ec17f) SHA1(a7db233111112e7fed5dbe8490d02b8bc9d16cbd) )
	ROM_LOAD16_BYTE( "95416177.hi", 0x00000, 0x080000, CRC(f1919ea4) SHA1(2b8bef90b66b7682ef2ca6a6face929d73239551) )
	ROM_LOAD16_BYTE( "95416572.lo", 0x00001, 0x080000, CRC(70489d47) SHA1(18127558ba138db015f5219001e05082ccc695b6) )
	ROM_LOAD16_BYTE( "95416573.hi", 0x00000, 0x080000, CRC(681f1467) SHA1(04ac5e5f809d3f4b7240c4326080e67815557245) )
	ROM_LOAD16_BYTE( "95417098.lo", 0x00001, 0x080000, CRC(d13c9710) SHA1(12a4906254127fa623289ae1fffbb0cbb5d24c95) )
	ROM_LOAD16_BYTE( "95417099.hi", 0x00000, 0x080000, CRC(61f4177d) SHA1(eb125e0062030fdc98828f8c48d130516b62d978) )
	ROM_LOAD16_BYTE( "95417142.lo", 0x00001, 0x080000, CRC(e51d2ea6) SHA1(7270cd90ea1c95675102bc7cb75e819a9c4b51c5) )
	ROM_LOAD16_BYTE( "95417143.hi", 0x00000, 0x080000, CRC(0204eef4) SHA1(6a240c108f5e196aff7b0e2caf81cd9b366d12dd) )
	ROM_LOAD16_BYTE( "95417176.lo", 0x00001, 0x080000, CRC(5668faa3) SHA1(2b1e64ddb59bbd99df123caec5fe22911101b126) )
	ROM_LOAD16_BYTE( "95417177.hi", 0x00000, 0x080000, CRC(beb1deb3) SHA1(a222890d80fa97e6b8f4bd0d12dee1b7adce022a) )
	ROM_LOAD16_BYTE( "95417572.lo", 0x00001, 0x080000, CRC(b016031d) SHA1(e81aaadaccc72fabbb3c4b75a7dd4e069bdcb87c) )
	ROM_LOAD16_BYTE( "95417573.hi", 0x00000, 0x080000, CRC(067d6cbf) SHA1(5b152efd5977a2b5a5428db79a1d7261e332fb0e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_tgear )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402185.lo", 0x00001, 0x080000, CRC(a6bdc445) SHA1(b469a0f911a15976c95ed103bf9c9949bed574af) )
	ROM_LOAD16_BYTE( "95402186.hi", 0x00000, 0x080000, CRC(7da86752) SHA1(e389f28da825d661017f29c9e66550f54ae667cb) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402365.lo", 0x00001, 0x080000, CRC(2d68a732) SHA1(31e5d64a25df4d563707392673377a606446cdfa) )
	ROM_LOAD16_BYTE( "95402366.hi", 0x00000, 0x080000, CRC(8c2d2aa1) SHA1(16159ef036134b48b6ea0c584fcaf5c3bf9de55f) )
	ROM_LOAD16_BYTE( "95402540.lo", 0x00001, 0x080000, CRC(657c486f) SHA1(218f001fc5d439fc4a617955b7e1d7d8a100a985) )
	ROM_LOAD16_BYTE( "95402541.hi", 0x00000, 0x080000, CRC(d38a9bdc) SHA1(81e6189544fd361d79263ccaf08a6aae320d8439) )
	ROM_LOAD16_BYTE( "95403365.lo", 0x00001, 0x080000, CRC(9a2bc700) SHA1(d2cdc13325e91bea12ade44fcff5bd2cec5d75df) )
	ROM_LOAD16_BYTE( "95403366.hi", 0x00000, 0x080000, CRC(088433d5) SHA1(aa5b7300b21d97b23dfe2f4b9ea507062a509baf) )
	ROM_LOAD16_BYTE( "95403540.lo", 0x00001, 0x080000, CRC(4c88b6d4) SHA1(847289d2c5bba58338d8f617416b6bbed4ef3a10) )
	ROM_LOAD16_BYTE( "95403541.hi", 0x00000, 0x080000, CRC(354431b1) SHA1(b5be30cefab77c4919d8805989d4d31f51dccb87) )
	ROM_LOAD16_BYTE( "95404168.lo", 0x00001, 0x080000, CRC(8f78f578) SHA1(e48cf81108a1160f1446e46eeb7ad7601851675c) )
	ROM_LOAD16_BYTE( "95404169.hi", 0x00000, 0x080000, CRC(99ce746b) SHA1(839a31a142ff28405822936453ccc94201dce543) )
	ROM_LOAD16_BYTE( "95405168.lo", 0x00001, 0x080000, CRC(ad7de0ae) SHA1(63a0c834edd2413eecd6de643813a89e1bc2242c) )
	ROM_LOAD16_BYTE( "95405169.hi", 0x00000, 0x080000, CRC(443429ab) SHA1(b8c585423781a8ef4e3558137ff06b90cdedeaf7) )

	ROM_LOAD( "top_gear.hi", 0x0000, 0x080000, CRC(8e819a04) SHA1(03ebd61123599dbf845a40b38f5dca7b9a6c4182) )
	ROM_LOAD( "top_gear.lo", 0x0000, 0x080000, CRC(96d1e012) SHA1(a5ca70b9371587b169c812873b0ef7848491ba3c) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008063.1", 0x0000, 0x100000, CRC(f87314dc) SHA1(00528243bd58e50ab24dde879f352feec2721019) )
	ROM_LOAD( "95008063.2", 0x0000, 0x100000, CRC(5d25d9e8) SHA1(a7f1abcf4bdb5ced2b414d43a13568d13ac334de) )
ROM_END


ROM_START( sc_tload )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408424.lo", 0x00001, 0x080000, CRC(1f8f93d4) SHA1(62349a83010f90931aa8a179db216e138824379e) )
	ROM_LOAD16_BYTE( "95408425.hi", 0x00000, 0x080000, CRC(a4a6930e) SHA1(c75d9ce127ba90e070412888551991cf7d46d7c6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008362.bin", 0x0000, 0x100000, CRC(fb14b937) SHA1(c8cbdda6184cc3d5b837a3cda105a39cf745bd4d) )
ROM_END


ROM_START( sc_tpsht )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416320.lo", 0x00001, 0x080000, CRC(a43419b2) SHA1(e26d4225b922868ca341c50a8e739b8b63ccb866) )
	ROM_LOAD16_BYTE( "95416321.hi", 0x00000, 0x080000, CRC(1dcc98e0) SHA1(4eea0f246bd53728ef068e3ee4754acc5e3aeffb) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416566.lo", 0x00001, 0x080000, CRC(b658136f) SHA1(635c9016b57673ca1a2db2dc3f17e04b00b46003) )
	ROM_LOAD16_BYTE( "95416567.hi", 0x00000, 0x080000, CRC(7446cadf) SHA1(9024c00f0f28a06e7ad39a47d05e1efd61b60a5e) )
	ROM_LOAD16_BYTE( "95416722.lo", 0x00001, 0x080000, CRC(eee6ba3c) SHA1(3e7e3685594f6ce2acae7a04c2be4bf3420a911e) )
	ROM_LOAD16_BYTE( "95416723.hi", 0x00000, 0x080000, CRC(4cbc9ad1) SHA1(382dae732dbe45899ec0ccf555f05adf410e9c66) )
	ROM_LOAD16_BYTE( "95417320.lo", 0x00001, 0x080000, CRC(58058edf) SHA1(f92a0350d82b77c740ada7cb4670f05486a1d115) )
	ROM_LOAD16_BYTE( "95417321.hi", 0x00000, 0x080000, CRC(38fd30b5) SHA1(d52b9c9f4da11984af5c16ea42c0b462c4f6bf87) )
	ROM_LOAD16_BYTE( "95417566.lo", 0x00001, 0x080000, CRC(4cc38da6) SHA1(f29f8f4c7d62f6d72a657b232c6c2b5eae3f46e1) )
	ROM_LOAD16_BYTE( "95417567.hi", 0x00000, 0x080000, CRC(fc754e52) SHA1(ce6551bc3e3d70ca16765e542fdc63403ea63562) )
	ROM_LOAD16_BYTE( "95417722.lo", 0x00001, 0x080000, CRC(5b384d61) SHA1(24853023a2dc447d16c70d7ec2ca0e50a0db6169) )
	ROM_LOAD16_BYTE( "95417723.hi", 0x00000, 0x080000, CRC(e55270ab) SHA1(2f31088c260e1db733d9162e9474118d0a50abac) )
	ROM_LOAD16_BYTE( "95420100.lo", 0x00001, 0x080000, CRC(9a84928c) SHA1(9c360110f2b35320222a4dab942ff70cf39f9888) )
	ROM_LOAD16_BYTE( "95420101.hi", 0x00000, 0x080000, CRC(e403add7) SHA1(56cf7c4fb4dee8878662afcfea2e5682c4a2f586) )
	ROM_LOAD16_BYTE( "95420102.lo", 0x00001, 0x080000, CRC(b86f8743) SHA1(55c68e7a8212ebcb991830021c627d046a6ddccd) )
	ROM_LOAD16_BYTE( "95420103.hi", 0x00000, 0x080000, CRC(f2887588) SHA1(e7eacd8ff6825d19045863a20c4b606624d6d3e0) )
	ROM_LOAD16_BYTE( "95420104.lo", 0x00001, 0x080000, CRC(3c5e6071) SHA1(d771021707a20f948786ab4c324a89e09de8f04e) )
	ROM_LOAD16_BYTE( "95420105.hi", 0x00000, 0x080000, CRC(9a578c11) SHA1(6bd6ae769a4d1c739b53ede4dadbb93647e7e006) )
	ROM_LOAD16_BYTE( "95421100.lo", 0x00001, 0x080000, CRC(0574029a) SHA1(8cecd1e4a39a66d9737c6d08b0631fb18ab0e114) )
	ROM_LOAD16_BYTE( "95421101.hi", 0x00000, 0x080000, CRC(6d895bf8) SHA1(79663c2f61bbdcffeb91d6e0a131551438c3296c) )
	ROM_LOAD16_BYTE( "95421102.lo", 0x00001, 0x080000, CRC(e179a093) SHA1(51b541ea4c53db66799d4f7bf4b9188c50486a87) )
	ROM_LOAD16_BYTE( "95421103.hi", 0x00000, 0x080000, CRC(f8961d14) SHA1(72c7fc478260e9dc207dc564390af6af0bd62293) )
	ROM_LOAD16_BYTE( "95421104.lo", 0x00001, 0x080000, CRC(9759ea90) SHA1(c5b75e033be1a3d531aa5ac9e9f7de560d159f62) )
	ROM_LOAD16_BYTE( "95421105.hi", 0x00000, 0x080000, CRC(6ba6f024) SHA1(217555b0deca94add7d42207306028213b124a52) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_trail )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414888.lo", 0x00001, 0x080000, CRC(72c1bb74) SHA1(cc98cc984a5d99afcbc5641e72a0fa20fca4420e) )
	ROM_LOAD16_BYTE( "95414889.hi", 0x00000, 0x080000, CRC(8a946127) SHA1(044f4ec93b161aa72665c363213448de8bc0f43a) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414972.lo", 0x00001, 0x080000, CRC(e4c960b6) SHA1(0d4a94323139c55fbb50f35167f73f02461258bd) )
	ROM_LOAD16_BYTE( "95414973.hi", 0x00000, 0x080000, CRC(5088fcdd) SHA1(ab02354a31a6817a1c345db66b1b06fdf685657c) )
	ROM_LOAD16_BYTE( "95414974.lo", 0x00001, 0x080000, CRC(3395e8b0) SHA1(b4573f69cc85be6a43f39a1e57313a2067d563c4) )
	ROM_LOAD16_BYTE( "95414975.hi", 0x00000, 0x080000, CRC(8a1b50db) SHA1(7a86bcbf73c9282252087a86aacc68770bec384b) )
	ROM_LOAD16_BYTE( "95415888.lo", 0x00001, 0x080000, CRC(91825b39) SHA1(d1833f404be2f473ee01c373b0396a9f17eef1b2) )
	ROM_LOAD16_BYTE( "95415889.hi", 0x00000, 0x080000, CRC(7577b260) SHA1(9137ddb1c04e7ec44a6e9213effa3ffd56706b50) )
	ROM_LOAD16_BYTE( "95415972.lo", 0x00001, 0x080000, CRC(14890ed2) SHA1(05d76ededfb89691eda2c8429b78cb6db676ef8f) )
	ROM_LOAD16_BYTE( "95415973.hi", 0x00000, 0x080000, CRC(3e75d23d) SHA1(b847a6d8d12f1ceae593f6330670fda713c0a71e) )
	ROM_LOAD16_BYTE( "95415974.lo", 0x00001, 0x080000, CRC(c94dc3a4) SHA1(789ddd7a14e56bc3547b6ee09f79b70683aecedc) )
	ROM_LOAD16_BYTE( "95415975.hi", 0x00000, 0x080000, CRC(9e8a5aa0) SHA1(ad7a5d6e5e0858f8a57fc64fc40e1384afa6e5af) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "trailblazer.bin", 0x0000, 0x0f6a6c, CRC(c27b5f9d) SHA1(24ac4ae0bec9a898690dfa2a78f765026d58255b) )
ROM_END


ROM_START( sc_ticlb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
//  ROM_LOAD16_BYTE( "95000599.mtx", 0x0000, 0x0074cc, CRC(b0f669d4) SHA1(9703a5e2d7ddbffab304316dc09b225f9cfd1664) )
	ROM_LOAD16_BYTE( "club-treasure-island_dat_ac_p65ss.hi", 0x00000, 0x080000, CRC(3529018b) SHA1(aa49f68bb3ca550c77d4667b8373f94856a70cf3) )
	ROM_LOAD16_BYTE( "club-treasure-island_dat_ac_p65ss.lo", 0x00001, 0x080000, CRC(180fcb0a) SHA1(17400ae744af37b5a17389e4f7a639a5e5743b2d) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "club-treasure-island_dat_acss.hi", 0x00000, 0x080000, CRC(a51b94c9) SHA1(919f44f04a3b60b190e9c87c0d844ddde1268318) )
	ROM_LOAD16_BYTE( "club-treasure-island_dat_acss.lo", 0x00001, 0x080000, CRC(2d685792) SHA1(36329c83f247d284294e381293b25f745ea220da) )
	ROM_LOAD16_BYTE( "club-treasure-island_std_ac_p65ss.hi", 0x00000, 0x080000, CRC(856d863b) SHA1(c00ee8032fd0dee6466a30a4bc59ae3b0cd4f556) )
	ROM_LOAD16_BYTE( "club-treasure-island_std_ac_p65ss.lo", 0x00001, 0x080000, CRC(2335e1b7) SHA1(ed32e892c9e71cccb642734e14eaea36f8f1853c) )
	ROM_LOAD16_BYTE( "club-treasure-island_std_acss.hi", 0x00000, 0x080000, CRC(155f1379) SHA1(0768ce46a661f1280bd75897b82cca276ce7dbed) )
	ROM_LOAD16_BYTE( "club-treasure-island_std_acss.lo", 0x00001, 0x080000, CRC(16527d2f) SHA1(dba35f4b8f5953a1043610efe627a97b4fca8b74) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004082.p1", 0x0000, 0x080000, CRC(b7caba0f) SHA1(777afdb6a2f78edad5f4df506eb4cd571f9f357b) )
	ROM_LOAD( "95004083.p2", 0x0000, 0x080000, CRC(c0cc21b7) SHA1(d0b22db4c1faeef34b794ac4c31bc9fd386493ea) )

	ROM_REGION( 0x400000, "others", 0 )
	ROM_LOAD( "club-treasure-island_mtx_ass.bin", 0x0000, 0x010000, CRC(74f97b29) SHA1(9334bf1e4b4e2bcbbfaa5ae32201ceaab0641d83) ) // DMD

ROM_END


ROM_START( sc_ttomb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406814.lo", 0x00001, 0x080000, CRC(9892b8b8) SHA1(c337a325def655a8878a1d04bdb5ddd73d01bf85) )
	ROM_LOAD16_BYTE( "95406815.hi", 0x00000, 0x080000, CRC(c46d3962) SHA1(17dfa99baf02d74b1f8118cf5f38adf66d9fc173) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407814.lo", 0x00001, 0x080000, CRC(56387b17) SHA1(a489b2650e95c8a097285a7d5a9c78203f85e811) )
	ROM_LOAD16_BYTE( "95407815.hi", 0x00000, 0x080000, CRC(bf3fb189) SHA1(69b31379b1fead7c5028a7bae4d9612b24a10c29) )
	ROM_LOAD16_BYTE( "p1305p12.hi", 0x00000, 0x080000, CRC(d1103ab7) SHA1(7fa4ed1f76e42e188103e13b8b188a304de3d9e4) )
	ROM_LOAD16_BYTE( "p1305p12.lo", 0x00001, 0x080000, CRC(8cb4a6a4) SHA1(bd1e4363024670914a82c65eaa3b37dafddf627a) )
	ROM_LOAD16_BYTE( "p1305s12.hi", 0x00000, 0x080000, CRC(91276b7c) SHA1(52da930c77a07e234657838bcd35725ba471f747) )
	ROM_LOAD16_BYTE( "p1305s12.lo", 0x00001, 0x080000, CRC(768e8914) SHA1(89bb914f22b08b1abd83d759b6f232d3aa1ff89b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008287.bin", 0x0000, 0x100000, CRC(9a3f47f9) SHA1(5844f3be0fe4febe04d924afc00f2f55273c15f1) )
ROM_END


ROM_START( sc_tridn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408364.lo", 0x00001, 0x080000, CRC(a3f03319) SHA1(3e48644d66e66b1a1cc4973992fdd87364d43e5a) )
	ROM_LOAD16_BYTE( "95408365.hi", 0x00000, 0x080000, CRC(04f5c0cc) SHA1(8e30ef352fb85e3f4186765c6e413e3985eedaf1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409364.lo", 0x00001, 0x080000, CRC(e2e70d26) SHA1(6736b70981c3c255f0ece8c8a704e525b924eeca) )
	ROM_LOAD16_BYTE( "95409365.hi", 0x00000, 0x080000, CRC(8e244a99) SHA1(1a400cb48ce3e26d9d9e76343a7d2c98003dc4b5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008335.bin", 0x0000, 0x0fd5ab, CRC(f0fed8d5) SHA1(dd974c70adfb9a5fb37a069eb736d5ef23b43ddf) )
ROM_END


ROM_START( sc_tri7 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410994.lo", 0x00001, 0x080000, CRC(1026c0f6) SHA1(fddeb118835adc899da0197777c9923125944df8) )
	ROM_LOAD16_BYTE( "95410995.hi", 0x00000, 0x080000, CRC(49db3a2b) SHA1(503ab7a10ac04e416683bb931d52772bb652d8d1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95411994.lo", 0x00001, 0x080000, CRC(0bbb112e) SHA1(a01b89b5fe20b34aa2e76287c6b76c043eab8d9f) )
	ROM_LOAD16_BYTE( "95411995.hi", 0x00000, 0x080000, CRC(ee4d4370) SHA1(8265e738a53d24a17d670a45f4c5f42419b34c0b) )
	ROM_LOAD16_BYTE( "95412064.lo", 0x00001, 0x080000, CRC(a842778f) SHA1(ad711c31b1e5e89f024476cb41abe75d4efe4141) )
	ROM_LOAD16_BYTE( "95412065.hi", 0x00000, 0x080000, CRC(024c3d0c) SHA1(c586cb58ff512dad2d4ae7c4378af05c2bb4db95) )
	ROM_LOAD16_BYTE( "95412454.lo", 0x00001, 0x080000, CRC(ee646837) SHA1(59b18e3aecbc32d87eac5bb76402496c39a5e89d) )
	ROM_LOAD16_BYTE( "95412455.hi", 0x00000, 0x080000, CRC(03e09830) SHA1(ef76bc3b8031455378d8486e337b81da3030775f) )
	ROM_LOAD16_BYTE( "95413064.lo", 0x00001, 0x080000, CRC(37190cc4) SHA1(59c4a685723d502ad636349e4e65b74c2b1475f7) )
	ROM_LOAD16_BYTE( "95413065.hi", 0x00000, 0x080000, CRC(6ef29239) SHA1(ee2997c1685fb0e38aaa534aae95c49717241883) )
	ROM_LOAD16_BYTE( "95413454.lo", 0x00001, 0x080000, CRC(432af7c8) SHA1(bba8231e2da9a9e85035187e3b03fd019a9c8c6d) )
	ROM_LOAD16_BYTE( "95413455.hi", 0x00000, 0x080000, CRC(18a8fb22) SHA1(4a4558ce2dbee92754f61bc4e8db8964c23a1e53) )
	ROM_LOAD16_BYTE( "p1328p12.hi", 0x00000, 0x080000, CRC(babba77d) SHA1(53aa064eb8aa2821e4033f1110523bcee0690f7b) )
	ROM_LOAD16_BYTE( "p1328p12.lo", 0x00001, 0x080000, CRC(0e9108f0) SHA1(981d6bbe2201c38195df17ae1de178c907efe901) )
	ROM_LOAD16_BYTE( "p1328p14.hi", 0x00000, 0x080000, CRC(807b5637) SHA1(fb2bb00348f299d517e55d044a705f6581b7c8de) )
	ROM_LOAD16_BYTE( "p1328p14.lo", 0x00001, 0x080000, CRC(227cc82d) SHA1(18e512cb8a6a07915c17285f2c1c73da90031813) )
	ROM_LOAD16_BYTE( "p1328p15.hi", 0x00000, 0x080000, CRC(6650d9f4) SHA1(ac157fb98d1d5f7a8724d4d072344bd7ae9a12ca) )
	ROM_LOAD16_BYTE( "p1328p15.lo", 0x00001, 0x080000, CRC(ac654552) SHA1(ed1854336d9910ba7681288b8b4d93db793c6bbb) )
	ROM_LOAD16_BYTE( "p1328p42.hi", 0x00000, 0x080000, CRC(0e27e529) SHA1(ec1faa8b0807173ca1d2e8900fc1fd17cad03da3) )
	ROM_LOAD16_BYTE( "p1328p42.lo", 0x00001, 0x080000, CRC(e840f88f) SHA1(fa8626dae0cb9a806a01264a4d8503ac71765901) )
	ROM_LOAD16_BYTE( "p1328p43.hi", 0x00000, 0x080000, CRC(1011729f) SHA1(5e259fc4d332f2bac890dde7dfb64e504b3cb2c2) )
	ROM_LOAD16_BYTE( "p1328p43.lo", 0x00001, 0x080000, CRC(3e0ab5e0) SHA1(fb587e5833bf854ad884ccbe50d9f57f24cef4b0) )
	ROM_LOAD16_BYTE( "p1328p44.hi", 0x00000, 0x080000, CRC(554e574e) SHA1(b211bfea65c4f993ab9d5bd9d97c3b910a24a806) )
	ROM_LOAD16_BYTE( "p1328p44.lo", 0x00001, 0x080000, CRC(6a788656) SHA1(10e9dff7c56386334b7ceac712ca3ad9d2df0793) )
	ROM_LOAD16_BYTE( "p1328p45.hi", 0x00000, 0x080000, CRC(0bab79ba) SHA1(03e246aa584797b6613c023c69ad44423c03606d) )
	ROM_LOAD16_BYTE( "p1328p45.lo", 0x00001, 0x080000, CRC(45640e95) SHA1(8b12e67d81767171ff5408d707f04a4b1e21e3b7) )
	ROM_LOAD16_BYTE( "p1328p93.hi", 0x00000, 0x080000, CRC(f3f210cf) SHA1(c266a39161134fcb16d44bc5417f7e72c382233f) )
	ROM_LOAD16_BYTE( "p1328p93.lo", 0x00001, 0x080000, CRC(eb57adbe) SHA1(33e1031150b7609779c9bc3365700df0e3b7c2f3) )
	ROM_LOAD16_BYTE( "p1328p94.hi", 0x00000, 0x080000, CRC(e838472e) SHA1(de145ba9a02b1bafc3ee2c7aec93d25193b9cf41) )
	ROM_LOAD16_BYTE( "p1328p94.lo", 0x00001, 0x080000, CRC(a441fefe) SHA1(c861b3db7c16d4ff3b7bb828ccee0f7dd36700e3) )
	ROM_LOAD16_BYTE( "p1328s12.hi", 0x00000, 0x080000, CRC(98d06e2e) SHA1(f89d74d35a0eb68c939a207c3fe8fb9f34e012b3) )
	ROM_LOAD16_BYTE( "p1328s12.lo", 0x00001, 0x080000, CRC(2942cd24) SHA1(1649efb28459dfbf01d70caaec6a8644c2b86cc5) )
	ROM_LOAD16_BYTE( "p1328s14.hi", 0x00000, 0x080000, CRC(abd8c9de) SHA1(52526bb32c24f1d7c5183e1fff3ceb0459b6544d) )
	ROM_LOAD16_BYTE( "p1328s14.lo", 0x00001, 0x080000, CRC(46b39cd1) SHA1(4fb0e0c4c9aa59f0d1197393b8df9ac0c5f5f590) )
	ROM_LOAD16_BYTE( "p1328s15.hi", 0x00000, 0x080000, CRC(455ec1c4) SHA1(b7b7161e19d5841501174fc3366efceec2077e2a) )
	ROM_LOAD16_BYTE( "p1328s15.lo", 0x00001, 0x080000, CRC(8babf31d) SHA1(a746111dacdc55cb9de37c0c7cb4e2572cae956a) )
	ROM_LOAD16_BYTE( "p1328s42.hi", 0x00000, 0x080000, CRC(e6b01cb3) SHA1(88e5a680c4294f917265c60027b471447fc6941f) )
	ROM_LOAD16_BYTE( "p1328s42.lo", 0x00001, 0x080000, CRC(127a843c) SHA1(6e88ca16f63659c5c58ccbafca4d4f07f7d90b7a) )
	ROM_LOAD16_BYTE( "p1328s43.hi", 0x00000, 0x080000, CRC(e338ba38) SHA1(4a063151f44fe322d4c8151188ea51b0854c8555) )
	ROM_LOAD16_BYTE( "p1328s43.lo", 0x00001, 0x080000, CRC(7b05833e) SHA1(8442622e810905e95bf8edb0852a45e149f47e2a) )
	ROM_LOAD16_BYTE( "p1328s44.hi", 0x00000, 0x080000, CRC(702ef9f8) SHA1(a6ccad92fd23af04b73166204fb9f43280002219) )
	ROM_LOAD16_BYTE( "p1328s44.lo", 0x00001, 0x080000, CRC(4ab4597e) SHA1(2a24a4d6eebf15a1b5728d18c36a960cfcb67e76) )
	ROM_LOAD16_BYTE( "p1328s45.hi", 0x00000, 0x080000, CRC(c66fa7e6) SHA1(71c3c152e0a257401d87dcb9ba1d9ccbc18d367f) )
	ROM_LOAD16_BYTE( "p1328s45.lo", 0x00001, 0x080000, CRC(7a32fb1a) SHA1(c98bcc39740fae3c74cb0edd931ea0d3d86d1fef) )
	ROM_LOAD16_BYTE( "p1328s93.hi", 0x00000, 0x080000, CRC(c8f46a5c) SHA1(6d21b7d2cd950aa006b6d74c1691dd03314025d5) )
	ROM_LOAD16_BYTE( "p1328s93.lo", 0x00001, 0x080000, CRC(15b328f5) SHA1(4e56ddfbaceab9e662abf6028421e517ff8ab324) )
	ROM_LOAD16_BYTE( "p1328s94.hi", 0x00000, 0x080000, CRC(543b5016) SHA1(2efdbcdd1db27c2cb0b10e477fbfc55eec210d15) )
	ROM_LOAD16_BYTE( "p1328s94.lo", 0x00001, 0x080000, CRC(0127367f) SHA1(e63d656a1d76ea4d61d5cd432bef6adf58c86f30) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008308.bin", 0x0000, 0x100000, CRC(87a25bc3) SHA1(bf3d6b86f8f217131c33b681787f4a6fe84b8b8d) )
ROM_END


ROM_START( sc_trist )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414872.lo", 0x00001, 0x080000, CRC(361abb05) SHA1(a62c0aafee9eac3ec9b42c4b74bb63a6520cb77c) )
	ROM_LOAD16_BYTE( "95414873.hi", 0x00000, 0x080000, CRC(64d2487e) SHA1(2f135190ca532ad8ba3d19dcb7c06833c39ffd83) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414874.lo", 0x00001, 0x080000, CRC(d6290c57) SHA1(41daa18354305fe4a530508adb9a21e68b66fdeb) )
	ROM_LOAD16_BYTE( "95414875.hi", 0x00000, 0x080000, CRC(61a96e02) SHA1(ef2fbf2ac53c119ef7de5cf97dd00824b9425032) )
	ROM_LOAD16_BYTE( "95416232.lo", 0x00001, 0x080000, CRC(0b10d683) SHA1(a2bb6c65c13eaa26cc546135ed668a809b5b7446) )
	ROM_LOAD16_BYTE( "95416233.hi", 0x00000, 0x080000, CRC(aceb2b79) SHA1(5301fedb2f0a84d20db1e0bb655ea3194e2aaa8f) )
	ROM_LOAD16_BYTE( "95416238.lo", 0x00001, 0x080000, CRC(0440c2f7) SHA1(b44f5ac81d6a140421603547a4e851e0db580d0e) )
	ROM_LOAD16_BYTE( "95416239.hi", 0x00000, 0x080000, CRC(0429ad5e) SHA1(59978dfdc62942f95f92fddd76887b6cc6f80073) )
	ROM_LOAD16_BYTE( "95416418.lo", 0x00001, 0x080000, CRC(e4989a37) SHA1(07c545f2b38dbd7ba54ba0436d3c31e52e51a38b) )
	ROM_LOAD16_BYTE( "95416419.hi", 0x00000, 0x080000, CRC(aec5d5f8) SHA1(64a20d24b17b113e9f686f570720f445faf6797b) )
	ROM_LOAD16_BYTE( "95416574.lo", 0x00001, 0x080000, CRC(837e1854) SHA1(c6c6b797a56a94619db83b611d45e96dd7523efa) )
	ROM_LOAD16_BYTE( "95416575.hi", 0x00000, 0x080000, CRC(64238f62) SHA1(d8e3a4d4a906782d9aa56705f1d53f15de5bff5c) )
	ROM_LOAD16_BYTE( "95416626.lo", 0x00001, 0x080000, CRC(f5aebfd8) SHA1(82f30aeefd8a469989ffbbebf949f2f73395eaf5) )
	ROM_LOAD16_BYTE( "95416627.hi", 0x00000, 0x080000, CRC(3a66d685) SHA1(1a324454ee6f5725430fa8fa908606f5a277cef5) )
	ROM_LOAD16_BYTE( "95416632.lo", 0x00001, 0x080000, CRC(58307537) SHA1(1aa783734ea833a5bd9e167b5c332e7bc41ee453) )
	ROM_LOAD16_BYTE( "95416633.hi", 0x00000, 0x080000, CRC(31336f19) SHA1(1c21ea319eae54055bddcebcfdfa7f2216090595) )
	ROM_LOAD16_BYTE( "95416634.lo", 0x00001, 0x080000, CRC(8bbfeee2) SHA1(a32fa36b13a293dce89da7a7ec87a3d53018472d) )
	ROM_LOAD16_BYTE( "95416635.hi", 0x00000, 0x080000, CRC(df28e46c) SHA1(64241771fa1a96a9c646a6fab3ce2494515d1fcc) )
	ROM_LOAD16_BYTE( "95416636.lo", 0x00001, 0x080000, CRC(ada2434b) SHA1(d22223faedea8686c21f1d341a70278147f4facc) )
	ROM_LOAD16_BYTE( "95416637.hi", 0x00000, 0x080000, CRC(e8c0e8a7) SHA1(7ee848b3a08af66824837466c54a0f3ab6ad6dc3) )
	ROM_LOAD16_BYTE( "95416642.lo", 0x00001, 0x080000, CRC(70a56cc6) SHA1(9c29307081c02c1b05c832396c5bfa6fdbde8572) )
	ROM_LOAD16_BYTE( "95416643.hi", 0x00000, 0x080000, CRC(24a76a32) SHA1(3669ae6c38781ba26516bc6106970fe8811f9ac7) )
	ROM_LOAD16_BYTE( "95417232.lo", 0x00001, 0x080000, CRC(7bb4de17) SHA1(c798d7033026e88ba0559537035fb05f7d58f30c) )
	ROM_LOAD16_BYTE( "95417233.hi", 0x00000, 0x080000, CRC(6a5915ab) SHA1(bdf913cf54c682ce2e38d5fc89b54b0b58342d23) )
	ROM_LOAD16_BYTE( "95417234.lo", 0x00001, 0x080000, CRC(ac1d42e8) SHA1(1860de568b5b09403f13d6b2ba3769b19acb3e7f) )
	ROM_LOAD16_BYTE( "95417235.hi", 0x00000, 0x080000, CRC(ed94dbab) SHA1(ff8ed44d277add4447befd27818cf4a78e25badf) )
	ROM_LOAD16_BYTE( "95417236.lo", 0x00001, 0x080000, CRC(e29f1c8d) SHA1(6254be7ed555e2331a0b5ac0f2d8319145b01a63) )
	ROM_LOAD16_BYTE( "95417237.hi", 0x00000, 0x080000, CRC(294cab6f) SHA1(bfbf01d75504f8c4e829aa887db2812de2dd9fed) )
	ROM_LOAD16_BYTE( "95417238.lo", 0x00001, 0x080000, CRC(9eb0fdf7) SHA1(b66a0ad8f0083db2926309ddb9a5cf463b03e763) )
	ROM_LOAD16_BYTE( "95417239.hi", 0x00000, 0x080000, CRC(2b8c5088) SHA1(517291c99827f324f50140dbc4f706dd9d069ac5) )
	ROM_LOAD16_BYTE( "95417418.lo", 0x00001, 0x080000, CRC(23d8bb79) SHA1(8e838e2744cbe1129cdb5b0195a2e55355297ed2) )
	ROM_LOAD16_BYTE( "95417419.hi", 0x00000, 0x080000, CRC(3359f77e) SHA1(7a42a53423824b8264a4c619103721cb0b1c0be4) )
	ROM_LOAD16_BYTE( "95417574.lo", 0x00001, 0x080000, CRC(0840f093) SHA1(74611230b1c9d8588e492dad38fec9775c49bf33) )
	ROM_LOAD16_BYTE( "95417575.hi", 0x00000, 0x080000, CRC(176608f3) SHA1(db64046341f559c46a705cbef26679ccd080ff5d) )
	ROM_LOAD16_BYTE( "95417626.lo", 0x00001, 0x080000, CRC(ddf809b0) SHA1(3aa5c116111f5cb677460a93130f8472cfe5fec8) )
	ROM_LOAD16_BYTE( "95417627.hi", 0x00000, 0x080000, CRC(0e141e79) SHA1(5723a75ae4758b27bff125f646231590bbb7f404) )
	ROM_LOAD16_BYTE( "95417628.lo", 0x00001, 0x080000, CRC(1fcc127d) SHA1(cad3ff8055d48cae67394ec4fb3d373e7c24a8ff) )
	ROM_LOAD16_BYTE( "95417629.hi", 0x00000, 0x080000, CRC(ec102d98) SHA1(12cf171a50d639f965955ce0c2a6d5dcbaecefcf) )
	ROM_LOAD16_BYTE( "95417630.lo", 0x00001, 0x080000, CRC(fa2ad681) SHA1(45312fb02e2ad46d23ba6e62c5a9ecc8f736ffa5) )
	ROM_LOAD16_BYTE( "95417631.hi", 0x00000, 0x080000, CRC(3cc61b01) SHA1(82dcfea953d09f41aae9ae5c281b8fbbe2ef7ec7) )
	ROM_LOAD16_BYTE( "95417632.lo", 0x00001, 0x080000, CRC(cd19235e) SHA1(57848f8405799230ab74679f2704a8d0a674fb29) )
	ROM_LOAD16_BYTE( "95417633.hi", 0x00000, 0x080000, CRC(e38f0d88) SHA1(906fb3957f6c320771588cec22cdfcfe290804b9) )
	ROM_LOAD16_BYTE( "95417634.lo", 0x00001, 0x080000, CRC(9da385ab) SHA1(34f9e1bb10df6b5c6a12be01d1250447a6b26bb8) )
	ROM_LOAD16_BYTE( "95417635.hi", 0x00000, 0x080000, CRC(d1cf2175) SHA1(1dd72e2c0a9c19ba00df66976b2b2d8d96b72242) )
	ROM_LOAD16_BYTE( "95417636.lo", 0x00001, 0x080000, CRC(a2b799ce) SHA1(b9aaf08f4eadf5c1174454b288502c3c4295a5e3) )
	ROM_LOAD16_BYTE( "95417637.hi", 0x00000, 0x080000, CRC(a9076da9) SHA1(84324bdb91ed32e35e16e0a7853b2c53281d138a) )
	ROM_LOAD16_BYTE( "95417638.lo", 0x00001, 0x080000, CRC(8c45eb89) SHA1(4a0db371245a9c922958f6d001b4fe370f831ade) )
	ROM_LOAD16_BYTE( "95417639.hi", 0x00000, 0x080000, CRC(4dbad597) SHA1(7f2ef44e34864551aa69075160cdf04578a9f337) )
	ROM_LOAD16_BYTE( "95417640.lo", 0x00001, 0x080000, CRC(883b66f2) SHA1(1f9ad6b0213a87a654fe68766d3ee8ea1a8bc593) )
	ROM_LOAD16_BYTE( "95417641.hi", 0x00000, 0x080000, CRC(d06acd1c) SHA1(b4191a97cec37cd4ce687f690f3a9b577b06236f) )
	ROM_LOAD16_BYTE( "95417642.lo", 0x00001, 0x080000, CRC(3090f654) SHA1(b03e59fe9d58e2d2f0116e7d2bfb5391b4d4e0d7) )
	ROM_LOAD16_BYTE( "95417643.hi", 0x00000, 0x080000, CRC(81d31db1) SHA1(23379d169434b31675c268d641713a5994fc4a67) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008499.bin", 0x0000, 0x0efbd7, CRC(90710d1f) SHA1(923f6396941b713d3f55bb002c36b0e42063ae4d) )
ROM_END


ROM_START( sc_tub )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404460.lo", 0x00001, 0x080000, CRC(2e876763) SHA1(194ab445923c4377be9725e98ba77d11653df1cd) )
	ROM_LOAD16_BYTE( "95404461.hi", 0x00000, 0x080000, CRC(30a4ebc8) SHA1(7cbaf6b78066954291e71596a8490585c64043e4) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405460.lo", 0x00001, 0x080000, CRC(b7746ce2) SHA1(0ebf630ece5273f7683e1fbe164349d130ea2fb0) )
	ROM_LOAD16_BYTE( "95405461.hi", 0x00000, 0x080000, CRC(afdac796) SHA1(b7d4197e9dedd08ddbaa971cbe71820c0401b460) )
	ROM_LOAD16_BYTE( "95406032.lo", 0x00001, 0x080000, CRC(11f97160) SHA1(cafd18038d3345702272eabb1ee2bd3d90bf857c) )
	ROM_LOAD16_BYTE( "95406033.hi", 0x00000, 0x080000, CRC(9b4a5f6d) SHA1(21051d01cd937edd9906730c88461b4c5a6d08d0) )
	ROM_LOAD16_BYTE( "95407032.lo", 0x00001, 0x080000, CRC(0d9920ba) SHA1(2eb8f661bb11cf28a94dfdbbacf07e2a8a41058b) )
	ROM_LOAD16_BYTE( "95407033.hi", 0x00000, 0x080000, CRC(52be5eee) SHA1(1bed67c56da01c4c8048645eb97109dc5fd453eb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008164.bin", 0x0000, 0x100000, CRC(37fb6004) SHA1(d171223dd4a4162bfb1e63e4af26ea012a2de5ea) )
ROM_END


ROM_START( sc_tfclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402177.lo", 0x00001, 0x080000, CRC(f74c912a) SHA1(a1709bdf360ed97df200d6e32e16c1196575b9eb) )
	ROM_LOAD16_BYTE( "95402178.hi", 0x00000, 0x080000, CRC(7fa1a196) SHA1(3da86c82ed6115442b7960e5c9c75fa8b62c1c31) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403177.lo", 0x00001, 0x080000, CRC(6b11a6b8) SHA1(ff436b2686bc11e141d49ae2348a47fc7861c5d3) )
	ROM_LOAD16_BYTE( "95403178.hi", 0x00000, 0x080000, CRC(db742c5d) SHA1(e25129d0bcb8542ebb55d2801892f3f517425732) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008043.bin", 0x0000, 0x100000, CRC(b168cec4) SHA1(42b891ba918c7063420688c99dc72609801a1987) )
	ROM_LOAD( "95008044.bin", 0x0000, 0x100000, CRC(6074fa77) SHA1(1d4fa88a7ba2b020042ef3681e0f8eb732705d55) )
ROM_END


ROM_START( sc_twilt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406534.lo", 0x00001, 0x080000, CRC(05db2b5a) SHA1(c5ff8ee24b57f6af08ea74d04034d9ba7e50b5da) )
	ROM_LOAD16_BYTE( "95406535.hi", 0x00000, 0x080000, CRC(c81afcb2) SHA1(25c79f2de750b30f6268260291d773dab8415bba) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004299.snd", 0x0000, 0x080000, CRC(f4837e10) SHA1(78c4455b1585ca60ed15734dac517f5f1ef4d237) )
ROM_END


ROM_START( sc_ufg )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400633.lo", 0x00001, 0x080000, CRC(0dd9d476) SHA1(f60b3dff5b26b5ad46d4a96a5d397de265bfde98) )
	ROM_LOAD16_BYTE( "95400634.hi", 0x00000, 0x080000, CRC(7c3678a4) SHA1(508472ec4fa33bf691183909a224607d569ec119) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95401633.lo", 0x00001, 0x080000, CRC(06ed97e6) SHA1(f1acb597187c90e888a8c9810856c9b8f817473c) )
	ROM_LOAD16_BYTE( "95401634.hi", 0x00000, 0x080000, CRC(5ea8e2c3) SHA1(ff4a488a616c10694c4041a85d0dc2729c9da3a9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004167.bin", 0x0000, 0x080000, CRC(9dcd31cc) SHA1(2ce9e167debbc2315b4be964116fdc35e19b6046) )
ROM_END


ROM_START( sc_ufi )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400723.lo", 0x00001, 0x080000, CRC(5a08e5e2) SHA1(4cba2a450be3ac78294a94a8964b03d243dd73f0) )
//  ROM_LOAD16_BYTE( "95400723.sum", 0x0000, 0x00003a, CRC(49657b66) SHA1(54d16ea33e8b932854b0d19f2dd87fdc026f7cd2) )
	ROM_LOAD16_BYTE( "95400724.hi", 0x00000, 0x080000, CRC(a47a8c15) SHA1(0996c613d49bea0fdb156a54c9704852f79735e2) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400725.lo", 0x00001, 0x080000, CRC(abd57573) SHA1(8851454c8d253d862f81af44c7541a110e331873) )
//  ROM_LOAD16_BYTE( "95400725.sum", 0x0000, 0x00003a, CRC(d1302953) SHA1(b1cdb277b9a9be554d32a8f48f488887bc147aaa) )
	ROM_LOAD16_BYTE( "95400726.hi", 0x00000, 0x080000, CRC(26b1a723) SHA1(a64129046c2db33c7df96165b2591c056f5fbb0d) )
	ROM_LOAD16_BYTE( "95400912.hi", 0x00000, 0x080000, CRC(d1a24394) SHA1(03d6561f8e66bbaaabd18fb9d5244f12b2202c0d) )
	ROM_LOAD16_BYTE( "95401701.lo", 0x00001, 0x080000, CRC(5c09007e) SHA1(d69290225f08ed5dcf0204bd96f7f09a73c2f243) )
	ROM_LOAD16_BYTE( "95401723.lo", 0x00001, 0x080000, CRC(38d4e8c8) SHA1(d238bda3b5bc407933575230a1640bd1cc789491) )
//  ROM_LOAD16_BYTE( "95401723.sum", 0x0000, 0x00003a, CRC(6819e743) SHA1(cdbd8f66fb42301fccb086718cdccc058ef820b0) )
	ROM_LOAD16_BYTE( "95401724.hi", 0x00000, 0x080000, CRC(92ea4a31) SHA1(a9b42e039f89ae7ecfcc0b87b9715772e1a06696) )
	ROM_LOAD16_BYTE( "95401725.lo", 0x00001, 0x080000, CRC(09ad97c6) SHA1(9c9628156d2220ad6b1bab490d48fde1ecd6c2c3) )
//  ROM_LOAD16_BYTE( "95401725.sum", 0x0000, 0x00003a, CRC(4fb81c41) SHA1(d1f385452dacd6aad76e5357b7e8dd4de589fda7) )
	ROM_LOAD16_BYTE( "95401726.hi", 0x00000, 0x080000, CRC(2ab46ce2) SHA1(60f74cc855c35a3dc07a32640c14835c1cfe1827) )
	ROM_LOAD16_BYTE( "95401911.lo", 0x00001, 0x080000, CRC(ae68b469) SHA1(de77f117a3d688f0feb9415f00b534d3651f52c7) )
	ROM_LOAD16_BYTE( "95401912.hi", 0x00000, 0x080000, CRC(87b73871) SHA1(598764a0a73705475f15263a79106f22b6d1abe8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_valnv )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402005.lo", 0x00001, 0x080000, CRC(0b42f5f2) SHA1(02982861f7f3bb1cd20718df539a909dabe929af) )
	ROM_LOAD16_BYTE( "95402006.hi", 0x00000, 0x080000, CRC(5886ecdd) SHA1(4cec3d51871a5956bdeaaa1a4bc37236812d5e16) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "sound1.bin", 0x0000, 0x080000, CRC(cedee498) SHA1(311ab99746cff8f72ec8ffb9ac386a713fc300dd) )
	ROM_LOAD( "sound2.bin", 0x0000, 0x080000, CRC(0994b7bb) SHA1(ad79998467fee8fd95c944ea6a33450fcf6d3d56) )
ROM_END


ROM_START( sc_valqp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406480.lo", 0x00001, 0x080000, CRC(c0860d85) SHA1(2625c3ba9fadc1c537baef6a619dff50e12e0a13) )
	ROM_LOAD16_BYTE( "95406481.hi", 0x00000, 0x080000, CRC(ddb3439f) SHA1(70ef8e7bdf3234f8e83e47beca54a4d8712257c4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004296.sn1", 0x0000, 0x080000, CRC(aecc8138) SHA1(64fd18666c2c753899bff971227b9358c2bf22f1) )
	ROM_LOAD( "95004297.sn2", 0x0000, 0x080000, CRC(2c8b698b) SHA1(7b8dd1f2215579b5ad69a2a1f11bfcd04e3d07f9) )
ROM_END


ROM_START( sc_vrgcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404018.lo", 0x00001, 0x080000, CRC(21ee4f08) SHA1(d2a89dcab0810eb1cccd6176dacbb2bfc96d7450) )
	ROM_LOAD16_BYTE( "95404019.hi", 0x00000, 0x080000, CRC(434fef1c) SHA1(3653a81213599272db63282573b1c639e630c6c2) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404076.lo", 0x00001, 0x080000, CRC(65551002) SHA1(fe41d92b0ca3137d1731d6d2cbcc94d4a9da6088) )
	ROM_LOAD16_BYTE( "95404077.hi", 0x00000, 0x080000, CRC(04550388) SHA1(7613591cabdf72628ad5a6915137cba43c427984) )
	ROM_LOAD16_BYTE( "95404548.lo", 0x00001, 0x080000, CRC(e8dacffe) SHA1(cc9034542d684bc300ffdf7a38e047f1ce0ca739) )
	ROM_LOAD16_BYTE( "95404549.hi", 0x00000, 0x080000, CRC(fa5075f9) SHA1(9f87a52c8f9ed64724be87e88fff833253d3e22a) )
	ROM_LOAD16_BYTE( "95404550.lo", 0x00001, 0x080000, CRC(b2ce484f) SHA1(88db91f7bce08ee6e84352286bc33df5d4c9a6d0) )
	ROM_LOAD16_BYTE( "95404551.hi", 0x00000, 0x080000, CRC(66ab7174) SHA1(ec4ae81c1f4e4a9a48c17f8aef798dff216aefc4) )
	ROM_LOAD16_BYTE( "95404634.lo", 0x00001, 0x080000, CRC(9e2ed4a0) SHA1(44c1707f9489e755f9035c039b7b976b1734630d) )
	ROM_LOAD16_BYTE( "95404635.hi", 0x00000, 0x080000, CRC(8249f713) SHA1(1f361f849985ae70c841b2b40658d40b1aa6b399) )
	ROM_LOAD16_BYTE( "95405548.lo", 0x00001, 0x080000, CRC(bba0c2bc) SHA1(c3a99423fc62920c5c1ca6fa4f0a3283ca6490f0) )
	ROM_LOAD16_BYTE( "95405549.hi", 0x00000, 0x080000, CRC(b113fe1d) SHA1(7883c34c403c532209137105a15f97f18311bf8a) )
	ROM_LOAD16_BYTE( "95405550.lo", 0x00001, 0x080000, CRC(2c882c37) SHA1(c35645c58d11971cc9d8717a7b27c1082259f07b) )
	ROM_LOAD16_BYTE( "95405551.hi", 0x00000, 0x080000, CRC(ac52e4c3) SHA1(2f93b3f262861e5ba54f70824fcc6961e66f935d) )
	ROM_LOAD16_BYTE( "95405634.lo", 0x00001, 0x080000, CRC(056413e9) SHA1(555dec6eea70135b6a12c0c3c0421618c321fb94) )
	ROM_LOAD16_BYTE( "95405635.hi", 0x00000, 0x080000, CRC(0046f382) SHA1(8d3cb10b44edba2cd677eab2618a610b0f9fa35c) )
	ROM_LOAD16_BYTE( "95412208.lo", 0x00001, 0x080000, CRC(3edfe2d8) SHA1(c4f12de7ed7db8fc317418a8adeea1a2f15ca7ef) )
	ROM_LOAD16_BYTE( "95412209.hi", 0x00000, 0x080000, CRC(509088c4) SHA1(c6b70ecd33599adb379586bbb2cbe3b58fce857b) )
	ROM_LOAD16_BYTE( "95413208.lo", 0x00001, 0x080000, CRC(4d34246d) SHA1(4bcfae186064f3d1619de336c74e8d4d5d4ef05f) )
	ROM_LOAD16_BYTE( "95413209.hi", 0x00000, 0x080000, CRC(e04b594c) SHA1(d1c5d00e3fc2a4fc6d612ca0d51b83851129398d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008143.bin", 0x0000, 0x100000, CRC(8bf35d69) SHA1(0a5017d02ba839f2f21402df99e7684ce559d931) )
	ROM_LOAD( "95008144.bin", 0x0000, 0x100000, CRC(1ce7f671) SHA1(ccca34515217e72ef1879a3cbad77c7adea3a665) )
//  ROM_LOAD( "very rich geezer club sound 1 bfg 70f5.bin", 0x0000, 0x100000, CRC(8bf35d69) SHA1(0a5017d02ba839f2f21402df99e7684ce559d931) )
//  ROM_LOAD( "very rich geezer club sound 2 bfg 7202.bin", 0x0000, 0x100000, CRC(1ce7f671) SHA1(ccca34515217e72ef1879a3cbad77c7adea3a665) )
ROM_END


ROM_START( sc_vivam )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400703.lo", 0x00001, 0x080000, CRC(611bee94) SHA1(207bad11a23fd88258ceb8adccd24ca09dd35600) )
	ROM_LOAD16_BYTE( "95400704.hi", 0x00000, 0x080000, CRC(62c4d22d) SHA1(e6a75ab77cdb01399f87a6b17d1f6b240c8e3fb2) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400705.lo", 0x00001, 0x080000, CRC(23f82b23) SHA1(9a18705864c53609164720f48017a3f758e3c07e) )
	ROM_LOAD16_BYTE( "95400706.hi", 0x00000, 0x080000, CRC(254244ea) SHA1(a861ff07ddefcc645cfe97990ad321968ac8352d) )
	ROM_LOAD16_BYTE( "95400985.lo", 0x00001, 0x080000, CRC(d2ccb5df) SHA1(40eaeaf23431846aed70a535dddc8ab4452c6934) )
	ROM_LOAD16_BYTE( "95400986.hi", 0x00000, 0x080000, CRC(4d1a78d6) SHA1(0765bd2db52752fff21b7909f98536a788f54f58) )
	ROM_LOAD16_BYTE( "95401703.lo", 0x00001, 0x080000, CRC(bdd484d4) SHA1(48a5501f06a0992e95f9f1c2bbe2d6efeb4ea47d) )
	ROM_LOAD16_BYTE( "95401704.hi", 0x00000, 0x080000, CRC(3aa93ae9) SHA1(4b98f5c1ebfd3326bbcb1d45d7adb788892a814d) )
	ROM_LOAD16_BYTE( "95401705.lo", 0x00001, 0x080000, CRC(583e6e00) SHA1(825d99d46adf12dfc3f7aa25e32a4faa28ae2535) )
	ROM_LOAD16_BYTE( "95401706.hi", 0x00000, 0x080000, CRC(b9e0ca1c) SHA1(4c7f655e53d8f1bf3afdafcd1296b0f182626e61) )
	ROM_LOAD16_BYTE( "95401985.lo", 0x00001, 0x080000, CRC(d7307e01) SHA1(06adc3c22000062beb4d16df6470a582fcd77fb6) )
	ROM_LOAD16_BYTE( "95401986.hi", 0x00000, 0x080000, CRC(b27ebf71) SHA1(f90d908d1fdab7f81903a7af5c699bbbde1a7157) )
	ROM_LOAD16_BYTE( "95406530.lo", 0x00001, 0x080000, CRC(d7b0d682) SHA1(ea6a2d919a4066eb278bc6a74b354678afb264da) )
	ROM_LOAD16_BYTE( "95406531.hi", 0x00000, 0x080000, CRC(6ced2032) SHA1(d89aa8d3d2a6aea92650634e9af63ded26b10265) )
	ROM_LOAD16_BYTE( "95407530.lo", 0x00001, 0x080000, CRC(f679842e) SHA1(eb11a0478295e7cc091d45957a6d1313098884b4) )
	ROM_LOAD16_BYTE( "95407531.hi", 0x00000, 0x080000, CRC(3924f97f) SHA1(9c4b99e36b723adb53c0f229c95afa55a35c26ed) )
	ROM_LOAD16_BYTE( "95410054.lo", 0x00001, 0x080000, CRC(6133a322) SHA1(fef8a250a15234c4edc9f0503b95d5fc39295383) )
	ROM_LOAD16_BYTE( "95410055.hi", 0x00000, 0x080000, CRC(4aca6d50) SHA1(99e91c14cf19f4b14797f2b9ada0a1c7dc527e30) )
	ROM_LOAD16_BYTE( "95410058.lo", 0x00001, 0x080000, CRC(5688892a) SHA1(68edeb781623b9c5622f8523612faf7f9e012f3b) )
	ROM_LOAD16_BYTE( "95410059.hi", 0x00000, 0x080000, CRC(4aa40ae2) SHA1(f9068b542697c188e26847205b7c72f518f987dc) )
	ROM_LOAD16_BYTE( "95411054.lo", 0x00001, 0x080000, CRC(0bb6da59) SHA1(21fc9b6a2e294b7ec25054bc3c08e72806e85c3f) )
	ROM_LOAD16_BYTE( "95411055.hi", 0x00000, 0x080000, CRC(3acd1951) SHA1(9250c42d28a6eb4364b3c30557d8270e85a56263) )
	ROM_LOAD16_BYTE( "95411058.lo", 0x00001, 0x080000, CRC(e98505e3) SHA1(6254c7016672a92e189970fcf79e3c3414bb7436) )
	ROM_LOAD16_BYTE( "95411059.hi", 0x00000, 0x080000, CRC(cedaf6bd) SHA1(9d459d8896d577d373e989042167ea46078de564) )
	ROM_LOAD16_BYTE( "p3010p41.hi", 0x00000, 0x080000, CRC(25ded37d) SHA1(3a24cae18d80e7f77975157d37483cecd3ed0e55) )
	ROM_LOAD16_BYTE( "p3010p41.lo", 0x00001, 0x080000, CRC(4cfc8f4d) SHA1(ecc7bb4ce72de9f7cbdaaf4ff5182bc9d1325f45) )
	ROM_LOAD16_BYTE( "p3010s41.hi", 0x00000, 0x080000, CRC(1003cf54) SHA1(34e47911517a77dfd113af14bae4f335207f30be) )
	ROM_LOAD16_BYTE( "p3010s41.lo", 0x00001, 0x080000, CRC(89c37841) SHA1(9b2d313c2498a1d05903490adbf9b0157a14e65f) )
	ROM_LOAD16_BYTE( "viva_mex.hi", 0x00000, 0x080000, CRC(521cea58) SHA1(a2a193c23843195e6f7ef666f3785869e11c9baa) )
	ROM_LOAD16_BYTE( "viva_mex.lo", 0x00001, 0x080000, CRC(ca5260f1) SHA1(1f2901e76db3c2cd615cf1efafc7e965c1ac48f1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004246.bin", 0x0000, 0x080000, CRC(4e5a0143) SHA1(a9e668aceb21671a78b584fd55c21d5501ea1f8a) )
	ROM_LOAD( "95004247.bin", 0x0000, 0x080000, CRC(4a35b6a1) SHA1(24e4ed93149b7f6caf785ecaa5a4685585a36f5b) )
	ROM_LOAD( "95008719.bin", 0x0000, 0x100000, CRC(f99eafef) SHA1(7a7dedf5bf8292b94ac6da78478441335bfcb66f) )
	ROM_LOAD( "95008720.bin", 0x0000, 0x100000, CRC(6419033f) SHA1(3d222696dd9f4f201596fd444a031690cc8c1b0d) )
	ROM_LOAD( "viva_mex.sn1", 0x0000, 0x080000, CRC(ed357575) SHA1(610047e83062fd4a6d23d9b9281a3a6c04d63f7d) )
	ROM_LOAD( "viva_mex.sn2", 0x0000, 0x080000, CRC(aab9421d) SHA1(db2941e013597be3fe05a2b002aebdfb0f7a2b41) )
ROM_END


ROM_START( sc_vmnv )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404300.lo", 0x00001, 0x080000, CRC(97526a2a) SHA1(0e650cd1e33bab5c2a7db6057053b8b15c2efa02) )
	ROM_LOAD16_BYTE( "95404301.hi", 0x00000, 0x080000, CRC(89a6384c) SHA1(022eddf0e93f86f10c78252f24502a319097920c) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p6984s16.hi", 0x00000, 0x080000, CRC(098c104b) SHA1(f9d28ced6d35e95bad7d406fe932dd887a3ed42e) )
	ROM_LOAD16_BYTE( "p6984s16.lo", 0x00001, 0x080000, CRC(957bdbb3) SHA1(2093a331c91d68b0aea66e5dd0b304b958a4b168) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_vmclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404686.lo", 0x00001, 0x080000, CRC(f3d7d462) SHA1(3de86eab8cab50924d5186b57863260dfd555bd7) )
	ROM_LOAD16_BYTE( "95404687.hi", 0x00000, 0x080000, CRC(07d6f891) SHA1(1b5ce61733b3c2adbda439dbca857693d34e3022) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405686.lo", 0x00001, 0x080000, CRC(5852e489) SHA1(987918f92b2cd53e09696ccf795f0e50ee44cde4) )
	ROM_LOAD16_BYTE( "95405687.hi", 0x00000, 0x080000, CRC(c73c6888) SHA1(6be3c7285ec975a4798c9ff9d59da3466e3b545a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008101.bin", 0x0000, 0x100000, CRC(751a433f) SHA1(36aaf1b2425c58bd49671fc6bd61addc33a082f1) )
	ROM_LOAD( "95008102.bin", 0x0000, 0x100000, CRC(155ec8ab) SHA1(5f38fb49facab94d041f315178a3d2adf9d95853) )
ROM_END


ROM_START( sc_wadzl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406160.lo", 0x00001, 0x080000, CRC(c4f62558) SHA1(ba8180828f42cecb94ec58b7ad36575c70d4bce3) )
	ROM_LOAD16_BYTE( "95406161.hi", 0x00000, 0x080000, CRC(6cb9e360) SHA1(a902bd3af145d92fe99fa51b81188f5674d9e6e1) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD( "95407160.lo", 0x00001, 0x080000, CRC(9fba6410) SHA1(41d5af5560a0de4e05975d35d5610e79ac985782) )
	ROM_LOAD( "95407161.hi", 0x00000, 0x080000, CRC(00a6c358) SHA1(85ab782804600272daf8de4b591f788dd0777893) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_wernr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402169.lo", 0x00001, 0x080000, CRC(0081b03f) SHA1(07f682278187ccb5cc2adc7be3e457a1966f9fa5) )
	ROM_LOAD16_BYTE( "95402170.hi", 0x00000, 0x080000, CRC(8deb5244) SHA1(e02c051bab6deb009a3b9e4716af29f16e66abba) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "gw_snd_1.8mb", 0x0000, 0x100000, CRC(990a3471) SHA1(356120558681440cac8252223c31fb9eca2572db) )
	ROM_LOAD( "gw_snd_2.8mb", 0x0000, 0x100000, CRC(468431e6) SHA1(90e8dd52b1ce752672b0a02d3cb7715cfa3fb49d) )
ROM_END


ROM_START( sc_wrnlt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402866.lo", 0x00001, 0x080000, CRC(9727bc1e) SHA1(166165dfe43a981d25ea32651b3527113942dc8f) )
	ROM_LOAD16_BYTE( "95402867.hi", 0x00000, 0x080000, CRC(c4a654de) SHA1(f41c867010ac9451ad96bb65b6349a6ab30c4a96) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_waw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402846.lo", 0x00001, 0x080000, CRC(fd7afc01) SHA1(62786a0cc5908451c672aece504590cb5596ddd9) )
	ROM_LOAD16_BYTE( "95402847.hi", 0x00000, 0x080000, CRC(0b12e6ee) SHA1(2f06c548b30d635c383d5408f31c264a7a6a7455) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95403369.lo", 0x00001, 0x080000, CRC(cd9f20c1) SHA1(7fb3c249c3d65a5288d870bc0eb1c331cf08f4e2) )
	ROM_LOAD16_BYTE( "95403370.hi", 0x00000, 0x080000, CRC(e5251c71) SHA1(2f7af921665a2cb458886e3bbc8e1133c5d6a90b) )
	ROM_LOAD16_BYTE( "95403456.lo", 0x00001, 0x080000, CRC(30765ea8) SHA1(9079118006dee0c49b154ae5462bd10afd129039) )
	ROM_LOAD16_BYTE( "95403457.hi", 0x00000, 0x080000, CRC(8d6f2111) SHA1(ac670aab260ac8d94615e5290e4650b47bf70a67) )
	ROM_LOAD16_BYTE( "95403846.lo", 0x00001, 0x080000, CRC(fa064a7c) SHA1(0820b51a84be3c102b2809f804b8c1aff7b79c9f) )
	ROM_LOAD16_BYTE( "95403847.hi", 0x00000, 0x080000, CRC(1319716c) SHA1(8960de17a15682a8ccea199207c5b988d0f358ab) )
	ROM_LOAD16_BYTE( "95404462.lo", 0x00001, 0x080000, CRC(2bbd8487) SHA1(1b2bc57c05b0eae7d7251f53422ada65bc2760ff) )
	ROM_LOAD16_BYTE( "95404463.hi", 0x00000, 0x080000, CRC(6cbc38db) SHA1(d9d7ea5abe4870ff0771bae28723ec7782bf96dc) )
	ROM_LOAD16_BYTE( "95405462.lo", 0x00001, 0x080000, CRC(82c07e2c) SHA1(94a4d263767435f38d65da8d6231bb28322a4ade) )
	ROM_LOAD16_BYTE( "95405463.hi", 0x00000, 0x080000, CRC(e92b8ddf) SHA1(693da6e5cbb30353d26b419d85d814f83616ae80) )
	ROM_LOAD16_BYTE( "wet__pound15.lo", 0x00001, 0x080000, CRC(3d2bcf6e) SHA1(12bbf1127b4e2046b58d47d01ca593c39d511ab1) )
	ROM_LOAD16_BYTE( "wet__pound15.hi", 0x00000, 0x080000, CRC(ea2e9311) SHA1(febce0cc05f25f11cb911d5583e18271038645c6) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004292.bin", 0x0000, 0x17ba49, CRC(a5a03ead) SHA1(f1319d0e254b980262e3d404410e6ddbf18057b6) )
ROM_END


ROM_START( sc_wdw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95400321.lo", 0x00001, 0x080000, CRC(f9040cc9) SHA1(cf74e5beb74cd94667a2ee9db7a5b53ac8512533) )
	ROM_LOAD16_BYTE( "95400322.hi", 0x00000, 0x080000, CRC(f234fb3c) SHA1(f87875b8c9c3879673e63f7f642f9ee71fe614c9) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95400323.lo", 0x00001, 0x080000, CRC(20d7d0e1) SHA1(bf159a55e4a71f3483ac7da52d9f67db850efaf1) )
	ROM_LOAD16_BYTE( "95400324.hi", 0x00000, 0x080000, CRC(722ad66e) SHA1(43578625d3fe62405468fffeb2555b5cc77fb928) )
	ROM_LOAD16_BYTE( "95400379.lo", 0x00001, 0x080000, CRC(8c9a5ef2) SHA1(310f92c930ce6d1d1cdc6573c8fdc9b32e5f46d8) )
	ROM_LOAD16_BYTE( "95400380.hi", 0x00000, 0x080000, CRC(ead1c62b) SHA1(39e71139810cd2aa7e41a33b237c3ef4154f29c6) )
	ROM_LOAD16_BYTE( "95400759.lo", 0x00001, 0x080000, CRC(f0f38034) SHA1(2c38870ce9051807a519cc54f33f0224546c2abc) )
	ROM_LOAD16_BYTE( "95400760.hi", 0x00000, 0x080000, CRC(70f91f2e) SHA1(d04f630242078b8668d701c221724c596fe3b92e) )
	ROM_LOAD16_BYTE( "95400761.lo", 0x00001, 0x080000, CRC(6401a1bc) SHA1(bce8992b6d3ff2e322b1a52f1813496e146a1861) )
	ROM_LOAD16_BYTE( "95400762.hi", 0x00000, 0x080000, CRC(ecf12b04) SHA1(483feede4eb4f2e92b3db1e4d7241b278a4d0a67) )
	ROM_LOAD16_BYTE( "95401321.lo", 0x00001, 0x080000, CRC(06e84686) SHA1(102259607447b5563f915c7c2e75aea60c36fdb0) )
	ROM_LOAD16_BYTE( "95401322.hi", 0x00000, 0x080000, CRC(d10b9b13) SHA1(60a4c343e2681465241691e7cb31226e9b24798c) )
	ROM_LOAD16_BYTE( "95401323.lo", 0x00001, 0x080000, CRC(b1a740e7) SHA1(9e09ce3f58aa688dfba77cf66be81967373db2e4) )
	ROM_LOAD16_BYTE( "95401324.hi", 0x00000, 0x080000, CRC(f8fb5c3b) SHA1(64b84bd246d0d305e4eee94f48605a0c51d051ce) )
	ROM_LOAD16_BYTE( "95401379.lo", 0x00001, 0x080000, CRC(a3d1d95c) SHA1(abe3a03dd9ab50f69fd5a144a912eb2118a7b4b9) )
	ROM_LOAD16_BYTE( "95401380.hi", 0x00000, 0x080000, CRC(ab89151d) SHA1(da1ffed3f780917f062a4a4dc1e101ba6ac5998a) )
	ROM_LOAD16_BYTE( "95401759.lo", 0x00001, 0x080000, CRC(99e31f91) SHA1(83e80cc10d54a315df751bd1b8dd646be0c6a1e3) )
	ROM_LOAD16_BYTE( "95401760.hi", 0x00000, 0x080000, CRC(70664916) SHA1(50135cb63bc631d75e0cb22233b932e0b5dd4099) )
	ROM_LOAD16_BYTE( "95401761.lo", 0x00001, 0x080000, CRC(6be8bf00) SHA1(74f7fc5f9989c91958837f12e512a2ea0bc00ab9) )
	ROM_LOAD16_BYTE( "95401762.hi", 0x00000, 0x080000, CRC(a34e3d2b) SHA1(74b97b7a8d07b13d3375c45862faa0e9a751ec84) )
	ROM_LOAD16_BYTE( "wdw15hi", 0x0000, 0x080000, CRC(46dcc106) SHA1(647add94380523292436981ce280d523a6569f69) )
	ROM_LOAD16_BYTE( "wdw15lo", 0x00001, 0x080000, CRC(88cc9c2a) SHA1(270a1f17b74f9ac619dd88cbde1c6da6b469ed67) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_leg )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404332.lo", 0x00001, 0x080000, CRC(7ff4995e) SHA1(f74b891c8987687bb9aa359aac5b498383227729) )
	ROM_LOAD16_BYTE( "95404333.hi", 0x00000, 0x080000, CRC(2e0e489c) SHA1(2d3f79c89f7b5ad036637980b1607385c9376839) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404334.lo", 0x00001, 0x080000, CRC(93a161e5) SHA1(429fc5d99f12f25a95de824f449a8c4ef939e507) )
	ROM_LOAD16_BYTE( "95404335.hi", 0x00000, 0x080000, CRC(8f1672a7) SHA1(088bf89cf8d189b18a85b3fbcc4ead2a9ca812c9) )
	ROM_LOAD16_BYTE( "95405332.lo", 0x00001, 0x080000, CRC(2e74e812) SHA1(4b08dc2e12ef659da2408f9d28bb6f125adf80a4) )
	ROM_LOAD16_BYTE( "95405333.hi", 0x00000, 0x080000, CRC(99df54d8) SHA1(03d6a106e3a1ebdfce23699b9d642b6201954e70) )
	ROM_LOAD16_BYTE( "95405334.lo", 0x00001, 0x080000, CRC(2ccd6c8a) SHA1(1b8443177beaf83be303a80ac452f39b470acb3a) )
	ROM_LOAD16_BYTE( "95405335.hi", 0x00000, 0x080000, CRC(3dbd4830) SHA1(1c01142fd43692e5ea614e9671d6b1fd9b6a3f50) )
	ROM_LOAD16_BYTE( "95406056.hi", 0x00000, 0x080000, CRC(62a94976) SHA1(da9796643b7fa7ad0906ec2447402b28f8fce362) )
	ROM_LOAD16_BYTE( "95406056.lo", 0x00001, 0x080000, CRC(be74ec40) SHA1(334543a08448ce68b149bcbb756ef6c7b1c14d67) )
	ROM_LOAD16_BYTE( "95406057.hi", 0x00000, 0x080000, CRC(62a94976) SHA1(da9796643b7fa7ad0906ec2447402b28f8fce362) )
	ROM_LOAD16_BYTE( "95406060.lo", 0x00001, 0x080000, CRC(70b0814f) SHA1(dd63ad9633d46b3b703b79a4a1220ccac4b7959e) )
	ROM_LOAD16_BYTE( "95406061.hi", 0x00000, 0x080000, CRC(4660a459) SHA1(4928a6a6d51dc745dff4663eeda1cf6af8f9ffd4) )
	ROM_LOAD16_BYTE( "95407056.lo", 0x00001, 0x080000, CRC(a7d254b6) SHA1(5e2c8f8d7c633ed0c8fac03a08133c4f54e217e7) )
	ROM_LOAD16_BYTE( "95407057.hi", 0x00000, 0x080000, CRC(f60c7c32) SHA1(4398b77ca86531bae4fd0b052602d837fe1d6f13) )
	ROM_LOAD16_BYTE( "95407060.lo", 0x00001, 0x080000, CRC(b3be6239) SHA1(cbe275e8a13e0a4cbc2c00404971dc97fd7d1ec8) )
	ROM_LOAD16_BYTE( "95407061.hi", 0x00000, 0x080000, CRC(edf316c3) SHA1(8caba456c2133f760999c8ef8e782739432aa987) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008093.bin", 0x0000, 0x100000, CRC(86e27465) SHA1(1d27358fe795286676a8031382387ff4225f7118) )
	ROM_LOAD( "95008094.bin", 0x0000, 0x100000, CRC(08909b00) SHA1(3e5b3da186036d7fe67ed2739de6fba79d4a978a) )
ROM_END


ROM_START( sc_legcb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404336.lo", 0x00001, 0x080000, CRC(622b31cd) SHA1(94ecdc0982baa92f5328446627d997f17a865630) )
	ROM_LOAD16_BYTE( "95404337.hi", 0x00000, 0x080000, CRC(229e8a0c) SHA1(f34d4063f2e1e098f6ee6f4ac015af0a423b402b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404380.lo", 0x00001, 0x080000, CRC(a66b2f18) SHA1(54bf8fb0613c20c16f9eacd247b83fbe201a4aa8) )
	ROM_LOAD16_BYTE( "95404381.hi", 0x00000, 0x080000, CRC(95f78581) SHA1(ea0c014102d60a54e481fa65564a351d94700d99) )
	ROM_LOAD16_BYTE( "95405336.lo", 0x00001, 0x080000, CRC(593a1dfd) SHA1(c7fe22e129ca4578c1e47ef78eded5ed5da0a787) )
	ROM_LOAD16_BYTE( "95405337.hi", 0x00000, 0x080000, CRC(7f85031d) SHA1(a8712c07147a406706ac5ad800768dc53450400c) )
	ROM_LOAD16_BYTE( "95405380.lo", 0x00001, 0x080000, CRC(eb0c6d92) SHA1(7eb660cdeeb442091c86977a564eb67a1bac167a) )
	ROM_LOAD16_BYTE( "95405381.hi", 0x00000, 0x080000, CRC(db763fde) SHA1(26caad76f16e0936a545a7481d978e19554d35fd) )
	ROM_LOAD16_BYTE( "95412206.lo", 0x00001, 0x080000, CRC(63b1e5a6) SHA1(d9ad4ac6eb57ec13e07ec359a9f214829fee30cd) )
	ROM_LOAD16_BYTE( "95412207.hi", 0x00000, 0x080000, CRC(2e684c7f) SHA1(90e43834bce1e2884428e2f1df3c1528f15c634b) )
	ROM_LOAD16_BYTE( "95413206.lo", 0x00001, 0x080000, CRC(76d29d4e) SHA1(1823fe130110b36fc715b88e35c590fab55618c7) )
	ROM_LOAD16_BYTE( "95413207.hi", 0x00000, 0x080000, CRC(b25594b1) SHA1(f3771534787f6bebd723552424a7968ec46261e4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008197.bin", 0x0000, 0x100000, CRC(234ff677) SHA1(571c2fa2b5a24d07e90e43061d9947f64874e482) )
	ROM_LOAD( "95008198.bin", 0x0000, 0x100000, CRC(4b03df47) SHA1(13c24cc90a618ebc7c150ab3694a1b787fb049d6) )
ROM_END


ROM_START( sc_wldbn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402876.lo", 0x00001, 0x080000, CRC(267e0d9a) SHA1(e7e615d3d0d036305a239d3d0070d6abeeeff8ed) )
	ROM_LOAD16_BYTE( "95402877.hi", 0x00000, 0x080000, CRC(cea65dca) SHA1(9b7b379683759673258b7f184004b5c6cf31c6d6) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402878.lo", 0x00001, 0x080000, CRC(b7c33be2) SHA1(5a21cbfa053f271b042c1f52e1cff16f30800e51) )
	ROM_LOAD16_BYTE( "95402879.hi", 0x00000, 0x080000, CRC(89ffe589) SHA1(43979e3fe14c876e9778bcf0ccfa16901c632c99) )
	ROM_LOAD16_BYTE( "95403876.lo", 0x00001, 0x080000, CRC(ff229596) SHA1(b0e499d709cb19e2eb6efbed31d77672b85f6d2c) )
	ROM_LOAD16_BYTE( "95403877.hi", 0x00000, 0x080000, CRC(680e88e1) SHA1(8b66d1746e6f429774bf637481ee41b3ab016f3d) )
	ROM_LOAD16_BYTE( "95403878.lo", 0x00001, 0x080000, CRC(5b3233fb) SHA1(fdc242e12ee4792efb097aeb96cde9292af2d286) )
	ROM_LOAD16_BYTE( "95403879.hi", 0x00000, 0x080000, CRC(60e8268d) SHA1(5f458f40806bb81728a4bb16b532b2391fa52f3c) )
	ROM_LOAD16_BYTE( "95410060.lo", 0x00001, 0x080000, CRC(9d73db8c) SHA1(5dfeabdcaa403ad31dd868aa001a5168c904083e) )
	ROM_LOAD16_BYTE( "95410061.hi", 0x00000, 0x080000, CRC(83b5c62c) SHA1(f433e2ca8d80a4e4d55e8c38dada961887f7e56a) )
	ROM_LOAD16_BYTE( "95410062.lo", 0x00001, 0x080000, CRC(ba531b0a) SHA1(98d1c3f15e39f7ee51141580479b4b37451fa042) )
	ROM_LOAD16_BYTE( "95410063.hi", 0x00000, 0x080000, CRC(1a7a2fbc) SHA1(16a18e951c47991fd3633cfb42bb9b1d8353f6c8) )
	ROM_LOAD16_BYTE( "95410064.lo", 0x00001, 0x080000, CRC(85dcb53d) SHA1(101392cf181d964c258f5bfcad5a4fa84f77caf6) )
	ROM_LOAD16_BYTE( "95410065.hi", 0x00000, 0x080000, CRC(9519c652) SHA1(54d891b9a45c642650a44be164bf94f9f0c47977) )
	ROM_LOAD16_BYTE( "95410582.lo", 0x00001, 0x080000, CRC(13299581) SHA1(391c827d1592e8090eebab57e28a482029403d8a) )
	ROM_LOAD16_BYTE( "95410583.hi", 0x00000, 0x080000, CRC(0c59c28f) SHA1(e590df5666f09439aef2352a72b608f032c15309) )
	ROM_LOAD16_BYTE( "95410584.lo", 0x00001, 0x080000, CRC(97614a28) SHA1(b4d643b62f3a2eafc83dc51cf356545f1ef315b8) )
	ROM_LOAD16_BYTE( "95410585.hi", 0x00000, 0x080000, CRC(4191c770) SHA1(5d681a9edc3e4d43781285c0d7cd1927790840b4) )
	ROM_LOAD16_BYTE( "95411060.lo", 0x00001, 0x080000, CRC(79ae7a14) SHA1(aae8e31b115cf54aa2d1997a5cae93db0e811500) )
	ROM_LOAD16_BYTE( "95411061.hi", 0x00000, 0x080000, CRC(b3a28869) SHA1(5536221e358e5d545369978fec62070d0b4a1257) )
	ROM_LOAD16_BYTE( "95411062.lo", 0x00001, 0x080000, CRC(53f2e0b2) SHA1(5472ab467fa1adb8eecc0cce348330d091f3222b) )
	ROM_LOAD16_BYTE( "95411063.hi", 0x00000, 0x080000, CRC(d16c20e7) SHA1(3aa22dbe6e3f4f56ba9614448199a69cf1ded868) )
	ROM_LOAD16_BYTE( "95411064.lo", 0x00001, 0x080000, CRC(63fffbf2) SHA1(361c502d22fc57c698d85d4a5fcd065a021f8ca3) )
	ROM_LOAD16_BYTE( "95411065.hi", 0x00000, 0x080000, CRC(469b08b3) SHA1(7cd44820d517bcbb4588ac5ba7599d60d65dfb6b) )
	ROM_LOAD16_BYTE( "95411582.lo", 0x00001, 0x080000, CRC(9e8953aa) SHA1(7823d79838ee2dd0d631b149680bbda25f334460) )
	ROM_LOAD16_BYTE( "95411583.hi", 0x00000, 0x080000, CRC(c896a4bd) SHA1(f78cbf64e85b2ed88e0798aa65e2ce5d7dd9c672) )
	ROM_LOAD16_BYTE( "95411584.lo", 0x00001, 0x080000, CRC(9905864b) SHA1(ef69b35ab10e63ff2e10b94889179aab0c08132c) )
	ROM_LOAD16_BYTE( "95411585.hi", 0x00000, 0x080000, CRC(ea0275ea) SHA1(68e9d894504eab0d8ade5ec770dc35f94cd6e0b5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_wldjk )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95409556.lo", 0x00001, 0x080000, CRC(5ceaee5c) SHA1(5e6dc9d69279032331da29096f29cba65fd37902) )
	ROM_LOAD16_BYTE( "95409557.hi", 0x00000, 0x080000, CRC(21384bcc) SHA1(22f8f678bb9934ba4ba1d730a6c9fe9829d2bbbf) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409558.lo", 0x00001, 0x080000, CRC(18f07626) SHA1(0c87938315ded313b1bfb5698d24a278ad6597ef) )
	ROM_LOAD16_BYTE( "95409559.hi", 0x00000, 0x080000, CRC(c4dc5df9) SHA1(f40dbb9df35c325ee8bda45663ae098d4c56b237) )
	ROM_LOAD16_BYTE( "95410088.lo", 0x00001, 0x080000, CRC(4fcb8ee4) SHA1(31e908492eaf2ee371f1530418587774910dfb8e) )
	ROM_LOAD16_BYTE( "95410089.hi", 0x00000, 0x080000, CRC(4770fbf6) SHA1(57c8f8d4da40c506b0f1d8afdcdef1b98ac8ca18) )
	ROM_LOAD16_BYTE( "95410114.lo", 0x00001, 0x080000, CRC(2f9649f4) SHA1(7912f8109716c92461e2bb9f212d7e49fc2e428d) )
	ROM_LOAD16_BYTE( "95410115.hi", 0x00000, 0x080000, CRC(ab9da179) SHA1(cc092847ca7604c03c7fd5492ede40683bbeb71f) )
	ROM_LOAD16_BYTE( "95411088.lo", 0x00001, 0x080000, CRC(1f4e4cf9) SHA1(d51161604f224c7b081e3e9e55ff1ab6dac241b9) )
	ROM_LOAD16_BYTE( "95411089.hi", 0x00000, 0x080000, CRC(c13bec5a) SHA1(4951d036ed5cd59c04801e705eea198c93aa9d05) )
	ROM_LOAD16_BYTE( "95411090.lo", 0x00001, 0x080000, CRC(e8a5edea) SHA1(ea4c488de8b07b0b427ca3230c6b81ca10b26174) )
	ROM_LOAD16_BYTE( "95411091.hi", 0x00000, 0x080000, CRC(b6a1a1d0) SHA1(75a736f5fe993fa03973903b0b9e7861f3979e04) )
	ROM_LOAD16_BYTE( "95411092.lo", 0x00001, 0x080000, CRC(b23b31ca) SHA1(5b50561764156c363987299a6d46420890aa5582) )
	ROM_LOAD16_BYTE( "95411093.hi", 0x00000, 0x080000, CRC(efea1fdc) SHA1(fb48cb6e732a416192081e9dc26a6eabc85ce90c) )
	ROM_LOAD16_BYTE( "95411114.lo", 0x00001, 0x080000, CRC(7f138be9) SHA1(b4a01a0a3de1588dc0676cd360887e066caad260) )
	ROM_LOAD16_BYTE( "95411115.hi", 0x00000, 0x080000, CRC(2dd6b6d5) SHA1(cf66389b8e6c2c2bb996ddac9033dd0607669520) )
	ROM_LOAD16_BYTE( "95420552.lo", 0x00001, 0x080000, CRC(27c67626) SHA1(8ec95b1bed40c710f1ce67f722009c7fd886fdf4) )
	ROM_LOAD16_BYTE( "95420553.hi", 0x00000, 0x080000, CRC(e058b60d) SHA1(ba6fe8e6fbb0d1bf8064e6c8dd5eedbaa2afff16) )
	ROM_LOAD16_BYTE( "95421552.lo", 0x00001, 0x080000, CRC(7dd4a966) SHA1(792679ba64495bbfefdd7a4d4db8981d83ad4a0e) )
	ROM_LOAD16_BYTE( "95421553.hi", 0x00000, 0x080000, CRC(f9826f0f) SHA1(c62e820fe9ac6a2c7691a9c1b2d43158c006c9ec) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008999.bin", 0x0000, 0x0b4dd9, CRC(0fa36a2e) SHA1(0168a326fd50c15e8f48293dff45e1411e5044f8) )
	ROM_REGION( 0x400000, "pics", 0 )
	ROM_LOAD( "95890709.bin", 0x0000, 0x5000, CRC(4b3ba87a) SHA1(6ec85bc6d14825ea0a497e6ee6e38d17c0c7b79f) )
	ROM_LOAD( "95890710.bin", 0x0000, 0x5000, CRC(3eadec4e) SHA1(bbb80a6325fd561ca762a0261b68b550285bb8f6) )
	ROM_LOAD( "95890711.bin", 0x0000, 0x5000, CRC(a0172012) SHA1(07ceb089ec88801700ea12f52e4cc49e8c1d5d36) )
ROM_END


ROM_START( sc_wthng )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402371.lo", 0x00001, 0x080000, CRC(8cde578d) SHA1(2fe764c8a018ee7893ac3d6ce54f73455cfc9395) )
	ROM_LOAD16_BYTE( "95402372.hi", 0x00000, 0x080000, CRC(aced6068) SHA1(6519ddecec8ec200161d273d3279b8eb2e752610) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402512.lo", 0x00001, 0x080000, CRC(a0e0fe7a) SHA1(076f646b44a1fae6c27ad3875dc8a86214dbe2fc) )
	ROM_LOAD16_BYTE( "95402513.hi", 0x00000, 0x080000, CRC(409e66d8) SHA1(8fe03bca8140b919f77893571ff8d2e9e8079d60) )
	ROM_LOAD16_BYTE( "95403371.lo", 0x00001, 0x080000, CRC(5863f65b) SHA1(f56f613decbd19944f3276045465450788f46d66) )
	ROM_LOAD16_BYTE( "95403372.hi", 0x00000, 0x080000, CRC(6983fc12) SHA1(c68242d707e4ecfe93a6ec2ecb27bb74d4b5e8b6) )
	ROM_LOAD16_BYTE( "95403512.lo", 0x00001, 0x080000, CRC(25798118) SHA1(09d120509e53fb47cee5263c09f9d421eca8a8d3) )
	ROM_LOAD16_BYTE( "95403513.hi", 0x00000, 0x080000, CRC(ab6bab04) SHA1(6561ffcf822c9228a04c79cc4795eb408f41ed95) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_wthnm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412264.lo", 0x00001, 0x080000, CRC(bace4f11) SHA1(0a9c3ad35c547c513aca290e03af968050def5e9) )
	ROM_LOAD16_BYTE( "95412265.hi", 0x00000, 0x080000, CRC(cd1c4e6e) SHA1(b564bea4e1a19a533e54163e0fb19b66afbb7317) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95413264.lo", 0x00001, 0x080000, CRC(76fe4465) SHA1(2b8612cd55f75337f4f14f71d54f45ed37810bce) )
	ROM_LOAD16_BYTE( "95413265.hi", 0x00000, 0x080000, CRC(d912122d) SHA1(c97f0d6ec98a64ead447ecbbad6b36b054e9100f) )
	ROM_LOAD16_BYTE( "95415092.lo", 0x00001, 0x080000, CRC(53ee4489) SHA1(1c12f0abde9827d9bb8dfe90b40c578f5b1933d1) )
	ROM_LOAD16_BYTE( "95415093.hi", 0x00000, 0x080000, CRC(30759ce6) SHA1(d75f0a978f220dfba05e78817bdecf1a47de654b) )
	ROM_LOAD16_BYTE( "95415996.lo", 0x00001, 0x080000, CRC(dceffb2f) SHA1(467f4b8e0410c3672c72ab444f7b51666f393a57) )
	ROM_LOAD16_BYTE( "95415997.hi", 0x00000, 0x080000, CRC(0c5d7998) SHA1(75759b0af87f04c459e3fdc1554b215bdc5a6278) )
	ROM_LOAD16_BYTE( "95415998.lo", 0x00001, 0x080000, CRC(4caccab6) SHA1(07da95fafbca8982202af67f32a53c5829b2ba24) )
	ROM_LOAD16_BYTE( "95415999.hi", 0x00000, 0x080000, CRC(15552b8f) SHA1(f120b65568eba18d53ee40cb0392663dc6eb4dcd) )
	ROM_LOAD16_BYTE( "95417012.lo", 0x00001, 0x080000, CRC(16879c8d) SHA1(f976dee82c6a05a4c2bb016cdc4d1636df11a5b0) )
	ROM_LOAD16_BYTE( "95417013.hi", 0x00000, 0x080000, CRC(687dd1f9) SHA1(b2b5cc21a4a6bd4ef4bf37a235b9f03b323791d4) )
	ROM_LOAD16_BYTE( "95417014.lo", 0x00001, 0x080000, CRC(75e910f3) SHA1(bf7794651721797870ee148e2249f53acea3b441) )
	ROM_LOAD16_BYTE( "95417015.hi", 0x00000, 0x080000, CRC(b8d5f355) SHA1(b15c6509358334ffe9f750b96a25e4381e874e1d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_wtc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404512.lo", 0x00001, 0x080000, CRC(d19da45b) SHA1(797ac1f6a97454bdaa1fb1dee892ee242fba8872) )
	ROM_LOAD16_BYTE( "95404513.hi", 0x00000, 0x080000, CRC(5b96b3d8) SHA1(8f9dfdf3ee27ddafcf3372e62cd48a365d0d8b8b) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95404514.lo", 0x00001, 0x080000, CRC(3974cde4) SHA1(63ba97d8a38d4ab4da534c3694de0371c3774d5a) )
	ROM_LOAD16_BYTE( "95404515.hi", 0x00000, 0x080000, CRC(7b49a314) SHA1(eba6dc7c3c9a886fb135e85270f4cb08f10eea75) )
	ROM_LOAD16_BYTE( "95405512.lo", 0x00001, 0x080000, CRC(8f023916) SHA1(7dda48feb0ade5bebb515fbc45bb784ccd541a8f) )
	ROM_LOAD16_BYTE( "95405513.hi", 0x00000, 0x080000, CRC(4f98ef9b) SHA1(ea706a37f848014b13e318944f8ecad03ca00846) )
	ROM_LOAD16_BYTE( "95405516.lo", 0x00001, 0x080000, CRC(53c6c8a6) SHA1(25ea04184f43e842cc6e6772ca3fd1efca86c7c5) )
	ROM_LOAD16_BYTE( "95405517.hi", 0x00000, 0x080000, CRC(b7e08463) SHA1(dbcb1fb6a06ca1f9c100c6beaaec98a153b52572) )
	ROM_LOAD16_BYTE( "95405518.lo", 0x00001, 0x080000, CRC(cdfb2f40) SHA1(d168eb292e35c551cec63769a52259d39b4d55ca) )
	ROM_LOAD16_BYTE( "95405519.hi", 0x00000, 0x080000, CRC(056732b2) SHA1(271cac84becb847e2916897820ba27ad2f62cc4c) )
	ROM_LOAD16_BYTE( "95406406.lo", 0x00001, 0x080000, CRC(d5debf25) SHA1(cee6034eb0994cd4deccf9f42b7b0ca8a971668f) )
	ROM_LOAD16_BYTE( "95406407.hi", 0x00000, 0x080000, CRC(e7aaf70b) SHA1(5ecf4d60ad163f54e5dc34aee3d265b2a92387f6) )
	ROM_LOAD16_BYTE( "95407406.lo", 0x00001, 0x080000, CRC(214864a1) SHA1(680daf34460dcce8080782068f36a6d50b508041) )
	ROM_LOAD16_BYTE( "95407407.hi", 0x00000, 0x080000, CRC(9dc6d390) SHA1(1ae57bf771266ee5f302ad22a3241b0d9409ce3f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_wspin )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414962.odd", 0x00001, 0x080000, CRC(bcf5b2e5) SHA1(07c15798d23c4adba0cef2281f81ca9f715ae2f1) )
	ROM_LOAD16_BYTE( "95414963.evn", 0x00000, 0x080000, CRC(5f8539af) SHA1(1889e351a3d808d52917d0a56ef4e8ce5cf81042) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416048.odd", 0x00001, 0x080000, CRC(52b89fce) SHA1(6a56f58ee44110cfec2da02389089e075daf52c3) )
	ROM_LOAD16_BYTE( "95416049.evn", 0x00000, 0x080000, CRC(bfe02b55) SHA1(ba63d26b04f8962b39f30304806d39db71540457) )
	ROM_LOAD16_BYTE( "95416072.odd", 0x00001, 0x080000, CRC(e70b27cb) SHA1(857284ac95a3354317915dfd94f8d794c29267da) )
	ROM_LOAD16_BYTE( "95416073.evn", 0x00000, 0x080000, CRC(83f8e087) SHA1(da99388b3084728c5ef086610948a8f01c538315) )
	ROM_LOAD16_BYTE( "95417048.odd", 0x00001, 0x080000, CRC(0ee5dd5a) SHA1(383c9c67295ae10fe7f78fc7da01b31e8b10d0ca) )
	ROM_LOAD16_BYTE( "95417049.evn", 0x00000, 0x080000, CRC(7a8eb72f) SHA1(47b29e6ef18c0b1da41f6397e6c52ebf09959228) )
	ROM_LOAD16_BYTE( "95417072.odd", 0x00001, 0x080000, CRC(9c705a07) SHA1(c873115a6769cea96d7276e9d4e89e70c3b7d276) )
	ROM_LOAD16_BYTE( "95417073.evn", 0x00000, 0x080000, CRC(82591acf) SHA1(70bac24f6b7df4b321460342c358cf0ef1c42d86) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008516.bin", 0x0000, 0x0c35e4, CRC(b8deeea9) SHA1(5bc5f96e5f1b994448d90f05eea2e1c01e17ab66) )
ROM_END


ROM_START( sc_wwys )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1301p13.hi", 0x00000, 0x080000, CRC(62e6c8a1) SHA1(938df49c93274650ee078ed31980eb6b2465315d) )
	ROM_LOAD16_BYTE( "p1301p13.lo", 0x00001, 0x080000, CRC(5e98d205) SHA1(e73a7f59b9c4ab1772678f2b0d7d88f0bec14dcb) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1301s13.hi", 0x00000, 0x080000, CRC(78a947e3) SHA1(aea4fa72cae0121c5a15812d227f43080f04a2a2) )
	ROM_LOAD16_BYTE( "p1301s13.lo", 0x00001, 0x080000, CRC(c36ed88b) SHA1(287c6bfa5d1398b7efd21bc9565ad4d2557f7378) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008277.bin", 0x0000, 0x100000, CRC(19051eb6) SHA1(accc9b452dd80e6ca40e79dcc7d4fc6d4f234243) )
ROM_END


ROM_START( sc_winxp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406368.lo", 0x00001, 0x080000, CRC(cb014e09) SHA1(1e1fc13b5cf6c027a169ad9379e44a41ee22ef18) )
	ROM_LOAD16_BYTE( "95406369.hi", 0x00000, 0x080000, CRC(77128fec) SHA1(c6add5d90e1cb621589e988012eda7b2a3e0a568) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004265.snd", 0x0000, 0x080000, CRC(1e3e761d) SHA1(81c1e1af72836b25a053cf62c52341a0f8837e3e) )
ROM_END


ROM_START( sc_winsp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414890.odd", 0x00001, 0x080000, CRC(b236cae2) SHA1(19511af3f728615fea097d283072844602a228f9) )
	ROM_LOAD16_BYTE( "95414891.evn", 0x00000, 0x080000, CRC(acd72d71) SHA1(8ecebbf828a001b6ce3339c5237fddb05d2135ff) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414892.odd", 0x00001, 0x080000, CRC(0fd370d3) SHA1(7765109f28ee823fbc3066f03e06836702151bd7) )
	ROM_LOAD16_BYTE( "95414893.evn", 0x00000, 0x080000, CRC(21b3d497) SHA1(6b77e3e200c86fc826fa0b50b85cee795f768e65) )
	ROM_LOAD16_BYTE( "95414894.odd", 0x00001, 0x080000, CRC(758b2b7d) SHA1(ed115f78317a69e7953321b3bb1293e7b857f0d3) )
	ROM_LOAD16_BYTE( "95414895.evn", 0x00000, 0x080000, CRC(52b8f1c5) SHA1(428b4f3bc55e180763df3707cfb1044a9181e724) )
	ROM_LOAD16_BYTE( "95414896.odd", 0x00001, 0x080000, CRC(7ff2ff25) SHA1(c48221410c507d44b83fba6f62c860c1c69b14d1) )
	ROM_LOAD16_BYTE( "95414897.evn", 0x00000, 0x080000, CRC(0f3329e4) SHA1(da2afebd87c95fd74abd8a09c301d8ffe8389550) )
	ROM_LOAD16_BYTE( "95414908.odd", 0x00001, 0x080000, CRC(98870df3) SHA1(d3749471939d035288dd957ba63787f1b1be4e74) )
	ROM_LOAD16_BYTE( "95414909.evn", 0x00000, 0x080000, CRC(a725a4a9) SHA1(f5a1e6f3b026c45a9df6b292a422afa59d115cfd) )
	ROM_LOAD16_BYTE( "95414984.odd", 0x00001, 0x080000, CRC(b6d64685) SHA1(039f1bdde77acfff313abde8acf6dffcfc6c2a90) )
	ROM_LOAD16_BYTE( "95414985.evn", 0x00000, 0x080000, CRC(bae2b240) SHA1(2946c21d540a1631c6418766aeb2851cf07bf628) )
	ROM_LOAD16_BYTE( "95414986.odd", 0x00001, 0x080000, CRC(b417ee3c) SHA1(7767a6a2b01b3073b18c3dd444e7a07b0671905e) )
	ROM_LOAD16_BYTE( "95414987.evn", 0x00000, 0x080000, CRC(b521ec03) SHA1(e5f5e49bc591551a28c70b4aa997577c0652f4d6) )
	ROM_LOAD16_BYTE( "95414988.odd", 0x00001, 0x080000, CRC(68c56a33) SHA1(b494de885163227f8d3e735b4b35503273d953d8) )
	ROM_LOAD16_BYTE( "95414989.evn", 0x00000, 0x080000, CRC(b69b4d7e) SHA1(e5ece3ba353e1630d3ae4d2766d8c54f064945a9) )
	ROM_LOAD16_BYTE( "95415892.odd", 0x00001, 0x080000, CRC(58611d9b) SHA1(a31137a1d21281d9defd884080f504d013435cb2) )
	ROM_LOAD16_BYTE( "95415893.evn", 0x00000, 0x080000, CRC(c59f7022) SHA1(2ae528880152d0763037feed3ea46bf19407bd9c) )
	ROM_LOAD16_BYTE( "95415894.odd", 0x00001, 0x080000, CRC(6a0793ad) SHA1(ffab484074c896cf8a14463dda6b47cd3ef2a2f9) )
	ROM_LOAD16_BYTE( "95415895.evn", 0x00000, 0x080000, CRC(050c7068) SHA1(744c0f44b79d9ff6fb2bad4ca92d1b55ba585b1c) )
	ROM_LOAD16_BYTE( "95415896.odd", 0x00001, 0x080000, CRC(607e47f5) SHA1(c22c3fcfbea5e656eddd8e55533d709a248d98ca) )
	ROM_LOAD16_BYTE( "95415897.evn", 0x00000, 0x080000, CRC(5887a849) SHA1(f5ae020e23f23407f39153413772a51ec9fa9507) )
	ROM_LOAD16_BYTE( "95415908.odd", 0x00001, 0x080000, CRC(e99d8830) SHA1(730c8ae6b9f81835862e6ede7b3d7624b44339fd) )
	ROM_LOAD16_BYTE( "95415909.evn", 0x00000, 0x080000, CRC(8bc3adef) SHA1(6499cc21550867ede2484348ab826ee38c9ef0d6) )
	ROM_LOAD16_BYTE( "95415984.odd", 0x00001, 0x080000, CRC(909e4fa8) SHA1(391638f35b2768f67dd0626d5afea00ce4859a28) )
	ROM_LOAD16_BYTE( "95415985.evn", 0x00000, 0x080000, CRC(80e8e99d) SHA1(ac5ee0db62a9ac789e6b02b65e93ddc92a95794c) )
	ROM_LOAD16_BYTE( "95415986.odd", 0x00001, 0x080000, CRC(2c811199) SHA1(d16790e0a4a8161be75060f59fa4156c08dea78c) )
	ROM_LOAD16_BYTE( "95415987.evn", 0x00000, 0x080000, CRC(1ccf0679) SHA1(1941cc6e88a6bf769302c0e260e34f516ff222f1) )
	ROM_LOAD16_BYTE( "95415988.odd", 0x00001, 0x080000, CRC(f0539596) SHA1(513170b69aaff10244a5c556dadbd232ab7e2542) )
	ROM_LOAD16_BYTE( "95415989.evn", 0x00000, 0x080000, CRC(1f75a704) SHA1(13731ec1bdd8a780bf5b117b4de8e95710774155) )
	ROM_LOAD16_BYTE( "95416043.hi", 0x00000, 0x080000, CRC(61d1a38b) SHA1(631b14ed69cdf39473677ae42ebe3ed0046b221c) )
	ROM_LOAD16_BYTE( "95416114.odd", 0x00001, 0x080000, CRC(faefa0a4) SHA1(b75258b7b03c8e3af5294ecfc58db39a686dae10) )
	ROM_LOAD16_BYTE( "95416115.evn", 0x00000, 0x080000, CRC(458dd65c) SHA1(21be5720c5d46286ccc45ac5f46a88ecb6cd35ff) )
	ROM_LOAD16_BYTE( "95416145.hi", 0x00000, 0x080000, CRC(6acba346) SHA1(93240893f6a988ee1bd24feb862ed2d0681de976) )
	ROM_LOAD16_BYTE( "95416150.odd", 0x00001, 0x080000, CRC(7f0302c3) SHA1(43a4800904f0785996175ffdbbe40c5afa4370b4) )
	ROM_LOAD16_BYTE( "95416151.evn", 0x00000, 0x080000, CRC(e4cd7e83) SHA1(53027a6db2961878a70f7bbfe30a1e661a625323) )
	ROM_LOAD16_BYTE( "95416348.odd", 0x00001, 0x080000, CRC(ef3e1d73) SHA1(93da61a878c2d33ec8f490c8aae39f1baf033100) )
	ROM_LOAD16_BYTE( "95416349.evn", 0x00000, 0x080000, CRC(6a771259) SHA1(83cb40367d3ea9601d343db7baae3e8df81b57b9) )
	ROM_LOAD16_BYTE( "95416350.odd", 0x00001, 0x080000, CRC(b1dacd4f) SHA1(c52554810ad8ff05d737e8f3f4d25e5074aff547) )
	ROM_LOAD16_BYTE( "95416351.evn", 0x00000, 0x080000, CRC(b7744719) SHA1(1443b274b61297f92411c6ac1abe79d07b881c67) )
	ROM_LOAD16_BYTE( "95416352.odd", 0x00001, 0x080000, CRC(8cc72003) SHA1(c87f4128f4131c444fb0dea19e493ce7a38714be) )
	ROM_LOAD16_BYTE( "95416353.evn", 0x00000, 0x080000, CRC(ce28b419) SHA1(8a18c835c561d9a1d5ea8f4ec1e7bde6aef78567) )
	ROM_LOAD16_BYTE( "95416354.odd", 0x00001, 0x080000, CRC(3ba7aed6) SHA1(21f05531c6f919d5467adb2bae02e46283883e24) )
	ROM_LOAD16_BYTE( "95416355.evn", 0x00000, 0x080000, CRC(80c59dc5) SHA1(4bbf03a721ad87101979774e67782bf09d9ca184) )
	ROM_LOAD16_BYTE( "95417114.odd", 0x00001, 0x080000, CRC(250f1566) SHA1(5fb712a2662c6eb70b401a28befdd451026b3127) )
	ROM_LOAD16_BYTE( "95417115.evn", 0x00000, 0x080000, CRC(b5af2eaa) SHA1(51a37c811be4566478ead5fede7f8dc82927ea1e) )
	ROM_LOAD16_BYTE( "95417150.odd", 0x00001, 0x080000, CRC(5223412f) SHA1(ee8c3024e69c78319246c0cadaf46e0d63c69192) )
	ROM_LOAD16_BYTE( "95417151.evn", 0x00000, 0x080000, CRC(6e1cf4d6) SHA1(b0a2afb65580da98fc8379210991433ef25f5801) )
	ROM_LOAD16_BYTE( "95417348.odd", 0x00001, 0x080000, CRC(5e838229) SHA1(8d07f9ef8b1ed071f2a55bb3c6647410c6b7c559) )
	ROM_LOAD16_BYTE( "95417349.evn", 0x00000, 0x080000, CRC(8ffa4ca4) SHA1(b0cfd9fbdaf40f22ae293ef836c3493fca195304) )
	ROM_LOAD16_BYTE( "95417350.odd", 0x00001, 0x080000, CRC(f7bcae3d) SHA1(5b4becb70bdfc8ed971b4b6663ba352493dc378c) )
	ROM_LOAD16_BYTE( "95417351.evn", 0x00000, 0x080000, CRC(8f9c121c) SHA1(876b54be2e9995cc91d3efc45e0a8ac99ad377c1) )
	ROM_LOAD16_BYTE( "95417352.odd", 0x00001, 0x080000, CRC(caa14371) SHA1(a9e3c3823746abde54478168876cb56e4b6e0959) )
	ROM_LOAD16_BYTE( "95417353.evn", 0x00000, 0x080000, CRC(f6c0e11c) SHA1(e383588102ada0a08bd5dea32e654a3882acbed8) )
	ROM_LOAD16_BYTE( "95417354.odd", 0x00001, 0x080000, CRC(0a6afe0c) SHA1(73f4a4eb7c7ebb6f8c685f7c902808819068d8c3) )
	ROM_LOAD16_BYTE( "95417355.evn", 0x00000, 0x080000, CRC(7ddc0282) SHA1(3e79a277276adf384a3065c29d8e358f2a534296) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008504.bin", 0x0000, 0x0bd369, CRC(c27f88ca) SHA1(bfc34cc433b68dc6377af7ee464cbdb74a6e0e8d) )
ROM_END


ROM_START( sc_wondw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1318p11.hi", 0x00000, 0x080000, CRC(3704daa2) SHA1(2e20ea8473d69432b17d6d3ce6d241dc0331345e) )
	ROM_LOAD16_BYTE( "p1318p11.lo", 0x00001, 0x080000, CRC(5c28ed76) SHA1(b2ce5a73410cba6579bbb37dae23d220611af7a4) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1318s11.hi", 0x00000, 0x080000, CRC(f9b2dcf0) SHA1(873adac0859ec1d64858be0320369e8b99a0af32) )
	ROM_LOAD16_BYTE( "p1318s11.lo", 0x00001, 0x080000, CRC(603e115b) SHA1(46e626e25b204b657d065531d475c498b74df61f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008330.bin", 0x0000, 0x100000, CRC(15e80096) SHA1(da02a8afc83400fdf1ead9dad8a461eb9e911586) )
ROM_END


ROM_START( sc_xmark )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1116p16.hi", 0x00000, 0x080000, CRC(53c9161a) SHA1(0afb525a4b28f5068dc04b274881712190fbdff6) )
	ROM_LOAD16_BYTE( "p1116p16.lo", 0x00001, 0x080000, CRC(f409ccb9) SHA1(ef60f3bae17b3d11e4307b1f93c9a21721f10511) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1116s16.hi", 0x00000, 0x080000, CRC(383bbaf0) SHA1(50e3929f8c726c010f434a43b3052af7b03d1dfc) )
	ROM_LOAD16_BYTE( "p1116s16.lo", 0x00001, 0x080000, CRC(534cac1a) SHA1(92006516a77d367c7712ba3474c4bcfa994c47ec) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008263.bin", 0x0000, 0x100000, CRC(43507f43) SHA1(a5eb9e142847a338bf18f4b26da7fe5a2807a027) )
ROM_END


ROM_START( sc_xcash )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408160.lo", 0x00001, 0x080000, CRC(2532bc0a) SHA1(a4886fb10bf3d9c44f702d26dc82a5c54b6ea975) )
	ROM_LOAD16_BYTE( "95408161.hi", 0x00000, 0x080000, CRC(2b6ca545) SHA1(87cdb7c0723b31015560953b2393625ce147c508) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95004321.snd", 0x0000, 0x080000, CRC(97682381) SHA1(b1ef910e7b2e3574576fb6583a088c3de61e6019) )
ROM_END


ROM_START( sc_unk )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410476.lo", 0x00001, 0x080000, CRC(511f86b5) SHA1(3d6fe59bd19fb5b3a581781867b3b81dd0f77762) )
	ROM_LOAD16_BYTE( "95410477.hi", 0x00000, 0x080000, CRC(436bd1a7) SHA1(1f88e9f3b99601004c419530537efb063997a156) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_s16 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416184.lo", 0x00001, 0x080000, CRC(1c96f8f2) SHA1(5afb19c9ce8f83dda7208f68ed6e6a402662ac16) )
	ROM_LOAD16_BYTE( "95416185.hi", 0x00000, 0x080000, CRC(a03534ee) SHA1(1af3c2defeafdf0fd43bef7112ee63778ba75f0f) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417184.lo", 0x00001, 0x080000, CRC(f126c832) SHA1(afca10926c41be212c36438f47d829c7f5df9ed0) )
	ROM_LOAD16_BYTE( "95417185.hi", 0x00000, 0x080000, CRC(5c8d51e1) SHA1(e6a08ab10dddb04a432578edacbef21fcd68eec6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END





ROM_START( sc_plays )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424604.lo", 0x00001, 0x080000, CRC(5246dbec) SHA1(427134776ec8301c2eaea0c998234dd439952749) )
	ROM_LOAD16_BYTE( "95424605.hi", 0x00000, 0x080000, CRC(e975cc4e) SHA1(7dc7700eefded96076cf79d6a16cbcb24c06aa9d) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425604.lo", 0x00001, 0x080000, CRC(0b0d5566) SHA1(a8c8ba0f05bd9b17fe7ea97ff25e407b559bfe6e) )
	ROM_LOAD16_BYTE( "95425605.hi", 0x00000, 0x080000, CRC(62e1c485) SHA1(7c006b69c1748ef16e6ba4fdf8684fca58d5f1ff) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891106.bin", 0x0000, 0x5000, CRC(1f616820) SHA1(c0b19d4243f250c3159564c65e9a2247e61e315f) )
	ROM_LOAD( "95891107.bin", 0x0000, 0x5000, CRC(6af72c14) SHA1(4666e338fc629a32178f617c8536e7f11d703b14) )
	ROM_LOAD( "95891108.bin", 0x0000, 0x5000, CRC(f44de048) SHA1(783ae2b12e8e548a90f626a2050968e3f38b6042) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009013.bin", 0x0000, 0x0f3ee2, CRC(f324a590) SHA1(0533af3304100c99af5fdeba2773d92384101f43) )
ROM_END



ROM_START( sc_adga )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426374.lo", 0x00001, 0x080000, CRC(e5a83baa) SHA1(893f711cc4c336d590b573a5d2be3eca71f504bb) )
	ROM_LOAD16_BYTE( "95426375.hi", 0x00000, 0x080000, CRC(584703e9) SHA1(81da9b9b69779e1d69a2e771065113f6e3d1228f) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427374.lo", 0x00001, 0x080000, CRC(77d2ba04) SHA1(f192edc5f0c7c487737d5a2b26b481ed37e287c7) )
	ROM_LOAD16_BYTE( "95427375.hi", 0x00000, 0x080000, CRC(35e3bc9f) SHA1(e1b5f9d8f32f10f03ea208e40a759fff663e7af8) )
	ROM_LOAD16_BYTE( "p3214p13.hi", 0x00000, 0x080000, CRC(07a89d93) SHA1(ce636454372274955edf61e837b11525916cb059) )
	ROM_LOAD16_BYTE( "p3214p13.lo", 0x00001, 0x080000, CRC(6d132a98) SHA1(d3b4d7d336ab186c2962dc2da9cfc593c9dc182d) )
	ROM_LOAD16_BYTE( "p3214s13.hi", 0x00000, 0x080000, CRC(0b9888e7) SHA1(92f6e42782a000163089c60e20f98930a2de0601) )
	ROM_LOAD16_BYTE( "p3214s13.lo", 0x00001, 0x080000, CRC(ab2a0599) SHA1(e0be6369c0ee4d8542f3a29ad4fc9cfe1ad73c62) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_adgtc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3214p11.hi", 0x00000, 0x080000, CRC(dff99bd2) SHA1(4108684ccdb77d723e53a8adb258eb422502b624) )
	ROM_LOAD16_BYTE( "p3214p11.lo", 0x00001, 0x080000, CRC(7bd8446b) SHA1(d0d66edf560fc518b48a3ae93aa51233837479a5) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3214s11.hi", 0x00000, 0x080000, CRC(4869c664) SHA1(4338e941d6756b4f2f4b86a47789ebf956c10333) )
	ROM_LOAD16_BYTE( "p3214s11.lo", 0x00001, 0x080000, CRC(937fe069) SHA1(393671b649608e2f43534636bda42199b2c19f32) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_adsnt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412702.lo", 0x00001, 0x080000, CRC(3993a885) SHA1(5672c8c617d14f0898726a22bc4fbb52ef570c1e) )
	ROM_LOAD16_BYTE( "95412703.hi", 0x00000, 0x080000, CRC(0e16a5e5) SHA1(fa86fba7eeb68a3d36c8e68e67abdd9e5a3e9cd2) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412756.lo", 0x00001, 0x080000, CRC(a7d1eb05) SHA1(9bf168f340f555af12af19e0857ab1c10114c063) )
	ROM_LOAD16_BYTE( "95412757.hi", 0x00000, 0x080000, CRC(0f68c1ae) SHA1(f12debf0e38182ab513dfd5f8fdeb081901397d9) )
	ROM_LOAD16_BYTE( "95413702.lo", 0x00001, 0x080000, CRC(4fed4b97) SHA1(e902467882026dc48423b9fee95cae97bbb12e84) )
	ROM_LOAD16_BYTE( "95413703.hi", 0x00000, 0x080000, CRC(3e5a472c) SHA1(f7395f63ab59492d0684734d95c63893e4a2b438) )
	ROM_LOAD16_BYTE( "95413756.lo", 0x00001, 0x080000, CRC(6b3054d4) SHA1(b3d6d599df4c08b88926469fc8fb4a8d03d6627d) )
	ROM_LOAD16_BYTE( "95413757.hi", 0x00000, 0x080000, CRC(222f32a0) SHA1(1b6a8f90b56c19cbcf82dc0d037a1381b5489a52) )
//  p1920p44.hi = p1920p44.hi           sc4adwta   Ant & Dec's Saturday Night Takeaway Win The Ads (Bellfruit) (Scorpion 4)
//  p1920p44.lo = p1920p44.lo           sc4adwta   Ant & Dec's Saturday Night Takeaway Win The Ads (Bellfruit) (Scorpion 4)
//  p1920s44.hi = p1920s44.hi           sc4adwta   Ant & Dec's Saturday Night Takeaway Win The Ads (Bellfruit) (Scorpion 4)
//  p1920s44.lo = p1920s44.lo           sc4adwta   Ant & Dec's Saturday Night Takeaway Win The Ads (Bellfruit) (Scorpion 4)

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008478.bin", 0x0000, 0x100000, CRC(d8aa3daf) SHA1(dafeb014f04179882921622df9b5c9917279bd02) )
	ROM_LOAD( "95008479.bin", 0x0000, 0x100000, CRC(f1ec9928) SHA1(cd2eb8115217c205f248564c9340353c84db2ac5) )
ROM_END



ROM_START( sc_bjob )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "g95426588.lo", 0x00001, 0x080000, CRC(b56aa911) SHA1(a2d4e93fe7b5d2340c907769adb52cba176f89d1) )
	ROM_LOAD16_BYTE( "g95426589.hi", 0x00000, 0x080000, CRC(ec36a251) SHA1(c636dcfcb7cd0e306bd04ce69b21d8a8072261fe) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "g95426620.lo", 0x00001, 0x080000, CRC(ad2605bb) SHA1(e3798ed3bb54415064ab6da7936c5fb9e9a34a23) )
	ROM_LOAD16_BYTE( "g95426621.hi", 0x00000, 0x080000, CRC(8679fcee) SHA1(4903bdca94598ba1c5b65d3ae18d5f0f90b30165) )
	ROM_LOAD16_BYTE( "g95426672.lo", 0x00001, 0x080000, CRC(4d19718f) SHA1(b03b246f23058de1a24ae805389b9901d3d070b0) )
	ROM_LOAD16_BYTE( "g95426673.hi", 0x00000, 0x080000, CRC(d50073e9) SHA1(3e7c5b2ee0d65e596329dc15d638463feed21702) )
	ROM_LOAD16_BYTE( "g95426716.lo", 0x00001, 0x080000, CRC(2acdf369) SHA1(7ee4689b8992a4b65d1a71c16bf69eee5af7f6a7) )
	ROM_LOAD16_BYTE( "g95426717.hi", 0x00000, 0x080000, CRC(2014d898) SHA1(265a112c83b9216928c6febd55da68b5fc89b84e) )
	ROM_LOAD16_BYTE( "g95426892.lo", 0x00001, 0x080000, CRC(f9496abd) SHA1(65f6e5dac4793f8723ff0d38663a74c544be33a3) )
	ROM_LOAD16_BYTE( "g95426893.hi", 0x00000, 0x080000, CRC(1ae5adac) SHA1(ed5b406e198e99feb6249df664b27bbbe098a7aa) )
	ROM_LOAD16_BYTE( "g95427588.lo", 0x00001, 0x080000, CRC(c73c53f6) SHA1(6f7e7befa27b9521817cd275c40f2110331f7bd1) )
	ROM_LOAD16_BYTE( "g95427589.hi", 0x00000, 0x080000, CRC(753bab78) SHA1(b534aaceca3c5a64780071c05cdba6319ed3abc2) )
	ROM_LOAD16_BYTE( "g95427620.lo", 0x00001, 0x080000, CRC(5ea85161) SHA1(bf18d73213e72e532da92a93f143e544f3ae8d0c) )
	ROM_LOAD16_BYTE( "g95427621.hi", 0x00000, 0x080000, CRC(15cb3c62) SHA1(3f0a44c0136ba978a994974cffcf8772cf04c461) )
	ROM_LOAD16_BYTE( "g95427672.lo", 0x00001, 0x080000, CRC(e631253c) SHA1(1222ee7b2e29f2ff52f3f1a2cf3579424400047b) )
	ROM_LOAD16_BYTE( "g95427673.hi", 0x00000, 0x080000, CRC(dd773396) SHA1(92de59a940f7d5b831e3057d159d7e66fb486ba2) )
	ROM_LOAD16_BYTE( "g95427716.lo", 0x00001, 0x080000, CRC(4d461005) SHA1(5283a50b55cd38711f5b48b8c9ed68f9396a5bad) )
	ROM_LOAD16_BYTE( "g95427717.hi", 0x00000, 0x080000, CRC(a8633e1c) SHA1(000d59182c959f44e73d24e1209cc77f2b246eee) )
	ROM_LOAD16_BYTE( "g95427892.lo", 0x00001, 0x080000, CRC(48633820) SHA1(f3d6e9ddda131e5d47116ae41ac1b4b87bbad239) )
	ROM_LOAD16_BYTE( "g95427893.hi", 0x00000, 0x080000, CRC(624dd2ef) SHA1(93818c088859a4b1190daf60907b91da8d836f0b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009126.bin", 0x0000, 0x100000, CRC(55940c44) SHA1(e4f2f36ccf28446011e43f5c8a72fa9d15f72df0) )
	ROM_LOAD( "95009127.bin", 0x0000, 0x100000, CRC(0d3ee6d9) SHA1(a40bffaf631010d53ce9228758bbf5dba8423f6e) )
ROM_END



ROM_START( sc_bkngx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416328.lo", 0x00001, 0x080000, CRC(5390798a) SHA1(4577812d04ea6ea462d6ba37ba008981e88e5af4) )
	ROM_LOAD16_BYTE( "95416329.hi", 0x00000, 0x080000, CRC(98f21c81) SHA1(822c64d045dbfbf59fdde38a8ad21be0508f4f87) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417328.lo", 0x00001, 0x080000, CRC(817e8314) SHA1(7eb4464c29317e2d505f2b505352f184573adb81) )
	ROM_LOAD16_BYTE( "95417329.hi", 0x00000, 0x080000, CRC(cbb63a7d) SHA1(272d8cc2b7fa499c54bb0561124bcfd7e5a78c23) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890139.bin", 0x0000, 0x5000, CRC(03d69c54) SHA1(9e1e79378874092a19eb31af8d8b5b2422364086) )
	ROM_LOAD( "95890140.bin", 0x0000, 0x5000, CRC(1f006ce8) SHA1(4ce346e7b72546d5d6d9137a5fa6c449c6da292d) )
	ROM_LOAD( "95890141.bin", 0x0000, 0x5000, CRC(dc5a4e78) SHA1(31aefb5dcf67eafdd9fc83e086fc00e678f0093a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_bgold )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	// 95404304.lo = big7_issue382_8tkn.bin  ec_big7    Big 7 (Electrocoin) (?)
	ROM_LOAD16_BYTE( "95404305.hi", 0x00000, 0x080000, CRC(d618e9b5) SHA1(ed333968c917c67fbaf7ef30b674f3a0619d3b02) )
	ROM_LOAD16_BYTE( "95404604.lo", 0x00001, 0x080000, CRC(3697c961) SHA1(6053e5e05092294c41b78377b8d739309c2e45ac) )
	// 95404605.hi = big7_issue382_8tkn.bin  ec_big7    Big 7 (Electrocoin) (?)
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_blokq )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95404422.odd", 0x00001, 0x080000, CRC(cb1973eb) SHA1(9604bb13aa06491293c3735be93697b4a5dd5bd9) )
	ROM_LOAD16_BYTE( "95404423.evn", 0x00000, 0x080000, CRC(8bf528bb) SHA1(794b346fbd78020cd6a6b82748a298eca7c7536d) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95405422.odd", 0x00001, 0x080000, CRC(e6ff1728) SHA1(3b67d1754da55b5ca57724632991a014d959edd5) )
	ROM_LOAD16_BYTE( "95405423.evn", 0x00000, 0x080000, CRC(8988705b) SHA1(d9fa53889e5b8e68bdd4070dd3db9a2e090ec4d4) )
	ROM_LOAD16_BYTE( "95405424.odd", 0x00001, 0x080000, CRC(dcf048ce) SHA1(f57c9e74fa0c948fc5be17cac7bd601bc09fa4d3) )
	ROM_LOAD16_BYTE( "95405425.evn", 0x00000, 0x080000, CRC(5e1a3264) SHA1(9c9d26d4d7b1686e0e44309b182bf71a171a7176) )
	ROM_LOAD16_BYTE( "95406240.odd", 0x00001, 0x080000, CRC(e579d5d3) SHA1(ccf94d314f604eee53919c6333deff55e908d260) )
	ROM_LOAD16_BYTE( "95406241.evn", 0x00000, 0x080000, CRC(565b4041) SHA1(cc02b2b0d0bf20193821d915cfc49e6701f49d86) )
	ROM_LOAD16_BYTE( "95407100.odd", 0x00001, 0x080000, CRC(37695cfb) SHA1(171a4144af8441a29495ace00cd0371a9b2a3b52) )
	ROM_LOAD16_BYTE( "95407101.evn", 0x00000, 0x080000, CRC(bb08fd97) SHA1(f52d45e092ce6dce2444f96cc98c4b8e2a3a5354) )
	ROM_LOAD16_BYTE( "95407240.odd", 0x00001, 0x080000, CRC(d32b9e02) SHA1(b2401d39c5fa5ffabb05e26987b3f9573c0ed076) )
	ROM_LOAD16_BYTE( "95407241.evn", 0x00000, 0x080000, CRC(c5bff1e6) SHA1(890c5db1a7093ae91ecb0eef033703caadc42859) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_bucc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3216p71.hi", 0x00000, 0x080000, CRC(f1ee1a57) SHA1(afc4f9f3840afebe6ec14f5ec6eabe147a080dc1) )
	ROM_LOAD16_BYTE( "p3216p71.lo", 0x00001, 0x080000, CRC(ddc9a6b6) SHA1(4bc541990313e06e11509a7c1afe8ffc2f7a6838) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3216p72.hi", 0x00000, 0x080000, CRC(9de364fd) SHA1(01c2e3764f339dac2a4b3021969ec71b988ded3b) )
	ROM_LOAD16_BYTE( "p3216p72.lo", 0x00001, 0x080000, CRC(63ab9a8f) SHA1(d74e2389eff4201fce985f280412a4e0c2c83514) )
	ROM_LOAD16_BYTE( "p3216p73.hi", 0x00000, 0x080000, CRC(dec91d24) SHA1(9e0123ee969aeca4a8f13312cd58d5816ef2e2a5) )
	ROM_LOAD16_BYTE( "p3216p73.lo", 0x00001, 0x080000, CRC(9f67e4fa) SHA1(b2caac73fbe6e313070fa73c355320f1198d67f1) )
	ROM_LOAD16_BYTE( "p3216s71.hi", 0x00000, 0x080000, CRC(e8763ac4) SHA1(aeb3c242ebd35b8b84a1beb0f998d550c258acfe) )
	ROM_LOAD16_BYTE( "p3216s71.lo", 0x00001, 0x080000, CRC(5c72ac7b) SHA1(b6b391fabcc0e68cb967a3c543215e595da10061) )
	ROM_LOAD16_BYTE( "p3216s72.hi", 0x00000, 0x080000, CRC(f68d9ac7) SHA1(00a3075d5c85dd530b9370c4c3495e065c66461f) )
	ROM_LOAD16_BYTE( "p3216s72.lo", 0x00001, 0x080000, CRC(0edd2afb) SHA1(3ef1536beed26395b49cd7dcc6902b6b29154cc3) )
	ROM_LOAD16_BYTE( "p3216s73.hi", 0x00000, 0x080000, CRC(79fb2b1e) SHA1(76a46b039212f15869b271fa455b2a1e0fa03318) )
	ROM_LOAD16_BYTE( "p3216s73.lo", 0x00001, 0x080000, CRC(b502b6de) SHA1(db7eb916f310c7ee96cf3f3209c885b1d3a55805) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008806.bin", 0x0000, 0x100000, CRC(16ee0143) SHA1(0890da3b2108ec67db1cc8ed2dc40f2eac2a5fbc) )
	ROM_LOAD( "95008807.bin", 0x0000, 0x100000, CRC(7141737f) SHA1(74607352f32df2a27f0724f243532c98ca315910) )
ROM_END



ROM_START( sc_bpfpb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3205p71.hi", 0x00000, 0x080000, CRC(3105b47f) SHA1(379949c5fe6f678966aa28d6ba193b758c119a19) )
	ROM_LOAD16_BYTE( "p3205p71.lo", 0x00001, 0x080000, CRC(9ee5e2cd) SHA1(57dc76b76b501e22e1ee9eec6a4161884910eecc) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3205s71.hi", 0x00000, 0x080000, CRC(707602d4) SHA1(ff857a84aa5a1779b1ac957da457878f8f0efabd) )
	ROM_LOAD16_BYTE( "p3205s71.lo", 0x00001, 0x080000, CRC(a255a583) SHA1(04d3efe7894180d89c90db1f1fbd5f0d1e1b2764) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008771.bin", 0x0000, 0x100000, CRC(121b6db2) SHA1(634f435635fcb08013729629fc8f56a4180c2034) )
	ROM_LOAD( "95008772.bin", 0x0000, 0x100000, CRC(c8813870) SHA1(5c4571a3ca9a06c49e80c5e10e9fd288de560324) )
ROM_END



ROM_START( sc_bpfpm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211339.bin", 0x0000, 0xa91458, CRC(e653ce23) SHA1(8cf3ad73974d97f3ed1d715c607e7888cf0992b1) )
	ROM_LOAD( "39211344.bin", 0x0000, 0x4d2ac4, CRC(2c20765f) SHA1(0856649f6ebef51e1159fdf6a146136a50cf5325) )
	ROM_LOAD( "39212339.bin", 0x0000, 0xa91458, CRC(73ed1ef5) SHA1(a8132e47d4b5644a2da26d512fa68c9078fb2bc1) )
	ROM_LOAD( "39212344.bin", 0x0000, 0x4d2ac4, CRC(01c3c686) SHA1(1c5bb9da7f7ffbf3d2086de3c2a22fa0240187b3) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890492.bin", 0x0000, 0x5000, CRC(5bddee9e) SHA1(7c2af91793f1f8c3c7f12535874c032129af7c8c) )
	ROM_LOAD( "95890494.bin", 0x0000, 0x5000, CRC(84513cb2) SHA1(8d45cff91953263c4aa8e7cb4a437c27371bd8a1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008987.bin", 0x0000, 0x0fe101, CRC(798c9559) SHA1(4afb21a78be73353741b5903099d3c48e44fcebb) )
	ROM_LOAD( "95008994.bin", 0x0000, 0x0fb8bc, CRC(2c7a4446) SHA1(b1e327747043c795e179643e8bd485f51f838021) )
ROM_END



ROM_START( sc_btiab )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1914p11.hi", 0x00000, 0x080000, CRC(be0e6e7d) SHA1(3ce2c1c116991912e875a5ee86060a87739cc61c) )
	ROM_LOAD16_BYTE( "p1914p11.lo", 0x00001, 0x080000, CRC(72ad4175) SHA1(01c7c504098159360c9ed1d6da75c9478d687e53) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_btrip )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1744p11.hi", 0x00000, 0x080000, CRC(c4634163) SHA1(6d7ed6afcabbe38f3315140b7aa985c0acab1af5) )
	ROM_LOAD16_BYTE( "p1744p11.lo", 0x00001, 0x080000, CRC(aaeef50f) SHA1(eccdbe5951314105ec5a06724582fc021e0dbd2c) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1744s11.hi", 0x00000, 0x080000, CRC(89649f68) SHA1(3e785dce35cab75d1e8eaa98b11db7af2bb08b0a) )
	ROM_LOAD16_BYTE( "p1744s11.lo", 0x00001, 0x080000, CRC(08bf00ea) SHA1(9eec569703d71db15d553b9f7a72931fa738f91a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_btc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "p1758p53.bin", 0x0000, 0x1000000, CRC(0323a676) SHA1(26f5d1c6bc4cd2d8405a95714f0dee6c26c21539) )
	ROM_LOAD( "p1758p82.bin", 0x0000, 0x1000000, CRC(5f5e5869) SHA1(37b471340c42c1776e8e6312f3b8db6eab9441e5) )
	ROM_LOAD( "p1758s82.bin", 0x0000, 0x1000000, CRC(55761c4a) SHA1(56531c4df469e5dc4f7df7dcc49c97656ed1183c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_bpb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418022.lo", 0x00001, 0x080000, CRC(c6a84731) SHA1(65b7d1fef892644c5e07aa203e703a9400cd7049) )
	ROM_LOAD16_BYTE( "95418023.hi", 0x00000, 0x080000, CRC(b8a33eae) SHA1(8fbabac58b287130db49b5c37aca4e674ae89906) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418050.lo", 0x00001, 0x080000, CRC(548d09d0) SHA1(037fe5fc16222994f5c1d9688379bf1ca75aa2b0) )
	ROM_LOAD16_BYTE( "95418051.hi", 0x00000, 0x080000, CRC(0e811890) SHA1(ee77c31b2b59695c5a067eb70cbffe69d6a60bde) )
	ROM_LOAD16_BYTE( "95418804.lo", 0x00001, 0x080000, CRC(0a8363e9) SHA1(0f45aa3e40250a43ba96271e7596aa6c0d6da6bd) )
	ROM_LOAD16_BYTE( "95418805.hi", 0x00000, 0x080000, CRC(9b106d25) SHA1(455ea82638630e16b7a117f287cc5df4282282fa) )
	ROM_LOAD16_BYTE( "95418818.lo", 0x00001, 0x080000, CRC(17103948) SHA1(d27f15629f03630ea38c388ea17ce71cf3dd9a4f) )
	ROM_LOAD16_BYTE( "95418819.hi", 0x00000, 0x080000, CRC(cf0029af) SHA1(f0b230a70edb057c1e0b3a2add846e08968c0ed5) )
	ROM_LOAD16_BYTE( "95418946.lo", 0x00001, 0x080000, CRC(bdc928e7) SHA1(d7a21dde2dd40a57d2c7243bdb04b37a55ccc8d3) )
	ROM_LOAD16_BYTE( "95418947.hi", 0x00000, 0x080000, CRC(29ae9d0a) SHA1(80860f70cf71070b3d923f7685ad185e396f5d97) )
	ROM_LOAD16_BYTE( "95419022.lo", 0x00001, 0x080000, CRC(ab8f24e8) SHA1(d2730c78bdc6e7e50781a74e8f80a2fa807736f1) )
	ROM_LOAD16_BYTE( "95419023.hi", 0x00000, 0x080000, CRC(0492566f) SHA1(7d026bcf43000ad696a3c800743904aaf8475331) )
	ROM_LOAD16_BYTE( "95419050.lo", 0x00001, 0x080000, CRC(ed898de9) SHA1(8a2a0ff43a8c7dbd30e532f421527bc96b6b6f31) )
	ROM_LOAD16_BYTE( "95419051.hi", 0x00000, 0x080000, CRC(f2397d9f) SHA1(22c698551304e0571530315753d9c26fb6023655) )
	ROM_LOAD16_BYTE( "95419804.lo", 0x00001, 0x080000, CRC(4173b520) SHA1(0d6eaf5eb30d01205f1f04f351290a7b62ab34fb) )
	ROM_LOAD16_BYTE( "95419805.hi", 0x00000, 0x080000, CRC(44083e3d) SHA1(ca7941bebea8ec88ca9d6e8b2168d63679ec026b) )
	ROM_LOAD16_BYTE( "95419818.lo", 0x00001, 0x080000, CRC(71f668c4) SHA1(82c960547acbcead07c4efe8673731e3ba573961) )
	ROM_LOAD16_BYTE( "95419819.hi", 0x00000, 0x080000, CRC(982bfe3a) SHA1(008f1f2c756237d3a8333301170e8dbcc13b9743) )
	ROM_LOAD16_BYTE( "95419946.lo", 0x00001, 0x080000, CRC(8aebcc4b) SHA1(22a002ebb7c052dd85895c71feba4310b939682b) )
	ROM_LOAD16_BYTE( "95419947.hi", 0x00000, 0x080000, CRC(11388159) SHA1(9e6483a096cfdd68c8375e0f5e9a8c1a5bd998fe) )
	ROM_LOAD16_BYTE( "p1708p11.hi", 0x00000, 0x080000, CRC(d529391a) SHA1(1d095a8f665b5d67c51a05c6cd77fdbbe494d941) )
	ROM_LOAD16_BYTE( "p1708p11.lo", 0x00001, 0x080000, CRC(27f50f01) SHA1(bb71c6e44f0ad30716f4b39caeb982bd49a4b393) )
	ROM_LOAD16_BYTE( "p1708s11.hi", 0x00000, 0x080000, CRC(45dc3169) SHA1(d06fccc34a2ce7e76132e7789d3161487e7033ea) )
	ROM_LOAD16_BYTE( "p1708s11.lo", 0x00001, 0x080000, CRC(3f9363bc) SHA1(632a870193b71cb6518c1e58366d636a484188a9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008553.bin", 0x0000, 0x100000, CRC(f8019fb2) SHA1(aa5baed73538ebc6e39c6e35437b77a5cc22135e) )
	ROM_LOAD( "95008554.bin", 0x0000, 0x100000, CRC(8e00a011) SHA1(821686d96ee6fb45ab0b771934ce25ab7a230c0c) )
ROM_END



ROM_START( sc_bsp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422224.lo", 0x00001, 0x080000, CRC(4aa91225) SHA1(18be588d87bfa4953c943bc2dc2629d3105ae81b) )
	ROM_LOAD16_BYTE( "95422225.hi", 0x00000, 0x080000, CRC(cf857a93) SHA1(a5a25b773c146b14d98be271053a09fc14ea1ca9) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422226.lo", 0x00001, 0x080000, CRC(5fd47b45) SHA1(13bb169e164b993cb0147f78b292cafec77829e9) )
	ROM_LOAD16_BYTE( "95422227.hi", 0x00000, 0x080000, CRC(649e74f7) SHA1(53cde46fa8de3e1379c78b0f179a1866f2f6b527) )
	ROM_LOAD16_BYTE( "95422348.lo", 0x00001, 0x080000, CRC(d2c9d70c) SHA1(aaf01d423a8e74bab1551df3a4cf58d67b1081d1) )
	ROM_LOAD16_BYTE( "95422349.hi", 0x00000, 0x080000, CRC(b93691cc) SHA1(c3a17fdc39cff7fd4fcf34af9aa59876e06bd95c) )
	ROM_LOAD16_BYTE( "95422372.lo", 0x00001, 0x080000, CRC(d4b9ca13) SHA1(b960f9b72650b59e1cbaa4ac67582c31065bf789) )
	ROM_LOAD16_BYTE( "95422373.hi", 0x00000, 0x080000, CRC(108a56af) SHA1(04e062c425845d309ddef7c1d1d1b228ba230eb8) )
	ROM_LOAD16_BYTE( "95422374.lo", 0x00001, 0x080000, CRC(cb58e965) SHA1(275bfcad11e59636b7f397d9473fdd8036434d5f) )
	ROM_LOAD16_BYTE( "95422375.hi", 0x00000, 0x080000, CRC(b49e8b02) SHA1(cbf6a297a8c3dde772b6f960fb25676631da0197) )
	ROM_LOAD16_BYTE( "95422506.lo", 0x00001, 0x080000, CRC(72df1cd5) SHA1(8f3ec5242a0e666d33245321073dcd090092cbc2) )
	ROM_LOAD16_BYTE( "95422507.hi", 0x00000, 0x080000, CRC(068ec97f) SHA1(2dbe3133a6e0db31472074dc9d9c060d905da70f) )
	ROM_LOAD16_BYTE( "95422710.lo", 0x00001, 0x080000, CRC(92191d36) SHA1(081b21df2817ed73fb7406532f7ab6e0f79968df) )
	ROM_LOAD16_BYTE( "95422711.hi", 0x00000, 0x080000, CRC(4ff402f5) SHA1(c9781e41ef769bba90d625ad1296c19f2bdbef42) )
	ROM_LOAD16_BYTE( "95423224.lo", 0x00001, 0x080000, CRC(12032bda) SHA1(abceef649a6fa7f46cf097eb4541391d66d42d7b) )
	ROM_LOAD16_BYTE( "95423225.hi", 0x00000, 0x080000, CRC(9f372c59) SHA1(f5265bd5c5f17a08b8312575b2e133debfea6914) )
	ROM_LOAD16_BYTE( "95423226.lo", 0x00001, 0x080000, CRC(2588a662) SHA1(efa06f405a4215692550341b84a21b5d6eba1796) )
	ROM_LOAD16_BYTE( "95423227.hi", 0x00000, 0x080000, CRC(bb8b013e) SHA1(57fd0a3444a280945b583386f3b88a160105d708) )
	ROM_LOAD16_BYTE( "95423348.lo", 0x00001, 0x080000, CRC(2373e487) SHA1(de47d3728e3ba067085c4e5962012e39ae94ba9a) )
	ROM_LOAD16_BYTE( "95423349.hi", 0x00000, 0x080000, CRC(ccf27b49) SHA1(d8c6f8862073db392394319666d15b6ee314066d) )
	ROM_LOAD16_BYTE( "95423372.lo", 0x00001, 0x080000, CRC(21b01d1f) SHA1(436736fc5f158c9e250a167f7cc34c9f505cc0e5) )
	ROM_LOAD16_BYTE( "95423373.hi", 0x00000, 0x080000, CRC(73c08edb) SHA1(0529f59496b1a495f48978d8dff5fe3419a11349) )
	ROM_LOAD16_BYTE( "95423374.lo", 0x00001, 0x080000, CRC(8272900b) SHA1(c4e8bdc0c6d9a1ac74d4cff59586894671872b6b) )
	ROM_LOAD16_BYTE( "95423375.hi", 0x00000, 0x080000, CRC(9962b48f) SHA1(a6d3ee09dde57b8980863a488fd954a63e99b44c) )
	ROM_LOAD16_BYTE( "95423506.lo", 0x00001, 0x080000, CRC(dc8b85dd) SHA1(497634c277b3779dd4f57a5929c5101e079fb296) )
	ROM_LOAD16_BYTE( "95423507.hi", 0x00000, 0x080000, CRC(08cca11d) SHA1(e17cef5cff10cb592bbe8d2d173832f5d28f42f2) )
	ROM_LOAD16_BYTE( "95423710.lo", 0x00001, 0x080000, CRC(659f3613) SHA1(99ad4158c87dd83242be7b14fccf7120b533dc15) )
	ROM_LOAD16_BYTE( "95423711.hi", 0x00000, 0x080000, CRC(c001f60b) SHA1(9f540ee0f131578207edf1769e2c3de759cf5438) )
	ROM_LOAD16_BYTE( "95426104.lo", 0x00001, 0x080000, CRC(505913a9) SHA1(be9a1e03e5200ec4238d465a7a6c710c6d70ef09) )
	ROM_LOAD16_BYTE( "95426105.hi", 0x00000, 0x080000, CRC(5e827a3f) SHA1(7788c5439fb7d216b3ab043319891eb1a573a01f) )
	ROM_LOAD16_BYTE( "95426326.lo", 0x00001, 0x080000, CRC(49045e86) SHA1(d9185d4577647a4f9a186557ef8ffca866ba9b91) )
	ROM_LOAD16_BYTE( "95426327.hi", 0x00000, 0x080000, CRC(4e9a8a63) SHA1(4d9154e773fe7275d5a80c000c9a6346632afff2) )
	ROM_LOAD16_BYTE( "95426402.lo", 0x00001, 0x080000, CRC(9b82ca7f) SHA1(64d1de521357b014feeb924f680ebddaa0844fe2) )
	ROM_LOAD16_BYTE( "95426403.hi", 0x00000, 0x080000, CRC(352f353e) SHA1(b56f35c75d292c1cca8c7d7728f55a85d9f3e747) )
	ROM_LOAD16_BYTE( "95427104.lo", 0x00001, 0x080000, CRC(2d40d065) SHA1(f37a7a576100c5399c88b67e15d070bbe1b377c5) )
	ROM_LOAD16_BYTE( "95427105.hi", 0x00000, 0x080000, CRC(c03738f9) SHA1(d37f794449a914263f0088f5c3fd63814603ae39) )
	ROM_LOAD16_BYTE( "95427326.lo", 0x00001, 0x080000, CRC(39569a5b) SHA1(e71d56445cb416713df4748e9624cedb616fb69c) )
	ROM_LOAD16_BYTE( "95427327.hi", 0x00000, 0x080000, CRC(8cdcb4e1) SHA1(f0de9deb147e4396c0f4234de88ddcfba2ce6a07) )
	ROM_LOAD16_BYTE( "95427402.lo", 0x00001, 0x080000, CRC(2d14361a) SHA1(ac555e45bfffdfb2d1b42bfdf195aef80558f441) )
	ROM_LOAD16_BYTE( "95427403.hi", 0x00000, 0x080000, CRC(fe0684d4) SHA1(9d11d455e3ef5d9b7b3f5b40ab10fb11f0e4d0d8) )
	ROM_LOAD16_BYTE( "p3012p71.hi", 0x00000, 0x080000, CRC(0f2d1056) SHA1(ef69dc75ce581a2b58df71f5fe8615a83d586680) )
	ROM_LOAD16_BYTE( "p3012p71.lo", 0x00001, 0x080000, CRC(e59265f1) SHA1(4a7fc13383076d7f2b2999f994c5b2064eec18e8) )
	ROM_LOAD16_BYTE( "p3012p73.hi", 0x00000, 0x080000, CRC(660c709c) SHA1(a020b16ede3d160d8a9715cc0aec9e21caf389e2) )
	ROM_LOAD16_BYTE( "p3012p73.lo", 0x00001, 0x080000, CRC(3ada5001) SHA1(5056ce3056c2d7defc31100ba2a9b53401ae962b) )
	ROM_LOAD16_BYTE( "p3012s71.hi", 0x00000, 0x080000, CRC(1c3e5a08) SHA1(0cea2fc9e9ed0f00414c697bcc88815771968bca) )
	ROM_LOAD16_BYTE( "p3012s71.lo", 0x00001, 0x080000, CRC(7ab0cd4d) SHA1(030e166abfc19fc4597b2c2fca80c0775ff11d7f) )
	ROM_LOAD16_BYTE( "p3012s73.hi", 0x00000, 0x080000, CRC(1fe675ca) SHA1(8309d76925d4a2e62f42da0bb7ebc31e68d2e2a7) )
	ROM_LOAD16_BYTE( "p3012s73.lo", 0x00001, 0x080000, CRC(e1c6d034) SHA1(9d07da9f7fd38bae44ad88a291bdcce8641d46b7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008725.bin", 0x0000, 0x100000, CRC(e0a46426) SHA1(f6bc41c48ec1c4f113968a6ccc7a7dc81a7674b2) )
	ROM_LOAD( "95008726.bin", 0x0000, 0x100000, CRC(f01062bb) SHA1(a75937e85010ff4da01277336ad37bcbb8d0ba9f) )
ROM_END



ROM_START( sc_bunny )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416270.lo", 0x00001, 0x080000, CRC(c8935320) SHA1(904d34e1fd6245367d7c7d3f5286f5c60e949030) )
	ROM_LOAD16_BYTE( "95416271.hi", 0x00000, 0x080000, CRC(61953e6a) SHA1(44da22a54a198b89e050ec88d4d0c669d09bc79e) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417270.lo", 0x00001, 0x080000, CRC(253cdfbe) SHA1(52f4adcbbbc3f0e8844181cdab32d6f4022927d5) )
	ROM_LOAD16_BYTE( "95417271.hi", 0x00000, 0x080000, CRC(3701bf9d) SHA1(fc5f1e57a4df659913aef29a37ae52599a58c1bd) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008907.bin", 0x0000, 0x08b8c3, CRC(2b4911fd) SHA1(7ccdb5e5accb548c10ef288fd901825505559866) )
ROM_END



ROM_START( sc_cbrun )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "g95426670.lo", 0x00001, 0x080000, CRC(6ea51f05) SHA1(bf2a408134edd32942813a4915fe2223a3d78186) )
	ROM_LOAD16_BYTE( "g95426671.hi", 0x00000, 0x080000, CRC(ab83a503) SHA1(f2a5d1083de79d8152c417ba218ad97c36744909) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "g95427670.lo", 0x00001, 0x080000, CRC(e617766a) SHA1(99e2587677b51264fbb9edfbb3f9ded27b95dbac) )
	ROM_LOAD16_BYTE( "g95427671.hi", 0x00000, 0x080000, CRC(1e20b280) SHA1(feae190c21f2a5839c3bed0205c3bdf488f42c5c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_cfact )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412960.lo", 0x00001, 0x080000, CRC(0d29f038) SHA1(6a75b56b3af0acae99ed214dd0edbcbed5172b6f) )
	ROM_LOAD16_BYTE( "95412961.hi", 0x00000, 0x080000, CRC(c83a672d) SHA1(0cc84da5d162312b194b130e1386cbc231d65043) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "cfactor.hi", 0x00000, 0x080000, CRC(c9ce2ef5) SHA1(46cb6dc3c1a670bf1cc66c9750046735bef6e654) )
	ROM_LOAD16_BYTE( "cfactor.l0", 0x0000, 0x080000, CRC(1ce109d9) SHA1(9fb5f847a0732c7b356b45792224e81322c84472) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008508.bin", 0x0000, 0x100000, CRC(97d26d77) SHA1(828e3797184b39e1b8fd788253071f323f2d890e) )
	ROM_LOAD( "95008509.bin", 0x0000, 0x100000, CRC(8d1e1f36) SHA1(8976a74c050158fc63fbcbfbadd3f41fca187a24) )
ROM_END



ROM_START( sc_ctit )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3204p71.hi", 0x00000, 0x080000, CRC(66d0bd00) SHA1(5a613eda7baceaad1b948f494ed205b17f1f1efa) )
	ROM_LOAD16_BYTE( "p3204p71.lo", 0x00001, 0x080000, CRC(8ec228c6) SHA1(f0ea566eeba816b3ef4188843c5f0b00b4aec84d) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3204s71.hi", 0x00000, 0x080000, CRC(e86b8113) SHA1(c5e7a50e3acfb444edf7b7ac5334013291b8b2c8) )
	ROM_LOAD16_BYTE( "p3204s71.lo", 0x00001, 0x080000, CRC(75cc8864) SHA1(0bea4b4ccc29c239154ea20363845eb46186e1cb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008762.bin", 0x0000, 0x100000, CRC(cf7fc030) SHA1(0c34d9b35eb6229ae48b27f2f88ff682b4601816) )
	ROM_LOAD( "95008763.bin", 0x0000, 0x100000, CRC(767b94d9) SHA1(5cac6831e54af03eea065143c04bda54f44fec7d) )
ROM_END




ROM_START( sc_craid )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420786.lo", 0x00001, 0x080000, CRC(b2ad952c) SHA1(34d4fe88f59a737b1931cf26f438f80c001fe338) )
	ROM_LOAD16_BYTE( "95420787.hi", 0x00000, 0x080000, CRC(00be96b1) SHA1(dab040328e53a793941975d8247c287a8be275a2) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95421786.lo", 0x00001, 0x080000, CRC(084a10a9) SHA1(b7cb2e9bebfb2a5d9757f553e9e08d9cf36eb45f) )
	ROM_LOAD16_BYTE( "95421787.hi", 0x00000, 0x080000, CRC(83217eba) SHA1(23d2741128e27c206180a7524688a3af3267710e) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890715.bin", 0x0000, 0x5000, CRC(60af654b) SHA1(ec714992a41b154f534aac0a515e1ef490dad0db) )
	ROM_LOAD( "95890716.bin", 0x0000, 0x5000, CRC(1539217f) SHA1(bc766636048c720ac5df55bbf643e2801536e58f) )
	ROM_LOAD( "95890717.bin", 0x0000, 0x5000, CRC(8b83ed23) SHA1(43d56d728fbbb81c9e660e537746cd2aa01aadd1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008851.bin", 0x0000, 0x0fa2fc, CRC(ec82c860) SHA1(7806065db24c13208c77009c64de91a3fb0f4311) )
ROM_END




ROM_START( sc_cvega )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412826.lo", 0x00001, 0x080000, CRC(7bc826bf) SHA1(0985a2f07dd1318cb6c16f5e557cabc685d4c220) )
	ROM_LOAD16_BYTE( "95412827.hi", 0x00000, 0x080000, CRC(76827bbe) SHA1(1aa77f9a5a5043b5f8255444d0bc210aafa256c8) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95413826.lo", 0x00001, 0x080000, CRC(889a9336) SHA1(92401dfdb00f1db8803ebdf421ac32f3a20c2b1b) )
	ROM_LOAD16_BYTE( "95413827.hi", 0x00000, 0x080000, CRC(b67145ea) SHA1(5f7123d7091cfae108bae433c630f65de3d69369) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008477.bin", 0x0000, 0x100000, CRC(74607f2f) SHA1(8ce25e6af2fa8b2b4acd794dd78511983d10f7f5) )
ROM_END




ROM_START( sc_chain )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1312p13.hi", 0x00000, 0x080000, CRC(6ce6a39b) SHA1(329cde7eed857a1a772974725027db3531857ccd) )
	ROM_LOAD16_BYTE( "p1312p13.lo", 0x00001, 0x080000, CRC(e258be41) SHA1(b4012c5d2d08971a09bc1bac6ff78686aa38db30) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1312p23.hi", 0x00000, 0x080000, CRC(e7b27d08) SHA1(07171c023f6382513d2671ba838d59bfdb8a6f4f) )
	ROM_LOAD16_BYTE( "p1312p23.lo", 0x00001, 0x080000, CRC(07643205) SHA1(5ddffad4b6034b1d600854aa2e2f9f3489c32775) )
	ROM_LOAD16_BYTE( "p1312p24.hi", 0x00000, 0x080000, CRC(0628e1e9) SHA1(32c5063ed218998a0732c480acc6fce34ff42451) )
	ROM_LOAD16_BYTE( "p1312p24.lo", 0x00001, 0x080000, CRC(ba87c653) SHA1(d88cd779bc6088ae4bf231970b5cfddd99a43c73) )
	ROM_LOAD16_BYTE( "p1312s13.hi", 0x00000, 0x080000, CRC(f5e38577) SHA1(d921bb4520547f85c0e190875305d0562fa36cc6) )
	ROM_LOAD16_BYTE( "p1312s13.lo", 0x00001, 0x080000, CRC(55b7a061) SHA1(01b7c564f21570feee2c2c01c4717b786784cc8f) )
	ROM_LOAD16_BYTE( "p1312s23.hi", 0x00000, 0x080000, CRC(66aacd7a) SHA1(45f5ecb35cc6a2d88fe5bdb7d70f719b1ab0ce4a) )
	ROM_LOAD16_BYTE( "p1312s23.lo", 0x00001, 0x080000, CRC(2124ed53) SHA1(4ae362fd6a7e6116873ddba3f52e1b4195b3a34c) )
	ROM_LOAD16_BYTE( "p1312s24.hi", 0x00000, 0x080000, CRC(6bbf0b47) SHA1(a4955efb886a57b2840fe9a97288555c7d937fae) )
	ROM_LOAD16_BYTE( "p1312s24.lo", 0x00001, 0x080000, CRC(17b60464) SHA1(e1857fd5b17e6c9fd62d49a68ada38d2b73ed81c) )
	ROM_LOAD16_BYTE( "p1316p11.hi", 0x00000, 0x080000, CRC(d1aec816) SHA1(ffc66f52996f2772831a2c4966a3ace9ded8b244) )
	ROM_LOAD16_BYTE( "p1316p11.lo", 0x00001, 0x080000, CRC(d6d28126) SHA1(3d33fc26612ca39dada0dddf303f4680a149ce1f) )
	ROM_LOAD16_BYTE( "p1316p21.hi", 0x00000, 0x080000, CRC(70089d28) SHA1(270c85f0a0866934bd018d80c2464fd4b7a791f7) )
	ROM_LOAD16_BYTE( "p1316p21.lo", 0x00001, 0x080000, CRC(49cc172c) SHA1(7e78801934a81631f6f47e7ed1b879aebbbe0dc2) )
	ROM_LOAD16_BYTE( "p1316s11.hi", 0x00000, 0x080000, CRC(b15e9ed8) SHA1(e6fbd5058942231179bcec3ac1cb1f5d8e5e4a8a) )
	ROM_LOAD16_BYTE( "p1316s11.lo", 0x00001, 0x080000, CRC(7f3b9b2a) SHA1(b3ed6211afd89d962c58088b67bea208a459e2d4) )
	ROM_LOAD16_BYTE( "p1316s21.hi", 0x00000, 0x080000, CRC(a38e5906) SHA1(7986d52314913275f4c46bcc2a8d363d6dda6f6d) )
	ROM_LOAD16_BYTE( "p1316s21.lo", 0x00001, 0x080000, CRC(53cf724e) SHA1(623ae3b8c1997da511a4dd3c1644c094d256133b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008318.bin", 0x0000, 0x100000, CRC(d4fb4702) SHA1(b6cdeb8e34d081a403d5918ec95e2eb387102538) )
ROM_END




ROM_START( sc_chopc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416272.lo", 0x00001, 0x080000, CRC(849c04ac) SHA1(c0a48ba08f1dd78fc683b74eb5b33dd976461b7a) )
	ROM_LOAD16_BYTE( "95416273.hi", 0x00000, 0x080000, CRC(1a8fab5c) SHA1(b551c2808c55e3e30a26ec81b1c522db7b6c2c53) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417272.lo", 0x00001, 0x080000, CRC(d6a21098) SHA1(6d6026e5a9691694115f96a69f2443925f95818d) )
	ROM_LOAD16_BYTE( "95417273.hi", 0x00000, 0x080000, CRC(34d07425) SHA1(6a82aae33eb7cad44269dca66c7ad81fb90a232f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008908.bin", 0x0000, 0x0fa18a, CRC(78e8e1cf) SHA1(0211fffcaab36d88610525c85efb5ea7835fb641) )
ROM_END



ROM_START( sc_cbar7 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424480.lo", 0x00001, 0x080000, CRC(97e2621f) SHA1(b46712278963997e896c2ddf40a189c5f14b2c4e) )
	ROM_LOAD16_BYTE( "95424481.hi", 0x00000, 0x080000, CRC(3b728280) SHA1(5a1cd00f924d679a26be1384b71c841782c0297b) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425480.lo", 0x00001, 0x080000, CRC(13cf6f77) SHA1(54b76934971605f87d904b2b57c7e62f9e83e7b5) )
	ROM_LOAD16_BYTE( "95425481.hi", 0x00000, 0x080000, CRC(86911488) SHA1(64ac43ff032c574bc2c882573c4f7b14972cec48) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891086.bin", 0x0000, 0x5000, CRC(64066892) SHA1(acdf17a6fec87c3094b4b363d5f5a21d58e6260a) )
	ROM_LOAD( "95891087.bin", 0x0000, 0x5000, CRC(11902ca6) SHA1(2c7fbf5ec8f22cf1d29d7eb437b8e0403ebbfb13) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009002.bin", 0x0000, 0x05dab2, CRC(7763eeea) SHA1(946ec95a75e3ffdba98c67d58162f7d2e456480e) )
ROM_END



ROM_START( sc_clown )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418158.lo", 0x00001, 0x080000, CRC(0f6e6170) SHA1(537ae0ab41d93ad5cd26437d8a67cf20d913d4a9) )
	ROM_LOAD16_BYTE( "95418159.hi", 0x00000, 0x080000, CRC(7a57a493) SHA1(372263f7d34a65adbe5213236c8ad73a8f8a461d) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418182.lo", 0x00001, 0x080000, CRC(f6e960f7) SHA1(c3f94e0b90f2bfb13111f933107926f4dbe1e1da) )
	ROM_LOAD16_BYTE( "95418183.hi", 0x00000, 0x080000, CRC(8593167c) SHA1(cbac923e69ad43c75027cca66917bc41fa30ac0c) )
	ROM_LOAD16_BYTE( "95418820.lo", 0x00001, 0x080000, CRC(ccb31a88) SHA1(7f30cccf58bb1bf044f515bbd7d9b2817d283757) )
	ROM_LOAD16_BYTE( "95418821.hi", 0x00000, 0x080000, CRC(867c31f5) SHA1(9f47ca053e7aab09561c61e6c1886c753b089dfe) )
	ROM_LOAD16_BYTE( "95418822.lo", 0x00001, 0x080000, CRC(0ff36c6d) SHA1(237fb47b50a82ab5afa4e8b3ac5045b5fba2412d) )
	ROM_LOAD16_BYTE( "95418823.hi", 0x00000, 0x080000, CRC(704115a5) SHA1(6fd8f9f47d8c5b42d091c268a7ba73f833badeeb) )
	ROM_LOAD16_BYTE( "95418930.lo", 0x00001, 0x080000, CRC(627a5df6) SHA1(f636f55249e30334a847c079a55ca156bb8ed456) )
	ROM_LOAD16_BYTE( "95418931.hi", 0x00000, 0x080000, CRC(7afd9b2e) SHA1(ef84334086a147383ba3d365d6e6294a61c32327) )
	ROM_LOAD16_BYTE( "95418940.lo", 0x00001, 0x080000, CRC(31903d5e) SHA1(83ab5669af91727957fa56877b7ea16dabe8abd4) )
	ROM_LOAD16_BYTE( "95418941.hi", 0x00000, 0x080000, CRC(918ae1b5) SHA1(fc23aad05e6ebe811dad8051f43af818fdba9c34) )
	ROM_LOAD16_BYTE( "95419158.lo", 0x00001, 0x080000, CRC(7f2ca446) SHA1(e2b2f8787729c7a2466d67f9acaf5abe44c8845d) )
	ROM_LOAD16_BYTE( "95419159.hi", 0x00000, 0x080000, CRC(cb2d8f53) SHA1(2ca81928f51739c249cf582be3b238d892ecaa12) )
	ROM_LOAD16_BYTE( "95419182.lo", 0x00001, 0x080000, CRC(7f1ba659) SHA1(60e160259512555b9a86a886967ca9c6cd8c4c6f) )
	ROM_LOAD16_BYTE( "95419183.hi", 0x00000, 0x080000, CRC(3830ef7c) SHA1(fc093adfd9776d9975572c56c22e4c53e5586788) )
	ROM_LOAD16_BYTE( "95419820.lo", 0x00001, 0x080000, CRC(8967e729) SHA1(c717512b1d965d89019e0cbc4713c0f8900921ae) )
	ROM_LOAD16_BYTE( "95419821.hi", 0x00000, 0x080000, CRC(56225dbc) SHA1(83102dec281b99eea75f14422217f78db27c0012) )
	ROM_LOAD16_BYTE( "95419822.lo", 0x00001, 0x080000, CRC(5951c9c5) SHA1(14c9707abc5349702b703d46059fc0ff42a27c1f) )
	ROM_LOAD16_BYTE( "95419823.hi", 0x00000, 0x080000, CRC(5240d9fa) SHA1(3860ff617be1515f64528868436c3273f60a15dd) )
	ROM_LOAD16_BYTE( "95419930.lo", 0x00001, 0x080000, CRC(b917a6a2) SHA1(5855479cdc9bf63ca980bdd659a3a486558e8a76) )
	ROM_LOAD16_BYTE( "95419931.hi", 0x00000, 0x080000, CRC(8e8ea89f) SHA1(8d91dfeedb2dbbdb3682715b209bb078f49bee6b) )
	ROM_LOAD16_BYTE( "95419940.lo", 0x00001, 0x080000, CRC(01b56b1f) SHA1(a68370f9c857c568a310f381be9800e667992639) )
	ROM_LOAD16_BYTE( "95419941.hi", 0x00000, 0x080000, CRC(034e4435) SHA1(7040791e5c2f4fd431ad379db88f188eff08e75f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008552.bin", 0x0000, 0x100000, CRC(89173513) SHA1(7c332b6c14725897b0ae1ed33d38a384eae9cfdd) )
ROM_END




ROM_START( sc_clbtm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402149.lo", 0x00001, 0x080000, CRC(f5eee630) SHA1(102ef766562a67cd5c339d755f527252aee924be) )
	ROM_LOAD16_BYTE( "95402150.hi", 0x00000, 0x080000, CRC(19ada5f4) SHA1(3719e29465249026c781fe5226d05770c2e8ce99) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95402257.lo", 0x00001, 0x080000, CRC(fca966af) SHA1(63aa17640405fb858d776799e2388679dfe02a26) )
	ROM_LOAD16_BYTE( "95402258.hi", 0x00000, 0x080000, CRC(24ca572a) SHA1(5daa89c4427e70d0fbebfca116ea6932716f38f8) )
	ROM_LOAD16_BYTE( "95403149.lo", 0x00001, 0x080000, CRC(a62d1945) SHA1(197f9245d46cb156987cbacc1ac0c8230030fdcd) )
	ROM_LOAD16_BYTE( "95403150.hi", 0x00000, 0x080000, CRC(9f79e460) SHA1(0162d5fc54361c5853dc865d61849f766f833545) )
	ROM_LOAD16_BYTE( "95403257.lo", 0x00001, 0x080000, CRC(5aada808) SHA1(e24bc5e523961abdedfb27ec5cff2cbb6f45bddd) )
	ROM_LOAD16_BYTE( "95403258.hi", 0x00000, 0x080000, CRC(2b133e43) SHA1(805ca1ddf1ebcf6cbbd4b8b41baf5c2056b5bf17) )
	ROM_LOAD16_BYTE( "95404682.lo", 0x00001, 0x080000, CRC(3b9e429f) SHA1(01046d8671a287b2a1c739f84d28c69ba2c8c80f) )
	ROM_LOAD16_BYTE( "95404683.hi", 0x00000, 0x080000, CRC(f84b37ad) SHA1(4430c7fe6274d25de58342d255c4c4a52966b0b3) )
	ROM_LOAD16_BYTE( "95405682.lo", 0x00001, 0x080000, CRC(12d4bf1a) SHA1(2b28c5fdca13e7a70496984e02bfd3b98d60a9ac) )
	ROM_LOAD16_BYTE( "95405683.hi", 0x00000, 0x080000, CRC(b9aba368) SHA1(ec6404447c9e23e179ec1200848d966d5f3f846b) )

	ROM_REGION( 0x800000, "ymz", ROMREGION_ERASE00 )
	// very large sound roms!
	ROM_LOAD( "95008055.p1", 0x0000, 0x800000, CRC(ef474fd3) SHA1(e7427184683603b57a3a8b37452fa6ec7a41e34c) )
	ROM_LOAD( "95008056.p2", 0x0000, 0x800000, CRC(39b1b566) SHA1(937ec27964124b92b75d4b37d09a35585baa68c6) )

	ROM_LOAD( "95008055.bin", 0x0000, 0x100000, CRC(df9ae6e3) SHA1(5766cb1749aa92c34a76270a641f7a9302cc44d7) )

	ROM_REGION( 0x400000, "others", ROMREGION_ERASE00 )
	// dot matrix roms?
	ROM_LOAD( "club-temptation_mtx_(ihex)ss.hex", 0x0000, 0x01d0da, CRC(08ebee96) SHA1(2e87d734c966abab1d4a59c9481ebea161f77286) )
	ROM_LOAD( "clubtempdot.bin", 0x0000, 0x010000, CRC(283d2d9c) SHA1(5b76a13ad674f8a40c270e5dbc61dac04d411d02) )
	ROM_LOAD( "95717692a.bin", 0x0000, 0x008000, CRC(f9fe7b9a) SHA1(0e3fe5da9fc837726d08f02a2c6ed782f016c982) ) // is this something else? sc1/2?
ROM_END


ROM_START( sc_clu70 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424606.lo", 0x00001, 0x080000, CRC(5116899c) SHA1(d063e9e317d94d63fef93bd5b84ef28fd308ef56) )
	ROM_LOAD16_BYTE( "95424607.hi", 0x00000, 0x080000, CRC(90ff0e9f) SHA1(b319989cfd55eacb53cae0e667e18f8b923cf42d) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425606.lo", 0x00001, 0x080000, CRC(f57ff256) SHA1(60b3d61526b180cd130ffc442359c1a565049a12) )
	ROM_LOAD16_BYTE( "95425607.hi", 0x00000, 0x080000, CRC(244f3da1) SHA1(02abcf21f054cb1996f5a5856e523aa0bc9a4489) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891124.bin", 0x0000, 0x5000, CRC(efb25e7e) SHA1(f1da25d6f6c2fe9953c0f95e889b845e65a1fe27) )
	ROM_LOAD( "95891125.bin", 0x0000, 0x5000, CRC(9a241a4a) SHA1(3383c31a1de5f4a0ced5e3346de7b7e1f7fdbe04) )
	ROM_LOAD( "95891126.bin", 0x0000, 0x5000, CRC(049ed616) SHA1(2c29271dfebff92b3f537dd3cc89aea53decf978) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009017.bin", 0x0000, 0x100000, CRC(4df62a63) SHA1(1d3b7927683d45bf81c038527b57881a58657e21) )
	ROM_LOAD( "95009018.bin", 0x0000, 0x030022, CRC(90c95f34) SHA1(a63d52b7ec202f6757ed24251e542be2409ba2a9) )
ROM_END



ROM_START( sc_clcas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420214.lo", 0x00001, 0x080000, CRC(96e79a96) SHA1(3c5c7cb5f566fb5be2e4198a127396eb507786dc) )
	ROM_LOAD16_BYTE( "95420215.hi", 0x00000, 0x080000, CRC(f884d509) SHA1(e93ae6fd3daa77cacc8896599a17c185dbe4ef05) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95421214.lo", 0x00001, 0x080000, CRC(b98c0d2b) SHA1(19dab8240a6f5e76eefdd01c0f0133b1e2982212) )
	ROM_LOAD16_BYTE( "95421215.hi", 0x00000, 0x080000, CRC(8b7ecfd2) SHA1(4b322f11a08cbb1de95a5bcb3095516821c45228) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890486.bin", 0x0000, 0x5000, CRC(52bab0b5) SHA1(2144c1c9b980f6dbc1948e94c34fc2213fc5aa70) )
	ROM_LOAD( "95890487.bin", 0x0000, 0x5000, CRC(4e6c4009) SHA1(44ae2ce42ff9b91174e214213ccf52c281827434) )
	ROM_LOAD( "95890488.bin", 0x0000, 0x5000, CRC(8d366299) SHA1(1d0cd59dfb39ca3a78ae2398992a992d34b2e61a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008985.bin", 0x0000, 0x0b57f9, CRC(63366697) SHA1(cdab5d0aa1bf738e4e326ed31f78f2a797bd8bd6) )
ROM_END



ROM_START( sc_clnot )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3320p71.hi", 0x00000, 0x080000, CRC(e7577b95) SHA1(ae489c5b8a71bb12a03a5bec12402e8f8e307b80) )
	ROM_LOAD16_BYTE( "p3320p71.lo", 0x00001, 0x080000, CRC(3c4ba88b) SHA1(0a4dc6437767b00d103fa6fe6a92c05f7e85cb51) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3320p72.hi", 0x00000, 0x080000, CRC(a834e1c1) SHA1(5acf39a842beffeb7b0af58679f9076370880e58) )
	ROM_LOAD16_BYTE( "p3320p72.lo", 0x00001, 0x080000, CRC(77e9e22a) SHA1(29a76b6a4d8598d98e07df115551b130a59c1b4a) )
	ROM_LOAD16_BYTE( "p3320p73.hi", 0x00000, 0x080000, CRC(0ac70145) SHA1(a5ede1d3550f2cf38a5bce20e6136e16909efcfb) )
	ROM_LOAD16_BYTE( "p3320p73.lo", 0x00001, 0x080000, CRC(255d9cc3) SHA1(de3d06db28e0d27fc09add57cc1bc1bdd09dfdbc) )
	ROM_LOAD16_BYTE( "p3320p74.hi", 0x00000, 0x080000, CRC(8d568fc6) SHA1(6ad6af35e6eab275e1540ef1c622c509e91593ca) )
	ROM_LOAD16_BYTE( "p3320p74.lo", 0x00001, 0x080000, CRC(dcb272df) SHA1(461241d3b58e8b6bb13918b911d952809815a2b8) )
	ROM_LOAD16_BYTE( "p3320s71.hi", 0x00000, 0x080000, CRC(05550ef4) SHA1(70f465b70a22c09a3ddf1709070cc8132d809dea) )
	ROM_LOAD16_BYTE( "p3320s71.lo", 0x00001, 0x080000, CRC(41e0158b) SHA1(f8e23402bddc64c22e4307921ca36dc6e21f58e9) )
	ROM_LOAD16_BYTE( "p3320s72.hi", 0x00000, 0x080000, CRC(d30d4f7b) SHA1(ed71344de1c17d9ae26d235fe7269ece6e7afd7d) )
	ROM_LOAD16_BYTE( "p3320s72.lo", 0x00001, 0x080000, CRC(f6464393) SHA1(ce5d5ffae4627188c1e8334d9ef9171db054d366) )
	ROM_LOAD16_BYTE( "p3320s73.hi", 0x00000, 0x080000, CRC(292cf9d2) SHA1(9cdcd35b99d86021c801e9c3cf165c41d6b95e0c) )
	ROM_LOAD16_BYTE( "p3320s73.lo", 0x00001, 0x080000, CRC(048da036) SHA1(aa4fea9b6afcd92e1145343784c8854e8dfbd5c5) )
	ROM_LOAD16_BYTE( "p3320s74.hi", 0x00000, 0x080000, CRC(1ffb7940) SHA1(f6ca07bcfb11109c3a1444c49f4ad80bd7f29455) )
	ROM_LOAD16_BYTE( "p3320s74.lo", 0x00001, 0x080000, CRC(7bddd63f) SHA1(b82d75d9a8c1b144a5ab876d067f5d9df7ca5afc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009135.bin", 0x0000, 0x100000, CRC(af699e46) SHA1(e8f685847f4eb83a67074cae92ed59e96f37653b) )
	ROM_LOAD( "95009136.bin", 0x0000, 0x100000, CRC(cd1ea94c) SHA1(8010ba1490c656f870230611d15255db175a5a49) )
ROM_END




ROM_START( sc_clus )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420232.lo", 0x00001, 0x080000, CRC(0495a57e) SHA1(fc6861f7b1f5014e996e38735c7d65e5e3a4d4f9) )
	ROM_LOAD16_BYTE( "95420233.hi", 0x00000, 0x080000, CRC(a3268eb5) SHA1(ac430b90a0d40bbc2e421310ca686650f23e946b) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420420.lo", 0x00001, 0x080000, CRC(f8966c71) SHA1(0303a3ff037c82bc2d60be32e5dc190fe2900809) )
	ROM_LOAD16_BYTE( "95420421.hi", 0x00000, 0x080000, CRC(40309b0a) SHA1(afc67a77aed2046b53dfacf1d1ef9bb064012eee) )
	ROM_LOAD16_BYTE( "95420572.lo", 0x00001, 0x080000, CRC(45b4b964) SHA1(ed9d277b06110fe5e804c679b55b884e7c8f00ed) )
	ROM_LOAD16_BYTE( "95420573.hi", 0x00000, 0x080000, CRC(3b80b863) SHA1(0609d9f0a3576bb4ffa0f8f106c094aa892227d5) )
	ROM_LOAD16_BYTE( "95420798.lo", 0x00001, 0x080000, CRC(f49872ab) SHA1(c9fa88f342a1099a973eb6f9c1568c9df330efe0) )
	ROM_LOAD16_BYTE( "95420799.hi", 0x00000, 0x080000, CRC(38986101) SHA1(39cd09e8448c10f3f2a25f4e451454fc24260c16) )
	ROM_LOAD16_BYTE( "95421232.lo", 0x00001, 0x080000, CRC(1398a93b) SHA1(3bd8c28a3ca42c3f51aa81a6147d5b03d786180e) )
	ROM_LOAD16_BYTE( "95421233.hi", 0x00000, 0x080000, CRC(f697f34c) SHA1(edb9278188451ffe5a199b6385778e77b705c513) )
	ROM_LOAD16_BYTE( "95421420.lo", 0x00001, 0x080000, CRC(9ab5593b) SHA1(80a4002332406274d541900bf99e8b583fc19425) )
	ROM_LOAD16_BYTE( "95421421.hi", 0x00000, 0x080000, CRC(3c680a89) SHA1(1f4da3fe6b2210596c1cb876042977039527233e) )
	ROM_LOAD16_BYTE( "95421572.lo", 0x00001, 0x080000, CRC(ecb35ea6) SHA1(127077129925cb8f986bb735c361f7562900adbe) )
	ROM_LOAD16_BYTE( "95421573.hi", 0x00000, 0x080000, CRC(66c3c372) SHA1(1269772935b53a2455317bdf46aff31d41457d82) )
	ROM_LOAD16_BYTE( "95421798.lo", 0x00001, 0x080000, CRC(618dd281) SHA1(9dd4ada2eea9ceccb4981f69434b510accd5f1b0) )
	ROM_LOAD16_BYTE( "95421799.hi", 0x00000, 0x080000, CRC(be57bd8f) SHA1(1cda9a9d4300664afe94193710ef6fdfc9c6e59f) )
	ROM_LOAD16_BYTE( "95424488.lo", 0x00001, 0x080000, CRC(1262616d) SHA1(4de9f9015036dff77df13ee098de2ef8014bd5da) )
	ROM_LOAD16_BYTE( "95424489.hi", 0x00000, 0x080000, CRC(3a89646c) SHA1(1b84c2f48e746fc90e5a7ae290e9271e55d6ff65) )
	ROM_LOAD16_BYTE( "95424530.lo", 0x00001, 0x080000, CRC(ec75bc8a) SHA1(cd4416a8a391d9cbf5f99701dbef0efb112c6f99) )
	ROM_LOAD16_BYTE( "95424531.hi", 0x00000, 0x080000, CRC(6a71f145) SHA1(cda03395827a0c5ef9b4e8b4b7569f1827828135) )
	ROM_LOAD16_BYTE( "95425488.lo", 0x00001, 0x080000, CRC(16e68f76) SHA1(14f0ce9d4cf2e1c6e4122512ad0d8f63d6127f59) )
	ROM_LOAD16_BYTE( "95425489.hi", 0x00000, 0x080000, CRC(6d83d072) SHA1(a662bada38a22703567a4cdf0597f2878ef9935f) )
	ROM_LOAD16_BYTE( "95425530.lo", 0x00001, 0x080000, CRC(bd66367e) SHA1(33d9e3392229e9d7c0a5a44e6b1135f6135c2a97) )
	ROM_LOAD16_BYTE( "95425531.hi", 0x00000, 0x080000, CRC(a11b6d6f) SHA1(20ab31e399a6b537d014b69963e01e945e1fea35) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890495.bin", 0x0000, 0x5000, CRC(a475b60f) SHA1(4f02f0e0c19be7378736d6d4707f7b4a3068be9b) )
	ROM_LOAD( "95890496.bin", 0x0000, 0x5000, CRC(d1e3f23b) SHA1(6f9032c000bcc0cd61180193d85d0a4623026d14) )
	ROM_LOAD( "95890497.bin", 0x0000, 0x5000, CRC(4f593e67) SHA1(3a4591ae8ca140dff54d5e74143359fbecc14bfc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008988.bin", 0x0000, 0x0d23ea, CRC(b33581a0) SHA1(667bf4e499b50fd072313bad671ffcbd299fd97b) )
ROM_END




ROM_START( sc_cmony )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426818.lo", 0x00001, 0x080000, CRC(898b5c17) SHA1(5e090bec5d9dc303e3d6d80a4b27c095c285eb29) )
	ROM_LOAD16_BYTE( "95426819.hi", 0x00000, 0x080000, CRC(d6eeeddd) SHA1(70d11f51b257d7d565bad65a9f0b0e7bde716bf7) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427818.lo", 0x00001, 0x080000, CRC(f696797d) SHA1(fd1ae9bf1e248cadf547d18601a7df54f6384b91) )
	ROM_LOAD16_BYTE( "95427819.hi", 0x00000, 0x080000, CRC(ee6fadce) SHA1(47d14fcc8040f72c97e1cade26f1a62cf1ead511) )
	ROM_LOAD16_BYTE( "p3317p71.hi", 0x00000, 0x080000, CRC(6b3964f1) SHA1(4f464ca86a59e30a7f05fe1d6ed8f30f8260d186) )
	ROM_LOAD16_BYTE( "p3317p71.lo", 0x00001, 0x080000, CRC(af2a8342) SHA1(4865f3ff996b67bebf38c93aad3f7b32afcb2d7e) )
	ROM_LOAD16_BYTE( "p3317p73.hi", 0x00000, 0x080000, CRC(fad957ba) SHA1(56446892d5ef88488e4ee223bee489ce822a78ce) )
	ROM_LOAD16_BYTE( "p3317p73.lo", 0x00001, 0x080000, CRC(28ebb95e) SHA1(0dcde4f0fb1ffdc3f5efeadbf119fb89097da9fb) )
	ROM_LOAD16_BYTE( "p3317s71.hi", 0x00000, 0x080000, CRC(2883db1b) SHA1(a3cd5cc0f6e17425e4de4a81d18c710ec873da86) )
	ROM_LOAD16_BYTE( "p3317s71.lo", 0x00001, 0x080000, CRC(074f7cc2) SHA1(159071cce2a2c834e0e1b9bdd448b16b46577637) )
	ROM_LOAD16_BYTE( "p3317s73.hi", 0x00000, 0x080000, CRC(3a9fdba2) SHA1(6bd035186e28bff42d2fc285b07c5c9ec683db7b) )
	ROM_LOAD16_BYTE( "p3317s73.lo", 0x00001, 0x080000, CRC(6ee18188) SHA1(73b01c51d12ba5d971b9a0da94e781a08788a6fa) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009031.bin", 0x0000, 0x100000, CRC(58ded502) SHA1(27c05614b03b51fe4a168b8c64535ec3ca9e85c1) )
	ROM_LOAD( "95009032.bin", 0x0000, 0x100000, CRC(e1eb711a) SHA1(f6c0c10992f2aacd6f9fadc4e15d8ad5ba5b4ed8) )
	ROM_LOAD( "95009124.bin", 0x0000, 0x100000, CRC(798d8d5a) SHA1(931bfca5d204c62fc834959d9babcd9488fc7f07) )
	ROM_LOAD( "95009125.bin", 0x0000, 0x100000, CRC(d6090812) SHA1(16ca4868725eff0cc4bd056d751dc7861c1e53a1) )
ROM_END




ROM_START( sc_newcm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426926.lo", 0x00001, 0x080000, CRC(905a15ce) SHA1(987782cd163f1a8869970912ad412e5440dacdf3) )
	ROM_LOAD16_BYTE( "95426927.hi", 0x00000, 0x080000, CRC(70fa9626) SHA1(e9a58b489665e8b540adaa220995d5237de1c820) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427926.lo", 0x00001, 0x080000, CRC(5897abbc) SHA1(7714218e76a1d2ebdda65c1403c4fc3f5a5263f6) )
	ROM_LOAD16_BYTE( "95427927.hi", 0x00000, 0x080000, CRC(4c44681c) SHA1(ed808ab3d06157da9dbe65b1e27925b3a3b53f91) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_copsr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410312.lo", 0x00001, 0x080000, CRC(969fb1ab) SHA1(6224309662e012e432698b0c760bd25586aa2b7f) )
	ROM_LOAD16_BYTE( "95410313.hi", 0x00000, 0x080000, CRC(c5eed678) SHA1(1b139bb296b0843192715016cc500354027cf1a1) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410314.lo", 0x00001, 0x080000, CRC(46e40095) SHA1(eab1f9c0ebbcd0a11fa8e6abc34ea3681cc2fffb) )
	ROM_LOAD16_BYTE( "95410315.hi", 0x00000, 0x080000, CRC(2d321463) SHA1(071ab915f8ff3c9fbce1ca0f9c0885d45a09a306) )
	ROM_LOAD16_BYTE( "95410428.lo", 0x00001, 0x080000, CRC(6f1519b9) SHA1(bbff593364f5fe7596aa6107c737117cfdced59e) )
	ROM_LOAD16_BYTE( "95410429.hi", 0x00000, 0x080000, CRC(b1782f45) SHA1(b9fb5f44dd0f1e48c011f6d66ec0c908572f5f8a) )
	ROM_LOAD16_BYTE( "95410430.lo", 0x00001, 0x080000, CRC(f583c07e) SHA1(d64e38d0bb54c59532e39db25012aa9e59ccddad) )
	ROM_LOAD16_BYTE( "95410431.hi", 0x00000, 0x080000, CRC(2e476370) SHA1(944b51f6b63f5c28f3b11c85b4bca0856fe60477) )
	ROM_LOAD16_BYTE( "95410604.lo", 0x00001, 0x080000, CRC(157ee491) SHA1(c7a76925bc4b41a6216c3da9fbe8e740f851ba0b) )
	ROM_LOAD16_BYTE( "95410605.hi", 0x00000, 0x080000, CRC(4bcd3bbb) SHA1(1fa65539760e126e66fdd0e88082d2a9c396db11) )
	ROM_LOAD16_BYTE( "95410606.lo", 0x00001, 0x080000, CRC(969cbe89) SHA1(47e4f0834806bf8e50dd3b8962ffae31133ec14c) )
	ROM_LOAD16_BYTE( "95410607.hi", 0x00000, 0x080000, CRC(75f6d7d1) SHA1(5fe2f2a4a0ee528f8ac6e9ae8e603db81143b9e9) )
	ROM_LOAD16_BYTE( "95410608.lo", 0x00001, 0x080000, CRC(658c5b6d) SHA1(0586fe753e16f0d044e65e9cbb9c1cff61c5f84e) )
	ROM_LOAD16_BYTE( "95410609.hi", 0x00000, 0x080000, CRC(20674963) SHA1(28d0364be5def1a172962ba2a132b266e35c50f7) )
	ROM_LOAD16_BYTE( "95410610.lo", 0x00001, 0x080000, CRC(f72522c7) SHA1(2120710195120c5f398b7ffb7dc2fed6fe88a79b) )
	ROM_LOAD16_BYTE( "95410611.hi", 0x00000, 0x080000, CRC(cbe9cf90) SHA1(ecc8644aab30f017537191c37c4de6c98f6662e9) )
	ROM_LOAD16_BYTE( "95411312.lo", 0x00001, 0x080000, CRC(497d25fd) SHA1(66c325eb6c5f0a1deb761914d6f804fad412900e) )
	ROM_LOAD16_BYTE( "95411313.hi", 0x00000, 0x080000, CRC(a4813889) SHA1(abc2642c11f17bcf995e493c1bfbd488192a0eb6) )
	ROM_LOAD16_BYTE( "95411314.lo", 0x00001, 0x080000, CRC(b44ee169) SHA1(37ea84ed8a0b8697d08d609d98bc35c05c246da6) )
	ROM_LOAD16_BYTE( "95411315.hi", 0x00000, 0x080000, CRC(7939ff32) SHA1(468e43634f33f02823c3d8f878ecf9c71d2b6be5) )
	ROM_LOAD16_BYTE( "95411428.lo", 0x00001, 0x080000, CRC(2378450f) SHA1(d814b5cadd6a28b10d4cfae26a8afb62d677d456) )
	ROM_LOAD16_BYTE( "95411429.hi", 0x00000, 0x080000, CRC(140c58c6) SHA1(50a51b42f01401d73083f3cda189510baa75ef3b) )
	ROM_LOAD16_BYTE( "95411430.lo", 0x00001, 0x080000, CRC(b9ee9cc8) SHA1(8bd5c68d4001e738f351eecb627aa713055da614) )
	ROM_LOAD16_BYTE( "95411431.hi", 0x00000, 0x080000, CRC(8b3314f3) SHA1(4999262b4e0b11d8e6fe88467e39ae446a5525fc) )
	ROM_LOAD16_BYTE( "95411604.lo", 0x00001, 0x080000, CRC(e0806bcf) SHA1(14b3b2db6acd9e6d29b8cca4eae0e354a65e7d2e) )
	ROM_LOAD16_BYTE( "95411605.hi", 0x00000, 0x080000, CRC(cf6422cf) SHA1(582a60bfca87ed1ac900bf1ca4e21fe70c164330) )
	ROM_LOAD16_BYTE( "95411606.lo", 0x00001, 0x080000, CRC(82a6c9eb) SHA1(b89d25a3a57af3397c85dc7c230e228e4f08676d) )
	ROM_LOAD16_BYTE( "95411607.hi", 0x00000, 0x080000, CRC(0f05a572) SHA1(96ebfd085e2d49e65410b8eec1743beb8c25e08d) )
	ROM_LOAD16_BYTE( "95411608.lo", 0x00001, 0x080000, CRC(8279a3c2) SHA1(73ff7c9c5e8589759d24ede74c035065a8e7863b) )
	ROM_LOAD16_BYTE( "95411609.hi", 0x00000, 0x080000, CRC(4fa4cbf3) SHA1(444a8a2657cadfa143e70b1878991fa3903bb86b) )
	ROM_LOAD16_BYTE( "95411610.lo", 0x00001, 0x080000, CRC(10d0da68) SHA1(36a45b25f9003362b6daad98080c9beb6db49371) )
	ROM_LOAD16_BYTE( "95411611.hi", 0x00000, 0x080000, CRC(a42a4d00) SHA1(6a74c226b15b4a0282300f53ad8868cea5deaaa9) )
	ROM_LOAD16_BYTE( "95412562.lo", 0x00001, 0x080000, CRC(d45b9b34) SHA1(5093c254c92d2169368d0a9d3c8b9814c90215d8) )
	ROM_LOAD16_BYTE( "95412563.hi", 0x00000, 0x080000, CRC(14e1d22f) SHA1(56a5f09fb763475fa1e2766f816ae0307989b3aa) )
	ROM_LOAD16_BYTE( "95412564.lo", 0x00001, 0x080000, CRC(3eaebc41) SHA1(867887d1d06126dc989c530999aea1a0944b969e) )
	ROM_LOAD16_BYTE( "95412565.hi", 0x00000, 0x080000, CRC(079d1921) SHA1(d6f8cea3b211c8fd86adca84e24748a23f48bfb4) )
	ROM_LOAD16_BYTE( "95413562.lo", 0x00001, 0x080000, CRC(f31046cb) SHA1(9dcb8bc1e04447166b00dafa065653ab4a3be4b5) )
	ROM_LOAD16_BYTE( "95413563.hi", 0x00000, 0x080000, CRC(ca5d39dd) SHA1(e5533ac21e130b88f577ec50cacafc2879ab3c0d) )
	ROM_LOAD16_BYTE( "95413564.lo", 0x00001, 0x080000, CRC(f6f9caea) SHA1(e23f5553be66d293428932b06bcf057833ea30e4) )
	ROM_LOAD16_BYTE( "95413565.hi", 0x00000, 0x080000, CRC(26ee9922) SHA1(5906557c201ecc1b84092803c3e848471aca5bd9) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211436.bin", 0x0000, 0x1000000, CRC(9bc4cc3a) SHA1(6726d43281b1c7c9630fa8b5854b4f036e12b19b) )
	ROM_LOAD( "39211451.bin", 0x0000, 0x1000000, CRC(76ebb736) SHA1(10e3e349dde9941d900d900dc98e3f9a922bb116) )
	ROM_LOAD( "39211453.bin", 0x0000, 0x1000000, CRC(0fad8171) SHA1(c636774a53bd34e42e70b3ef09feecbb7e868154) )
	ROM_LOAD( "39211461.bin", 0x0000, 0x1000000, CRC(03f714e1) SHA1(ed4278471dc415c92a7076039307b87381d90882) )
	ROM_LOAD( "39211464.bin", 0x0000, 0x1000000, CRC(3f4a00bd) SHA1(1b48da1e9b6fee7fe1451de5cae8206cc9f8d778) )
	ROM_LOAD( "39211465.bin", 0x0000, 0x1000000, CRC(8b6c393d) SHA1(fb3546f94d8ab387078f934f651f3b8be9c3802e) )
	ROM_LOAD( "39211466.bin", 0x0000, 0x1000000, CRC(76d0bc51) SHA1(cbcc85c88d558d4720f99ef43ab9de72ed0a30a0) )
	ROM_LOAD( "39211483.bin", 0x0000, 0x1000000, CRC(5c7ea8ba) SHA1(0beb1575d9daa9b46af45fb9164b6508bd411f38) )
	ROM_LOAD( "39211546.bin", 0x0000, 0x1000000, CRC(2c7349a3) SHA1(83dc0595888b4b1afa79deb2713130418c8e9d30) )
	ROM_LOAD( "39211547.bin", 0x0000, 0x1000000, CRC(8384d64f) SHA1(c4127b666250a164ed02c415e7b2003293cd2863) )
	ROM_LOAD( "39211548.bin", 0x0000, 0x1000000, CRC(7b103e0b) SHA1(4dc8f5f197f68cba5104cea792f486b31f41a6ea) )
	ROM_LOAD( "39212436.bin", 0x0000, 0x1000000, CRC(ec543259) SHA1(272396189296f6989c35d3d8a0cec744b14da463) )
	ROM_LOAD( "39212451.bin", 0x0000, 0x1000000, CRC(ac5f5f27) SHA1(3adc50085a1d6fc2f63a63c112e75552d9a1f772) )
	ROM_LOAD( "39212453.bin", 0x0000, 0x1000000, CRC(e282bc72) SHA1(4326c656c779e48e8080ef332af7539a5d889140) )
	ROM_LOAD( "39212461.bin", 0x0000, 0x1000000, CRC(2017b8b7) SHA1(32baabdcf929ae9dc12d98dd91d6733961940d40) )
	ROM_LOAD( "39212464.bin", 0x0000, 0x1000000, CRC(33dce15c) SHA1(0b5ffef40f455a4beebbbd830940170207a73f23) )
	ROM_LOAD( "39212465.bin", 0x0000, 0x1000000, CRC(778fccce) SHA1(b4eeccec2b9255ff2810abb0f4d2cb3430acb177) )
	ROM_LOAD( "39212466.bin", 0x0000, 0x1000000, CRC(7d5c2d9d) SHA1(3d72b4ab137a24abdceec0ed7db8eb3a32ddb468) )
	ROM_LOAD( "39212483.bin", 0x0000, 0x1000000, CRC(156a328a) SHA1(e0e8300a536b18cbf687f2673fbf91771d92ad51) )
	ROM_LOAD( "39212546.bin", 0x0000, 0x1000000, CRC(22144763) SHA1(e376c74992c14f5f7787351fcf8c72b3da2fbae5) )
	ROM_LOAD( "39212547.bin", 0x0000, 0x1000000, CRC(b0c8a8d6) SHA1(d52c15a5f51d64232a40976fb1bd630a53396879) )
	ROM_LOAD( "39212548.bin", 0x0000, 0x1000000, CRC(fcd6f179) SHA1(77214ddfd452311e1631dafad3e7bc682a8ae7bd) )
	ROM_LOAD( "p3206p11.bin", 0x0000, 0x1000000, CRC(8b583dc6) SHA1(69ca467c509319d577b27b2945ab7265cdbe572c) )
	ROM_LOAD( "p3206s11.bin", 0x0000, 0x1000000, CRC(944b7cb9) SHA1(7a7c6e5d14371ef2131a1bf40a5e4972a6518a0a) )
	ROM_LOAD( "p3255p01.bin", 0x0000, 0x1000000, CRC(4855b7e3) SHA1(b69f9782c171a38f1f44f3eeab449d68d37ca996) )
	ROM_LOAD( "p3255s01.bin", 0x0000, 0x1000000, CRC(e971e090) SHA1(df201580ee6189f5fabab0e6f955aac90d82f9a6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "cops_rob_snd.bin", 0x0000, 0x080000, CRC(e25bddb7) SHA1(96d6be2407bf876ad685bdc13d96585782ad4a50) )
	ROM_LOAD( "95008393.bin", 0x0000, 0x100000, CRC(693cd9be) SHA1(e965b2dcd6d6619815c919b7d2c372c726abfea3) )
	ROM_LOAD( "95008787.bin", 0x0000, 0x100000, CRC(82713d8b) SHA1(317cb1c482bd13e1cad2e5739c99f6e3ca163684) )
	ROM_LOAD( "95008846.bin", 0x0000, 0x080000, CRC(44f9eaab) SHA1(394bd36121c33aba97bc957b3d46d2944c1daeed) )
	ROM_LOAD( "95009130.bin", 0x0000, 0x100000, CRC(f6813371) SHA1(bd9e5d009c7870d50149d9de396f363fb19b183c) )
ROM_END




ROM_START( sc_crcpt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426832.lo", 0x00001, 0x080000, CRC(42263084) SHA1(aa6fad35eced4b97c20edbc6fce3661e6407ac4d) )
	ROM_LOAD16_BYTE( "95426833.hi", 0x00000, 0x080000, CRC(fa9e267e) SHA1(29dcc0ff79adbb5012159ee93c1940d268f44cd2) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427832.lo", 0x00001, 0x080000, CRC(6b18f66d) SHA1(dfffe8dd763980d811f6c843226762c17525837c) )
	ROM_LOAD16_BYTE( "95427833.hi", 0x00000, 0x080000, CRC(b6a1f0d0) SHA1(051a3a5bb8baae1a18d2dc8b95202cb70398806b) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211599.bin", 0x0000, 0x1000000, CRC(0fa50547) SHA1(95b1890851e82ad827b739a8d359309529c0b5b7) )
	ROM_LOAD( "39212599.bin", 0x0000, 0x1000000, CRC(10d4aef1) SHA1(71345ec08cecfdae7a8e0161fd0cf33b9cca5c3e) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_crotr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3506p71.hi", 0x00000, 0x080000, CRC(18f6b748) SHA1(ec174b5aecdda995d1812232403188c822ba327d) )
	ROM_LOAD16_BYTE( "p3506p71.lo", 0x00001, 0x080000, CRC(f3f99f46) SHA1(7dafa1b56ed331891c1488ae57ce2bdf8d94474d) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3506s71.hi", 0x00000, 0x080000, CRC(de6b2bc2) SHA1(9f78c06443d57222da677d102657a8117aa8ed88) )
	ROM_LOAD16_BYTE( "p3506s71.lo", 0x00001, 0x080000, CRC(51e69ad7) SHA1(89577f066cb39bbf667920c61fc0c6d5e734ac38) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009049.bin", 0x0000, 0x100000, CRC(10c94788) SHA1(8fb5113036a0122a4dbc9af15b600ffe99e51094) )
	ROM_LOAD( "95009050.bin", 0x0000, 0x100000, CRC(5e47e86c) SHA1(9aaca1390852f9079cd355c48b889fb5962c5c09) )
ROM_END




ROM_START( sc_crsgc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426598.lo", 0x00001, 0x080000, CRC(fe619021) SHA1(41996277f5cc77544a65217cdb4f60ca1bb6850f) )
	ROM_LOAD16_BYTE( "95426599.hi", 0x00000, 0x080000, CRC(72829ae6) SHA1(37481bc1cab53f873e01a0416043f0e1838f1e84) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426606.lo", 0x00001, 0x080000, CRC(8a547a39) SHA1(d697ace6bdfd277baef9608a44c96b4f3c574e37) )
	ROM_LOAD16_BYTE( "95426607.hi", 0x00000, 0x080000, CRC(d05e09f5) SHA1(2d54fccf561ee6a141a53952f048b4eca355f4db) )
	ROM_LOAD16_BYTE( "95427598.lo", 0x00001, 0x080000, CRC(6d24c35c) SHA1(6840debf594b27a8a8c05a604f82bb871c128a4a) )
	ROM_LOAD16_BYTE( "95427599.hi", 0x00000, 0x080000, CRC(c355c84c) SHA1(858a88b8ab93ce033acdf24ab2b831fa734b311b) )
	ROM_LOAD16_BYTE( "95427606.lo", 0x00001, 0x080000, CRC(6d734a40) SHA1(c0ac02f515d29e6fb081f20c6871a579209e9532) )
	ROM_LOAD16_BYTE( "95427607.hi", 0x00000, 0x080000, CRC(0187e6d5) SHA1(f0fdd3154cd78b783f27a37dc0f810849a31f75d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_crsgr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426584.lo", 0x00001, 0x080000, CRC(6e8a71de) SHA1(0494b00a605910b5e1f79102f629f4952896a2ff) )
	ROM_LOAD16_BYTE( "95426585.hi", 0x00000, 0x080000, CRC(1c65926f) SHA1(d5620e9af764cb6bdd8e90077bfac2f70f7d4971) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426608.lo", 0x00001, 0x080000, CRC(33288757) SHA1(0df682d95354e1825409effbd4b3474c7891b9d9) )
	ROM_LOAD16_BYTE( "95426609.hi", 0x00000, 0x080000, CRC(1b59bf7f) SHA1(10e3db4573f47a677ceff6aa6b051593647cc136) )
	ROM_LOAD16_BYTE( "95427584.lo", 0x00001, 0x080000, CRC(0b00d71d) SHA1(efc169bf5aae880d99cb32067abb011e3ce52ae4) )
	ROM_LOAD16_BYTE( "95427585.hi", 0x00000, 0x080000, CRC(90d71fce) SHA1(df10ad1176fd69344fe79c12b3ac60e15c18c858) )
	ROM_LOAD16_BYTE( "95427608.lo", 0x00001, 0x080000, CRC(24dff702) SHA1(48249a94eff659defd1ff21187e76fac5b0c6983) )
	ROM_LOAD16_BYTE( "95427609.hi", 0x00000, 0x080000, CRC(c481cac6) SHA1(98e88aa602b5cde63d40ffd5368717a8f65bd5ba) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009139.bin", 0x0000, 0x100000, CRC(f2e4fa3c) SHA1(1909de32f232e5bfb3ee3c624f29c585cca254c2) )
	ROM_LOAD( "95009140.bin", 0x0000, 0x100000, CRC(81bdf47f) SHA1(49c02fb87a4ffc1be4c748c469f5518c314b1391) )
ROM_END




ROM_START( sc_corst )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426842.lo", 0x00001, 0x080000, CRC(4c027808) SHA1(f386534a9e2470814d29544718c0764a05c54bd9) )
	ROM_LOAD16_BYTE( "95426843.hi", 0x00000, 0x080000, CRC(0299593c) SHA1(4043d959be75c3a670a39a5b23faf0c4ee3259c6) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427842.lo", 0x00001, 0x080000, CRC(0b519c35) SHA1(97228d8f92a25bc12b67b8f04797e9b40efe3c35) )
	ROM_LOAD16_BYTE( "95427843.hi", 0x00000, 0x080000, CRC(1d8d6aab) SHA1(1aa49c097a4aa492c6dc7d205123e1470b9d0ab5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009037.bin", 0x0000, 0x100000, CRC(c2d3b6ee) SHA1(36e7e9c956ab91fd1b2e52800b4482ce3a3597f5) )
	ROM_LOAD( "95009038.bin", 0x0000, 0x100000, CRC(45dc4df3) SHA1(7710a0ba9bbe7ae6f590b61bbc1395cd408926d2) )
ROM_END




ROM_START( sc_cfnc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426718.lo", 0x00001, 0x080000, CRC(5cb56926) SHA1(bb8091cf480955fa8bc77f199b133f13d85fe8da) )
	ROM_LOAD16_BYTE( "95426719.hi", 0x00000, 0x080000, CRC(7d8d81a5) SHA1(8181e42af97d3b35b55020a3c109ae48d20fde55) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427718.lo", 0x00001, 0x080000, CRC(5295be6f) SHA1(08fd1c090ac2d59e54b28098e12e705535520777) )
	ROM_LOAD16_BYTE( "95427719.hi", 0x00000, 0x080000, CRC(6e1e6fef) SHA1(647b4ccb490b25b66bf2ddb015f703c2188c3fd6) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009178.bin", 0x0000, 0x100000, CRC(eb938e0a) SHA1(978fa5554462d5d2cbf6a696c6c754318e950223) )
	ROM_LOAD( "95009179.bin", 0x0000, 0x100000, CRC(baf8b8b7) SHA1(43b967f3909270b99b563dab4bd1035079a5cb78) )
ROM_END




ROM_START( sc_cfcp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426830.lo", 0x00001, 0x080000, CRC(c7eb6583) SHA1(3e230e30176fc249c3e3b4ded317ec3d487b0cea) )
	ROM_LOAD16_BYTE( "95426831.hi", 0x00000, 0x080000, CRC(83441be3) SHA1(01cefec8d62000bc59bd89d3ad3bdf2a4ef1a678) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426870.lo", 0x00001, 0x080000, CRC(c6de776d) SHA1(555fa846dbe34d9c6a151e0511358069039e8332) )
	ROM_LOAD16_BYTE( "95426871.hi", 0x00000, 0x080000, CRC(0e02ad7b) SHA1(51f52469d66826e489c5b5c45f604ea5b4ede1a3) )
	ROM_LOAD16_BYTE( "95426922.lo", 0x00001, 0x080000, CRC(7ea0e9b1) SHA1(68bac0c7b0db0115130fd4710755bb2fe0404a86) )
	ROM_LOAD16_BYTE( "95426923.hi", 0x00000, 0x080000, CRC(2aefeb5d) SHA1(0a1f48f7a87d1af42d7bc39100d0590368b94a3e) )
	ROM_LOAD16_BYTE( "95427830.lo", 0x00001, 0x080000, CRC(734d7a37) SHA1(af857ec31e337a890947e9ec3da96467440aeeb0) )
	ROM_LOAD16_BYTE( "95427831.hi", 0x00000, 0x080000, CRC(e22a638e) SHA1(b5199410602e078ca51d009e42b2ad7cdaa7e006) )
	ROM_LOAD16_BYTE( "95427870.lo", 0x00001, 0x080000, CRC(8f2314a5) SHA1(819f51c6f4712ca9ae74be16972b1abdd890b6b2) )
	ROM_LOAD16_BYTE( "95427871.hi", 0x00000, 0x080000, CRC(6813dd1a) SHA1(003d06287cf94364f2967e2513dbca7238fe8838) )
	ROM_LOAD16_BYTE( "95427922.lo", 0x00001, 0x080000, CRC(19a993dd) SHA1(909880cb610e567b7f5c51d479a23561b84835aa) )
	ROM_LOAD16_BYTE( "95427923.hi", 0x00000, 0x080000, CRC(5e679b12) SHA1(385bb9fbadc0e4708b0d08859a18caaa542c609b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009035.bin", 0x0000, 0x100000, CRC(8138c442) SHA1(ceaeb84a27d0e3eba8d3a9a7c76e86b4214178c9) )
	ROM_LOAD( "95009036.bin", 0x0000, 0x100000, CRC(757f44b9) SHA1(61fe15024f7c7f97f865b1b666a5f837a57446a5) )
ROM_END




ROM_START( sc_cfpt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410134.lo", 0x00001, 0x080000, CRC(e133fa6d) SHA1(bc626558bbe460613eae7787f23ede75d1433acc) )
	ROM_LOAD16_BYTE( "95410135.hi", 0x00000, 0x080000, CRC(5ccdd3e0) SHA1(b0ff1d824153746fb4d4494430d511d5e9c09822) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412426.lo", 0x00001, 0x080000, CRC(a6a229da) SHA1(910e6ab809d323cb7b32bdaba008fba2199a5237) )
	ROM_LOAD16_BYTE( "95412427.hi", 0x00000, 0x080000, CRC(121fda59) SHA1(2e43fd580de33316f152e5df515ab08bd8b59f1f) )
	ROM_LOAD16_BYTE( "95413426.lo", 0x00001, 0x080000, CRC(2592f2d2) SHA1(bd08bbd4c8df85004c65391611808f41cb271bfc) )
	ROM_LOAD16_BYTE( "95413427.hi", 0x00000, 0x080000, CRC(a696c5f3) SHA1(12659ced7c10ed3997807b74e86975a9edf39787) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008348.bin", 0x0000, 0x100000, CRC(9c6db3d1) SHA1(f2f613326d0a8c0a1c2e1eea1e91ed34cd344f41) )
	ROM_LOAD( "95008349.bin", 0x0000, 0x100000, CRC(6f7716a0) SHA1(75f8fbee605b96e36e8596068dd4570928a5a02d) )
	ROM_LOAD( "95008363.bin", 0x0000, 0x100000, CRC(6d211d7b) SHA1(59dbb6201aa355a585253d17302e4f8ceed9a220) )
ROM_END




ROM_START( sc_cknig )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426792.lo", 0x00001, 0x080000, CRC(bce4a51b) SHA1(5344198130b8d45a5d24aa2d167d6ee483f3da9c) )
	ROM_LOAD16_BYTE( "95426793.hi", 0x00000, 0x080000, CRC(a995cbfa) SHA1(1b4b9fa170aebcb2284fce7eedf7a7769285dcef) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427792.lo", 0x00001, 0x080000, CRC(42971ac1) SHA1(ec0c682c208766d14b9d9e9f788fc83c5f0f0109) )
	ROM_LOAD16_BYTE( "95427793.hi", 0x00000, 0x080000, CRC(e8d1d3fc) SHA1(cd922021f1086a5ac8410428686fb667d24537d5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009193.bin", 0x0000, 0x100000, CRC(6c3cb54b) SHA1(a140209d19f9cbd18ede08924b94718264ba4118) )
	ROM_LOAD( "95009194.bin", 0x0000, 0x100000, CRC(44229686) SHA1(eda0481282614e6bd82985486ef4eea0eb0ddccd) )
ROM_END




ROM_START( sc_cmons )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211009.bin", 0x0000, 0x8ba10c, CRC(3883c4ea) SHA1(ac5876d252ef9900bbd86a43c73b2e3ba08f4e04) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008434.bin", 0x0000, 0x100000, CRC(2d35e8ab) SHA1(a2e39beb891416bc5fae3d17125d146fe3ec3a12) )
ROM_END




ROM_START( sc_cpays )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412924.lo", 0x00001, 0x080000, CRC(7d2dbbd9) SHA1(330d54bb786ef9b9e12a64897b156ca38fba5e76) )
	ROM_LOAD16_BYTE( "95412925.hi", 0x00000, 0x080000, CRC(66231b51) SHA1(7a20bd591a782c785d5d7fee3b7ed9bccc90fa1c) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95413924.lo", 0x00001, 0x080000, CRC(9ed3fa11) SHA1(bb4b3b42bd19a7ec4d88aa21868933a55e558c5d) )
	ROM_LOAD16_BYTE( "95413925.hi", 0x00000, 0x080000, CRC(771b42fa) SHA1(2d8a481e6d04c6796a127bbe76bbda6b06b68467) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008528.bin", 0x0000, 0x100000, CRC(eccde2dc) SHA1(83fc283269fea98ea1b2c0b846bb790bf84d3053) )
ROM_END




ROM_START( sc_dndbo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426644.lo", 0x00001, 0x080000, CRC(91fa1679) SHA1(e53b7dfb031106441ff21e8782e32f14dde1ee88) )
	ROM_LOAD16_BYTE( "95426645.hi", 0x00000, 0x080000, CRC(257d158a) SHA1(4452939c5e988b5406e1b90d952c3d34de45970e) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426682.lo", 0x00001, 0x080000, CRC(3c856cfa) SHA1(a4e0ccef01a5fd8fcb03ac783a949d5af6a1ffe6) )
	ROM_LOAD16_BYTE( "95426683.hi", 0x00000, 0x080000, CRC(db7182bd) SHA1(5280b59251276c67519aa297c380874106bf12f1) )
	ROM_LOAD16_BYTE( "95426826.lo", 0x00001, 0x080000, CRC(4e8e8bdd) SHA1(8f67e9ff36c77ec2f3abcdb411583d0d2473f4b8) )
	ROM_LOAD16_BYTE( "95426827.hi", 0x00000, 0x080000, CRC(9b971a80) SHA1(226c5e743f7de51a103447fe8278a002b75518d5) )
	ROM_LOAD16_BYTE( "95426852.lo", 0x00001, 0x080000, CRC(185fc345) SHA1(475296683007b0608e2572b156a59f3a24aa15ad) )
	ROM_LOAD16_BYTE( "95426853.hi", 0x00000, 0x080000, CRC(0f7a81ad) SHA1(46fa2d40e3bf43307e70573bcc22c1d77cb7887b) )
	ROM_LOAD16_BYTE( "95426914.lo", 0x00001, 0x080000, CRC(d2dd5940) SHA1(7ed46231a5ff9e2e3a8d427a55967f98195c345d) )
	ROM_LOAD16_BYTE( "95426915.hi", 0x00000, 0x080000, CRC(00acb2ed) SHA1(30448843ab65e0eb16322652ddbcf576f2d88e13) )
	ROM_LOAD16_BYTE( "95427644.lo", 0x00001, 0x080000, CRC(69ffa92c) SHA1(2d9f0545e279d4c480e4a8747a5638268d33b567) )
	ROM_LOAD16_BYTE( "95427645.hi", 0x00000, 0x080000, CRC(408a15b8) SHA1(837067032b352bc396fa2801e89a7c34387c2b6e) )
	ROM_LOAD16_BYTE( "95427682.lo", 0x00001, 0x080000, CRC(9ef8c027) SHA1(905c75f133a8970b39a9538af937d813775036b9) )
	ROM_LOAD16_BYTE( "95427683.hi", 0x00000, 0x080000, CRC(893dbff9) SHA1(e0426062859d3e8431b94a74b533fbf02f4ed09d) )
	ROM_LOAD16_BYTE( "95427826.lo", 0x00001, 0x080000, CRC(3a9fdf64) SHA1(dd2852d394c1ac74f9035346bf02e0ddf594e06d) )
	ROM_LOAD16_BYTE( "95427827.hi", 0x00000, 0x080000, CRC(d0ab32aa) SHA1(d861867702be09a0523a47bb18e2e44e9b302948) )
	ROM_LOAD16_BYTE( "95427852.lo", 0x00001, 0x080000, CRC(1d7def08) SHA1(ca500d62a3d1fda81d8597bcffcf04721a229751) )
	ROM_LOAD16_BYTE( "95427853.hi", 0x00000, 0x080000, CRC(b926d9c4) SHA1(b3ae0ff4fd5a18b98bbabf1d938700b8510baa00) )
	ROM_LOAD16_BYTE( "95427914.lo", 0x00001, 0x080000, CRC(c7a3b44e) SHA1(7b0b2992b8098b69c2fa6315e6c2d9e895b3959b) )
	ROM_LOAD16_BYTE( "95427915.hi", 0x00000, 0x080000, CRC(a6590c68) SHA1(aaeb8a9422fc38f044a46489c61f5a306910b4eb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009158.bin", 0x0000, 0x100000, CRC(27f11b81) SHA1(f2690c2828ad09d73cb14c5c1cb53c2ad1fc7b53) )
	ROM_LOAD( "95009159.bin", 0x0000, 0x100000, CRC(95e278c8) SHA1(7d85b6dbe3ccacd6c5a5b4eb475598a3d5548ce0) )
ROM_END




ROM_START( sc_dndbl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422086.lo", 0x00001, 0x080000, CRC(5deb6c03) SHA1(2ac729194d1e6b0fb71f5f248bf4918140f4ab2a) )
	ROM_LOAD16_BYTE( "95422087.hi", 0x00000, 0x080000, CRC(e194968f) SHA1(ca2a17f826671025c6cdd7b1361107b7ffe3ea07) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95422148.lo", 0x00001, 0x080000, CRC(825d9ed9) SHA1(b123fd2190d10888286a5e58b3a796890b673bd6) )
	ROM_LOAD16_BYTE( "95422149.hi", 0x00000, 0x080000, CRC(b9dff341) SHA1(a27f5e7d1a2f78898c74eae1f87cb6c6b242791e) )
	ROM_LOAD16_BYTE( "95422206.lo", 0x00001, 0x080000, CRC(b50bc3df) SHA1(29e5edddbc8f67fd5d13eef44b6dd03f714110f0) )
	ROM_LOAD16_BYTE( "95422207.hi", 0x00000, 0x080000, CRC(98a749aa) SHA1(0e3eecc9f257994dba4907e735b9371e81a25e8f) )
	ROM_LOAD16_BYTE( "95422210.lo", 0x00001, 0x080000, CRC(ef3c7726) SHA1(7f9d2e548800c295731b8c15c5cc8119017069ba) )
	ROM_LOAD16_BYTE( "95422211.hi", 0x00000, 0x080000, CRC(07545d4c) SHA1(d3dd3ff04c1d2f485dacd13b4214f2462254a6d5) )
	ROM_LOAD16_BYTE( "95422246.lo", 0x00001, 0x080000, CRC(ab3326ea) SHA1(d511f252f1acf76fc59d3f343c4d1db54bb8de8a) )
	ROM_LOAD16_BYTE( "95422247.hi", 0x00000, 0x080000, CRC(b9c05994) SHA1(e6ca9c7f8e6df6aa2277a329ab211134dae684aa) )
	ROM_LOAD16_BYTE( "95422248.lo", 0x00001, 0x080000, CRC(45192ed6) SHA1(21980888e1deb5e4d8cf140b957d10e18cd7315a) )
	ROM_LOAD16_BYTE( "95422249.hi", 0x00000, 0x080000, CRC(5b671826) SHA1(202f1b63e64c71fd7a1ef8c3159ed7a778d7d6f5) )
	ROM_LOAD16_BYTE( "95422324.lo", 0x00001, 0x080000, CRC(681980ea) SHA1(11520621d11bc6642fa1ef6a81f36e4c2c5c2349) )
	ROM_LOAD16_BYTE( "95422325.hi", 0x00000, 0x080000, CRC(9337c3c8) SHA1(55313e2658ebd3fe314d5d2fe7fc846b54cb6b6d) )
	ROM_LOAD16_BYTE( "95422326.lo", 0x00001, 0x080000, CRC(5f886988) SHA1(6b97194b2da2ba32b36652b0cf6f033ca364e297) )
	ROM_LOAD16_BYTE( "95422327.hi", 0x00000, 0x080000, CRC(71fdb9df) SHA1(c39ac2a70572bc4a337c1b578430e881cf5c0dc6) )
	ROM_LOAD16_BYTE( "95422864.lo", 0x00001, 0x080000, CRC(f969e95d) SHA1(c4dc12d745ad4e4e1a37cbf696875c65d0e33349) )
	ROM_LOAD16_BYTE( "95422865.hi", 0x00000, 0x080000, CRC(76abce7e) SHA1(737bdf6c3fa3820b8e114d61acc072a493fe7b26) )
	ROM_LOAD16_BYTE( "95423086.lo", 0x00001, 0x080000, CRC(330ad71d) SHA1(e80e38e0a7dc00271f589a35fa1666027ce7f764) )
	ROM_LOAD16_BYTE( "95423087.hi", 0x00000, 0x080000, CRC(2c028fb9) SHA1(5ba125d474f6d916967ad90bddfc8ebabcdb18aa) )
	ROM_LOAD16_BYTE( "95423148.lo", 0x00001, 0x080000, CRC(b2c47c77) SHA1(f788eaf4aaf8509de48d661341d5d46bee5ee1d9) )
	ROM_LOAD16_BYTE( "95423149.hi", 0x00000, 0x080000, CRC(55164612) SHA1(06d666a611a89ee0e79072a54959508a5cd55981) )
	ROM_LOAD16_BYTE( "95423206.lo", 0x00001, 0x080000, CRC(e734b65f) SHA1(04f38218aeb61305df1dd26574a24efb1cf04a33) )
	ROM_LOAD16_BYTE( "95423207.hi", 0x00000, 0x080000, CRC(c0384d57) SHA1(c1841c1b06e47edeb760538a89b6302e67f6473d) )
	ROM_LOAD16_BYTE( "95423210.lo", 0x00001, 0x080000, CRC(6db7b68f) SHA1(db23b755758bee7706ee1504743ef6fa84e542d0) )
	ROM_LOAD16_BYTE( "95423211.hi", 0x00000, 0x080000, CRC(fc572112) SHA1(27b3bd337ce82b8029b0e2ab9bbcc45c1d2f5244) )
	ROM_LOAD16_BYTE( "95423246.lo", 0x00001, 0x080000, CRC(36bdbe7a) SHA1(f8de104bafa301dc653b3aa01bbee08f57f42d33) )
	ROM_LOAD16_BYTE( "95423247.hi", 0x00000, 0x080000, CRC(7432ef89) SHA1(1c71c4fc96afd6bf1b644cce9312a77370f1e201) )
	ROM_LOAD16_BYTE( "95423248.lo", 0x00001, 0x080000, CRC(e3fe8ce9) SHA1(503ac6f37a24e36ce268f77e13cb7ef3719abca2) )
	ROM_LOAD16_BYTE( "95423249.hi", 0x00000, 0x080000, CRC(cfc95a9e) SHA1(a9f235f3688ccd978c28c6425a4aeff68e433a75) )
	ROM_LOAD16_BYTE( "95423324.lo", 0x00001, 0x080000, CRC(0d2469ff) SHA1(b219ee90cefb52ab495ec976f8554e834e2c8088) )
	ROM_LOAD16_BYTE( "95423325.hi", 0x00000, 0x080000, CRC(4eabcf0c) SHA1(295b4771f64493466cd75098f71f0e118460e2f3) )
	ROM_LOAD16_BYTE( "95423326.lo", 0x00001, 0x080000, CRC(8bfe21a2) SHA1(1fc13b53cda62531322a12f210daa0e510391ba3) )
	ROM_LOAD16_BYTE( "95423327.hi", 0x00000, 0x080000, CRC(883e7518) SHA1(8a437306751932f04a72cd532c567616e4d10315) )
	ROM_LOAD16_BYTE( "95423864.lo", 0x00001, 0x080000, CRC(06e43774) SHA1(d01802ed4a2da78dd5c1b99890b32fb582ba745e) )
	ROM_LOAD16_BYTE( "95423865.hi", 0x00000, 0x080000, CRC(18f40e09) SHA1(8e3be8b84ed0833c9306e17d14bc3784babc1153) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_dndbe )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418408.lo", 0x00001, 0x080000, CRC(cfed16c5) SHA1(fdec6bb6865c258af8ebfd5db529ef0e1c54fe35) )
	ROM_LOAD16_BYTE( "95418409.hi", 0x00000, 0x080000, CRC(a7fa99e7) SHA1(ff098a9adf00dce6d975d20c66734ac789f4d82d) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418410.lo", 0x00001, 0x080000, CRC(ddd534d0) SHA1(1c8acd74d79fc7f169ed54e2d603100775610e5a) )
	ROM_LOAD16_BYTE( "95418411.hi", 0x00000, 0x080000, CRC(5346fd2a) SHA1(ada8ed84a173bf3f68af0a2e1b92dbfe94f2d6c9) )
	ROM_LOAD16_BYTE( "95418560.lo", 0x00001, 0x080000, CRC(8587f089) SHA1(5c08f5442bc0de473af1fed397e179cff94aa417) )
	ROM_LOAD16_BYTE( "95418561.hi", 0x00000, 0x080000, CRC(5e9afe60) SHA1(0fc5c84d6e9eb824550f8f370dd6080401365497) )
	ROM_LOAD16_BYTE( "95418562.lo", 0x00001, 0x080000, CRC(71ddd3aa) SHA1(8e48d21e41454e1fc1845638baeee17da8f99a3e) )
	ROM_LOAD16_BYTE( "95418563.hi", 0x00000, 0x080000, CRC(4e4baee8) SHA1(064c7e05bee768f6240d766000f8480a08d59738) )
	ROM_LOAD16_BYTE( "95419408.lo", 0x00001, 0x080000, CRC(948adf45) SHA1(9faf9eaaae60994c7653c35c8886e329eb6cef56) )
	ROM_LOAD16_BYTE( "95419409.hi", 0x00000, 0x080000, CRC(79dc668f) SHA1(263fb10f42a6586283a0b6dbdeb401c639a837e8) )
	ROM_LOAD16_BYTE( "95419410.lo", 0x00001, 0x080000, CRC(e129a4ec) SHA1(8752b7c26bc9a95ea32d023f466eac0a85fd2d1a) )
	ROM_LOAD16_BYTE( "95419411.hi", 0x00000, 0x080000, CRC(996e5e01) SHA1(66fd3155be23f350f4d53deed604202eeba83f1a) )
	ROM_LOAD16_BYTE( "95419560.lo", 0x00001, 0x080000, CRC(e04c774c) SHA1(ba49c4b382a2f92a55cf0b9b60b64c9074e6bc0c) )
	ROM_LOAD16_BYTE( "95419561.hi", 0x00000, 0x080000, CRC(acc55e76) SHA1(b4ffe164113d82880c8ed57569aab193990375cb) )
	ROM_LOAD16_BYTE( "95419562.lo", 0x00001, 0x080000, CRC(c6a73fc8) SHA1(d33694a4b67581d450835d89709d859fda3bdb09) )
	ROM_LOAD16_BYTE( "95419563.hi", 0x00000, 0x080000, CRC(a521350c) SHA1(45dddd7791b0ac76ed6d39450624c8e2140fed3f) )
	ROM_LOAD16_BYTE( "95422007.hi", 0x00000, 0x080000, CRC(7ae82867) SHA1(60c02d9abc05e1655eef71d5ddfc9b8e6dd3c4aa) )
	ROM_LOAD16_BYTE( "95422008.lo", 0x00001, 0x080000, CRC(1071a6bf) SHA1(1ccd638a4899707f024575bf30db2ffd17b63d3c) )
//  95422009.hi = 95422009.hi           sc4dndtp   Deal Or No Deal The Power (Bellfruit) (Scorpion 4)
	ROM_LOAD16_BYTE( "95422094.lo", 0x00001, 0x080000, CRC(4b3cce67) SHA1(1e85f125308ffcbdc1564d2b00ce07db83a7b5ba) )
	ROM_LOAD16_BYTE( "95422095.hi", 0x00000, 0x080000, CRC(e4fa031f) SHA1(7438d213055bd5f26ac6c2e3798a0db1a11c1dc5) )
	ROM_LOAD16_BYTE( "95422136.lo", 0x00001, 0x080000, CRC(0ed927b0) SHA1(6dc5b1d4668d5849a84fd43d05ea293ce0ff333f) )
	ROM_LOAD16_BYTE( "95422137.hi", 0x00000, 0x080000, CRC(842752bd) SHA1(d1211df434028f294b2b39f47833ca2f26d35482) )
	ROM_LOAD16_BYTE( "95422138.lo", 0x00001, 0x080000, CRC(14830e37) SHA1(728e7b3c71d69c71e20daa1d766d238b2167dd0d) )
	ROM_LOAD16_BYTE( "95422139.hi", 0x00000, 0x080000, CRC(63172b46) SHA1(0ca1032a31f2a75840ca2689167054bf9dd48718) )
	ROM_LOAD16_BYTE( "95422536.lo", 0x00001, 0x080000, CRC(bb212e12) SHA1(31022880984eaebc5a9164ff9116f85ffa6ac7af) )
	ROM_LOAD16_BYTE( "95422537.hi", 0x00000, 0x080000, CRC(1094f140) SHA1(a17824ec68d7d0ee2ea10090807974e41b202e00) )
	ROM_LOAD16_BYTE( "95422716.lo", 0x00001, 0x080000, CRC(9012dfb9) SHA1(58fa79aa00ab91d60ed222ab5e7befd89544c488) )
	ROM_LOAD16_BYTE( "95422717.hi", 0x00000, 0x080000, CRC(fec7aa06) SHA1(50f11ca1073d546cc3e6fdf40c0e004e0c8a65b2) )
	ROM_LOAD16_BYTE( "95422718.lo", 0x00001, 0x080000, CRC(bb440f5d) SHA1(739816ec468a223d3aae2fc8c968af3ea868063b) )
	ROM_LOAD16_BYTE( "95422719.hi", 0x00000, 0x080000, CRC(eb972e40) SHA1(ebdb7a47d54ff4cf46645783fdf6dd150aa1eeee) )
	ROM_LOAD16_BYTE( "95422864.lo", 0x00001, 0x080000, CRC(f969e95d) SHA1(c4dc12d745ad4e4e1a37cbf696875c65d0e33349) )
	ROM_LOAD16_BYTE( "95422865.hi", 0x00000, 0x080000, CRC(76abce7e) SHA1(737bdf6c3fa3820b8e114d61acc072a493fe7b26) )
	ROM_LOAD16_BYTE( "95422868.lo", 0x00001, 0x080000, CRC(be84dbf7) SHA1(cc970d04d8a3dea192299272da1f23e1df64b596) )
	ROM_LOAD16_BYTE( "95422869.hi", 0x00000, 0x080000, CRC(6ec7b821) SHA1(9b413c1e2bdb1e21c51fdadc9f72f54d0aa98801) )
	ROM_LOAD16_BYTE( "95422888.lo", 0x00001, 0x080000, CRC(75df9f2a) SHA1(6b0356a37a4cf5b9d687e22ff767a44cd4acda74) )
	ROM_LOAD16_BYTE( "95422889.hi", 0x00000, 0x080000, CRC(b1c5800f) SHA1(23da01d0095b741960182f8f2e336cbd74ddf87b) )
	ROM_LOAD16_BYTE( "95422892.lo", 0x00001, 0x080000, CRC(3b605323) SHA1(54c8a858c908cf6e70e476e2ee905b1b5cd1d194) )
	ROM_LOAD16_BYTE( "95422893.hi", 0x00000, 0x080000, CRC(34e1a059) SHA1(0dfae3d49562750ff161fc25285e097a727298af) )
	ROM_LOAD16_BYTE( "95423007.hi", 0x00000, 0x080000, CRC(1858f222) SHA1(679f6c35e9953caf738660c67c372d9bd09e086b) )
	ROM_LOAD16_BYTE( "95423008.lo", 0x00001, 0x080000, CRC(90b98909) SHA1(e37f728fbd3aabeef4109778daf992314a2884a6) )
//  95423009.hi = 95423009.hi           sc4dndtp   Deal Or No Deal The Power (Bellfruit) (Scorpion 4)
	ROM_LOAD16_BYTE( "95423094.lo", 0x00001, 0x080000, CRC(69bd6da4) SHA1(96cdc3f4a05eca4fc4f650fc1dbf9b2c20247916) )
	ROM_LOAD16_BYTE( "95423095.hi", 0x00000, 0x080000, CRC(f117c581) SHA1(cc4404b587f30e77e73860b57156ef8e57baab58) )
	ROM_LOAD16_BYTE( "95423136.lo", 0x00001, 0x080000, CRC(0a58892d) SHA1(a034a3adfa6cc6d367124fa339bd54f45601671f) )
	ROM_LOAD16_BYTE( "95423137.hi", 0x00000, 0x080000, CRC(4f515fc8) SHA1(6b9839637be3978db21a8cc6d7260a4929371f74) )
	ROM_LOAD16_BYTE( "95423138.lo", 0x00001, 0x080000, CRC(8ed1cc62) SHA1(c80dad36e8b742b9577fada6642cf76fc87ae838) )
	ROM_LOAD16_BYTE( "95423139.hi", 0x00000, 0x080000, CRC(10ddb941) SHA1(d41c6382f699a7ed7551027e62be387347a8b7b8) )
	ROM_LOAD16_BYTE( "95423536.lo", 0x00001, 0x080000, CRC(dadf5809) SHA1(fddb333a725ca655cbb510652f99111d57f2a0c0) )
	ROM_LOAD16_BYTE( "95423537.hi", 0x00000, 0x080000, CRC(64e96cf9) SHA1(5606fa6dc0c12aba697da8f0184c9a474d890f96) )
	ROM_LOAD16_BYTE( "95423718.lo", 0x00001, 0x080000, CRC(7557f475) SHA1(45a644b461899636a86709a1779d3c8194286ccc) )
	ROM_LOAD16_BYTE( "95423719.hi", 0x00000, 0x080000, CRC(ac09d7b8) SHA1(e7547f28b2b607b4bdd69360c2f4d46a69b5e738) )
	ROM_LOAD16_BYTE( "95423864.lo", 0x00001, 0x080000, CRC(06e43774) SHA1(d01802ed4a2da78dd5c1b99890b32fb582ba745e) )
	ROM_LOAD16_BYTE( "95423865.hi", 0x00000, 0x080000, CRC(18f40e09) SHA1(8e3be8b84ed0833c9306e17d14bc3784babc1153) )
	ROM_LOAD16_BYTE( "95423868.lo", 0x00001, 0x080000, CRC(0e57c5b3) SHA1(54811dc668177ea431905b72f33638e9541d54ee) )
	ROM_LOAD16_BYTE( "95423869.hi", 0x00000, 0x080000, CRC(81cb7a36) SHA1(2da85f66a5809e909a7fc002564bed2cfd9d5b33) )
	ROM_LOAD16_BYTE( "95423888.lo", 0x00001, 0x080000, CRC(45dbf280) SHA1(6e6226984c7ad4cee3021cd50c7d853fee51d1cd) )
	ROM_LOAD16_BYTE( "95423889.hi", 0x00000, 0x080000, CRC(2184fc7d) SHA1(6b08cd6b3d8e860c3d73181a8ced7b26ecad4243) )
	ROM_LOAD16_BYTE( "95423892.lo", 0x00001, 0x080000, CRC(0fb3f196) SHA1(19d727557e3f82a59a9e77ef210066403c6b2b10) )
	ROM_LOAD16_BYTE( "95423893.hi", 0x00000, 0x080000, CRC(a455e50c) SHA1(a721b85b2505a49db6c2e668007addd6f7b75f83) )
	ROM_LOAD16_BYTE( "95426148.lo", 0x00001, 0x080000, CRC(b064f517) SHA1(170b5671407f6c65c3ad41d07fa0fb616da1fb99) )
	ROM_LOAD16_BYTE( "95426149.hi", 0x00000, 0x080000, CRC(4bfc2d8d) SHA1(2333ebf2cdb9322fcd41d5d07ebbd9ecd178d8ff) )
	ROM_LOAD16_BYTE( "95426150.lo", 0x00001, 0x080000, CRC(4de9cfa2) SHA1(1dbe3af03ce4f7eca858c47e28ad65c650dabf88) )
	ROM_LOAD16_BYTE( "95426151.hi", 0x00000, 0x080000, CRC(83d36e43) SHA1(243d5c457f871a2f3cea8d4e2b207b2cd962ba48) )
	ROM_LOAD16_BYTE( "95427148.lo", 0x00001, 0x080000, CRC(e28fc33c) SHA1(1658f809021e8a7993025ad0884444f1cd5aac1d) )
	ROM_LOAD16_BYTE( "95427149.hi", 0x00000, 0x080000, CRC(f01bf5b2) SHA1(e7c9a50c64210cc790cb1d14cdba785d84f9252f) )
	ROM_LOAD16_BYTE( "95427150.lo", 0x00001, 0x080000, CRC(0ce46255) SHA1(dddf8edc4ee681d8e8be4f9f01fcd3c775c2aaa1) )
	ROM_LOAD16_BYTE( "95427151.hi", 0x00000, 0x080000, CRC(97f4a22b) SHA1(178b5beb99952e77889e5c444216802195756e54) )
	ROM_LOAD16_BYTE( "p3063p41.hi", 0x00000, 0x080000, CRC(0b458c4a) SHA1(6983b9509136b6534c4ddd2bae171018142e8c5c) )
	ROM_LOAD16_BYTE( "p3063p41.lo", 0x00001, 0x080000, CRC(ade6c7a2) SHA1(8b7a42cf616fb7b7f93584acaecc0b405b47d020) )
	ROM_LOAD16_BYTE( "p3063p51.hi", 0x00000, 0x080000, CRC(959e73df) SHA1(866dfcf64958ae2e36ba5180aa8f045d624fa817) )
	ROM_LOAD16_BYTE( "p3063p51.lo", 0x00001, 0x080000, CRC(9b4f1dd8) SHA1(4c55dd6a8e899a072d4537c78e3d1f1d4e00384f) )
	ROM_LOAD16_BYTE( "p3063s41.hi", 0x00000, 0x080000, CRC(1aace185) SHA1(7b5e14dd79bd911890c1269d8400cdd1171a1011) )
	ROM_LOAD16_BYTE( "p3063s41.lo", 0x00001, 0x080000, CRC(5afa2568) SHA1(b7a5b7899f5b8464539f9a3153ab7848f5e6be8f) )
	ROM_LOAD16_BYTE( "p3063s51.hi", 0x00000, 0x080000, CRC(2b55719c) SHA1(5fc9af53e2ca6fa0735d30723433e793db61fdcb) )
	ROM_LOAD16_BYTE( "p3063s51.lo", 0x00001, 0x080000, CRC(4a339c8b) SHA1(710e1ff391517dcb6122026de85ba79948d5de1f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008624.bin", 0x0000, 0x100000, CRC(bf9620ea) SHA1(63f5a209da3d0117fcb579364a53b23d2b02cfe5) )
	ROM_LOAD( "95008625.bin", 0x0000, 0x100000, CRC(2e1a1db0) SHA1(41ebad0615d0ad3fea6f2c00e2bb170d5e417e4a) )
ROM_END




ROM_START( sc_dndbq )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424268.lo", 0x00001, 0x080000, CRC(d51cf30a) SHA1(8fcaf84bea865801052a09894465bd7e9ea0f235) )
	ROM_LOAD16_BYTE( "95424269.hi", 0x00000, 0x080000, CRC(285a80ad) SHA1(36da0dbd0fd1c4a50ac7c8b5d91011f6ed039168) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95424366.lo", 0x00001, 0x080000, CRC(a529920f) SHA1(02f7e6158288eabb7d37ed19cca873db8b7d6c1a) )
	ROM_LOAD16_BYTE( "95424367.hi", 0x00000, 0x080000, CRC(01fc85be) SHA1(bf98096c7e0ddd4e9b3683896166b591372aeb24) )
	ROM_LOAD16_BYTE( "95424404.lo", 0x00001, 0x080000, CRC(e086dbd4) SHA1(cbc70e4fe552fbeacf8994c2a32185f4884a234b) )
	ROM_LOAD16_BYTE( "95424405.hi", 0x00000, 0x080000, CRC(3b886af7) SHA1(e5379ac5999d2be0399e182f9afce68bd60ee857) )
	ROM_LOAD16_BYTE( "95425268.lo", 0x00001, 0x080000, CRC(382fc268) SHA1(e884e557043322ca5a5c2b6ec31272a031e37ae4) )
	ROM_LOAD16_BYTE( "95425269.hi", 0x00000, 0x080000, CRC(57183b0e) SHA1(e8260b9a2f9b625547ef4b3a594b7a7ccc687138) )
	ROM_LOAD16_BYTE( "95425366.lo", 0x00001, 0x080000, CRC(9286e0c1) SHA1(6cc384725083d72a29cc59aa98849e9455ace35c) )
	ROM_LOAD16_BYTE( "95425367.hi", 0x00000, 0x080000, CRC(a3a9e3fb) SHA1(1fa5273bec77a605fd95916316a7a066e6b8d378) )
	ROM_LOAD16_BYTE( "95425404.lo", 0x00001, 0x080000, CRC(6891391c) SHA1(9c2da4c54ca7bfd2a7652705e5c96096dfbeed48) )
	ROM_LOAD16_BYTE( "95425405.hi", 0x00000, 0x080000, CRC(4c9566bc) SHA1(76eaa4556dc7bc69ea64f0d4ef7456241134c8af) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891057.bin", 0x0000, 0x5000, CRC(75c0cf91) SHA1(20e7fb3a279cc127cec08a78b6633852b0a950f7) )
	ROM_LOAD( "95891058.bin", 0x0000, 0x5000, CRC(69163f2d) SHA1(66b6b593126c452f01b36c03e82d003860340025) )
	ROM_LOAD( "95891059.bin", 0x0000, 0x5000, CRC(aa4c1dbd) SHA1(4ebd1b132a4125bdcf58d5867cffb821e3e7b1a3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008887.bin", 0x0000, 0x100000, CRC(53cb9dc5) SHA1(66cdf8624736ea5a4e239bdb81fc96366ec4623e) )
ROM_END



ROM_START( sc_dndbc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426508.lo", 0x00001, 0x080000, CRC(17e3bc31) SHA1(a26066e4cb4e3c0109c6bdf6fd2d0b539688b71a) )
	ROM_LOAD16_BYTE( "95426509.hi", 0x00000, 0x080000, CRC(c8c97bca) SHA1(c246af21a048beecd73739d314f76f1a50c88138) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426510.lo", 0x00001, 0x080000, CRC(fa55da72) SHA1(92c229edbaa72f24296ec256451e9d3657e8407c) )
	ROM_LOAD16_BYTE( "95426511.hi", 0x00000, 0x080000, CRC(df28fee5) SHA1(15241426c9749f362dc9c967a0ef50e7a8ae9ba1) )
	ROM_LOAD16_BYTE( "95426656.lo", 0x00001, 0x080000, CRC(94a14d32) SHA1(3d78e7ccf70665e0668b3459655877525e3d2e29) )
	ROM_LOAD16_BYTE( "95426657.hi", 0x00000, 0x080000, CRC(35c7b6b0) SHA1(37639fc41dcf1632a76b80e404ee35fe95f23a4e) )
	ROM_LOAD16_BYTE( "95426704.lo", 0x00001, 0x080000, CRC(71e48612) SHA1(d64fb9b27ad705bcaef2e4ce4ae7aa35403a6c25) )
	ROM_LOAD16_BYTE( "95426705.hi", 0x00000, 0x080000, CRC(76c0a661) SHA1(78cf4b37c8e216dad1c0c67725a1181a75e51878) )
	ROM_LOAD16_BYTE( "95426808.lo", 0x00001, 0x080000, CRC(bad06e32) SHA1(6a63c93ca7f9b970ee44a1314c5637c0f3f6ec6c) )
	ROM_LOAD16_BYTE( "95426809.hi", 0x00000, 0x080000, CRC(1c2f66e7) SHA1(1acffa960e5badd60021417632a0d904dd6e11c5) )
	ROM_LOAD16_BYTE( "95427508.lo", 0x00001, 0x080000, CRC(f06cf1c8) SHA1(745af8c14e0ed424bd124b8b12ace26e716fa36c) )
	ROM_LOAD16_BYTE( "95427509.hi", 0x00000, 0x080000, CRC(9459fce4) SHA1(4c02457468771e027b2447b4d78a2306ac975057) )
	ROM_LOAD16_BYTE( "95427510.lo", 0x00001, 0x080000, CRC(86fdd1ec) SHA1(40785abe4cfda54fb42100cc79ed1d195e8cd40f) )
	ROM_LOAD16_BYTE( "95427511.hi", 0x00000, 0x080000, CRC(5d6dd79e) SHA1(20518116a1975b69379723940654c1862e9985f2) )
	ROM_LOAD16_BYTE( "95427656.lo", 0x00001, 0x080000, CRC(a4411416) SHA1(8724e8613ad00fc829e7a97a11c3a654a8c6e0a9) )
	ROM_LOAD16_BYTE( "95427657.hi", 0x00000, 0x080000, CRC(26fdcc94) SHA1(c2ac19a0fd94dd32ece5113613e51888ba3b39be) )
	ROM_LOAD16_BYTE( "95427704.lo", 0x00001, 0x080000, CRC(fe58add2) SHA1(3a33665a53661e57459c5e3d75b24e87c946bd2a) )
	ROM_LOAD16_BYTE( "95427705.hi", 0x00000, 0x080000, CRC(efb27e44) SHA1(c6918bcf8bff48e935b6f4000ac7505a9381e3d9) )
	ROM_LOAD16_BYTE( "95427808.lo", 0x00001, 0x080000, CRC(c16fe4dd) SHA1(8eae8e1c26b050f195b8161edf36644cf2fc7a3a) )
	ROM_LOAD16_BYTE( "95427809.hi", 0x00000, 0x080000, CRC(88e7cb95) SHA1(35b3dfd80aedb75b997338d212ca6a5e8af5e3ed) )
	ROM_LOAD16_BYTE( "p3312p01.hi", 0x00000, 0x080000, CRC(f15c7ec4) SHA1(b73ac27e894cd1749f331363f94bdf5ddb2e73d5) )
	ROM_LOAD16_BYTE( "p3312p01.lo", 0x00001, 0x080000, CRC(6f6baaf4) SHA1(b2d6d2c6bda0f7d11ee70c2e3c57991de21fa5c0) )
	ROM_LOAD16_BYTE( "p3312p71.hi", 0x00000, 0x080000, CRC(0fa9bdcd) SHA1(cd302c1c297cae17c41b4d187169a86764f23ccf) )
	ROM_LOAD16_BYTE( "p3312p71.lo", 0x00001, 0x080000, CRC(9fd10bf5) SHA1(f1689e55469c04736ed095d7b95d8327ea179333) )
	ROM_LOAD16_BYTE( "p3312s01.hi", 0x00000, 0x080000, CRC(2468a800) SHA1(3edd7645cd320f57ec92a023b97716984b8b99cf) )
	ROM_LOAD16_BYTE( "p3312s01.lo", 0x00001, 0x080000, CRC(8bbd30d7) SHA1(62ba1668e78385c1d3f595ede9debbe65711d556) )
	ROM_LOAD16_BYTE( "p3312s71.hi", 0x00000, 0x080000, CRC(9d2f60c1) SHA1(b0300c779cd0e86621ad0d04da948662c074822a) )
	ROM_LOAD16_BYTE( "p3312s71.lo", 0x00001, 0x080000, CRC(5de05c8c) SHA1(520ec4c7d9bc1d93e7a60396c1aa3b9697a57689) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009100.bin", 0x0000, 0x100000, CRC(b06110c0) SHA1(84289721a8c71124cc4df79fc90d0ded8d43fd07) )
	ROM_LOAD( "95009101.bin", 0x0000, 0x100000, CRC(53b38d0a) SHA1(1da40cbee8a18713864e3a578ac49c2108585e44) )
ROM_END




ROM_START( sc_dndcr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426820.lo", 0x00001, 0x080000, CRC(30427067) SHA1(84eb1f430a43c7938ef1c8921a962a6ddc6e8baf) )
	ROM_LOAD16_BYTE( "95426821.hi", 0x00000, 0x080000, CRC(28a3813f) SHA1(6df280c5606c96ce559084afa9f7155064b7249e) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426912.lo", 0x00001, 0x080000, CRC(2c47dda7) SHA1(74005f1b80bb33bf087f183928573045f90c3b8c) )
	ROM_LOAD16_BYTE( "95426913.hi", 0x00000, 0x080000, CRC(22b2d228) SHA1(6966339a4e1e8fb704608833d191d2db2a073c9e) )
	ROM_LOAD16_BYTE( "95427820.lo", 0x00001, 0x080000, CRC(1878c967) SHA1(b156db8c67aaccd2b35c0d27116e01e2ec745c37) )
	ROM_LOAD16_BYTE( "95427821.hi", 0x00000, 0x080000, CRC(1b71bd56) SHA1(cdfa355f7abbf60a0b4473538d90a7f3c58638d8) )
	ROM_LOAD16_BYTE( "95427912.lo", 0x00001, 0x080000, CRC(473ff969) SHA1(3e953156ed3062aeeb9de8f9bae45c7db7209a10) )
	ROM_LOAD16_BYTE( "95427913.hi", 0x00000, 0x080000, CRC(771dd070) SHA1(838256baa0121691d15e3de333fffc9d33ea87e7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009033.bin", 0x0000, 0x100000, CRC(4e167844) SHA1(d0e7101fe033bc9fc0e279c3d457a7da8e8aab00) )
	ROM_LOAD( "95009034.bin", 0x0000, 0x100000, CRC(a3e7b40a) SHA1(09f1fde693750f15e78da91c796e8593d06d19e9) )
ROM_END




ROM_START( sc_dndde )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426902.lo", 0x00001, 0x080000, CRC(cde3fda5) SHA1(667b2704f3d91590c24592f37a07604f8bb5e77a) )
	ROM_LOAD16_BYTE( "95426903.hi", 0x00000, 0x080000, CRC(ea6372ce) SHA1(f26e31bbe280d32d2ba127b404d9488924b90bd3) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427902.lo", 0x00001, 0x080000, CRC(c4041b95) SHA1(dd23bf09425b6c2cdf6422dfce3db22797f62c73) )
	ROM_LOAD16_BYTE( "95427903.hi", 0x00000, 0x080000, CRC(2f2ed99f) SHA1(157e088838fc551606546b1c660fb6a0f61cd846) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009053.bin", 0x0000, 0x100000, CRC(f06acb47) SHA1(043756eda04d193f7365f2fd0fafc36c3b6b0bd9) )
	ROM_LOAD( "95009054.bin", 0x0000, 0x100000, CRC(595baae8) SHA1(9aa03b265294eaed0051b0a25cc9a0e1481b4390) )
ROM_END



ROM_START( sc_dnddi )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426790.lo", 0x00001, 0x080000, CRC(da4e4dc9) SHA1(c86349015f8778e2666db187d784340253d66df3) )
	ROM_LOAD16_BYTE( "95426791.hi", 0x00000, 0x080000, CRC(86063fdc) SHA1(c94b13be13bb947fca82c4e042c2d0a37e3c5679) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426824.lo", 0x00001, 0x080000, CRC(5c80b3a0) SHA1(3ad8506c4f52ebff92da0f9d623ebd8712918e8c) )
	ROM_LOAD16_BYTE( "95426825.hi", 0x00000, 0x080000, CRC(cad14f6b) SHA1(8bf99cd5a894eb80fb5e14d6648d4ed1c743a97e) )
	ROM_LOAD16_BYTE( "95427790.lo", 0x00001, 0x080000, CRC(5cf6f903) SHA1(96d2b527ccab605c0300dd9d8d5146680cbdb795) )
	ROM_LOAD16_BYTE( "95427791.hi", 0x00000, 0x080000, CRC(b1ecf625) SHA1(910106d49e5432cafaa0a33069c059ef8237ce9e) )
	ROM_LOAD16_BYTE( "95427824.lo", 0x00001, 0x080000, CRC(321b526b) SHA1(10204de33e26fbb5c48650676d673a69b79dfda3) )
	ROM_LOAD16_BYTE( "95427825.hi", 0x00000, 0x080000, CRC(0ff60803) SHA1(af10556777aabdab55538afa30b5fb25c0c6c12f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009191.bin", 0x0000, 0x100000, CRC(2f3cda1a) SHA1(017533caadf86d0d70e1b57b697621e0b4a8fef2) )
	ROM_LOAD( "95009192.bin", 0x0000, 0x100000, CRC(eb9b6b0b) SHA1(127bb283b32a997c04a1b29c18f4093f4d969151) )
ROM_END




ROM_START( sc_dnddt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426578.lo", 0x00001, 0x080000, CRC(a74ca97c) SHA1(11e75209528c43d83ffa901c90b00273ebe9da1e) )
	ROM_LOAD16_BYTE( "95426579.hi", 0x00000, 0x080000, CRC(bc60373a) SHA1(c03021b4de928761c448ad3ac1fdf0455d1b9369) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426696.lo", 0x00001, 0x080000, CRC(6213b9c0) SHA1(0084c42f7f8bcf2482eac63fa5e012c42ae8854f) )
	ROM_LOAD16_BYTE( "95426697.hi", 0x00000, 0x080000, CRC(fe4bbb8c) SHA1(275b6c9c19f0b9977c48b8ce58177dded1fddf79) )
	ROM_LOAD16_BYTE( "95427578.lo", 0x00001, 0x080000, CRC(3074c629) SHA1(7c1f73690247324cff5229b3a55d6b56f60fc82a) )
	ROM_LOAD16_BYTE( "95427579.hi", 0x00000, 0x080000, CRC(c0176341) SHA1(e49ce2b5739fe9a48273a58eaff5d02a47de5867) )
	ROM_LOAD16_BYTE( "95427696.lo", 0x00001, 0x080000, CRC(08365313) SHA1(0177b939949272f807af6fff022e3557732c787e) )
	ROM_LOAD16_BYTE( "95427697.hi", 0x00000, 0x080000, CRC(f14302c1) SHA1(78a7f88eb0fd08f8a837d671341db2e6a55691e1) )
	ROM_LOAD16_BYTE( "p3313p71.hi", 0x00000, 0x080000, CRC(f4154827) SHA1(fbdfb6f36556082ec8cfc3beaefb22688bf0b49a) )
	ROM_LOAD16_BYTE( "p3313p71.lo", 0x00001, 0x080000, CRC(9b633600) SHA1(2de506e0d393487e7bc076c29a3eb213c1fa0444) )
	ROM_LOAD16_BYTE( "p3313s71.hi", 0x00000, 0x080000, CRC(45ab938e) SHA1(00c04b1b18154f5234e3d5f171935b8118cff301) )
	ROM_LOAD16_BYTE( "p3313s71.lo", 0x00001, 0x080000, CRC(1f8c90b0) SHA1(dd989f34aefcdb381b099977b54f38cd98efd5f4) )
	ROM_LOAD16_BYTE( "p3313s72.hi", 0x00000, 0x080000, CRC(ca3f781e) SHA1(9e0e0ba1f8f378df96ea6d8aacbb3a278115175c) )
	ROM_LOAD16_BYTE( "p3313s72.lo", 0x00001, 0x080000, CRC(aebdf2ac) SHA1(780737be28e18dbcaf93e1d3c0593c4ff77f0f95) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009106.bin", 0x0000, 0x100000, CRC(afa266cf) SHA1(adc80bc677a7524bec4bbd102a4a5ff293571abc) )
	ROM_LOAD( "95009107.bin", 0x0000, 0x100000, CRC(493981a8) SHA1(77308e453848d092d63330e10e3b1e88caeb4fb5) )
ROM_END




ROM_START( sc_dnddo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3316p71.hi", 0x00000, 0x080000, CRC(1a9a9a58) SHA1(c447fa98c547ce4759fe6ff5fb85035c39c7ab39) )
	ROM_LOAD16_BYTE( "p3316p71.lo", 0x00001, 0x080000, CRC(978ca869) SHA1(3ebcdf3ada31a7d0e493a93bd433293ac7405e2e) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3316p72.hi", 0x00000, 0x080000, CRC(a9869e6d) SHA1(cfa6e0af311c2ea7b4b594803b2439f46692a5d5) )
	ROM_LOAD16_BYTE( "p3316p72.lo", 0x00001, 0x080000, CRC(842a8e3d) SHA1(ddd6b4c1abc7bd031650bfe2d79bb164066b3138) )
	ROM_LOAD16_BYTE( "p3316s71.hi", 0x00000, 0x080000, CRC(5ccdd8c2) SHA1(292948be4e4532509702c6de9b3e00f2c87d6e8c) )
	ROM_LOAD16_BYTE( "p3316s71.lo", 0x00001, 0x080000, CRC(b00f32c6) SHA1(c8719088f863c27a5f642ccda612d00a651a20c4) )
	ROM_LOAD16_BYTE( "p3316s72.hi", 0x00000, 0x080000, CRC(60b2b117) SHA1(1003dca8caa0926c7e53f61d3e248f2d4bbc6af5) )
	ROM_LOAD16_BYTE( "p3316s72.lo", 0x00001, 0x080000, CRC(702a6a1d) SHA1(30d0c0b8e8d86b2e6d290056f9d48b6485e20b32) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009120.bin", 0x0000, 0x100000, CRC(327c01a0) SHA1(9b7fa28ff6ecc83c2e9ee73aac0af98be170b28f) )
	ROM_LOAD( "95009121.bin", 0x0000, 0x100000, CRC(d7991c7e) SHA1(4f4e4043f272ff2325b0fa64c66b34cb1aefb97c) )
ROM_END




ROM_START( sc_dndfl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426676.lo", 0x00001, 0x080000, CRC(8dbcd884) SHA1(d024691be186d846fcf9635d4ac77efd9b63a4b6) )
	ROM_LOAD16_BYTE( "95426677.hi", 0x00000, 0x080000, CRC(244747b2) SHA1(429c70a19e8f56f9aa9d3bacdf75566c58d77fe7) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427676.lo", 0x00001, 0x080000, CRC(8cf59b89) SHA1(7ad62468875832ae71cf9126e1eb4964879620f3) )
	ROM_LOAD16_BYTE( "95427677.hi", 0x00000, 0x080000, CRC(4d11c889) SHA1(e66db9f2f5c2574b1a1529e626bfe4310a68bcc6) )
	ROM_LOAD16_BYTE( "p3309p71.hi", 0x00000, 0x080000, CRC(d5d25ff9) SHA1(bc3cbb0bb4a5dee36f7bfef40f6ee4c4db63dcda) )
	ROM_LOAD16_BYTE( "p3309p71.lo", 0x00001, 0x080000, CRC(c532a4b5) SHA1(484710e74214d80ff62c43cd0dbf973a0bb37a72) )
	ROM_LOAD16_BYTE( "p3309p72.hi", 0x00000, 0x080000, CRC(ea4eda24) SHA1(a1280073d75e09f38d71db5f71f26528423cf40e) )
	ROM_LOAD16_BYTE( "p3309p72.lo", 0x00001, 0x080000, CRC(6576a5c9) SHA1(c9bda0422f5b3a148072b8d7df3afb145b42126e) )
	ROM_LOAD16_BYTE( "p3309s71.hi", 0x00000, 0x080000, CRC(e104cdd5) SHA1(29259bddda6350cdadbeec937aac80391ef5d7cd) )
	ROM_LOAD16_BYTE( "p3309s71.lo", 0x00001, 0x080000, CRC(4da37d67) SHA1(747a8b9815a9222056aadec587249f0d4712d795) )
	ROM_LOAD16_BYTE( "p3309s72.hi", 0x00000, 0x080000, CRC(a0ebabb4) SHA1(671b5df68cb8ff9d92b6abdd157819d23602e2a1) )
	ROM_LOAD16_BYTE( "p3309s72.lo", 0x00001, 0x080000, CRC(0a02b017) SHA1(426a58c94224810af69724ed285a371d6a71a4a5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008847.bin", 0x0000, 0x100000, CRC(7f3eae56) SHA1(f5d25c87caf76fc1961c8fb5c389bb73cefbcb28) )
	ROM_LOAD( "95008848.bin", 0x0000, 0x100000, CRC(ba00c16d) SHA1(f2e55441857e5f036e19d2ee29dfad97b99134b8) )
ROM_END




ROM_START( sc_dndgo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426800.lo", 0x00001, 0x080000, CRC(39367127) SHA1(6160fea037569fff180fa0ed1c754086b31f06ad) )
	ROM_LOAD16_BYTE( "95426801.hi", 0x00000, 0x080000, CRC(c1df2a9b) SHA1(231bd993c0fe3b2a5725b37339e3ba6d911a5e00) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427800.lo", 0x00001, 0x080000, CRC(d808fc3f) SHA1(40788064e83f73a3492241d8d0eb7a326b84bf13) )
	ROM_LOAD16_BYTE( "95427801.hi", 0x00000, 0x080000, CRC(95172f9c) SHA1(ab863a84999b338608599663cb0c5a24e4ecdb0f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009197.bin", 0x0000, 0x100000, CRC(bdf253cb) SHA1(6f046f1c27bae1141919874b27a8d87295b39261) )
	ROM_LOAD( "95009198.bin", 0x0000, 0x100000, CRC(420105d4) SHA1(23e4eac4146a3985c3a7dc5f80f1b5900a116303) )
ROM_END




ROM_START( sc_dndgl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426562.lo", 0x00001, 0x080000, CRC(49336039) SHA1(5f95556647c5958bdcdcb8128c3ed1a6b375cbfb) )
	ROM_LOAD16_BYTE( "95426563.hi", 0x00000, 0x080000, CRC(c0dc0b3f) SHA1(745772d3462f627695fcb353d90316a63edb9429) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426626.lo", 0x00001, 0x080000, CRC(9e2407c3) SHA1(73e9bff320cdc87bd1347a898db1cd06c24e51ad) )
	ROM_LOAD16_BYTE( "95426627.hi", 0x00000, 0x080000, CRC(a048f32e) SHA1(ea9b705b515b5948574ebdebd84888b1cdf85eab) )
	ROM_LOAD16_BYTE( "95426690.lo", 0x00001, 0x080000, CRC(d097ddbc) SHA1(bb08d825ebe85c6dab7944ced0557d8d496bda3b) )
	ROM_LOAD16_BYTE( "95426691.hi", 0x00000, 0x080000, CRC(64aa23cc) SHA1(00b0bf467b7c3e5f5d580b12776b2169c349ff70) )
	ROM_LOAD16_BYTE( "95426860.lo", 0x00001, 0x080000, CRC(d44426d7) SHA1(f6eea5d092e684917df3fb45ddf100793a47ebfe) )
	ROM_LOAD16_BYTE( "95426861.hi", 0x00000, 0x080000, CRC(0edd3b08) SHA1(a52516f448b85e7d486f0bf5faea1cb460b56224) )
	ROM_LOAD16_BYTE( "95427562.lo", 0x00001, 0x080000, CRC(2fc1bf60) SHA1(fb527d88b8a6963ba47c8365b8a3d26f4a656346) )
	ROM_LOAD16_BYTE( "95427563.hi", 0x00000, 0x080000, CRC(1f3d8eca) SHA1(9a38b7aaa34fd773d1f5d9826474cc93a40a5d28) )
	ROM_LOAD16_BYTE( "95427626.lo", 0x00001, 0x080000, CRC(8a7ea029) SHA1(e330139d4c2032567702f9cfb4b692896063f931) )
	ROM_LOAD16_BYTE( "95427627.hi", 0x00000, 0x080000, CRC(af702461) SHA1(2ed8740e0726dfc4568004e838b207a74c54f20d) )
	ROM_LOAD16_BYTE( "95427690.lo", 0x00001, 0x080000, CRC(39a0d719) SHA1(7a7c220e1e0af38d29da58bee6a2887eb38f4a28) )
	ROM_LOAD16_BYTE( "95427691.hi", 0x00000, 0x080000, CRC(154cf89d) SHA1(4edfa3162fb246fc3bcaa5c131a868d9dc84a65b) )
	ROM_LOAD16_BYTE( "95427860.lo", 0x00001, 0x080000, CRC(90a642c5) SHA1(64afaa2ab321cf1e1b46b5c66525af100aea8f74) )
	ROM_LOAD16_BYTE( "95427861.hi", 0x00000, 0x080000, CRC(fe3bb2ce) SHA1(e04589f47436a1269ae697cb153af1b2e48a7a20) )
	ROM_LOAD16_BYTE( "p3310p71.hi", 0x00000, 0x080000, CRC(93953596) SHA1(867f4fcca166e35f6b275c067a301c7aef12f6c0) )
	ROM_LOAD16_BYTE( "p3310p71.lo", 0x00001, 0x080000, CRC(c6daebd9) SHA1(d1c523e885ba4d729c6b74c2d32d373a1c38a3f7) )
	ROM_LOAD16_BYTE( "p3310p72.hi", 0x00000, 0x080000, CRC(8b56e7fd) SHA1(e628db20db2b02bc2e9ce9b195a798b355e65957) )
	ROM_LOAD16_BYTE( "p3310p72.lo", 0x00001, 0x080000, CRC(108ffb05) SHA1(fdcb95d6be5fbd0910b1c22f193752a1c870a6aa) )
	ROM_LOAD16_BYTE( "p3310s71.hi", 0x00000, 0x080000, CRC(b3ed6b15) SHA1(6bce0dba67a7026ca025f3808978484c8259cdb3) )
	ROM_LOAD16_BYTE( "p3310s71.lo", 0x00001, 0x080000, CRC(29ac8746) SHA1(730dde7723fa42ab7526f8f768827dc8e0ff41c7) )
	ROM_LOAD16_BYTE( "p3310s72.hi", 0x00000, 0x080000, CRC(20e3f24a) SHA1(31c346a92d20f4c486cff3938d73391dda45ad0f) )
	ROM_LOAD16_BYTE( "p3310s72.lo", 0x00001, 0x080000, CRC(ee262128) SHA1(15323bf6d5ef8ce0c126cf30fe0b9ae869bc2e1e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009102.bin", 0x0000, 0x100000, CRC(9d03cd95) SHA1(e062c816a19af0dc86bfa5a66f69342e69fffcfa) )
	ROM_LOAD( "95009103.bin", 0x0000, 0x100000, CRC(51ae4095) SHA1(b397984d3b0beb4ca95050ff595648a80e5ea87a) )
ROM_END




ROM_START( sc_dndld )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426794.lo", 0x00001, 0x080000, CRC(24f1eeb3) SHA1(ed1aed751924f43b16d8cef7463167af872017f6) )
	ROM_LOAD16_BYTE( "95426795.hi", 0x00000, 0x080000, CRC(79cb1434) SHA1(fd4a9543d2b873d1c87079bd3c98dd782ea9bb34) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427794.lo", 0x00001, 0x080000, CRC(4a07d98c) SHA1(b24bddabf866601c496b3a8e5e02f75076d27f0e) )
	ROM_LOAD16_BYTE( "95427795.hi", 0x00000, 0x080000, CRC(8b90c5cd) SHA1(c9d1ffed3c2420597c1fe3b589db8485e94f3387) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009184.bin", 0x0000, 0x100000, CRC(25a36077) SHA1(92c05f410456414b825b09338a474c52f7c1bd9b) )
	ROM_LOAD( "95009185.bin", 0x0000, 0x100000, CRC(eacdfc26) SHA1(8ab462e7f49ca9374b9245d9d97cf909ea979ae3) )
ROM_END




ROM_START( sc_dndmb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426694.lo", 0x00001, 0x080000, CRC(950ca36e) SHA1(7117d648dc42bcc8d222887b12c8b868c4e9a786) )
	ROM_LOAD16_BYTE( "95426695.hi", 0x00000, 0x080000, CRC(c04f8237) SHA1(8011df90e1f163feeb672b90fcf43fc0a02e1678) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426796.lo", 0x00001, 0x080000, CRC(0d56b9ee) SHA1(ea23cb9e349d501e1889736640324046eb7b7200) )
	ROM_LOAD16_BYTE( "95426797.hi", 0x00000, 0x080000, CRC(3d8a3753) SHA1(f7570f7dbf38fbafa1634ad494138e5ba1d39df7) )
	ROM_LOAD16_BYTE( "95426864.lo", 0x00001, 0x080000, CRC(307c66c9) SHA1(effeca62e43df66bcb71e63140c9ca178d4e368d) )
	ROM_LOAD16_BYTE( "95426865.hi", 0x00000, 0x080000, CRC(c4a063e7) SHA1(6dbceaadb05d12f7f378d40825751ff7d09f6ef0) )
	ROM_LOAD16_BYTE( "95426876.lo", 0x00001, 0x080000, CRC(1efa04fb) SHA1(27ed4542581b4ff45530b60fafa65a68212b73cb) )
	ROM_LOAD16_BYTE( "95426877.hi", 0x00000, 0x080000, CRC(c8211660) SHA1(4e32a4eb4e70ddcd45da279ed3dd9b239bf4353e) )
	ROM_LOAD16_BYTE( "95427694.lo", 0x00001, 0x080000, CRC(3ae07652) SHA1(7cd263f0a90fa7cbef8e8b781ac90f83bc1d95ad) )
	ROM_LOAD16_BYTE( "95427695.hi", 0x00000, 0x080000, CRC(0049809f) SHA1(42bee330256ed771da9703a4185a0dcbda3235ae) )
	ROM_LOAD16_BYTE( "95427796.lo", 0x00001, 0x080000, CRC(177cf067) SHA1(21cfd7f6e86964115180ce81db929b5f6a523c4a) )
	ROM_LOAD16_BYTE( "95427797.hi", 0x00000, 0x080000, CRC(e708e777) SHA1(9bbc8b8bd8287028257d59f1d6d2574881009277) )
	ROM_LOAD16_BYTE( "95427864.lo", 0x00001, 0x080000, CRC(795d29d2) SHA1(e1d27f46a11e5a85090440e3bf3b1500003d5d06) )
	ROM_LOAD16_BYTE( "95427865.hi", 0x00000, 0x080000, CRC(8b155e76) SHA1(b3bec85b913e408fe2bc62165bb360e4ec6e57b1) )
	ROM_LOAD16_BYTE( "95427876.lo", 0x00001, 0x080000, CRC(69c44133) SHA1(50d3a6db2f0664cb48a53e71cb62524fcda4ea18) )
	ROM_LOAD16_BYTE( "95427877.hi", 0x00000, 0x080000, CRC(87bb490e) SHA1(a7a1f232065cec58815cb11a281fb0988698b743) )
	ROM_LOAD16_BYTE( "p3407p11.hi", 0x00000, 0x080000, CRC(6dfec831) SHA1(819e97aecb8777323f723a9d768ee511854f3584) )
	ROM_LOAD16_BYTE( "p3407p11.lo", 0x00001, 0x080000, CRC(9a4be116) SHA1(a32b1ab39938b483129e3ec1b811eb9e1d6f4ab2) )
	ROM_LOAD16_BYTE( "p3407p13.hi", 0x00000, 0x080000, CRC(3fa805a3) SHA1(9a002323719d4f2d13d3645611601650e3bc902f) )
	ROM_LOAD16_BYTE( "p3407p13.lo", 0x00001, 0x080000, CRC(5ca2a0cf) SHA1(e065a3504c53b87c844aaefbfa6a1b3116951bd1) )
	ROM_LOAD16_BYTE( "p3407s11.hi", 0x00000, 0x080000, CRC(e2d831ff) SHA1(8c26789960d0f77c4d0e17d4f3c64212ea3c5c72) )
	ROM_LOAD16_BYTE( "p3407s11.lo", 0x00001, 0x080000, CRC(4b6fab54) SHA1(6c2014400b9d7692c8e6b345924068cd5b5b7ab8) )
	ROM_LOAD16_BYTE( "p3407s13.hi", 0x00000, 0x080000, CRC(cbbb0081) SHA1(17553777cfba64e9af5536e24b361d68335cbf86) )
	ROM_LOAD16_BYTE( "p3407s13.lo", 0x00001, 0x080000, CRC(c68c23c0) SHA1(837bae53f2884a8c09d9e923572448abc34711e1) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009156.bin", 0x0000, 0x100000, CRC(7c68c70c) SHA1(eb4006e185f3cd4e7d66999b3ff064a7903f5bc8) )
	ROM_LOAD( "95009157.bin", 0x0000, 0x100000, CRC(a0541504) SHA1(689ba32fd1b1a9592a9cd7039424655a652b1bcd) )
ROM_END




ROM_START( sc_dndmd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426786.lo", 0x00001, 0x080000, CRC(fb527cd3) SHA1(1e77ea5b62126dd975a0d60c238998d3bcff7fce) )
	ROM_LOAD16_BYTE( "95426787.hi", 0x00000, 0x080000, CRC(e99a0bef) SHA1(23a8dce42ac136eaf961b83c633aa219741f08d5) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426836.lo", 0x00001, 0x080000, CRC(fccfe5ab) SHA1(817367349ddc9c138008beb19af3244c99893db7) )
	ROM_LOAD16_BYTE( "95426837.hi", 0x00000, 0x080000, CRC(ba12681d) SHA1(2cddad5e774ac472b7f8fc646d17ccac5ceeba20) )
	ROM_LOAD16_BYTE( "95426838.lo", 0x00001, 0x080000, CRC(d48a430a) SHA1(cfeb444cca0b374bfff4ac1f3ec8a0ef65d3ac0b) )
	ROM_LOAD16_BYTE( "95426839.hi", 0x00000, 0x080000, CRC(18a780c9) SHA1(e1cda4af84f79810305f51340d67e5f31da48cf8) )
	ROM_LOAD16_BYTE( "95426862.lo", 0x00001, 0x080000, CRC(74849196) SHA1(c34bd4b8f67ffa86abb42ffcc9a83aa1663fd9cc) )
	ROM_LOAD16_BYTE( "95426863.hi", 0x00000, 0x080000, CRC(a72d2f11) SHA1(0102e59b55399153a5f5d7fc248d69e30cd50da2) )
	ROM_LOAD16_BYTE( "95426866.lo", 0x00001, 0x080000, CRC(f0fd9206) SHA1(0dfb454870c43f428604e9717a352fc6deda9212) )
	ROM_LOAD16_BYTE( "95426867.hi", 0x00000, 0x080000, CRC(e38b6b48) SHA1(a9d815eb12b7c4651e4adb123e398030c0eb2179) )
	ROM_LOAD16_BYTE( "95427786.lo", 0x00001, 0x080000, CRC(b50adb65) SHA1(ff259c97c02994eb58b0012654f017119c0f538e) )
	ROM_LOAD16_BYTE( "95427787.hi", 0x00000, 0x080000, CRC(5c9d20b0) SHA1(780b86395d2678216d7e14ef4ab6138959029203) )
	ROM_LOAD16_BYTE( "95427836.lo", 0x00001, 0x080000, CRC(83faf417) SHA1(d8436e4a9524cc1e2e6a6b834731b67c7edef40f) )
	ROM_LOAD16_BYTE( "95427837.hi", 0x00000, 0x080000, CRC(0503486d) SHA1(4c82f58de544f6bb6349368ea5422fcfcbeb9498) )
	ROM_LOAD16_BYTE( "95427838.lo", 0x00001, 0x080000, CRC(e046eb60) SHA1(5bd7eb4b2d2cec81503e153ece20e2b582cd1bd4) )
	ROM_LOAD16_BYTE( "95427839.hi", 0x00000, 0x080000, CRC(a304ce00) SHA1(74aedcd8ad06b168285ce894b149fa77c9d46b9a) )
	ROM_LOAD16_BYTE( "95427862.lo", 0x00001, 0x080000, CRC(5704cacb) SHA1(6f8a0075fd82baaa1b0d757ab1ecc044a1f59992) )
	ROM_LOAD16_BYTE( "95427863.hi", 0x00000, 0x080000, CRC(b7398001) SHA1(f863113565c7d83b5cdfff335e3a43de3655375f) )
	ROM_LOAD16_BYTE( "95427866.lo", 0x00001, 0x080000, CRC(46f8244c) SHA1(59fc36323f772506d94dd2b2d96523dae823c69c) )
	ROM_LOAD16_BYTE( "95427867.hi", 0x00000, 0x080000, CRC(ee973a37) SHA1(3da42f8f6587c408c3c9e102dbd422a86195fd72) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009170.bin", 0x0000, 0x100000, CRC(6ab363a5) SHA1(1a98566161aec187074cbbdb7372ed8484202639) )
	ROM_LOAD( "95009171.bin", 0x0000, 0x100000, CRC(bc5d3113) SHA1(836eff78265f6d0371be18467c5edc6d32aba6d5) )
ROM_END




ROM_START( sc_dndpl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "39211495.bin", 0x0000, 0x1000000, CRC(d87cda50) SHA1(215776dfe2b9393f8c58bdb0e14cf21505d01ae3) )
	ROM_LOAD16_BYTE( "39212495.bin", 0x0000, 0x1000000, CRC(67c829da) SHA1(c30353c432389e5648ffb14f9ff14821e11fcf38) )
	ROM_LOAD16_BYTE( "p3314p71.bin", 0x0000, 0x1000000, CRC(56b9fa95) SHA1(d33d04089b95116da09700278a732d66eb06cf8c) )
	ROM_LOAD16_BYTE( "p3314s71.bin", 0x0000, 0x1000000, CRC(a6285e1d) SHA1(c790c12150c152e08b541521ed2e80ed2203e639) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009108.bin", 0x0000, 0x100000, CRC(113b7f60) SHA1(62a8ca9dd9fc663971037936ddbd634273c3055f) )
	ROM_LOAD( "95009109.bin", 0x0000, 0x100000, CRC(edf5a701) SHA1(3514b4a46dd921446c74c5b87a3a4b272e7b0fdb) )
ROM_END




ROM_START( sc_dndpa )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426600.lo", 0x00001, 0x080000, CRC(0b999f25) SHA1(371e15a9182e83ef4245398f4dcf542bf0cb1471) )
	ROM_LOAD16_BYTE( "95426601.hi", 0x00000, 0x080000, CRC(8efda096) SHA1(11c8cef15b792391c62a97be35ae7f4fc7138fe6) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426654.lo", 0x00001, 0x080000, CRC(421cbdc5) SHA1(5f6ed7e4e0624bfb95c039554809b834d330b932) )
	ROM_LOAD16_BYTE( "95426655.hi", 0x00000, 0x080000, CRC(5d2a2256) SHA1(33855ece3112bd87b79517b56e1b9bd3cf8cdf98) )
	ROM_LOAD16_BYTE( "95427600.lo", 0x00001, 0x080000, CRC(85d3ea06) SHA1(fecde10abf342b7f8255251276f42a2034e4cdc8) )
	ROM_LOAD16_BYTE( "95427601.hi", 0x00000, 0x080000, CRC(594a7d67) SHA1(411373ff7277c84b9cdebb766a1dce6359674bb6) )
	ROM_LOAD16_BYTE( "95427654.lo", 0x00001, 0x080000, CRC(1908555b) SHA1(80cfdf571a513a2d6da5c0c89b7c048d42b82bc0) )
	ROM_LOAD16_BYTE( "95427655.hi", 0x00000, 0x080000, CRC(31c5e56b) SHA1(2fab1e34e69b5d42123a4c6499d1a4b3ca6fd344) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009150.bin", 0x0000, 0x100000, CRC(54d9f01a) SHA1(6d62ca07443c42e16243a843dee6a11c7a1383fc) )
	ROM_LOAD( "95009151.bin", 0x0000, 0x100000, CRC(89bb7543) SHA1(e8bea8a00798329af590be5e2ccbfcc54f70f98d) )
ROM_END




ROM_START( sc_ddptg )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426872.lo", 0x00001, 0x080000, CRC(d09ec5c8) SHA1(5c3c6c62b5e1f3f9e6a8f9d90e89971f5d79069a) )
	ROM_LOAD16_BYTE( "95426873.hi", 0x00000, 0x080000, CRC(e1f1b293) SHA1(f397bf2e97712c2f805dd1859073d8819f8b7fa7) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426936.lo", 0x00001, 0x080000, CRC(99a16526) SHA1(1e95ccea0492e7fcd0475127f4c806ea31318ac1) )
	ROM_LOAD16_BYTE( "95426937.hi", 0x00000, 0x080000, CRC(02a5a5c2) SHA1(3fde8ebaf6fd123a447b08912e521ab4f83823fc) )
	ROM_LOAD16_BYTE( "95427872.lo", 0x00001, 0x080000, CRC(5de69791) SHA1(5d2acb1c8a8742b38b5a43dad4c25275b1f6bf9d) )
	ROM_LOAD16_BYTE( "95427873.hi", 0x00000, 0x080000, CRC(9eef10fe) SHA1(6081f4d226565165ee3dbec5eab1e09a13fff35c) )
	ROM_LOAD16_BYTE( "95427936.lo", 0x00001, 0x080000, CRC(3f290768) SHA1(97f9b9a38bf7409a652afb7ce7315e6a96906dc7) )
	ROM_LOAD16_BYTE( "95427937.hi", 0x00000, 0x080000, CRC(0477abf3) SHA1(df52a3ae072139c698b842896ffa3b80be48990d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009041.bin", 0x0000, 0x100000, CRC(143d05fb) SHA1(f3d2735dc5b1bdc4e3f4205521f1b614d4b4c4b0) )
	ROM_LOAD( "95009042.bin", 0x0000, 0x100000, CRC(65efd8fd) SHA1(c7f2d1f6b31767a56269f53e9327de3abe64218f) )
ROM_END




ROM_START( sc_ddply )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3303p11.hi", 0x00000, 0x080000, CRC(0fda3a5b) SHA1(b7d96ac0724dad8e2676d0bf281edbc077b81d5a) )
	ROM_LOAD16_BYTE( "p3303p11.lo", 0x00001, 0x080000, CRC(f9c9818f) SHA1(f7ea65e6099e94092846a36c3f7deab5553b027e) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3303s11.hi", 0x00000, 0x080000, CRC(1275867c) SHA1(6f612b9e397106a2fc050241305c7ca1661b9e96) )
	ROM_LOAD16_BYTE( "p3303s11.lo", 0x00001, 0x080000, CRC(b0e29d4d) SHA1(feed1310eba65853faa9e634472419038b7db982) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008830.bin", 0x0000, 0x100000, CRC(bb66ae0c) SHA1(4a7df180dd67aa96059a83986cb98721a81963d8) )
	ROM_LOAD( "95008831.bin", 0x0000, 0x100000, CRC(8a632940) SHA1(e955b05a82312ab356117f348903292d6f26a5a5) )
ROM_END




ROM_START( sc_dndrr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426784.lo", 0x00001, 0x080000, CRC(19a3a912) SHA1(033072b3e6dd41c40cab0b7d361bea258560696c) )
	ROM_LOAD16_BYTE( "95426785.hi", 0x00000, 0x080000, CRC(f962e6f8) SHA1(bd46e3f736afaf144e5a72232bd31e7d736ca58c) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426880.lo", 0x00001, 0x080000, CRC(ac22b48d) SHA1(f618d479dc4cab24ef7552760ff98dc000ae163f) )
	ROM_LOAD16_BYTE( "95426881.hi", 0x00000, 0x080000, CRC(ad855ae4) SHA1(bf533137ea191b7c92003661be4007afff348163) )
	ROM_LOAD16_BYTE( "95427784.lo", 0x00001, 0x080000, CRC(ae9b171a) SHA1(96f9824043571c682c1f72261fdad2f2f55b732e) )
	ROM_LOAD16_BYTE( "95427785.hi", 0x00000, 0x080000, CRC(f8ee4d22) SHA1(886f9c6416d08a7ac4a319b03ae47fa3365bb37a) )
	ROM_LOAD16_BYTE( "95427880.lo", 0x00001, 0x080000, CRC(e3d6c3ec) SHA1(89a09a5fea57b56f7a6cda644a89c63af73c9f65) )
	ROM_LOAD16_BYTE( "95427881.hi", 0x00000, 0x080000, CRC(fb419a7c) SHA1(6197f8aee36de9b2eee1b4c336817557b9d6e8f0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009188.bin", 0x0000, 0x100000, CRC(a2dceadd) SHA1(af1696bf32f37005c6a01bb209f38b90daab4e29) )
	ROM_LOAD( "95009189.bin", 0x0000, 0x100000, CRC(02b0d336) SHA1(7713212ebf59fa2464110b0238a870e81d43be05) )
ROM_END




ROM_START( sc_dndsi )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3219p71.hi", 0x00000, 0x080000, CRC(998038e1) SHA1(577650c85e025bb3b56ce4a618003b77768531cd) )
	ROM_LOAD16_BYTE( "p3219p71.lo", 0x00001, 0x080000, CRC(b8e397fa) SHA1(b87349fa551317e96614b421f7167243af6381d4) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3219p72.hi", 0x00000, 0x080000, CRC(fb10dad2) SHA1(5ba3b60285ae6019eea526c56caf362870c6dfca) )
	ROM_LOAD16_BYTE( "p3219p72.lo", 0x00001, 0x080000, CRC(47962d32) SHA1(d254b3c9ae27a7501433f84e20bb95653e9c5f9d) )
	ROM_LOAD16_BYTE( "p3219p73.hi", 0x00000, 0x080000, CRC(0a8153ae) SHA1(16464f7f2020f587ef9f1ffd393410d4b33d7290) )
	ROM_LOAD16_BYTE( "p3219p73.lo", 0x00001, 0x080000, CRC(83ab4f08) SHA1(c20f3186a34bba2b67b63b5e1dea3abdf8f5c4fd) )
	ROM_LOAD16_BYTE( "p3219s71.hi", 0x00000, 0x080000, CRC(0a8bc683) SHA1(49421a15598c6bc25fcfa2f1c754fa4a2160fc22) )
	ROM_LOAD16_BYTE( "p3219s71.lo", 0x00001, 0x080000, CRC(5370078c) SHA1(cdba77c38f3a9c1f21cbcb805f8efc643cf60095) )
	ROM_LOAD16_BYTE( "p3219s73.hi", 0x00000, 0x080000, CRC(ad675a6a) SHA1(8d6c94b4d804f8c6b2b4e7e395782646eba8e285) )
	ROM_LOAD16_BYTE( "p3219s73.lo", 0x00001, 0x080000, CRC(5e91a6bd) SHA1(3dd3456b2c0059d129fd85bb8e38a8995f194dc2) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008838.bin", 0x0000, 0x100000, CRC(34e9d2eb) SHA1(140f9ccf287e24e3917b1a6bb8d8118bf20f232c) )
	ROM_LOAD( "95008839.bin", 0x0000, 0x100000, CRC(4475bb6b) SHA1(864575f9b35495bfe0d8f7563e2d4b5e35b6a396) )
ROM_END




ROM_START( sc_dndrt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426564.lo", 0x00001, 0x080000, CRC(80576d4c) SHA1(88196fb562269827414ac10f1fcf08921b5eea50) )
	ROM_LOAD16_BYTE( "95426565.hi", 0x00000, 0x080000, CRC(f6c6a4b0) SHA1(07cd42d85ddc9760222ccce445280a5d47058cab) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426628.lo", 0x00001, 0x080000, CRC(d50998d5) SHA1(08b75ee0ac3ddaeccd5a90c043d911af2e2e5d3f) )
	ROM_LOAD16_BYTE( "95426629.hi", 0x00000, 0x080000, CRC(331eac9e) SHA1(9e8e269754d012597568ebdc6ff6d6205f37aa38) )
	ROM_LOAD16_BYTE( "95426856.lo", 0x00001, 0x080000, CRC(a7a83a03) SHA1(60fcc72fef47239818e124d2e6f15337a9b59847) )
	ROM_LOAD16_BYTE( "95426857.hi", 0x00000, 0x080000, CRC(75f8fe7d) SHA1(c8ec593ce18bff56bc89349f0c7a9b11ead83cbc) )
	ROM_LOAD16_BYTE( "95427564.lo", 0x00001, 0x080000, CRC(10254396) SHA1(0b7e526c9bacb46dfb4e81f38bfffa64ba6cb44a) )
	ROM_LOAD16_BYTE( "95427565.hi", 0x00000, 0x080000, CRC(bf1018c3) SHA1(fd52b008ac5a921c53938e3d080c3ebe1c81c3c3) )
	ROM_LOAD16_BYTE( "95427628.lo", 0x00001, 0x080000, CRC(419ee27c) SHA1(2d2081e5247b2da701a1c24f4227c84f8f15f034) )
	ROM_LOAD16_BYTE( "95427629.hi", 0x00000, 0x080000, CRC(a55237f6) SHA1(f59a14e5332f8fc62a97edae6319d69a8ae421cf) )
	ROM_LOAD16_BYTE( "95427856.lo", 0x00001, 0x080000, CRC(17522a17) SHA1(31d65822f36bedf6f2696b8ddddd3c7fc67a3277) )
	ROM_LOAD16_BYTE( "95427857.hi", 0x00000, 0x080000, CRC(1c386bba) SHA1(7a4b89788042fd6045342abbcca5ce34a67dd652) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009141.bin", 0x0000, 0x100000, CRC(e53f8ba3) SHA1(10eea3246352bf65e1ca7b4cd6e1a873d6a2f7fe) )
	ROM_LOAD( "95009142.bin", 0x0000, 0x100000, CRC(54b47cbd) SHA1(71e8f49b0d031fcc8c5450279dc26d39b90af678) )
ROM_END




ROM_START( sc_dndpd )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426686.lo", 0x00001, 0x080000, CRC(d308b28a) SHA1(522fdd06185d26a328c251ba95818d318d85fe05) )
	ROM_LOAD16_BYTE( "95426687.hi", 0x00000, 0x080000, CRC(daef4474) SHA1(210955eb3bf891190a29cc7ab0234fce92567e2d) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426850.lo", 0x00001, 0x080000, CRC(a526c153) SHA1(2380083cf6df2b76f5a842f99205434a346ac822) )
	ROM_LOAD16_BYTE( "95426851.hi", 0x00000, 0x080000, CRC(0205ab1e) SHA1(f06a28717a990f63d5ae801f298c8030681b010c) )
	ROM_LOAD16_BYTE( "95427686.lo", 0x00001, 0x080000, CRC(799a6b4f) SHA1(58af5a23868b225928dd73cb45b61c161aad82ec) )
	ROM_LOAD16_BYTE( "95427687.hi", 0x00000, 0x080000, CRC(1afee3e0) SHA1(e5d113043a16947f95b67716d9954c46fd5f2bfd) )
	ROM_LOAD16_BYTE( "95427850.lo", 0x00001, 0x080000, CRC(024a4826) SHA1(c4124526102be162ab101de25748461f26a0936f) )
	ROM_LOAD16_BYTE( "95427851.hi", 0x00000, 0x080000, CRC(b0cae8de) SHA1(1f70ea6b56407e9ac8794e524bf4375ff38a0e1c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009172.bin", 0x0000, 0x100000, CRC(f124785f) SHA1(2291dca731bb6037d655dc8bbdfa7f35f6a4d4d1) )
	ROM_LOAD( "95009173.bin", 0x0000, 0x100000, CRC(aae9318c) SHA1(4b53bec7284950fbca4650117e727ab9a01b5509) )
ROM_END




ROM_START( sc_dndpc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3303p72.hi", 0x00000, 0x080000, CRC(01399a36) SHA1(a7bacb358f0f803b3cc2118bbdf112f71b1cc770) )
	ROM_LOAD16_BYTE( "p3303p72.lo", 0x00001, 0x080000, CRC(310adb3c) SHA1(03faf72ee909c142b633ca226b28121dfd8cf525) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3303s72.hi", 0x00000, 0x080000, CRC(8d896e95) SHA1(347c83bf914cc40fae6a89d7c27f97cf861083ae) )
	ROM_LOAD16_BYTE( "p3303s72.lo", 0x00001, 0x080000, CRC(5e793210) SHA1(bfe9fbdc3ff11bbdd42741c6d2ff66265b792f90) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_dndtb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426780.lo", 0x00001, 0x080000, CRC(beba0181) SHA1(228f5c8ef549b36c3d10c9eed19d98005ba86abe) )
	ROM_LOAD16_BYTE( "95426781.hi", 0x00000, 0x080000, CRC(466771cf) SHA1(5deea15eb735095aa0a0fdb6275b7a8da036ebf6) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427780.lo", 0x00001, 0x080000, CRC(5cbb0fb9) SHA1(aab95a8b64ab455723ce30aff22d88ea6825f0f9) )
	ROM_LOAD16_BYTE( "95427781.hi", 0x00000, 0x080000, CRC(41e8e286) SHA1(296f9d3fbecaa6a1bd03279d8109ce544c7e0751) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009186.bin", 0x0000, 0x100000, CRC(1da5489b) SHA1(b282e523b52e34a625502ec99ca42f059e701448) )
	ROM_LOAD( "95009187.bin", 0x0000, 0x100000, CRC(2c3ea82c) SHA1(50ade918503e224288407abf60b3d53e5334aadb) )
ROM_END




ROM_START( sc_devil )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420562.lo", 0x00001, 0x080000, CRC(de71acc6) SHA1(f4d7697929db6ff629764608eed6b07f5f8601b9) )
	ROM_LOAD16_BYTE( "95420563.hi", 0x00000, 0x080000, CRC(3dfd6cd8) SHA1(943df339ec339155db28c4d688b6ed835a9e1e77) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95420748.lo", 0x00001, 0x080000, CRC(49f591f3) SHA1(270a532f8be3766c6eae7632d813d5c58a5d5a68) )
	ROM_LOAD16_BYTE( "95420749.hi", 0x00000, 0x080000, CRC(3d3a9afc) SHA1(914215eee96234b2913ad33c0ff008f2d6ce42a8) )
	ROM_LOAD16_BYTE( "95421562.lo", 0x00001, 0x080000, CRC(12d560cf) SHA1(909fcddbfb208598ae66ed20f1e1d7bffee0914c) )
	ROM_LOAD16_BYTE( "95421563.hi", 0x00000, 0x080000, CRC(07651d3f) SHA1(1709b08f7d6e14239900b887c20c801ee94a2f85) )
	ROM_LOAD16_BYTE( "95421748.lo", 0x00001, 0x080000, CRC(fe23d2d7) SHA1(80f290edef39b9a92ac1be0f98f21e66c80eb9bf) )
	ROM_LOAD16_BYTE( "95421749.hi", 0x00000, 0x080000, CRC(875c5df1) SHA1(c4664c6541a17fd1d575ed1d7839a385a943e75d) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890464.bin", 0x0000, 0x5000, CRC(35e24491) SHA1(e762854ac074df67db843fed4c6c7cfe1d8f754b) )
	ROM_LOAD( "95890465.bin", 0x0000, 0x5000, CRC(407400a5) SHA1(dba6f4204a27f26056ffc3d9b512c0f4a8f17562) )
	ROM_LOAD( "95890466.bin", 0x0000, 0x5000, CRC(dececcf9) SHA1(6ebaec58330b7ce8bb166d2aefd203147c4823fa) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008978.bin", 0x0000, 0x0ff462, CRC(b0dac89b) SHA1(afdc4fec96849b81e52aa03d9df821e336001c74) )
ROM_END




ROM_START( sc_dcrls )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414698.odd", 0x00001, 0x080000, CRC(0bb93d5c) SHA1(f3b0c59b731ba3ae2074fe864cbb5ac8f4cac651) )
	ROM_LOAD16_BYTE( "95414699.evn", 0x00000, 0x080000, CRC(f4f800a1) SHA1(3be6ef0c8b15d00db3ccf41646d661e4b82be20e) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414700.odd", 0x00001, 0x080000, CRC(01aeb959) SHA1(71646ec778408384c8cd973199b4491211763718) )
	ROM_LOAD16_BYTE( "95414701.evn", 0x00000, 0x080000, CRC(f17499f5) SHA1(6f1275d118657dead35dbf79f5a3efcd4a396954) )
	ROM_LOAD16_BYTE( "95414780.odd", 0x00001, 0x080000, CRC(b8331602) SHA1(ad4eb67d6382cf09fbb8e5cb5cf5ebcf24ce70fc) )
	ROM_LOAD16_BYTE( "95414781.evn", 0x00000, 0x080000, CRC(9a7b0030) SHA1(2be0aa919b4661218365ceb6c85d5527c2788077) )
	ROM_LOAD16_BYTE( "95414782.odd", 0x00001, 0x080000, CRC(52ddb034) SHA1(b6a1d432ed94d21555e37b7ef134766ee5dc67e2) )
	ROM_LOAD16_BYTE( "95414783.evn", 0x00000, 0x080000, CRC(2baa047f) SHA1(4fc5e0e9e21d2dbbeabe8c9af6613ecf53edb08f) )
	ROM_LOAD16_BYTE( "95414898.odd", 0x00001, 0x080000, CRC(9459b0df) SHA1(c7220fba49630f2c48aeab95f9cbcab620ccdc70) )
	ROM_LOAD16_BYTE( "95414899.evn", 0x00000, 0x080000, CRC(394ea9d1) SHA1(e0466af5de3097f9cdae0c95e808fcb2df853035) )
	ROM_LOAD16_BYTE( "95414900.odd", 0x00001, 0x080000, CRC(b84e2dbd) SHA1(7d5a4e34f8659ac559b5b65e22d2b4da6d38786a) )
	ROM_LOAD16_BYTE( "95414901.evn", 0x00000, 0x080000, CRC(832918b4) SHA1(ae9700c7d70ead755c4481a07b59bcaa51b893b4) )
	ROM_LOAD16_BYTE( "95415698.odd", 0x00001, 0x080000, CRC(697dc789) SHA1(eb1144fb72f3d850cad8026c62095e89fc2ae285) )
	ROM_LOAD16_BYTE( "95415699.evn", 0x00000, 0x080000, CRC(ed526d6b) SHA1(34ce8f9526564b03ecb1f45d9883942407f53752) )
	ROM_LOAD16_BYTE( "95415700.odd", 0x00001, 0x080000, CRC(636a438c) SHA1(64a1520466e1cafa4784f63034931f652465ae98) )
	ROM_LOAD16_BYTE( "95415701.evn", 0x00000, 0x080000, CRC(e8def43f) SHA1(b849ca3176c89cc62b53ccc0a562ec7bfc53ae4a) )
	ROM_LOAD16_BYTE( "95415780.odd", 0x00001, 0x080000, CRC(fb2a8220) SHA1(16317ed2609c163ef5a23fa3e9c6ba05c94ed763) )
	ROM_LOAD16_BYTE( "95415781.evn", 0x00000, 0x080000, CRC(516d0f6b) SHA1(a12a34d1d5dfd7e13c470d561c519d090fa4d6fa) )
	ROM_LOAD16_BYTE( "95415782.odd", 0x00001, 0x080000, CRC(11c42416) SHA1(9a846a19856a15919186985a4b6383d5ea3a2a30) )
	ROM_LOAD16_BYTE( "95415783.evn", 0x00000, 0x080000, CRC(e0bc0b24) SHA1(eb87b62de2800107fe2153213704fcb7ab8fd586) )
	ROM_LOAD16_BYTE( "95415898.odd", 0x00001, 0x080000, CRC(05d6ccd5) SHA1(ff6fb91f61d4620fd46a3fd8070a3a9fa4335347) )
	ROM_LOAD16_BYTE( "95415899.evn", 0x00000, 0x080000, CRC(6260b585) SHA1(989f32a5007a85c4a469cbadf573c9c3620dfe87) )
	ROM_LOAD16_BYTE( "95415900.odd", 0x00001, 0x080000, CRC(29c151b7) SHA1(2d3d24e0b2ef0a01d5c4c30feb6502c894986b02) )
	ROM_LOAD16_BYTE( "95415901.evn", 0x00000, 0x080000, CRC(d80704e0) SHA1(ba6622c8c8b47c66133980c8823690325ffa000c) )


	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008482.bin", 0x0000, 0x04c048, CRC(e0b13788) SHA1(e364ccedd31e1fe0560312a28ad6d5cfaac5bfaa) )
ROM_END




ROM_START( sc_dracp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3007p42.hi", 0x00000, 0x080000, CRC(dff8d46d) SHA1(cc5fda9909e1067d1f43ca9b1ef100652a36389a) )
	ROM_LOAD16_BYTE( "p3007p42.lo", 0x00001, 0x080000, CRC(9d030171) SHA1(514c9bb3da5c084738784e6fe5993e76e2263b71) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3007s42.hi", 0x00000, 0x080000, CRC(ffadb510) SHA1(193fa0cf1cfcbdb752dcb6a357e726c3205460d4) )
	ROM_LOAD16_BYTE( "p3007s42.lo", 0x00001, 0x080000, CRC(5496cbe2) SHA1(460d0cdc38b0785dcaecb4ba8254fec1b32a9fd7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_eyes )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "39211248.bin", 0x0000, 0x4d88b4, CRC(a2b799c9) SHA1(9088de779c31d33d9f1eb83e46ec28c30181a0fc) )
	ROM_LOAD16_BYTE( "39211256.bin", 0x0000, 0x4d8648, CRC(de99153a) SHA1(42e00c847effc60130451e19328cd36cfba1cc76) )
	ROM_LOAD16_BYTE( "39211264.bin", 0x0000, 0x4d546c, CRC(73602540) SHA1(2418628a565504281d7a50879fc8ed6bcec73f8b) )
	ROM_LOAD16_BYTE( "39212246.bin", 0x0000, 0x4d858a, CRC(028d59c7) SHA1(75b0643ec51dc02c678cf3aa034dd1be88fea67f) )
	ROM_LOAD16_BYTE( "39212248.bin", 0x0000, 0x4d88b4, CRC(25c68cad) SHA1(f80b0ee24187e8c55c4aa66687ba378f3f7d24ea) )
	ROM_LOAD16_BYTE( "39212256.bin", 0x0000, 0x4d8648, CRC(94150812) SHA1(b3839e90e99bfa7ed4e3a1401db99e42d4f58642) )
	ROM_LOAD16_BYTE( "39212264.bin", 0x0000, 0x4d546c, CRC(a6ec1842) SHA1(e4ce5d53d140a00e2d620eece6d182b201662b61) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890303.bin", 0x0000, 0x5000, CRC(dd0d9672) SHA1(5cf162e77b2b395138e02aca3ac9327ffb08e3e4) )
	ROM_LOAD( "95890304.bin", 0x0000, 0x5000, CRC(c1db66ce) SHA1(e45846411d347cad74135a1392b7ce3df2407b07) )
	ROM_LOAD( "95890305.bin", 0x0000, 0x5000, CRC(0281445e) SHA1(b93460a79c906fb0f33bd898054f4c7aaea8fe12) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008933.bin", 0x0000, 0x03fc55, CRC(5f01c246) SHA1(b5e2b79f780d48935b8eb158b3292ab26340ba7f) )
	ROM_LOAD( "95008959.bin", 0x0000, 0x07daf0, CRC(61e7fb11) SHA1(039efe731866314770800224e2b8536822252193) )
ROM_END




ROM_START( sc_fgbh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426652.lo", 0x00001, 0x080000, CRC(bd72d8ef) SHA1(c9ca907fc1f25bb12c0f0409a79fd49f350bf64c) )
	ROM_LOAD16_BYTE( "95426653.hi", 0x00000, 0x080000, CRC(0e8458f6) SHA1(e716450dad5dfa616c02bc07e6842fa90704ad3f) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427652.lo", 0x00001, 0x080000, CRC(ef45b1b3) SHA1(ac4448d2e1f540d654785ab59224a0848d66da74) )
	ROM_LOAD16_BYTE( "95427653.hi", 0x00000, 0x080000, CRC(ac0450a1) SHA1(1e348be661ef50d39bded3386eaba627570f6c95) )
	ROM_LOAD16_BYTE( "p3306p71.hi", 0x00000, 0x080000, CRC(b48cf490) SHA1(51b5ad358edfc7cb7a68e9ab8784460837c9b632) )
	ROM_LOAD16_BYTE( "p3306p71.lo", 0x00001, 0x080000, CRC(8cfed5af) SHA1(800d31491391199317f290077b41ed46acb84d5c) )
	ROM_LOAD16_BYTE( "p3306s71.hi", 0x00000, 0x080000, CRC(84cd120a) SHA1(c6ac1867ede452c09f40c9a06fb1de1b3938e02f) )
	ROM_LOAD16_BYTE( "p3306s71.lo", 0x00001, 0x080000, CRC(308edcce) SHA1(7281f0911c83a5971e0f0f984177db2247548ceb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_fggp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3301p11.hi", 0x00000, 0x080000, CRC(078596d1) SHA1(ce678b49fdab810eb595a57e237d9a91f5444bb3) )
	ROM_LOAD16_BYTE( "p3301p11.lo", 0x00001, 0x080000, CRC(8a82e48d) SHA1(b4859a388bb12bddabf89b7f10f61b64826d8f33) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3301p12.hi", 0x00000, 0x080000, CRC(984a9241) SHA1(dafa3c7356a8e2df8d5bb5e4af5bca1cd9549a16) )
	ROM_LOAD16_BYTE( "p3301p12.lo", 0x00001, 0x080000, CRC(9bd6fb14) SHA1(37a74a8829fe8569b6ac76465a5c9ed1f22ed251) )
	ROM_LOAD16_BYTE( "p3301p13.hi", 0x00000, 0x080000, CRC(6d569756) SHA1(aaa7083e2e99971fcac3f1bf082b50cc4cc5a6ae) )
	ROM_LOAD16_BYTE( "p3301p13.lo", 0x00001, 0x080000, CRC(758f8920) SHA1(ccc03cce127ed07d0ef036d2025c37efa5b39341) )
	ROM_LOAD16_BYTE( "p3301p71.hi", 0x00000, 0x080000, CRC(b86c7b2a) SHA1(39ce9553dfd964ccab4c4ddc24be98ec05ad4db0) )
	ROM_LOAD16_BYTE( "p3301p71.lo", 0x00001, 0x080000, CRC(6652ccc9) SHA1(e9813e15c072faf95392e3f554bf385d8b2082f7) )
	ROM_LOAD16_BYTE( "p3301s11.hi", 0x00000, 0x080000, CRC(01605580) SHA1(095490b99801ce008d2200bf66509a3dff3823ac) )
	ROM_LOAD16_BYTE( "p3301s11.lo", 0x00001, 0x080000, CRC(eadd9941) SHA1(d63e618a2262fc4eaecdcc07338feaef6aa8fc4e) )
	ROM_LOAD16_BYTE( "p3301s12.hi", 0x00000, 0x080000, CRC(60f36d9a) SHA1(734660b1df84c8b55eae68ef6a95bf520d70e769) )
	ROM_LOAD16_BYTE( "p3301s12.lo", 0x00001, 0x080000, CRC(c1b4f4be) SHA1(c00b04d743f3ad2b4f6a88f0fe2ed818eb2d7a1c) )
	ROM_LOAD16_BYTE( "p3301s13.hi", 0x00000, 0x080000, CRC(2dbc846f) SHA1(8b01d38b1638ec29f02bf110d839803dbab79e40) )
	ROM_LOAD16_BYTE( "p3301s13.lo", 0x00001, 0x080000, CRC(55cf9abc) SHA1(f10d0053e0b6379a1d5d2300f4df10fa59519c33) )
	ROM_LOAD16_BYTE( "p3301s71.hi", 0x00000, 0x080000, CRC(1c3c0d91) SHA1(43f25296edd272eb3ba3510f861856f2b27fca0d) )
	ROM_LOAD16_BYTE( "p3301s71.lo", 0x00001, 0x080000, CRC(20828f79) SHA1(e16346a8d34f22abca67dddc0b5de8b800b848cd) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008824.bin", 0x0000, 0x100000, CRC(58119c7f) SHA1(40f6376b5e1caf0c3231a9b870f584e9b2362676) )
	ROM_LOAD( "95008825.bin", 0x0000, 0x100000, CRC(7fdae5e2) SHA1(57bcb01b66bdd7ad68dc601f67bc13229ad604f8) )
ROM_END




ROM_START( sc_fast )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414220.odd", 0x00001, 0x080000, CRC(ec6810f9) SHA1(a4eda90bc3f91e42472257f810df4d04b00d394c) )
	ROM_LOAD16_BYTE( "95414221.evn", 0x00000, 0x080000, CRC(102f5ea1) SHA1(0067d0d125d9d895defc704643e34f1252d0af60) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008453.bin", 0x0000, 0x0a5c12, CRC(bc1d0d4b) SHA1(1a6de68ead3287b32741dd596ca23b64e2a47925) )
ROM_END




ROM_START( sc_fnclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418608.lo", 0x00001, 0x080000, CRC(a3ef5746) SHA1(7e3b233d022cd79672dde69d14d94de6d1e04e01) )
	ROM_LOAD16_BYTE( "95418609.hi", 0x00000, 0x080000, CRC(e4c0ed80) SHA1(55064cc5d33c69a803d921fb3bcf5dd5ed1c9311) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95418632.lo", 0x00001, 0x080000, CRC(6d999198) SHA1(3eee67c474cba80293c685bef236f60ca294859e) )
	ROM_LOAD16_BYTE( "95418633.hi", 0x00000, 0x080000, CRC(ac8e0908) SHA1(2c3f43320ac42d406aaca12abd26f7748acb929f) )
	ROM_LOAD16_BYTE( "95419608.lo", 0x00001, 0x080000, CRC(8a44e232) SHA1(570f972d0dab69b8c7ba0a880f5d334ae1eb7386) )
	ROM_LOAD16_BYTE( "95419609.hi", 0x00000, 0x080000, CRC(5afcf911) SHA1(e4846f7a3dedb5ed456b07eabe256d8515ca9ccd) )
	ROM_LOAD16_BYTE( "95419632.lo", 0x00001, 0x080000, CRC(9fea4c77) SHA1(c5c179fa398ca53977f231cb9f69bc4ca0e54f19) )
	ROM_LOAD16_BYTE( "95419633.hi", 0x00000, 0x080000, CRC(a2f69a29) SHA1(923b3ccc3dd7a6ea16484fc0230aaff3e7571cfa) )
	ROM_LOAD16_BYTE( "p3061p32.hi", 0x00000, 0x080000, CRC(a48c1c47) SHA1(c417a0515c04889014677928e932e9ad5cf690cc) )
	ROM_LOAD16_BYTE( "p3061p32.lo", 0x00001, 0x080000, CRC(822394b4) SHA1(c10a6542cf33cdb89784ae40c818902e61c6a36c) )
	ROM_LOAD16_BYTE( "p3061s32.hi", 0x00000, 0x080000, CRC(74585398) SHA1(7140755dda8444e5da4b14bdfbf00dffaba3cc72) )
	ROM_LOAD16_BYTE( "p3061s32.lo", 0x00001, 0x080000, CRC(c11d0eac) SHA1(d421d9290ca01a6a50d5c495b7ea1cf4452302e5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008670.bin", 0x0000, 0x100000, CRC(345c0993) SHA1(9fdc586c415c5f4586b8395d4a8d93d87792d43e) )
	ROM_LOAD( "95008671.bin", 0x0000, 0x100000, CRC(11dd3c77) SHA1(f125c510a10819dac3391a582277f99b53c131fa) )
ROM_END




ROM_START( sc_fdice )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1919p41.hi", 0x00000, 0x080000, CRC(bb7e7a30) SHA1(4597dd56822107c87511aeff05c1491eb9f47e0a) )
	ROM_LOAD16_BYTE( "p1919p41.lo", 0x00001, 0x080000, CRC(2b8d35c3) SHA1(fb7c90c3b7609e83f7222efcdea221a65b41a715) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1919s41.hi", 0x00000, 0x080000, CRC(1b765fd4) SHA1(c607f3d6459962d4c6003538a0e888ed200efea6) )
	ROM_LOAD16_BYTE( "p1919s41.lo", 0x00001, 0x080000, CRC(70dbb9b8) SHA1(ee5729806a381e6d025ccb521b96ee97adce5d05) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_fires )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412418.lo", 0x00001, 0x080000, CRC(0f071b4a) SHA1(ec71255493abfb948d6188cf2cb49db8206dfe60) )
	ROM_LOAD16_BYTE( "95412419.hi", 0x00000, 0x080000, CRC(8475ba03) SHA1(f9a04208e47075ec5e693c9582944952b9a7bfdf) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412420.lo", 0x00001, 0x080000, CRC(914100b4) SHA1(8d49cedfb769dbf4cd17dfa945402e26c1a3748d) )
	ROM_LOAD16_BYTE( "95412421.hi", 0x00000, 0x080000, CRC(032814fe) SHA1(10ee04f42b65a5b352539f5747c1ee1c2ca4a464) )
	ROM_LOAD16_BYTE( "95413418.lo", 0x00001, 0x080000, CRC(9f921678) SHA1(0592fd70066d042b09aeb253c2dbb9c87fb3cb99) )
	ROM_LOAD16_BYTE( "95413419.hi", 0x00000, 0x080000, CRC(b3dbd057) SHA1(df81a5eb47fc30747956a3484db761d723e037d1) )
	ROM_LOAD16_BYTE( "95413420.lo", 0x00001, 0x080000, CRC(01d40d86) SHA1(99cea49ec881613e6d321e924c705cb88a513404) )
	ROM_LOAD16_BYTE( "95413421.hi", 0x00000, 0x080000, CRC(34867eaa) SHA1(677dd05792fbfa73dc4a1fdad1394ab1e4cc6c2b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008442.bin", 0x0000, 0x100000, CRC(8b815735) SHA1(8374c706a5378bb8923fd331b96dd07f0204b2e7) )
ROM_END




ROM_START( sc_ftcas )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424426.lo", 0x00001, 0x080000, CRC(7984a6f1) SHA1(a52dd24af6da84ecd16da5c690e9e9a680624cc1) )
	ROM_LOAD16_BYTE( "95424427.hi", 0x00000, 0x080000, CRC(f5fbc8b3) SHA1(23ba3f5ffa17acddb3f4a5ce7750e1981c98b780) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425426.lo", 0x00001, 0x080000, CRC(b650c635) SHA1(fed9ce19c70d0eb3ba8d0a6f4890c746b68cb1d5) )
	ROM_LOAD16_BYTE( "95425427.hi", 0x00000, 0x080000, CRC(2cb9dc4a) SHA1(be18cae57dce0ed199d7bbcf5a4e864349496e02) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008894.bin", 0x0000, 0x0ff163, CRC(9a25809f) SHA1(8be16ac75056be025b4881d50493650c8e290183) )
ROM_END




ROM_START( sc_floop )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420190.lo", 0x00001, 0x080000, CRC(cec33026) SHA1(71f90edaa513268f3b48053e8ebdb22dc94840ac) )
	ROM_LOAD16_BYTE( "95420191.hi", 0x00000, 0x080000, CRC(c940d6e0) SHA1(5b60d562f66ce4873b26ce6fe00bb11638d0b29a) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95421190.lo", 0x00001, 0x080000, CRC(2f269a07) SHA1(ee30a00dbc66da8f36044f3ed3498f6fb713047c) )
	ROM_LOAD16_BYTE( "95421191.hi", 0x00000, 0x080000, CRC(3d7cba6a) SHA1(5c20dc1cf6ec1701c2caa1c0dc5ee835344be34d) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890455.bin", 0x0000, 0x5000, CRC(e69028e8) SHA1(4b2f2daf0f0cda3fb9c48fe04eaedce3a1bb1bcd) )
	ROM_LOAD( "95890456.bin", 0x0000, 0x5000, CRC(93066cdc) SHA1(6bae40c87d083d11ec3b920637c10427ab30d0e2) )
	ROM_LOAD( "95890457.bin", 0x0000, 0x5000, CRC(0dbca080) SHA1(3855987a78f1110741ed8580999c3eceb9126378) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008974.bin", 0x0000, 0x0fdd10, CRC(22b0f002) SHA1(df0e66b693ea5587b6cb54847adafc4720dddaa6) )
ROM_END




ROM_START( sc_grq )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1404p12.hi", 0x00000, 0x080000, CRC(955a6dd0) SHA1(ae846239497562ded1949c810358bfe6114cf949) )
	ROM_LOAD16_BYTE( "p1404p12.lo", 0x00001, 0x080000, CRC(cbb39e3e) SHA1(81b15e03438d1ec5f06cbfe78ad5e94e6dd172d9) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1404p13.hi", 0x00000, 0x080000, CRC(e7f5dfb6) SHA1(a37c862f55108022c2e9c20dd2ab34c16696a9a4) )
	ROM_LOAD16_BYTE( "p1404p13.lo", 0x00001, 0x080000, CRC(81093039) SHA1(90b865ae1ccf34bbdd1d98b7a4001591e8745112) )
	ROM_LOAD16_BYTE( "p1404s12.hi", 0x00000, 0x080000, CRC(464e2427) SHA1(bc98a4fa31be0217c57af68cdc7bc1dcba5ae78c) )
	ROM_LOAD16_BYTE( "p1404s12.lo", 0x00001, 0x080000, CRC(47165998) SHA1(e29bb219a423ea76de85aa83c78515a26a701258) )
	ROM_LOAD16_BYTE( "p1404s13.hi", 0x00000, 0x080000, CRC(244123f8) SHA1(36efd4a0a66324827f6414963e1c7393c50a28b7) )
	ROM_LOAD16_BYTE( "p1404s13.lo", 0x00001, 0x080000, CRC(87b48e68) SHA1(5f1a90a39a725ae373c376e81c773f0b1346b230) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008357.bin", 0x0000, 0x100000, CRC(c5d8c1ba) SHA1(b017c0b616b5ad2e54f111571b16067269a0e69f) )
ROM_END




ROM_START( sc_gldfv )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408450.lo", 0x00001, 0x080000, CRC(23a30f94) SHA1(55f7ddc53f1dd3e6bee58c077c80cb1af42cc218) )
	ROM_LOAD16_BYTE( "95408451.hi", 0x00000, 0x080000, CRC(814bddaa) SHA1(468586c76c6fadb5fe819caee11ea21730253238) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408452.lo", 0x00001, 0x080000, CRC(a3171618) SHA1(ba5fa5eed6ccd73fa6867ff1dc08c01f9213f296) )
	ROM_LOAD16_BYTE( "95408453.hi", 0x00000, 0x080000, CRC(d4624de3) SHA1(08d9d0510cabb666adf55a8cb0ab43758b9226d0) )
	ROM_LOAD16_BYTE( "95409450.lo", 0x00001, 0x080000, CRC(d793ed74) SHA1(939202d3ccd0a01e028acc47bf160160c094a352) )
	ROM_LOAD16_BYTE( "95409451.hi", 0x00000, 0x080000, CRC(7f8ee045) SHA1(e40ad207cb9c21fcf328a31f9be3ebf1ee3f805c) )
	ROM_LOAD16_BYTE( "95409452.lo", 0x00001, 0x080000, CRC(5727f4f8) SHA1(500605b84c2fe3f716c8d11e26d6983af8ce356c) )
	ROM_LOAD16_BYTE( "95409453.hi", 0x00000, 0x080000, CRC(2aa7700c) SHA1(a6127052dae9ede28965a1d120096e18f234d3f3) )
	ROM_LOAD16_BYTE( "p1403p11.hi", 0x00000, 0x080000, CRC(c9b6dfe2) SHA1(0de51adba368ca911b6efdc1864bcb7e85247f67) )
	ROM_LOAD16_BYTE( "p1403p11.lo", 0x00001, 0x080000, CRC(d1f31d6d) SHA1(53cf1a9ac3c6179734431aeb9862da5b8543dede) )
	ROM_LOAD16_BYTE( "p1403p12.hi", 0x00000, 0x080000, CRC(29b634d9) SHA1(418210848f28fb3374ceba58ff331c0ebabc3cc1) )
	ROM_LOAD16_BYTE( "p1403p12.lo", 0x00001, 0x080000, CRC(c132ca11) SHA1(9ade9400ad8af0efbd280624c9dc41f933e96a56) )
	ROM_LOAD16_BYTE( "p1403s11.hi", 0x00000, 0x080000, CRC(bb3e472e) SHA1(bde554659ebbbea026b18a99b033896d80daa825) )
	ROM_LOAD16_BYTE( "p1403s11.lo", 0x00001, 0x080000, CRC(1a6b920b) SHA1(cbd6057cf2ff69f5fe36df5095407e6d53c5ad89) )
	ROM_LOAD16_BYTE( "p1403s12.hi", 0x00000, 0x080000, CRC(a8595220) SHA1(d3a0dc2793fc92cf2283c2b46a0032e1ea663b09) )
	ROM_LOAD16_BYTE( "p1403s12.lo", 0x00001, 0x080000, CRC(68cbe6cf) SHA1(d80a015f0f5de84acd853c80214b32d83f67cee3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008347.bin", 0x0000, 0x100000, CRC(1d24f3ed) SHA1(01c7a8d2c8811cccee3748305681df75361f2254) )
ROM_END




ROM_START( sc_gldmn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211462.bin", 0x0000, 0x1000000, CRC(811a32ab) SHA1(d37238fd6b4a5d13594cc80da48a6b45f44e7c4b) )
	ROM_LOAD( "39211498.bin", 0x0000, 0x1000000, CRC(56624b52) SHA1(181c8b1a4cd039ea7332b1eb71158a424848eea5) )
	ROM_LOAD( "39211567.bin", 0x0000, 0x1000000, CRC(fe309726) SHA1(f7ae2a2c48ce06845df6ce2b2f57ef754f7b4816) )
	ROM_LOAD( "39212462.bin", 0x0000, 0x1000000, CRC(0bdc0f2d) SHA1(53e6a207fbdfae024337bb68ff68797d08485737) )
	ROM_LOAD( "39212498.bin", 0x0000, 0x1000000, CRC(e7d9b5ce) SHA1(c59adf6ed279af1ff655467036f83b63c45a3f66) )
	ROM_LOAD( "39212567.bin", 0x0000, 0x1000000, CRC(8f807849) SHA1(e1e9eeb08db67c94828db832ebab5d96db747fb0) )
	ROM_LOAD( "p3217p71.bin", 0x0000, 0x1000000, CRC(ad0004ea) SHA1(7af464e25adcbbc08d00ed375d460408a3cd1a65) )
	ROM_LOAD( "p3217p72.bin", 0x0000, 0x1000000, CRC(0e721af2) SHA1(89bfdff03b6d197f34320a14c2f8f7b19b2a91ab) )
	ROM_LOAD( "p3217p73.bin", 0x0000, 0x1000000, CRC(ee580fdb) SHA1(0ce8f29f59b7a482eeab00241ca148ae35ea3873) )
	ROM_LOAD( "p3217s71.bin", 0x0000, 0x1000000, CRC(0f09c1da) SHA1(1cbdf80c631ba571a12cb0ea1ceb51b9ccfe63f4) )
	ROM_LOAD( "p3217s72.bin", 0x0000, 0x1000000, CRC(d588b225) SHA1(d74201f8347accc64fa4d8b07adaafb9a2b305bb) )
	ROM_LOAD( "p3217s73.bin", 0x0000, 0x1000000, CRC(4818d397) SHA1(3a96f90cd424deb1242df1443732d3eae8707ac5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008808.bin", 0x0000, 0x100000, CRC(0982179a) SHA1(ea962cc30d191c8e581bb1672a201d6f56a29b22) )
	ROM_LOAD( "95008809.bin", 0x0000, 0x100000, CRC(fcd6f506) SHA1(3d2b8768d9b168f06c01568ed248ee9f687a56b5) )
ROM_END




ROM_START( sc_gldgo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3410p71.hi", 0x00000, 0x080000, CRC(9a7d12fc) SHA1(8a5287d81b8a1faaa947d7f58feccafb6d0e433a) )
	ROM_LOAD16_BYTE( "p3410p71.lo", 0x00001, 0x080000, CRC(567ecb06) SHA1(2cc0407de76103beb137ff59e169a9a99584fad3) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3410s71.hi", 0x00000, 0x080000, CRC(3da6027d) SHA1(d328263459de864e11bc41e3b51bb30c0b6fb9bf) )
	ROM_LOAD16_BYTE( "p3410s71.lo", 0x00001, 0x080000, CRC(51bf1ea1) SHA1(18f584f1e40a54e186452e08975c4c111ab7be8d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009166.bin", 0x0000, 0x100000, CRC(06ae879f) SHA1(b4357306f4361bd26532e3db399f105f09fdf5be) )
	ROM_LOAD( "95009167.bin", 0x0000, 0x100000, CRC(5e34266d) SHA1(35fa153ccb7fd9001cd23dc0c9e683291615e9e0) )
ROM_END




ROM_START( sc_gldsp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416274.lo", 0x00001, 0x080000, CRC(e2a5590d) SHA1(5976206019bd685594d3bf79fb76bf184857faeb) )
	ROM_LOAD16_BYTE( "95416275.hi", 0x00000, 0x080000, CRC(a4d95994) SHA1(93a30575469ab4b5d5543352f937176c32a9ee2e) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416276.lo", 0x00001, 0x080000, CRC(8479c324) SHA1(da8ed080dc5a41caabfd867cb3f4f72d94b14f6c) )
	ROM_LOAD16_BYTE( "95416277.hi", 0x00000, 0x080000, CRC(53bb63b4) SHA1(3751339ea3a5385a25dba4cb76cd726eebc97384) )
	ROM_LOAD16_BYTE( "95416478.lo", 0x00001, 0x080000, CRC(a375a742) SHA1(eceeb012bfbd187ad970e8509c99bc67748a755b) )
	ROM_LOAD16_BYTE( "95416479.hi", 0x00000, 0x080000, CRC(ec268d6d) SHA1(101a95d2e50bb33f5ce50ee31377524ec9b39695) )
	ROM_LOAD16_BYTE( "95416496.lo", 0x00001, 0x080000, CRC(da9e23b8) SHA1(da4accb7dbf71dd20ae77843a944741876c6b54f) )
	ROM_LOAD16_BYTE( "95416497.hi", 0x00000, 0x080000, CRC(90517dcb) SHA1(38fd51b810ccec84747a2526d5236b548a16ae39) )
	ROM_LOAD16_BYTE( "95416498.lo", 0x00001, 0x080000, CRC(4a4f972d) SHA1(8108f9e005ee18339b28ac92601446c4fb8a0ffa) )
	ROM_LOAD16_BYTE( "95416499.hi", 0x00000, 0x080000, CRC(0042bda8) SHA1(a32f3f97d5045fe7321ecc50a821b0e5cfd48eff) )
	ROM_LOAD16_BYTE( "95416510.lo", 0x00001, 0x080000, CRC(a161e0c3) SHA1(92e5c9b642ac2c04110fd512dcd3879cf3b0e4d3) )
	ROM_LOAD16_BYTE( "95416511.hi", 0x00000, 0x080000, CRC(fc4c4f24) SHA1(7328789b96135182f138b1aff4d8a38644506c9d) )
	ROM_LOAD16_BYTE( "95416512.lo", 0x00001, 0x080000, CRC(10d64ab1) SHA1(a6986d83b987f19481cb6703422b4f61e54f732f) )
	ROM_LOAD16_BYTE( "95416513.hi", 0x00000, 0x080000, CRC(ffdc3694) SHA1(e2fc677f1a26a1e2b72900f947b1292beb69ceb7) )
	ROM_LOAD16_BYTE( "95416598.lo", 0x00001, 0x080000, CRC(155af599) SHA1(ad0d43b2e971d9a2335ec53bfee7aa38b763b7da) )
	ROM_LOAD16_BYTE( "95416599.hi", 0x00000, 0x080000, CRC(96e96989) SHA1(abb86f1b1ca48b10194b4136b02ee3c7a0159152) )
	ROM_LOAD16_BYTE( "95416600.lo", 0x00001, 0x080000, CRC(0aeacd49) SHA1(fddd947e1979c450ca8c8bd55a0e31415ac163e0) )
	ROM_LOAD16_BYTE( "95416601.hi", 0x00000, 0x080000, CRC(4984ba72) SHA1(4feb6eabb11001187bdcd2935a90ab361dca0bd5) )
	ROM_LOAD16_BYTE( "95417178.lo", 0x00001, 0x080000, CRC(7a2848cc) SHA1(d33d2c4d3a122d9570a687c04a2877afd65d7b44) )
	ROM_LOAD16_BYTE( "95417179.hi", 0x00000, 0x080000, CRC(52d2c75d) SHA1(954127fa29b6280fec53c9b5dda243ce469752d4) )
	ROM_LOAD16_BYTE( "95417276.lo", 0x00001, 0x080000, CRC(78f656c5) SHA1(24f17545896b9715b214c82f13ce17737b4e73c7) )
	ROM_LOAD16_BYTE( "95417277.hi", 0x00000, 0x080000, CRC(20c713be) SHA1(da71c4d462f3d5125a4bf27a889641d92ba33cc9) )
	ROM_LOAD16_BYTE( "95417478.lo", 0x00001, 0x080000, CRC(5ffa32a3) SHA1(ab1cbe94f06cb05ae8014cd2a137a52a54a083bc) )
	ROM_LOAD16_BYTE( "95417479.hi", 0x00000, 0x080000, CRC(9f5afd67) SHA1(1b15c2846df5c919caaa860d762dd9081c8bcfd6) )
	ROM_LOAD16_BYTE( "95417496.lo", 0x00001, 0x080000, CRC(964b9ddc) SHA1(b10a3dd9025f4019b340366b8a7d75f1980ced6c) )
	ROM_LOAD16_BYTE( "95417497.hi", 0x00000, 0x080000, CRC(53bb8e66) SHA1(9d2543867d12c929550535a2af38e6ede3c24a9b) )
	ROM_LOAD16_BYTE( "95417510.lo", 0x00001, 0x080000, CRC(95a522dc) SHA1(0e19745ac65c4193c11c5e38fa7e9b4ceb27d4ef) )
	ROM_LOAD16_BYTE( "95417511.hi", 0x00000, 0x080000, CRC(7c83375f) SHA1(a676397b9015aedde0fe303ece1e3a681722bc2e) )
	ROM_LOAD16_BYTE( "95417512.lo", 0x00001, 0x080000, CRC(c3fc2286) SHA1(4f0fd419315cf4454201c8cb1d453b569b4a99c6) )
	ROM_LOAD16_BYTE( "95417513.hi", 0x00000, 0x080000, CRC(666b2732) SHA1(1160c0c093043f06eadf177ead7dc28201b2da3d) )
	ROM_LOAD16_BYTE( "95417598.lo", 0x00001, 0x080000, CRC(595b911f) SHA1(b78daf7133004da65f36c38f9490026478d8c088) )
	ROM_LOAD16_BYTE( "95417599.hi", 0x00000, 0x080000, CRC(4ab83460) SHA1(9a8400d7ca21162418bdf02a7388652ef7ef995e) )
	ROM_LOAD16_BYTE( "95417600.lo", 0x00001, 0x080000, CRC(2930a2db) SHA1(e1b1992c4a4921fc10d8d35e9a67c40611ad2775) )
	ROM_LOAD16_BYTE( "95417601.hi", 0x00000, 0x080000, CRC(e3038952) SHA1(c4993167a3782fb09320b4498aefa823c4c50aff) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008543.bin", 0x0000, 0x0d877c, CRC(eabb0fd5) SHA1(260807cf2ce23e02bfaa7d880823e606f8240bee) )
ROM_END




ROM_START( sc_gldwn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211347.bin", 0x0000, 0x1000000, CRC(9db14fec) SHA1(ade5ae1764eb1889624b11ccc5a1faea093fc3ef) )
	ROM_LOAD( "39212347.bin", 0x0000, 0x1000000, CRC(a951e5b9) SHA1(adb004cdfc76a8b753a89018f45cee0ab8551a2f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008945.bin", 0x0000, 0x0ff168, CRC(a467d802) SHA1(4120b3a21598f1c3642f0ce05a3c35c15bf6d811) )
ROM_END




ROM_START( sc_gcclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406700.lo", 0x00001, 0x080000, CRC(1f3ae8fb) SHA1(957108b50deb9e43f541fa2b00dfca28422db7ba) )
	ROM_LOAD16_BYTE( "95406701.hi", 0x00000, 0x080000, CRC(d76642cc) SHA1(f650d0a16c7edeec1d0a10848fb01746f6d4f1db) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95406702.lo", 0x00001, 0x080000, CRC(556ff86c) SHA1(1c3c46e57f9813ce08772f9b613ae0646bc1c6ea) )
	ROM_LOAD16_BYTE( "95406703.hi", 0x00000, 0x080000, CRC(0e69bda3) SHA1(3cf4d4b8588f41bc1c0754683fec4aed5da2d18a) )
	ROM_LOAD16_BYTE( "95406746.lo", 0x00001, 0x080000, CRC(775b97cc) SHA1(b6d6de9f2fbc9b0325c7cd89d2d8c6a20e40f827) )
	ROM_LOAD16_BYTE( "95406747.hi", 0x00000, 0x080000, CRC(e41d5f3a) SHA1(9871c02b2338999eb16ac99c09d20a6f1e64e68b) )
	ROM_LOAD16_BYTE( "95406974.lo", 0x00001, 0x080000, CRC(a424b04c) SHA1(8cdd2799964c02e2dbe7f84da8bf111fe1b7f11d) )
	ROM_LOAD16_BYTE( "95406975.hi", 0x00000, 0x080000, CRC(585f9415) SHA1(172380f0bbc650560e626d80fdc34e1c369fb6e6) )
	ROM_LOAD16_BYTE( "95406976.lo", 0x00001, 0x080000, CRC(f975389d) SHA1(9d76cac21dd791724c9ed477d341909ad488f80d) )
	ROM_LOAD16_BYTE( "95406977.hi", 0x00000, 0x080000, CRC(94e0a013) SHA1(01712a044ed1c4638092d6e6e57d9fb2557aec0b) )
	ROM_LOAD16_BYTE( "95406980.lo", 0x00001, 0x080000, CRC(fb0421c5) SHA1(c0493d68bcebfc5dfb4e6d3224b7ce6c5d8da909) )
	ROM_LOAD16_BYTE( "95406981.hi", 0x00000, 0x080000, CRC(33a244b9) SHA1(6446d2f01c9edfd785f87ac6cc3d9c2e6e3c2b10) )
	ROM_LOAD16_BYTE( "95407700.lo", 0x00001, 0x080000, CRC(2001695e) SHA1(d8a1d6aa77ffd51c150ac2dc302c59ece392ee95) )
	ROM_LOAD16_BYTE( "95407701.hi", 0x00000, 0x080000, CRC(7c7cd268) SHA1(09a9be12e7048401e84a5166dfca584eb4ce7b6e) )
	ROM_LOAD16_BYTE( "95407702.lo", 0x00001, 0x080000, CRC(29ee1cdc) SHA1(cadb16843f830649aed124faf5f92792b4489449) )
	ROM_LOAD16_BYTE( "95407703.hi", 0x00000, 0x080000, CRC(d1e1aea0) SHA1(3dfb3f74a8551e1fbbd231347e0194ce527a8433) )
	ROM_LOAD16_BYTE( "95407746.lo", 0x00001, 0x080000, CRC(e618e6e7) SHA1(49a9923bc514d46da1428c0ba6e6c9df106ebf1f) )
	ROM_LOAD16_BYTE( "95407747.hi", 0x00000, 0x080000, CRC(f12daf09) SHA1(273649df6f55e16e95601de6e4d995f64ee70dd7) )
	ROM_LOAD16_BYTE( "95407974.lo", 0x00001, 0x080000, CRC(bb8b187d) SHA1(a0028ed0383fd7aec72cfcde0de73158f47459e7) )
	ROM_LOAD16_BYTE( "95407975.hi", 0x00000, 0x080000, CRC(13ac9693) SHA1(a9e35791c5c51904f0ac4c2ed073544e940b825e) )
	ROM_LOAD16_BYTE( "95407976.lo", 0x00001, 0x080000, CRC(21721e51) SHA1(de81051ad8759455c30e6295e7ef4543d19a1a85) )
	ROM_LOAD16_BYTE( "95407977.hi", 0x00000, 0x080000, CRC(e7eb90e6) SHA1(8ffde2059e41167234605a30c73462386948025f) )
	ROM_LOAD16_BYTE( "95407980.lo", 0x00001, 0x080000, CRC(561ca30c) SHA1(18321f96b68edec5f5a4246af0314758626bbf86) )
	ROM_LOAD16_BYTE( "95407981.hi", 0x00000, 0x080000, CRC(c651f342) SHA1(0fb82c53f236d4d132726d1e4373c48c1dae0712) )
	ROM_LOAD16_BYTE( "95410756.lo", 0x00001, 0x080000, CRC(796eb631) SHA1(13d1ee86bd0a05474fa14e4698190f4650bfdd7f) )
	ROM_LOAD16_BYTE( "95410757.hi", 0x00000, 0x080000, CRC(17fab5ef) SHA1(5e99358216176f16a62e6c6922a4a7e017ecea3b) )
	ROM_LOAD16_BYTE( "95411756.lo", 0x00001, 0x080000, CRC(9f43dba9) SHA1(116424e0f4e6ba095805d54b84658fc4dad7ee8c) )
	ROM_LOAD16_BYTE( "95411757.hi", 0x00000, 0x080000, CRC(5b990168) SHA1(0d0c9381444138f831a1c3bacc5e95e66f7acc95) )
	ROM_LOAD16_BYTE( "95412166.lo", 0x00001, 0x080000, CRC(f7b4806d) SHA1(906ce4a0acfa98618dae6853abe0442f25364f56) )
	ROM_LOAD16_BYTE( "95412167.hi", 0x00000, 0x080000, CRC(a306f5d0) SHA1(942ccba0e9506ff29f7ff36f173d473a7963a6e2) )
	ROM_LOAD16_BYTE( "95412168.lo", 0x00001, 0x080000, CRC(37dfdeb2) SHA1(7cd4cdb39cf62a7ceb14cc57bd15b8534f386585) )
	ROM_LOAD16_BYTE( "95412169.hi", 0x00000, 0x080000, CRC(cdc31346) SHA1(2a066b346e1945f05bf5ca969aceeacc47f6903b) )
	ROM_LOAD16_BYTE( "95413166.lo", 0x00001, 0x080000, CRC(b5c8b0d3) SHA1(3ed87adecdbfe1305455dc8fbf283b10a73c0df7) )
	ROM_LOAD16_BYTE( "95413167.hi", 0x00000, 0x080000, CRC(9c1d98b6) SHA1(5e62de5f8239c9fbe128976727a13c41f0eff3c9) )
	ROM_LOAD16_BYTE( "95413168.lo", 0x00001, 0x080000, CRC(040346b8) SHA1(23448739b850a1a6b5f1126bf89574624411d95f) )
	ROM_LOAD16_BYTE( "95413169.hi", 0x00000, 0x080000, CRC(326bdfa7) SHA1(4d2eed69bf2d363137282d35d03f32f5968dea55) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	// this is intel hex format
	ROM_LOAD( "95004252.bin", 0x0000, 0x134084, CRC(b05844f8) SHA1(e2a2f3ad69cc9a66ca703e9e07ac008300d4139d) )
	ROM_LOAD( "95004253.bin", 0x0000, 0x134084, CRC(a546da40) SHA1(fead6e4f8dab919f65c48cf04100a7742432b1f4) )
ROM_END




ROM_START( sc_gmclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "g95426512.lo", 0x00001, 0x080000, CRC(f5e9e663) SHA1(45761b2c728a97f66cf9aac8fa7203cb34333588) )
	ROM_LOAD16_BYTE( "g95426513.hi", 0x00000, 0x080000, CRC(d54f139e) SHA1(0afe8d94556de6f885caffee0478acae33001790) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "g95426624.lo", 0x00001, 0x080000, CRC(c469ac6a) SHA1(1e2e2465a86910b574621a8a86cc41ec486847aa) )
	ROM_LOAD16_BYTE( "g95426625.hi", 0x00000, 0x080000, CRC(52ac982d) SHA1(d4c98a02ab9062fc59bbabe81294c105444e7b68) )
	ROM_LOAD16_BYTE( "g95427512.lo", 0x00001, 0x080000, CRC(642be142) SHA1(0d0791ee38503a7a02c4cc55b04e9ad17a24157b) )
	ROM_LOAD16_BYTE( "g95427513.hi", 0x00000, 0x080000, CRC(60f1f1b8) SHA1(19e7ea4b6f8f0600dca9727a417953252ac30fbe) )
	ROM_LOAD16_BYTE( "g95427624.lo", 0x00001, 0x080000, CRC(689fd215) SHA1(706359430fde0cbd8c945d441dc30e3fec4e24d9) )
	ROM_LOAD16_BYTE( "g95427625.hi", 0x00000, 0x080000, CRC(7df98b6c) SHA1(c7c7f9016d2d56decb6b3ec7a69a678652dcfd50) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009112.bin", 0x0000, 0x100000, CRC(80be159b) SHA1(2e6d19f97613152fcb17d027efc886815102fd56) )
	ROM_LOAD( "95009113.bin", 0x0000, 0x100000, CRC(edd3d30e) SHA1(94a56fda349d998b8571c271041d11cc79afaec2) )
ROM_END




ROM_START( sc_hir )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "p3401p71.bin", 0x0000, 0x1000000, CRC(02dfd5d1) SHA1(cddab71cbd9061390183b773fa9a965812c34087) )
	ROM_LOAD( "p3401p72.bin", 0x0000, 0x1000000, CRC(f7a52510) SHA1(e6d494346b6b72a8b68dce24c95b35faee52a0a9) )
	ROM_LOAD( "p3401s71.bin", 0x0000, 0x1000000, CRC(247754f6) SHA1(78a1caaa613d9033b8f870e916df023f724adb95) )
	ROM_LOAD( "p3401s72.bin", 0x0000, 0x1000000, CRC(f7f13885) SHA1(b9d334fdc3e57f0ebaa32b9da6c0951784b87a65) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008555.bin", 0x0000, 0x100000, CRC(51d07478) SHA1(1e678b61d594d4884601e92485ab22206dc425d4) )
	ROM_LOAD( "95009143.bin", 0x0000, 0x100000, CRC(e8bab23e) SHA1(dc8e5173fcb301ee4abedc76d42ebf4d58d07af1) )
	ROM_LOAD( "95009144.bin", 0x0000, 0x100000, CRC(73b81f14) SHA1(0a8d7949a290dce2b9cd6c4ec42a64ac8f18836d) )
ROM_END




ROM_START( sc_hircl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211098.bin", 0x0000, 0x1000000, CRC(0f40863e) SHA1(30c15f42c6f293b3210dbc91f6fe55fc51069ab6) )
	ROM_LOAD( "39212098.bin", 0x0000, 0x1000000, CRC(32da0bbe) SHA1(117bc8496ae44ea641188b7a9e0952f9378520aa) )
	ROM_LOAD( "39212099.bin", 0x0000, 0x1000000, CRC(92661240) SHA1(670c733c73621a561c01cd50d2e0064a12ef615f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_hirol )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416966.lo", 0x00001, 0x080000, CRC(419f71ee) SHA1(b2234a3d43861a6d1a1cb333253e856fd3391282) )
	ROM_LOAD16_BYTE( "95416967.hi", 0x00000, 0x080000, CRC(ef4c8100) SHA1(7db37ba1ec21dc48fe2514d55dbc19d547f00d16) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417966.lo", 0x00001, 0x080000, CRC(86e10937) SHA1(f018062911b5ccd3fbe1776468a25d267fe1133c) )
	ROM_LOAD16_BYTE( "95417967.hi", 0x00000, 0x080000, CRC(5d340315) SHA1(010721948820e3f429b76e673e180668523b602b) )
	ROM_LOAD16_BYTE( "95420608.lo", 0x00001, 0x080000, CRC(0bdced16) SHA1(7421887db6f79314b52be10bb967f8ed6917c340) )
	ROM_LOAD16_BYTE( "95420609.hi", 0x00000, 0x080000, CRC(8ddfe3f9) SHA1(eba6467ea6c868b1b99f0a771d5be1d049f6f449) )
	ROM_LOAD16_BYTE( "95420742.lo", 0x00001, 0x080000, CRC(0bd1af11) SHA1(2d05b19dea9aa1b73a75b8e5b09bb694cb9f647f) )
	ROM_LOAD16_BYTE( "95420743.hi", 0x00000, 0x080000, CRC(84339062) SHA1(0ff89fc9b397051adcb46056cbcb33ec7d27fbc0) )
	ROM_LOAD16_BYTE( "95421608.lo", 0x00001, 0x080000, CRC(ea134ae9) SHA1(84b5274d62f724f7711734757ee562b7b4a07a60) )
	ROM_LOAD16_BYTE( "95421609.hi", 0x00000, 0x080000, CRC(990be37d) SHA1(edd18b2456628bc77b9f1e591ee17da42e51738a) )
	ROM_LOAD16_BYTE( "95421742.lo", 0x00001, 0x080000, CRC(70e329a7) SHA1(a6b85055849750dd821ca3755f7c8faa1208b42c) )
	ROM_LOAD16_BYTE( "95421743.hi", 0x00000, 0x080000, CRC(1b75a76a) SHA1(28da05855afc0a67966941dcb5e207fa74161e06) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890458.bin", 0x0000, 0x5000, CRC(237fc19f) SHA1(41c0dad102e8345c568f6178b13a17acedcbe1b3) )
	ROM_LOAD( "95890459.bin", 0x0000, 0x5000, CRC(56e985ab) SHA1(48c425f85a8feba6775f2b34be8c91c78c233d66) )
	ROM_LOAD( "95890460.bin", 0x0000, 0x5000, CRC(c85349f7) SHA1(7be87d120dc5d5972663ede3df6c9221deddff9b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008977.bin", 0x0000, 0x0d9fcb, CRC(99173f54) SHA1(86d6432a37453865f6ee3b80bf8e1c1c84c6e3f9) )
ROM_END




ROM_START( sc_hulk )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408676.lo", 0x00001, 0x080000, CRC(81ce7644) SHA1(ccf48d494ac8d2ba94b9becbd9ac53d508e7d8aa) )
	ROM_LOAD16_BYTE( "95408677.hi", 0x00000, 0x080000, CRC(19d75bb8) SHA1(70d223d79ba1cc8a66650dd2df6e5c9ada283600) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95408678.lo", 0x00001, 0x080000, CRC(8ca8f9ff) SHA1(92b1c5479f53a7b0fbc390020b6702f969f55de3) )
	ROM_LOAD16_BYTE( "95408679.hi", 0x00000, 0x080000, CRC(50dc05a7) SHA1(e3439285eefd8ca05a5a5610b64f18d0361144e0) )
	ROM_LOAD16_BYTE( "95409676.lo", 0x00001, 0x080000, CRC(5299d009) SHA1(5836790581a3de5fd5ba3870bf91c64ee0720af4) )
	ROM_LOAD16_BYTE( "95409677.hi", 0x00000, 0x080000, CRC(fef3fa32) SHA1(f4223747190ac1bf9b738a3f637213e16fa0c3ee) )
	ROM_LOAD16_BYTE( "95409678.lo", 0x00001, 0x080000, CRC(88c7de44) SHA1(f59502eab3f0fff3ac12d6cf802d2a348390a036) )
	ROM_LOAD16_BYTE( "95409679.hi", 0x00000, 0x080000, CRC(68127cfa) SHA1(c5d016a3716c1e0876a62b2269f5763b2d59c27c) )
	ROM_LOAD16_BYTE( "95410538.lo", 0x00001, 0x080000, CRC(d18cdfd1) SHA1(99f71c1cee836fa528d2f15de666119f2a214d83) )
	ROM_LOAD16_BYTE( "95410539.hi", 0x00000, 0x080000, CRC(54adfa49) SHA1(ac5f680f97d26b31cb9c1f76f08d439def521cd4) )
	ROM_LOAD16_BYTE( "95410540.lo", 0x00001, 0x080000, CRC(6e31db7b) SHA1(aa8f28353934128142b0d8de92b282060d7ce78f) )
	ROM_LOAD16_BYTE( "95410541.hi", 0x00000, 0x080000, CRC(f2d7da51) SHA1(706bdb5fc6ecb58304892d309e6c59a2019b05b6) )
	ROM_LOAD16_BYTE( "95411538.lo", 0x00001, 0x080000, CRC(00a58cf4) SHA1(322f3f7cb4dc24aca201300ebe84c439c48e5393) )
	ROM_LOAD16_BYTE( "95411539.hi", 0x00000, 0x080000, CRC(d09bb505) SHA1(eb7f5c7e89a25ea44df2b04c84f193b82a8a135f) )
	ROM_LOAD16_BYTE( "95411540.lo", 0x00001, 0x080000, CRC(bf18885e) SHA1(371bb5ed75e9f7d0d85cca5860ce5ee409395277) )
	ROM_LOAD16_BYTE( "95411541.hi", 0x00000, 0x080000, CRC(76e1951d) SHA1(eef5ebbf647728786b92ababdadb91654a9bfd93) )
	ROM_LOAD16_BYTE( "p1405p12.hi", 0x00000, 0x080000, CRC(0ed57cdf) SHA1(6075eef121334801729839b5edf5723ca183214b) )
	ROM_LOAD16_BYTE( "p1405p12.lo", 0x00001, 0x080000, CRC(3fe9f6f9) SHA1(269944162a76b77249527d9384b5b86da7159b5f) )
	ROM_LOAD16_BYTE( "p1405s12.hi", 0x00000, 0x080000, CRC(020ef4e7) SHA1(ef2684275fcf5fd1bb7b77169965f803f19b5a73) )
	ROM_LOAD16_BYTE( "p1405s12.lo", 0x00001, 0x080000, CRC(cfd0d293) SHA1(719b06fb5e10eaf3f7a852c3fff6e403ea505241) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008367.bin", 0x0000, 0x100000, CRC(37eea219) SHA1(e612b2c0bca83d742b35fbaf487b6805cfac024d) )
	ROM_LOAD( "95008368.bin", 0x0000, 0x100000, CRC(06549054) SHA1(923a320f9689361802dc82db467b294f7bc85147) )
ROM_END




ROM_START( sc_iab )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420322.lo", 0x00001, 0x080000, CRC(921741fa) SHA1(02d8b6974fe21726873381c9ce14503a3c029411) )
	ROM_LOAD16_BYTE( "95420323.hi", 0x00000, 0x080000, CRC(bc7d1388) SHA1(fedc3035cd5a43b0c878e2ca2bb320a4d23bd497) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95421322.lo", 0x00001, 0x080000, CRC(4b19cb34) SHA1(3c4127ca78cbc1b4d7bfda253b34c0a991bdca0f) )
	ROM_LOAD16_BYTE( "95421323.hi", 0x00000, 0x080000, CRC(26233a47) SHA1(6ccd7f05a7c24f638423b397d74372074061a2e2) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890446.bin", 0x0000, 0x5000, CRC(8fbf0046) SHA1(5e121f73fcf1777041995c9891465e17c37c8163) )
	ROM_LOAD( "95890447.bin", 0x0000, 0x5000, CRC(fa294472) SHA1(71fa4cfaf8ba81f446d9f3504123e3c0c9a9af90) )
	ROM_LOAD( "95890448.bin", 0x0000, 0x5000, CRC(6493882e) SHA1(c69401b35ef710d0df51541e615818dbd259c7f7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008969.bin", 0x0000, 0x0fe101, CRC(798c9559) SHA1(4afb21a78be73353741b5903099d3c48e44fcebb) )
ROM_END




ROM_START( sc_ijbdo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424446.lo", 0x00001, 0x080000, CRC(49b4b792) SHA1(9ca4d6fb248b8c7fcc4cf1fe09cdafe5b6c0d41f) )
	ROM_LOAD16_BYTE( "95424447.hi", 0x00000, 0x080000, CRC(fd82fee7) SHA1(eba4ac00f22001d2c40cd426a3f34e03c6880ab1) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95424540.lo", 0x00001, 0x080000, CRC(d4f00854) SHA1(53c703e80264d288afc6437b8849cab746a65460) )
	ROM_LOAD16_BYTE( "95424541.hi", 0x00000, 0x080000, CRC(970dde6e) SHA1(f83e84a7179f363d946798e1b233e915faa64287) )
	ROM_LOAD16_BYTE( "95425446.lo", 0x00001, 0x080000, CRC(61b97ff3) SHA1(56a77ca7453df982d882849ecc2cfc335be1ba58) )
	ROM_LOAD16_BYTE( "95425447.hi", 0x00000, 0x080000, CRC(e4faf2fc) SHA1(ffb129ebb7211ed1116cf41ed49e1830eb5e17c9) )
	ROM_LOAD16_BYTE( "95425540.lo", 0x00001, 0x080000, CRC(70dd0ea8) SHA1(feece9475d421e02feb74ad2fa6e341e0dc3fe3c) )
	ROM_LOAD16_BYTE( "95425541.hi", 0x00000, 0x080000, CRC(f684cea2) SHA1(a53ed0d57fb6f7a90bcc66843b1351b15c47243e) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891076.bin", 0x0000, 0x5000, CRC(d535ed90) SHA1(0e349023bec422b356d7b9cf7f892a10fabbdedd) )
	ROM_LOAD( "95891077.bin", 0x0000, 0x5000, CRC(a0a3a9a4) SHA1(e74ec6d2729bbef737300a014e83409ef034f605) )
	ROM_LOAD( "95891078.bin", 0x0000, 0x5000, CRC(3e1965f8) SHA1(b37c73edf7f4b17fe3554fa394846929ad2031c0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008896.bin", 0x0000, 0x0eeaef, CRC(d581cb00) SHA1(16b44ba6cf4008109792a016d7aef12e6d6329d7) )
ROM_END




ROM_START( sc_jckmo )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211254.bin", 0x0000, 0x432c2c, CRC(66a52091) SHA1(03fd4c1ba2ea7a2ce09dd6200985a2d882e3160e) )
	ROM_LOAD( "39211261.bin", 0x0000, 0x4279d8, CRC(8ee6e967) SHA1(f5c37717cf7905a479a80604c622261669f504a1) )
	ROM_LOAD( "39211266.bin", 0x0000, 0x427514, CRC(6fad3371) SHA1(5a9d3da46980a24907a0fa131f2f77a65b72cde5) )
	ROM_LOAD( "39211294.bin", 0x0000, 0x4284c0, CRC(8fed15d4) SHA1(cc072ee7736f31fb10ad6d293b4ab59cc1a00542) )
	ROM_LOAD( "39212254.bin", 0x0000, 0x432c2c, CRC(f9eeb730) SHA1(602fccdd05c621d3707e42f9571bb515af1c7f9b) )
	ROM_LOAD( "39212261.bin", 0x0000, 0x4279d8, CRC(3641bfe6) SHA1(5a34ada0e3c70c0d05d552be2f5fee50055b1dd4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_kingx )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416616.lo", 0x00001, 0x080000, CRC(dcd5b5fd) SHA1(b161f50030e71e5a57dadea3cf6980f57bbdcc27) )
	ROM_LOAD16_BYTE( "95416617.hi", 0x00000, 0x080000, CRC(fbe8024c) SHA1(7dd1741381f715d5bd6b3ee2626015033baf67bb) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417616.lo", 0x00001, 0x080000, CRC(52cd059d) SHA1(4e15cfefcd37e02a5dd97b53fd687b5b0294d9ca) )
	ROM_LOAD16_BYTE( "95417617.hi", 0x00000, 0x080000, CRC(026afaf4) SHA1(902bcd07001788140a0b1b284c5b63bcc18d729b) )
	ROM_LOAD16_BYTE( "95420278.lo", 0x00001, 0x080000, CRC(b999edc6) SHA1(a3a228f93ec0fcdde6450877edb62208cc804608) )
	ROM_LOAD16_BYTE( "95420279.hi", 0x00000, 0x080000, CRC(a7853b5e) SHA1(483ca0e9df84703e17d38f5b0470ab9f88418f33) )
	ROM_LOAD16_BYTE( "95420280.lo", 0x00001, 0x080000, CRC(371f9cea) SHA1(24c7398daae3c3f63cba293e72dc5f17aaebf069) )
	ROM_LOAD16_BYTE( "95420281.hi", 0x00000, 0x080000, CRC(41a9ecff) SHA1(5874f0488007fe0514d749b2fa30d96804825c54) )
	ROM_LOAD16_BYTE( "95421278.lo", 0x00001, 0x080000, CRC(b109a07c) SHA1(529b34927afee94b38ca4bdb7baf63396f12dc1f) )
	ROM_LOAD16_BYTE( "95421279.hi", 0x00000, 0x080000, CRC(566cc152) SHA1(c2d90c35597732b566de5c7fdb2cb42889836485) )
	ROM_LOAD16_BYTE( "95421280.lo", 0x00001, 0x080000, CRC(573270d1) SHA1(cb4d14979144499455baf484e3d3e52a5bb9d3e2) )
	ROM_LOAD16_BYTE( "95421281.hi", 0x00000, 0x080000, CRC(ec960391) SHA1(5ac06e9db72da0b1817b034d9f7855e19a0992a6) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890374.bin", 0x0000, 0x5000, CRC(87f2ca06) SHA1(480be8b0a42c9be55cb9e4c264438667734eb644) )
	ROM_LOAD( "95890375.bin", 0x0000, 0x5000, CRC(9b243aba) SHA1(537783dff8f155921a378224f2a8fe754c4947a5) )
	ROM_LOAD( "95890376.bin", 0x0000, 0x5000, CRC(587e182a) SHA1(23de9e8b4d2631e53917346d4902813d474e64a0) )
	ROM_LOAD( "95890700.bin", 0x0000, 0x5000, CRC(fab9a6f1) SHA1(a7901e76e96f083ca65ffbd847b36e1140c6caaf) )
	ROM_LOAD( "95890701.bin", 0x0000, 0x5000, CRC(e66f564d) SHA1(7267fd9d4ad1b1886870eb89c940f59a8f84c014) )
	ROM_LOAD( "95890702.bin", 0x0000, 0x5000, CRC(253574dd) SHA1(15b9aac5e9a176f792eefcbd7de2ad8df38ff67b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	// 95008990.bin = 95008995.bin          sc4ckx     Casino King X (Mazooma) (Scorpion 4)
ROM_END




ROM_START( sc_monky )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420550.lo", 0x00001, 0x080000, CRC(763c83de) SHA1(6a6e899536ed181ec8a87013760a3688f3f90281) )
	ROM_LOAD16_BYTE( "95420551.hi", 0x00000, 0x080000, CRC(c1e93f0c) SHA1(5e2d9a6440f996b1075f38850140c2d4fe64c18b) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95421550.lo", 0x00001, 0x080000, CRC(7fb82da1) SHA1(c5667ec3c0c764dc2905f9588c0e5474da8405b6) )
	ROM_LOAD16_BYTE( "95421551.hi", 0x00000, 0x080000, CRC(fb6159c1) SHA1(2123db922c0b37e1863fd5ab196124d701b3bfe7) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890706.bin", 0x0000, 0x5000, CRC(4b2c5ee0) SHA1(e5bdcc4f076cc5550e51f3f4d4de5d8c59a4f545) )
	ROM_LOAD( "95890707.bin", 0x0000, 0x5000, CRC(3eba1ad4) SHA1(c780a4813c6b507a7e21ef2d7a401f3d764fd0f7) )
	ROM_LOAD( "95890708.bin", 0x0000, 0x5000, CRC(a000d688) SHA1(bcc197af2596b9c81cc56926fefc5854d7a94a27) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008998.bin", 0x0000, 0x0f0a3e, CRC(cc0dd8f2) SHA1(c99c54ce1289604f57ce2345ec5cb69be91b69d6) )
ROM_END




ROM_START( sc_mobob )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426614.lo", 0x00001, 0x080000, CRC(338cfeb2) SHA1(16fbc219fba8b4667ba217167953301b4079731f) )
	ROM_LOAD16_BYTE( "95426615.hi", 0x00000, 0x080000, CRC(8b4b25f6) SHA1(bbaf7a977506f2d55a72b08f0c6fc854837552f8) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426630.lo", 0x00001, 0x080000, CRC(2614eff3) SHA1(74c3487dfa348d2f137100379f1ceb511570b91c) )
	ROM_LOAD16_BYTE( "95426631.hi", 0x00000, 0x080000, CRC(2e254ca7) SHA1(0722a7dc44d2839feff22ccff33f396fd1e5cba0) )
	ROM_LOAD16_BYTE( "95426658.lo", 0x00001, 0x080000, CRC(709e313b) SHA1(9730b4efd4da2ea978e49020a43f3554824c1a23) )
	ROM_LOAD16_BYTE( "95426659.hi", 0x00000, 0x080000, CRC(e0542cd2) SHA1(19730918c8ab3c5fe7a9d9fdcc4e3e491cd4046a) )
	ROM_LOAD16_BYTE( "95426812.lo", 0x00001, 0x080000, CRC(f140a579) SHA1(c0255ba637c0e5a67472c6dfa1e282078bcac92d) )
	ROM_LOAD16_BYTE( "95426813.hi", 0x00000, 0x080000, CRC(adfd1181) SHA1(013dc9ac8942170173099e51cb08290462033737) )
	ROM_LOAD16_BYTE( "95427614.lo", 0x00001, 0x080000, CRC(b090aa6c) SHA1(5cefb3e35d3e3ecff43e342f7e31de7c7c6eabf9) )
	ROM_LOAD16_BYTE( "95427615.hi", 0x00000, 0x080000, CRC(95348c58) SHA1(637fdbf6d4ebb48e754f40efa70caf0cd8367086) )
	ROM_LOAD16_BYTE( "95427630.lo", 0x00001, 0x080000, CRC(bd853224) SHA1(424836ac6dcf9cac1187361156717447f9f90fdd) )
	ROM_LOAD16_BYTE( "95427631.hi", 0x00000, 0x080000, CRC(25f09e39) SHA1(97a5f905715d63f595e1d5d95a805e33e6d54109) )
	ROM_LOAD16_BYTE( "95427658.lo", 0x00001, 0x080000, CRC(bd0d09ea) SHA1(ebe2b1ce28ef7ba6ec0dd99a92cbe3abbcf5b0ec) )
	ROM_LOAD16_BYTE( "95427659.hi", 0x00000, 0x080000, CRC(c1641c9e) SHA1(cc3f1e3a39ac88043216fd677c047201b7e1fb38) )
	ROM_LOAD16_BYTE( "95427812.lo", 0x00001, 0x080000, CRC(ad3df75c) SHA1(cd9988b2c9bd19b39efd3bf2dc5def3053094835) )
	ROM_LOAD16_BYTE( "95427813.hi", 0x00000, 0x080000, CRC(310e0cec) SHA1(533cfef424fa3e4f0182a308c826d7f35a314270) )
	ROM_LOAD16_BYTE( "p3307p71.hi", 0x00000, 0x080000, CRC(d234205a) SHA1(65d3bb4b1a3baa4eec9c89268c27b3f346bcb18e) )
	ROM_LOAD16_BYTE( "p3307p71.lo", 0x00001, 0x080000, CRC(7668f4f1) SHA1(82d78e8336fe409dd2ae3fe0637b9ba7116662a0) )
	ROM_LOAD16_BYTE( "p3307s71.hi", 0x00000, 0x080000, CRC(5a6be577) SHA1(ecae25998e9374b1b65a5f23aa7d7344eb5c3c2f) )
	ROM_LOAD16_BYTE( "p3307s71.lo", 0x00001, 0x080000, CRC(154694d5) SHA1(5f721cf84e78acccb41d41474796bc2ef49b363c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008842.bin", 0x0000, 0x100000, CRC(3205f4c9) SHA1(a8b92e1558911e02281b1c38c64c5e04836794b0) )
	ROM_LOAD( "95008843.bin", 0x0000, 0x100000, CRC(95057e16) SHA1(6c26451dd336f908ce0fcea0c56176b589111868) )
ROM_END




ROM_START( sc_mogta )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3504s72.hi", 0x00000, 0x080000, CRC(684fe38d) SHA1(4fde491734acca1bd02e75f4cf2ae467ad6e62c0) )
	ROM_LOAD16_BYTE( "p3504s72.lo", 0x00001, 0x080000, CRC(2bbe91ad) SHA1(fbad244458d20dc95dc19d5fc19401adbdfd3f09) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3504p72.hi", 0x00000, 0x080000, CRC(79828a85) SHA1(672e5b5c683746e4872d17ea61ff39e0ad591824) )
	ROM_LOAD16_BYTE( "p3504p72.lo", 0x00001, 0x080000, CRC(484ef5a4) SHA1(f8822470bbbc289e93a61622eeefa12e3ddb9fac) )
	ROM_LOAD16_BYTE( "p3504s71.hi", 0x00000, 0x080000, CRC(3edc6b86) SHA1(d69294423623ab5fbd5c1889742bc5aa830cb8db) )
	ROM_LOAD16_BYTE( "p3504s71.lo", 0x00001, 0x080000, CRC(ec028348) SHA1(491461e59a7b5addd044ce48187e2c7e3c1e9b8d) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009039.bin", 0x0000, 0x100000, CRC(0756b1b7) SHA1(82a8f9bf4c70a492ae2d4f478ecc73cccf9aecdd) )
	ROM_LOAD( "95009040.bin", 0x0000, 0x100000, CRC(9a928ef4) SHA1(5b19f70d067540aef3dc140115c12601d2b8176e) )
ROM_END




ROM_START( sc_momil )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426544.lo", 0x00001, 0x080000, CRC(a6bbb93c) SHA1(57803fd6647ab5ff789c301e6d0079bb168eb0ca) )
	ROM_LOAD16_BYTE( "95426545.hi", 0x00000, 0x080000, CRC(c900531f) SHA1(e996e262c29e002420304fba903793b05bcfae75) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426712.lo", 0x00001, 0x080000, CRC(32d5015a) SHA1(a2638aaa04abb4ec6d900af4b5a6423ec0309016) )
	ROM_LOAD16_BYTE( "95426713.hi", 0x00000, 0x080000, CRC(f2750c3f) SHA1(1383adb9940db84dbe9b607171599d26dba482b6) )
	ROM_LOAD16_BYTE( "95427544.lo", 0x00001, 0x080000, CRC(9d3de68b) SHA1(813e853ebe67d0a3459de1572faf8d7d6543958a) )
	ROM_LOAD16_BYTE( "95427545.hi", 0x00000, 0x080000, CRC(c8a608d8) SHA1(823fe352d7b2a50270e93f70b42faa0c634902cf) )
	ROM_LOAD16_BYTE( "95427712.lo", 0x00001, 0x080000, CRC(ba917e8e) SHA1(ab5f10cc4819fa7a10436cf53d19dfe22490fad3) )
	ROM_LOAD16_BYTE( "95427713.hi", 0x00000, 0x080000, CRC(4021322b) SHA1(27c9fe7133e594e901dd086c28e1346bb44d8208) )
	ROM_LOAD16_BYTE( "p3311p71.hi", 0x00000, 0x080000, CRC(06ed3a17) SHA1(ab7c625b03eb1c401d167a44ee6c35beef7e488d) )
	ROM_LOAD16_BYTE( "p3311p71.lo", 0x00001, 0x080000, CRC(2a7ef03f) SHA1(94c8fb7369a61ed69a95cef1904e194bcfe083c3) )
	ROM_LOAD16_BYTE( "p3311s71.hi", 0x00000, 0x080000, CRC(f3a892ce) SHA1(a97c20568bb65442e97ca6761aa0cd80d81f957e) )
	ROM_LOAD16_BYTE( "p3311s71.lo", 0x00001, 0x080000, CRC(e56d477a) SHA1(883d7749d2bd10e53743379eb8b2e0bac7d91098) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009110.bin", 0x0000, 0x100000, CRC(8ec67890) SHA1(ba7f8cd4315a4ca8d2adeedc40c50e9e9a9b38f6) )
	ROM_LOAD( "95009111.bin", 0x0000, 0x100000, CRC(de68000c) SHA1(be69779ccb213a95698c2eafafe1f4a339febc4f) )
ROM_END




ROM_START( sc_mombc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418604.lo", 0x00001, 0x080000, CRC(07c5b10d) SHA1(950d9527bf7a981b36afddab5e6f24391cd55a06) )
	ROM_LOAD16_BYTE( "95418605.hi", 0x00000, 0x080000, CRC(7d64a83e) SHA1(56494f9ad62dd53c6b828a09cb5e5eee39be803f) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890597.bin", 0x0000, 0x5000, CRC(0d24f414) SHA1(85912d9e07995ffd6682d1ef65e4d71090b6584f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_moms )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424616.lo", 0x00001, 0x080000, CRC(ae4363d4) SHA1(f1fa2832f1b2a65bcfa7640d0625e4f7f4708b7b) )
	ROM_LOAD16_BYTE( "95424617.hi", 0x00000, 0x080000, CRC(47e09bd9) SHA1(cea5735ee872a488aac73a3cb3718a06e3ab3cfb) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95424640.lo", 0x00001, 0x080000, CRC(3be74882) SHA1(8cffcdd874da49eebc766922b4b7118b79fe993e) )
	ROM_LOAD16_BYTE( "95424641.hi", 0x00000, 0x080000, CRC(bb291d3b) SHA1(7ae49b2fe2a028389ddd1054f6ee24ddfd5d922f) )
	ROM_LOAD16_BYTE( "95424642.lo", 0x00001, 0x080000, CRC(53d95c00) SHA1(1dedc0fd19c12b4f777b1ce5b09316e61c472e06) )
	ROM_LOAD16_BYTE( "95424643.hi", 0x00000, 0x080000, CRC(24572033) SHA1(6097cbf9de056b0d621696c0b872d8d787c5c329) )
	ROM_LOAD16_BYTE( "95425616.lo", 0x00001, 0x080000, CRC(63d60ce1) SHA1(b4b0af64672f79e7e002a4500cc6ccd4fd677eb7) )
	ROM_LOAD16_BYTE( "95425617.hi", 0x00000, 0x080000, CRC(a4a6129b) SHA1(338613573fc606a52bb7bd856806e28ca156e84f) )
	ROM_LOAD16_BYTE( "95425640.lo", 0x00001, 0x080000, CRC(a33c4242) SHA1(a5b1e7e6affe77895d6662f27690266e02becb3c) )
	ROM_LOAD16_BYTE( "95425641.hi", 0x00000, 0x080000, CRC(4f1772a4) SHA1(acaf47b3e896cf4e624f7dc7df65c10220227e1a) )
	ROM_LOAD16_BYTE( "95425642.lo", 0x00001, 0x080000, CRC(e5158548) SHA1(d120a09553b5d7df1b140139f4d4f999f7e773b5) )
	ROM_LOAD16_BYTE( "95425643.hi", 0x00000, 0x080000, CRC(1f307939) SHA1(b091d3cc55235aa3389d0b3fdc0ca5fa78d13285) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891135.bin", 0x0000, 0x5000, CRC(3fdecc78) SHA1(271699c347bcd2b40282d22f9e1a4e36713845e1) )
	ROM_LOAD( "95891136.bin", 0x0000, 0x5000, CRC(4a48884c) SHA1(d641295cdcc0226c64797d24799d8508ef13f204) )
	ROM_LOAD( "95891137.bin", 0x0000, 0x5000, CRC(d4f24410) SHA1(a35803e69aa8a45d46409baebbcbc20a35c1ac5d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009023.bin", 0x0000, 0x0ffbf6, CRC(a10e8614) SHA1(85fc093f176cb81660717eb84301e9204402e83e) )
ROM_END




ROM_START( sc_mopl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3408p71.hi", 0x00000, 0x080000, CRC(cf33ba2b) SHA1(be9cfb797f3d6983e26be362f108dbefff8b6cf2) )
	ROM_LOAD16_BYTE( "p3408p71.lo", 0x00001, 0x080000, CRC(022074a5) SHA1(88d67b1294621feb1e79461fd0f20c8c6b14e547) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3408p72.hi", 0x00000, 0x080000, CRC(9d8b4f48) SHA1(78eed5283d20fd58f58d773ffc5bf4c709034bd0) )
	ROM_LOAD16_BYTE( "p3408p72.lo", 0x00001, 0x080000, CRC(7f318753) SHA1(99f37daee34a5b69b0245b63425012f2c991f415) )
	ROM_LOAD16_BYTE( "p3408s71.hi", 0x00000, 0x080000, CRC(b630cc98) SHA1(b03b222afc4657b22f5ff0ae7c054de799d642ff) )
	ROM_LOAD16_BYTE( "p3408s71.lo", 0x00001, 0x080000, CRC(9ec19fc1) SHA1(17f90b4b8077c69c0c549b4c7a07e9eb8209200a) )
	ROM_LOAD16_BYTE( "p3408s72.hi", 0x00000, 0x080000, CRC(1e0bc7d6) SHA1(9b999e9be6ecc6b1557ea755928af421046776c4) )
	ROM_LOAD16_BYTE( "p3408s72.lo", 0x00001, 0x080000, CRC(bc529040) SHA1(7262ca69f8fb1e7301d6af73eb44518dedfdb59b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_mor2r )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424484.lo", 0x00001, 0x080000, CRC(9e1253c8) SHA1(5d3387e21bb22e68babe2ba5ee5cd0087d9d3af7) )
	ROM_LOAD16_BYTE( "95424485.hi", 0x00000, 0x080000, CRC(535b57dc) SHA1(a505731f4fd541501da192f6df6dee1548855416) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425484.lo", 0x00001, 0x080000, CRC(443db88e) SHA1(d3e7702c7d588e0862c68afbc0d3ac8284b9ccbb) )
	ROM_LOAD16_BYTE( "95425485.hi", 0x00000, 0x080000, CRC(66220c17) SHA1(ffb645b0c2ecedf2a328fd3b1a1f95b538d359e1) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891090.bin", 0x0000, 0x5000, CRC(a5009c47) SHA1(38b08c39ded1f1baef8a01373f19694b49d032b7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009004.bin", 0x0000, 0x0ffe87, CRC(2403a082) SHA1(cd69739b2249724e3a88ea1c0b61151aeae0ea01) )
ROM_END




ROM_START( sc_mowow )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414676.lo", 0x00001, 0x080000, CRC(7ffcefa9) SHA1(45ef8f4e378fc0f88c1a650532204a4ba2423a5c) )
	ROM_LOAD16_BYTE( "95414677.hi", 0x00000, 0x080000, CRC(c4570e36) SHA1(b118f50b6772fd47c32d2a4e674dcb0e46433b82) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95414678.lo", 0x00001, 0x080000, CRC(550e1901) SHA1(764f36e8d1e01fd8fb8af70ae4ab4c61936e1de8) )
	ROM_LOAD16_BYTE( "95414679.hi", 0x00000, 0x080000, CRC(b307c478) SHA1(7735ee8b9d2dfd44f7b923135e60c9722c029fe7) )
	ROM_LOAD16_BYTE( "95415676.lo", 0x00001, 0x080000, CRC(d4a44d31) SHA1(1a703881c57aca72a0431ea904886a083314f770) )
	ROM_LOAD16_BYTE( "95415677.hi", 0x00000, 0x080000, CRC(a44de5cf) SHA1(39afc96e8ca3e6af2930985446925bacc277b28f) )
	ROM_LOAD16_BYTE( "95415678.lo", 0x00001, 0x080000, CRC(e0df72ff) SHA1(c47956af13a748836e846495803d603444534633) )
	ROM_LOAD16_BYTE( "95415679.hi", 0x00000, 0x080000, CRC(009fe160) SHA1(d42230def9749660638c0f2422208b4cb49ba761) )
	ROM_LOAD16_BYTE( "95416144.lo", 0x00001, 0x080000, CRC(7d4ed381) SHA1(1ec73ffe04a4ae4fc35bc3e3b74fd98e2e0ad03e) )
	ROM_LOAD16_BYTE( "95418076.lo", 0x00001, 0x080000, CRC(3a1340cd) SHA1(5567323e42a0e87abeae9a2f4433d9b64af145e9) )
	ROM_LOAD16_BYTE( "95418077.hi", 0x00000, 0x080000, CRC(73abe57d) SHA1(82deeb7a88346ad8e16e52feeb9ac81e7650b569) )
	ROM_LOAD16_BYTE( "95418078.lo", 0x00001, 0x080000, CRC(73044155) SHA1(f86e25c7c02f65e2f99b3e7b3b7192d2b5fc0b54) )
	ROM_LOAD16_BYTE( "95418079.hi", 0x00000, 0x080000, CRC(1d260113) SHA1(834fec1e07e9a2f59adbb052e51dc03493dcee9e) )
	ROM_LOAD16_BYTE( "95419076.lo", 0x00001, 0x080000, CRC(117f4e3e) SHA1(dd712361d05ad34d58b892a3fe98e057adf14a23) )
	ROM_LOAD16_BYTE( "95419077.hi", 0x00000, 0x080000, CRC(c67ba8dd) SHA1(bd14783c59f745f2be929fa9b217563916d8a585) )
	ROM_LOAD16_BYTE( "95419078.lo", 0x00001, 0x080000, CRC(9205e5fb) SHA1(e77062edcc51e44612c558ee593028934835a41d) )
	ROM_LOAD16_BYTE( "95419079.hi", 0x00000, 0x080000, CRC(f80fae88) SHA1(c483f89204489775458112d7ed34ad778d3c9e71) )
	ROM_LOAD16_BYTE( "95424056.lo", 0x00001, 0x080000, CRC(255586e1) SHA1(caa32b86ab5f726174bb45402a015e2ae1b6ff68) )
	ROM_LOAD16_BYTE( "95424057.hi", 0x00000, 0x080000, CRC(be45b2b1) SHA1(5d17963f705f8bcaa7a93af2c2621677a57ef039) )
	ROM_LOAD16_BYTE( "95424214.lo", 0x00001, 0x080000, CRC(a8b93c99) SHA1(83e6fa6751634f64d285ba6f93b8d52690c17d4a) )
	ROM_LOAD16_BYTE( "95424215.hi", 0x00000, 0x080000, CRC(05c523d6) SHA1(558031df5270567ca2bd88a389b33cfae34b7967) )
	ROM_LOAD16_BYTE( "95424512.lo", 0x00001, 0x080000, CRC(14b7ef71) SHA1(675345c95d2a68d1b3092d564a9c6192a7390486) )
	ROM_LOAD16_BYTE( "95424513.hi", 0x00000, 0x080000, CRC(dd7c5383) SHA1(fad0cbba52a5c2746d325f437f9d85bee5776201) )
	ROM_LOAD16_BYTE( "95425056.lo", 0x00001, 0x080000, CRC(b2c7fe92) SHA1(00e27916482a5fcabde46da8e139b49f789837a8) )
	ROM_LOAD16_BYTE( "95425057.hi", 0x00000, 0x080000, CRC(8946e5d6) SHA1(1426c7ea7ded18b03bab7b08d0d13021bc8aa75b) )
	// 95425512.lo = 95425512.lo           sc4dndpg   Deal Or No Deal The Perfect Game (Bellfruit) (Scorpion 4)
	// 95425513.hi = 95425513.hi           sc4dndpg   Deal Or No Deal The Perfect Game (Bellfruit) (Scorpion 4)

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211346.bin", 0x0000, 0x511188, CRC(2dc41c91) SHA1(36fe572860e8bba1b8f9e0245ab6fb93ff75d3ad) )
	ROM_LOAD( "39211350.bin", 0x0000, 0x4a746f, CRC(55e3d72e) SHA1(ca793fc2fb603e12feed0869dbb53d6e2a820a76) )
	ROM_LOAD( "39211356.bin", 0x0000, 0x4a74b7, CRC(8d5b75ab) SHA1(17740100c5df334bc69a690faea39c3a97afc623) )
	ROM_LOAD( "39211508.bin", 0x0000, 0x646fd1, CRC(9e405c5a) SHA1(19598d11756fece575785bb75dd620e333b6877b) )
	ROM_LOAD( "39211509.bin", 0x0000, 0x646781, CRC(669da0d0) SHA1(e34bcd6cbb21e07e42e274c30126dd536ead908d) )
	ROM_LOAD( "39212346.bin", 0x0000, 0x511188, CRC(40e92995) SHA1(9911761b89a73156b592567385ef61f609ac40dd) )
	ROM_LOAD( "39212350.bin", 0x0000, 0x4a746f, CRC(8dd8926d) SHA1(5beee9809c4c7292c8edb410eb748b43550c19d9) )
	ROM_LOAD( "39212356.bin", 0x0000, 0x4a74b7, CRC(15a8bb77) SHA1(4a8a2f50d832ce6d3230e76e4164a0bde041ccd4) )
	ROM_LOAD( "39212508.bin", 0x0000, 0x646fcd, CRC(811c9e4c) SHA1(34b59d319d80f45c238aca9f3ec536047427cfb3) )
	ROM_LOAD( "39212509.bin", 0x0000, 0x646781, CRC(637a930a) SHA1(4ad90e242701b3beef5209e967795d632c5d39a4) )

	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890712.bin", 0x0000, 0x5000, CRC(ec6db00b) SHA1(d16a1527caa3c115e3326c897ce0fa66e3a0420d) )
	ROM_LOAD( "95890713.bin", 0x0000, 0x5000, CRC(f0bb40b7) SHA1(33c19dab3086cdeae4f503fbf3f3cc5f0dad98c4) )
	ROM_LOAD( "95890714.bin", 0x0000, 0x5000, CRC(33e16227) SHA1(87efc1a046ef6af0b72cc76a6ee393a4d1ddbce3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008550.bin", 0x0000, 0x100000, CRC(db6343bf) SHA1(e4d702020af67aa5be0560027706c1cbf34296fa) )
	ROM_LOAD( "95008551.bin", 0x0000, 0x100000, CRC(2d89a52a) SHA1(244101df7f6beae545f9b823750f908f532ac1e4) )
	ROM_LOAD( "95008850.bin", 0x0000, 0x0af41f, CRC(8ca16e09) SHA1(9b494ad6946c2c7bbfad6591e62fa699fd53b6dc) )
	ROM_LOAD( "95008869.bin", 0x0000, 0x0b9d9d, CRC(f3ef3bbb) SHA1(92f9835e96c4fc444a451e97b2b8a7b66e5794b7) )

	ROM_REGION( 0x400000, "others", ROMREGION_ERASE00 )
	ROM_LOAD( "95416144.bin", 0x0000, 0x100000, CRC(580447a3) SHA1(c923001656b46771dd4a387db19eca614df2eb5e) ) // combined
ROM_END




ROM_START( sc_monwa )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424588.lo", 0x00001, 0x080000, CRC(55a1a299) SHA1(483d0fcaf17acc5e6911acd1410f660fddbb8f70) )
	ROM_LOAD16_BYTE( "95424589.hi", 0x00000, 0x080000, CRC(409a7d42) SHA1(599affd706d261f2d3cafd52a3701407d47dde7b) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425588.lo", 0x00001, 0x080000, CRC(6f7f5a26) SHA1(8fa14415d94089d7cc1d0dc0bd20d7e766c9ec5b) )
	ROM_LOAD16_BYTE( "95425589.hi", 0x00000, 0x080000, CRC(3ebe5f6a) SHA1(e4fdd750d81e06a6cd064980d0dac840013bad4f) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891094.bin", 0x0000, 0x5000, CRC(a241259b) SHA1(94dfcc7371593d983c8b62dba085b3ec51a33ed1) )
	ROM_LOAD( "95891095.bin", 0x0000, 0x5000, CRC(d7d761af) SHA1(a7adda6fe7bcec0f40587273a9a1d16a220f400a) )
	ROM_LOAD( "95891096.bin", 0x0000, 0x5000, CRC(496dadf3) SHA1(997f91c4c96b8971cc3ccfcaaaa42af6aac42ddd) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008010.bin", 0x0000, 0x0d5d57, CRC(1a75f403) SHA1(3bb5ca732d27aa4b8a2c96945be7e32c2abfe1c4) )
ROM_END




ROM_START( sc_cmcob )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424608.lo", 0x00001, 0x080000, CRC(277b6ac5) SHA1(834a18b67728774aece6595cc57fb00917f826d8) )
	ROM_LOAD16_BYTE( "95424609.hi", 0x00000, 0x080000, CRC(f4ef6f33) SHA1(4b70c86845f8761784e3703e608ff081968bb632) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95424610.lo", 0x00001, 0x080000, CRC(41fa3ebf) SHA1(2386f28741feb2c11edba5a34199ec926e63010d) )
	ROM_LOAD16_BYTE( "95424611.hi", 0x00000, 0x080000, CRC(c9a25750) SHA1(ad0c6f534b59b593a3a7ae9389d0f57f7147b7d7) )
	ROM_LOAD16_BYTE( "95425608.lo", 0x00001, 0x080000, CRC(26093186) SHA1(cb8343804cb5bc932dfb6f256bc80e07fabc7dd7) )
	ROM_LOAD16_BYTE( "95425609.hi", 0x00000, 0x080000, CRC(57ea57fd) SHA1(a5dae0e11f0aaa170a8e288116fe8f5440cad5af) )
	ROM_LOAD16_BYTE( "95425610.lo", 0x00001, 0x080000, CRC(fa6d1e11) SHA1(85449a56c05c6a14dab609a9cc3ebea5f4c2d614) )
	ROM_LOAD16_BYTE( "95425611.hi", 0x00000, 0x080000, CRC(00a16611) SHA1(8b7eb5ad71e6ab76f1ed0f6fc82dbbad76455052) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891127.bin", 0x0000, 0x5000, CRC(7e7d858c) SHA1(8fe2b07275ad36ae80149e091582f729c8a1d240) )
	ROM_LOAD( "95891128.bin", 0x0000, 0x5000, CRC(acfcec9c) SHA1(270b9ae893016d6272f599fa29402d911650b85f) )
	ROM_LOAD( "95891129.bin", 0x0000, 0x5000, CRC(c7299792) SHA1(f6279d507091d257a74b2419ec883c363b3c548f) )
	ROM_LOAD( "95891130.bin", 0x0000, 0x5000, CRC(15a8fe82) SHA1(7fb448b5559d8248a302b7b0cfaa7dfa07dc16dd) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009021.bin", 0x0000, 0x0ff73b, CRC(068c715c) SHA1(25f80da3b548b9b0b6331d402d732a312985993b) )
ROM_END




ROM_START( sc_mcob )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211513.bin", 0x0000, 0x9ad06f, CRC(195c3690) SHA1(0fe72c20fb80c8c1430ddb6aac056be77af9ec24) )
	ROM_LOAD( "39211516.bin", 0x0000, 0x9af0eb, CRC(ef35489e) SHA1(c5d71130ddd8bdb86b45b075bd929ec2eaebeded) )
	ROM_LOAD( "39212513.bin", 0x0000, 0x9ad06f, CRC(0f25723f) SHA1(10cb91accac8a7e5da55e4511e6cffe4164f5314) )
	ROM_LOAD( "39212516.bin", 0x0000, 0x9af0eb, CRC(0b6faf76) SHA1(e9a1158911b8a474acf3b0abe4856aaa406800ca) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009011.bin", 0x0000, 0x0ff73b, CRC(9f6e0643) SHA1(d0f76b8a45aef2dd42939f1fca7b010637aaabe1) )
ROM_END




ROM_START( sc_nunsb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420446.lo", 0x00001, 0x080000, CRC(27a45977) SHA1(1e15a814fc99f4d749929f569b61f1e241cf8f91) )
	ROM_LOAD16_BYTE( "95420447.hi", 0x00000, 0x080000, CRC(b8a8fb4f) SHA1(e7792a60355f3b5ebb03b71ea1009b982ba4fab5) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_nunsm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416074.lo", 0x00001, 0x080000, CRC(4da36836) SHA1(1a14c21e67047714817cd8f7c2050b3f018b4deb) )
	ROM_LOAD16_BYTE( "95416075.hi", 0x00000, 0x080000, CRC(d84cb53c) SHA1(f90d71bedb95450c5eea37dc64775d5b93ae7ab2) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416246.lo", 0x00001, 0x080000, CRC(a7e086c5) SHA1(3597c442c3416a17e96b548b32ec503e17c74db4) )
	ROM_LOAD16_BYTE( "95416247.hi", 0x00000, 0x080000, CRC(325706fa) SHA1(f888358e6632a339d7a5a159b78e6da556d649f7) )
	ROM_LOAD16_BYTE( "95416248.lo", 0x00001, 0x080000, CRC(c5370071) SHA1(c35592b712123b7e1d03e52af19deddd69830f3d) )
	ROM_LOAD16_BYTE( "95416249.hi", 0x00000, 0x080000, CRC(6c3ab635) SHA1(233ff1dd70628318ee5ba5dee5e3d46098237b95) )
	ROM_LOAD16_BYTE( "95416682.lo", 0x00001, 0x080000, CRC(bc930119) SHA1(208ea184e634c054c67a03d7644539a1d59462e5) )
	ROM_LOAD16_BYTE( "95416683.hi", 0x00000, 0x080000, CRC(efb0ccf4) SHA1(2ff450b788050bb22e874b833903e09fb88aedf3) )
	ROM_LOAD16_BYTE( "95416686.lo", 0x00001, 0x080000, CRC(2f17e640) SHA1(02407a7ae7e3a888ede0fbafbbf1b5043d7eb191) )
	ROM_LOAD16_BYTE( "95416687.hi", 0x00000, 0x080000, CRC(433fddea) SHA1(429e35116e2032eb4b2ecea64c183e93aa46cee1) )
	ROM_LOAD16_BYTE( "95417074.lo", 0x00001, 0x080000, CRC(9688de66) SHA1(e53a5225a37e0c22872be7f4613caafce752019e) )
	ROM_LOAD16_BYTE( "95417075.hi", 0x00000, 0x080000, CRC(69ae75e2) SHA1(506231981495cb432320373a81855843272cfe18) )
	ROM_LOAD16_BYTE( "95417246.lo", 0x00001, 0x080000, CRC(04698eb1) SHA1(2250fb9c958b4b00c389878fb86a4056e6740c52) )
	ROM_LOAD16_BYTE( "95417247.hi", 0x00000, 0x080000, CRC(53ec174b) SHA1(2a327f14216c01b55455b52136fc65e1ccf65e40) )
	ROM_LOAD16_BYTE( "95417248.lo", 0x00001, 0x080000, CRC(f74a405c) SHA1(2fe594da8728b4b5c80b3bca7f7cc8cde2af8ee4) )
	ROM_LOAD16_BYTE( "95417249.hi", 0x00000, 0x080000, CRC(9e651623) SHA1(ad65aa765ff06c72ce0b6c5f647127b1f8744731) )
	ROM_LOAD16_BYTE( "95417682.lo", 0x00001, 0x080000, CRC(6f3e9dd3) SHA1(ac97685f0c964f888c7a457e8cab50282283f2eb) )
	ROM_LOAD16_BYTE( "95417683.hi", 0x00000, 0x080000, CRC(948156dc) SHA1(76db7472c8e86a8f682a2954b3e54e7b487d12b9) )
	ROM_LOAD16_BYTE( "95417686.lo", 0x00001, 0x080000, CRC(8b591c8a) SHA1(a0a7dc03e64d372265060763f5a40af33507b563) )
	ROM_LOAD16_BYTE( "95417687.hi", 0x00000, 0x080000, CRC(9170602e) SHA1(6bf20fcb3ec33c2220dba527724579741b5fb584) )
	ROM_LOAD16_BYTE( "95420446.lo", 0x00001, 0x080000, CRC(27a45977) SHA1(1e15a814fc99f4d749929f569b61f1e241cf8f91) )
	ROM_LOAD16_BYTE( "95420447.hi", 0x00000, 0x080000, CRC(b8a8fb4f) SHA1(e7792a60355f3b5ebb03b71ea1009b982ba4fab5) )
	ROM_LOAD16_BYTE( "95420448.lo", 0x00001, 0x080000, CRC(70b450f6) SHA1(e93838749b78a44fa65c0164f567efe75a80c663) )
	ROM_LOAD16_BYTE( "95420449.hi", 0x00000, 0x080000, CRC(13825de0) SHA1(5621494c10518df79c577b33847e5eefe8f814d0) )
	ROM_LOAD16_BYTE( "95420450.lo", 0x00001, 0x080000, CRC(3c44ed83) SHA1(48c7d7103d9dfb4df6a77c4f8336b4503bafb54f) )
	ROM_LOAD16_BYTE( "95420451.hi", 0x00000, 0x080000, CRC(abf2e2f4) SHA1(65087fe900e517904686524d1e150faf8998378a) )
	ROM_LOAD16_BYTE( "95421446.lo", 0x00001, 0x080000, CRC(73d6847d) SHA1(5886ee6c2154173a9fa0e62bbae70af2c885f56d) )
	ROM_LOAD16_BYTE( "95421447.hi", 0x00000, 0x080000, CRC(a24ee8d9) SHA1(cdef31a0a0a284bc2d6ccc44d88714ba0702bf17) )
	ROM_LOAD16_BYTE( "95421448.lo", 0x00001, 0x080000, CRC(91cdeb5d) SHA1(7b99f39023f7b9b1d02bc38b2388165025ab68dc) )
	ROM_LOAD16_BYTE( "95421449.hi", 0x00000, 0x080000, CRC(0343ab8c) SHA1(1791c6ae18d48fae9446d6f54885ab657c471b28) )
	ROM_LOAD16_BYTE( "95421450.lo", 0x00001, 0x080000, CRC(484f1622) SHA1(7508450f44be2f60c3a2fc8a02fc7b582cd9f5dc) )
	ROM_LOAD16_BYTE( "95421451.hi", 0x00000, 0x080000, CRC(ef9625c4) SHA1(2345da679113c7a245ad1e18b93a70d030e4fcc7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008522.bin", 0x0000, 0x0f9907, CRC(df612d06) SHA1(cbca56230c4ad4c6411aa5c2e2ca2ae8152b5297) )
ROM_END




ROM_START( sc_onup )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95406964.lo", 0x00001, 0x080000, CRC(cca9a87b) SHA1(e761060a55b65dbc4a4b46ccac60c5727f15a03d) )
	ROM_LOAD16_BYTE( "95406965.hi", 0x00000, 0x080000, CRC(644f49a7) SHA1(744f0d217d4d5cb221b8414c8292042595f01b88) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95407964.lo", 0x00001, 0x080000, CRC(c40c37b9) SHA1(4f41062ee1c487ecd0c5e8b2d26b814e3cf860c7) )
	ROM_LOAD16_BYTE( "95407965.hi", 0x00000, 0x080000, CRC(90a9802d) SHA1(05090cadc227904e159537ba9792956e2799a30b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008298.bin", 0x0000, 0x100000, CRC(6dcdcbfa) SHA1(1742f54ddd74d7513e8efb8cecfff574263c65df) )
ROM_END




ROM_START( sc_rainb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3315p71.hi", 0x00000, 0x080000, CRC(3afa32d9) SHA1(8e3005715388fceb3c1deba02d78433ddd838f0f) )
	ROM_LOAD16_BYTE( "p3315p71.lo", 0x00001, 0x080000, CRC(67d8604e) SHA1(ecdb9e296a3daf89c2309ca9544f4f0bb845b710) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3315p72.hi", 0x00000, 0x080000, CRC(29bed5f5) SHA1(e33cc0dd671c2dd14ac7ed639c9b4cb71b8a1906) )
	ROM_LOAD16_BYTE( "p3315p72.lo", 0x00001, 0x080000, CRC(81b3d9b0) SHA1(fde847ea6c27ce823cc04c90889a1bfa62a21e5e) )
	ROM_LOAD16_BYTE( "p3315p73.hi", 0x00000, 0x080000, CRC(f8a3f3aa) SHA1(7ef80e13ad44b01cede0d5ff347ae041a8b90db2) )
	ROM_LOAD16_BYTE( "p3315p73.lo", 0x00001, 0x080000, CRC(66e9ca49) SHA1(413c9035b9bc59c915c54ce976d78d8ccac95a39) )
	ROM_LOAD16_BYTE( "p3315s71.hi", 0x00000, 0x080000, CRC(19bc7f67) SHA1(905640b12821cfb2d367f33e1878660b1368b275) )
	ROM_LOAD16_BYTE( "p3315s71.lo", 0x00001, 0x080000, CRC(f1dd2f9e) SHA1(5b75afdcdefbd29380d320980a1cf48bb8aa3a01) )
	ROM_LOAD16_BYTE( "p3315s72.hi", 0x00000, 0x080000, CRC(9162a00e) SHA1(79965056fbb9be15a3c7cd6eaac578d41ce84d2e) )
	ROM_LOAD16_BYTE( "p3315s72.lo", 0x00001, 0x080000, CRC(ee57ffd7) SHA1(85ee352f6d116abb6cbb41c790599b2d3a0d6563) )
	ROM_LOAD16_BYTE( "p3315s73.hi", 0x00000, 0x080000, CRC(3c4d9c5d) SHA1(c71792e08a5b5acad008d7119e0f889e04ee3a2f) )
	ROM_LOAD16_BYTE( "p3315s73.lo", 0x00001, 0x080000, CRC(5e8937b6) SHA1(8f2f315dff57b35643f6d62b7ae9a106f1dbc0ca) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009122.bin", 0x0000, 0x100000, CRC(7197027f) SHA1(216e43135c00452556ad5e7647891f14641840ed) )
	ROM_LOAD( "95009123.bin", 0x0000, 0x100000, CRC(3454f17d) SHA1(fc45d2653a0f260702a94663939b0d0176fc1c87) )
ROM_END




ROM_START( sc_parot )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3015p71.hi", 0x00000, 0x080000, CRC(6ab7bcd2) SHA1(7ee059789b5641f6a8da47a0e29ef15a1beecd8b) )
	ROM_LOAD16_BYTE( "p3015p71.lo", 0x00001, 0x080000, CRC(d62a090c) SHA1(a9bb1fd33fd08c525998c9c0153c8078c776a079) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3015p72.hi", 0x00000, 0x080000, CRC(a1e66876) SHA1(ec055df597b12af05d1fbb84e1c1876219e514be) )
	ROM_LOAD16_BYTE( "p3015p72.lo", 0x00001, 0x080000, CRC(aca9f8c5) SHA1(036c9ac8cead65ccb1703b6f8645d7beb4de6cff) )
	ROM_LOAD16_BYTE( "p3015p73.hi", 0x00000, 0x080000, CRC(375f895f) SHA1(799bd79e96ec9c06ba5724692b4d216cc2d02a02) )
	ROM_LOAD16_BYTE( "p3015p73.lo", 0x00001, 0x080000, CRC(61b727dc) SHA1(ba79d7c2654d56e7031e18397171a72663581820) )
	ROM_LOAD16_BYTE( "p3015p74.hi", 0x00000, 0x080000, CRC(59d0b3c1) SHA1(e730d43a9640e8aceb0938c90ba5748eaba2e8b0) )
	ROM_LOAD16_BYTE( "p3015p74.lo", 0x00001, 0x080000, CRC(8e03fbc2) SHA1(6ad244ca0c92fb526e3280b105085f080c7613bf) )
	ROM_LOAD16_BYTE( "p3015s71.hi", 0x00000, 0x080000, CRC(10b8b141) SHA1(a2ba6e19bc888978d4b147e1c477834e9c56380c) )
	ROM_LOAD16_BYTE( "p3015s71.lo", 0x00001, 0x080000, CRC(9fed58a3) SHA1(439b0cd9cb2ee676c826c5f33f31f26284560dc0) )
	ROM_LOAD16_BYTE( "p3015s72.hi", 0x00000, 0x080000, CRC(68474982) SHA1(75b31cc8e17d69e68443b4507be009c76960dead) )
	ROM_LOAD16_BYTE( "p3015s72.lo", 0x00001, 0x080000, CRC(9de37289) SHA1(c5253437707dce1cfe0b785d6340dcda006875cc) )
	ROM_LOAD16_BYTE( "p3015s73.hi", 0x00000, 0x080000, CRC(27695902) SHA1(f2793cbc14e742e1fa15c9dc0ab773b7d2689f57) )
	ROM_LOAD16_BYTE( "p3015s73.lo", 0x00001, 0x080000, CRC(d5a5a816) SHA1(43027cf4d341b63f345aac19b8c60258142349dd) )
	ROM_LOAD16_BYTE( "p3015s74.hi", 0x00000, 0x080000, CRC(1ac7be89) SHA1(e0e7d49b833438f5f168d8a600da0946c29890db) )
	ROM_LOAD16_BYTE( "p3015s74.lo", 0x00001, 0x080000, CRC(81e4fede) SHA1(2643ac419a55950d8e909888b0c856a00ecdebda) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008736.bin", 0x0000, 0x100000, CRC(148a7600) SHA1(d57f4a667151e78715d617b3d1e963d29d83b538) )
	ROM_LOAD( "95008737.bin", 0x0000, 0x100000, CRC(4e61167f) SHA1(6faa7a395bd2d9067b88a9c9c365198ea26ebb39) )
ROM_END




ROM_START( sc_phgcl )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412964.lo", 0x00001, 0x080000, CRC(2251829c) SHA1(9daf30ddc112830413d8bbff36a291b6aeb8f72a) )
	ROM_LOAD16_BYTE( "95412965.hi", 0x00000, 0x080000, CRC(18e529c0) SHA1(62484b51db99e74f6d8d6d9b985060d4eabf91ec) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95412966.lo", 0x00001, 0x080000, CRC(50ef0337) SHA1(4f4873ec66e47d2060aef8a09df594ea4500e803) )
	ROM_LOAD16_BYTE( "95412967.hi", 0x00000, 0x080000, CRC(620e019e) SHA1(4f5c8359f64c3cf83fc34e6469416941415d1e3b) )
	ROM_LOAD16_BYTE( "95413964.lo", 0x00001, 0x080000, CRC(53831eb9) SHA1(3aeaf4025dc45d35740f058f58bb838d7299b317) )
	ROM_LOAD16_BYTE( "95413965.hi", 0x00000, 0x080000, CRC(512227b5) SHA1(a12339903414e3e5953b9e7b4dd6ccec8201b250) )
	ROM_LOAD16_BYTE( "95413966.lo", 0x00001, 0x080000, CRC(65685e8b) SHA1(5c40712e732e8d4d3604fbdc301b2db71672d4ce) )
	ROM_LOAD16_BYTE( "95413967.hi", 0x00000, 0x080000, CRC(836bf5ca) SHA1(685b6a80012b54816ede5529f45e65c4f19d302f) )
	ROM_LOAD16_BYTE( "95418058.lo", 0x00001, 0x080000, CRC(1e38ff3d) SHA1(063d0c400b76315bc188b017fd425a1cb505aaa9) )
	ROM_LOAD16_BYTE( "95418059.hi", 0x00000, 0x080000, CRC(53500791) SHA1(00d2b6a0e3a249fb757cde5f88d65db33728cccd) )
	ROM_LOAD16_BYTE( "95419058.lo", 0x00001, 0x080000, CRC(2762e348) SHA1(b53c95475d56af25b80cadf780df41b3df648920) )
	ROM_LOAD16_BYTE( "95419059.hi", 0x00000, 0x080000, CRC(6c0faf2d) SHA1(5f3a2ba0422fc7f76577994f0c965f2461511ae2) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008475.bin", 0x0000, 0x100000, CRC(30f77b7e) SHA1(bbb16020f33c8440344670beec8b13dd554be858) )
ROM_END




ROM_START( sc_pilep )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424364.lo", 0x00001, 0x080000, CRC(ad9e0f59) SHA1(1d91f49b5de6a5982f1977b9fa28487b1ceaac43) )
	ROM_LOAD16_BYTE( "95424365.hi", 0x00000, 0x080000, CRC(d5bdf417) SHA1(5995cdc20678c2acec855f6281bd949c5236446d) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95424384.lo", 0x00001, 0x080000, CRC(abe8bb2b) SHA1(442574ec1fe73f7e24a76af349d5de5ec785e568) )
	ROM_LOAD16_BYTE( "95424385.hi", 0x00000, 0x080000, CRC(46ae0592) SHA1(9a896a1acca28cd5e877165ab96d485ed1953e7f) )
	ROM_LOAD16_BYTE( "95425364.lo", 0x00001, 0x080000, CRC(d6c32f2b) SHA1(ef5e77b543d8a61ac231902e121634bfcb46df94) )
	ROM_LOAD16_BYTE( "95425365.hi", 0x00000, 0x080000, CRC(b33b86ed) SHA1(5efa3e4ed34cbfe85b38d7b4c90221b11a719304) )
	ROM_LOAD16_BYTE( "95425384.lo", 0x00001, 0x080000, CRC(92db0e3f) SHA1(7c61beb88f615042a94fa993df6bbce4ed11db9b) )
	ROM_LOAD16_BYTE( "95425385.hi", 0x00000, 0x080000, CRC(49b9b0fe) SHA1(5adf034e4baac642d7b4f2c1fb385895ee37a185) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891066.bin", 0x0000, 0x5000, CRC(c058097e) SHA1(f6940ac1fe02498d13d62bd4318fd7445880c9a9) )
	ROM_LOAD( "95891067.bin", 0x0000, 0x5000, CRC(b5ce4d4a) SHA1(918009698696ce6bd9d0d68b4dc3e4234ff552bb) )
	ROM_LOAD( "95891068.bin", 0x0000, 0x5000, CRC(2b748116) SHA1(f6100c3ce79b4456d2f7fcda8e48734aad48141c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008892.bin", 0x0000, 0x0fe398, CRC(e59abfb2) SHA1(fbe9ec614774a46f93ffb3ef9b8d4ee430d0aeed) )
ROM_END




ROM_START( sc_ppbtb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211324.bin", 0x0000, 0x565596, CRC(0d58ec3b) SHA1(3cbbd08fc182ec425e51f73a1434591a56ce514b) )
	ROM_LOAD( "39211327.bin", 0x0000, 0x5651c6, CRC(535d29fd) SHA1(a9f1822a8b3ac5eb501dbe957c354f5d29361d4b) )
	ROM_LOAD( "39212324.bin", 0x0000, 0x565426, CRC(3891535d) SHA1(54b1ae18da66a4c91f3c40f9819dc6d93ddd3177) )
	ROM_LOAD( "39212327.bin", 0x0000, 0x5651c6, CRC(3091ec62) SHA1(a14fe3bafc3b3a716209f18860f76e2d2d0a3a0e) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890416.bin", 0x0000, 0x5000, CRC(2becd79f) SHA1(e87c668c651adf55c234aaa2f9d8a0ed66792356) )
	ROM_LOAD( "95890417.bin", 0x0000, 0x5000, CRC(373a2723) SHA1(61795c8e22e97903f0a4388b3aff6db3ca3af981) )
	ROM_LOAD( "95890418.bin", 0x0000, 0x5000, CRC(f46005b3) SHA1(58b6369c0a9414f8ccf16ccbe05adfa47c188e1b) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_pking )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211031.bin", 0x0000, 0x1000000, CRC(ec68ef4b) SHA1(2f00afa1ac3b6776f9e8cb44e861d572025c72b2) )
//  ROM_LOAD( "39211031.txt", 0x0000, 0x0000d0, CRC(05e5443e) SHA1(2cbfa749b976c733195ddfc1afd715d0e97963fa) )
	ROM_LOAD( "39212031.bin", 0x0000, 0x1000000, CRC(08811e4d) SHA1(983c39b09ad3d33546a9873e1d77dd6be50b9b2e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008495.bin", 0x0000, 0x080000, CRC(dac8c4a8) SHA1(0192e1d2b9558a789753a5e58d97503cc09dfa27) )
ROM_END




ROM_START( sc_potsm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95420312.lo", 0x00001, 0x080000, CRC(b33457b9) SHA1(0815848437e222348b306179401434b4769af857) )
	ROM_LOAD16_BYTE( "95420313.hi", 0x00000, 0x080000, CRC(522510fc) SHA1(778ca15b46d04bf1a0f378b554e21855a1ceaabe) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95421312.lo", 0x00001, 0x080000, CRC(f86d79c8) SHA1(028a9b97480e34148ceecad948dda1c21a242a8a) )
	ROM_LOAD16_BYTE( "95421313.hi", 0x00000, 0x080000, CRC(10329d84) SHA1(b0e5b34bc1b5f1a5a5462d29ef8bcb71791b737e) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008966.bin", 0x0000, 0x0ff8c9, CRC(1cc159e9) SHA1(f7f5a027806c561825656c5741166e0893a30b10) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890443.bin", 0x0000, 0x5000, CRC(d6ee4a71) SHA1(f638c1e150ae089533ea43ca66010cb7190eb646) )
	ROM_LOAD( "95890444.bin", 0x0000, 0x5000, CRC(a3780e45) SHA1(4babae846051a0199f0e0baa6de0c7b16c73a185) )
	ROM_LOAD( "95890445.bin", 0x0000, 0x5000, CRC(3dc2c219) SHA1(acad92fd6d5112a5366b609761fbd2907bbce91a) )
ROM_END




ROM_START( sc_cpen1 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95427906.lo", 0x00001, 0x080000, CRC(05e73940) SHA1(5adc5f705f444f25af450d89f8cf02c4855fe3d0) )
	ROM_LOAD16_BYTE( "95427907.hi", 0x00000, 0x080000, CRC(2b5a0958) SHA1(2aafb88fc8ef5d559926cd91d6ef50cb438646a5) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95426906.lo", 0x00001, 0x080000, CRC(17d2a36d) SHA1(44216b05445c7b9d4298411806487168f0325668) )
	ROM_LOAD16_BYTE( "95426907.hi", 0x00000, 0x080000, CRC(2c26de1b) SHA1(3307980fca15ee2ad8756fd294d2da5bbbf3e7ae) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009057.bin", 0x0000, 0x100000, CRC(7b83611b) SHA1(6163ab8e848f019190af446710b31e3516386c57) )
	ROM_LOAD( "95009058.bin", 0x0000, 0x100000, CRC(43858a26) SHA1(fdb831e6a2ba161e72883100c22e2e9eee335fe6) )
ROM_END




ROM_START( sc_qual )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95408562.lo", 0x00001, 0x080000, CRC(511eca10) SHA1(233cd773eb2dcf4e73399b734ed69d2696eb5c85) )
	ROM_LOAD16_BYTE( "95408563.hi", 0x00000, 0x080000, CRC(12424475) SHA1(48dd42f82b399ec5eb135b7e992ec23204c82fc5) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95409562.lo", 0x00001, 0x080000, CRC(fce0df75) SHA1(41829416ebfc2d0abcf253bedd7b7034eb37ebeb) )
	ROM_LOAD16_BYTE( "95409563.hi", 0x00000, 0x080000, CRC(45e450b3) SHA1(e92daad5e0dee68b52b7689c90c10acb5165cbc5) )
	ROM_LOAD16_BYTE( "95410402.lo", 0x00001, 0x080000, CRC(c2fcfab1) SHA1(b063655aa025513e147928f2bb785a306069fd41) )
	ROM_LOAD16_BYTE( "95410403.hi", 0x00000, 0x080000, CRC(11653865) SHA1(9853ffd6106bec26e36cfd2ee2c9afe7f1a8c204) )
	ROM_LOAD16_BYTE( "95410404.lo", 0x00001, 0x080000, CRC(9b793a14) SHA1(ea8f6422bdac48c57b17c3037a0b21d48311e140) )
	ROM_LOAD16_BYTE( "95410405.hi", 0x00000, 0x080000, CRC(97aee36e) SHA1(ae3dd0fc48629de411533a59f4a29e53cf4e9c76) )
	ROM_LOAD16_BYTE( "95410542.lo", 0x00001, 0x080000, CRC(4e9c6cfa) SHA1(f7113cf271a8776094c7ea1a73e784f9e9023452) )
	ROM_LOAD16_BYTE( "95410543.hi", 0x00000, 0x080000, CRC(9783ea6f) SHA1(a33b169b29f10bbe315b222b0391c0acc74700d6) )
	ROM_LOAD16_BYTE( "95411402.lo", 0x00001, 0x080000, CRC(99fa28c9) SHA1(9b12ce7d01730dce22f2a5614dd7dfcd56618f87) )
	ROM_LOAD16_BYTE( "95411403.hi", 0x00000, 0x080000, CRC(37b6c0be) SHA1(b71b49386feb49dca2608285dd7618b5dc2a82a9) )
	ROM_LOAD16_BYTE( "95411404.lo", 0x00001, 0x080000, CRC(8891df54) SHA1(87c4ee731db042516a54acfa1f219d99ec0d01db) )
	ROM_LOAD16_BYTE( "95411405.hi", 0x00000, 0x080000, CRC(53902424) SHA1(6ce22049018cfd3a0fba79cba8a752852a038b65) )
	ROM_LOAD16_BYTE( "95411542.lo", 0x00001, 0x080000, CRC(44908000) SHA1(3c7420dbba6cc1de7ff4078c0ee12012dc7a5b59) )
	ROM_LOAD16_BYTE( "95411543.hi", 0x00000, 0x080000, CRC(29bffefe) SHA1(87f29b2c088badab9365dd57b67e8bec317c9c37) )
	ROM_LOAD16_BYTE( "95412482.lo", 0x00001, 0x080000, CRC(3b6c4520) SHA1(f09444ca0c2adc5f4e51de39bcc0f4d70614c537) )
	ROM_LOAD16_BYTE( "95412483.hi", 0x00000, 0x080000, CRC(485729b6) SHA1(91f6fb7b631772ee37959dcf15c851e7fab79ee4) )
	ROM_LOAD16_BYTE( "95412484.lo", 0x00001, 0x080000, CRC(16e6d2d9) SHA1(72132f6b5fea6c7b9ab8643555e472a882ff35fa) )
	ROM_LOAD16_BYTE( "95412485.hi", 0x00000, 0x080000, CRC(3e64b174) SHA1(7b7f3e59e1ac53c95ba482526a82ef5b1f272299) )
	ROM_LOAD16_BYTE( "95413482.lo", 0x00001, 0x080000, CRC(b15c836e) SHA1(3f358ce5bded3330a9fd96ec64122ce3c38acc1c) )
	ROM_LOAD16_BYTE( "95413483.hi", 0x00000, 0x080000, CRC(2ac91acc) SHA1(146caea4dc8968c60454a5f67a402409ecf8f257) )
	ROM_LOAD16_BYTE( "95413484.lo", 0x00001, 0x080000, CRC(fe7c4133) SHA1(bf5a7fe530ff57757dc023d6639227afa40089a8) )
	ROM_LOAD16_BYTE( "95413485.hi", 0x00000, 0x080000, CRC(7cf03220) SHA1(a69dd3cbb519259ba9b3c0b769352d0febc43473) )
	ROM_LOAD16_BYTE( "p1406p12.hi", 0x00000, 0x080000, CRC(8ba5ce5f) SHA1(e4b7f93e124565deab64f02c4d5c031c39421e1a) )
	ROM_LOAD16_BYTE( "p1406p12.lo", 0x00001, 0x080000, CRC(bfbe93c8) SHA1(60054b63e22e1ef90d615ceec4b0531430cb4a8e) )
	ROM_LOAD16_BYTE( "p1406s12.hi", 0x00000, 0x080000, CRC(ddf86cdb) SHA1(528f8276dffa667098564b1de7158991c9ca9c1c) )
	ROM_LOAD16_BYTE( "p1406s12.lo", 0x00001, 0x080000, CRC(6fb9725d) SHA1(ecef4f752a4f8e996fafb7e80d35af56abf4e1fe) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008354.bin", 0x0000, 0x100000, CRC(1fb18180) SHA1(c21456253b670ce140efeaff6a590f8a50112bd4) )
ROM_END




ROM_START( sc_rsnw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211205.bin", 0x0000, 0x6a39e0, CRC(bb426781) SHA1(b1e21abd85589a7ca0e77b123f18b61c16e47971) )
	ROM_LOAD( "39211241.bin", 0x0000, 0x6c2cea, CRC(ec610e0d) SHA1(946a0c400745fae967ad4f6f5ddb589a93de13f6) )
	ROM_LOAD( "39212205.bin", 0x0000, 0x6a39e0, CRC(20c43fd3) SHA1(38b3489f3e966c94ef87cc8566c8df02b7b9aee8) )
	ROM_LOAD( "39212241.bin", 0x0000, 0x6c2cea, CRC(2b433106) SHA1(8e430097ec993549684f34dc9bac64ff88346b24) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_rspin )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211388.bin", 0x0000, 0x1000000, CRC(56fca244) SHA1(56890695c230a62b50c9dc2ecb4e8d6c123ed8dc) )
	ROM_LOAD( "39212387.bin", 0x0000, 0x1000000, CRC(7affbe1b) SHA1(9fced7102afe267f426ada6e7840b877b185ca57) )
	ROM_LOAD( "39212388.bin", 0x0000, 0x1000000, CRC(9ed7ae4f) SHA1(ff55640fd2538e9ed9b17b4387d1430401b22e69) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008549.bin", 0x0000, 0x100000, CRC(dd7399cf) SHA1(1d4f475dde67048c6a425623a696a06e49231308) )
ROM_END




ROM_START( sc_rsclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211057.bin", 0x0000, 0x1000000, CRC(6bd542ce) SHA1(635a829461555f86da7e5d19e8f4e198d63f5400) )
	ROM_LOAD( "39211096.bin", 0x0000, 0x1000000, CRC(e34160e1) SHA1(92308c870c7782a8025ccbe97e7c17773dcbd3f4) )
	ROM_LOAD( "39211097.bin", 0x0000, 0x1000000, CRC(b9c0409b) SHA1(8cef9887f2b89cca2e8a28187db2d3a6828a285e) )
	ROM_LOAD( "39211169.bin", 0x0000, 0x1000000, CRC(45b44bdb) SHA1(2b5a01c9beaa7fa50688ddd50b9f8e5eb135f3fc) )
	ROM_LOAD( "39211170.bin", 0x0000, 0x1000000, CRC(d9e85ee5) SHA1(5da29c3203a9a8ad91c556eb5fb085ee38e1b920) )
	ROM_LOAD( "39211187.bin", 0x0000, 0x1000000, CRC(2f9c7191) SHA1(32c815cab7475fcfe50cba94a25740c37ae8d04f) )
	ROM_LOAD( "39212057.bin", 0x0000, 0x1000000, CRC(85555f52) SHA1(52464e934b28f637ea8f2577ae270ddd0353bf7c) )
	ROM_LOAD( "39212096.bin", 0x0000, 0x1000000, CRC(8df5a794) SHA1(ca005e560a1772da525435728ace0aff53e95640) )
	ROM_LOAD( "39212097.bin", 0x0000, 0x1000000, CRC(9e774d32) SHA1(1d8d97539953d5d33703b39eba39a62dfbf5849a) )
	ROM_LOAD( "39212169.bin", 0x0000, 0x1000000, CRC(1f149fc4) SHA1(808ccaa893f9be2680f8b33e882ab0f3e8b36488) )
	ROM_LOAD( "39212170.bin", 0x0000, 0x1000000, CRC(fedcf3a1) SHA1(c46fd797d81edca5a751e89045c18d6787a43500) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008546.bin", 0x0000, 0x100000, CRC(3d97132f) SHA1(b611617b21b6b7afafa300604ec09e0a84bde8ba) )
ROM_END




ROM_START( sc_rwclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
//  ROM_LOAD( "39211073.txt", 0x0000, 0x0000d1, CRC(7e897cdf) SHA1(9444d6b08d3c61e878512dc761e669d0f7b93717) )
	ROM_LOAD( "39211073.bin", 0x0000, 0x1000000, CRC(bd3e0d73) SHA1(063058051dd5d774e2755f3fd0fb3f83277221db) )
	ROM_LOAD( "39211074.bin", 0x0000, 0x1000000, CRC(917dbae6) SHA1(87c664beba60054c0349861f4bd19393cf993bf1) )
	ROM_LOAD( "39212073.bin", 0x0000, 0x1000000, CRC(64d98913) SHA1(b207d411a007079ac2a46df3d801f933635fc55f) )
	ROM_LOAD( "39212074.bin", 0x0000, 0x1000000, CRC(972b5457) SHA1(83a0cbc3875027e91224cff6e60b9da696ff9c8e) )
	ROM_LOAD( "p1757p11.bin", 0x0000, 0x1000000, CRC(34de65e7) SHA1(c5d449f4eeb596e9d8874c1a80dd77dccc75d1b8) )
	ROM_LOAD( "p1757s11.bin", 0x0000, 0x1000000, CRC(36f2efbc) SHA1(9431a1ae738f24370a785b69c50ce34dd260dc8c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_rapid )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211120.bin", 0x0000, 0x1000000, CRC(7de15e7d) SHA1(02ee9bf3d670f9ec7f4428c5b9c1d40a1e68df17) )
	ROM_LOAD( "39212120.bin", 0x0000, 0x1000000, CRC(16f91987) SHA1(1ad0b3b3c58f0566fc1a23904c7bc0e8693d99d4) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008570.bin", 0x0000, 0x080000, CRC(edd2bff6) SHA1(213b16eb091f96633dec5ec8df5084062dd68ba0) )
ROM_END




ROM_START( sc_rcash )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211273.bin", 0x0000, 0x80ceaa, CRC(2577ad05) SHA1(9f9d003331821a79d3bb0901dd91af8c19bbbc49) )
	ROM_LOAD( "39212273.bin", 0x0000, 0x80ceaa, CRC(7459b4a7) SHA1(d78fe6ffddd97a7ba81a053712b0d5be9cefe33a) )
	ROM_REGION( 0x400000, "pics", ROMREGION_ERASEFF )
	ROM_LOAD( "95890390.bin", 0x0000, 0x5000, CRC(f973db95) SHA1(f91b206e1a1fb5125654ad081d666ae2bfd2036f) )
	ROM_LOAD( "95890391.bin", 0x0000, 0x5000, CRC(e5a52b29) SHA1(ac408585a14060b81651e14f0cae6a77edee1985) )
	ROM_LOAD( "95890392.bin", 0x0000, 0x5000, CRC(26ff09b9) SHA1(236d0808126d517e4a1c86bebad3c877252de4d8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008946.bin", 0x0000, 0x0f7b10, CRC(9a70fd7b) SHA1(692908750bea92af5f06d7151b15aec294aaf686) )
ROM_END



ROM_START( sc_rroul )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211342.bin", 0x0000, 0xfc273a, CRC(50b63c2f) SHA1(2670f41b05cabf40d1ce1fb03d1c936207a50afa) )
	ROM_LOAD( "39211345.bin", 0x0000, 0x643110, CRC(c3838739) SHA1(1260e2348bc41a1d364b3bbd3914724ea2c6153a) )
	ROM_LOAD( "39212342.bin", 0x0000, 0xfc273a, CRC(81491291) SHA1(a32687e3e4d535540fcc78cea5f432b5bd4e01b9) )
	ROM_LOAD( "39212345.bin", 0x0000, 0x643110, CRC(216efed6) SHA1(8c5b66bac3bde410577d2c8b6f8d352404a36695) )
	ROM_REGION( 0x400000, "pics", ROMREGION_ERASEFF )
	ROM_LOAD( "95890489.bin", 0x0000, 0x5000, CRC(8f41d119) SHA1(83f276c02a0fe404c397cf708552674fb3bb15c4) )
	ROM_LOAD( "95890490.bin", 0x0000, 0x5000, CRC(939721a5) SHA1(be0a9c2af853ab8c28e63aa6dcff350d4e69e437) )
	ROM_LOAD( "95890491.bin", 0x0000, 0x5000, CRC(50cd0335) SHA1(db2bcf0e2be67eb8c657ab3536a5056bb66649b8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008986.bin", 0x0000, 0x0c18ab, CRC(f69f04b5) SHA1(b1095592120c3f4f3bac8963362611def14f7233) )
	ROM_LOAD( "95008996.bin", 0x0000, 0x0ce354, CRC(a462a168) SHA1(6598605123407bb2206928e82a903f9a41ba524c) )
ROM_END




ROM_START( sc_rssh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416078.lo", 0x00001, 0x080000, CRC(497b3c48) SHA1(fb1ce70293606d7cee50c8c9f91aac46fdbf0237) )
	ROM_LOAD16_BYTE( "95416079.hi", 0x00000, 0x080000, CRC(6f6b372b) SHA1(7fc38789b8a7e26f21877e17dc3f95854162b3e9) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417078.lo", 0x00001, 0x080000, CRC(1056cb40) SHA1(2fe6d90ce69353d389167a55f54c7a8d5b74b237) )
	ROM_LOAD16_BYTE( "95417079.hi", 0x00000, 0x080000, CRC(03eb412b) SHA1(913c3e8b43fddc463eb744c2a0d1be13c8c4f296) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_rh )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95426476.lo", 0x00001, 0x080000, CRC(c33a4532) SHA1(94079594092abc1be8068e9ecc336c97f754fed9) )
	ROM_LOAD16_BYTE( "95426477.hi", 0x00000, 0x080000, CRC(f26b8576) SHA1(cecdfe93b9e71719bfd4eed321ff9f355290c838) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95427476.lo", 0x00001, 0x080000, CRC(caae18b9) SHA1(0ff77bd30996bb2eaf5855dc03d184c0c0cd5384) )
	ROM_LOAD16_BYTE( "95427477.hi", 0x00000, 0x080000, CRC(c8737336) SHA1(189f96c1bcd2ff2ce009879ac58bb64f42b0c4a4) )
	ROM_LOAD16_BYTE( "p3208p71.hi", 0x00000, 0x080000, CRC(850c2cb1) SHA1(c5eac4024bff58e962a8920e2874b97b18dca57d) )
	ROM_LOAD16_BYTE( "p3208p71.lo", 0x00001, 0x080000, CRC(47b4f49f) SHA1(7a92345879080aad73f5f2db30206c8ab3f160f0) )
	ROM_LOAD16_BYTE( "p3208s71.hi", 0x00000, 0x080000, CRC(51ba60df) SHA1(3c7e604626f513b9cf8da393abadc4286c7dbb07) )
	ROM_LOAD16_BYTE( "p3208s71.lo", 0x00001, 0x080000, CRC(9f6373f2) SHA1(e5dc797b8dda3abe9ab64f5fec77f22038ae2c33) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008783.bin", 0x0000, 0x100000, CRC(50d2c89b) SHA1(f3e592f009765118009f97bd7d0951b72ffc2898) )
	ROM_LOAD( "95008784.bin", 0x0000, 0x100000, CRC(88185c65) SHA1(b3a6d06aca91dc04d9efbc1e4ff89b37bcf87a57) )
ROM_END




ROM_START( sc_rhclb )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95422816.lo", 0x00001, 0x080000, CRC(cb6dcc16) SHA1(f33692abb167847ebbf02b25f2929e15a2645a9e) )
	ROM_LOAD16_BYTE( "95422817.hi", 0x00000, 0x080000, CRC(ff60c202) SHA1(d48ee1c7d29091c0744150151c8cd16721741209) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95423816.lo", 0x00001, 0x080000, CRC(f315b177) SHA1(3dcc4ee7b570bc01222734f1ed3300dce9906328) )
	ROM_LOAD16_BYTE( "95423817.hi", 0x00000, 0x080000, CRC(6f2a3ddb) SHA1(7791c3bbf6e965d383feac1a579b50b94e6bc48b) )
	ROM_LOAD16_BYTE( "95426430.lo", 0x00001, 0x080000, CRC(0c8f13b6) SHA1(ba3dbc142c2d5978176d3fa0b9f72a51f48e28b7) )
	ROM_LOAD16_BYTE( "95426431.hi", 0x00000, 0x080000, CRC(afb442d0) SHA1(3999c2bac3fe1de6f7efbb98186b16bd192c55b5) )
	ROM_LOAD16_BYTE( "95427430.lo", 0x00001, 0x080000, CRC(ac9ebd80) SHA1(d0b551eff727ef11d0c09fc0cb03aa8aee89b325) )
	ROM_LOAD16_BYTE( "95427431.hi", 0x00000, 0x080000, CRC(a88dde7b) SHA1(301e69d8c6ad1b79ff47ac970db64ab7e911e8ae) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008802.bin", 0x0000, 0x100000, CRC(36647f4a) SHA1(ffa0cdf4f2b8ccc9afda67160a50e603b2a41ae6) )
	ROM_LOAD( "95008803.bin", 0x0000, 0x100000, CRC(2d26ff8a) SHA1(b9c797dfb2b06b3558e9a02d197e046244f4f2fc) )
ROM_END




ROM_START( sc_rsrm )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "p3302p71.bin", 0x0000, 0x1000000, CRC(09aa5633) SHA1(1733dc5430f1277ff32c6b8abcbee7a274b1c9de) )
	ROM_LOAD( "p3302s71.bin", 0x0000, 0x1000000, CRC(9f4c34ad) SHA1(81493e5f957d0e705d5fe9111f46e119b871b6b0) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_rsrr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008828.bin", 0x0000, 0x100000, CRC(35a1b9aa) SHA1(a6d03645994b36a9e506b950f752a6c1c899e110) )
	ROM_LOAD( "95008829.bin", 0x0000, 0x100000, CRC(3745f572) SHA1(ffc9e67ed92552e7b2790433ea4838df10712f4d) )
	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "p3302p12.bin", 0x0000, 0x1000000, CRC(92294235) SHA1(1ff971f24a1de18d29e009800e6c7aa2830962f5) )
	ROM_LOAD( "p3302s12.bin", 0x0000, 0x1000000, CRC(ca95d6e0) SHA1(4fdb2e136251ffc8aa475b6c1ccbc0d6a8afe0d2) )
ROM_END




ROM_START( sc_sharp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95419012.lo", 0x00001, 0x080000, CRC(096c3ca8) SHA1(555933d106a8c9d1b1e1927cb62fc2f20218192a) )
	ROM_LOAD16_BYTE( "95419013.hi", 0x00000, 0x080000, CRC(3cfeea5f) SHA1(4f226d9a743e124a0fdcfa7682bfa4c697e69522) )

	ROM_REGION( 0x400000, "altrevs", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418013.hi", 0x00000, 0x080000, CRC(29514c54) SHA1(b062be5dff916965e1ac0ab2ab45bc18cf8f9c93) )
	ROM_LOAD16_BYTE( "95418012.lo", 0x00001, 0x080000, CRC(6330d3b3) SHA1(bfeb25241c8a7ca9e730eb379dcc7da0270a20a0) )

	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008561.bin", 0x0000, 0x100000, CRC(98d21491) SHA1(e06156dbe83fc26968da1a2432d697d68e6b88ee) )
	ROM_LOAD( "95008562.bin", 0x0000, 0x100000, CRC(fb3a25e7) SHA1(e8a60e4e870438fd4a330453ce1bdf8ad836fbc0) )
ROM_END




ROM_START( sc_sfts )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "g95424650.lo", 0x00001, 0x080000, CRC(2e9460ba) SHA1(f449701e19c254716ca9aae63c359cfc57be8b1b) )
	ROM_LOAD16_BYTE( "g95424651.hi", 0x00000, 0x080000, CRC(15fddbb7) SHA1(b48a257e3ba74b79272969e9702ecab032df6051) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "g95424656.lo", 0x00001, 0x080000, CRC(a0b723c7) SHA1(458bfc964f300659b8497c18cb325b7803666600) )
	ROM_LOAD16_BYTE( "g95424657.hi", 0x00000, 0x080000, CRC(ea65f9de) SHA1(7695e5361d22e8f3acd5842434bd61bdeaf9948f) )
	ROM_LOAD16_BYTE( "g95425650.lo", 0x00001, 0x080000, CRC(cb99c5e3) SHA1(c0a67576693e547e5db4a52388dcbbccdd229c11) )
	ROM_LOAD16_BYTE( "g95425651.hi", 0x00000, 0x080000, CRC(8db18aa2) SHA1(87969702f4a71df394bd2ea521e5768403b91659) )
	ROM_LOAD16_BYTE( "g95425656.lo", 0x00001, 0x080000, CRC(406fa07c) SHA1(e564b331f0b409d967c4ef6ccc17bb37e633d3c8) )
	ROM_LOAD16_BYTE( "g95425657.hi", 0x00000, 0x080000, CRC(3103d2e9) SHA1(f4f5694dc1dbfbe4bd10561adfb517e768d832fb) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_srrqp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424514.lo", 0x00001, 0x080000, CRC(3fa1e76e) SHA1(9a1ee8172f05210fbebb3823ec589a444ea24586) )
	ROM_LOAD16_BYTE( "95424515.hi", 0x00000, 0x080000, CRC(759f0ef7) SHA1(736521894808134ff43c798b9a862dfe29994e69) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425514.lo", 0x00001, 0x080000, CRC(e61834e8) SHA1(c24e1de4010c57019fa3ee09e50e6cd7a83c4854) )
	ROM_LOAD16_BYTE( "95425515.hi", 0x00000, 0x080000, CRC(89b0bfc5) SHA1(af7c5f0ec42ad9c5899817524594a910cb1fe08a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891091.bin", 0x0000, 0x5000, CRC(e8a89f86) SHA1(0260292e43320b4d7a7cd93c9c058be6250a1441) )
	ROM_LOAD( "95891092.bin", 0x0000, 0x5000, CRC(9d3edbb2) SHA1(6a1f3030dc6438da5e83f1d9144bd7f4fab98c97) )
	ROM_LOAD( "95891093.bin", 0x0000, 0x5000, CRC(038417ee) SHA1(5e4234bf9b7d698b0f82af702209789948456e32) )
ROM_END




ROM_START( sc_witwi )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3203p12.hi", 0x00000, 0x080000, CRC(70665f72) SHA1(f23d975fb98a305ff5eab65d76791780d621593e) )
	ROM_LOAD16_BYTE( "p3203p12.lo", 0x00001, 0x080000, CRC(9dc27ba0) SHA1(9217892885afe5a421996567de82f82f14e791b0) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3203s12.hi", 0x00000, 0x080000, CRC(76604bb7) SHA1(04aa6fd4e4783b2e5ea7e26c1511c15b8dda68cd) )
	ROM_LOAD16_BYTE( "p3203s12.lo", 0x00001, 0x080000, CRC(d19fffc9) SHA1(253a88331214a8be0c34cdcbe305317ef4a13987) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008756.bin", 0x0000, 0x100000, CRC(bde21cff) SHA1(fc8945e66416447d690515161acf9260620d7768) )
	ROM_LOAD( "95008757.bin", 0x0000, 0x100000, CRC(7c33cf90) SHA1(f3ad90c5623d97e3bf013927945383115042b84b) )
ROM_END



ROM_START( sc_spnrn )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416158.lo", 0x00001, 0x080000, CRC(c422d907) SHA1(9d42e7db20c1366267dac5bf09f8746479531b40) )
	ROM_LOAD16_BYTE( "95416159.hi", 0x00000, 0x080000, CRC(24e6c208) SHA1(8f672249466475f5770e8a3d1ea69c7f82ec374b) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417158.lo", 0x00001, 0x080000, CRC(9ef26fc7) SHA1(eea26ad28ffe51dd0d7205da6057a2bd0467cff3) )
	ROM_LOAD16_BYTE( "95417159.hi", 0x00000, 0x080000, CRC(1f4d639d) SHA1(eb20d3a92e8fb93a5a7d7c2dfd81d32aaf1559e7) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008538.bin", 0x0000, 0x0de67f, CRC(5f689b5c) SHA1(a0469987b93fdd0c661ef622403e03c6edbc561a) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890178.bin", 0x0000, 0x5000, CRC(bb0186be) SHA1(575f212b555035a6a30fea7f49836f4ad72868d2) )
	ROM_LOAD( "95890179.bin", 0x0000, 0x5000, CRC(ea390914) SHA1(ac34e41f6e277115e5fc2ea2bb1675c1d7df0dfe) )
	ROM_LOAD( "95890180.bin", 0x0000, 0x5000, CRC(7483c548) SHA1(06675caa6e0e4f136995d542210bddbb2e9e2ba4) )
ROM_END




ROM_START( sc_srace )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95418036.lo", 0x00001, 0x080000, CRC(b891ca07) SHA1(61b3b1851d8881e960b3b69ea2bc69650e9559a1) )
	ROM_LOAD16_BYTE( "95418037.hi", 0x00000, 0x080000, CRC(986ed7be) SHA1(840536cf145f08d2dab277cf529469c98e05642b) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95419036.lo", 0x00001, 0x080000, CRC(c060d8fd) SHA1(011f8af6792e25c9510ecbae3ec93732125ecb70) )
	ROM_LOAD16_BYTE( "95419037.hi", 0x00000, 0x080000, CRC(b4a34db3) SHA1(d20f89dca7ab0ba81d89fb261170551a0bc6e0c9) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END




ROM_START( sc_sleut )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424064.lo", 0x00001, 0x080000, CRC(b07c1bcf) SHA1(82b8bf3cb8344e461492d03f8df70f1577be2073) )
	ROM_LOAD16_BYTE( "95424065.hi", 0x00000, 0x080000, CRC(c17d9250) SHA1(6e647f67794e2d326fcf4d97d80244f949ba6554) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425064.lo", 0x00001, 0x080000, CRC(88b07e21) SHA1(4c3e9c7bd046300369fbc450fb943c680faa577b) )
	ROM_LOAD16_BYTE( "95425065.hi", 0x00000, 0x080000, CRC(1660b679) SHA1(921a5fe7300614e8889223f2d0b0a52e22db192f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008870.bin", 0x0000, 0x0fa9dd, CRC(9b219ee5) SHA1(a488919d305bc8a2f8d92ea73054ea9e467dbb4e) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890777.bin", 0x0000, 0x5000, CRC(12e0a0db) SHA1(f7360b7f7086111dd951c9742f4b0402dfdd988c) )
	ROM_LOAD( "95890778.bin", 0x0000, 0x5000, CRC(6776e4ef) SHA1(a39e7aefb57521e4782dd0a8b37c904b7b76ff29) )
	ROM_LOAD( "95890779.bin", 0x0000, 0x5000, CRC(f9cc28b3) SHA1(031df3658b5aec9f318f42f04e8041fd9ae1b761) )
ROM_END




ROM_START( sc_tornc )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD16_BYTE( "95008564.bin", 0x0000, 0x100000, CRC(55d0d855) SHA1(343cfe935c34c8f95a638eccb1397238fa7698e4) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211114.bin", 0x0000, 0x1000000, CRC(f218d87b) SHA1(230038ee52d47dde9669a6fd3a363264f222f1f8) )
	ROM_LOAD( "39211115.bin", 0x0000, 0x1000000, CRC(867ad45b) SHA1(90b9c256ffb99ecae912771aa8eb1605651f2a68) )
	ROM_LOAD( "39212114.bin", 0x0000, 0x1000000, CRC(5f80e76b) SHA1(a8aeef603a815b34ba61963532b4c6699cb3c27d) )
	ROM_LOAD( "39212115.bin", 0x0000, 0x1000000, CRC(2be2eb4b) SHA1(c70e27938e60c701cb41060536cc68c69a2df50b) )
	ROM_LOAD( "p1627p12.bin", 0x0000, 0x1000000, CRC(71b881b6) SHA1(a18455c2ce769d9ea135f887c83594be319ac8ce) )
	ROM_LOAD( "p1627s12.bin", 0x0000, 0x1000000, CRC(0cd2ca21) SHA1(fa2dfdd73540d3446ac5c33f72e93d1c4b520d73) )
ROM_END




ROM_START( sc_tsmp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p1630p19.hi", 0x00000, 0x080000, CRC(0de71ba2) SHA1(2bf9f95ecfa7a3f37b93739a573cba214fefdffe) )
	ROM_LOAD16_BYTE( "p1630p19.lo", 0x00001, 0x080000, CRC(df020dcc) SHA1(2863a8b982f374fa2073f8b9d5333cc246fc6614) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p1630s19.hi", 0x00000, 0x080000, CRC(32dbdf76) SHA1(2f2aebeedf00e15c476014bea21178a31b58d5e6) )
	ROM_LOAD16_BYTE( "p1630s19.lo", 0x00001, 0x080000, CRC(c70f7f83) SHA1(c1c811830c919eeaa7f74e9d9e6116ddb9b977a8) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_pompa )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95412578.lo", 0x00001, 0x080000, CRC(c302b2ef) SHA1(7da7e4b34c23a34ed7e00ae4673b522abde52b00) )
	ROM_LOAD16_BYTE( "95412579.hi", 0x00000, 0x080000, CRC(5f8815fa) SHA1(5ce9000183da8b64545158b70ffaaf5223197155) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95413578.lo", 0x00001, 0x080000, CRC(bca7fa00) SHA1(908eed34e66ccb4e5a98c4ec0cdff8f29aece37d) )
	ROM_LOAD16_BYTE( "95413579.hi", 0x00000, 0x080000, CRC(c9a297e8) SHA1(1c8a99d020932964788e5ac1dfcb28dd03ebd36f) )
	ROM_LOAD16_BYTE( "p1606s41.lo", 0x00001, 0x080000, CRC(4c47bb0f) SHA1(16d2e6d7c6c6c116c2c9dd503e957e639a07ef04) ) // missing other part of pair?
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END



ROM_START( sc_vamp )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424380.lo", 0x00001, 0x080000, CRC(46b87ded) SHA1(8bc8a06185498910424772678ae037e09090ab38) )
	ROM_LOAD16_BYTE( "95424381.hi", 0x00000, 0x080000, CRC(5b463863) SHA1(465f767aa57f5ee5f2effc1548bfd829aa4a9e9e) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95425380.lo", 0x00001, 0x080000, CRC(c49b44bd) SHA1(174b1e51b04ede8ba19511d3f9a8d37d661747b1) )
	ROM_LOAD16_BYTE( "95425381.hi", 0x00000, 0x080000, CRC(e033bebb) SHA1(5f5679fa410d5be0f852bd61dffe152320634dee) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008890.bin", 0x0000, 0x0ffd25, CRC(bdf5491b) SHA1(231264d83a84fcc54bf45a43a37464fc5c604d9b) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95891062.bin", 0x0000, 0x5000, CRC(3816210d) SHA1(890eed46cf9d7285887d0fe422ff6c8d8bf35820) )
	ROM_LOAD( "95891063.bin", 0x0000, 0x5000, CRC(4d806539) SHA1(73958733c49fa020f6425aef511489965df13907) )
ROM_END



ROM_START( sc_vpa )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008722.bin", 0x0000, 0x080000, CRC(0643d71d) SHA1(027e096a82d5c13a98ef773548c8f5e16257e863) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "p3073p71.bin", 0x0000, 0x1000000, CRC(75320ec0) SHA1(833a44c62a132d06de63995780769966efeff5c3) )
	ROM_LOAD( "p3073p72.bin", 0x0000, 0x1000000, CRC(cdd49281) SHA1(1771504c3b335744a195c93858b1418099599e19) )
	ROM_LOAD( "p3073s71.bin", 0x0000, 0x1000000, CRC(0adee992) SHA1(fba11f05c762bc456adbcd3d682fceb3b19a851b) )
	ROM_LOAD( "p3073s72.bin", 0x0000, 0x1000000, CRC(b048298e) SHA1(0f55563b80d00c743f75d71500e3493087abcfc0) )
ROM_END



ROM_START( sc_viper )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95414750.lo", 0x00001, 0x080000, CRC(38d24824) SHA1(a98d1f610f92ffb70387d57c8d0641d1ff399438) )
	ROM_LOAD16_BYTE( "95414751.hi", 0x00000, 0x080000, CRC(a2355e09) SHA1(f887915ec1f271416e17aa8ac2c22337e4a0f643) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95415750.lo", 0x00001, 0x080000, CRC(362920a9) SHA1(19dc0fdf2bd2623ce1215ab6d21121d04dfbf248) )
	ROM_LOAD16_BYTE( "95415751.hi", 0x00000, 0x080000, CRC(29088c30) SHA1(c09720cb0b890e51df9167f97e9c3d38161d4e75) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	// 95008474.bin = 95008910.bin          sc4hiss    Hissing Quid (Qps) (Scorpion 4)
ROM_END



ROM_START( sc_vlv )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95009055.bin", 0x0000, 0x100000, CRC(6fa39bdb) SHA1(a78b02d4b7d38da529db590b32d5d22ed7b46870) )
	ROM_LOAD( "95009056.bin", 0x0000, 0x100000, CRC(d530f185) SHA1(a3a8ac81ce7d9a8e8e005cfaab3f9ae82804cbd9) )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASE00 )
	ROM_LOAD( "39211605.bin", 0x0000, 0x1000000, CRC(b8fab0a2) SHA1(68ad9810549d9d01934182cb578e17af05ffa3c2) )
	ROM_LOAD( "39211606.bin", 0x0000, 0x1000000, CRC(fa465b43) SHA1(8be39ffbee06a5b662a40b447276f95aa3b9bbe2) )
	ROM_LOAD( "39212605.bin", 0x0000, 0x1000000, CRC(e5deb9fd) SHA1(9490d506080e729a43daf73710d4077c5d33d47b) )
ROM_END



ROM_START( sc_viz )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95424368.lo", 0x00001, 0x080000, CRC(978f755c) SHA1(8790b4f7ea0e2302a1166c93364705c2e9f25703) )
	ROM_LOAD16_BYTE( "95424369.hi", 0x00000, 0x080000, CRC(83a94061) SHA1(bb7125219c2f67601e883481d1665a0dd0614bf7) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95424562.lo", 0x00001, 0x080000, CRC(31032781) SHA1(511cd503651eb7ca078c52cec8a506f752270e70) )
	ROM_LOAD16_BYTE( "95424563.hi", 0x00000, 0x080000, CRC(b51ab196) SHA1(ff0500ce47ff04b19c7a4d4d3014de198b5ac0ae) )
	ROM_LOAD16_BYTE( "95425368.lo", 0x00001, 0x080000, CRC(d08cfae9) SHA1(d0ab570f6939c5c9f6f252a23f25b1a7b7ecb0f7) )
	ROM_LOAD16_BYTE( "95425369.hi", 0x00000, 0x080000, CRC(e92a4e55) SHA1(0732350de7dd5f7cb52473b3231cf7fc02d10fed) )
	ROM_LOAD16_BYTE( "95425562.lo", 0x00001, 0x080000, CRC(32fc1aff) SHA1(cb2a0923fa6f40caaaacaf3552c985ee0655cf63) )
	ROM_LOAD16_BYTE( "95425563.hi", 0x00000, 0x080000, CRC(1cf8e3d1) SHA1(7bf620d40d2c1dfa07321fa765aa1ea08965f633) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008859.bin", 0x0000, 0x100000, CRC(86e4b4a1) SHA1(21344c9e5757d8d9ad7f1cd5ce5deb9f93d18fcc) )
	ROM_LOAD( "95008860.bin", 0x0000, 0x0ae3ea, CRC(0e49df2c) SHA1(629b90f91e8840560ea6eaf0e94d6b2fb6aba71c) )
	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890742.bin", 0x0000, 0x5000, CRC(247f75ec) SHA1(92d63123aabf6932b283bbbd581c1bbe526318ce) )
	ROM_LOAD( "95890743.bin", 0x0000, 0x5000, CRC(51e931d8) SHA1(91ceb930eac97e090de5471c8a789ddd31c65a10) )
	ROM_LOAD( "95890744.bin", 0x0000, 0x5000, CRC(cf53fd84) SHA1(0de52e4ce83f41f2928866fc914ed36023415a4f) )
ROM_END



ROM_START( sc_wacky )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3305p71.hi", 0x00000, 0x080000, CRC(8a1c95ca) SHA1(79ca2ba01f3dbfe1226cce7572f5d4d6ffd3f527) )
	ROM_LOAD16_BYTE( "p3305p71.lo", 0x00001, 0x080000, CRC(b956a760) SHA1(14ecbda474370936fbc257364b5f98e774b85193) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3305p72.hi", 0x00000, 0x080000, CRC(45b0f07d) SHA1(ca066e5ee481002c99bbcbf0f4df43f3f2b9e14a) )
	ROM_LOAD16_BYTE( "p3305p72.lo", 0x00001, 0x080000, CRC(afe37e0b) SHA1(eafc45ba58e69d809324756c0606f935d430fca2) )
	ROM_LOAD16_BYTE( "p3305s71.hi", 0x00000, 0x080000, CRC(6f52c415) SHA1(f3044d4168cf47ef2f468acbdc08d566f514e46a) )
	ROM_LOAD16_BYTE( "p3305s71.lo", 0x00001, 0x080000, CRC(f579d441) SHA1(377919555b6748f1ffd408b7200b027f7525dff3) )
	ROM_LOAD16_BYTE( "p3305s72.hi", 0x00000, 0x080000, CRC(df124698) SHA1(f019a9e739cf2852e6b90eab7bcc2f9ad47a0e9d) )
	ROM_LOAD16_BYTE( "p3305s72.lo", 0x00001, 0x080000, CRC(d1517e62) SHA1(bd13fcf0fd8c157526921ae9b321c65fbcb29cd3) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008834.bin", 0x0000, 0x100000, CRC(def73602) SHA1(681aafa4c035fdbb0f03e92fa56d31c13e27ca59) )
	ROM_LOAD( "95008835.bin", 0x0000, 0x100000, CRC(9a10ff4f) SHA1(903e43d9db726dc5ee92abaf23b61454611064b1) )
	ROM_LOAD( "95009128.bin", 0x0000, 0x100000, CRC(d9883f0c) SHA1(3cfeb470248a9d5d6b653175c16f88c54d51fceb) )
	ROM_LOAD( "95009129.bin", 0x0000, 0x100000, CRC(969f418a) SHA1(ca65dfa23f9e6a516bc65baa8ddd80faa530af1f) )
ROM_END



ROM_START( sc_wotw )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416514.lo", 0x00001, 0x080000, CRC(ec4081ce) SHA1(333dd386c6fa09cecf10dfabc757fece98310e6d) )
	ROM_LOAD16_BYTE( "95416515.hi", 0x00000, 0x080000, CRC(2790e4b4) SHA1(f0c644596ec7229f3b539c100b8613e7ea66559e) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417514.lo", 0x00001, 0x080000, CRC(505c1fa3) SHA1(26f73bc53390597f685368b8a94b6f853f5caed0) )
	ROM_LOAD16_BYTE( "95417515.hi", 0x00000, 0x080000, CRC(802d1030) SHA1(1887eba0c5ad74d6127c5a504c4cab309d326f8d) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008925.bin", 0x0000, 0x0eea8c, CRC(9cb8a972) SHA1(9b99eea5264fa0764f4598330f442335a8024cdb) )
ROM_END


ROM_START( sc_wild )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416410.lo", 0x00001, 0x080000, CRC(46719b6e) SHA1(fbc40168becb125ef1d2019b1a42c90275cc93c6) )
	ROM_LOAD16_BYTE( "95416411.hi", 0x00000, 0x080000, CRC(dd8dd80f) SHA1(e5422de00df5d88ff1260fb8c03845754bf6eb65) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95417410.lo", 0x00001, 0x080000, CRC(077fe968) SHA1(92c32dc8929f0905f7f2371d417cebab1359a15b) )
	ROM_LOAD16_BYTE( "95417411.hi", 0x00000, 0x080000, CRC(69475b32) SHA1(402af3e0b86261f6621f75f7d747803f4295ea10) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )

	ROM_REGION( 0x5000, "pics", 0 )
	ROM_LOAD( "95890339.bin", 0x0000, 0x5000, CRC(e3fbc85c) SHA1(8fc235f53b9359d378f86819e04377e7c102428c) )
	ROM_LOAD( "95890340.bin", 0x0000, 0x5000, CRC(ff2d38e0) SHA1(3b62d6c6448312f999502c244d483df8a60be77a) )
	ROM_LOAD( "95890341.bin", 0x0000, 0x5000, CRC(3c771a70) SHA1(bf47ecdea05757d9636526308f4aeabe3748d307) )
ROM_END


ROM_START( sc_wca )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416066.odd", 0x00001, 0x080000, CRC(f07af4e1) SHA1(d6c2372cdaeb4033dcf2a7a8df787a69f4eb5362) )
	ROM_LOAD16_BYTE( "95416067.evn", 0x00000, 0x080000, CRC(194f0267) SHA1(07500aad418e80118974f22f4761204013980a13) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416094.odd", 0x00001, 0x080000, CRC(795ea9dd) SHA1(b4d3cac0ef50732174ebcc349c7a0855587ff7bd) )
	ROM_LOAD16_BYTE( "95416095.evn", 0x00000, 0x080000, CRC(60f1cd18) SHA1(212288329f5e347a40aa5dc9e102f37224f36011) )
	ROM_LOAD16_BYTE( "95416170.odd", 0x00001, 0x080000, CRC(b1ff0caf) SHA1(036bbd709454604365b6a15100b5926bbe8594d9) )
	ROM_LOAD16_BYTE( "95416171.evn", 0x00000, 0x080000, CRC(0ab724d5) SHA1(ab17f1fe4f6579022d8fb80399f270ed64ec7612) )
	ROM_LOAD16_BYTE( "95416172.odd", 0x00001, 0x080000, CRC(a927b15a) SHA1(ca9b5a87e89feeffb99fbb23fe390a424e27675f) )
	ROM_LOAD16_BYTE( "95416173.evn", 0x00000, 0x080000, CRC(815e89a3) SHA1(0cbea4613c6f7ce69b76c0d7d443e85163373f73) )
	ROM_LOAD16_BYTE( "95416398.odd", 0x00001, 0x080000, CRC(3b283b54) SHA1(530812228b7ad96b4c40e33edb9d54632c2b33f5) )
	ROM_LOAD16_BYTE( "95416399.evn", 0x00000, 0x080000, CRC(a0ac5a0d) SHA1(12a8e4a09cdbfd87ad287e6aa1e4d114c1e4b6c3) )
	ROM_LOAD16_BYTE( "95416400.odd", 0x00001, 0x080000, CRC(c4e6949f) SHA1(b17ded78ea23f18b47bbb48cfb462d013881abd4) )
	ROM_LOAD16_BYTE( "95416401.evn", 0x00000, 0x080000, CRC(cc482fb8) SHA1(ff912ea928f9c1ad4f6249aaf70dc62292503cd4) )
	ROM_LOAD16_BYTE( "95416402.odd", 0x00001, 0x080000, CRC(b7f71001) SHA1(b959840ac4fbd0f4d076e163bcebb840152f6652) )
	ROM_LOAD16_BYTE( "95416403.evn", 0x00000, 0x080000, CRC(13b30567) SHA1(5c5d3d9db53439f58faed4858333885d4f117c73) )
	ROM_LOAD16_BYTE( "95416404.odd", 0x00001, 0x080000, CRC(fc2105b0) SHA1(04fb1e3b14cae3132818901c1efd49a362334ca1) )
	ROM_LOAD16_BYTE( "95416405.evn", 0x00000, 0x080000, CRC(df9f1d8a) SHA1(2ba998a7092b623023b47690332f018369e3631c) )
	ROM_LOAD16_BYTE( "95417066.odd", 0x00001, 0x080000, CRC(f0a528d7) SHA1(6df30a806b2be5f2a909357d2b6dbd35a5073261) )
	ROM_LOAD16_BYTE( "95417067.evn", 0x00000, 0x080000, CRC(0209e0e0) SHA1(d73b6ce5b1a9f7b2ebad2d077fa0c80dad10da3d) )
	ROM_LOAD16_BYTE( "95417094.odd", 0x00001, 0x080000, CRC(f9546e54) SHA1(adbd5f07ea5e029bf4b3f748ffb646872a358730) )
	ROM_LOAD16_BYTE( "95417095.evn", 0x00000, 0x080000, CRC(7e7d655e) SHA1(ea59d192de08917c19a02ce1ce4bff5acf8df0fd) )
	ROM_LOAD16_BYTE( "95417170.odd", 0x00001, 0x080000, CRC(4e59642a) SHA1(dad89cc76dd375cf7db1abcddefdb782b317a587) )
	ROM_LOAD16_BYTE( "95417171.evn", 0x00000, 0x080000, CRC(ce9b4edf) SHA1(0624a82d535bc15619263dc730e61121bed494eb) )
	ROM_LOAD16_BYTE( "95417172.odd", 0x00001, 0x080000, CRC(8602fb1a) SHA1(5e1e599f607af9b745f722873f2577a54572266d) )
	ROM_LOAD16_BYTE( "95417173.evn", 0x00000, 0x080000, CRC(5cb9d48d) SHA1(b098147757248f37578fcce3693cf9ea6dd1064f) )
	ROM_LOAD16_BYTE( "95417398.odd", 0x00001, 0x080000, CRC(9a0a1a0a) SHA1(6093fd9ccf74119a121dc5f9af70e68baf183dfe) )
	ROM_LOAD16_BYTE( "95417399.evn", 0x00000, 0x080000, CRC(f3956efb) SHA1(1913ef5c3896eabcc34018d3aa4bc6c30f4b27b7) )
	ROM_LOAD16_BYTE( "95417400.odd", 0x00001, 0x080000, CRC(d449fd36) SHA1(58eb42cbb4edaf0d3b050a042331dcc5f854294f) )
	ROM_LOAD16_BYTE( "95417401.evn", 0x00000, 0x080000, CRC(f6f510f0) SHA1(1d43ab933a9fcb8720babda5d8a1ebeae7f7bf73) )
	ROM_LOAD16_BYTE( "95417402.odd", 0x00001, 0x080000, CRC(10b4f7b1) SHA1(9db139bb360f3e220b552affc9598f499e318658) )
	ROM_LOAD16_BYTE( "95417403.evn", 0x00000, 0x080000, CRC(56453ab0) SHA1(98fab945a48ee009cb03ed427660b3bd20da2e8a) )
	ROM_LOAD16_BYTE( "95417404.odd", 0x00001, 0x080000, CRC(7321174d) SHA1(95f8426f1a3f31b285c2bb448756fb79050cc1bb) )
	ROM_LOAD16_BYTE( "95417405.evn", 0x00000, 0x080000, CRC(b8522473) SHA1(b89f5ce736e32f380eb7b8249d54499eda8f95dc) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008524.bin", 0x0000, 0x0ec9a6, CRC(a585c613) SHA1(dbe4f3b8584b92012e84d48c232b31a0fba6e20c) )
ROM_END


ROM_START( sc_wok )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "p3218p11.hi", 0x00000, 0x080000, CRC(351f4f4b) SHA1(81e7c2f7475f9af6e0006bcd189954931a3438ef) )
	ROM_LOAD16_BYTE( "p3218p11.lo", 0x00001, 0x080000, CRC(8e3238c0) SHA1(cfcb2318ce00f427ffe67a5b4bbbd43685e1e0ff) )
	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "p3218s11.hi", 0x00000, 0x080000, CRC(0fb2b822) SHA1(b05cb0f5598c4ad11da9afd35ecb1cdb123589fd) )
	ROM_LOAD16_BYTE( "p3218s11.lo", 0x00001, 0x080000, CRC(21e8ff34) SHA1(4abaa43f72031053e6724bd78ea25b4f1f1ded6c) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008811.bin", 0x0000, 0x100000, CRC(0aae3aea) SHA1(a13ca57b4ff95022392b6bf06065593c3271637a) )
	ROM_LOAD( "95008812.bin", 0x0000, 0x100000, CRC(4a48eabd) SHA1(30dc0cccc636c1472b7577353c1db8e88242bba4) )
ROM_END


ROM_START( sc_u1337 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )

	ROM_REGION( 0x1000000, "adder5", ROMREGION_ERASEFF )
	ROM_LOAD( "39211337.bin", 0x0000, 0xa9136a, CRC(4e984598) SHA1(8e5af7faeb7fb650f7bd44e5e7b3c1162514d15f) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_u1396 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	// 95411395.hi = 95411395.hi           sc4lotrr   Lord Of The Rings - Return Of The King (Bellfruit) (Scorpion 4)
	ROM_LOAD16_BYTE( "95411396.lo", 0x00001, 0x080000, CRC(4ad5c0fa) SHA1(8b881cd9ee1440b48644bf9cdf93637b74c75cb2) )
	ROM_LOAD16_BYTE( "95411397.hi", 0x00000, 0x080000, CRC(78acfb4e) SHA1(1d9b251a73bfd8452c1842c0a96c020c1d123906) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_u6606 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416606.lo", 0x00001, 0x080000, CRC(f8698061) SHA1(ffa9cdd15a76f4185538abdd9fa208d79887bba3) )
	ROM_LOAD16_BYTE( "95416607.hi", 0x00000, 0x080000, CRC(9cb25cd4) SHA1(ea5e35e5e7a78b786442810785b83e6b7993984a) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_u7606 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95417606.lo", 0x00001, 0x080000, CRC(aed7276a) SHA1(36ce9bda535d3eae76d8d86e74c9afc09b37ef04) )
	ROM_LOAD16_BYTE( "95417607.hi", 0x00000, 0x080000, CRC(f29bec42) SHA1(d29fa197c8bb17ca5a6632c19c0850416c2c9f57) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END


ROM_START( sc_rhr )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95416688.lo", 0x00001, 0x080000, CRC(a6eca55c) SHA1(f7a2386053ed6076242c1bf276ae2f8d3611491b) )
	ROM_LOAD16_BYTE( "95416689.hi", 0x00000, 0x080000, CRC(4899c647) SHA1(ea44672d797c406a8d5fb829f43257eaa2f661fd) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95416690.lo", 0x00001, 0x080000, CRC(4632a223) SHA1(0e1d998f03bbe9d0292500383a1444ae53e91f4d) )
	ROM_LOAD16_BYTE( "95416691.hi", 0x00000, 0x080000, CRC(f2aa4607) SHA1(1c0491b3094d9407724e63757c7e667155408778) )
	ROM_LOAD16_BYTE( "95417688.lo", 0x00001, 0x080000, CRC(9dc8eb48) SHA1(7c32d52686e7b154540d0c8717b4dea2b35b95b2) )
	ROM_LOAD16_BYTE( "95417689.hi", 0x00000, 0x080000, CRC(d9a00561) SHA1(446ec41e9364e2606d704d36a8779e538d407100) )
	ROM_LOAD16_BYTE( "95417690.lo", 0x00001, 0x080000, CRC(53cba141) SHA1(5f02cad66703bda185b36f59bc46bf583e3afd03) )
	ROM_LOAD16_BYTE( "95417691.hi", 0x00000, 0x080000, CRC(7bdb4c8c) SHA1(95034cb6f401368be6e6cb4013bcadaacc805a17) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END

ROM_START( sc_po8 )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95410072.odd", 0x00001, 0x080000, CRC(8074a508) SHA1(c369bfefbc402baac250e3fa92344e90dc39b5f1) )
	ROM_LOAD16_BYTE( "95410073.evn", 0x00000, 0x080000, CRC(c7e741b6) SHA1(6fd91ab8178060a35cd8a03ed432f897016c3874) )

	ROM_REGION( 0x400000, "altrevs", 0 )
	ROM_LOAD16_BYTE( "95410630.odd", 0x00001, 0x080000, CRC(4bba9faa) SHA1(f00b03c83c109ba9a51c6df097678ab5e6d1893f) )
	ROM_LOAD16_BYTE( "95410631.evn", 0x00000, 0x080000, CRC(67ea26f9) SHA1(ee431d26addb4295194d2c64fe41ea932efba7b4) )
	ROM_LOAD16_BYTE( "95410632.odd", 0x00001, 0x080000, CRC(ea53cd6c) SHA1(c4d90fbaccf0b99b293a789a3c36c5ce30a383a4) )
	ROM_LOAD16_BYTE( "95410633.evn", 0x00000, 0x080000, CRC(2f3b47cc) SHA1(72a6315d96f78eeb8d275b94698d0a6a6d6dda25) )
	ROM_LOAD16_BYTE( "95410780.odd", 0x00001, 0x080000, CRC(71c1e1d8) SHA1(bf6cf3a0558444c0d6b589a829b41897187b3212) )
	ROM_LOAD16_BYTE( "95410781.evn", 0x00000, 0x080000, CRC(d65ab66f) SHA1(9c8433cda1321707fad421ef832df4a71b49ea72) )
	ROM_LOAD16_BYTE( "95410782.odd", 0x00001, 0x080000, CRC(5131bf33) SHA1(f5f4ba29468c8acf3461a56a83146215933ad803) )
	ROM_LOAD16_BYTE( "95410783.evn", 0x00000, 0x080000, CRC(32ff0966) SHA1(cf8bd00c7723e995be4c131c79adbb365c7f75e0) )
	ROM_LOAD16_BYTE( "95411072.odd", 0x00001, 0x080000, CRC(680a2308) SHA1(d00958222ef7f6194741ebf65ba1c3024380a1fb) )
	ROM_LOAD16_BYTE( "95411073.evn", 0x00000, 0x080000, CRC(23cbe503) SHA1(4533ab7a043d8210215b442fd72c122d23797737) )
	ROM_LOAD16_BYTE( "95411074.odd", 0x00001, 0x080000, CRC(d9789364) SHA1(1454819151cd13afb589607c44f521cb9987dead) )
	ROM_LOAD16_BYTE( "95411075.evn", 0x00000, 0x080000, CRC(1f761219) SHA1(3d54e31e3be19062d7837f7342347e48b8033410) )
	ROM_LOAD16_BYTE( "95411630.odd", 0x00001, 0x080000, CRC(3fa173cf) SHA1(ee19dd50bad4b482a20bd17d9e8ba7e45b3ae550) )
	ROM_LOAD16_BYTE( "95411631.evn", 0x00000, 0x080000, CRC(e3dc69b5) SHA1(b91e5569ac83bb0e7c8ba9ad4b6b6b4530413f2a) )
	ROM_LOAD16_BYTE( "95411632.odd", 0x00001, 0x080000, CRC(9e482109) SHA1(3dda3167f48848bb497b0c218913af16f500dc72) )
	ROM_LOAD16_BYTE( "95411633.evn", 0x00000, 0x080000, CRC(ab0d0880) SHA1(b5de6dc648e5b349ba6f0aa93bf54840ae74f334) )
	// check where these actually belong!
	//95411780.odd = 95411780.odd          sc4pstat   Paystation (Qps) (Scorpion 4)
	//95411781.evn = 95411781.evn          sc4pstat   Paystation (Qps) (Scorpion 4)
	//95411782.odd = 95411782.odd          sc4pstat   Paystation (Qps) (Scorpion 4)
	//95411783.evn = 95411783.evn          sc4pstat   Paystation (Qps) (Scorpion 4)
	ROM_LOAD16_BYTE( "95412078.odd", 0x00001, 0x080000, CRC(e36d9e85) SHA1(a33bb8ec8e82e4b25e2716c6b420639d38e58497) )
	ROM_LOAD16_BYTE( "95412079.evn", 0x00000, 0x080000, CRC(0e20cadd) SHA1(885cf084b28d6a341efa568f008c7f5223e2206c) )
	ROM_LOAD16_BYTE( "95412080.odd", 0x00001, 0x080000, CRC(02185e38) SHA1(011968d6689d445cc70d63e1c8e5643f2639629e) )
	ROM_LOAD16_BYTE( "95412081.evn", 0x00000, 0x080000, CRC(3463680b) SHA1(b75dd8dfe04299c375e8387cf53e7f10e175900f) )
	ROM_LOAD16_BYTE( "95413078.odd", 0x00001, 0x080000, CRC(e30c37b4) SHA1(41a94ca95b297d2d52db4f6c8ef2573e311a7d29) )
	ROM_LOAD16_BYTE( "95413079.evn", 0x00000, 0x080000, CRC(1568a9cf) SHA1(2b76f8e55fa0305895683516f13099116aff6644) )
	ROM_LOAD16_BYTE( "95413080.odd", 0x00001, 0x080000, CRC(6069cfe3) SHA1(a5cb4b520a6a24cfdf6bf3eed8ddee043789bf17) )
	ROM_LOAD16_BYTE( "95413081.evn", 0x00000, 0x080000, CRC(b0552747) SHA1(8da04c01ea3129cbda9cf651029e54379d981303) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
	ROM_LOAD( "95008416.bin", 0x0000, 0x0fe66d, CRC(9ae69b6a) SHA1(7bb94d7c941c64c1ea53e391b3f66a6e1b483417) )
ROM_END

ROM_START( sc_wag )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_LOAD16_BYTE( "95402516.lo", 0x00001, 0x080000, CRC(afae6512) SHA1(f07a6a21492167488117980828d4885de43a2d8f) )
	ROM_LOAD16_BYTE( "95402517.hi", 0x00000, 0x080000, CRC(b69e7146) SHA1(f84754625d9fb9bd7633105de88faf0f9cbbb6b2) )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )
ROM_END

// unsorted roms, mostly sound, probably for undumped sets, but kept here on the chance that they belong
// with some of the above which could be mislabeled
ROM_START( sc_unsrt )
	ROM_REGION( 0x400000, "maincpu", ROMREGION_ERASEFF )
	ROM_REGION( 0x400000, "ymz", ROMREGION_ERASE00 )

	// Ali G Boyacash (Bellfruit)
	ROM_LOAD( "95008179.bin", 0x0000, 0x100000, CRC(14b735fa) SHA1(7533510de6687747fc635a5bf66da0a58c6fc718) )
	ROM_LOAD( "95008180.bin", 0x0000, 0x100000, CRC(ec441f54) SHA1(7e8bec5cd293f29fca2363e5f1ab278a532b8a47) )
	// Bank It (Bellfruit)
	ROM_LOAD( "95008545.bin", 0x0000, 0x100000, CRC(8ec806e1) SHA1(1af9dd83e4da4848b7d84ee23bee29f9bcf2b404) )
	// Cash Climber (Bellfruit)
	ROM_LOAD( "95008115.bin", 0x0000, 0x100000, CRC(c3b2faac) SHA1(2c54d48f5798178006e82654abed42df43457e25) )
	ROM_LOAD( "95008116.bin", 0x0000, 0x100000, CRC(84e663f0) SHA1(cb0275cc3761aa16640ac5383125e2098ba80850) )
	// Cash In The Box (Bellfruit)
	ROM_LOAD( "95008135.bin", 0x0000, 0x100000, CRC(08d7040d) SHA1(c62ce0de0d57451d0c02f0796573eef1edcab947) )
	ROM_LOAD( "95008136.bin", 0x0000, 0x100000, CRC(456cc709) SHA1(85ae7a81fbd1dc13b4395baefea82ba31e6c4d3f) )
	// Cash Splash (Qps)
	ROM_LOAD( "95008403.bin", 0x0000, 0x0facbf, CRC(cf3969bb) SHA1(4cb6fb4e536882a11bb6c1548ffb94daea70ca5f) )
	// Casino Triple Classic (Bellfruit)
	// 95008423.bin =
	// 95008423.bin          sc4bar7    Bar 7's (Bellfruit) (Scorpion 4)
	// 95008423.bin          sc4druby   Diamonds & Rubys (Bellfruit) (Scorpion 4)
	// 95008423.bin          sc4goldw   Golden Winner (Bellfruit) (Scorpion 4)
	// Champion Chips (Bellfruit)
	ROM_LOAD( "95008558.bin", 0x0000, 0x100000, CRC(6c032de9) SHA1(3aed801f8b6f2d62fffa03054afd8ff1c3ff3ac3) )
	// Clever Clogs (Mazooma)
	ROM_LOAD( "95008361.bin", 0x0000, 0x0ff54f, CRC(d1cc7b58) SHA1(32328e0e56bbf65e91e32de8802edce38f0abc65) )
	// Costa Del Dosh (Bellfruit)
	ROM_LOAD( "95008420.bin", 0x0000, 0x100000, CRC(cce5f09a) SHA1(8b1f30eb1c48a3e3c6c403f28e97918ddac51033) )
	// Deal Or No Deal Red Hot (Bellfruit)
	ROM_LOAD( "95009063.bin", 0x0000, 0x100000, CRC(52b4e9a1) SHA1(2ff66ed13b2307ebc24500b920585f9cf04b0f4e) )
	ROM_LOAD( "95009064.bin", 0x0000, 0x100000, CRC(1a94524b) SHA1(f5fa0904682888131ae359671ceeff0336adf5dd) )
	// Deal Or No Deal Spank The Banker (Bellfruit)
	ROM_LOAD( "95009059.bin", 0x0000, 0x100000, CRC(a3264545) SHA1(94b324c93edad7975ee152a7daaf7f6d7b91cb5e) )
	ROM_LOAD( "95009060.bin", 0x0000, 0x100000, CRC(3cb58cf3) SHA1(f1eaeba8633c42ef43b4b32deb154f0683d8d42a) )
	// Double Agent (Bellfruit)
	ROM_LOAD( "95008147.bin", 0x0000, 0x100000, CRC(c74ce6b4) SHA1(426ac64234bc07ba676570b90e28fa7439d68eaa) )
	ROM_LOAD( "95008148.bin", 0x0000, 0x100000, CRC(ea146768) SHA1(2ef2e619d0c48f150619ba2176aed0fc42d43ef8) )
	// Down Mexico Way (Mazooma)
	ROM_LOAD( "95008379.bin", 0x0000, 0x0f1c34, CRC(3d18e770) SHA1(cdcc600a14329c645ff35fefc355a9ff6b845224) )
	// Firecracker (Bellfruit)
	ROM_LOAD( "95004262.bin", 0x0000, 0x080000, CRC(3f5fad9e) SHA1(528a2803baa155d66cb896f643f858238aa7f189) )
	ROM_LOAD( "95712394.bin", 0x0000, 0x000800, CRC(2658fedf) SHA1(32125bc5a58ddd49f8be36c7cb2ebbbdf2cb292b) )
	ROM_LOAD( "95712395.bin", 0x0000, 0x000800, CRC(d5df2317) SHA1(66f25a2a11657653f5eed3e8196d9b52119236c3) )
	// Golden Palace (Qps)
	ROM_LOAD( "61000120.bin", 0x0000, 0x080000, CRC(a2cdc045) SHA1(5f2534683f2399e2fe0e8686be0f2e42e1b04a74) )
	// Grid Lock (Mazooma)
	ROM_LOAD( "95008401.bin", 0x0000, 0x0e486b, CRC(d81d7736) SHA1(8046b95482058ea55735a278dd3b71f708d66b1a) )
	// Hi Lo Oxo (Bellfruit)
	ROM_LOAD( "95004278.bin", 0x0000, 0x080000, CRC(c21ff246) SHA1(56345ee0af02a51a96df98ed01ffb6202b8cd772) )
	// Jackpot Bars (Bellfruit)
	ROM_LOAD( "95008501.bin", 0x0000, 0x080000, CRC(dd7937a8) SHA1(7aef4f451f307d0074992cdda3401fde0112b977) )
	// Lollywood (Mazooma)
	ROM_LOAD( "95004332.bin", 0x0000, 0x0a5e3d, CRC(266d4371) SHA1(8e72022db71b432f53826720aac79901e8ba37af) )
	// On The Up (Bellfruit)
	ROM_LOAD( "95008298.bin", 0x0000, 0x100000, CRC(96a487da) SHA1(491c5133757d6f26c106d122a29cd7ed454c2353) )
	// Pay Back (Bellfruit)
	ROM_LOAD( "95008591.bin", 0x0000, 0x100000, CRC(1cecf466) SHA1(7c54acf00b8dd4272843a7b3b3d60dc683a5f6d8) )
	// Pharaoh's Treasure (Bellfruit)
	ROM_LOAD( "95008534.bin", 0x0000, 0x100000, CRC(fe599d0a) SHA1(f5f31ea43bfc446f2b3ed1c0c88b718428addbdf) )
	// Pick 'n' Mix (Bellfruit)
	ROM_LOAD( "95008077.bin", 0x0000, 0x100000, CRC(32a34d15) SHA1(c23ebd30165ebc80098fd956755b98cb433a3e28) )
	ROM_LOAD( "95008078.bin", 0x0000, 0x100000, CRC(d4832994) SHA1(bdde017bb2f876252d8984a0c5b60950669f579e) )
	// Powerball (Mazooma)
	ROM_LOAD( "95004218", 0x0000, 0x080000, CRC(4e90206c) SHA1(475fe57a4f08b17acaf63f0863a705fd70b910db) )
	ROM_LOAD( "95004219", 0x0000, 0x080000, CRC(f7e344a2) SHA1(7f2411373fdd49d7ef3c6990fb3cc1fe93ca3348) )
	// Racing Cert (Bellfruit)
	ROM_LOAD( "95008106.bin", 0x0000, 0x100000, CRC(403935bb) SHA1(471cbc822dc2765e5c32948f7b25b2301ddab990) )
	// Random Winner (Bellfruit)
	ROM_LOAD( "95008569.bin", 0x0000, 0x080000, CRC(1a966dd9) SHA1(1314b7ee5b6e22d504e12e9eba3b2b88f6f5d64c) )
	// Rat Race (Bellfruit)
	ROM_LOAD( "95008422.bin", 0x0000, 0x100000, CRC(5d9a6af7) SHA1(b32fd97d0e248f59b199c143f8fc2deddb4ec5fc) )
	// Silver 'n' Gold (Bellfruit)
	ROM_LOAD( "95008125.bin", 0x0000, 0x100000, CRC(ad1d69d5) SHA1(66d07488fdec6b1c65b41e20d74d5add22746334) )
	ROM_LOAD( "95008126.bin", 0x0000, 0x100000, CRC(28f979a8) SHA1(ce480ab19b3066343bf88d2fda78dc6a71cd61e2) )
	// Swag (Mazooma)
	ROM_LOAD( "95008377.bin", 0x0000, 0x0f6813, CRC(55fad813) SHA1(efa07cd5aa68e1372e8de6bb955ee114cf74ae9c) )
	// Ticket To Ride (Bellfruit)
	ROM_LOAD( "95008580.bin", 0x0000, 0x100000, CRC(f6019676) SHA1(535896a199047e61274d82413904580572523e2a) )
	// Trick Shot (Bellfruit)
	ROM_LOAD( "95008402.bin", 0x0000, 0x100000, CRC(d9cbc877) SHA1(aa35f9da3d7d470ebc712a958ee2f2d2646c0cce) )
	ROM_LOAD( "95008458.bin", 0x0000, 0x100000, CRC(845b4fec) SHA1(4f4089bd4db0fbb50594d0e96e7d6198d85c81ba) )
	ROM_LOAD( "95008470.bin", 0x0000, 0x100000, CRC(b5162561) SHA1(28feebc4de68264b92325e58bbf95458533bde7f) )
	ROM_LOAD( "95008513.bin", 0x0000, 0x080000, CRC(e57f076a) SHA1(9c9c4686cc39849748f212e073a0959ff93d0ed3) )
	// Trick Shot Club (Bellfruit) [c]
	ROM_LOAD( "95008497.bin", 0x0000, 0x100000, CRC(4f7907bd) SHA1(cf5dab2a40a07293b727e8a6f35dc1a57cdec6fc) )
	// Uncle Sam (Mazooma)
	ROM_LOAD( "95004360.bin", 0x0000, 0x03ab65, CRC(b357535e) SHA1(b9c03ca1c29f6414ac18e454a2a98ed24799fa92) )
	// Up Your Streak (Bellfruit)
	ROM_LOAD( "95008404.bin", 0x0000, 0x100000, CRC(4197f3d1) SHA1(5529090d7d396054b0b4bdf251c6c86c76ed6648) )
	// Van Helsing (Bellfruit)
	ROM_LOAD( "95008451.bin", 0x0000, 0x100000, CRC(061d309e) SHA1(588d0ecf6e27815054f4e164c44f3f1464be832b) )
	ROM_LOAD( "95008452.bin", 0x0000, 0x100000, CRC(08c35e66) SHA1(531f532e55303621d17e497cddc9398745a18211) )
	// Who Wants To Be A Millionaire Club (Bellfruit) [c]
	// 95008197.bin = 95008197.bin          sc4legcb   Who Wants To Be A Legionnaire Club (Bellfruit) (Scorpion 4)
	// 95008198.bin = 95008198.bin          sc4legcb   Who Wants To Be A Legionnaire Club (Bellfruit) (Scorpion 4)
ROM_END



/* Scorpion 4 */

GAME( 200?, sc4tst		,0,			sc4, sc4, 0, ROT0, "BFM","Scorpion 4 Test Rig (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )

GAME( 200?, sc4bbust	,0,			sc4, sc4, 0, ROT0, "Mazooma","Blockbuster (Mazooma) (Scorpion 4)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc4pstat	,0,			sc4, sc4, 0, ROT0, "QPS","Paystation (Qps) (Scorpion 4)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc4cvani	,0,			sc4, sc4, 0, ROT0, "QPS","Cashvania (Qps) (Scorpion 4)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc4cvclb	,0,			sc4, sc4, 0, ROT0, "QPS","Cashvania Club (Qps) (Scorpion 4)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc4spark	,0,			sc4, sc4, 0, ROT0, "BFM","South Park (BFM) (Scorpion 4)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc4brkfs	,0,			sc4, sc4, 0, ROT0, "BFM","The Big Breakfast (BFM) (Scorpion 4)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc4gslam	,0,			sc4, sc4, 0, ROT0, "BFM","Grandslam Club (BFM) (Scorpion 4)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )

/* Scorpion 4 + Adder 4 */

GAME( 200?, ad4skill	,0,			sc4_adder4, sc4, 0, ROT0, "BFM","Skill Dice (BFM) (Scorpion 4 + Adder 4)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )

/* Unsorted */

GAME( 200?, sc_ivply	,0,			sc4, sc4, 0, ROT0, "BFM","4 Play (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_abra		,0,			sc4, sc4, 0, ROT0, "Qps","Abracadabra (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_acesh	,0,			sc4, sc4, 0, ROT0, "Mazooma","Aces High (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_adren	,0,			sc4, sc4, 0, ROT0, "Mazooma","Adrenalin (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_alad		,0,			sc4, sc4, 0, ROT0, "Mazooma","Aladdin's Cave (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_adjb		,0,			sc4, sc4, 0, ROT0, "BFM","Ant & Dec's Jiggy Bank (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_adwta	,0,			sc4, sc4, 0, ROT0, "BFM","Ant & Dec's Saturday Night Takeaway Win The Ads (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_a40		,0,			sc4, sc4, 0, ROT0, "Mazooma","Around The Board In 40 Days (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_a40cl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Around The Board In 40 Days Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_aztec	,0,			sc4, sc4, 0, ROT0, "BFM","Aztec (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_botn		,0,			sc4, sc4, 0, ROT0, "Qps","Back Of The Net (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_broll	,0,			sc4, sc4, 0, ROT0, "Mazooma","Bank Roll (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bankb	,0,			sc4, sc4, 0, ROT0, "Qps","Bankety Bank (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bantm	,0,			sc4, sc4, 0, ROT0, "Mazooma","Bantam Of The Opera (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bar7		,0,			sc4, sc4, 0, ROT0, "BFM","Bar 7's (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_batl		,0,			sc4, sc4, 0, ROT0, "BFM","Battleships & Cruisers (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bed		,0,			sc4, sc4, 0, ROT0, "Mazooma","Bedazzled (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bedcl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Bedazzled Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bblas	,0,			sc4, sc4, 0, ROT0, "Mazooma","Big Blaster (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bigdl	,0,			sc4, sc4, 0, ROT0, "Qps","Big Deal (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bingb	,0,			sc4, sc4, 0, ROT0, "Mazooma","Bingo Belle (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bb		,0,			sc4, sc4, 0, ROT0, "Qps","Blankety Bank (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bbclb	,0,			sc4, sc4, 0, ROT0, "Qps","Blankety Bank Club (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_blast	,0,			sc4, sc4, 0, ROT0, "Qps","Blast Off (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_blue		,0,			sc4, sc4, 0, ROT0, "Mazooma","Blue Rinse (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bob		,0,			sc4, sc4, 0, ROT0, "Mazooma","Bobby Dazzler (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bobcl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Bobby Dazzler Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bonbx	,0,			sc4, sc4, 0, ROT0, "Mazooma","Bonus Bar X (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_brksp	,0,			sc4, sc4, 0, ROT0, "Mazooma","Break The Spell (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_brix		,0,			sc4, sc4, 0, ROT0, "Nova","Brix (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bugs		,0,			sc4, sc4, 0, ROT0, "BFM","Bugs Money (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bull		,0,			sc4, sc4, 0, ROT0, "BFM","Bullseye (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bulcl	,0,			sc4, sc4, 0, ROT0, "BFM","Bullseye Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_butch	,0,			sc4, sc4, 0, ROT0, "BFM","Butch Cashidy & The Sundance Quid (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cabin	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cabin Fever (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_canca	,0,			sc4, sc4, 0, ROT0, "Mazooma","Can Can Cash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_captn	,0,			sc4, sc4, 0, ROT0, "Qps","Captain Cash (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cari		,0,			sc4, sc4, 0, ROT0, "Qps","Caribbean Cash (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_carry	,0,			sc4, sc4, 0, ROT0, "BFM","Carry On Winning (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cmous	,0,			sc4, sc4, 0, ROT0, "Qps","Cash & Mouse (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cburn	,0,			sc4, sc4, 0, ROT0, "Qps","Cash 'n' Burn (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cnfr		,0,			sc4, sc4, 0, ROT0, "BFM","Cash 'n' Fruit (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cad		,0,			sc4, sc4, 0, ROT0, "Qps","Cash Adder (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cadcl	,0,			sc4, sc4, 0, ROT0, "Qps","Cash Adder Club (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cbaz		,0,			sc4, sc4, 0, ROT0, "BFM","Cash Bazaar Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cblas	,0,			sc4, sc4, 0, ROT0, "BFM","Cash Blast (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cconx	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cash Connexion (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ccrus	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cash Crusaders (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cerup	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cash Eruption (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cexpl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cash Explosion (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_chand	,0,			sc4, sc4, 0, ROT0, "BFM","Cash In Hand (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cinv		,0,			sc4, sc4, 0, ROT0, "BFM","Cash Invaders (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clash	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cash On The Lash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cr		,0,			sc4, sc4, 0, ROT0, "Qps","Cash Raker (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crcl		,0,			sc4, sc4, 0, ROT0, "Qps","Cash Raker Club (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cashn	,0,			sc4, sc4, 0, ROT0, "BFM","Cashanova (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cashm	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cashanova (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cckey	,0,			sc4, sc4, 0, ROT0, "BFM","Casino Crazy Keys (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ckx		,0,			sc4, sc4, 0, ROT0, "Mazooma","Casino King X (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_casry	,0,			sc4, sc4, 0, ROT0, "Mazooma","Casino Royale (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_casxt	,0,			sc4, sc4, 0, ROT0, "Mazooma","Casino Xtravaganza  (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_chavi	,0,			sc4, sc4, 0, ROT0, "BFM","Chav It (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_chavy	,0,			sc4, sc4, 0, ROT0, "Mazooma","Chavy Chase (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_chick	,0,			sc4, sc4, 0, ROT0, "Mazooma","Chickendales (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_chub		,0,			sc4, sc4, 0, ROT0, "Mazooma","Chubby Does Vegas (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cla7		,0,			sc4, sc4, 0, ROT0, "Mazooma","Classic 7s (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ccogs	,0,			sc4, sc4, 0, ROT0, "Qps","Clever Cogs (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cclas	,0,			sc4, sc4, 0, ROT0, "BFM","Club Class (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clclo	,0,			sc4, sc4, 0, ROT0, "Mazooma","Club Clouseau (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clue		,0,			sc4, sc4, 0, ROT0, "Mazooma","Cluedo (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clucl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cluedo Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_colos	,0,			sc4, sc4, 0, ROT0, "BFM","Colossus (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cmani	,0,			sc4, sc4, 0, ROT0, "BFM","Colour Mania (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cj		,0,			sc4, sc4, 0, ROT0, "BFM","Cool Jewels (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cjcl		,0,			sc4, sc4, 0, ROT0, "BFM","Cool Jewels Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ctl		,0,			sc4, sc4, 0, ROT0, "BFM","Cop The Lot (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ctlcl	,0,			sc4, sc4, 0, ROT0, "BFM","Cop The Lot Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crcc		,0,			sc4, sc4, 0, ROT0, "BFM","Cops 'n' Robbers Club Classic (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crcp		,0,			sc4, sc4, 0, ROT0, "BFM","Cops 'n' Robbers Club Platinum (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_srgc		,0,			sc4, sc4, 0, ROT0, "BFM","Cops 'n' Robbers Gold Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crsc		,0,			sc4, sc4, 0, ROT0, "BFM","Cops 'n' Robbers Safe Cracker (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_coro		,0,			sc4, sc4, 0, ROT0, "Mazooma","Coronation Street (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_corcl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Coronation Street Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cyc		,0,			sc4, sc4, 0, ROT0, "Mazooma","Count Yer Cash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cyccl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Count Yer Cash Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_count	,0,			sc4, sc4, 0, ROT0, "BFM","Countdown (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crzcs	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Casino (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cclim	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Climber (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cf		,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Fruits (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfqps	,0,			sc4, sc4, 0, ROT0, "Qps","Crazy Fruits (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfcla	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Fruits Classic (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfclb	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Fruits Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfdu		,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Fruits Down Under (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfg		,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Fruits Gold (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfgcl	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Fruits Gold Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crzgn	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Gang (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crzky	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Keys (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crzwl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Crazy World (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cccsh	,0,			sc4, sc4, 0, ROT0, "Mazooma","Criss Cross Cash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ccc		,0,			sc4, sc4, 0, ROT0, "BFM","Criss Cross Crazy (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crnjw	,0,			sc4, sc4, 0, ROT0, "BFM","Crown Jewels (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_db		,0,			sc4, sc4, 0, ROT0, "Mazooma","D & B (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_daylt	,0,			sc4, sc4, 0, ROT0, "BFM","Daylight Robbery (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dnd		,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndbb	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Break The Bank (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndcl	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dnddd	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Double Deal Or No Deal (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndhf	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Hall Of Fame (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndys	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal It's Your Show (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndlp	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Let's Play Deal Or No Deal (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndra	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Red Alert (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndbd	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Big Deal (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndbr	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Big Reds (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndcc	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Crazy Chair (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dnddw	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Deal Wheel (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dnddf	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Dream Factory (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndpg	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Perfect Game (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndtp	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Power (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndww	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Walk Of Wealth (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndtr	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Think Red (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndwb	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal What's In Your Box (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_deepi	,0,			sc4, sc4, 0, ROT0, "Mazooma","Deep Impact (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_derby	,0,			sc4, sc4, 0, ROT0, "BFM","Demolition Derby (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dmine	,0,			sc4, sc4, 0, ROT0, "BFM","Diamond Mine (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_druby	,0,			sc4, sc4, 0, ROT0, "BFM","Diamonds & Rubys (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_disco	,0,			sc4, sc4, 0, ROT0, "Mazooma","Disco Inferno (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ddosh	,0,			sc4, sc4, 0, ROT0, "BFM","Doctor Dosh (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dbldm	,0,			sc4, sc4, 0, ROT0, "Qps","Double Diamond (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dblfr	,0,			sc4, sc4, 0, ROT0, "Qps","Double Frenzy (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_darw		,0,			sc4, sc4, 0, ROT0, "Qps","Dough & Arrow (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dhh		,0,			sc4, sc4, 0, ROT0, "BFM","Dough Ho Ho (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dough	,0,			sc4, sc4, 0, ROT0, "BFM","Dough Selecta (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ducks	,0,			sc4, sc4, 0, ROT0, "Mazooma","Ducks Of Hazzard (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_duckq	,0,			sc4, sc4, 0, ROT0, "Qps","Ducks Of Hazzard (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dyna		,0,			sc4, sc4, 0, ROT0, "BFM","Dynamite (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_easy		,0,			sc4, sc4, 0, ROT0, "BFM","Easy Streak (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_emmer	,0,			sc4, sc4, 0, ROT0, "Mazooma","Emmerdale (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_evol		,0,			sc4, sc4, 0, ROT0, "Qps","Evolution (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fguy		,0,			sc4, sc4, 0, ROT0, "BFM","Family Guy (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fastf	,0,			sc4, sc4, 0, ROT0, "Mazooma","Fast 'n' Furious (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ffru		,0,			sc4, sc4, 0, ROT0, "Qps","Fast Fruit (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fbspn	,0,			sc4, sc4, 0, ROT0, "BFM","Fat Boy Spin (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fever	,0,			sc4, sc4, 0, ROT0, "BFM","Fever (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fpitc	,0,			sc4, sc4, 0, ROT0, "BFM","Fever Pitch (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fevnx	,0,			sc4, sc4, 0, ROT0, "BFM","Fever The Next (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_film		,0,			sc4, sc4, 0, ROT0, "BFM","Film Premiere (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fcc		,0,			sc4, sc4, 0, ROT0, "BFM","Firecracker Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fire		,0,			sc4, sc4, 0, ROT0, "Mazooma","Firepower (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fwp		,0,			sc4, sc4, 0, ROT0, "Mazooma","Five Ways Pays (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fwpcs	,0,			sc4, sc4, 0, ROT0, "Mazooma","Five Ways Pays Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fbcrz	,0,			sc4, sc4, 0, ROT0, "BFM","Football Crazy (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fd7th	,0,			sc4, sc4, 0, ROT0, "BFM","Frankie Dettori's 7th Heaven (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_frboo	,0,			sc4, sc4, 0, ROT0, "BFM","Frooty Booty (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_frenz	,0,			sc4, sc4, 0, ROT0, "BFM","Fruit Frenzy (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ftopi	,0,			sc4, sc4, 0, ROT0, "Qps","Fruitopia (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_frsu		,0,			sc4, sc4, 0, ROT0, "BFM","Fruits 'n' Suits (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fmj		,0,			sc4, sc4, 0, ROT0, "Mazooma","Full Metal Jackpot (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fullt	,0,			sc4, sc4, 0, ROT0, "Qps","Full Throttle (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gamcs	,0,			sc4, sc4, 0, ROT0, "BFM","Game Casino, The (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_game		,0,			sc4, sc4, 0, ROT0, "BFM","Game, The (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ziggy	,0,			sc4, sc4, 0, ROT0, "Mazooma","Gettin Ziggy With It (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_glad		,0,			sc4, sc4, 0, ROT0, "Mazooma","Gladiator (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gldcl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Gladiator Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gd		,0,			sc4, sc4, 0, ROT0, "BFM","Gold Digger (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gdmz		,0,			sc4, sc4, 0, ROT0, "Mazooma","Gold Digger (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gdclb	,0,			sc4, sc4, 0, ROT0, "BFM","Gold Digger Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gfev		,0,			sc4, sc4, 0, ROT0, "Mazooma","Gold Fever (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gball	,0,			sc4, sc4, 0, ROT0, "BFM","Golden Balls (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gg		,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden Game (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ggcas	,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden Game Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gnc		,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden Game Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ghost	,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden Ghost (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ggrid	,0,			sc4, sc4, 0, ROT0, "Qps","Golden Grid (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ggcl		,0,			sc4, sc4, 0, ROT0, "Qps","Golden Grid Club (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_goldo	,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden Oldie (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gocas	,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden Oldie Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gshot	,0,			sc4, sc4, 0, ROT0, "Qps","Golden Shot (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_goldw	,0,			sc4, sc4, 0, ROT0, "BFM","Golden Winner (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gx		,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden X (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gxcas	,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden X Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gx3		,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden X Triple (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_goud		,0,			sc4, sc4, 0, ROT0, "BFM","Goudkoorts (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gag		,0,			sc4, sc4, 0, ROT0, "Mazooma","Grab A Granny (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gcb		,0,			sc4, sc4, 0, ROT0, "Mazooma","Grand Blaster Cash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ggg		,0,			sc4, sc4, 0, ROT0, "Mazooma","Grand Golden Game (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_greed	,0,			sc4, sc4, 0, ROT0, "BFM","Greedy Gonzalez (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gunp		,0,			sc4, sc4, 0, ROT0, "BFM","Gunpowder Slot (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hf		,0,			sc4, sc4, 0, ROT0, "BFM","Happy Fruits (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hfcl		,0,			sc4, sc4, 0, ROT0, "BFM","Happy Fruits Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hapnt	,0,			sc4, sc4, 0, ROT0, "BFM","Happy Notes (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_heatw	,0,			sc4, sc4, 0, ROT0, "BFM","Heatwave (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_helrd	,0,			sc4, sc4, 0, ROT0, "BFM","Hellraiser (Bellfruit) [Dutch] (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_helrs	,0,			sc4, sc4, 0, ROT0, "BFM","Hellraiser (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hellb	,0,			sc4, sc4, 0, ROT0, "BFM","Hells Bells (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hdd		,0,			sc4, sc4, 0, ROT0, "Mazooma","Hickory Dickory Dosh (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_himi		,0,			sc4, sc4, 0, ROT0, "Mazooma","High 'n' Mighty (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hi5		,0,			sc4, sc4, 0, ROT0, "BFM","High 5 (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sprng	,0,			sc4, sc4, 0, ROT0, "Mazooma","Highly Sprung (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hill		,0,			sc4, sc4, 0, ROT0, "BFM","Hill Billionaire (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hilo		,0,			sc4, sc4, 0, ROT0, "BFM","Hilowatha (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hiss		,0,			sc4, sc4, 0, ROT0, "Qps","Hissing Quid (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hitsh	,0,			sc4, sc4, 0, ROT0, "BFM","Hit Shot (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_holyw	,0,			sc4, sc4, 0, ROT0, "BFM","Hollywood (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hotdg	,0,			sc4, sc4, 0, ROT0, "BFM","Hot Dog (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hotpr	,0,			sc4, sc4, 0, ROT0, "BFM","Hot Property (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hotrd	,0,			sc4, sc4, 0, ROT0, "BFM","Hot Rod (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hotsh	,0,			sc4, sc4, 0, ROT0, "BFM","Hot Shots (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_h6cl		,0,			sc4, sc4, 0, ROT0, "BFM","Hot Six Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hotwd	,0,			sc4, sc4, 0, ROT0, "BFM","Hot Wad (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hyde		,0,			sc4, sc4, 0, ROT0, "Mazooma","Hyde & Streak (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hyper	,0,			sc4, sc4, 0, ROT0, "Mazooma","Hyperactive (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_celeb	,0,			sc4, sc4, 0, ROT0, "BFM","I'm A Celebrity (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_inspn	,0,			sc4, sc4, 0, ROT0, "Mazooma","Inner Spin (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ijob		,0,			sc4, sc4, 0, ROT0, "Mazooma","Italian Job (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ijclb	,0,			sc4, sc4, 0, ROT0, "Mazooma","Italian Job Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jack		,0,			sc4, sc4, 0, ROT0, "Mazooma","Jack The Kipper (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jjok		,0,			sc4, sc4, 0, ROT0, "BFM","Jackpot Jokers (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jjunc	,0,			sc4, sc4, 0, ROT0, "BFM","Jackpot Junction (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jjucl	,0,			sc4, sc4, 0, ROT0, "BFM","Jackpot Junction Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jiggn	,0,			sc4, sc4, 0, ROT0, "Nova","Jiggery Pockery (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jiggr	,0,			sc4, sc4, 0, ROT0, "Mazooma","Jiggery Pokery (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jive		,0,			sc4, sc4, 0, ROT0, "Mazooma","Jive Money (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jolly	,0,			sc4, sc4, 0, ROT0, "Qps","Jolly Jousting (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_juicy	,0,			sc4, sc4, 0, ROT0, "BFM","Juicy Jackpots Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jjc		,0,			sc4, sc4, 0, ROT0, "Mazooma","Jumping Jack Cash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jjf		,0,			sc4, sc4, 0, ROT0, "BFM","Jumping Jack Flash (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jbuck	,0,			sc4, sc4, 0, ROT0, "BFM","Jungle Bucks (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_kalei	,0,			sc4, sc4, 0, ROT0, "Qps","Kaleidoscope (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_kkong	,0,			sc4, sc4, 0, ROT0, "Mazooma","King Kong Cash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_knok		,0,			sc4, sc4, 0, ROT0, "Mazooma","Knockout (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lasv		,0,			sc4, sc4, 0, ROT0, "BFM","Las Vegas (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lir		,0,			sc4, sc4, 0, ROT0, "BFM","Let It Roll (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lined	,0,			sc4, sc4, 0, ROT0, "Mazooma","Line Dancer (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ldcas	,0,			sc4, sc4, 0, ROT0, "Mazooma","Line Dancer Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ldvcl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Little Devil Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ldvl		,0,			sc4, sc4, 0, ROT0, "Mazooma","Little Devil (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lockb	,0,			sc4, sc4, 0, ROT0, "BFM","Lock Buster (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lkbcl	,0,			sc4, sc4, 0, ROT0, "BFM","Lock Buster Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lotrr	,0,			sc4, sc4, 0, ROT0, "BFM","Lord Of The Rings - Return Of The King (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lotrf	,0,			sc4, sc4, 0, ROT0, "BFM","Lord Of The Rings - The Fellowship Of The Ring (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lotr2	,0,			sc4, sc4, 0, ROT0, "BFM","Lord Of The Rings - The Two Towers (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ltr2c	,0,			sc4, sc4, 0, ROT0, "BFM","Lord Of The Rings - The Two Towers Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lotrt	,0,			sc4, sc4, 0, ROT0, "BFM","Lord Of The Rings Triology (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_luck7	,0,			sc4, sc4, 0, ROT0, "Mazooma","Lucky 7s (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_luckb	,0,			sc4, sc4, 0, ROT0, "BFM","Lucky Balls (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_magci	,0,			sc4, sc4, 0, ROT0, "Qps","Magic Circle (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_magic	,0,			sc4, sc4, 0, ROT0, "Qps","Magic Poundabout (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_manic	,0,			sc4, sc4, 0, ROT0, "BFM","Manic Miner (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_maxim	,0,			sc4, sc4, 0, ROT0, "Mazooma","Maximus Cash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_maxcc	,0,			sc4, sc4, 0, ROT0, "Mazooma","Maximus Cash Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mmm		,0,			sc4, sc4, 0, ROT0, "Mazooma","Mental Money Monsters (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_miljo	,0,			sc4, sc4, 0, ROT0, "BFM","Miljonairs (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_milja	,0,			sc4, sc4, 0, ROT0, "BFM","Miljonairs Arcade (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mbags	,0,			sc4, sc4, 0, ROT0, "BFM","Money Bags (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mgr		,0,			sc4, sc4, 0, ROT0, "BFM","Money Go Round (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mmad		,0,			sc4, sc4, 0, ROT0, "Mazooma","Money Madness (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mspid	,0,			sc4, sc4, 0, ROT0, "BFM","Money Spider (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_monsp	,0,			sc4, sc4, 0, ROT0, "BFM","Money Spinner (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_msclb	,0,			sc4, sc4, 0, ROT0, "BFM","Money Spinner Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mtb		,0,			sc4, sc4, 0, ROT0, "BFM","Money To Burn (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mtbcl	,0,			sc4, sc4, 0, ROT0, "BFM","Money To Burn Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_m2m		,0,			sc4, sc4, 0, ROT0, "Mazooma","Money To Money (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_monob	,0,			sc4, sc4, 0, ROT0, "BFM","Monopoly (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_monod	,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly (Mazooma) [German] (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_monop	,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mcas		,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mclb		,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mdlx		,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Deluxe (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mdm		,0,			sc4, sc4, 0, ROT0, "BFM","Monopoly Double Money (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mhn		,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Here & Now (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mhp		,0,			sc4, sc4, 0, ROT0, "BFM","Monopoly Hot Property (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mmb		,0,			sc4, sc4, 0, ROT0, "BFM","Monopoly Money Bags (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mrh		,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Red Hot (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mrrcl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Road To Riches Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mr2r		,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Road To Riches (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mww		,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Wonders Of The World (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mwwcl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Wonders Of The World Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mont		,0,			sc4, sc4, 0, ROT0, "Qps","Montego Pay (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_motor	,0,			sc4, sc4, 0, ROT0, "BFM","Motorway Mania (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mou		,0,			sc4, sc4, 0, ROT0, "Qps","Move On Up (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_nmtj		,0,			sc4, sc4, 0, ROT0, "Mazooma","Never Mind The Jackpots (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_nmare	,0,			sc4, sc4, 0, ROT0, "BFM","A Nightmare On Elm Street (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_nudit	,0,			sc4, sc4, 0, ROT0, "Mazooma","Nudge It (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_oyf		,0,			sc4, sc4, 0, ROT0, "BFM","Off Your Face (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_opses	,0,			sc4, sc4, 0, ROT0, "BFM","Open Sesame (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_outlw	,0,			sc4, sc4, 0, ROT0, "BFM","Outlaw (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pacmn	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pac Man (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_paccs	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pac Man Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_paccl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pac Man Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pacpl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pac Man Plus (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pmani	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pac Mania (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_party	,0,			sc4, sc4, 0, ROT0, "Nova","Party Time (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_paytm	,0,			sc4, sc4, 0, ROT0, "BFM","Pay Time (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pgold	,0,			sc4, sc4, 0, ROT0, "BFM","Pharaoh's Gold (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_potp		,0,			sc4, sc4, 0, ROT0, "BFM","Pick Of The Pack (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pp		,0,			sc4, sc4, 0, ROT0, "Mazooma","Pink Panther (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ppcr		,0,			sc4, sc4, 0, ROT0, "Mazooma","Pink Panther Clouseau's Revenge (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ppclb	,0,			sc4, sc4, 0, ROT0, "Qps","Pink Panther Club (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ppctc	,0,			sc4, sc4, 0, ROT0, "BFM","Pink Panther Crack The Code (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ppdym	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pink Panther Double Your Money (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ppsag	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pink Panther Strikes Again (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pptp		,0,			sc4, sc4, 0, ROT0, "Qps","Pink Panther Think Pink (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pipe		,0,			sc4, sc4, 0, ROT0, "Mazooma","Piping Hot (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_plumb	,0,			sc4, sc4, 0, ROT0, "Qps","Plumb Crazy Club (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_polem	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pole Position (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_polen	,0,			sc4, sc4, 0, ROT0, "Nova","Pole Position (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_polic	,0,			sc4, sc4, 0, ROT0, "Qps","Police Squid (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pony		,0,			sc4, sc4, 0, ROT0, "BFM","Pony Express (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_popey	,0,			sc4, sc4, 0, ROT0, "Mazooma","Popeye (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_potsh	,0,			sc4, sc4, 0, ROT0, "Qps","Pot Shot (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pog		,0,			sc4, sc4, 0, ROT0, "BFM","Pots Of Gold (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pogcl	,0,			sc4, sc4, 0, ROT0, "BFM","Pots Of Gold Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pwcrz	,0,			sc4, sc4, 0, ROT0, "BFM","Power Crazy (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pwrpl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Power Play (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pwrsg	,0,			sc4, sc4, 0, ROT0, "Qps","Power Surge (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pwrbl	,0,			sc4, sc4, 0, ROT0, "BFM","Powerball (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pwrbq	,0,			sc4, sc4, 0, ROT0, "Qps","Powerball (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pircl	,0,			sc4, sc4, 0, ROT0, "BFM","The Prize Is Right Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pir		,0,			sc4, sc4, 0, ROT0, "BFM","The Prize Is Right (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pen1		,0,			sc4, sc4, 0, ROT0, "BFM","Public Enemy No1 (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_quart	,0,			sc4, sc4, 0, ROT0, "Mazooma","Quaterback (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_qmodo	,0,			sc4, sc4, 0, ROT0, "Qps","Quazzi Mo Dough (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_quidr	,0,			sc4, sc4, 0, ROT0, "Qps","Quid Rock (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_quidv	,0,			sc4, sc4, 0, ROT0, "Mazooma","Quid Vicious (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_redad	,0,			sc4, sc4, 0, ROT0, "BFM","Red Alert (Bellfruit) [Dutch] (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_redal	,0,			sc4, sc4, 0, ROT0, "BFM","Red Alert (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rdrag	,0,			sc4, sc4, 0, ROT0, "Qps","Red Dragon (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rdrcl	,0,			sc4, sc4, 0, ROT0, "Qps","Red Dragon Club (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ibiza	,0,			sc4, sc4, 0, ROT0, "BFM","Red Hot Ibiza (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rhx		,0,			sc4, sc4, 0, ROT0, "Mazooma","Red Hot X (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rhxcs	,0,			sc4, sc4, 0, ROT0, "Mazooma","Red Hot X Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rhxcl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Red Hot X Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_redsq	,0,			sc4, sc4, 0, ROT0, "Mazooma","Red Square (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_r2r		,0,			sc4, sc4, 0, ROT0, "Mazooma","Reel To Reel (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_relcz	,0,			sc4, sc4, 0, ROT0, "BFM","Reely Crazy (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rotc		,0,			sc4, sc4, 0, ROT0, "Mazooma","Return Of The Count (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rvlnx	,0,			sc4, sc4, 0, ROT0, "BFM","Revoluion The Next (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rvl		,0,			sc4, sc4, 0, ROT0, "BFM","Revolution (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_revo		,0,			sc4, sc4, 0, ROT0, "Mazooma","Revolver (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rich		,0,			sc4, sc4, 0, ROT0, "BFM","Rich Geezer (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rio		,0,			sc4, sc4, 0, ROT0, "BFM","Rio Grande (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rttt		,0,			sc4, sc4, 0, ROT0, "Mazooma","Rise To The Top (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_roksc	,0,			sc4, sc4, 0, ROT0, "Qps","Rocket Science (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rogds	,0,			sc4, sc4, 0, ROT0, "Qps","Rogan Dosh (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rmo		,0,			sc4, sc4, 0, ROT0, "BFM","Roll Me Over (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rt		,0,			sc4, sc4, 0, ROT0, "Mazooma","Rolling Thunder (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rtclb	,0,			sc4, sc4, 0, ROT0, "Mazooma","Rolling Thunder Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rollo	,0,			sc4, sc4, 0, ROT0, "Mazooma","Rollover Jackpot (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rosts	,0,			sc4, sc4, 0, ROT0, "BFM","Ronnie O'Sullivan's Tournament Snooker (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_r66		,0,			sc4, sc4, 0, ROT0, "Mazooma","Route 66 (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rovrt	,0,			sc4, sc4, 0, ROT0, "Mazooma","Rovers Return (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rbank	,0,			sc4, sc4, 0, ROT0, "BFM","Royle Banker (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_royle	,0,			sc4, sc4, 0, ROT0, "BFM","Royle Family (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_srrm		,0,			sc4, sc4, 0, ROT0, "Mazooma","Shake Rattle Roll (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_srrca	,0,			sc4, sc4, 0, ROT0, "Mazooma","Shake Rattle Roll Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_smtm		,0,			sc4, sc4, 0, ROT0, "Mazooma","Show Me The Money (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_showt	,0,			sc4, sc4, 0, ROT0, "BFM","Showtime (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sidsp	,0,			sc4, sc4, 0, ROT0, "Mazooma","Side Splitter (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_s2k		,0,			sc4, sc4, 0, ROT0, "Nova","Sinbad 2000 (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sirpz	,0,			sc4, sc4, 0, ROT0, "Mazooma","Sir Prize (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_stl		,0,			sc4, sc4, 0, ROT0, "BFM","Sky's The Limit, The (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_smk7		,0,			sc4, sc4, 0, ROT0, "BFM","Smoking 7's (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_srrcl	,0,			sc4, sc4, 0, ROT0, "BFM","Snake Rattle 'n' Roll Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_srr		,0,			sc4, sc4, 0, ROT0, "BFM","Snake Rattle 'n' Roll (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_slad		,0,			sc4, sc4, 0, ROT0, "BFM","Snakes & Ladders (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_slc		,0,			sc4, sc4, 0, ROT0, "BFM","Snakes & Ladders Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_solgl	,0,			sc4, sc4, 0, ROT0, "BFM","Solid Gold (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_slih		,0,			sc4, sc4, 0, ROT0, "Mazooma","Some Like It Hot (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sace		,0,			sc4, sc4, 0, ROT0, "Qps","Space Ace (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sbust	,0,			sc4, sc4, 0, ROT0, "Qps","Space Buster (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_spice	,0,			sc4, sc4, 0, ROT0, "BFM","Spice It Up (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_swywm	,0,			sc4, sc4, 0, ROT0, "Mazooma","Spin When Your Winning (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_splgb	,0,			sc4, sc4, 0, ROT0, "Mazooma","Splash & Grab (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_spred	,0,			sc4, sc4, 0, ROT0, "Mazooma","Spread Your Bet (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_stag		,0,			sc4, sc4, 0, ROT0, "BFM","Stag Night (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_starp	,0,			sc4, sc4, 0, ROT0, "BFM","Starprize (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_strbr	,0,			sc4, sc4, 0, ROT0, "BFM","Stars 'n' Bars (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_stirc	,0,			sc4, sc4, 0, ROT0, "Mazooma","Stir Crazy (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_strk		,0,			sc4, sc4, 0, ROT0, "Mazooma","Streak, The (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_strka	,0,			sc4, sc4, 0, ROT0, "Qps","Streaks Ahead (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sf		,0,			sc4, sc4, 0, ROT0, "Mazooma","Street Fighter (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_strx		,0,			sc4, sc4, 0, ROT0, "BFM","Strike X (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_suscl	,0,			sc4, sc4, 0, ROT0, "Qps","Suits U Sir Club (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sus		,0,			sc4, sc4, 0, ROT0, "Qps","Suits U Sir (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_s6c		,0,			sc4, sc4, 0, ROT0, "BFM","Super 6 Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sdr		,0,			sc4, sc4, 0, ROT0, "BFM","Super Diamonds & Rubies (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sslam	,0,			sc4, sc4, 0, ROT0, "BFM","Super Slam (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sstep	,0,			sc4, sc4, 0, ROT0, "Qps","Super Step (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_supst	,0,			sc4, sc4, 0, ROT0, "Mazooma","Super Streax (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_swbak	,0,			sc4, sc4, 0, ROT0, "Mazooma","Switch Back (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_taekw	,0,			sc4, sc4, 0, ROT0, "Qps","Tae Kwon Dough (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_taknt	,0,			sc4, sc4, 0, ROT0, "BFM","Take Note (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_takcl	,0,			sc4, sc4, 0, ROT0, "BFM","Take Note Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ttpie	,0,			sc4, sc4, 0, ROT0, "BFM","Take The Piece (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ttp		,0,			sc4, sc4, 0, ROT0, "Mazooma","Take The Piste (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_typ		,0,			sc4, sc4, 0, ROT0, "BFM","Take Your Pick (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tempt	,0,			sc4, sc4, 0, ROT0, "BFM","Temptation (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tetri	,0,			sc4, sc4, 0, ROT0, "Mazooma","Tetris (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_lions	,0,			sc4, sc4, 0, ROT0, "Mazooma","Three Lions (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tic2		,0,			sc4, sc4, 0, ROT0, "Mazooma","Tic Tac Two (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tbana	,0,			sc4, sc4, 0, ROT0, "BFM","Top Banana (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tbox		,0,			sc4, sc4, 0, ROT0, "Mazooma","Top Box (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tgear	,0,			sc4, sc4, 0, ROT0, "Mazooma","Top Gear (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tload	,0,			sc4, sc4, 0, ROT0, "Mazooma","Top Loader (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tpsht	,0,			sc4, sc4, 0, ROT0, "Mazooma","Top Of The Shots (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_trail	,0,			sc4, sc4, 0, ROT0, "Mazooma","Trailblazer (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ticlb	,0,			sc4, sc4, 0, ROT0, "BFM","Treasure Island Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ttomb	,0,			sc4, sc4, 0, ROT0, "BFM","Treasure Tomb (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tridn	,0,			sc4, sc4, 0, ROT0, "Mazooma","Trident, The (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tri7		,0,			sc4, sc4, 0, ROT0, "BFM","Triple 7's (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_trist	,0,			sc4, sc4, 0, ROT0, "Mazooma","Triple Streak (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tub		,0,			sc4, sc4, 0, ROT0, "BFM","Tubular Bells (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tfclb	,0,			sc4, sc4, 0, ROT0, "BFM","Tutti Frutti Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_twilt	,0,			sc4, sc4, 0, ROT0, "BFM","Twilight (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ufg		,0,			sc4, sc4, 0, ROT0, "Mazooma","Up For Grabs (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ufi		,0,			sc4, sc4, 0, ROT0, "BFM","Up For It (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_valnv	,0,			sc4, sc4, 0, ROT0, "Nova","Valhalla (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_valqp	,0,			sc4, sc4, 0, ROT0, "Qps","Valhalla (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_vrgcl	,0,			sc4, sc4, 0, ROT0, "BFM","Very Rich Geezer Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_vivam	,0,			sc4, sc4, 0, ROT0, "BFM","Viva Mexico (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_vmnv		,0,			sc4, sc4, 0, ROT0, "Nova","Viva Mexico (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_vmclb	,0,			sc4, sc4, 0, ROT0, "BFM","Viva Mexico Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wadzl	,0,			sc4, sc4, 0, ROT0, "Mazooma","Wadzilla (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wernr	,0,			sc4, sc4, 0, ROT0, "Nova","Werner (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wrnlt	,0,			sc4, sc4, 0, ROT0, "Nova","Werner Light (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_waw		,0,			sc4, sc4, 0, ROT0, "Mazooma","Wet & Wild (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wdw		,0,			sc4, sc4, 0, ROT0, "BFM","Who Dares Wins (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_leg		,0,			sc4, sc4, 0, ROT0, "BFM","Who Wants To Be A Legionnaire (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_legcb	,0,			sc4, sc4, 0, ROT0, "BFM","Who Wants To Be A Legionnaire Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wldbn	,0,			sc4, sc4, 0, ROT0, "BFM","Wild Bunch (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wldjk	,0,			sc4, sc4, 0, ROT0, "Mazooma","Wild Jackpots (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wthng	,0,			sc4, sc4, 0, ROT0, "BFM","Wild Thing (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wthnm	,0,			sc4, sc4, 0, ROT0, "Mazooma","Wild Thing (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wtc		,0,			sc4, sc4, 0, ROT0, "Mazooma","Wild Thing Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wspin	,0,			sc4, sc4, 0, ROT0, "Qps","Win Spinner (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wwys		,0,			sc4, sc4, 0, ROT0, "BFM","Win When Your Spinning (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_winxp	,0,			sc4, sc4, 0, ROT0, "BFM","Win X-plosion (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_winsp	,0,			sc4, sc4, 0, ROT0, "Qps","Winning Spin (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wondw	,0,			sc4, sc4, 0, ROT0, "BFM","Wonder Wheel (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_xmark	,0,			sc4, sc4, 0, ROT0, "BFM","X Marks The Spot (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_xcash	,0,			sc4, sc4, 0, ROT0, "BFM","Xtra Cash (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_unk		,0,			sc4, sc4, 0, ROT0, "Mazooma","Unknown Scorpion '95410476' (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_s16		,0,			sc4, sc4, 0, ROT0, "Mazooma","Unknown Scorpion 'Section 16' (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_plays	,0,			sc4, sc4, 0, ROT0, "Qps","28 Plays Later (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_adga		,0,			sc4, sc4, 0, ROT0, "BFM","Ant & Dec's Grab The Ads (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_adgtc	,0,			sc4, sc4, 0, ROT0, "BFM","Ant & Dec's Grab The Cash (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_adsnt	,0,			sc4, sc4, 0, ROT0, "BFM","Ant & Dec's Saturday Night Takeaway (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bjob		,0,			sc4, sc4, 0, ROT0, "BFM","Bank Job (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bkngx	,0,			sc4, sc4, 0, ROT0, "Mazooma","Bar King X (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bgold	,0,			sc4, sc4, 0, ROT0, "Nova","Black Gold (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_blokq	,0,			sc4, sc4, 0, ROT0, "Qps","Blockbuster (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bucc		,0,			sc4, sc4, 0, ROT0, "BFM","Buccaneers (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bpfpb	,0,			sc4, sc4, 0, ROT0, "BFM","Bullseye Pounds For Points (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bpfpm	,0,			sc4, sc4, 0, ROT0, "Mazooma","Bullseye Pounds For Points (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_btiab	,0,			sc4, sc4, 0, ROT0, "BFM","Bullseye Three In A Bed (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_btrip	,0,			sc4, sc4, 0, ROT0, "BFM","Bullseye Triple (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_btc		,0,			sc4, sc4, 0, ROT0, "BFM","Bullseye Triple Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bpb		,0,			sc4, sc4, 0, ROT0, "BFM","Bully's Prize Board (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bsp		,0,			sc4, sc4, 0, ROT0, "BFM","Bully's Star Prize (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_bunny	,0,			sc4, sc4, 0, ROT0, "Mazooma","Bunny Money (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cbrun	,0,			sc4, sc4, 0, ROT0, "BFM","Cannonball Run (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfact	,0,			sc4, sc4, 0, ROT0, "BFM","Cash Factor (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ctit		,0,			sc4, sc4, 0, ROT0, "BFM","Cash Of The Titans (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_craid	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cash Raider (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cvega	,0,			sc4, sc4, 0, ROT0, "BFM","Cash Vegas (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_chain	,0,			sc4, sc4, 0, ROT0, "BFM","Chain Reaction (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_chopc	,0,			sc4, sc4, 0, ROT0, "Mazooma","Chop 'n' Change  (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cbar7	,0,			sc4, sc4, 0, ROT0, "Mazooma","Classic Bar 7 (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clown	,0,			sc4, sc4, 0, ROT0, "BFM","Clown Around (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clbtm	,0,			sc4, sc4, 0, ROT0, "BFM","Club Temptation (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clu70	,0,			sc4, sc4, 0, ROT0, "Qps","Cluedo 70 (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clcas	,0,			sc4, sc4, 0, ROT0, "Mazooma","Cluedo Casino (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clnot	,0,			sc4, sc4, 0, ROT0, "BFM","Cluedo Notorious (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_clus		,0,			sc4, sc4, 0, ROT0, "Mazooma","Cluedo The Usual Suspects (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cmony	,0,			sc4, sc4, 0, ROT0, "BFM","Colour Of Money (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_newcm	,0,			sc4, sc4, 0, ROT0, "BFM","Colour Of Money New, The (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_copsr	,0,			sc4, sc4, 0, ROT0, "BFM","Cops 'n' Robbers (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crcpt	,0,			sc4, sc4, 0, ROT0, "BFM","Cops 'n' Robbers Community Party (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crotr	,0,			sc4, sc4, 0, ROT0, "BFM","Cops 'n' Robbers On The Run (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crsgc	,0,			sc4, sc4, 0, ROT0, "BFM","Cops 'n' Robbers Smash 'n' Grab Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_crsgr	,0,			sc4, sc4, 0, ROT0, "BFM","Cops 'n' Robbers Smash 'n' Grab (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_corst	,0,			sc4, sc4, 0, ROT0, "BFM","Coronation Street (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfnc		,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Fruit & Nutcase (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfcp		,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Fruits Community Party (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cfpt		,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Fruits Party Time (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cknig	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Knights (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cmons	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Money (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cpays	,0,			sc4, sc4, 0, ROT0, "BFM","Crazy Pays (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndbo	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Banker's Bonus (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndbl	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Beat The Banker Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndbe	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Beat The Banker (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndbq	,0,			sc4, sc4, 0, ROT0, "Qps","Deal Or No Deal Beat The Banker (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndbc	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Box Clever (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndcr	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Cops 'n' Robbers (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndde	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Desert Island Deal (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dnddi	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Diamond (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dnddt	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Double Take (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dnddo	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Dream Offer (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndfl	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Feeling Lucky (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndgo	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Game On (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndgl	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Gold (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndld	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Live The Dream (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndmb	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Make Or Break (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndmd	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Mega Deal Or No Deal (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndpl	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Platinum (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndpa	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Play It Again (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ddptg	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Play The Game (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ddply	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Player's Choice (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndrr	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Road To Riches (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndsi	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Simply Deal Or No Deal (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndrt	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Banker Rings Twice (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndpd	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Perfect Deal (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndpc	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal The Players Choice (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dndtb	,0,			sc4, sc4, 0, ROT0, "BFM","Deal Or No Deal Think Big (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_devil	,0,			sc4, sc4, 0, ROT0, "Mazooma","Devil Of A Deal (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dcrls	,0,			sc4, sc4, 0, ROT0, "Mazooma","Double Crazy Reels (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_dracp	,0,			sc4, sc4, 0, ROT0, "BFM","Drac Pack (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_eyes		,0,			sc4, sc4, 0, ROT0, "Mazooma","Eyes Down (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fgbh		,0,			sc4, sc4, 0, ROT0, "BFM","Family Guy Booze Hound (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fggp		,0,			sc4, sc4, 0, ROT0, "BFM","Family Guy Griffin Plumbing (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fast		,0,			sc4, sc4, 0, ROT0, "Qps","Fast Cash (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fnclb	,0,			sc4, sc4, 0, ROT0, "BFM","Fight Night Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fdice	,0,			sc4, sc4, 0, ROT0, "BFM","Fire 'n' Dice (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_fires	,0,			sc4, sc4, 0, ROT0, "BFM","Firestarter (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ftcas	,0,			sc4, sc4, 0, ROT0, "Mazooma","Flash The Cash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_floop	,0,			sc4, sc4, 0, ROT0, "Mazooma","Fruit Loops (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_grq		,0,			sc4, sc4, 0, ROT0, "BFM","Get Rich Quick (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gldfv	,0,			sc4, sc4, 0, ROT0, "BFM","Gold Fever (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gldmn	,0,			sc4, sc4, 0, ROT0, "BFM","Gold Mine (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gldgo	,0,			sc4, sc4, 0, ROT0, "BFM","Golden Goals (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gldsp	,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden Spinner (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gldwn	,0,			sc4, sc4, 0, ROT0, "Mazooma","Golden Winner (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gcclb	,0,			sc4, sc4, 0, ROT0, "BFM","Grand Casino Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_gmclb	,0,			sc4, sc4, 0, ROT0, "BFM","Grand Master Cash (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hir		,0,			sc4, sc4, 0, ROT0, "BFM","Hi Roller (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hircl	,0,			sc4, sc4, 0, ROT0, "BFM","Hi Roller Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hirol	,0,			sc4, sc4, 0, ROT0, "Mazooma","High Roller (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_hulk		,0,			sc4, sc4, 0, ROT0, "BFM","Hulk, The (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_iab		,0,			sc4, sc4, 0, ROT0, "Mazooma","It's A Bullseye (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ijbdo	,0,			sc4, sc4, 0, ROT0, "Qps","Italian Job - Blow The Doors Off (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_jckmo	,0,			sc4, sc4, 0, ROT0, "Mazooma","Jackpot Monopoly (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_kingx	,0,			sc4, sc4, 0, ROT0, "BFM","King X (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_monky	,0,			sc4, sc4, 0, ROT0, "Mazooma","Monkey Business (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mobob	,0,			sc4, sc4, 0, ROT0, "BFM","Monopoly Boom Or Bust (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mogta	,0,			sc4, sc4, 0, ROT0, "BFM","Monopoly Go To Auction (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_momil	,0,			sc4, sc4, 0, ROT0, "BFM","Monopoly Millionaire (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mombc	,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Money Bags Club (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_moms		,0,			sc4, sc4, 0, ROT0, "Qps","Monopoly Money Spinner (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mopl		,0,			sc4, sc4, 0, ROT0, "BFM","Monopoly Property Ladder (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mor2r	,0,			sc4, sc4, 0, ROT0, "Qps","Monopoly Road To Riches (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mowow	,0,			sc4, sc4, 0, ROT0, "Mazooma","Monopoly Wheel Of Wealth (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_monwa	,0,			sc4, sc4, 0, ROT0, "Qps","Monopoly Win Again (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cmcob	,0,			sc4, sc4, 0, ROT0, "Qps","Monte Carlo Or Bust Club (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_mcob		,0,			sc4, sc4, 0, ROT0, "Qps","Monte Carlo Or Bust (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_nunsb	,0,			sc4, sc4, 0, ROT0, "BFM","Nuns 'n' Roses (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_nunsm	,0,			sc4, sc4, 0, ROT0, "Mazooma","Nuns 'n' Roses (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_onup		,0,			sc4, sc4, 0, ROT0, "BFM","On The Up (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rainb	,0,			sc4, sc4, 0, ROT0, "BFM","Over The Rainbow (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_parot	,0,			sc4, sc4, 0, ROT0, "BFM","Parrots Of The Caribbean (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_phgcl	,0,			sc4, sc4, 0, ROT0, "BFM","Pharaoh's Gold Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pilep	,0,			sc4, sc4, 0, ROT0, "Qps","Pile On The Pounds (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_ppbtb	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pink Panther Break The Bank (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pking	,0,			sc4, sc4, 0, ROT0, "BFM","Poker King (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_potsm	,0,			sc4, sc4, 0, ROT0, "Mazooma","Pots Of Luck (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_cpen1	,0,			sc4, sc4, 0, ROT0, "BFM","Public Enemy No1 Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_qual		,0,			sc4, sc4, 0, ROT0, "BFM","Quality Streak (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rsnw		,0,			sc4, sc4, 0, ROT0, "Mazooma","Random Spin 'n' Win (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rspin	,0,			sc4, sc4, 0, ROT0, "BFM","Random Spinner (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rsclb	,0,			sc4, sc4, 0, ROT0, "BFM","Random Spinner Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rwclb	,0,			sc4, sc4, 0, ROT0, "BFM","Random Winner Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rapid	,0,			sc4, sc4, 0, ROT0, "BFM","Rapid Pay (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rcash	,0,			sc4, sc4, 0, ROT0, "Mazooma","Reel Cash (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rroul	,0,			sc4, sc4, 0, ROT0, "Mazooma","Reel Roulette (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rssh		,0,			sc4, sc4, 0, ROT0, "Mazooma","Reel Spin Shady (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rh		,0,			sc4, sc4, 0, ROT0, "BFM","Road Hog (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rhclb	,0,			sc4, sc4, 0, ROT0, "BFM","Road Hog Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rsrm		,0,			sc4, sc4, 0, ROT0, "BFM","Ronnie O'Sullivan's Rocket Money (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rsrr		,0,			sc4, sc4, 0, ROT0, "BFM","Ronnie O'Sullivan's Rocket Ronnie (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sharp	,0,			sc4, sc4, 0, ROT0, "Voodoo","Sharp Shooter (Voodoo) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sfts		,0,			sc4, sc4, 0, ROT0, "BFM","Shoot For The Stars (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_srrqp	,0,			sc4, sc4, 0, ROT0, "Qps","Snake Rattle & Roll (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_witwi	,0,			sc4, sc4, 0, ROT0, "BFM","Spin It To Win It (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_spnrn	,0,			sc4, sc4, 0, ROT0, "Mazooma","Spinning Around (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_srace	,0,			sc4, sc4, 0, ROT0, "BFM","Streak Racer (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_sleut	,0,			sc4, sc4, 0, ROT0, "Mazooma","Super Sleuth (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tornc	,0,			sc4, sc4, 0, ROT0, "BFM","Tornado Club (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_tsmp		,0,			sc4, sc4, 0, ROT0, "BFM","Trick Shot Multi Player (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_pompa	,0,			sc4, sc4, 0, ROT0, "BFM","Up Pompay (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_vamp		,0,			sc4, sc4, 0, ROT0, "Qps","Vampire Payer (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_vpa		,0,			sc4, sc4, 0, ROT0, "BFM","Video Poker Ace (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_viper	,0,			sc4, sc4, 0, ROT0, "BFM","Viper Active (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_vlv		,0,			sc4, sc4, 0, ROT0, "BFM","Viva Las Vegas (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_viz		,0,			sc4, sc4, 0, ROT0, "Qps","Viz (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wacky	,0,			sc4, sc4, 0, ROT0, "BFM","Wacky Racers (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wotw		,0,			sc4, sc4, 0, ROT0, "Mazooma","War Of The Wads (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wild		,0,			sc4, sc4, 0, ROT0, "Mazooma","Wild Reels (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wca		,0,			sc4, sc4, 0, ROT0, "Qps","Win Can Alley (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wok		,0,			sc4, sc4, 0, ROT0, "BFM","Wok n' Roll (Bellfruit) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_u1337	,0,			sc4, sc4, 0, ROT0, "Mazooma","Unknown Scorpion '39211337' (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_u1396	,0,			sc4, sc4, 0, ROT0, "Mazooma","Unknown Scorpion '95411396' (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_u6606	,0,			sc4, sc4, 0, ROT0, "Mazooma","Unknown Scorpion '95416606' (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_u7606	,0,			sc4, sc4, 0, ROT0, "Mazooma","Unknown Scorpion '95417606' (Mazooma) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_rhr		,0,			sc4, sc4, 0, ROT0, "Qps","Red Hot Reels (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_po8		,0,			sc4, sc4, 0, ROT0, "Qps","Pieces Of Eight (Qps) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_wag		,0,			sc4, sc4, 0, ROT0, "Nova","Win-A-Gain (Nova) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )
GAME( 200?, sc_unsrt	,0,			sc4, sc4, 0, ROT0, "unknown","Unknown Scorpion 'Unsorted Sound' (Unknown) (Scorpion ?)", GAME_NOT_WORKING|GAME_NO_SOUND|GAME_REQUIRES_ARTWORK|GAME_MECHANICAL )



